<?php
/**
 * Вывод формы напоминания пароля
 *
 *
 * @author Казбек Елекоев <elekoev@binn.ru>
 * @version 4.0
 * @package SB_Core
 * @copyright Copyright (c) 2007, OOO "СИБИЭС Групп"
 */

/**
 * Подключение сжатия страниц внутри системы и инициализация основных библиотек ядра системы
 */
$dir = substr(dirname(__FILE__), 0, -5).'kernel';
require_once($dir.'/header.inc.php');

/**
 * Подключение языковых констант
 */
require_once(SB_CMS_LANG_PATH.'/index.lng.php');

$error = '';
$sb_adm_login = '';
$sb_adm_email = '';

if (isset($_POST['sb_adm_login']))
{
    // проверяем логин и мейл и отправляем пользователю новый пароль
    $sb_adm_login = preg_replace('/[^a-zA-Z0-9_\-]+/', '', $_POST['sb_adm_login']);
    $sb_adm_email = preg_replace('/[^a-zA-Z0-9_\-\.\@]+/', '', $_POST['sb_adm_email']);
    
    $res = sql_query('SELECT u_id, u_name FROM sb_users WHERE u_login=? AND u_email=?', $sb_adm_login, $sb_adm_email);
    if (!$res)
    {
        $error = INDEX_ERROR_NO_EMAIL_OR_LOGIN;
    }
    else 
    {
        list($id, $name) = $res[0];

        $pass = substr(md5(uniqid()), 0, 10);
        sql_query('UPDATE sb_users SET u_pass=?, u_pass_date=?d WHERE u_id=?d', md5($pass), time(), $id);
        
        if ($name == '') 
            $name = $sb_adm_login;
        
        $mail = new sbMail();
        $mail->setSubject(INDEX_REMIND_SUBJECT);
        $mail->setHtml(sprintf(INDEX_REMIND_BODY, SB_COOKIE_DOMAIN, $name, SB_COOKIE_DOMAIN, $sb_adm_login, $pass, CMS_NAME));
        $mail->setFrom(SB_COOKIE_DOMAIN.' <robotsb@'.SB_COOKIE_DOMAIN.'>');
        $mail->setReturnPath('robotsb@'.SB_COOKIE_DOMAIN);
        
        $mail->send(array($sb_adm_email));

        echo '
            <!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
            <html lang="ru">
            <head>
            <title>'.INDEX_REMINDER_TITLE.'</title>
            <meta http-equiv="Content-Script-Type" content="text/javascript">
            <style type="text/css">
            img
            {
                behavior: url("'.SB_CMS_JSCRIPT_URL.'/sbFixPng.htc.php");
            }
            </style>
            <link rel="stylesheet" type="text/css" href="'.SB_CMS_CSS_URL.'/sbIndex.css">
            <script src="'.SB_CMS_JSCRIPT_URL.'/sbIndex.js.php"></script>
            <body onload=\'sbShowMsgDiv("'.INDEX_REMIND_OK.'");\'>
            <table cellpadding="0" cellspacing="0" style="height:100%;width:100%;">
            <tr><td valign="middle" align="center">
            <div id="sb_msg_div" class="sb_msg_div" style="display:block;position: relative;top:0px;"><table cellspacing="0" cellpadding="0" width="100%"><tr><td width="50"><img src="'.SB_CMS_IMG_URL.'/information.png" width="32" height="32" /></td><td id="sb_msg_div_text" class="sb_msg_div_text">
            '.INDEX_REMIND_OK.'
            </td></tr></table></div><br /><br />
            <a href="/cms/admin/index.php">[ '.INDEX_REMIND_ENTER.' ]</a>
            </td></tr></table>
            </body></html>';
        
        require_once(SB_CMS_KERNEL_PATH.'/footer.inc.php');
        exit(0);
    }
}

// вывод страницы c формой логина
echo '
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html lang="ru">
<head>
<title>'.INDEX_REMINDER_TITLE.'</title>
<meta http-equiv="Content-Script-Type" content="text/javascript">
<style type="text/css">
    img
    {
        behavior: url(/cms/jscript/sbFixPng.htc.php);
    }
</style>
<link rel="stylesheet" type="text/css" href="'.SB_CMS_CSS_URL.'/sbIndex.css">
<script src="'.SB_CMS_JSCRIPT_URL.'/sbFunctions.js.php"></script>
<script src="'.SB_CMS_JSCRIPT_URL.'/sbIndex.js.php"></script>
<script>
var sb_cms_img_url = "'.SB_CMS_IMG_URL.'";

function checkValues()
{
    var login_el = document.getElementById("sb_adm_login");
    var email_el = document.getElementById("sb_adm_email");
    
    if (login_el.value == "")
    {
        alert("'.INDEX_ERROR_NO_LOGIN.'");
        return false;
    }
    
    if (email_el.value == "")
    {
        alert("'.INDEX_ERROR_NO_EMAIL.'");
        return false;
    }
    
    return true;
}
</script>
</head>
<body'.($error != '' ? ' onload=\'sbShowMsgDiv("'.$error.'");\'' : '').'>
    <form id="sb_reminder_form" action="'.$_SERVER['PHP_SELF'].'" method="post" onsubmit="return checkValues();">
    <table cellpadding="0" cellspacing="0" style="height:100%;width:100%;">
    <tr><td valign="middle" align="center">';

if (CMS_SITE_NAME == 'www.sbuilder.ru')
    echo '<div class="login_img">
            <a href="http://www.sbuilder.ru" target="_blank"><img src="'.SB_CMS_IMG_URL.'/login.png" class="login_img" width="161" height="207" /></a>
        </div>';
            
echo '<table cellpadding="0" cellspacing="0" class="form" width="330">
          <tr>
            <th class="header" colspan="2">
              '.INDEX_TITLE_REMINDER_FORM.'
            </th>
          </tr>
          <tr>
            <th width="80" style="padding-top: 15px;">'.INDEX_USER.':</th>
            <td style="padding-top: 15px;"><input type="text" name="sb_adm_login" id="sb_adm_login" value="'.$sb_adm_login.'" tabIndex="1" style="width: 200px;"></td>
          </tr>
          <tr>
              <th>'.INDEX_EMAIL.':</th>
              <td><input type="text" name="sb_adm_email" id="sb_adm_email" value="'.$sb_adm_email.'" tabIndex="2" style="width: 200px;"></td>
          </tr>
          <tr>
            <td colspan="2" align="center" style="padding: 5px 2px 2px 2px;">
                <div class="footer"><input type="submit" tabIndex="4" value="'.INDEX_REMIND.'"></div>
            </td>
          </tr>
        </table>
    </td></tr>';

if (CMS_SITE_NAME == 'www.sbuilder.ru')
{
    echo '<tr><td class="links">
        <a href="http://know.sbuilder.ru/" target="_blank">'.INDEX_KNOW_LINK.'</a><br>
        <a href="http://api.sbuilder.ru" target="_blank">'.INDEX_API_LINK.'</a><br>
        <a href="http://www.sbuilder.ru/forum/" target="_blank">'.INDEX_FORUM_LINK.'</a><br>
        <a href="http://www.sbuilder.ru" target="_blank">'.INDEX_SITE_LINK.'</a><br>
        '.INDEX_COPYRIGHT.'
    </td></tr>';
}

echo '</form></table>
<div id="sb_msg_div" class="sb_msg_div"><table cellspacing="0" cellpadding="0" width="100%"><tr><td width="50"><img src="'.SB_CMS_IMG_URL.'/warning.png" width="40" height="40" id="sb_msg_img" /></td><td id="sb_msg_div_text" class="sb_msg_div_text"></td></tr></table></div>
</body></html>';

require_once(SB_CMS_KERNEL_PATH.'/footer.inc.php');
?>