<?php require_once(dirname(__FILE__).'/../jheader.inc.php'); ?>
var sbEditorStateActions = [];

/**
 * Функции, вызываемые при определенных событиях в редактируемой области 
 */
function sbEditorExecDrop()
{
    sbEditorUndo._SaveUndoStep();
    sbEditorOnSelectionChangeTimer();
    
    window.setTimeout( sbEditorAfterExecDrop, 100 ) ;
}

function sbEditorAfterExecDrop()
{
    if (_isIE)
    {
        sbEditorDocumentProcessor._Process( sbEditorArea ) ;
    }
    else
    {
        var range = new sbEditorDomRange( sbEditorAreaWnd ) ;
        range._MoveToSelection() ;

        var bookmark = range._CreateBookmark() ;
        sbEditorDocumentProcessor._Process( sbEditorArea ) ;
        
        try
        {
            range._MoveToBookmark( bookmark ) ;
            range._Select() ;
        }
        catch ( e ) {}
    }
}

function sbEditorOnSelectionChange()
{
	if ( !sbEditorSelectionChangeLocked && sbEditorArea )
		sbEditorEvents._FireEvent( "OnSelectionChange" ) ;
}

function sbEditorOnSelectionChangeTimer()
{
	if ( sbEditorLastOnChangeTimer )
		window.clearTimeout( sbEditorLastOnChangeTimer ) ;

	sbEditorLastOnChangeTimer = window.setTimeout( sbEditorOnSelectionChange, 100 ) ;
}

function sbEditorOnKeyDown(e)
{
	function _IsFunctionKey ( keyCode )
	{
		if ( keyCode >= 16 && keyCode <= 20 )
			return true ;
		if ( keyCode == 27 || ( keyCode >= 33 && keyCode <= 40 ) )
			return true ;
		if ( keyCode == 45 )
			return true ;
			
		return false ;
	}

	if ( sbEditorArea )
	{
		if ( !_IsFunctionKey(e.keyCode)	&& !(e.ctrlKey || e.metaKey) && !(e.keyCode == 46) )
		{
			if ( !sbEditorUndo._Typing )
			{
				sbEditorUndo._SaveUndoStep() ;
				sbEditorUndo._Typing = true ;
				sbEditorEvents._FireEvent( "OnSelectionChange" ) ;
			}
	
			sbEditorUndo._TypesCount++ ;
			sbEditorUndo._Changed = 1 ;
	
			if ( sbEditorUndo._TypesCount > sbEditorUndo._MaxTypes )
			{
				sbEditorUndo._TypesCount = 0 ;
				sbEditorUndo._SaveUndoStep() ;
			}
		}		
	}
	
	return true ; 
}

function sbEditorOnMouseUp(e)
{
	function checkSelection(el)
	{
		var par = el;
	    while (par)
	    {
	    	if (par == sbEditorArea)
	        	break;
	        
	        if (par.tagName == "BODY")
	        	return false;

	        par = par.parentNode;
	    }
	    
	    return true;
	}
	
	if ( !_isIE )
	{
		var oRange = new sbEditorDomRange( sbEditorAreaWnd ) ;
		oRange._MoveToSelection() ;
		var el = oRange._Range.startContainer ;
	}
	else
		var el = sbEventTarget(e);

	if (!checkSelection(el))
	{
		if ( _isIE || oRange._IsCollapsed())
        {
        	sbEditorFocus(true);
        }
        else if (!_isIE)
        {
        	oRange.setStart(sbEditorArea, 1);
        	oRange._Select();
        }
	}
	
	if (!_isIE && !oRange._IsCollapsed())
	{
		if (!checkSelection(oRange._Range.endContainer))
		{
			oRange.setEnd(sbEditorArea, 2);
	        oRange._Select();
		}
	}
	
	sbEditorOnSelectionChangeTimer();
}

var sbEditorOnPasteActive = false;
function sbEditorOnPaste()
{
	if (sbEditorOnPasteActive)
		return true;
		
	sbEditorOnPasteActive = true;
	var ret = sbEditorPaste() ;
	sbEditorOnPasteActive = false;

	return ret ;
}

function sbEditorCheckCaret(e)
{
	if ( e.type == 'keypress' )
	{
		var keyCode = e.keyCode ;
		if ( keyCode < 33 || keyCode > 40 )
			return ;
	}

	var blockEmptyStop = function( node )
	{
		if ( node.nodeType != 1 )
			return false ;
		var tag = node.tagName.toLowerCase() ;
		return ( sbEditorListsLib.BlockElements[tag] || sbEditorListsLib.EmptyElements[tag] ) ;
	}

	var moveCursor = function()
	{
		var selection = sbEditorSelection._GetSelection() ;
		var range = selection.getRangeAt(0) ;
		if ( ! range || ! range.collapsed )
			return ;

		if ( range.startContainer == sbEditorArea && range.startOffset == 0 )
		{
			range.selectNodeContents( sbEditorArea.firstChild ) ;
			range.collapse( true ) ;
			selection.removeAllRanges() ;
			selection.addRange( range ) ;
			
			return;
		}
		
		var node = range.endContainer ;

		if ( node.nodeType != 3 )
			return ;

		if ( node.nodeValue.length != range.endOffset )
			return ;

		var parentTag = node.parentNode.tagName.toLowerCase() ;
		if ( ! (  parentTag == 'a' || ( !_isOpera && String(node.parentNode.contentEditable) == 'false' ) ||
				( ! ( sbEditorListsLib.BlockElements[parentTag] || sbEditorListsLib.NonEmptyBlockElements[parentTag] )
				  && keyCode == 35 ) ) )
			return ;

		var nextTextNode = sbEditorGetNextTextNode( node, node.parentNode, blockEmptyStop ) ;
		if ( nextTextNode )
			return ;

		range = sbEditorAreaDoc.createRange() ;

		nextTextNode = sbEditorGetNextTextNode( node, node.parentNode.parentNode, blockEmptyStop ) ;
		if ( nextTextNode )
		{
			if ( _isOpera && keyCode == 37 )
				return ;

			range.setStart( nextTextNode, 0 ) ;
			range.setEnd( nextTextNode, 0 ) ;
		}
		else
		{
			while ( node.parentNode
				&& node.parentNode != sbEditorArea
				&& node.parentNode != sbEditorAreaDoc.body
				&& node.parentNode != sbEditorAreaDoc.documentElement
				&& node == node.parentNode.lastChild
				&& ( ! sbEditorListsLib.BlockElements[node.parentNode.tagName.toLowerCase()]
				  && ! sbEditorListsLib.NonEmptyBlockElements[node.parentNode.tagName.toLowerCase()] ) )
				node = node.parentNode ;


			if ( sbEditorListsLib.BlockElements[ parentTag ]
					|| sbEditorListsLib.EmptyElements[ parentTag ]
					|| node == sbEditorArea )
			{
				range.setStart( node, node.childNodes.length ) ;
				range.setEnd( node, node.childNodes.length ) ;
			}
			else
			{
				var stopNode = node.nextSibling ;

				while ( stopNode )
				{
					if ( stopNode.nodeType != 1 )
					{
						stopNode = stopNode.nextSibling ;
						continue ;
					}

					var stopTag = stopNode.tagName.toLowerCase() ;
					if ( sbEditorListsLib.BlockElements[stopTag] || sbEditorListsLib.EmptyElements[stopTag]
						|| sbEditorListsLib.NonEmptyBlockElements[stopTag] )
						break ;
					stopNode = stopNode.nextSibling ;
				}

				var marker = sbEditorAreaDoc.createTextNode( '' ) ;
				if ( stopNode )
					node.parentNode.insertBefore( marker, stopNode ) ;
				else
					node.parentNode.appendChild( marker ) ;
				range.setStart( marker, 0 ) ;
				range.setEnd( marker, 0 ) ;
			}
		}

		selection.removeAllRanges() ;
		selection.addRange( range ) ;
		sbEditorEvents._FireEvent( "OnSelectionChange" ) ;
	}

	setTimeout( moveCursor, 1 ) ;
}

/**
 * Функции, вызываемые при щелчке по различным кнопкам тулбара
 */
 
// HTML-код
var sbOldAreaHtml = "";
function sbEditorSourceAction(el)
{
	if ( el.className == "buttonDisabled" || !sbEditorArea )
		return;
	
	el.className = "button";
				
	sbOldAreaHtml = sbEditorArea.innerHTML;
	
	var sHtml = sbEditorGetData() ;
	if ( sHtml == null )
		return ;

	var strPage = window.parent.sb_cms_modal_dialog_file + "?event=pl_editor_source";
    var strAttr = "resizable=1,width=1000,height=750";
    var args = new Object();
    args.value = sHtml;
    
    window.parent.sbShowModalDialog(strPage, strAttr, sbEditorSetData, args);
}

function sbEditorSetData(data)
{
	if (!data && !window.parent.sbModalDialog.returnValue)
	{
		if ( sbEditorArea )
		{
	    	sbEditorArea.innerHTML = sbOldAreaHtml;
	    	sbOldAreaHtml = "";
	    	setTimeout("sbEditorFocus(true)", 100);
    	}
    				
    	return "";
    }
   
    sbEditorTempBin._Reset();
    
    data = data || window.parent.sbModalDialog.returnValue.value;
	data = sbEditorProtectedSource._Protect( data ) ;
	data = sbEditorDataProcessor._ConvertToHtml( data ) ;
	data = data.replace( sbEditorRegexLib.InvalidSelfCloseTags, '$1></$2>' ) ;
	data = sbEditorProtectUrls( data ) ;
	data = sbEditorProtectTags( data ) ;

	if (window.parent.sbModalDialog.returnValue)
	{
		sbEditorArea.innerHTML = data;
		setTimeout(sbEditorOnAfterSetData, 0);
	}
	else
		return data;
}

function sbEditorOnAfterSetData()
{
	var sBody = sbEditorArea.innerHTML;
	if ( _isFF && ( sBody.length == 0 || sbEditorRegexLib.EmptyParagraph.test( sBody ) ) )
		sbEditorArea.innerHTML = '<br type="_moz">' ;
		
	sbEditorDocumentProcessor._Process( sbEditorArea ) ;
	setTimeout(sbEditorFocus, 100);
}

function sbEditorRemoveDirtyTags()
{
    var spans = sbEditorArea.getElementsByTagName( 'span' );
    for ( var i = spans.length - 1 ; i >= 0 ; i-- )
    {
        if ( spans[i].className == 'Apple-style-span' || !sbEditorHasAttributes( spans[i] ) )
            sbEditorRemoveNode( spans[i], true ) ;
    }
}

function sbEditorGetData ()
{
	if ( !sbEditorArea )
		return null ;

	var isFullPage = sbEditorFullPage ;
	
	sbEditorRemoveDirtyTags();
            
	var data = sbEditorDataProcessor._ConvertToDataFormat(
		sbEditorArea,
		!isFullPage ) ;

	function RestoreEvents( match, encodedOriginal )
	{
		return decodeURIComponent( encodedOriginal ) ;
	}

	data = data.replace( sbEditorRegexLib.ProtectedEvents, RestoreEvents ) ;

	if ( _isIE )
		data = data.replace( sbEditorRegexLib.ToReplace, '$1' ) ;

	if ( isFullPage )
	{
		if ( sbEditorDocTypeDeclaration && sbEditorDocTypeDeclaration.length > 0 )
			data = sbEditorDocTypeDeclaration + '\n' + data ;
	}

	return sbEditorProtectedSource._Revert( data ) ;
}

// Cut Copy
function sbEditorCutCopyAction( el, cName )
{
	if ( el.className == "buttonDisabled" || !sbEditorArea )
		return;
		
	var enabled = false ;

	if ( _isIE )
	{
		var onEvent = function()
		{
			enabled = true ;
		} ;

		var eventName = 'on' + cName ;

		sbEditorAreaDoc.body.attachEvent( eventName, onEvent ) ;
		sbEditorExecuteNamedCommand( cName ) ;
		sbEditorAreaDoc.body.detachEvent( eventName, onEvent ) ;
	}
	else
	{
		try
		{
			sbEditorExecuteNamedCommand( cName ) ;
			enabled = true ;
		}
		catch(e){}
	}

	if ( !enabled )
	{
		if (cName == "cut")
			alert( "<?php echo EDITOR_CUT_ERROR; ?>" ) ;
		else
			alert( "<?php echo EDITOR_COPY_ERROR; ?>" ) ;
			
		el.className = "button";
		sbEditorFocus();
	}
}

// Paste
function sbEditorPasteHelper()
{
	if (window.parent.sbModalDialog.returnValue)
		sbEditorInsertHtml(window.parent.sbModalDialog.returnValue);

	sbEditorFocus();
}

function sbEditorPasteAction(el)
{
	if ( el.className == "buttonDisabled" || !sbEditorArea )
		return;
	
	el.className = "button";
		
	if ( _isIE )
		sbEditorPaste() ;
	else
		sbEditorExecuteNamedCommand( 'Paste', null, true ) ;
}

function sbEditorPastePlainAction(el)
{
	if ( el.className == "buttonDisabled" || !sbEditorArea )
		return;
		
	el.className = "button";
	
	sbEditorPastePlainText();
}

function sbEditorPasteFromWordAction(el)
{
	if ((el && el.className == "buttonDisabled") || !sbEditorArea )
		return;
	
	if (el)
		el.className = "button";
		
	var strPage = window.parent.sb_cms_modal_dialog_file + "?event=pl_editor_paste";
    var strAttr = "resizable=0,width=800,height=600";
    var attr = new Object();
    attr.wnd = window;
    attr.type = "Word";
    		
    window.parent.sbShowModalDialog(strPage, strAttr, sbEditorPasteHelper, attr);
}

// Find
function sbEditorFindAction(el)
{
	if ( el.className == "buttonDisabled" || !sbEditorArea )
		return;
	
	el.className = "button";
		
	var strPage = window.parent.sb_cms_modal_dialog_file + "?event=pl_editor_find&editor=1";
    var strAttr = "resizable=0,width=500,height=300";
    		
    window.parent.sbShowModalDialog(strPage, strAttr, null, window);
}

// Spell
function sbEditorSpellAction(el)
{
	if ( el.className == "buttonDisabled" || !sbEditorArea )
		return;
	
	el.className = "button";
		
	var strPage = window.parent.sb_cms_modal_dialog_file + "?event=pl_editor_spell";
    var strAttr = "resizable=0,width=800,height=600";
    		
    window.parent.sbShowModalDialog(strPage, strAttr, null, window);
}

// Undo
function sbEditorUndoAction(el)
{
	if ( el.className == "buttonDisabled" || !sbEditorArea )
		return;
		
	sbEditorUndo._Undo();
}

// Redo
function sbEditorRedoAction(el)
{
	if ( el.className == "buttonDisabled" || !sbEditorArea )
		return;
		
	sbEditorUndo._Redo();
}

// Ссылка
function sbEditorLinkAction(el)
{
	if ( el.className == "buttonDisabled" || !sbEditorArea )
		return;
	
	el.className = "button";
		
	var strPage = window.parent.sb_cms_modal_dialog_file + "?event=pl_editor_link";
    var strAttr = "resizable=1,width=800,height=600";
    
    window.parent.sbShowModalDialog(strPage, strAttr, null, window);
}

// Якорь
function sbEditorAnchorAction(el)
{
	if ( el.className == "buttonDisabled" || !sbEditorArea )
		return;
	
	el.className = "button";
		
	var strPage = window.parent.sb_cms_modal_dialog_file + "?event=pl_editor_anchor";
    var strAttr = "resizable=1,width=600,height=300";
    
    window.parent.sbShowModalDialog(strPage, strAttr, null, window);
}

function sbEditorAnchorDeleteAction()
{
	if ( !sbEditorArea )
		return;
		 
	if (sbEditorSelection._GetType() == 'Control')
	{
		sbEditorSelection._Delete();
	}
	else
	{
		var oFakeImage = sbEditorSelection._GetSelectedElement() ;
		if ( oFakeImage )
		{
			if ( oFakeImage.tagName == 'IMG' && oFakeImage.getAttribute('_sbanchor') )
				oAnchor = sbEditorGetRealElement( oFakeImage ) ;
			else
				oFakeImage = null ;
		}

		if ( !oFakeImage )
		{
			oAnchor = sbEditorSelection._MoveToAncestorNode( 'A' ) ;
			if ( oAnchor )
				sbEditorSelection._SelectNode( oAnchor ) ;
		}

		if ( oAnchor.href.length != 0 )
		{
			oAnchor.removeAttribute( 'name' ) ;
			if ( _isIE )
				oAnchor.className = oAnchor.className.replace( sbEditorRegexLib.SB_Class, '' ) ;
			return ;
		}

		if ( oFakeImage )
		{
			oFakeImage.parentNode.removeChild( oFakeImage ) ;
			return ;
		}

		if ( oAnchor.innerHTML.length == 0 )
		{
			oAnchor.parentNode.removeChild( oAnchor ) ;
			return ;
		}

		sbEditorRemoveOuterTags( oAnchor ) ;
	}
	if ( _isFF )
		sbEditorSelection._Collapse( true ) ;
}

// Убрать ссылку
function sbEditorUnlinkAction(el)
{
	if ( el.className == "buttonDisabled" || !sbEditorArea )
		return;
		
	sbEditorUndo._SaveUndoStep() ;

	if ( !_isIE )
	{
		var oLink = sbEditorSelection._MoveToAncestorNode( 'A' ) ;
		if ( oLink )
			sbEditorRemoveOuterTags( oLink ) ;
	}
	else
	{
		sbEditorExecuteNamedCommand( 'Unlink' ) ;
	}
	
	setTimeout( "sbEditorEvents._FireEvent( \"OnSelectionChange\" ) ;", 100 );
}

// Изображение
function sbEditorImageAction(el)
{
	if ( el.className == "buttonDisabled" || !sbEditorArea )
		return;
	
	el.className = "button";
		
	var strPage = window.parent.sb_cms_modal_dialog_file + "?event=pl_editor_image";
    var strAttr = "resizable=1,width=800,height=600";
    
    window.parent.sbShowModalDialog(strPage, strAttr, null, window);
}

// Карта изображения
function sbEditorImagemapAction(el)
{
	if ( el.className == "buttonDisabled" || !sbEditorArea )
		return;
	
	el.className = "button";
		
	var strPage = window.parent.sb_cms_modal_dialog_file + "?event=pl_editor_imagemap";
    var strAttr = "resizable=1,width=800,height=600";
    
    window.parent.sbShowModalDialog(strPage, strAttr, null, window);
}

// Flash
function sbEditorFlashAction(el)
{
	if ( el.className == "buttonDisabled" || !sbEditorArea )
		return;
	
	el.className = "button";
		
	var strPage = window.parent.sb_cms_modal_dialog_file + "?event=pl_editor_flash";
    var strAttr = "resizable=1,width=800,height=600";
    
    window.parent.sbShowModalDialog(strPage, strAttr, null, window);
}

// Movie
function sbEditorMovieAction(el)
{
	if ( el.className == "buttonDisabled" || !sbEditorArea )
		return;
	
	el.className = "button";
		
	var strPage = window.parent.sb_cms_modal_dialog_file + "?event=pl_editor_movie";
    var strAttr = "resizable=1,width=800,height=600";
    
    window.parent.sbShowModalDialog(strPage, strAttr, null, window);
}

// Шаблон
function sbEditorTemplatesHelper()
{	
	if (window.parent.sbModalDialog.returnValue)
	{
		sbEditorInsertHtml(window.parent.sbModalDialog.returnValue);
	}
}

function sbEditorTemplatesAction(el)
{
	if ( el.className == "buttonDisabled" || !sbEditorArea )
		return;
	
	el.className = "button";
		
	var strPage = window.parent.sb_cms_modal_dialog_file + "?event=pl_editor_templates";
    var strAttr = "resizable=1,width=500,height=600";
    
    window.parent.sbShowModalDialog(strPage, strAttr, sbEditorTemplatesHelper, window);
}

// Специальный символ
function sbEditorSpecialCharHelper()
{	
	if (window.parent.sbModalDialog.returnValue)
	{
		sbEditorInsertHtml(window.parent.sbModalDialog.returnValue);
	}
}

function sbEditorSpecialCharAction(el)
{
	if ( el.className == "buttonDisabled" || !sbEditorArea )
		return;
	
	el.className = "button";
		
	var strPage = window.parent.sb_cms_modal_dialog_file + "?event=pl_editor_special_char";
    var strAttr = "resizable=0,width=650,height=300";
    
    window.parent.sbShowModalDialog(strPage, strAttr, sbEditorSpecialCharHelper);
}

// Разрыв страницы
function sbEditorPageBreakAction(el)
{
	if ( el.className == "buttonDisabled" || !sbEditorArea )
		return;
		
	sbEditorUndo._SaveUndoStep() ;

	var e = sbEditorAreaDoc.createElement( 'DIV' ) ;
	e.style.pageBreakAfter = 'always' ;
	e.innerHTML = '<span style="DISPLAY:none">&nbsp;</span>' ;

	var oFakeImage = sbEditorDocumentProcessor._CreateFakeImage( 'sb__PageBreak', e ) ;
	var oRange = new sbEditorDomRange( sbEditorAreaWnd ) ;
	oRange._MoveToSelection() ;
	var oSplitInfo = oRange._SplitBlock() ;
	oRange._InsertNode( oFakeImage ) ;

	sbEditorEvents._FireEvent( 'OnSelectionChange' ) ;
}

// HR
function sbEditorHRAction(el)
{
	if ( el.className == "buttonDisabled" || !sbEditorArea )
		return;
		
	sbEditorUndo._SaveUndoStep() ;
	sbEditorInsertElement( 'hr' ) ;
}

// Bold, Italic, Underline
function sbEditorCoreStyleAction(el, styleName)
{
	if ( el.className == "buttonDisabled" || !sbEditorArea )
		return;
		
	styleName = "_sb_" + styleName;
	sbEditorUndo._SaveUndoStep() ;

	if ( sbEditorActiveStyles[styleName] )
		sbEditorStyles._RemoveStyle( styleName ) ;
	else
		sbEditorStyles._ApplyStyle( styleName ) ;

	sbEditorFocus() ;
	sbEditorEvents._FireEvent( 'OnSelectionChange' ) ;
}

// Выравнивание текста
function sbEditorJustifyAction ( el, alignValue )
{
	if ( el.className == "buttonDisabled" || !sbEditorArea )
		return;
		
	sbEditorUndo._SaveUndoStep() ;

	var range = new sbEditorDomRange( sbEditorAreaWnd ) ;
	range._MoveToSelection() ;

	var currentState = sbEditorJustifyState() ;
	if ( currentState == SB_EDITOR_STATE_DISABLED )
		return ;

	if (_isOpera)
		var bookmark = range._CreateBookmark2() ;
	else
		var bookmark = range._CreateBookmark() ;

	var iterator = new sbEditorDomRangeIterator( range ) ;
	var block ;
	while ( ( block = iterator._GetNextParagraph() ) )
	{
		block.removeAttribute( 'align' ) ;
		var style = block.style ;
		if ( currentState == SB_EDITOR_STATE_OFF )
			style.textAlign = alignValue ;
		else
		{
			style.textAlign = '' ;
			if ( style.cssText.length == 0 )
				block.removeAttribute( 'style' ) ;
		}
	}

	sbEditorRangeFocus(range, bookmark);
	sbEditorEvents._FireEvent( 'OnSelectionChange' ) ;
}

// Списки
function sbEditorListAction(el, tagName)
{
	if ( el.className == "buttonDisabled" || !sbEditorArea )
		return;
		
	sbEditorUndo._SaveUndoStep() ;

	var doc = sbEditorAreaDoc ;
	var range = new sbEditorDomRange( sbEditorAreaWnd ) ;
	range._MoveToSelection() ;
	var state = sbEditorListState(tagName) ;

	if ( state == SB_EDITOR_STATE_OFF )
	{
		sbEditorTrimNode( sbEditorArea ) ;
		if ( ! sbEditorArea.firstChild )
		{
			var paragraph = doc.createElement( 'p' ) ;
			sbEditorArea.appendChild( paragraph ) ;
			range._MoveToNodeContents( paragraph ) ;
		}
	}

	if ( _isOpera)
		var bookmark = range._CreateBookmark2() ;
	else
		var bookmark = range._CreateBookmark() ;

	var listGroups = [] ;
	var markerObj = {} ;
	var iterator = new sbEditorDomRangeIterator( range ) ;
	var block ;

	iterator._ForceBrBreak = ( state == SB_EDITOR_STATE_OFF ) ;
	var nextRangeExists = true ;
	var rangeQueue = null ;
	while ( nextRangeExists )
	{
		while ( ( block = iterator._GetNextParagraph() ) )
		{
			var path = new sbEditorElementPath( block ) ;
			var listNode = null ;
			var processedFlag = false ;
			var blockLimit = path._BlockLimit ;

			for ( var i = path._Elements.length - 1 ; i >= 0 ; i-- )
			{
				var el = path._Elements[i] ;
				if ( el.nodeName.IEquals( ['ol', 'ul'] ) )
				{
					if ( blockLimit && blockLimit._sb_ListGroupObject )
						blockLimit._sb_ListGroupObject = null ;

					var groupObj = el._sb_ListGroupObject ;
					if ( groupObj )
						groupObj.contents.push( block ) ;
					else
					{
						groupObj = { 'root' : el, 'contents' : [ block ] } ;
						listGroups.push( groupObj ) ;
						sbEditorSetElementMarker( markerObj, el, '_sb_ListGroupObject', groupObj ) ;
					}
					processedFlag = true ;
					break ;
				}
			}

			if ( processedFlag )
				continue ;

			var root = blockLimit ;
			if ( root && root._sb_ListGroupObject )
				root._sb_ListGroupObject.contents.push( block ) ;
			else
			{
				var groupObj = { 'root' : root, 'contents' : [ block ] } ;
				sbEditorSetElementMarker( markerObj, root, '_sb_ListGroupObject', groupObj ) ;
				listGroups.push( groupObj ) ;
			}
		}

		if ( _isIE )
			nextRangeExists = false ;
		else
		{
			if ( rangeQueue == null )
			{
				rangeQueue = [] ;
				var selectionObject = sbEditorSelection._GetSelection() ;
				if ( selectionObject && listGroups.length == 0 )
					rangeQueue.push( selectionObject.getRangeAt( 0 ) ) ;
				for ( var i = 1 ; selectionObject && i < selectionObject.rangeCount ; i++ )
					rangeQueue.push( selectionObject.getRangeAt( i ) ) ;
			}
			if ( rangeQueue.length < 1 )
				nextRangeExists = false ;
			else
			{
				var internalRange = sbEditorW3CRange._CreateFromRange( doc, rangeQueue.shift() ) ;
				range._Range = internalRange ;
				range._UpdateElementInfo() ;
				if ( range.startNode.nodeName.IEquals( 'td' ) )
					range.setStart( range.startNode, 1 ) ;
				if ( range.endNode.nodeName.IEquals( 'td' ) )
					range.setEnd( range.endNode, 2 ) ;
				iterator = new sbEditorDomRangeIterator( range ) ;
				iterator._ForceBrBreak = ( state == SB_EDITOR_STATE_OFF ) ;
			}
		}
	}

	var listsCreated = [] ;
	while ( listGroups.length > 0 )
	{
		var groupObj = listGroups.shift() ;
		if ( state == SB_EDITOR_STATE_OFF )
		{
			if ( groupObj.root.nodeName.IEquals( ['ul', 'ol'] ) )
				sbEditorChangeListType( groupObj, markerObj, listsCreated, tagName ) ;
			else
				sbEditorCreateList( groupObj, listsCreated, tagName ) ;
		}
		else if ( state == SB_EDITOR_STATE_ON && groupObj.root.nodeName.IEquals( ['ul', 'ol'] ) )
			sbEditorRemoveList( groupObj, markerObj ) ;
	}

	for ( var i = 0 ; i < listsCreated.length ; i++ )
	{
		var listNode = listsCreated[i] ;
		var stopFlag = false ;
		var currentNode = listNode ;
		while ( ! stopFlag )
		{
			currentNode = currentNode.nextSibling ;
			if ( currentNode && currentNode.nodeType == 3 && currentNode.nodeValue.search( /^[\n\r\t ]*$/ ) == 0 )
				continue ;
			stopFlag = true ;
		}

		if ( currentNode && currentNode.nodeName.IEquals( tagName ) )
		{
			currentNode.parentNode.removeChild( currentNode ) ;
			while ( currentNode.firstChild )
				listNode.appendChild( currentNode.removeChild( currentNode.firstChild ) ) ;
		}

		stopFlag = false ;
		currentNode = listNode ;
		while ( ! stopFlag )
		{
			currentNode = currentNode.previousSibling ;
			if ( currentNode && currentNode.nodeType == 3 && currentNode.nodeValue.search( /^[\n\r\t ]*$/ ) == 0 )
				continue ;
			stopFlag = true ;
		}
		if ( currentNode && currentNode.nodeName.IEquals( tagName ) )
		{
			currentNode.parentNode.removeChild( currentNode ) ;
			while ( currentNode.lastChild )
				listNode.insertBefore( currentNode.removeChild( currentNode.lastChild ), listNode.firstChild ) ;
		}
	}

	sbEditorClearAllMarkers( markerObj ) ;
	sbEditorRangeFocus(range, bookmark)
	sbEditorEvents._FireEvent( 'OnSelectionChange' ) ;
}

// Отступы
function sbEditorIdentAction(el, identName)
{
	if ( el.className == "buttonDisabled" || !sbEditorArea )
		return;
		
	sbEditorUndo._SaveUndoStep() ;

	var range = new sbEditorDomRange( sbEditorAreaWnd ) ;
	range._MoveToSelection() ;
	var bookmark = range._CreateBookmark() ;

	var nearestListBlock = sbEditorGetCommonParentNode( range.startNode || range.startContainer ,
			range.endNode || range.endContainer,
			['ul', 'ol'] ) ;
	if ( nearestListBlock )
		sbEditorIndentList( range, nearestListBlock, identName ) ;
	else
		sbEditorIndentBlock( range, SB_EDITOR_IDENT_OFFSET * ( identName.IEquals( 'indent' ) ? 1 : -1 ) ) ;
	
	range._MoveToBookmark( bookmark ) ;
	range._Select() ;

	sbEditorFocus() ;
	sbEditorEvents._FireEvent( 'OnSelectionChange' ) ;
}

// Цвет шрифта и фона
var sbEditorColorType = "";
function sbEditorTextColorAction(el, cType)
{
	if ( el.className == "buttonDisabled" || !sbEditorArea )
		return;
	
	el.className = "button";
		
	sbEditorColorType = cType == 'ForeColor' ? 'Color' : 'BackColor' ;

    if ( sbEditorSelection._GetType() == 'Control' )
        var startElement = sbEditorSelection._GetSelectedElement() ;
    else
        var startElement = sbEditorSelection._GetBoundaryParentElement( true ) ;

    var color = "";
    if ( startElement )
    {
        color = (cType == 'ForeColor' ? startElement.style.color : startElement.style.backgroundColor);
    }
    
	var strPage = window.parent.sb_cms_modal_dialog_file + "?event=pl_editor_color&drop_btn=1&color="+sbEscapeEx(color);
    if (/MSIE (5\.5|6\.)/.test(navigator.userAgent))
    	var strAttr = "resizable=0,width=700,height=470";
    else    
        var strAttr = "resizable=0,width=700,height=450";
    
    window.parent.sbShowModalDialog(strPage, strAttr, sbEditorTextColorActionHelper);
}

function sbEditorTextColorActionHelper()
{
	if (!window.parent.sbModalDialog.returnValue && window.parent.sbModalDialog.returnValue !== "")
    	return ;
    
    var color = window.parent.sbModalDialog.returnValue;
    sbEditorUndo._SaveUndoStep() ;

	var style = sbEditorStyles._GetStyle( '_sb_' + sbEditorColorType ) ;
    
	if ( !color || color.length == 0 )
	{
		sbEditorStyles._RemoveStyle( style ) ;
    }
	else
	{
	    style._SetVariable( 'Color', color ) ;
		sbEditorStyles._ApplyStyle( style ) ;
	}

	sbEditorFocus() ;
	sbEditorEvents._FireEvent( 'OnSelectionChange' ) ;
}

// Очистить форматирование
function sbEditorRemoveFormatAction(el)
{
	if ( el.className == "buttonDisabled" || !sbEditorArea )
		return;
		
	sbEditorUndo._SaveUndoStep() ;
	sbEditorStyles._RemoveAll() ;

	sbEditorFocus() ;
	sbEditorEvents._FireEvent( 'OnSelectionChange' ) ;
}

// Показать границы блоков
function sbEditorShowBlocksAction(el)
{
	if ( el.className == "buttonDisabled" || !sbEditorArea )
		return;
		
	var state = sbEditorShowBlocksState() ;

	if ( state == SB_EDITOR_STATE_DISABLED )
		return ;

	if ( state == SB_EDITOR_STATE_ON )
		sbEditorArea.className = sbEditorArea.className.replace( /(^| )sb__ShowBlocks/g, '' ) ;
	else
		sbEditorArea.className += ' sb__ShowBlocks' ;

	if ( _isIE )
	{
		try
		{
			sbEditorAreaDoc.selection.createRange().select() ;
		}
		catch ( e )
		{}
	}
	else
	{
		var focus = sbEditorAreaWnd.getSelection().focusNode ;
		if ( focus.nodeType != 1 )
			focus = focus.parentNode ;
		sbEditorScrollIntoView( focus, false ) ;
	}

	sbEditorEvents._FireEvent( 'OnSelectionChange' ) ;
}

// BR
function sbEditorBRAction(el)
{
	if ( el.className == "buttonDisabled" || !sbEditorArea )
		return;
		
	sbEditorUndo._SaveUndoStep() ;
	sbEditorInsertElement( 'br' ) ;
}

// &nbsp;
function sbEditorNbspAction(el)
{
	if ( el.className == "buttonDisabled" || !sbEditorArea )
		return;
		
	sbEditorUndo._SaveUndoStep() ;
	sbEditorInsertHtml( '&nbsp;' ) ;
}

// Справка
function sbEditorHelpAction()
{
	window.open("http://www.sbuilder.ru/docs/helps40/vizred.doc", "_blank", "resizable=1, width="+screen.availWidth+", height="+screen.availHeight);
}

// Стиль	
function sbEditorStyleAction(sname, item)
{
	if ( !sbEditorArea )
		return;
		 
	sbEditorUndo._SaveUndoStep() ;

	if ( item._Selected )
	{
		sbEditorStyles._RemoveStyle( item._Style ) ;
	}
	else
	{
		sbEditorStyles._ApplyStyle( item._Style ) ;
	}

	sbEditorFocus() ;
}

// Вставка и свойства таблицы
function sbEditorTableAction(el, _action)
{
	if ( el.className == "buttonDisabled" || !sbEditorArea )
		return;
	
	if (_action == "remove")
	{
		sbEditorUndo._SaveUndoStep();
		
		sbEditorTableHandler._DeleteTable();
		
		sbEditorFocus();
		sbEditorEvents._FireEvent("OnSelectionChange");
		return;
	}
	
	el.className = "button";
	
	var strPage = window.parent.sb_cms_modal_dialog_file + "?event=pl_editor_table" + (_action == "props" ? "&props=true" : "");
    var strAttr = "resizable=1,width=750,height=450";
    
    window.parent.sbShowModalDialog(strPage, strAttr, null, window);
}

// Св-ва ячейки, дива и параграфа
function sbEditorTableCellAction(el, _block)
{
	if ( el.className == "buttonDisabled" || !sbEditorArea )
		return;
		
	if ( !_block)
	{
		if ( sbEditorBlocksState() == SB_EDITOR_STATE_DISABLED )
			return ;
			
		_block = 'p';
	}
	
	el.className = "button";
	
	var strPage = window.parent.sb_cms_modal_dialog_file + "?event=pl_editor_table_cell&block=" + _block ;
    var strAttr = "resizable=1,width=750,height=500";
    
    window.parent.sbShowModalDialog(strPage, strAttr, null, window);
}

// Выравнивание внутри ячейки
function sbEditorValignAction ( el, alignValue )
{
	if ( el.className == "buttonDisabled" || !sbEditorArea )
		return;
		
	var currentState = sbEditorValignState() ;
	if ( currentState == SB_EDITOR_STATE_DISABLED )
		return ;
		
	var oCells = sbEditorTableHandler._GetSelectedCells();
		
	sbEditorUndo._SaveUndoStep() ;

	for (var i = 0; i < oCells.length; i++)
	{
		var oCell = oCells[i]; 
		oCell.removeAttribute( 'valign' ) ;
		var style = oCell.style ;
		if ( currentState == SB_EDITOR_STATE_OFF )
			style.verticalAlign = alignValue ;
		else
		{
			style.verticalAlign = '' ;
			if ( style.cssText.length == 0 )
				oCell.removeAttribute( 'style' ) ;
		}
	}

	sbEditorEvents._FireEvent( 'OnSelectionChange' ) ;
}

// Работа с ячейками
function sbEditorTableCellsAction(el, _what, _action, _where)
{
	if ( el.className == "buttonDisabled" || !sbEditorArea )
		return;
		
	sbEditorUndo._SaveUndoStep();
	
	switch (_what)
	{
		case 'col':
			if (_action == 'add')
				sbEditorTableHandler._InsertColumn(_where);
			else if (_action == 'remove')
				sbEditorTableHandler._DeleteColumns();
			else if (_action == 'split')
				sbEditorTableHandler._SplitCol();
			break;
			
		case 'row':
			if (_action == 'add')
				sbEditorTableHandler._InsertRow(_where);
			else if (_action == 'remove')
				sbEditorTableHandler._DeleteRows();
			else if (_action == 'split')
				sbEditorTableHandler._SplitRow();
			break;
		
		case 'cells':
			if (_action == 'merge' && _where == 'cells')
				sbEditorTableHandler._MergeCells();
			else if (_action == 'merge' && _where == 'row')
				sbEditorTableHandler._MergeRow();
			else if (_action == 'merge' && _where == 'col')
				sbEditorTableHandler._MergeCol();
			break;
	}
	
	sbEditorFocus();
	sbEditorEvents._FireEvent("OnSelectionChange");
}

/**
 * Функции, меняющие состояние кнопок тулбара и выполняющие другие действия при смене позиции курсора
 */

function sbEditorRefreshButtons()
{
	for (el_id in sbEditorStateActions)
	{
		if (el_id.search(/sbEditor/i) != -1)
		{
			if (sbEditorStateActions[el_id])
				sbEditorSetState(el_id, sbEditorArea ? sbEditorStateActions[el_id] : SB_EDITOR_STATE_DISABLED);
			else
				sbEditorSetState(el_id, sbEditorArea ? SB_EDITOR_STATE_OFF : SB_EDITOR_STATE_DISABLED);
		}
	}
}

function sbEditorPaddingNodeListener()
{
	if ( !sbEditorArea )
		return;
		 
	if ( SB_EDITOR_ENTER_MODE.IEquals( 'br' ) )
		return ;
		
	sbEditorEnforcePaddingNode( sbEditorAreaDoc, SB_EDITOR_ENTER_MODE ) ;

	if ( ! _isIE && sbEditorPaddingNode )
	{
		var sel = sbEditorSelection._GetSelection() ;
		if ( sel && sel.rangeCount == 1 )
		{
			var range = sel.getRangeAt( 0 ) ;
			if ( range.collapsed && range.startContainer == sbEditorArea && range.startOffset == 0 )
			{
				range.selectNodeContents( sbEditorPaddingNode ) ;
				range.collapse( true ) ;
				sel.removeAllRanges() ;
				sel.addRange( range ) ;
			}
		}
	}
	else if ( sbEditorPaddingNode )
	{
		var parentElement = sbEditorSelection._GetParentElement() ;
		var paddingNode = sbEditorPaddingNode ;
		
		if ( parentElement && parentElement == sbEditorArea )
		{
			if ( sbEditorArea.childNodes.length == 1 && sbEditorArea.firstChild == paddingNode )
			{
				if ( sbEditorSelection._GetSelectionDocument( sbEditorAreaDoc.selection ) != sbEditorAreaDoc )
					return ;

				var range = sbEditorAreaDoc.body.createTextRange() ;
				var clearContents = false ;
				if ( !paddingNode.childNodes.firstChild )
				{
					paddingNode.appendChild( sbGetElementDocument( paddingNode ).createTextNode( '\ufeff' ) ) ;
					clearContents = true ;
				}
				range.moveToElementText( paddingNode ) ;
				range.select() ;
				if ( clearContents )
					range.pasteHTML( '' ) ;
			}
		}
	}
}

function sbEditorEmptyBlockListener()
{
	if ( !sbEditorArea )
		return;
		 
	sbEditorFillEmptyBlock( sbEditorArea.firstChild ) ;
	var sel = sbEditorSelection._GetSelection() ;
	if ( !sel || sel.rangeCount < 1 )
		return ;
	var range = sel.getRangeAt( 0 );
	sbEditorFillEmptyBlock( range.startContainer ) ;
}

function sbEditorCutCopyState()
{
	return sbEditorGetNamedCommandState( 'Cut' ) ;
}

function sbEditorPasteState()
{
	return sbEditorGetNamedCommandState( 'Paste' ) ;
}

function sbEditorUnlinkState()
{
	var state = sbEditorGetNamedCommandState( 'Unlink' ) ;

	if ( state == SB_EDITOR_STATE_OFF )
	{
		var oLink = sbEditorSelection._MoveToAncestorNode( 'A' ) ;
		if ( !oLink )
			state = SB_EDITOR_STATE_DISABLED ;
	}

	return state ;
}

function sbEditorImagemapState()
{
	if ( sbEditorSelection._GetType() == 'Control' )
	{
		var el = sbEditorSelection._GetSelectedElement() ;
		if ( !el || el.getAttribute('_sbfakelement') || el.nodeName.toLowerCase() != 'img')
			return SB_EDITOR_STATE_DISABLED ;
	}
	else
	{
		return SB_EDITOR_STATE_DISABLED ;
	}
	
	return SB_EDITOR_STATE_OFF ;
}

function sbEditorHRState()
{
	return sbEditorGetNamedCommandState( 'InsertHorizontalRule' ) ;
}

function sbEditorCoreStyleStateChange(styleName, isActive)
{
	sbEditorActiveStyles[ styleName ] = isActive;
}

function sbEditorCoreStyleState( styleName )
{
	return sbEditorActiveStyles[ "_sb_" + styleName ] ? SB_EDITOR_STATE_ON : SB_EDITOR_STATE_OFF ;
}

function sbEditorJustifyState ( alignValue )
{
	var path = new sbEditorElementPath( sbEditorSelection._GetBoundaryParentElement( true ) ) ;
	var firstBlock = path._Block || path._BlockLimit ;

	if ( !firstBlock || firstBlock.nodeName.toLowerCase() == 'body' || firstBlock == sbEditorArea)
		return SB_EDITOR_STATE_OFF ;

	var currentAlign ;
	if ( _isIE )
		currentAlign = firstBlock.currentStyle.textAlign ;
	else
		currentAlign = sbEditorAreaWnd.getComputedStyle( firstBlock, '' ).getPropertyValue( 'text-align' );
	currentAlign = currentAlign.replace( /(-moz-|-webkit-|start|auto)/i, '' );
	
	if ( ( !currentAlign && alignValue == "left" ) || currentAlign == alignValue )
		return SB_EDITOR_STATE_ON ;
		
	return SB_EDITOR_STATE_OFF ;
}

function sbEditorListState(tagName)
{
	var startContainer = sbEditorSelection._GetBoundaryParentElement( true ) ;
	var listNode = startContainer ;
	while ( listNode )
	{
		if ( listNode.nodeName.IEquals( [ 'ul', 'ol' ] ) )
			break ;
		listNode = listNode.parentNode ;
	}
	if ( listNode && listNode.nodeName.IEquals( tagName ) )
		return SB_EDITOR_STATE_ON ;
	else
		return SB_EDITOR_STATE_OFF ;
}

function sbEditorIdentState(identName)
{
	var startContainer = sbEditorSelection._GetBoundaryParentElement( true ) ;
	var endContainer = sbEditorSelection._GetBoundaryParentElement( false ) ;
	var listNode = sbEditorGetCommonParentNode( startContainer, endContainer, ['ul','ol'] ) ;

	if ( listNode )
	{
		if ( identName.IEquals( 'outdent' ) )
			return SB_EDITOR_STATE_OFF ;
			
		var firstItem = sbEditorGetElementAscensor( startContainer, 'li' ) ;
		if ( !firstItem || !firstItem.previousSibling )
			return SB_EDITOR_STATE_DISABLED ;
			
		return SB_EDITOR_STATE_OFF ;
	}
	if ( identName.IEquals( 'indent' ) )
		return SB_EDITOR_STATE_OFF;

	var path = new sbEditorElementPath( startContainer ) ;
	var firstBlock = path._Block || path._BlockLimit ;
	if ( !firstBlock )
		return SB_EDITOR_STATE_DISABLED ;

	var indent = parseInt( firstBlock.style['marginLeft'], 10 ) ;
	if ( isNaN( indent ) )
		indent = 0 ;
	if ( indent <= 0 )
		return SB_EDITOR_STATE_DISABLED ;
		
	return SB_EDITOR_STATE_OFF ;
}

function sbEditorShowBlocksState()
{
	if ( /sb__ShowBlocks(?:\s|$)/.test( sbEditorArea.className ) )
		return SB_EDITOR_STATE_ON ;

	return SB_EDITOR_STATE_OFF ;
}

function sbEditorTableState(_name)
{
	if ( sbEditorSelection._HasAncestorNode( 'TABLE' ) )
	{
		if (sbEditorSelection._MoveToAncestorNode( 'CAPTION' ) )
		{
			if (_name != 'TableEdit')
				return SB_EDITOR_STATE_DISABLED;
			else
				return SB_EDITOR_STATE_OFF;
		}
		
		switch ( _name )
		{
			case 'SplitCol' :
			case 'SplitRow' :
				if ( sbEditorTableHandler._GetSelectedCells().length == 1 )
					return SB_EDITOR_STATE_OFF ;
				else
					return SB_EDITOR_STATE_DISABLED ;
					
			case 'Merge' :
				if ( sbEditorTableHandler._CheckIsSelectionRectangular() && sbEditorTableHandler._GetSelectedCells().length > 1 )
					return SB_EDITOR_STATE_OFF ;
				else
					return SB_EDITOR_STATE_DISABLED ;
			
			case 'MergeCol' :
				return sbEditorTableHandler._GetMergeRightTarget() ? SB_EDITOR_STATE_OFF : SB_EDITOR_STATE_DISABLED ;
				break;
				
			case 'MergeRow' :
				return sbEditorTableHandler._GetMergeDownTarget() ? SB_EDITOR_STATE_OFF : SB_EDITOR_STATE_DISABLED ;
				break;
						
			default :
				return SB_EDITOR_STATE_OFF ;
		}
	}
	else
		return SB_EDITOR_STATE_DISABLED;
}

function sbEditorValignState ( alignValue )
{
	if ( sbEditorTableState('TableEdit') == SB_EDITOR_STATE_DISABLED )
		return SB_EDITOR_STATE_DISABLED;
		
	var oCells = sbEditorTableHandler._GetSelectedCells();
	if (oCells.length < 1)
		return SB_EDITOR_STATE_DISABLED;
		
	var currentAlign ;
	if ( _isIE )
		currentAlign = oCells[0].currentStyle.verticalAlign ;
	else
		currentAlign = oCells[0].style.verticalAlign;

	currentAlign = currentAlign.replace( /(-moz-|-webkit-|start|auto)/i, '' );

	if ( ( !currentAlign && alignValue == "middle" ) || currentAlign == alignValue )
		return SB_EDITOR_STATE_ON ;
		
	return SB_EDITOR_STATE_OFF ;
}

function sbEditorBlocksState()
{
	var path = new sbEditorElementPath( sbEditorSelection._GetBoundaryParentElement( true ) ) ;
	var firstBlock = path._Block || path._BlockLimit ;

	if ( !firstBlock || firstBlock == sbEditorArea ||
		firstBlock.nodeName.toLowerCase() == 'body' ||
		firstBlock.nodeName.toLowerCase() == 'td' ||
		firstBlock.nodeName.toLowerCase() == 'th')
		return SB_EDITOR_STATE_DISABLED ;
		
	return SB_EDITOR_STATE_OFF ;
}

/**
 * Объявляем наши события
 */ 

// должно идти всегда первым, так как влияет на другие события
sbEditorEvents._AttachEvent( 'OnSelectionChange', function() { sbEditorStyles._CheckSelectionChanges() ; } ) ;

var sbEditorActiveStyles = [];
sbEditorActiveStyles['_sb_Bold'] = false;
sbEditorActiveStyles['_sb_Italic'] = false;
sbEditorActiveStyles['_sb_Underline'] = false;
sbEditorActiveStyles['_sb_StrikeThrough'] = false;
sbEditorActiveStyles['_sb_Subscript'] = false;
sbEditorActiveStyles['_sb_Superscript'] = false;

sbEditorStyles._AttachStyleStateChange( '_sb_Bold', sbEditorCoreStyleStateChange ) ;
sbEditorStyles._AttachStyleStateChange( '_sb_Italic', sbEditorCoreStyleStateChange ) ;
sbEditorStyles._AttachStyleStateChange( '_sb_Underline', sbEditorCoreStyleStateChange ) ;
sbEditorStyles._AttachStyleStateChange( '_sb_StrikeThrough', sbEditorCoreStyleStateChange ) ;
sbEditorStyles._AttachStyleStateChange( '_sb_Subscript', sbEditorCoreStyleStateChange ) ;
sbEditorStyles._AttachStyleStateChange( '_sb_Superscript', sbEditorCoreStyleStateChange ) ;

sbEditorEvents._AttachEvent( 'OnSelectionChange', sbEditorRefreshButtons ) ;
sbEditorEvents._AttachEvent( 'OnSelectionChange', sbEditorPaddingNodeListener ) ;
if (_isFF)
{
	sbEditorEvents._AttachEvent( 'OnSelectionChange', sbEditorEmptyBlockListener ) ;
}
	
/**
 * Объявляем функции, возвращающие состояние кнопок
 */

sbEditorStateActions["sbEditorBtnSave"] = false;
sbEditorStateActions["sbEditorBtnSource"] = false;
sbEditorStateActions["sbEditorBtnExit"] = false;

sbEditorStateActions["sbEditorBtnCopy"] = new Array(sbEditorCutCopyState, null);
sbEditorStateActions["sbEditorBtnCut"] = new Array(sbEditorCutCopyState, null);

sbEditorStateActions["sbEditorBtnPaste"] = new Array(sbEditorPasteState, null);
sbEditorStateActions["sbEditorBtnPastePlain"] = new Array(sbEditorPasteState, null);
sbEditorStateActions["sbEditorBtnPasteWord"] = new Array(sbEditorPasteState, null);

sbEditorStateActions["sbEditorBtnFind"] = false;
sbEditorStateActions["sbEditorBtnSpell"] = false;

sbEditorStateActions["sbEditorBtnUndo"] = new Array(sbEditorUndo._CheckUndoState, sbEditorUndo);
sbEditorStateActions["sbEditorBtnRedo"] = new Array(sbEditorUndo._CheckRedoState, sbEditorUndo);

sbEditorStateActions["sbEditorBtnLink"] = false;
sbEditorStateActions["sbEditorBtnAnchor"] = false;
sbEditorStateActions["sbEditorBtnUnlink"] = new Array(sbEditorUnlinkState, null);

sbEditorStateActions["sbEditorBtnImage"] = false;
sbEditorStateActions["sbEditorBtnImageMap"] = new Array(sbEditorImagemapState, null);

sbEditorStateActions["sbEditorBtnFlash"] = false;
sbEditorStateActions["sbEditorBtnMovie"] = false;

sbEditorStateActions["sbEditorBtnTemplates"] = false;
sbEditorStateActions["sbEditorBtnChar"] = false;

sbEditorStateActions["sbEditorBtnPageBreak"] = false;
sbEditorStateActions["sbEditorBtnHR"] = new Array(sbEditorHRState, null);

sbEditorStateActions["sbEditorBtnBold"] = new Array(sbEditorCoreStyleState, 'Bold');
sbEditorStateActions["sbEditorBtnItalic"] = new Array(sbEditorCoreStyleState, 'Italic');
sbEditorStateActions["sbEditorBtnUnderline"] = new Array(sbEditorCoreStyleState, 'Underline');
sbEditorStateActions["sbEditorBtnStrike"] = new Array(sbEditorCoreStyleState, 'StrikeThrough');

sbEditorStateActions["sbEditorBtnSub"] = new Array(sbEditorCoreStyleState, 'Subscript');
sbEditorStateActions["sbEditorBtnSup"] = new Array(sbEditorCoreStyleState, 'Superscript');

sbEditorStateActions["sbEditorBtnLeft"] = new Array(sbEditorJustifyState, 'left');
sbEditorStateActions["sbEditorBtnCenter"] = new Array(sbEditorJustifyState, 'center');
sbEditorStateActions["sbEditorBtnRight"] = new Array(sbEditorJustifyState, 'right');
sbEditorStateActions["sbEditorBtnJustify"] = new Array(sbEditorJustifyState, 'justify');

sbEditorStateActions["sbEditorBtnNumberList"] = new Array(sbEditorListState, 'ol');
sbEditorStateActions["sbEditorBtnBulletList"] = new Array(sbEditorListState, 'ul');

sbEditorStateActions["sbEditorBtnOutdent"] = new Array(sbEditorIdentState, 'outdent');
sbEditorStateActions["sbEditorBtnIndent"] = new Array(sbEditorIdentState, 'indent');

sbEditorStateActions["sbEditorBtnFontColor"] = false;
sbEditorStateActions["sbEditorBtnBackColor"] = false;

sbEditorStateActions["sbEditorBtnSelect"] = false;
sbEditorStateActions["sbEditorBtnRemoveFormat"] = false;
sbEditorStateActions["sbEditorBtnBorders"] = new Array(sbEditorShowBlocksState, null);

sbEditorStateActions["sbEditorBtnPar"] = new Array(sbEditorBlocksState, null);
sbEditorStateActions["sbEditorBtnDiv"] = false;

sbEditorStateActions["sbEditorBtnBR"] = false;
sbEditorStateActions["sbEditorBtnNbsp"] = false;

sbEditorStateActions["sbEditorBtnTable"] = false;
sbEditorStateActions["sbEditorBtnRemoveTable"] = new Array(sbEditorTableState, 'RemoveTable');

sbEditorStateActions["sbEditorBtnTableEdit"] = new Array(sbEditorTableState, 'TableEdit');
sbEditorStateActions["sbEditorBtnCellEdit"] = new Array(sbEditorTableState, 'CellEdit');

sbEditorStateActions["sbEditorBtnTopAlign"] = new Array(sbEditorValignState, 'top');
sbEditorStateActions["sbEditorBtnMiddleAlign"] = new Array(sbEditorValignState, 'middle');
sbEditorStateActions["sbEditorBtnBottomAlign"] = new Array(sbEditorValignState, 'bottom');

sbEditorStateActions["sbEditorBtnMergeCol"] = new Array(sbEditorTableState, 'MergeCol');
sbEditorStateActions["sbEditorBtnMergeRow"] = new Array(sbEditorTableState, 'MergeRow');

sbEditorStateActions["sbEditorBtnMerge"] = new Array(sbEditorTableState, 'Merge');
sbEditorStateActions["sbEditorBtnSplitCol"] = new Array(sbEditorTableState, 'SplitCol');
sbEditorStateActions["sbEditorBtnSplitRow"] = new Array(sbEditorTableState, 'SplitRow');

sbEditorStateActions["sbEditorBtnAddColBefore"] = new Array(sbEditorTableState, 'AddColBefore');
sbEditorStateActions["sbEditorBtnAddCol"] = new Array(sbEditorTableState, 'AddCol');
sbEditorStateActions["sbEditorBtnRemoveCol"] = new Array(sbEditorTableState, 'RemoveCol');

sbEditorStateActions["sbEditorBtnAddRowBefore"] = new Array(sbEditorTableState, 'AddRowBefore');
sbEditorStateActions["sbEditorBtnAddRow"] = new Array(sbEditorTableState, 'AddRow');
sbEditorStateActions["sbEditorBtnRemoveRow"] = new Array(sbEditorTableState, 'RemoveRow');

<?php require_once(dirname(__FILE__).'/../jfooter.inc.php'); ?>