<?php require_once(dirname(__FILE__).'/../jheader.inc.php'); ?>
// расширяем возможности JS

String.prototype.Contains = function( textToCheck )
{
	return ( this.indexOf( textToCheck ) > -1 ) ;
}

String.prototype.Equals = function()
{
	var aArgs = arguments ;

	if ( aArgs.length == 1 && aArgs[0].pop )
		aArgs = aArgs[0] ;

	for ( var i = 0 ; i < aArgs.length ; i++ )
	{
		if ( this == aArgs[i] )
			return true ;
	}
	return false ;
}

String.prototype.IEquals = function()
{
	var thisUpper = this.toUpperCase() ;

	var aArgs = arguments ;

	if ( aArgs.length == 1 && aArgs[0].pop )
		aArgs = aArgs[0] ;

	for ( var i = 0 ; i < aArgs.length ; i++ )
	{
		if ( thisUpper == aArgs[i].toUpperCase() )
			return true ;
	}
	return false ;
}

String.prototype.ReplaceAll = function( searchArray, replaceArray )
{
	var replaced = this ;

	for ( var i = 0 ; i < searchArray.length ; i++ )
	{
		replaced = replaced.replace( searchArray[i], replaceArray[i] ) ;
	}

	return replaced ;
}

String.prototype.StartsWith = function( value )
{
	return ( this.substr( 0, value.length ) == value ) ;
}

String.prototype.EndsWith = function( value, ignoreCase )
{
	var L1 = this.length ;
	var L2 = value.length ;

	if ( L2 > L1 )
		return false ;

	if ( ignoreCase )
	{
		var oRegex = new RegExp( value + '$' , 'i' ) ;
		return oRegex.test( this ) ;
	}
	else
		return ( L2 == 0 || this.substr( L1 - L2, L2 ) == value ) ;
}

String.prototype.Remove = function( start, length )
{
	var s = '' ;

	if ( start > 0 )
		s = this.substring( 0, start ) ;

	if ( start + length < this.length )
		s += this.substring( start + length , this.length ) ;

	return s ;
}

String.prototype.Trim = function()
{
	return this.replace( /(^[ \t\n\r]*)|([ \t\n\r]*$)/g, '' ) ;
}

String.prototype.LTrim = function()
{
	return this.replace( /^[ \t\n\r]*/g, '' ) ;
}

String.prototype.RTrim = function()
{
	return this.replace( /[ \t\n\r]*$/g, '' ) ;
}

String.prototype.ReplaceNewLineChars = function( replacement )
{
	return this.replace( /\n/g, replacement ) ;
}

String.prototype.Replace = function( regExp, replacement, thisObj )
{
	if ( typeof replacement == 'function' )
	{
		return this.replace( regExp,
			function()
			{
				return replacement.apply( thisObj || this, arguments ) ;
			} ) ;
	}
	else
		return this.replace( regExp, replacement ) ;
}

Array.prototype.AddItem = function( item )
{
	var i = this.length ;
	this[ i ] = item ;
	return i ;
}

Array.prototype.IndexOf = function( value )
{
	for ( var i = 0 ; i < this.length ; i++ )
	{
		if ( this[i] == value )
			return i ;
	}
	return -1 ;
}

//////////////////////////////////////////////////////////////////////
function sbEditorRemoveOuterTags ( e )
{
	if (_isIE)
	{
		e.insertAdjacentHTML( 'beforeBegin', e.innerHTML ) ;
		e.parentNode.removeChild( e ) ;
	}
	else
	{
		var oFragment = e.ownerDocument.createDocumentFragment() ;
	
		for ( var i = 0 ; i < e.childNodes.length ; i++ )
			oFragment.appendChild( e.childNodes[i].cloneNode(true) ) ;
	
		e.parentNode.replaceChild( oFragment, e ) ;
	}
}

function sbEditorGetAllChildrenIds ( parentElement )
{
	var aIds = new Array() ;
	
	if (_isIE)
	{
		for ( var i = 0 ; i < parentElement.all.length ; i++ )
		{
			var sId = parentElement.all[i].id ;
			if ( sId && sId.length > 0 )
				aIds[ aIds.length ] = sId ;
		}
	}
	else
	{
		var fGetIds = function( parent )
		{
			for ( var i = 0 ; i < parent.childNodes.length ; i++ )
			{
				var sId = parent.childNodes[i].id ;
				if ( sId && sId.length > 0 ) aIds[ aIds.length ] = sId ;
				fGetIds( parent.childNodes[i] ) ;
			}
		}
	
		fGetIds( parentElement ) ;
	}
	
	return aIds ;
}

function sbEditorCreateLink ( url, noUndo )
{
	var aCreatedLinks = new Array() ;

	if (_isIE)
	{
		sbEditorExecuteNamedCommand( 'Unlink', null, false, !!noUndo ) ;
		
		if ( url.length > 0 )
		{
			if (sbEditorSelection._GetType() == 'Control')
			{
				var oLink = sbEditorAreaDoc.createElement( 'A' ) ;
				oLink.href = url ;

				var oControl = sbEditorSelection._GetSelectedElement() ;
				oControl.parentNode.insertBefore(oLink, oControl) ;
				oControl.parentNode.removeChild( oControl ) ;
				oLink.appendChild( oControl ) ;
	
				return [ oLink ] ;
			}
	
			var sTempUrl = 'javascript:void(0);/*' + ( new Date().getTime() ) + '*/' ;
	
			sbEditorExecuteNamedCommand( 'CreateLink', sTempUrl, false, !!noUndo ) ;
	
			var oLinks = sbEditorAreaDoc.links ;
	
			for ( i = 0 ; i < oLinks.length ; i++ )
			{
				var oLink = oLinks[i] ;
				if ( oLink.getAttribute( 'href', 2 ) == sTempUrl )
				{
					var sInnerHtml = oLink.innerHTML ;
					oLink.href = url ;
					oLink.innerHTML = sInnerHtml ;
	
					var oLastChild = oLink.lastChild ;
					if ( oLastChild && oLastChild.nodeName == 'BR' )
					{
						sbEditorInsertAfterNode( oLink, oLink.removeChild( oLastChild ) ) ;
					}
	
					aCreatedLinks.push( oLink ) ;
				}
			}
		}
	}
	else
	{

		if ( sbEditorSelection._GetSelection().isCollapsed )
			return aCreatedLinks ;	

		sbEditorExecuteNamedCommand( 'Unlink', null, false, !!noUndo ) ;
	
		if ( url.length > 0 )
		{
			var sTempUrl = 'javascript:void(0);/*' + ( new Date().getTime() ) + '*/' ;
	
			sbEditorExecuteNamedCommand( 'CreateLink', sTempUrl, false, !!noUndo ) ;
	
			var oLinksInteractor = sbEditorAreaDoc.evaluate("//a[@href='" + sTempUrl + "']", sbEditorArea, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null) ;
	
			for ( var i = 0 ; i < oLinksInteractor.snapshotLength ; i++ )
			{
				var oLink = oLinksInteractor.snapshotItem( i ) ;
				oLink.href = url ;
	
				aCreatedLinks.push( oLink ) ;
			}
		}
	}
	
	return aCreatedLinks ;
}

var sbEditorPasteIsRunning = false;
var sbEditorPasteIsEnabled = false;

function sbEditorPaste ()
{
	if ( !_isIE )
	{
		return true ;
	}
	else
	{
		if ( sbEditorPasteIsRunning )
			return true ;
	
		var sHTML = sbEditorCheckIsPastingEnabled( true ) ;
	
		if ( sHTML === false )
		{
			var strPage = window.parent.sb_cms_modal_dialog_file + "?event=pl_editor_paste";
    		var strAttr = "resizable=0,width=800,height=600";
    		var attr = new Object();
    		attr.wnd = window;
    		attr.type = "Security";
    		
    		window.parent.sbShowModalDialog(strPage, strAttr, sbEditorPasteHelper, attr);
		}
		else
		{
			if ( sHTML.length > 0 )
			{
				var re = /<\w[^>]*(( class="?MsoNormal"?)|(="mso-))/gi ;
				if ( re.test( sHTML ) )
				{
					if ( confirm( "<?php echo EDITOR_PASTE_FROM_WORD_CONFIRM; ?>" ) )
					{
						sbEditorPasteFromWordAction(false) ;
						return false ;
					}
				}
			}
	
			sbEditorPasteIsRunning = true ;
			sbEditorExecuteNamedCommand( 'Paste' ) ;
			sbEditorPasteIsRunning = false;
		}
	
		return false ;
	}
}

function sbEditorPastePlainText(forceText)
{
	if (_isIE)
	{
		if ( !sbEditorCheckIsPastingEnabled() )
		{
			var strPage = window.parent.sb_cms_modal_dialog_file + "?event=pl_editor_paste";
	    	var strAttr = "resizable=0,width=800,height=600";
	    	var attr = new Object();
	    	attr.wnd = window;
	    	attr.type = "PlainText";
	    	
	    	window.parent.sbShowModalDialog(strPage, strAttr, sbEditorPasteHelper, attr);
			return ;
		}
	
		var sText = null ;
		if ( ! forceText )
			sText = sbEditorAreaWnd.clipboardData.getData("Text") ;
		else
			sText = forceText ;

		if ( sText && sText.length > 0 )
		{
			sText = sbEditorHTMLEncode( sText ) ;
			sText = sbEditorProcessLineBreaks( sText ) ;
	
			var closeTagIndex = sText.search( '</p>' ) ;
			var startTagIndex = sText.search( '<p>' ) ;
	
			if ( ( closeTagIndex != -1 && startTagIndex != -1 && closeTagIndex < startTagIndex )
				 || ( closeTagIndex != -1 && startTagIndex == -1 ) )
			{
				var prefix = sText.substr( 0, closeTagIndex ) ;
				sText = sText.substr( closeTagIndex + 4 ) ;
				sbEditorInsertHtml( prefix, true ) ;
			}
	
			sbEditorInsertHtml( sText ) ;
		}
	}
	else
	{
		var strPage = window.parent.sb_cms_modal_dialog_file + "?event=pl_editor_paste";
    	var strAttr = "resizable=0,width=800,height=600";
    	var attr = new Object();
    	attr.wnd = window;
    	attr.type = "PlainText";
    	
    	window.parent.sbShowModalDialog(strPage, strAttr, sbEditorPasteHelper, attr);
	}
}
	
function sbEditorCheckIsPastingEnabled ( returnContents )
{
	function CheckPasting_Listener()
	{
		sbEditorPasteIsEnabled = true ;
	}
	
	sbEditorPasteIsEnabled = false ;
	sbEditorPasteIsRunning = true ;
	sbEditorAreaDoc.body.attachEvent( 'onpaste', CheckPasting_Listener ) ;

	var oReturn = sbEditorGetClipboardHTML() ;

	sbEditorAreaDoc.body.detachEvent( 'onpaste', CheckPasting_Listener ) ;
	sbEditorPasteIsRunning = false ;
	
	if ( sbEditorPasteIsEnabled )
	{
		if ( !returnContents )
			oReturn = true ;
	}
	else
		oReturn = false ;

	return oReturn ;
}
	
function sbEditorGetClipboardHTML ()
{
	var oDiv = sbEditorAreaDoc.getElementById( '___sbHiddenDiv' ) ;

	if ( !oDiv )
	{
		oDiv = sbEditorAreaDoc.createElement( 'DIV' ) ;
		oDiv.id = '___sbHiddenDiv' ;

		var oDivStyle = oDiv.style ;
		oDivStyle.position = 'absolute' ;
		oDivStyle.visibility = oDivStyle.overflow	= 'hidden' ;
		oDivStyle.width	= oDivStyle.height = 1 ;

		sbEditorAreaDoc.body.appendChild( oDiv ) ;
	}

	oDiv.innerHTML = '' ;

	var oTextRange = sbEditorAreaDoc.body.createTextRange() ;
	oTextRange.moveToElementText( oDiv ) ;
	
	try
	{
		oTextRange.execCommand( 'Paste' ) ;
	}
	catch (e)
	{
		return false;
	}
	
	var sData = oDiv.innerHTML ;
	oDiv.innerHTML = '' ;

	return sData ;
}

function sbEditorProcessLineBreaksForPMode ( text, liState, node, strArray )
{
	var closeState = 0 ;
	var blockStartTag = "<p>" ;
	var blockEndTag = "</p>" ;
	var lineBreakTag = "<br />" ;
	if ( liState )
	{
		blockStartTag = "<li>" ;
		blockEndTag = "</li>" ;
		closeState = 1 ;
	}

	while ( node && node != sbEditorArea )
	{
		if ( node.tagName.toLowerCase() == 'p' )
		{
			closeState = 1 ;
			break;
		}
		node = node.parentNode ;
	}

	for ( var i = 0 ; i < text.length ; i++ )
	{
		var c = text.charAt( i ) ;
		if ( c == '\r' )
			continue ;

		if ( c != '\n' )
		{
			strArray.push( c ) ;
			continue ;
		}

		var n = text.charAt( i + 1 ) ;
		if ( n == '\r' )
		{
			i++ ;
			n = text.charAt( i + 1 ) ;
		}
		if ( n == '\n' )
		{
			i++ ;
			if ( closeState )
				strArray.push( blockEndTag ) ;
			strArray.push( blockStartTag ) ;
			closeState = 1 ;
		}
		else
			strArray.push( lineBreakTag ) ;
	}
}

function sbEditorProcessLineBreaksForDivMode ( text, liState, node, strArray )
{
	var closeState = 0 ;
	var blockStartTag = "<div>" ;
	var blockEndTag = "</div>" ;
	if ( liState )
	{
		blockStartTag = "<li>" ;
		blockEndTag = "</li>" ;
		closeState = 1 ;
	}

	while ( node && node != sbEditorArea )
	{
		if ( node.tagName.toLowerCase() == 'div' )
		{
			closeState = 1 ;
			break ;
		}
		node = node.parentNode ;
	}

	for ( var i = 0 ; i < text.length ; i++ )
	{
		var c = text.charAt( i ) ;
		if ( c == '\r' )
			continue ;

		if ( c != '\n' )
		{
			strArray.push( c ) ;
			continue ;
		}

		if ( closeState )
		{
			if ( strArray[ strArray.length - 1 ] == blockStartTag )
			{
				strArray.push( "&nbsp;" ) ;
			}
			strArray.push( blockEndTag ) ;
		}
		strArray.push( blockStartTag ) ;
		closeState = 1 ;
	}
	if ( closeState )
		strArray.push( blockEndTag ) ;
}

function sbEditorProcessLineBreaksForBrMode( text, liState, node, strArray )
{
	var closeState = 0 ;
	var blockStartTag = "<br />" ;
	var blockEndTag = "" ;
	if ( liState )
	{
		blockStartTag = "<li>" ;
		blockEndTag = "</li>" ;
		closeState = 1 ;
	}

	for ( var i = 0 ; i < text.length ; i++ )
	{
		var c = text.charAt( i ) ;
		if ( c == '\r' )
			continue ;

		if ( c != '\n' )
		{
			strArray.push( c ) ;
			continue ;
		}

		if ( closeState && blockEndTag.length )
			strArray.push ( blockEndTag ) ;
		strArray.push( blockStartTag ) ;
		closeState = 1 ;
	}
}

function sbEditorProcessLineBreaks ( text )
{
	var enterMode = SB_EDITOR_ENTER_MODE ;
	var strArray = [] ;

	var liState = 0 ;
	var range = new sbEditorDomRange( sbEditorAreaWnd ) ;
	range._MoveToSelection() ;
	var node = range._Range.startContainer ;
	while ( node && node.nodeType != 1 )
		node = node.parentNode ;
	if ( node && node.tagName.toLowerCase() == 'li' )
		liState = 1 ;

	if ( SB_EDITOR_ENTER_MODE == 'p' )
		sbEditorProcessLineBreaksForPMode( text, liState, node, strArray ) ;
	else if ( SB_EDITOR_ENTER_MODE == 'div' )
		sbEditorProcessLineBreaksForDivMode( text, liState, node, strArray ) ;
	else if ( SB_EDITOR_ENTER_MODE == 'br' )
		sbEditorProcessLineBreaksForBrMode( text, liState, node, strArray ) ;
	return strArray.join( "" ) ;
}

function sbEditorHTMLEncode ( text )
{
	if ( !text )
		return '' ;

	text = text.replace( /&/g, '&amp;' ) ;
	text = text.replace( /</g, '&lt;' ) ;
	text = text.replace( />/g, '&gt;' ) ;

	return text ;
}

function sbEditorConvertHtmlSizeToStyle ( size )
{
	return size.EndsWith( '%' ) ? size : ( size + 'px' ) ;
}

function sbEditorInsertHtml ( html, noSaveUndo, noRemove )
{
	html = sbEditorProtectedSource._Protect( html ) ;
	html = sbEditorProtectUrls( html ) ;
	html = sbEditorProtectTags( html ) ;
		
	if (_isIE)
	{
		sbEditorSelection._Restore() ;
		if (!noSaveUndo)
			sbEditorUndo._SaveUndoStep() ;

		var oSel = sbEditorSelection._GetSelection() ;

		if ( oSel.type.toLowerCase() == 'control' )
			oSel.clear() ;
	
		html = '<span id="__fakesbRemove__" style="display:none;">fakesbRemove</span>' + html ;

		oSel.createRange().pasteHTML( html ) ;
		sbEditorDocumentProcessor._Process( sbEditorArea ) ;
		
		sbEditorAreaDoc.getElementById('__fakesbRemove__').removeNode( true ) ;
	}
	else
	{
		var doc = sbEditorAreaDoc, range;
		if (!noSaveUndo)
			sbEditorUndo._SaveUndoStep() ;
		
		if ( _isFF )
		{
			html = html.replace( /&nbsp;$/, '$&<span _sbtemp="1"/>' ) ;
	
			var docFrag = new sbEditorDocumentFragment( sbEditorAreaDoc ) ;
			docFrag._AppendHtml( html ) ;
	
			var lastNode = docFrag._RootNode.lastChild ;
	
			range = new sbEditorDomRange( sbEditorAreaWnd ) ;
			range._MoveToSelection() ;
			range._DeleteContents();
			range._InsertNode( docFrag._RootNode ) ;
	
			range._MoveToPosition( lastNode, 4 ) ;
		}
		else
			doc.execCommand( 'inserthtml', false, html ) ;
	
		if ( !range )
		{
			range = new sbEditorDomRange( sbEditorAreaWnd ) ;
			range._MoveToSelection() ;
		}
		
		var bookmark = range._CreateBookmark() ;
		sbEditorDocumentProcessor._Process( sbEditorArea ) ;
		
		try
		{
			range._MoveToBookmark( bookmark ) ;
			range._Select() ;
		}
		catch ( e ) {}
	}
	
	var data = sbEditorArea.innerHTML;
	data = data.replace( sbEditorRegexLib.InvalidSelfCloseTags, '$1></$2>' ) ;
	sbEditorArea.innerHTML = data;
	
	sbEditorEvents._FireEvent( "OnSelectionChange" ) ;
}

function sbEditorProtectUrls ( html )
{
	html = html.replace( sbEditorRegexLib.ProtectUrlsA, '$& _sbsavedurl=$1' ) ;
	html = html.replace( sbEditorRegexLib.ProtectUrlsImg, '$& _sbsavedurl=$1' ) ;
	html = html.replace( sbEditorRegexLib.ProtectUrlsArea, '$& _sbsavedurl=$1' ) ;

	return html ;
}

function sbEditorProtectTags ( html )
{
	var sTags = "";
	
	if ( _isIE )
		sTags += 'ABBR|XML|EMBED|OBJECT' ;

	var oRegex ;
	if ( sTags.length > 0 )
	{
		oRegex = new RegExp( '<(' + sTags + ')(?!\w|:)', 'gi' ) ;
		html = html.replace( oRegex, '<SB:$1' ) ;

		oRegex = new RegExp( '<\/(' + sTags + ')>', 'gi' ) ;
		html = html.replace( oRegex, '<\/SB:$1>' ) ;
	}

	sTags = 'META' ;
	if ( _isIE )
		sTags += '|HR' ;

	oRegex = new RegExp( '<((' + sTags + ')(?=\\s|>|/)[\\s\\S]*?)/?>', 'gi' ) ;
	html = html.replace( oRegex, '<SB:$1 />' ) ;

	return html ;
}

function sbEditorIndentBlock ( range, identOffset )
{
	var iterator = new sbEditorDomRangeIterator( range ) ;
	iterator._EnforceRealBlocks = true ;

	range._Expand( 'block_contents' ) ;
	var commonParents = sbEditorGetCommonParents( range.startContainer, range.endContainer ) ;
	var nearestParent = commonParents[commonParents.length - 1] ;
	var block ;

	while ( ( block = iterator._GetNextParagraph() ) )
	{
		if ( ! ( block == nearestParent || block.parentNode == nearestParent ) )
			continue ;

		var currentOffset = parseInt( block.style['marginLeft'], 10 ) ;
		if ( isNaN( currentOffset ) )
			currentOffset = 0 ;
		currentOffset += identOffset ;
		currentOffset = Math.max( currentOffset, 0 ) ;
		currentOffset = Math.ceil( currentOffset / identOffset ) * identOffset ;
		block.style['marginLeft'] = currentOffset ? currentOffset + 'px' : '' ;
		if ( block.getAttribute( 'style' ) == '' )
			block.removeAttribute( 'style' ) ;
	}
}

function sbEditorIndentList ( range, listNode, identName )
{
	var startContainer = range.startContainer ;
	var endContainer = range.endContainer ;
	while ( startContainer && startContainer.parentNode != listNode )
		startContainer = startContainer.parentNode ;
	while ( endContainer && endContainer.parentNode != listNode )
		endContainer = endContainer.parentNode ;

	if ( ! startContainer || ! endContainer )
		return ;

	var block = startContainer ;
	var itemsToMove = [] ;
	var stopFlag = false ;
	while ( stopFlag == false )
	{
		if ( block == endContainer )
			stopFlag = true ;
		itemsToMove.push( block ) ;
		block = block.nextSibling ;
	}
	if ( itemsToMove.length < 1 )
		return ;

	var listParents = sbEditorGetParents( listNode ) ;
	for ( var i = 0 ; i < listParents.length ; i++ )
	{
		if ( listParents[i].nodeName.IEquals( ['ul', 'ol'] ) )
		{
			listNode = listParents[i] ;
			break ;
		}
	}
	var indentOffset = identName.IEquals( 'indent' ) ? 1 : -1 ;
	var startItem = itemsToMove[0] ;
	var lastItem = itemsToMove[ itemsToMove.length - 1 ] ;
	var markerObj = {} ;

	var listArray = sbEditorListToArray( listNode, markerObj ) ;

	var baseIndent = listArray[lastItem._sb_ListArray_Index].indent ;
	for ( var i = startItem._sb_ListArray_Index ; i <= lastItem._sb_ListArray_Index ; i++ )
		listArray[i].indent += indentOffset ;
	for ( var i = lastItem._sb_ListArray_Index + 1 ; i < listArray.length && listArray[i].indent > baseIndent ; i++ )
		listArray[i].indent += indentOffset ;

	var newList = sbEditorArrayToList( listArray ) ;
	if ( newList )
		listNode.parentNode.replaceChild( newList.listNode, listNode ) ;

	sbEditorClearAllMarkers( markerObj ) ;
}
	
function sbEditorChangeListType ( groupObj, markerObj, listsCreated, tagName )
{
	var listArray = sbEditorListToArray( groupObj.root, markerObj ) ;
	var selectedListItems = [] ;
	for ( var i = 0 ; i < groupObj.contents.length ; i++ )
	{
		var itemNode = groupObj.contents[i] ;
		itemNode = sbEditorGetElementAscensor( itemNode, 'li' ) ;
		if ( ! itemNode || itemNode._sb_ListItem_Processed )
			continue ;
		selectedListItems.push( itemNode ) ;
		sbEditorSetElementMarker( markerObj, itemNode, '_sb_ListItem_Processed', true ) ;
	}
	var fakeParent = sbGetElementDocument( groupObj.root ).createElement( tagName ) ;
	for ( var i = 0 ; i < selectedListItems.length ; i++ )
	{
		var listIndex = selectedListItems[i]._sb_ListArray_Index ;
		listArray[listIndex].parent = fakeParent ;
	}
	var newList = sbEditorArrayToList( listArray, markerObj ) ;
	for ( var i = 0 ; i < newList.listNode.childNodes.length ; i++ )
	{
		if ( newList.listNode.childNodes[i].nodeName.IEquals( tagName ) )
			listsCreated.push( newList.listNode.childNodes[i] ) ;
	}
	groupObj.root.parentNode.replaceChild( newList.listNode, groupObj.root ) ;
}

function sbEditorCreateList ( groupObj, listsCreated, tagName )
{
	var contents = groupObj.contents ;
	var doc = sbGetElementDocument( groupObj.root ) ;
	var listContents = [] ;

	if ( contents.length == 1 && contents[0] == groupObj.root )
	{
		var divBlock = doc.createElement( 'div' );
		while ( contents[0].firstChild )
			divBlock.appendChild( contents[0].removeChild( contents[0].firstChild ) ) ;
		contents[0].appendChild( divBlock ) ;
		contents[0] = divBlock ;
	}

	var commonParent = groupObj.contents[0].parentNode ;
	for ( var i = 0 ; i < contents.length ; i++ )
		commonParent = sbEditorGetCommonParents( commonParent, contents[i].parentNode ).pop() ;

	for ( var i = 0 ; i < contents.length ; i++ )
	{
		var contentNode = contents[i] ;
		while ( contentNode.parentNode )
		{
			if ( contentNode.parentNode == commonParent )
			{
				listContents.push( contentNode ) ;
				break ;
			}
			contentNode = contentNode.parentNode ;
		}
	}

	if ( listContents.length < 1 )
		return ;

	var insertAnchor = listContents[listContents.length - 1].nextSibling ;
	var listNode = doc.createElement( tagName ) ;
	listsCreated.push( listNode ) ;
	while ( listContents.length )
	{
		var contentBlock = listContents.shift() ;
		var docFrag = doc.createDocumentFragment() ;
		while ( contentBlock.firstChild )
			docFrag.appendChild( contentBlock.removeChild( contentBlock.firstChild ) ) ;
		contentBlock.parentNode.removeChild( contentBlock ) ;
		var listItem = doc.createElement( 'li' ) ;
		listItem.appendChild( docFrag ) ;
		listNode.appendChild( listItem ) ;
	}
	commonParent.insertBefore( listNode, insertAnchor ) ;
}

function sbEditorRemoveList ( groupObj, markerObj )
{
	var listArray = sbEditorListToArray( groupObj.root, markerObj ) ;
	var selectedListItems = [] ;
	for ( var i = 0 ; i < groupObj.contents.length ; i++ )
	{
		var itemNode = groupObj.contents[i] ;
		itemNode = sbEditorGetElementAscensor( itemNode, 'li' ) ;
		if ( ! itemNode || itemNode._sb_ListItem_Processed )
			continue ;
		selectedListItems.push( itemNode ) ;
		sbEditorSetElementMarker( markerObj, itemNode, '_sb_ListItem_Processed', true ) ;
	}

	var lastListIndex = null ;
	for ( var i = 0 ; i < selectedListItems.length ; i++ )
	{
		var listIndex = selectedListItems[i]._sb_ListArray_Index ;
		listArray[listIndex].indent = -1 ;
		lastListIndex = listIndex ;
	}

	for ( var i = lastListIndex + 1; i < listArray.length ; i++ )
	{
		if ( listArray[i].indent > listArray[i-1].indent + 1 )
		{
			var indentOffset = listArray[i-1].indent + 1 - listArray[i].indent ;
			var oldIndent = listArray[i].indent ;
			while ( listArray[i] && listArray[i].indent >= oldIndent)
			{
				listArray[i].indent += indentOffset ;
				i++ ;
			}
			i-- ;
		}
	}

	var newList = sbEditorArrayToList( listArray, markerObj ) ;
	if ( groupObj.root.nextSibling == null || groupObj.root.nextSibling.nodeName.IEquals( 'br' ) )
	{
		if ( newList.listNode.lastChild.nodeName.IEquals( 'br' ) )
			newList.listNode.removeChild( newList.listNode.lastChild ) ;
	}
	groupObj.root.parentNode.replaceChild( newList.listNode, groupObj.root ) ;
}

function sbEditorGetCommonParents ( node1, node2 )
{
	var p1 = sbEditorGetParents( node1 ) ;
	var p2 = sbEditorGetParents( node2 ) ;
	var retval = [] ;
	for ( var i = 0 ; i < p1.length ; i++ )
	{
		if ( p1[i] == p2[i] )
			retval.push( p1[i] ) ;
	}
	return retval ;
}

function sbEditorGetCommonParentNode ( node1, node2, tagList )
{
	var tagMap = {} ;
	if ( ! tagList.pop )
		tagList = [ tagList ] ;
	while ( tagList.length > 0 )
		tagMap[tagList.pop().toLowerCase()] = 1 ;

	var commonParents = sbEditorGetCommonParents( node1, node2 ) ;
	var currentParent = null ;
	while ( ( currentParent = commonParents.pop() ) )
	{
		if ( tagMap[currentParent.nodeName.toLowerCase()] )
			return currentParent ;
	}
	return null ;
}
			
function sbEditorSetElementMarker ( markerObj, element, attrName, value)
{
	var id = String( parseInt( Math.random() * 0xffffffff, 10 ) ) ;
	element._sbMarkerId = id ;
	element[attrName] = value ;
	if ( ! markerObj[id] )
		markerObj[id] = { 'element' : element, 'markers' : {} } ;
	markerObj[id]['markers'][attrName] = value ;
}

function sbEditorClearElementJSProperty ( element, attrName )
{
	if ( _isIE )
		element.removeAttribute( attrName ) ;
	else
		delete element[attrName] ;
}
	
function sbEditorClearElementMarkers ( markerObj, element, clearMarkerObj )
{
	var id = element._sbMarkerId ;
	if ( ! id )
		return ;
	sbEditorClearElementJSProperty( element, '_sbMarkerId' ) ;
	for ( var j in markerObj[id]['markers'] )
		sbEditorClearElementJSProperty( element, j ) ;
	if ( clearMarkerObj )
		delete markerObj[id] ;
}

function sbEditorClearAllMarkers ( markerObj )
{
	for ( var i in markerObj )
		sbEditorClearElementMarkers( markerObj, markerObj[i]['element'], true ) ;
}
			
function sbEditorListToArray ( listNode, markerObj, baseArray, baseIndentLevel, grandparentNode )
{
	if ( ! listNode.nodeName.IEquals( ['ul', 'ol'] ) )
		return [] ;

	if ( ! baseIndentLevel )
		baseIndentLevel = 0 ;
	if ( ! baseArray )
		baseArray = [] ;
	
	for ( var i = 0 ; i < listNode.childNodes.length ; i++ )
	{
		var listItem = listNode.childNodes[i] ;
		if ( ! listItem.nodeName.IEquals( 'li' ) )
			continue ;
			
		var itemObj = { 'parent' : listNode, 'indent' : baseIndentLevel, 'contents' : [] } ;
		if ( ! grandparentNode )
		{
			itemObj.grandparent = listNode.parentNode ;
			if ( itemObj.grandparent && itemObj.grandparent.nodeName.IEquals( 'li' ) )
				itemObj.grandparent = itemObj.grandparent.parentNode ;
		}
		else
			itemObj.grandparent = grandparentNode ;
			
		if ( markerObj )
			sbEditorSetElementMarker( markerObj, listItem, '_sb_ListArray_Index', baseArray.length ) ;
			
		baseArray.push( itemObj ) ;
		for ( var j = 0 ; j < listItem.childNodes.length ; j++ )
		{
			var child = listItem.childNodes[j] ;
			if ( child.nodeName.IEquals( ['ul', 'ol'] ) )
				sbEditorListToArray( child, markerObj, baseArray, baseIndentLevel + 1, itemObj.grandparent ) ;
			else
				itemObj.contents.push( child ) ;
		}
	}
	return baseArray ;
}

function sbEditorArrayToList ( listArray, markerObj, baseIndex )
{
	if ( baseIndex == undefined )
		baseIndex = 0 ;
	if ( ! listArray || listArray.length < baseIndex + 1 )
		return null ;
	var doc = sbGetElementDocument( listArray[baseIndex].parent ) ;
	var retval = doc.createDocumentFragment() ;
	var rootNode = null ;
	var currentIndex = baseIndex ;
	var indentLevel = Math.max( listArray[baseIndex].indent, 0 ) ;
	var currentListItem = null ;
	while ( true )
	{
		var item = listArray[currentIndex] ;
		if ( item.indent == indentLevel )
		{
			if ( ! rootNode || listArray[currentIndex].parent.nodeName != rootNode.nodeName )
			{
				rootNode = listArray[currentIndex].parent.cloneNode( false ) ;
				retval.appendChild( rootNode ) ;
			}
			currentListItem = doc.createElement( 'li' ) ;
			rootNode.appendChild( currentListItem ) ;
			for ( var i = 0 ; i < item.contents.length ; i++ )
				currentListItem.appendChild( item.contents[i].cloneNode( true ) ) ;
			currentIndex++ ;
		}
		else if ( item.indent == Math.max( indentLevel, 0 ) + 1 )
		{
			var listData = sbEditorArrayToList( listArray, null, currentIndex ) ;
			currentListItem.appendChild( listData.listNode ) ;
			currentIndex = listData.nextIndex ;
		}
		else if ( item.indent == -1 && baseIndex == 0 && item.grandparent )
		{
			var currentListItem ;
			if ( item.grandparent.nodeName.IEquals( ['ul', 'ol'] ) )
				currentListItem = doc.createElement( 'li' ) ;
			else
			{
				if ( SB_EDITOR_ENTER_MODE.IEquals( ['div', 'p'] ) && ! item.grandparent.nodeName.IEquals( 'td' ) )
					currentListItem = doc.createElement( SB_EDITOR_ENTER_MODE ) ;
				else
					currentListItem = doc.createDocumentFragment() ;
			}
			for ( var i = 0 ; i < item.contents.length ; i++ )
				currentListItem.appendChild( item.contents[i].cloneNode( true ) ) ;
			if ( currentListItem.nodeType == 11 )
			{
				if ( currentListItem.lastChild &&
					 currentListItem.lastChild.getAttribute &&
					 currentListItem.lastChild.getAttribute( 'type' ) == '_moz' )
					currentListItem.removeChild( currentListItem.lastChild );
				currentListItem.appendChild( doc.createElement( 'br' ) ) ;
			}
			if ( currentListItem.nodeName.IEquals( SB_EDITOR_ENTER_MODE ) && currentListItem.firstChild )
			{
				sbEditorTrimNode( currentListItem ) ;
				if ( sbEditorListsLib.BlockBoundaries[currentListItem.firstChild.nodeName.toLowerCase()] )
				{
					var tmp = doc.createDocumentFragment() ;
					while ( currentListItem.firstChild )
						tmp.appendChild( currentListItem.removeChild( currentListItem.firstChild ) ) ;
					currentListItem = tmp ;
				}
			}
			if ( !_isIE && currentListItem.nodeName.IEquals( ['div', 'p'] ) )
				sbEditorAppendBogusBr( currentListItem ) ;
			retval.appendChild( currentListItem ) ;
			rootNode = null ;
			currentIndex++ ;
		}
		else
			return null ;

		if ( listArray.length <= currentIndex || Math.max( listArray[currentIndex].indent, 0 ) < indentLevel )
		{
			break ;
		}
	}

	if ( markerObj )
	{
		var currentNode = retval.firstChild ;
		while ( currentNode )
		{
			if ( currentNode.nodeType == 1 )
				sbEditorClearElementMarkers( markerObj, currentNode ) ;
			currentNode = sbEditorGetNextSourceNode( currentNode ) ;
		}
	}

	return { 'listNode' : retval, 'nextIndex' : currentIndex } ;
}
	
function sbEditorInsertElement ( element )
{
	if ( typeof element == 'string' )
		element = sbEditorAreaDoc.createElement( element ) ;

	var elementName = element.nodeName.toLowerCase() ;

	sbEditorSelection._Restore() ;

	var range = new sbEditorDomRange( sbEditorAreaWnd ) ;

	range._MoveToSelection() ;
	range._DeleteContents() ;

	if ( sbEditorListsLib.BlockElements[ elementName ] != null && elementName != "div" )
	{
		if ( range._StartBlock )
		{
			if ( range._CheckStartOfBlock() )
				range._MoveToPosition( range._StartBlock, 3 ) ;
			else if ( range._CheckEndOfBlock() )
				range._MoveToPosition( range._StartBlock, 4 ) ;
			else
				range._SplitBlock() ;
		}

		range._InsertNode( element ) ;

		var next = sbEditorGetNextSourceElement( element, false, null, [ 'hr','br','param','img','area','input' ], true ) ;

		if ( !next && SB_EDITOR_ENTER_MODE != 'br')
		{
			next = sbEditorArea.appendChild( sbEditorAreaDoc.createElement( SB_EDITOR_ENTER_MODE ) ) ;

			if ( !_isIE )
				sbEditorAppendBogusBr( next ) ;
		}

		if ( sbEditorListsLib.EmptyElements[ elementName ] == null )
			range._MoveToElementEditStart( element ) ;
		else if ( next )
			range._MoveToElementEditStart( next ) ;
		else
			range._MoveToPosition( element, 4 ) ;

		if ( !_isIE )
		{
			if ( next )
				sbEditorScrollIntoView( next, false );
			sbEditorScrollIntoView( element, false );
		}
	}
	else
	{
		range._InsertNode( element ) ;

		range.setStart( element, 4 ) ;
		range.setEnd( element, 4 ) ;
	}

	range._Select() ;
	range._Release() ;

	setTimeout(sbEditorFocus, 100);

	return element ;
}
	
function sbEditorGetNextNode ( node, limitNode )
{
	if ( node.firstChild )
		return node.firstChild ;
	else if ( node.nextSibling )
		return node.nextSibling ;
	else
	{
		var ancestor = node.parentNode ;
		while ( ancestor )
		{
			if ( ancestor == limitNode )
				return null ;
			if ( ancestor.nextSibling )
				return ancestor.nextSibling ;
			else
				ancestor = ancestor.parentNode ;
		}
	}
	return null ;
}

function sbEditorGetNextTextNode ( textnode, limitNode, checkStop )
{
	node = sbEditorGetNextNode( textnode, limitNode ) ;
	if ( checkStop && node && checkStop( node ) )
		return null ;
	while ( node && node.nodeType != 3 )
	{
		node = sbEditorGetNextNode( node, limitNode ) ;
		if ( checkStop && node && checkStop( node ) )
			return null ;
	}
	return node ;
}

//#REMOVE
function sbEditorFixBody ()
{
	var sBlockTag = SB_EDITOR_ENTER_MODE ;

	if ( sBlockTag != 'p' && sBlockTag != 'div' )
		return ;

	if ( !sbEditorArea )
		return ;

	sbEditorTrimNode( sbEditorArea ) ;

	var oNode = sbEditorArea.firstChild ;
	var oNewBlock ;

	while ( oNode )
	{
		var bMoveNode = false ;

		switch ( oNode.nodeType )
		{
			case 1 :
				var nodeName = oNode.nodeName.toLowerCase() ;
				if ( !sbEditorListsLib.BlockElements[ nodeName ] &&	nodeName != 'li' &&
					 !oNode.getAttribute('_sbfakelement') && oNode.getAttribute('_moz_dirty') == null )
					bMoveNode = true ;
				break ;

			case 3 :
				if ( oNewBlock || oNode.nodeValue.Trim().length > 0 )
					bMoveNode = true ;
				break;

			case 8 :
				if ( oNewBlock )
					bMoveNode = true ;
				break;
		}

		if ( bMoveNode )
		{
			var oParent = oNode.parentNode ;

			if ( !oNewBlock )
				oNewBlock = oParent.insertBefore( sbEditorAreaDoc.createElement( sBlockTag ), oNode ) ;

			oNewBlock.appendChild( oParent.removeChild( oNode ) ) ;

			oNode = oNewBlock.nextSibling ;
		}
		else
		{
			if ( oNewBlock )
			{
				sbEditorTrimNode( oNewBlock ) ;
				oNewBlock = null ;
			}
			oNode = oNode.nextSibling ;
		}
	}

	if ( oNewBlock )
		sbEditorTrimNode( oNewBlock ) ;
}
	
var sbEditorPaddingNode = null;

function sbEditorEnforcePaddingNode ( doc, tagName )
{
	try
	{
		if ( !doc || !doc.body || !sbEditorArea)
			return ;
	}
	catch (e)
	{
		return ;
	}

	sbEditorCheckAndRemovePaddingNode( doc, tagName, true ) ;

	try
	{
		if ( sbEditorArea.lastChild && ( sbEditorArea.lastChild.nodeType != 1
				|| sbEditorArea.lastChild.tagName.toLowerCase() == tagName.toLowerCase() ) )
			return ;
	}
	catch (e)
	{
		return ;
	}

	var node = doc.createElement( tagName ) ;
	if ( _isFF && sbEditorListsLib.NonEmptyBlockElements[ tagName ] )
		sbEditorAppendBogusBr( node ) ;
		
	sbEditorPaddingNode = node ;
	
	if ( sbEditorArea.childNodes.length == 1 && sbEditorArea.firstChild.nodeType == 1
		 && sbEditorArea.firstChild.tagName.toLowerCase() == 'br' && 
		 ( sbEditorArea.firstChild.getAttribute( '_moz_dirty' ) != null || sbEditorArea.firstChild.getAttribute( 'type' ) == '_moz' ) )
		sbEditorArea.replaceChild( node, sbEditorArea.firstChild ) ;
	else
		sbEditorArea.appendChild( node ) ;
}

function sbEditorCheckAndRemovePaddingNode ( doc, tagName, dontRemove )
{
	var paddingNode = sbEditorPaddingNode ;
	if ( ! paddingNode )
		return ;

	try
	{
		if ( paddingNode.parentNode != sbEditorArea	|| paddingNode.tagName.toLowerCase() != tagName
			|| paddingNode.childNodes.length > 1 || ( paddingNode.firstChild && paddingNode.firstChild.nodeValue != '\xa0'
			&& String(paddingNode.firstChild.tagName).toLowerCase() != 'br' ) )
		{
			sbEditorPaddingNode = null ;
			return ;
		}
	}
	catch (e)
	{
			sbEditorPaddingNode = null ;
			return ;
	}

	if ( !dontRemove )
	{
		if ( paddingNode.parentNode.childNodes.length > 1 ) 
			paddingNode.parentNode.removeChild( paddingNode ) ;
		
		sbEditorPaddingNode = null ;
	}
}

function sbEditorFillEmptyBlock ( emptyBlockNode )
{
	if ( ! emptyBlockNode || emptyBlockNode.nodeType != 1 )
		return ;
	var nodeTag = emptyBlockNode.tagName.toLowerCase() ;
	if ( nodeTag != 'p' && nodeTag != 'div' )
		return ;
	if ( emptyBlockNode.firstChild )
		return ;
	sbEditorAppendBogusBr( emptyBlockNode ) ;
}

function sbEditorGetFirstChild ( node, childNames )
{
	if ( typeof ( childNames ) == 'string' )
		childNames = [ childNames ] ;

	var eChild = node.firstChild ;
	while( eChild )
	{
		if ( eChild.nodeType == 1 && eChild.tagName.Equals.apply( eChild.tagName, childNames ) )
			return eChild ;

		eChild = eChild.nextSibling ;
	}

	return null ;
}

function sbEditorGetLastChild ( node, childNames )
{
	if ( typeof ( childNames ) == 'string' )
		childNames = [ childNames ] ;

	var eChild = node.lastChild ;
	while( eChild )
	{
		if ( eChild.nodeType == 1 && ( !childNames || eChild.tagName.Equals( childNames ) ) )
			return eChild ;

		eChild = eChild.previousSibling ;
	}

	return null ;
}

function sbEditorGetElementAscensor ( element, ascensorTagNames )
{
	var e = element ;
	var lstTags = "," + ascensorTagNames.toUpperCase() + "," ;

	while ( e && e != sbEditorArea)
	{
		if ( lstTags.indexOf( "," + e.nodeName.toUpperCase() + "," ) != -1 )
			return e ;

		e = e.parentNode ;
	}
	return null ;
}

function sbEditorScrollIntoView ( element, alignTop )
{
	var window = sbGetElementWindow( element ) ;
	var windowHeight = sbGetViewPaneSize( window ).Height ;

	var offset = windowHeight * -1 ;

	if ( alignTop === false )
	{
		offset += element.offsetHeight || 0 ;
		offset += parseInt( element.style.marginBottom || 0, 10 ) || 0 ;
	}

	var elementPosition = sbGetDocumentPosition( window, element ) ;
	offset += elementPosition.y ;

	var currentScroll = sbGetScrollPosition( window ).Y ;
	if ( offset > 0 && ( offset > currentScroll || offset < currentScroll - windowHeight ) )
		window.scrollTo( 0, offset ) ;
}
		
function sbEditorCloneObject ( obj )
{
	var fCloneCreator = function() {} ;
	fCloneCreator.prototype = obj ;
	return new fCloneCreator ;
}

function sbEditorHTMLDecode ( text )
{
	if ( !text )
		return '' ;

	text = text.replace( /&gt;/g, '>' ) ;
	text = text.replace( /&lt;/g, '<' ) ;
	text = text.replace( /&amp;/g, '&' ) ;

	return text ;
}

function sbEditorAppendLengthProperty ( targetObject, propertyName )
{
	var counter = 0 ;

	for ( var n in targetObject )
		counter++ ;

	return targetObject[ propertyName || 'length' ] = counter ;
}

function sbEditorNormalizeCssText ( unparsedCssText )
{
	var tempSpan = document.createElement( 'span' ) ;
	tempSpan.style.cssText = unparsedCssText ;
	return tempSpan.style.cssText ;
}

function sbEditorGetNextSibling ( node, includeEmpties )
{
	node = node.nextSibling ;

	while ( node && !includeEmpties && node.nodeType != 1 && ( node.nodeType != 3 || node.nodeValue.length == 0 ) )
		node = node.nextSibling ;

	return node ;
}

function sbEditorGetPreviousSibling ( node, includeEmpties )
{
	node = node.previousSibling ;

	while ( node && !includeEmpties && node.nodeType != 1 && ( node.nodeType != 3 || node.nodeValue.length == 0 ) )
		node = node.previousSibling ;

	return node ;
}
	
function sbEditorGetIndexOf ( node )
{
	var currentNode = node.parentNode ? node.parentNode.firstChild : null ;
	var currentIndex = -1 ;

	while ( currentNode )
	{
		currentIndex++ ;

		if ( currentNode == node )
			return currentIndex ;

		currentNode = currentNode.nextSibling ;
	}

	return -1 ;
}

function sbEditorHasAttributes ( element )
{
	var attributes = element.attributes ;

	for ( var i = 0 ; i < attributes.length ; i++ )
	{
		if ( _isIE && attributes[i].nodeName == 'class' )
		{
			if ( element.className.length > 0 )
				return true ;
		}
		else if (_isIE && attributes[i].nodeName == 'style')
		{
			if (element.style.cssText.length > 0)
				return true;
		}
		else if (attributes[i].nodeName == '_sbxhtmljob')
		{
			continue;
		}
		else if ( attributes[i].specified )
			return true ;
	}

	return false ;
}

function sbEditorHasAttribute ( element, attributeName )
{
	if ( element.hasAttribute )
		return element.hasAttribute( attributeName ) ;
	else
	{
		var att = element.attributes[ attributeName ] ;
		return ( att != undefined && att.specified ) ;
	}
}

function sbEditorGetAttributeValue ( element, att )
{
	var attName = att ;

	if ( typeof (att) == 'string' )
		att = element.attributes[ att ] ;
	else
		attName = att.nodeName ;

	if ( att && att.specified )
	{
		if ( attName == 'style' )
			return element.style.cssText ;
		else if ( attName == 'class' || attName.indexOf('on') == 0 )
			return att.nodeValue ;
		else
		{
			return element.getAttribute( attName, 2 ) ;
		}
	}
	return null ;
}
	
function sbEditorRemoveAttribute ( element, attributeName )
{
	if ( _isIE && attributeName.toLowerCase() == 'class' )
		attributeName = 'className' ;

	return element.removeAttribute( attributeName, 0 ) ;
}

function sbEditorRemoveAttributes (el, ar )
{
	for ( var i = 0 ; i < ar.length ; i++ )
		sbEditorRemoveAttribute( el, ar[i] );
}
			
function sbEditorInsertAfterNode ( existingNode, newNode )
{
	return existingNode.parentNode.insertBefore( newNode, existingNode.nextSibling ) ;
}
	
function sbEditorMoveChildren ( source, target, toTargetStart )
{
	if ( source == target )
		return ;

	var eChild ;

	if ( toTargetStart )
	{
		while ( (eChild = source.lastChild) )
			target.insertBefore( source.removeChild( eChild ), target.firstChild ) ;
	}
	else
	{
		while ( (eChild = source.firstChild) )
			target.appendChild( source.removeChild( eChild ) ) ;
	}
}

function sbEditorGetParents ( node )
{
	var parents = new Array() ;

	while ( node )
	{
		parents.unshift( node ) ;
		node = node.parentNode ;
	}

	return parents ;
}

function sbEditorIsEditable ( element )
{
	var nodeName = element.nodeName.toLowerCase() ;

	var childDTD = sbEditorDTD[ nodeName ] || sbEditorDTD.span ;

	return ( childDTD['#'] && !sbEditorListsLib.NonEditableElements[ nodeName ] ) ;
}

function sbEditorTrimNode ( node )
{
	sbEditorLTrimNode( node ) ;
	sbEditorRTrimNode( node ) ;
}

function sbEditorLTrimNode ( node )
{
	var eChildNode ;

	while ( (eChildNode = node.firstChild) )
	{
		if ( eChildNode.nodeType == 3 )
		{
			var sTrimmed = eChildNode.nodeValue.LTrim() ;
			var iOriginalLength = eChildNode.nodeValue.length ;

			if ( sTrimmed.length == 0 )
			{
				node.removeChild( eChildNode ) ;
				continue ;
			}
			else if ( sTrimmed.length < iOriginalLength )
			{
				eChildNode.splitText( iOriginalLength - sTrimmed.length ) ;
				node.removeChild( node.firstChild ) ;
			}
		}
		break ;
	}
}

function sbEditorRTrimNode ( node )
{
	var eChildNode ;

	while ( (eChildNode = node.lastChild) )
	{
		if ( eChildNode.nodeType == 3 )
		{
			var sTrimmed = eChildNode.nodeValue.RTrim() ;
			var iOriginalLength = eChildNode.nodeValue.length ;

			if ( sTrimmed.length == 0 )
			{
				eChildNode.parentNode.removeChild( eChildNode ) ;
				continue ;
			}
			else if ( sTrimmed.length < iOriginalLength )
			{
				eChildNode.splitText( sTrimmed.length ) ;
				node.lastChild.parentNode.removeChild( node.lastChild ) ;
			}
		}
		break ;
	}

	if ( !_isIE && !_isOpera )
	{
		eChildNode = node.lastChild ;

		if ( eChildNode && eChildNode.nodeType == 1 && eChildNode.nodeName.toLowerCase() == 'br' )
		{
			eChildNode.parentNode.removeChild( eChildNode ) ;
		}
	}
}

function sbEditorGetPreviousSourceElement ( currentNode, ignoreSpaceTextOnly, stopSearchElements, ignoreElements )
{
	if ( !currentNode )
		return null ;

	if ( stopSearchElements && currentNode.nodeType == 1 && currentNode.nodeName.IEquals( stopSearchElements ) || currentNode == sbEditorArea )
		return null ;

	if ( currentNode.previousSibling )
		currentNode = currentNode.previousSibling ;
	else
		return sbEditorGetPreviousSourceElement( currentNode.parentNode, ignoreSpaceTextOnly, stopSearchElements, ignoreElements ) ;

	while ( currentNode )
	{
		if ( currentNode.nodeType == 1 )
		{
			if ( stopSearchElements && currentNode.nodeName.IEquals( stopSearchElements ) )
				break ;

			if ( !ignoreElements || !currentNode.nodeName.IEquals( ignoreElements ) )
				return currentNode ;
		}
		else if ( ignoreSpaceTextOnly && currentNode.nodeType == 3 && currentNode.nodeValue.RTrim().length > 0 )
			break ;

		if ( currentNode.lastChild )
			currentNode = currentNode.lastChild ;
		else
			return sbEditorGetPreviousSourceElement( currentNode, ignoreSpaceTextOnly, stopSearchElements, ignoreElements ) ;
	}

	return null ;
}

function sbEditorGetNextSourceElement ( currentNode, ignoreSpaceTextOnly, stopSearchElements, ignoreElements, startFromSibling )
{
	while( ( currentNode = sbEditorGetNextSourceNode( currentNode, startFromSibling ) ) )
	{
		if (currentNode == sbEditorArea)
			break;
			
		if ( currentNode.nodeType == 1 )
		{
			if ( stopSearchElements && currentNode.nodeName.IEquals( stopSearchElements ) )
				break ;

			if ( ignoreElements && currentNode.nodeName.IEquals( ignoreElements ) )
				return sbEditorGetNextSourceElement( currentNode, ignoreSpaceTextOnly, stopSearchElements, ignoreElements ) ;

			return currentNode ;
		}
		else if ( ignoreSpaceTextOnly && currentNode.nodeType == 3 && currentNode.nodeValue.RTrim().length > 0 )
			break ;
	}

	return null ;
}
		
function sbEditorGetPreviousSourceNode ( currentNode, startFromSibling, nodeType, stopSearchNode )
{
	if ( !currentNode )
		return null ;

	var node ;

	if ( !startFromSibling && currentNode.lastChild )
		node = currentNode.lastChild ;
	else
	{
		if ( stopSearchNode && currentNode == stopSearchNode || currentNode == sbEditorArea )
			return null ;

		node = currentNode.previousSibling ;

		if ( !node && ( !stopSearchNode || stopSearchNode != currentNode.parentNode ) )
			return sbEditorGetPreviousSourceNode( currentNode.parentNode, true, nodeType, stopSearchNode ) ;
	}

	if ( nodeType && node && node.nodeType != nodeType )
		return sbEditorGetPreviousSourceNode( node, false, nodeType, stopSearchNode ) ;

	return node ;
}
	
function sbEditorGetNextSourceNode ( currentNode, startFromSibling, nodeType, stopSearchNode )
{
	if ( !currentNode )
		return null ;

	var node ;

	if ( !startFromSibling && currentNode.firstChild )
		node = currentNode.firstChild ;
	else
	{
		if ( stopSearchNode && currentNode == stopSearchNode || currentNode == sbEditorArea)
			return null ;

		node = currentNode.nextSibling ;

		if ( !node && ( !stopSearchNode || stopSearchNode != currentNode.parentNode ) )
			return sbEditorGetNextSourceNode( currentNode.parentNode, true, nodeType, stopSearchNode ) ;
	}

	if ( nodeType && node && node.nodeType != nodeType )
		return sbEditorGetNextSourceNode( node, false, nodeType, stopSearchNode ) ;

	return node ;
}
	
function sbEditorRemoveNode ( node, excludeChildren )
{
	if ( excludeChildren )
	{
		var eChild ;
		while ( (eChild = node.firstChild) )
			node.parentNode.insertBefore( node.removeChild( eChild ), node ) ;
	}

	return node.parentNode.removeChild( node ) ;
}

function sbEditorMoveNode ( source, target, toTargetStart )
{
	if ( toTargetStart )
		target.insertBefore( sbEditorRemoveNode( source ), target.firstChild ) ;
	else
		target.appendChild( sbEditorRemoveNode( source ) ) ;
}
	
function sbEditorCloneElement ( element )
{
	element = element.cloneNode( false ) ;
	element.removeAttribute( 'id', false ) ;
	return element ;
}

function sbEditorBreakParent ( element, parent, reusableRange )
{
	var range = reusableRange || new sbEditorDomRange( sbGetElementWindow( element ) ) ;

	range.setStart( element, 4 ) ;
	range.setEnd( parent, 4 ) ;

	var docFrag = range._ExtractContents() ;

	range._InsertNode( element.parentNode.removeChild( element ) ) ;

	docFrag._InsertAfterNode( element ) ;

	range._Release( !!reusableRange ) ;
}
		
function sbEditorGetNodeAddress ( node, normalized )
{
	var retval = [] ;
	while ( node && node != sbGetElementDocument( node ).documentElement )
	{
		var parentNode = node.parentNode ;
		var currentIndex = -1 ;
		for( var i = 0 ; i < parentNode.childNodes.length ; i++ )
		{
			var candidate = parentNode.childNodes[i] ;
			if ( normalized === true &&
				 candidate.nodeType == 3 &&
				 candidate.previousSibling &&
				 candidate.previousSibling.nodeType == 3 )
				continue;
			currentIndex++ ;
			if ( parentNode.childNodes[i] == node )
				break ;
		}
		retval.unshift( currentIndex ) ;
		node = node.parentNode ;
	}
	return retval ;
}
	
function sbEditorGetNodeFromAddress ( doc, addr, normalized )
{
	var cursor = doc.documentElement ;
	for ( var i = 0 ; i < addr.length ; i++ )
	{
		var target = addr[i] ;
		if ( ! normalized )
		{
			cursor = cursor.childNodes[target] ;
			continue ;
		}

		var currentIndex = -1 ;
		for (var j = 0 ; j < cursor.childNodes.length ; j++ )
		{
			var candidate = cursor.childNodes[j] ;
			if ( normalized === true &&
				 candidate.nodeType == 3 &&
				 candidate.previousSibling &&
				 candidate.previousSibling.nodeType == 3 )
				continue ;
			currentIndex++ ;
			if ( currentIndex == target )
			{
				cursor = candidate ;
				break ;
			}
		}
	}
	return cursor ;
}
	
function sbEditorAppendBogusBr ( element )
{
	if ( !element )
		return ;

	var eLastChild = sbEditorGetLastItem( element.getElementsByTagName('br') ) ;

	if ( !eLastChild || ( eLastChild.getAttribute( 'type', 2 ) != '_moz' && eLastChild.getAttribute( '_moz_dirty' ) == null ) )
	{
		var doc = sbGetElementDocument( element ) ;

		if ( _isOpera )
			element.appendChild( doc.createTextNode('') ) ;
		else
		{
			var eBR = doc.createElement( 'br' ) ;
			eBR.setAttribute( 'type', '_moz' ) ;
			element.appendChild( eBR ) ;
		}
	}
}

function sbEditorIsEmptyElement ( element, elementCheckCallback )
{
	var child = element.firstChild ;
	var elementChild ;

	while ( child )
	{
		if ( child.nodeType == 1 )
		{
			if ( elementChild || !sbEditorListsLib.InlineNonEmptyElements[ child.nodeName.toLowerCase() ] )
				return false ;

			if ( !elementCheckCallback || elementCheckCallback( child ) === true )
				elementChild = child ;
		}
		else if ( child.nodeType == 3 && child.nodeValue.length > 0 )
			return false ;

		child = child.nextSibling ;
	}

	return elementChild ? sbEditorIsEmptyElement( elementChild, elementCheckCallback ) : true ;
}
	
function sbEditorGetLastItem ( list )
{
	if ( list.length > 0 )
		return list[ list.length - 1 ] ;

	return null ;
}
		
///////////////////////////////////////////////////////////////////

var sbEditorSelection = 
{
	_GetParentBlock : function()
	{
		var retval = this._GetParentElement() ;
		while ( retval )
		{
			if ( sbEditorListsLib.BlockBoundaries[retval.nodeName.toLowerCase()] )
				break ;
			retval = retval.parentNode ;
		}
		return retval ;
	},

	_ApplyStyle : function( styleDefinition )
	{
		sbEditorStyles._ApplyStyle( new sbEditorStyle( styleDefinition ) ) ;
	}
} 

sbEditorSelection._GetType = function()
{
	if (_isIE)
	{
		try
		{
			var ieType = this._GetSelection().type ;
			if ( ieType == 'Control' || ieType == 'Text' )
				return ieType ;
	
			if ( this._GetSelection().createRange().parentElement )
				return 'Text' ;
		}
		catch(e)
		{
		}
	
		return 'None' ;
	}
	else
	{
		var type = 'Text' ;
		var sel ;
		try { sel = this._GetSelection() ; } catch (e) {}
	
		if ( sel && sel.rangeCount == 1 )
		{
			var range = sel.getRangeAt(0) ;
			if ( range.startContainer == range.endContainer
				&& ( range.endOffset - range.startOffset ) == 1
				&& range.startContainer.nodeType == 1
				&& sbEditorListsLib.StyleObjectElements[ range.startContainer.childNodes[ range.startOffset ].nodeName.toLowerCase() ] )
			{
				type = 'Control' ;
			}
		}
	
		return type ;
	}
}

sbEditorSelection._GetSelectedElement = function()
{
	if (_isIE)
	{
		if ( this._GetType() == 'Control' )
		{
			var oRange = this._GetSelection().createRange() ;
	
			if ( oRange && oRange.item )
				return this._GetSelection().createRange().item(0) ;
		}
		return null ;
	}
	else
	{
		var selection = !!sbEditorAreaWnd && this._GetSelection() ;
		if ( !selection || selection.rangeCount < 1 )
			return null ;
	
		var range = selection.getRangeAt( 0 ) ;
		if ( range.startContainer != range.endContainer || range.startContainer.nodeType != 1 || range.startOffset != range.endOffset - 1 )
			return null ;
	
		var node = range.startContainer.childNodes[ range.startOffset ] ;
		if ( node.nodeType != 1 )
			return null ;
	
		return node ;
	}
}

sbEditorSelection._GetParentElement = function()
{
	if (_isIE)
	{
		switch ( this._GetType() )
		{
			case 'Control' :
				var el = sbEditorSelection._GetSelectedElement() ;
				return el ? el.parentElement : null ;
	
			case 'None' :
				return null ;
	
			default :
				return this._GetSelection().createRange().parentElement() ;
		}
	}
	else
	{
		if ( this._GetType() == 'Control' )
			return sbEditorSelection._GetSelectedElement().parentNode ;
		else
		{
			var oSel = this._GetSelection() ;
			if ( oSel )
			{
				if ( oSel.anchorNode && oSel.anchorNode == oSel.focusNode )
				{
					var oRange = oSel.getRangeAt( 0 ) ;
					if ( oRange.collapsed || oRange.startContainer.nodeType == 3 )
						return oSel.anchorNode.parentNode ;
					else
						return oSel.anchorNode ;
				}

				var anchorPath = new sbEditorElementPath( oSel.anchorNode ) ;
				var focusPath = new sbEditorElementPath( oSel.focusNode ) ;
				var deepPath = null ;
				var shallowPath = null ;
				if ( anchorPath._Elements.length > focusPath._Elements.length )
				{
					deepPath = anchorPath._Elements ;
					shallowPath = focusPath._Elements ;
				}
				else
				{
					deepPath = focusPath._Elements ;
					shallowPath = anchorPath._Elements ;
				}
	
				var deepPathBase = deepPath.length - shallowPath.length ;
				for( var i = 0 ; i < shallowPath.length ; i++)
				{
					if ( deepPath[deepPathBase + i] == shallowPath[i])
						return shallowPath[i];
				}
				
				return null ;
			}
		}
		return null ;
	}
}

sbEditorSelection._GetBoundaryParentElement = function( startBoundary )
{
	if (_isIE)
	{
		switch ( this._GetType() )
		{
			case 'Control' :
				var el = sbEditorSelection._GetSelectedElement() ;
				return el ? el.parentElement : null ;
	
			case 'None' :
				return null ;
	
			default :
				var doc = sbEditorAreaDoc ;
	
				var range = doc.selection.createRange() ;
				range.collapse( startBoundary !== false ) ;
	
				var el = range.parentElement() ;
	
				return sbGetElementDocument( el ) == doc ? el : null ;
		}
	}
	else
	{
		if ( ! sbEditorAreaWnd )
			return null ;
		if ( this._GetType() == 'Control' )
			return sbEditorSelection._GetSelectedElement().parentNode ;
		else
		{
			var oSel = this._GetSelection() ;
			if ( oSel && oSel.rangeCount > 0 )
			{
				var range = oSel.getRangeAt( startBoundary ? 0 : ( oSel.rangeCount - 1 ) ) ;
				var element = startBoundary ? range.startContainer : range.endContainer ;
	
				return ( element.nodeType == 1 ? element : element.parentNode ) ;
			}
		}
		return null ;
	}
}

sbEditorSelection._SelectNode = function( node )
{
	if (_isIE)
	{
		//sbEditorFocus() ;
		this._GetSelection().empty() ;
		var oRange ;
		try
		{
			oRange = sbEditorAreaDoc.body.createControlRange() ;
			oRange.addElement( node ) ;
		}
		catch(e)
		{
			oRange = sbEditorAreaDoc.body.createTextRange() ;
			oRange.moveToElementText( node ) ;
		}

		oRange.select() ;
	}
	else
	{
		var oRange = sbEditorAreaDoc.createRange() ;
		oRange.selectNode( node ) ;
	
		var oSel = this._GetSelection() ;
		oSel.removeAllRanges() ;
		oSel.addRange( oRange ) ;
	}
}

sbEditorSelection._Collapse = function( toStart )
{
	if (_isIE)
	{
		sbEditorFocus() ;
		if ( this._GetType() == 'Text' )
		{
			var oRange = this._GetSelection().createRange() ;
			oRange.collapse( toStart == null || toStart === true ) ;
			oRange.select() ;
		}
	}
	else
	{
		var oSel = this._GetSelection() ;

		if ( toStart == null || toStart === true )
			oSel.collapseToStart() ;
		else
			oSel.collapseToEnd() ;
	}
}

sbEditorSelection._HasAncestorNode = function( nodeTagName )
{
	if (_isIE)
	{
		var oContainer ;
	
		if ( this._GetSelection().type == "Control" )
		{
			oContainer = this._GetSelectedElement() ;
		}
		else
		{
			var oRange  = this._GetSelection().createRange() ;
			oContainer = oRange.parentElement() ;
		}
	
		while ( oContainer && oContainer != sbEditorArea  )
		{
			if ( oContainer.nodeName.IEquals( nodeTagName ) ) 
				return true ;
				
			oContainer = oContainer.parentNode ;
		}
	}
	else
	{
		var oContainer = this._GetSelectedElement() ;
		if ( ! oContainer && sbEditorAreaWnd )
		{
			try	{ oContainer = this._GetSelection().getRangeAt(0).startContainer ; }
			catch(e){}
		}
	
		while ( oContainer && oContainer != sbEditorArea )
		{
			if ( oContainer.nodeType == 1 && oContainer.nodeName.IEquals( nodeTagName ) ) 
				return true ;
				
			oContainer = oContainer.parentNode ;
		}
	}
	
	return false ;
}

sbEditorSelection._MoveToAncestorNode = function( nodeTagName )
{
	if (_isIE)
	{
		var oNode, oRange ;
	
		if ( !sbEditorAreaDoc )
			return null ;
	
		if ( this._GetSelection().type == "Control" )
		{
			oRange = this._GetSelection().createRange() ;
			for ( i = 0 ; i < oRange.length ; i++ )
			{
				if (oRange(i).parentNode)
				{
					oNode = oRange(i).parentNode ;
					break ;
				}
			}
		}
		else
		{
			oRange  = this._GetSelection().createRange() ;
			oNode = oRange.parentElement() ;
		}
	
		while ( oNode && oNode.nodeName != nodeTagName && oNode != sbEditorArea )
			oNode = oNode.parentNode ;
	
		if (oNode == sbEditorArea)
			return null;
			
		return oNode ;
	}
	else
	{
		var oNode ;

		var oContainer = this._GetSelectedElement() ;
		if ( ! oContainer )
			oContainer = this._GetSelection().getRangeAt(0).startContainer ;
	
		while ( oContainer && oContainer != sbEditorArea )
		{
			if ( oContainer.nodeName.IEquals( nodeTagName ) )
				return oContainer ;
	
			oContainer = oContainer.parentNode ;
		}
		
		if (oContainer == sbEditorArea)
			return null;
			
		return null ;
	}
}

sbEditorSelection._Delete = function()
{
	var oSel = this._GetSelection() ;
	
	if (_isIE)
	{
		if ( oSel.type.toLowerCase() != "none" )
		{
			oSel.clear() ;
		}
	
		return oSel ;
	}
	else
	{
		for ( var i = 0 ; i < oSel.rangeCount ; i++ )
		{
			oSel.getRangeAt(i).deleteContents() ;
		}

		return oSel ;
	}
}

sbEditorSelection._GetSelection = function()
{
	if (_isIE)
	{
		this._Restore() ;
		return sbEditorAreaDoc.selection ;
	}
	else
	{
		return sbEditorAreaWnd.getSelection() ;
	}
}

sbEditorSelection._Save = function( noFocus )
{
	if (_isIE)
	{
		if ( !noFocus )
			sbEditorFocus() ;
	
		var editorDocument = sbEditorAreaDoc ;
	
		if ( !editorDocument )
			return ;
	
		var selection = editorDocument.selection ;
		var range ;
	
		if ( selection )
		{
			range = selection.createRange() ;
	
			if ( range )
			{
				if ( range.parentElement && sbGetElementDocument( range.parentElement() ) != editorDocument )
					range = null ;
				else if ( range.item && sbGetElementDocument( range.item(0) ) != editorDocument )
					range = null ;
			}
		}
		this._SelectionData = range ;
	}
}

sbEditorSelection._GetSelectionDocument = function( selection )
{
	var range = selection.createRange() ;
	if ( !range )
		return null;
	else if ( range.item )
		return sbGetElementDocument( range.item( 0 ) ) ;
	else
		return sbGetElementDocument( range.parentElement() ) ;
}

sbEditorSelection._Restore = function()
{
	if ( this._SelectionData )
	{
		sbEditorSelectionChangeLocked = true ;

		try
		{
			if ( this._GetSelectionDocument( sbEditorAreaDoc.selection ) == sbEditorAreaDoc )
			{
				sbEditorSelectionChangeLocked = false ;
				return ;
			}
			this._SelectionData.select() ;
		}
		catch ( e ) {}

		sbEditorSelectionChangeLocked = false ;
	}
}

sbEditorSelection._Release = function()
{
	delete this._SelectionData ;
}

///////////////////////////////////////////////////////////////////

var sbEditorHtmlIterator = function( source )
{
	this._SourceHtml = source ;
}

var pt = sbEditorHtmlIterator.prototype;

pt._Next = function()
{
	var sourceHtml = this._SourceHtml ;
	if ( sourceHtml == null )
		return null ;

	var match = sbEditorRegexLib.HtmlTag.exec( sourceHtml ) ;
	var isTag = false ;
	var value = "" ;
	if ( match )
	{
		if ( match.index > 0 )
		{
			value = sourceHtml.substr( 0, match.index ) ;
			this._SourceHtml = sourceHtml.substr( match.index ) ;
		}
		else
		{
			isTag = true ;
			value = match[0] ;
			this._SourceHtml = sourceHtml.substr( match[0].length ) ;
		}
	}
	else
	{
		value = sourceHtml ;
		this._SourceHtml = null ;
	}
	
	return { 'isTag' : isTag, 'value' : value } ;
}

pt._Each = function( func )
{
	var chunk ;
	while ( ( chunk = this._Next() ) )
		func( chunk.isTag, chunk.value ) ;
}

///////////////////////////////////////////////////////////////////

var sbEditorDomRangeIterator = function( range )
{
	this._Range = range ;
	this._ForceBrBreak = false ;
	this._EnforceRealBlocks = false ;
}

sbEditorDomRangeIterator._CreateFromSelection = function( targetWindow )
{
	var range = new sbEditorDomRange( targetWindow ) ;
	range._MoveToSelection() ;
	return new sbEditorDomRangeIterator( range ) ;
}

sbEditorDomRangeIterator.prototype._GetNextParagraph = function()
{
	var block ;
	var range ;
	var isLast ;
	var removePreviousBr ;
	var removeLastBr ;

	var boundarySet = this._ForceBrBreak ? sbEditorListsLib.ListBoundaries : sbEditorListsLib.BlockBoundaries ;

	if ( !this._LastNode )
	{
		var range = this._Range._Clone() ;
		range._Expand( this._ForceBrBreak ? 'list_contents' : 'block_contents' ) ;

		this._NextNode = range._GetTouchedStartNode() ;
		this._LastNode = range._GetTouchedEndNode() ;

		range = null ;
	}
	
	var currentNode = this._NextNode ;
	var lastNode = this._LastNode ;

	this._NextNode = null ;
	while ( currentNode && currentNode != sbEditorArea )
	{
		var closeRange = false ;
		var includeNode = ( currentNode.nodeType != 1 ) ;
		var continueFromSibling = false ;

		if ( !includeNode )
		{
			var nodeName = currentNode.nodeName.toLowerCase() ;

			if ( boundarySet[ nodeName ] && ( !_isIE || currentNode.scopeName == 'HTML' ) )
			{
				if ( nodeName == 'br' )
					includeNode = true ;
				else if ( !range && currentNode.childNodes.length == 0 && nodeName != 'hr' )
				{
					block = currentNode ;
					isLast = currentNode == lastNode ;
					break ;
				}

				if ( range )
				{
					range.setEnd( currentNode, 3, true ) ;
					if ( nodeName != 'br' )
						this._NextNode = sbEditorGetNextSourceNode( currentNode, true, null, lastNode ) ;
				}

				closeRange = true ;
			}
			else
			{
				if ( currentNode.firstChild )
				{
					if ( !range )
					{
						range = new sbEditorDomRange( this._Range._Window ) ;
						range.setStart( currentNode, 3, true ) ;
					}

					currentNode = currentNode.firstChild ;
					continue ;
				}
				includeNode = true ;
			}
		}
		else if ( currentNode.nodeType == 3 )
		{
			if ( /^[\r\n\t ]+$/.test( currentNode.nodeValue ) )
				includeNode = false ;
		}

		if ( includeNode && !range )
		{
			range = new sbEditorDomRange( this._Range._Window ) ;
			range.setStart( currentNode, 3, true ) ;
		}

		isLast = ( ( !closeRange || includeNode ) && currentNode == lastNode ) ;

		if ( range && !closeRange )
		{
			while ( !currentNode.nextSibling && !isLast )
			{
				var parentNode = currentNode.parentNode ;

				if ( boundarySet[ parentNode.nodeName.toLowerCase() ] )
				{
					closeRange = true ;
					isLast = isLast || ( parentNode == lastNode ) ;
					break ;
				}

				currentNode = parentNode ;
				includeNode = true ;
				isLast = ( currentNode == lastNode ) ;
				continueFromSibling = true ;
			}
		}

		if ( includeNode )
			range.setEnd( currentNode, 4, true ) ;

		if ( ( closeRange || isLast ) && range )
		{
			range._UpdateElementInfo() ;

			if ( range._StartNode == range._EndNode
				 && range._StartNode.parentNode == range._StartBlockLimit
				 && range._StartNode.getAttribute && range._StartNode.getAttribute( '_sb_bookmark' ) )
				range = null ;
			else
				break ;
		}

		if ( isLast )
			break ;

		currentNode = sbEditorGetNextSourceNode( currentNode, continueFromSibling, null, lastNode ) ;
	}

	if ( !block )
	{
		if ( !range )
		{
			this._NextNode = null ;
			return null ;
		}

		block = range._StartBlock != sbEditorArea ? range._StartBlock : null;
			
		if ( !block
			&& !this._EnforceRealBlocks
			&& range._StartBlockLimit
			&& range._StartBlockLimit.nodeName.IEquals( 'DIV', 'TH', 'TD' )
			&& range._CheckStartOfBlock()
			&& range._CheckEndOfBlock() )
		{
			block = range._StartBlockLimit ;
		}
		else if ( !block || ( this._EnforceRealBlocks && block.nodeName.toLowerCase() == 'li' ) )
		{
			block = this._Range._Window.document.createElement( SB_EDITOR_ENTER_MODE == 'p' ? 'p' : 'div' ) ;

			range._ExtractContents()._AppendTo( block ) ;
			sbEditorTrimNode( block ) ;

			range._InsertNode( block ) ;

			removePreviousBr = true ;
			removeLastBr = true ;
		}
		else if ( block.nodeName.toLowerCase() != 'li' )
		{
			if ( !range._CheckStartOfBlock() || !range._CheckEndOfBlock() )
			{
				block = block.cloneNode( false ) ;

				range._ExtractContents()._AppendTo( block ) ;
				sbEditorTrimNode( block ) ;

				var splitInfo = range._SplitBlock() ;

				removePreviousBr = !splitInfo._WasStartOfBlock ;
				removeLastBr = !splitInfo._WasEndOfBlock ;

				range._InsertNode( block ) ;
			}
		}
		else if ( !isLast )
		{
			this._NextNode = block == lastNode ? null : sbEditorGetNextSourceNode( range._EndNode, true, null, lastNode ) ;
			return block ;
		}
	}

	if ( removePreviousBr )
	{
		var previousSibling = block.previousSibling ;
		if ( previousSibling && previousSibling.nodeType == 1 )
		{
			if ( previousSibling.nodeName.toLowerCase() == 'br' )
				previousSibling.parentNode.removeChild( previousSibling ) ;
			else if ( previousSibling.lastChild && previousSibling.lastChild.nodeName.IEquals( 'br' ) )
				previousSibling.removeChild( previousSibling.lastChild ) ;
		}
	}

	if ( removeLastBr )
	{
		var lastChild = block.lastChild ;
		if ( lastChild && lastChild.nodeType == 1 && lastChild.nodeName.toLowerCase() == 'br' )
			block.removeChild( lastChild ) ;
	}

	if ( !this._NextNode )
		this._NextNode = ( isLast || block == lastNode ) ? null : sbEditorGetNextSourceNode( block, true, null, lastNode ) ;

	return block ;
}
	
///////////////////////////////////////////////////////////////////
		
var sbEditorElementPath = function( lastNode )
{
	var eBlock = null ;
	var eBlockLimit = null ;
	var aElements = new Array() ;

	var e = lastNode ;
	while ( e )
	{
		if ( e.nodeType == 1 )
		{
			if ( !this._LastElement )
				this._LastElement = e ;

			var sElementName = e.nodeName.toLowerCase() ;
			
			if ( _isIE && e.scopeName != 'HTML' )
				sElementName = e.scopeName.toLowerCase() + ':' + sElementName ;

			if ( !eBlockLimit )
			{
				if ( !eBlock && sbEditorListsLib.PathBlockElements[ sElementName ] != null )
					eBlock = e ;

				if ( sbEditorListsLib.PathBlockLimitElements[ sElementName ] != null )
				{
					if ( !eBlock && sElementName == 'div' && !this._CheckHasBlock( e ) )
						eBlock = e ;
					else
						eBlockLimit = e ;
				}
			}

			aElements.push( e ) ;
			
			if ( sElementName == 'body' || e == sbEditorArea )
				break ;
		}
		e = e.parentNode ;
	}

	this._Block = eBlock ;
	this._BlockLimit = eBlockLimit ;
	this._Elements = aElements ;
}

sbEditorElementPath.prototype._CheckHasBlock = function( element )
{
	var childNodes = element.childNodes ;

	for ( var i = 0, count = childNodes.length ; i < count ; i++ )
	{
		var child = childNodes[i] ;

		if ( child.nodeType == 1 && sbEditorListsLib.BlockElements[ child.nodeName.toLowerCase() ] )
			return true ;
	}

	return false ;
}

///////////////////////////////////////////////////////////////////

var sbEditorDocumentFragment = function( parentDocument, baseDocFrag )
{
	if (_isIE)
		this._RootNode = parentDocument.createElement( 'div' ) ;
	else
		this._RootNode = baseDocFrag || parentDocument.createDocumentFragment() ;
}

var pt = sbEditorDocumentFragment.prototype;

pt._AppendTo = function( targetNode )
{
	if (_isIE)
		sbEditorMoveChildren( this._RootNode, targetNode ) ;
	else
		targetNode.appendChild( this._RootNode ) ;
}

pt._AppendHtml = function( html )
{
	if (_isIE)
	{
		var eTmpDiv = parentDocument.createElement( 'div' ) ;
	}
	else
	{
		var eTmpDiv = this._RootNode.ownerDocument.createElement( 'div' ) ;
	}
	
	eTmpDiv.innerHTML = html ;
	sbEditorMoveChildren( eTmpDiv, this._RootNode ) ;
}

pt._InsertAfterNode = function( existingNode )
{
	if (_isIE)
	{
		var eRoot = this._RootNode ;
		var eLast ;

		while( ( eLast = eRoot.lastChild ) )
			sbEditorInsertAfterNode( existingNode, eRoot.removeChild( eLast ) ) ;
	}
	else
	{
		sbEditorInsertAfterNode( existingNode, this._RootNode ) ;
	}
}

///////////////////////////////////////////////////////////////////

var sbEditorW3CRange = function( parentDocument )
{
	this._Document = parentDocument ;
	this.startContainer = null ;
	this.startOffset = null ;
	this.endContainer = null ;
	this.endOffset = null ;
	this.collapsed = true ;
}

sbEditorW3CRange._CreateRange = function( parentDocument )
{
	return new sbEditorW3CRange( parentDocument ) ;
}

sbEditorW3CRange._CreateFromRange = function( parentDocument, sourceRange )
{
	var range = sbEditorW3CRange._CreateRange( parentDocument ) ;
	range.setStart( sourceRange.startContainer, sourceRange.startOffset ) ;
	range.setEnd( sourceRange.endContainer, sourceRange.endOffset ) ;
	return range ;
}

var pt = sbEditorW3CRange.prototype;

pt._UpdateCollapsed = function()
{
	this.collapsed = ( this.startContainer == this.endContainer && this.startOffset == this.endOffset ) ;
}

pt.setStart = function( refNode, offset )
{
	this.startContainer = refNode ;
	this.startOffset = offset ;

	if ( !this.endContainer )
	{
		this.endContainer = refNode ;
		this.endOffset = offset ;
	}

	this._UpdateCollapsed() ;
}

pt.setEnd = function( refNode, offset )
{
	this.endContainer = refNode ;
	this.endOffset = offset ;

	if ( !this.startContainer )
	{
		this.startContainer = refNode ;
		this.startOffset = offset ;
	}

	this._UpdateCollapsed() ;
}

pt.setStartAfter = function( refNode )
{
	this.setStart( refNode.parentNode, sbEditorGetIndexOf( refNode ) + 1 ) ;
}

pt.setStartBefore = function( refNode )
{
	this.setStart( refNode.parentNode, sbEditorGetIndexOf( refNode ) ) ;
}

pt.setEndAfter = function( refNode )
{
	this.setEnd( refNode.parentNode, sbEditorGetIndexOf( refNode ) + 1 ) ;
}

pt.setEndBefore = function( refNode )
{
	this.setEnd( refNode.parentNode, sbEditorGetIndexOf( refNode ) ) ;
}

pt.collapse = function( toStart )
{
	if ( toStart )
	{
		this.endContainer = this.startContainer ;
		this.endOffset = this.startOffset ;
	}
	else
	{
		this.startContainer = this.endContainer ;
		this.startOffset = this.endOffset ;
	}

	this.collapsed = true ;
}

pt.selectNodeContents = function( refNode )
{
	this.setStart( refNode, 0 ) ;
	this.setEnd( refNode, refNode.nodeType == 3 ? refNode.data.length : refNode.childNodes.length ) ;
}

pt.insertNode = function( newNode )
{
	var startContainer = this.startContainer ;
	var startOffset = this.startOffset ;
		
	if ( startContainer.nodeType == 3 )
	{
		startContainer.splitText( startOffset ) ;

		if ( startContainer == this.endContainer )
			this.setEnd( startContainer.nextSibling, this.endOffset - this.startOffset ) ;

		sbEditorInsertAfterNode( startContainer, newNode ) ;

		return ;
	}
	else
	{
		startContainer.insertBefore( newNode, startContainer.childNodes[ startOffset ] || null ) ;

		if ( startContainer == this.endContainer )
		{
			this.endOffset++ ;
			this.collapsed = false ;
		}
	}
}

pt.deleteContents = function()
{
	if ( this.collapsed )
		return ;

	this._ExecContentsAction( 0 ) ;
}

pt.extractContents = function()
{
	var docFrag = new sbEditorDocumentFragment( this._Document ) ;
	
	if ( !this.collapsed )
		this._ExecContentsAction( 1, docFrag ) ;

	return docFrag ;
}

pt.cloneContents = function()
{
	var docFrag = new sbEditorDocumentFragment( this._Document ) ;

	if ( !this.collapsed )
		this._ExecContentsAction( 2, docFrag ) ;

	return docFrag ;
}

pt._ExecContentsAction = function( action, docFrag )
{
	var startNode = this.startContainer ;
	var endNode = this.endContainer ;

	var startOffset = this.startOffset ;
	var endOffset = this.endOffset ;

	var removeStartNode = false ;
	var removeEndNode = false ;

	if ( endNode.nodeType == 3 )
		endNode = endNode.splitText( endOffset ) ;
	else
	{
		if ( endNode.childNodes.length > 0 )
		{
			if ( endOffset > endNode.childNodes.length - 1 )
			{
				endNode = sbEditorInsertAfterNode( endNode.lastChild, this._Document.createTextNode('') ) ;
				removeEndNode = true ;
			}
			else
				endNode = endNode.childNodes[ endOffset ] ;
		}
	}

	if ( startNode.nodeType == 3 )
	{
		startNode.splitText( startOffset ) ;

		if ( startNode == endNode )
			endNode = startNode.nextSibling ;
	}
	else
	{
		if ( startOffset == 0 )
		{
			startNode = startNode.insertBefore( this._Document.createTextNode(''), startNode.firstChild ) ;
			removeStartNode = true ;
		}
		else if ( startOffset > startNode.childNodes.length - 1 )
		{
			startNode = startNode.appendChild( this._Document.createTextNode('') ) ;
			removeStartNode = true ;
		}
		else
			startNode = startNode.childNodes[ startOffset ].previousSibling ;
	}

	var startParents = sbEditorGetParents( startNode ) ;
	var endParents = sbEditorGetParents( endNode ) ;

	var i, topStart, topEnd ;

	for ( i = 0 ; i < startParents.length ; i++ )
	{
		topStart = startParents[i] ;
		topEnd = endParents[i] ;

		if ( topStart != topEnd )
			break ;
	}

	var clone, levelStartNode, levelClone, currentNode, currentSibling ;

	if ( docFrag )
		clone = docFrag._RootNode ;

	for ( var j = i ; j < startParents.length ; j++ )
	{
		levelStartNode = startParents[j] ;

		if ( clone && levelStartNode != startNode )
			levelClone = clone.appendChild( levelStartNode.cloneNode( levelStartNode == startNode ) ) ;

		currentNode = levelStartNode.nextSibling ;

		while( currentNode )
		{
			if ( currentNode == endParents[j] || currentNode == endNode )
				break ;

			currentSibling = currentNode.nextSibling ;

			if ( action == 2 )
				clone.appendChild( currentNode.cloneNode( true ) ) ;
			else
			{
				currentNode.parentNode.removeChild( currentNode ) ;

				if ( action == 1 )
					clone.appendChild( currentNode ) ;
			}

			currentNode = currentSibling ;
		}

		if ( clone )
			clone = levelClone ;
	}

	if ( docFrag )
		clone = docFrag._RootNode ;

	for ( var k = i ; k < endParents.length ; k++ )
	{
		levelStartNode = endParents[k] ;

		if ( action > 0 && levelStartNode != endNode )
			levelClone = clone.appendChild( levelStartNode.cloneNode( levelStartNode == endNode ) ) ;

		if ( !startParents[k] || levelStartNode.parentNode != startParents[k].parentNode )
		{
			currentNode = levelStartNode.previousSibling ;

			while( currentNode )
			{
				if ( currentNode == startParents[k] || currentNode == startNode )
					break ;

				currentSibling = currentNode.previousSibling ;

				if ( action == 2 )
					clone.insertBefore( currentNode.cloneNode( true ), clone.firstChild ) ;
				else
				{
					currentNode.parentNode.removeChild( currentNode ) ;

					if ( action == 1 )
						clone.insertBefore( currentNode, clone.firstChild ) ;
				}

				currentNode = currentSibling ;
			}
		}

		if ( clone )
			clone = levelClone ;
	}

	if ( action == 2 )
	{
		var startTextNode = this.startContainer ;
		if ( startTextNode.nodeType == 3 )
		{
			startTextNode.data += startTextNode.nextSibling.data ;
			startTextNode.parentNode.removeChild( startTextNode.nextSibling ) ;
		}

		var endTextNode = this.endContainer ;
		if ( endTextNode.nodeType == 3 && endTextNode.nextSibling )
		{
			endTextNode.data += endTextNode.nextSibling.data ;
			endTextNode.parentNode.removeChild( endTextNode.nextSibling ) ;
		}
	}
	else
	{
		if ( topStart && topEnd && ( startNode.parentNode != topStart.parentNode || endNode.parentNode != topEnd.parentNode ) )
		{
			var endIndex = sbEditorGetIndexOf( topEnd ) ;

			if ( removeStartNode && topEnd.parentNode == startNode.parentNode )
				endIndex-- ;

			this.setStart( topEnd.parentNode, endIndex ) ;
		}

		this.collapse( true ) ;
	}

	if( removeStartNode )
		startNode.parentNode.removeChild( startNode ) ;

	if( removeEndNode && endNode.parentNode )
		endNode.parentNode.removeChild( endNode ) ;
}

pt.cloneRange = function()
{
	return sbEditorW3CRange._CreateFromRange( this._Document, this ) ;
}

///////////////////////////////////////////////////////////////////

var sbEditorDomRange = function( sourceWindow )
{
	this._Window = sourceWindow ;
	this._Cache = {} ;
}

var pt = sbEditorDomRange.prototype;

pt._UpdateElementInfo = function()
{
	var innerRange = this._Range ;

	if ( !innerRange )
		this._Release( true ) ;
	else
	{
		var eStart = innerRange.startContainer ;
		if (!eStart)
			return;
			
		var oElementPath = new sbEditorElementPath( eStart ) ;
		this._StartNode = eStart.nodeType == 3 ? eStart : eStart.childNodes[ innerRange.startOffset ] ;
		this.startContainer = eStart ;
		this._StartBlock = oElementPath._Block != sbEditorArea ? oElementPath._Block : null ;
		this._StartBlockLimit = oElementPath._BlockLimit ;

		if ( innerRange.collapsed )
		{
			this._EndNode = this._StartNode ;
			this.endContainer = this.startContainer ;
			this._EndBlock = this._StartBlock ;
			this._EndBlockLimit = this._StartBlockLimit ;
		}
		else
		{
			var eEnd = innerRange.endContainer ;

			if ( eStart != eEnd )
				oElementPath = new sbEditorElementPath( eEnd ) ;

			var eEndNode = eEnd ;
			if ( innerRange.endOffset == 0 )
			{
				while ( eEndNode && !eEndNode.previousSibling )
					eEndNode = eEndNode.parentNode ;

				if ( eEndNode )
					eEndNode = eEndNode.previousSibling ;
			}
			else if ( eEndNode.nodeType == 1 )
				eEndNode = eEndNode.childNodes[ innerRange.endOffset - 1 ] ;

			this._EndNode = eEndNode ;
			this.endContainer = eEnd ;
			this._EndBlock = oElementPath._Block ;
			this._EndBlockLimit = oElementPath._BlockLimit ;
		}
	}

	this._Cache = {} ;
}

pt._CreateRange = function()
{
	return new sbEditorW3CRange( this._Window.document ) ;
}

pt._DeleteContents = function()
{
	if ( this._Range )
	{
		this._Range.deleteContents() ;
		this._UpdateElementInfo() ;
	}
}

pt._ExtractContents = function()
{
	if ( this._Range )
	{
		var docFrag = this._Range.extractContents() ;
		this._UpdateElementInfo() ;
		return docFrag ;
	}
	
	return null ;
}

pt._IsCollapsed = function()
{
	if ( this._Range )
		return this._Range.collapsed ;

	return false ;
}

pt._Collapse = function( toStart )
{
	if ( this._Range )
		this._Range.collapse( toStart ) ;

	this._UpdateElementInfo() ;
}

pt._Clone = function()
{
	var oClone = new sbEditorDomRange(this._Window) ;
	
	if ( this._Range )
		oClone._Range = this._Range.cloneRange() ;

	return oClone ;
}

pt._MoveToNodeContents = function( targetNode )
{
	if ( !this._Range )
		this._Range = this._CreateRange() ;

	this._Range.selectNodeContents( targetNode ) ;

	this._UpdateElementInfo() ;
}

pt._MoveToElementStart = function( targetElement )
{
	this.setStart(targetElement, 1) ;
	this.setEnd(targetElement, 1) ;
}

pt._MoveToElementEditStart = function( targetElement )
{
	var editableElement ;

	while ( targetElement && targetElement.nodeType == 1 )
	{
		if ( sbEditorIsEditable( targetElement ) )
			editableElement = targetElement ;
		else if ( editableElement )
			break ;		

		targetElement = targetElement.firstChild ;
	}

	if ( editableElement )
		this._MoveToElementStart( editableElement ) ;
}

pt._InsertNode = function( node )
{
	if ( this._Range )
		this._Range.insertNode( node ) ;
}

pt._IsEmpty = function()
{
	if ( this._IsCollapsed() )
		return true ;

	var eToolDiv = this._Window.document.createElement( 'div' ) ;
	this._Range.cloneContents()._AppendTo( eToolDiv ) ;

	sbEditorTrimNode( eToolDiv ) ;

	return ( eToolDiv.innerHTML.length == 0 ) ;
}

pt._CheckStartOfBlock = function()
{
	var cache = this._Cache ;
	var bIsStartOfBlock = cache._IsStartOfBlock ;

	if ( bIsStartOfBlock != undefined )
		return bIsStartOfBlock ;

	var block = this._StartBlock || this._StartBlockLimit ;
	var container = this._Range.startContainer ;
	var offset = this._Range.startOffset ;

	var currentNode ;

	if ( offset > 0 )
	{
		if ( container.nodeType == 3 )
		{
			var textValue = container.nodeValue.substr( 0, offset ).Trim() ;
			if ( textValue.length != 0 )
				return cache._IsStartOfBlock = false ;
		}
		else
			currentNode = container.childNodes[ offset - 1 ] ;
	}

	if ( !currentNode )
		currentNode = sbEditorGetPreviousSourceNode( container, true, null, block ) ;

	while ( currentNode )
	{
		switch ( currentNode.nodeType )
		{
			case 1 :
				if ( !sbEditorListsLib.InlineChildReqElements[ currentNode.nodeName.toLowerCase() ] )
					return cache._IsStartOfBlock = false ;

				break ;

			case 3 :
				if ( currentNode.nodeValue.Trim().length > 0 )
					return cache._IsStartOfBlock = false ;
		}

		currentNode = sbEditorGetPreviousSourceNode( currentNode, false, null, block ) ;
	}

	return cache._IsStartOfBlock = true ;
}

pt._CheckEndOfBlock = function( refreshSelection )
{
	var isEndOfBlock = this._Cache._IsEndOfBlock ;

	if ( isEndOfBlock != undefined )
		return isEndOfBlock ;

	var block = this._EndBlock || this._EndBlockLimit ;

	var container = this._Range.endContainer ;
	var offset = this._Range.endOffset ;
	var currentNode ;

	if ( container.nodeType == 3 )
	{
		var textValue = container.nodeValue ;
		if ( offset < textValue.length )
		{
			textValue = textValue.substr( offset ) ;

			if ( textValue.Trim().length != 0 )
				return this._Cache._IsEndOfBlock = false ;
		}
	}
	else
		currentNode = container.childNodes[ offset ] ;

	if ( !currentNode )
		currentNode = sbEditorGetNextSourceNode( container, true, null, block ) ;

	var hadBr = false ;

	while ( currentNode )
	{
		switch ( currentNode.nodeType )
		{
			case 1 :
				var nodeName = currentNode.nodeName.toLowerCase() ;

				if ( sbEditorListsLib.InlineChildReqElements[ nodeName ] )
					break ;

				if ( nodeName == 'br' && !hadBr )
				{
					hadBr = true ;
					break ;
				}

				return this._Cache._IsEndOfBlock = false ;

			case 3 :
				if ( currentNode.nodeValue.Trim().length > 0 )
					return this._Cache._IsEndOfBlock = false ;
		}

		currentNode = sbEditorGetNextSourceNode( currentNode, false, null, block ) ;
	}

	if ( refreshSelection )
		this._Select() ;

	return this._Cache._IsEndOfBlock = true ;
}

pt._CreateBookmark = function( includeNodes )
{
	if (!this.startContainer)
		return;
		
	var oBookmark =
		{
			_StartId	: (new Date()).valueOf() + Math.floor(Math.random()*1000) + 'S',
			_EndId	: (new Date()).valueOf() + Math.floor(Math.random()*1000) + 'E'
		} ;

	var oDoc = this._Window.document ;
	var eStartSpan ;
	var eEndSpan ;
	var oClone ;

	if ( !this._IsCollapsed() )
	{
		eEndSpan = oDoc.createElement( 'span' ) ;
		eEndSpan.style.display = 'none' ;
		eEndSpan.id = oBookmark._EndId ;
		eEndSpan.setAttribute( '_sb_bookmark', true ) ;
		eEndSpan.innerHTML = '&nbsp;' ;

		oClone = this._Clone() ;
		oClone._Collapse( false ) ;
		oClone._InsertNode( eEndSpan ) ;
	}

	eStartSpan = oDoc.createElement( 'span' ) ;
	eStartSpan.style.display = 'none' ;
	eStartSpan.id = oBookmark._StartId ;
	eStartSpan.setAttribute( '_sb_bookmark', true ) ;
	eStartSpan.innerHTML = '&nbsp;' ;

	oClone = this._Clone() ;
	oClone._Collapse( true ) ;
	oClone._InsertNode( eStartSpan ) ;

	if ( includeNodes )
	{
		oBookmark._StartNode = eStartSpan ;
		oBookmark._EndNode = eEndSpan ;
	}

	if ( eEndSpan )
	{
		this.setStart( eStartSpan, 4 ) ;
		this.setEnd( eEndSpan, 3 ) ;
	}
	else
		this._MoveToPosition( eStartSpan, 4 ) ;

	return oBookmark ;
}

pt._GetBookmarkNode = function( bookmark, start )
{
	var doc = this._Window.document ;

	if ( start )
		return bookmark._StartNode || doc.getElementById( bookmark._StartId ) ;
	else
		return bookmark._EndNode || doc.getElementById( bookmark._EndId ) ;
}

pt._MoveToBookmark = function( bookmark, preserveBookmark )
{
	var eStartSpan = this._GetBookmarkNode( bookmark, true ) ;
	var eEndSpan = this._GetBookmarkNode( bookmark, false ) ;

	this.setStart( eStartSpan, 3 ) ;

	if ( !preserveBookmark )
		sbEditorRemoveNode( eStartSpan ) ;

	if ( eEndSpan )
	{
		this.setEnd( eEndSpan, 3 ) ;

		if ( !preserveBookmark )
			sbEditorRemoveNode( eEndSpan ) ;
	}
	else
		this._Collapse( true ) ;

	this._UpdateElementInfo() ;
}

pt._CreateBookmark2 = function()
{
	if ( ! this._Range )
		return { "Start" : 0, "End" : 0 } ;

	var bookmark =
	{
		"_Start" : [ this._Range.startOffset ],
		"_End" : [ this._Range.endOffset ]
	} ;
	
	var curStart = this._Range.startContainer.previousSibling ;
	var curEnd = this._Range.endContainer.previousSibling ;

	var addrStart = this._Range.startContainer ;
	var addrEnd = this._Range.endContainer ;
	while ( curStart && addrStart.nodeType == 3 )
	{
		bookmark._Start[0] += curStart.length ;
		addrStart = curStart ;
		curStart = curStart.previousSibling ;
	}
	while ( curEnd && addrEnd.nodeType == 3 )
	{
		bookmark._End[0] += curEnd.length ;
		addrEnd = curEnd ;
		curEnd = curEnd.previousSibling ;
	}

	if ( addrStart.nodeType == 1 && addrStart.childNodes[bookmark._Start[0]] && addrStart.childNodes[bookmark._Start[0]].nodeType == 3 )
	{
		var curNode = addrStart.childNodes[bookmark._Start[0]] ;
		var offset = 0 ;
		while ( curNode.previousSibling && curNode.previousSibling.nodeType == 3 )
		{
			curNode = curNode.previousSibling ;
			offset += curNode.length ;
		}
		addrStart = curNode ;
		bookmark._Start[0] = offset ;
	}
	if ( addrEnd.nodeType == 1 && addrEnd.childNodes[bookmark._End[0]] && addrEnd.childNodes[bookmark._End[0]].nodeType == 3 )
	{
		var curNode = addrEnd.childNodes[bookmark._End[0]] ;
		var offset = 0 ;
		while ( curNode.previousSibling && curNode.previousSibling.nodeType == 3 )
		{
			curNode = curNode.previousSibling ;
			offset += curNode.length ;
		}
		addrEnd = curNode ;
		bookmark._End[0] = offset ;
	}

	bookmark._Start = sbEditorGetNodeAddress( addrStart, true ).concat( bookmark._Start ) ;
	bookmark._End = sbEditorGetNodeAddress( addrEnd, true ).concat( bookmark._End ) ;
	return bookmark;
}

pt._MoveToBookmark2 = function( bookmark )
{
	var curStart = sbEditorGetNodeFromAddress( this._Window.document, bookmark._Start.slice( 0, -1 ), true ) ;
	var curEnd = sbEditorGetNodeFromAddress( this._Window.document, bookmark._End.slice( 0, -1 ), true ) ;

	this._Release( true ) ;
	this._Range = new sbEditorW3CRange( this._Window.document ) ;
	var startOffset = bookmark._Start[ bookmark._Start.length - 1 ] ;
	var endOffset = bookmark._End[ bookmark._End.length - 1 ] ;
	while ( curStart.nodeType == 3 && startOffset > curStart.length )
	{
		if ( ! curStart.nextSibling || curStart.nextSibling.nodeType != 3 )
			break ;
		startOffset -= curStart.length ;
		curStart = curStart.nextSibling ;
	}
	while ( curEnd.nodeType == 3 && endOffset > curEnd.length )
	{
		if ( ! curEnd.nextSibling || curEnd.nextSibling.nodeType != 3 )
			break ;
		endOffset -= curEnd.length ;
		curEnd = curEnd.nextSibling ;
	}
	this._Range.setStart( curStart, startOffset ) ;
	this._Range.setEnd( curEnd, endOffset ) ;
	this._UpdateElementInfo() ;
}

pt._MoveToPosition = function( targetElement, position )
{
	this.setStart( targetElement, position ) ;
	this._Collapse( true ) ;
}

pt.setStart = function( targetElement, position, noInfoUpdate )
{
	var oRange = this._Range ;
	if ( !oRange )
		oRange = this._Range = this._CreateRange() ;

	switch( position )
	{
		case 1 :
			oRange.setStart( targetElement, 0 ) ;
			break ;

		case 2 :
			oRange.setStart( targetElement, targetElement.childNodes.length ) ;
			break ;

		case 3 :
			oRange.setStartBefore( targetElement ) ;
			break ;

		case 4 :
			oRange.setStartAfter( targetElement ) ;
	}

	if ( !noInfoUpdate )
		this._UpdateElementInfo() ;
}

pt.setEnd = function( targetElement, position, noInfoUpdate )
{
	var oRange = this._Range ;
	if ( !oRange )
		oRange = this._Range = this._CreateRange() ;

	switch( position )
	{
		case 1 :
			oRange.setEnd( targetElement, 0 ) ;
			break ;

		case 2 :
			oRange.setEnd( targetElement, targetElement.childNodes.length ) ;
			break ;

		case 3 :
			oRange.setEndBefore( targetElement ) ;
			break ;

		case 4 :
			oRange.setEndAfter( targetElement ) ;
	}

	if ( !noInfoUpdate )
		this._UpdateElementInfo() ;
},

pt._Expand = function( unit )
{
	var oNode, oSibling ;

	switch ( unit )
	{
		case 'inline_elements' :
			if ( this._Range.startOffset == 0 )
			{
				oNode = this._Range.startContainer ;

				if ( oNode.nodeType != 1 )
					oNode = oNode.previousSibling ? null : oNode.parentNode ;

				if ( oNode )
				{
					while ( sbEditorListsLib.InlineNonEmptyElements[ oNode.nodeName.toLowerCase() ] )
					{
						this._Range.setStartBefore( oNode ) ;

						if ( oNode != oNode.parentNode.firstChild )
							break ;

						oNode = oNode.parentNode ;
					}
				}
			}

			oNode = this._Range.endContainer ;
			var offset = this._Range.endOffset ;

			if ( ( oNode.nodeType == 3 && offset >= oNode.nodeValue.length ) || ( oNode.nodeType == 1 && offset >= oNode.childNodes.length ) || ( oNode.nodeType != 1 && oNode.nodeType != 3 ) )
			{
				if ( oNode.nodeType != 1 )
					oNode = oNode.nextSibling ? null : oNode.parentNode ;

				if ( oNode )
				{
					while ( sbEditorListsLib.InlineNonEmptyElements[ oNode.nodeName.toLowerCase() ] )
					{
						this._Range.setEndAfter( oNode ) ;

						if ( oNode != oNode.parentNode.lastChild )
							break ;

						oNode = oNode.parentNode ;
					}
				}
			}

			break ;

		case 'block_contents' :
		case 'list_contents' :
			var boundarySet = sbEditorListsLib.BlockBoundaries ;
			if ( unit == 'list_contents' || SB_EDITOR_ENTER_MODE == 'br' )
				boundarySet = sbEditorListsLib.ListBoundaries ;

			if ( this._StartBlock && SB_EDITOR_ENTER_MODE != 'br' && unit == 'block_contents' )
				this.setStart( this._StartBlock, 1 ) ;
			else
			{
				oNode = this._Range.startContainer ;

				if ( oNode.nodeType == 1 )
				{
					var lastNode = oNode.childNodes[ this._Range.startOffset ] ;
					if ( lastNode )
						oNode = sbEditorGetPreviousSourceNode( lastNode, true ) ;
					else
						oNode = oNode.lastChild || oNode ;
				}

				while ( oNode && ( oNode.nodeType != 1 || ( oNode != this._StartBlockLimit && !boundarySet[ oNode.nodeName.toLowerCase() ] ) ) )
				{
					this._Range.setStartBefore( oNode ) ;
					oNode = oNode.previousSibling || oNode.parentNode ;
				}
			}

			if ( this._EndBlock && SB_EDITOR_ENTER_MODE != 'br' && unit == 'block_contents' && this._EndBlock.nodeName.toLowerCase() != 'li' )
				this.setEnd( this._EndBlock, 2 ) ;
			else
			{
				oNode = this._Range.endContainer ;
				if ( oNode.nodeType == 1 )
					oNode = oNode.childNodes[ this._Range.endOffset ] || oNode.lastChild ;

				while ( oNode && ( oNode.nodeType != 1 || ( oNode != this._StartBlockLimit && !boundarySet[ oNode.nodeName.toLowerCase() ] ) ) )
				{
					this._Range.setEndAfter( oNode ) ;
					oNode = oNode.nextSibling || oNode.parentNode ;
				}

				if ( oNode && oNode.nodeName.toLowerCase() == 'br' )
					this._Range.setEndAfter( oNode ) ;
			}

			this._UpdateElementInfo() ;
			break;
	}
}

pt._SplitBlock = function( forceBlockTag )
{
	var blockTag = forceBlockTag || SB_EDITOR_ENTER_MODE ;

	if ( !this._Range )
		this._MoveToSelection() ;

	if ( this._StartBlockLimit == this._EndBlockLimit )
	{
		var eStartBlock = this._StartBlock ;
		var eEndBlock = this._EndBlock ;
		var oElementPath = null ;

		if ( blockTag != 'br' )
		{
			if ( !eStartBlock )
			{
				eStartBlock = this._FixBlock( true, blockTag ) ;
				eEndBlock	= this._EndBlock ;
			}

			if ( !eEndBlock )
				eEndBlock = this._FixBlock( false, blockTag ) ;
		}

		var bIsStartOfBlock	= ( eStartBlock != null && this._CheckStartOfBlock() ) ;
		var bIsEndOfBlock	= ( eEndBlock != null && this._CheckEndOfBlock() ) ;

		if ( !this._IsEmpty() )
			this._DeleteContents() ;

		if ( eStartBlock && eEndBlock && eStartBlock == eEndBlock )
		{
			if ( bIsEndOfBlock )
			{
				oElementPath = new sbEditorElementPath( this.startContainer ) ;
				this._MoveToPosition( eEndBlock, 4 ) ;
				eEndBlock = null ;
			}
			else if ( bIsStartOfBlock )
			{
				oElementPath = new sbEditorElementPath( this.startContainer ) ;
				this._MoveToPosition( eStartBlock, 3 ) ;
				eStartBlock = null ;
			}
			else
			{
				this.setEnd( eStartBlock, 2 ) ;
				var eDocFrag = this._ExtractContents() ;

				eEndBlock = eStartBlock.cloneNode( false ) ;
				eEndBlock.removeAttribute( 'id', false ) ;

				eDocFrag._AppendTo( eEndBlock ) ;

				sbEditorInsertAfterNode( eStartBlock, eEndBlock ) ;

				this._MoveToPosition( eStartBlock, 4 ) ;

				if ( _isFF && ! eStartBlock.nodeName.IEquals( ['ul', 'ol'] ) )
					sbEditorAppendBogusBr( eStartBlock ) ;
			}
		}

		return {
			_PreviousBlock : eStartBlock,
			_NextBlock : eEndBlock,
			_WasStartOfBlock : bIsStartOfBlock,
			_WasEndOfBlock : bIsEndOfBlock,
			_ElementPath : oElementPath
		} ;
	}

	return null ;
}

pt._FixBlock = function( isStart, blockTag )
{
	var oBookmark = this._CreateBookmark() ;

	this._Collapse( isStart ) ;
	this._Expand( 'block_contents' ) ;

	var oFixedBlock = this._Window.document.createElement( blockTag ) ;

	this._ExtractContents()._AppendTo( oFixedBlock ) ;
	sbEditorTrimNode( oFixedBlock ) ;

	if ( sbEditorIsEmptyElement(oFixedBlock, function( element ) { return element.getAttribute('_sb_bookmark') != 'true' ; } )
			&& !_isIE )
		sbEditorAppendBogusBr( oFixedBlock ) ;

	this._InsertNode( oFixedBlock ) ;
	this._MoveToBookmark( oBookmark ) ;

	return oFixedBlock ;
}

pt._Release = function( preserveWindow )
{
	if ( !preserveWindow )
		this._Window = null ;

	this._StartNode = null ;
	this.startContainer = null ;
	this._StartBlock = null ;
	this._StartBlockLimit = null ;
	this._EndNode = null ;
	this.endContainer = null ;
	this._EndBlock = null ;
	this._EndBlockLimit = null ;
	this._Range = null ;
	this._Cache = null ;
}

pt._HasRange = function()
{
	return !!this._Range ;
}

pt._GetTouchedStartNode = function()
{
	var range = this._Range ;
	var container = range.startContainer ;

	if ( range.collapsed || container.nodeType != 1 )
		return container ;

	return container.childNodes[ range.startOffset ] || container ;
}

pt._GetTouchedEndNode = function()
{
	var range = this._Range ;
	var container = range.endContainer ;

	if ( range.collapsed || container.nodeType != 1 )
		return container ;

	return container.childNodes[ range.endOffset - 1 ] || container ;
}

pt._MoveToSelection = function()
{
	this._Release( true ) ;

	if (_isIE)
	{
		this._Range = new sbEditorW3CRange( this._Window.document ) ;
	
		var oSel = this._Window.document.selection ;
	
		if ( oSel.type != 'Control' )
		{
			var eMarkerStart = this._GetSelectionMarkerTag( true ) ;
			var eMarkerEnd = this._GetSelectionMarkerTag( false ) ;

			if ( !eMarkerStart && !eMarkerEnd )
			{
				this._Range.setStart( sbEditorArea, 0 ) ;
				this._UpdateElementInfo() ;
				return ;
			}

			this._Range.setStart( eMarkerStart.parentNode, sbEditorGetIndexOf( eMarkerStart ) ) ;
			eMarkerStart.parentNode.removeChild( eMarkerStart ) ;
	
			this._Range.setEnd( eMarkerEnd.parentNode, sbEditorGetIndexOf( eMarkerEnd ) ) ;
			eMarkerEnd.parentNode.removeChild( eMarkerEnd ) ;
	
			this._UpdateElementInfo() ;
		}
		else
		{
			try
			{
				var oControl = oSel.createRange().item(0);
				if ( oControl )
				{
					this._Range.setStartBefore( oControl ) ;
					this._Range.setEndAfter( oControl ) ;
					this._UpdateElementInfo() ;
				}
			}
			catch (e) {}
		}
	}
	else
	{
		var oSel = this._Window.getSelection() ;
		if ( oSel && oSel.rangeCount > 0 )
		{
			this._Range = sbEditorW3CRange._CreateFromRange( this._Window.document, oSel.getRangeAt(0) ) ;
			this._UpdateElementInfo() ;
		}
		else
			if ( this._Window.document )
				this._MoveToElementStart( this._Window.document.body ) ;
	}
}

pt._Select = function( forceExpand )
{
	if (_isIE)
	{
		if ( this._Range )
			this._SelectBookmark( this._CreateBookmark( true ), forceExpand ) ;
	}
	else
	{
		var oRange = this._Range ;
		if ( oRange )
		{
			var startContainer = oRange.startContainer ;
			if ( oRange.collapsed && startContainer.nodeType == 1 && startContainer.childNodes.length == 0 )
				startContainer.appendChild( oRange._Document.createTextNode('') ) ;

			var oDocRange = this._Window.document.createRange() ;
			oDocRange.setStart( startContainer, oRange.startOffset ) ;

			try
			{
				oDocRange.setEnd( oRange.endContainer, oRange.endOffset ) ;
			}
			catch ( e )
			{
				if ( e.toString().Contains( 'NS_ERROR_ILLEGAL_VALUE' ) || e.toString().Contains( 'INDEX_SIZE_ERROR' ) )
				{
					oRange.collapse( true ) ;
					oDocRange.setEnd( oRange.endContainer, oRange.endOffset ) ;
				}
			}

			var oSel = this._Window.getSelection() ;
			oSel.removeAllRanges() ;
			oSel.addRange( oDocRange ) ;
		}
	}

}

pt._SelectBookmark = function( bookmark, forceExpand )
{
	if (_isIE)
	{
		var bIsCollapsed = this._IsCollapsed() ;
		var bIsStartMakerAlone ;
		var dummySpan ;
	
		var eStartMarker = this._GetBookmarkNode( bookmark, true ) ;
	
		if ( !eStartMarker )
			return ;
	
		var eEndMarker ;
		if ( !bIsCollapsed )
			eEndMarker = this._GetBookmarkNode( bookmark, false ) ;
	
		var oIERange = this._Window.document.body.createTextRange() ;
	
		oIERange.moveToElementText( eStartMarker ) ;
		oIERange.moveStart( 'character', 1 ) ;
	
		if ( eEndMarker )
		{
			var oIERangeEnd = this._Window.document.body.createTextRange() ;
	
			oIERangeEnd.moveToElementText( eEndMarker ) ;
	
			oIERange.setEndPoint( 'EndToEnd', oIERangeEnd ) ;
			oIERange.moveEnd( 'character', -1 ) ;
		}
		else
		{
			bIsStartMakerAlone = ( forceExpand || !eStartMarker.previousSibling || eStartMarker.previousSibling.nodeName.toLowerCase() == 'br' ) && !eStartMarker.nextSibing ;
	
			dummySpan = this._Window.document.createElement( 'span' ) ;
			dummySpan.innerHTML = '&#65279;' ;
			eStartMarker.parentNode.insertBefore( dummySpan, eStartMarker ) ;
	
			if ( bIsStartMakerAlone )
			{
				eStartMarker.parentNode.insertBefore( this._Window.document.createTextNode( '\ufeff' ), eStartMarker ) ;
			}
		}
	
		if ( !this._Range )
			this._Range = this._CreateRange() ;
	
		this._Range.setStartBefore( eStartMarker ) ;
		eStartMarker.parentNode.removeChild( eStartMarker ) ;
	
		if ( bIsCollapsed )
		{
			if ( bIsStartMakerAlone )
			{
				oIERange.moveStart( 'character', -1 ) ;
				oIERange.select() ;
				this._Window.document.selection.clear() ;
			}
			else
				oIERange.select() ;
	
			sbEditorRemoveNode( dummySpan ) ;
		}
		else
		{
			this._Range.setEndBefore( eEndMarker ) ;
			eEndMarker.parentNode.removeChild( eEndMarker ) ;
			oIERange.select() ;
		}
	}
	else
	{
		var domRange = this._Window.document.createRange() ;

		var startNode = this._GetBookmarkNode( bookmark, true ) ;
		var endNode	= this._GetBookmarkNode( bookmark, false ) ;
	
		domRange.setStart( startNode.parentNode, sbEditorGetIndexOf( startNode ) ) ;
		sbEditorRemoveNode( startNode ) ;
	
		if ( endNode )
		{
			domRange.setEnd( endNode.parentNode, sbEditorGetIndexOf( endNode ) ) ;
			sbEditorRemoveNode( endNode ) ;
		}
	
		var selection = this._Window.getSelection() ;
		selection.removeAllRanges() ;
		selection.addRange( domRange ) ;
	}
}

pt._GetSelectionMarkerTag = function( toStart )
{
	var doc = this._Window.document ;
	var selection = doc.selection ;

	var oRange ;

	try
	{
		oRange = selection.createRange() ;
	}
	catch (e)
	{
		return null ;
	}

	if ( oRange.parentElement().document != doc )
		return null ;

	oRange.collapse( toStart === true ) ;

	var sMarkerId = 'sb_dom_range_temp_' + (new Date()).valueOf() + '_' + Math.floor(Math.random()*1000) ;
	oRange.pasteHTML( '<span id="' + sMarkerId + '"></span>' ) ;

	return doc.getElementById( sMarkerId ) ;
}

///////////////////////////////////////////////////////////////////////

var sbEditorTempBin =
{
	_Elements : new Array(),

	_AddElement : function( element )
	{
		var iIndex = this._Elements.length ;
		this._Elements[ iIndex ] = element ;
		return iIndex ;
	},

	_RemoveElement : function( index )
	{
		var e = this._Elements[ index ] ;
		this._Elements[ index ] = null ;
		return e ;
	},

	_Reset : function()
	{
		var i = 0 ;
		while ( i < this._Elements.length )
			this._Elements[ i++ ] = null ;
		this._Elements.length = 0 ;
	}/*,

	_ToHtml : function()
	{
		for ( var i = 0 ; i < this._Elements.length ; i++ )
		{
			this._Elements[i] = '<div>&nbsp;' + this._Elements[i].outerHTML + '</div>' ;
			this._Elements[i].isHtml = true ;
		}
	},

	_ToElements : function()
	{
		var node = sbEditorAreaDoc.createElement( 'div' ) ;
		for ( var i = 0 ; i < this._Elements.length ; i++ )
		{
			if ( this._Elements[i].isHtml )
			{
				node.innerHTML = this._Elements[i] ;
				this._Elements[i] = node.firstChild.removeChild( node.firstChild.lastChild ) ;
			}
		}
	}*/
} ;

///////////////////////////////////////////////////////////////////

var sbEditorDocumentProcessor = new Object() ;
sbEditorDocumentProcessor._Items = new Array() ;

sbEditorDocumentProcessor._AppendNew = function()
{
	var oNewItem = new Object() ;
	this._Items.AddItem( oNewItem ) ;
	return oNewItem ;
}

sbEditorDocumentProcessor._Process = function( doc )
{
	var oProcessor, i = 0 ;
	while( ( oProcessor = this._Items[i++] ) )
		oProcessor._ProcessDocument( doc ) ;
}

sbEditorDocumentProcessor._CreateFakeImage = function( fakeClass, realElement )
{
	var oImg = sbGetElementDocument( realElement ).createElement( 'IMG' ) ;
	oImg.className = fakeClass ;
	oImg.src = window.parent.sb_cms_img_url + '/blank.gif' ;
	oImg.setAttribute( '_sbfakelement', 'true', 0 ) ;
	oImg.setAttribute( '_sbrealelement', sbEditorTempBin._AddElement( realElement ), 0 ) ;
	return oImg ;
}

// Anchors
var sbEditorAnchorsProcessor = sbEditorDocumentProcessor._AppendNew() ;
sbEditorAnchorsProcessor._ProcessDocument = function( doc )
{
	var aLinks = doc.getElementsByTagName( 'A' ) ;

	var oLink ;
	var i = aLinks.length - 1 ;
	while ( i >= 0 && ( oLink = aLinks[i--] ) )
	{
		if ( oLink.name.length > 0 || oLink.id.length > 0 )
		{
			if ( oLink.innerHTML !== '' )
			{
				if ( _isIE )
					oLink.className += ' sb__AnchorC' ;
			}
			else
			{
				var oImg = sbEditorDocumentProcessor._CreateFakeImage( 'sb__Anchor', oLink.cloneNode(true) ) ;
				oImg.setAttribute( '_sbanchor', 'true', 0 ) ;

				oLink.parentNode.insertBefore( oImg, oLink ) ;
				oLink.parentNode.removeChild( oLink ) ;
			}
		}
	}
}

// Page Breaks
var sbEditorPageBreaksProcessor = sbEditorDocumentProcessor._AppendNew() ;
sbEditorPageBreaksProcessor._ProcessDocument = function( doc )
{
	var aDIVs = doc.getElementsByTagName( 'DIV' ) ;

	var eDIV ;
	var i = aDIVs.length - 1 ;
	while ( i >= 0 && ( eDIV = aDIVs[i--] ) )
	{
		if ( eDIV.style.pageBreakAfter == 'always' && eDIV.childNodes.length == 1 && eDIV.childNodes[0].style && eDIV.childNodes[0].style.display == 'none' )
		{
			var oFakeImage = sbEditorDocumentProcessor._CreateFakeImage( 'sb__PageBreak', eDIV.cloneNode(true) ) ;

			eDIV.parentNode.insertBefore( oFakeImage, eDIV ) ;
			eDIV.parentNode.removeChild( eDIV ) ;
		}
	}
}

// EMBED and OBJECT tags.
sbEditorEmbedAndObjectProcessor = (function()
{
	var customProcessors = [] ;

	var _ProcessElement = function( el )
	{
		var clone = el.cloneNode( true ) ;
		var replaceElement ;
		var fakeImg = replaceElement = sbEditorDocumentProcessor._CreateFakeImage( 'sb__UnknownObject', clone ) ;
		sbEditorEmbedAndObjectProcessor._RefreshView( fakeImg, el ) ;

		for ( var i = 0 ; i < customProcessors.length ; i++ )
			replaceElement = customProcessors[i]( el, replaceElement ) || replaceElement ;

		if ( replaceElement != fakeImg )
			sbEditorTempBin._RemoveElement( fakeImg.getAttribute( '_sbrealelement' ) ) ;

		el.parentNode.replaceChild( replaceElement, el ) ;
	}

	var _ProcessElementsByName = function( elementName, doc )
	{
		var aObjects = doc.getElementsByTagName( elementName );
		for ( var i = aObjects.length - 1 ; i >= 0 ; i-- )
			_ProcessElement( aObjects[i] ) ;
	}

	var _ProcessObjectAndEmbed = function( doc )
	{
		_ProcessElementsByName( 'object', doc );
		_ProcessElementsByName( 'embed', doc );
	}

	return sbEditorMerge ( sbEditorDocumentProcessor._AppendNew(),
       {
			_ProcessDocument : function( doc )
			{
				if ( _isFF )
				{
					setTimeout(
						function()
						{
							_ProcessObjectAndEmbed.apply( this, [].concat( [ doc ] ) ) ;
						}, 0 ) ;
				}
				else
					_ProcessObjectAndEmbed( doc ) ;
			},
	
			_RefreshView : function( placeHolder, original )
			{
				if ( original.getAttribute( 'width' ) > 0 )
					placeHolder.style.width = sbEditorConvertHtmlSizeToStyle( original.getAttribute( 'width' ) ) ;
	
				if ( original.getAttribute( 'height' ) > 0 )
					placeHolder.style.height = sbEditorConvertHtmlSizeToStyle( original.getAttribute( 'height' ) ) ;
			},
	
			_AddCustomHandler : function( func )
			{
				customProcessors.push( func ) ;
			}
	} ) ;
} )() ;

function sbEditorConvertStyleSizeToHtml ( size )
{
	return size.EndsWith( '%' ) ? size : parseInt( size, 10 ) ;
}

function sbEditorGetRealElement ( fakeElement )
{
	var e = sbEditorTempBin._Elements[ fakeElement.getAttribute('_sbrealelement') ] ;

	if ( fakeElement.getAttribute('_sbflash') || fakeElement.getAttribute('_sbmovie'))
	{
		if ( fakeElement.style.width.length > 0 )
				e.width = sbEditorConvertStyleSizeToHtml( fakeElement.style.width ) ;

		if ( fakeElement.style.height.length > 0 )
				e.height = sbEditorConvertStyleSizeToHtml( fakeElement.style.height ) ;
	}

	return e ;
}

// HR Processor.
if ( _isIE )
{
	sbEditorDocumentProcessor._AppendNew()._ProcessDocument = function( doc )
	{
		var aHRs = doc.getElementsByTagName( 'HR' ) ;
		var eHR ;
		var i = aHRs.length - 1 ;
		while ( i >= 0 && ( eHR = aHRs[i--] ) )
		{
			var newHR = sbEditorAreaDoc.createElement( 'hr' ) ;
			newHR.mergeAttributes( eHR, true ) ;
			sbEditorInsertAfterNode( eHR, newHR ) ;
			eHR.parentNode.removeChild( eHR ) ;
		}
	}
}

// Flash handler.
sbEditorEmbedAndObjectProcessor._AddCustomHandler( function( el, fakeImg )
{
	if ( ! ( el.nodeName.IEquals( 'embed' ) && ( el.type == 'application/x-shockwave-flash' || /\.swf($|#|\?)/i.test( el.src ) ) ) )
		return ;
		
	fakeImg.className = 'sb__Flash' ;
	fakeImg.setAttribute( '_sbflash', 'true', 0 );
} ) ;

// AVI handler.
sbEditorEmbedAndObjectProcessor._AddCustomHandler( function( el, fakeImg )
{
	if ( ! ( el.nodeName.IEquals( 'object' ) && ( ( el.getAttribute('classid') && el.getAttribute('classid').toLowerCase() == 'clsid:22d6f312-b0f6-11d0-94ab-0080c74c7e95' ) || /\.avi($|#|\?)/i.test( el.src ) ) ) ) 
		return ;
		
	fakeImg.className = 'sb__AVI' ;
	fakeImg.setAttribute( '_sbmovie', 'avi', 0 );
} ) ;

// MOV handler.
sbEditorEmbedAndObjectProcessor._AddCustomHandler( function( el, fakeImg )
{
	if ( ! ( el.nodeName.IEquals( 'object' ) && ( ( el.getAttribute('classid') && el.getAttribute('classid').toLowerCase() == 'clsid:02bf25d5-8c17-4b23-bc80-d3488abddc6b' ) || /\.mov($|#|\?)/i.test( el.src ) ) ) )
		return ;
		
	fakeImg.className = 'sb__MOV' ;
	fakeImg.setAttribute( '_sbmovie', 'mov', 0 );
} ) ;

// RM handler.
sbEditorEmbedAndObjectProcessor._AddCustomHandler( function( el, fakeImg )
{
	if ( ! ( el.nodeName.IEquals( 'object' ) && ( ( el.getAttribute('classid') && el.getAttribute('classid').toLowerCase() == 'clsid:cfcdaa03-8be4-11cf-b84b-0020afbbccfa' ) || /\.rm($|#|\?)/i.test( el.src ) ) ) )
		return ;
		
	fakeImg.className = 'sb__RM' ;
	fakeImg.setAttribute( '_sbmovie', 'rm', 0 );
} ) ;

if ( _isSafari )
{
	sbEditorDocumentProcessor._AppendNew()._ProcessDocument = function( doc )
	{
		var spans = doc.getElementsByClassName ?
			doc.getElementsByClassName( 'Apple-style-span' ) :
			Array.prototype.filter.call(
					doc.getElementsByTagName( 'span' ),
					function( item ){ return item.className == 'Apple-style-span' ; }
					) ;

		for ( var i = spans.length - 1 ; i >= 0 ; i-- )
			sbEditorRemoveNode( spans[i], true ) ;
	}
}

/////////////////////////////////////////////////////////

sbEditorProtectedSource = new Object() ;

sbEditorProtectedSource._CodeTag = (new Date()).valueOf() ;

sbEditorProtectedSource._RegexEntries = [
	/<!--[\s\S]*?-->/g ,
	/<script[\s\S]*?<\/script>/gi,
	/<noscript[\s\S]*?<\/noscript>/gi
] ;

sbEditorProtectedSource._Add = function( regexPattern )
{
	this._RegexEntries.AddItem( regexPattern ) ;
}

sbEditorProtectedSource._Protect = function( html )
{
	var codeTag = this._CodeTag ;
	function _Replace( protectedSource )
	{
		var index = sbEditorTempBin._AddElement( protectedSource ) ;
		return '<!--{' + codeTag + index + '}-->' ;
	}

	for ( var i = 0 ; i < this._RegexEntries.length ; i++ )
	{
		html = html.replace( this._RegexEntries[i], _Replace ) ;
	}

	return html ;
}

sbEditorProtectedSource._Revert = function( html, clearBin )
{
	function _Replace( m, opener, index )
	{
		var protectedValue = clearBin ? sbEditorTempBin._RemoveElement( index ) : sbEditorTempBin._Elements[ index ] ;
		return sbEditorProtectedSource._Revert( protectedValue, clearBin ) ;
	}

	var regex = new RegExp( "(<|&lt;)!--\\{" + this._CodeTag + "(\\d+)\\}--(>|&gt;)", "g" ) ;
	return html.replace( regex, _Replace ) ;
}
<?php require_once(dirname(__FILE__).'/../jfooter.inc.php'); ?>