<?php require_once(dirname(__FILE__).'/../jheader.inc.php'); ?>
var CTRL	= 10000 ;
var SHIFT	= 20000 ;
var ALT		= 40000 ;

var sbEditorKeystrokeHandler = function()
{
	this._Keystrokes = new Object() ;
	this._KeyDownCallerFunc = null;
	this._KeyPressCallerFunc = null;
}

var pt = sbEditorKeystrokeHandler.prototype;

pt._AttachToElement = function( target )
{
	this._KeyDownCallerFunc = new sbCallerFunction(this._OnKeyDown, this);
	sbAddEvent( target, 'keydown', this._KeyDownCallerFunc ) ;
	if ( _isOpera )
	{
	    this._KeyPressCallerFunc = new sbCallerFunction(this._OnKeyPress, this);
		sbAddEvent( target, 'keypress', this._KeyPressCallerFunc ) ;
	}
}

pt._DettachFromElement = function( target )
{
	sbRemoveEvent( target, 'keydown', this._KeyDownCallerFunc ) ;
	if ( _isOpera )
		sbRemoveEvent( target, 'keypress', this._KeyPressCallerFunc ) ;
}

pt._SetKeystrokes = function()
{
	for ( var i = 0 ; i < arguments.length ; i++ )
	{
		var keyDef = arguments[i] ;

		if ( !keyDef )
			continue ;

		if ( typeof( keyDef[0] ) == 'object' )
			this._SetKeystrokes.apply( this, keyDef ) ;
		else
		{
			if ( keyDef.length == 1 )
				delete this._Keystrokes[ keyDef[0] ] ;
			else			
				this._Keystrokes[ keyDef[0] ] = keyDef[1] === true ? true : keyDef ;
		}
	}
}

pt._OnKeyDown = function( obj, tmp, e )
{
	var keystroke = e.keyCode || e.which ;
	var keyModifiers = 0 ;

	if ( e.ctrlKey || e.metaKey )
		keyModifiers += CTRL ;

	if ( e.shiftKey )
		keyModifiers += SHIFT ;

	if ( e.altKey )
		keyModifiers += ALT ;

	var keyCombination = keystroke + keyModifiers ;

	var cancelIt = obj._CancelIt = false ;
	var keystrokeValue = obj._Keystrokes[ keyCombination ] ;

	if ( keystrokeValue )
	{
		if ( keystrokeValue === true || !( obj._OnKeystroke && obj._OnKeystroke.apply( obj, keystrokeValue ) ) )
			return true ;

		cancelIt = true ;
	}

	if ( cancelIt )
	{
		obj._CancelIt = true ;
		return sbCancelEvent(e);
	}

	return true ;
}

pt._OnKeyPress = function ( obj, tmp, e )
{
	if ( obj._CancelIt )
		return sbCancelEvent(e);

	return true ;
}

/////////////////////////////////////////////////////////////////////////

var sbEditorEnterKey = function( targetWindow, enterMode, shiftEnterMode, tabSpaces )
{
	this._Window = targetWindow ;
	this._EnterMode	= enterMode || 'p' ;
	this._ShiftEnterMode = shiftEnterMode || 'br' ;

	this.oKeystrokeHandler = new sbEditorKeystrokeHandler( false ) ;
	this.oKeystrokeHandler._EnterKey = this ;
	this.oKeystrokeHandler._OnKeystroke = sbEditorEnterKey_OnKeystroke ;

	this.oKeystrokeHandler._SetKeystrokes( [
		[ 13		, 'Enter' ],
		[ SHIFT + 13, 'ShiftEnter' ],
		[ 8			, 'Backspace' ],
		[ CTRL + 8	, 'CtrlBackspace' ],
		[ 46		, 'Delete' ],
		[ CTRL + 73, 'Italic' ],
		[ CTRL + 66, 'Bold' ],
		[ CTRL + 83, 'Save' ],
		[ CTRL + 70, 'Find' ],
		[ CTRL + 90, 'Undo' ],
		[ CTRL + 89, 'Redo' ],
		[ CTRL + 85, 'Underline' ],
		[ CTRL + 69, 'Center' ],
		[ CTRL + 74, 'Justify' ],
		[ CTRL + 82, 'Right' ],
		[ CTRL + 76, 'Left' ],
		[ CTRL + 107, 'Sub' ],
		[ CTRL + SHIFT + 107, 'Sup' ]
	] ) ;

	this._TabText = '' ;

	if ( tabSpaces > 0 || _isSafari )
	{
		while ( tabSpaces-- )
			this._TabText += '\xa0' ;

		this.oKeystrokeHandler._SetKeystrokes( [ 9, 'Tab' ] );
	}

	this.oKeystrokeHandler._AttachToElement( sbEditorArea ) ;
}


function sbEditorEnterKey_OnKeystroke(  keyCombination, keystrokeValue )
{
	var oEnterKey = this._EnterKey ;

	try
	{
		switch ( keystrokeValue )
		{
			case 'Enter' :
				return oEnterKey._DoEnter() ;
				break ;
			case 'ShiftEnter' :
				return oEnterKey._DoShiftEnter() ;
				break ;
			case 'Backspace' :
				return oEnterKey._DoBackspace() ;
				break ;
			case 'Delete' :
				return oEnterKey._DoDelete() ;
				break ;
			case 'Tab' :
				return oEnterKey._DoTab() ;
				break ;
			case 'CtrlBackspace' :
				return oEnterKey._DoCtrlBackspace() ;
				break ;
			case 'Bold' :
			    sbEditorCoreStyleAction(sbGetE("sbEditorBtnBold"), "Bold");
			    return true;
			    break;
			case 'Italic' :
			    sbEditorCoreStyleAction(sbGetE("sbEditorBtnItalic"), "Italic");
                return true;
                break;
            case 'Save' :
                sbEditorSaveAction(sbGetE("sbEditorBtnSave"));
                return true;
                break;
            case 'Find' :
                sbEditorFindAction(sbGetE("sbEditorBtnFind"));
                return true;
                break;
            case 'Undo' :
                sbEditorUndoAction(sbGetE("sbEditorBtnUndo"));
                return true;
                break;
            case 'Redo' :
                sbEditorRedoAction(sbGetE("sbEditorBtnRedo"));
                return true;
                break;
            case 'Underline' :
                sbEditorCoreStyleAction(sbGetE("sbEditorBtnUnderline"), "Underline");
                return true;
                break;
            case 'Center' :
                sbEditorJustifyAction(sbGetE("sbEditorBtnCenter"), "center");
                return true;
                break;
            case 'Justify' :
                sbEditorJustifyAction(sbGetE("sbEditorBtnJustify"), "justify");
                return true;
                break;
            case 'Right' :
                sbEditorJustifyAction(sbGetE("sbEditorBtnRight"), "right");
                return true;
                break;
            case 'Left' :
                sbEditorJustifyAction(sbGetE("sbEditorBtnLeft"), "left");
                return true;
                break;
            case 'Sub' :
                sbEditorCoreStyleAction(sbGetE("sbEditorBtnSub"), "Subscript");
                return true;
                break;
            case 'Sup' :
                sbEditorCoreStyleAction(sbGetE("sbEditorBtnSup"), "Superscript");
                return true;
                break;
		}
	}
	catch (e)
	{
	}

	return false ;
}

var pt = sbEditorEnterKey.prototype;
/*
 * <Enter>
 */
pt._DoEnter = function( mode, hasShift )
{
	sbEditorUndo._SaveUndoStep() ;

	this._HasShift = ( hasShift === true ) ;

	var parentElement = sbEditorSelection._GetParentElement() ;
	var parentPath = new sbEditorElementPath( parentElement ) ;
	var sMode = mode || this._EnterMode ;

	if ( sMode == 'br' || parentPath._Block && parentPath._Block.tagName.toLowerCase() == 'pre' )
	{
		return this._ExecuteEnterBr() ;
	}
	else
		return this._ExecuteEnterBlock( sMode ) ;
}

/*
 * <Shift>+<Enter>
 */
pt._DoShiftEnter = function()
{
	return this._DoEnter( this._ShiftEnterMode, true ) ;
}

/*
 * <Backspace>
 */
pt._DoBackspace = function()
{
	var bCustom = false ;

	var oRange = new sbEditorDomRange( this._Window ) ;
	oRange._MoveToSelection() ;

	if ( _isIE && this._CheckIsAllContentsIncluded( oRange, sbEditorArea ) )
	{
		this._FixIESelectAllBug( oRange ) ;
		return true ;
	}

	var isCollapsed = oRange._IsCollapsed() ;

	if ( !isCollapsed )
	{
		if ( _isIE && this._Window.document.selection.type.toLowerCase() == "control" )
		{
			var controls = this._Window.document.selection.createRange() ;
			for ( var i = controls.length - 1 ; i >= 0 ; i-- )
			{
				var el = controls.item( i ) ;
				el.parentNode.removeChild( el ) ;
			}
			return true ;
		}

		return false ;
	}

	if ( _isIE )
	{
		var previousElement = sbEditorGetPreviousSourceElement( oRange._StartNode, true ) ;

		if ( previousElement && previousElement.nodeName.toLowerCase() == 'br' )
		{
			var testRange = oRange._Clone() ;
			testRange.setStart( previousElement, 4 ) ;

			if ( testRange._IsEmpty() )
			{
				previousElement.parentNode.removeChild( previousElement ) ;
				return true ;
			}
		}
	}

	var oStartBlock = oRange._StartBlock ;
	var oEndBlock = oRange._EndBlock ;

	if ( oRange._StartBlockLimit == oRange._EndBlockLimit && oStartBlock && oEndBlock )
	{
		if ( !isCollapsed )
		{
			var bEndOfBlock = oRange._CheckEndOfBlock() ;
	
			oRange._DeleteContents() ;
	
			if ( oStartBlock != oEndBlock )
			{
				oRange.setStart(oEndBlock,1) ;
				oRange.setEnd(oEndBlock,1) ;
			}
	
			oRange._Select() ;
			if ( _isOpera )
				sbEditorArea.focus();
	
			bCustom = ( oStartBlock == oEndBlock ) ;
		}
		
		if ( oRange._CheckStartOfBlock() )
		{
			var oCurrentBlock = oRange._StartBlock ;
			var ePrevious = sbEditorGetPreviousSourceElement( oCurrentBlock, true, [ 'BODY', oRange._StartBlockLimit.nodeName ], ['UL','OL'] ) ;

			bCustom = this._ExecuteBackspace( oRange, ePrevious, oCurrentBlock ) ;
		}
		else if ( _isFF )
		{
			oRange._Select() ;
		}
	}

	oRange._Release() ;
	return bCustom ;
}

pt._DoCtrlBackspace = function()
{
	sbEditorUndo._SaveUndoStep() ;
	var oRange = new sbEditorDomRange( this._Window ) ;
	oRange._MoveToSelection() ;
	if ( _isIE && this._CheckIsAllContentsIncluded( oRange, sbEditorArea ) )
	{
		this._FixIESelectAllBug( oRange ) ;
		return true ;
	}
	return false ;
}

pt._ExecuteBackspace = function( range, previous, currentBlock )
{
	var bCustom = false ;

	if ( !previous && currentBlock && currentBlock.nodeName.IEquals( 'LI' ) && currentBlock.parentNode.parentNode.nodeName.IEquals( 'LI' ) )
	{
		this._OutdentWithSelection( currentBlock, range ) ;
		return true ;
	}

	if ( previous && previous.nodeName.IEquals( 'LI' ) )
	{
		var oNestedList = sbEditorGetLastChild( previous, ['UL','OL'] ) ;

		while ( oNestedList )
		{
			previous = sbEditorGetLastChild( oNestedList, 'LI' ) ;
			oNestedList = sbEditorGetLastChild( previous, ['UL','OL'] ) ;
		}
	}

	if ( previous && currentBlock )
	{
		if ( currentBlock.nodeName.IEquals( 'LI' ) && !previous.nodeName.IEquals( 'LI' ) )
		{
			this._OutdentWithSelection( currentBlock, range ) ;
			return true ;
		}

		var oCurrentParent = currentBlock.parentNode ;

		var sPreviousName = previous.nodeName.toLowerCase() ;
		if ( sbEditorListsLib.EmptyElements[ sPreviousName ] != null || sPreviousName == 'table' )
		{
			sbEditorRemoveNode( previous ) ;
			bCustom = true ;
		}
		else
		{
			sbEditorRemoveNode( currentBlock ) ;

			while ( oCurrentParent.innerHTML.Trim().length == 0 )
			{
				var oParent = oCurrentParent.parentNode ;
				oParent.removeChild( oCurrentParent ) ;
				oCurrentParent = oParent ;
			}

			sbEditorLTrimNode( currentBlock ) ;
			sbEditorRTrimNode( previous ) ;

			range.setStart( previous, 2, true ) ;
			range._Collapse( true ) ;
			var oBookmark = range._CreateBookmark( true ) ;

			if ( ! currentBlock.tagName.IEquals( [ 'TABLE' ] ) )
				sbEditorMoveChildren( currentBlock, previous ) ;

			range._SelectBookmark( oBookmark ) ;
			if ( _isOpera )
				sbEditorArea.focus();
				
			bCustom = true ;
		}
	}

	return bCustom ;
}

/*
 * <Delete>
 */
pt._DoDelete = function()
{
	sbEditorUndo._SaveUndoStep() ;

	var bCustom = false ;

	var oRange = new sbEditorDomRange( this._Window ) ;
	oRange._MoveToSelection() ;

	if ( _isIE && this._CheckIsAllContentsIncluded( oRange, sbEditorArea ) )
	{
		this._FixIESelectAllBug( oRange ) ;
		return true ;
	}

	if ( oRange._IsCollapsed() && oRange._CheckEndOfBlock( !_isIE ) )
	{
		var oCurrentBlock = oRange._StartBlock ;
		var eCurrentCell = sbEditorGetElementAscensor( oCurrentBlock, 'td' );

		var eNext = sbEditorGetNextSourceElement( oCurrentBlock, true, [ oRange._StartBlockLimit.nodeName ],
				['UL','OL','TR'], true ) ;

		if ( eCurrentCell )
		{
			var eNextCell = sbEditorGetElementAscensor( eNext, 'td' );
			if ( eNextCell != eCurrentCell )
				return true ;
		}

		bCustom = this._ExecuteBackspace( oRange, oCurrentBlock, eNext ) ;
	}

	oRange._Release() ;
	return bCustom ;
}

/*
 * <Tab>
 */
pt._DoTab = function()
{
	var oRange = new sbEditorDomRange( this._Window );
	oRange._MoveToSelection() ;

	var node = oRange._Range.startContainer ;
	while ( node )
	{
		if ( node.nodeType == 1 )
		{
			var tagName = node.tagName.toLowerCase() ;
			if ( tagName == "tr" || tagName == "td" || tagName == "th" || tagName == "tbody" || tagName == "table" )
				return false ;
			else
				break ;
		}
		node = node.parentNode ;
	}

	if ( this._TabText )
	{
		oRange._DeleteContents() ;
		oRange._InsertNode( this._Window.document.createTextNode( this._TabText ) ) ;
		oRange._Collapse( false ) ;
		oRange._Select() ;
		if ( _isOpera )
			sbEditorArea.focus();
	}
	return true ;
}

pt._ExecuteEnterBlock = function( blockTag, range )
{
	var oRange = range || new sbEditorDomRange( this._Window ) ;
	var oSplitInfo = oRange._SplitBlock( blockTag ) ;
	if ( oSplitInfo )
	{
		var ePreviousBlock = oSplitInfo._PreviousBlock ;
		var eNextBlock = oSplitInfo._NextBlock ;

		var bIsStartOfBlock	= oSplitInfo._WasStartOfBlock ;
		var bIsEndOfBlock = oSplitInfo._WasEndOfBlock ;

		if ( eNextBlock )
		{
			if ( eNextBlock.parentNode.nodeName.IEquals( 'li' ) )
			{
				sbEditorBreakParent( eNextBlock, eNextBlock.parentNode ) ;
				sbEditorMoveNode( eNextBlock, eNextBlock.nextSibling, true ) ;
			}
		}
		else if ( ePreviousBlock && ePreviousBlock.parentNode.nodeName.IEquals( 'li' ) )
		{
			sbEditorBreakParent( ePreviousBlock, ePreviousBlock.parentNode ) ;
			oRange._MoveToElementEditStart( ePreviousBlock.nextSibling );
			sbEditorMoveNode( ePreviousBlock, ePreviousBlock.previousSibling ) ;
		}

		if ( !bIsStartOfBlock && !bIsEndOfBlock )
		{
			if ( eNextBlock.nodeName.IEquals( 'li' ) && eNextBlock.firstChild
				 && eNextBlock.firstChild.nodeName.IEquals( ['ul', 'ol'] ) )
				eNextBlock.insertBefore( sbGetElementDocument( eNextBlock ).createTextNode( '\xa0' ), eNextBlock.firstChild ) ;
			if ( eNextBlock )
				oRange._MoveToElementEditStart( eNextBlock ) ;
		}
		else
		{
			if ( bIsStartOfBlock && bIsEndOfBlock && ePreviousBlock.tagName.toUpperCase() == 'LI' )
			{
				oRange._MoveToElementStart( ePreviousBlock ) ;
				this._OutdentWithSelection( ePreviousBlock, oRange ) ;
				oRange._Release() ;
				return true ;
			}

			var eNewBlock ;

			if ( ePreviousBlock )
			{
				var sPreviousBlockTag = ePreviousBlock.tagName.toUpperCase() ;

				if ( !this._HasShift && !(/^H[1-6]$/).test( sPreviousBlockTag ) )
				{
					eNewBlock = sbEditorCloneElement( ePreviousBlock ) ;
				}
			}
			else if ( eNextBlock )
				eNewBlock = sbEditorCloneElement( eNextBlock ) ;

			if ( !eNewBlock )
				eNewBlock = this._Window.document.createElement( blockTag ) ;

			var elementPath = oSplitInfo._ElementPath ;
			if ( elementPath )
			{
				for ( var i = 0, len = elementPath._Elements.length ; i < len ; i++ )
				{
					var element = elementPath._Elements[i] ;

					if ( element == elementPath._Block || element == elementPath._BlockLimit )
						break ;

					if ( sbEditorListsLib.InlineChildReqElements[ element.nodeName.toLowerCase() ] )
					{
						element = sbEditorCloneElement( element ) ;
						sbEditorMoveChildren( eNewBlock, element ) ;
						eNewBlock.appendChild( element ) ;
					}
				}
			}

			if ( !_isIE )
				sbEditorAppendBogusBr( eNewBlock ) ;

			oRange._InsertNode( eNewBlock ) ;

			if ( _isIE )
			{
				oRange._MoveToElementEditStart( eNewBlock ) ;
				oRange._Select() ;
			}
			
			oRange._MoveToElementEditStart( bIsStartOfBlock && !bIsEndOfBlock ? eNextBlock : eNewBlock ) ;
		}

		if ( !_isIE )
			sbEditorScrollIntoView( eNextBlock || eNewBlock, false ) ;

		oRange._Select() ;
			
		if ( _isOpera )
			sbEditorArea.focus();
	}

	oRange._Release() ;

	return true ;
}

pt._ExecuteEnterBr = function( blockTag )
{
	var oRange = new sbEditorDomRange( this._Window ) ;
	oRange._MoveToSelection() ;

	if ( oRange._StartBlockLimit == oRange._EndBlockLimit )
	{
	
		oRange._DeleteContents() ;
		oRange._MoveToSelection() ;

		var bIsStartOfBlock	= oRange._CheckStartOfBlock() ;
		var bIsEndOfBlock	= oRange._CheckEndOfBlock() ;

		var sStartBlockTag = oRange._StartBlock ? oRange._StartBlock.tagName.toUpperCase() : '' ;

		var bHasShift = this._HasShift ;
		var bIsPre = false ;

		if ( !bHasShift && sStartBlockTag == 'LI' )
			return this._ExecuteEnterBlock( null, oRange ) ;

		if ( !bHasShift && bIsEndOfBlock && (/^H[1-6]$/).test( sStartBlockTag ) )
		{
			sbEditorInsertAfterNode( oRange._StartBlock, this._Window.document.createElement( 'br' ) ) ;

			if ( _isFF )
				sbEditorInsertAfterNode( oRange._StartBlock, this._Window.document.createTextNode( '' ) ) ;

			oRange.setStart( oRange._StartBlock.nextSibling, _isIE ? 3 : 1 ) ;
		}
		else
		{
			var eLineBreak ;
			
			bIsPre = sStartBlockTag.IEquals( 'pre' ) ;
			if ( bIsPre )
				eLineBreak = this._Window.document.createTextNode( _isIE ? '\r' : '\n' ) ;
			else
				eLineBreak = this._Window.document.createElement( 'br' ) ;

			oRange._InsertNode( eLineBreak ) ;

			if ( _isFF )
				sbEditorInsertAfterNode( eLineBreak, this._Window.document.createTextNode( '' ) ) ;

			if ( bIsEndOfBlock && !_isIE )
				sbEditorAppendBogusBr( eLineBreak.parentNode ) ;

			if ( _isIE )
				oRange.setStart( eLineBreak, 4 ) ;
			else
				oRange.setStart( eLineBreak.nextSibling, 1 ) ;

			if ( ! _isIE )
			{
				var dummy = null ;
				if ( _isOpera )
					dummy = this._Window.document.createElement( 'span' ) ;
				else
					dummy = this._Window.document.createElement( 'br' ) ;

				eLineBreak.parentNode.insertBefore( dummy, eLineBreak.nextSibling ) ;

				sbEditorScrollIntoView( dummy, false ) ;

				dummy.parentNode.removeChild( dummy ) ;
			}
		}

		oRange._Collapse( true ) ;
		oRange._Select( bIsPre ) ;
	}

	oRange._Release() ;

	return true ;
}

pt._OutdentWithSelection = function( li, range )
{
	var oBookmark = range._CreateBookmark() ;

	sbEditorListHandler._OutdentListItem( li ) ;

	range._MoveToBookmark( oBookmark ) ;
	range._Select() ;
}

pt._CheckIsAllContentsIncluded = function( range, node )
{
	var startOk = false ;
	var endOk = false ;

	if ( range._StartContainer == node || range._StartContainer == node.firstChild )
		startOk = ( range._Range.startOffset == 0 ) ;

	if ( range._EndContainer == node || range._EndContainer == node.lastChild )
	{
		var nodeLength = range._EndContainer.nodeType == 3 ? range._EndContainer.length : range._EndContainer.childNodes.length ;
		endOk = ( range._Range.endOffset == nodeLength ) ;
	}

	return startOk && endOk ;
}

pt._FixIESelectAllBug = function( range )
{
	sbEditorArea.innerHTML = '' ;
	var editBlock ;
	if ( SB_EDITOR_EDIT_MODE.IEquals( ['div', 'p'] ) )
	{
		editBlock = sbEditorAreaDoc.createElement( SB_EDITOR_EDIT_MODE ) ;
		sbEditorArea.appendChild( editBlock ) ;
	}
	else
		editBlock = sbEditorArea ;

	range._MoveToNodeContents( editBlock ) ;
	range._Collapse( true ) ;
	range._Select() ;
	range._Release() ;
}

///////////////////////////////////////////////////////////////////

var sbEditorListHandler =
{
	_OutdentListItem : function( listItem )
	{
		var eParent = listItem.parentNode ;

		if ( eParent.tagName.toUpperCase().Equals( 'UL','OL' ) )
		{
			var oDocument = sbGetElementDocument( listItem ) ;
			var oDogFrag = new sbEditorDocumentFragment( oDocument ) ;

			var eNextSiblings = oDogFrag._RootNode ;
			var eHasLiSibling = false ;
			var eChildList = sbEditorGetFirstChild( listItem, ['UL','OL'] ) ;
			if ( eChildList )
			{
				eHasLiSibling = true ;

				var eChild ;
				while ( (eChild = eChildList.firstChild) )
					eNextSiblings.appendChild( eChildList.removeChild( eChild ) ) ;

				sbEditorRemoveNode( eChildList ) ;
			}

			var eSibling ;
			var eHasSuccessiveLiSibling = false ;
			while ( (eSibling = listItem.nextSibling) )
			{
				if ( !eHasLiSibling && eSibling.nodeType == 1 && eSibling.nodeName.toUpperCase() == 'LI' )
					eHasSuccessiveLiSibling = eHasLiSibling = true ;

				eNextSiblings.appendChild( eSibling.parentNode.removeChild( eSibling ) ) ;

				if ( !eHasSuccessiveLiSibling && eSibling.nodeType == 1 && eSibling.nodeName.toUpperCase().Equals( 'UL','OL' ) )
					sbEditorRemoveNode( eSibling, true ) ;
			}

			var sParentParentTag = eParent.parentNode.tagName.toUpperCase() ;
			var bWellNested = ( sParentParentTag == 'LI' ) ;
			if ( bWellNested || sParentParentTag.Equals( 'UL','OL' ) )
			{
				if ( eHasLiSibling )
				{
					var eChildList = eParent.cloneNode( false ) ;
					oDogFrag._AppendTo( eChildList ) ;
					listItem.appendChild( eChildList ) ;
				}
				else if ( bWellNested )
					oDogFrag._InsertAfterNode( eParent.parentNode ) ;
				else
					oDogFrag._InsertAfterNode( eParent ) ;

				if ( bWellNested )
					sbEditorInsertAfterNode( eParent.parentNode, eParent.removeChild( listItem ) ) ;
				else
					sbEditorInsertAfterNode( eParent, eParent.removeChild( listItem ) ) ;
			}
			else
			{
				if ( eHasLiSibling )
				{
					var eNextList = eParent.cloneNode( false ) ;
					oDogFrag._AppendTo( eNextList ) ;
					sbEditorInsertAfterNode( eParent, eNextList ) ;
				}

				var eBlock = oDocument.createElement( SB_EDITOR_ENTER_MODE == 'p' ? 'p' : 'div' ) ;
				sbEditorMoveChildren( eParent.removeChild( listItem ), eBlock ) ;
				sbEditorInsertAfterNode( eParent, eBlock ) ;

				if ( SB_EDITOR_ENTER_MODE == 'br' )
				{
					if ( _isFF )
						eBlock.parentNode.insertBefore( sbEditorCreateBogusBR( oDocument ), eBlock ) ;
					else
						sbEditorInsertAfterNode( eBlock, sbEditorCreateBogusBR( oDocument ) ) ;

					sbEditorRemoveNode( eBlock, true ) ;
				}
			}

			if ( this._CheckEmptyList( eParent ) )
				sbEditorRemoveNode( eParent, true ) ;
		}
	},

	_CheckEmptyList : function( listElement )
	{
		return ( sbEditorGetFirstChild( listElement, 'LI' ) == null ) ;
	},

	_CheckListHasContents : function( listElement )
	{
		var eChildNode = listElement.firstChild ;

		while ( eChildNode )
		{
			switch ( eChildNode.nodeType )
			{
				case 1 :
					if ( !eChildNode.nodeName.IEquals( 'UL','LI' ) )
						return true ;
					break ;

				case 3 :
					if ( eChildNode.nodeValue.Trim().length > 0 )
						return true ;
			}

			eChildNode = eChildNode.nextSibling ;
		}

		return false ;
	}
} ;
<?php require_once(dirname(__FILE__).'/../jfooter.inc.php'); ?>