<?php require_once(dirname(__FILE__).'/../jheader.inc.php'); ?>
var sbEditorTableHandler = new Object() ;

sbEditorTableHandler._GetSelectedCells = function()
{
	var aCells = new Array() ;
	
	if (_isIE)
	{
		if ( sbEditorSelection._GetType() == 'Control' )
		{
			var td = sbEditorSelection._MoveToAncestorNode( 'TD' ) || sbEditorSelection._MoveToAncestorNode( 'TH' ) ;
			return td ? [ td ] : [] ;
		}

		var oRange = sbEditorSelection._GetSelection().createRange() ;
		var oParent = sbEditorSelection._GetParentElement() ;
	
		if ( oParent && oParent.tagName.Equals( 'TD', 'TH' ) )
			aCells[0] = oParent ;
		else
		{
			oParent = sbEditorSelection._MoveToAncestorNode( 'TABLE' ) ;
	
			if ( oParent )
			{
				for ( var i = 0 ; i < oParent.cells.length ; i++ )
				{
					var oCellRange = sbEditorAreaDoc.body.createTextRange() ;
					oCellRange.moveToElementText( oParent.cells[i] ) ;
	
					if ( oRange.inRange( oCellRange )
						|| ( oRange.compareEndPoints('StartToStart', oCellRange) >= 0 &&  oRange.compareEndPoints('StartToEnd', oCellRange) <= 0 )
						|| ( oRange.compareEndPoints('EndToStart',oCellRange) >= 0 &&  oRange.compareEndPoints('EndToEnd',oCellRange) <= 0 ) )
					{
						aCells[aCells.length] = oParent.cells[i] ;
					}
				}
			}
		}
	}
	else
	{
		var oSelection = sbEditorSelection._GetSelection() ;
	
		if ( oSelection.rangeCount == 1 && oSelection.anchorNode.nodeType == 3 )
		{
			var oParent = sbEditorGetElementAscensor( oSelection.anchorNode, 'TD,TH' ) ;
			
			if ( oParent )
				aCells[0] = oParent ;

			return aCells ;
		}
	
		for ( var i = 0 ; i < oSelection.rangeCount ; i++ )
		{
			var oRange = oSelection.getRangeAt(i) ;
			var oCell ;
			if ( oRange.startContainer.tagName.Equals( 'TD', 'TH' ) )
				oCell = oRange.startContainer ;
			else
				oCell = oRange.startContainer.childNodes[ oRange.startOffset ] ;
	
			if ( oCell && oCell.tagName)
			{
				if ( oCell.tagName.Equals( 'TD', 'TH' ) )
					aCells[aCells.length] = oCell ;
				else
				{
					oCell = sbEditorGetElementAscensor( oCell, 'TD,TH' ) ;
					if ( oCell )
						aCells[aCells.length] = oCell ;
				}
			}
		}
	}
	
	return aCells ;
}

sbEditorTableHandler._MarkCells = function( cells, label )
{
	for ( var i = 0 ; i < cells.length ; i++ )
		cells[i][label] = true ;
}

sbEditorTableHandler._UnmarkCells = function( cells, label )
{
	for ( var i = 0 ; i < cells.length ; i++ )
	{
		if ( _isIE )
			cells[i].removeAttribute( label ) ;
		else
			delete cells[i][label] ;
	}
}

sbEditorTableHandler._CreateTableMap = function( table )
{
	var aRows = table.rows ;
	var r = -1 ;

	var aMap = [] ;

	for ( var i = 0 ; i < aRows.length ; i++ )
	{
		r++ ;
		if ( !aMap[r] )
			aMap[r] = [] ;

		var c = -1 ;

		for ( var j = 0 ; j < aRows[i].cells.length ; j++ )
		{
			var oCell = aRows[i].cells[j] ;

			c++ ;
			while ( aMap[r][c] )
				c++ ;

			var iColSpan = isNaN( oCell.colSpan ) ? 1 : oCell.colSpan ;
			var iRowSpan = isNaN( oCell.rowSpan ) ? 1 : oCell.rowSpan ;

			for ( var rs = 0 ; rs < iRowSpan ; rs++ )
			{
				if ( !aMap[r + rs] )
					aMap[r + rs] = [] ;

				for ( var cs = 0 ; cs < iColSpan ; cs++ )
				{
					aMap[r + rs][c + cs] = aRows[i].cells[j] ;
				}
			}

			c += iColSpan - 1 ;
		}
	}
	return aMap ;
}

sbEditorTableHandler._InstallTableMap = function( tableMap, table )
{
	var rowSpanAttr = _isIE ? "_sbrowspan" : "rowSpan" ;

	while ( table.rows.length > 0 )
	{
		var row = table.rows[0] ;
		row.parentNode.removeChild( row ) ;
	}

	for ( var i = 0 ; i < tableMap.length ; i++ )
	{
		for ( var j = 0 ; j < tableMap[i].length ; j++ )
		{
			var cell = tableMap[i][j] ;
			cell.colSpan = cell[rowSpanAttr] = 1 ;
		}
	}

	var colsToDelete = [];
	for ( var j = 1 ; j < tableMap[0].length - 1 ; j++ )
	{
		var found = true;
		for ( var i = 0 ; i < tableMap.length ; i++ )
		{
			var cell = tableMap[i][j] ;
			if ( ! cell)
				continue ;

			if ( tableMap[i][j-1] != cell && tableMap[i][j+1] != cell )
			{
				found = false;
				break;
			} 
		}
		
		if ( found )
		{
			colsToDelete[ j ] = true;
			for ( var i = 0 ; i < tableMap.length ; i++ )
				tableMap[i][j] = null;
		}
	}
	
	var rowsToDelete = [];
	for ( var i = 1 ; i < tableMap.length - 1 ; i++ )
	{
		var found = true;
		for ( var j = 0 ; j < tableMap[i].length ; j++ )
		{
			var cell = tableMap[i][j] ;
			if ( ! cell)
				continue ;

			if ( tableMap[i + 1][j] != cell && tableMap[i - 1][j] != cell )
			{
				found = false;
				break;
			} 
		}
		
		if ( found )
		{
			rowsToDelete[ i ] = true ;
			for ( var j = 0 ; j < tableMap[i].length ; j++ )
				tableMap[i][j] = null;
		}
	}
	
	var newTableMap = [];
	var ni = 0;
	for ( var i = 0 ; i < tableMap.length ; i++ )
	{
		if ( rowsToDelete[i] === true)
			continue;
		
		newTableMap[ni] = [];
			
		var nj = 0 ; 
		for ( var j = 0 ; j < tableMap[i].length ; j++ )
		{
			if (colsToDelete[j] === true)
				continue;
			
			newTableMap[ni][nj] = tableMap[i][j];	
			nj++;
		}
		
		ni++;
	}
	tableMap = newTableMap;
	
	for ( var i = 0 ; i < tableMap.length ; i++ )
	{
		for ( var j = 0 ; j < tableMap[i].length ; j++ )
		{
			var cell = tableMap[i][j] ;
			if ( ! cell || cell._colScanned === true )
				continue ;
				
			if ( tableMap[i][j-1] == cell )
				cell.colSpan++ ;
			if ( tableMap[i][j+1] != cell )
				cell._colScanned = true ;
		}
	}

	for ( var i = 0 ; i <= tableMap[0].length ; i++ )
	{
		for ( var j = 0 ; j < tableMap.length ; j++ )
		{
			var cell = tableMap[j][i] ;
			if ( ! cell || cell._rowScanned === true )
				continue ;
				
			if ( tableMap[j-1] && tableMap[j-1][i] == cell )
				cell[rowSpanAttr]++ ;
			if ( ! tableMap[j+1] || tableMap[j+1][i] != cell )
				cell._rowScanned = true ;
		}
	}

	for ( var i = 0 ; i < tableMap.length ; i++ )
	{
		for ( var j = 0 ; j < tableMap[i].length ; j++)
		{
			var cell = tableMap[i][j] ;
			if ( !cell )
				continue;
				
			if ( _isIE )
			{
				cell.removeAttribute( '_colScanned' ) ;
				cell.removeAttribute( '_rowScanned' ) ;
			}
			else
			{
				delete cell._colScanned ;
				delete cell._rowScanned ;
			}
		}
	}

	for ( var i = 0 ; i < tableMap.length ; i++ )
	{
		var rowObj = null;
		
		for ( var j = 0 ; j < tableMap[i].length ; )
		{
			var cell = tableMap[i][j] ;
			if ( !cell )
			{
				j++;
				continue;
			}
				
			if ( cell._cellScanned === true )
			{
				j += cell.colSpan ;
				continue ;
			}
			
			if ( !rowObj )
				rowObj = sbGetElementDocument( table ).createElement( 'tr' ) ;
				
			rowObj.appendChild( cell ) ;
			j += cell.colSpan ? cell.colSpan : 1 ;
			if ( cell.colSpan == 1 )
				cell.removeAttribute( 'colSpan' ) ;
			if ( cell.rowSpan == 1 )
				cell.removeAttribute( 'rowSpan' ) ;
				
			cell._cellScanned = true ;
		}
		
		if ( rowObj )
			table.appendChild( rowObj ) ;
	}
	
	for ( var i = 0; i < table.rows.length; i++ )
	{
		for (var j = 0; j < table.rows[i].cells.length; j++)
		{
			var oCell = table.rows[i].cells[j];
			if ( _isIE )
			{
				var rowspan = oCell.getAttribute("_sbrowspan");
				if (rowspan)
				{
					oCell.setAttribute("rowSpan", rowspan);
					oCell.removeAttribute("_sbrowspan");
				}
				
				oCell.removeAttribute( '_cellScanned' ) ;
			}
			else
			{
				delete oCell._cellScanned ;
			}
		}
	}
	
	/*var tm = this._CreateTableMap( table );	
	for ( var i = 0 ; i < tm.length ; i++ )
	{
		var allRowspan = true;
		var minRowspan = 1000000;
		var maxRow = -1;
		for ( var j = 0 ; j < tm[ i ].length ; j++ )
		{
			if ( !tm[ i ][ j ] )
				continue;
				
			if ( tm[ i ][ j ].rowSpan <= 1 )
			{
				allRowspan = false;
				break;
			}
			
			if ( tm[ i ][ j ].rowSpan < minRowspan )
				minRowspan = tm[ i ][ j ].rowSpan;
			
			if ( tm[ i ][ j ].parentNode.rowIndex > maxRow )
				maxRow = tm[ i ][ j ].parentNode.rowIndex;	
		}
		
		if ( allRowspan && maxRow != -1 )
		{
			if ( table.rows[ maxRow ].nextSibling && maxRow != 0)
			{
		    	this._DeleteRows( table.rows[ maxRow ] );
		    	tm = this._CreateTableMap( table );
		    }
		    else
		    {
		    	for ( var j = 0 ; j < tm[ i ].length ; j++ )
				{
					if ( !tm[ i ][ j ] || tm[ i ][ j ]._rowScanned )
						continue;
					var newRowspan = tm[ i ][ j ].rowSpan - minRowspan + 1;
					if (newRowspan > 1)
						tm[ i ][ j ].rowSpan = newRowspan;
					else
						tm[ i ][ j ].removeAttribute("rowSpan");
						
					tm[ i ][ j ]._rowScanned = true;
				}
				
				for ( var j = 0 ; j < tm[ i ].length ; j++ )
				{
					if ( !tm[ i ][ j ] )
						continue;
						
					if ( _isIE )
						tm[ i ][ j ].removeAttribute( '_rowScanned' ) ;
					else
						delete tm[ i ][ j ]._rowScanned ;
				}
			}
		}
	}
	
	for ( var j = 0 ; j < tm[0].length ; j++ )
	{
		var allColspan = true;
		var minColspan = 1000000;
		for ( var i = 0 ; i < tm.length ; i++ )
		{
			if ( !tm[ i ][ j ] )
				continue;
				 
			if ( tm[ i ][ j ].colSpan <= 1 )
			{
				allColspan = false;
				break;
			}
			
			if ( tm[ i ][ j ].colSpan < minColspan )
				minColspan = tm[ i ][ j ].colSpan; 
		}
		
		if ( allColspan )
		{
			for ( var i = 0 ; i < tm.length ; i++ )
			{
				if ( !tm[ i ][ j ] || tm[ i ][ j ]._colScanned )
					continue;
					
				var newColspan = tm[ i ][ j ].colSpan - minColspan + 1;
				if (newColspan > 1)
					tm[ i ][ j ].colSpan = newColspan;
				else
					tm[ i ][ j ].removeAttribute("colSpan");
					
				tm[ i ][ j ]._colScanned = true;
			}
			
			for ( var i = 0 ; i < tm.length ; i++ )
			{
				if ( !tm[ i ][ j ] )
					continue;
				
				if ( _isIE )
					tm[ i ][ j ].removeAttribute( '_colScanned' ) ;
				else
					delete tm[ i ][ j ]._colScanned ;
			}
		}
	}*/
}

sbEditorTableHandler._GetCellIndexSpan = function( tableMap, rowIndex, cell )
{
	if ( tableMap.length < rowIndex + 1 )
		return null ;

	var oRow = tableMap[ rowIndex ] ;

	for ( var c = 0 ; c < oRow.length ; c++ )
	{
		if ( oRow[c] == cell )
			return c ;
	}

	return null ;
}

sbEditorTableHandler._GetMarkerGeometry = function( tableMap, rowIdx, colIdx, markerName )
{
	var selectionWidth = 0 ;
	var selectionHeight = 0 ;
	var cellsLeft = 0 ;
	var cellsUp = 0 ;
	
	for ( var i = colIdx ; tableMap[rowIdx][i] && tableMap[rowIdx][i][markerName] ; i++ )
		selectionWidth++ ;
	for ( var i = colIdx - 1 ; tableMap[rowIdx][i] && tableMap[rowIdx][i][markerName] ; i-- )
	{
		selectionWidth++ ;
		cellsLeft++ ;
	}
	for ( var i = rowIdx ; tableMap[i] && tableMap[i][colIdx] && tableMap[i][colIdx][markerName] ; i++ )
		selectionHeight++ ;
	for ( var i = rowIdx - 1 ; tableMap[i] && tableMap[i][colIdx] && tableMap[i][colIdx][markerName] ; i-- )
	{
		selectionHeight++ ;
		cellsUp++ ;
	}
	
	return { 'width' : selectionWidth, 'height' : selectionHeight, 'x' : cellsLeft, 'y' : cellsUp } ;
}

sbEditorTableHandler._CheckIsSelectionRectangular = function()
{
	var cells = sbEditorTableHandler._GetSelectedCells() ;
	if ( cells.length < 1 )
		return false ;

	this._MarkCells( cells, '_CellSelected' ) ;

	var tableMap = this._CreateTableMap( cells[0].parentNode.parentNode ) ;
	var firstCol = 1000000;
	var lastCol = -1;
	var firstRow = -1;
	var lastRow = -1;
	
	for (var i = 0; i < tableMap.length; i++)
	{
		for (var j = 0; j < tableMap[i].length; j++)
		{
			if ( tableMap[i][j]['_CellSelected'] )
			{
				if (j < firstCol)
					firstCol = j;
					
				if (firstRow == -1)
					firstRow = i;
					
				if (j > lastCol)
					lastCol = j;
					
				if (i > lastRow)
					lastRow = i;
			}
		}
	}
	
	for (var i = firstRow; i <= lastRow; i++)
	{
		for (var j = firstCol; j <= lastCol; j++)
		{
			if ( !tableMap[i][j]['_CellSelected'] )
			{
				this._UnmarkCells( cells, '_CellSelected' ) ;
				return false;
			} 
		}
	}
	
	this._UnmarkCells( cells, '_CellSelected' ) ;
	return true ;
}

sbEditorTableHandler._DeleteTable = function( table )
{
	if ( !table )
	{
		table = sbEditorSelection._GetSelectedElement() ;
		if ( !table || table.tagName != 'TABLE' )
			table = sbEditorSelection._MoveToAncestorNode( 'TABLE' ) ;
	}
	if ( !table ) return ;

	sbEditorSelection._SelectNode( table ) ;
	sbEditorSelection._Collapse();

	if ( table.parentNode.childNodes.length == 1 )
		table.parentNode.parentNode.removeChild( table.parentNode );
	else
		table.parentNode.removeChild( table ) ;
}

sbEditorTableHandler._DeleteRows = function( row )
{
	if ( ! row )
	{
		var aCells = this._GetSelectedCells() ;
		var aRowsToDelete = new Array() ;
		for ( var i = 0; i < aCells.length; i++ )
		{
			var oRow = sbEditorGetElementAscensor( aCells[i], 'TR' ) ;
			aRowsToDelete[oRow.rowIndex] = oRow ;
		}
		for ( var i = aRowsToDelete.length - 1; i >= 0; i-- )
		{
			if ( aRowsToDelete[i] )
				this._DeleteRows( aRowsToDelete[i] );
		}
		return ;
	}

	var oTable = sbEditorGetElementAscensor( row, 'TABLE' ) ;

	if ( oTable.rows.length == 1 )
	{
		this._DeleteTable( oTable ) ;
		return ;
	}

	var tm = this._CreateTableMap( oTable );
	var allRowspan = true;
	for ( var i = 0; i < tm[ row.rowIndex ].length ; i++ )
	{    
	    var cell = tm[ row.rowIndex ][ i ];
		if (cell && ( cell.rowSpan <= 1 || ( row.rowIndex != 0 && cell == tm[ row.rowIndex - 1 ][ i ] ) ) )
		{
			allRowspan = false;
			break;
		}
	}

	if ( allRowspan )
	{
		for ( var i = 0; i < tm[ row.rowIndex ].length ; i++ )
		{    
		    var cell = tm[ row.rowIndex ][ i ];
				
			if ( cell && ! cell[ "_CellProcessed" ] )
			{
				if ( cell.rowSpan == 2 )
					cell.removeAttribute( "rowSpan" ) ;
				else		
					cell.rowSpan-- ;
					
				this._MarkCells( [ cell ], "_CellProcessed" );
			}
		}
	}
	else
	{
		var remove = true;
		for ( var i = 0; i < tm[ row.rowIndex ].length ; i++ )
		{    
		    var cell = tm[ row.rowIndex ][ i ];
				
			if ( cell && ! cell[ "_CellProcessed" ] )
			{
				if (cell.rowSpan > 1)
				{
					var addCell = false;
				    if ( row.rowIndex > 0 )
				    {
				    	if ( cell == tm[ row.rowIndex - 1 ][ i ] || ( row.cells.length == 1 && row.cells[0].colSpan == tm[ row.rowIndex ].length ) )
				    	{
							if ( cell.rowSpan == 2 )
								cell.removeAttribute( "rowSpan" ) ;
							else		
								cell.rowSpan-- ;
								
							if ( row.cells.length == 1 && row.cells[0].colSpan == tm[ row.rowIndex ].length )
								remove = false;
						}
						else
						{
							addCell = true;
						}
					}
					else
						addCell = true;

					if (addCell && row.rowIndex < tm.length - 1)
					{
						var newCell = cell.cloneNode( true );
						
						if ( !_isIE )
						{
							if ( newCell.rowSpan == 2 )
								newCell.removeAttribute( "rowSpan" ) ;
							else		
								newCell.rowSpan-- ;
						}
							
						var nextCell = null;
						for ( var j = i + 1; j < tm[ row.rowIndex + 1 ].length; j++ )
						{
							if ( tm[ row.rowIndex + 1 ][ j ] != cell && tm[ row.rowIndex + 1 ][ j ].parentNode.rowIndex == row.rowIndex + 1 )
							{
								nextCell = tm[ row.rowIndex + 1 ][ j ];
								break;
							} 
						}
						
						if ( !oTable.rows[ row.rowIndex + 1 ] )
						{
							var newRow = row.cloneNode( false );
							oTable.appendChild( newRow );
						}
						
						oTable.rows[ row.rowIndex + 1 ].insertBefore( newCell, nextCell );
						
						if ( _isIE )
							newCell.setAttribute("_sbrowspan", cell.rowSpan - 1) ;
					}
				}	
					
				this._MarkCells( [ cell ], "_CellProcessed" );
			}
		}

		if ( remove )
			row.parentNode.removeChild( row ) ;
	}
	
	for ( var i = 0; i < oTable.rows.length; i++ )
	{
		if ( _isIE )
		{
			for (var j = 0; j < oTable.rows[i].cells.length; j++)
			{
				var oCell = oTable.rows[i].cells[j];
				var rowspan = oCell.getAttribute("_sbrowspan");
				if (rowspan)
				{
					oCell.setAttribute("rowSpan", rowspan);
					oCell.removeAttribute("_sbrowspan");
				}
			}
		}
		
		this._UnmarkCells( oTable.rows[ i ].cells, "_CellProcessed" );
	}
}

sbEditorTableHandler._DeleteColumns = function( oCell )
{
	if ( !oCell  )
	{
		var aColsToDelete = this._GetSelectedCells();
		for ( var i = aColsToDelete.length - 1; i >= 0; i--  )
		{
			if ( aColsToDelete[i]  )
				this._DeleteColumns( aColsToDelete[i]  );
		}
		return;
	}

	if ( !oCell ) return ;

	var oTable = sbEditorGetElementAscensor( oCell, 'TABLE' ) ;
	var iIndex = oCell.cellIndex ;
	var tm = this._CreateTableMap(oTable);

	for ( var i = oTable.rows.length - 1 ; i >= 0 ; i-- )
	{
		var oRow = oTable.rows[i] ;
		var cell = tm[ i ][ iIndex ];
		
		if ( iIndex == 0 && oRow.cells.length == 1 && cell.colSpan <= 1 )
		{
			this._DeleteRows( oRow ) ;
			continue ;
		}
		
		if ( cell && ! cell[ "_CellProcessed" ] )
		{
			if (cell.colSpan > 1)
			{
				if ( cell.colSpan == 2 )
					cell.removeAttribute( "colSpan" ) ;
				else		
					cell.colSpan-- ;
			}
			else
			{	
				if (cell.rowSpan > 1)
				{
					i = i - cell.rowSpan + 1;
					oRow = oTable.rows[i] ;
				}
				oRow.removeChild( cell ) ;
			}
			
			this._MarkCells( [ cell ], "_CellProcessed" );
		}
	}
	
	for ( var i = 0; i < oTable.rows.length; i++ )
	{
		this._UnmarkCells( oTable.rows[ i ].cells, "_CellProcessed" );
	}
}
			
sbEditorTableHandler._InsertRow = function( insertBefore )
{
	var oCell = null ;
	var nodes = this._GetSelectedCells() ;

	if ( nodes && nodes.length )
		oCell = nodes[ insertBefore ? 0 : ( nodes.length - 1 ) ] ;

	if ( ! oCell )
		return ;
		
	var oRow = sbEditorGetElementAscensor( oCell, 'TR' ) ;
	var oTable = sbEditorGetElementAscensor( oCell, 'TABLE' ) ;
	
	var tm = this._CreateTableMap( oTable );
	var newRow = oRow.cloneNode( false ) ;
	var iIndex = oRow.rowIndex;
	var cellIndex = -1;
	
	for ( var i = 0; i < tm[ iIndex ].length; i++ )
	{
		if ( tm[ iIndex ][ i ] == oCell )
		{
			cellIndex = i;
			break;
		}
	}

	if ( !insertBefore )
	{
	    for ( var i = tm.length - 1; i >= iIndex; i-- )
	    {
	    	if ( tm[ i ][ cellIndex ] == oCell )
	    	{
	    		iIndex = i;
	    		break;
	    	}
	    }
	}

	for ( var i = 0; i < tm[ iIndex ].length; i++)
	{
		var oCell = tm[ iIndex ][ i ] ;
		if (oCell[ "_CellProcessed" ])
			continue;
			
		var addCell = true ;
		
		if ( insertBefore )
		{
			if ( oCell.rowSpan > 1 && iIndex > 0 && tm[ iIndex - 1 ][ i ] == oCell )
			{
				oCell.rowSpan++;
				addCell = false;
			}
		}
		else
		{
			if ( oCell.rowSpan > 1 && iIndex < tm.length - 1 && tm[ iIndex + 1 ][ i ] == oCell )
			{
				oCell.rowSpan++;
				addCell = false;
			}
		}

		if ( addCell )
		{
			var newCell = oCell.cloneNode( false );
			if ( !_isIE )
				sbEditorAppendBogusBr( newCell ) ;
			
			newCell.removeAttribute("rowSpan");	
			newRow.appendChild( newCell ) ;
		}
		
		this._MarkCells( [ oCell ], "_CellProcessed" );
	}
	
	if ( insertBefore )  
		oRow.parentNode.insertBefore( newRow, oRow ) ;
	else
		oRow.parentNode.insertBefore( newRow, ( iIndex + 1 < oTable.rows.length ? oTable.rows[ iIndex + 1 ] : null ) ) ;
	
	for ( var i = 0; i < oTable.rows.length; i++ )
	{
		this._UnmarkCells( oTable.rows[ i ].cells, "_CellProcessed" );
	}
}

sbEditorTableHandler._InsertColumn = function( insertBefore )
{
	var oCell = null ;
	var nodes = this._GetSelectedCells() ;

	if ( nodes && nodes.length )
		oCell = nodes[ insertBefore ? 0 : ( nodes.length - 1 ) ] ;

	if ( ! oCell )
		return ;

	var oTable = sbEditorGetElementAscensor( oCell, 'TABLE' ) ;
	var tm = this._CreateTableMap( oTable );
	var oRow = sbEditorGetElementAscensor( oCell, 'TR' ) ;
	var iIndex = -1;
	
	if ( insertBefore )
	{
		for ( var i = 0; i < tm[ oRow.rowIndex ].length; i++ )
		{
			if ( tm[ oRow.rowIndex ][ i ] == oCell )
			{
				iIndex = i ;
				break;
			}
		}
	}
	else
	{
		for ( var i = tm[ oRow.rowIndex ].length - 1; i >= 0 ; i-- )
		{
			if ( tm[ oRow.rowIndex ][ i ] == oCell )
			{
				iIndex = i ;
				break;
			}
		}
	}
	
	if ( iIndex == -1 ) 
		return;
		
	for ( var i = 0; i < tm.length; i++)
	{
		var oCell = tm[ i ][ iIndex ] ;
		var oRow = sbEditorGetElementAscensor( oCell, 'TR' ) ;
		if (oCell[ "_CellProcessed" ])
			continue;
			
		var addCell = true ;
		
		if ( insertBefore )
		{
			if ( oCell.colSpan > 1 && iIndex > 0 && tm[ i ][ iIndex - 1 ] == oCell )
			{
				oCell.colSpan++;
				addCell = false;
			}
		}
		else
		{
			if ( oCell.colSpan > 1 && iIndex < tm[ i ].length - 1 && tm[ i ][ iIndex + 1 ] == oCell )
			{
				oCell.colSpan++;
				addCell = false;
			}
		}

		if ( addCell )
		{
			var newCell = oCell.cloneNode( false );
			if ( !_isIE )
				sbEditorAppendBogusBr( newCell ) ;
			
			newCell.removeAttribute("colSpan");	
			
			if ( insertBefore )  
				oRow.insertBefore( newCell, oCell ) ;
			else
				oRow.insertBefore( newCell, oCell.nextSibling ) ;
		}
		
		this._MarkCells( [ oCell ], "_CellProcessed" );
	}
	
	for ( var i = 0; i < oTable.rows.length; i++ )
	{
		this._UnmarkCells( oTable.rows[ i ].cells, "_CellProcessed" );
	}
}

sbEditorTableHandler._ReplaceCellsByMarker = function( tableMap, marker, substitute )
{
	for ( var i = 0 ; i < tableMap.length ; i++ )
	{
		for ( var j = 0 ; j < tableMap[i].length ; j++ )
		{
			if ( tableMap[i][j][marker] )
				tableMap[i][j] = substitute ;
		}
	}
}

sbEditorTableHandler._MoveCaretToCell = function ( refCell, toStart )
{
	var range = new sbEditorDomRange( sbEditorAreaWnd ) ;
	range._MoveToNodeContents( refCell ) ;
	range._Collapse( toStart ) ;
	range._Select() ;
}

sbEditorTableHandler._MergeCells = function()
{
	var cells = this._GetSelectedCells() ;
	if ( cells.length < 2 )
		return ;

	var refCell = cells[0] ;
	refCell.setAttribute("_sboldid", refCell.id);
	refCell.setAttribute("id", "_sbmergedcell");
	
	var tableMap = this._CreateTableMap( refCell.parentNode.parentNode ) ;
	var rowIdx = refCell.parentNode.rowIndex ;
	var colIdx = this._GetCellIndexSpan( tableMap, rowIdx, refCell ) ;

	this._MarkCells( cells, '_SelectedCells' ) ;
	var selectionGeometry = this._GetMarkerGeometry( tableMap, rowIdx, colIdx, '_SelectedCells' ) ;

	var baseColIdx = colIdx - selectionGeometry.x ;
	var baseRowIdx = rowIdx - selectionGeometry.y ;
	var cellContents = sbGetElementDocument( refCell ).createDocumentFragment() ;
	for ( var i = 0 ; i < selectionGeometry.height ; i++ )
	{
		var rowChildNodesCount = 0 ;
		for ( var j = 0 ; j < selectionGeometry.width ; j++ )
		{
			var currentCell = tableMap[baseRowIdx + i][baseColIdx + j] ;
			while ( currentCell.childNodes.length > 0 )
			{
				var node = currentCell.removeChild( currentCell.firstChild ) ;
				if ( node.nodeType != 1
					|| ( node.getAttribute( 'type', 2 ) != '_moz' && node.getAttribute( '_moz_dirty' ) == null ) )
				{
					cellContents.appendChild( node ) ;
					rowChildNodesCount++ ;
				}
			}
		}
		if ( rowChildNodesCount > 0 )
			cellContents.appendChild( sbGetElementDocument( refCell ).createElement( 'br' ) ) ;
	}

	this._ReplaceCellsByMarker( tableMap, '_SelectedCells', refCell ) ;
	this._UnmarkCells( cells, '_SelectedCells' ) ;
	this._InstallTableMap( tableMap, refCell.parentNode.parentNode ) ;
	
	var refCell = sbEditorAreaDoc.getElementById("_sbmergedcell");
	refCell.appendChild( cellContents );
	
	if (refCell.getAttribute("_sboldid") != "")
		refCell.setAttribute("id", refCell.getAttribute("_sboldid"));
	else
		refCell.removeAttribute("id");
		
	refCell.removeAttribute("_sboldid");

	if ( !_isIE && ( ! refCell.firstChild ) )
		sbEditorAppendBogusBr( refCell ) ;

	this._MoveCaretToCell( refCell, false ) ;
}

sbEditorTableHandler._GetMergeRightTarget = function()
{
	var cells = this._GetSelectedCells() ;
	if ( cells.length != 1 )
		return null ;

	var refCell = cells[0] ;
	var tableMap = this._CreateTableMap( refCell.parentNode.parentNode ) ;
	var rowIdx = refCell.parentNode.rowIndex ;
	var colIdx = this._GetCellIndexSpan( tableMap, rowIdx, refCell ) ;
	var nextColIdx = colIdx + ( isNaN( refCell.colSpan ) ? 1 : refCell.colSpan ) ;
	var nextCell = tableMap[rowIdx][nextColIdx] ;

	if ( ! nextCell )
		return null ;

	this._MarkCells( [refCell, nextCell], '_SizeTest' ) ;
	var refGeometry = this._GetMarkerGeometry( tableMap, rowIdx, colIdx, '_SizeTest' ) ;
	var nextGeometry = this._GetMarkerGeometry( tableMap, rowIdx, nextColIdx, '_SizeTest' ) ;
	this._UnmarkCells( [refCell, nextCell], '_SizeTest' ) ;

	if ( refGeometry.height != nextGeometry.height || refGeometry.y != nextGeometry.y )
		return null ;

	return { 'refCell' : refCell, 'nextCell' : nextCell, 'tableMap' : tableMap } ;
}

sbEditorTableHandler._GetMergeDownTarget = function()
{
	var cells = this._GetSelectedCells() ;
	if ( cells.length != 1 )
		return null ;

	var refCell = cells[0] ;
	var tableMap = this._CreateTableMap( refCell.parentNode.parentNode ) ;
	var rowIdx = refCell.parentNode.rowIndex ;
	var colIdx = this._GetCellIndexSpan( tableMap, rowIdx, refCell ) ;
	var newRowIdx = rowIdx + ( isNaN( refCell.rowSpan ) ? 1 : refCell.rowSpan ) ;
	if ( ! tableMap[newRowIdx] )
		return null ;

	var nextCell = tableMap[newRowIdx][colIdx] ;

	if ( ! nextCell )
		return null ;

	this._MarkCells( [refCell, nextCell], '_SizeTest' ) ;
	var refGeometry = this._GetMarkerGeometry( tableMap, rowIdx, colIdx, '_SizeTest' ) ;
	var nextGeometry = this._GetMarkerGeometry( tableMap, newRowIdx, colIdx, '_SizeTest' ) ;
	this._UnmarkCells( [refCell, nextCell], '_SizeTest' ) ;

	if ( refGeometry.width != nextGeometry.width || refGeometry.x != nextGeometry.x )
		return null ;

	return { 'refCell' : refCell, 'nextCell' : nextCell, 'tableMap' : tableMap } ;
}

sbEditorTableHandler._MergeCol = function()
{
	var target = this._GetMergeRightTarget() ;
	if ( target == null )
		return ;
		
	var refCell = target.refCell ;
	var tableMap = target.tableMap ;
	var nextCell = target.nextCell ;

	var cellContents = sbEditorAreaDoc.createDocumentFragment() ;
	while ( nextCell && nextCell.childNodes && nextCell.childNodes.length > 0 )
		cellContents.appendChild( nextCell.removeChild( nextCell.firstChild ) ) ;

	nextCell.parentNode.removeChild( nextCell ) ;
	refCell.appendChild( cellContents ) ;
	this._MarkCells( [nextCell], '_Replace' ) ;
	this._ReplaceCellsByMarker( tableMap, '_Replace', refCell ) ;
	this._InstallTableMap( tableMap, refCell.parentNode.parentNode ) ;

	this._MoveCaretToCell( refCell, false ) ;
}

sbEditorTableHandler._MergeRow = function()
{
	var target = this._GetMergeDownTarget() ;
	if ( target == null )
		return ;
		
	var refCell = target.refCell ;
	var tableMap = target.tableMap ;
	var nextCell = target.nextCell ;

	var cellContents = sbEditorAreaDoc.createDocumentFragment() ;
	while ( nextCell && nextCell.childNodes && nextCell.childNodes.length > 0 )
		cellContents.appendChild( nextCell.removeChild( nextCell.firstChild ) ) ;
	
	if ( cellContents.firstChild )
		cellContents.insertBefore( sbEditorAreaDoc.createElement( 'br' ), cellContents.firstChild ) ;
	
	refCell.appendChild( cellContents ) ;
	this._MarkCells( [nextCell], '_Replace' ) ;
	this._ReplaceCellsByMarker( tableMap, '_Replace', refCell ) ;
	this._InstallTableMap( tableMap, refCell.parentNode.parentNode ) ;

	this._MoveCaretToCell( refCell, false ) ;
}

sbEditorTableHandler._SplitCol = function()
{
	var cells = this._GetSelectedCells() ;
	if ( cells.length != 1 )
		return ;

	var refCell = cells[0] ;
	var tableMap = this._CreateTableMap( refCell.parentNode.parentNode ) ;
	var rowIdx = refCell.parentNode.rowIndex ;
	var colIdx = this._GetCellIndexSpan( tableMap, rowIdx, refCell ) ;
	var cellSpan = isNaN( refCell.colSpan ) ? 1 : refCell.colSpan ;

	if ( cellSpan > 1 )
	{
		var newCellSpan = Math.ceil( cellSpan / 2 ) ;
		var newCell = refCell.cloneNode( false );
		if ( !_isIE )
			sbEditorAppendBogusBr( newCell ) ;
			
		var startIdx = colIdx + newCellSpan ;
		var endIdx = colIdx + cellSpan ;
		var rowSpan = isNaN( refCell.rowSpan ) ? 1 : refCell.rowSpan ;
		for ( var r = rowIdx ; r < rowIdx + rowSpan ; r++ )
		{
			for ( var i = startIdx ; i < endIdx ; i++ )
				tableMap[r][i] = newCell ;
		}
	}
	else
	{
		var newTableMap = [] ;
		var newCell = refCell.cloneNode( false );
		if ( !_isIE )
			sbEditorAppendBogusBr( newCell ) ;
					
		for ( var i = 0 ; i < tableMap.length ; i++ )
		{
			var newRow = tableMap[i].slice( 0, colIdx ) ;
			if ( tableMap[i].length <= colIdx )
			{
				newTableMap.push( newRow ) ;
				continue ;
			}
			if ( tableMap[i][colIdx] == refCell )
			{
				newRow.push( refCell ) ;
				newRow.push( newCell ) ;
			}
			else
			{
				newRow.push( tableMap[i][colIdx] ) ;
				newRow.push( tableMap[i][colIdx] ) ;
			}
			for ( var j = colIdx + 1 ; j < tableMap[i].length ; j++ )
				newRow.push( tableMap[i][j] ) ;
			newTableMap.push( newRow ) ;
		}
		tableMap = newTableMap ;
	}

	this._InstallTableMap( tableMap, refCell.parentNode.parentNode ) ;
}

sbEditorTableHandler._SplitRow = function()
{
	var cells = this._GetSelectedCells() ;
	if ( cells.length != 1 )
		return ;

	var currentCell = cells[0] ;
	var tableMap = this._CreateTableMap( currentCell.parentNode.parentNode ) ;
	var cellIndex = this._GetCellIndexSpan( tableMap, currentCell.parentNode.rowIndex, currentCell ) ;
	var currentRowSpan = currentCell.rowSpan ;
	var currentRowIndex = currentCell.parentNode.rowIndex ;
	if ( isNaN( currentRowSpan ) )
		currentRowSpan = 1 ;

	if ( currentRowSpan > 1 )
	{
		currentCell.rowSpan = Math.ceil( currentRowSpan / 2 ) ;

		var newCellRowIndex = currentRowIndex + Math.ceil( currentRowSpan / 2 ) ;
		var insertMarker = null ;
		for ( var i = cellIndex+1 ; i < tableMap[newCellRowIndex].length ; i++ )
		{
			if ( tableMap[newCellRowIndex][i].parentNode.rowIndex == newCellRowIndex )
			{
				insertMarker = tableMap[newCellRowIndex][i] ;
				break ;
			}
		}

		var newCell = currentCell.cloneNode( false );
		newCell.rowSpan = Math.floor( currentRowSpan / 2 ) ;
		if ( !_isIE )
			sbEditorAppendBogusBr( newCell ) ;
		currentCell.parentNode.parentNode.rows[newCellRowIndex].insertBefore( newCell, insertMarker ) ;
	}
	else
	{
		var newCellRowIndex = currentRowIndex + 1 ;
		var newRow = sbEditorAreaDoc.createElement( 'tr' ) ;
		var tBody = currentCell.parentNode.parentNode ;
		if ( tBody.rows.length > newCellRowIndex )
			tBody.insertBefore( newRow, tBody.rows[newCellRowIndex] ) ;
		else
			tBody.appendChild( newRow ) ;

		for ( var i = 0 ; i < tableMap[currentRowIndex].length ; )
		{
			var colSpan = tableMap[currentRowIndex][i].colSpan ;
			if ( isNaN( colSpan ) || colSpan < 1 )
				colSpan = 1 ;
			if ( i == cellIndex )
			{
				i += colSpan ;
				continue ;
			}
			var rowSpan = tableMap[currentRowIndex][i].rowSpan ;
			if ( isNaN( rowSpan ) )
				rowSpan = 1 ;
			tableMap[currentRowIndex][i].rowSpan = rowSpan + 1 ;
			i += colSpan ;
		}

		var newCell = currentCell.cloneNode( false );
		if ( !_isIE )
			sbEditorAppendBogusBr( newCell	) ;
		newRow.appendChild( newCell ) ;
	}
}
<?php require_once(dirname(__FILE__).'/../jfooter.inc.php'); ?>