<?php 
require_once(dirname(__FILE__).'/../jheader.inc.php'); 
require_once(SB_CMS_LANG_PATH.'/pl_editor.h.lng.php');
?>
function sbEditorHover(e)
{
    var el = sbEventTarget(e);

    if (el && el.nodeName == "IMG" && el.className == "button") 
    {
        el.className = "buttonOver";
    }
}

function sbEditorHout(e)    
{
	var el = sbEventTarget(e);
    if (el && el.className != "buttonDisabled" && el.nodeName == "IMG")
    {
	    if (!el.getAttribute("checked"))
	    {
	    	el.className = "button";
	    }
	    else
	    {
	        el.className = "buttonChecked";
	    }
	}
}

function sbEditorMouseDown(e)
{
    var el = sbEventTarget(e);

    if (el && el.nodeName == "IMG" && el.className == "buttonOver") 
    {
        el.className = "buttonDown";
    }
}

function sbEditorMouseUp(e)
{
    var el = sbEventTarget(e);
	if (el && el.className != "buttonDisabled" && el.nodeName == "IMG")
	{
    	if (!el.getAttribute("checked"))
	    {
	    	el.className = "buttonOver";
	    }
	    else
	    {
	        el.className = "buttonChecked";
	    }
   	}
}

function sbEditorSetState(el_id, param)
{
	if (typeof(param[0]) == "function")
		var state = param[0](param[1]);
	else
		var state = param;
	
	var el = sbGetE(el_id);
	if (!el)
		return;
		
	switch (state)
	{
		case SB_EDITOR_STATE_OFF:
			if (el.className != "buttonOver")
				el.className = "button";
			el.removeAttribute("checked");
			break;

		case SB_EDITOR_STATE_ON:
			el.className = "buttonChecked";
			el.setAttribute("checked", 1);
			break;

		case SB_EDITOR_STATE_DISABLED:
			el.className = "buttonDisabled";
			break;	
	}
}

function sbEditorMinMaxToolbar(el)
{
	var img = sbGetE("sbEditorBtnMinMax");
	if (img.src.match(/up.gif/))
	{
		img.src = sb_cms_img_url + "/editor/down.gif";
		img.title = "<?php echo EDITOR_MAXIMIZE; ?>";
		el.title = "<?php echo EDITOR_MAXIMIZE; ?>";
		sbGetE("toolbar_row1").style.display = "none";
		sbGetE("toolbar_row2").style.display = "none";
		sbGetE("toolbar_row3").style.display = "none";
		sbGetE("toolbar_row4").style.display = "none";
		sbEditorTopWnd.sbGetE("sb_editor_toolbar").height = 14;
	}
	else
	{
		img.src = sb_cms_img_url + "/editor/up.gif";
		img.title = "<?php echo EDITOR_MINIMIZE; ?>";
		el.title = "<?php echo EDITOR_MINIMIZE; ?>";
		sbGetE("toolbar_row1").style.display = "";
		sbGetE("toolbar_row2").style.display = "";
		sbGetE("toolbar_row3").style.display = "";
		sbGetE("toolbar_row4").style.display = "";
		sbEditorTopWnd.sbGetE("sb_editor_toolbar").height = 104;
	}
	
	sbEditorTopWnd.sbResizeIFrame();
}

//////////////////////////////////////////////////////////////////

var sbEditorSpecialCombo = function()
{
	this._FieldWidth = null ;
	this._PanelWidth = null ;
	this._PanelMaxHeight = null ;
	this._OnSelect = null ;
}

var pt = sbEditorSpecialCombo.prototype;
pt._DefaultLabel = '' ;

pt._Create = function( targetElement )
{
	this._Combo = new sbSpecialCombo( this._GetLabel(), this._FieldWidth, this._PanelWidth, this._PanelMaxHeight, _isIE ? window : sbGetElementWindow( targetElement ).parent ) ;

	this._CreateItems( this._Combo ) ;

	this._Combo._Create( targetElement ) ;
	this._Combo._OnSelect = this._OnSelect ;
	sbEditorEvents._AttachEvent("OnSelectionChange", new sbCallerFunction(this._Refresh, this, null));
}

pt._RefreshItems = function( value )
{
	this._Combo._DeselectAll() ;
	this._Combo._SelectItem( value ) ;
	this._Combo._SetLabelById( value ) ;
}

pt._Refresh = function(obj)
{with(obj){
	var sValue = _GetState();
	var eState = SB_EDITOR_STATE_ON ;

	if ( sValue != SB_EDITOR_STATE_DISABLED )
	{
		if ( _RefreshActiveItems )
			_RefreshActiveItems( _Combo, sValue ) ;
		else
		{
			if ( _LastValue !== sValue)
			{
				_LastValue = sValue ;

				if ( !sValue || sValue.length == 0 )
				{
					_Combo._DeselectAll() ;
					_Combo._SetLabel( _DefaultLabel ) ;
				}
				else
					_RefreshItems( sValue ) ;
			}
		}
	}
	else
		eState = SB_EDITOR_STATE_DISABLED ;

	if ( eState == obj._State ) return ;

	if ( eState == SB_EDITOR_STATE_DISABLED )
	{
		_Combo._DeselectAll() ;
		_Combo._SetLabel( '' ) ;
	}

	obj._State = eState ;
	_Combo._SetEnabled( eState != SB_EDITOR_STATE_DISABLED ) ;
}}

pt._Enable = function()
{
	this._Refresh() ;
}

pt._Disable = function()
{
	this._State = SB_EDITOR_STATE_DISABLED ;
	this._Combo._DeselectAll() ;
	this._Combo._SetLabel( '' ) ;
	this._Combo._SetEnabled( false ) ;
}

//////////////////////////////////////////////////////////////////////////

var sbEditorStyleCombo = function( not_init)
{
	if (not_init === false)
		return;
		
	this._OnSelect = sbEditorStyleAction;
	this._State = SB_EDITOR_STATE_DISABLED;
	this._DefaultLabel = '' ;
}

var pt = sbEditorStyleCombo.prototype = new sbEditorSpecialCombo ;

pt._GetLabel = function()
{
	return "<?php echo PL_EDITOR_H_BTN_STYLE; ?>" ;
}

pt._GetStyles = function()
{
	var styles = {} ;
	var allStyles = sbEditorStyles._GetStyles() ;

	for ( var styleName in allStyles )
	{
		var style = allStyles[ styleName ] ;
		if ( !style._IsCore )
			styles[ styleName ] = style ;
	}
	return styles ;
}

pt._CreateItems = function( targetSpecialCombo )
{
	var targetDoc = targetSpecialCombo._Panel._Document ;

	sbAppendStyleString( targetDoc, '<?php echo SB_CMS_EDITOR_URL; ?>/styles.css' ) ;
	targetDoc.body.className += ' ForceBaseFont' ;

	var styles = this._GetStyles() ;

	for ( var styleName in styles )
	{
		var style = styles[ styleName ] ;
		var caption = style._GetType() == SB_EDITOR_STYLE_OBJECT ?
			styleName :
			this._BuildPreview( style, style._Label || styleName ) ;

		var item = targetSpecialCombo._AddItem( style._Label || styleName, caption ) ;
		item._Style = style ;
	}

	targetSpecialCombo._OnBeforeClick = this._OnBeforeClick ;
}

pt._RefreshActiveItems = function( targetSpecialCombo )
{
	if ( sbEditorSelection._GetType() == 'Control' )
		var startElement = sbEditorSelection._GetSelectedElement() ;
	else
		var startElement = sbEditorSelection._GetBoundaryParentElement( true ) ;

	if ( startElement )
	{
		var path = new sbEditorElementPath( startElement ) ;
		var elements = path._Elements ;

		for ( var e = 0 ; e < elements.length ; e++ )
		{
			for ( var i in targetSpecialCombo._Items )
			{
				var item = targetSpecialCombo._Items[i] ;
				var style = item._Style ;

				if ( style._IsRemovable( elements[ e ], true ) )
				{
					targetSpecialCombo._SetLabel( style._Label || style._Name ) ;
					return ;
				}
			}
		}
	}

	targetSpecialCombo._SetLabel( this._DefaultLabel ) ;
}

pt._OnBeforeClick = function( targetSpecialCombo )
{
	targetSpecialCombo._DeselectAll() ;

	var startElement ;
	var path ;
	var tagName ;

	var selection = sbEditorSelection;

	if ( selection._GetType() == 'Control' )
	{
		startElement = selection._GetSelectedElement() ;
		tagName = startElement.nodeName.toLowerCase() ;
	}
	else
	{
		startElement = selection._GetBoundaryParentElement( true ) ;
		path = new sbEditorElementPath( startElement ) ;
	}

	for ( var i in targetSpecialCombo._Items )
	{
		var item = targetSpecialCombo._Items[i] ;
		var style = item._Style ;

		if ( ( tagName && style._Element == tagName ) || ( !tagName && style._GetType() != SB_EDITOR_STYLE_OBJECT ) )
		{
			item.style.display = '' ;

			if ( ( path && style._IsActive( path ) ) || ( !path && style._IsRemovable( startElement, true ) ) )
				targetSpecialCombo._SelectItem( style._Name ) ;
		}
		else
			item.style.display = 'none' ;
	}
}

pt._BuildPreview = function( style, caption )
{
	var styleType = style._GetType() ;
	var html = [] ;

	if ( styleType == SB_EDITOR_STYLE_BLOCK )
		html.push( '<div class="BaseFont">' ) ;

	var elementName = style._Element ;

	if ( elementName == 'bdo' )
		elementName = 'span' ;

	html.push( '<', elementName ) ;

	var attribs	= style._StyleDesc.Attributes ;
	if ( attribs )
	{
		for ( var att in attribs )
		{
			html.push( ' ', att, '="', style._GetFinalAttributeValue( att ), '"' ) ;
		}
	}

	if ( style._GetStyleText().length > 0 )
		html.push( ' style="', style._GetFinalStyleValue(), '"' ) ;

	html.push( '>', caption, '</', elementName, '>' ) ;

	if ( styleType == SB_EDITOR_STYLE_BLOCK )
		html.push( '</div>' ) ;

	return html.join( '' ) ;
}

pt._GetState = function()
{
	if ( !sbEditorArea )
		return SB_EDITOR_STATE_DISABLED ;

	if ( sbEditorSelection._GetType() == 'Control' )
	{
		var el = sbEditorSelection._GetSelectedElement() ;
		if ( !el || !sbEditorStyles._HasObjectStyle( el.nodeName.toLowerCase() ) || el.getAttribute('_sbfakelement'))
			return SB_EDITOR_STATE_DISABLED ;
	}

	return SB_EDITOR_STATE_OFF ;
}

//////////////////////////////////////////////////////////////////////////

var sbEditorFontFormatCombo = function(not_init)
{
	if (not_init === false)
		return;
		
	this._OnSelect = sbEditorStyleAction;
	this._State = SB_EDITOR_STATE_DISABLED;
	this._DefaultLabel = "";
	this._PanelWidth = 190;
}

var pt = sbEditorFontFormatCombo.prototype = new sbEditorStyleCombo( false ) ;

pt._GetLabel = function()
{
	return "<?php echo PL_EDITOR_H_BTN_FONT_FORMAT; ?>" ;
}

pt._GetStyles = function()
{
	var styles = {} ;
	var oNames = {
		p		: "<?php echo PL_EDITOR_H_FONT_FORMAT1; ?>",
		pre		: "<?php echo PL_EDITOR_H_FONT_FORMAT2; ?>",
		address	: "<?php echo PL_EDITOR_H_FONT_FORMAT3; ?>",
		h1		: "<?php echo PL_EDITOR_H_FONT_FORMAT4; ?>",
		h2		: "<?php echo PL_EDITOR_H_FONT_FORMAT5; ?>",
		h3		: "<?php echo PL_EDITOR_H_FONT_FORMAT6; ?>",
		h4		: "<?php echo PL_EDITOR_H_FONT_FORMAT7; ?>",
		h5		: "<?php echo PL_EDITOR_H_FONT_FORMAT8; ?>",
		h6		: "<?php echo PL_EDITOR_H_FONT_FORMAT9; ?>",
		div		: "<?php echo PL_EDITOR_H_FONT_FORMAT10; ?>"
	} ;

	var els = new String('p;h1;h2;h3;h4;h5;h6;pre;address;div').split(';') ;

	for ( var i = 0 ; i < els.length ; i++ )
	{
		var el = els[ i ] ;
		var style = sbEditorStyles._GetStyle( '_sb_' + el ) ;
		if ( style )
		{
			style._Label = oNames[ el ] ;
			styles[ '_sb_' + el ] = style ;
		}
	}

	return styles ;
}

pt._OnBeforeClick = function( combo )
{
	combo._DeselectAll() ;

	var startElement = sbEditorSelection._GetBoundaryParentElement( true ) ;

	if ( startElement )
	{
		var path = new sbEditorElementPath( startElement ) ;
		var blockElement = path._Block ;

		for ( var i in combo._Items )
		{
			var item = combo._Items[i] ;
			var style = item._Style ;

			if ( style._IsRemovable( blockElement ) )
			{
				combo._SelectItem( item ) ;
				return ;
			}
		}
	}
}

pt._GetState = function()
{
	if ( !sbEditorArea )
		return SB_EDITOR_STATE_DISABLED ;
	
	return SB_EDITOR_STATE_OFF ;
}
////////////////////////////////////////////////////////////////////////

var sbEditorFontNameCombo = function()
{
	this._OnSelect = sbEditorStyleAction;
	this._State = SB_EDITOR_STATE_DISABLED;
	this._DefaultLabel = "";
}

var pt = sbEditorFontNameCombo.prototype = new sbEditorFontFormatCombo( false ) ;

pt._GetLabel = function()
{
	return "<?php echo PL_EDITOR_H_BTN_FONT_NAME; ?>" ;
}

pt._GetStyles = function()
{
	var baseStyle = sbEditorStyles._GetStyle( '_sb_FontFace' ) ;

	if ( !baseStyle )
	{
		return {} ;
	}

	var styles = {} ;
	for ( var i = 0 ; i < sbEditorFonts.length ; i++ )
	{
		var fontParts = sbEditorFonts[i].split('/') ;
		var font = fontParts[0] ;
		var caption = fontParts[1] || font ;

		var style = sbEditorCloneObject( baseStyle ) ;
		style._SetVariable( 'Font', font ) ;
		style._Label = caption ;

		styles[ caption ] = style ;
	}

	return styles ;
}

pt._RefreshActiveItems = sbEditorStyleCombo.prototype._RefreshActiveItems ;

pt._OnBeforeClick = function( combo )
{
	combo._DeselectAll() ;

	var startElement = sbEditorSelection._GetBoundaryParentElement( true ) ;

	if ( startElement )
	{
		var path = new sbEditorElementPath( startElement ) ;

		for ( var i in combo._Items )
		{
			var item = combo._Items[i] ;
			var style = item._Style ;

			if ( style._IsActive( path ) )
			{
				combo._SelectItem( item ) ;
				return ;
			}
		}
	}
}

/////////////////////////////////////////////////////////////////////

var sbEditorFontSizeCombo = function()
{
	this._OnSelect = sbEditorStyleAction;
	this._State = SB_EDITOR_STATE_DISABLED;
	this._DefaultLabel = "";
	this._FieldWidth = 70 ;
}

var pt = sbEditorFontSizeCombo.prototype = new sbEditorFontFormatCombo( false ) ;

pt._GetLabel = function()
{
	return "<?php echo PL_EDITOR_H_BTN_FONT_SIZE; ?>" ;
}

pt._GetStyles = function()
{
	var baseStyle = sbEditorStyles._GetStyle( '_sb_Size' ) ;

	if ( !baseStyle )
	{
		return {} ;
	}

	var styles = {} ;
	for ( var i = 0 ; i < sbEditorFontSizes.length ; i++ )
	{
		var fontParts = sbEditorFontSizes[i].split('/') ;
		var font = fontParts[0] ;
		var caption = fontParts[1] || font ;

		var style = sbEditorCloneObject( baseStyle ) ;
		style._SetVariable( 'Size', font ) ;
		style._Label = caption ;

		styles[ caption ] = style ;
	}

	return styles ;
}

pt._RefreshActiveItems = sbEditorStyleCombo.prototype._RefreshActiveItems ;
pt._OnBeforeClick = sbEditorFontNameCombo.prototype._OnBeforeClick ;

<?php $GLOBALS['sb_cache_time'] = 1; require_once(dirname(__FILE__).'/../jfooter.inc.php'); ?>