<?php require_once(dirname(__FILE__).'/../jheader.inc.php'); ?>
// константы
var SB_EDITOR_STATE_OFF	= 0 ;
var SB_EDITOR_STATE_ON = 1 ;
var SB_EDITOR_STATE_DISABLED = -1 ;

var SB_EDITOR_STYLE_BLOCK = 0 ;
var SB_EDITOR_STYLE_INLINE = 1 ;
var SB_EDITOR_STYLE_OBJECT = 2 ;

var sbEditorTopWnd = window.parent;
var sbEditorAreaId = "";
var sbEditorArea = null;
var sbEditorEnterKeyHandler = null;

var sbEditorSelectionChangeLocked = false;
var sbEditorLastOnChangeTimer = null;
var sbEditorDocTypeDeclaration = "";

var sbEditorTemplates = null;

var sbEditorDocType = "";
var sbEditorDocumentTitle = "";
var sbEditorFullPage = false;

/**
 * События редактора
 */
var sbEditorEvents =
{
	_RegisteredEvents : [],

	_AttachEvent : function( e, f )
	{
		var aTargets ;
	
		if ( !( aTargets = this._RegisteredEvents[ e ] ) )
			this._RegisteredEvents[ e ] = [ f ] ;
		else
		{
			if ( aTargets.IndexOf( f ) == -1 )
				aTargets.push( f ) ;
		}
	},
	
	_FireEvent : function( e, params )
	{
		var res = true ;
		var oCalls = this._RegisteredEvents[ e ] ;
		if ( oCalls )
		{
			for ( var i = 0 ; i < oCalls.length ; i++ )
			{
				try
				{
					res = ( oCalls[ i ]( params ) && res ) ;
				}
				catch(e)
				{
					if ( e.number != -2146823277 )
						throw e ;
				}
			}
		}
	
		return res ;
	}
}
 
function sbEditorInit()
{	
	var els = document.getElementsByTagName("IMG");
	for (var i = 0; i < els.length; i++)
	{
		if (els[i].className == "button")
		{
			sbAddEvent(els[i], "mouseover", sbEditorHover);
			sbAddEvent(els[i], "mouseout", sbEditorHout);
			sbAddEvent(els[i], "mousedown", sbEditorMouseDown);
			sbAddEvent(els[i], "mouseup", sbEditorMouseUp);
		}
	}
	
	if (sbEditorMode == "popup")
	{
		sbEditorAreaWnd = sbEditorTopWnd.sbGetE("sb_editor_area").contentWindow;
		sbEditorAreaDoc = sbEditorAreaWnd.document;
		
		var base = '' ;
		if ( _isSafari )
		{
			base = '<base href="' + window.document.location + '">' ;
		}

		sbEditorAreaDoc.open();
		sbEditorAreaDoc.write('<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">'
					+ '<html><head>' + base 
					+ '<style type="text/css">' 
					+ 'html {height: 99%;width: 100%;}'
					+ 'body {width: 100%;height: 99%;margin: 0px;padding: 0px;}'
					+ '</style>'
<?php
$styles = sbPlugins::getSetting('sb_editor_styles');
if (trim($styles) != '')
{
	$styles = explode(';', $styles);
	foreach ($styles as $val)
	{
		echo '+ \'<link rel="stylesheet" href="'.trim($val).'">\''; 
	}
}
?>
					+ '<link rel="stylesheet" type="text/css" href="<?php echo SB_CMS_CSS_URL; ?>/editor/sbArea.css"></head>'
					+ '<body><div id="sb_editor_div">' + sbEditorSetData( sbEditorTopWnd.sbGetE("sb_editor_value").value ) 
					+ '</div></body></html>');
		sbEditorAreaDoc.close();
		
		sbEditorAreaId = "sb_editor_div";
		setTimeout(sbEditorInitArea, 0);
	}
	else
	{
		sbAddEvent(window.document, "click", sbEditorTopWnd.sbEditorHideMenu);
		sbEditorRefreshButtons();
		sbEditorStylesCombo._Disable();
		sbEditorFontFormatsCombo._Disable();
		sbEditorFontNamesCombo._Disable();
		sbEditorFontSizesCombo._Disable();
	}
	
	sbEditorTopWnd.hideLoading();
}

function sbEditorInitArea()
{
	if (sbEditorAreaId != "")
	{
		sbEditorArea = sbEditorAreaDoc.getElementById(sbEditorAreaId);
		if (sbEditorArea)
		{
			sbEditorMakeEditable();
		
			sbEditorInitializeBehaviors();
			sbEditorDocumentProcessor._Process( sbEditorArea ) ;
			
			setTimeout("sbEditorFocus(true);", 100);
			sbEditorEvents._FireEvent("OnSelectionChange");
		}
	}
}

function sbEditorMakeEditable()
{
	var sBody = sbEditorArea.innerHTML;
	if ( _isFF && ( sBody.length == 0 || sbEditorRegexLib.EmptyParagraph.test( sBody ) ) )
		sbEditorArea.innerHTML = '<br type="_moz">' ;

	sbEditorAreaDoc.body.disabled = true ;
	sbEditorArea.contentEditable = true ;
	sbEditorAreaDoc.body.removeAttribute("disabled");
}

function sbEditorMakeUneditable()
{
	sbEditorAreaDoc.body.disabled = true ;
	sbEditorArea.contentEditable = false ;
	sbEditorAreaDoc.body.removeAttribute("disabled");
	
	// сделать деинициализацию событий
	sbEditorDeinitializeBehaviors();
}

function sbEditorInitializeBehaviors ()
{
	sbEditorEnterKeyHandler = new sbEditorEnterKey(sbEditorAreaWnd, SB_EDITOR_ENTER_MODE, SB_EDITOR_SHIFT_ENTER_MODE, SB_EDITOR_TAB_SPACES);
	
	sbAddEvent(sbEditorArea, "keydown", sbEditorOnKeyDown ) ;
	sbAddEvent(sbEditorAreaWnd, "focus", sbEditorOnSelectionChange ) ;
	sbAddEvent(sbEditorAreaDoc, "mouseup", sbEditorOnMouseUp ) ;
	sbAddEvent(sbEditorArea, "keyup", sbEditorOnSelectionChangeTimer ) ;
		
	if (_isIE)
	{
		sbAddEvent(sbEditorAreaDoc.body, "selectstart", sbEditorCheckSelection );
		sbAddEvent(sbEditorArea, "beforedeactivate", function(){ sbEditorSelection._Save( true ) ; } ) ;
		sbAddEvent(sbEditorAreaDoc.body, "paste", sbEditorOnPaste ) ;
		sbAddEvent(sbEditorArea, "drop", sbEditorExecDrop ) ;
	}
	else
	{
		if ( _isFF || _isOpera )
		{
			sbAddEvent(sbEditorArea, "keypress", sbEditorCheckCaret ) ;
			sbAddEvent(sbEditorArea, "click", sbEditorCheckCaret ) ;
			sbAddEvent(sbEditorArea, "dragdrop", sbEditorExecDrop ) ;
		}
		
		if ( _isSafari )
		{
			sbAddEvent(sbEditorAreaDoc, "mousedown", sbEditorSafariControlSelect );
		}
	}
}

function sbEditorDeinitializeBehaviors ()
{
	sbEditorEnterKeyHandler.oKeystrokeHandler._DettachFromElement(sbEditorArea);
	sbEditorEnterKeyHandler = null;
	
	sbRemoveEvent(sbEditorArea, "keydown", sbEditorOnKeyDown ) ;
	sbRemoveEvent(sbEditorAreaWnd, "focus", sbEditorOnSelectionChange ) ;
	sbRemoveEvent(sbEditorAreaDoc, "mouseup", sbEditorOnMouseUp ) ;
	sbRemoveEvent(sbEditorArea, "keyup", sbEditorOnSelectionChangeTimer ) ;
		
	if (_isIE)
	{
		sbRemoveEvent(sbEditorAreaDoc.body, "selectstart", sbEditorCheckSelection );
		sbRemoveEvent(sbEditorArea, "beforedeactivate", function(){ sbEditorSelection._Save( true ) ; } ) ;
		sbRemoveEvent(sbEditorAreaDoc.body, "paste", sbEditorOnPaste ) ;
		sbRemoveEvent(sbEditorArea, "drop", sbEditorExecDrop ) ;
	}
	else
	{
		if ( _isFF || _isOpera )
		{
			sbRemoveEvent(sbEditorArea, "keypress", sbEditorCheckCaret ) ;
			sbRemoveEvent(sbEditorArea, "click", sbEditorCheckCaret ) ;
			sbRemoveEvent(sbEditorArea, "dragdrop", sbEditorExecDrop ) ;
		}
		
		if ( _isSafari )
		{
			sbRemoveEvent(sbEditorAreaDoc, "mousedown", sbEditorSafariControlSelect) ;
		}
	}
}

function sbEditorSafariControlSelect( e )
{
	var el = e.srcElement ;

	if ( el.nodeName.IEquals( 'IMG', 'HR' ) )
	{
		sbEditorSelection._SelectNode( el ) ;
	}
}

function sbEditorRangeFocus(range, bookmark)
{
	if (_isOpera)
	{
		try
		{
			range._MoveToBookmark2( bookmark ) ;
			range._Select() ;
		}
		catch (e) {}
		sbEditorFocus();
	}
	else
	{
		range._MoveToBookmark( bookmark ) ;
		range._Select() ;
		if (_isFF || _isIE)
			sbEditorArea.focus();
		else
			sbEditorAreaWnd.focus();
	}
}

function sbEditorFocus (start)
{
	if (!_isOpera)
		sbEditorArea.focus();

	var oRange = new sbEditorDomRange( sbEditorAreaWnd ) ;
	if ( start )
		oRange._MoveToElementEditStart(sbEditorArea) ;
	else
		oRange._MoveToSelection() ;	
		
	oRange._Select();

	if (_isOpera)
		sbEditorArea.focus();
		
	sbEditorEvents._FireEvent( 'OnSelectionChange' );
}

function sbEditorCheckSelection(e)
{
	var el = sbEventTarget(e);
	if (sbEditorArea && !sbEditorArea.contains(el))
        return sbCancelEvent(e);
}

// Работа со стандартными командами редактора

function sbEditorExecuteNamedCommand ( commandName, commandParameter, noSaveUndo )
{
	if ( !noSaveUndo )
		sbEditorUndo._SaveUndoStep() ;

	if ( commandName == "Paste" && !_isIE )
	{
		try
		{
			if ( _isSafari )
				throw '' ;
				
			if ( sbEditorPaste() )
				sbEditorAreaDoc.execCommand( commandName, false, commandParameter ) ;
		}
		catch (e)	
		{ 
			var strPage = window.parent.sb_cms_modal_dialog_file + "?event=pl_editor_paste";
    		var strAttr = "resizable=0,width=800,height=600";
    		var attr = new Object();
    		attr.wnd = window;
    		attr.type = "Security";
    		
    		window.parent.sbShowModalDialog(strPage, strAttr, sbEditorPasteHelper, attr); 
		}	
	}
	else
	{
		sbEditorAreaDoc.execCommand( commandName, false, commandParameter ) ;
		sbEditorEvents._FireEvent( 'OnSelectionChange' ) ;
	}
}
	
function sbEditorGetNamedCommandState ( commandName )
{
	try
	{
		if ( _isSafari && sbEditorArea && commandName.IEquals( 'Paste' ) )
			return SB_EDITOR_STATE_OFF ;

		if ( !_isIE && commandName.toLowerCase() == 'unlink')
			return sbEditorSelection._HasAncestorNode('A') ? SB_EDITOR_STATE_OFF : SB_EDITOR_STATE_DISABLED ;
			 
		if ( !sbEditorAreaDoc.queryCommandEnabled( commandName ) )
			return SB_EDITOR_STATE_DISABLED ;
		else
		{
			return sbEditorAreaDoc.queryCommandState( commandName ) ? SB_EDITOR_STATE_ON : SB_EDITOR_STATE_OFF ;
		}
	}
	catch ( e )
	{
		return SB_EDITOR_STATE_OFF ;
	}
}

function sbEditorGetNamedCommandValue ( commandName )
{
	var sValue = '' ;
	var eState = sbEditorGetNamedCommandState( commandName ) ;

	if ( eState == SB_EDITOR_STATE_DISABLED )
		return null ;

	try
	{
		sValue = sbEditorAreaDoc.queryCommandValue( commandName ) ;
	}
	catch(e) {}

	return sValue ? sValue : '' ;
}
	
// другие полезные функции
function sbEditorSetInnerHtml ( html )
{
	sbEditorArea.innerHTML = '<div id="__fakeSBRemove__">&nbsp;</div>' + html ;
	sbEditorAreaDoc.getElementById('__fakeSBRemove__').removeNode( true ) ;
}

sbAddEvent(window, "load", sbEditorInit);

if (_isSafari || _isOpera)
{
	if (_isOpera)
	{
		history.navigationMode = "compatible";
	}
	
	window.onunload = function ()
	{
		if (sbEditorArea && sbEditorTopWnd.sbGetE("sb_editor_value").value != sbEditorGetData() && confirm("<?php echo EDITOR_CONFIRM_SAVE; ?>"))
		{
			sbEditorSaveAction(sbGetE("sbEditorBtnSave"), true);
		}
	};
}
else
{		
	window.onbeforeunload = function ()
	{
		if (sbEditorArea && sbEditorTopWnd.sbGetE("sb_editor_value").value != sbEditorGetData() && confirm("<?php echo EDITOR_CONFIRM_SAVE; ?>"))
		{
			sbEditorSaveAction(sbGetE("sbEditorBtnSave"), true);
		}
	};
}
<?php require_once(dirname(__FILE__).'/../jfooter.inc.php'); ?>