<?php require_once(dirname(__FILE__).'/../jheader.inc.php'); ?>

var wnd = (_isIE ? dialogArguments : window.opener.sbModalDialog.args);

var HighlightStyle = wnd.sbEditorStyles._GetStyle( '_sb_SelectionHighlight' )  ;

function GetNextNonEmptyTextNode ( node, stopNode )
{
	while ( ( node = wnd.sbEditorGetNextSourceNode( node, false, 3, stopNode ) ) && node && node.length < 1 )
		1 ;
		
	return node ;
}

CharacterCursor = function( arg )
{
	if ( arg == wnd.sbEditorArea )
	{
		this._textNode = GetNextNonEmptyTextNode( wnd.sbEditorArea, wnd.sbEditorArea ) ;
		this._offset = 0 ;
		this._doc = arg ;
	}
	else
	{
		this._textNode = arguments[0] ;
		this._offset = arguments[1] ;
		this._doc = wnd.sbEditorAreaDoc ;
	}
}
CharacterCursor.prototype =
{
	GetCharacter : function()
	{
		return ( this._textNode && this._textNode.nodeValue.charAt( this._offset ) ) || null ;
	},

	GetTextNode : function()
	{
		return this._textNode ;
	},

	GetIndex : function()
	{
		return this._offset ;
	},

	MoveNext : function()
	{
		if ( this._offset < this._textNode.length - 1 )
		{
			this._offset++ ;
			return false ;
		}

		var crossed = false ;
		var curNode = this._textNode ;
		while ( ( curNode = wnd.sbEditorGetNextSourceNode( curNode ) )
				&& curNode && ( curNode.nodeType != 3 || curNode.length < 1 ) )
		{
			var tag = curNode.nodeName.toLowerCase() ;
			if ( wnd.sbEditorListsLib.BlockElements[tag] || tag == 'br' )
				crossed = true ;
		}

		this._textNode = curNode ;
		this._offset = 0 ;
		return crossed ;
	},

	MoveBack : function()
	{
		if ( this._offset > 0 && this._textNode.length > 0 )
		{
			this._offset = Math.min( this._offset - 1, this._textNode.length - 1 ) ;
			return false ;
		}

		var crossed = false ;
		var curNode = this._textNode ;
		while ( ( curNode = wnd.sbEditorGetPreviousSourceNode( curNode ) )
				&& curNode && ( curNode.nodeType != 3 || curNode.length < 1 ) )
		{
			var tag = curNode.nodeName.toLowerCase() ;
			if ( wnd.sbEditorListsLib.BlockElements[tag] || tag == 'br' )
				crossed = true ;
		}

		this._textNode = curNode ;
		this._offset = curNode.length - 1 ;
		return crossed ;
	},

	Clone : function()
	{
		return new CharacterCursor( this._textNode, this._offset ) ;
	}
} ;

CharacterRange = function( initCursor, maxLength )
{
	this._cursors = initCursor.push ? initCursor : [initCursor] ;
	this._maxLength = maxLength ;
	this._highlightRange = null ;
}
CharacterRange.prototype =
{
	ToDomRange : function()
	{
		var firstCursor = this._cursors[0] ;
		var lastCursor = this._cursors[ this._cursors.length - 1 ] ;
		var domRange = new wnd.sbEditorDomRange( wnd.sbEditorAreaWnd ) ;
		var w3cRange = domRange._Range = domRange._CreateRange() ;
		w3cRange.setStart( firstCursor.GetTextNode(), firstCursor.GetIndex() ) ;
		w3cRange.setEnd( lastCursor.GetTextNode(), lastCursor.GetIndex() + 1 ) ;
		domRange._UpdateElementInfo() ;
		return domRange ;
	},

	Highlight : function()
	{
		if ( this._cursors.length < 1 )
			return ;

		var domRange = this.ToDomRange() ;
		HighlightStyle._ApplyToRange( domRange, false, true ) ;
		this._highlightRange = domRange ;

		var charRange = CharacterRange.CreateFromDomRange( domRange ) ;
		var focusNode = domRange._StartNode ;
		if ( focusNode.nodeType != 1 )
			focusNode = focusNode.parentNode ;
		wnd.sbEditorScrollIntoView( focusNode, false ) ;
		this._cursors = charRange._cursors ;
	},

	RemoveHighlight : function()
	{
		if ( this._highlightRange )
		{
			HighlightStyle._RemoveFromRange( this._highlightRange, false, true ) ;
			var charRange = CharacterRange.CreateFromDomRange( this._highlightRange ) ;
			this._cursors = charRange._cursors ;
			this._highlightRange = null ;
		}
	},

	GetHighlightDomRange : function()
	{
		return this._highlightRange;
	},

	MoveNext : function()
	{
		var next = this._cursors[ this._cursors.length - 1 ].Clone() ;
		var retval = next.MoveNext() ;
		if ( retval )
			this._cursors = [] ;
		this._cursors.push( next ) ;
		if ( this._cursors.length > this._maxLength )
			this._cursors.shift() ;
		return retval ;
	},

	MoveBack : function()
	{
		var prev = this._cursors[0].Clone() ;
		var retval = prev.MoveBack() ;
		if ( retval )
			this._cursors = [] ;
		this._cursors.unshift( prev ) ;
		if ( this._cursors.length > this._maxLength )
			this._cursors.pop() ;
		return retval ;
	},

	GetEndCharacter : function()
	{
		if ( this._cursors.length < 1 )
			return null ;
			
		var retval = this._cursors[ this._cursors.length - 1 ].GetCharacter() ;
		return retval ;
	},

	GetNextRange : function( len )
	{
		if ( this._cursors.length == 0 )
			return null ;
		var cur = this._cursors[ this._cursors.length - 1 ].Clone() ;
		cur.MoveNext() ;
		return new CharacterRange( cur, len ) ;
	},

	GetCursors : function()
	{
		return this._cursors ;
	}
} ;

CharacterRange.CreateFromDomRange = function( domRange )
{
	var w3cRange = domRange._Range ;
	var startContainer = w3cRange.startContainer ;
	var endContainer = w3cRange.endContainer ;
	var startTextNode, startIndex, endTextNode, endIndex ;

	if ( startContainer.nodeType == 3 )
	{
		startTextNode = startContainer ;
		startIndex = w3cRange.startOffset ;
	}
	else if ( domRange._StartNode.nodeType == 3 )
	{
		startTextNode = domRange._StartNode ;
		startIndex = 0 ;
	}
	else
	{
		startTextNode = GetNextNonEmptyTextNode( domRange._StartNode, domRange._StartNode.parentNode ) ;
		if ( !startTextNode )
			return null ;
		startIndex = 0 ;
	}

	if ( endContainer.nodeType == 3 && w3cRange.endOffset > 0 )
	{
		endTextNode = endContainer ;
		endIndex = w3cRange.endOffset - 1 ;
	}
	else
	{
		endTextNode = domRange._EndNode ;
		while ( endTextNode.nodeType != 3 )
			endTextNode = endTextNode.lastChild ;
		endIndex = endTextNode.length - 1 ;
	}

	var cursors = [] ;
	var current = new CharacterCursor( startTextNode, startIndex ) ;
	cursors.push( current ) ;
	if ( !( current.GetTextNode() == endTextNode && current.GetIndex() == endIndex ) && !domRange._IsEmpty() )
	{
		do
		{
			current = current.Clone() ;
			current.MoveNext() ;
			cursors.push( current ) ;
		}
		while ( !( current.GetTextNode() == endTextNode && current.GetIndex() == endIndex ) ) ;
	}

	return new CharacterRange( cursors, cursors.length ) ;
}

KMP_NOMATCH = 0 ;
KMP_ADVANCED = 1 ;
KMP_MATCHED = 2 ;
KmpMatch = function( pattern, ignoreCase )
{
	var overlap = [ -1 ] ;
	for ( var i = 0 ; i < pattern.length ; i++ )
	{
		overlap.push( overlap[i] + 1 ) ;
		while ( overlap[ i + 1 ] > 0 && pattern.charAt( i ) != pattern.charAt( overlap[ i + 1 ] - 1 ) )
			overlap[ i + 1 ] = overlap[ overlap[ i + 1 ] - 1 ] + 1 ;
	}
	this._Overlap = overlap ;
	this._State = 0 ;
	this._IgnoreCase = ( ignoreCase === true ) ;
	if ( ignoreCase )
		this.Pattern = pattern.toLowerCase();
	else
		this.Pattern = pattern ;
}

KmpMatch.prototype = 
{
	FeedCharacter : function( c )
	{
		if ( this._IgnoreCase )
			c = c.toLowerCase();

		while ( true )
		{
			if ( c == this.Pattern.charAt( this._State ) )
			{
				this._State++ ;
				if ( this._State == this.Pattern.length )
				{
					this._State = 0;
					return KMP_MATCHED;
				}
				return KMP_ADVANCED ;
			}
			else if ( this._State == 0 )
				return KMP_NOMATCH;
			else
				this._State = this._Overlap[ this._State ];
		}

		return null ;
	},

	Reset : function()
	{
		this._State = 0 ;
	}
};

function sbBtnStat()
{
	sbHideMsgDiv();
	sbGetE('btnReplace').disabled =
	sbGetE('btnReplaceAll').disabled =
	sbGetE('btnFind').disabled =
	( sbGetE('txtFind').value.length == 0 ) ;
}

function sbBtnStatDelayed()
{
	setTimeout( sbBtnStat, 1 ) ;
}

function GetSearchString()
{
	return sbGetE('txtFind').value ;
}

function GetReplaceString()
{
	return sbGetE('txtReplace').value ;
}

function GetCheckCase()
{
	return !! ( sbGetE('chkCase').checked ) ;
}

function GetMatchWord()
{
	return !! ( sbGetE('chkWord').checked ) ;
}

function CheckIsWordSeparator( c )
{
	var code = c.charCodeAt( 0 );
	if ( code >= 9 && code <= 0xd )
		return true;
	if ( code >= 0x2000 && code <= 0x200a )
		return true;
	switch ( code )
	{
		case 0x20:
		case 0x85:
		case 0xa0:
		case 0x1680:
		case 0x180e:
		case 0x2028:
		case 0x2029:
		case 0x202f:
		case 0x205f:
		case 0x3000:
			return true;
		default:
	}
	return /[.,"'?!;:]/.test( c ) ;
}

FindRange = null ;
function _Find()
{
	var searchString = GetSearchString() ;
	if ( !FindRange )
		FindRange = new CharacterRange( new CharacterCursor( wnd.sbEditorArea ), searchString.length ) ;
	else
	{
		FindRange.RemoveHighlight() ;
		FindRange = FindRange.GetNextRange( searchString.length ) ;
	}
	var matcher = new KmpMatch( searchString, ! GetCheckCase() ) ;
	var matchState = KMP_NOMATCH ;
	var character = '%' ;

	while ( character != null )
	{
		while ( ( character = FindRange.GetEndCharacter() ) )
		{
			matchState = matcher.FeedCharacter( character ) ;
			if ( matchState == KMP_MATCHED )
				break ;
			if ( FindRange.MoveNext() )
				matcher.Reset() ;
		}

		if ( matchState == KMP_MATCHED )
		{
			if ( GetMatchWord() )
			{
				var cursors = FindRange.GetCursors() ;
				var head = cursors[ cursors.length - 1 ].Clone() ;
				var tail = cursors[0].Clone() ;
				if ( !head.MoveNext() && !CheckIsWordSeparator( head.GetCharacter() ) )
					continue ;
				if ( !tail.MoveBack() && !CheckIsWordSeparator( tail.GetCharacter() ) )
					continue ;
			}

			FindRange.Highlight() ;
			return true ;
		}
	}

	FindRange = null ;
	return false ;
}

function sbFind()
{
	sbHideMsgDiv();
	if ( ! _Find() )
		sbShowMsgDiv("<?php echo EDITOR_FINDDLG_NOTFOUND_MSG; ?>", "information.png") ;
}

function sbReplace()
{
	sbHideMsgDiv();
	var saveUndoStep = function( selectRange )
	{
		var ieRange ;
		if ( _isIE )
			ieRange = document.selection.createRange() ;

		selectRange._Select() ;
		wnd.sbEditorUndo._SaveUndoStep() ;
		var cloneRange = selectRange._Clone() ;
		cloneRange._Collapse( false ) ;
		cloneRange._Select() ;

		if ( ieRange )
			setTimeout( function(){ ieRange.select() ; }, 1 ) ;
	}

	if ( FindRange && FindRange.GetHighlightDomRange() )
	{
		var range = FindRange.GetHighlightDomRange() ;
		var bookmark = range._CreateBookmark() ;
		FindRange.RemoveHighlight() ;
		range._MoveToBookmark( bookmark ) ;

		saveUndoStep( range ) ;
		range._DeleteContents() ;
		range._InsertNode( wnd.sbEditorAreaDoc.createTextNode( GetReplaceString() ) ) ;
		range._UpdateElementInfo() ;

		FindRange = CharacterRange.CreateFromDomRange( range ) ;
	}
	
	if ( ! _Find() )
	{
		FindRange && FindRange.RemoveHighlight() ;
		sbShowMsgDiv("<?php echo EDITOR_FINDDLG_NOTFOUND_MSG; ?>", "information.png") ;
	}
}

function sbReplaceAll()
{
	sbHideMsgDiv();
	
	var replaceCount = 0 ;

	while ( _Find() )
	{
	    if (replaceCount == 0)
	    	wnd.sbEditorUndo._SaveUndoStep() ;
	    	
		var range = FindRange.GetHighlightDomRange() ;
		var bookmark = range._CreateBookmark() ;
		FindRange.RemoveHighlight() ;
		range._MoveToBookmark( bookmark) ;

		range._DeleteContents() ;
		range._InsertNode( wnd.sbEditorAreaDoc.createTextNode( GetReplaceString() ) ) ;
		range._UpdateElementInfo() ;

		FindRange = CharacterRange.CreateFromDomRange( range ) ;
		replaceCount++ ;
	}
	
	if ( replaceCount != 0 )
	{
		var str = new String("<?php echo EDITOR_FINDDLG_REPLACE_MSG; ?>");
	    sbShowMsgDiv(str.replace("%s", replaceCount), "information.png");
	}
	else
	{
		sbShowMsgDiv("<?php echo EDITOR_FINDDLG_NOTFOUND_MSG; ?>", "information.png") ;
	}
}

window.onunload = function()
{
	if ( FindRange )
	{
		FindRange.RemoveHighlight() ;
		FindRange.ToDomRange()._Select() ;
	}
	
	wnd.sbEditorFocus();
}

<?php require_once(dirname(__FILE__).'/../jfooter.inc.php'); ?>