<?php require_once(dirname(__FILE__).'/../jheader.inc.php'); ?>

var wnd = (_isIE ? dialogArguments : window.opener.sbModalDialog.args);
var oLink = wnd.sbEditorSelection._MoveToAncestorNode( 'A' ) ;
if ( oLink )
	wnd.sbEditorSelection._SelectNode( oLink ) ;

var oParser = new Object() ;

oParser.SortNumerical = function(a, b)
{
	return parseInt( a, 10 ) - parseInt( b, 10 ) ;
}

oParser.ParseEMailParams = function(sParams)
{
	var oEMailParams = new Object() ;
	oEMailParams.Subject = '' ;
	oEMailParams.Body = '' ;

	var aMatch = sParams.match( /(^|^\?|&)subject=([^&]+)/i ) ;
	if ( aMatch ) oEMailParams.Subject = decodeURIComponent( aMatch[2] ) ;

	aMatch = sParams.match( /(^|^\?|&)body=([^&]+)/i ) ;
	if ( aMatch ) oEMailParams.Body = decodeURIComponent( aMatch[2] ) ;

	return oEMailParams ;
}

oParser.ParseEMailUri = function( sUrl )
{
	var oEMailInfo = new Object() ;
	oEMailInfo.Address = '' ;
	oEMailInfo.Subject = '' ;
	oEMailInfo.Body = '' ;

	var aLinkInfo = sUrl.match( /^(\w+):(.*)$/ ) ;
	if ( aLinkInfo && aLinkInfo[1] == 'mailto' )
	{
		var aParts = aLinkInfo[2].match( /^([^\?]+)\??(.+)?/ ) ;
		if ( aParts )
		{
			oEMailInfo.Address = aParts[1] ;

			if ( aParts[2] )
			{
				var oEMailParams = oParser.ParseEMailParams( aParts[2] ) ;
				oEMailInfo.Subject = oEMailParams.Subject ;
				oEMailInfo.Body = oEMailParams.Body ;
			}
		}
		return oEMailInfo ;
	}
	
	return false;
}

oParser.CreateEMailUri = function( address, subject, body )
{
	var sBaseUri = 'mailto:' + address ;
	var sParams = '' ;

	if ( subject.length > 0 )
		sParams = '?subject=' + encodeURIComponent( subject ) ;

	if ( body.length > 0 )
	{
		sParams += ( sParams.length == 0 ? '?' : '&' ) ;
		sParams += 'body=' + encodeURIComponent( body ) ;
	}

	return sBaseUri + sParams ;
}

window.onload = function()
{
	LoadAnchorNamesAndIds() ;
	LoadSelection() ;

	SetLinkType( sbGetE('cmbLinkType').value ) ;

	switch( sbGetE('cmbLinkType').value )
	{
		case 'url' :
			sbSelectField( 'txtUrl' ) ;
			break ;
			
		case 'popup' :
			sbSelectField( 'txtPopup' ) ;
			break ;
		
		case 'file':
			sbSelectField( 'txtFile' ) ;
			break;
				
		case 'email' :
			sbSelectField( 'txtEMailAddress' ) ;
			break ;
			
		case 'anchor' :
			if ( sbGetE('divSelAnchor').style.display != 'none' )
				sbSelectField( 'cmbAnchorName' ) ;
			else
				sbSelectField( 'cmbLinkType' ) ;
	}
}

function LoadAnchorNamesAndIds()
{
	var bHasAnchors = false ;
	var aAnchors = new Array() ;
	var i ;
	var oImages = wnd.sbEditorArea.getElementsByTagName( 'IMG' ) ;
	for( i = 0 ; i < oImages.length ; i++ )
	{
		if ( oImages[i].getAttribute('_sbanchor') )
			aAnchors[ aAnchors.length ] = wnd.sbEditorGetRealElement( oImages[i] ) ;
	}

	var oLinks = wnd.sbEditorAreaDoc.body.getElementsByTagName( 'A' ) ;
	for( i = 0 ; i < oLinks.length ; i++ )
	{
		if ( oLinks[i].name && ( oLinks[i].name.length > 0 ) )
			aAnchors[ aAnchors.length ] = oLinks[i] ;
	}
	
	var aIds = wnd.sbEditorGetAllChildrenIds( wnd.sbEditorArea ) ;

	bHasAnchors = ( aAnchors.length > 0 || aIds.length > 0 ) ;

	for ( i = 0 ; i < aAnchors.length ; i++ )
	{
		var sName = aAnchors[i].name ;
		if ( sName && sName.length > 0 )
			AddSelectOption( sbGetE('cmbAnchorName'), sName, sName ) ;
	}

	for ( i = 0 ; i < aIds.length ; i++ )
	{
		AddSelectOption( sbGetE('cmbAnchorId'), aIds[i], aIds[i] ) ;
	}

	ShowE( 'divSelAnchor', bHasAnchors ) ;
	ShowE( 'divNoAnchor', !bHasAnchors ) ;
	ShowE( 'anchor_name_tr', bHasAnchors && aAnchors.length > 0 );
	ShowE( 'anchor_id_tr', bHasAnchors && aIds.length > 0 );
}

function LoadSelection()
{
	if ( !oLink ) return ;

	var sType = 'url' ;

	var sHRef = oLink.getAttribute( '_sbsavedurl' ) ;
	var bSBox = oLink.getAttribute( 'rel' ) ;
	if (bSBox == 'shadowbox')
		bSBox = true;
	else
		bSBox = false;
		
	if ( sHRef == null )
		sHRef = oLink.getAttribute( 'href' , 2 ) || '' ;
		
	var oEMailInfo = oParser.ParseEMailUri( sHRef );

	if ( oEMailInfo )
	{
		sType = 'email' ;

		GetE('txtEMailAddress').value = oEMailInfo.Address ;
		GetE('txtEMailSubject').value = oEMailInfo.Subject ;
		GetE('txtEMailBody').value = oEMailInfo.Body ;
	}
	else if ( sHRef.substr(0,1) == '#' && sHRef.length > 1 )
	{
		sType = 'anchor' ;
		sbGetE('cmbAnchorName').value = sbGetE('cmbAnchorId').value = sHRef.substr(1) ;
	}
	else					
	{
		var r = sHRef.match(/[\s]*sbPopupImg[\s]*\([\s]*['|"](.*)['|"].*['|"](.*)['|"]/);
		if (r)
		{
			sType = 'popup' ;
			sbGetE('txtPopup').value = r[1];
			var imageTitle = new String(r[2]);
			imageTitle = imageTitle.replace(/##/g, '"');
	    	imageTitle = imageTitle.replace(/\^\^/g, "'");
			sbGetE('txtPopupTitle').value = imageTitle;
		}
		else
		{
			var r = sHRef.match(/(.html|.htm|.php|.xml|.rss)$/);
			if (r)
			{
				sType = 'url';
				sbGetE('txtUrl').value = sHRef ;
			}
			else
			{
				if (bSBox)
				{
					r = sHRef.match(/(.jpg|.gif|.jpeg|.png)$/);
					if (r)
					{
						sType = 'popup';
						sbGetE('txtPopup').value = sHRef;
					}
					else
					{
						sType = 'file';
						sbGetE('txtFile').value = sHRef ;
					}
				}
				
				sType = 'file';
				sbGetE('txtFile').value = sHRef ;
			}
		}
	}

	var sTarget = oLink.target ;

	if ( sTarget && sTarget.length > 0 )
	{
		sTarget = sTarget.toLowerCase() ;
		sbGetE('cmbTarget').value = sTarget ;
	}

	sbGetE('txtAttId').value = oLink.id ;
	sbGetE('txtAttName').value = oLink.name ;
	sbGetE('txtAttTitle').value = oLink.title ;

	var sClass ;
	if ( _isIE )
	{
		sClass = oLink.getAttribute('className',2) || '' ;
		sClass = sClass.replace( wnd.sbEditorRegexLib.SB_Class, '' ) ;
		sbGetE('txtAttStyle').value	= oLink.style.cssText ;
	}
	else
	{
		sClass	= oLink.getAttribute('class',2) || '' ;
		sbGetE('txtAttStyle').value	= oLink.getAttribute('style',2) || '' ;
	}
	sbGetE('txtAttClasses').value = sClass ;
	sbGetE('cmbLinkType').value = sType ;
	
	if ((sType == 'file' || sType == 'popup' || sType == 'url') && bSBox)
	{
		sbGetE('chkShadowbox').checked = true;
	}
}

function SetLinkType( linkType )
{
	ShowE('url_tr', (linkType == 'url') ) ;
	ShowE('file_tr', (linkType == 'file') ) ;
	ShowE('target_tr', (linkType == 'url' || linkType == 'file') && !sbGetE("chkShadowbox").checked ) ;
	ShowE('delim_tr', (linkType == 'url') || linkType == 'file' || linkType == 'popup' ) ;
	ShowE('shadowbox_tr', (linkType == 'url') || linkType == 'file' || linkType == 'popup' ) ;
	ShowE('popup_tr', (linkType == 'popup') ) ;
	ShowE('popup_title_tr', (linkType == 'popup' && !sbGetE("chkShadowbox").checked) ) ;

	ShowE('anchor_tr', (linkType == 'anchor') ) ;

	ShowE('mail_tr', (linkType == 'email') ) ;
	ShowE('mail_subj_tr', (linkType == 'email') ) ;
	ShowE('mail_text_tr', (linkType == 'email') ) ;
}

function save()
{
	var sUri, sInnerHtml ;
	wnd.sbEditorUndo._SaveUndoStep() ;
	var lType = sbGetE('cmbLinkType').value; 
	
	switch ( lType )
	{
		case 'url' :
			sUri = sbGetE('txtUrl').value ;
			if ( sUri.length == 0 )
			{
				alert( "<?php echo EDITOR_LINK_NO_URL; ?>" ) ;
				return false ;
			}
			break ;
		
		case 'popup' :
			var sPopupUrl = sbGetE('txtPopup').value.Trim() ;
			var sPopupTitle = sbGetE('txtPopupTitle').value.Trim();
			if ( sPopupUrl.length == 0 )
			{
				alert( "<?php echo EDITOR_LINK_NO_POPUP; ?>" ) ;
				return false ;
			}
				
			if (sbGetE('chkShadowbox').checked)
			{
				sUri = sPopupUrl;
			}
			else
			{
				sPopupTitle = sPopupTitle.replace(/'/g, "^^");
				sPopupTitle = sPopupTitle.replace(/"/g, "##");
				sUri = "javascript: sbPopupImg('" + sPopupUrl + "', '" + sPopupTitle + "')";
			}
			break;
			
		case 'file' :
			sUri = sbGetE('txtFile').value ;
			if ( sUri.length == 0 )
			{
				alert( "<?php echo EDITOR_LINK_NO_URL; ?>" ) ;
				return false ;
			}
			break;
			
		case 'email' :
			sUri = sbGetE('txtEMailAddress').value ;

			if ( sUri.length == 0 )
			{
				alert( "<?php echo EDITOR_LINK_NO_MAIL; ?>" ) ;
				return false ;
			}

			sUri = oParser.CreateEMailUri(
				sUri,
				sbGetE('txtEMailSubject').value,
				sbGetE('txtEMailBody').value ) ;
			break ;

		case 'anchor' :
			var sAnchor = sbGetE('cmbAnchorName').value ;
			if ( sAnchor.length == 0 ) sAnchor = sbGetE('cmbAnchorId').value ;

			if ( sAnchor.length == 0 )
			{
				alert( "<?php echo EDITOR_LINK_NO_ANCHOR; ?>" ) ;
				return false ;
			}

			sUri = '#' + sAnchor ;
			break ;
	}

	var aLinks = oLink ? [ oLink ] : wnd.sbEditorCreateLink( sUri, true ) ;
	var aHasSelection = ( aLinks.length > 0 ) ;

	if ( !aHasSelection )
	{
		sInnerHtml = sUri;

		switch ( lType )
		{
			case 'anchor':
				sInnerHtml = sInnerHtml.replace( /^#/, '' ) ;
				break ;

			case 'url':
			case 'file':
				var oLinkPathRegEx = new RegExp("//?([^?\"']+)([?].*)?$") ;
				var asLinkPath = oLinkPathRegEx.exec( sUri ) ;
				if (asLinkPath != null)
					sInnerHtml = asLinkPath[1];
				break ;

			case 'email':
				sInnerHtml = sbGetE('txtEMailAddress').value ;
				break ;
		}

		aLinks = [ wnd.sbEditorInsertElement( 'a' ) ] ;
	}

	for ( var i = 0 ; i < aLinks.length ; i++ )
	{
		oLink = aLinks[i] ;

		if ( aHasSelection )
			sInnerHtml = oLink.innerHTML ;	

		oLink.innerHTML = sInnerHtml ;

		if( sbGetE('cmbTarget').value != '' )
			sbSetAttribute( oLink, 'target', sbGetE('cmbTarget').value ) ;
		else
			sbSetAttribute( oLink, 'target', null ) ;

	    if( sbGetE('chkShadowbox').checked && (lType == 'url' || lType == 'popup' || lType == 'file') )
			sbSetAttribute( oLink, 'rel', 'shadowbox' ) ;
		else
			sbSetAttribute( oLink, 'rel', null ) ;
			
		if ( i == 0 )
			sbSetAttribute( oLink, 'id', sbGetE('txtAttId').value ) ;

		sbSetAttribute( oLink, 'name', sbGetE('txtAttName').value ) ;
		sbSetAttribute( oLink, 'title', sbGetE('txtAttTitle').value ) ;

		if ( _isIE )
		{
			var sClass = sbGetE('txtAttClasses').value ;
			if ( sbGetE('txtAttName').value.length != 0 )
				sClass += ' sb__AnchorC' ;
			sbSetAttribute( oLink, 'className', sClass ) ;

			oLink.style.cssText = sbGetE('txtAttStyle').value ;
		}
		else
		{
			sbSetAttribute( oLink, 'class', sbGetE('txtAttClasses').value ) ;
			sbSetAttribute( oLink, 'style', sbGetE('txtAttStyle').value ) ;
		}
		
		oLink.href = sUri ;
		sbSetAttribute( oLink, '_sbsavedurl', sUri ) ;
	}

	wnd.sbEditorSelection._SelectNode( aLinks[0] );
	sbCloseDialog();
}

function SetPopup()
{
	if (sbGetE("txtPopup").value.Trim() != "")
	{
		sbGetE("txtUrl").value = "";
	}
}

function SetLink()
{
	if (sbGetE("txtUrl").value.Trim() != "")
	{
		sbGetE("txtPopup").value = "";
		sbGetE("txtAttTitle").value = sbGetE("txtUrl_title").value;
	}
}

function SetShadowbox(el)
{
	if (el.checked)
	{
		ShowE('target_tr', false) ;
		ShowE('popup_title_tr', false) ;
		
	}
	else
	{
		SetLinkType(sbGetE('cmbLinkType').value);
	}
}
<?php require_once(dirname(__FILE__).'/../jfooter.inc.php'); ?>