<?php require_once(dirname(__FILE__).'/../jheader.inc.php'); ?>

String.prototype.Trim = function()
{
	return this.replace( /(^[ \t\n\r]*)|([ \t\n\r]*$)/g, '' ) ;
}

String.prototype.Replace = function( regExp, replacement, thisObj )
{
	if ( typeof replacement == 'function' )
	{
		return this.replace( regExp,
			function()
			{
				return replacement.apply( thisObj || this, arguments ) ;
			} ) ;
	}
	else
		return this.replace( regExp, replacement ) ;
}

function controlWindow( controlForm ) 
{
	this._form = controlForm;

	this.windowType = "controlWindow";
	this.noSuggestionSelection = "(<?php echo EDITOR_SPELL_NO_SUGGESTIONS; ?>)" ;
	this.suggestionList  = this._form.sugg;
	this.evaluatedText   = this._form.misword;
	this.replacementText = this._form.txtsugg;
	this.undoButton      = this._form.btnUndo;
}

var pt = controlWindow.prototype;

pt.resetForm = function() 
{
	if( this._form ) 
	{
		this._form.reset();
		this._form.btnIgnore.disabled = false;
		this._form.btnIgnoreAll.disabled = false;
		this._form.btnReplace.disabled = false;
		this._form.btnReplaceAll.disabled = false;
	}
}

pt.setSuggestedText = function() 
{
	var slct = this.suggestionList;
	var txt = this.replacementText;
	var str = "";
	if( slct.options[0].text && slct.options[0].text.Trim() != this.noSuggestionSelection.Trim() ) 
	{
		str = slct.options[slct.selectedIndex].text;
	}
	
	txt.value = str;
}

pt.selectDefaultSuggestion = function() 
{
	var slct = this.suggestionList;
	var txt = this.replacementText;
	if( slct.options.length == 0 ) 
	{
		this.addSuggestion( this.noSuggestionSelection );
	} 

	slct.options[0].selected = true;
	
	this.setSuggestedText();
}

pt.addSuggestion = function( sugg_text ) 
{
	var slct = this.suggestionList;
	if( sugg_text ) 
	{
		var i = slct.options.length;
		var newOption = new Option( sugg_text, 'sugg_text'+i );
		slct.options[i] = newOption;
	 }
}

pt.clearSuggestions = function() 
{
	var slct = this.suggestionList;
	for( var j = slct.length - 1; j > -1; j-- ) 
	{
		if( slct.options[j] ) 
		{
			slct.options[j] = null;
		}
	}
}

pt.enableUndo = function() 
{
	if( this.undoButton ) 
	{
		if( this.undoButton.disabled == true ) 
		{
			this.undoButton.disabled = false;
		}
	}
}

pt.disableUndo = function() 
{
	if( this.undoButton ) 
	{
		if( this.undoButton.disabled == false ) 
		{
			this.undoButton.disabled = true;
		}
	}
}

function wordWindow() 
{
	this.wordChar = /[a-zA-Z<?php echo $GLOBALS['sb_reg_lower_interval'].$GLOBALS['sb_reg_upper_interval']; ?>]/;
	this.windowType = "wordWindow";
	this.originalSpellings = [];
	this.suggestions = [];
	this.checkWordBgColor = "pink";
	this.normWordBgColor = "white";
	this.text = "";
	this.textInput = "";
	this.indexes = [];
	this.cur_i = 0;
	this.cur_j = 0;
}

var pt = wordWindow.prototype;

pt.totalWords = function() 
{
	return this.indexes.length;
}

pt.totalPreviousWords = function( wordIndex ) 
{
	var total_words = 0;
	for( var i = 0; i < this.totalWords(); i++ ) 
	{
		if( i == wordIndex ) 
		{
			break;
		} 
		else 
		{
			total_words++;
		}
	}
	
	return total_words;
}

pt.getTextVal = function( wordIndex ) 
{
	var word = this._getWordObject( wordIndex );
	if( word ) 
	{
		return word.value;
	}
}

pt.setFocus = function( wordIndex ) 
{
	var word = this._getWordObject( wordIndex );
	if( word ) 
	{
		if( word.type == "text" ) 
		{
			word.focus();
			word.style.backgroundColor = this.checkWordBgColor;
		}
	}
}

pt.removeFocus = function( wordIndex ) 
{
	var word = this._getWordObject( wordIndex );
	if( word ) 
	{
		if( word.type == "text" ) 
		{
			word.blur();
			word.style.backgroundColor = this.normWordBgColor;
		}
	}
}

pt.setText = function( wordIndex, newText ) 
{
	var word = this._getWordObject( wordIndex );
	var beginStr;
	var endStr;
	if( word ) 
	{
		var pos = this.indexes[wordIndex]['index'];
		var oldText = word.value;
		
		beginStr = this.textInput.substring( 0, pos );
		endStr = this.textInput.substring(
			pos + oldText.length,
			this.textInput.length
		);
		
		this.textInput = beginStr + newText + endStr;

		var lengthDiff = newText.length - oldText.length;
		this._adjustIndexes( wordIndex, lengthDiff );

		word.size = newText.length;
		word.value = newText;
		this.removeFocus( wordIndex );
	}
}

pt.writeBody = function() 
{
	var d = window.document;
	var is_html = false;

	d.open();
	var wordtxt = this.textInput;
	
	if( wordtxt ) 
	{
		d.writeln( '<div class="plainText">' );
		
		var orig = this.originalSpellings;
		var j = 0;
		var output = wordtxt + " ";
		
		for( var i = 0; i < orig.length; i++ ) 
		{
			var end_idx = 0;
			var begin_idx = 0;
			this.cur_i = i;
			this.cur_j = j;

		    do
		    {
				do 
				{
					begin_idx = wordtxt.indexOf( orig[i], end_idx );
					if( begin_idx == -1 ) break;
					
					end_idx = begin_idx + orig[i].length;
	
					var before_char = wordtxt.charAt( begin_idx - 1 );
					var after_char = wordtxt.charAt( end_idx );
				} 
				while ( this._isWordChar( before_char ) || this._isWordChar( after_char ) );

				if (begin_idx != -1)
				{
					this.indexes[j] = [];
					this.indexes[j]['word'] = i;
					this.indexes[j]['index'] = begin_idx;
					this.indexes[j]['input'] = j;
					
					j++;
				}
			}
			while ( begin_idx != -1);

			var re = new RegExp("([^a-zA-Z<?php echo $GLOBALS['sb_reg_lower_interval'].$GLOBALS['sb_reg_upper_interval']; ?>]?)(" + orig[i] + ")([^a-zA-Z<?php echo $GLOBALS['sb_reg_lower_interval'].$GLOBALS['sb_reg_upper_interval']; ?>])", "g");
			output = output.Replace( re , this._wordInputStr, this);
		}

		this.indexes.sort( function( a, b )
		{
			if (a['index'] < b['index'])
				return -1;
			else if (a['index'] > b['index'])
				return 1;
			else
				return 0;
		} );
		
		d.write( output );
		d.writeln( '</div>' );
	}
	
	d.close();
}

pt._lastPos = function( idx ) 
{
	if( idx > 0 )
		return this.indexes[idx-1]['index'] + this.originalSpellings[this.indexes[idx-1]['word']].length;
	else
		return 0;
}

pt._isWordChar = function( letter ) 
{
	if( letter.search( this.wordChar ) == -1 ) 
	{
		return false;
	} 
	else 
	{
		return true;
	}
}

pt._getWordObject = function( wordIdx ) 
{
	var el = sbGetE( '_sbspell' + this.indexes[wordIdx]['input'] );
	
	return el;
}

pt._wordInputStr = function( $0, $1, $2, $3 ) 
{
	var str = '<input readonly class="blend" type="text" value="' + this.originalSpellings[this.cur_i] + '" size="' + this.originalSpellings[this.cur_i].length + '" id="_sbspell' + this.cur_j + '">';
	this.cur_j++;
	return $1 + str + $3;
}

pt._adjustIndexes = function(wordIndex, lengthDiff ) 
{
	for( var i = wordIndex + 1; i < this.indexes.length; i++ ) 
	{
		this.indexes[i]['index'] = this.indexes[i]['index'] + lengthDiff;
	}
}

<?php require_once(dirname(__FILE__).'/../jfooter.inc.php'); ?>