<?php
/**
 * Время кэширования скриптов (по умолчанию 1 день)
 */
$html = ob_get_clean();
while (ob_get_level() > 0)
{
	ob_end_clean();
}

if (!isset($GLOBALS['sb_cache_time']))
	$GLOBALS['sb_cache_time'] = 86400;

$m_file_time = @filemtime(SB_BASEDIR.$_SERVER['PHP_SELF']);
if ($m_file_time)
{
	$m_file_time = gmdate('D, d M Y H:i:s', $m_file_time).' GMT';
}
else 
{
	$m_file_time = gmdate('D, d M Y H:i:s', time()).' GMT';
}

$hash = md5($m_file_time);

if ((isset($_SERVER['HTTP_IF_NONE_MATCH']) && $_SERVER['HTTP_IF_NONE_MATCH'] == 'PUB'.$hash) || 
	(isset($_SERVER['HTTP_IF_MODIFIED_SINCE']) && $_SERVER['HTTP_IF_MODIFIED_SINCE'] == $m_file_time))
{ 
    header('HTTP/1.1 304 Not Modified');
    header('Expires: '.gmdate('D, d M Y H:i:s', time() + $GLOBALS['sb_cache_time']).' GMT');
    header('Cache-Control: private, max-age='.$GLOBALS['sb_cache_time']);
    exit(0);
}
else 
{
	header('Expires: '.gmdate('D, d M Y H:i:s', time() + $GLOBALS['sb_cache_time']).' GMT');
	header('Cache-Control: private, max-age='.$GLOBALS['sb_cache_time']);
	header('Last-Modified: '.$m_file_time);
	header('ETag: PUB'.$hash);
}

/*
 * Попробуем использовать компрессию, это должно заметно уменьшить время загрузки страницы
 */
$gzip = sbPlugins::getSetting('sb_gzip_compress');
if ($gzip && extension_loaded('zlib') && (browser_get_agent() != 'IE' || browser_get_version() >= '7.0'))
{
	if (isset($_SERVER['HTTP_USER_AGENT']) && (strstr($_SERVER['HTTP_USER_AGENT'], 'compatible') || strstr($_SERVER['HTTP_USER_AGENT'], 'Gecko')))
    {
        ob_start('ob_gzhandler');
        echo $html;
        exit(0);
    }
    elseif (isset($_SERVER['HTTP_ACCEPT_ENCODING']) && strstr($_SERVER['HTTP_ACCEPT_ENCODING'], 'gzip'))
    {
        ob_implicit_flush(0);
        ob_start();
        echo $html;
        $gzip_size = ob_get_length();
        ob_end_clean();
            
        header('Content-Encoding: gzip');
    
        echo "\x1f\x8b\x08\x00\x00\x00\x00\x00".substr(gzcompress($html, 3), 0, -4);
        echo pack('V', crc32($html));
        echo pack('V', $gzip_size);
        exit(0);
    }
}

echo $html;
exit(0);
?>