<?php require_once(dirname(__FILE__).'/jheader.inc.php'); ?>
function sbPosition(x, y)
{
  this.X = x;
  this.Y = y;
 
  this.Add = function(val)
  {
    var newPos = new sbPosition(this.X, this.Y);
    if(val != null)
    {
      if(!isNaN(val.X))
        newPos.X += val.X;
      if(!isNaN(val.Y))
        newPos.Y += val.Y
    }
    return newPos;
  }
 
  this.Subtract = function(val)
  {
    var newPos = new sbPosition(this.X, this.Y);
    if(val != null)
    {
      if(!isNaN(val.X))
        newPos.X -= val.X;
      if(!isNaN(val.Y))
        newPos.Y -= val.Y
    }
    return newPos;
  }
 
  this.Min = function(val)
  {
    var newPos = new sbPosition(this.X, this.Y)
    if(val == null)
      return newPos;
   
    if(!isNaN(val.X) && this.X> val.X)
      newPos.X = val.X;
    if(!isNaN(val.Y) && this.Y> val.Y)
      newPos.Y = val.Y;
   
    return newPos; 
  }
 
  this.Max = function(val)
  {
    var newPos = new sbPosition(this.X, this.Y)
    if(val == null)
      return newPos;
   
    if(!isNaN(val.X) && this.X <val.X)
      newPos.X = val.X;
    if(!isNaN(val.Y) && this.Y <val.Y)
      newPos.Y = val.Y;
   
    return newPos; 
  } 
 
  this.Bound = function(lower, upper)
  {
    var newPos = this.Max(lower);
    return newPos.Min(upper);
  }
 
  this.Check = function()
  {
    var newPos = new sbPosition(this.X, this.Y);
    if(isNaN(newPos.X))
      newPos.X = 0;
    if(isNaN(newPos.Y))
      newPos.Y = 0;
    return newPos;
  }
 
  this.Apply = function(element)
  {
    if(typeof(element) == "string")
      element = sbGetE(element);
    if(element == null)
      return;
    if(!isNaN(this.X))
      element.style.left = this.X + 'px';
    if(!isNaN(this.Y))
      element.style.top = this.Y + 'px'; 
  }
}

function sbDragObj(element, attachElement, lowerBound, upperBound, startCallback, moveCallback, endCallback, attachLater)
{
  if(typeof(element) == "string")
    element = sbGetE(element);
  if(element == null)
    return;
 
  if(lowerBound != null && upperBound != null)
  {
    var temp = lowerBound.Min(upperBound);
    upperBound = lowerBound.Max(upperBound);
    lowerBound = temp;
  }

  var cursorStartPos = null;
  var elementStartPos = null;
  var dragging = false;
  var listening = false;
  var disposed = false;
 
  function absoluteCursorPos(eventObj)
  {
    eventObj = eventObj ? eventObj : window.event;
 
    if(isNaN(window.scrollX))
      return new sbPosition(eventObj.clientX +
                document.documentElement.scrollLeft +
                document.body.scrollLeft,
                eventObj.clientY +
                document.documentElement.scrollTop +
                document.body.scrollTop);
    else
      return new sbPosition(eventObj.clientX + window.scrollX,
                eventObj.clientY + window.scrollY);
  }

  function dragStart(eventObj)
  {
    if(dragging || !listening || disposed) return;
    dragging = true;
   
    if(startCallback != null)
      startCallback(eventObj, element);
   
    cursorStartPos = absoluteCursorPos(eventObj);
    elementStartPos = new sbPosition(parseInt(element.style.left), parseInt(element.style.top));
   
    elementStartPos = elementStartPos.Check();
   
    sbAddEvent(document, "mousemove", dragGo);
    sbAddEvent(document, "mouseup", dragStopHook);
   
    return sbCancelEvent(eventObj);
  }
 
  function dragGo(eventObj)
  {
    if(!dragging || disposed) return;
   
    var newPos = absoluteCursorPos(eventObj);
    newPos = newPos.Add(elementStartPos)
    newPos = newPos.Subtract(cursorStartPos);
    newPos = newPos.Bound(lowerBound, upperBound)
    newPos.Apply(element);
    if(moveCallback != null)
      moveCallback(newPos, element);
       
    return sbCancelEvent(eventObj);
  }
 
  function dragStopHook(eventObj)
  {
    dragStop();
    return sbCancelEvent(eventObj);
  }
 
  function dragStop()
  {
    if(!dragging || disposed) return;
    
    sbRemoveEvent(document, "mousemove", dragGo);
    sbRemoveEvent(document, "mouseup", dragStopHook);
    
    cursorStartPos = null;
    elementStartPos = null;
    if(endCallback != null)
      endCallback(element);
    dragging = false;
  }
 
  this.Dispose = function()
  {
    if(disposed) return;
    this.stopListening(true);
    element = null;
    attachElement = null
    lowerBound = null;
    upperBound = null;
    startCallback = null;
    moveCallback = null
    endCallback = null;
    disposed = true;
  }
 
  this.startListening = function()
  {
    if(listening || disposed) return;
    listening = true;
    sbAddEvent(attachElement, "mousedown", dragStart);
  }
 
  this.stopListening = function(stopCurrentDragging)
  {
    if(!listening || disposed) return;
    sbRemoveEvent(attachElement, "mousedown", dragStart);
    listening = false;
   
    if(stopCurrentDragging && dragging)
      dragStop();
  }
 
  this.isDragging = function(){ return dragging; }
  this.isListening = function() { return listening; }
  this.isDisposed = function() { return disposed; }
 
  if(typeof(attachElement) == "string")
    attachElement = sbGetE(attachElement);
  if(attachElement == null)
    attachElement = element;
   
  if(!attachLater)
    this.startListening();
}
<?php require_once(dirname(__FILE__).'/jfooter.inc.php'); ?>