<?php require_once(dirname(__FILE__).'/jheader.inc.php'); ?>
// вспомогательные функции
function sbGetElementDocument ( el )
{
	return el.ownerDocument || el.document ;
}

function sbGetElementWindow ( el )
{
	return sbGetDocumentWindow( sbGetElementDocument( el ) ) ;
}

function sbGetDocumentWindow ( doc )
{
	if ( _isSafari && !document.parentWindow )
		sbFixDocumentParentWindow( window.top ) ;

	return document.parentWindow || document.defaultView ;
}

function sbFixDocumentParentWindow ( wnd )
{
	if ( wnd.document )
		wnd.document.parentWindow = wnd ;

	for ( var i = 0 ; i < wnd.frames.length ; i++ )
		sbFixDocumentParentWindow( wnd.frames[i] ) ;
}

function sbDisableSelection ( el )
{
	if (_isIE)
	{
		el.unselectable = 'on' ;
	
		var e, i = 0 ;
		while ( (e = el.all[ i++ ]) )
		{
			switch ( e.tagName )
			{
				case 'IFRAME' :
				case 'TEXTAREA' :
				case 'INPUT' :
				case 'SELECT' :
					break ;
					
				default :
					e.unselectable = 'on' ;
			}
		}
	}
	else if (_isSafari)
	{
		el.style.KhtmlUserSelect = 'none' ;
	}
	else if (_isFF)
	{
		el.style.MozUserSelect = 'none' ;
	}
	else
	{
		el.style.userSelect = 'none' ;	
	}
}

function sbIsStrictMode ( document )
{
	return ( 'CSS1Compat' == ( document.compatMode || ( _isSafari ? 'CSS1Compat' : null ) ) ) ;
}

function sbGetPositionedAncestor ( el )
{
	while ( el != sbGetElementDocument( el ).documentElement )
	{
		if ( el.style.position != 'static' )
			return el ;

		el = el.parentNode ;
	}

	return null ;
}
	
function sbGetViewPaneSize ( wnd )
{
	if (_isIE)
	{
		var oSizeSource ;
	
		var oDoc = wnd.document.documentElement ;
		if ( oDoc && oDoc.clientWidth )				
			oSizeSource = oDoc ;
		else
			oSizeSource = wnd.document.body ;		
	
		if ( oSizeSource )
			return { Width : oSizeSource.clientWidth, Height : oSizeSource.clientHeight } ;
		else
			return { Width : 0, Height : 0 } ;
	}
	else
	{
		return { Width : wnd.innerWidth, Height : wnd.innerHeight } ;
	}
}

function sbGetScrollPosition ( wnd )
{
	if (_isIE)
	{
		var oDoc = wnd.document ;
	
		var oPos = { X : oDoc.documentElement.scrollLeft, Y : oDoc.documentElement.scrollTop } ;
	
		if ( oPos.X > 0 || oPos.Y > 0 )
			return oPos ;
	
		return { X : oDoc.body.scrollLeft, Y : oDoc.body.scrollTop } ;
	}
	else
	{
		return { X : wnd.pageXOffset, Y : wnd.pageYOffset } ;
	}
}

function sbGetDocumentPosition ( w, node )
{
	var x = 0 ;
	var y = 0 ;
	var curNode = node ;
	var prevNode = null ;
	var curWindow = sbGetElementWindow( curNode ) ;
	while ( curNode && !( curWindow == w && ( curNode == w.document.body || curNode == w.document.documentElement ) ) )
	{
		x += curNode.offsetLeft - curNode.scrollLeft ;
		y += curNode.offsetTop - curNode.scrollTop ;

		if ( !_isOpera )
		{
			var scrollNode = prevNode ;
			while ( scrollNode && scrollNode != curNode )
			{
				x -= scrollNode.scrollLeft ;
				y -= scrollNode.scrollTop ;
				scrollNode = scrollNode.parentNode ;
			}
		}

		prevNode = curNode ;
		if ( curNode.offsetParent )
			curNode = curNode.offsetParent ;
		else
		{
			if ( curWindow != w )
			{
				curNode = curWindow.frameElement ;
				prevNode = null ;
				if ( curNode )
					curWindow = curNode.contentWindow.parent ;
			}
			else
				curNode = null ;
		}
	}

	if ( w.document.body.style.position != 'static' || ( _isIE && sbGetPositionedAncestor( node ) == null ) )
	{
		x += w.document.body.offsetLeft ;
		y += w.document.body.offsetTop ;
	}

	return { "x" : x, "y" : y } ;
}

function sbFixCssUrls ( prefix, css )
{
	if ( !prefix || prefix.length == 0 )
		return css ;

	return css.replace( /url\s*\(([\s'"]*)(.*?)([\s"']*)\)/g, function( match, opener, path, closer )
		{
			if ( /^\/|^\w?:/.test( path ) )
				return match ;
			else
				return 'url(' + opener + prefix + path + closer + ')' ;
		} ) ;
}

function sbGetUrlFixedCss ( css, prefix )
{
	var match = css.match( /^([^|]+)\|([\s\S]*)/ ) ;

	if ( match )
		return sbFixCssUrls( match[1], match[2] ) ;
	else
		return css ;
}

function sbAppendStyleSheetHelper ( doc, css )
{
	if (_isIE)
	{
		return doc.createStyleSheet( css ).owningElement ;
	}
	else
	{
		var e = doc.createElement( 'LINK' ) ;
		e.rel = 'stylesheet' ;
		e.type = 'text/css' ;
		e.href = css ;
		doc.getElementsByTagName("HEAD")[0].appendChild( e ) ;
		return e ;
	}
}

function sbAppendStyleString ( doc, css )
{
	if ( !css )
		return null ;

	if (_isIE)
	{
		var s = doc.createStyleSheet( "" ) ;
		s.cssText = css ;
		return s ;
	}
	else
	{
		var e = doc.createElement( "STYLE" ) ;
		e.appendChild( doc.createTextNode( css ) ) ;
		doc.getElementsByTagName( "HEAD" )[0].appendChild( e ) ;
		return e ;
	}
}

function sbAppendStyleSheet ( doc, css )
{
	if ( !css )
		return [] ;

	if ( typeof( css ) == 'string' )
	{
		if ( /[\\\/\.][^{}]*$/.test( css ) )
		{
			return sbAppendStyleSheet( doc, css.split(',') ) ;
		}
		else
		{
			return [ sbAppendStyleString( doc, sbGetUrlFixedCss( css ) ) ] ;
		}
	}
	else
	{
		var styles = [] ;
		for ( var i = 0 ; i < css.length ; i++ )
			styles.push( sbAppendStyleSheetHelper( doc, css[i] ) );
			
		return styles ;
	}
}

function sbResetStyles ( el )
{
	el.style.cssText = 'margin:0;padding:0;border:0;background-color:transparent;background-image:none;' ;
}

// выпадающая панель
var sbPanel = function( parentWindow )
{
	this._Window = parentWindow || window ;
	var oDocument ;

	if ( _isIE )
	{
		this._Popup	= this._Window.createPopup() ;
		oDocument = this._Document = this._Popup.document ;
	}
	else
	{
		var oIFrame = this._IFrame = this._Window.document.createElement('iframe') ;
		sbResetStyles( oIFrame );
		oIFrame.src	= 'javascript:void(0)' ;
		oIFrame.allowTransparency = true ;
		oIFrame.frameBorder	= '0' ;
		oIFrame.scrolling = 'no' ;
		oIFrame.style.width = oIFrame.style.height = '0px' ;
		oIFrame.style.position = 'absolute';
		oIFrame.style.zIndex = 100000;
		
		this._Window.document.body.appendChild( oIFrame ) ;

		var oIFrameWindow = oIFrame.contentWindow ;

		oDocument = this._Document = oIFrameWindow.document ;

		var base = '' ;
		if ( _isSafari )
			base = '<base href="' + window.document.location + '">' ;

		oDocument.open() ;
		oDocument.write( '<html><head>' + base + '<link rel="stylesheet" type="text/css" href="<?php echo SB_CMS_CSS_URL; ?>/sbSpecialCombo.css"><\/head><body style="margin:0px;padding:0px;"><\/body><\/html>' ) ;
		oDocument.close() ;

		sbAddEvent( oIFrameWindow, 'focus', new sbCallerFunction(this._OnFocus, this) ) ;
		sbAddEvent( oIFrameWindow, 'blur', new sbCallerFunction(this._OnBlur, this) ) ;
	}

	this._MainNode = oDocument.body.appendChild( oDocument.createElement('DIV') ) ;
	this._MainNode.style.cssFloat = 'left' ;
}

var pt = sbPanel.prototype;
var sbOpenedPanel = null;

pt._OnFocus = function( panel )
{
	panel._HasFocus = true ;
}

pt._OnBlur = function ( panel )
{
	panel._HasFocus = false ;

	setTimeout(new sbCallerFunction(panel._Hide, panel), 0);
}

pt._AppendStyleSheet = function( css )
{
	sbAppendStyleSheet( this._Document, css ) ;
}

pt._Preload = function( x, y, el )
{
	if ( this._Popup )
		this._Popup.show( x, y, 0, 0, el ) ;
}

pt._Show = function( x, y, el, width, height )
{
	var iMainWidth ;
	var eMainNode = this._MainNode ;

	if ( this._Popup )
	{
		this._Popup.show( x, y, 0, 0, el ) ;

		eMainNode.style.width = width ? width + 'px' : '';
		eMainNode.style.height = height ? height + 'px' : '';

		iMainWidth = eMainNode.offsetWidth ;

		this._Popup.show( x, y, iMainWidth, eMainNode.offsetHeight, el ) ;
	}
	else
	{
		if ( sbOpenedPanel && sbOpenedPanel != this )
			sbOpenedPanel._Hide() ;

		eMainNode.style.width = width ? width + 'px' : '';
		eMainNode.style.height = height ? height + 'px' : '';

		iMainWidth = eMainNode.offsetWidth ;

		if ( !width ) this._IFrame.width = 1 ;
		if ( !height ) this._IFrame.height = 1 ;

		iMainWidth = eMainNode.offsetWidth || eMainNode.firstChild.offsetWidth ;

		var oPos = sbGetDocumentPosition( this._Window, el.nodeType == 9 ? ( sbIsStrictMode( el ) ? el.documentElement : el.body ) : el ) ;

		var positionedAncestor = sbGetPositionedAncestor( this._IFrame.parentNode ) ;
		if ( positionedAncestor )
		{
			var nPos = sbGetDocumentPosition( sbGetElementWindow( positionedAncestor ), positionedAncestor ) ;
			oPos.x -= nPos.x ;
			oPos.y -= nPos.y ;
		}

		x += oPos.x ;
		y += oPos.y ;

		var oViewPaneSize = sbGetViewPaneSize( this._Window ) ;
		var oScrollPosition = sbGetScrollPosition( this._Window ) ;

		var iViewPaneHeight	= oViewPaneSize.Height + oScrollPosition.Y ;
		var iViewPaneWidth	= oViewPaneSize.Width + oScrollPosition.X ;

		if ( ( x + iMainWidth ) > iViewPaneWidth )
			x -= x + iMainWidth - iViewPaneWidth ;

		if ( ( y + eMainNode.offsetHeight ) > iViewPaneHeight )
			y -= y + eMainNode.offsetHeight - iViewPaneHeight ;

		this._IFrame.style.left = x + 'px';
		this._IFrame.style.top = y + 'px';

		this._IFrame.contentWindow.focus() ;
		this._IsOpened = true ;

		var me = this ;
		this._resizeTimer = setTimeout( function()
			{
				var iWidth = eMainNode.offsetWidth || eMainNode.firstChild.offsetWidth ;
				var iHeight = eMainNode.offsetHeight ;
				me._IFrame.style.width = iWidth + 'px' ;
				me._IFrame.style.height = iHeight + 'px' ;

			}, 0 ) ;

		sbOpenedPanel = this;
	}
}

pt._Hide = function( panel )
{
	panel = panel || this;
	
	if ( panel._Popup )
		panel._Popup.hide() ;
	else
	{
		if ( !panel._IsOpened )
			return ;

		panel._IFrame.style.width = panel._IFrame.style.height = '0px' ;
		panel._IsOpened = false ;

		if ( panel._resizeTimer )
		{
			clearTimeout( panel._resizeTimer ) ;
			panel._resizeTimer = null ;
		}
	}
}

// сам компонент ComboBox
var sbSpecialCombo = function( caption, fieldWidth, panelWidth, panelMaxHeight, parentWindow )
{
	// свойства по умолчанию
	this._FieldWidth = fieldWidth || 100 ;
	this._PanelWidth = panelWidth || 150 ;
	this._PanelMaxHeight = panelMaxHeight || 150 ;
	this._Label = '&nbsp;' ;
	this._Caption = caption ;
	this._Enabled = true ;

	this._Items = new Object() ;

	this._Panel = new sbPanel( parentWindow || window ) ;
	this._Panel._AppendStyleSheet( '<?php echo SB_CMS_CSS_URL; ?>/sbSpecialCombo.css' ) ;
	this._PanelBox = this._Panel._MainNode.appendChild( this._Panel._Document.createElement( 'DIV' ) ) ;
	this._PanelBox.className = 'sb_panel' ;
	this._PanelBox.style.width = this._PanelWidth + 'px' ;

	this._PanelBox.innerHTML = '<table cellpadding="0" cellspacing="0" width="100%" style="TABLE-LAYOUT: fixed"><tr><td nowrap></td></tr></table>' ;

	this._ItemsHolderEl = this._PanelBox.getElementsByTagName('TD')[0] ;
}

var pt = sbSpecialCombo.prototype;

pt._ClearItems = function ()
{with(this){
	
	if ( _Items )
		_Items = {} ;

	var ih = _ItemsHolderEl ;
	while ( ih.firstChild )
		ih.removeChild( ih.firstChild ) ;
}}

pt._AddItem = function( id, html, label, bgColor )
{
	var oDiv = this._ItemsHolderEl.appendChild( this._Panel._Document.createElement( 'DIV' ) ) ;
	oDiv.className = oDiv.originalClass = 'sb_item' ;
	oDiv.innerHTML = html ;
	oDiv.itemLabel = label || id ;
	oDiv._Selected = false ;

	if ( _isIE )
		oDiv.style.width = '100%' ;

	if ( bgColor )
		oDiv.style.backgroundColor = bgColor ;

	sbAddEvent( oDiv, 'mouseover', new sbCallerFunction(this._ItemOver, this, oDiv) ) ;
	sbAddEvent( oDiv, 'mouseout', new sbCallerFunction(this._ItemOut, this, oDiv) ) ;
	
	var param = new Object();
	param.id = id;
	param.el = oDiv;
	sbAddEvent( oDiv, 'click', new sbCallerFunction(this._ItemClick, this, param) ) ;

	this._Items[ id.toString().toLowerCase() ] = oDiv ;

	return oDiv ;
}

pt._ItemOver = function ( obj, el )
{
	el.className += ' sb_itemover' ;
}

pt._ItemOut = function ( obj, el )
{
	el.className = el.originalClass ;
}

pt._ItemClick = function ( obj, param )
{with(obj){

	param.el.className = param.el.originalClass ;

	_Panel._Hide() ;
	_SetLabel( param.el.itemLabel ) ;

	if ( typeof( _OnSelect ) == 'function' )
		_OnSelect( param.id, param.el ) ;
}}

pt._SelectItem = function( item )
{
	if ( typeof(item) == 'string' )
	{
		item = this._Items[ item.toString().toLowerCase() ] ;
	}
	
	if ( item )
	{
		item.className = item.originalClass = 'sb_itemselected' ;
		item._Selected = true ;
	}
}

pt._SelectItemByLabel = function( label, setLabel )
{
	for ( var id in this._Items )
	{
		var oDiv = this._Items[id] ;

		if ( oDiv.itemLabel == label )
		{
			oDiv.className = oDiv.originalClass = 'sb_itemselected' ;
			oDiv._Selected = true ;

			if ( setLabel )
				this._SetLabel( label ) ;
		}
	}
}

pt._DeselectAll = function( clearLabel )
{with(this){
	for ( var i in _Items )
	{
		if ( !_Items[i] ) 
			continue;
			
		_Items[i].className = _Items[i].originalClass = 'sb_item' ;
		_Items[i]._Selected = false ;
	}

	if ( clearLabel )
		_SetLabel( '' ) ;
}}

pt._SetLabelById = function( id )
{
	id = id ? id.toString().toLowerCase() : '' ;

	var oDiv = this._Items[ id ] ;
	this._SetLabel( oDiv ? oDiv.itemLabel : '' ) ;
}

pt._SetLabel = function( text )
{
	text = ( !text || text.length == 0 ) ? '&nbsp;' : text ;

	if ( text == this._Label )
		return ;

	this._Label = text ;

	var labelEl = this._LabelEl ;
	if ( labelEl )
	{
		labelEl.innerHTML = text ;
		sbDisableSelection( labelEl ) ;
	}
}

pt._SetEnabled = function( on )
{
	this._Enabled = on ;

	if ( this._OuterTable )
		this._OuterTable.className = on ? '' : 'sb_fielddisabled' ;
}

pt._Create = function( el )
{
	var oDoc = sbGetElementDocument( el ) ;
	var eOuterTable = this._OuterTable = el.appendChild( oDoc.createElement( 'TABLE' ) ) ;

	eOuterTable.cellPadding = 0 ;
	eOuterTable.cellSpacing = 0 ;
	eOuterTable.insertRow(-1) ;

	if ( this._Caption && this._Caption.length > 0 )
	{
		var oCaptionCell = eOuterTable.rows[0].insertCell(-1) ;
		oCaptionCell.innerHTML = this._Caption ;
		oCaptionCell.className = 'sb_fieldcaption' ;
	}

	var oFieldCell = eOuterTable.rows[0].insertCell(-1);
	var oField = oFieldCell.appendChild( oDoc.createElement( 'DIV' ) ) ;
	oField.className = 'sb_field' ;
	oField.style.width = this._FieldWidth + 'px' ;
	oField.innerHTML = '<table width="100%" cellpadding="0" cellspacing="0" style="TABLE-LAYOUT: fixed;"><tbody><tr><td class="sb_fieldLabel"><label>&nbsp;</label></td><td class="sb_fieldbutton">&nbsp;</td></tr></tbody></table>' ;

	this._LabelEl = oField.getElementsByTagName('label')[0] ;
	this._LabelEl.innerHTML = this._Label ;

	sbAddEvent( oField, 'mouseover', new sbCallerFunction(this._Over, this, oField) ) ;
	sbAddEvent( oField, 'mouseout', new sbCallerFunction(this._Out, this, oField) ) ;
	sbAddEvent( oField, 'click', new sbCallerFunction(this._Click, this, oField) ) ;

	sbDisableSelection( this._Panel._Document.body ) ;
}

pt._Over = function ( obj, el )
{
	if ( obj._Enabled )
	{
		el.className = 'sb_field sb_fieldover' ;
	}
}

pt._Out = function ( obj, el )
{
	el.className='sb_field' ;
}

pt._Click = function ( obj, el )
{with(obj){
	if ( _Enabled )
	{
	    var j = 0;
	    for ( var i in _Items )
	    {
	    	j++;
	    }
	    
	    if (j == 0)
	    	return;
	    	
		if ( _OnBeforeClick )
			_OnBeforeClick( obj ) ;

		if ( _isIE )
			_Panel._Preload( 0, el.offsetHeight, el ) ;

		if ( _ItemsHolderEl.offsetHeight > _PanelMaxHeight )
			_PanelBox.style.height = _PanelMaxHeight + 'px' ;
		else
			_PanelBox.style.height = '' ;

		_Panel._Show( 0, el.offsetHeight, el ) ;
	}
}}

<?php require_once(dirname(__FILE__).'/jfooter.inc.php'); ?>