<?php
define('SB_CRON', true);

require_once(dirname(__FILE__).'/prog/header.inc.php');

@set_time_limit(0);

$sc_id = -1;
$cur_time = time();

$cur_y = sb_date('Y', $cur_time);
$cur_m = sb_date('n', $cur_time);
$cur_d = sb_date('j', $cur_time);
$cur_w = sb_date('w', $cur_time);
$cur_h = sb_date('G', $cur_time) + 1;

if($cur_w == 0)
{
    $cur_w = $cur_w + 7;
}

//Восстанавливаем "зависшие" задания
$res = sql_param_query('SELECT sc_id, sc_name FROM sb_cron WHERE sc_inprogress=1 AND (?d - sc_date) > sc_revoke*60', $cur_time);
$names = '';
if($res)
{
    $ids = array();
    foreach($res as $row)
    {
        $ids[] = $row[0];
        $names .= $row[1].'<br/>';
    }
    sql_param_query('UPDATE sb_cron SET sc_inprogress=0 WHERE sc_id IN (?a)', $ids, sprintf(KERNEL_PROG_PL_CRON_RESTART_MSG, $names), SB_MSG_WARNING);
}

// достаем все задания которые необходимо выполнить
$result = sql_query('SELECT sc_id, sc_name, sc_date, sc_file_path, sc_func_name, sc_time_table, sc_start_interval, sc_manual FROM sb_cron WHERE (sc_active=1 OR sc_manual=1) AND sc_inprogress=0 AND sc_id > ?d ORDER BY sc_id LIMIT 1', $sc_id);

while($result)
{
	list($sc_id, $sc_name, $sc_date, $sc_file_path, $sc_func_name, $sc_time_table, $sc_start_interval, $sc_manual) = $result[0];

	// временно отключаем задание, чтобы избежать повторного запуска
	sql_query('UPDATE sb_cron SET sc_inprogress=1 WHERE sc_id=?d', $sc_id);

	if (is_null($sc_date))
	{
		$sc_date = 0;
	}

	$sc_time_table = explode('||', $sc_time_table);

    // проверяем месяц запуска задания
    if ($sc_manual == 0) //если не ручной запуск, то выполняем необходимые проверки
    {
        $month_ar = explode(';', $sc_time_table[1]);
        if (!in_array($cur_m, $month_ar))
        {
            sql_query('UPDATE sb_cron SET sc_inprogress=0 WHERE sc_id=?d', $sc_id);
            $result = sql_query('SELECT sc_id, sc_name, sc_date, sc_file_path, sc_func_name, sc_time_table, sc_start_interval, sc_manual FROM sb_cron WHERE (sc_active=1 OR sc_manual=1) AND sc_inprogress=0 AND sc_id > ?d ORDER BY sc_id LIMIT 1', $sc_id);
            continue;
        }

        if ($sc_time_table[0] == '' && in_array($cur_m, $month_ar))
        {
            if ($cur_d != 1)
            {
                sql_query('UPDATE sb_cron SET sc_inprogress=0 WHERE sc_id=?d', $sc_id);
                $result = sql_query('SELECT sc_id, sc_name, sc_date, sc_file_path, sc_func_name, sc_time_table, sc_start_interval, sc_manual FROM sb_cron WHERE (sc_active=1 OR sc_manual=1) AND sc_inprogress=0 AND sc_id > ?d ORDER BY sc_id LIMIT 1', $sc_id);
                continue;
            }
        }
        elseif (sb_strpos($sc_time_table[0], $cur_w . ',' . $cur_h . ';') === false)    // проверяем день недели и время запуска
        {
            sql_query('UPDATE sb_cron SET sc_inprogress=0 WHERE sc_id=?d', $sc_id);
            $result = sql_query('SELECT sc_id, sc_name, sc_date, sc_file_path, sc_func_name, sc_time_table, sc_start_interval, sc_manual FROM sb_cron WHERE (sc_active=1 OR sc_manual=1) AND sc_inprogress=0 AND sc_id > ?d ORDER BY sc_id LIMIT 1', $sc_id);
            continue;
        }

        if ($sc_start_interval > 0)
        {
            // проверка интервала запуска
            $interval = floor(($cur_time - $sc_date) / 60);
            if ($interval < $sc_start_interval)
            {
                sql_query('UPDATE sb_cron SET sc_inprogress=0 WHERE sc_id=?d', $sc_id);
                $result = sql_query('SELECT sc_id, sc_name, sc_date, sc_file_path, sc_func_name, sc_time_table, sc_start_interval, sc_manual FROM sb_cron WHERE (sc_active=1 OR sc_manual=1) AND sc_inprogress=0 AND sc_id > ?d ORDER BY sc_id LIMIT 1', $sc_id);
                continue;
            }
        }
        else
        {
            $sc_y = sb_date('Y', $sc_date);
            $sc_m = sb_date('n', $sc_date);
            $sc_d = sb_date('j', $sc_date);
            $sc_w = sb_date('w', $sc_date);
            $sc_h = sb_date('G', $sc_date) + 1;

            if ($cur_w == 0)
            {
                $cur_w = $cur_w + 7;
            }

            if ($sc_y == $cur_y && $sc_m == $cur_m && $sc_d == $cur_d && $sc_h == $cur_h)
            {
                // задание уже выполнялось
                sql_query('UPDATE sb_cron SET sc_inprogress=0 WHERE sc_id=?d', $sc_id);
                $result = sql_query('SELECT sc_id, sc_name, sc_date, sc_file_path, sc_func_name, sc_time_table, sc_start_interval, sc_manual FROM sb_cron WHERE (sc_active=1 OR sc_manual=1) AND sc_inprogress=0 AND sc_id > ?d ORDER BY sc_id LIMIT 1', $sc_id);
                continue;
            }
        }
    }

    $args = array();
	if (($pos = strpos($sc_func_name, '(')) !== false)
	{
		$args = explode(',', substr($sc_func_name, $pos + 1, -1));
		$sc_func_name = substr($sc_func_name, 0, $pos);
	}

    @include_once (SB_CMS_PL_PATH.'/'.$sc_file_path);
    if (function_exists($sc_func_name))
    {
    	sql_query('UPDATE sb_cron SET sc_date=?d WHERE sc_id=?d', time(), $sc_id);

		sb_add_system_message(sprintf(KERNEL_PROG_PL_CRON_START_MSG, $sc_name));

		if (count($args) > 0)
			call_user_func_array($sc_func_name, $args);
		else
			call_user_func($sc_func_name);

		sql_query('UPDATE sb_cron SET sc_inprogress=0, sc_manual=0 WHERE sc_id=?d', $sc_id, sprintf(KERNEL_PROG_PL_CRON_END_MSG, $sc_name));
    }

    $result = sql_query('SELECT sc_id, sc_name, sc_date, sc_file_path, sc_func_name, sc_time_table, sc_start_interval, sc_manual FROM sb_cron WHERE (sc_active=1 OR sc_manual=1) AND sc_inprogress=0 AND sc_id > ?d ORDER BY sc_id LIMIT 1', $sc_id);
}

require_once(SB_CMS_KERNEL_PATH.'/prog/footer.inc.php');
?>