<?php
/**
 * Подгрузка событий модуля через AJAX
 *
 * Вся подгрузка событий системы через AJAX должна вестись через данный файл.
 *
 * @author Казбек Елекоев <elekoev@binn.ru>
 * @version 4.0
 * @package SB_Core
 * @copyright Copyright (c) 2007, OOO "СИБИЭС Групп"
 */
require_once(dirname(__FILE__).'/header.inc.php');

if (!isset($_SESSION['sbAuth']) && (!isset($_GET['event']) || $_GET['event'] != 'pl_about_renew'))
{
	exit(KERNEL_NO_SESSIONS);
}
elseif(!isset($_SESSION['sbAuth']) && isset($_GET['event']) && $_GET['event'] == 'pl_about_renew')
{
    require_once SB_CMS_PL_PATH . '/pl_about/pl_about.php';
    fAbout_Renew_NoAuth();
    exit(0);
}

if (!isset($_GET['event']))
{
    exit(0);
}
else
{
    $_GET['event'] = preg_replace('/[^a-zA-Z0-9_]+/', '', $_GET['event']);

    if (empty($_GET['event']))
    {
        exit(0);
    }
}

/**
 * Продлеваем сессию пользователя в системе
 */
if (isset($_SESSION['sbAuth']) && $_GET['event'] == 'user_status')
{
    $_SESSION['sbAuth']->updateSession();
    
    if ($_SESSION['sbAuth']->mError != '')
    {
        exit ($_SESSION['sbAuth']->mError);
    }
    else
    {
        // проверяем кол-во новых личных сообщений
        $res_inbox_new = sql_query('SELECT COUNT(*) FROM sb_users_messages WHERE um_to_id=?d AND um_delete = 0 AND um_look = 0', $_SESSION['sbAuth']->getUserId());
        
        exit('OK^'.$res_inbox_new[0][0]);
    }
}

if(isset($_SESSION['sbAuth']))
{
    $_SESSION['sbAuth']->updateEventSession();

    /**
     * Если в настройках системы включена опция 'Убирать PHP-код', то вырезаем PHP-код
     */
    if ($_SESSION['sbAuth']->checkStripPHP())
    {
        sb_replace_php($_POST);
        sb_replace_php($_GET);
        sb_replace_php($_COOKIE);
        sb_replace_php($_REQUEST);
    }
}

$GLOBALS['sbVfs']->mFileMode = octdec(sbPlugins::getSetting('sb_file_rights'));
$GLOBALS['sbVfs']->mDirMode = octdec(sbPlugins::getSetting('sb_folder_rights'));

// подключаем все языковые файлы модулей для inc-файлов
$inc_lang_files = isset($_SESSION['sbPlugins']) ? $_SESSION['sbPlugins']->getIncLangFiles() : false;
if ($inc_lang_files)
{
    foreach ($inc_lang_files as $value)
    {
        require_once($value);
    }
}

if ($_GET['event'] == 'event_tip')
{
    /**
     * Получить следующую подсказку персонажа
     */
    $help_event = preg_replace('/[^a-zA-Z0-9_]+/', '', $_GET['tip_event']);
    $help_index = intval($_GET['tip_index']);

    $event_help = $_SESSION['sbPlugins']->getEventTip($help_event, $help_index);
    if ($event_help)
    {
        $dir = SB_CMS_CHARACTERS_PATH.'/'.sbPlugins::getUserSetting('sb_character').'/';
        $url = SB_CMS_CHARACTERS_URL.'/'.sbPlugins::getUserSetting('sb_character').'/';
        // считываем все файлы из директории персонажа
        $files = @scandir($dir);
        $characters = array();

        if ($files)
        {
            for ($i = 0; $i < count($files); $i++)
            {
                if ($files[$i] == '.' || $files[$i] == '..' || @is_dir($dir.'/'.$files[$i]))
                    continue;
                    
                // если файл не картинка, игнорируем его
                $ext = pathinfo($files[$i]); 
				$ext = isset($ext['extension']) ? sb_strtolower($ext['extension']) : '';
		
				if ($ext != 'gif' && $ext != 'png' && $ext != 'jpg' && $ext != 'jpeg')
					continue;
					
                $ar = @getimagesize($dir.$files[$i]);
                if (!in_array($ar[2], array(1,2,3)))
                    continue;

                $characters[] = $url.$files[$i];
            }
        }

        $num = count($characters);
        if ($num != 0)
        {
            echo $event_help[0].'~~'.$event_help[1].'~~'.$characters[rand(0, $num - 1)];
        }
    }
    exit(0);
}

if (isset($_SESSION['sbAuth']) && $_SESSION['sbAuth']->mError != '')
{
    exit ($_SESSION['sbAuth']->mError);
}

// подлючаем все inc-файлы модулей
$inc_files = isset($_SESSION['sbPlugins']) ? $_SESSION['sbPlugins']->getIncFiles() : false;
if ($inc_files)
{
    foreach ($inc_files as $value)
    {
        require_once($value);
    }
}

$ar = isset($_SESSION['sbPlugins']) ? $_SESSION['sbPlugins']->getEventFunction($_GET['event']) : false;
if (!$ar)
{
    // Событие не зарегистрировано в системе
    exit(KERNEL_NO_EVENT);
}
else
{
    // подключаем файл, содержащий функцию-обработчик вызываемого события
    if ($ar['include_file'] != '')
    {
        if (file_exists($ar['include_file']))
        {
            require_once($ar['include_file']);
        }
        else
        {
            exit(sprintf(KERNEL_NO_FILE, str_replace(SB_BASEDIR.'/', '', $ar['include_file'])));
        }
    }

    // подключаем файл с языковыми константами
    if ($ar['lang_file'] != '')
    {
        if (file_exists($ar['lang_file']))
        {
            require_once($ar['lang_file']);
        }
        else
        {
            exit(sprintf(KERNEL_NO_LANG_FILE, str_replace(SB_BASEDIR.'/', '', $ar['lang_file'])));
        }
    }

    // вызываем функцию-обработчик события
    if (function_exists($ar['function']))
    {
        $ar['function']();
    }
    else
    {
        exit(sprintf(KERNEL_NO_FUNCTION, $ar['function'].'()'));
    }
}

require_once(SB_CMS_KERNEL_PATH.'/footer.inc.php');
?>
