<?php
/**
 * Вывод содержимого страницы
 *
 * @author Казбек Елекоев <elekoev@binn.ru>
 * @version 4.0
 * @package SB_Core
 * @copyright Copyright (c) 2007, OOO "СИБИЭС Групп"
 */
$html = trim(ob_get_clean());
while (ob_get_level() > 0)
{
	ob_end_clean();
}

if (defined('SB_HTTPS') && SB_HTTPS)
{
	// HTTPS-протокол
	$html = preg_replace('/<(img|script)\s+(.*?)src=([\'"])?http:(\/\/'.SB_COOKIE_DOMAIN.'[^>]*?>)/i'.SB_PREG_MOD, '<\\1 \\2src=\\3https:\\4', $html);
	$html = preg_replace('/<(img|script)\s+(.*?)src=([\'"])?http:(\/\/www.'.SB_COOKIE_DOMAIN.'[^>]*?>)/i'.SB_PREG_MOD, '<\\1 \\2src=\\3https:\\4', $html);
	$html = preg_replace('/<link\s+(.*?)href=([\'"])?http:(:\/\/'.SB_COOKIE_DOMAIN.'[^>]*?>)/i'.SB_PREG_MOD, '<link \\1href=\\2https:\\3', $html);
	$html = preg_replace('/<link\s+(.*?)href=([\'"])?http:(:\/\/www.'.SB_COOKIE_DOMAIN.'[^>]*?>)/i'.SB_PREG_MOD, '<link \\1href=\\2https:\\3', $html);
}

/*
 * Попробуем использовать компрессию, это должно заметно уменьшить время загрузки страницы
 */
$gzip = sbPlugins::getSetting('sb_gzip_compress');

if (isset($_SESSION['sbPlugins']) && $gzip == 1 && (!isset($GLOBALS['sb_gzip_compress']) || $GLOBALS['sb_gzip_compress']))
{
	if (extension_loaded('zlib'))
    {
	    if (isset($_SERVER['HTTP_USER_AGENT']) && (strstr($_SERVER['HTTP_USER_AGENT'], 'compatible') || strstr($_SERVER['HTTP_USER_AGENT'], 'Gecko')))
	    {
	        ob_start('ob_gzhandler');
	        echo $html;
	        
	        if (class_exists('sbProfiler'))
	        {
	        	sbProfiler::flush();
	        }
	        
	        exit(0);
	    }
	    elseif (isset($_SERVER['HTTP_ACCEPT_ENCODING']) && strstr($_SERVER['HTTP_ACCEPT_ENCODING'], 'gzip'))
	    {
            ob_implicit_flush(0);
            ob_start();
            echo $html;
            $gzip_size = ob_get_length();
            ob_end_clean();

            header('Content-Encoding: gzip');

            echo "\x1f\x8b\x08\x00\x00\x00\x00\x00".substr(gzcompress($html, 3), 0, -4);
            echo pack('V', crc32($html));
            echo pack('V', $gzip_size);
            
            if (class_exists('sbProfiler'))
            {
            	sbProfiler::flush();
            }
            
            exit(0);
	    }
    }
}

echo $html;

if (class_exists('sbProfiler'))
{
	sbProfiler::flush();
}

exit(0);
?>