<?php
$html = ob_get_clean();
while (ob_get_level() > 0)
{
	ob_end_clean();
}

if (isset($_POST['su_pass']) && sbAuth::getErrorCode() == -1 && !isset($_GET['noredir']))
{
	header('Location: '.sb_sanitize_header($GLOBALS['PHP_SELF'].($_SERVER['QUERY_STRING'] != '' ? '?'.$_SERVER['QUERY_STRING'] : '')));
	if (class_exists('sbProfiler'))
	{
		sbProfiler::flush();
	}
	exit(0);
}

$m_file_time = time();
if (count($_POST) == 0 && @file_exists(SB_BASEDIR.$_SERVER['PHP_SELF']))
{
	$m_file_time = @filemtime(SB_BASEDIR.$_SERVER['PHP_SELF']);
	$last_modified = $GLOBALS['sbCache']->getLastModified();
	if ($last_modified > $m_file_time)
	{
		$m_file_time = $last_modified;
	}
}

$m_file_time = gmdate('D, d M Y H:i:s', $m_file_time) . ' GMT';
$hash = md5($m_file_time);

if (defined('SB_PAGE_NOCACHE') && SB_PAGE_NOCACHE || isset($_REQUEST['sb_page_nocache']))
{
    /*
     * Запрещаем кэширование страницы барузером и проксей
    */
    header('ETag: PUB' . time());
    header('Expires: '.date('r'));
    header('Cache-Control: no-store, no-cache, must-revalidate, proxy-revalidate, post-check=0, pre-check=0');
}
else
{
    if ((isset($_SERVER['HTTP_IF_NONE_MATCH']) && $_SERVER['HTTP_IF_NONE_MATCH'] == 'PUB'.$hash) ||
    	(isset($_SERVER['HTTP_IF_MODIFIED_SINCE']) && strtotime($_SERVER['HTTP_IF_MODIFIED_SINCE']) > strtotime($m_file_time)))
    {
       	header('HTTP/1.1 304 Not Modified');
       	header('Cache-Control: private, must-revalidate, proxy-revalidate, max-age=1');
       	header('Last-Modified: '.$m_file_time);
	    if (class_exists('sbProfiler'))
		{
			sbProfiler::flush();
		}
       	exit(0);
    }
    else
    {
    	header('Cache-Control: private, must-revalidate, proxy-revalidate, max-age=1');
    	header('Last-Modified: '.$m_file_time);
    	header('ETag: PUB'.$hash);
    }
}

if (trim($html) == '')
{
	echo $html;
	if (class_exists('sbProfiler'))
	{
		sbProfiler::flush();
	}
	exit;
}

if (defined('SB_XSLT'))
{
    $xml = new DOMDocument('1.0', SB_CHARSET);
    if (sb_stripos($html, '<?xml ') === false)
        $xml->loadXML('<?xml version="1.0" encoding="'.SB_CHARSET.'"?>'.$html);
    else
		$xml->loadXML($html);

    $xsl = new DOMDocument;
    if (sb_stripos(SB_XSLT, '://') === false)
        $xsl->load(sb_str_replace('//', '/', SB_BASEDIR.'/'.SB_XSLT));
    else
        $xsl->load(SB_XSLT);

    $proc = new XSLTProcessor;
    $proc->importStyleSheet($xsl);
    $dom = $proc->transformToDoc($xml);

    if ($dom)
    {
        $html = $dom->saveHTML();
    }
    else
    {
    	$html = '';
    }
}

if (defined('SB_DEMO_SITE') && SB_DEMO_SITE)
{
	// режим тестового сайта
	$host = str_ireplace('www.', '', SB_COOKIE_DOMAIN);
	$host = str_ireplace('www-demo.', '', SB_COOKIE_DOMAIN);
    $html = str_ireplace(array('://www.'.$host, '://'.$host), '://'.SB_COOKIE_DOMAIN, $html);
}

if (sbPlugins::getSetting('sb_strip_domain') == 1 && !isset($_REQUEST['sb_no_strip_domain']))
{
	// делаем все ссылки относительными
	$html = preg_replace('!(<[^>]*?\s)(href|src)(\s?=\s?["\'])(http://)(www\.)?('.str_replace('.', '\\.', SB_COOKIE_DOMAIN).')(.*?["\'].*?>)!imsu'.SB_PREG_MOD, '$1$2$3$7', $html);
}
elseif (defined('SB_HTTPS') && SB_HTTPS)
{
	// HTTPS-протокол
	$html = preg_replace('/<(img|script)\s+(.*?)src=([\'"])?http:\/\/'.SB_COOKIE_DOMAIN.'([^>]*?>)/i'.SB_PREG_MOD, '<\\1 \\2src=\\3'.SB_DOMAIN.'\\4', $html);
	$html = preg_replace('/<(img|script)\s+(.*?)src=([\'"])?http:(\/\/www.'.SB_COOKIE_DOMAIN.'[^>]*?>)/i'.SB_PREG_MOD, '<\\1 \\2src=\\3https:\\4', $html);
	$html = preg_replace('/<link\s+(.*?)href=([\'"])?http:\/\/'.SB_COOKIE_DOMAIN.'([^>]*?>)/i'.SB_PREG_MOD, '<link \\1href=\\2'.SB_DOMAIN.'\\3', $html);
	$html = preg_replace('/<link\s+(.*?)href=([\'"])?http:(\/\/www.'.SB_COOKIE_DOMAIN.'[^>]*?>)/i'.SB_PREG_MOD, '<link \\1href=\\2https:\\3', $html);
}

if ((sb_stripos($html, 'rel="shadowbox"') !== false || sb_stripos($html, "rel='shadowbox'") !== false)
	&& sb_stripos($html, 'shadowbox.js') === false)
{
	// если используется shadowbox
    $html = preg_replace('!\</head\>!i', '<link rel="stylesheet" type="text/css" href="/cms/jscript/shadowbox/shadowbox.css">'."\n".
		'<script type="text/javascript" src="/cms/jscript/shadowbox/shadowbox.js"></script>'."\n".
		'<script type="text/javascript">Shadowbox.init();</script>'."\n".'</head>', $html);
}

if ((sb_stripos($html, 'sbPopupImg') !== false || sb_stripos($html, 'sbGetLinkData') !== false)
	&& sb_stripos($html, 'sbTools.js') === false)
{
    // есть вспомогательные яваскриптовые функции, включаем наш яваскрипт
    $html = preg_replace('!\</head\>!i', '<script src="/cms/jscript/sbTools.js"></script>'."\n".'</head>', $html);
}

if (sbPlugins::getSetting('sb_html_compress') == 1 && !defined('SB_VISUAL_EDITOR'))
{
	// проверяем Content-type, если text/html, то жмем код
	$headers = headers_list();
	$found = false;
	foreach ($headers as $str)
	{
		if (preg_match('/\s*?content\-type\s*?\:\s*?text\/html.*?/i', $str) > 0)
		{
			$found = true;
			break;
		}
	}
	
	if ($found)
	{
	    require_once(SB_CMS_LIB_PATH.'/compressor/sbCompressor.inc.php');
	
	    // вырезаем из HTML-кода CSS и JS файлы, заменяем на вызов скрипта
	    $html = sbCompressor::compress($html);
	
	    $options = array(
	               'cssCompressor' => 'sbCompressorCSS::compress',
	               'jsCompressor' => 'sbCompressorJS::compress'
	                );
	    // жмем HTML-код
	    $html = sbCompressorHTML::compress($html, $options);
	}
}

/*
 * Попробуем использовать компрессию, это должно заметно уменьшить время загрузки страницы
 */
if (sbPlugins::getSetting('sb_gzip_compress') == 1 && extension_loaded('zlib') && (!isset($GLOBALS['sb_gzip_compress']) || $GLOBALS['sb_gzip_compress']))
{
	if (isset($_SERVER['HTTP_USER_AGENT']) && (strstr($_SERVER['HTTP_USER_AGENT'], 'compatible') || strstr($_SERVER['HTTP_USER_AGENT'], 'Gecko')))
    {
        ob_start('ob_gzhandler');
        if(class_exists('sbCachePage'))
        {
            sbCachePage::getInstance()->save($html);
        }
        else
        {
             echo $html;
        }
        if (class_exists('sbProfiler'))
        {
        	sbProfiler::flush();
        }
        exit(0);
    }
    elseif (isset($_SERVER['HTTP_ACCEPT_ENCODING']) && strstr($_SERVER['HTTP_ACCEPT_ENCODING'], 'gzip'))
    {
        ob_implicit_flush(0);
        ob_start();
        if(class_exists('sbCachePage'))
        {
            sbCachePage::getInstance()->save($html);
        }
        else
        {
            echo $html;
        }
        $gzip_size = ob_get_length();
        ob_end_clean();

        header('Content-Encoding: gzip');

        $html = "\x1f\x8b\x08\x00\x00\x00\x00\x00".substr(gzcompress($html, 3), 0, -4);
        if(class_exists('sbCachePage'))
        {
            sbCachePage::getInstance()->save($html);
        }
        else
        {
            echo $html;
        }
        echo pack('V', crc32($html));
        echo pack('V', $gzip_size);
        if (class_exists('sbProfiler'))
        {
        	sbProfiler::flush();
        }
        exit(0);
    }
}

        if(class_exists('sbCachePage'))
        {
            sbCachePage::getInstance()->save($html);
        }
        else
        {
            echo $html;
        }
if (class_exists('sbProfiler'))
{
	sbProfiler::flush();
}
exit(0);
?>