<?php
/**
 * Класс, отвечающий за вывод разделительной полосы в форме
 *
 * @see sbLayout
 * @author Казбек Елекоев <elekoev@binn.ru>
 * @version 4.0
 * @package SB_Layout
 * @copyright Copyright (c) 2007, OOO "СИБИЭС Групп"
 */
class sbLayoutDelim
{
    /**
     * Дополнительные св-ва (например, стили)
     *
     * @var string
     */
    private $mDopStr = '';

    /**
     * Конструктор класса
     *
     * @param string $dop_str Дополнительные стили, аттрибуты.
     *
     * @return binnLayoutDelim
     */
    function __construct($dop_str = '')
    {
        $this->mDopStr   = $dop_str;
    }

    /**
     * Возвращает HTML-код таблицы
     *
     * @param int $title_width Ширина столбца заголовка поля.
     * @param string $title Заголовок поля.
     * @param bool $show_title Отображать или нет столбец заголовков полей.
     * @param string $tr_str Доп. свойства тегов <i>tr</i>.
     * @param string $th_str Доп. свойства тегов <i>th</i>.
     * @param string $td_str Доп. свойства тегов <i>td</i>.
     *
     * @return string HTML-код таблицы.
     */
    public function getFull($title_width, $title, $show_title, $tr_str, $th_str, $td_str)
    {
        return '<tr'.($tr_str != '' ? ' '.$tr_str : '').'>
                  <td colspan="2" class="delim"'.($td_str != '' ? ' '.$td_str : '').($this->mDopStr != '' ? ' '.$this->mDopStr : '').'></td>
                </tr>';
    }
}
?>