<?php

/**
 * Функция добавления роликов
 *
 * @param array $row Ассоциативный массив со значениями полей элемента (ключи - имена полей, значения - значения полей).
 * @param array $cat_ids Массив идентификаторов разделов, с которыми необходимо прописать связь элемента.
 * @param integer $premod_movies Модерируемые ролики или нет.
 *
 * @return mixed Если добавление идет со стороны сайта возвращает идентификатор добавленного элемента, FALSE в случае ошибки.
 */
function sbAddMovies($row = array(), $cat_ids = array(), $premod_movies = '')
{
	if(!is_array($row) || !is_array($cat_ids))
	{
		if(isset($_POST['btf_save']))
		{
			sb_show_message(PL_SR_NOT_ADD_MOVIE);
			fServices_Rutube_Upload();
			return;
		}
		else
		{
			return false;
		}
	}

	$rt_developer_key = trim(sbPlugins::getSetting('sb_services_rutube_partner_key'));
    if(!$rt_developer_key)
    {
        if (isset($_POST['btf_save']))
        {
            sb_show_message(PL_SR_NO_DIV_KEY);
            fServices_Rutube_Upload();
            return;
        }
        elseif(isset($_FILES['ssr_file_path']))
        {
			return false;
		}
	}

    if(isset($_POST['btf_save']) || isset($_FILES['ssr_file_path']))
    {
		$ssr_date = sb_date('d.m.Y H:i', time());
		$ssr_url = '';
		$ssr_show = 1;

		extract($_POST);
		set_time_limit(0);

        $ssr_author = isset($_POST['ssr_author']) ? $_POST['ssr_author'] : '';
        $ssr_movie_name = isset($_POST['ssr_movie_name']) ? $_POST['ssr_movie_name'] : '';
        $ssr_category = isset($_POST['ssr_category']) ? $_POST['ssr_category'] : '';
        $ssr_tags = isset($_POST['ssr_tags']) ? $_POST['ssr_tags'] : '';
        $ssr_show_rutube = isset($_POST['ssr_show_rutube']) ? $_POST['ssr_show_rutube'] : '0';
        $ssr_description = isset($_POST['ssr_description']) ? $_POST['ssr_description'] : '';
        $ssr_url_location = isset($_POST['ssr_url_location']) ? $_POST['ssr_url_location'] : '';

        if(isset($ssr_url_location) && $ssr_url_location != '' && !preg_match('/^http\:\/\/w*\.{0,1}\w{2,6}\./', $ssr_url_location))
        {
            sb_show_message(PL_SR_ERR_URL_PATH);
            fServices_Rutube_Upload();
            return;
        }

        if(isset($_FILES['ssr_file_path']) && $premod_movies == 1)
        {
			$ssr_show = 0;
        }

		$id = '';
		$ssr_url = sb_check_chpu($id, $ssr_url, $ssr_movie_name, 'sb_services_rutube', 'ssr_url', 'ssr_id');
		if ($ssr_movie_name)
        {
            $GLOBALS['sbVfs']->mLocal = true;

            if(!$GLOBALS['sbVfs']->exists(SB_BASEDIR.SB_SITE_USER_UPLOAD_PATH.'/pl_services_rutube'))
            {
                $GLOBALS['sbVfs']->mkdir(SB_BASEDIR.SB_SITE_USER_UPLOAD_PATH.'/pl_services_rutube');
            }

			if(isset($_FILES['ssr_file_path']))
            {
                $path_tem = $GLOBALS['sbVfs']->mkdir(SB_BASEDIR.SB_SITE_USER_UPLOAD_PATH.'/tempor');
                if(!$path_tem)
                {
                    if(isset($_POST['btf_save']))
                    {
                        sb_show_message(PL_SR_NO_CR_TEMPOR);
                        fServices_Rutube_Upload();
                        return;
                    }
                    elseif(isset($_FILES['ssr_file_path']))
                    {
                        return false;
                    }
                }
            }

			$filename_tmp = '';
            if(isset($_POST['btf_save']) && $ssr_url_location == '')
            {
			    $filename_tmp = str_replace('\\', '/', preg_replace('/[^0-9a-zA-Z\_\-\.\[\]]+/', '', $_POST['ssr_file_path_tmp']));
				$filename_tmp = preg_replace('/\.\.+/', '', $filename_tmp);
			    $filename_tmp = trim(preg_replace('/\/\/+/', '', $filename_tmp));

				$GLOBALS['sbVfs']->mLocal = true;

			}

            if ((isset($_FILES['ssr_file_path']['tmp_name']) && $GLOBALS['sbVfs']->move_uploaded_file($_FILES['ssr_file_path']['tmp_name'], SB_BASEDIR.SB_SITE_USER_UPLOAD_PATH.'/tempor/'.$_FILES['ssr_file_path']['name']))
				|| ($filename_tmp != '' && $GLOBALS['sbVfs']->exists(SB_CMS_TMP_PATH.'/'.$filename_tmp) && $GLOBALS['sbVfs']->is_file(SB_CMS_TMP_PATH.'/'.$filename_tmp))
            	|| $ssr_url_location != '')
            {
				if($ssr_url_location != '')
                {
    	            $filename = explode('/', $ssr_url_location);
	                $count = count($filename);
                	$filename = $filename[$count-1];

					$file_location = SB_BASEDIR.sb_str_replace(SB_DOMAIN, '', $ssr_url_location);
                }
                elseif(isset($_FILES['ssr_file_path']['name']))
                {
					$filename = $_FILES['ssr_file_path']['name'];

					$file_location = SB_BASEDIR.SB_SITE_USER_UPLOAD_PATH.'/tempor/'.$_FILES['ssr_file_path']['name'];
				}
				else
                {
					$filename = sb_strtolat($_POST['ssr_file_path']);
					$filename = trim(preg_replace('/[^0-9a-zA-Z\_\-\.\[\]]+/', '', str_replace(array(' ', '%20'), array('_', '_'), $filename)));

					$file_location = SB_CMS_TMP_PATH.'/'.$filename_tmp;
                }

                $GLOBALS['bnd'] = md5(uniqid(time()));

                function add_var($name, $val)
                {
                    $r  = '--'.$GLOBALS['bnd']."\r\n";
                    $r .= 'Content-Disposition: form-data; name="'.$name.'"'."\r\n";
                    $r .= "\r\n";
                    $r .= $val."\r\n";
                    return $r;
                }

                $data2  = add_var('save', 'y');
                $data2 .= add_var('rt_mode', 'do_upload');
                $data2 .= add_var('rt_developer_key', $rt_developer_key);
                $data2 .= add_var('rt_redirect_ok', 'ok.html?redirect=ok');
                $data2 .= add_var('rt_redirect_error', 'error.html?redirect=error');

                $data2 .= add_var('rt_auto_publish', $ssr_show_rutube);
                $data2 .= add_var('rt_user', '');
                $data2 .= add_var('rt_sign', '');
                $data2 .= add_var('rt_enc', (SB_CHARSET != 'UTF-8' ? SB_CHARSET :'UTF-8'));
                $data2 .= add_var('referer', '');
                $data2 .= add_var('title', $ssr_movie_name);
                $data2 .= add_var('rt_tags', $ssr_tags);
                $data2 .= add_var('comment', $ssr_description);
                $data2 .= add_var('category', $ssr_category);
                $data2 .= "--".$GLOBALS['bnd']."\r\n";
                $data2 .= 'Content-Disposition: form-data; name="data"; filename="'.$filename.'"\r\n';
                $data2 .= "Content-Type: application/octet-stream\r\n";
                $data2 .= "Content-Transfer-Encoding: binary\r\n";
                $data2 .= "\r\n";

                $data3 = "\r\n";
                $data3 .= '--'.$GLOBALS['bnd']."--\r\n";
                $data1  = "POST http://uploader.rutube.ru/cgi-bin/jsapi.cgi HTTP/1.0\r\n";
                $data1 .= "Host: uploader.rutube.ru\r\n";
                $data1 .= "Content-Type: multipart/form-data; boundary=".$GLOBALS['bnd']."\r\n";
                $data1 .= "Content-Length: ".(sb_strlen($data2.$data3, '8bit')+$GLOBALS['sbVfs']->filesize($file_location))."\r\n";
                $data1 .= "Connection: close\r\n";
                $data1 .= "\r\n";

				$array_var = array('save' => 'y',
                                       'rt_mode' => 'do_upload',
                                       'rt_developer_key' => $rt_developer_key,
                                       'rt_redirect_ok' => 'ok.html?redirect=ok',
                                       'rt_redirect_error' => 'error.html?redirect=error',
                                       'rt_auto_publish' => $ssr_show_rutube,
                                       'rt_user' => '',
                                       'rt_sign' => '',
                                       'rt_enc' => SB_CHARSET,
                                       'referer' => '',
                                       'title' => $ssr_movie_name,
                                       'rt_tags' => $ssr_tags,
                                       'comment' => $ssr_description,
                                       'category' => $ssr_category,
                                       'data'=> '@'.$file_location);

				$ch = curl_init();
                curl_setopt($ch, CURLOPT_URL, 'http://uploader.rutube.ru/cgi-bin/jsapi.cgi');	//	url который php должен получать
                curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 0);
                curl_setopt($ch, CURLOPT_POSTFIELDS, $array_var);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

				$response = curl_exec($ch);
				$error = false;
				if (curl_errno($ch) > 0)
                {
					$f = fsockopen('uploader.rutube.ru', 80);
                    if($f)
                    {
                        $GLOBALS['sbVfs']->fwrite($data1.$data2, $f);
                        $f2 = $GLOBALS['sbVfs']->fopen($file_location, 'rb');

                        if ($f2)
                        {
	                        while (!$GLOBALS['sbVfs']->feof($f2))
	                        {
	                            $buff = $GLOBALS['sbVfs']->fread(1024*128, $f2);
	                            $GLOBALS['sbVfs']->fwrite($buff, $f);
	                        }

	                        $GLOBALS['sbVfs']->fclose($f2);
	                        $GLOBALS['sbVfs']->fwrite($data3, $f);

	                        $response = '';
	                        while (!$GLOBALS['sbVfs']->feof($f))
	                        {
	                            $response .= $GLOBALS['sbVfs']->fgets(128, $f);
	                        }
                        }
                        else
                        {
                        	$error = true;
                        }

                        $GLOBALS['sbVfs']->fclose($f);
                    }
                }
                else
                {
                	$error = true;
                }

            	if ($error)
                {
                    if(isset($_POST['btf_save']))
                    {
                        sb_show_message(PL_SR_NOT_ADD_MOVIE);
                        if(curl_error($ch) != '')
                            sb_add_system_message(sprintf(PL_SR_ERR_UPLOAD, curl_error($ch)), SB_MSG_WARNING);
                    }
                    elseif(isset($_FILES['ssr_file_path']))
                    {
                        $GLOBALS['sbVfs']->delete(SB_BASEDIR.SB_SITE_USER_UPLOAD_PATH.'/tempor');
                        $GLOBALS['sbVfs']->mLocal = false;
                        if(curl_error($ch) != '')
                            sb_add_system_message(sprintf(KERNEL_PROG_PL_SR_ERR_UPLOAD, curl_error($ch)), SB_MSG_WARNING);
                        return false;
                    }
                }

                if($GLOBALS['sbVfs']->exists(SB_BASEDIR.SB_SITE_USER_UPLOAD_PATH.'/tempor'))
                {
	                $GLOBALS['sbVfs']->delete(SB_BASEDIR.SB_SITE_USER_UPLOAD_PATH.'/tempor');
	                $GLOBALS['sbVfs']->mLocal = false;
                }
                curl_close($ch);

				$response = split("\r\n\r\n", $response);
				$response = trim(preg_replace('/.*Location:.*redirect=(\S*).*/i', '$1',  strtr($response[0], array("\n" =>' ', "\r" => ' '))));

                if(strpos($response[0], 'error') === false)
                {
					$response = preg_replace('/.*rt_movie_id=(.*)/i', '$1', $response);

                    if(isset($_POST['btf_save']))
                    {
						$row = array();
	                    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

	                    $layout = new sbLayout();
	                    $row = $layout->checkPluginFields('pl_services_rutube', '', 'ssr_id');

	                    if ($row === false)
	                    {
	                        $layout->deletePluginFieldsFiles();
                            fServices_Rutube_Upload();
                            return;
	                    }
                    }

                    $row['ssr_name'] = $ssr_movie_name;
                    $row['ssr_description'] = $ssr_description;
                    $row['ssr_date'] = sb_datetoint($ssr_date);
                    $row['ssr_author'] = $ssr_author;

                    if(isset($_POST['btf_save']))
                    {
						$row['ssr_user_id'] = '0';
                    }
                    else
                    {
                        $row['ssr_user_id'] = (isset($_SESSION['sbAuth']) ? $_SESSION['sbAuth']->getUserId() : '0');
                    }

                    if(isset($_POST['btf_save']))
                    {
						$_POST['ssr_show'] = $ssr_show;
						sb_submit_workflow_status($row, 'ssr_show', 'ssr_pub_start', 'ssr_pub_end');
                    }
					else
					{
						$row['ssr_show'] = isset($ssr_show) ? intval($ssr_show) : 0;
					}

                    $row['ssr_status'] = 1;
                    $row['ssr_rutube_id'] = sb_substr($response, 0, 7);
                    $row['ssr_url'] = $ssr_url;
                    $row['ssr_views'] = 0;
                    $row['ssr_duration'] = 0;
                    $row['ssr_size'] = 0;

                    if(preg_match('/^[0-9]+$/', sb_substr($response, 0, 7)))
                    {
	                    sql_query('INSERT INTO sb_services_rutube (?#) VALUES (?a)', array_keys($row), array_values($row));
	                    $id = sql_insert_id();
                    }
					else
					{
						$id = false;
					}

                    if($id)
                    {
                        if(isset($_POST['btf_save']))
                        {
							fClouds_Set_Field($id, 'pl_services_rutube', $ssr_tags);
							sb_mail_workflow_status('pl_services_rutube', $id, $ssr_movie_name, $ssr_show, 1);
	                    }
                        else
                        {
							include_once(SB_CMS_PL_PATH.'/pl_clouds/pl_clouds.inc.php');
							fClouds_Set_Field($id, 'pl_services_rutube', $ssr_tags);
                        }
                    }

                    if(!$id)
                    {
                        if(isset($_POST['btf_save']))
                        {
                            sb_show_message(PL_SR_NOT_ADD_MOVIE);
                            fServices_Rutube_Upload();
                            return;
                        }
                        elseif(isset($_FILES['ssr_file_path']))
                        {
                            sb_add_system_message(sprintf(KERNEL_PROG_PL_SR_FORM_ERR_ADD_MOVIE, $ssr_movie_name), SB_MSG_WARNING);
                            return false;
                        }
                    }

                    if(isset($_POST['btf_save']))
                    {
	                    require_once(SB_CMS_LIB_PATH.'/sbElements.inc.php');
	                    $elems = new sbElements('sb_services_rutube', 'ssr_id', 'ssr_name', 'fServices_Rutube_Get', 'pl_services_rutube_init', 'pl_services_rutube');
	                    $cat = $elems->mCategsSelectedId;

	                    sql_query('LOCK TABLE sb_catlinks WRITE, sb_catchanges WRITE');
	                    sql_query('INSERT INTO sb_catlinks (link_cat_id, link_el_id, link_src_cat_id) VALUES (?d, ?d, 0)', $cat, $id);
                        $id_cl = sql_insert_id();
	                    sql_query('INSERT INTO sb_catchanges (el_id, cat_ident, change_date, change_user_id, action) VALUES (?d, ?, ?d, ?d, ?)', $id, 'pl_services_rutube', time(), (isset($_SESSION['sbAuth']) ? $_SESSION['sbAuth']->getUserId() : '0'), 'add');
	                    sql_query('UNLOCK TABLES');
                    }
                    elseif(isset($_FILES['ssr_file_path']))
                    {
				        $root_id = -1;
				        $date = time();

				        sql_query('LOCK TABLES sb_catlinks WRITE, sb_catchanges WRITE');
				        foreach($cat_ids as $cat_id)
				        {
				            if($root_id == -1)
				            {
				                if (sql_query('INSERT INTO sb_catlinks (link_cat_id, link_el_id, link_src_cat_id) VALUES (?d, ?d, 0)', $cat_id, $id))
				                {
                                    $id_cl = sql_insert_id();
				                	sql_query('INSERT INTO sb_catchanges (el_id, cat_ident, change_date, change_user_id, action) VALUES (?d, ?, ?d, 0, ?)', $id, 'pl_services_rutube', $date, 'add');
				                    $root_id = $cat_id;
				                }
				            }
				            else
				            {
				                sql_query('INSERT INTO sb_catlinks (link_cat_id, link_el_id, link_src_cat_id) VALUES (?d, ?d, ?d)', $cat_id, $id, $root_id);
				            }
				        }
				        sql_query('UNLOCK TABLES');
                    }

                    if(!isset($id_cl) || !$id_cl)
                    {
                        sql_query('DELETE FROM sb_services_rutube WHERE ssr_id=?d', $id);

                        if(isset($_POST['btf_save']))
                        {
                            sb_show_message(PL_SR_NOT_ADD_MOVIE);
                            fServices_Rutube_Upload();
                            return;
                        }
                        elseif(isset($_FILES['ssr_file_path']))
                        {
                            sb_add_system_message(sprintf(KERNEL_PROG_PL_SR_FORM_ERR_ADD_MOVIE, $ssr_movie_name), SB_MSG_WARNING);
                            return false;
                        }
                    }

                    if(isset($_POST['btf_save']))
                    {
                        echo '<script>
                                sbReturnValue('.$id.');
                            </script>';
                    }
                    elseif(isset($_FILES['ssr_file_path']))
                    {
                        return $id;
                    }
                }
                else
                {
                    if(isset($_POST['btf_save']))
                    {
                        sb_show_message(PL_SR_NOT_ADD_MOVIE);
                        fServices_Rutube_Upload();
                    }
                    else
                    {
                        sb_add_system_message(sprintf(KERNEL_PROG_PL_SR_FORM_ERR_ADD_MOVIE, $ssr_movie_name), SB_MSG_WARNING);
                        return false;
                    }
                }
            }

            if($GLOBALS['sbVfs']->exists(SB_BASEDIR.SB_SITE_USER_UPLOAD_PATH.'/tempor'))
			{
				$GLOBALS['sbVfs']->delete(SB_BASEDIR.SB_SITE_USER_UPLOAD_PATH.'/tempor');
	        	$GLOBALS['sbVfs']->mLocal = false;
            }
        }
    }
}

/**
 * Функция добавления роликов на YouTube
 *
 * @param array $row Ассоциативный массив со значениями полей элемента (ключи - имена полей, значения - значения полей).
 * @param array $cat_ids Массив идентификаторов разделов, с которыми необходимо прописать связь элемента.
 * @param integer $premod_movies Модерируемые ролики или нет.
 *
 * @return mixed Если добавление идет со стороны сайта возвращает идентификатор добавленного элемента, FALSE в случае ошибки.
 */
function sbAddYouTubeMovies($row = array(), $cat_ids = array(), $premod_movies = '')
{
	if(!is_array($row) || !is_array($cat_ids))
	{
		if(isset($_POST['btf_save']))
		{
			sb_show_message(PL_SR_ERR_UPLOAD_FILE, false, 'warning');
			fServices_Rutube_Upload();
			return;
		}
		else
		{
			return false;
		}
	}

	$yt_marker = trim(sbPlugins::getSetting('sb_services_rutube_youtube_marker'));
	if(!$yt_marker)
	{
		sb_show_message(PL_SR_EDIT_IMPORT_AUTH_LINK_DESCRIPTION);
		fServices_Rutube_Upload();
		return false;
	}

	$yt_dev_key = trim(sbPlugins::getSetting('sb_services_rutube_youtube_key'));
    if(!$yt_dev_key)
    {
		sb_show_message(PL_SR_NO_DIV_YOUTUBE_KEY);
		fServices_Rutube_Upload();
		return false;
	}

	$ssr_url = '';
	$ssr_show = 1;

	extract($_POST);
	set_time_limit(0);

	$ssr_author = isset($_POST['ssr_author']) ? $_POST['ssr_author'] : '';
    $ssr_movie_name = isset($_POST['ssr_movie_name']) ? $_POST['ssr_movie_name'] : '';
    $ssr_category = isset($_POST['ssr_category']) ? $_POST['ssr_category'] : '';
    $ssr_tags = isset($_POST['ssr_tags']) ? $_POST['ssr_tags'] : '';
    $ssr_show_rutube = isset($_POST['ssr_show_rutube']) ? $_POST['ssr_show_rutube'] : '0';
    $ssr_description = isset($_POST['ssr_description']) ? $_POST['ssr_description'] : '';

    if(isset($_FILES['ssr_file_path']) && $premod_movies == 1)
    {
		$ssr_show = 0;
	}

	if(!isset($ssr_movie_name) || sb_strlen($ssr_movie_name) > 60 || sb_strpos($ssr_movie_name, '>') !== false || sb_strpos($ssr_movie_name, '<') !== false)
	{
		if(isset($_POST['btf_save']))
		{
			sb_show_message(PL_SR_UPLOAD_YOUTUBE_ERR_LENGTH_TITLE, false, 'warning');
			fServices_Rutube_Upload();
			return;
		}
		else
		{
			return false;
		}
	}

	if(!isset($ssr_tags) || sb_strlen($ssr_tags) > 120 || sb_strpos($ssr_tags, '>') !== false || sb_strpos($ssr_tags, '<') !== false)
	{
		if(isset($_POST['btf_save']))
		{
			sb_show_message(PL_SR_UPLOAD_YOUTUBE_ERR_LENGTH_TAGS, false, 'warning');
			fServices_Rutube_Upload();
			return;
		}
		else
		{
			return false;
		}
	}

	if (!isset($ssr_description) || sb_strlen($ssr_description) > 5000 || sb_strpos($ssr_description, '>') !== false || sb_strpos($ssr_description, '<') !== false)
	{
		if(isset($_POST['btf_save']))
		{
			sb_show_message(PL_SR_UPLOAD_YOUTUBE_ERR_LENGTH_DESCR, false, 'warning');
			fServices_Rutube_Upload();
			return;
		}
		else
		{
			return false;
		}
	}

	if(!isset($youtube_cats) && isset($_POST['btf_save']))
	{
		sb_show_message(PL_SR_UPLOAD_YOUTUBE_ERR_CATEG, false, 'warning');
		fServices_Rutube_Upload();
		return;
	}

	if (!function_exists('curl_init'))
	{
		if(isset($_POST['btf_save']))
		{
			sb_show_message(PL_SR_ERR_UPLOAD_FILE, false, 'warning');
			fServices_Rutube_Upload();
		}

		sb_add_system_message(PL_SR_UPLOAD_YOUTUBE_ERR_CURL, SB_MSG_WARNING);
		return false;
	}

	$file_location = '';
	if(isset($_POST['btf_save']))
	{
		if(!isset($_POST['yt_file']) || $_POST['yt_file'] == '')
		{
			sb_show_message(PL_SR_UPLOAD_YOUTUBE_ERR_FILE, false, 'warning');
			sb_add_system_message(PL_SR_UPLOAD_YOUTUBE_ERR_FILE, SB_MSG_WARNING);
			fServices_Rutube_Upload();
			return;
		}

		$file_name = sb_strtolat($_POST['yt_file']);
		$file_name = trim(preg_replace('/[^0-9a-zA-Z\_\-\.\[\]]+/', '', str_replace(array(' ', '%20'), array('_', '_'), $file_name)));

		$filename_tmp = str_replace('\\', '/', preg_replace('/[^0-9a-zA-Z\_\-\.\[\]]+/', '', $_POST['yt_file_tmp']));
		$filename_tmp = preg_replace('/\.\.+/', '', $filename_tmp);
		$filename_tmp = trim(preg_replace('/\/\/+/', '', $filename_tmp));

		$GLOBALS['sbVfs']->mLocal = true;
		if($filename_tmp != '' && $GLOBALS['sbVfs']->exists(SB_CMS_TMP_PATH.'/'.$filename_tmp) && $GLOBALS['sbVfs']->is_file(SB_CMS_TMP_PATH.'/'.$filename_tmp))
		{
			$file_location = SB_CMS_TMP_PATH.'/'.$filename_tmp;
		}
		$GLOBALS['sbVfs']->mLocal = false;
	}
	else
	{
		if(!isset($_FILES['ssr_file_path']) || $_FILES['ssr_file_path']['tmp_name'] == '')
		{
			return false;
		}
		$file_location = $_FILES['ssr_file_path']['tmp_name'];
		$file_name = $_FILES['ssr_file_path']['name'];

		$youtube_cats = $ssr_category;
	}

    $youtube_cats = $_POST['youtube_cats'];

    $uploadTags=explode(',',$ssr_tags);
    $uploadRes=sbAddYouTubeMovie($file_location, $ssr_movie_name, $ssr_description, $uploadTags, $youtube_cats);
    if(!$uploadRes)
    {
        sb_show_message(sprintf(PL_SR_ERR_UPLOAD_FILE, $ssr_movie_name), false, 'warning');
        fServices_Rutube_Upload();
        return false;
    }

	if(isset($_POST['btf_save']))
	{
		require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
		$row = array();

		$layout = new sbLayout();
		$row = $layout->checkPluginFields('pl_services_rutube', '', 'ssr_id');

		if ($row === false)
		{
            $layout->deletePluginFieldsFiles();
            fServices_Rutube_Upload();
           	return;
		}
	}

	if (isset($uploadRes['id']))
	{
		$row['ssr_rutube_id'] = $uploadRes['id'];
	}
	else
	{
		if(isset($_POST['btf_save']))
		{
			sb_show_message(PL_SR_ERR_UPLOAD_FILE, false, 'warning');
			fServices_Rutube_Upload();
		}
		return false;
	}

	$id = '';
	$ssr_url = sb_check_chpu($id, $ssr_url, $ssr_movie_name, 'sb_services_rutube', 'ssr_url', 'ssr_id');

	if(isset($_POST['btf_save']))
	{
		$_POST['ssr_show'] = $ssr_show;
		sb_submit_workflow_status($row, 'ssr_show', 'ssr_pub_start', 'ssr_pub_end');
	}
	else
	{
		$row['ssr_show'] = isset($ssr_show) ? intval($ssr_show) : 0;
	}

	$GLOBALS['sbVfs']->mLocal = true;

	$row['ssr_name'] = $ssr_movie_name;
	$row['ssr_description'] = $ssr_description;
	$row['ssr_date'] = sb_datetoint($ssr_date);
	$row['ssr_views'] = '0';
	$row['ssr_author'] = $ssr_author;
	$row['ssr_duration'] = '0';
	$row['ssr_size'] = 	$GLOBALS['sbVfs']->filesize($file_location);
	$row['ssr_user_id'] = '0';
	$row['ssr_status'] = '1';
	$row['ssr_url'] = $ssr_url;

	$GLOBALS['sbVfs']->mLocal = false;

	sql_query('INSERT INTO sb_services_rutube (?#) VALUES (?a)', array_keys($row), array_values($row));
	$id = sql_insert_id();

	if($id)
	{
		if(isset($_POST['btf_save']))
		{
			fClouds_Set_Field($id, 'pl_services_rutube', $ssr_tags);
			sb_mail_workflow_status('pl_services_rutube', $id, $ssr_movie_name, $ssr_show, 1);
        }
		else
		{
			include_once(SB_CMS_PL_PATH.'/pl_clouds/pl_clouds.inc.php');
			fClouds_Set_Field($id, 'pl_services_rutube', $ssr_tags);
		}
	}
	elseif(!$id)
	{
		if(isset($_POST['btf_save']))
		{
			sb_show_message(PL_SR_NOT_ADD_MOVIE);
			fServices_Rutube_Upload();
			return;
		}
		elseif(isset($_FILES['ssr_file_path']))
		{
            sb_add_system_message(sprintf(KERNEL_PROG_PL_SR_FORM_ERR_ADD_MOVIE, $ssr_movie_name), SB_MSG_WARNING);
			return false;
    	}
	}

	if(isset($_POST['btf_save']))
    {
		require_once(SB_CMS_LIB_PATH.'/sbElements.inc.php');
		$elems = new sbElements('sb_services_rutube', 'ssr_id', 'ssr_name', 'fServices_Rutube_Get', 'pl_services_rutube_init', 'pl_services_rutube');
		$cat_ids = array($elems->mCategsSelectedId);

		$change_user_id = (isset($_SESSION['sbAuth']) ? $_SESSION['sbAuth']->getUserId() : '0');
	}
	elseif(isset($_FILES['ssr_file_path']))
	{
		$change_user_id = '0';
	}

	$root_id = -1;
	$date = time();

	sql_query('LOCK TABLES sb_catlinks WRITE, sb_catchanges WRITE');
	foreach($cat_ids as $cat_id)
	{
		if($root_id == -1)
		{
			if (sql_query('INSERT INTO sb_catlinks (link_cat_id, link_el_id, link_src_cat_id) VALUES (?d, ?d, 0)', $cat_id, $id))
			{
				$id_cl = sql_insert_id();
			    sql_query('INSERT INTO sb_catchanges (el_id, cat_ident, change_date, change_user_id, action) VALUES (?d, ?, ?d, ?d, ?)', $id, 'pl_services_rutube', $date, $change_user_id, 'add');
				$root_id = $cat_id;
			}
		}
		else
		{
			sql_query('INSERT INTO sb_catlinks (link_cat_id, link_el_id, link_src_cat_id) VALUES (?d, ?d, ?d)', $cat_id, $id, $root_id);
		}
	}
	sql_query('UNLOCK TABLES');

	if(!isset($id_cl) || !$id_cl)
    {
    	sql_query('DELETE FROM sb_services_rutube WHERE ssr_id=?d', $id);

		if(isset($_POST['btf_save']))
        {
			sb_show_message(PL_SR_NOT_ADD_MOVIE);
            fServices_Rutube_Upload();
			return;
		}
		elseif(isset($_FILES['ssr_file_path']))
        {
        	sb_add_system_message(sprintf(KERNEL_PROG_PL_SR_FORM_ERR_ADD_MOVIE, $ssr_movie_name), SB_MSG_WARNING);
            return false;
		}
	}

	if(isset($_POST['btf_save']))
    {
    	echo '<script>
        	sbReturnValue('.$id.');
		</script>';
	}
	elseif(isset($_FILES['ssr_file_path']))
	{
		return $id;
	}
}

/**
 * Функция редактирования роликов на YouTube
 *
 * @param int $id Идентификатор ролика в cms
 * @param array $row Ассоциативный массив со значениями полей элемента (ключи - имена полей, значения - значения полей).
 * @param array $cats массив категорий ролика, в системе youtube.com
 * @param string $tags Тэги ролика, в системе youtube.com, перечисленные через запятую
 *
 *
 * @return mixed Если добавление идет со стороны сайта возвращает идентификатор добавленного элемента, FALSE в случае ошибки.
 */
function sbEditYouTubeMovies($id, $row, $cats, $tags)
{
	$yt_marker = trim(sbPlugins::getSetting('sb_services_rutube_youtube_marker'));
	if(!$yt_marker)
	{
		sb_show_message(PL_SR_EDIT_IMPORT_AUTH_LINK_DESCRIPTION);
		fServices_Rutube_Upload();
		return false;
	}

	$yt_dev_key = trim(sbPlugins::getSetting('sb_services_rutube_youtube_key'));
    if(!$yt_dev_key)
    {
		sb_show_message(PL_SR_NO_DIV_YOUTUBE_KEY);
		fServices_Rutube_Upload();
		return false;
	}

	set_time_limit(0);

	if(!isset($_POST['ssr_category']) && isset($_POST['btf_save']))
	{
		sb_show_message(PL_SR_UPLOAD_YOUTUBE_ERR_CATEG, false, 'warning');
		fServices_Rutube_Upload();
		return;
	}

	// Проверка полей
	$res1 = sql_query('SELECT ssr_name, ssr_description, ssr_rutube_id from sb_services_rutube where ssr_id = ?d', $id);

	if(!isset($row['ssr_name']))
		$row['ssr_name'] = $res1[0][0];
	if(!isset($row['ssr_description']))
		$row['ssr_description'] = $res1[0][1];

	$moovie_id = array();
	preg_match('/http:\/\/www.youtube.com\/v\/(.*)\?[.]*/im'.SB_PREG_MOD,$res1[0][2], $moovie_id);

	if(!isset($moovie_id[1]))
		return false;

	if(!is_array($cats))
		$cats = array($cats);

	$res = '';
	$xml_obj = '';
	$fp = fsockopen ("gdata.youtube.com", 80);
	if ($fp)
	{
		$data =
		'<?xml version="1.0"?>
			<entry xmlns="http://www.w3.org/2005/Atom"
	  		xmlns:media="http://search.yahoo.com/mrss/"
	  		xmlns:yt="http://gdata.youtube.com/schemas/2007">
	  			<media:group>
	    			<media:title type="plain">'.$row['ssr_name'].'</media:title>

	    			<media:description type="plain">'.$row['ssr_description'].'</media:description>';
					foreach ($cats as $v)
					{
						$data .= '<media:category scheme="http://gdata.youtube.com/schemas/2007/categories.cat">'.$v.'</media:category>';
					}
					$data .= '<media:keywords>'.$tags.'</media:keywords>
	  			</media:group>
			</entry>';

		$request ="PUT /feeds/api/users/default/uploads/".$moovie_id[1]." HTTP/1.1\r\n";
		$request.="Host: gdata.youtube.com\r\n";
		$request.="Content-Type: application/atom+xml; charset=UTF-8\r\n";
		$request.="Content-Length: ".strlen($data)."\r\n";
		$request.="Authorization: AuthSub token=".trim($yt_marker)."\r\n";

		$request.="X-GData-Client: default \r\n";
		$request.="X-GData-Key: key=".$yt_dev_key."\r\n";
		$request.="\r\n";
		$request.=$data."\r\n";

		fputs($fp,$request,strlen($request));
	 	while (!feof($fp))
	 	{
	 		$line = fgets ($fp);
        	if ($line!==FALSE)
        	{
        		if(sb_strpos($line,'<?xml') !== false)
        			$res .= trim($line);
        	}
    	}
	}
	if($res != '')
		$xml_obj = simplexml_load_string($res);

	if(!isset($xml_obj->id) || $xml_obj->id == '')
	{
		return false;
	}
	return true;
}


/**
 * Функция обновления access_token
 *
 */
function sbRefreshToken(){
    $token = sbGetUserToken();
    $message=array(
        'client_id' => tirm(sbPlugins::getSetting('sb_services_rutube_youtube_key')),
        'client_secret' => trim(sbPlugins::getSetting('sb_services_rutube_youtube_marker')),
        'refresh_token' => $token,
        'grant_type' => 'refresh_token'
    );

    $ch = curl_init('https://accounts.google.com/o/oauth2/token');
    curl_setopt($ch, CURLOPT_HEADER, 'Content-Type: application/x-www-form-urlencoded');
    curl_setopt($ch, CURLOPT_POSTFIELDS, $message);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_HEADER, 0);
    $res = curl_exec($ch);
    curl_close($ch);
    $obj = json_decode($res, true);
    if(array_key_exists('access_token',$obj)){
        return $obj['access_token'];
    } else {
        return false;
    }
}

/**
 * Функция получает  refresh_token
 *
 */
function sbGetUserToken(){
    $res=sql_query('SELECT u_refresh_token FROM sb_users WHERE u_id=?d',$_SESSION['sbAuth']->getUserId());
    return $res[0][0];
}
/**
 * Функция начинает добавление видео youtube
 *
 */
function sbAddYouTubeMovie($filePath, $movieName, $movieDescription, array $uploadTags, $catId){
    if(!isset($_SESSION['access_token']) && $_SESSION['access_token']==null){
        $_SESSION['access_token']=sbRefreshToken();
    }
    $fileSize=filesize($filePath);
    $header=array(
        'Content-Length'=>$fileSize,
        'Content-Type'=>'Content-Type: application/json; charset=utf-8',
        'X-Upload-Content-Length'=>$fileSize,
        'X-Upload-Content-Type'=>'video/*'
    );
    $data = array(
        'snippet' => array(
            'title'=>$movieName,
            'description'=>$movieDescription,
            'tags'=>$uploadTags,
            'categoryId'=>$catId),
        'status' => array(
            'privacyStatus'=>'public',
            'embeddable'=>true,
            'license'=>'youtube'
        ));
    $dataString = json_encode($data);
    $ch = curl_init('https://www.googleapis.com/upload/youtube/v3/videos?uploadType=resumable&part=snippet,status,contentDetails&access_token='.$_SESSION['access_token']);
    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
    curl_setopt($ch, CURLOPT_HTTPHEADER ,  $header);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $dataString);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_HEADER, true);
    $res=curl_exec($ch);
    $info = curl_getinfo($ch);
    curl_close($ch);
    preg_match("/location\:\s*(?<url>.+)/i",$res,$match);
    // проверить результат
    if(empty($match)){
        // истекло время токена
        if($info['http_code'] == '401') {
            $_SESSION['access_token'] = null;
            $uploadRes = sbAddYoutubeMovie($filePath, $movieName, $movieDescription, $uploadTags, $catId);
        } else{
            sb_show_message(PL_SR_ERR_APP, false, 'warning');
            return false;
        }
    } else {
        $uploadRes = sbAddYouTubeFile($match['url'], $filePath, $fileSize);
    }
    return $uploadRes;
}
/**
 * Функция закачивает сам файл видео.
 *
 */
function sbAddYouTubeFile($downloadLink, $filePath, $fileSize){
    $header=array(
        'Content-Length'=>$fileSize,
        'Content-Type'=>'video/*'
    );

    $ch = curl_init(trim($downloadLink));
    $fp = fopen($filePath, 'r');
    curl_setopt($ch, CURLOPT_PUT, true);
    curl_setopt($ch, CURLOPT_INFILE, $fp);
    curl_setopt($ch, CURLOPT_INFILESIZE, $fileSize);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_UPLOAD, true);
    $res=curl_exec($ch);
    $info = curl_getinfo($ch);
    $obj = json_decode($res, true);
    curl_close($ch);
    fclose($fp);
    if ($info['http_code'] == '200') {
        return $obj;
    }elseif ($info['http_code'] == '401') {
        $obj=sbAddYouTubeFile($downloadLink, $filePath, $fileSize);
        return $obj;
    }elseif ($info['http_code'] == '403') {
        sb_show_message(PL_SR_ERR_APP, false, 'warning');
        return false;
    } else {
        return false;
    }
}
