<?php
/**
 * Description of sbProfiler
 *
 * @author Serg
 */
class sbProfiler
{
    protected static $_instance = null;
    protected $_domain = null;
    protected $_inprogress = false;
    protected $_sql_enable = false;
    protected $_components_enable = false;
    protected $_allow_ips = '';
    protected $_sql_pool = array();
    protected $_plugins_pool = array();
    public static $sql_count = 0;
    protected $_pl_time_start = 0;
    protected $_pl_time_end = 0;
    protected $_pl_pool_hash = 0;
    protected $_need_reinit = true;
    protected $_client_ip = '';


    static public function init()
    {
        if(!self::$_instance)
        {
            self::$_instance = new sbProfiler();
        }
        
        if (class_exists('sbPlugins'))
        {
            self::$_instance->_need_reinit = false;
            self::$_instance->_domain            = defined('SB_KEY_DOMAIN') ? SB_KEY_DOMAIN
                    : SB_COOKIE_DOMAIN;
            self::$_instance->_sql_enable        = (sbPlugins::getSetting('sb_profiler_sql', self::$_instance->_domain) == 1)
                    ? true : false;
            self::$_instance->_components_enable = (sbPlugins::getSetting('sb_profiler_plugins', self::$_instance->_domain) == 1)
                    ? true : false;
            self::$_instance->_allow_ips         = (sbPlugins::getSetting('sb_profiler_ip', self::$_instance->_domain));
            self::$_instance->_client_ip = sbAuth::getIP();
        }
    }
    
    static public function SQL($sql, $time)
    {
        //Не профилируем начальный запрос настроек системы
        if(preg_match('/^select .+ from sb_settings\s*$/i'.SB_PREG_MOD, $sql))
        {
            return;
        }
        if(self::$_instance === null || self::$_instance->_need_reinit)
        {
            self::init();
        }
        
        if(!self::$_instance->checkIP())
        {
            return;
        }
        
        if(!self::$_instance->_sql_enable 
        || sb_stripos($sql, 'sb_profiler_sql') !== false 
        || sb_stripos($sql, 'sb_profiler_plugins') !== false 
        || sb_stripos($sql, 'sb_profiler_ip') !== false
        || sb_stripos($sql, 'sb_cron') !== false
        || sb_stripos($sql, 'u_pass') !== false)
        {
            if(sb_stripos($sql, 'sb_profiler_sql') === false
            && sb_stripos($sql, 'sb_profiler_plugins') === false
            && sb_stripos($sql, 'sb_profiler_ip') === false)
            {
                //Запрос не логируем, но считаем для профайла компонентов
                self::$sql_count++;
            }
            return;
        }

        $tracker = self::$_instance->parseTracer();
        $plugin = $tracker['plugin'];
        unset($tracker['plugin']);
        
        $uri = '';
        
        if (isset($_SERVER['REQUEST_URI']) && $_SERVER['REQUEST_URI'] != '')
        {
            $uri = (sb_stripos($_SERVER['REQUEST_URI'], SB_COOKIE_DOMAIN) === false
                        ? 'http://' . SB_COOKIE_DOMAIN : '') . $_SERVER['REQUEST_URI'];
        }
        
        self::$_instance->_sql_pool[] = array(
            'date' => time(),
            'time' => round($time, 6),
            'text_sql' => $GLOBALS['sbSql']->escape(preg_replace('/\s+/', ' ',$sql)),
            'tracker' => $GLOBALS['sbSql']->escape(serialize($tracker)),
            'plugin' => $GLOBALS['sbSql']->escape($plugin),
            'uri' => $GLOBALS['sbSql']->escape($uri),
            'domain' =>$GLOBALS['sbSql']->escape(self::$_instance->_domain),
            'hash' => $GLOBALS['sbSql']->escape(self::$_instance->_pl_pool_hash)
        );
        self::$sql_count++;
    }
    
    static public function Plugin($ident=null)
    {
        if(!self::$_instance->checkIP())
        {
            return;
        }
        
        if($ident !== null)
        {
            self::$_instance->profPLEnd($ident);
        }
        else
        {
            self::$_instance->profPLStart();
        }
    }
    
    protected function profPLStart()
    {
        self::$sql_count = 0;
        $this->_pl_time_start = microtime(true);
        $this->_pl_pool_hash = md5(microtime(true));
    }
    
    protected function profPLEnd($ident)
    {
        $this->_pl_time_end = microtime(true);
        
        $uri = '';
        if (isset($_SERVER['REQUEST_URI']) && $_SERVER['REQUEST_URI'] != '')
        {
            $uri = (sb_stripos($_SERVER['REQUEST_URI'], SB_COOKIE_DOMAIN) === false
                        ? 'http://' . SB_COOKIE_DOMAIN : '') . $_SERVER['REQUEST_URI'];
        }
        
        self::$_instance->_plugins_pool[] = array(
            'ident' => $GLOBALS['sbSql']->escape($ident),
            'time' => round($this->_pl_time_end - $this->_pl_time_start, 6),
            'sql_count' => self::$sql_count,
            'uri' => $GLOBALS['sbSql']->escape($uri),
            'domain' =>$GLOBALS['sbSql']->escape(self::$_instance->_domain),
            'date' => time(),
            'hash' => $GLOBALS['sbSql']->escape($this->_pl_pool_hash)
        );
        self::$sql_count = 0;
        $this->_pl_pool_hash = 0;
    }
    
    static public function flush()
    {
        self::$_instance->_sql_enable = self::$_instance->_components_enable = false;
        self::$_instance->_pl_pool_hash = 0;
        
        //Сохраняем профайлинг SQL-запросов
        $i = 0;
        $query_str = '';
        if(!empty(self::$_instance->_sql_pool))
        {
            foreach(self::$_instance->_sql_pool as $item)
            {
                $i++;
                $query_str .= '('.implode(',', $item).'), ';
                if($i >= 50)
                {
                    $query_str = 'INSERT INTO sb_profiler_sql (pr_date, pr_time, pr_text_sql, pr_tracker, pr_plugin, pr_url, pr_domain, pr_hash) VALUES '.sb_substr($query_str, 0, -2);
                    sql_param_query($query_str);
                    $query_str = '';
                    $i=0;
                }
            }
            if($query_str != '')
            {
                $query_str = 'INSERT INTO sb_profiler_sql (pr_date, pr_time, pr_text_sql, pr_tracker, pr_plugin, pr_url, pr_domain, pr_hash) VALUES '.sb_substr($query_str, 0, -2);
                sql_param_query($query_str);
            }
        }
        
        $query_str = '';
        $i = 0;
        if(!empty(self::$_instance->_plugins_pool))
        {
            foreach(self::$_instance->_plugins_pool as $item)
            {
                $i++;
                $query_str .= '('.implode(',', $item).'), ';
                if($i >= 50)
                {
                    $query_str = 'INSERT INTO sb_profiler_plugins (prp_ident, prp_time, prp_sql_count, prp_uri, prp_domain, prp_date, prp_hash) VALUES '.sb_substr($query_str, 0, -2);
                    sql_param_query($query_str);
                    $query_str = '';
                    $i=0;
                }
            }

            if($query_str != '')
            {
                $query_str = 'INSERT INTO sb_profiler_plugins (prp_ident, prp_time, prp_sql_count, prp_uri, prp_domain, prp_date, prp_hash) VALUES '.sb_substr($query_str, 0, -2);
                sql_param_query($query_str);
            }
        }
    }
    
    protected function parseTracer()
    {
        $aCallstack = debug_backtrace(false);
        $backtrace  = array();
        $plugin = 'Unknown';
        if (count($aCallstack) > 0)
        {
            $aCallstack = array_reverse($aCallstack);

            $i = 1;
            foreach ($aCallstack as $aCall)
            {
                if ($aCall['function'] == 'sb_php_error_reporting' || $aCall['function'] == 'sb_php_shutdown')
                    continue;
                
                if($aCall['function'] == 'paramQuery')
                    break;

                if (!isset($aCall['file']))
                    $aCall['file'] = KERNEL_ERROR_BACKTRACE_PHP_KERNEL;

                if (!isset($aCall['line']))
                    $aCall['line'] = '';
                
                if(isset($aCall['class']))
                    $aCall['function'] = $aCall['class'].$aCall['type'].$aCall['function'];

                $backtrace[] = array(
                    'function' => $aCall['function'],
                    'file' => sb_str_replace(SB_BASEDIR, '', sb_str_replace('\\', '/', $aCall['file'])),
                    'line' => $aCall['line']
                );
                
                if(isset($aCall['file']) && preg_match('/[\/\\\]plugins[\/\\\]/', $aCall['file']))
                {
                    $plugin = preg_replace('/.+[\/\\\]plugins[\/\\\]([a-z0-9_-]+)[\/\\\].+/', '$1', $aCall['file']);
                }
            }
        }
        $backtrace['plugin'] = $plugin;
        return $backtrace;
    }
    
    protected function checkIP()
    {
        if($this->_allow_ips == '')
        {
            return true;
        }
        
        $masks = explode(' ', $this->_allow_ips);
        foreach($masks as $mask)
        {
            if(sbAuth::compareIP($mask, $this->_client_ip))
            {
                return true;
            }
        }
        return false;
    }
    
    protected function __construct()
    {
        
    }
}

?>
