<?php
/**
 * Реализация класса визуального редактирования страниц
 *
 * @author Казбек Елекоев <elekoev@binn.ru>
 * @version 4.0
 * @package SB_VisualEditor
 * @copyright Copyright (c) 2007, OOO "СИБИЭС Групп"
 */

/**
 * Класс, реализущий визуальный редактор страниц
 *
 * @author Казбек Елекоев <elekoev@binn.ru>
 * @version 4.0
 * @package SB_VisualEditor
 * @copyright Copyright (c) 2007, OOO "СИБИЭС Групп"
 */
class sbVisualEditor
{
	/**
	 * Редактируемый HTML-код.
	 *
	 * @var string
	 */
	public $mValue = '';

	/**
	 * Выводит HTML-код редактора.
	 *
	 */
	public function show($page = '')
	{
		echo $this->createHtml($page) ;
	}

	/**
	 * Формирует HTML-код, необходимый для работы редактора.
	 *
	 * @return string
	 */
	private function createHtml($page)
	{
		$value = sb_htmlspecialchars( $this->mValue );
		$result = '';
		
		if ($page != '')
		{
			$default_text = sbPlugins::getUserSetting('sb_editor_default_new_text');
			if ($default_text != '')
			{
				$res = sql_query('SELECT COUNT(*) FROM sb_categs WHERE cat_id=?d AND cat_ident=?', $default_text, 'pl_texts');
				if ($res && $res[0][0] > 0)
				{
					$default_text = 1;
				}
				else 
				{
					$default_text = 0;
				}
			}
			else
			{
				$default_text = 0;
			}
			
			$result .= '<script src="'.SB_CMS_JSCRIPT_URL.'/sbCMenu.js.php"></script>
				<script>
                    sbEditorDesignItem = '.(sbPlugins::getUserSetting('sb_editor_design_item') == 1 ? 'true' : 'false').';
                    sbEditorDefaultNewText = '.$default_text.';
                    '.($_SESSION['sbPlugins']->isPluginAvailable('pl_workflow') ? 'var sbWorkflow = true;' : 'var sbWorkflow = false;').'
                </script>
                <script src="'.SB_CMS_JSCRIPT_URL.'/editor/sbVisualEditor.js.php"></script>';
		}
		
		$result .= '
			<form id="sb_editor_form" method="post" action="'.SB_CMS_EMPTY_FILE.'?event=pl_editor_save_block">
				<input type="hidden" name="value" id="sb_editor_value" value="'.$value.'" />
				<input type="hidden" name="el_id" id="sb_editor_el_id" value="" />
				<input type="hidden" name="el_type" id="sb_editor_el_type" value="" />
			</form>
			<iframe id="sb_editor_toolbar" src="'.SB_CMS_EMPTY_FILE.'?event=pl_editor_toolbar&mode='.($page == '' ? 'popup' : 'full' ).'" width="100%" height="104" frameborder="0" scrolling="no" unselectable="on" style="visibility: hidden;"></iframe>
			<iframe id="sb_editor_area" src="javascript: void(0);" width="100%" height="0" frameborder="0" '.($page == '' ? 'scrolling="no"' : 'scrolling="yes"').' style="border-top: 1px solid #737376;visibility: hidden;"></iframe>
			<script src="'.SB_CMS_JSCRIPT_URL.'/editor/sbPopupEditor.js.php"></script>
			<script>';
		
		if ($page != '')
		{
			$result .= 'sbGetE("sb_editor_area").src = "'.$page.'";';
		}
			
		$result .= '
			showLoading();
			sbGetE("event_content").style.overflow = "hidden";
			sbResizeFuncs[sbResizeFuncs.length]=sbResizeIFrame;
			</script>';
		
		return $result;
	}
}
?>