<?php

/********************************** функции построения диалоговых окон ***********************************/
function fBanners_Get_Elem()
{
    require_once(SB_CMS_LIB_PATH.'/sbJustCategs.inc.php');

    $params = unserialize($_GET['params']);

    echo '<script>
        function choose()
        {
            var res = new Object();
            var params = new Array();

            var el_cats = sbCatTree.getAllSelected();
            if (el_cats.length == 0)
            {
                alert("'.PL_BANNERS_H_ELEM_LIST_NO_CATEGS_MSG.'");
                return;
            }

            params["ids"] = el_cats;
            var el_temp = sbGetE("temp_id");
            if (el_temp)
            {
                params["temp_id"] = el_temp.value;
            }

            var el_sub_categs = sbGetE("sub_categs");
            if(el_sub_categs)
            {
                if(el_sub_categs.checked)
                {
                    params["sub_categs"] = 1;
                }
                else
                {
                    params["sub_categs"] = 0;
                }
            }

            res.temp_id = el_temp.value;
            res.params = sb_serialize(params);

            sbReturnValue(res);
        }
    </script>';

    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

    $layout = new sbLayout();
    $layout->mTableWidth = '100%';
    $layout->mTitleWidth = '200';

    $layout->addTab(PL_BANNERS_H_CATEG_TAB);

    $categs = new sbJustCategs('pl_banners');
    $categs->mCategsMenu = false;
    $categs->mCategsMultiSelect = true;

    $categs->mCategsSelectedIds = (isset($params['ids']) && $params['ids'] != '' ? explode('^', $params['ids']) : array());;

    $layout->addField('', new sbLayoutHTML($categs->showTree('', '', '', false), true));
    $categs->init();

    $layout->addTab(PL_BANNERS_H_PROPS_TAB);
    $layout->addHeader(PL_BANNERS_H_PROPS_TAB);

    $res = sql_query('SELECT categs.cat_title, temps.sbt_id, temps.sbt_title FROM sb_categs categs, sb_catlinks links, sb_banners_temps temps WHERE temps.sbt_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_banners_design" ORDER BY categs.cat_left, temps.sbt_title');
    if ($res)
    {
        $options = array();
        $old_cat_title = '';
        foreach ($res as $value)
        {
            list($cat_title, $st_id, $st_title) = $value;
            if ($old_cat_title != $cat_title)
            {
                $options[uniqid()] = '-'.$cat_title;
                $options[0] = ' ---- ';
                $old_cat_title = $cat_title;
			}
			$options[$st_id] = $st_title;
        }

		$fld = new sbLayoutSelect($options, 'temp_id');
		$fld->mSelOptions = array((isset($params['temp_id']) ? $params['temp_id'] : ''));

        $layout->addField(PL_BANNERS_H_DESIGN_LIST, $fld);
    }
    else
    {
        $layout->addField(PL_BANNERS_H_DESIGN_LIST, new sbLayoutLabel('<div class="hint_div">'.PL_BANNERS_H_DESIGN_NO_TEMPS_MSG.'</div>', '', '', false));
    }

    $layout->addField(PL_BANNERS_H_BAN_FROM_SUBCATEGS, new sbLayoutInput('checkbox', 'sub_categs', '1', 'sub_categs', (isset($params['sub_categs']) && $params['sub_categs'] == 1?' checked="checked"' : '')));
    $layout->addButton('button', KERNEL_SAVE, '', '', 'onclick="choose();"'.($res ? '' : ' disabled="disabled"'));
    $layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');

    $layout->show();

}


/********************************** функции получения информации по элементам модуля ***********************************/
function fBanners_Elem_Info($params)
{
    $categs_str = '';
    if(isset($params['ids']) && $params['ids'] != '')
    {
    	$in_str = '(0,'.sb_str_replace('^', ',', $params['ids']).')';

	    $res = sql_query('SELECT cat_title FROM sb_categs WHERE cat_id IN '.$in_str.' ORDER BY cat_left');
	    if ($res)
	    {
	        foreach ($res as $value)
	        {
	            $categs_str .= $value[0].', ';
	        }
	        $categs_str = substr($categs_str, 0, -2);
	    }
    }

    $res = sql_param_query('SELECT categs.cat_title, temps.sbt_title FROM sb_categs categs, sb_catlinks links, sb_banners_temps temps
                            WHERE temps.sbt_id=?d AND links.link_el_id=temps.sbt_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_banners_design"', $params['temp_id']);

    echo '<div style="padding-bottom: 5px;"><b>'.PL_BANNERS_H_INFO_CATEGS.':</b> '.($categs_str != '' ? $categs_str : '<span style="color:red;">'.PL_BANNERS_H_INFO_CATEGS_WAS_DELETED_MSG.'</span>').'</div>
          <div style="padding-bottom: 5px;"><b>'.PL_BANNERS_H_DESIGN_DESIGN.':</b> '.($res ? $res[0][0].' -&gt; '.$res[0][1] : '<span style="color:red;">'.PL_BANNERS_H_INFO_TEMP_WAS_DELETED_MSG.'</span>').'</div>
          <div class="delim"></div>
          <div style="padding-bottom: 5px;"><b>'.PL_BANNERS_H_INFO_SUBCATEGS.':</b> '.(isset($params['sub_categs']) && $params['sub_categs'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>';

}


/********************************** функции получения элементов модуля ***********************************/
function fBanners_Elem($el_id, $temp_id, $params, $tag_id)
{
    return "<?php include_once SB_CMS_PL_PATH.'/pl_banners/prog/pl_banners.php'; \n
        fBanners_Elem('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id');\n
    ?>";
}

//------------------- Вывод списка баннеров -------------------
function fBanners_Get_Elem_List()
{
    $params = unserialize($_GET['params']);

    if (!isset($params['subcategs']))
    	$params['subcategs'] = 0;

    echo '<script type="text/javascript">
        function changeSort(el, el_id)
        {
            var order_el = sbGetE("order" + el_id);
            if (el.value == "RAND()" || el.value == "")
            {
                order_el.disabled = true;
            }
            else
            {
                order_el.disabled = false;
            }
        }

        function chooseCat()
        {
            var res = new Object();
            var params = new Array();

            var el_cats = sbCatTree.getAllSelected();
            if (el_cats.length == 0)
            {
                alert("'.PL_BANNERS_H_ELEM_LIST_NO_CATEGS_MSG.'");
                return;
            }

            params["ids"] = el_cats;
            var el_temp = sbGetE("temp_id");
            if (el_temp)
            {
                params["temp_id"] = el_temp.value;
			}
            else
            {
                alert("'.PL_BANNERS_H_ELEM_LIST_NO_TEMPS_ALERT.'");
                return;
            }


            var el_sort1 = sbGetE("sort1");
            var el_order1 = sbGetE("order1");
            var el_sort2 = sbGetE("sort2");
            var el_order2 = sbGetE("order2");
            var el_sort3 = sbGetE("sort3");
            var el_order3 = sbGetE("order3");

            params["sort1"] = el_sort1.value;
            params["sort2"] = el_sort2.value;
            params["sort3"] = el_sort3.value;

            params["order1"] = el_order1.disabled ? "" : el_order1.value;
            params["order2"] = el_order2.disabled ? "" : el_order2.value;
            params["order3"] = el_order3.disabled ? "" : el_order3.value;


            params["subcategs"] = sbGetE("subcategs").checked ? 1 : 0;

			res.temp_id = el_temp.value;
			res.params = sb_serialize(params);

			sbReturnValue(res);
		}
    </script>';

    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
    require_once(SB_CMS_LIB_PATH.'/sbJustCategs.inc.php');

    $layout = new sbLayout();
    $layout->mTableWidth = '100%';
    $layout->mTitleWidth = '200';

    $layout->addTab(PL_BANNERS_H_CATEG_TAB);

    $categs = new sbJustCategs('pl_banners');
    $categs->mCategsUseRights = false;
    $categs->mCategsMenu = false;
    $categs->mCategsMultiSelect = true;
    $categs->mCategsSelectedIds = (isset($params['ids']) && $params['ids'] != '' ? explode('^', $params['ids']) : array());

    $layout->addField('', new sbLayoutHTML($categs->showTree('', '', '', false), true));
    $categs->init();

    $layout->addTab(PL_BANNERS_H_PROPS_TAB);
    $layout->addHeader(PL_BANNERS_H_PROPS_TAB);

    $options = array();
    $res = sql_query('SELECT categs.cat_title, temps.sbdl_id, temps.sbdl_title FROM sb_categs categs, sb_catlinks links, sb_banners_temps_list temps WHERE temps.sbdl_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_banners_design_list" ORDER BY categs.cat_left, temps.sbdl_title');
    if ($res)
    {
        $old_cat_title = '';
        foreach ($res as $value)
        {
            list($cat_title, $sbdl_id, $sbdl_title) = $value;
            if ($old_cat_title != $cat_title)
            {
                $options[uniqid()] = '-'.$cat_title;
                $old_cat_title = $cat_title;
            }
            $options[$sbdl_id] = $sbdl_title;
        }


    }

    if (count($options) > 0)
    {
    	$fld = new sbLayoutSelect($options, 'temp_id');
        if (isset($_GET['temp_id']))
        {
            $fld->mSelOptions = array($_GET['temp_id']);
        }
    }
    else
    {
        $fld = new sbLayoutLabel('<div class="hint_div">'.PL_BANNERS_H_ELEM_LIST_NO_TEMPS_MSG.'</div>', '', '', false);
    }

    $layout->addField(PL_BANNERS_H_DESIGN_DESIGN, $fld);
    $layout->addField('', new sbLayoutDelim());

    $fields = sbPlugins::getSortFields('pl_banners');

    $res = sql_query('SELECT pd_fields FROM sb_plugins_data WHERE pd_plugin_ident="pl_banners"');
    if ($res)
    {
        list($pd_fields) = $res[0];
        $pd_fields = unserialize($pd_fields);

		if(is_array($pd_fields) && count($pd_fields) > 0)
		{
        	foreach($pd_fields as $value)
        	{
        	    if ($value['type'] == 'string' ||
       		        $value['type'] == 'number' ||
        	        $value['type'] == 'date' ||
        	        $value['type'] == 'checkbox' ||
        	        $value['type'] == 'image' ||
        	        $value['type'] == 'link' ||
        	        $value['type'] == 'file' ||
        	        $value['type'] == 'color' ||
        	        $value['type'] == 'select_sprav' ||
        	        $value['type'] == 'radio_sprav' ||
	    	        $value['type'] == 'select_plugin' ||
	    	        $value['type'] == 'radio_plugin' ||
	    	        $value['type'] == 'elems_plugin')
        	    {
           		    $fields['sb.user_f_'.$value['id']] = $value['title'];

		        	if ($value['type'] == 'date')
		        	{
                	    $calendar_fields['user_f_'.$value['id']] = $value['title'];
		    		}
            	}
			}
		}
    }

    $order = array('DESC' => PL_BANNERS_H_ELEM_LIST_SORT_DESC,
                   'ASC'  => PL_BANNERS_H_ELEM_LIST_SORT_ASC);

    $fld1 = new sbLayoutSelect($fields, 'sort1', '', 'onchange="changeSort(this, 1);"');
    $fld1->mSelOptions = array((isset($params['sort1']) ? $params['sort1'] : 'im.im_date'));
    $fld2 = new sbLayoutSelect($order, 'order1');
    $fld2->mSelOptions = array((isset($params['order1']) && $params['order1'] != '' ? $params['order1'] : 'DESC'));
    $fld1->mHTML = '&nbsp;&nbsp;'.$fld2->getField();

    $layout->addField(PL_BANNERS_H_ELEM_LIST_SORT_FIELD.' 1', $fld1);

    $fld1 = new sbLayoutSelect($fields, 'sort2', '', 'onchange="changeSort(this, 2);"');
    $fld1->mSelOptions = array((isset($params['sort2']) && $params['sort1'] != '' ? $params['sort2'] : ''));
    $fld2 = new sbLayoutSelect($order, 'order2');
    $fld2->mSelOptions = array((isset($params['order2']) && $params['order1'] != '' ? $params['order2'] : ''));
    $fld1->mHTML = '&nbsp;&nbsp;'.$fld2->getField();

    $layout->addField(PL_BANNERS_H_ELEM_LIST_SORT_FIELD.' 2', $fld1);

    $fld1 = new sbLayoutSelect($fields, 'sort3', '', 'onchange="changeSort(this, 3);"');
    $fld1->mSelOptions = array((isset($params['sort3']) && $params['sort1'] != '' ? $params['sort3'] : ''));
    $fld2 = new sbLayoutSelect($order, 'order3');
    $fld2->mSelOptions = array((isset($params['order3']) && $params['order3'] != '' ? $params['order3'] : ''));
    $fld1->mHTML = '&nbsp;&nbsp;'.$fld2->getField();

    $layout->addField(PL_BANNERS_H_ELEM_LIST_SORT_FIELD.' 3', $fld1);

    $layout->addField('', new sbLayoutDelim());
    $layout->addField(PL_BANNERS_H_ELEM_LIST_SUBCATEGS, new sbLayoutInput('checkbox', '1', 'subcategs', '', (isset($params['subcategs']) && $params['subcategs'] == 1 ? 'checked="checked"' : '')));

    $layout->addButton('button', KERNEL_SAVE, '', '', 'onclick="chooseCat();"'.(count($options) > 0 ? '' : ' disabled="disabled"'));
	$layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');

    $layout->show();
}

function fBanners_Elem_List_Info($params)
{
    $in_str = implode(',', explode('^', $params['ids']));
    $in_str = '(0,'.$in_str.')';
    $categs_str = '';
    $res = sql_query('SELECT cat_title FROM sb_categs WHERE cat_id IN '.$in_str.' ORDER BY cat_left');
    if ($res)
    {
        $categs_str = '';
        foreach ($res as $value)
        {
            $categs_str .= $value[0].', ';
        }
        $categs_str = substr($categs_str, 0, -2);
    }

    $res = sql_param_query('SELECT categs.cat_title, temps.sbdl_title FROM sb_categs categs, sb_catlinks links, sb_banners_temps_list temps
				                         WHERE temps.sbdl_id=?d AND links.link_el_id=temps.sbdl_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_banners_design_list"', $params['temp_id']);

    echo '<div style="padding-bottom: 5px;"><b>'.PL_BANNERS_H_INFO_CATEGS.':</b> '.($categs_str != '' ? $categs_str : '<span style="color:red;">'.PL_BANNERS_H_INFO_CATEGS_WAS_DELETED_MSG.'</span>').'</div>
          <div style="padding-bottom: 5px;"><b>'.PL_BANNERS_H_DESIGN_DESIGN.':</b> '.($res ? $res[0][0].' -&gt; '.$res[0][1] : '<span style="color:red;">'.PL_BANNERS_H_INFO_TEMP_WAS_DELETED_MSG.'</span>').'</div>

          <div class="delim"></div>
          <div style="padding-bottom: 5px;"><b>'.PL_BANNERS_H_INFO_SUBCATEGS.':</b> '.(isset($params['subcategs']) && $params['subcategs'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>
          <div style="padding-bottom: 5px;"><b>'.PL_BANNERS_H_INFO_RUBRIK_LINK.':</b> '.(isset($params['rubrikator']) && $params['rubrikator'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>
          <div class="delim"></div>';
}

function fBanners_Elem_List($el_id, $temp_id, $params, $tag_id)
{
    return "<?php include_once SB_CMS_PL_PATH.'/pl_banners/prog/pl_banners.php'; \n
        fBanners_Elem_List('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id');\n
    ?>";
}
?>