<?php

function fBanners_Get($args)
{
    $icon = '';
    if ($args['sb_upload_name'] != '') {
        $args['sb_upload_name'] = sb_str_replace(SB_COOKIE_DOMAIN, '', $args['sb_upload_name']);
        $args['sb_upload_name'] = sb_str_replace('http://', '', $args['sb_upload_name']);
        $args['sb_upload_name'] = sb_str_replace('www.', '', $args['sb_upload_name']);

        $GLOBALS['sbVfs']->mLocal = true;
        $img = $GLOBALS['sbVfs']->getimagesize(SB_BASEDIR . $args['sb_upload_name']);
        $GLOBALS['sbVfs']->mLocal = false;

        if (isset($img[0]) && isset($img[1])) {
            $size = '';
            if ($img[0] >= $img[1] && $img[0] > 200) {
                $size = 'width="200"';
            } elseif ($img[0] < $img[1] && $img[1] > 100) {
                $size = 'height="100"';
            }

            $icon = '<img src="' . $args['sb_upload_name'] . '" ' . $size . '>';
        }
    }

    if ($icon == '') {
        $icon = $_SESSION['sbPlugins']->getPluginsInfo();
        $icon = str_replace('24', '32', $icon['pl_banners']['icon']);

        $icon = '<img src="' . $icon . '">';
    }

    $result = '<table><tr><td>' . $icon . '</td>
                <td style="padding-left:5px;"><b><a href="javascript:void(0);" onclick="sbElemsEdit(event);" id="sb_name' . $args['sb_id'] . '">' . strip_tags($args['sb_name']) . '</a></b>
    <div class="smalltext" style="margin-top: 7px;">';

    $res = sql_param_query('SELECT sum(sb_count_clicks), sum(sb_count_views) FROM sb_banners_statistics WHERE sb_bid= ?d GROUP BY sb_bid', $args['sb_id']);

    $views = 0;
    $clicks = 0;

    if ($res) {
        list($clicks, $views) = $res[0];
    }

    $result .= PL_BANNERS_FILTER_ID . ': <span style="color:#33805E;">' . (isset($args['sb_id']) ? $args['sb_id'] : '') . '</span><br />';
    $result .= PL_BANNERS_GET_VIEWS_COUNT . ': <span style="color:#33805E;">' . $views . '</span><br />';
    $result .= PL_BANNERS_GET_CLICKS . ': <span style="color:#33805E;">' . $clicks . '</span><br />';
    $result .= PL_BANNERS_GET_CTR . ': <span style="color:#33805E;">' . ($views > 0 ? round(($clicks / $views) * 100, 2) : '0') . '%</span><br />';
    $result .= PL_BANNERS_GET_PRIORITY . ': ' . (isset($args['sb_priority']) ? '<span style="color: #33805E;">' . $args['sb_priority'] . '</span><br />' : '<br />');
    $result .= PL_BANNERS_GET_VIEWS . ': <span style="color:#33805E;">' . ($args['sb_count_show'] == -1 ? '<i>' . PL_BANNERS_EDIT_UNLIMITED_BOX . '</i>' : $args['sb_count_show']) . '</span>';

    sb_get_workflow_status($result, 'pl_banners', $args['sb_active'], $args['sb_date_from'], $args['sb_date_to']);

    require_once(SB_CMS_LIB_PATH . '/sbLayout.inc.php');
    $result .= sbLayout::getPluginFieldsInfo('pl_banners', $args);
    $result .= '</div></td></tr></table>';

    return $result;
}

function fBanners_Init()
{
    require_once(SB_CMS_LIB_PATH . '/sbElements.inc.php');

    $elems = new sbElements('sb_banners', 'sb_id', 'sb_name', 'fBanners_Get', 'pl_banners_init', 'pl_banners');
    $elems->mCategsRootName = PL_BANNERS_ROOT_CATEG_NAME;

    $elems->addField('sb_name');
    $elems->addField('sb_priority');
    $elems->addField('sb_count_show');
    $elems->addField('sb_code');
    $elems->addField('sb_upload_name');
    $elems->addField('sb_active');
    $elems->addField('sb_date_to');
    $elems->addField('sb_date_from');

    $elems->addFilter(PL_BANNERS_FILTER_ID, 'sb_id', 'number');
    $elems->addFilter(PL_BANNERS_EDIT_TITLE, 'sb_name', 'string');

    $elems->mShowIcons = false;

    $elems->addSorting(PL_BANNERS_SORT_BY_ID, 'sb_id');
    $elems->addSorting(PL_BANNERS_SORT_BY_NAME, 'sb_name');
    $elems->addSorting(PL_BANNERS_SORT_BY_PRIORITY, 'sb_priority');

    $elems->mCategsPasteWithElementsMenu = true;

    $elems->mElemsUseLinks = true;
    $elems->mElemsEditEvent = 'pl_banners_edit';
    $elems->mElemsEditDlgWidth = '800';
    $elems->mElemsEditDlgHeight = '600';

    $elems->mElemsAddEvent = 'pl_banners_edit';
    $elems->mElemsAddDlgWidth = '800';
    $elems->mElemsAddDlgHeight = '600';

    $elems->mElemsDeleteEvent = 'pl_banners_delete';
    $elems->mCategsDeleteWithElementsMenu = true;
    $elems->mCategsAfterDeleteWithElementsEvent = 'pl_banners_delete_cat_with_elements';

    $elems->mElemsAfterPasteEvent = 'pl_banners_after_paste';
    $elems->mCategsAfterPasteWithElementsEvent = 'pl_banners_after_paste_with_elements';

    if ($_SESSION['sbPlugins']->isRightAvailable('pl_banners',
            'elems_public') && (!$_SESSION['sbPlugins']->isPluginAvailable('pl_workflow') || !$_SESSION['sbPlugins']->isPluginInWorkflow('pl_banners'))
    ) {
        $elems->mElemsJavascriptStr = '
            function bannersSetActive()
            {
                var ids = "0";
                for (var i = 0; i < sbSelectedEls.length; i++)
                {
                    var el = sbGetE("el_" + sbSelectedEls[i]);
                    if (el)
                        ids += "," + el.getAttribute("el_id");
                }

                var res = sbLoadSync("' . SB_CMS_EMPTY_FILE . '?event=pl_banners_set_active&ids=" + ids);
                if (res != "TRUE")
                {
                    alert("' . PL_BANNERS_SHOWHIDE_ERROR . '");
                    return;
                }

                var div_el = sbGetE("elems_list_div");
                var from = "";
                if (div_el)
                {
                    from = div_el.getAttribute("from");
                }
                var url = sb_cms_empty_file + "?event=" + sb_elems_event + "&id=" + sbCatTree.getSelectedItemId() + "&page_elems=" + from;
                sbElemsShow(url);
            }';
        $elems->addElemsMenuItem(PL_BANNERS_SET_ACTIVE, 'bannersSetActive();');
    }

    $elems->mElemsJavascriptStr .= '
                    function statDelete()
                    {
                        var strPage = "' . SB_CMS_MODAL_DIALOG_FILE . '?event=pl_banners_stat_delete";
                        var strAttr = "resizable=1,width=500,height=280";
                        sbShowModalDialog(strPage, strAttr, "");

                    }';
    $elems->addElemsMenuItem(PL_BANNERS_INIT_STAT_DELETE, 'statDelete();', false);

    $elems->mElemsJavascriptStr .= '
        function sbBanExport(c)
        {
            if(c && sbSelCat)
            {
                var cat_id = sbSelCat.id;
            }
            else
            {
                var cat_id = sbCatTree.getSelectedItemId();
            }
            var args = new Object();
            var form = sbGetE("filter_form");
            if(form)
            {
                var els = form.elements;
                for(var i = 0; i < els.length; i++)
                {
                    if(els[i] && els[i].type != "button" && els[i].value != "")
                    {
                        var reg_date = new RegExp("date_");
                        var reg_spin = new RegExp("spin_");

                        if(reg_date.test(els[i].id))
                        {
                            args[els[i].name] = {};
                            args[els[i].name]["value"]= els[i].value;
                            args[els[i].name]["type"]= "date";
                        }
                        else if(reg_spin.test(els[i].id))
                        {
                            args[els[i].name] = {};
                            args[els[i].name]["value"]= els[i].value;
                            args[els[i].name]["type"]= "number";
                        }
                        else if(els[i].nodeName == "SELECT" && els[i].multiple)
                        {
                            var str = "";
                            for(var j = 0; j < els[i].length; j++)
                            {
                                if(els[i][j].selected)
                                    str += els[i][j].value+",";
                            }
                            str = str.slice(0, -1);

                            args[els[i].name] = {};
                            args[els[i].name]["value"]= str;
                            args[els[i].name]["type"]= "multyselect";
                        }
                        else if(els[i].nodeName == "SELECT")
                        {
                            var reg_link = new RegExp("_link");
                            if(els[i].value == -1 && reg_link.test(els[i].id))
                            {
                                var name = els[i].name.replace(/_link/, "");
                                args[name] = "";
                                continue;
                            }
                            else if(els[i].value == -1)
                            {
                                continue;
                            }

                            args[els[i].name] = {};
                            args[els[i].name]["value"]= els[i].value;
                            args[els[i].name]["type"]= "select";
                        }
                        else if(els[i].type == "ckeckbox")
                        {
                            args[els[i].name] = {};
                            args[els[i].name]["value"]= els[i].value;
                            args[els[i].name]["type"]= "checkbox";
                        }
                        else if(els[i].type == "text")
                        {
                            args[els[i].name] = {};
                            args[els[i].name]["value"]= els[i].value;
                            args[els[i].name]["type"]= "string";
                        }
                    }
                }
            }

            var strPage = "' . SB_CMS_DIALOG_FILE . '?event=pl_export_edit&ident=pl_banners&cat_id="+ cat_id;
            var strAttr = "resizable=1,width=700,height=600";
            sbShowModalDialog(strPage, strAttr, null, args);
        }
        function sbBanImport(c)
        {
            if(c && sbSelCat)
            {
                var cat_id = sbSelCat.id;
            }
            else
            {
                var cat_id = sbCatTree.getSelectedItemId();
            }

            var args = new Object();

            var strPage = "' . SB_CMS_DIALOG_FILE . '?event=pl_export_import_edit&ident=pl_banners&cat_id="+ cat_id;
            var strAttr = "resizable=1,width=650,height=370";
            sbShowModalDialog(strPage, strAttr, sbAfterBanImport, args);
        }

        function sbAfterBanImport()
        {
            window.location.href = "' . SB_CMS_CONTENT_FILE . '?event=pl_banners_init";
        }';

    $elems->addElemsMenuItem(PL_BANNERS_EDIT_EXPORT, 'sbBanExport()', false);
    //$elems->addElemsMenuItem(PL_BANNERS_EDIT_IMPORT, 'sbBanImport()', false);

    $elems->addCategsMenuItem(PL_BANNERS_EDIT_EXPORT, 'sbBanExport(true)');
    //$elems->addCategsMenuItem(PL_BANNERS_EDIT_IMPORT, 'sbBanImport(true)');

    $elems->init();
}

function fBanners_Edit($htmlStr = '', $footerStr = '', $footerLinkStr = '')
{
    //    определяем групповое редактирование или нет.
    $edit_group = sbIsGroupEdit();

    if (!$edit_group) {
        if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'], 'pl_banners')) {
            return;
        }
    } else {
        if (!fCategs_Check_Elems_Rights($_GET['ids'][0], $_GET['cat_id'], 'pl_banners')) {
            return;
        }
    }

    $edit_rights = $_SESSION['sbPlugins']->isRightAvailable('pl_banners', 'elems_edit');

    if (count($_POST) == 0 && isset($_GET['id']) && $_GET['id'] != '' && !$edit_group) {
        $result = sql_param_query('SELECT sb_name, sb_link, sb_code, sb_upload_name, sb_count_show, sb_priority, sb_date_from, sb_date_to, sb_plan_dates, sb_active, sb_statistics, sb_restricted_cats
                             FROM sb_banners WHERE sb_id = ?d', $_GET['id']);
        if ($result) {
            list($sb_name, $sb_link, $sb_code, $sb_upload_name, $sb_count_show, $sb_priority, $sb_date_from, $sb_date_to, $sb_plan_dates, $sb_active, $sb_statistics, $sb_restricted_cats) = $result[0];
        } else {
            sb_show_message(PL_BANNERS_EDIT_ERROR, true, 'warning');
            return;
        }

        if (!is_null($sb_date_from)) {
            $sb_date_from = date('d.m.Y H:i', $sb_date_from);
        } else {
            $sb_date_from = '';
        }

        if (!is_null($sb_date_to)) {
            $sb_date_to = date('d.m.Y H:i', $sb_date_to);
        } else {
            $sb_date_to = '';
        }
    } elseif (count($_POST) > 0) {
        $sb_statistics = 0;
        $sb_plan_dates = '';
        $sb_unlimited = 0;
        $sb_active = 0;

        extract($_POST);
        if (!isset($_GET['id'])) {
            $_GET['id'] = '';
        }

        if ($sb_unlimited == 1) {
            $sb_count_show = -1;
        } elseif ($add_views > 0) {
            $sb_count_show = $sb_count_show + $add_views;
        }
    } else {
        $sb_restricted_cats = $sb_name = $sb_code = $sb_upload_name = $sb_link = $sb_plan_dates = '';
        $sb_count_show = '0';
        $sb_statistics = 1;
        $sb_priority = 1;
        $sb_count_show = -1;
        $sb_active = 1;

        $sb_date_from = date('d.m.Y H:i', mktime(0, 0, 0, date("m"), date("d"), date("Y")));
        $sb_date_to = date('d.m.Y H:i', mktime(0, 0, 0, date("m") + 1, date("d"), date("Y")));

        $_GET['id'] = '';
    }
    echo '<script>
            function typeBanner(radio_id)
            {
                if(radio_id == "tt")
                {
                    sbGetE("img").style.display = "none";
                    sbGetE("text").style.display = "block";
                    sbGetE("sb_upload_name").value = "";
                }
                else if (radio_id == "tg")
                {
                    sbGetE("img").style.display = "block";
                    sbGetE("text").style.display = "none";
                    sbGetE("sb_code").value = "";
                }
            }

            function checkValues()
            {
                var el_title = sbGetE("sb_name");
                ' . ($edit_group ? '
                    var ch_n = sbGetE("ch_sb_name");
                    var ch_t = sbGetE("ch_type");
                ' : '') . '

                if (el_title.value == "" ' . ($edit_group ? ' && ch_n.checked' : '') . ')
                {
                     alert("' . PL_BANNERS_EDIT_NO_TITLE_MSG . '");
                     return false;
                }

                var img = sbGetE("tg");
                var text = sbGetE("tt");

                if(img.checked ' . ($edit_group ? ' && ch_t.checked' : '') . ')
                {
                    if(sbGetE("sb_upload_name").value == "")
                    {
                        alert("' . PL_BANNERS_EDIT_NO_IMG . '");
                        return false;
                    }
                }

                if(text.checked ' . ($edit_group ? ' && ch_t.checked' : '') . ')
                {
                    if(window.sbCodeditor_sb_code)
                    {
                        var code = sbCodeditor_sb_code.getCode();
                    }
                    else
                    {
                        var code = sbGetE("sb_code").value;
                    }

                    if(!code)
                    {
                        alert("' . PL_BANNERS_EDIT_NO_TEXT . '");
                        return false;
                    }
                }
            }

            function addFile(num_files)
            {
                num_files++;
                var elem = sbGetE("ch_index_id");
                elem.firstChild.id = num_files;

                var el = sbGetE("td_files");
                var nobr = document.createElement("NOBR");
                var br = document.createElement("BR");
                nobr.innerHTML = "<input type=\'text\' style=\'width:94%;\' value=\'\' id=\'pages_urls["+num_files+"]\' name=\'pages_urls["+num_files+"]\'/>\n               <input type=\'hidden\' value=\'\' id=\'pages_urls["+num_files+"]_title\'/>\n               \n               &nbsp;<img height=\'20\' align=\'absmiddle\' width=\'20\' onclick=\"sbGetPage(\'pages_urls["+num_files+"]\')\"  id=\'pages_urls["+num_files+"]_button\' onmousedown=\'sbPress(this, true);\' onmouseup=\'sbPress(this, false);\' src=\'' . SB_CMS_IMG_URL . '/pages.png\' class=\'button\'/>";
                el.appendChild(br);
                el.appendChild(nobr);
            }

            function changeActive(el)
            {
                var pub_s = sbGetE("sb_date_from");
                var pub_e = sbGetE("sb_date_to");

                pub_s.disabled = !el.checked;
                pub_e.disabled = !el.checked;

                pub_s.value = "";
                pub_e.value = "";
            }

            function findSWF(movieName)
            {
                  if (navigator.appName.indexOf("Microsoft")!= -1)
                  {
                    return document.forms[0][movieName];
                  }
                  else
                  {
                    return document[movieName];
                  }
            }

            var graph_period_day = 0;
            var graph_period_month = 0;
            var graph_period_year = 0;

            var graph_period = "day";

            function reload_graph(period_val, next_prev)
            {
                var views_graph = findSWF("views_graph");
                var ctr_graph = findSWF("ctr_graph");
                var click_graph = findSWF("click_graph");

                if(period_val && period_val != "")
                    graph_period = period_val;

                if(!next_prev || next_prev == "")
                    next_prev = "0";

                var from = "";
                if(graph_period == "day" && !(graph_period_day == 0 && next_prev > 0))
                {
                    graph_period_day = graph_period_day - next_prev;
                    from = graph_period_day;

                    sbGetE("year_link").style.color = "#A50101";
                    sbGetE("month_link").style.color = "#A50101";
                    sbGetE("day_link").style.color = "#FF9933";
                    sbGetE("year_link_2").style.color = "#A50101";
                    sbGetE("month_link_2").style.color = "#A50101";
                    sbGetE("day_link_2").style.color = "#FF9933";
                }
                else if(graph_period == "month" && !(graph_period_month == 0 && next_prev > 0))
                {
                    graph_period_month = graph_period_month - next_prev;
                    from = graph_period_month;

                    sbGetE("year_link").style.color = "#A50101";
                    sbGetE("month_link").style.color = "#FF9933";
                    sbGetE("day_link").style.color = "#A50101";
                    sbGetE("year_link_2").style.color = "#A50101";
                    sbGetE("month_link_2").style.color = "#FF9933";
                    sbGetE("day_link_2").style.color = "#A50101";
                }
                else if(graph_period == "year" && !(graph_period_year == 0 && next_prev > 0))
                {
                    graph_period_year = graph_period_year - next_prev;
                    from = graph_period_year;

                    sbGetE("year_link").style.color = "#FF9933";
                    sbGetE("month_link").style.color = "#A50101";
                    sbGetE("day_link").style.color = "#A50101";
                    sbGetE("year_link_2").style.color = "#FF9933";
                    sbGetE("month_link_2").style.color = "#A50101";
                    sbGetE("day_link_2").style.color = "#A50101";
                }


                views_graph.reload("' . SB_CMS_EMPTY_FILE . '?event=pl_banners_stat_show&graph=views&period="+graph_period+"&from="+from+"&id=' . $_GET['id'] . '");
                ctr_graph.reload("' . SB_CMS_EMPTY_FILE . '?event=pl_banners_stat_show&graph=ctr&period="+graph_period+"&from="+from+"&id=' . $_GET['id'] . '");;
                click_graph.reload("' . SB_CMS_EMPTY_FILE . '?event=pl_banners_stat_show&graph=click&period="+graph_period+"&from="+from+"&id=' . $_GET['id'] . '");
            }

            function after_save_graph(str)
            {
                if (str == "FALSE")
                {
                    alert("' . PL_BANNERS_STAT_SHOW_IMG_SAVE_ERROR . '");
                    return;
                }

                window.open("' . SB_CMS_EMPTY_FILE . '?event=pl_kernel_download_graph_image&image=" + str);
            }

            function save_graph(el_id)
            {
                var graph = findSWF(el_id);
                sbPostAsync("' . SB_CMS_EMPTY_FILE . '?event=pl_kernel_upload_graph_image", graph.get_img_binary(), after_save_graph, "application/octet-stream");

            }';

    if ($htmlStr != '') {
        echo '
            function cancel()
            {';
        if ($edit_group) {
            echo 'sbReturnValue("refresh");';
        } else {
            echo 'var res = new Object();
                    res.html = "' . $htmlStr . '";
                    res.footer = "' . $footerStr . '";
                    res.footer_link = "' . $footerLinkStr . '";
                    sbReturnValue(res);';
        }
        echo '}
            sbAddEvent(window, "close", cancel);';
    } elseif ($edit_group) {
        echo '
            function cancel()
            {
                sbReturnValue("refresh");
            }
            sbAddEvent(window, "close", cancel);';
    }
    echo '</script>';

    require_once(SB_CMS_LIB_PATH . '/sbLayout.inc.php');

    $layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE . '?event=pl_banners_submit' . ($_SERVER['QUERY_STRING'] != '' ? '&' . $_SERVER['QUERY_STRING'] : ''),
        'thisDialog', 'post', 'checkValues()', 'main', 'enctype="multipart/form-data"');
    if ($edit_group) {
        $layout->mShowColon = false;
    }

    $layout->mTableWidth = '95%';
    $layout->mTitleWidth = '200';

    $layout->addTab(PL_BANNERS_EDIT_TAB1);
    $layout->addHeader(PL_BANNERS_EDIT_TAB1);

    $layout->addField(PL_BANNERS_EDIT_TITLE . sbGetGroupEditCheckbox('sb_name', $edit_group),
        new sbLayoutInput('text', $sb_name, 'sb_name', '', 'style="width:95%;"', true));

    $layout->addField('', new sbLayoutDelim());
    $layout->addField(PL_BANNERS_EDIT_LINK . sbGetGroupEditCheckbox('sb_link', $edit_group), new sbLayoutPage($sb_link, 'sb_link', '', 'style="width:95%;"'));

    $layout->addField('', new sbLayoutDelim());

    $fld1 = new sbLayoutInput('radio', '', 'type', 'tt', 'onClick="typeBanner(this.id);"');
    $fld2 = new sbLayoutInput('radio', '', 'type', 'tg', 'onClick="typeBanner(this.id);"');
    $html = '<table cellpadding="0" cellspacing="0" style="margin-left:-4px;">
                <tr>
                    <td style="padding-bottom:5px;">
                    ' . $fld1->getField() . '
                    </td>
                    <td>
                    <label for="tt">' . PL_BANNERS_EDIT_TYPE_TEXT . '</label>
                    </td>
                </tr>
                <tr>
                    <td>
                    ' . $fld2->getField() . '
                    </td>
                    <td>
                    <label for="tg">' . PL_BANNERS_EDIT_TYPE_IMG . '</label>
                    </td>
                </tr>
            </table>';

    $fld = new sbLayoutHTML($html);
    $fld->mShowColon = false;
    $layout->addField(PL_BANNERS_EDIT_TYPE . sbGetGroupEditCheckbox('type', $edit_group), $fld);

    $fld3 = new sbLayoutTextarea($sb_code, 'sb_code', 'sb_code', 'rows="8" style="margin-left:5px; width:99%; height:150px"');
    $fld3->mTags = array('-', '{BANNER_LINK}');
    $fld3->mValues = array(PL_BANNERS_EDIT_TAB1, PL_BANNERS_BANNER_LINK);

    $fld3->mShowEditorBtn = true;

    $fld4 = new sbLayoutImage($sb_upload_name, 'sb_upload_name', 'sb_upload_name', 'style="width:95%;"');
    $fld4->mFileTypes = 'jpg png gif jpeg bmp swf';
    $html = '<div id="text"><table  style="font-weight:bold; width:100%;">
                <tr>
                    <th style="width:196px; text-align:right;padding-right:8px">
                       ' . PL_BANNERS_EDIT_TEXT_BANNER . '
                    </th>
                    <td>
                    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $fld3->getJavaScript() . $fld3->getField() . '
                    </td>
                </tr>
            </table></div><div id="img">
            <table style="font-weight:bold; width:100%;">
                <tr>
                    <th style="width:196px;text-align:right;padding-right:8px">
                       ' . PL_BANNERS_EDIT_IMG_BANNER . '
                    </th>
                    <td>
                        ' . $fld4->getJavaScript() . $fld4->getField() . '
                    </td>
                </tr>
            </table></div>';

    $layout->addField('', new sbLayoutHTML($html, true));

    $layout->addField('', new sbLayoutDelim());

    $options = array();
    $options[1] = 1;
    $options[2] = 2;
    $options[3] = 3;
    $options[4] = 4;
    $options[5] = 5;
    $options[6] = 6;
    $options[7] = 7;
    $options[8] = 8;
    $options[9] = 9;
    $options[10] = 10;
    $options[11] = 11;
    $options[12] = 12;
    $options[13] = 13;
    $options[14] = 14;
    $options[15] = 15;

    $fld6_1 = new sbLayoutSelect($options, 'sb_priority', 'sb_priority', '');
    $fld6_1->mSelOptions = array($sb_priority);
    $layout->addField(PL_BANNERS_EDIT_PRIORITY . sbGetGroupEditCheckbox('sb_priority', $edit_group), $fld6_1);

    if (!$edit_group) {
        $edit_rights = $edit_rights && sb_add_workflow_status($layout, 'pl_banners', $_GET['id'], 'sb_active', $sb_active, 'sb_date_from', $sb_date_from,
                'sb_date_to', $sb_date_to);
        $layout->getPluginFields('pl_banners', $_GET['id'], 'sb_id');
    } else {
        $states_arr = array();
        $states = sql_query('SELECT sb_active FROM sb_banners WHERE sb_id IN (?a)', $_GET['ids']);
        if ($states) {
            foreach ($states as $val) {
                $states_arr[] = $val[0];
            }
        }
        $edit_rights = $edit_rights && sb_add_workflow_status($layout, 'pl_banners', $_GET['ids'], 'sb_active', $states_arr, 'sb_date_from', $sb_date_from,
                'sb_date_to', $sb_date_to);
        $layout->getPluginFields('pl_banners', '', 'sb_id', '', $edit_group);
    }

    $layout->addTab(PL_BANNERS_EDIT_OGRANICHENIE_TAB);
    $layout->addHeader(PL_BANNERS_EDIT_OGRANICHENIE_TAB);

    $fld5 = new sbLayoutInput('text', (($sb_count_show == -1) ? PL_BANNERS_EDIT_UNLIMITED_BOX : $sb_count_show), 'sb_count_show', 'sb_count_show',
        'style="border:' . ($sb_count_show > 0 || $sb_count_show == -1 ? 'green' : 'red') . ' 2px solid;font-weight:bold;text-align:center;"');
    $fld6 = new sbLayoutInput('checkbox', '1', 'sb_unlimited', 'sb_unlimited', ($sb_count_show == -1 ? 'checked="checked"' : ''));

    $html = '<table>
                <tr>
                    <td>
                       ' . $fld5->getField() . '
                    </td>
                    <td>
                        ' . $fld6->getField() . ' <label for="sb_unlimited">' . PL_BANNERS_EDIT_UNLIMITED . '</label>
                    </td>
                </tr>
            </table>';
    $fld = new sbLayoutHtml($html);
    $fld->mShowColon = false;

    $layout->addField(PL_BANNERS_EDIT_REMAIN_VIEWS . sbGetGroupEditCheckbox('sb_unlimited', $edit_group), $fld);

    $layout->addField(PL_BANNERS_EDIT_ADD_VIEWS . sbGetGroupEditCheckbox('add_views', $edit_group),
        new sbLayoutInput('text', '0', 'add_views', 'spin_add_views', 'style="width:80px;"'));

    $layout->addField('', new sbLayoutDelim());

    $fld = new sbLayoutPlanTable($sb_plan_dates, false);
    $fld->mShowColon = false;
    $layout->addField(PL_BANNERS_EDIT_TIME_OGRANICH . sbGetGroupEditCheckbox('sb_plan_dates', $edit_group), $fld);

    $layout->addTab(PL_BANNERS_EDIT_ZAPRESH_PAGE);
    $layout->addHeader(PL_BANNERS_EDIT_ZAPRESH_PAGE);

    $fld = new sbLayoutCategs('pl_pages', '', (isset($sb_restricted_cats) && $sb_restricted_cats != '' ? $sb_restricted_cats : ''), 'sb_restricted_cats');
    $fld->mMultiSelect = true;
    $layout->addField(PL_BANNERS_EDIT_RESTRICT_CATS . sbGetGroupEditCheckbox('sb_restricted_cats', $edit_group), $fld);

    $layout->addField('', new sbLayoutDelim());

    $restricted = sql_param_query('SELECT sbr_bid, sbr_url FROM sb_banners_restricted WHERE sbr_bid = ?d ORDER BY sbr_url', $_GET['id']);
    if ($restricted) {
        $count = count($restricted) - 1;
        $str = '';
        $sb_restricted_cats = array();

        foreach ($restricted as $key => $value) {
            if (isset($value[1]) && $value[1] != '') {
                $fld = new sbLayoutPage($value[1], 'pages_urls[' . $key . ']', '', 'style="width:94%;"');
                $str .= $fld->getJavaScript();
                if ($count == $key) {
                    $str .= $fld->getField();
                } else {
                    $str .= $fld->getField() . '<br />';
                }
                $index = $key;
            }
        }
    } else {
        $fld = new sbLayoutPage('', 'pages_urls[0]', '', 'style="width:94%;"');
        $str = $fld->getJavaScript() . $fld->getField();
        $index = 0;
    }

    $html = '<table width="100%">
                <tr>
                    <td id="td_files" style="width:100%;">' . $str . '</td>
                    <td style="padding-left:5px; vertical-align:top; width:25px;" id="ch_index_id"><img style="margin-top:3px;" height="20" id="' . $index . '" align="top" width="20" src="' . SB_CMS_IMG_URL . '/btn_add.png" onmousedown=\'sbPress(this, true);addFile(this.id);\' onmouseup=\'sbPress(this, false);\' class="button"/></td>
                </tr>
            </table>';

    $fld = new sbLayoutHTML($html);
    $fld->mShowColon = false;

    $layout->addField(PL_BANNERS_EDIT_LIST_PAGES . sbGetGroupEditCheckbox('sb_restricted_pages', $edit_group), $fld, '', '');

    /*** начало статистики ***/
    if (!$edit_group) {
        $layout->addTab(PL_BANNERS_EDIT_STATISTICS_TAB);
        $layout->addHeader(PL_BANNERS_EDIT_STATISTICS_TAB);

        $fld = new sbLayoutInput('checkbox', '1', 'sb_statistics', '', ($sb_statistics == 1 ? 'checked="chekced"' : ''));
        $html = '<table cellpadding="0" cellspacing="0" width="100%">
                    <tr>
                        <td style="width:195px;text-align:right;padding-right:8px;font-family: Arial, sans-serif; font-size: 12px;">
                            <b>' . PL_BANNERS_EDIT_STATISTICS . '</b>
                        </td>
                        <td>
                            ' . $fld->getField() . '
                        </td>
                    </tr>
                </table>';

        $fld1 = new sbLayoutHTML($html, true);
        $layout->addField('', $fld1);

        //Обновление графиков
        $html = '<div class="delim" style="margin:10px 0;">&nbsp;</div>
        <table cellpadding="0" cellspacing="0" width="100%">
                <tr>
                    <td style="text-align:left;">
                        ' . PL_BANNERS_EDIT_STATISTICS_TAB . ': <a href="#" id="year_link" onclick="reload_graph(\'year\')">' . PL_BANNERS_STAT_SHOW_YEAR . '</a>, <a href="#" id="month_link" onclick="reload_graph(\'month\')">' . PL_BANNERS_STAT_SHOW_MONTH . '</a>, <a href="#" id="day_link" onclick="reload_graph(\'day\')">' . PL_BANNERS_STAT_SHOW_DAY . '</a>
                    </td>
                    <td style="text-align:right;">
                        <img onclick="reload_graph(\'\', \'-12\')" src="' . SB_CMS_IMG_URL . '/previous.gif" align="absmiddle">&nbsp;&nbsp;<a href="#" onclick="reload_graph(\'\', \'-12\')">' . PL_BANNERS_STAT_SHOW_PREV_LINK . '</a>&nbsp;&nbsp;&nbsp;&nbsp;
                        <a href="#" onclick="reload_graph(\'\', \'12\')">' . PL_BANNERS_STAT_SHOW_NEXT_LINK . '</a>&nbsp;&nbsp;<img onclick="reload_graph(\'\', \'12\')" src="' . SB_CMS_IMG_URL . '/next.gif" align="absmiddle">
                    </td>
                </tr>
            </table>
            <div class="delim" style="margin-top:10px;">&nbsp;</div>';
        $fld = new sbLayoutHTML($html, true);
        $layout->addField('', $fld);

        //Количество просмотров
        $fld = new sbLayoutGraph('', 'views_graph', '650', '250');
        $fld->mAutoloadingUrl = SB_CMS_EMPTY_FILE . '?event=pl_banners_stat_show&graph=views&period=days&from=0&id=' . $_GET['id'];
        $fld->mHTML = '<br /><br />
            <div style="text-align:left;">
                <img height="20" width="20" align="absmiddle" src="' . SB_CMS_IMG_URL . '/images.png" class="button"/>&nbsp;&nbsp;
                <a href="#" onclick="save_graph(\'views_graph\')">' . KERNEL_SAVE . '</a>
            </div>
            <div class="delim" style="margin:10px 0px 10px 0px;"></div>';

        $layout->addField('', $fld, '', 'style="text-align:center;"');

        //Количество кликов
        $fld = new sbLayoutGraph('', 'click_graph', '650', '250');
        $fld->mAutoloadingUrl = SB_CMS_EMPTY_FILE . '?event=pl_banners_stat_show&graph=click&period=days&from=0&id=' . $_GET['id'];
        $fld->mHTML = '<br /><br />
            <div style="text-align:left;">
                <img height="20" width="20" align="absmiddle" src="' . SB_CMS_IMG_URL . '/images.png" class="button"/>&nbsp;&nbsp;
                <a href="#" onclick="save_graph(\'click_graph\')">' . KERNEL_SAVE . '</a>
            </div>
            <div class="delim" style="margin:10px 0px 10px 0px;"></div>
            ';

        $layout->addField('', $fld, '', 'style="text-align:center;"');

        //CTR Кампании
        $fld = new sbLayoutGraph('', 'ctr_graph', '650', '250');
        $fld->mAutoloadingUrl = SB_CMS_EMPTY_FILE . '?event=pl_banners_stat_show&graph=ctr&period=days&from=0&id=' . $_GET['id'];
        $fld->mHTML = '<br /><br />
        <div style="float:left;">
            <img  height="20" width="20" align="absmiddle" src="' . SB_CMS_IMG_URL . '/images.png" class="button"/>&nbsp;&nbsp;
            <a href="#" onclick="save_graph(\'ctr_graph\')">' . KERNEL_SAVE . '</a><br />
        </div>';
        $layout->addField('', $fld, '', 'style="text-align:center;"');

        //Обновление графиков
        $html = '<div class="delim" style="margin:10px 0;">&nbsp;</div>
        <table cellpadding="0" cellspacing="0" width="100%">
                <tr>
                    <td style="text-align:left;">
                        ' . PL_BANNERS_EDIT_STATISTICS_TAB . ': <a href="#" id="year_link_2" onclick="reload_graph(\'year\')">' . PL_BANNERS_STAT_SHOW_YEAR . '</a>, <a href="#" id="month_link_2" onclick="reload_graph(\'month\')">' . PL_BANNERS_STAT_SHOW_MONTH . '</a>, <a href="#" id="day_link_2" onclick="reload_graph(\'day\')">' . PL_BANNERS_STAT_SHOW_DAY . '</a>
                    </td>
                    <td style="text-align:right;">
                        <img onclick="reload_graph(\'\', \'-12\')" src="' . SB_CMS_IMG_URL . '/previous.gif" align="absmiddle">&nbsp;&nbsp;<a href="#" onclick="reload_graph(\'\', \'-12\')">' . PL_BANNERS_STAT_SHOW_PREV_LINK . '</a>&nbsp;&nbsp;&nbsp;&nbsp;
                        <a href="#" onclick="reload_graph(\'\', \'12\')">' . PL_BANNERS_STAT_SHOW_NEXT_LINK . '</a>&nbsp;&nbsp;<img onclick="reload_graph(\'\', \'12\')" src="' . SB_CMS_IMG_URL . '/next.gif" align="absmiddle">
                    </td>
                </tr>
            </table>';
        $fld = new sbLayoutHTML($html, true);
        $layout->addField('', $fld);
    }
    /*** конец статистики ***/

    $layout->addButton('submit', KERNEL_SAVE, 'btn_save', '', ($edit_rights ? '' : 'disabled="disabled"'));
    if ($_GET['id'] != '' && !$edit_group) {
        $layout->addButton('submit', KERNEL_APPLY, 'btn_apply', '', ($edit_rights ? '' : 'disabled="disabled"'));
    }
    $layout->addButton('button', KERNEL_CANCEL, '', '', $htmlStr != '' || $edit_group ? 'onclick="cancel()"' : 'onclick="sbCloseDialog()"');

    $layout->show();
    echo '<script>
            if (sbGetE("sb_upload_name").value == "" && sbGetE("sb_code").value != "")
            {
                sbGetE("tt").checked = true;
                sbGetE("img").style.display = "none";
                sbGetE("text").style.display = "block";
            }
            else
            {
                sbGetE("tg").checked = true;
                sbGetE("img").style.display = "block";
                sbGetE("text").style.display = "none";
            }
        </script>';
}

function fBanners_Submit()
{
    $edit_group = sbIsGroupEdit();

    if (!$edit_group) {
        if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'], 'pl_banners')) {
            return;
        }
    } else {
        if (!fCategs_Check_Elems_Rights($_GET['ids'][0], $_GET['cat_id'], 'pl_banners')) {
            return;
        }
    }

    if (!isset($_GET['id'])) {
        $_GET['id'] = '';
    }

    $ch_add_views = $ch_sb_restricted_pages = $ch_sb_restricted_cats = $ch_sb_plan_dates = $ch_sb_priority = $ch_sb_unlimited =
    $ch_type = $ch_sb_name = $ch_sb_link = $sb_priority = $sb_active = $sb_date_from = $sb_date_to = $sb_statistics = $add_views = 0;
    $sb_name = $sb_code = $sb_upload_name = $sb_link = $pageid = '';
    $sb_unlimited = false;
    $sb_restricted_cats = '';
    $pages_urls = array();

    extract($_POST);
    $pageid = explode('^', $pageid);

    if ($sb_active == 1) {
        if ($sb_date_from != '') {
            $sb_date_from = sb_datetoint($sb_date_from);
        } else {
            $sb_date_from = null;
        }

        if ($sb_date_to != '') {
            $sb_date_to = sb_datetoint($sb_date_to);
        } else {
            $sb_date_to = null;
        }
    } else {
        $sb_date_from = null;
        $sb_date_to = null;
    }

    if (!$edit_group && $sb_name == '') {
        sb_show_message(PL_BANNERS_EDIT_NO_TITLE_MSG, false, 'warning');
        fBanners_Edit();
        return;
    }

    $sb_active = intval($sb_active);
    require_once(SB_CMS_LIB_PATH . '/sbLayout.inc.php');
    $layout = new sbLayout();

    $row = $layout->checkPluginFields('pl_banners', ($edit_group ? '' : $_GET['id']), 'sb_id', false, $edit_group);
    if ($row === false) {
        $layout->deletePluginFieldsFiles();
        fBanners_Edit();
        return;
    }

    $plan = sbLayoutPlanTable::getStrForDb();
    $count_show = false;
    if (isset($_GET['id']) && $_GET['id'] != '') {
        $count_show = sql_param_query('SELECT sb_count_show FROM sb_banners WHERE sb_id=?d', $_GET['id']);
    }

    if ($count_show) {
        if ($count_show[0][0] == -1) {
            $count_show = 0;
        } else {
            $count_show = $count_show[0][0];
        }
    }
    sb_submit_workflow_status($row, 'sb_active', 'sb_date_from', 'sb_date_to', $edit_group);

    if (!$edit_group || $edit_group && $ch_sb_link == 1) {
        $row['sb_link'] = $sb_link;
    }
    if (!$edit_group || $edit_group && $ch_sb_name == 1) {
        $row['sb_name'] = $sb_name;
    }
    if (!$edit_group || $edit_group && $ch_type == 1) {
        $row['sb_code'] = $sb_code;
        $row['sb_upload_name'] = $sb_upload_name;
    }
    if ($edit_group && $ch_sb_unlimited == 1) {
        $row['sb_count_show'] = isset($sb_unlimited) && $sb_unlimited == 1 ? -1 : 0;
    }
    if (!$edit_group) {
        $row['sb_count_show'] = (isset($sb_unlimited) && $sb_unlimited == 1 ? -1 : $add_views + $count_show);
    }
    if (!$edit_group || $edit_group && $ch_sb_priority == 1) {
        $row['sb_priority'] = $sb_priority;
    }
    if (!$edit_group || $edit_group && $ch_sb_plan_dates == 1) {
        $row['sb_plan_dates'] = $plan;
    }
    if (!$edit_group) {
        $row['sb_statistics'] = (isset($sb_statistics) && $sb_statistics == 1 ? 1 : 0);
    }
    if (!$edit_group || $edit_group && $ch_sb_restricted_cats == 1) {
        $row['sb_restricted_cats'] = $sb_restricted_cats;
    }

    if ($_GET['id'] != '' || $edit_group) {
        if (!$edit_group) {
            $res = sql_param_query('SELECT sb_name FROM sb_banners WHERE sb_id=?d', $_GET['id']);
        } else {
            $res = true;
        }

        if ($res) {
            sql_query('LOCK TABLE sb_banners WRITE, sb_banners_restricted WRITE');

            if (!$edit_group) {
                list($old_title) = $res[0];
                sql_query('UPDATE sb_banners SET ?a WHERE sb_id=?d', $row, $_GET['id'], sprintf(PL_BANNERS_EDIT_OK, $old_title));
            } else {
                if (count($row) > 0) {
                    sql_query('UPDATE sb_banners SET ?a WHERE sb_id IN (?a)', $row, $_GET['ids'], PL_BANNERS_EDIT_GROUP_OK);
                }

                if ($edit_group && (($ch_sb_unlimited == 1 && isset($row['sb_count_show']) && $row['sb_count_show'] == 0 && $ch_add_views == 1) ||
                        ($ch_add_views == 1 && $ch_sb_unlimited == 0))
                ) {
                    sql_query('UPDATE sb_banners SET sb_count_show = sb_count_show + ?d WHERE sb_id IN (?a)', $add_views, $_GET['ids']);
                }
            }

            if ($edit_group && $ch_sb_restricted_pages == 1) {
                sql_query('DELETE FROM sb_banners_restricted WHERE sbr_bid IN (?a) ', $_GET['ids']);

                foreach ($_GET['ids'] as $value) {
                    foreach ($pages_urls as $val) {
                        if ($val != '') {
                            $rows = array();
                            $rows['sbr_bid'] = $value;
                            $rows['sbr_url'] = sb_str_replace('www.', '', $val);
                            sql_param_query('INSERT INTO sb_banners_restricted SET ?a', $rows);
                        }
                    }
                }
            } elseif (!$edit_group) {
                sql_query('DELETE FROM sb_banners_restricted WHERE sbr_bid= ?d ', $_GET['id']);

                foreach ($pages_urls as $value) {
                    if ($value != '') {
                        $rows = array();
                        $rows['sbr_bid'] = $_GET['id'];
                        $rows['sbr_url'] = sb_str_replace('www.', '', $value);
                        sql_param_query('INSERT INTO sb_banners_restricted SET ?a', $rows);
                    }
                }

                sql_query('UNLOCK TABLES');

                $footer_ar = fCategs_Edit_Elem();
                if (!$footer_ar) {
                    sb_show_message(PL_BANNERS_EDIT_ERROR, false, 'warning');
                    sb_add_system_message(sprintf(PL_BANNERS_EDIT_SYSTEMLOG_ERROR, $old_title), SB_MSG_WARNING);

                    $layout->deletePluginFieldsFiles();
                    fBanners_Edit();
                    return;
                }
                $footer_str = $GLOBALS['sbSql']->escape($footer_ar[0], false, false);
                $footer_link_str = $GLOBALS['sbSql']->escape($footer_ar[1], false, false);

                $row['sb_id'] = intval($_GET['id']);

                $html_str = fBanners_Get($row);
                $html_str = sb_str_replace(array("\r\n", "\r", "\n"), '', $html_str);
                $html_str = $GLOBALS['sbSql']->escape($html_str, false, false);

                if (!isset($_POST['btn_apply'])) {
                    echo '<script>
                            var res = new Object();
                            res.html = "' . $html_str . '";
                            res.footer = "' . $footer_str . '";
                            res.footer_link = "' . $footer_link_str . '";
                            sbReturnValue(res);
                          </script>';
                } else {
                    fBanners_Edit($html_str, $footer_str, $footer_link_str);
                }
            }
            sb_mail_workflow_status('pl_banners', ($edit_group ? $_GET['ids'] : $_GET['id']), $sb_name, $sb_active);

            if ($edit_group) {
                echo '<script>
                            sbReturnValue("refresh");
                    </script>';
            }
        } else {
            sb_show_message(PL_BANNERS_EDIT_ERROR, false, 'warning');
            sb_add_system_message(sprintf(PL_BANNERS_EDIT_SYSTEMLOG_ERROR, $sb_name), SB_MSG_WARNING);

            $layout->deletePluginFieldsFiles();
            fBanners_Edit();
            return;
        }
    } elseif (!$edit_group) {
        $error = true;
        sql_query('LOCK TABLES sb_banners WRITE, sb_banners_restricted WRITE');
        if (sql_param_query('INSERT INTO sb_banners SET ?a', $row)) {
            $id = sql_insert_id();

            foreach ($pages_urls as $key => $value) {
                if ($value != '') {
                    $rows = array();
                    $rows['sbr_bid'] = $id;
                    $rows['sbr_url'] = sb_str_replace('www.', '', $value);
                    sql_param_query('INSERT INTO sb_banners_restricted SET ?a', $rows);
                }
            }

            sql_query('UNLOCK TABLES');

            if (fCategs_Add_Elem($id)) {
                sb_add_system_message(sprintf(PL_BANNERS_ADD_OK, $sb_name));
                echo '<script>
                        sbReturnValue(' . $id . ');
                      </script>';

                sb_mail_workflow_status('pl_banners', $id, $sb_name, $sb_active);

                $error = false;
            } else {
                sql_query('DELETE FROM sb_banners WHERE sb_id="' . $id . '"');
            }
        } else {
            sql_query('UNLOCK TABLES');
        }

        if ($error) {
            sb_show_message(sprintf(PL_BANNERS_ADD_ERROR, $sb_name), false, 'warning');
            sb_add_system_message(sprintf(PL_BANNERS_ADD_SYSTEMLOG_ERROR, $sb_name), SB_MSG_WARNING);

            $layout->deletePluginFieldsFiles();
            fBanners_Edit();
            return;
        }
    }
}

function fBanners_Set_Active()
{
    if (!$_SESSION['sbPlugins']->isRightAvailable('pl_banners', 'elems_public')) {
        return;
    }

    sbIsGroupEdit(false);

    $date = time();
    foreach ($_GET['ids'] as $val) {
        sql_query('INSERT INTO sb_catchanges (el_id, cat_ident, change_date, change_user_id, action) VALUES (?d, ?, ?d, ?d, ?)', $val, 'pl_banners', $date,
            $_SESSION['sbAuth']->getUserId(), 'edit');
    }

    $res = sql_param_query('UPDATE sb_banners SET sb_active=IF(sb_active=0,1,0) WHERE sb_id IN (?a)', $_GET['ids'], PL_BANNERS_EDIT_ACTIVE_STATUS);
    if ($res) {
        echo 'TRUE';
    }
}

function fBanners_Delete()
{
    sql_param_query('DELETE FROM sb_banners_statistics WHERE sb_bid=?d ', $_GET['id']);
    sql_param_query('DELETE FROM sb_banners_restricted WHERE sbr_bid=?d ', $_GET['id']);
}

function fBanners_Delete_With_Elements()
{
    if (isset($_GET['elems_id']) && $_GET['elems_id'] != '') {
        $elems = explode(',', $_GET['elems_id']);
        sql_param_query('DELETE FROM sb_banners_statistics WHERE sb_bid IN (?a) ', $elems);
        sql_param_query('DELETE FROM sb_banners_restricted WHERE sbr_bid IN (?a) ', $elems);
    }
}

function fBanners_After_Paste()
{
    if (!isset($_GET['action']) || $_GET['action'] != 'copy' || !isset($_GET['e']) || !is_array($_GET['e']) || count($_GET['e']) <= 0 || !isset($_GET['ne']) || !is_array($_GET['ne']) || count($_GET['ne']) <= 0) {
        return;
    }

    $els = array();
    foreach ($_GET['e'] as $key => $value) {
        $els[intval($value)] = intval($_GET['ne'][$key]);
    }

    $in_str = implode(',', array_keys($els));

    $res = sql_query('SELECT sbr_bid, sbr_url FROM sb_banners_restricted WHERE sbr_bid IN (' . $in_str . ')');
    if ($res) {
        foreach ($res as $value) {
            list($b_id, $b_url) = $value;

            sql_query('INSERT INTO sb_banners_restricted (sbr_bid, sbr_url) VALUES (?d, ?)', $els[$b_id], $b_url);
        }
    }

    if (!$_SESSION['sbPlugins']->isPluginAvailable('pl_workflow') || !$_SESSION['sbPlugins']->isPluginInWorkflow('pl_banners')) {
        return;
    }

    $res = sql_query('SELECT sb_id, sb_active FROM sb_banners WHERE sb_id IN (' . implode(',', $_GET['ne']) . ')');

    if ($res) {
        foreach ($res as $value) {
            list($sb_id, $sb_active) = $value;

            if (!sb_workflow_status_available($sb_active, 'pl_banners', -1)) {
                sql_query('UPDATE sb_banners SET sb_active=?d WHERE sb_id=?d', current(sb_get_avail_workflow_status('pl_banners')), $sb_id);
            }
        }
    }
}

function fBanners_After_Paste_With_Elements()
{
    if (!isset($_SESSION['paste_categs_with_elems_ids']) ||
        !isset($_SESSION['paste_categs_with_elems_ids']['old']) ||
        !isset($_SESSION['paste_categs_with_elems_ids']['new'])
    ) {
        return;
    }

    $_GET['e'] = array_values($_SESSION['paste_categs_with_elems_ids']['old']);
    $_GET['ne'] = array_values($_SESSION['paste_categs_with_elems_ids']['new']);
    $_GET['action'] = 'copy';

    fBanners_After_Paste();
}

function fBanners_Stat_Show()
{
    require_once(SB_CMS_LIB_PATH . '/graph/OFC_Chart.php');

    if (!isset($_GET['period']) || $_GET['period'] == '') {
        $_GET['period'] = 'day';
    }

    $today = time();
    $year = sb_date('Y', $today);
    $month = sb_date('n', $today);
    $day = sb_date('j', $today);

    if (isset($_GET['from']) && $_GET['from'] != '') {
        if ($_GET['period'] == 'day') {
            $today = $today - ($_GET['from'] * 86400);
        } else {
            if ($_GET['period'] == 'month') {
                if ($_GET['from'] != 0) {
                    $_GET['from'] = -($_GET['from'] - 12);
                    $today = mktime(0, 0, 0, $_GET['from'], $day, $year);
                }
            } else {
                if ($_GET['period'] == 'year') {
                    $year -= $_GET['from'];
                    $today = mktime(0, 0, 0, $month, $day, $year);
                }
            }
        }

        $year = sb_date('Y', $today);
        $month = sb_date('n', $today);
        $day = sb_date('j', $today);
    }

    $views = $clicks = $labels_from_array = array();
    for ($i = 0; $i < 12; $i++) {
        if ($_GET['period'] == 'year') {
            $res = sql_param_query('SELECT sb_year, sb_month, sb_day, sum(sb_count_clicks), sum(sb_count_views) FROM sb_banners_statistics
                WHERE sb_bid = ?d AND sb_year <= ?d GROUP BY sb_year ORDER BY sb_year DESC LIMIT 0, 1', $_GET['id'], $year);

            $labels_from_array[] = (string)$year--;
        } elseif ($_GET['period'] == 'month') {
            if ($month == 0) {
                $month = 12;
                $year--;
            }

            $res = sql_param_query('SELECT sb_year, sb_month, sb_day, sum(sb_count_clicks), sum(sb_count_views) FROM sb_banners_statistics WHERE
                    sb_bid = ?d AND sb_year = ?d AND sb_month = ?d
                    GROUP BY sb_month ORDER BY sb_year DESC, sb_month DESC LIMIT 0, 1', $_GET['id'], $year, $month);

            $str_month = $month--;
            $labels_from_array[] = (sb_strlen($str_month) == 1 ? '0' . $str_month : $str_month) . '.' . sb_substr($year, 2);
        } else {
            if ($day == 0) {
                $month--;
                $day = sb_date('t', mktime(0, 0, 0, $month, 1, $year));

                if ($month == 0) {
                    $month = 12;
                    $year = $year - 1;
                }
            }

            $labels_from_array[] = (sb_strlen($day) == 1 ? '0' . $day : $day) . '.' . (sb_strlen($month) == 1 ? '0' . $month : $month);

            $res = sql_param_query('SELECT sb_year, sb_month, sb_day, sum(sb_count_clicks), sum(sb_count_views) FROM sb_banners_statistics WHERE
                        sb_bid = ?d AND sb_year = ?d AND sb_month = ?d AND sb_day = ?d
                        GROUP BY sb_day ORDER BY sb_year DESC, sb_month DESC, sb_day DESC LIMIT 0, 1', $_GET['id'], $year, $month, $day);

            $day -= 1;
        }

        list($sb_year, $sb_month, $sb_day, $count_clicks, $count_views) = isset($res[0]) ? $res[0] : array('0', '0', '0', '0', '0');

        $views[] = isset($count_views) && $count_views > 0 ? intval($count_views) : 0;
        $clicks[] = isset($count_clicks) && $count_clicks > 0 ? intval($count_clicks) : 0;
    }

    $labels_from_array = array_reverse($labels_from_array);
    $views = array_reverse($views);
    $clicks = array_reverse($clicks);

    $ctr = array();

    $max_view = 0;
    foreach ($views as $key => $value) {
        $ctr[] = $value != 0 ? round($clicks[$key] / $value * 100) : 0;

        if ($value > $max_view) {
            $max_view = $value;
        }
    }
    $max_clicks = 0;
    foreach ($clicks as $key => $value) {
        if ($value > $max_clicks) {
            $max_clicks = $value;
        }
    }

    $tooltip = new OFC_Elements_Tooltip();
    $tooltip->set_shadow(false);
    $tooltip->set_stroke(1);
    $tooltip->set_colour("#000000");
    $tooltip->set_background_colour("#FFFFE1");
    $tooltip->set_title_style("{font-size: 10px; color: #000000;}");
    $tooltip->set_body_style("{font-size: 10px; color: #000000;}");
    $tooltip->set_hover();

    $x_axis = new OFC_Elements_Axis_X();
    $x_axis->set_stroke(1);
    $x_axis->set_colours('#909090', '#FFF5E0');
    $x_axis->set_labels_from_array($labels_from_array);

    $y_axis = new OFC_Elements_Axis_Y();
    $y_axis->set_stroke(1);
    $y_axis->set_colours('#909090', '#FFF5E0');

    switch ($_GET['graph']) {
        case 'views':
            if ($max_view == 0) {
                $max_view = 100;
            }

            $y_axis->set_range(0, $max_view, floor(($max_view) / 10));

            $title = new OFC_Elements_Title(PL_BANNERS_STAT_SHOW_VIEWS_TITLE);
            $title->set_style('font-size:12px;font-weight:bold;color:#A50101');
            break;
        case 'click':
            if ($max_clicks == 0) {
                $max_clicks = 100;
            }

            $y_axis->set_range(0, $max_clicks, floor(($max_clicks) / 10));

            $title = new OFC_Elements_Title(PL_BANNERS_STAT_SHOW_CLICKS_TITLE);
            $title->set_style('font-size:12px;font-weight:bold;color:#A50101');
            break;
        default:
            $y_axis->set_range(0, 100, 10);

            $title = new OFC_Elements_Title(PL_BANNERS_STAT_SHOW_CTR_TITLE);
            $title->set_style('font-size:12px;font-weight:bold;color:#A50101');
            break;
    }

    $chart = new OFC_Chart();
    $chart->set_bg_colour('#EFE5D0');
    $chart->set_tooltip($tooltip);
    $chart->set_x_axis($x_axis);
    $chart->set_y_axis($y_axis);
    $chart->set_title($title);

    switch ($_GET['graph']) {
        case 'views':
            $bar = new OFC_Charts_Bar();
            $bar->set_values($views);
            $bar->set_colour('#B67D56');
            $bar->set_alpha(0.8);
            $bar->set_on_show(new OFC_Charts_Bar_On_Show('grow-up', 0.5, 0));
            $bar->set_key(PL_BANNERS_GET_VIEWS_COUNT, 11);
            $bar->set_tooltip(PL_BANNERS_GET_VIEWS_COUNT . ': #val#');
            $chart->add_element($bar);


            break;
        case 'click':
            $bar = new OFC_Charts_Bar();
            $bar->set_values($clicks);
            $bar->set_colour('#008000');
            $bar->set_alpha(0.8);
            $bar->set_on_show(new OFC_Charts_Bar_On_Show('grow-up', 0.5, 0));
            $bar->set_key(PL_BANNERS_GET_CLICKS, 11);
            $bar->set_tooltip(PL_BANNERS_GET_CLICKS . ': #val#');
            $chart->add_element($bar);
            break;
        default:
            $line = new OFC_Charts_Line();
            $line->set_colour('#A50101');
            $line->set_values($ctr);
            $line->set_key(PL_BANNERS_GET_CTR_PROC, 11);
            $line->set_width(1);
            $line->set_on_show(new OFC_Charts_Line_On_Show('pop-up', 0.5, 0));

            $dot = new OFC_Charts_Solid_Dot();
            $dot->set_size(3);
            $dot->set_halo_size(1);
            $dot->set_colour('#A50101');
            $dot->set_tooltip(PL_BANNERS_GET_CTR . ': #val#%');

            $line->set_default_dot_style($dot);
            $chart->add_element($line);
            break;
    }

    echo $chart->toString();
}

function fBanners_Stat_Delete()
{
    echo '<script>
        function checkValues()
        {
            var date = sbGetE("delete_date");
            if (date.value == "")
            {
                alert("' . PL_BANNERS_STAT_DELETE_NO_DATE_MSG . '");
                return false;
            }
        }
        </script><br /><br />';
    require_once(SB_CMS_LIB_PATH . '/sbLayout.inc.php');

    $layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE . '?event=pl_banners_stat_delete_submit' . ($_SERVER['QUERY_STRING'] != '' ? '&' . $_SERVER['QUERY_STRING'] : ''),
        'thisDialog', 'post', 'checkValues()');
    $layout->mTableWidth = '95%';
    $layout->mTitleWidth = '130';

    $layout->addHeader(PL_BANNERS_STAT_DELETE_HEADER_TITLE);

    $delete_date = sb_date('d.m.Y', time());

    $fld = new  sbLayoutDate($delete_date, 'delete_date', '', 'style="width:95%;"', true);
    $fld->mShowTime = false;
    $fld->mHTML = '<div class="hint_div" style="margin-top: 5px;">' . PL_BANNERS_STAT_DELETE_DATE_LABEL . '</div>';
    $layout->addField(PL_BANNERS_STAT_DELETE_DATE, $fld);

    $layout->addButton('submit', KERNEL_DELETE, 'btn_delete', '',
        ($_SESSION['sbPlugins']->isRightAvailable('pl_banners', 'elems_edit') ? '' : 'disabled="disabled"'));
    $layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog()"');
    $layout->show();
}

function fBanners_Stat_Delete_Submit()
{
    extract($_POST);

    if (isset($delete_date) && $delete_date != '') {
        $delete_date = explode('.', $delete_date);
    } else {
        echo '<script>
                sbReturnValue("TRUE");
            </script>';
        return;
    }

    $day = intval($delete_date[0]);
    $month = intval($delete_date[1]);
    $year = intval($delete_date[2]);

    $res = true;
    if ($day > 0 && $month > 0 && $year > 0) {
        $res = sql_param_query('DELETE FROM sb_banners_statistics WHERE
        (sb_year < ?d) OR
        (sb_year = ?d AND sb_month < ?d) OR
        (sb_year = ?d AND sb_month = ?d AND sb_day < ?d)', $year, $year, $month, $year, $month, $day);
    }

    if (!$res) {
        sb_show_message(PL_BANNERS_INIT_STAT_DELETE_ERROR);
        fBanners_Stat_Delete();
        return;
    } else {
        echo '<script>
                sbReturnValue("TRUE");
            </script>';
    }
}

function fBanners_Design_Get($args)
{
    $result = '<b><a href="javascript:void(0);" onclick="sbElemsEdit(event);">' . $args['sbt_title'] . '</a></b>
    <div class="smalltext" style="margin-top: 7px;">';

    static $view_info_pages = null;
    static $view_info_temps = null;

    if (is_null($view_info_pages)) {
        $view_info_pages = $_SESSION['sbPlugins']->isRightAvailable('pl_pages', 'read');
    }

    if (is_null($view_info_temps)) {
        $view_info_temps = $_SESSION['sbPlugins']->isRightAvailable('pl_templates', 'read');
    }

    $id = intval($args['sbt_id']);

    $pages = sql_query('SELECT pages.p_id, pages.p_name FROM sb_pages pages, sb_elems elems
                        WHERE elems.e_link="page" AND elems.e_temp_id="' . $id . '" AND elems.e_ident="pl_banners_design" AND pages.p_id=elems.e_p_id GROUP BY pages.p_id ORDER BY pages.p_name LIMIT 4');

    $temps = sql_query('SELECT temps.t_id, temps.t_name FROM sb_templates temps, sb_elems elems
                        WHERE elems.e_link="temp" AND elems.e_temp_id="' . $id . '" AND elems.e_ident="pl_banners_design" AND temps.t_id=elems.e_p_id GROUP BY temps.t_id ORDER BY temps.t_name LIMIT 4');

    if ($pages) {
        $result .= '<table cellpadding="0" cellspacing="0">
                    <tr>
                        <td valign="top" nowrap="nowrap" class="smalltext">' . KERNEL_USED_ON_PAGES . ':&nbsp;</td>
                        <td class="smalltext"><span style="color:green;">';

        $num = min(3, count($pages));
        for ($i = 0; $i < $num; $i++) {
            list($p_id, $p_name) = $pages[$i];
            $result .= ($view_info_pages ? '<a href="' . SB_CMS_CONTENT_FILE . '?event=pl_pages_init&sb_sel_id=' . $p_id . '">' . $p_name . '</a>' : $p_name) . ', ';
        }

        if ($num < count($pages)) {
            $result .= '&nbsp;<a href="javascript:void(0);" onclick="linkPages(event);">...</a>';
        } else {
            $result = substr($result, 0, -2);
        }

        $result .= '</span></td></tr></table>';
    } else {
        $result .= KERNEL_USED_ON_PAGES . ': <span style="color: red;">' . KERNEL_NOT_USED . '</span><br />';
    }

    if ($temps) {
        $result .= '<table cellpadding="0" cellspacing="0">
                    <tr>
                        <td valign="top" nowrap="nowrap" class="smalltext">' . KERNEL_USED_ON_TEMPS . ':&nbsp;</td>
                        <td class="smalltext"><span style="color:green;">';

        $num = min(3, count($temps));
        for ($i = 0; $i < $num; $i++) {
            list($t_id, $t_name) = $temps[$i];
            $result .= ($view_info_temps ? '<a href="' . SB_CMS_CONTENT_FILE . '?event=pl_templates_init&sb_sel_id=' . $t_id . '">' . $t_name . '</a>' : $t_name) . ', ';
        }

        if ($num < count($temps)) {
            $result .= '&nbsp;<a href="javascript:void(0);" onclick="linkTemps(event);">...</a>';
        } else {
            $result = substr($result, 0, -2);
        }

        $result .= '</span></td></tr></table>';
    } else {
        $result .= KERNEL_USED_ON_TEMPS . ': <span style="color: red;">' . KERNEL_NOT_USED . '</span><br />';
    }

    $result .= '</div>';

    return $result;

}

function fBanners_Design_Init()
{
    require_once(SB_CMS_LIB_PATH . '/sbElements.inc.php');
    $elems = new sbElements('sb_banners_temps', 'sbt_id', 'sbt_title', 'fBanners_Design_Get', 'pl_banners_design_init', 'pl_banners_design');

    $elems->mCategsRootName = PL_BANNERS_ROOT_CATEG_NAME;
    $elems->mCategsDeleteWithElementsMenu = true;

    $elems->addField('sbt_title');

    $elems->mElemsEditEvent = 'pl_banners_design_edit';
    $elems->mElemsEditDlgHeight = '570';
    $elems->mElemsEditDlgWidth = '870';

    $elems->mElemsAddEvent = 'pl_banners_design_edit';
    $elems->mElemsAddDlgHeight = '570';
    $elems->mElemsAddDlgWidth = '870';

    $elems->mElemsDeleteEvent = 'pl_banners_design_delete';

    $elems->addSorting(PL_BANNERS_SORT_BY_NAME, 'sbt_title');
    if ($_SESSION['sbPlugins']->isRightAvailable('pl_banners', 'elems_edit')) {
        $elems->mElemsJavascriptStr .= '
            function BannersList()
            {
                window.location = "' . SB_CMS_CONTENT_FILE . '?event=pl_banners_init";
            }';
        $elems->addElemsMenuItem(PL_BANNERS_ROOT_CATEG_NAME, 'BannersList();', false);
    }
    $elems->init();
}

function fBanners_Design_Edit($htmlStr = '', $footerStr = '')
{
    if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'], 'pl_banners_design')) {
        return;
    }

    if (count($_POST) == 0 && isset($_GET['id']) && $_GET['id'] != '') {
        $result = sql_param_query('SELECT sbt_title, sbt_lang, sbt_element, sbt_active, sbt_fields_temps, sbt_checked
                    FROM sb_banners_temps WHERE sbt_id=?d', $_GET['id']);

        if ($result) {
            list($sbt_title, $sbt_lang, $sbt_element, $sbt_active, $sbt_fields_temps, $sbt_checked) = $result[0];
        } else {
            sb_show_message(PL_BANNERS_DESIGN_EDIT_ERROR, true, 'warning');
            return;
        }

        if ($sbt_element != '') {
            $sbt_element = unserialize($sbt_element);
        } else {
            $sbt_element = array();
        }

        if ($sbt_fields_temps != '') {
            $sbt_fields_temps = unserialize($sbt_fields_temps);
        } else {
            $sbt_fields_temps = array();
        }

        if ($sbt_checked != '') {
            $sbt_checked = explode(' ', $sbt_checked);
        } else {
            $sbt_checked = array();
        }
        if (!isset($sbt_fields_temps['sbt_text_change_date'])) {
            $sbt_fields_temps['sbt_text_change_date'] = '{DAY}.{MONTH}.{LONG_YEAR} {HOUR}:{MINUTE}';
        }
        if (!isset($sbt_fields_temps['sbt_img_change_date'])) {
            $sbt_fields_temps['sbt_img_change_date'] = '{DAY}.{MONTH}.{LONG_YEAR} {HOUR}:{MINUTE}';
        }
    } elseif (count($_POST) > 0) {
        extract($_POST);

        if (!isset($_GET['id'])) {
            $_GET['id'] = '';
        }
    } else {
        $sbt_title = '';
        $sbt_lang = SB_CMS_LANG;
        $sbt_active = 1;
        $sbt_checked = $sbt_fields_temps = array();

        $sbt_element = array();
        $sbt_element['img'] = '';
        $sbt_element['text'] = '';
        $sbt_fields_temps['sbt_img_change_date'] = '{DAY}.{MONTH}.{LONG_YEAR} {HOUR}:{MINUTE}';
        $sbt_fields_temps['sbt_text_change_date'] = '{DAY}.{MONTH}.{LONG_YEAR} {HOUR}:{MINUTE}';
        $sbt_fields_temps['sbt_img_date_from'] = '{DAY}.{MONTH}.{LONG_YEAR} {HOUR}:{MINUTE}';
        $sbt_fields_temps['sbt_img_date_to'] = '{DAY}.{MONTH}.{LONG_YEAR} {HOUR}:{MINUTE}';
        $sbt_fields_temps['sbt_text_date_from'] = '{DAY}.{MONTH}.{LONG_YEAR} {HOUR}:{MINUTE}';
        $sbt_fields_temps['sbt_text_date_to'] = '{DAY}.{MONTH}.{LONG_YEAR} {HOUR}:{MINUTE}';

        $_GET['id'] = '';
    }

    echo '<script>
        function checkValues()
        {
            var el_title = sbGetE("sbt_title");
            if (el_title.value == "")
            {
                alert("' . PL_BANNERS_DESIGN_NO_TITLE_MSG . '");
                return false;
            }
        }';

    if ($htmlStr != '') {
        echo '
            function cancel()
            {
                var res = new Object();
                res.html = "' . $htmlStr . '";
                res.footer = "' . $footerStr . '";
                res.footer_link = "";
                sbReturnValue(res);
            }
            sbAddEvent(window, "close", cancel);';
    }
    echo '</script>';

    require_once(SB_CMS_LIB_PATH . '/sbLayout.inc.php');

    $layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE . '?event=pl_banners_design_submit' . ($_SERVER['QUERY_STRING'] != '' ? '&' . $_SERVER['QUERY_STRING'] : ''),
        'thisDialog', 'post', 'checkValues()');
    $layout->mTableWidth = '95%';
    $layout->mTitleWidth = '170';

    $layout->addTab(PL_BANNERS_DESIGN_EDIT);
    $layout->addHeader(PL_BANNERS_DESIGN_EDIT);

    $layout->addField(PL_BANNERS_DESIGN_TITLE, new  sbLayoutInput('text', $sbt_title, 'sbt_title', '', 'style="width:95%;"', true));

    $fld = new sbLayoutSelect($GLOBALS['sb_site_langs'], 'sbt_lang');
    $fld->mSelOptions = array($sbt_lang);
    $fld->mHTML = '<div class="hint_div" style="margin-top: 5px;">' . PL_BANNERS_DESIGN_EDIT_LANG_LABEL . '</div>';
    $layout->addField(PL_BANNERS_DESIGN_EDIT_LANG, $fld);

    $tags = array();
    $values = array();
    $layout->getPluginFieldsTags('pl_banners', $tags, $values);

    /*Поля графического банера*/
    $layout->addTab(PL_BANNERS_DESIGN_EDIT_IMG_BANNER_FIELDS_TAB);
    $layout->addHeader(PL_BANNERS_DESIGN_EDIT_IMG_BANNER_FIELDS_TAB);

    // Дата последнего изменения
    $fld = new sbLayoutTextarea($sbt_fields_temps['sbt_img_change_date'], 'sbt_fields_temps[sbt_img_change_date]', '', 'style="width:100%;height:50px;"');
    $fld->mTags = array('{DAY}', '{WEEKDAY}', '{WEEKDAY_SHORT}', '{MONTH}', '{MONTH_TEXTUAL}', '{LONG_YEAR}', '{SHORT_YEAR}', '{HOUR}', '{MINUTE}');
    $fld->mValues = array(
        KERNEL_DAY_TAG,
        KERNEL_WEEKDAY_TAG_FULL,
        KERNEL_WEEKDAY_TAG_SHORT,
        KERNEL_MONTH_TAG,
        KERNEL_MONTH_NAME_TAG,
        KERNEL_YEAR_4_TAG,
        KERNEL_YEAR_2_TAG,
        KERNEL_HOURS_TAG,
        KERNEL_MINUTES_TAG
    );
    $layout->addField(PL_BANNERS_DESIGN_EDIT_CHANGE_DATE_FIELDS, $fld);

    if(!isset($sbt_fields_temps['sbt_img_date_from'])){
        $sbt_fields_temps['sbt_img_date_from']= '{DAY}.{MONTH}.{LONG_YEAR} {HOUR}:{MINUTE}';
    }
    if(!isset($sbt_fields_temps['sbt_img_date_to'])){
        $sbt_fields_temps['sbt_img_date_to'] = '{DAY}.{MONTH}.{LONG_YEAR} {HOUR}:{MINUTE}';
    }
    if(!isset($sbt_fields_temps['sbt_text_date_from'])){
        $sbt_fields_temps['sbt_text_date_from']= '{DAY}.{MONTH}.{LONG_YEAR} {HOUR}:{MINUTE}';
    }

    if(!isset($sbt_fields_temps['sbt_text_date_to'])){
        $sbt_fields_temps['sbt_text_date_to'] = '{DAY}.{MONTH}.{LONG_YEAR} {HOUR}:{MINUTE}';
    }


    $fld = new sbLayoutTextarea($sbt_fields_temps['sbt_img_date_from'], 'sbt_fields_temps[sbt_img_date_from]', '', 'style="width:100%;height:50px;"');
    $fld->mTags = array('{DAY}', '{WEEKDAY}', '{WEEKDAY_SHORT}', '{MONTH}', '{MONTH_TEXTUAL}', '{LONG_YEAR}', '{SHORT_YEAR}', '{HOUR}', '{MINUTE}');
    $fld->mValues = array(
        KERNEL_DAY_TAG,
        KERNEL_WEEKDAY_TAG_FULL,
        KERNEL_WEEKDAY_TAG_SHORT,
        KERNEL_MONTH_TAG,
        KERNEL_MONTH_NAME_TAG,
        KERNEL_YEAR_4_TAG,
        KERNEL_YEAR_2_TAG,
        KERNEL_HOURS_TAG,
        KERNEL_MINUTES_TAG
    );
    $layout->addField(PL_BANNERS_DESIGN_EDIT_STERT, $fld);

    $fld = new sbLayoutTextarea($sbt_fields_temps['sbt_img_date_to'], 'sbt_fields_temps[sbt_img_date_to]', '', 'style="width:100%;height:50px;"');
    $fld->mTags = array('{DAY}', '{WEEKDAY}', '{WEEKDAY_SHORT}', '{MONTH}', '{MONTH_TEXTUAL}', '{LONG_YEAR}', '{SHORT_YEAR}', '{HOUR}', '{MINUTE}');
    $fld->mValues = array(
        KERNEL_DAY_TAG,
        KERNEL_WEEKDAY_TAG_FULL,
        KERNEL_WEEKDAY_TAG_SHORT,
        KERNEL_MONTH_TAG,
        KERNEL_MONTH_NAME_TAG,
        KERNEL_YEAR_4_TAG,
        KERNEL_YEAR_2_TAG,
        KERNEL_HOURS_TAG,
        KERNEL_MINUTES_TAG
    );
    $layout->addField(PL_BANNERS_DESIGN_EDIT_END, $fld);


    $layout->addPluginFieldsTemps('pl_banners', $sbt_fields_temps, 'sbt_', array(), array(), false, '', 'img_');

    $layout->addTab(PL_BANNERS_DESIGN_EDIT_IMG_BANNER_TAB);
    $layout->addHeader(PL_BANNERS_DESIGN_EDIT_IMG_BANNER_TAB);

    $fld = new sbLayoutTextarea($sbt_element['img'], 'sbt_element[img]', '', 'style="width:100%; height:250px;"');
    $fld->mTags = array_merge(array('-', '{BANNER_TITLE}', '{BANNER_LINK}', '{BANNER_URL}', '{CHANGE_DATE}', '{DATE_FROM}', '{DATE_TO}'), $tags);
    $fld->mValues = array_merge(array(
        PL_BANNERS_EDIT_TAB1,
        PL_BANNERS_BANNER_NAME,
        PL_BANNERS_BANNER_LINK,
        PL_BANNERS_BANNER_IMG,
        PL_BANNERS_BANNER_CHANGE_DATE_TAG,
        PL_BANNERS_DESIGN_EDIT_STERT,
        PL_BANNERS_DESIGN_EDIT_END
    ), $values);
    $layout->addField(PL_BANNERS_DESIGN_BANNER_ELEM_IMG, $fld);

    /*Поля текстового банера*/
    $layout->addTab(PL_BANNERS_DESIGN_EDIT_TEXT_BANNER_FIELDS_TAB);
    $layout->addHeader(PL_BANNERS_DESIGN_EDIT_TEXT_BANNER_FIELDS_TAB);

    // Дата последнего изменения
    $fld = new sbLayoutTextarea($sbt_fields_temps['sbt_text_change_date'], 'sbt_fields_temps[sbt_text_change_date]', '', 'style="width:100%;height:50px;"');
    $fld->mTags = array('{DAY}', '{WEEKDAY}', '{WEEKDAY_SHORT}', '{MONTH}', '{MONTH_TEXTUAL}', '{LONG_YEAR}', '{SHORT_YEAR}', '{HOUR}', '{MINUTE}');
    $fld->mValues = array(
        KERNEL_DAY_TAG,
        KERNEL_WEEKDAY_TAG_FULL,
        KERNEL_WEEKDAY_TAG_SHORT,
        KERNEL_MONTH_TAG,
        KERNEL_MONTH_NAME_TAG,
        KERNEL_YEAR_4_TAG,
        KERNEL_YEAR_2_TAG,
        KERNEL_HOURS_TAG,
        KERNEL_MINUTES_TAG
    );
    $layout->addField(PL_BANNERS_DESIGN_EDIT_CHANGE_DATE_FIELDS, $fld);

    $fld = new sbLayoutTextarea($sbt_fields_temps['sbt_text_date_from'], 'sbt_fields_temps[sbt_text_date_from]', '', 'style="width:100%;height:50px;"');
    $fld->mTags = array('{DAY}', '{WEEKDAY}', '{WEEKDAY_SHORT}', '{MONTH}', '{MONTH_TEXTUAL}', '{LONG_YEAR}', '{SHORT_YEAR}', '{HOUR}', '{MINUTE}');
    $fld->mValues = array(
        KERNEL_DAY_TAG,
        KERNEL_WEEKDAY_TAG_FULL,
        KERNEL_WEEKDAY_TAG_SHORT,
        KERNEL_MONTH_TAG,
        KERNEL_MONTH_NAME_TAG,
        KERNEL_YEAR_4_TAG,
        KERNEL_YEAR_2_TAG,
        KERNEL_HOURS_TAG,
        KERNEL_MINUTES_TAG
    );
    $layout->addField(PL_BANNERS_DESIGN_EDIT_STERT, $fld);

    $fld = new sbLayoutTextarea($sbt_fields_temps['sbt_text_date_to'], 'sbt_fields_temps[sbt_text_date_to]', '', 'style="width:100%;height:50px;"');
    $fld->mTags = array('{DAY}', '{WEEKDAY}', '{WEEKDAY_SHORT}', '{MONTH}', '{MONTH_TEXTUAL}', '{LONG_YEAR}', '{SHORT_YEAR}', '{HOUR}', '{MINUTE}');
    $fld->mValues = array(
        KERNEL_DAY_TAG,
        KERNEL_WEEKDAY_TAG_FULL,
        KERNEL_WEEKDAY_TAG_SHORT,
        KERNEL_MONTH_TAG,
        KERNEL_MONTH_NAME_TAG,
        KERNEL_YEAR_4_TAG,
        KERNEL_YEAR_2_TAG,
        KERNEL_HOURS_TAG,
        KERNEL_MINUTES_TAG
    );
    $layout->addField(PL_BANNERS_DESIGN_EDIT_END, $fld);

    $layout->addPluginFieldsTemps('pl_banners', $sbt_fields_temps, 'sbt_', array(), array(), false, '', 'text_');

    $layout->addTab(PL_BANNERS_DESIGN_EDIT_TEXT_BANNER_TAB);
    $layout->addHeader(PL_BANNERS_DESIGN_EDIT_TEXT_BANNER_TAB);

    $fld = new sbLayoutTextarea($sbt_element['text'], 'sbt_element[text]', '', 'style="width:100%; height:250px;"');
    $fld->mTags = array_merge(array('-', '{BANNER_TITLE}', '{BANNER_LINK}', '{BANNER_TEXT}', '{CHANGE_DATE}', '{DATE_FROM}', '{DATE_TO}'), $tags);
    $fld->mValues = array_merge(array(
        PL_BANNERS_EDIT_TAB1,
        PL_BANNERS_BANNER_NAME,
        PL_BANNERS_BANNER_LINK,
        PL_BANNERS_BANNER_TEXT_TAG,
        PL_BANNERS_BANNER_CHANGE_DATE_TAG,
        PL_BANNERS_DESIGN_EDIT_STERT,
        PL_BANNERS_DESIGN_EDIT_END
    ), $values);
    $layout->addField(PL_BANNERS_DESIGN_BANNER_ELEM_TEXT, $fld);

    $layout->addButton('submit', KERNEL_SAVE, 'btn_save', '',
        ($_SESSION['sbPlugins']->isRightAvailable('pl_banners', 'design_edit') ? '' : 'disabled="disabled"'));
    if ($_GET['id'] != '') {
        $layout->addButton('submit', KERNEL_APPLY, 'btn_apply', '',
            ($_SESSION['sbPlugins']->isRightAvailable('pl_banners', 'design_edit') ? '' : 'disabled="disabled"'));
    }

    $layout->addButton('button', KERNEL_CANCEL, '', '', $htmlStr != '' ? 'onclick="cancel()"' : 'onclick="sbCloseDialog()"');
    $layout->show();
}

function fBanners_Design_Submit()
{
    // проверка прав
    if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'], 'pl_banners_design')) {
        return;
    }

    if (!isset($_GET['id'])) {
        $_GET['id'] = '';
    }

    $sbt_active = 1;
    $sbt_element = $sbt_checked = $sbt_fields_temps = array();
    $sbt_lang = '';

    extract($_POST);

    if ($sbt_title == '') {
        sb_show_message(PL_BANNERS_DESIGN_EDIT_NO_TITLE_MSG, false, 'warning');
        fBanners_Design_Edit();
        return;
    }

    $row = array();
    $row['sbt_title'] = $sbt_title;
    $row['sbt_lang'] = $sbt_lang;
    $row['sbt_element'] = serialize($sbt_element);
    $row['sbt_checked'] = implode(' ', $sbt_checked);
    $row['sbt_fields_temps'] = serialize($sbt_fields_temps);
    $row['sbt_active'] = $sbt_active;

    if ($_GET['id'] != '') {
        $res = sql_param_query('SELECT sbt_title FROM sb_banners_temps WHERE sbt_id=?d', $_GET['id']);
        if ($res) {
            // С_РчР_Р°РєС'РёС_Р_Р_Р°Р_РёРч
            list($old_title) = $res[0];

            sql_param_query('UPDATE sb_banners_temps SET ?a WHERE sbt_id=?d', $row, $_GET['id'], sprintf(PL_BANNERS_DESIGN_EDIT_OK, $old_title));
            sbQueryCache::updateTemplate('sb_banners_temps', $_GET['id']);

            $footer_ar = fCategs_Edit_Elem('design_edit');
            if (!$footer_ar) {
                sb_show_message(PL_BANNERS_DESIGN_EDIT_ERROR, false, 'warning');
                sb_add_system_message(sprintf(PL_BANNERS_DESIGN_EDIT_SYSTEMLOG_ERROR, $old_title), SB_MSG_WARNING);

                fBanners_Design_Edit();
                return;
            }

            $footer_str = $GLOBALS['sbSql']->escape($footer_ar[0], false, false);

            $row['sbt_id'] = intval($_GET['id']);

            $html_str = fBanners_Design_Get($row);
            $html_str = sb_str_replace(array("\r\n", "\r", "\n"), '', $html_str);
            $html_str = $GLOBALS['sbSql']->escape($html_str, false, false);

            if (!isset($_POST['btn_apply'])) {
                echo '<script>
                        var res = new Object();
                        res.html = "' . $html_str . '";
                        res.footer = "' . $footer_str . '";
                        res.footer_link = "";
                        sbReturnValue(res);
                      </script>';
            } else {
                fBanners_Design_Edit($html_str, $footer_str);
            }
        } else {
            sb_show_message(PL_BANNERS_DESIGN_EDIT_ERROR, false, 'warning');
            sb_add_system_message(sprintf(PL_BANNERS_DESIGN_EDIT_SYSTEMLOG_ERROR, $sbt_title), SB_MSG_WARNING);

            fBanners_Design_Edit();
            return;
        }
    } else {
        $error = true;
        if (sql_param_query('INSERT INTO sb_banners_temps SET ?a', $row)) {
            $id = sql_insert_id();

            if (fCategs_Add_Elem($id, 'design_edit')) {
                sbQueryCache::updateTemplate('sb_banners_temps', $id);
                sb_add_system_message(sprintf(PL_BANNERS_DESIGN_ADD_TEMP_OK, $sbt_title));

                echo '<script>
                            sbReturnValue(' . $id . ');
                      </script>';

                $error = false;
            } else {
                sql_query('DELETE FROM sb_banners_temps WHERE sbt_id="' . $id . '"');
            }
        }

        if ($error) {
            sb_show_message(sprintf(PL_BANNERS_DESIGN_ADD_ERROR, $sbt_title), false, 'warning');
            sb_add_system_message(sprintf(PL_BANNERS_DESIGN_ADD_SYSTEMLOG_ERROR, $sbt_title), SB_MSG_WARNING);

            fBanners_Design_Edit();
            return;

        }
    }
}

function fBanners_Design_Delete()
{
    $id = intval($_GET['id']);
    $pages = sql_query('SELECT pages.p_id FROM sb_pages pages, sb_elems elems
                        WHERE elems.e_link="page" AND elems.e_temp_id="' . $id . '" AND elems.e_ident="pl_banners_design" AND pages.p_id=elems.e_p_id LIMIT 1');
    $temps = false;
    if (!$pages) {
        $temps = sql_query('SELECT temps.t_id FROM sb_templates temps, sb_elems elems
                        WHERE elems.e_link="temp" AND elems.e_temp_id="' . $id . '" AND elems.e_ident="pl_banners_design" AND temps.t_id=elems.e_p_id LIMIT 1');
    }

    if ($pages || $temps) {
        echo PL_BANNERS_DESIGN_DELETE_ERROR;
    }
}

// ------------ Вывод списка баннеров ---------------------
function fBanners_Design_List_Get($args)
{
    $result = '<b><a href="javascript:void(0);" onclick="sbElemsEdit(event);">' . $args['sbdl_title'] . '</a></b>
    <div class="smalltext" style="margin-top: 7px;">';

    static $view_info_pages = null;
    static $view_info_temps = null;

    if (is_null($view_info_pages)) {
        $view_info_pages = $_SESSION['sbPlugins']->isRightAvailable('pl_pages', 'read');
    }

    if (is_null($view_info_temps)) {
        $view_info_temps = $_SESSION['sbPlugins']->isRightAvailable('pl_templates', 'read');
    }

    $id = intval($args['sbdl_id']);

    $pages = sql_query('SELECT pages.p_id, pages.p_name FROM sb_pages pages, sb_elems elems
                        WHERE elems.e_link="page" AND elems.e_temp_id="' . $id . '" AND elems.e_ident="pl_banners_design" AND pages.p_id=elems.e_p_id GROUP BY pages.p_id ORDER BY pages.p_name LIMIT 4');

    $temps = sql_query('SELECT temps.t_id, temps.t_name FROM sb_templates temps, sb_elems elems
                        WHERE elems.e_link="temp" AND elems.e_temp_id="' . $id . '" AND elems.e_ident="pl_banners_design" AND temps.t_id=elems.e_p_id GROUP BY temps.t_id ORDER BY temps.t_name LIMIT 4');

    if ($pages) {
        $result .= '<table cellpadding="0" cellspacing="0">
                    <tr>
                        <td valign="top" nowrap="nowrap" class="smalltext">' . KERNEL_USED_ON_PAGES . ':&nbsp;</td>
                        <td class="smalltext"><span style="color:green;">';

        $num = min(3, count($pages));
        for ($i = 0; $i < $num; $i++) {
            list($p_id, $p_name) = $pages[$i];
            $result .= ($view_info_pages ? '<a href="' . SB_CMS_CONTENT_FILE . '?event=pl_pages_init&sb_sel_id=' . $p_id . '">' . $p_name . '</a>' : $p_name) . ', ';
        }

        if ($num < count($pages)) {
            $result .= '&nbsp;<a href="javascript:void(0);" onclick="linkPages(event);">...</a>';
        } else {
            $result = substr($result, 0, -2);
        }

        $result .= '</span></td></tr></table>';
    } else {
        $result .= KERNEL_USED_ON_PAGES . ': <span style="color: red;">' . KERNEL_NOT_USED . '</span><br />';
    }

    if ($temps) {
        $result .= '<table cellpadding="0" cellspacing="0">
                    <tr>
                        <td valign="top" nowrap="nowrap" class="smalltext">' . KERNEL_USED_ON_TEMPS . ':&nbsp;</td>
                        <td class="smalltext"><span style="color:green;">';

        $num = min(3, count($temps));
        for ($i = 0; $i < $num; $i++) {
            list($t_id, $t_name) = $temps[$i];
            $result .= ($view_info_temps ? '<a href="' . SB_CMS_CONTENT_FILE . '?event=pl_templates_init&sb_sel_id=' . $t_id . '">' . $t_name . '</a>' : $t_name) . ', ';
        }

        if ($num < count($temps)) {
            $result .= '&nbsp;<a href="javascript:void(0);" onclick="linkTemps(event);">...</a>';
        } else {
            $result = substr($result, 0, -2);
        }

        $result .= '</span></td></tr></table>';
    } else {
        $result .= KERNEL_USED_ON_TEMPS . ': <span style="color: red;">' . KERNEL_NOT_USED . '</span><br />';
    }

    $result .= '</div>';

    return $result;
}

function fBanners_Design_List_Init()
{
    require_once(SB_CMS_LIB_PATH . '/sbElements.inc.php');

    $elems = new sbElements('sb_banners_temps_list', 'sbdl_id', 'sbdl_title', 'fBanners_Design_List_Get', 'pl_banners_design_list_init',
        'pl_banners_design_list');
    $elems->mCategsDeleteWithElementsMenu = true;

    $elems->mCategsRootName = KERNEL_DESIGN_ROOT_NAME;
    $elems->mElemsIcon = SB_CMS_IMG_URL . '/plugins/pl_banners_list_32.png';

    $elems->addSorting(PL_BANNERS_DESIGN_EDIT_SORT_BY_NAME, 'sb_name');
    $elems->mCategsPasteElemsMenuTitle = KERNEL_DESIGN_PASTE_ELEMS_MENU_TITLE;

    $elems->mElemsAddMenuTitle = KERNEL_DESIGN_ELEMS_ADD_MENU_TITLE;
    $elems->mElemsEditMenuTitle = KERNEL_DESIGN_ELEMS_EDIT_MENU_TITLE;
    $elems->mElemsCopyMenuTitle = KERNEL_DESIGN_ELEMS_COPY_MENU_TITLE;
    $elems->mElemsCutMenuTitle = KERNEL_DESIGN_ELEMS_CUT_MENU_TITLE;

    $elems->mElemsEditEvent = 'pl_banners_design_list_edit';
    $elems->mElemsEditDlgWidth = 900;
    $elems->mElemsEditDlgHeight = 700;

    $elems->mElemsAddEvent = 'pl_banners_design_list_edit';
    $elems->mElemsAddDlgWidth = 900;
    $elems->mElemsAddDlgHeight = 700;


    $elems->mElemsDeleteEvent = 'pl_banners_design_list_delete';

    $elems->mCategsClosed = false;
    $elems->mCategsRubrikator = false;
    $elems->mElemsUseLinks = false;

    $elems->mElemsJavascriptStr .= '
          function linkPages(e)
          {
              if (!sbSelEl)
              {
                  var el = sbEventTarget(e);

                  while (el.parentNode && !el.getAttribute("true_id"))
                      el = el.parentNode;

                  var el_id = el.getAttribute("el_id");
              }
              else
                  var el_id = sbSelEl.getAttribute("el_id");

              strPage = "' . SB_CMS_DIALOG_FILE . '?event=pl_pages_get_links&id=" + el_id + "&ident[]=pl_news_list";
              strAttr = "resizable=1,width=800,height=600";
              sbShowModalDialog(strPage, strAttr, null, window);
          }
          function linkTemps(e)
          {
              if (!sbSelEl)
              {
                  var el = sbEventTarget(e);

                  while (el.parentNode && !el.getAttribute("true_id"))
                      el = el.parentNode;

                  var el_id = el.getAttribute("el_id");
              }
              else
                  var el_id = sbSelEl.getAttribute("el_id");

              strPage = "' . SB_CMS_DIALOG_FILE . '?event=pl_templates_get_links&id=" + el_id + "&ident[]=pl_news_list";
              strAttr = "resizable=1,width=800,height=600";
              sbShowModalDialog(strPage, strAttr, null, window);
          }
          function newsList()
          {
              window.location = "' . SB_CMS_CONTENT_FILE . '?event=pl_banners_init";
          }';

    $elems->addElemsMenuItem(KERNEL_LINK_PAGES_MENU_ITEM, 'linkPages();');
    $elems->addElemsMenuItem(KERNEL_LINK_TEMPS_MENU_ITEM, 'linkTemps();');
    $elems->addElemsMenuItem(PL_BANNERS_H_PLUGIN_NAME, 'bannersList();', false);

    $elems->init();
}

function fBanners_Design_List_Edit($htmlStr = '', $footerStr = '')
{
    // проверка прав доступа
    if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'], 'pl_banners_design_list')) {
        return;
    }

    if (count($_POST) == 0 && isset($_GET['id']) && $_GET['id'] != '') {
        //редактирование
        $result = sql_param_assoc('SELECT sbdl_title, sbdl_checked, sbdl_count, sbdl_no_banners, sbdl_top, sbdl_element, sbdl_bottom, sbdl_elem_temps
                    FROM sb_banners_temps_list WHERE sbdl_id=?d', $_GET['id']);

        if ($result) {
            extract($result[0]);
            $sbdl_checked = explode(' ', $sbdl_checked);
        } else {
            sb_show_message(PL_BANNERS_DESIGN_EDIT_ERROR, true, 'warning');
            return;
        }
    } else {
        if (count($_POST) > 0) {
            if (!isset($_GET['id'])) {
                $_GET['id'] = '';
            }

            $sbdl_checked = array();
            extract($_POST);
        } else {
            //новый макет
            $sbdl_title = '';
            $sbdl_count = 0;
            $sbdl_no_banners = PL_BANNERS_DESIGN_LIST_EDIT_NO_BANNERS;
            $sbdl_element = '{ELEM}';
            $sbdl_checked = array();
            $sbdl_elem_temps = null;

            $sbdl_top = PL_BANNERS_DESIGN_EDIT_TOP_DEFAULT;
            $sbdl_bottom = PL_BANNERS_DESIGN_EDIT_BOTTOM_DEFAULT;

            $_GET['id'] = '';
        }
    }

    echo '<script>
            function checkValues()
            {
                errText = "";
                
                var el_title = sbGetE("sbdl_title");
                if (el_title.value == "")
                {
                       errText = "' . PL_BANNERS_DESIGN_NO_TITLE_MSG . '";
                }

                var tpl_list = sbGetE("sbdl_elem_temps"); 
                if (tpl_list.value == "")
                {
                     errText += "\n' . PL_BANNERS_DESIGN_NO_TPL . '";
                }

                if(errText != "")
                {
                    alert(errText);
                    return false;
                }
            };';


    if ($htmlStr != '') {
        echo '
            function cancel()
            {
                var res = new Object();
                res.html = "' . $htmlStr . '";
                res.footer = "' . $footerStr . '";
                res.footer_link = "";
                sbReturnValue(res);
            }
            sbAddEvent(window, "close", cancel);';
    }
    echo '</script>';

    require_once(SB_CMS_LIB_PATH . '/sbLayout.inc.php');

    $layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE . '?event=pl_banners_design_list_edit_submit' . ($_SERVER['QUERY_STRING'] != '' ? '&' . $_SERVER['QUERY_STRING'] : ''),
        'thisDialog', 'post', 'checkValues()');
    $layout->mTableWidth = '95%';
    $layout->mTitleWidth = '200';

    $layout->addTab(PL_BANNERS_DESIGN_EDIT);
    $layout->addHeader(PL_BANNERS_DESIGN_EDIT);

    //Название макета
    $layout->addField(PL_BANNERS_DESIGN_TITLE, new sbLayoutInput('text', $sbdl_title, 'sbdl_title', '', 'style="width:450px;"', true));
    $layout->addField('', new sbLayoutDelim());

    //Флажки
    $layout->addPluginFieldsTempsCheckboxes('pl_banners', $sbdl_checked, 'sbdl_checked');

    //Макет вывода баннера
    $layout->addField('', new sbLayoutDelim());
    $options = array();
    $res = sql_query('SELECT categs.cat_title, temps.sbt_id, temps.sbt_title FROM sb_categs categs, sb_catlinks links, sb_banners_temps temps WHERE temps.sbt_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_banners_design" ORDER BY categs.cat_left, temps.sbt_title');
    if ($res) {
        $old_cat_title = '';
        foreach ($res as $value) {
            list($cat_title, $sbt_id, $sbt_title) = $value;
            if ($old_cat_title != $cat_title) {
                $options[uniqid()] = '-' . $cat_title;
                $old_cat_title = $cat_title;
            }
            $options[$sbt_id] = $sbt_title;
        }
        $fld = new sbLayoutSelect($options, 'sbdl_elem_temps', 'sbdl_elem_temps');
        $fld->mSelOptions = array($sbdl_elem_temps);
        $layout->addField(PL_BANNERS_DESIGN_LIST_EDIT_ELEMS_TEMPS, $fld);
    } else {
        $fld = new sbLayoutLabel('<div class="hint_div"><b style="color:red;">' . PL_BANNERS_DESIGN_NO_TEMPLATE . '</div><input type="hidden" id="sbdl_elem_temps" value="">',
            '', '', false);
        $layout->addField(PL_BANNERS_DESIGN_LIST_EDIT_ELEMS_TEMPS, $fld);
    }


    //Кол-во выводимых элементов
    $fld = new sbLayoutInput('text', $sbdl_count, 'sbdl_count', 'spin_sbdl_count', 'style="width:100px;"');
    $fld->mMinValue = 0;
    $layout->addField(PL_BANNERS_DESIGN_LIST_EDIT_COUNT, $fld);
    $layout->addField('',
        new sbLayoutLabel('<div class="hint_div" style="margin-top: 5px;">' . PL_BANNERS_DESIGN_LIST_EDIT_COUNT_HINT . '</div>', '', '', false));

    //Сообщение "Баннеров нет"
    $layout->addField('', new sbLayoutDelim());
    $layout->addField(PL_BANNERS_DESIGN_LIST_EDIT_NO_BANNERS_TITLE,
        new sbLayoutTextarea($sbdl_no_banners, 'sbdl_no_banners', '', 'style="width:100%;height:50px;"'));

    //Список баннеров
    $layout->addTab(PL_BANNERS_DESIGN_EDIT_TAB2);
    $layout->addHeader(PL_BANNERS_DESIGN_EDIT_TAB2);

    //верх вывода
    $fld = new sbLayoutTextarea($sbdl_top, 'sbdl_top', '', 'style="width:100%;height:100px;"');
    $layout->addField(PL_BANNERS_DESIGN_EDIT_TOP, $fld);

    $layout->addField('', new sbLayoutDelim());

    //баннер
    $fld = new sbLayoutTextarea($sbdl_element, 'sbdl_element', '', 'style="width:100%;height:100px;"');
    $fld->mTags = array('{ELEM}');
    $fld->mValues = array(PL_BANNERS_DESIGN_LIST_ELEM);
    $layout->addField(PL_BANNERS_DESIGN_EDIT_ELEMENT, $fld);

    //низ вывода
    $layout->addField('', new sbLayoutDelim());
    $fld = new sbLayoutTextarea($sbdl_bottom, 'sbdl_bottom', '', 'style="width:100%;height:100px;"');
    $layout->addField(PL_BANNERS_DESIGN_EDIT_BOTTOM, $fld);

    $layout->addButton('submit', KERNEL_SAVE, 'btn_save', '',
        ($_SESSION['sbPlugins']->isRightAvailable('pl_banners', 'design_edit') ? '' : 'disabled="disabled"'));
    if ($_GET['id'] != '') {
        $layout->addButton('submit', KERNEL_APPLY, 'btn_apply', '',
            ($_SESSION['sbPlugins']->isRightAvailable('pl_banners', 'design_edit') ? '' : 'disabled="disabled"'));
    }

    $layout->addButton('button', KERNEL_CANCEL, '', '', $htmlStr != '' ? 'onclick="cancel()"' : 'onclick="sbCloseDialog()"');
    $layout->show();
}

function fBanners_Design_List_Edit_Submit()
{
    // проверка прав
    if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'], 'pl_banners_design_list')) {
        return;
    }

    if (!isset($_GET['id'])) {
        $_GET['id'] = '';
    }


    $sbdl_checked = array();

    extract($_POST);

    if ($sbdl_title == '') {
        sb_show_message(PL_BANNERS_DESIGN_EDIT_NO_TITLE_MSG, false, 'warning');
        fBanners_Design_List_Edit();
        return;
    }

    $row = array(
        'sbdl_title' => $sbdl_title,
        'sbdl_checked' => implode(' ', $sbdl_checked),
        'sbdl_count' => $sbdl_count,
        'sbdl_no_banners' => $sbdl_no_banners,
        'sbdl_top' => $sbdl_top,
        'sbdl_elem_temps' => $sbdl_elem_temps,
        'sbdl_element' => $sbdl_element,
        'sbdl_bottom' => $sbdl_bottom
    );

    if ($_GET['id'] != '') {
        $res = sql_param_query('SELECT sbdl_title FROM sb_banners_temps_list WHERE sbdl_id=?d', $_GET['id']);
        if ($res) {
            // вытаскиваем старое название
            list($old_title) = $res[0];

            sql_param_query('UPDATE sb_banners_temps_list SET ?a WHERE sbdl_id=?d', $row, $_GET['id'], sprintf(PL_BANNERS_DESIGN_EDIT_OK, $old_title));
            sbQueryCache::updateTemplate('sb_banners_temps_list', $_GET['id'], true);

            $footer_ar = fCategs_Edit_Elem();
            if (!$footer_ar) {
                sb_show_message(PL_BANNERS_DESIGN_EDIT_ERROR, false, 'warning');
                sb_add_system_message(sprintf(PL_BANNERS_DESIGN_EDIT_SYSTEMLOG_ERROR, $old_title), SB_MSG_WARNING);

                fBanners_Design_List_Edit();
                return;
            }

            $footer_str = $GLOBALS['sbSql']->escape($footer_ar[0], false, false);

            $row['sbdl_id'] = intval($_GET['id']);

            $html_str = fBanners_Design_List_Get($row);
            $html_str = sb_str_replace(array("\r\n", "\r", "\n"), '', $html_str);
            $html_str = $GLOBALS['sbSql']->escape($html_str, false, false);

            if (!isset($_POST['btn_apply'])) {
                echo '<script>
                        var res = new Object();
                        res.html = "' . $html_str . '";
                        res.footer = "' . $footer_str . '";
                        res.footer_link = "";
                        sbReturnValue(res);
                      </script>';
            } else {
                fBanners_Design_List_Edit($html_str, $footer_str);
            }
        }
    } else {
        $error = true;
        if (sql_param_query('INSERT INTO sb_banners_temps_list SET ?a', $row)) {
            $id = sql_insert_id();
            if (fCategs_Add_Elem($id)) {
                sbQueryCache::updateTemplate('sb_banners_temps_list', $id, true);
                sb_add_system_message(sprintf(PL_BANNERS_DESIGN_ADD_TEMP_OK, $sbdl_title));

                echo '<script>
                            sbReturnValue(' . $id . ');
                      </script>';

                $error = false;
            } else {
                sql_query('DELETE FROM sb_banners_temps_list WHERE sbdl_id="' . $id . '"');
            }
        }

        if ($error) {
            sb_show_message(sprintf(PL_BANNERS_DESIGN_LIST_ADD_ERROR, $sbdl_title), false, 'warning');
            sb_add_system_message(sprintf(PL_BANNERS_DESIGN_LIST_ADD_SYSTEMLOG_ERROR, $sbdl_title), SB_MSG_WARNING);

            fBanners_Design_List_Edit();
            return;

        }
    }
}

function fBanners_Design_List_Delete()
{
    $id = intval($_GET['id']);
    $pages = sql_query('SELECT pages.p_id FROM sb_pages pages, sb_elems elems
                        WHERE elems.e_link="page" AND elems.e_temp_id="' . $id . '" AND elems.e_ident="pl_banners_design" AND pages.p_id=elems.e_p_id LIMIT 1');
    $temps = false;
    if (!$pages) {
        $temps = sql_query('SELECT temps.t_id FROM sb_templates temps, sb_elems elems
                        WHERE elems.e_link="temp" AND elems.e_temp_id="' . $id . '" AND elems.e_ident="pl_banners_design" AND temps.t_id=elems.e_p_id LIMIT 1');
    }

    if ($pages || $temps) {
        echo PL_BANNERS_DESIGN_DELETE_ERROR;
    }
}

?>