<?php

/**
 * Функция производит операции удаления и добавления в миникорзину
 *
 */
function fBasket_Elems_Add()
{
	$is_prop_modify = false;
	foreach($_REQUEST as $key => $value)
	{
		if(strpos($key, 'user_eo_') !== false)
		{
			$is_prop_modify = true;
			break;
		}
	}

	$pl_plugin_order = isset($_REQUEST['pl_plugin_order']) ? $_REQUEST['pl_plugin_order'] : (isset($_REQUEST['pl_plugin_reserving']) ? $_REQUEST['pl_plugin_reserving'] : '');
	if((!isset($pl_plugin_order) || $pl_plugin_order == '') && !$is_prop_modify)
	{
		return false;
	}

    // получить текущее время
    $cur_time = time();
    // берем из установок число дней хранения
    $span_dt = intval(sbPlugins::getSetting('pl_basket_datespan'));
    if($span_dt > 0)
	{
		// преобразуем число дней в количество секунд
		$span_dt *= (24 * 60 * 60);
	}
	else
	{
		return false;
	}

	$id_user_hash = ' ';
	$id_user = -1;

	// получение ИД текущего пользователя
	if(isset($_SESSION['sbAuth']))
	{
		$id_user = $_SESSION['sbAuth']->getUserId();
		if(isset($_COOKIE['pl_basket_user_id']))
		{
			// обновить таблицу для данного юзера. Поменять временный ИД юзера на новый
            if(!sql_param_query('UPDATE sb_basket SET b_id_user = ?d, b_hash=? WHERE (b_id_user=?d OR b_hash = ?) AND (b_domain=? OR b_domain=?)', $id_user, $_COOKIE['pl_basket_user_id'], $id_user, $_COOKIE['pl_basket_user_id'], 'all', SB_COOKIE_DOMAIN))
			{
                // ошибка при выполнении операции
                sb_add_system_message(KERNEL_PROG_PLUGIN_BASKET_ERROR_UPDATE_ID_USER);
            	return false;
            }
    	}
    	else
    	{
			// нет - значит сгенерировать уникальный ИД для него и помещаем в куки
            $id_user_hash = time().uniqid();
			sb_setcookie('pl_basket_user_id', $id_user_hash, $cur_time + $span_dt);
		}
	}
	else
	{
		// нет такого. Проверяем а в куках он есть?
		if (isset($_COOKIE['pl_basket_user_id']))
		{
			// берем
			$id_user_hash = preg_replace('/[^A-Za-z0-9]+/'.SB_PREG_MOD, '', $_COOKIE['pl_basket_user_id']);
        }
        else
		{
			// нет - значит сгенерировать уникальный ИД для него и помещаем в куки
            $id_user_hash = time().uniqid();
			sb_setcookie('pl_basket_user_id', $id_user_hash, $cur_time + $span_dt);
    	}
	}

	if(isset($pl_plugin_order) && is_array($pl_plugin_order))
	{
		//	сначала мы должны обновить все товары, у которых характеристики не изменились
		//	затем идет апдейт товаров, у которых изменились характеристики, для правильного расчета кол-ва
		//	в этот массив записываем данные для апдейта для последнего вида товаров.
		$delay_update = array();

//		формируем условие для sql запроса с учетом того что все операции нужно произвести только для текущего пользователя.
		$basket_arg = ' ';
		$basket_where = ' b_hash = ?';

		if($id_user > 0)
		{
			$basket_arg = $id_user;
			$basket_where = ' b_id_user = ?d';
		}
		elseif(trim($id_user_hash) != '')
		{
			$basket_arg = $id_user_hash;
		}

		require_once (SB_CMS_LIB_PATH.'/prog/sbFunctions.inc.php');

		foreach ($pl_plugin_order as $name => $val)
		{
			$strs = explode('_', $name);
            if(!isset($strs[0]))
				continue;

			if(($val == 0 || $val == 'del_orders') && isset($_REQUEST['pl_plugin_order']))
			{
				if (intval($strs[0]) <= 0)
				{
					// если нужно удалить все из корзины (для конкретного пользователя)
					sql_param_query('DELETE FROM sb_basket WHERE (b_domain=? OR b_domain=?) AND '.$basket_where, 'all', SB_COOKIE_DOMAIN, $basket_arg);
					return true;
				}
				elseif (count($strs) > 1)
				{
					// удаляем конкретный товар из корзины
					$del_params = '';
					if(isset($strs[2]) && $strs[2] != '')
					{
						//	Если товар добавлен с параметрами - удаляем товар с этими параметрами
						$del_params = ' AND b_prop = '.$GLOBALS['sbSql']->escape($strs[2]);
					}
					else
					{
						$del_params = ' AND b_prop = "" ';
					}

					sql_query('DELETE FROM sb_basket WHERE b_id_mod = ?d AND b_id_el = ?d AND (b_domain=? OR b_domain=?) AND '.$basket_where.$del_params, $strs[0], $strs[1], 'all', SB_COOKIE_DOMAIN, $basket_arg);
				}
				else
				{
					// удаляем товары конкретного модуля
					sql_param_query('DELETE FROM sb_basket WHERE b_id_mod = ?d AND (b_domain=? OR b_domain=?) AND '.$basket_where, $strs[0], 'all', SB_COOKIE_DOMAIN, $basket_arg);
				}
				
				continue;
			}


			if($strs[0] == '' || !isset($strs[1]) || $strs[1] == '')
				continue;

			$strs[0] = intval($strs[0]);
			$strs[1] = intval($strs[1]);

			$inp_key = $strs[0].'_'.$strs[1];
			if(isset($strs[2]) && $strs[2] != '')
			{
				$strs[2] = preg_replace('/[^0-9\:\|_\,]+/', '', $strs[2]);
				$inp_key .= '_'.$strs[2];
			}

			if(isset($_REQUEST['pl_plugin_order']) || isset($_REQUEST['pl_plugin_reserving'][$inp_key]) && $_REQUEST['pl_plugin_reserving'][$inp_key] > 0)
			{
				$b_count_el = intval($val);
				$b_discount = 0;

				if (isset($_REQUEST['pl_plugin_discount'][$name]))
				{
				    $hash = explode('|', base64_decode($_REQUEST['pl_plugin_discount'][$name]));
				    if (count($hash) == 2)
				    {
				        $b_discount = floatval($hash[0]);
				        $hash = $hash[1];

				        if (sbProgGetHash($b_discount) != $hash)
				        {
				            $b_discount = 0;
				        }
				    }
				}

				// Генерирую b_prop
				$old_prop = '';
				$new_prop = '';

				if(isset($strs[2]))
				{
					// Если пришли параметры
					$old_prop = $strs[2];
				}

				$prop_arr = array();
				// Формирую массив
				foreach($_REQUEST as $key => $value)
				{
					if(sb_strpos($key, 'user_eo_') !== false)
					{
						// Параметры для корзины
						$prop_t = sb_str_replace('user_eo_', '', $key);
						$prop_t = explode('_', $prop_t);

						if (!isset($prop_t[0]) || $prop_t[0] != $strs[0] ||
						    !isset($prop_t[2]) || $prop_t[2] != $strs[1] ||
						     isset($prop_t[3]) && $prop_t[3] != $old_prop)
						    continue;

						$prop_arr[$prop_t[1]] = $value;
					}
					elseif(sb_strpos($key, 'user_res_') !== false)
					{
						// Параметры для резервирования
						$prop_t = sb_str_replace('user_res_', '',$key);
						$prop_t = explode('_', $prop_t);

						if (!isset($prop_t[0]) || $prop_t[0] != $strs[0] ||
						    !isset($prop_t[2]) || $prop_t[2] != $strs[1] ||
						     isset($prop_t[3]) && $prop_t[3] != $old_prop)
						    continue;

						$prop_arr[$prop_t[1]] = $value;
					}
				}

				// Сортирую массив
				if(count($prop_arr) > 0)
				{
					asort($prop_arr);
					foreach($prop_arr as $key => $value)
					{
						// Генерирую строку
						$new_prop .= $key.'::'.(is_array($value) ? implode(',', $value) : $value).'||';
					}
				}

				if($new_prop != '')
				{
					$new_prop = sb_substr($new_prop, 0, -2);
				}

				if ($old_prop == '' && !isset($_REQUEST['order_goods']))
				{
				    fAddUpdateBasket($basket_where, $basket_arg, $strs[0], $strs[1], $new_prop, $b_count_el, $id_user, $id_user_hash, $cur_time, $b_discount);
				}
				else
				{
					if ($old_prop == $new_prop || $new_prop == '')
					{
						// характеристики не поменялись, изменяем кол-во
						$res = sql_query('UPDATE sb_basket SET b_count_el = ?d, b_date = ?d WHERE b_id_mod = ?d AND b_id_el = ?d AND b_prop = ? AND (b_domain=? OR b_domain=?) AND '.$basket_where, $b_count_el, $cur_time, $strs[0], $strs[1], $old_prop, 'all', SB_COOKIE_DOMAIN, $basket_arg);
						if(!$res)
						{
						    // выдать сообщение об ошибке
					        sb_add_system_message(KERNEL_PROG_PLUGIN_MAKER_ERROR_ADD);
					       	return false;
						}
					}
					else
					{
						//	изменение характеристики в корзине
						sql_query('DELETE FROM sb_basket WHERE b_id_mod = ?d AND b_id_el = ?d AND b_prop = ? AND (b_domain=? OR b_domain=?) AND '.$basket_where, $strs[0], $strs[1], $old_prop, 'all', SB_COOKIE_DOMAIN, $basket_arg);
						fAddUpdateBasket($basket_where, $basket_arg, $strs[0], $strs[1], $new_prop, $b_count_el, $id_user, $id_user_hash, $cur_time, $b_discount);
					}
				}
			}

			if(isset($_REQUEST['pl_plugin_reserving'][$strs[0].'_'.$strs[1]]))
			{
				$res = sql_query('UPDATE sb_basket SET b_reserved = ?d WHERE b_id_mod = ?d AND b_id_el = ?d AND (b_domain=? OR b_domain=?) AND '.$basket_where, $_REQUEST['pl_plugin_reserving'][$strs[0].'_'.$strs[1]], $strs[0], $strs[1], 'all', SB_COOKIE_DOMAIN, $basket_arg);
				if(!$res)
				{
			        //	выдать сообщение об ошибке
		            sb_add_system_message(KERNEL_PROG_PLUGIN_MAKER_ERROR_RESERVING);
		    	   	return false;
				}
			}
		}
	}

	$res_time = $cur_time - $span_dt;

	//	удаляем записи для которых истек срок хранения
 	sql_param_query('DELETE FROM sb_basket WHERE b_date < ?d OR b_count_el <= 0', $res_time);
	return true;
}

function fAddUpdateBasket($basket_where, $basket_arg, $p_id, $el_id, $new_prop, $b_count_el, $id_user, $id_user_hash, $cur_time, $b_discount)
{
	$res = sql_query('SELECT b_count_el FROM sb_basket WHERE b_id_mod = ?d AND b_id_el = ?d AND b_prop = ? AND (b_domain=? OR b_domain=?) AND '.$basket_where, $p_id, $el_id, $new_prop, 'all', SB_COOKIE_DOMAIN, $basket_arg);
	if(!$res && $b_count_el > 0)
	{
		// Добавление элемента
		$row = array();
	    $row['b_id_user'] = $id_user;
	    $row['b_hash'] = $id_user_hash;
		$row['b_id_mod'] = $p_id;
	    $row['b_id_el'] = $el_id;
	    $row['b_count_el'] = $b_count_el;
	    $row['b_reserved'] = 0;
		$row['b_prop'] = $new_prop;
		$row['b_date'] = $cur_time;
        $row['b_domain'] = SB_COOKIE_DOMAIN;
        $row['b_discount'] = $b_discount;

		$res = sql_query('INSERT INTO sb_basket SET ?a', $row);

        if(!$res)
		{
			// выдать сообщение об ошибке
			sb_add_system_message(KERNEL_PROG_PLUGIN_MAKER_ERROR_ADD);
			return false;
		}
	}
	elseif ($b_count_el != 0)
	{
		$old_count = isset($res[0][0]) ? $res[0][0] : 0;
		if(!isset($_REQUEST['pl_plugin_reserving']))
		{
			$res = sql_query('UPDATE sb_basket SET b_count_el = ?d, b_date = ?d WHERE b_id_mod = ?d AND b_id_el = ?d AND b_prop = ? AND (b_domain=? OR b_domain=?) AND '.$basket_where, $b_count_el+$old_count, $cur_time, $p_id, $el_id, $new_prop, 'all', SB_COOKIE_DOMAIN, $basket_arg);
		}
		else
		{
			$res = sql_query('UPDATE sb_basket SET b_date = ?d WHERE b_id_mod = ?d AND b_id_el = ?d AND b_prop = ? AND (b_domain=? OR b_domain=?) AND '.$basket_where, $cur_time, $p_id, $el_id, $new_prop, 'all', SB_COOKIE_DOMAIN, $basket_arg);
		}

		if(!$res)
		{
			//	выдать сообщение об ошибке
			sb_add_system_message(KERNEL_PROG_PLUGIN_MAKER_ERROR_ADD);
			return false;
		}
	}
}

/********************************** функции построения диалоговых окон при связке компонента ***********************************/

function fBasket_Get_Elem_Mini_Form()
{
	$params = unserialize($_GET['params']);
	echo '<script>
		function choose()
		{
			var res = new Object();
			var params = new Array();

			var el_temp = sbGetE("temp_id");
			if (el_temp)
			{
				params["temp_id"] = el_temp.value;
			}
			else
			{
				alert("'.PL_BASKET_H_ELEM_FORM_NO_TEMPS_ALERT.'");
				return;
			}

			params["page"] = sbGetE("page").value;
			params["cena"] = sbGetE("cena").value;
            params["plugins"] = [];
            
			var els = sbGetE("sb_layout_table").getElementsByTagName("input");
            var preg = /^chb_\d+$/;
						
            for(var i=0; i<els.length; i++)
            {
				if (!preg.test(els[i].getAttribute("id")))
                {
                    continue;
                }
						
                if(els[i].checked && els[i].value != "0")
                {
                    params["plugins"].push(els[i].value);
                }
            }

            res.temp_id = el_temp.value;
            res.params = sb_serialize(params);
			sbReturnValue(res);
		}
        
        function changePlugins()
        {
            var all = sbGetE("chb_0");
            var els = sbGetE("sb_layout_table").getElementsByTagName("input");
            var preg = /^chb_\d+$/;
            var selected_cnt = 0;
            
            for(var i=0; i<els.length; i++)
            {
                if(!preg.test(els[i].getAttribute("id")) || els[i].getAttribute("id")=="chb_0")
                {
                    continue;
                }
						
                if(all.checked)
                {
                    els[i].checked=false;
                    els[i].disabled=true;
                }
                else
                {
                    els[i].disabled=false;
                }
            }
            
        }
	</script>';

	require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
	require_once(SB_CMS_LIB_PATH.'/sbJustCategs.inc.php');

	$layout = new sbLayout();
	$layout->mTableWidth = '95%';
	$layout->mTitleWidth = '200';

	echo '<br /><br />';
	$layout->addHeader(PL_BASKET_H_MINI_DESIGN_MENU);

	$res = sql_query('SELECT categs.cat_title, temps.ptf_id, temps.ptf_title
			FROM sb_categs categs, sb_catlinks links, sb_plugins_temps_form temps
			WHERE temps.ptf_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_basket_mini_basket"
			ORDER BY categs.cat_left, temps.ptf_title');

	if ($res)
	{
		$options = array();

		$old_cat_title = '';
		foreach ($res as $value)
		{
			list($cat_title, $st_id, $st_title) = $value;

			if ($old_cat_title != $cat_title)
			{
				$options[uniqid()] = '-'.$cat_title;
				$old_cat_title = $cat_title;
			}
			$options[$st_id] = $st_title;
		}

		$fld = new sbLayoutSelect($options, 'temp_id');
		$fld->mSelOptions = isset($params['temp_id']) ? array($params['temp_id']) : array();
		$layout->addField(PL_BASKET_H_ELEM_TEMP, $fld);
	}
	else
	{
		$layout->addField(PL_BASKET_H_ELEM_TEMP, new sbLayoutLabel('<div class="hint_div">'.PL_BASKET_H_ELEM_FORM_NO_TEMPS_MSG.'</div>', '', '', false));
	}

	$layout->addField('', new sbLayoutDelim());
	$layout->addField(PL_BASKET_H_ELEM_FORM_PAGE, new sbLayoutPage(isset($params['page']) ? $params['page'] : '', 'page', '', 'style="width: 480px;"'));

	$options = array();
	$options[1] = PL_BASKET_H_CENA_1;
	$options[2] = PL_BASKET_H_CENA_2;
	$options[3] = PL_BASKET_H_CENA_3;
	$options[4] = PL_BASKET_H_CENA_4;
	$options[5] = PL_BASKET_H_CENA_5;

	$fld = new sbLayoutSelect($options, 'cena');
	$fld->mSelOptions = isset($params['cena']) ? array($params['cena']) : array();
	$layout->addfield(PL_BASKET_H_CENA_FILED_TITLE, $fld);

	$layout->addField('', new sbLayoutDelim());
    
    $plugins = array(PL_BASKET_H_PLUGINS_AVALIABLE_ALL);
    $res1 = sql_param_assoc('SELECT pm_id, pm_title, pm_elems_settings FROM sb_plugins_maker');
    if($res1)
    {
        foreach($res1 as $row)
        {
            if($row['pm_elems_settings'] != '')
            {
                $pl_settings = unserialize($row['pm_elems_settings']);
                if(!isset($pl_settings['need_basket']) || $pl_settings['need_basket'] == 1)
                {
                    $plugins[$row['pm_id']] = $row['pm_title'];
                }
            }
        }
    }
    $selected_plugins = (isset($params['plugins']) && $params['plugins'] != '')? explode(',', $params['plugins']) : array(0);
    
    foreach($plugins as $key=>$plugin)
    {
        $checked = (in_array($key, $selected_plugins))? 'checked="checked"' : '';
        
        if(count($selected_plugins) == 1 && $selected_plugins[0] == 0 && $key > 0)
        {
            $checked .= ' disabled="disabled"';
        }
        
        $fld = new sbLayoutInput('checkbox', $key, 'plugins[]', 'chb_'.$key, $checked.' onclick="changePlugins()"');
        $fld->mHTML = '<label for="chb_'.$key.'">'.$plugin.'</label>';
        if($key == 0)
        {
            $layout->addfield(PL_BASKET_H_PLUGINS_AVALIABLE, $fld);
        }
        else
        {
            $layout->addfield('', $fld);
        }
        
    }
    
    /**
    $fld = new sbLayoutSelect($plugins, 'plugins[]', 'plugins', 'multiple="multiple"');
	$fld->mSelOptions = (isset($params['plugins']) && $params['plugins'] != '') ? explode(',', $params['plugins']) : array('0');
	$layout->addfield(PL_BASKET_H_PLUGINS_AVALIABLE, $fld);
**/
    
    $layout->addField('', new sbLayoutDelim());

	$layout->addButton('button', KERNEL_SAVE, '', '', 'onclick="choose();"'.($res ? '' : ' disabled="disabled"'));
	$layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');

	$layout->show();
}


/********************************** функции получения информации по элементам модуля ***********************************/

function fBasket_Elem_Mini_Form_Info($params)
{
	$res = sql_param_query('SELECT categs.cat_title, temps.ptf_title
                    FROM sb_categs categs, sb_catlinks links, sb_plugins_temps_form temps
					WHERE temps.ptf_id=?d
					AND links.link_el_id=temps.ptf_id
					AND categs.cat_id=links.link_cat_id
					AND categs.cat_ident="pl_basket_mini_basket"', $params['temp_id']);

	echo '<div style="padding-bottom: 5px;"><b>'.PL_BASKET_H_ELEM_TEMP.':</b> '.($res ? $res[0][0].' -&gt; '.$res[0][1] : '<span style="color:red;">'.PL_BASKET_H_INFO_TEMP_WAS_DELETED_MSG.'</span>').'</div>
          <div class="delim"></div>
          <div style="padding-bottom: 5px;"><b>'.PL_BASKET_H_ELEM_FORM_PAGE.':</b> '.(isset($params['page']) && $params['page'] != '' ? $params['page'] : '').'</div>';
}


/********************************** функции получения элементов модуля ***********************************/

function fBasket_Elem_Mini_Form_Prog($el_id, $temp_id, $params, $tag_id)
{
	return "<?php include_once SB_CMS_PL_PATH.'/pl_basket/prog/pl_basket.php';\n
		fBasket_Elem_Mini_Form('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id');\n
		?>";
}


?>