<?php
function fCache_Init()
{
    $tabId = (isset($_GET['tab_id']) ? intval($_GET['tab_id']) : -1);
    $tabNum = 0;

    $plugins = $_SESSION['sbPlugins']->getPluginsInfo();

    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

    $layout = new sbLayout(SB_CMS_CONTENT_FILE.'?event=pl_cache_submit', '', 'post', '');
    $layout->mTitleWidth = 200;
    $layout->mShowColon = false;
    $layout->setAutoLoading(SB_CMS_EMPTY_FILE.'?event=pl_cache_init');
    $layout->mTabsOnLoadTab = 'sbSetSpin';

    require_once (SB_CMS_LIB_PATH.'/sbIDN.inc.php');
    $idn = new sbIDN();
    
    if (!$_SESSION['sbAuth']->isAdmin())
    {
        $res = sql_query('SELECT u_domains FROM sb_users WHERE u_id=?d', $_SESSION['sbAuth']->getUserId());
        if ($res)
        {
            $u_domains = explode(',', $res[0][0]);
        }
        else
        {
            $u_domains = array();
        }
    }
    
    foreach ($GLOBALS['sb_domains'] as $domain => $tmp)
    {
        $idn_domain = $idn->decode($domain);
        if (isset($u_domains) && !in_array($idn_domain, $u_domains))
        {
            continue;
        }

        $layout->addTab($idn_domain);
        $layout->addHeader(sprintf(PL_CACHE_HEADER, $idn_domain));

        if ($tabNum == $tabId)
        {
            $layout->addField('', new sbLayoutHTML('<div class="hint_div">'.PL_CACHE_HINT.'</div>', true));

            $res = sql_query('SELECT ident, time FROM sb_cache_settings WHERE domain=?', $domain);
            $settings = array();
            if ($res)
            {
                foreach ($res as $value)
                {
                    list($ident, $time) = $value;
                    $settings[$ident] = $time;
                }
            }

            $dmn = str_replace('.', '_', $domain);
            $dmn = str_replace('-', '_', $dmn);

            foreach ($plugins as $ident => $value)
            {
                if (isset($value['use_cache']) && $value['use_cache'])
                {
                    $fld1 = new sbLayoutInput('text', (isset($settings[$ident]) ? $settings[$ident] : 30), $dmn.'_'.$ident, 'spin_'.$dmn.'_'.$ident, 'style="width: 80px;"');
                    $fld2 = new sbLayoutInput('button', PL_CACHE_DROP, '', '', 'onclick="dropCache(\''.$ident.'\', \''.$domain.'\');"');

                    $fld = new sbLayoutHTML('<table><tr><td>'.$fld1->getField().'</td><td>&nbsp;&nbsp;'.$fld2->getField().'</td></tr></table>');
                    $fld->mShowColon = false;

                    $layout->addField($value['title'].($value['icon'] != '' ? '&nbsp;&nbsp;&nbsp;<img src="'.str_replace('_24', '_16', $value['icon']).'" align="absmiddle" width="16" height="16" />' : ''), $fld);
                    $layout->addField('', new sbLayoutDelim());
                }
            }
        }

        $tabNum++;
    }

    $layout->addButton('submit', KERNEL_SAVE);
    $layout->addButton('button', PL_CACHE_DROP, '', '', 'onclick="dropCache(\'all\');"');

    if ($tabId == -1)
    {
	    echo '<script src="'.SB_CMS_JSCRIPT_URL.'/sbSpinButton.js.php"></script>
	    <script>
	    function dropCache(ident, domain)
	    {
	        if (ident == "all")
	        {
	            domain = window.tabs.getTitle(window.tabs.selectedItem);
	        }
	        var res = sbLoadSync(sb_cms_empty_file + "?event=pl_cache_drop&ident=" + ident + "&domain=" + domain);

	        if (res == "TRUE")
	        {
	            sbShowMsgDiv("'.PL_CACHE_DROPPED.'", "information.png");
	        }
	        else
	        {
	            sbShowMsgDiv("'.PL_CACHE_NOT_DROPPED.'", "warning.png");
	        }
	    }
	    </script>';
    }

    $layout->show();
}

function fCache_Submit()
{
    $plugins = $_SESSION['sbPlugins']->getPluginsInfo();

    sql_query('TRUNCATE TABLE sb_cache_settings');

    foreach ($plugins as $ident => $value)
    {
        if (!isset($value['use_cache']) || !$value['use_cache'])
            continue;

        foreach ($GLOBALS['sb_domains'] as $domain => $tmp)
        {
            $dmn = str_replace('.', '_', $domain);
            $dmn = str_replace('-', '_', $dmn);

            $row = array();
            if (isset($_POST[$dmn.'_'.$ident]))
            {
                $row['ident'] = $ident;
                $row['time'] = intval($_POST[$dmn.'_'.$ident]);
                $row['domain'] = $domain;
            }
            else
            {
                $row['ident'] = $ident;
                $row['time'] = 30;
                $row['domain'] = $domain;
            }

            sql_query('INSERT INTO sb_cache_settings (?#) VALUES (?a)', array_keys($row), array_values($row));
        }
    }

    sb_show_message(PL_CACHE_LOG_SAVE);
    sb_add_system_message(PL_CACHE_LOG_SAVE);

    fCache_Init();
}

function fCache_Drop()
{
    require_once(SB_CMS_LIB_PATH.'/sbCache.inc.php');

    if ($GLOBALS['sbCache']->drop($_GET['ident'], $_GET['domain']))
        echo 'TRUE';
}
?>