<?php

/**
 * Функция выводящая список последних комментариев на рабочий стол
 */
function fComments_Info()
{
	$count_c = sbPlugins::getUserSetting('sb_comments_count_comments');

	$cat_right_str = '';

	$cats = array();
	if (!$_SESSION['sbAuth']->isAdmin())
    {
		$plugins_str = '';
		if(isset($_SESSION['sbPlugins']->mComments) && is_array($_SESSION['sbPlugins']->mComments))
		{
			foreach($_SESSION['sbPlugins']->mComments as $key => $value)
			{
				$plugins_str .= ' c.cat_ident="'.$key.'" OR ';
			}
			$plugins_str = ' AND ('.substr($plugins_str, 0, -4).')';
		}

		$res = sql_query('SELECT c.cat_id, c.cat_rights, c.cat_ident FROM sb_categs c WHERE c.cat_rights != "" '.$plugins_str);
		if ($res)
		{
        	foreach($res as $value)
        	{
	            $cat_rights = trim($value[1]);

	            if($cat_rights == '')
	            	continue;

			    $cat_rights = explode('^', $cat_rights);
			    $cat_groups = array();

			    foreach ($cat_rights as $right)
			    {
			    	if ($right[0] == 'g')
			    	{
			    		$cat_groups[] = intval(substr($right, 1));
			    	}
			    	elseif ($right[0] == 'u')
			    	{
			    		if (intval(substr($right, 1)) == $_SESSION['sbAuth']->getUserId())
			    		{
			    			$cats[] = $value[0];
			    			break;
			    		}
			    	}
			    	else
			    	{
						$cat_groups[] = intval($right);
			    	}
			    }

				$groups = $_SESSION['sbAuth']->getUserGroups();
			    if (count(array_intersect($groups, $cat_groups)) > 0)
			    {
					$cats[] = $value[0];
			    }
        	}
        }
	}

	if(count($cats) > 0)
	{
		$cat_right_str = ' AND cat.cat_id IN ('.implode(',', $cats).') ';
	}

	$res = false;
	if(count($cats) > 0 || $_SESSION['sbAuth']->isAdmin())
	{
		$res = sql_param_query('SELECT c.c_plugin, c.c_el_id, c.c_text, c.c_date, c.c_author, su.su_login, su.su_email, m.pm_id, c.c_id
				FROM sb_comments c LEFT JOIN sb_site_users su ON su.su_id = c.c_user_id
				LEFT JOIN sb_plugins_maker m ON c.c_plugin = CONCAT("pl_plugin_", m.pm_id), sb_categs cat, sb_catlinks l
				WHERE IF(c.c_plugin = CONCAT("pl_plugin_", m.pm_id), m.pm_elems_settings LIKE "%\"show_comments\";s:1:\"1\";%", 1=1)
				AND l.link_cat_id = cat.cat_id AND l.link_el_id=c.c_el_id
				AND c.c_plugin = cat.cat_ident
				'.$cat_right_str.'
				ORDER BY c_date DESC LIMIT 0, '.$count_c);
	}

	if($res)
	{
		$result = '<table width="100%" cellspacing="0" cellpadding="5" class="form" style="border: 0;">';
		$plugins_info = $_SESSION['sbPlugins']->getPluginsInfo();

		$r = 0;
		foreach($res as $key=>$value)
		{
			list($c_plugin, $c_el_id, $c_text, $c_date, $c_author, $su_login, $su_email) = $value;

			$r++;
			if($r%2 == 0)
				$class = 'even';
            else
				$class = 'add';

			if($c_author == '')
				$c_author = $su_login;
			elseif($su_login == '' && $c_author == '')
				$c_author = $su_email;

			$result .= '<tr style="border-bottom:1px solid red;"  class="'.$class.'">
					<td style="padding:5px 10px 5px 10px; vertical-align:top; width:150px;">
						<table cellpadding="0" cellspacing="0" border="0">
							<tr class="'.$class.'">
								<td style="padding-right:8px; vertical-align:top;">'.
								(isset($plugins_info[$c_plugin]) ?
									'<img style="float:left;" title="'.$plugins_info[$c_plugin]['title'].'" src="'.sb_str_replace('24', '16', $plugins_info[$c_plugin]['icon']).'">' : '').'
								</td>
								<td style="text-align:center;">
									<nobr>'.sb_date('d.m.Y  H:i', $c_date).'</nobr><br />
									<b>'.$c_author.'</b>
								</td>
							</tr>
						</table>
                    </td>
					<td style="padding:5px 10px 0px 0px; vertical-align:top;">';

			require_once (SB_CMS_LIB_PATH.'/prog/sbFunctions.inc.php');
			$c_text = sbProgParseBBCodes($c_text, '', '', true);

			if (!$_SESSION['sbPlugins']->isRightAvailable($c_plugin, 'elems_edit'))
			{
				$result .= '<a href="javascript:void(0);">'.$c_text.'</a>';
			}
			else
			{
				if(isset($plugins_info[$c_plugin]['main_event']))
					$result .= '<a href="'.SB_CMS_CONTENT_FILE.'?event='.$plugins_info[$c_plugin]['main_event'].'&sb_sel_id='.$c_el_id.'&show_comments=1">'.$c_text.'</a>';
				else
					$result .= '<a href="javascript:void(0);">'.$c_text.'</a>';
			}
			$result .= '</td></tr>';
		}

		$result .= '</table><br />
			<div class="sbDS_more"><a href="'.SB_CMS_CONTENT_FILE.'?event=pl_comments_all_comments">'.KERNEL_MORE.'</a></div>';
		echo $result;
	}
	else
	{
		echo '<div class="hint_div" style="text-align:center; height:30px; margin:20px 5px 20px 5px; padding:10px 0px 0px 0px;">'.PL_COMMENTS_H_INFO_NO_COMMENTS.'</div>';
    }
}

/**
 * Возвращает строку вывода кол-ва комментариев в списке элементов
 *
 * @param int $el_id ID эелемента.
 * @param string $plugin_ident Уникальный идентификатор модуля.
 *
 * @return string Строка вывода кол-ва комментариев элемента.
 */
function fComments_Get_Count_Get ($el_id, $plugin_ident)
{
	$res = sql_param_query('SELECT COUNT(*) FROM sb_comments WHERE c_el_id = ?d AND c_plugin = ?', $el_id, $plugin_ident);
    if($res && $res[0][0] > 0)
    {
        return '<br />'.PL_COMMENTS_H_INFO_COUNT.': <a href="javascript:void(0);" onClick="showComments('.$el_id.');">'.$res[0][0].'</a>';
    }

    return '<br />'.PL_COMMENTS_H_INFO_COUNT.': 0';
}

/**
 * Функция, выводящая поле выбора макет дизайна комментариев
 *
 * @param object $layout Объект sbLayout, к которому будут добавлены поля.
 * @param string $field_value Идентификатор выбранного макета дизайна.
 * @param string $field_name Имя поля, в котором будет храниться идентификатор макета дизайна.
 */
function fComments_Design_Get(&$layout, $field_value, $field_name)
{
	$res = sql_query('SELECT categs.cat_title, comments.ctl_id, comments.ctl_title FROM sb_categs categs, sb_catlinks links, sb_comments_temps_list comments WHERE comments.ctl_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_comments" ORDER BY categs.cat_left, comments.ctl_title');
    if ($res)
    {
        $options = array();
        $old_cat_title = '';
        foreach ($res as $value)
        {
            list($cat_title, $ctl_id, $ctl_title) = $value;

            if ($old_cat_title != $cat_title)
            {
                $options[uniqid()] = '-'.$cat_title;
                $old_cat_title = $cat_title;
            }

            $options[$ctl_id] = $ctl_title;
        }
        $fld = new sbLayoutSelect($options, $field_name);
        $fld->mSelOptions = array($field_value);
    }
    else
    {
        $fld = new sbLayoutLabel('<div class="hint_div">'.PL_COMMENTS_H_NO_TEMP_COMMENTS.'</div>', '', '', false);
    }

    $layout->addField(PL_COMMENTS_H_DESIGN_GET, $fld);
}

function fComments_Show()
{
	require_once(SB_CMS_LIB_PATH . '/sbLayout.inc.php');
	require_once (SB_CMS_LIB_PATH . '/prog/sbFunctions.inc.php');

	echo '<br /><br />';

	$layout = new sbLayout();
	$layout->mShowTitle = false;

	if($_GET['pl_ident'] != '' && $_GET['id'] != '')
	{
		$pl_ident = preg_replace('/[^a-zA-Z0-9\-_]+/'.SB_PREG_MOD, '', $_GET['pl_ident']);
		$el_id = intval($_GET['id']);
	}
	else
	{
		$layout->addField('', new sbLayoutHTML(sb_show_message(PL_COMMENTS_H_SHOW_ERROR, true, 'warning', true).'<br /><br />'));
		$layout->addButton('button', KERNEL_CLOSE, '', '', 'onclick="window.close();"');
		$layout->show();
		return;
	}
    
    require_once(SB_CMS_LIB_PATH.'/sbDBPager.inc.php');
	$order_sql = 'ORDER BY c_left, c_date DESC';

	$pager = new sbDBPager('pl_comments', 7, 10);
	$comments_total = true;
	$res = $pager->init($comments_total, 'SELECT c_id, c_author, c_email, c_subj, c_text, c_date, c_file, c_user_id, c_ip, c_file_name, c_show, su_login, c_level FROM sb_comments LEFT JOIN sb_site_users ON su_id=c_user_id WHERE c_plugin = ? AND c_el_id = ?d '.$order_sql, $pl_ident, $el_id);

	$plugin_title = $_SESSION['sbPlugins']->getPluginTitle($pl_ident);
	$dialog_title = $plugin_title.': '.$_GET['title'];

	echo '<script>sbGetE("event_title").innerHTML = "<nobr>&nbsp;'.str_replace('"', '\"', $dialog_title).'&nbsp;</nobr>";</script>';

	$view_info = $_SESSION['sbPlugins']->isRightAvailable('pl_site_users', 'read');
	$view_controls = $_SESSION['sbPlugins']->isRightAvailable($pl_ident, 'elems_edit');

	$com_add = $_SESSION['sbPlugins']->isRightAvailable($pl_ident, 'elems_com_add');
	$com_edit = $_SESSION['sbPlugins']->isRightAvailable($pl_ident, 'elems_com_edit');
	$com_del = $_SESSION['sbPlugins']->isRightAvailable($pl_ident, 'elems_com_del');

	$pl_info = $_SESSION['sbPlugins']->getPluginsInfo();
    
    //проверка цепочки публикаций
    if($_SESSION['sbPlugins']->isPluginAvailable('pl_workflow') && isset($pl_info[$pl_ident]['meta_data']['show']))
    {
        $avail_workflow = sb_get_avail_workflow_status($pl_ident); //разрешенные данному пользователю статусы публикации
        $cur_workflow = sql_param_query('SELECT '.$pl_info[$pl_ident]['meta_data']['show'].' FROM '.$pl_info[$pl_ident]['table'].' WHERE '.$pl_info[$pl_ident]['meta_data']['id'].' = ?d', $el_id);
        if($cur_workflow)
        {
            $view_controls = $view_controls && in_array($cur_workflow[0][0], $avail_workflow);
        }
    }

	if ($view_info)
	{
		echo '<script>
		function showUser(uid)
        {
            var wnd = window.opener;
            wnd.location = sb_cms_content_file + "?event=pl_site_users_init&sb_sel_id=" + uid;
            wnd.focus();
        }
        </script>';
	}

	if ($view_controls)
	{
		echo '<script>
		function showHide(el_id)
		{
			var res = sbLoadSync("'.SB_CMS_EMPTY_FILE.'?event=pl_comments_hide&pl_ident='.$pl_ident.'&id="+el_id);
			if(res != "")
			{
				alert(res);
			}
		}

		function deleteFile(el_id)
		{
			if (!confirm("'.PL_COMMENTS_H_DELETE_FILE_CONFIRM.'"))
				return;

			var res = sbLoadSync("'.SB_CMS_EMPTY_FILE.'?event=pl_comments_delete_file&pl_ident='.$pl_ident.'&id="+el_id);
			if(res != "")
			{
				alert(res);
				return;
			}

			window.location = "'.SB_CMS_DIALOG_FILE.'?event=pl_comments_show'.($_SERVER['QUERY_STRING'] != '' ? '&'.$_SERVER['QUERY_STRING'] : '').'";
		}

		function deleteComment(el_id)
		{
			if (!confirm("'.PL_COMMENTS_H_DELETE_CONFIRM.'"))
				return;

			var res = sbLoadSync("'.SB_CMS_EMPTY_FILE.'?event=pl_comments_delete&pl_ident='.$pl_ident.'&title='.urlencode($_GET['title']).'&id="+el_id);
			if(res != "")
			{
				alert(res);
				return;
			}

			window.location = "'.SB_CMS_DIALOG_FILE.'?event=pl_comments_show'.($_SERVER['QUERY_STRING'] != '' ? '&'.$_SERVER['QUERY_STRING'] : '').'";
		}

		function editComment(id, event_ident)
		{
			var el_id = "";
			if(event_ident != "edit")
				el_id = "&el_id='.$_GET['id'].'";

			var strPage = "'.SB_CMS_MODAL_DIALOG_FILE.'?event=pl_comments_edit_comment&pl_ident='.$pl_ident.'&title='.urlencode($_GET['title']).'&id="+id+el_id+"&event_ident="+event_ident;
			var strAttr = "resizable=1,width=750,height=500";
			sbShowModalDialog(strPage, strAttr, afterEditComment);
		}

		function afterEditComment()
		{
			if (sbModalDialog.returnValue)
				window.location = "'.SB_CMS_DIALOG_FILE.'?event=pl_comments_show'.($_SERVER['QUERY_STRING'] != '' ? '&'.$_SERVER['QUERY_STRING'] : '').'";
		}
		</script>';
	}

	if ($res)
	{
		$layout->addField('', new sbLayoutHTML('<div style="text-align:center;">'.$pager->show().'</div>'));

		foreach ($res as $value)
		{
			list($c_id, $c_author, $c_email, $c_subj, $c_text, $c_date, $c_file, $c_user_id, $c_ip, $c_file_name, $c_show, $su_login, $c_level) = $value;

			$c_text = sbProgParseBBCodes($c_text, '<div class="hint_div" style="border: 1px dashed #B67D56; margin: 7 7 7 20;">', '</div>');

			$width_str = 100;
			$width_str -= (3 * ($c_level - 1));

			$html = '<table width="'.$width_str.'%" style="float:right;" cellspacing="0" cellpadding="5" class="form" align="center">
			<tr>
				<th class="header" style="text-align: left;">
					'.($view_controls ? '<input type="checkbox" onclick="showHide('.$c_id.')"'.($c_show == 1 ? 'checked="checked"' : '') : '').'>
						&nbsp;&nbsp;'.$c_subj.'
					</th>
			</tr>
			<tr class="even">
				<td>
					<div class="smalltext" style="border-bottom: 1px solid #B67D56;padding-bottom: 5px;">'.PL_COMMENTS_H_SHOW_ADD.': <b>'.date('d.m.Y '.KERNEL_IN.' H:i', $c_date).'</b>'.($c_author != '' ? '&nbsp;&nbsp;<b>'.$c_author.'</b>' : '').($c_email != '' ? ($c_author != '' ? '&nbsp;&nbsp;(' : '').'<a href="mailto:'.$c_email.'" target="_blank" class="small">'.$c_email.'</a>'.($c_author != '' ? ')' : '') : '').
					'<br />'.PL_COMMENTS_H_SHOW_IP.': <b>'.$c_ip.'</b>'.
					($c_user_id > 0 ? '<br />'.PL_COMMENTS_H_SHOW_SITE_USER.': '.($view_info ? '<a href="javascript:showUser('.$c_user_id.')">' : '').'<img src="'.SB_CMS_IMG_URL.'/users.png" width="15" height="15" border="0" align="absmiddle" />&nbsp;'.$su_login.($view_info ? '</a>' : '') : '').'</div><br />'.$c_text.'<br /><br />
					'.($c_file != '' ? '<div style="border-top: 1px solid #B67D56;padding-top: 5px;"><a href="'.$c_file.'" target="_blank" class="smalltext"><img src="'.SB_CMS_IMG_URL.'/clip.gif" width="7" height="13" border="0" align="absmiddle" />&nbsp;'.$c_file_name.'</a><br /></div>' : '').'
				</td>
			</tr>
			'.($view_controls ? '
			<tr class="odd">
				<td style="text-align:right;">
					'.($com_add ? '
					<img src="'.SB_CMS_IMG_URL.'/btn_add.png" width="20" height="20" title="'.PL_COMMENTS_H_ANSWER.'" onclick="editComment('.$c_id.', \'answer\');" style="cursor:hand;cursor:pointer;" />
					&nbsp;&nbsp;&nbsp;' : '').'
					'.($com_edit ? '
					<img src="'.SB_CMS_IMG_URL.'/btn_props.png" width="20" height="20" title="'.PL_COMMENTS_H_SHOW_EDIT.'" onclick="editComment('.$c_id.', \'edit\');" style="cursor:hand;cursor:pointer;" />
					&nbsp;&nbsp;&nbsp;' : '').'
					'.($com_del ? '
					<img src="'.SB_CMS_IMG_URL.'/btn_delete.png" width="20" height="20" title="'.PL_COMMENTS_H_SHOW_DELETE.'" onclick="deleteComment('.$c_id.');" style="cursor:hand;cursor:pointer;" />
					':'').'
					'.($c_file != '' ? '&nbsp;&nbsp;&nbsp;<img src="'.SB_CMS_IMG_URL.'/images_drop.png" width="20" height="20" title="'.PL_COMMENTS_H_SHOW_DELETE_FILE.'" onclick="deleteFile('.$c_id.');" style="cursor:hand;cursor:pointer;" />' : '').'
				</td>
			</tr>' : '').'
			</table>';
			$layout->addField('', new sbLayoutHTML($html));
		}

		$layout->addField('', new sbLayoutHTML('<div style="text-align: center;">'.$pager->show().'</div>'));
	}
	else
	{
		$layout->addField('', new sbLayoutHTML(sb_show_message(PL_COMMENTS_H_SHOW_NO_COMMENTS, true, 'information', true).'<br /><br />'));
	}

	$layout->addButton('button', KERNEL_ADD, 'btn_add', '', ($view_controls ? '' : 'disabled="disabled"').' onclick="editComment(\'\', \'add\');"');
	$layout->addButton('button', KERNEL_CLOSE, '', '', 'onclick="window.close();"');
	$layout->show();
}

function fComments_Hide()
{
	if(!isset($_GET['id']) || $_GET['id'] == '')
	{
		echo PL_COMMENTS_H_HIDE_ERROR;
		return;
	}

	if (!isset($_GET['pl_ident']) || $_GET['pl_ident'] == '' || !$_SESSION['sbPlugins']->isRightAvailable($_GET['pl_ident'], 'elems_com_edit'))
	{
		echo PL_COMMENTS_H_NO_EDIT_RIGHTS_ERROR;
		return;
	}

	$res = sql_param_query('SELECT c_show FROM sb_comments WHERE c_id=?d', $_GET['id']);
	if(!$res)
	{
		echo PL_COMMENTS_H_HIDE_ERROR2;
		return;
	}

	$show = ($res[0][0] == 1 ? 0 : 1);

	if(!sql_param_query('UPDATE sb_comments SET c_show = ?d WHERE c_id = ?d', $show, $_GET['id']))
	{
		echo PL_COMMENTS_H_HIDE_ERROR;
		return;
	}
}

function fComments_Delete_File()
{
	if(!isset($_GET['id']) || $_GET['id'] == '')
	{
		echo sprintf(PL_COMMENTS_H_DELETE_FILE_ERROR, '');
		return;
	}

	if (!isset($_GET['pl_ident']) || $_GET['pl_ident'] == '' || !$_SESSION['sbPlugins']->isRightAvailable($_GET['pl_ident'], 'elems_com_del'))
	{
		echo PL_COMMENTS_H_NO_EDIT_RIGHTS_ERROR;
		return;
	}

	$res = sql_param_query('SELECT c_file FROM sb_comments WHERE c_id = ?d', $_GET['id']);
	if(!$res)
	{
		echo PL_COMMENTS_H_DELETE_FILE_ERROR2;
		return;
	}

	list($file_name) = $res[0];
	$file_name = str_ireplace(array('http://', 'www.', SB_COOKIE_DOMAIN), '', $file_name);

	if (trim($file_name) != '' && $GLOBALS['sbVfs']->is_file($file_name) && $GLOBALS['sbVfs']->delete($file_name))
	{
		sql_param_query('UPDATE sb_comments SET c_file = "", c_file_name = "" WHERE c_id = ?d', $_GET['id']);
	}
	else
	{
		echo sprintf(PL_COMMENTS_H_DELETE_FILE_ERROR, $file_name);
		return;
	}
}

function fComments_Delete()
{
	if(!isset($_GET['id']) || $_GET['id'] == '')
	{
		echo PL_COMMENTS_H_DELETE_ERROR;
		return;
	}

	if (!isset($_GET['pl_ident']) || $_GET['pl_ident'] == '' || !$_SESSION['sbPlugins']->isRightAvailable($_GET['pl_ident'], 'elems_com_del'))
	{
		echo PL_COMMENTS_H_NO_EDIT_RIGHTS_ERROR;
		return;
	}

	$res = sql_param_query('SELECT c_subj, c_file, c_left, c_right, c_el_id FROM sb_comments WHERE c_id = ?d', $_GET['id']);
	if(!$res)
	{
		echo PL_COMMENTS_H_DELETE_ERROR;
		return;
	}

	list($c_subj, $c_file, $c_left, $c_right, $c_el_id) = $res[0];

	if (trim($c_file) != '')
	{
		$c_file = trim(str_ireplace(array('http://', 'www.', SB_COOKIE_DOMAIN), '', $c_file), '/\\');
		if(trim($c_file) != '' && $GLOBALS['sbVfs']->is_file($c_file))
		{
			$GLOBALS['sbVfs']->delete($c_file);
		}
	}

	sql_query('LOCK TABLES sb_comments WRITE');

	$res = sql_query('SELECT COUNT(*) FROM sb_comments WHERE c_left >= ?d AND c_right <= ?d AND c_plugin=? AND c_el_id = ?d', $c_left, $c_right, $_GET['pl_ident'], $c_el_id);
	list($num) = $res[0];

	$decr = $num * 2;

	$res = sql_query('DELETE FROM sb_comments WHERE c_left >= ?d AND c_right <= ?d AND c_plugin=? AND c_el_id = ?d', $c_left, $c_right, $_GET['pl_ident'], $c_el_id);
	if(!$res)
	{
		sql_query('UNLOCK TABLES');
		echo PL_COMMENTS_H_DELETE_ERROR;
		return;
	}

	sql_query('UPDATE sb_comments SET c_right = c_right - '.$decr.' WHERE c_plugin=? AND c_el_id = ?d AND c_right >= ?d', $_GET['pl_ident'], $c_el_id, $c_right);
	sql_query('UPDATE sb_comments SET c_left = c_left - '.$decr.' WHERE c_plugin=? AND c_el_id = ?d AND c_left > ?d', $_GET['pl_ident'], $c_el_id, $c_right);
	sql_query('UNLOCK TABLES');

	if(!$res)
	{
		echo PL_COMMENTS_H_DELETE_ERROR;
		return;
	}

	$pl_ident = preg_replace('/[^a-zA-Z0-9\-_]+/'.SB_PREG_MOD, '', $_GET['pl_ident']);
	$plugin_title = $_SESSION['sbPlugins']->getPluginTitle($pl_ident);

	if ($_GET['title'] != '')
		sb_add_system_message(sprintf(PL_COMMENTS_H_DELETE_SYSTEMLOG_MSG, $c_subj, $plugin_title, urldecode($_GET['title'])));
	else
		sb_add_system_message(sprintf(PL_COMMENTS_H_DELETE_NO_TITLE_SYSTEMLOG_MSG, $c_subj, $plugin_title));
}


function fComments_Edit_Comment()
{
	if (!isset($_GET['pl_ident']) || $_GET['pl_ident'] == '' || (!$_SESSION['sbPlugins']->isRightAvailable($_GET['pl_ident'], 'elems_com_edit') && 
		$_GET['event_ident'] == 'edit'))
	{
		sb_show_message(PL_COMMENTS_H_NO_EDIT_RIGHTS_ERROR, true, 'warning');
		echo '<br /><br />[ <a href="javascript:sbCloseDialog();">'.KERNEL_CLOSE.'</a> ]';
		return;
	}

	if(!$_SESSION['sbPlugins']->isRightAvailable($_GET['pl_ident'], 'elems_com_add') && ($_GET['event_ident'] == 'answer' || $_GET['event_ident'] == 'add'))
	{
		sb_show_message(PL_COMMENTS_H_NO_EDIT_RIGHTS_ERROR, true, 'warning');
		echo '<br /><br />[ <a href="javascript:sbCloseDialog();">'.KERNEL_CLOSE.'</a> ]';
		return;
	}

	if((!isset($_GET['id']) || $_GET['id'] == '') && $_GET['event_ident'] != 'add')
	{
		sb_show_message(PL_COMMENTS_H_EDIT_COMMENT_ERROR, true, 'warning');
		echo '<br /><br />[ <a href="javascript:sbCloseDialog();">'.KERNEL_CLOSE.'</a> ]';
		return;
	}

	if (isset($_GET['id']) && $_GET['id'] != '')
	{
		$res = sql_param_query('SELECT c_author, c_email, c_subj, c_text, c_date, c_file, c_file_name, c_show, c_ip FROM sb_comments WHERE c_id = ?d', $_GET['id']);
		if(!$res)
		{
			sb_show_message(PL_COMMENTS_H_EDIT_COMMENT_ERROR, true, 'warning');
			echo '<br /><br />[ <a href="javascript:sbCloseDialog();">'.KERNEL_CLOSE.'</a> ]';
			return;
		}

		list($c_author, $c_email, $c_subj, $c_text, $c_date, $c_file, $c_file_name, $c_show, $c_ip) = $res[0];
		$c_date = date('d.m.Y H:i', $c_date);

		if(isset($_GET['el_id']) && isset($_GET['event_ident']) && $_GET['event_ident'] == 'answer')
		{
			$c_subj = (strpos($c_subj, 'RE: ') !== false ? '' : 'RE: ').$c_subj;
			$c_text = '[quote'.($c_author != '' ? '='.$c_author : '').($c_date != '' ? ' date='.$c_date : '').']'.preg_replace('=<br.*?/?>=i', '', $c_text).'[/quote]';
			$c_date = sb_date('d.m.Y H:i');
			$c_author = $_SESSION['sbAuth']->getUserLogin();
			$c_email = $_SESSION['sbAuth']->getUserEmail();
			$c_date = sb_date('d.m.Y H:i');
			$c_file = $c_file_name = '';
			$c_show = 1;
			$c_ip = $_SESSION['sbAuth']->getIP();
		}
	}
	elseif (count($_POST) > 0)
	{
		$c_show = 0;
		extract($_POST);
	}
	elseif(isset($_GET['el_id']))
	{
		if(isset($_GET['event_ident']) && $_GET['event_ident'] == 'answer')
		{
			$c_subj = (strpos($c_subj, 'RE: ') !== false ? '' : 'RE: ').$c_subj;
			$c_text = '[quote'.($c_author != '' ? '='.$c_author : '').($c_date != '' ? ' date='.$c_date : '').']'.preg_replace('=<br.*?/?>=i', '', $c_text).'[/quote]';
		}
		elseif(isset($_GET['event_ident']) && $_GET['event_ident'] == 'add')
		{
			$c_subj = '';
			$c_text = '';
		}

		$c_date = sb_date('d.m.Y H:i');
		$c_author = $_SESSION['sbAuth']->getUserLogin();
		$c_email = $_SESSION['sbAuth']->getUserEmail();
		$c_date = sb_date('d.m.Y H:i');
		$c_file = $c_file_name = '';
		$c_show = 1;
		$c_ip = $_SESSION['sbAuth']->getIP();
	}

	require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

	$layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE.'?event=pl_comments_edit_comment_submit'.($_SERVER['QUERY_STRING'] != '' ? '&'.$_SERVER['QUERY_STRING'] : ''), 'thisDialog', 'post', '');

	$layout->addTab(PL_COMMENTS_H_EDIT_TAB1);
	$layout->addHeader(PL_COMMENTS_H_EDIT_TAB1);

	$layout->addField(PL_COMMENTS_H_EDIT_COMMENT_SUBJ, new sbLayoutInput('text', $c_subj, 'c_subj', '', 'style="width:100%;"'));
	$layout->addField(PL_COMMENTS_H_EDIT_COMMENT_TEXT, new sbLayoutTextarea($c_text, 'c_text', '', 'style="width:100%;height:200px;"'));
	$layout->addField(PL_COMMENTS_H_EDIT_COMMENT_SHOW, new sbLayoutInput('checkbox', '1', 'c_show', '', ($c_show == 1 ? 'checked="checked"' : '')));

	$layout->addTab(PL_COMMENTS_H_EDIT_TAB2);
	$layout->addHeader(PL_COMMENTS_H_EDIT_TAB2);

	$layout->addField(PL_COMMENTS_H_EDIT_COMMENT_AUTHOR, new sbLayoutInput('text', $c_author, 'c_author', '', 'style="width:100%;"'));
	$layout->addField(PL_COMMENTS_H_EDIT_COMMENT_EMAIL, new sbLayoutInput('text', $c_email, 'c_email', '', 'style="width:100%;"'));
	$layout->addField('', new sbLayoutDelim());

	$layout->addField(PL_COMMENTS_H_EDIT_COMMENT_DATE, new sbLayoutDate($c_date, 'c_date', '', 'style="width:100%;"'));
	$layout->addField(PL_COMMENTS_H_EDIT_COMMENT_IP, new sbLayoutInput('text', $c_ip, 'c_ip', '', 'style="width:130px;"'));

	$layout->addField('', new sbLayoutDelim());

	$layout->addField(PL_COMMENTS_H_EDIT_COMMENT_FILE, new sbLayoutFile($c_file, 'c_file', '', 'style="width:450px;"'));
	$layout->addField(PL_COMMENTS_H_EDIT_COMMENT_FILE_NAME, new sbLayoutInput('text', $c_file_name, 'c_file_name', '', 'style="width:100%;"'));

	if(isset($_GET['el_id']))
		$layout->addButton('submit', KERNEL_ADD);
	else
		$layout->addButton('submit', KERNEL_SAVE);

	$layout->addButton('button', KERNEL_CLOSE, '', '', 'onclick="sbCloseDialog();" ');
	$layout->show();
}

function fComments_Edit_Comment_Submit()
{
	if ((!isset($_GET['id']) || $_GET['id'] == '') && $_GET['event_ident'] != 'add' || count($_POST) <= 0)
	{
		sb_show_message(PL_COMMENTS_H_EDIT_COMMENT_ERROR, false, 'warning');
		fComments_Edit_Comment();
		return;
	}

	$c_show = 0;
	extract($_POST);

	if(!isset($c_text) || trim($c_text) == '')
	{
		sb_show_message(PL_COMMENTS_H_EDIT_NO_COMMENT_TEXT_MSG, false, 'warning');
		fComments_Edit_Comment();
		return;
	}

	if ($c_file != '' && trim($c_file_name) == '')
	{
		$c_file_name = basename($c_file);
	}

	$row = array();
	$row['c_author'] = $c_author;
	$row['c_email'] = $c_email;
	$row['c_subj'] = $c_subj;
	$row['c_text'] = $c_text;
	$row['c_date'] = sb_datetoint($c_date);
	$row['c_file'] = $c_file;
	$row['c_file_name'] = $c_file_name;
	$row['c_show'] = $c_show;
	$row['c_ip'] = $c_ip;

	sql_query('LOCK TABLES sb_comments WRITE');

	if(isset($_GET['el_id']))
	{
		$row['c_plugin'] = $_GET['pl_ident'];
		$row['c_el_id'] = $_GET['el_id'];

		if (isset($_GET['id']) && intval($_GET['id']) > 0)
		{
			$res = sql_query('SELECT c_right, c_level FROM sb_comments WHERE c_id=?d', $_GET['id']);
			if (!$res)
				return false;

			list($right, $level) = $res[0];
		}
		else
		{
//			всегда подразумеваем что у нас есть корневой комментарий с level = 0
			$res = sql_query('SELECT MAX(c_right) FROM sb_comments WHERE c_el_id=?d AND c_plugin=?', $_GET['el_id'], $_GET['pl_ident']);

//			правое значение и уровень корневого узла(комментария, реально не существующего)
			$right = (isset($res[0][0]) ? $res[0][0] + 1 : 2);
			$level = 0;
		}

		sql_query('UPDATE sb_comments SET c_right = c_right + 2 WHERE c_el_id=?d AND c_plugin=? AND c_right >= ?d', $_GET['el_id'], $_GET['pl_ident'], $right);
		sql_query('UPDATE sb_comments SET c_left = c_left + 2 WHERE c_el_id=?d AND c_plugin=? AND c_left > ?d', $_GET['el_id'], $_GET['pl_ident'], $right);

		$level++;

		$row['c_left'] = $right;
		$row['c_right'] = ($right + 1);
		$row['c_level'] = $level;

		sql_query('INSERT INTO sb_comments (?#) VALUES (?a)', array_keys($row), array_values($row));
	}
	else
	{
		sql_query('UPDATE sb_comments SET ?a WHERE c_id = ?d', $row, $_GET['id']);
	}

	sql_query('UNLOCK TABLES');

	$pl_ident = preg_replace('/[^a-zA-Z0-9\-_]+/'.SB_PREG_MOD, '', $_GET['pl_ident']);
	$plugin_title = $_SESSION['sbPlugins']->getPluginTitle($pl_ident);

	if(isset($_GET['el_id']))
	{
		sb_add_system_message(sprintf(PL_COMMENTS_H_EDIT_COMMENT_SYSTEMLOG_ADD_MSG, $c_subj, $plugin_title, urldecode($_GET['title'])));
	}
	else
	{
		if ($_GET['title'] != '')
			sb_add_system_message(sprintf(PL_COMMENTS_H_EDIT_COMMENT_SYSTEMLOG_MSG, $c_subj, $plugin_title, urldecode($_GET['title'])));
		else
			sb_add_system_message(sprintf(PL_COMMENTS_H_EDIT_COMMENT_NO_TITLE_SYSTEMLOG_MSG, $c_subj, $plugin_title));
	}

	echo '<script>
		sbReturnValue(true);
	</script>';
}

/**
 * Функция, удаляющая комментарии, относящиеся к удаляемому элементу
 *
 * @param int $el_id ID Удаляемого элемента.
 * @param string $plugin_id Уникальный идентификатор модуля.
 */
function fComments_Delete_Comment($el_id, $plugin_id)
{
	if(is_array($el_id))
    	$res = sql_query('SELECT c_file FROM sb_comments WHERE c_plugin = ? AND c_el_id IN (?a) AND c_file IS NOT NULL AND c_file != ?', $plugin_id, $el_id, '');
    else
    	$res = sql_query('SELECT c_file FROM sb_comments WHERE c_plugin = ? AND c_el_id = ?d AND c_file IS NOT NULL AND c_file != ?', $plugin_id, $el_id, '');
    if($res)
    {
	    foreach ($res as $value)
	    {
	    	list($c_file) = $value;

		    if (trim($c_file) != '')
			{
				if (stripos($c_file, 'http://') !== false)
				{
					$c_file = substr($c_file, 8);
					$c_file = substr($c_file, strpos($c_file, '/'));
				}

				if($GLOBALS['sbVfs']->is_file($c_file))
				{
					$GLOBALS['sbVfs']->delete($c_file);
				}
			}
	    }
    }

    if(is_array($el_id))
    	sql_query('DELETE FROM sb_comments WHERE c_plugin = ? AND c_el_id IN (?a)', $plugin_id, $el_id);
    else
    	sql_query('DELETE FROM sb_comments WHERE c_plugin = ? AND c_el_id = ?d', $plugin_id, $el_id);
}



function fComments_Get_Elem_Comments_List()
{
	$params = unserialize($_GET['params']);
	if (!isset($params['filter']))
		$params['filter'] = 'all';

	echo '<script>
		function chooseCat()
		{
			var res = new Object();
			var params = new Array();
			var el_temp = sbGetE("temp_id");

			if(el_temp)
			{
				params["temp_id"] = el_temp.value;
			}
			else
            {
				alert("'.PL_COMMENTS_H_ELEM_NO_TEMPS_ALERT.'");
				return;
            }

            var cat_el = sbGetE("cat_id");
			if(cat_el.value == "")
			{
				alert("'.PL_COMMENTS_H_NO_CATEGS_ALERT.'");
				return;
			}

            var close = sbGetE("close_cat");
			if(close.checked)
			{
				params["close_cat"] = 1;
			}

			var hidden = sbGetE("hidden_cat");
			if(hidden.checked)
            {
				params["hidden_cat"] = 1;
			}
            
            var only_own_comments = sbGetE("only_own_comments");
            if(only_own_comments.checked)
            {
                params["only_own_comments"] = 1;
            }
            
			var sub_cats = sbGetE("sub_cats");
			if(sub_cats.checked)
            {
				params["sub_cats"] = 1;
			}

			var r_filter_all = sbGetE("r_filter_all");
			var r_filter_from_to = sbGetE("r_filter_from_to");

            if (r_filter_all.checked)
            {
				params["filter"] = r_filter_all.value;
            }
            else if (r_filter_from_to.checked)
            {
				params["filter"] = r_filter_from_to.value;
				var el_filter_from = sbGetE("spin_filter_from");
				var el_filter_to = sbGetE("spin_filter_to");

				if (el_filter_to.value != "" && el_filter_to.value != 0 && parseInt(el_filter_from.value) > parseInt(el_filter_to.value))
				{
					alert("'.PL_COMMENTS_H_ELEM_LIST_FILTER_FROM_TO_ERROR.'");
					return;
				}

                params["filter_from"] = el_filter_from.value;
                params["filter_to"] = el_filter_to.value;
            }

            var page = sbGetE("page");
			params["page"] = page.value;

			var ids = sbGetE("cat_id");
			params["ids"] = ids.value;

			var ident = sbGetE("pl_ident");
			params["pl_ident"] = ident.value;

			var cats_title = sbGetE("cat_id_text");
			params["cats_title"] = cats_title.innerHTML;

			var i = 1;
			var el = "";
			while(el = sbGetE("mComments"+i))
			{
				if(!params[el.name])
				{
					switch(el.name)
					{
						case "pl_news":
							params[el.name] = "news";
							break;
						case "pl_imagelib":
							params[el.name] = "imagelib";
							break;
						case "pl_site_users":
							params[el.name] = "su";
							break;
						case "pl_services_rutube":
							params[el.name] = "rutube";
							break;
						case "pl_faq":
							params[el.name] = "faq";
							break;
					}

					var reg = new RegExp("pl_plugin");
					if(reg.test(el.name))
					{
						params[el.name] = "pl"+el.name.replace(/[a-z_]/ig, "");
					}
				}
				params[el.name] += "__"+el.value;
				i++;
			}

			res.temp_id = el_temp.value;
			res.params = sb_serialize(params);
			sbReturnValue(res);
		}

		function changeIdent(el)
		{
			var cat_el = sbGetE("cat_id");
			var text_el = sbGetE("cat_id_text");
			var cat_cat_el = sbGetE("cat_id_cat");
			var ident = sbGetE("cat_id_ident");
			var page = sbGetE("page_title");
			var page_href = sbGetE("page");

			cat_el.value = "";
			page_href.value = "";
			ident.value = el.value;
			cat_el.value = "";
			text_el.innerHTML = "<b style=\'font-size:11px;\'>'.SB_LAYOUT_NO_SPRAV.'</b>";
			cat_cat_el.value = "";
        }
	</script>';

	require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
	$layout = new sbLayout();
	$layout->mTableWidth = '100%';
    $layout->mTitleWidth = '200';

	$layout->addTab(PL_COMMENTS_H_EDIT_TAB1);
	$layout->addHeader(PL_COMMENTS_H_EDIT_TAB1);

	$options = array();
	foreach($_SESSION['sbPlugins']->mComments as $key => $value)
	{
		$options[$key] = $value['title'];
    }

	$fld = new sbLayoutSelect($options, 'pl_ident', 'pl_ident', 'onkeyup="changeIdent(this);" onchange="changeIdent(this);"');
	if (isset($params['pl_ident']))
	{
		$fld->mSelOptions = array($params['pl_ident']);
		$ident = $params['pl_ident'];
	}
	$layout->addField(PL_COMMENTS_H_EDIT_CATEGS_PLUGIN, $fld);


	if (!isset($ident))
	{
		reset($_SESSION['sbPlugins']->mComments);
		$m_comments = each($_SESSION['sbPlugins']->mComments);

		if(!$m_comments)
		{
			$ident = '';
        }
		else
		{
			$ident = $m_comments['key'];
			$m_comments = $m_comments['value'];
    	}
	}
	else
	{
		$m_comments = $_SESSION['sbPlugins']->mComments[$ident];
	}

	$fld = new sbLayoutCategs($ident, '', isset($params['ids']) ? $params['ids'] : '', 'cat_id', 'cat_id', '', true);
	$fld->mHTML = '<br />';
	$fld->mDropButton = false;
	$fld->mMultiSelect = true;

	$html = $fld->getJavaScript().$fld->getField();
	$layout->addField(PL_COMMENTS_H_EDIT_CATEGS_CAT_ID, new sbLayoutHTML($html));

	$options = array();
	$res = sql_query('SELECT categs.cat_title, temps.ctl_id, temps.ctl_title
						FROM sb_categs categs, sb_catlinks links, sb_comments_temps_list temps
						WHERE temps.ctl_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_comments"
						ORDER BY categs.cat_left, temps.ctl_title');
	if ($res)
    {
		$old_cat_title = '';
		foreach ($res as $value)
        {
			list($cat_title, $ctl_id, $ctl_title) = $value;
			if($old_cat_title != $cat_title)
            {
				$options[uniqid()] = '-'.$cat_title;
				$old_cat_title = $cat_title;
            }
			$options[$ctl_id] = $ctl_title;
        }
    }

	if (count($options) > 0)
    {
		$fld = new sbLayoutSelect($options, 'temp_id');
		if (isset($_GET['temp_id']))
        {
			$fld->mSelOptions = array($_GET['temp_id']);
        }
	}
	else
	{
		$fld = new sbLayoutLabel('<div class="hint_div">'.PL_COMMENTS_H_ELEM_NO_TEMPS_MSG.'</div>', '', '', false);
	}

	$layout->addField('', new sbLayoutDelim());
	$layout->addField(PL_COMMENTS_H_ELEM_TEMP, $fld);
	$layout->addField('', new sbLayoutDelim());

	$layout->addField(PL_COMMENTS_H_ELEM_PLUGIN_LIST_PAGE, new sbLayoutPage((isset($params['page']) ? $params['page'] : ''), 'page', 'page', 'style="width:440px;"'));

    $layout->addField(PL_COMMENTS_H_USER_COMMENTS, new sbLayoutInput('checkbox', '1', 'only_own_comments', 'only_own_comments', (isset($params['only_own_comments']) && $params['only_own_comments'] == 1 ? 'checked="checked"' : '')));

	$layout->addField(PL_COMMENTS_H_SUB_CATEGS, new sbLayoutInput('checkbox', '1', 'sub_cats', 'sub_cats', (isset($params['sub_cats']) && $params['sub_cats'] == 1 ? 'checked="checked"' : '')));

	$layout->addField(PL_COMMENTS_H_CLOSE_THEMES, new sbLayoutInput('checkbox', '1', 'close_cat', 'close_cat', (isset($params['close_cat']) && $params['close_cat'] == 1 ? 'checked="checked"' : '')));
	$layout->addField(PL_COMMENTS_H_HIDDEN_THEMES, new sbLayoutInput('checkbox', '1', 'hidden_cat', 'hidden_cat', (isset($params['hidden_cat']) && $params['hidden_cat'] == 1 ? 'checked="checked"' : '')));

    $layout->addTab(PL_COMMENTS_H_FILTER_TAB);
	$layout->addHeader(PL_COMMENTS_H_FILTER_TAB);
    $html = '';
    $fld1 = new sbLayoutInput('radio', 'all', 'filter', 'r_filter_all', ($params['filter'] == 'all' ? ' checked="checked"' : ''));
    $fld1->mHTML = '&nbsp;&nbsp;'.PL_COMMENTS_H_ELEM_LIST_FILTER_ALL;
    $html .= $fld1->getField().'<br /><br />';

	$fld2 = new sbLayoutInput('radio', 'from_to', 'filter', 'r_filter_from_to', ($params['filter'] == 'from_to' ? ' checked="checked"' : ''));
	$fld2_1 = new sbLayoutInput('input', (isset($params['filter_from']) ? $params['filter_from'] : ''), 'filter_from', 'spin_filter_from', 'style="width: 50px;"');
	$fld2_2 = new sbLayoutInput('input', (isset($params['filter_to']) ? $params['filter_to'] : ''), 'filter_to', 'spin_filter_to', 'style="width: 50px;"');
	$fld2_1->mMinValue = 1;
	$html .= $fld2_1->getJavascript().'<table cellpadding="0" cellspacing="0"><tr><td>'.$fld2->getField().'</td><td>&nbsp;&nbsp;'.KERNEL_FROM.'&nbsp;&nbsp;</td><td>'.$fld2_1->getField().'</td><td>&nbsp;&nbsp;'.KERNEL_TO.'&nbsp;&nbsp;</td><td>'.$fld2_2->getField().'</td></tr></table>
				<div class="hint_div">'.PL_COMMENTS_H_ELEM_LIST_FILTER_FROM_TO_HINT.'</div>';

	$fld = new sbLayoutHTML($html);
	$layout->addField(PL_COMMENTS_H_ELEM_LIST_FILTER, $fld);

	if(count($_SESSION['sbPlugins']->mComments) > 0)
	{
		$i = 0;
		foreach($_SESSION['sbPlugins']->mComments as $key => $value)
		{
			$layout->addField('', new sbLayoutInput('hidden', $value['table'], $key, 'mComments'.($i+1)));
			$layout->addField('', new sbLayoutInput('hidden', $value['id_field'], $key, 'mComments'.($i+2) ));
			$layout->addField('', new sbLayoutInput('hidden', $value['title_field'], $key, 'mComments'.($i+3)));
			$layout->addField('', new sbLayoutInput('hidden', $value['url_field'], $key, 'mComments'.($i+4)));

			$i += 4;
		}
	}

	$layout->addButton('button', KERNEL_SAVE, '', '', 'onclick="chooseCat();"'.(count($options) > 0 ? '' : ' disabled="disabled"'));
	$layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');
	$layout->show();
}

function fComments_Elem_Comments_List_Info($params)
{
	$res = sql_param_query('SELECT categs.cat_title, temps.ctl_title FROM sb_categs categs, sb_catlinks links, sb_comments_temps_list temps
		WHERE temps.ctl_id=?d AND links.link_el_id=temps.ctl_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_comments"', $params['temp_id']);

	echo '<div style="padding-bottom: 5px;"><b>'.PL_COMMENTS_H_ELEM_TEMP.':</b> '.($res ? $res[0][0].' -&gt; '.$res[0][1] : '<span style="color:red;">'.PL_COMMENTS_H_INFO_TEMP_WAS_DELETED_MSG.'</span>').'</div>
		<div class="delim"></div>
		<div style="padding-bottom: 5px;"><b>'.PL_COMMENTS_H_CLOSE_THEMES.':</b> '.(isset($params['close_cat']) && $params['close_cat'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>
		<div style="padding-bottom: 5px;"><b>'.PL_COMMENTS_H_HIDDEN_THEMES.':</b> '.(isset($params['hidden_cat']) && $params['hidden_cat'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>';
}

function fComments_Elem_Comments_list($el_id, $temp_id, $params, $tag_id)
{
	return "<?php include_once SB_CMS_PL_PATH.'/pl_comments/prog/pl_comments.php';\n
	fComments_Get_List('$temp_id', '', '$el_id', false, '".addslashes(serialize($params))."', '$tag_id');\n
	?>";
}

?>