<?php
function fEditor_Templates_Create_System_Cats()
{
    require_once(SB_CMS_LIB_PATH.'/sbTree.inc.php');
    $tree = new sbTree('pl_editor_templates');

    $res = sql_query('SELECT cat_id FROM sb_categs WHERE cat_ident=? AND cat_level=0', 'pl_editor_templates');
    if (!$res)
    {
        // создаем корневой раздел
        $fields = array();
        $fields['cat_title'] = PL_EDITOR_TEMPLATES_ROOT_NAME;
        $fields['cat_closed'] = 0;
        $fields['cat_rubrik'] = 0;
        $fields['cat_rights'] = $_SESSION['sbAuth']->isAdmin() ? '' : 'u'.$_SESSION['sbAuth']->getUserId();

        $root_id = $tree->insertNode(0, $fields);

        if (!$root_id)
            return false;
    }
    else
    {
        $root_id = $res[0][0];
    }

    $result = array($root_id);

    // проверяем, есть ли разделы для доменов
    foreach ($GLOBALS['sb_domains'] as $domain => $value)
    {
        $res = sql_query('SELECT cat_id FROM sb_categs WHERE cat_ident=? AND cat_level=1 AND cat_title=?', 'pl_editor_templates', $domain);

        if (!$res)
        {
            $fields['cat_closed'] = 0;
            $fields['cat_rubrik'] = 0;
            $fields['cat_title'] = $domain;
            $fields['cat_rights'] = $_SESSION['sbAuth']->isAdmin() ? '' : 'u'.$_SESSION['sbAuth']->getUserId();

            if (!$cat_id = $tree->insertNode($root_id, $fields))
                return false;
        }
    }

    return $result;
}

function fEditor_Templates_Get($args)
{
	$img = $args['te_img'];
    $img_width = 88;

    if ($img != '' && $GLOBALS['sbVfs']->exists(SB_CMS_EDITOR_URL . '/templates/' . $img))
    {
        $ar = $GLOBALS['sbVfs']->getimagesize(SB_CMS_EDITOR_URL . '/templates/' . $img);
        if (!$ar || !in_array($ar[2], array(1,2,3)))
        {
            $img = '<img src="'.SB_CMS_IMG_URL.'/noimage.png" width="88" height="88" alt="'.$args['te_id'].'" title="'.$args['te_id'].'" />';
        }
        else
        {
            $img_width = min(88, $ar[0]);
            $img = '<img src="'.SB_CMS_EDITOR_URL . '/templates/' . $img.'" width="'.$img_width.'" alt="'.$args['te_id'].'" title="'.$args['te_id'].'" />';
        }
    }
    else
    {
        $img = '<img src="'.SB_CMS_IMG_URL.'/noimage.png" width="88" height="88" alt="'.$args['te_id'].'" title="'.$args['te_id'].'" />';
    }

    $result = '
    <table width="100%" cellpadding="0" cellspacing="0">
    	<tr>
    		<td width="100" align="center">'.$img.'</td>
    		<td valign="top"><b><a href="javascript:void(0);" onclick="sbElemsEdit(event);">'.$args['te_name'].'</a></b>
    		<div class="smalltext" style="margin-top: 7px;">'
    		.($args['te_desc'] != '' ? PL_EDITOR_TEMPLATES_EDIT_DESC.': <span style="color: green;">'.$args['te_desc'].'</span><br />' : '')
    		.PL_EDITOR_TEMPLATES_EDIT_SORT.': <span style="color: green;">'.$args['te_sort'].'</span>
    		</div>
    		</td>
    	</tr>
    </table>';

	return $result;
}

function fEditor_Templates_Init()
{
	$never_show_cats = fEditor_Templates_Create_System_Cats();
    if (!$never_show_cats)
    {
        sb_show_message(PL_EDITOR_TEMPLATES_CREATE_CATEGS_ERROR, true, 'warning');
        return;
    }

    require_once(SB_CMS_LIB_PATH.'/sbElements.inc.php');

    $elems = new sbElements('sb_editor_templates', 'te_id', 'te_name', 'fEditor_Templates_Get', 'pl_editor_templates_init', 'pl_editor_templates');

    $elems->mCategsRootName = PL_EDITOR_TEMPLATES_ROOT_NAME;

	$elems->addField('te_img');
	$elems->addField('te_sort');
	$elems->addField('te_desc');

    $elems->addFilter(PL_EDITOR_TEMPLATES_EDIT_TITLE, 'te_name', 'string');
    $elems->addFilter(PL_EDITOR_TEMPLATES_EDIT_SORT, 'te_sort', 'number');

    $elems->addSorting(PL_EDITOR_TEMPLATES_SORT_BY_NAME, 'te_name');
    $elems->addSorting(PL_EDITOR_TEMPLATES_SORT_BY_SORT, 'te_sort');

    $elems->mCategsPasteElemsMenuTitle = PL_EDITOR_TEMPLATES_PASTE_ELEMS_MENU_TITLE;
    $elems->mCategsPasteLinksMenuTitle = PL_EDITOR_TEMPLATES_PASTE_LINKS_MENU_TITLE;

    $elems->mElemsAddMenuTitle  = PL_EDITOR_TEMPLATES_ADD_MENU_TITLE;
    $elems->mElemsEditMenuTitle = PL_EDITOR_TEMPLATES_EDIT_MENU_TITLE;
    $elems->mElemsCopyMenuTitle = PL_EDITOR_TEMPLATES_COPY_MENU_TITLE;
    $elems->mElemsCutMenuTitle  = PL_EDITOR_TEMPLATES_CUT_MENU_TITLE;

    $elems->mElemsEditEvent = 'pl_editor_templates_edit';
    $elems->mElemsEditDlgWidth = '800';
	$elems->mElemsEditDlgHeight = '600';

	$elems->mElemsAddEvent = 'pl_editor_templates_edit';
    $elems->mElemsAddDlgWidth = '800';
	$elems->mElemsAddDlgHeight = '600';

	$elems->mElemsDeleteEvent = 'pl_editor_templates_delete';
	$elems->mElemsAfterPasteEvent = 'pl_editor_templates_paste';

    $elems->mCategsClosed = false;
	$elems->mCategsRubrikator = false;
	$elems->mCategsNeverShowCats = $never_show_cats;

	$elems->mCategsAddMenu = false;
	$elems->mCategsEditMenu = false;
	$elems->mCategsCopyMenu = false;
	$elems->mCategsCutMenu = false;
	$elems->mCategsDad = false;
	$elems->mCategsDeleteMenu = false;
	$elems->mCategsDeleteWithElementsMenu = false;
	$elems->mCategsPasteCategsMenu = false;

	$elems->mCategsPasteElemsMenuLevel = 2;
	$elems->mElemsAddMenuLevel = 2;
	$elems->mElemsUseLinks = true;
	$elems->mShowIcons = false;

    $elems->init();
}

function fEditor_Templates_Edit($htmlStr = '', $footerStr = '', $footerLinkStr = '')
{
	// проверка прав доступа
	if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'], 'pl_editor_templates'))
		return;

    require_once (SB_CMS_LIB_PATH . '/sbLayout.inc.php');

    if (count($_POST) == 0 && isset($_GET['id']) && $_GET['id'] != '')
    {
        $result = sql_query('SELECT te_name, te_code, te_desc, te_img, te_sort FROM sb_editor_templates WHERE te_id = ?d', $_GET['id']);
        if ($result)
        {
            list ($te_name, $te_code, $te_desc, $te_img, $te_sort) = $result[0];
        }
        else
        {
            sb_show_message(PL_EDITOR_EDIT_ERROR, true, 'warning');
            return;
        }
    }
    elseif (count($_POST) > 0)
    {
    	$te_img = '';

        extract($_POST);
        if (!isset($_GET['id']))
            $_GET['id'] = '';
    }
    else
    {
        $te_img = $te_name = $te_code = $te_desc = '';
        $res = sql_query('SELECT MAX(te_sort) FROM sb_editor_templates');
	    if ($res)
	    {
	        list($max) = $res[0];
	    }
	    else
	    {
	        $max = 0;
	    }
	    $te_sort = $max + 5;
        $_GET['id'] = '';
    }

    echo '<script>
    	function checkValues()
    	{
    		if(sbGetE("te_name").value == "")
    		{
    			alert("'.PL_EDITOR_TEMPLATES_EDIT_NO_NAME_MSG.'");
    			return false;
    		}
    	}';

    if ($htmlStr != '')
	{
	    echo '
            function cancel()
            {
                var res = new Object();
		        res.html = "'.$htmlStr.'";
		        res.footer = "'.$footerStr.'";
		        res.footer_link = "'.$footerLinkStr.'";
				sbReturnValue(res);
            }
            sbAddEvent(window, "close", cancel);';
	}

	echo '</script><br /><br />';

    // создаем главный диалог
    $layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE . '?event=pl_editor_templates_edit_submit'.($_SERVER['QUERY_STRING'] != '' ? '&'.$_SERVER['QUERY_STRING'] : ''), 'thisDialog', 'post', 'checkValues()', '', 'enctype="multipart/form-data"');
    $layout->mTableWidth = '95%';

    $layout->addHeader($_GET['id'] != '' ? PL_EDITOR_TEMPLATES_EDIT_EDIT : PL_EDITOR_TEMPLATES_EDIT_ADD);

    // поле для ввода названия
    $layout->addField(PL_EDITOR_TEMPLATES_EDIT_TITLE, new sbLayoutInput('text', $te_name, 'te_name', '', 'style="width:97%;"', true));

    // поле для ввода описания
    $layout->addField(PL_EDITOR_TEMPLATES_EDIT_DESC, new sbLayoutTextarea($te_desc, 'te_desc', '', 'style="width:99%;height:50px;"'));

    // поле для выбора изображения
    $file = new sbLayoutImage($te_img, 'te_img', '', 'size="67"');
    $file->mLocal = true;
    $file->mShow = false;
    $layout->addField(PL_EDITOR_TEMPLATES_EDIT_IMG, $file);

    // поле для ввода HTML кода
    $fldHTML = new sbLayoutTextarea($te_code, 'te_code', '', 'style="width:99%;height:150px;"');

    // проверка на использование PHP кода
    $use_php = (sb_stripos($te_code, '<?') !== false && sb_stripos($te_code, '?>') !== false);
    if ($use_php)
    {
        sb_show_message(PL_EDITOR_TEMPLATES_EDIT_PHP_MSG);
    }
    else
    {
        $fldHTML->mShowEditorBtn = true;
    }

    $layout->addField(PL_EDITOR_TEMPLATES_EDIT_SORT, new sbLayoutInput('text', $te_sort, 'te_sort', 'spin_te_sort', 'style="width:50px;"'));
    $layout->addField('', new sbLayoutDelim());
    $layout->addField(PL_EDITOR_TEMPLATES_EDIT_HTML, $fldHTML);

    // кнопка "Сохранить"
    $layout->addButton('submit', KERNEL_SAVE, 'btn_save', '', ($_SESSION['sbPlugins']->isRightAvailable('pl_editor', 'elems_edit') ? '' : 'disabled="disabled"'));

    // кнопка "Применить"
    if ($_GET['id'] != '')
        $layout->addButton('submit', KERNEL_APPLY, 'btn_apply', '', ($_SESSION['sbPlugins']->isRightAvailable('pl_editor', 'elems_edit') ? '' : 'disabled="disabled"'));

    // кнопка "Отменить"
    $layout->addButton('button', KERNEL_CANCEL, '', '', $htmlStr != '' ? 'onclick="cancel()"' : 'onclick="sbCloseDialog()"');

    $layout->show();
}

function fEditor_Templates_Edit_Submit()
{
	// проверка прав доступа
	if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'], 'pl_editor_templates'))
		return;

    if (!isset($_GET['id']))
        $te_id = '';
	else
		$te_id = intval($_GET['id']);

    $te_img_delete = 0;

    extract($_POST);

    if ($te_name == '')
    {
        sb_show_message(PL_EDITOR_TEMPLATES_EDIT_NO_NAME_MSG, false, 'warning');
        fEditor_Templates_Edit();
        return;
    }

    $te_name = strip_tags($te_name);

    //  получить старое изображение
    $te_img = '';
    $result = sql_query('SELECT te_img FROM sb_editor_templates WHERE te_id = ?d', $te_id);
	if($result)
    {
        list($te_img) = $result[0];
    }

	// удалить старый файл изображения ?
	if($te_img_delete == 1 || ($te_img != '' && isset($_FILES['te_img']['name']) && $_FILES['te_img']['name'] != ''))
    {
    	$te_img = SB_CMS_EDITOR_URL.'/templates/'.$te_img;
        if($GLOBALS['sbVfs']->is_file($te_img))
        {
            $GLOBALS['sbVfs']->delete($te_img);
        }

        $te_img = '';
    }

	if(isset($_FILES['te_img']['name']) && $_FILES['te_img']['name'] != '' && is_uploaded_file($_FILES['te_img']['tmp_name']))
	{
		require_once(SB_CMS_LIB_PATH.'/sbUploader.inc.php');

		// Настраиваем Аплоадер
		$uploader = new sbUploader();
        if(!$uploader->upload('te_img', array('jpg', 'png', 'gif', 'bmp')))
        {
	    	sb_show_message($uploader->getError(), false, 'warning');
		    fEditor_Templates_Edit();
		    return;
        }

        // копируем выбранное локальное изображение в папку с изображениями шаблонов
	    $te_img = basename($uploader->move(SB_CMS_EDITOR_URL.'/templates', $_FILES['te_img']['name'], 2));
	    if(!$te_img)
    	{
	    	sb_show_message($uploader->getError(), false, 'warning');
		    fEditor_Templates_Edit();
		    return;
    	}
	}

	$row = array();
    $row['te_name'] = $te_name;
    $row['te_code'] = $te_code;
    $row['te_desc'] = $te_desc;
    $row['te_img'] = $te_img;
    $row['te_sort'] = $te_sort;

    $_POST['te_img'] = $te_img;

    // шаблон уже есть ? модифицируем
    if ($te_id != '')
    {
        // проверяем шаблон с таким ID уже существует ?
        $res = sql_query('SELECT te_name FROM sb_editor_templates WHERE te_id = ?d', $te_id);
        if($res)
        {
        	list($old_name) = $res[0];

            // да, такой уже есть
            sql_query('UPDATE sb_editor_templates SET ?a WHERE te_id = ?d', $row, $te_id, sprintf(PL_EDITOR_TEMPLATES_EDIT_EDIT_OK, $old_name));

            $footer_ar = fCategs_Edit_Elem();

    	    if (!$footer_ar)
    	    {
    	        sb_show_message(PL_EDITOR_TEMPLATES_EDIT_EDIT_ERROR, false, 'warning');
                sb_add_system_message(sprintf(PL_EDITOR_TEMPLATES_EDIT_EDIT_SYSTEMLOG_ERROR, $old_name), SB_MSG_WARNING);

                fEditor_Templates_Edit();
    		    return;
    	    }

    	    $footer_str = $GLOBALS['sbSql']->escape($footer_ar[0], false, false);
    	    $footer_link_str = $GLOBALS['sbSql']->escape($footer_ar[1], false, false);

            $row['te_id'] = $te_id;

        	$html_str = fEditor_Templates_Get($row);
    	    $html_str = sb_str_replace(array("\r\n", "\r", "\n"), '', $html_str);
            $html_str = $GLOBALS['sbSql']->escape($html_str, false, false);

    	    if (!isset($_POST['btn_apply']))
    	    {
        	    echo '<script>
        		        var res = new Object();
        		        res.html = "'.$html_str.'";
        		        res.footer = "'.$footer_str.'";
        		        res.footer_link = "'.$footer_link_str.'";
        				sbReturnValue(res);
        			  </script>';
    	    }
    	    else
    	    {
    	        fEditor_Templates_Edit($html_str, $footer_str, $footer_link_str);
    	    }
        }
        else
        {
            sb_show_message(PL_EDITOR_TEMPLATES_EDIT_EDIT_ERROR, false, 'warning');
            sb_add_system_message(sprintf(PL_EDITOR_TEMPLATES_EDIT_EDIT_SYSTEMLOG_ERROR, $te_name), SB_MSG_WARNING);

            fEditor_Templates_Edit();
            return;
        }
    }
    else
    {
    	$error = true;
        // добавляем новый
        if (sql_query('INSERT INTO sb_editor_templates (?#) VALUES (?a)', array_keys($row), array_values($row)))
        {
            $te_id = sql_insert_id();

        	if (fCategs_Add_Elem($te_id))
    		{
        		sb_add_system_message(sprintf(PL_EDITOR_TEMPLATES_EDIT_ADD_OK, $te_name));

        		echo '<script>
        				sbReturnValue('.$te_id.');
        			  </script>';

        		$error = false;
    		}
    		else
    		{
    		    sql_query('DELETE FROM sb_editor_templates WHERE te_id=?d', $te_id);
    		}
        }

    	if ($error)
	    {
	        sb_show_message(PL_EDITOR_TEMPLATES_EDIT_ADD_ERROR, false, 'warning');
            sb_add_system_message(sprintf(PL_EDITOR_TEMPLATES_EDIT_ADD_SYSTEMLOG_ERROR, $te_name), SB_MSG_WARNING);

            fEditor_Templates_Edit();
		    return;
	    }
    }
}

function fEditor_Templates_Delete ()
{
    $result = sql_query('SELECT te_img FROM sb_editor_templates WHERE te_id = ?d', $_GET['id']);
    if($result)
    {
        list($te_img) = $result[0];

	    if ($te_img != '')
        {
            $te_img = SB_CMS_EDITOR_URL . '/templates/' . $te_img;
            if($GLOBALS['sbVfs']->is_file($te_img))
            {
                $GLOBALS['sbVfs']->delete($te_img);
            }
        }
    }
}

function fEditor_Templates_Paste()
{
	if ($_GET['action'] != 'copy')
		return;

	if (!isset($_GET['e']) || !is_array($_GET['e']) || count($_GET['e']) <= 0 || !isset($_GET['ne']) || !is_array($_GET['ne']) || count($_GET['ne']) <= 0)
        return;

    require_once(SB_CMS_LIB_PATH.'/sbUploader.inc.php');
    $uploader = new sbUploader();

    foreach ($_GET['e'] as $key => $value)
    {
    	$res = sql_query('SELECT te_img FROM sb_editor_templates WHERE te_id = ?d', $value);
    	if ($res && $res[0][0] != '' && $GLOBALS['sbVfs']->is_file(SB_CMS_EDITOR_URL.'/templates/'.$res[0][0]))
    	{
    		$uploader->mFile['tmp_name'] = SB_CMS_EDITOR_URL.'/templates/'.$res[0][0];
    		$te_img = basename($uploader->copy(SB_CMS_EDITOR_URL.'/templates', $res[0][0], 2));
	    	if(!$te_img)
	    	{
		    	echo $uploader->getError();
			    return;
	    	}

	    	sql_query('UPDATE sb_editor_templates SET te_img=? WHERE te_id=?d', $te_img, $_GET['ne'][$key]);
    	}
    }
}

function fEditor_Styles_Create_System_Cats()
{
    require_once(SB_CMS_LIB_PATH.'/sbTree.inc.php');
    $tree = new sbTree('pl_editor_styles');

    $res = sql_query('SELECT cat_id FROM sb_categs WHERE cat_ident=? AND cat_level=0', 'pl_editor_styles');
    if (!$res)
    {
        // создаем корневой раздел
        $fields = array();
        $fields['cat_title'] = PL_EDITOR_STYLES_ROOT_NAME;
        $fields['cat_closed'] = 0;
        $fields['cat_rubrik'] = 0;
        $fields['cat_rights'] = $_SESSION['sbAuth']->isAdmin() ? '' : 'u'.$_SESSION['sbAuth']->getUserId();

        $root_id = $tree->insertNode(0, $fields);

        if (!$root_id)
            return false;
    }
    else
    {
        $root_id = $res[0][0];
    }

    $result = array($root_id);

    // проверяем, есть ли разделы для доменов
    foreach ($GLOBALS['sb_domains'] as $domain => $value)
    {
        $res = sql_query('SELECT cat_id FROM sb_categs WHERE cat_ident=? AND cat_level=1 AND cat_title=?', 'pl_editor_styles', $domain);

        if (!$res)
        {
            $fields['cat_closed'] = 0;
            $fields['cat_rubrik'] = 0;
            $fields['cat_title'] = $domain;
            $fields['cat_rights'] = $_SESSION['sbAuth']->isAdmin() ? '' : 'u'.$_SESSION['sbAuth']->getUserId();

            if (!$cat_id = $tree->insertNode($root_id, $fields))
                return false;
        }
    }

    return $result;
}

function fEditor_Styles_Get($args)
{
	$result = '<b><a href="javascript:void(0);" onclick="sbElemsEdit(event);">'.$args['se_name'].'</a></b>
    <div class="smalltext" style="margin-top: 7px;">'.
	PL_EDITOR_STYLES_EDIT_ELEMENT.': <span style="color: green;">'.sb_strtoupper($args['se_tag']).'</span><br />'.
	PL_EDITOR_STYLES_EDIT_SORT.': <span style="color: green;">'.$args['se_sort'].'</span>
	</div>';

	return $result;
}

function fEditor_Styles_Init()
{
	$never_show_cats = fEditor_Styles_Create_System_Cats();
    if (!$never_show_cats)
    {
        sb_show_message(PL_EDITOR_TEMPLATES_CREATE_CATEGS_ERROR, true, 'warning');
        return;
    }

    require_once(SB_CMS_LIB_PATH.'/sbElements.inc.php');

    $elems = new sbElements('sb_editor_styles', 'se_id', 'se_name', 'fEditor_Styles_Get', 'pl_editor_styles_init', 'pl_editor_styles');

    $elems->mCategsRootName = PL_EDITOR_STYLES_ROOT_NAME;
    $elems->mElemsIcon = SB_CMS_IMG_URL.'/plugins/pl_editor_styles_32.png';

    $elems->addField('se_tag');
	$elems->addField('se_sort');

    $elems->addFilter(PL_EDITOR_STYLES_EDIT_TITLE, 'se_name', 'string');
    $elems->addFilter(PL_EDITOR_STYLES_EDIT_ELEMENT, 'se_tag', 'string');
    $elems->addFilter(PL_EDITOR_STYLES_EDIT_SORT, 'se_sort', 'number');

    $elems->addSorting(PL_EDITOR_STYLES_SORT_BY_NAME, 'se_name');
    $elems->addSorting(PL_EDITOR_STYLES_SORT_BY_SORT, 'se_sort');
    $elems->addSorting(PL_EDITOR_STYLES_SORT_BY_TAG, 'se_tag');

    $elems->mCategsPasteElemsMenuTitle = PL_EDITOR_STYLES_PASTE_ELEMS_MENU_TITLE;
    $elems->mCategsPasteLinksMenuTitle = PL_EDITOR_STYLES_PASTE_LINKS_MENU_TITLE;

    $elems->mElemsAddMenuTitle  = PL_EDITOR_STYLES_ADD_MENU_TITLE;
    $elems->mElemsEditMenuTitle = PL_EDITOR_STYLES_EDIT_MENU_TITLE;
    $elems->mElemsCopyMenuTitle = PL_EDITOR_STYLES_COPY_MENU_TITLE;
    $elems->mElemsCutMenuTitle  = PL_EDITOR_STYLES_CUT_MENU_TITLE;

    $elems->mElemsEditEvent = 'pl_editor_styles_edit';
    $elems->mElemsEditDlgWidth = '800';
	$elems->mElemsEditDlgHeight = '600';

	$elems->mElemsAddEvent = 'pl_editor_styles_edit';
    $elems->mElemsAddDlgWidth = '800';
	$elems->mElemsAddDlgHeight = '600';

    $elems->mCategsClosed = false;
	$elems->mCategsRubrikator = false;
	$elems->mCategsNeverShowCats = $never_show_cats;

	$elems->mCategsAddMenu = false;
	$elems->mCategsEditMenu = false;
	$elems->mCategsCopyMenu = false;
	$elems->mCategsCutMenu = false;
	$elems->mCategsDad = false;
	$elems->mCategsDeleteMenu = false;
	$elems->mCategsPasteCategsMenu = false;

	$elems->mCategsPasteElemsMenuLevel = 2;
	$elems->mElemsAddMenuLevel = 2;
	$elems->mElemsUseLinks = true;

    $elems->init();
}

function fEditor_Styles_Edit($htmlStr = '', $footerStr = '', $footerLinkStr = '')
{
	// проверка прав доступа
	if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'], 'pl_editor_styles'))
		return;

    require_once (SB_CMS_LIB_PATH . '/sbLayout.inc.php');

    if (count($_POST) == 0 && isset($_GET['id']) && $_GET['id'] != '')
    {
        $result = sql_query('SELECT se_name, se_tag, se_sort, se_attrs FROM sb_editor_styles WHERE se_id = ?d', $_GET['id']);
        if ($result)
        {
            list ($se_name, $se_tag, $se_sort, $se_attrs) = $result[0];

            if (trim($se_attrs) != '')
            	$se_attrs = unserialize($se_attrs);
            else
            	$se_attrs = array();
        }
        else
        {
            sb_show_message(PL_EDITOR_EDIT_ERROR, true, 'warning');
            return;
        }
    }
    elseif (count($_POST) > 0)
    {
    	extract($_POST);
        if (!isset($_GET['id']))
            $_GET['id'] = '';
    }
    else
    {
        $se_name = $se_tag = '';
        $res = sql_query('SELECT MAX(se_sort) FROM sb_editor_styles');
	    if ($res)
	    {
	        list($max) = $res[0];
	    }
	    else
	    {
	        $max = 0;
	    }
	    $se_sort = $max + 5;
	    $se_attrs = array();
        $_GET['id'] = '';
    }

    echo '<script>
    	function checkValues()
    	{
    		if(sbGetE("se_name").value == "")
    		{
    			alert("'.PL_EDITOR_STYLES_EDIT_NO_NAME_MSG.'");
    			return false;
    		}

    		if(sbGetE("se_tag").value == "")
    		{
    			alert("'.PL_EDITOR_STYLES_EDIT_NO_TAG_MSG.'");
    			return false;
    		}
    	}

        function addAttr()
        {
            num_attrs++;
            var el = sbGetE("span_attrs");

            var oDiv = document.createElement("DIV");
            oDiv.className = "delim";

            var oSelect = document.createElement("SELECT");
            oSelect.name = "se_attrs[" + num_attrs + "][type]";
			oSelect.style.margin = "2px";

			var oOption = document.createElement("OPTION");
	        oSelect.appendChild(oOption);
            oOption.value = "Attribute";
	        oOption.innerHTML = "'.PL_EDITOR_STYLES_EDIT_ATTRS_TYPE_ATTR.'";

	        var oOption = document.createElement("OPTION");
	        oSelect.appendChild(oOption);
            oOption.value = "Style";
	        oOption.innerHTML = "'.PL_EDITOR_STYLES_EDIT_ATTRS_TYPE_STYLE.'";

	        var oNameText = document.createTextNode(" '.PL_EDITOR_STYLES_EDIT_ATTRS_NAME_TEXT.': ");

	        var oNameInput = document.createElement("INPUT");
	        oNameInput.type = "text";
	        oNameInput.name = "se_attrs[" + num_attrs + "][name]";
	        oNameInput.style.margin = "2px";
	        oNameInput.size = 20;
	        oNameInput.value = "";

	        var oValueText = document.createTextNode(" '.PL_EDITOR_STYLES_EDIT_ATTRS_VALUE_TEXT.': ");

	        var oValueInput = document.createElement("INPUT");
	        oValueInput.type = "text";
	        oValueInput.name = "se_attrs[" + num_attrs + "][value]";
	        oValueInput.style.margin = "2px";
	        oValueInput.size = 20;
	        oValueInput.value = "";

            el.appendChild(oDiv);
            el.appendChild(oSelect);
            el.appendChild(oNameText);
            el.appendChild(oNameInput);
            el.appendChild(oValueText);
            el.appendChild(oValueInput);
        }
	   ';

    if ($htmlStr != '')
	{
	    echo '
            function cancel()
            {
                var res = new Object();
		        res.html = "'.$htmlStr.'";
		        res.footer = "'.$footerStr.'";
		        res.footer_link = "'.$footerLinkStr.'";
				sbReturnValue(res);
            }
            sbAddEvent(window, "close", cancel);';
	}

	echo '</script><br /><br />';

    // создаем главный диалог
    $layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE . '?event=pl_editor_styles_edit_submit'.($_SERVER['QUERY_STRING'] != '' ? '&'.$_SERVER['QUERY_STRING'] : ''), 'thisDialog', 'post', 'checkValues()');
    $layout->mTableWidth = '95%';

    $layout->addHeader($_GET['id'] != '' ? PL_EDITOR_STYLES_EDIT_EDIT : PL_EDITOR_STYLES_EDIT_ADD);

    $layout->addField(PL_EDITOR_STYLES_EDIT_TITLE, new sbLayoutInput('text', $se_name, 'se_name', '', 'style="width:97%;"', true));

    $fld = new sbLayoutInput('text', $se_tag, 'se_tag', '', 'size="35" maxlength="35"', true);
    $fld->mHTML = '<div class="hint_div" style="margin-top: 5px;">'.PL_EDITOR_STYLES_EDIT_ELEMENT_HINT.'</div>';;
    $layout->addField(PL_EDITOR_STYLES_EDIT_ELEMENT, $fld);

    $layout->addField(PL_EDITOR_STYLES_EDIT_SORT, new sbLayoutInput('text', $se_sort, 'se_sort', 'spin_se_sort', 'style="width:50px;"'));

    $layout->addField('', new sbLayoutDelim());

    $attrs = '';
    if (count($se_attrs) > 0)
    {
    	$i = 0;
    	foreach($se_attrs as $value)
    	{
    		if (trim($value['name']) == '' || trim($value['value']) == '')
    			continue;

    		if ($i > 0)
    		{
    			$attrs .= '<div class="delim"></div>';
    		}

    		$attrs .= '<select name="se_attrs['.$i.'][type]" style="margin:2px;">
		    <option value="Attribute"'.($value['type'] == 'Attribute' ? ' selected="selected"' : '').'>'.PL_EDITOR_STYLES_EDIT_ATTRS_TYPE_ATTR.'</option>
		    <option value="Style"'.($value['type'] == 'Style' ? ' selected="selected"' : '').'>'.PL_EDITOR_STYLES_EDIT_ATTRS_TYPE_STYLE.'</option>
		    </select>
		     '.PL_EDITOR_STYLES_EDIT_ATTRS_NAME_TEXT.':
		    <input type="text" name="se_attrs['.$i.'][name]" style="margin:2px;" size="20" value="'.$value['name'].'" />
		     '.PL_EDITOR_STYLES_EDIT_ATTRS_VALUE_TEXT.':
		    <input type="text" name="se_attrs['.$i.'][value]" style="margin:2px;" size="20" value="'.$value['value'].'" />';

    		if ($i == 0)
    		{
		    	$attrs .= '&nbsp;&nbsp;<img class="button" onmouseup="sbPress(this, false)" onmousedown="sbPress(this, true);addAttr();" align="top" src="'.SB_CMS_IMG_URL.'/btn_add.png" width="20" height="20" />';
    		}

    		$i++;
    	}

    	echo '<script>var num_attrs = '.$i.';</script>';
    }

    if ($attrs == '')
    {
    	$attrs = '<select name="se_attrs[0][type]" style="margin:2px;">
		    <option value="Attribute">'.PL_EDITOR_STYLES_EDIT_ATTRS_TYPE_ATTR.'</option>
		    <option value="Style">'.PL_EDITOR_STYLES_EDIT_ATTRS_TYPE_STYLE.'</option>
		    </select>
		     '.PL_EDITOR_STYLES_EDIT_ATTRS_NAME_TEXT.':
		    <input type="text" name="se_attrs[0][name]" style="margin:2px;" size="20" value="" />
		     '.PL_EDITOR_STYLES_EDIT_ATTRS_VALUE_TEXT.':
		    <input type="text" name="se_attrs[0][value]" style="margin:2px;" size="20" value="" />
		    &nbsp;&nbsp;<img class="button" onmouseup="sbPress(this, false)" onmousedown="sbPress(this, true);addAttr();" align="top" src="'.SB_CMS_IMG_URL.'/btn_add.png" width="20" height="20" />';

    	echo '<script>var num_attrs = 0;</script>';
    }

    $fld = new sbLayoutHTML('<div id="span_attrs">'.$attrs.'</div>');
    $layout->addField(PL_EDITOR_STYLES_EDIT_ATTRS, $fld);

    // кнопка "Сохранить"
    $layout->addButton('submit', KERNEL_SAVE, 'btn_save', '', ($_SESSION['sbPlugins']->isRightAvailable('pl_editor', 'elems_edit') ? '' : 'disabled="disabled"'));

    // кнопка "Применить"
    if ($_GET['id'] != '')
        $layout->addButton('submit', KERNEL_APPLY, 'btn_apply', '', ($_SESSION['sbPlugins']->isRightAvailable('pl_editor', 'elems_edit') ? '' : 'disabled="disabled"'));

    // кнопка "Отменить"
    $layout->addButton('button', KERNEL_CANCEL, '', '', $htmlStr != '' ? 'onclick="cancel()"' : 'onclick="sbCloseDialog()"');

    $layout->show();
}

function fEditor_Styles_Edit_Submit()
{
	// проверка прав доступа
	if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'], 'pl_editor_styles'))
		return;

	if (!isset($_GET['id']))
        $se_id = '';
	else
		$se_id = intval($_GET['id']);

    extract($_POST);

    $se_name = trim(strip_tags($se_name));

    if ($se_name == '')
    {
        sb_show_message(PL_EDITOR_STYLES_EDIT_NO_NAME_MSG, false, 'warning');
        fEditor_Styles_Edit();
        return;
    }

    $_POST['se_name'] = $se_name;

    $se_tag = preg_replace('/[^a-zA-Z]+/', '', $se_tag);

	if ($se_tag == '')
    {
        sb_show_message(PL_EDITOR_STYLES_EDIT_NO_TAG_MSG, false, 'warning');
        fEditor_Styles_Edit();
        return;
    }

    $_POST['se_tag'] = $se_tag;

	$row = array();
    $row['se_name'] = $se_name;
    $row['se_tag'] = $se_tag;
    $row['se_sort'] = $se_sort;
    $row['se_attrs'] = serialize($se_attrs);

    // шаблон уже есть ? модифицируем
    if ($se_id != '')
    {
        // проверяем шаблон с таким ID уже существует ?
        $res = sql_query('SELECT se_name FROM sb_editor_styles WHERE se_id = ?d', $se_id);
        if($res)
        {
        	list($old_name) = $res[0];

            // да, такой уже есть
            sql_query('UPDATE sb_editor_styles SET ?a WHERE se_id = ?d', $row, $se_id, sprintf(PL_EDITOR_STYLES_EDIT_EDIT_OK, $old_name));

            $footer_ar = fCategs_Edit_Elem();

    	    if (!$footer_ar)
    	    {
    	        sb_show_message(PL_EDITOR_STYLES_EDIT_EDIT_ERROR, false, 'warning');
                sb_add_system_message(sprintf(PL_EDITOR_STYLES_EDIT_EDIT_SYSTEMLOG_ERROR, $old_name), SB_MSG_WARNING);

                fEditor_Styles_Edit();
    		    return;
    	    }

    	    $footer_str = $GLOBALS['sbSql']->escape($footer_ar[0], false, false);
    	    $footer_link_str = $GLOBALS['sbSql']->escape($footer_ar[1], false, false);

            $row['se_id'] = $se_id;

        	$html_str = fEditor_Styles_Get($row);
    	    $html_str = sb_str_replace(array("\r\n", "\r", "\n"), '', $html_str);
            $html_str = $GLOBALS['sbSql']->escape($html_str, false, false);

    	    if (!isset($_POST['btn_apply']))
    	    {
        	    echo '<script>
        		        var res = new Object();
        		        res.html = "'.$html_str.'";
        		        res.footer = "'.$footer_str.'";
        		        res.footer_link = "'.$footer_link_str.'";
        				sbReturnValue(res);
        			  </script>';
    	    }
    	    else
    	    {
    	        fEditor_Styles_Edit($html_str, $footer_str, $footer_link_str);
    	    }
        }
        else
        {
            sb_show_message(PL_EDITOR_STYLES_EDIT_EDIT_ERROR, false, 'warning');
            sb_add_system_message(sprintf(PL_EDITOR_STYLES_EDIT_EDIT_SYSTEMLOG_ERROR, $se_name), SB_MSG_WARNING);

            fEditor_Styles_Edit();
            return;
        }
    }
    else
    {
    	$error = true;
        // добавляем новый
        if (sql_query('INSERT INTO sb_editor_styles (?#) VALUES (?a)', array_keys($row), array_values($row)))
        {
            $se_id = sql_insert_id();

        	if (fCategs_Add_Elem($se_id))
    		{
        		sb_add_system_message(sprintf(PL_EDITOR_STYLES_EDIT_ADD_OK, $se_name));

        		echo '<script>
        				sbReturnValue('.$se_id.');
        			  </script>';

        		$error = false;
    		}
    		else
    		{
    		    sql_query('DELETE FROM sb_editor_styles WHERE se_id=?d', $se_id);
    		}
        }

    	if ($error)
	    {
	        sb_show_message(PL_EDITOR_STYLES_EDIT_ADD_ERROR, false, 'warning');
            sb_add_system_message(sprintf(PL_EDITOR_STYLES_EDIT_ADD_SYSTEMLOG_ERROR, $se_name), SB_MSG_WARNING);

            fEditor_Styles_Edit();
		    return;
	    }
    }
}
?>