<?php
require_once(SB_CMS_LANG_PATH . '/pl_external_script.h.lng.php');

function fExternal_Script_Init()
{
    $confirm_msg = PL_EXTERNAL_SCRIPT_CONFIRM_MSG;
    $delete_err_msg = PL_EXTERNAL_SCRIPT_DELETE_ERR_MSG;
    echo <<<EOF
        <script>
            function sbAddScript()
            {
                var strPage = sb_cms_modal_dialog_file + "?event=pl_external_script_edit";
                var strAttr = "resizable=1,width=850,height=700";
                sbShowModalDialog(strPage, strAttr, afterAddScript);
            }

            function afterAddScript()
            {
                if (sbModalDialog.returnValue)
                {
                    window.location.href = sb_cms_content_file+"?event=pl_external_script_init";
                }
            }

            function sbEditScript(id)
            {
                var strPage = sb_cms_modal_dialog_file + "?event=pl_external_script_edit&id="+id;
                var strAttr = "resizable=1,width=850,height=700";
                sbShowModalDialog(strPage, strAttr, afterAddScript);
            }

            function sbDeleteScript(id)
            {
                if(confirm("$confirm_msg"))
                {
                    var res = sbLoadSync(sb_cms_empty_file+"?event=pl_external_script_delete&id="+id);
                    if (res == "")
                    {
                        window.location.href = sb_cms_content_file+"?event=pl_external_script_init";
                    }
                    else
                    {
                        alert("$delete_err_msg");
                    }
                }
            }
        </script>
EOF;
    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
	$layout = new sbLayout();

    $t_head = array(PL_EXTERNAL_SCRIPT_TABLE_H_URL, PL_EXTERNAL_SCRIPT_TABLE_H_DATE, PL_EXTERNAL_SCRIPT_TABLE_H_ACTION);

    $t_value = array();

    $t_action = $_SESSION['sbPlugins']->isRightAvailable('pl_external_script', 'elems_edit')?
            '<img height="20" width="20" style="cursor: pointer;" onClick = "sbEditScript(%id%);" title="'.KERNEL_EDIT.'" src="'.SB_CMS_IMG_URL.'/btn_props.png"/>':'';
    $t_action .= $_SESSION['sbPlugins']->isRightAvailable('pl_external_script', 'delete') ? '&nbsp;
			<img height="20" width="20" style="cursor: pointer;" onClick = "sbDeleteScript(%id%);" title="'.KERNEL_DELETE.'" src="'.SB_CMS_IMG_URL.'/btn_delete.png"/>' : '';

    $res = sql_param_assoc('SELECT * FROM sb_external_script');
    if ($res)
    {
        foreach ($res as $row)
        {
            $t_value[] = array(
            sb_wordwrap($row['es_url'], 100, '...', true),
                $row['es_date'] > 0 ? sb_date('d.m.Y H:i', $row['es_date']) : '-',
                sb_str_replace('%id%', $row['es_id'], $t_action)
            );
        }
    }
    else
    {
        $add = $_SESSION['sbPlugins']->isRightAvailable('pl_external_script', 'elems_edit') ? '<a href="#" onclick="sbAddScript();">'.KERNEL_ADD.'</a>' : '';
        sb_show_message(sprintf(PL_EXTERNAL_SCRIPT_NO_URLS_MSG, $add), true);
        return;
    }

    if(empty($t_value))
    {
        $t_value[] = array('', '', '');
    }

    $table = new sbLayoutTable($t_head, $t_value);
    $table->mShowTable = true;
    $table->mAlign = array('left', 'center', 'center');
    $table->mWidth = array('60%', '30%', '10%');
    $layout->addField('', $table);


    $layout->addButton('button', KERNEL_ADD, 'btn_save', '', ($_SESSION['sbPlugins']->isRightAvailable('pl_external_script', 'elems_edit') ? '' : 'disabled="disabled"').' onClick="sbAddScript();"' );

    echo '<center><div style="margin-top:10px; paddind: 5px; width: 70%">';
    $layout->show();
    echo '</div></center>';
}

function fExternal_Script_Edit()
{
    if(isset($_GET['id']) && intval($_GET['id']) > 0)
    {
        //редактирование
        $res = sql_param_assoc('SELECT * FROM sb_external_script WHERE es_id=?d', intval($_GET['id']));
        if($res)
        {
            $id = $res[0]['es_id'];
            $url = $res[0]['es_url'];
            $handler = $res[0]['es_handler'];
        }
        else
        {
            sb_show_message(PL_EXTERNAL_SCRIPT_NO_ELEM_ERROR, true, 'warning');
            return;
        }
    }
    else
    {
        //Новый адрес
        $id = '';
        $url = '';
        $handler = '';
    }

    $err_msg = PL_EXTERNAL_SCRIPT_URL_ERR_MSG;
    echo <<<EOF
        <script>
            function checkValues()
            {
                var url = sbGetE('es_url');
                url.value = url.value.replace(/^\s+/, '');
                if(url.value == '')
                {
                    alert('$err_msg');
                    return false;
                }
                return true;
            }
        </script><br/><br/>
EOF;
    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
	$layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE . "?event=pl_external_script_edit_submit", 'thisDialog', 'post');
    $layout->addHeader(PL_EXTERNAL_SCRIPT_EDIT);

    $fld = new sbLayoutInput('text', $url, 'es_url', 'es_url', 'style="width: 500px"', true);
    $layout->addField(PL_EXTERNAL_SCRIPT_FLD_URL, $fld);

    $layout->addField('', new sbLayoutDelim());

    $html = '<div class="hint_div">'.PL_EXTERNAL_SCRIPT_HANDLER_HINT.'</div>';
    $fld = new sbLayoutHTML($html);
    $layout->addField('', $fld);

    $fld = new sbLayoutTextarea($handler, 'es_handler');
    $fld->mCols = 106;
    $fld->mRows = 25;
    $layout->addField(PL_EXTERNAL_SCRIPT_FLD_HANDLER, $fld);

    $fld = new sbLayoutInput('hidden', $id, 'es_id');
    $layout->addField('', $fld);

    $layout->addButton('submit', KERNEL_SAVE, 'btn_save', '', ($_SESSION['sbPlugins']->isRightAvailable('pl_external_script', 'elems_edit') ? '' : 'disabled="disabled"'));
	$layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');

    $layout->show();
}

function fExternal_Script_Edit_Submit()
{
    if(!$_SESSION['sbPlugins']->isRightAvailable('pl_external_script', 'elems_edit'))
    {
        return;
    }

    if(isset($_POST['es_id']) && intval($_POST['es_id']) > 0)
    {
        $_GET['id'] = $_POST['es_id'];
    }

    if(!isset($_POST['es_url']) || trim($_POST['es_url']) == '')
    {
        sb_show_message(PL_EXTERNAL_SCRIPT_NO_ELEM_ERROR, true, 'warning');
        fExternal_Script_Edit();
        return;
    }

    $url = trim($_POST['es_url']);
    $handler = trim($_POST['es_handler']);
    $id = (isset($_POST['es_id']) && intval($_POST['es_id']) > 0)? intval($_POST['es_id']) : 0;

    $res = sql_param_query('SELECT es_id FROM sb_external_script WHERE es_url=?s', $url);
    if ($res && $res[0][0] != $id && $id > 0)
    {
        sb_show_message(PL_EXTERNAL_SCRIPT_DUPLICATE_URL_ERROR, false, 'warning');
        fExternal_Script_Edit();
        return;
    }

    if($id <= 0)
    {

        if(sql_query('INSERT INTO sb_external_script (es_url, es_date, es_handler) VALUES (?s, 0, ?s)', $url, $handler))
        {
            $id = sql_insert_id();
            sb_add_system_message(sprintf(PL_EXTERNAL_SCRIPT_ADD_SYS_MSG, $url));
            
            $count = 0;
			if (!isset($_SESSION['sbPlugins']->mCron['pl_external_script']))
        	{
				$_SESSION['sbPlugins']->mCron['pl_external_script'] = array();
			}
			else
			{
				$count = count($_SESSION['sbPlugins']->mCron['pl_external_script']);
			}

			$_SESSION['sbPlugins']->mCron['pl_external_script'][$count] = array();
			$_SESSION['sbPlugins']->mCron['pl_external_script'][$count]['task_path'] = 'pl_external_script/cron/pl_external_script.php';
        	$_SESSION['sbPlugins']->mCron['pl_external_script'][$count]['task_func'] = 'fExternal_Script_Cron_Refresh('.$id.')';
    	    $_SESSION['sbPlugins']->mCron['pl_external_script'][$count]['task_name'] = sprintf(PL_EXTERNAL_SCRIPT_H_CRON, sb_wordwrap($url, 20, '...', true));
	        $_SESSION['sbPlugins']->mCron['pl_external_script'][$count]['task_descr'] = PL_EXTERNAL_SCRIPT_DESC_CRON;
        }
    }
    else
    {
        $row = array(
            'es_url' => $url,
            'es_handler' => $handler
        );
        sql_param_query('UPDATE sb_external_script SET ?a WHERE es_id=?d', $row, $id, sprintf(PL_EXTERNAL_SCRIPT_EDIT_SYS_MSG, $url));

        foreach ($_SESSION['sbPlugins']->mCron['pl_external_script'] as $key => $value)
        {
            if ($value['task_func'] == 'fExternal_Script_Cron_Refresh(' . intval($_GET['id']) . ')')
            {
                $_SESSION['sbPlugins']->mCron['pl_external_script'][$key]['task_name'] = sprintf(PL_EXTERNAL_SCRIPT_H_CRON, sb_wordwrap($url, 20, '...', true));
                break;
            }
        }
    }
    echo '<script>sbReturnValue(true);</script>';
}

function fExternal_Script_Delete()
{
    if(!isset($_GET['id']) || intval($_GET['id']) == 0)
    {
        return '';
    }

    $res = sql_param_assoc('SELECT * FROM sb_external_script WHERE es_id=?d', intval($_GET['id']));
    if(!$res)
    {
        return '';
    }

    $id = $res[0]['es_id'];
    $url = $res[0]['es_url'];

    sql_param_query('DELETE FROM sb_external_script WHERE es_id=?d', intval($_GET['id']), sprintf(PL_EXTERNAL_SCRIPT_DELETE_SYS_MSG, $url));

    $count = -1;
	if(isset($_SESSION['sbPlugins']->mCron['pl_external_script']) && count($_SESSION['sbPlugins']->mCron['pl_external_script']) > 0)
	{
		foreach ($_SESSION['sbPlugins']->mCron['pl_external_script'] as $key => $value)
		{
			if ($value['task_func'] == 'fExternal_Script_Cron_Refresh('.$id.')')
			{
				$count = $key;
				break;
			}
		}
	}

	if ($count == 0 && count($_SESSION['sbPlugins']->mCron['pl_external_script']) == 1)
    {
    	$_SESSION['sbPlugins']->mCron['pl_external_script'] = array();
    }
    elseif ($count >= 0)
    {
		$tmp = array();
		$j = 0;
    	for ($i = 0; $i < count($_SESSION['sbPlugins']->mCron['pl_external_script']); $i++)
    	{
			if ($i == $count)
				continue;

    		$tmp[$j] = array();
    		$tmp[$j]['task_path'] = $_SESSION['sbPlugins']->mCron['pl_external_script'][$i]['task_path'];
		    $tmp[$j]['task_func'] = $_SESSION['sbPlugins']->mCron['pl_external_script'][$i]['task_func'];
		    $tmp[$j]['task_name'] = $_SESSION['sbPlugins']->mCron['pl_external_script'][$i]['task_name'];
		    $tmp[$j]['task_descr'] = $_SESSION['sbPlugins']->mCron['pl_external_script'][$i]['task_descr'];
		    $j++;
		}
		$_SESSION['sbPlugins']->mCron['pl_external_script'] = $tmp;
    }

	if(count($_SESSION['sbPlugins']->mCron['pl_external_script']) == 0)
	{
		unset($_SESSION['sbPlugins']->mCron['pl_external_script']);
	}
}
?>
