<?php
require_once(SB_CMS_LANG_PATH.'/pl_maillist.h.lng.php');

if ($_SESSION['sbPlugins']->register('pl_maillist', PL_MAILLIST_H_PLUGIN_NAME, 'http://www.sbuilder.ru/docs/helps/maillist.pdf'))
{
    $_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_USER.'>'.PL_MAILLIST_H_SUB_MENU.'>'.PL_MAILLIST_H_PLUGIN_NAME, 'init');
    $_SESSION['sbPlugins']->addToExportImport(true, false);
    
    if ($_SESSION['sbPlugins']->isRightAvailable('pl_maillist', 'design_read'))
    {
		$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_MAILLIST_H_PLUGIN_NAME.'>'.PL_MAILLIST_H_ELEM_LIST , 'design_list', 'pl_maillist_design_list_24.png');
	}

	$_SESSION['sbPlugins']->setMainEvent('init');

    $_SESSION['sbPlugins']->addUserEvent('init', 'fMaillist_Init', 'read', PL_MAILLIST_H_PLUGIN_NAME);
    $_SESSION['sbPlugins']->addUserEvent('edit','fMaillist_Edit','read',PL_MAILLIST_H_PLUGIN_NAME);
    $_SESSION['sbPlugins']->addUserEvent('edit_submit','fMaillist_Edit_Submit','elems_edit',PL_MAILLIST_H_PLUGIN_NAME);
    $_SESSION['sbPlugins']->addUserEvent('cat_edit','fMaillist_Cat_Edit','categ_write',PL_MAILLIST_H_PLUGIN_NAME);
    $_SESSION['sbPlugins']->addUserEvent('cat_edit_submit','fMaillist_Cat_Edit_Submit','categ_write',PL_MAILLIST_H_PLUGIN_NAME);
    $_SESSION['sbPlugins']->addUserEvent('set_active','fMaillist_Set_Active','elems_edit');
	$_SESSION['sbPlugins']->addUserEvent('delete','fMaillist_Delete','elems_edit');
	$_SESSION['sbPlugins']->addUserEvent('delete_cat_with_elements','fMaillist_Delete_With_Elements','elems_edit');
	$_SESSION['sbPlugins']->addUserEvent('after_paste', 'fMaillist_After_Paste', 'elems_edit');
	$_SESSION['sbPlugins']->addUserEvent('after_paste_with_elements', 'fMaillist_After_Paste_Categs_With_Elements', 'categs_edit|elems_edit');
	
    $_SESSION['sbPlugins']->addUserEvent('design_list','fMaillist_Design_List_Init','design_read', PL_MAILLIST_H_DESIGN_LIST_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('design_list_edit','fMaillist_Design_List_Edit','design_read', PL_MAILLIST_H_DESIGN_EDIT_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('design_list_edit_submit','fMaillist_Design_List_Edit_Submit','design_edit', PL_MAILLIST_H_DESIGN_EDIT_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('design_list_delete','fMaillist_Design_List_Delete','design_edit', PL_MAILLIST_H_DESIGN_EDIT_TITLE);

    $_SESSION['sbPlugins']->addUserEvent('send','fMaillist_Send','maillist_send',PL_MAILLIST_H_PLUGIN_NAME);
    $_SESSION['sbPlugins']->addUserEvent('send_submit','fMaillist_Send_Submit','maillist_send',PL_MAILLIST_H_PLUGIN_NAME);
    $_SESSION['sbPlugins']->addUserEvent('all_users','fMaillist_All_Users','maillist_send');
    $_SESSION['sbPlugins']->addUserEvent('select_user','fMaillist_Select_User','maillist_send',PL_MAILLIST_H_PLUGIN_NAME);

	$_SESSION['sbPlugins']->addToConstructor('sb_maillist');
	$_SESSION['sbPlugins']->addToWorkflow();


	$_SESSION['sbPlugins']->addToCron('pl_maillist/cron/pl_maillist.php', 'fMaillist_Cron()', PL_MAILLIST_H_CRON_SEND_NEWS, PL_MAILLIST_H_CRON_SEND_NEWS_DESCR);

	$res = sql_query('SELECT m_id, m_name FROM sb_maillist WHERE m_use_default=1');
	if($res)
	{
		foreach($res as $key => $value)
		{
			$_SESSION['sbPlugins']->addToCron('pl_maillist/cron/pl_maillist.php', 'fMaillist_Cron('.$value[0].')', $value[1], sprintf(PL_MAILLIST_H_SUBMIT_CRON_DESCRIPTION, $value[1]));
		}
	}

	$fields = array();
	$fields['m_id'] = array('title' => PL_MAILLIST_H_ID_LABEL, 'flags' => '8');
	$fields['m_name'] = array('title' => PL_MAILLIST_H_NAME_LABEL, 'flags' => '4');
	$fields['m_active'] = array('title' => PL_MAILLIST_H_ACTIVE_LABEL, 'flags' => '8');
	$fields['m_pub_start'] = array('title' => PL_MAILLIST_H_PUB_START_LABEL, 'flags' => '9');
	$fields['m_pub_end'] = array('title' => PL_MAILLIST_H_PUB_END_LABEL, 'flags' => '9');
	$fields['m_conf_format'] = array('title' => PL_MAILLIST_H_FORMAT_LABEL, 'flags' => '17');
	$fields['m_conf_email'] = array('title' => PL_MAILLIST_H_EMAIL_LABEL, 'flags' => '4');
	$fields['m_conf_charset'] = array('title' => PL_MAILLIST_H_CHARSET_LABEL, 'flags' => '4');
	$fields['m_conf_images_attach'] = array('title' => PL_MAILLIST_H_IM_ATTACH_LABEL, 'flags' => '8');
	$fields['m_conf_signed'] = array('title' => PL_MAILLIST_H_SIGNED_LABEL, 'flags' => '5');
	$fields['m_unsub_page'] = array('title' => PL_MAILLIST_H_PAGE_LABEL, 'flags' => '4');
	$fields['m_mail_description'] = array('title' => PL_MAILLIST_H_DESC_LABEL, 'flags' => '5');
	$fields['m_news_temp_id'] = array('title' => PL_MAILLIST_H_NEWS_TEMP_ID_LABEL, 'flags' => '8');
	$fields['m_mail_designs'] = array('title' => PL_MAILLIST_H_MAIL_DESIGN_LABEL, 'flags' => '5');
	$fields['m_use_default'] = array('title' => PL_MAILLIST_H_USE_DEFAULT_LABEL, 'flags' => '8');
	$fields['m_ext_id'] = array('title' => PL_MAILLIST_H_EXT_ID, 'flags' => '8');

	$cat_fields = array();
	$cat_fields['cat_maillist_description'] = array('title' => PL_MAILLIST_H_CAT_DESCR_LABEL, 'flags' => '5');
	$cat_fields['m_conf_format'] = array('title' => PL_MAILLIST_H_FORMAT_LABEL, 'flags' => '17');
	$cat_fields['m_conf_email'] = array('title' => PL_MAILLIST_H_EMAIL_LABEL, 'flags' => '4');
	$cat_fields['m_conf_charset'] = array('title' => PL_MAILLIST_H_CHARSET_LABEL, 'flags' => '4');
	$cat_fields['m_conf_images_attach'] = array('title' => PL_MAILLIST_H_IM_ATTACH_LABEL, 'flags' => '8');
	$cat_fields['m_unsub_page'] = array('title' => PL_MAILLIST_H_PAGE_LABEL, 'flags' => '4');
	$cat_fields['m_conf_signed'] = array('title' => PL_MAILLIST_H_SIGNED_LABEL, 'flags' => '5');

	$_SESSION['sbPlugins']->addFieldsInfo('sb_maillist', 'm_id', 'm_name', $fields, $cat_fields);
}

//$_SESSION['sbPlugins']->addSystemEvent('elem_list', 'fMaillist_Get_Elem_List', PL_MAILLIST_H_LIST);
//$_SESSION['sbPlugins']->addElem(PL_MAILLIST_H_LIST, 'list', 'fMaillist_Elem_List', 'fMaillist_Elem_List_Info', 'elem_list', 800, 700, 'design_list_edit', 'pl_maillist_design_list');

sb_add_rights();

$_SESSION['sbPlugins']->addEventsRights('maillist_send', PL_MAILLIST_H_RIGHT_CREATE_SEND);
$_SESSION['sbPlugins']->addEventsRights('elems_public', RIGHTS_H_ELEMS_PUBLIC_RIGHT);

?>