<?php

/**
 * Функция генерирует список рассылок.
 *
 * @param array Макеты дизайн вывода полей рассылки
 * @param array $categs Массив идентификаторов разделов из которых нужно выводить рассылки
 * @param integer $sub Выводить рассылки из подразделов выбранных разделов
 * @param array $mail_data массив данных пришедших через post
 * @return распарсенный макет списка рассылок
 */
function fMaillist_Parse_Maillists($temp, $categs, $sub, $mail_data = array(), $temp_id = 0)
{
//	Если передан массив макетов и он пуст
	if(count($temp) == 0)
		return false;

	if (count($categs) == 0)
		return false;

	$result = array();
	$result['su_mail_subscription'] = '';
	$result['su_mail_lang'] = '';
	$result['su_mail_status'] = '';
	$result['su_mail_date'] = '';

	$data = array();
	if(count($_POST) > 0)
	{
		$data['su_mail'] = isset($_POST['su_mail']) ? $_POST['su_mail'] : array();
		$data['su_mail_lang'] = isset($_POST['su_mail_lang']) ? $_POST['su_mail_lang'] : '';
		$data['su_mail_status'] = isset($_POST['su_mail_status']) ? $_POST['su_mail_status'] : '';
		$data['su_mail_date'] = isset($_POST['su_mail_date']) ? $_POST['su_mail_date'] : '';
	}
	elseif(count($mail_data) > 0)
	{
		$data['su_mail'] = isset($mail_data['su_mail']) ? $mail_data['su_mail'] : array();
		$data['su_mail_lang'] = isset($mail_data['su_mail_lang']) ? $mail_data['su_mail_lang'] : '';
		$data['su_mail_status'] = isset($mail_data['su_mail_status']) ? $mail_data['su_mail_status'] : '';
		$data['su_mail_date'] = isset($mail_data['su_mail_date']) ? $mail_data['su_mail_date'] : '';
	}

	// если следует выводить рассылки из подразделов
	if(isset($sub) && $sub == 1 && count($categs) > 0)
    {
		$res = sql_query('SELECT c.cat_id FROM sb_categs AS c, sb_categs AS c2
							WHERE c2.cat_left <= c.cat_left
							AND c2.cat_right >= c.cat_right
							AND c.cat_ident = ?
							AND c2.cat_ident = ?
							AND c2.cat_id IN (?a)
							ORDER BY c.cat_left', 'pl_maillist', 'pl_maillist', $categs);
		if($res)
    	{
    		foreach($res as $value)
            {
				$categs[] = $value[0];
            }
        }
	}

	$res = sql_param_query('SELECT cat_id FROM sb_categs WHERE cat_closed=1 AND cat_id IN (?a)', $categs);
	if ($res)
    {
        // проверяем права на закрытые разделы и исключаем их из вывода
    	$closed_ids = array();
    	foreach ($res as $value)
        {
			$closed_ids[] = $value[0];
        }
		$categs = sbAuth::checkRights($closed_ids, $categs, 'pl_maillist_read');

	    if (count($categs) == 0)
			return false;
	}
	
	$categs_output = false;
	$group_str = '';

//	Cтроем список листов рассылок, если передан идентификатор макета дизайна.
	if($temp_id > 0)
	{
		// вытаскиваем макет дизайна
		$res = sql_query('SELECT smt_id, smt_title, smt_lang, smt_checked, smt_top, smt_categ_top, smt_elem, smt_categ_bottom, smt_bottom,
				smt_count, smt_empty, smt_delim, smt_no_delivery, smt_fields_temps, smt_categs_temps
				FROM sb_maillist_temps WHERE smt_id=?d', $temp_id);

		if (!$res)
		{
			return false;
		}

		list($smt_id, $smt_title, $smt_lang, $smt_checked, $smt_top, $smt_categ_top, $smt_elem, $smt_categ_bottom, $smt_bottom, $smt_count, $smt_empty,
				$smt_delim, $smt_no_delivery, $smt_fields_temps, $smt_categs_temps) = $res[0];

		$smt_fields_temps = unserialize($smt_fields_temps);
		$smt_categs_temps = unserialize($smt_categs_temps);

		// вытаскиваем пользовательские поля рассылок и раздела
		$res = sql_query('SELECT pd_fields, pd_categs FROM sb_plugins_data WHERE pd_plugin_ident=?', 'pl_maillist');

		$elems_fields = array();
		$categs_fields = array();

		$categs_sql_fields = array();
		$elems_fields_select_sql = '';

		$user_tags = array();
		$user_values = array();
		
		$tags = array();
		// формируем SQL-запрос для пользовательских полей
		if ($res)
	    {
			require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

			if($res[0][0] != '')
	        {
	            $elems_fields = unserialize($res[0][0]);
	        }
	
	        if($res[0][1] != '')
	        {
	            $categs_fields = unserialize($res[0][1]);
	        }

	        if ($elems_fields)
	        {
				foreach ($elems_fields as $value)
		        {
		            if (isset($value['sql']) && $value['sql'] == 1)
		            {
						$elems_fields_select_sql .= ', m.user_f_'.$value['id'];

		                if ($value['type'] == 'google_coords' || $value['type'] == 'yandex_coords')
		                {
		                	$tags[] = '{'.$value['tag'].'_LATITUDE}';
		                	$tags[] = '{'.$value['tag'].'_LONGTITUDE}';

		                	if ($value['type'] == 'yandex_coords')
		                	{
		                		$tags[] = '{'.$value['tag'].'_API_KEY}';
		                	}
		                }
		                else 
		                {
		                	$tags[] = '{'.$value['tag'].'}';
		                }
		            }
		        }
		        $user_tags = $tags;
	        }
	
	        if ($categs_fields)
	        {
		        foreach ($categs_fields as $value)
		        {
		            if (isset($value['sql']) && $value['sql'] == 1)
		            {
		            	if ($value['type'] == 'google_coords' || $value['type'] == 'yandex_coords')
		                {
		                	$tags[] = '{'.$value['tag'].'_LATITUDE}';
		                	$tags[] = '{'.$value['tag'].'_LONGTITUDE}';
		                	
		                	if ($value['type'] == 'yandex_coords')
		                	{
		                		$tags[] = '{'.$value['tag'].'_API_KEY}';
		                	}
		                }
		                else 
		                {
		                	$tags[] = '{'.$value['tag'].'}';
		                }
		                
		                $categs_sql_fields[] = 'user_f_'.$value['id'];
		            }
		        }
	        }
	    }

	    // формируем SQL-запрос для флажков, которые необходимо учитывать при выводе
	    $elems_fields_where_sql = '';
	    if ($smt_checked != '')
	    {
	        $smt_checked = explode(' ', $smt_checked);
	        foreach ($smt_checked as $value)
	        {
				$elems_fields_where_sql .= ' AND m.user_f_'.$value.'=1';
	        }
	    }

	    // используется ли группировка по разделам
	    if ($smt_categ_top != '' || $smt_categ_bottom != '')
	    {
	        $categs_output = true;
	    }	    

		$group_res = sql_query('SELECT COUNT(*) FROM sb_catlinks WHERE link_cat_id IN (?a) AND link_src_cat_id != 0', $categs);
	    if ($group_res && $group_res[0][0] > 0)
	    {
			$group_str = ' GROUP BY m.m_id ';
		}
	}

	$maillist_total = true;

	$now = time();
	if ($temp_id > 0)
	{
		$res = sql_query('SELECT l.link_cat_id, m.m_name, m.m_id, m.m_mail_description'.$elems_fields_select_sql.'
				FROM sb_maillist m, sb_catlinks l, sb_categs c
				WHERE c.cat_ident = ? AND c.cat_id = l.link_cat_id AND l.link_el_id = m.m_id
				AND m.m_active IN ('.sb_get_workflow_demo_statuses().')
				AND (m.m_pub_start IS NULL OR m.m_pub_start <= ?)
				AND (m.m_pub_end IS NULL OR m.m_pub_end >= ?)
				AND c.cat_id IN (?a) '.$elems_fields_where_sql.$group_str.($categs_output ? ' ORDER BY c.cat_left' : ''), 'pl_maillist', $now, $now, $categs);

		if (!$res)
		{
			$result['su_mail_subscription'] = $smt_no_delivery;
	    }
		$maillist_total = count($res);
	}
	else
	{
		$res = sql_query('SELECT m_name, m_id
					FROM sb_maillist m, sb_catlinks l, sb_categs c
					WHERE c.cat_ident = ? AND c.cat_id = l.link_cat_id AND l.link_el_id = m.m_id
					AND m.m_active IN ('.sb_get_workflow_demo_statuses().')
					AND (m.m_pub_start IS NULL OR m.m_pub_start <= ?)
					AND (m.m_pub_end IS NULL OR m.m_pub_end >= ?)
					AND c.cat_id IN (?a) '.$group_str, 'pl_maillist', $now, $now, $categs);
		if (!$res)
		{
			return false;
	    }
	}

	$options_tags = array('{VALUE}', '{SELECTED}', '{TITLE}');
	if (isset($temp['su_mail_lang']) && trim($temp['su_mail_lang']) != '')
	{
		$su_mail_lang = isset($data['su_mail_lang']) ? $data['su_mail_lang'] : '';
		$options = '';
		
		foreach($GLOBALS['sb_site_langs'] as $key => $value)
		{
			if ($key == $su_mail_lang)
				$selected_str = 'selected=\'selected\'';
			else
				$selected_str = '';

			$options .= sb_str_replace($options_tags, array($key, $selected_str, $value), $temp['su_mail_lang_opt']);
		}
		$result['su_mail_lang'] = sb_str_replace('{OPTIONS}', $options, $temp['su_mail_lang']);
	}

	if(isset($temp['su_mail_status']) && trim($temp['su_mail_status']) != '')
	{
		$su_mail_status = isset($data['su_mail_status']) ? $data['su_mail_status'] : '';
		$status_opt = array(KERNEL_PROG_PL_MAILLIST_H_PARSE_ACTIVE, KERNEL_PROG_PL_MAILLIST_H_PARSE_NOT_ACTIVE, KERNEL_PROG_PL_MAILLIST_H_PARSE_NOT_ACTIVE_TO);

		$options = '';
		foreach($status_opt as $key => $value)
		{
			if ($key == $su_mail_status)
				$selected_str = 'selected=\'selected\'';
			else
				$selected_str = '';

			$options .= str_replace($options_tags, array($key, $selected_str, $value), $temp['su_mail_status_opt']);
		}

		$result['su_mail_status'] .= sb_str_replace('{OPTIONS}', $options, $temp['su_mail_status']);
	}

	if(isset($temp['su_mail_date']) && trim($temp['su_mail_date']) != '')
	{
		$result['su_mail_date'] = sb_str_replace('{VALUE}', (isset($data['su_mail_date']) && !is_null($data['su_mail_date']) ? $data['su_mail_date'] : ''), $temp['su_mail_date']);
	}
    
	if ($temp_id > 0 && $res)
	{
		$count_maillist = 1;
	    $categs_data = array();

	    if (sb_substr_count($smt_categ_top, '{CAT_COUNT}') > 0 ||
	        sb_substr_count($smt_categ_bottom, '{CAT_COUNT}') > 0 ||
	        sb_substr_count($smt_elem, '{CAT_COUNT}') > 0
	       )
	    {
			$res_cat = sql_query('SELECT c1.cat_id, c1.cat_title, c1.cat_level, c1.cat_fields,
					(

	                SELECT COUNT(l.link_el_id) FROM sb_categs c LEFT JOIN sb_catlinks l ON l.link_cat_id = c.cat_id, sb_maillist m
	                WHERE c.cat_id = c1.cat_id
	                AND l.link_el_id=m.m_id
					'.$elems_fields_where_sql.'
					AND m.m_active IN ('.sb_get_workflow_demo_statuses().')
					AND (m.m_pub_start IS NULL OR m.m_pub_start <= ?)
					AND (m.m_pub_end IS NULL OR m.m_pub_end >= ?)
	                AND l.link_src_cat_id NOT IN (?a)

	                ) AS cat_count, c1.cat_closed
					FROM sb_categs c1 WHERE c1.cat_id IN (?a)', $now, $now, $categs, $categs);
	    }
		else
		{
			$res_cat = sql_query('SELECT cat_id, cat_title, cat_level, cat_fields, ? AS cat_count, cat_closed 
					FROM sb_categs WHERE cat_id IN (?a)', '', $categs);
	    }

    	$categs_data = array();
	    if ($res_cat)
	    {
	        foreach ($res_cat as $value)
	        {
	            $categs_data[$value[0]] = array();
	            $categs_data[$value[0]]['title'] = $value[1];
	            $categs_data[$value[0]]['level'] = $value[2] + 1;
	            $categs_data[$value[0]]['fields'] = (trim($value[3]) != '' ? unserialize($value[3]) : array());
	            $categs_data[$value[0]]['count'] = $value[4];
	        }
	    }

		$result_str = '';
		$tags = array_merge($tags, array('{CAT_TITLE}',
	                                     '{CAT_LEVEL}',
	                                     '{CAT_COUNT}',
	                                     '{CAT_ID}',
	    								 '{ELEM_NUMBER}',
										 '{ID}',
										 '{CHANGE_DATE}',
										 '{ELEM_TITLE}',
										 '{DESCRIPTION}',
										 '{MAILLISTS}'));
		$cur_cat_id = 0;
		$values = array();
		$num_fields = count($res[0]);
		$num_cat_fields = count($categs_sql_fields);
		$col = 0;

		$dop_tags = array('{ID}', '{NAME}', '{CAT_ID}', '{CAT_TITLE}');
		foreach($res as $value)
	    {
			$old_values = $values;
			$values = array();

			if ($value[0] != $cur_cat_id)
	        {
				$cat_values = array();
	        }

	        $dop_values = array($value[2], $value[1], $value[0], $categs_data[$value[0]]['title']);
	        if ($num_fields > 4)
	        {
	            for ($i = 4; $i < $num_fields; $i++)
	            {
					$values[] = $value[$i];
	            }
				$values = sbLayout::parsePluginFields($elems_fields, $values, $smt_fields_temps, $dop_tags, $dop_values, $smt_lang);
				$user_values = $values;
	        }

			if ($num_cat_fields > 0)
	        {
	            if (count($cat_values) == 0)
	            {
	                foreach ($categs_sql_fields as $cat_field)
	                {
						if (isset($categs_data[$value[0]]['fields'][$cat_field]))
							$cat_values[] = $categs_data[$value[0]]['fields'][$cat_field];
	                    else 
	                        $cat_values[] = null;
	                }
					$cat_values = sbLayout::parsePluginFields($categs_fields, $cat_values, $smt_categs_temps, $dop_tags, $dop_values, $smt_lang);
	            }

	            $values = array_merge($values, $cat_values);
	        }

	        $values[] = $categs_data[$value[0]]['title'];  // CAT_TITLE
	        $values[] = $categs_data[$value[0]]['level'];  // CAT_LEVEL
	        $values[] = $categs_data[$value[0]]['count'];  // CAT_COUNT
	        $values[] = $value[0]; //  CAT_ID
			$values[] = $count_maillist++;  // ELEM_NUMBER

			$values[] = $value[2]; //  ID
	    	// Дата последнего изменения
	        if(sb_strpos($smt_elem, '{CHANGE_DATE}') !== false)
	        {
	        	$res1 = sql_query('SELECT change_date FROM sb_catchanges WHERE el_id = ? AND cat_ident = ? ORDER BY change_date DESC LIMIT 0, 1', $value[2],'pl_maillist');
	        	$values[] = isset($res1[0][0]) ? sb_parse_date($res1[0][0], $smt_fields_temps['m_change_date'], $smt_lang) : ''; //   CHANGE_DATE
	        }
	        else
	       	{
	        	$values[] = '';
	       	}
			$values[] = $value[1]; //  TITLE
			$values[] = str_replace(array_merge($dop_tags, array('{VALUE}')), array_merge($dop_values, array($value[3])), $smt_fields_temps['m_mail_description']);		//	DESCRIPTION

			if(isset($smt_fields_temps['m_podpiska']) && $smt_fields_temps['m_podpiska'] != '')
			{
				$pos = stripos($smt_fields_temps['m_podpiska'], 'su_mail[]');
				if(stripos($smt_fields_temps['m_podpiska'], 'radio') !== false)
				{
					$selected_str = (isset($data['su_mail']['1']) && $data['su_mail']['1'] == $value[2] ? ' checked=\'checked\' ' : '');
					$temp_str = sb_substr($smt_fields_temps['m_podpiska'], 0, ($pos+8)).'1'.sb_substr($smt_fields_temps['m_podpiska'], ($pos+8));
				}
				else
				{
					$selected_str = (isset($data['su_mail'][$value[2]]) && $data['su_mail'][$value[2]] == $value[2] ? ' checked=\'checked\' ' : '');
					$temp_str = sb_substr($smt_fields_temps['m_podpiska'], 0, ($pos+8)).$value[2].sb_substr($smt_fields_temps['m_podpiska'], ($pos + 8));
				}
				$values[] = sb_str_replace(array_merge(array('{SELECTED}', '{VALUE}'), $dop_tags), array_merge(array($selected_str, $value[2]), $dop_values), $temp_str); //	MAILLISTS
			}
			else
			{
				$values[] = ''; //	MAILLISTS
			}

			if ($categs_output && $value[0] != $cur_cat_id)
	        {
				if ($cur_cat_id != 0)
	            {
					//	низ	вывода	раздела
					while ($col < $smt_count)
	                {
	                    $result_str .= $smt_empty;
	                    $col++;
	                }
					$result_str .= str_replace($tags, $old_values, $smt_categ_bottom);
	            }

				//	верх вывода раздела
				$result_str .= str_replace($tags, $values, $smt_categ_top);
				$col = 0;
	        }

			if($col >= $smt_count)
	        {
				$result_str .= $smt_delim;
	            $col = 0;
	        }

			$result_str .= str_replace($tags, $values, $smt_elem);

			$cur_cat_id = $value[0];
			$col++;
	    }

		while ($col < $smt_count)
		{
			$result_str .= $smt_empty;
			$col++;
	    }

	    if ($categs_output)
	    {
			//	низ вывода раздела
			$result_str .= str_replace($tags, $values, $smt_categ_bottom);
	    }

		// верх вывода листа рассылки
		$result_str = str_replace(array('{NUM_LIST}', '{ALL_COUNT}', '{MAILLIST_LANG}', '{MAILLIST_STATUS}', '{MAILLIST_DATE}'),
				array('', $maillist_total, $result['su_mail_lang'], $result['su_mail_status'], $result['su_mail_date']), $smt_top)
				.$result_str.
			str_replace(array('{NUM_LIST}', '{ALL_COUNT}', '{MAILLIST_LANG}', '{MAILLIST_STATUS}', '{MAILLIST_DATE}'),
				array('', $maillist_total, $result['su_mail_lang'], $result['su_mail_status'], $result['su_mail_date']), $smt_bottom);

		$result['su_mail_subscription'] = preg_replace('/\{[_A-Z0-9'.$GLOBALS['sb_reg_upper_interval'].']+\}/'.SB_PREG_MOD, '', $result_str);
	}
	elseif($temp_id == 0)
	{
		if ($res && isset($temp['su_mail_subscription']) && $temp['su_mail_subscription'] != '')
		{
			foreach($res as $key => $value)
			{
				$pos = stripos($temp['su_mail_subscription'], 'su_mail[]');
				if(stripos($temp['su_mail_subscription'], 'radio') !== false)
				{
					$selected_str = (isset($data['su_mail']['1']) && $data['su_mail']['1'] == $value[1] ? ' checked=\'checked\' ' : '');
					$temp_str = sb_substr($temp['su_mail_subscription'], 0, ($pos+8)).'1'.sb_substr($temp['su_mail_subscription'], ($pos+8));
				}
				else
				{
					$selected_str = (isset($data['su_mail'][$value[1]]) && $data['su_mail'][$value[1]] == $value[1] ? ' checked=\'checked\' ' : '');
					$temp_str = sb_substr($temp['su_mail_subscription'], 0, ($pos+8)).$value[1].sb_substr($temp['su_mail_subscription'],($pos+8));
				}
				$result['su_mail_subscription'] .= sb_str_replace(array('{MAIL_NAME}', '{SELECTED}', '{VALUE}'), array($value[0], $selected_str, $value[1]), $temp_str);
			}
		}
	}
	return $result;
}

/**
 * Функция, выводящая поле выбора макет дизайна листов рассылок
 *
 * @param object $layout Объект sbLayout, к которому будут добавлены поля.
 * @param string $field_value Идентификатор выбранного макета дизайна.
 * @param string $field_name Имя поля, в котором будет храниться идентификатор макета дизайна.
 * @param int $field_need_value Значение галочки "Обязательно для заполнения"
 */
function fMaillist_Design_Get(&$layout, $field_value, $field_name, $field_need_value)
{
	$res = sql_query('SELECT categs.cat_title, temps.smt_id, temps.smt_title
			FROM sb_categs categs, sb_catlinks links, sb_maillist_temps temps
			WHERE temps.smt_id=links.link_el_id
			AND categs.cat_id=links.link_cat_id
			AND categs.cat_ident = ?
			ORDER BY categs.cat_left, temps.smt_title', 'pl_maillist_design_list');

	if ($res)
    {
        $options = array();
        $old_cat_title = '';
        foreach ($res as $value)
        {
            list($cat_title, $smt_id, $smt_title) = $value;
                
            if ($old_cat_title != $cat_title)
            {
                $options[uniqid()] = '-'.$cat_title;
                $old_cat_title = $cat_title;
            }

            $options[$smt_id] = $smt_title;
        }
        $fld = new sbLayoutSelect($options, $field_name);
        $fld->mSelOptions = array($field_value);
    }
    else
    {
		$fld = new sbLayoutLabel('<div class="hint_div">'.PL_MAILLIST_H_NO_TEMP_COMMENTS.'</div>', '', '', false);
    }

	$layout->addField(PL_SITE_USERS_DESIGN_REG_EDIT_MAIL_MAILLIST.'<br><input type="checkbox" value="1" name="sut_fields_temps[su_mail_subscription_need]" id="su_mail_subscription_need"'.(isset($field_need_value) && $field_need_value == 1 ? 'checked' : '').'><label for="su_mail_subscription_need">'.SB_LAYOUT_PLUGIN_FIELDS_REQ.'</label>', $fld);
}

?>