<?php
require_once(SB_CMS_LANG_PATH.'/pl_menu.h.lng.php');

if ($_SESSION['sbPlugins']->register('pl_menu', PL_MENU_H_PLUGIN_NAME, 'http://www.sbuilder.ru/docs/helps40/navigation.doc'))
{
	$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_USER.'>'.PL_MENU_H_PLUGIN_NAME, 'init');
	
	if ($_SESSION['sbPlugins']->isRightAvailable('pl_menu', 'design_read'))
	{
	    $_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_MENU_H_PLUGIN_NAME.'>'.PL_MENU_H_ELEM_TREE, 'temps', 'pl_menu_temps_24.png');
	    $_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_MENU_H_PLUGIN_NAME.'>'.PL_MENU_H_ELEM_PATH, 'path_temps', 'pl_menu_path_temps_24.png');
	}

	$_SESSION['sbPlugins']->setMainEvent('init');

	$_SESSION['sbPlugins']->addUserEvent('init', 'fMenu_Init', 'read', PL_MENU_H_PLUGIN_NAME);
	$_SESSION['sbPlugins']->addUserEvent('tree', 'fMenu_Tree', 'read');
	$_SESSION['sbPlugins']->addUserEvent('add_edit', 'fMenu_Add_Edit', 'read', PL_MENU_H_ADD_EDIT_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('load_categs_temps', 'fMenu_Load_Categs_Temps', 'elems_edit');
	$_SESSION['sbPlugins']->addUserEvent('add_edit_submit', 'fMenu_Add_Edit_Submit', 'elems_edit', PL_MENU_H_ADD_EDIT_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('add_delim', 'fMenu_Add_Delim', 'elems_edit');
	$_SESSION['sbPlugins']->addUserEvent('delete', 'fMenu_Delete', 'elems_delete');
	$_SESSION['sbPlugins']->addUserEvent('check', 'fMenu_Check', 'elems_edit');
	$_SESSION['sbPlugins']->addUserEvent('paste', 'fMenu_Paste', 'elems_edit');
	$_SESSION['sbPlugins']->addUserEvent('cat_delete', 'fMenu_Cat_Delete', 'categs_delete');
	$_SESSION['sbPlugins']->addUserEvent('cat_edit', 'fMenu_Cat_Edit', 'categs_edit');
	$_SESSION['sbPlugins']->addUserEvent('after_paste_with_elements', 'fMenu_After_Paste_With_Elements', 'categs_edit');
	$_SESSION['sbPlugins']->addUserEvent('del_cats_w_elems', 'fMenu_Del_Cats_W_Elems', 'categs_edit');
	
	//Макеты дизайна меню
	$_SESSION['sbPlugins']->addUserEvent('temps', 'fMenu_Temps', 'design_read', PL_MENU_H_TEMPS_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('temps_edit', 'fMenu_Temps_Edit', 'design_read',  PL_MENU_H_TEMPS_EDIT_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('temps_submit', 'fMenu_Temps_Submit', 'design_edit', PL_MENU_H_TEMPS_EDIT_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('temps_delete', 'fMenu_Temps_Delete', 'design_edit');
	
	//Макеты дизайна пути по сайту
	$_SESSION['sbPlugins']->addUserEvent('path_temps', 'fMenu_Path_Temps', 'design_read', PL_MENU_H_PATH_TEMPS_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('path_temps_edit', 'fMenu_Path_Temps_Edit', 'design_read',  PL_MENU_H_PATH_TEMPS_EDIT_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('path_temps_submit', 'fMenu_Path_Temps_Submit', 'design_edit', PL_MENU_H_PATH_TEMPS_EDIT_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('path_temps_delete', 'fMenu_Path_Temps_Delete', 'design_edit');

	$_SESSION['sbPlugins']->addToConstructor('sb_menu', false);
	$_SESSION['sbPlugins']->addToCache();
	$_SESSION['sbPlugins']->addToWorkflow();

	$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_menu_delim', PL_MENU_H_PLUGIN_NAME, '', '');
	$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_menu_max_deep', PL_MENU_H_MAX_DEEP_SETTING, 'number', '', '7');
	$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_menu_max_items', PL_MENU_H_MAX_ITEMS_SETTING, 'number', '', '100');

	$fields = array();
	$fields['m_id'] = array('title' => PL_MENU_H_ID_LABEL, 'flags' => '8');
	$fields['m_title'] = array('title' => PL_MENU_H_TITLE_LABEL, 'flags' => '4');
	$fields['m_text'] = array('title' => PL_MENU_H_TEXT_LABEL, 'flags' => '5');
	$fields['m_url'] = array('title' => PL_MENU_H_URL_LABEL, 'flags' => '4');
	$fields['m_alt'] = array('title' => PL_MENU_H_ALT_LABEL, 'flags' => '4');
	$fields['m_target'] = array('title' => PL_MENU_H_TARGET_LABEL, 'flags' => '17');
	$fields['m_type'] = array('title' => PL_MENU_H_TYPE_LABEL, 'flags' => '4');
	$fields['m_props'] = array('title' => PL_MENU_H_PROPS_LABEL, 'flags' => '5');
	$fields['m_show'] = array('title' => PL_MENU_H_SHOW_LABEL, 'flags' => '8');
	$fields['m_left'] = array('title' => PL_MENU_H_LEFT_LABEL, 'flags' => '8');
	$fields['m_right'] = array('title' => PL_MENU_H_RIGHT_LABEL, 'flags' => '8');
	$fields['m_level'] = array('title' => PL_MENU_H_LEVEL_LABEL, 'flags' => '8');
	$fields['m_cat_id'] = array('title' => PL_MENU_H_CAT_ID_LABEL, 'flags' => '8');
	$fields['m_status'] = array('title' => PL_MENU_H_STATUS_LABEL, 'flags' => '8');
	$fields['ident'] = array('title' => PL_MENU_H_IDENT_LABEL, 'flags' => '4');
	$fields['cat_id'] = array('title' => PL_MENU_H_CATS_ID_LABEL, 'flags' => '4');
	$fields['temp_id'] = array('title' => PL_MENU_H_TEMP_ID_LABEL, 'flags' => '8');
	$fields['show_hidden'] = array('title' => PL_MENU_H_SHOW_HIDDEN_LABEL, 'flags' => '8');
	$fields['from'] = array('title' => PL_MENU_H_FROM_LABEL, 'flags' => '8');
	$fields['to'] = array('title' => PL_MENU_H_TO_LABEL, 'flags' => '8');
	$fields['plugin_ident'] = array('title' => PL_MENU_H_PLUGIN_IDENT_LABEL, 'flags' => '4');
	$fields['get_ident'] = array('title' => PL_MENU_H_GET_IDENT_LABEL, 'flags' => '4');

	$_SESSION['sbPlugins']->addFieldsInfo('sb_menu', 'm_id', 'm_title', $fields);
}

$_SESSION['sbPlugins']->addSystemEvent('elem_tree', 'fMenu_Get_Elem_Tree', PL_MENU_H_ELEM_TREE);
$_SESSION['sbPlugins']->addSystemEvent('elem_path', 'fMenu_Get_Elem_Path', PL_MENU_H_ELEM_PATH);

$_SESSION['sbPlugins']->addElem(PL_MENU_H_ELEM_TREE, 'tree', 'fMenu_Elem_Tree', 'fMenu_Elem_Tree_Info', 'elem_tree', 800, 700, 'temps_edit', 'pl_menu_temps');
$_SESSION['sbPlugins']->addElem(PL_MENU_H_ELEM_PATH_HTML, 'path_html', 'fMenu_Elem_Path_Html', 'fMenu_Elem_Path_Info', 'elem_path', 800, 700, 'path_temps_edit', 'pl_menu_path_temps');
$_SESSION['sbPlugins']->addElem(PL_MENU_H_ELEM_PATH_PLAIN, 'path_plain', 'fMenu_Elem_Path_Plain', 'fMenu_Elem_Path_Info', 'elem_path', 800, 700, 'path_temps_edit', 'pl_menu_path_temps');

$_SESSION['sbPlugins']->addEventsRights('categs_edit', RIGHTS_H_CATEGS_EDIT_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('categs_delete', RIGHTS_H_CATEGS_DELETE_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('categs_rights', RIGHTS_H_CATEGS_RIGHTS_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('elems_edit', PL_MENU_H_ELEMS_EDIT_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('elems_delete', PL_MENU_H_ELEMS_DELETE_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('design_read', RIGHTS_H_DESIGN_READ_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('design_edit', RIGHTS_H_DESIGN_EDIT_RIGHT);

?>