<?php
/********************************** функции построения диалоговых окон ***********************************/

/**
 * Вывод меню
 */
function fMenu_Get_Elem_Tree()
{
	require_once(SB_CMS_LIB_PATH.'/sbJustCategs.inc.php');
    $params = unserialize($_GET['params']);
    
    if (!isset($params['parent_selection']))
    	$params['parent_selection'] = 1;
    if (isset($params['count']) && $params['count'] <= 0)
    	$params['count'] = '';
    		
    if (!isset($params['menu_design']))
    	$params['menu_design'] = 0;
    	
    if (!isset($params['query_string']))
    	$params['query_string'] = 1;
    	
    echo '<script>
        function chooseCat()
        {
            var res = new Object();
            var params = new Array();
            
            var el_cats = sbCatTree.getAllSelected();
            if (el_cats.length == 0)
            {
                alert("'.PL_MENU_H_ELEM_TREE_NO_CATEGS_MSG.'");
                return;
            }
            
            params["ids"] = el_cats;
            var el_temp = sbGetE("temp_id");
            if (el_temp)
            {
                params["temp_id"] = el_temp.value;
            }
            else
            {
                alert("'.PL_MENU_H_ELEM_TREE_NO_TEMPS_ALERT.'");
                return;
            }

            var el_from = sbGetE("spin_from");
            var el_to = sbGetE("spin_to");
			if (el_to.value <= 0) el_to.value = "";
			                
            if (el_to.value != "" && parseInt(el_from.value) > parseInt(el_to.value))
            {
                alert("'.PL_MENU_H_ELEM_SUB_FROM_TO_ERROR.'");
                return;
            }
                
            params["from"] = el_from.value;
            params["to"] = el_to.value;
            params["count"] = sbGetE("spin_count").value > 0 && sbGetE("spin_count").value != "" ? sbGetE("spin_count").value : "0";
            
            params["parent_selection"] = sbGetE("parent_selection").checked ? 1 : 0;
            params["parent_link"] = sbGetE("parent_link").checked ? 1 : 0;
            params["show_closed"] = sbGetE("show_closed").checked ? 1 : 0;
            params["show_hidden"] = sbGetE("show_hidden").checked ? 1 : 0;
            params["menu_design"] = sbGetE("menu_desgin").checked ? 1 : 0;
            params["query_string"] = sbGetE("query_string").checked ? 1 : 0;
            
            res.temp_id = el_temp.value;
            res.params = sb_serialize(params);
    
            sbReturnValue(res);
        }
    </script>';
    
    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
    
    $layout = new sbLayout();
    $layout->mTableWidth = '100%';
    $layout->mTitleWidth = '200';
    
    $layout->addTab(PL_MENU_H_ELEM_TREE_CATEGS_TAB);
    
    $categs = new sbJustCategs('pl_menu');
    $categs->mCategsUseRights = false;
    $categs->mCategsMenu = false;
    $categs->mCategsMultiSelect = true;
    $categs->mCategsCount = false;
    $categs->mCategsSelectedIds = (isset($params['ids']) && $params['ids'] != '' ? explode('^', $params['ids']) : array());
    
    $layout->addField('', new sbLayoutHTML($categs->showTree('', '', '', false), true));
    $categs->init();
    
    $layout->addTab(PL_MENU_H_ELEM_TREE_PROPS_TAB);
    $layout->addHeader(PL_MENU_H_ELEM_TREE_PROPS_TAB);
    
    $options = array();
    $res = sql_query('SELECT categs.cat_title, temps.mt_id, temps.mt_title FROM sb_categs categs, sb_catlinks links, sb_menu_temps temps WHERE temps.mt_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_menu_temps" ORDER BY categs.cat_left, temps.mt_title');
    if ($res)
    {
        $old_cat_title = '';
        foreach ($res as $value)
        {
            list($cat_title, $mt_id, $mt_title) = $value;
            if ($old_cat_title != $cat_title)
            {
                $options[uniqid()] = '-'.$cat_title;
                $old_cat_title = $cat_title;
            }
            $options[$mt_id] = $mt_title;
        }
    }
       
    if (count($options) > 0)
    { 
    	$fld = new sbLayoutSelect($options, 'temp_id');
        if (isset($_GET['temp_id']))
        {
            $fld->mSelOptions = array($_GET['temp_id']);
        }
    }
    else 
    {
        $fld = new sbLayoutLabel('<div class="hint_div">'.PL_MENU_H_ELEM_TREE_NO_TEMPS_MSG.'</div>', '', '', false);    
    }

    $layout->addField(PL_MENU_H_ELEM_TEMP, $fld);
    
    $fld = new sbLayoutInput('checkbox', '1', 'menu_desgin', '', (isset($params['menu_design']) && $params['menu_design'] == 1 ? 'checked="checked"' : ''));
    $layout->addField(PL_MENU_H_MENU_DESIGN, $fld);
    $layout->addField('', new sbLayoutDelim());

    $fld1 = new sbLayoutInput('input', (isset($params['from']) ? $params['from'] : '1'), 'from', 'spin_from', 'style="width: 50px;"');
    $fld1->mMinValue = 1;
    $fld2 = new sbLayoutInput('input', (isset($params['to']) ? $params['to'] : ''), 'to', 'spin_to', 'style="width: 50px;"');
    
    $html = $fld1->getJavaScript().'<table cellpadding="0" cellspacing="0"><tr><td>'.$fld1->getField().'</td><td>&nbsp;&nbsp;'.KERNEL_TO.'&nbsp;&nbsp;</td><td>'.$fld2->getField().'</td></tr></table>
              <div class="hint_div">'.PL_MENU_H_ELEM_SUB_FROM_TO_HINT.'</div>';
        
    $fld = new sbLayoutHTML($html);
    $layout->addField(PL_MENU_H_ELEM_SUB_FROM_TO, $fld);
    
    $fld = new sbLayoutInput('input', (isset($params['count']) ? $params['count'] : ''), 'count', 'spin_count', 'style="width: 50px;"');
    $layout->addField(PL_MENU_H_COUNT, $fld);

    $fld = new sbLayoutInput('checkbox', '1', 'parent_link', '', (isset($params['parent_link']) && $params['parent_link'] == 1 ? 'checked="checked"' : ''));
    $fld->mHTML = '<div class="hint_div">'.PL_MENU_H_LINK_DESC.'</div>';
    $layout->addField(PL_MENU_H_LINK, $fld);
    
    $layout->addField('', new sbLayoutDelim());
    $layout->addField(PL_MENU_H_ELEM_TREE_PARENT_SELECTION, new sbLayoutInput('checkbox', '1', 'parent_selection', '', (isset($params['parent_selection']) && $params['parent_selection'] == 1 ? 'checked="checked"' : '')));
    $layout->addField(PL_MENU_H_ELEM_TREE_QUERY_STRING, new sbLayoutInput('checkbox', '1', 'query_string', '', (isset($params['query_string']) && $params['query_string'] == 1 ? 'checked="checked"' : '')));
    
    $fld = new sbLayoutInput('checkbox', '1', 'show_closed', '', (isset($params['show_closed']) && $params['show_closed'] == 1 ? 'checked="checked"' : ''));
    $fld->mHTML = '<div class="hint_div">'.PL_MENU_H_ELEM_TREE_SHOW_CLOSED_DESC.'</div>';
    $layout->addField(PL_MENU_H_ELEM_TREE_SHOW_CLOSED, $fld);

    $layout->addField(PL_MENU_H_ELEM_TREE_SHOW_HIDDEN, new sbLayoutInput('checkbox', '1', 'show_hidden', '', (isset($params['show_hidden']) && $params['show_hidden'] == 1 ? 'checked="checked"' : '')));
    
    $layout->addButton('button', KERNEL_SAVE, '', '', 'onclick="chooseCat();"'.(count($options) > 0 ? '' : ' disabled="disabled"'));
    $layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');
    
    $layout->show();
}

/**
 * Вывод пути
 */
function fMenu_Get_Elem_Path()
{
	require_once(SB_CMS_LIB_PATH.'/sbJustCategs.inc.php');
    $params = unserialize($_GET['params']);
    
    echo '<script>
        function chooseCat()
        {
            var res = new Object();
            var params = new Array();
            
            var el_cats = sbCatTree.getAllSelected();
            if (el_cats.length == 0)
            {
                alert("'.PL_MENU_H_ELEM_PATH_NO_CATEGS_MSG.'");
                return;
            }
            
            params["ids"] = el_cats;
            var el_temp = sbGetE("temp_id");
            if (el_temp)
            {
                params["temp_id"] = el_temp.value;
            }
            else
            {
                alert("'.PL_MENU_H_ELEM_TREE_NO_TEMPS_ALERT.'");
                return;
            }

            params["num_items"] = sbGetE("spin_num_items").value;
            params["show_hidden"] = sbGetE("show_hidden").checked ? 1 : 0;
            params["show_closed"] = sbGetE("show_closed").checked ? 1 : 0;
            
            res.temp_id = el_temp.value;
            res.params = sb_serialize(params);
    
            sbReturnValue(res);
        }
    </script>';
    
    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
    
    $layout = new sbLayout();
    $layout->mTableWidth = '100%';
    $layout->mTitleWidth = '200';
    
    $layout->addTab(PL_MENU_H_ELEM_TREE_CATEGS_TAB);
    
    $categs = new sbJustCategs('pl_menu');
    $categs->mCategsUseRights = false;
    $categs->mCategsMenu = false;
    $categs->mCategsMultiSelect = true;
    $categs->mCategsCount = false;
    $categs->mCategsSelectedIds = (isset($params['ids']) && $params['ids'] != '' ? explode('^', $params['ids']) : array());
    
    $layout->addField('', new sbLayoutHTML($categs->showTree('', '', '', false), true));
    $categs->init();
    
    $layout->addTab(PL_MENU_H_ELEM_TREE_PROPS_TAB);
    $layout->addHeader(PL_MENU_H_ELEM_TREE_PROPS_TAB);
    
    $options = array();
    $res = sql_query('SELECT categs.cat_title, temps.mpt_id, temps.mpt_title FROM sb_categs categs, sb_catlinks links, sb_menu_path_temps temps WHERE temps.mpt_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_menu_path_temps" ORDER BY categs.cat_left, temps.mpt_title');
    if ($res)
    {
        $old_cat_title = '';
        foreach ($res as $value)
        {
            list($cat_title, $mt_id, $mt_title) = $value;
            if ($old_cat_title != $cat_title)
            {
                $options[uniqid()] = '-'.$cat_title;
                $old_cat_title = $cat_title;
            }
            $options[$mt_id] = $mt_title;
        }
    }
       
    if (count($options) > 0)
    { 
    	$fld = new sbLayoutSelect($options, 'temp_id');
        if (isset($_GET['temp_id']))
        {
            $fld->mSelOptions = array($_GET['temp_id']);
        }
    }
    else 
    {
        $fld = new sbLayoutLabel('<div class="hint_div">'.PL_MENU_H_ELEM_PATH_NO_TEMPS_MSG.'</div>', '', '', false);    
    }

    $layout->addField(PL_MENU_H_ELEM_TEMP, $fld);
    $layout->addField('', new sbLayoutDelim());
       
    $fld = new sbLayoutInput('text', (isset($params['num_items']) ? $params['num_items'] : '5'), 'spin_num_items', '', 'style="width: 50px;"');
    $fld->mMinValue = 1;
    $layout->addField(PL_MENU_H_ELEM_PATH_COUNT, $fld);
    
    $fld = new sbLayoutInput('checkbox', '1', 'show_closed', '', (isset($params['show_closed']) && $params['show_closed'] == 1 ? 'checked="checked"' : ''));
    $fld->mHTML = '<div class="hint_div">'.PL_MENU_H_ELEM_TREE_SHOW_CLOSED_DESC.'</div>';
    $layout->addField(PL_MENU_H_ELEM_TREE_SHOW_CLOSED, $fld);
    
    $layout->addField(PL_MENU_H_ELEM_TREE_SHOW_HIDDEN, new sbLayoutInput('checkbox', '1', 'show_hidden', '', ((isset($params['show_hidden']) && $params['show_hidden'] == 1) || !isset($params['show_hidden']) ? 'checked="checked"' : '')));
    
    $layout->addButton('button', KERNEL_SAVE, '', '', 'onclick="chooseCat();"'.(count($options) > 0 ? '' : ' disabled="disabled"'));
    $layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');
    
    $layout->show();
}

/********************************** функции получения информации по элементам модуля ***********************************/

/**
 * Вывод меню
 */
function fMenu_Elem_Tree_Info($params)
{
	$in_str = implode(',', explode('^', $params['ids']));
    $in_str = '(0,'.$in_str.')';
    
    $categs_str = '';
    $res = sql_query('SELECT cat_title FROM sb_categs WHERE cat_id IN '.$in_str.' ORDER BY cat_left');
    if ($res)
    {
        $categs_str = '';
        foreach ($res as $value)
        {
            $categs_str .= $value[0].', ';
        }
        $categs_str = substr($categs_str, 0, -2);
    }
    
    $res = sql_param_query('SELECT categs.cat_title, temps.mt_title FROM sb_categs categs, sb_catlinks links, sb_menu_temps temps
                          WHERE temps.mt_id=?d AND links.link_el_id=temps.mt_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_menu_temps"', $params['temp_id']);
        
    echo '<div style="padding-bottom: 5px;"><b>'.PL_MENU_H_INFO_CATEGS.':</b> '.($categs_str != '' ? $categs_str : '<span style="color:red;">'.PL_MENU_H_INFO_CATEGS_WAS_DELETED_MSG.'</span>').'</div>
          <div style="padding-bottom: 5px;"><b>'.PL_MENU_H_ELEM_TEMP.':</b> '.($res ? $res[0][0].' -&gt; '.$res[0][1] : '<span style="color:red;">'.PL_MENU_H_INFO_TEMP_WAS_DELETED_MSG.'</span>').'</div>
          <div class="delim"></div>
          <div style="padding-bottom: 5px;"><b>'.PL_MENU_H_INFO_FROM_TO.':</b> '.KERNEL_FROM.' '.$params['from'].' '.KERNEL_TO.' '.$params['to'].'</div>
          <div style="padding-bottom: 5px;"><b>'.PL_MENU_H_COUNT.':</b> '.($params['count'] > 0 ? $params['count'] : '').'</div>
          <div style="padding-bottom: 5px;"><b>'.PL_MENU_H_INFO_LINK.':</b> '.(isset($params['parent_link']) && $params['parent_link'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>
          <div class="delim"></div>
          <div style="padding-bottom: 5px;"><b>'.PL_MENU_H_INFO_PARENT_SELECTION.':</b> '.(isset($params['parent_selection']) && $params['parent_selection'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>
          <div style="padding-bottom: 5px;"><b>'.PL_MENU_H_INFO_SHOW_CLOSED.':</b> '.(isset($params['show_closed']) && $params['show_closed'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>
          <div style="padding-bottom: 5px;"><b>'.PL_MENU_H_INFO_SHOW_HIDDEN.':</b> '.(isset($params['show_hidden']) && $params['show_hidden'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>';
}

/**
 * Вывод меню
 */
function fMenu_Elem_Path_Info($params)
{
	$in_str = implode(',', explode('^', $params['ids']));
    $in_str = '(0,'.$in_str.')';
    
    $categs_str = '';
    $res = sql_query('SELECT cat_title FROM sb_categs WHERE cat_id IN '.$in_str.' ORDER BY cat_left');
    if ($res)
    {
        $categs_str = '';
        foreach ($res as $value)
        {
            $categs_str .= $value[0].', ';
        }
        $categs_str = substr($categs_str, 0, -2);
    }
    
    $res = sql_param_query('SELECT categs.cat_title, temps.mpt_title FROM sb_categs categs, sb_catlinks links, sb_menu_path_temps temps
                          WHERE temps.mpt_id=?d AND links.link_el_id=temps.mpt_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_menu_path_temps"', $params['temp_id']);
        
    echo '<div style="padding-bottom: 5px;"><b>'.PL_MENU_H_INFO_CATEGS.':</b> '.($categs_str != '' ? $categs_str : '<span style="color:red;">'.PL_MENU_H_INFO_CATEGS_WAS_DELETED_MSG.'</span>').'</div>
          <div style="padding-bottom: 5px;"><b>'.PL_MENU_H_ELEM_TEMP.':</b> '.($res ? $res[0][0].' -&gt; '.$res[0][1] : '<span style="color:red;">'.PL_MENU_H_INFO_TEMP_WAS_DELETED_MSG.'</span>').'</div>
          <div class="delim"></div>
          <div style="padding-bottom: 5px;"><b>'.PL_MENU_H_INFO_NUM_ITEMS.':</b> '.$params['num_items'].'</div>
          <div style="padding-bottom: 5px;"><b>'.PL_MENU_H_INFO_SHOW_CLOSED.':</b> '.(isset($params['show_closed']) && $params['show_closed'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>
          <div style="padding-bottom: 5px;"><b>'.PL_MENU_H_INFO_SHOW_HIDDEN.':</b> '.(isset($params['show_hidden']) && $params['show_hidden'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>';
}

/********************************** функции получения элементов модуля ***********************************/

/**
 * Вывод меню
 */
function fMenu_Elem_Tree($el_id, $temp_id, $params, $tag_id)
{
	return "<?php include_once SB_CMS_PL_PATH.'/pl_menu/prog/pl_menu.php';\n
        fMenu_Elem_Tree('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id');\n
        ?>";
}

/**
 * Вывод пути по сайту (HTML)
 */
function fMenu_Elem_Path_Html($el_id, $temp_id, $params, $tag_id)
{
	return "<?php include_once SB_CMS_PL_PATH.'/pl_menu/prog/pl_menu.php';\n
        fMenu_Elem_Path('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id');\n
        ?>";
}

/**
 * Вывод пути по сайту (HTML)
 */
function fMenu_Elem_Path_Plain($el_id, $temp_id, $params, $tag_id)
{
	return "<?php include_once SB_CMS_PL_PATH.'/pl_menu/prog/pl_menu.php';\n
        fMenu_Elem_Path('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id', true);\n
        ?>";
}
?>