<?php
function fMenu_Init()
{
    require_once(SB_CMS_LIB_PATH.'/sbCategs.inc.php');

    $elems = new sbCategs('fMenu_Get', 'pl_menu_init', 'pl_menu');

    $elems->mCategsRootName = PL_MENU_ROOT_NAME;

    $elems->mCategsDeleteEvent = 'pl_menu_cat_delete';
    $elems->mCategsAfterEditEvent = 'pl_menu_cat_edit';
    $elems->mCategsAfterEditFunc = 'sbMenuChangeRoot';

    $elems->mCategsPasteWithElementsMenu = true;
	$elems->mCategsAfterPasteWithElementsEvent = 'pl_menu_after_paste_with_elements';

	$elems->mCategsDeleteWithElementsMenu = true;
	$elems->mCategsAfterDeleteWithElementsEvent = 'pl_menu_del_cats_w_elems';

	$elems->mCategsClosed = false;

    $edit_rights = $_SESSION['sbPlugins']->isRightAvailable('pl_menu', 'elems_edit');
    $delete_rights = $_SESSION['sbPlugins']->isRightAvailable('pl_menu', 'elems_delete');

    $elems->mCategsJavascriptStr = '
        function sbMenuChangeRoot(cat_id)
        {
            if (cat_id == sbCatTree.getSelectedItemId())
            {
                var cat_title = sbCatTree.getItemText(cat_id);
                sbMenuTree.setItemText(sbMenuTree._gis[1], cat_title);
            }
		}';

	$unfold_js = '';
	$parent_js = '';

    if(isset($_GET['sb_sel_id']) && $_GET['sb_sel_id'] != '')
	{
		$res = sql_query('SELECT m_cat_id FROM sb_menu WHERE m_id=?d', $_GET['sb_sel_id']);
		if ($res)
		{
			$elems->mCategsSelectedId = $res[0][0];
			$res = sql_query('SELECT m.m_id FROM sb_menu AS m, sb_menu AS m2
							WHERE m2.m_left > m.m_left
							AND m2.m_right < m.m_right
							AND m2.m_id=?d
							AND m.m_level != 0
							AND m.m_cat_id = ?d
							ORDER BY m.m_left', $_GET['sb_sel_id'], $elems->mCategsSelectedId);
			if($res)
			{
				$parent_js = 'var parent_ids = [];';
				foreach($res as $key => $value)
				{
					$parent_js .= 'parent_ids['.$key.'] = '.$value[0].';';
				}

				$unfold_js = '
				var el = sbGetE("menu_list");
				if (!el || sbMenuTree._gis.length < 0)
					return;

				for(var i = 0; i < parent_ids.length; i++)
				{
					sbMenuTree.openItem(parent_ids[i]);
				}';
			}
		}
	}

    $elems->mHeaderStr = '
	    <style type="text/css">
	    	#menu_list span.treeItem
	    	{
	    		border:1px solid #E6E6E6;
	    	}
	    </style>
        <script>
       		'.$parent_js.'
            var sb_menu_max_deep = '.intval(sbPlugins::getSetting('sb_menu_max_deep')).';
            var sb_menu_max_items = '.intval(sbPlugins::getSetting('sb_menu_max_items')).';
            var sb_menu_edit_rights = '.($edit_rights ? 'true' : 'false').';
            var sb_menu_delete_rights = '.($delete_rights ? 'true' : 'false').';

            var sbCutMenuId = 0;
            var sbCopyMenuId = 0;
            var sbCopyCutMenuId = 0;

            function sbMenuAfterLoad()
			{
			    sbCategsPreloadImages();
			    '.$unfold_js.'
			    sbHideMsgDiv();

			    sbMenu.init();

			    if (sbCopyMenuId != 0)
			        sbMenuTree.doCopy(sbCopyMenuId);

			    if (sbCutMenuId != 0)
			        sbMenuTree.doCut(sbCutMenuId);
			}
        </script>
        <script src="'.SB_CMS_JSCRIPT_URL.'/sbMenu.js.php"></script>';

	$elems->mElemsAfterLoadFunc = 'sbMenuLoad';

	$elems->mCategsJavascriptStr .= '
		function sbMenuExport()
		{
			if(sbSelCat.id)
			{
				var cat_id = sbSelCat.id;
			}
			else
			{
				var cat_id = sbCatTree.getSelectedItemId();
			}

			var strPage = "'.SB_CMS_DIALOG_FILE.'?event=pl_export_edit&ident=pl_menu&cat_id="+ cat_id;
			var strAttr = "resizable=1,width=700,height=600";
			sbShowModalDialog(strPage, strAttr, null);
		}';
	$elems->addCategsMenuItem(PL_MENU_EDIT_EXPORT, 'sbMenuExport()');

	$elems->init();
}

function fMenu_Get($args)
{
    echo '<div id="menu_list"></div>';
}

function fMenu_Tree()
{
    if (isset($_GET['id']))
        $root_id = intval($_GET['id']);
    else
        $root_id = -1;

    $tree_id = 0;

    $sign_less = '<';
    $sign_more = '>';
    $level_incr = 4;
    if ($root_id == -1)
    {
        $res = sql_param_query('SELECT m_id FROM sb_menu WHERE m_level=0 AND m_cat_id=?d', $_GET['cat_id']);
        if (!$res)
        {
            $res = sql_param_query('SELECT cat_title FROM sb_categs WHERE cat_id=?d', $_GET['cat_id']);
            if (!$res)
                return;

            sql_param_query('INSERT INTO sb_menu (m_title, m_left, m_right, m_level, m_cat_id) VALUES (?, 1, 2, 0, ?d)', $res[0][0], $_GET['cat_id']);
            $root_id = sql_insert_id();
        }
        else
        {
            list($root_id) = $res[0];
        }

        $sign_less = '<=';
        $sign_more = '>=';
        $level_incr = 3;
    }
    else
    {
        $tree_id = $root_id;
    }

    $result = sql_param_query('SELECT m_left, m_right, m_level FROM sb_menu WHERE m_id=?d', $root_id);
    if (!$result)
        return;

    list ($root_left, $root_right, $root_level) = $result[0];

    $result = sql_param_query('SELECT m_id, m_left, m_right, m_level, m_title, m_show, m_type, m_url, m_status
                                   FROM sb_menu WHERE m_cat_id=?d AND m_right '.$sign_less.' ?d AND m_left '.$sign_more.' ?d
                                   ORDER BY m_left ASC', $_GET['cat_id'], $root_right, $root_left);

    if (!$result)
        return;

    $str = '';
    $user_data = '';
    $num = count($result);
    $old_level = 1;
    $stack = array();
    $closed = false;
    $open_tags = array();

	$workflow_status = array();

	if ($_SESSION['sbPlugins']->isPluginAvailable('pl_workflow') && $_SESSION['sbPlugins']->isPluginInWorkflow('pl_menu'))
	{
		$workflow_res = sql_query('SELECT w_title, w_code FROM sb_workflow');
		if($workflow_res)
		{
			foreach($workflow_res as $key => $value)
			{
				$workflow_status[$value[1]] = $value[0];
			}
		}
	}

    for ($i = 0; $i < $num; $i++)
    {
        list($m_id, $m_left, $m_right, $m_level, $m_title, $m_show, $m_type, $m_url, $m_status) = $result[$i];

        $m_imgs = '';
        switch($m_type)
        {
            case 'categs':
                $m_imgs = ' im0="menuCategs.gif" im1="menuCategs.gif" im2="menuCategs.gif" im_copy0="menuCategsCopy.gif" im_copy1="menuCategsCopy.gif" im_copy2="menuCategsCopy.gif" im_cut0="menuCategsCut.gif" im_cut1="menuCategsCut.gif" im_cut2="menuCategsCut.gif"';
                $m_title = '<span onclick="sbMenuTitleClick(event, '.$m_id.')">'.$m_title.'</span>';
                break;

            case 'delim':
                $m_imgs = ' im0="menuDelim.gif" im1="menuDelim.gif" im2="menuDelim.gif" im_copy0="menuDelimCopy.gif" im_copy1="menuDelimCopy.gif" im_copy2="menuDelimCopy.gif" im_cut0="menuDelimCut.gif" im_cut1="menuDelimCut.gif" im_cut2="menuDelimCut.gif"';
                break;

            case 'item':
            	if ($m_level != 0)
            		$m_title = '<span onclick="sbMenuTitleClick(event, '.$m_id.')">'.$m_title.'</span>';

                if ($m_url != '')
                {
                	if (SB_PORT != '80')
                	{
                		$m_url = preg_replace('!(http://)?(www.'.SB_COOKIE_DOMAIN.':'.SB_PORT.')(.*?)!i'.SB_PREG_MOD, '$3', $m_url);
                        $m_url = preg_replace('!(http://)?('.SB_COOKIE_DOMAIN.':'.SB_PORT.')(.*?)!i'.SB_PREG_MOD, '$3', $m_url);
                	}
                	else
                	{
                        $m_url = preg_replace('!(http://)?(www.'.SB_COOKIE_DOMAIN.')(.*?)!i'.SB_PREG_MOD, '$3', $m_url);
                        $m_url = preg_replace('!(http://)?('.SB_COOKIE_DOMAIN.')(.*?)!i'.SB_PREG_MOD, '$3', $m_url);
                	}

                    if (trim($m_url, '/\\') == '')
                    {
                    	$m_url = sbPlugins::getSetting('sb_directory_index');
                    }

                    $m_title .= ' (<a href="'.$m_url.'" target="_blank">'.trim($m_url, '/\\').'</a>)';
                }
                break;
        }

		if($m_status != 1 && isset($workflow_status[$m_status]) && $m_level != 0)
        {
			$m_title .= '<span style="margin-left:10px;color:#CC0066;font-size:11px;">'.$workflow_status[$m_status].'</span>';
        }

        $m_title = sb_htmlspecialchars($m_title, ENT_QUOTES);

        if (count($stack) > 0)
        {
            while (array_key_exists(count($stack)-1, $stack) && $stack[count($stack)-1] < $m_right)
            {
                array_pop($stack);
			}
		}

		$stack[] = $m_right;
		$new_level = count($stack);

		if ($new_level > $old_level)
		{
            $str .= 'child="1">'."\n".$user_data."\n";
            $open_tags[] = $m_id;
            if ($new_level > 2)
            {
                array_pop($stack);
                $cur_level = $m_level;

                $found = false;
                for ($i = $i + 1; $i < $num; $i++)
                {
                	$found = true;

                    list($m_id, $m_left, $m_right, $m_level, $m_title, $m_show, $m_type, $m_url, $m_status) = $result[$i];
                    if ($m_level < $cur_level)
                    {
                        break;
                    }
                }

                if ($found)
                {
                	$m_imgs = '';
			        switch($m_type)
			        {
			            case 'categs':
			                $m_imgs = ' im0="menuCategs.gif" im1="menuCategs.gif" im2="menuCategs.gif" im_copy0="menuCategsCopy.gif" im_copy1="menuCategsCopy.gif" im_copy2="menuCategsCopy.gif" im_cut0="menuCategsCut.gif" im_cut1="menuCategsCut.gif" im_cut2="menuCategsCut.gif"';
			                $m_title = '<span onclick="sbMenuTitleClick(event, '.$m_id.')">'.$m_title.'</span>';
			                break;

			            case 'delim':
			                $m_imgs = ' im0="menuDelim.gif" im1="menuDelim.gif" im2="menuDelim.gif" im_copy0="menuDelimCopy.gif" im_copy1="menuDelimCopy.gif" im_copy2="menuDelimCopy.gif" im_cut0="menuDelimCut.gif" im_cut1="menuDelimCut.gif" im_cut2="menuDelimCut.gif"';
			                break;

			            case 'item':
			            	$m_title = '<span onclick="sbMenuTitleClick(event, '.$m_id.')">'.$m_title.'</span>';

			                if ($m_url != '')
			                {
			                    if (SB_PORT != '80')
			                    {
			                        $m_url = preg_replace('!(http://)?(www.'.SB_COOKIE_DOMAIN.':'.SB_PORT.')(.*?)!i'.SB_PREG_MOD, '$3', $m_url);
			                        $m_url = preg_replace('!(http://)?('.SB_COOKIE_DOMAIN.':'.SB_PORT.')(.*?)!i'.SB_PREG_MOD, '$3', $m_url);
			                    }
			                    else
			                    {
			                        $m_url = preg_replace('!(http://)?(www.'.SB_COOKIE_DOMAIN.')(.*?)!i'.SB_PREG_MOD, '$3', $m_url);
			                        $m_url = preg_replace('!(http://)?('.SB_COOKIE_DOMAIN.')(.*?)!i'.SB_PREG_MOD, '$3', $m_url);
			                    }

			                    if (trim($m_url, '/\\') == '')
			                    {
			                    	$m_url = sbPlugins::getSetting('sb_directory_index');
			                    }

			                    $m_title .= ' (<a href="'.$m_url.'" target="_blank">'.trim($m_url, '/\\').'</a>)';
			                }
			                break;
			        }

					if($m_status != 1 && isset($workflow_status[$m_status]) && $m_level != 0)
					{
						$m_title .= '<span style="margin-left:10px;color:#CC0066;font-size:11px;">'.$workflow_status[$m_status].'</span>';
			        }
					$m_title = sb_htmlspecialchars($m_title, ENT_QUOTES);
                }

                $str .= '</item>'."\n";
                $closed = true;
                array_pop($open_tags);
                if ($m_level >= $cur_level)
                {
                    break;
                }
                array_pop($stack);
                $i--;
                continue;
            }
            $str .= '<item text="'.$m_title.'" id="'.$m_id.'" level="'.($m_level + 1).'"'.($m_show == 1 ? ' checked="1"' : '').(isset($_GET['open']) ? ' open="1"' : '').$m_imgs.' ';
            $closed = false;
            $old_level = $new_level;
        }
        elseif($new_level < $old_level)
        {
            $str .= (!$closed ? '>'."\n".$user_data.'</item>' : '');
            for ($j = 0; $j < $old_level-$new_level; $j++)
            {
                $str .= '</item>'."\n";
                array_pop($open_tags);
            }
            $old_level = $new_level;
            $str .= '<item text="'.$m_title.'" id="'.$m_id.'" level="'.($m_level + 1).'"'.($m_show == 1 ? ' checked="1"' : '').(isset($_GET['open']) ? ' open="1"' : '').$m_imgs.' ';
            $closed = false;
        }
        else
        {
            $str .= (!$closed && $str != '' ? '>'."\n".$user_data.'</item>' : '').'<item text="'.$m_title.'" id="'.$m_id.'" level="'.($m_level + 1).'"'.($m_level == 0 || isset($_GET['open']) ? ' open="1"':'').($m_show == 1 ? ' checked="1"' : '').$m_imgs.' ';
            $closed = false;
        }

        $user_data = '<userdata name="m_type">'.$m_type.'</userdata>';
    }

    if (!$closed && $str != '') $str .= '>'."\n".$user_data.'</item>';

    for ($i = 0; $i < count($open_tags); $i++)
        $str .= '</item>'."\n";

    $str = '<?xml version="1.0" encoding="'.SB_CHARSET.'" ?>'."\n".'<tree id="'.$tree_id.'">'."\n".$str.'</tree>';

	echo $str;
}

function fMenu_Check()
{
	$res = sql_param_query('SELECT m_title, m_status FROM sb_menu WHERE m_id=?d', $_GET['m_id']);
	if (!$res)
	{
		echo PL_MENU_CHECK_ERROR;
		return;
	}

	list($m_title, $m_status) = $res[0];

	$edit_rights = $_SESSION['sbPlugins']->isRightAvailable('pl_menu', 'elems_edit');
	$edit_rights = $edit_rights && sb_workflow_status_available('all', 'pl_menu', $_GET['m_id'], $m_status);
	if (!$edit_rights)
	{
		echo PL_MENU_CHECK_STATUS_ERROR;
		return;
	}

    $res = sql_param_query('UPDATE sb_menu SET m_show=?d WHERE m_id=?d', $_GET['state'], $_GET['m_id'], sprintf(PL_MENU_SYSLOG_CHECK_OK, $m_title));

    if (!$res)
    {
        sb_add_system_message(sprintf(PL_MENU_SYSLOG_CHECK_ERROR, $m_title), SB_MSG_WARNING);
    }
}

function fMenu_Add_Edit()
{
	// проверка прав доступа
	if (!fCategs_Check_Elems_Rights(0, $_GET['m_cat_id'], 'pl_menu'))
		return;

	$edit_rights = $_SESSION['sbPlugins']->isRightAvailable('pl_menu', 'elems_edit');

    if (count($_POST) == 0 && isset($_GET['m_id']) && $_GET['m_id'] != '')
    {
		$res = sql_param_query('SELECT m.m_title, m.m_text, m.m_url, m.m_alt, m.m_target, m.m_type, m.m_props, c.cat_rights, m.m_status, m.m_show
                                FROM sb_menu m, sb_categs c
                                WHERE m.m_id=?d AND m.m_cat_id=c.cat_id', $_GET['m_id']);

        if ($res)
        {
            list($m_title, $m_text, $m_url, $m_alt, $m_target, $m_type, $m_props, $cat_rights, $m_status, $m_show) = $res[0];
            $_GET['m_id_p'] = '';

            if ($m_props != '')
            {
                $m_props = unserialize($m_props);
            }
            else
            {
                $m_props = array();
            }
        }
        else
        {
            sb_show_message(PL_MENU_EDIT_ERROR_NO_ITEM, true, 'warning');
            return;
        }
    }
    elseif (count($_POST) > 0)
	{
		$m_show = 0;
		$m_status = 0;

    	extract($_POST);
    	if (!isset($_GET['m_id']))
            $_GET['m_id'] = '';

    	$res = sql_param_query('SELECT cat_rights FROM sb_categs WHERE cat_id=?d', $_GET['m_cat_id']);
        if ($res)
        {
            list($cat_rights) = $res[0];
        }
        else
        {
            sb_show_message(PL_MENU_EDIT_ERROR_NO_ITEM, true, 'warning');
            return;
        }
	}
    else
    {
        $res = sql_param_query('SELECT cat_rights FROM sb_categs WHERE cat_id=?d', $_GET['m_cat_id']);
        if ($res)
        {
            list($cat_rights) = $res[0];

            $m_title = '';
            $m_text = '';
            $m_url = '';
            $m_alt = '';
            $m_target = '';
            $m_props = array();
			$m_show = $m_status = 1;
            $m_type = preg_replace('/[^a-z]+/', '', $_GET['type']);

            $_GET['m_id'] = '';
        }
        else
        {
            sb_show_message(PL_MENU_EDIT_ERROR_NO_ITEM, true, 'warning');
            return;
        }
    }

    if (!fCategs_Check_Rights($cat_rights, true))
    {
        sb_show_message(SB_ELEMS_DENY_MSG, true, 'warning');
        return;
    }

    echo '<script>';

    if ($m_type == 'item')
    {
    	echo 'function checkValues()
    	{
    	    var m_title = sbGetE("m_title");
            if (m_title.value == "")
    		{
    			alert("'.PL_MENU_NO_TITLE_MSG.'");
                m_title.focus();
        		return false;
    		}

    		var txtElVal = "";
    		var codeEditor = true;
    		var txtEl = eval("window.sbCodeditor_m_text");
    		if (txtEl)
    		{
    			txtElVal = txtEl.getCode();
    		}
    		else
    		{
    			codeEditor = false;
    			txtEl = sbGetE("m_text");
    			txtElVal = txtEl.value;
    		}

    		if (txtEl && txtElVal == "")
    		{
    			var titleEl = sbGetE("m_title");
    			if (codeEditor)
    			{
    				txtEl.setCode(titleEl.value);
    			}
    			else
    			{
    				txtEl.value = titleEl.value;
    			}
    		}

    		return true;
    	}';
    }
    elseif ($m_type == 'categs')
    {
        echo 'function checkValues()
    	{
    	    var cat_el = sbGetE("m_props_cat_id");
    		if (cat_el.value == "")
    		{
    		    alert("'.PL_MENU_EDIT_CATEGS_NO_CAT_MSG.'");
        		return false;
    		}

    		var el_from = sbGetE("spin_m_props_from");
            var el_to = sbGetE("spin_m_props_to");
            if (el_to.value <= 0) el_to.value = "";

            if (el_to.value != "" && parseInt(el_from.value) > parseInt(el_to.value))
            {
                alert("'.PL_MENU_EDIT_CATEGS_FROM_TO_ERROR.'");
                return false;
            }

    		return true;
    	}
        function changeIdent(el)
        {
            var cat_el = sbGetE("m_props_cat_id");
            var text_el = sbGetE("m_props_cat_id_text");
            var cat_cat_el = sbGetE("m_props_cat_id_cat");
            var ident_el = sbGetE("m_props_cat_id_ident");

            cat_el.value = "";
            text_el.innerHTML = "<b style=\'font-size:11px;\'>'.SB_LAYOUT_NO_SPRAV.'</b>";
            cat_cat_el.value = "";
            ident_el.value = el.value;

            var temps_td = sbGetE("m_props_temps_td");
            temps_td.innerHTML = "<div class=\"hint_div\">'.KERNEL_LOADING.'</div>";

            var page_tr = sbGetE("page_tr");
            if (el.value == "pl_pages")
            {
            	page_tr.style.display = "none";
            }
            else
            {
            	page_tr.style.display = "";
            }

            sbLoadAsync(sb_cms_empty_file + "?event=pl_menu_load_categs_temps&ident="+el.value, afterLoadTemps);
        }

        function changeTemps(el)
        {
        	var target_tr = sbGetE("target_tr");
        	if (el.value == -1)
        	{
        		target_tr.style.display = "";
        	}
        	else
        	{
        		target_tr.style.display = "none";
        	}
        }

        function afterLoadTemps(res)
        {
            var temps_td = sbGetE("m_props_temps_td");
            temps_td.innerHTML = res;
        }';
    }

    echo 'function changeTarget(el)
	{
	    if (el.value == "other")
	    {
	        sbGetE("m_target_other").style.display = "";
	    }
	    else
	    {
	        sbGetE("m_target_other").style.display = "none";
	    }
	}

	function setText(el)
	{
	    var txtEl = eval("window.sbCodeditor_m_text");
	    if (txtEl)
	    {
	    	if (txtEl.getCode() == "")
		    {
		        txtEl.setCode(el.value);
		    }
	    }
	    else
	    {
	    	txtEl = sbGetE("m_text");
	    	if (txtEl.value == "")
	    	{
	        	txtEl.value = el.value;
	    	}
	    }
	}

	function changePage()
	{
	    var el_title = sbGetE("m_title");
	    var el_alt = sbGetE("m_alt");
	    var p_title = sbGetE("m_url_title").value;

	    if (el_title.value == "")
	    {
	       el_title.value = p_title;
	    }

   		var el_text = eval("window.sbCodeditor_m_text");
    	if (el_text)
    	{
    		if (el_text.getCode() == "")
				el_text.setCode(p_title);
    	}
    	else
    	{
    		el_text = sbGetE("m_text");
    		if (el_text.value == "")
    			el_text.value = p_title;
    	}

	    if (p_title != "")
	    {
			el_alt.value = p_title;
	    }
	}
	</script>';
	require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

	$layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE.'?event=pl_menu_add_edit_submit'.($_SERVER['QUERY_STRING'] != '' ? '&'.$_SERVER['QUERY_STRING'] : ''), 'thisDialog', 'post', 'checkValues()', '', 'enctype="multipart/form-data"');
	$layout->mTitleWidth = 200;

    if ($m_type == 'item')
    {
        $layout->addHeader($_GET['m_id'] != '' ? PL_MENU_EDIT_EDIT_HEADER : PL_MENU_EDIT_ADD_HEADER);

        $layout->addField(PL_MENU_EDIT_TITLE, new sbLayoutInput('text', $m_title, 'm_title', '', 'onblur="setText(this);" style="width:495px;"', true));
        $layout->addField('', new sbLayoutDelim());
        $fld = new sbLayoutTextarea($m_text, 'm_text', '', 'style="width:100%;"');
        $fld->mShowEditorBtn = true;
        $layout->addField(PL_MENU_EDIT_TEXT, $fld);
        $layout->addField('', new sbLayoutDelim());

		fClouds_Get_Field($layout, 'm_tags', $_GET['m_id'], 'pl_menu');

        $layout->addField(PL_MENU_EDIT_URL, new sbLayoutPage($m_url, 'm_url', '', 'onchange="changePage();" style="width: 475px;"'));
		$layout->addField(PL_MENU_EDIT_ALT, new sbLayoutInput('text', $m_alt, 'm_alt', '', 'style="width:510px;"'));

        $options = array(
			'' => PL_MENU_EDIT_TARGET_NOT_SELECTED,
            '_blank' => PL_MENU_EDIT_TARGET_BLANK,
            '_parent' => PL_MENU_EDIT_TARGET_PARENT,
            '_top' => PL_MENU_EDIT_TARGET_TOP,
            '_self' => PL_MENU_EDIT_TARGET_SELF,
            'other' => PL_MENU_EDIT_TARGET_OTHER);

        $show_other = !array_key_exists($m_target, $options);
        $fld1 = new sbLayoutInput('text', $show_other ? $m_target : '', 'm_target_other', '', $show_other ? '' : 'style="display:none;"');

        $fld = new sbLayoutSelect($options, 'm_target', '', 'onkeydown="changeTarget(this);" onchange="changeTarget(this);"');
        $fld->mSelOptions = array($m_target);
        $fld->mHTML = '&nbsp;&nbsp;&nbsp;'.$fld1->getField();

        $layout->addField(PL_MENU_EDIT_TARGET, $fld);
		$layout->addField(PL_MENU_EDIT_SHOW, new sbLayoutInput('checkbox', '1', 'm_show', '', (isset($m_show) && $m_show == 1 ? 'checked="checked"' : '')));

		if($_SESSION['sbPlugins']->isPluginAvailable('pl_workflow') && $_SESSION['sbPlugins']->isPluginInWorkflow('pl_menu'))
		{
			$edit_rights = $edit_rights && sb_add_workflow_status($layout, 'pl_menu', $_GET['m_id'], 'm_status', isset($m_status) ? $m_status : '');
		}

        $layout->getPluginFields('pl_menu', $_GET['m_id'], 'm_id');

        if ($layout->getTabCount() <= 0)
            echo '<br /><br />';
    }
    elseif ($m_type == 'categs')
    {
        echo '<br /><br />';

        $layout->addHeader($_GET['m_id'] != '' ? PL_MENU_EDIT_CATEGS_EDIT_HEADER : PL_MENU_EDIT_CATEGS_ADD_HEADER);

        $options = array();
        foreach ($_SESSION['sbPlugins']->mRubrikator as $key => $value)
        {
            $options[$key] = $value['title'];
        }

        $fld = new sbLayoutSelect($options, 'm_props[ident]', '', 'onkeydown="changeIdent(this);" onchange="changeIdent(this);"');
        if (isset($m_props['ident']))
        {
            $fld->mSelOptions[] = $m_props['ident'];
            $ident = $m_props['ident'];
        }

        $layout->addField(PL_MENU_EDIT_CATEGS_PLUGIN, $fld);

        if (!isset($ident))
        {
            reset($_SESSION['sbPlugins']->mRubrikator);
            $m_rubrikator = each($_SESSION['sbPlugins']->mRubrikator);
            if (!$m_rubrikator)
            {
                $ident = '';
            }
            else
            {
                $ident = $m_rubrikator['key'];
                $m_rubrikator = $m_rubrikator['value'];
            }
        }
        else
        {
            $m_rubrikator = $_SESSION['sbPlugins']->mRubrikator[$ident];
        }

        $fld = new sbLayoutCategs($ident, '', isset($m_props['cat_id']) ? $m_props['cat_id'] : '', 'm_props[cat_id]', 'm_props_cat_id', '', true);
        $fld->mHTML = '<br />';
        $fld->mDropButton = false;
        $fld->mMultiSelect = true;

        $layout->addField(PL_MENU_EDIT_CATEGS_CAT_ID, $fld);

        $options = array('-1' => '('.PL_MENU_EDIT_CATEGS_NO_TEMP.')');
        if ($ident != '')
        {
            $res = sql_query('SELECT categs.cat_title, temps.ctl_id, temps.ctl_title FROM sb_categs categs, sb_catlinks links, sb_categs_temps_list temps WHERE temps.ctl_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="'.$m_rubrikator['temps_list_ident'].'" ORDER BY categs.cat_left, temps.ctl_title');
            if ($res)
            {
                $old_cat_title = '';
                foreach ($res as $value)
                {
                    list($cat_title, $ctl_id, $ctl_title) = $value;
                    if ($old_cat_title != $cat_title)
                    {
                        $options[uniqid()] = '-'.$cat_title;
                        $old_cat_title = $cat_title;
                    }
                    $options[$ctl_id] = $ctl_title;
                }
            }
        }

    	$fld = new sbLayoutSelect($options, 'm_props[temp_id]', '', 'onkeydown="changeTemps(this);" onchange="changeTemps(this);"');
        if (isset($m_props['temp_id']))
        {
            $fld->mSelOptions = array($m_props['temp_id']);
        }

        $layout->addField('', new sbLayoutDelim());
        $layout->addField(PL_MENU_EDIT_CATEGS_TEMP, $fld, '', 'id="m_props_temps_td"');
    	$layout->addField('', new sbLayoutDelim());

    	$fld1 = new sbLayoutInput('input', (isset($m_props['from']) ? $m_props['from'] : '2'), 'm_props[from]', 'spin_m_props_from', 'style="width: 50px;"');
	    $fld1->mMinValue = 1;
	    $fld2 = new sbLayoutInput('input', (isset($m_props['to']) ? $m_props['to'] : ''), 'm_props[to]', 'spin_m_props_to', 'style="width: 50px;"');

	    $html = $fld1->getJavaScript().'<table cellpadding="0" cellspacing="0"><tr><td style="background-color:#FFF5E0;">'.$fld1->getField().'</td><td style="background-color:#FFF5E0;">&nbsp;&nbsp;'.KERNEL_TO.'&nbsp;&nbsp;</td><td style="background-color:#FFF5E0;">'.$fld2->getField().'</td></tr></table>
	              <div class="hint_div" style="margin-top: 5px;">'.PL_MENU_EDIT_CATEGS_FROM_TO_HINT.'</div>';

	    $fld = new sbLayoutHTML($html);
	    $layout->addField(PL_MENU_EDIT_CATEGS_FROM_TO, $fld);
	    $layout->addField('', new sbLayoutDelim());

	    $layout->addField(PL_MENU_EDIT_CATEGS_SHOW_HIDDEN, new sbLayoutInput('checkbox', '1', 'm_props[show_hidden]', '', (isset($m_props['show_hidden']) && $m_props['show_hidden'] == 1 ? 'checked="checked"' : '')));

    	$layout->addField(PL_MENU_EDIT_CATEGS_PAGE, new sbLayoutPage($m_url, 'm_url', '', 'style="width: 475px;"'), '', '', 'id="page_tr"'.($ident == "pl_pages" ? ' style="display:none;"' : ''));
    	$options = array(
            '' => PL_MENU_EDIT_TARGET_NOT_SELECTED,
            '_blank' => PL_MENU_EDIT_TARGET_BLANK,
            '_parent' => PL_MENU_EDIT_TARGET_PARENT,
            '_top' => PL_MENU_EDIT_TARGET_TOP,
            '_self' => PL_MENU_EDIT_TARGET_SELF,
            'other' => PL_MENU_EDIT_TARGET_OTHER);

        $show_other = !array_key_exists($m_target, $options);
        $fld1 = new sbLayoutInput('text', $show_other ? $m_target : '', 'm_target_other', '', $show_other ? '' : 'style="display:none;"');

        $fld = new sbLayoutSelect($options, 'm_target', '', 'onkeydown="changeTarget(this);" onchange="changeTarget(this);"');
        $fld->mSelOptions = array($m_target);
        $fld->mHTML = '&nbsp;&nbsp;&nbsp;'.$fld1->getField();

        $layout->addField(PL_MENU_EDIT_TARGET, $fld, '', '', 'id="target_tr"'.(isset($m_props['temp_id']) && $m_props['temp_id'] != -1 ? ' style="display: none;"' : ''));

        $layout->addField(PL_MENU_EDIT_SHOW, new sbLayoutInput('checkbox', '1', 'm_show', '', (isset($m_show) && $m_show == 1 ? 'checked="checked"' : '')));

		if($_SESSION['sbPlugins']->isPluginAvailable('pl_workflow') && $_SESSION['sbPlugins']->isPluginInWorkflow('pl_menu'))
		{
			$edit_rights = $edit_rights && sb_add_workflow_status($layout, 'pl_menu', $_GET['m_id'], 'm_status', isset($m_status) ? $m_status : '');
		}
    }

    $layout->addField('', new sbLayoutInput('hidden', $m_type, 'm_type'));

    $layout->addButton('submit', KERNEL_SAVE, '', '', ($edit_rights ? '' : 'disabled="disabled"'));
    $layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog()"');
    $layout->show();
}

function fMenu_Load_Categs_Temps()
{
    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

    $options = array('-1' => '('.PL_MENU_EDIT_CATEGS_NO_TEMP.')');
    $ident = preg_replace('/[^a-zA-Z_0-9]+/', '', $_GET['ident']);

    $res = false;
    if ($ident == 'pl_pages')
    {
	    $res = sql_query('SELECT categs.cat_title, temps.mt_id, temps.mt_title FROM sb_categs categs, sb_catlinks links, sb_menu_temps temps WHERE temps.mt_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_menu_temps" ORDER BY categs.cat_left, temps.mt_title');

    }
    elseif (isset($_SESSION['sbPlugins']->mRubrikator[$ident]))
    {
        $ident = $_SESSION['sbPlugins']->mRubrikator[$ident]['temps_list_ident'];

        if ($ident != '')
        {
            $res = sql_query('SELECT categs.cat_title, temps.ctl_id, temps.ctl_title FROM sb_categs categs, sb_catlinks links, sb_categs_temps_list temps WHERE temps.ctl_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="'.$ident.'" ORDER BY categs.cat_left, temps.ctl_title');
        }
    }

	if ($res)
    {
        $old_cat_title = '';
        foreach ($res as $value)
        {
            list($cat_title, $mt_id, $mt_title) = $value;
            if ($old_cat_title != $cat_title)
            {
                $options[uniqid()] = '-'.$cat_title;
                $old_cat_title = $cat_title;
            }
            $options[$mt_id] = $mt_title;
        }
    }

	$fld = new sbLayoutSelect($options, 'm_props[temp_id]', '', 'onkeydown="changeTemps(this);" onchange="changeTemps(this);"');
    $html = $fld->getField();

    str_replace(array("\r\n", "\r", "\n"), '', $html);

    echo $html;
}

function fMenu_Add_Edit_Submit()
{
	// проверка прав доступа
	if (!fCategs_Check_Elems_Rights(0, $_GET['m_cat_id'], 'pl_menu'))
		return;

    if (!isset($_GET['m_id']))
    	$_GET['m_id'] = '';

    $m_show = 0;
	$m_status = 0;

    extract($_POST);
    $m_cat_id = intval($_GET['m_cat_id']);

    $res = sql_param_query('SELECT cat_title, cat_rights FROM sb_categs WHERE cat_id=?d', $_GET['m_cat_id']);
    if ($res)
    {
        list($cat_title, $cat_rights) = $res[0];
        if (!fCategs_Check_Rights($cat_rights, true))
        {
            sb_show_message(SB_ELEMS_DENY_MSG, false, 'warning');
            fMenu_Add_Edit();
            return;
        }
    }
    else
    {
        sb_show_message(PL_MENU_EDIT_ERROR_NO_ITEM, false, 'warning');
        fMenu_Add_Edit();
        return;
    }

	$workflow_status = '';
	if($_SESSION['sbPlugins']->isPluginAvailable('pl_workflow') && $_SESSION['sbPlugins']->isPluginInWorkflow('pl_menu'))
	{
		if (intval($m_status) != 1)
		{
			$workflow_res = sql_param_query('SELECT w_title FROM sb_workflow WHERE w_code = ?d', $m_status);
			if($workflow_res && $workflow_res[0][0] != '')
			{
				$workflow_status = '<span style="margin-left:10px;color:#CC0066;font-size:11px;">'.$workflow_res[0][0].'</span>';
			}
		}
	}
	else
	{
		$m_status = 1;
		$_POST['m_status'] = 1;
	}

    if ($m_type == 'item')
    {
        require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

        $layout = new sbLayout();
        $row = $layout->checkPluginFields('pl_menu', $_GET['m_id'], 'm_id');
        if ($row === false)
        {
            $layout->deletePluginFieldsFiles();
            fMenu_Add_Edit();
            return;
        }

        $row['m_title'] = $m_title;
        $row['m_text'] = $m_text;
        $row['m_url'] = $m_url;
        $row['m_alt'] = $m_alt;
        $row['m_target'] = ($m_target == 'other' ? $m_target_other : $m_target);
		$row['m_show'] = intval($m_show);

		sb_submit_workflow_status($row, 'm_status');

		if($_GET['m_id'] != '')
        {
            //редактирование
            $error = true;
            $res = sql_param_query('SELECT m_title FROM sb_menu WHERE m_id=?d', $_GET['m_id']);
            if ($res)
            {
                list($old_title) = $res[0];

                $result = sql_param_query('UPDATE sb_menu SET ?a WHERE m_id=?d', $row, $_GET['m_id'], sprintf(PL_MENU_SYSLOG_EDIT_OK, $old_title, $cat_title));
                if ($result)
                {
                    if ($m_url != '')
                    {
	                    if (SB_PORT != '80')
	                    {
	                        $m_url = preg_replace('!(http://)?(www.'.SB_COOKIE_DOMAIN.':'.SB_PORT.')(.*?)!i'.SB_PREG_MOD, '$3', $m_url);
	                        $m_url = preg_replace('!(http://)?('.SB_COOKIE_DOMAIN.':'.SB_PORT.')(.*?)!i'.SB_PREG_MOD, '$3', $m_url);
	                    }
	                    else
	                    {
	                        $m_url = preg_replace('!(http://)?(www.'.SB_COOKIE_DOMAIN.')(.*?)!i'.SB_PREG_MOD, '$3', $m_url);
	                        $m_url = preg_replace('!(http://)?('.SB_COOKIE_DOMAIN.')(.*?)!i'.SB_PREG_MOD, '$3', $m_url);
	                    }

                        $m_title .= ' (<a href="'.$m_url.'" target="_blank">'.trim($m_url, '/\\').'</a>)';
                    }

		    		fClouds_Set_Field($_GET['m_id'], 'pl_menu', $m_tags);

                    $m_title = '<span onclick="sbMenuTitleClick(event, '.$_GET['m_id'].')">'.$m_title.'</span>';

                    echo '<script>
            	        var res = new Object();
                        res.m_title = "'.str_replace('"', '\\"', $m_title.$workflow_status).'";
                        res.m_show = '.$row['m_show'].';
                        sbReturnValue(res);
            		  </script>';

                    $error = false;
                }
            }

            if ($error)
            {
                sb_show_message(PL_MENU_EDIT_ERROR_NO_ITEM, false, 'warning');
                sb_add_system_message(sprintf(PL_MENU_SYSLOG_EDIT_ERROR, $m_title, $cat_title), SB_MSG_WARNING);

                $layout->deletePluginFieldsFiles();
                fMenu_Add_Edit();
                return;
            }
            else
            {
            	sb_mail_workflow_status('pl_menu', $_GET['m_id'], $m_title, $m_status);
            }
        }
        else
        {
			require_once(SB_CMS_LIB_PATH.'/sbTree.inc.php');

            //добавление
            $tree = new sbTree($m_cat_id);
            $tree->setSettings('sb_menu', 'm_right', 'm_left', 'm_level', 'm_id', 'm_cat_id');

			$row['m_type'] = 'item';
            $row['m_props'] = '';
			$row['m_show'] = intval($m_show);

            $m_id = $tree->insertNode($_GET['m_id_p'], $row);
            if ($m_id)
            {
                sb_add_system_message(sprintf(PL_MENU_SYSLOG_ADD_OK, $m_title, $cat_title));

                $m_title = '<span onclick="sbMenuTitleClick(event, '.$m_id.')">'.$m_title.'</span>';

                if ($m_url != '')
                {
                    if (SB_PORT != '80')
                    {
                        $m_url = preg_replace('!(http://)?(www.'.SB_COOKIE_DOMAIN.':'.SB_PORT.')(.*?)!i'.SB_PREG_MOD, '$3', $m_url);
                        $m_url = preg_replace('!(http://)?('.SB_COOKIE_DOMAIN.':'.SB_PORT.')(.*?)!i'.SB_PREG_MOD, '$3', $m_url);
                    }
                    else
                    {
                        $m_url = preg_replace('!(http://)?(www.'.SB_COOKIE_DOMAIN.')(.*?)!i'.SB_PREG_MOD, '$3', $m_url);
                        $m_url = preg_replace('!(http://)?('.SB_COOKIE_DOMAIN.')(.*?)!i'.SB_PREG_MOD, '$3', $m_url);
                    }

                    $m_title .= ' (<a href="'.$m_url.'" target="_blank">'.trim($m_url, '/\\').'</a>)';
				}

				fClouds_Set_Field($m_id, 'pl_menu', $m_tags);

				sb_mail_workflow_status('pl_menu', $m_id, $m_title, $m_status);

                echo '<script>
        	        var res = new Object();
            	    res.m_id = '.$m_id.';
                    res.m_title = "'.str_replace('"', '\\"', $m_title.$workflow_status).'";
                    res.m_type = "'.$m_type.'";
                    res.m_show = '.$row['m_show'].';

                    sbReturnValue(res);
        		  </script>';
            }
            else
            {
                sb_show_message(PL_MENU_ADD_ERROR, false, 'warning');
                sb_add_system_message(sprintf(PL_MENU_SYSLOG_ADD_ERROR, $m_title, $cat_title), SB_MSG_WARNING);
                fMenu_Add_Edit();
                return;
            }
        }
    }
    elseif ($m_type == 'categs')
    {
        if (isset($_SESSION['sbPlugins']->mRubrikator[$m_props['ident']]))
        {
            $plugin_title = $_SESSION['sbPlugins']->mRubrikator[$m_props['ident']]['title'];
        }
        else
        {
            sb_show_message(PL_MENU_EDIT_ERROR_NO_PLUGIN, false, 'warning');
            fMenu_Add_Edit();
            return;
        }

        $res = sql_param_query('SELECT cat_title FROM sb_categs WHERE cat_id=?d', $m_props['cat_id']);
        if (!$res)
        {
            sb_show_message(PL_MENU_EDIT_ERROR_NO_CATEG, false, 'warning');
            fMenu_Add_Edit();
            return;
        }
        else
        {
            list($cat_title) = $res[0];
        }

        $m_props['plugin_ident'] = $_SESSION['sbPlugins']->mRubrikator[$m_props['ident']]['plugin_ident'];
        $m_props['get_ident'] = $_SESSION['sbPlugins']->mRubrikator[$m_props['ident']]['get_ident'];

        $m_title = sprintf(PL_MENU_EDIT_CATEGS_TITLE, $plugin_title, $cat_title);
        $row['m_title'] = $m_title;
        $row['m_text'] = '';
        $row['m_url'] = $m_url;
        $row['m_alt'] = '';
        $row['m_target'] = ($m_target == 'other' ? $m_target_other : $m_target);
        $row['m_props'] = serialize($m_props);
		$row['m_show'] = intval($m_show);

		sb_submit_workflow_status($row, 'm_status');

        if($_GET['m_id'] != '')
        {
            //редактирование
            $error = true;
            $res = sql_param_query('SELECT m_title FROM sb_menu WHERE m_id=?d', $_GET['m_id']);
            if ($res)
            {
				list($old_title) = $res[0];

                $result = sql_param_query('UPDATE sb_menu SET ?a WHERE m_id=?d', $row, $_GET['m_id'], sprintf(PL_MENU_SYSLOG_EDIT_OK, $old_title, $cat_title));
                if ($result)
                {
                    $m_title = '<span onclick="sbMenuTitleClick(event, '.$_GET['m_id'].')">'.$m_title.'</span>';

                    echo '<script>
            	        var res = new Object();
                        res.m_title = "'.str_replace('"', '\\"', $m_title.$workflow_status).'";
                        res.m_show = '.$row['m_show'].';
                        sbReturnValue(res);
            		  </script>';

                    $error = false;
                }
            }

            if ($error)
            {
                sb_show_message(PL_MENU_EDIT_ERROR_NO_ITEM, false, 'warning');
                sb_add_system_message(sprintf(PL_MENU_SYSLOG_EDIT_ERROR, $m_title, $cat_title), SB_MSG_WARNING);
                fMenu_Add_Edit();
                return;
            }
            else
            {
            	sb_mail_workflow_status('pl_menu', $_GET['m_id'], $row['m_title'], $m_status);
            }
        }
        else
        {
			require_once(SB_CMS_LIB_PATH.'/sbTree.inc.php');
            //добавление
            $tree = new sbTree($m_cat_id);
            $tree->setSettings('sb_menu', 'm_right', 'm_left', 'm_level', 'm_id', 'm_cat_id');

        	$row['m_type'] = 'categs';
            $row['m_status'] = intval($m_status);
			$row['m_show'] = intval($m_show);

            $m_id = $tree->insertNode($_GET['m_id_p'], $row);

            $m_title = '<span onclick="sbMenuTitleClick(event, '.$m_id.')">'.$m_title.'</span>';

            if ($m_id)
            {
                sb_add_system_message(sprintf(PL_MENU_SYSLOG_ADD_OK, $m_title, $cat_title));

                echo '<script>
        	        var res = new Object();
            	    res.m_id = '.$m_id.';
                    res.m_title = "'.str_replace('"', '\\"', $m_title.$workflow_status).'";
                    res.m_type = "'.$m_type.'";
                    res.m_show = '.$row['m_show'].';
                    sbReturnValue(res);
        		  </script>';

                sb_mail_workflow_status('pl_menu', $m_id, $row['m_title'], $m_status);
            }
			else
            {
                sb_show_message(PL_MENU_ADD_ERROR, false, 'warning');
                sb_add_system_message(sprintf(PL_MENU_SYSLOG_ADD_ERROR, $m_title, $cat_title), SB_MSG_WARNING);
                fMenu_Add_Edit();
                return;
            }
        }
    }
}

function fMenu_Add_Delim()
{
    $m_cat_id = intval($_GET['m_cat_id']);

    $res = sql_param_query('SELECT cat_title, cat_rights FROM sb_categs WHERE cat_id=?d', $_GET['m_cat_id']);
    if ($res)
    {
        list($cat_title, $cat_rights) = $res[0];
        if (!fCategs_Check_Rights($cat_rights, true))
        {
            echo SB_ELEMS_DENY_MSG;
            return;
        }
    }
    else
    {
        echo PL_MENU_EDIT_ERROR_NO_ITEM;
        return;
    }

    require_once(SB_CMS_LIB_PATH.'/sbTree.inc.php');
    //добавление
    $tree = new sbTree($m_cat_id);
    $tree->setSettings('sb_menu', 'm_right', 'm_left', 'm_level', 'm_id', 'm_cat_id');

    $row['m_title'] = '----------';
    $row['m_text'] = '';
    $row['m_url'] = '';
    $row['m_alt'] = '';
    $row['m_target'] = '';
    $row['m_props'] = '';
    $row['m_type'] = 'delim';
    $row['m_show'] = 1;
    $row['m_status'] = 1;

    $m_id = $tree->insertNode($_GET['m_id'], $row);
    if ($m_id)
    {
        sb_add_system_message(sprintf(PL_MENU_SYSLOG_ADD_DELIM_OK, $cat_title));

        echo $m_id;
    }
    else
    {
        echo PL_MENU_ADD_DELIM_ERROR;
        sb_add_system_message(sprintf(PL_MENU_SYSLOG_ADD_DELIM_ERROR, $cat_title), SB_MSG_WARNING);
    }
}

function fMenu_Delete()
{
	$title = '';

    $res = sql_param_query('SELECT menu.m_cat_id, menu.m_title, menu.m_type, categs.cat_title, categs.cat_rights FROM sb_menu menu, sb_categs categs WHERE m_id=?d AND categs.cat_id=menu.m_cat_id', $_GET['m_id']);
    if ($res)
    {
        list($m_cat_id, $m_title, $m_type, $cat_title, $cat_rights) = $res[0];
        if (!fCategs_Check_Rights($cat_rights, true))
        {
            echo 'FALSE';
            return;
        }

        require_once(SB_CMS_LIB_PATH.'/sbTree.inc.php');
        $tree = new sbTree($m_cat_id);
        $tree->setSettings('sb_menu', 'm_right', 'm_left', 'm_level', 'm_id', 'm_cat_id');

//		Достаем вложенные пункты меню, чтоб удалить для них тематические теги.
		$sub_menu = sql_param_query('SELECT m.m_id FROM sb_menu AS m, sb_menu AS m2
						WHERE m2.m_left < m.m_left
						AND m2.m_right > m.m_right
						AND m2.m_id = ?d
						AND m.m_cat_id = ?d
						AND m2.m_cat_id = ?d
						ORDER BY m.m_left', $_GET['m_id'], $m_cat_id, $m_cat_id);

		if (!$tree->removeNode($_GET['m_id']))
	    {
	        switch ($m_type)
	        {
	            case 'item':
	                sb_add_system_message(sprintf(PL_MENU_SYSLOG_DELETE_ITEM_ERROR, $m_title, $cat_title), SB_MSG_WARNING);
	                break;
	            case 'categs':
	                sb_add_system_message(sprintf(PL_MENU_SYSLOG_DELETE_CATEGS_ERROR, $m_title, $cat_title), SB_MSG_WARNING);
	                break;
	            case 'delim':
	                sb_add_system_message(sprintf(PL_MENU_SYSLOG_DELETE_DELIM_ERROR, $cat_title), SB_MSG_WARNING);
	                break;
	        }

	        echo 'FALSE';
			return;
	    }

		fClouds_Delete($_GET['m_id'], 'pl_menu');

		if($sub_menu)
		{
			foreach($sub_menu as $key => $value)
			{
				fClouds_Delete($value[0], 'pl_menu');
			}
		}

	    switch ($m_type)
        {
            case 'item':
                sb_add_system_message(sprintf(PL_MENU_SYSLOG_DELETE_ITEM_OK, $m_title, $cat_title));
                break;
            case 'categs':
                sb_add_system_message(sprintf(PL_MENU_SYSLOG_DELETE_CATEGS_OK, $m_title, $cat_title));
                break;
            case 'delim':
                sb_add_system_message(sprintf(PL_MENU_SYSLOG_DELETE_DELIM_OK, $cat_title));
                break;
        }

	    echo 'TRUE';
	    return;
    }
    else
    {
        switch ($m_type)
        {
            case 'item':
                sb_add_system_message(sprintf(PL_MENU_SYSLOG_DELETE_ITEM_ERROR, $m_title, $cat_title), SB_MSG_WARNING);
                break;
            case 'categs':
                sb_add_system_message(sprintf(PL_MENU_SYSLOG_DELETE_CATEGS_ERROR, $m_title, $cat_title), SB_MSG_WARNING);
                break;
            case 'delim':
                sb_add_system_message(sprintf(PL_MENU_SYSLOG_DELETE_DELIM_ERROR, $cat_title), SB_MSG_WARNING);
                break;
        }

        echo 'FALSE';
        return;
    }
}

function fMenu_Del_Cats_W_Elems()
{
	if(isset($_GET['c_ids']) && $_GET['c_ids'] != '')
	{
		sql_query('DELETE FROM sb_menu WHERE m_cat_id IN (?a)', explode(',', $_GET['c_ids']));
	}
}

function fMenu_Paste()
{
    $before_m_id = intval($_GET['before_m_id']);
    $max_level = intval(sbPlugins::getSetting('sb_menu_max_deep'));
    $max_items = intval(sbPlugins::getSetting('sb_menu_max_items'));

    $action = preg_replace('/[^a-z]+/', '', $_GET['action']);

    $res1 = sql_param_query('SELECT menu.m_cat_id, menu.m_level, categs.cat_rights FROM sb_menu menu, sb_categs categs WHERE menu.m_id=?d AND categs.cat_id=menu.m_cat_id', $_GET['m_id']);
    $res2 = sql_param_query('SELECT menu.m_cat_id, menu.m_level, menu.m_type, menu.m_left, menu.m_right, menu.m_title, categs.cat_rights, categs.cat_title FROM sb_menu menu, sb_categs categs WHERE menu.m_id=?d AND categs.cat_id=menu.m_cat_id', $_GET['paste_m_id']);
    if ($res1 && $res2)
    {
        list($m_cat_id, $m_level, $cat_rights) = $res1[0];
        list($paste_cat_id, $paste_start_level, $paste_m_type, $paste_m_left, $paste_m_right, $paste_m_title, $paste_cat_rights, $menu_title) = $res2[0];

        if (!$_SESSION['sbAuth']->isAdmin())
        {
            if (!fCategs_Check_Rights($cat_rights, true))
            {
                echo PL_MENU_PASTE_ERROR;
                return;
            }

            if (!fCategs_Check_Rights($paste_cat_rights, true))
            {
                echo PL_MENU_PASTE_ERROR;
                return;
            }
        }

        $res2 = sql_param_query('SELECT MAX(m_level) FROM sb_menu WHERE m_left >= ?d AND m_right <= ?d AND m_cat_id=?d', $paste_m_left, $paste_m_right, $paste_cat_id);
        list($paste_end_level) = $res2[0];
        if ($before_m_id)
            $incr = 0;
        else
            $incr = 1;

        if ($m_level + $incr + $paste_end_level - $paste_start_level > $max_level)
        {
            echo sprintf(PL_MENU_ERROR_MAX_DEEP, $max_level);
            return;
        }

        if ($paste_start_level == 0)
        {
            $res2 = sql_param_query('SELECT COUNT(*) FROM sb_menu WHERE m_left >= ?d AND m_right <= ?d AND m_cat_id=?d AND m_level=1', $paste_m_left, $paste_m_right, $paste_cat_id);
            list($paste_count) = $res2[0];

            if ($paste_count >= $max_items)
            {
                echo sprintf(PL_MENU_ERROR_MAX_ITEMS, $max_items);
                return;
            }
        }

        require_once(SB_CMS_LIB_PATH.'/sbTree.inc.php');
        $tree = new sbTree($paste_cat_id, $m_cat_id);
        $tree->setSettings('sb_menu', 'm_right', 'm_left', 'm_level', 'm_id', 'm_cat_id');

        $return_res = $tree->pasteNode($_GET['m_id'], $_GET['paste_m_id'], $action, $before_m_id);
        if ($action == 'copy')
        {
            if (!$return_res)
            {
                echo PL_MENU_PASTE_ERROR;
                return;
            }
            else
            {
            	$workflow = $_SESSION['sbPlugins']->isPluginAvailable('pl_workflow') && $_SESSION['sbPlugins']->isPluginInWorkflow('pl_menu');

				echo $return_res;
				$old_new_menu = explode('::', $return_res);

				$els = array();
				$els[intval($old_new_menu[0])] = intval($old_new_menu[1]);

				fClouds_Copy($els, 'pl_menu');

				if ($workflow)
				{
					$w_res = sql_query('SELECT m_status FROM sb_menu WHERE m_id=?d', $old_new_menu[1]);

					if (!sb_workflow_status_available($w_res[0][0], 'pl_menu', -1))
					{
						sql_query('UPDATE sb_menu SET m_status=?d WHERE m_id=?d', current(sb_get_avail_workflow_status('pl_menu')), $old_new_menu[1]);
					}
				}

//				Достаем подразделы копируемого раздела, чтоб скопировать их теги тоже.
				$sub_menu = sql_param_query('SELECT m.m_id FROM sb_menu AS m, sb_menu AS m2
							WHERE m2.m_left < m.m_left
							AND m2.m_right > m.m_right
							AND m2.m_id = ?d
							AND m.m_cat_id = ?d
							AND m2.m_cat_id = ?d
							ORDER BY m.m_left', $old_new_menu[0], $paste_cat_id, $paste_cat_id);

				if($sub_menu)
				{
//					Достаем новые подразделы скопированного раздела меню, чтоб сформировать нужный массив для функции fClouds_Copy
					$new_sub_menu = sql_param_query('SELECT m.m_id, m.m_status FROM sb_menu AS m, sb_menu AS m2
								WHERE m2.m_left < m.m_left
								AND m2.m_right > m.m_right
								AND m2.m_id = ?d
								AND m.m_cat_id = ?d
								AND m2.m_cat_id = ?d
								ORDER BY m.m_left', $old_new_menu[1], $m_cat_id, $m_cat_id);

					if($new_sub_menu)
					{
						foreach($new_sub_menu as $key => $value)
						{
							if(isset($sub_menu[$key][0]))
							{
								$els = array();
								$els[$sub_menu[$key][0]] = intval($value[0]);

								fClouds_Copy($els, 'pl_menu');

								if ($workflow)
								{
									if (!sb_workflow_status_available($value[1], 'pl_menu', -1))
									{
										sql_query('UPDATE sb_menu SET m_status=?d WHERE m_id=?d', current(sb_get_avail_workflow_status('pl_menu')), $value[0]);
									}
								}
							}
						}
					}
				}
            }

            if ($paste_m_type == 'delim')
    	        sb_add_system_message(sprintf(PL_MENU_SYSLOG_COPY_DELIM, $menu_title));
    	    else
	            sb_add_system_message(sprintf(PL_MENU_SYSLOG_COPY, $paste_m_title, $menu_title));
        }
        else
        {
        	if ($paste_m_type == 'delim')
	            sb_add_system_message(sprintf(PL_MENU_SYSLOG_CUT_DELIM, $menu_title));
	        else
    	        sb_add_system_message(sprintf(PL_MENU_SYSLOG_CUT, $paste_m_title, $menu_title));
        }
    }
    else
    {
        echo PL_MENU_PASTE_ERROR;
    }
}

function fMenu_Cat_Delete()
{
    sql_param_query('DELETE FROM sb_menu WHERE m_cat_id=?d', $_GET['cat_id']);
}

function fMenu_Cat_Edit()
{
    $res = sql_param_query('SELECT cat_title FROM sb_categs WHERE cat_id=?d', $_GET['cat_id']);
    if($res)
    {
        list($title) = $res[0];
        sql_param_query('UPDATE sb_menu SET m_title=? WHERE m_cat_id=?d AND m_level=0', $title, $_GET['cat_id']);
    }
}

/**
 * Макеты дизайна вывода меню
 */

function fMenu_Temps_Get($args)
{
	$result = '<b><a href="javascript:void(0);" onclick="sbElemsEdit(event);">'.$args['mt_title'].'</a></b>
    <div class="smalltext" style="margin-top: 7px;">';

    static $view_info_pages = null;
    static $view_info_temps = null;

    if (is_null($view_info_pages))
    {
        $view_info_pages = $_SESSION['sbPlugins']->isRightAvailable('pl_pages', 'read');
    }

    if (is_null($view_info_temps))
    {
        $view_info_temps = $_SESSION['sbPlugins']->isRightAvailable('pl_templates', 'read');
    }

    $id = intval($args['mt_id']);

	$pages = sql_query('SELECT pages.p_id, pages.p_name FROM sb_pages pages, sb_elems elems
	                    WHERE elems.e_link="page" AND elems.e_temp_id="'.$id.'" AND (elems.e_ident="pl_menu_tree" OR elems.e_ident="pl_menu_sub" OR elems.e_ident="pl_pages_categs") AND pages.p_id=elems.e_p_id GROUP BY pages.p_id ORDER BY pages.p_name LIMIT 4');

	$temps = sql_query('SELECT temps.t_id, temps.t_name FROM sb_templates temps, sb_elems elems
	                    WHERE elems.e_link="temp" AND elems.e_temp_id="'.$id.'" AND (elems.e_ident="pl_menu_tree" OR elems.e_ident="pl_menu_sub" OR elems.e_ident="pl_pages_categs") AND temps.t_id=elems.e_p_id GROUP BY temps.t_id ORDER BY temps.t_name LIMIT 4');

	if ($pages)
	{
	    $result .= '<table cellpadding="0" cellspacing="0">
	                <tr>
	                    <td valign="top" nowrap="nowrap" class="smalltext">'.KERNEL_USED_ON_PAGES.':&nbsp;</td>
	                    <td class="smalltext"><span style="color:green;">';

	    $num = min(3, count($pages));
	    for ($i = 0; $i < $num; $i++)
		{
			list($p_id, $p_name) = $pages[$i];
			$result .= ($view_info_pages ? '<a href="'.SB_CMS_CONTENT_FILE.'?event=pl_pages_init&sb_sel_id='.$p_id.'">'.$p_name.'</a>' : $p_name).', ';
		}

		if ($num < count($pages))
			$result .= '&nbsp;<a href="javascript:void(0);" onclick="linkPages(event);">...</a>';
	    else
	        $result = substr($result, 0, -2);

	    $result .= '</span></td></tr></table>';
	}
	else
	{
	    $result .= KERNEL_USED_ON_PAGES.': <span style="color: red;">'.KERNEL_NOT_USED.'</span><br />';
	}

	if ($temps)
	{
	    $result .= '<table cellpadding="0" cellspacing="0">
	                <tr>
	                    <td valign="top" nowrap="nowrap" class="smalltext">'.KERNEL_USED_ON_TEMPS.':&nbsp;</td>
	                    <td class="smalltext"><span style="color:green;">';

	    $num = min(3, count($temps));
	    for ($i = 0; $i < $num; $i++)
		{
			list($t_id, $t_name) = $temps[$i];
			$result .= ($view_info_temps ? '<a href="'.SB_CMS_CONTENT_FILE.'?event=pl_templates_init&sb_sel_id='.$t_id.'">'.$t_name.'</a>' : $t_name).', ';
		}

		if ($num < count($temps))
			$result .= '&nbsp;<a href="javascript:void(0);" onclick="linkTemps(event);">...</a>';
	    else
	        $result = substr($result, 0, -2);

	    $result .= '</span></td></tr></table>';
	}
	else
	{
		$result .= KERNEL_USED_ON_TEMPS.': <span style="color: red;">'.KERNEL_NOT_USED.'</span><br />';
	}

    $result .= '</div>';

    return $result;
}

function fMenu_Temps()
{
	require_once(SB_CMS_LIB_PATH.'/sbElements.inc.php');

    $elems = new sbElements('sb_menu_temps', 'mt_id', 'mt_title', 'fMenu_Temps_Get', 'pl_menu_temps', 'pl_menu_temps');

    $elems->mCategsRootName = KERNEL_DESIGN_ROOT_NAME;
    $elems->mElemsIcon = SB_CMS_IMG_URL.'/plugins/pl_menu_temps_32.png';
    $elems->mCategsDeleteWithElementsMenu = true;

    $elems->addSorting(PL_MENU_DESIGN_EDIT_SORT_BY_TITLE, 'mt_title');

    $elems->mCategsPasteElemsMenuTitle = KERNEL_DESIGN_PASTE_ELEMS_MENU_TITLE;

    $elems->mElemsAddMenuTitle  = KERNEL_DESIGN_ELEMS_ADD_MENU_TITLE;
    $elems->mElemsEditMenuTitle = KERNEL_DESIGN_ELEMS_EDIT_MENU_TITLE;
    $elems->mElemsCopyMenuTitle = KERNEL_DESIGN_ELEMS_COPY_MENU_TITLE;
    $elems->mElemsCutMenuTitle  = KERNEL_DESIGN_ELEMS_CUT_MENU_TITLE;

    $elems->mElemsEditEvent =  'pl_menu_temps_edit';
    $elems->mElemsEditDlgWidth = 900;
	$elems->mElemsEditDlgHeight = 700;

	$elems->mElemsAddEvent =  'pl_menu_temps_edit';
    $elems->mElemsAddDlgWidth = 900;
	$elems->mElemsAddDlgHeight = 700;

	$elems->mElemsDeleteEvent = 'pl_menu_temps_delete';

	$elems->mCategsClosed = false;
	$elems->mCategsRubrikator = false;
	$elems->mElemsUseLinks = false;

	$elems->mElemsJavascriptStr .= '
	      function linkPages(e)
	      {
	          if (!sbSelEl)
	          {
	              var el = sbEventTarget(e);

                  while (el.parentNode && !el.getAttribute("true_id"))
                      el = el.parentNode;

                  var el_id = el.getAttribute("el_id");
	          }
	          else
	              var el_id = sbSelEl.getAttribute("el_id");

	          strPage = "'.SB_CMS_DIALOG_FILE.'?event=pl_pages_get_links&id=" + el_id + "&ident[]=pl_menu_tree&ident[]=pl_menu_sub";
              strAttr = "resizable=1,width=800,height=600";
              sbShowModalDialog(strPage, strAttr, null, window);
	      }
	      function linkTemps(e)
	      {
	          if (!sbSelEl)
	          {
	              var el = sbEventTarget(e);

                  while (el.parentNode && !el.getAttribute("true_id"))
                      el = el.parentNode;

                  var el_id = el.getAttribute("el_id");
	          }
	          else
	              var el_id = sbSelEl.getAttribute("el_id");

	          strPage = "'.SB_CMS_DIALOG_FILE.'?event=pl_templates_get_links&id=" + el_id + "&ident[]=pl_menu_tree&ident[]=pl_menu_sub";
              strAttr = "resizable=1,width=800,height=600";
              sbShowModalDialog(strPage, strAttr, null, window);
	      }
	      function menuList()
	      {
	          window.location = "'.SB_CMS_CONTENT_FILE.'?event=pl_menu";
	      }';

	$elems->addElemsMenuItem(KERNEL_LINK_PAGES_MENU_ITEM, 'linkPages();');
	$elems->addElemsMenuItem(KERNEL_LINK_TEMPS_MENU_ITEM, 'linkTemps();');
	$elems->addElemsMenuItem(PL_MENU_DESIGN_EDIT_MENUTREE_ITEM, 'menuList();', false);

    $elems->init();
}

function fMenu_Temps_Edit($htmlStr = '', $footerStr = '', $add_level=false)
{
	// проверка прав доступа
	if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'], 'pl_menu_temps'))
		return;

	if (count($_POST) == 0 && isset($_GET['id']) && $_GET['id'] != '')
	{
   		$result = sql_param_query('SELECT mt_title, mt_lang, mt_levels, mt_fields_temps, mt_checked FROM sb_menu_temps WHERE mt_id=?d', $_GET['id']);

   		if ($result)
	    {
        	list($mt_title, $mt_lang, $mt_levels, $mt_fields_temps, $mt_checked) = $result[0];
	    }
	    else
	    {
	        sb_show_message(PL_MENU_DESIGN_EDIT_ERROR, true, 'warning');
	        return;
	    }

	    if ($mt_levels != '')
	        $mt_levels = unserialize($mt_levels);
	    else
	        $mt_levels = array();

	    if ($mt_fields_temps != '')
	        $mt_fields_temps = unserialize($mt_fields_temps);
	    else
	        $mt_fields_temps = array();

	    if ($mt_checked != '')
		    $mt_checked = explode(' ', $mt_checked);
		else
		    $mt_checked = array();
	}
	elseif (count($_POST) > 0)
	{
		$mt_checked = array();

		extract($_POST);

		if (!isset($_GET['id']))
            $_GET['id'] = '';
	}
	else
	{
	    $mt_title = '';
	    $mt_lang = SB_CMS_LANG;
	    $mt_levels = array();
	    $mt_levels[0] = array();
	    $mt_levels[0]['top'] = '';
	    $mt_levels[0]['sub'] = '';
	    $mt_levels[0]['sub_sel'] = '';
	    $mt_levels[0]['item'] = '';
	    $mt_levels[0]['item_sel'] = '';
	    $mt_levels[0]['bottom'] = '';
	    $mt_levels[0]['delim'] = '';

	    $mt_fields_temps = array();
	    $mt_checked = array();

	    $_GET['id'] = '';
	}

    echo '<script>
	        function checkValues()
            {
                var el_title = sbGetE("mt_title");
                if (el_title.value == "")
                {
          	         alert("'.PL_MENU_DESIGN_NO_TITLE_MSG.'");
          	         return false;
                }
            }
            function copyTab(tabFrom, tabTo)
            {
            	var tabFrom = sbGetE("sb_tab" + tabFrom);
            	var tabTo = sbGetE("sb_tab" + tabTo);

            	if (tabFrom && tabTo)
            	{
            		var elsFrom = tabFrom.getElementsByTagName("TEXTAREA");
            		var elsTo = tabTo.getElementsByTagName("TEXTAREA");

            		for (var i = 0; i < elsFrom.length; i++)
            		{
            			var editorFrom = eval("window.sbCodeditor_" + elsFrom[i].id.replace(/[^a-zA-Z0-9_\-]+/g, ""));
            			if (editorFrom)
            			{
            				var editorTo = eval("window.sbCodeditor_" + elsTo[i].id.replace(/[^a-zA-Z0-9_\-]+/g, ""));
            				editorTo.setCode(editorFrom.getCode());
            			}
            			else
            			{
            				elsTo[i].value = elsFrom[i].value;
            			}
            		}
            	}
            }
            function sbTabCheck(tab)
	    	{
	    	    if (window.tabs.getTitle(tab) == "+")
	    	    {
	    	    	main_form.action += "&add_level=1";
	    	    	main_form.onsubmit(null, true);
	    	    	main_form.submit();
	    	    	return false;
	    	    }

	    	    return true;
	    	}';

	if ($htmlStr != '')
	{
	    echo '
            function cancel()
            {
                var res = new Object();
		        res.html = "'.$htmlStr.'";
		        res.footer = "'.$footerStr.'";
		        res.footer_link = "";
				sbReturnValue(res);
            }
            sbAddEvent(window, "close", cancel);';
	}

	echo '</script>';

	require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

	$layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE.'?event=pl_menu_temps_submit'.($_SERVER['QUERY_STRING'] != '' ? '&'.$_SERVER['QUERY_STRING'] : ''), 'thisDialog', 'post', 'checkValues()', 'main_form');
	$layout->mTableWidth = '95%';
	$layout->mTitleWidth = '200';

	$layout->addTab(PL_MENU_DESIGN_EDIT_TAB1);
	$layout->addHeader(PL_MENU_DESIGN_EDIT_TAB1);

	$layout->addField(PL_MENU_DESIGN_EDIT_TITLE, new sbLayoutInput('text', $mt_title, 'mt_title', '', 'style="width:540px;"', true));

	$layout->addField('', new sbLayoutDelim());

	$fld = new sbLayoutSelect($GLOBALS['sb_site_langs'], 'mt_lang');
	$fld->mSelOptions = array($mt_lang);
	$fld->mHTML = '<div class="hint_div" style="margin-top: 5px;">'.PL_MENU_DESIGN_EDIT_LANG_LABEL.'</div>';
	$layout->addField(PL_MENU_DESIGN_EDIT_LANG, $fld);

	$res_fields = sql_query('SELECT pd_fields FROM sb_plugins_data WHERE pd_plugin_ident="pl_menu"');
	$pd_fields = array();
	if ($res_fields)
	{
	    list($pd_fields) = $res_fields[0];
	    if ($pd_fields != '')
	    {
	        $options = array();
 	        $pd_fields = unserialize($pd_fields);
	        foreach ($pd_fields as $key => $value)
	        {
	            if ($value['type'] == 'checkbox')
	            {
	                $options[$value['id']] = $value['title'];
	            }
	        }

	        if (count($options) > 0)
	        {
	            $fld = new sbLayoutSelect($options, 'mt_checked[]', '', 'multiple="multiple"');
	            $fld->mSelOptions = $mt_checked;
	            $fld->mHTML = '<div class="hint_div" style="margin-top: 5px;">'.PL_MENU_DESIGN_EDIT_CHECKED_LABEL.'</div>';
	            $layout->addField(PL_MENU_DESIGN_EDIT_CHECKED, $fld);
   	        }
	    }
	}

	$tags = array('-', '{ID}', '{PARENT_ID}', '{TEXT}', '{URL}', '{ALT}', '{TARGET}', '{CLOSED_ICON}');
	$values = array(PL_MENU_DESIGN_EDIT_TAB1, PL_MENU_DESIGN_EDIT_TAGS_ID, PL_MENU_DESIGN_EDIT_TAGS_PARENT_ID, PL_MENU_DESIGN_EDIT_TAGS_TITLE, PL_MENU_EDIT_URL, PL_MENU_EDIT_ALT, PL_MENU_EDIT_TARGET, PL_MENU_DESIGN_EDIT_CLOSED_ICON);

	$menu_tags = array();
	$menu_tags_values = array();
	$layout->getPluginFieldsTags('pl_menu', $menu_tags, $menu_tags_values);

	foreach ($mt_levels as $key => $value)
	{
		$layout->addTab(PL_MENU_DESIGN_EDIT_TAB_FIELD);
		$layout->addHeader(PL_MENU_DESIGN_EDIT_TAB_FIELD);

		if ($key != 0)
		{
			$fld = new sbLayoutHTML('<a href="#" onclick="copyTab('.($key * 2 - 1).', '.($key * 2 + 1).')">'.PL_MENU_DESIGN_EDIT_COPY_FROM.'</a>');
			$layout->addField('', $fld);
			$layout->addField('', new sbLayoutDelim());
		}

		$fld = new sbLayoutTextarea(isset($mt_fields_temps[$key]['closed_icon']) ? $mt_fields_temps[$key]['closed_icon'] : '', 'mt_fields_temps['.$key.'][closed_icon]', '', 'style="width:100%;height:50px;"');
		$fld->mTags = array('{ID}', '{PARENT_ID}', '{TEXT}', '{URL}', '{ALT}', '{TARGET}');
		$fld->mValues = array(PL_MENU_DESIGN_EDIT_TAGS_ID, PL_MENU_DESIGN_EDIT_TAGS_PARENT_ID, PL_MENU_DESIGN_EDIT_TAGS_TITLE, PL_MENU_EDIT_URL, PL_MENU_EDIT_ALT, PL_MENU_EDIT_TARGET);
		$layout->addField(PL_MENU_DESIGN_EDIT_CLOSED_ICON, $fld);

		if (count($pd_fields) > 0)
		{
			$layout->addField('', new sbLayoutDelim());

			$layout->addPluginFieldsTemps('pl_menu', isset($mt_fields_temps[$key]) ? $mt_fields_temps[$key] : array(), 'mt_', $tags, $values, false, '['.$key.']');
		}

		$layout->addTab(sprintf(PL_MENU_DESIGN_EDIT_TAB_LEVEL, $key + 1));
		$layout->addHeader(sprintf(PL_MENU_DESIGN_EDIT_TAB_LEVEL, $key + 1));

		if ($key != 0)
		{
			$fld = new sbLayoutHTML('<a href="#" onclick="copyTab('.($key * 2).', '.($key * 2 + 2).')">'.PL_MENU_DESIGN_EDIT_COPY_FROM.'</a>');
			$layout->addField('', $fld);
			$layout->addField('', new sbLayoutDelim());
		}

		$fld = new sbLayoutTextarea($value['top'], 'mt_levels['.$key.'][top]', '', 'style="width:100%;height:50px;"');
		$fld->mTags = array('{PARENT_ID}');
		$fld->mValues = array(PL_MENU_DESIGN_EDIT_TAGS_PARENT_ID);
		$layout->addField(PL_MENU_DESIGN_EDIT_TOP, $fld);

		$layout->addField('', new sbLayoutDelim());

		$fld = new sbLayoutTextarea($value['sub'], 'mt_levels['.$key.'][sub]', '', 'style="width:100%;height:100px;"');
		$fld->mTags = array_merge($tags, array('{COUNT}', '{SUB_ITEMS}'), $menu_tags);
		$fld->mValues = array_merge($values, array(PL_MENU_DESIGN_EDIT_TAGS_COUNT, PL_MENU_DESIGN_EDIT_TAGS_SUBITEMS), $menu_tags_values);
		$layout->addField(PL_MENU_DESIGN_EDIT_SUB, $fld);

		$fld = new sbLayoutTextarea($value['sub_sel'], 'mt_levels['.$key.'][sub_sel]', '', 'style="width:100%;height:100px;"');
		$fld->mTags = array_merge($tags, array('{COUNT}', '{SUB_ITEMS}'), $menu_tags);
		$fld->mValues = array_merge($values, array(PL_MENU_DESIGN_EDIT_TAGS_COUNT, PL_MENU_DESIGN_EDIT_TAGS_SUBITEMS), $menu_tags_values);
		$layout->addField(PL_MENU_DESIGN_EDIT_SUB_SEL, $fld);

		$layout->addField('', new sbLayoutDelim());

		$fld = new sbLayoutTextarea($value['item'], 'mt_levels['.$key.'][item]', '', 'style="width:100%;height:100px;"');
		$fld->mTags = array_merge($tags, $menu_tags);
		$fld->mValues = array_merge($values, $menu_tags_values);
		$layout->addField(PL_MENU_DESIGN_EDIT_ITEM, $fld);

		$fld = new sbLayoutTextarea($value['item_sel'], 'mt_levels['.$key.'][item_sel]', '', 'style="width:100%;height:100px;"');
		$fld->mTags = array_merge($tags, $menu_tags);
		$fld->mValues = array_merge($values, $menu_tags_values);
		$layout->addField(PL_MENU_DESIGN_EDIT_ITEM_SEL, $fld);

		$layout->addField('', new sbLayoutDelim());

		$fld = new sbLayoutTextarea($value['bottom'], 'mt_levels['.$key.'][bottom]', '', 'style="width:100%;height:50px;"');
		$fld->mTags = array('{PARENT_ID}');
		$fld->mValues = array(PL_MENU_DESIGN_EDIT_TAGS_PARENT_ID);
		$layout->addField(PL_MENU_DESIGN_EDIT_BOTTOM, $fld);

		$layout->addField('', new sbLayoutDelim());

		$fld = new sbLayoutTextarea($value['delim'], 'mt_levels['.$key.'][delim]', '', 'style="width:100%;height:50px;"');
		$fld->mTags = array('{ID}');
		$fld->mValues = array(PL_MENU_DESIGN_EDIT_TAGS_ID);
		$layout->addField(PL_MENU_DESIGN_EDIT_DELIM, $fld);
	}

	if ($add_level)
	{
		$key++;

		$layout->addTab(PL_MENU_DESIGN_EDIT_TAB_FIELD);
		$layout->addHeader(PL_MENU_DESIGN_EDIT_TAB_FIELD);

		$fld = new sbLayoutHTML('<a href="#" onclick="copyTab('.($key * 2 - 1).', '.($key * 2 + 1).')">'.PL_MENU_DESIGN_EDIT_COPY_FROM.'</a>');
		$layout->addField('', $fld);
		$layout->addField('', new sbLayoutDelim());

		$fld = new sbLayoutTextarea(isset($mt_fields_temps[$key]['closed_icon']) ? $mt_fields_temps[$key]['closed_icon'] : '', 'mt_fields_temps['.$key.'][closed_icon]', '', 'style="width:100%;height:50px;"');
		$fld->mTags = array('{ID}', '{PARENT_ID}', '{TEXT}', '{URL}', '{ALT}', '{TARGET}');
		$fld->mValues = array(PL_MENU_DESIGN_EDIT_TAGS_ID, PL_MENU_DESIGN_EDIT_TAGS_PARENT_ID, PL_MENU_DESIGN_EDIT_TAGS_TITLE, PL_MENU_EDIT_URL, PL_MENU_EDIT_ALT, PL_MENU_EDIT_TARGET);
		$layout->addField(PL_MENU_DESIGN_EDIT_CLOSED_ICON, $fld);

		if (count($pd_fields) > 0)
		{
			$layout->addField('', new sbLayoutDelim());

			$layout->addPluginFieldsTemps('pl_menu', array(), 'mt_', $tags, $values, false, '['.$key.']');
		}

		$layout->addTab(sprintf(PL_MENU_DESIGN_EDIT_TAB_LEVEL, $key + 1));
		$layout->addHeader(sprintf(PL_MENU_DESIGN_EDIT_TAB_LEVEL, $key + 1));

		$fld = new sbLayoutHTML('<a href="#" onclick="copyTab('.($key * 2).', '.($key * 2 + 2).')">'.PL_MENU_DESIGN_EDIT_COPY_FROM.'</a>');
		$layout->addField('', $fld);
		$layout->addField('', new sbLayoutDelim());

		$fld = new sbLayoutTextarea('', 'mt_levels['.$key.'][top]', '', 'style="width:100%;height:50px;"');
		$fld->mTags = array('{PARENT_ID}');
		$fld->mValues = array(PL_MENU_DESIGN_EDIT_TAGS_PARENT_ID);
		$layout->addField(PL_MENU_DESIGN_EDIT_TOP, $fld);

		$layout->addField('', new sbLayoutDelim());

		$fld = new sbLayoutTextarea('', 'mt_levels['.$key.'][sub]', '', 'style="width:100%;height:100px;"');
		$fld->mTags = array_merge($tags, array('{COUNT}', '{SUB_ITEMS}'), $menu_tags);
		$fld->mValues = array_merge($values, array(PL_MENU_DESIGN_EDIT_TAGS_COUNT, PL_MENU_DESIGN_EDIT_TAGS_SUBITEMS), $menu_tags_values);
		$layout->addField(PL_MENU_DESIGN_EDIT_SUB, $fld);

		$fld = new sbLayoutTextarea('', 'mt_levels['.$key.'][sub_sel]', '', 'style="width:100%;height:100px;"');
		$fld->mTags = array_merge($tags, array('{COUNT}', '{SUB_ITEMS}'), $menu_tags);
		$fld->mValues = array_merge($values, array(PL_MENU_DESIGN_EDIT_TAGS_COUNT, PL_MENU_DESIGN_EDIT_TAGS_SUBITEMS), $menu_tags_values);
		$layout->addField(PL_MENU_DESIGN_EDIT_SUB_SEL, $fld);

		$layout->addField('', new sbLayoutDelim());

		$fld = new sbLayoutTextarea('', 'mt_levels['.$key.'][item]', '', 'style="width:100%;height:100px;"');
		$fld->mTags = array_merge($tags, $menu_tags);
		$fld->mValues = array_merge($values, $menu_tags_values);
		$layout->addField(PL_MENU_DESIGN_EDIT_ITEM, $fld);

		$fld = new sbLayoutTextarea('', 'mt_levels['.$key.'][item_sel]', '', 'style="width:100%;height:100px;"');
		$fld->mTags = array_merge($tags, $menu_tags);
		$fld->mValues = array_merge($values, $menu_tags_values);
		$layout->addField(PL_MENU_DESIGN_EDIT_ITEM_SEL, $fld);

		$layout->addField('', new sbLayoutDelim());

		$fld = new sbLayoutTextarea('', 'mt_levels['.$key.'][bottom]', '', 'style="width:100%;height:50px;"');
		$fld->mTags = array('{PARENT_ID}');
		$fld->mValues = array(PL_MENU_DESIGN_EDIT_TAGS_PARENT_ID);
		$layout->addField(PL_MENU_DESIGN_EDIT_BOTTOM, $fld);

		$layout->addField('', new sbLayoutDelim());

		$fld = new sbLayoutTextarea('', 'mt_levels['.$key.'][delim]', '', 'style="width:100%;height:50px;"');
		$fld->mTags = array('{ID}');
		$fld->mValues = array(PL_MENU_DESIGN_EDIT_TAGS_ID);
		$layout->addField(PL_MENU_DESIGN_EDIT_DELIM, $fld);
	}

	$layout->addTab('+');

	$layout->addButton('submit', KERNEL_SAVE, 'btn_save', '', ($_SESSION['sbPlugins']->isRightAvailable('pl_menu', 'design_edit') ? '' : 'disabled="disabled"'));
    if ($_GET['id'] != '')
        $layout->addButton('submit', KERNEL_APPLY, 'btn_apply', '', ($_SESSION['sbPlugins']->isRightAvailable('pl_menu', 'design_edit') ? '' : 'disabled="disabled"'));
    $layout->addButton('button', KERNEL_CANCEL, '', '', $htmlStr != '' ? 'onclick="cancel()"' : 'onclick="sbCloseDialog();"');

    $layout->show();
}

function fMenu_Temps_Submit()
{
	// проверка прав доступа
	if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'], 'pl_menu_temps'))
		return;

	if (isset($_GET['add_level']) && $_GET['add_level'] == 1)
	{
		// добавляем уровень
		fMenu_Temps_Edit($htmlStr = '', $footerStr = '', true);
		return;
	}

	if (!isset($_GET['id']))
        $_GET['id'] = '';

    $mt_checked = array();
    $mt_levels = array();
    extract($_POST);

    if ($mt_title == '')
    {
        sb_show_message(PL_MENU_DESIGN_NO_TITLE_MSG, false, 'warning');
        fMenu_Temps_Edit();
        return;
    }

    // удаляем пустые уровни меню
    $num = count($mt_levels);
    $num_full = $num;
    for ($i = $num - 1; $i > 0; $i--)
    {
    	if (trim($mt_levels[$i]['top']) == '' && trim($mt_levels[$i]['sub']) == '' && trim($mt_levels[$i]['sub_sel']) == '' &&
	    	trim($mt_levels[$i]['item']) == '' && trim($mt_levels[$i]['item_sel']) == '' && trim($mt_levels[$i]['bottom']) == '' &&
	    	trim($mt_levels[$i]['delim']) == '')
	    {
	    	$num_full--;
	    	$_REQUEST['tabidx'] = 0;
	    }
	    else
	    {
	    	break;
	    }
    }

    $mt_full_levels = array();
    $mt_full_fields_temps = array();
    for ($i = 0; $i < $num_full; $i++)
    {
    	$mt_full_levels[$i] = $mt_levels[$i];
    	$mt_full_fields_temps[$i] = isset($mt_fields_temps[$i]) ? $mt_fields_temps[$i] : '';
    }

    $_POST['mt_levels'] = $mt_full_levels;
    $_POST['mt_fields_temps'] = $mt_full_fields_temps;

    $row = array();
    $row['mt_title'] = $mt_title;
    $row['mt_lang'] = $mt_lang;
    $row['mt_checked'] = implode(' ', $mt_checked);
    $row['mt_levels'] = serialize($mt_full_levels);
    $row['mt_fields_temps'] = serialize($mt_full_fields_temps);

    if ($_GET['id'] != '')
	{
	    $res = sql_param_query('SELECT mt_title FROM sb_menu_temps WHERE mt_id=?d', $_GET['id']);
	    if ($res)
	    {
	        // редактирование
	        list($old_title) = $res[0];

    	    sql_param_query('UPDATE sb_menu_temps SET ?a WHERE mt_id=?d', $row, $_GET['id'], sprintf(PL_MENU_DESIGN_EDIT_OK, $old_title));
            sbQueryCache::updateTemplate('sb_menu_temps', $_GET['id']);

            $footer_ar = fCategs_Edit_Elem('design_edit');
    	    if (!$footer_ar)
    	    {
    	        sb_show_message(PL_MENU_DESIGN_EDIT_ERROR, false, 'warning');
                sb_add_system_message(sprintf(PL_MENU_DESIGN_EDIT_SYSTEMLOG_ERROR, $old_title), SB_MSG_WARNING);

                fMenu_Temps_Edit();
    		    return;
    	    }
    	    $footer_str = $GLOBALS['sbSql']->escape($footer_ar[0], false, false);

    	    $row['mt_id'] = intval($_GET['id']);

            $html_str = fMenu_Temps_Get($row);
    	    $html_str = sb_str_replace(array("\r\n", "\r", "\n"), '', $html_str);
            $html_str = $GLOBALS['sbSql']->escape($html_str, false, false);

    	    if (!isset($_POST['btn_apply']))
    	    {
        	    echo '<script>
        		        var res = new Object();
        		        res.html = "'.$html_str.'";
        		        res.footer = "'.$footer_str.'";
        		        res.footer_link = "";
        				sbReturnValue(res);
        			  </script>';
    	    }
    	    else
    	    {
    	        fMenu_Temps_Edit($html_str, $footer_str);
    	        return;
    	    }
	    }
	    else
	    {
	        sb_show_message(PL_MENU_DESIGN_EDIT_ERROR, false, 'warning');
            sb_add_system_message(sprintf(PL_MENU_DESIGN_EDIT_SYSTEMLOG_ERROR, $mt_title), SB_MSG_WARNING);

            fMenu_Temps_Edit();
		    return;
	    }
	}
	else
	{
	    $error = true;
	    if (sql_param_query('INSERT INTO sb_menu_temps SET ?a', $row))
	    {
    		$id = sql_insert_id();

    		if (fCategs_Add_Elem($id, 'design_edit'))
    		{
                sbQueryCache::updateTemplate('sb_menu_temps', $id);
        		sb_add_system_message(sprintf(PL_MENU_DESIGN_ADD_OK, $mt_title));

        		echo '<script>
        				sbReturnValue('.$id.');
        			  </script>';

        		$error = false;
    		}
    		else
    		{
    		    sql_query('DELETE FROM sb_menu_temps WHERE mt_id="'.$id.'"');
    		}
	    }

	    if ($error)
	    {
	        sb_show_message(sprintf(PL_MENU_DESIGN_ADD_ERROR, $mt_title), false, 'warning');
            sb_add_system_message(sprintf(PL_MENU_DESIGN_ADD_SYSTEMLOG_ERROR, $mt_title), SB_MSG_WARNING);

            fMenu_Temps_Edit();
		    return;
	    }
	}
}

function fMenu_Temps_Delete()
{
	$id = intval($_GET['id']);

    $pages = sql_query('SELECT pages.p_id FROM sb_pages pages, sb_elems elems
	                    WHERE elems.e_link="page" AND elems.e_temp_id="'.$id.'" AND (elems.e_ident="pl_menu_tree" OR elems.e_ident="pl_menu_sub" OR elems.e_ident="pl_pages_categs") AND pages.p_id=elems.e_p_id LIMIT 1');

    $temps = sql_query('SELECT temps.t_id FROM sb_templates temps, sb_elems elems
	                    WHERE elems.e_link="temp" AND elems.e_temp_id="'.$id.'" AND (elems.e_ident="pl_menu_tree" OR elems.e_ident="pl_menu_sub" OR elems.e_ident="pl_pages_categs") AND temps.t_id=elems.e_p_id LIMIT 1');

    if ($pages || $temps)
    {
        echo PL_MENU_DESIGN_DELETE_ERROR;
    }
}

/**
 * Макеты дизайна вывода пути по сайту
 */

function fMenu_Path_Temps_Get($args)
{
	$result = '<b><a href="javascript:void(0);" onclick="sbElemsEdit(event);">'.$args['mpt_title'].'</a></b>
    <div class="smalltext" style="margin-top: 7px;">';

    static $view_info_pages = null;
    static $view_info_temps = null;

    if (is_null($view_info_pages))
    {
        $view_info_pages = $_SESSION['sbPlugins']->isRightAvailable('pl_pages', 'read');
    }

    if (is_null($view_info_temps))
    {
        $view_info_temps = $_SESSION['sbPlugins']->isRightAvailable('pl_templates', 'read');
    }

    $id = intval($args['mpt_id']);

	$pages = sql_query('SELECT pages.p_id, pages.p_name FROM sb_pages pages, sb_elems elems
	                    WHERE elems.e_link="page" AND elems.e_temp_id="'.$id.'" AND (elems.e_ident="pl_menu_path_html" OR elems.e_ident="pl_menu_path_plain" OR elems.e_ident="pl_pages_path_html" OR elems.e_ident="pl_pages_path_plain" OR elems.e_ident="pl_forum_forum_path") AND pages.p_id=elems.e_p_id GROUP BY pages.p_id ORDER BY pages.p_name LIMIT 4');

	$temps = sql_query('SELECT temps.t_id, temps.t_name FROM sb_templates temps, sb_elems elems
	                    WHERE elems.e_link="temp" AND elems.e_temp_id="'.$id.'" AND (elems.e_ident="pl_menu_path_html" OR elems.e_ident="pl_menu_path_plain" OR elems.e_ident="pl_pages_path_html" OR elems.e_ident="pl_pages_path_plain" OR elems.e_ident="pl_forum_forum_path") AND temps.t_id=elems.e_p_id GROUP BY temps.t_id ORDER BY temps.t_name LIMIT 4');

	if ($pages)
	{
	    $result .= '<table cellpadding="0" cellspacing="0">
	                <tr>
	                    <td valign="top" nowrap="nowrap" class="smalltext">'.KERNEL_USED_ON_PAGES.':&nbsp;</td>
	                    <td class="smalltext"><span style="color:green;">';

	    $num = min(3, count($pages));
	    for ($i = 0; $i < $num; $i++)
		{
			list($p_id, $p_name) = $pages[$i];
			$result .= ($view_info_pages ? '<a href="'.SB_CMS_CONTENT_FILE.'?event=pl_pages_init&sb_sel_id='.$p_id.'">'.$p_name.'</a>' : $p_name).', ';
		}

		if ($num < count($pages))
			$result .= '&nbsp;<a href="javascript:void(0);" onclick="linkPages(event);">...</a>';
	    else
	        $result = substr($result, 0, -2);

	    $result .= '</span></td></tr></table>';
	}
	else
	{
	    $result .= KERNEL_USED_ON_PAGES.': <span style="color: red;">'.KERNEL_NOT_USED.'</span><br />';
	}

	if ($temps)
	{
	    $result .= '<table cellpadding="0" cellspacing="0">
	                <tr>
	                    <td valign="top" nowrap="nowrap" class="smalltext">'.KERNEL_USED_ON_TEMPS.':&nbsp;</td>
	                    <td class="smalltext"><span style="color:green;">';

	    $num = min(3, count($temps));
	    for ($i = 0; $i < $num; $i++)
		{
			list($t_id, $t_name) = $temps[$i];
			$result .= ($view_info_temps ? '<a href="'.SB_CMS_CONTENT_FILE.'?event=pl_templates_init&sb_sel_id='.$t_id.'">'.$t_name.'</a>' : $t_name).', ';
		}

		if ($num < count($temps))
			$result .= '&nbsp;<a href="javascript:void(0);" onclick="linkTemps(event);">...</a>';
	    else
	        $result = substr($result, 0, -2);

	    $result .= '</span></td></tr></table>';
	}
	else
	{
		$result .= KERNEL_USED_ON_TEMPS.': <span style="color: red;">'.KERNEL_NOT_USED.'</span><br />';
	}

    $result .= '</div>';

    return $result;
}

function fMenu_Path_Temps()
{
	require_once(SB_CMS_LIB_PATH.'/sbElements.inc.php');

    $elems = new sbElements('sb_menu_path_temps', 'mpt_id', 'mpt_title', 'fMenu_Path_Temps_Get', 'pl_menu_path_temps', 'pl_menu_path_temps');
    $elems->mCategsDeleteWithElementsMenu = true;

    $elems->mCategsRootName = KERNEL_DESIGN_ROOT_NAME;
    $elems->mElemsIcon = SB_CMS_IMG_URL.'/plugins/pl_menu_path_temps_32.png';

    $elems->addSorting(PL_MENU_DESIGN_EDIT_SORT_BY_TITLE, 'mpt_title');

    $elems->mCategsPasteElemsMenuTitle = KERNEL_DESIGN_PASTE_ELEMS_MENU_TITLE;

    $elems->mElemsAddMenuTitle  = KERNEL_DESIGN_ELEMS_ADD_MENU_TITLE;
    $elems->mElemsEditMenuTitle = KERNEL_DESIGN_ELEMS_EDIT_MENU_TITLE;
    $elems->mElemsCopyMenuTitle = KERNEL_DESIGN_ELEMS_COPY_MENU_TITLE;
    $elems->mElemsCutMenuTitle  = KERNEL_DESIGN_ELEMS_CUT_MENU_TITLE;

    $elems->mElemsEditEvent =  'pl_menu_path_temps_edit';
    $elems->mElemsEditDlgWidth = 900;
	$elems->mElemsEditDlgHeight = 700;

	$elems->mElemsAddEvent =  'pl_menu_path_temps_edit';
    $elems->mElemsAddDlgWidth = 900;
	$elems->mElemsAddDlgHeight = 700;

	$elems->mElemsDeleteEvent = 'pl_menu_path_temps_delete';

	$elems->mCategsClosed = false;
	$elems->mCategsRubrikator = false;
	$elems->mElemsUseLinks = false;

	$elems->mElemsJavascriptStr .= '
	      function linkPages(e)
	      {
	          if (!sbSelEl)
	          {
	              var el = sbEventTarget(e);

                  while (el.parentNode && !el.getAttribute("true_id"))
                      el = el.parentNode;

                  var el_id = el.getAttribute("el_id");
	          }
	          else
	              var el_id = sbSelEl.getAttribute("el_id");

	          strPage = "'.SB_CMS_DIALOG_FILE.'?event=pl_pages_get_links&id=" + el_id + "&ident[]=pl_menu_path_html&ident[]=pl_menu_path_plain";
              strAttr = "resizable=1,width=800,height=600";
              sbShowModalDialog(strPage, strAttr, null, window);
	      }
	      function linkTemps(e)
	      {
	          if (!sbSelEl)
	          {
	              var el = sbEventTarget(e);

                  while (el.parentNode && !el.getAttribute("true_id"))
                      el = el.parentNode;

                  var el_id = el.getAttribute("el_id");
	          }
	          else
	              var el_id = sbSelEl.getAttribute("el_id");

	          strPage = "'.SB_CMS_DIALOG_FILE.'?event=pl_templates_get_links&id=" + el_id + "&ident[]=pl_menu_path_html&ident[]=pl_menu_path_plain";
              strAttr = "resizable=1,width=800,height=600";
              sbShowModalDialog(strPage, strAttr, null, window);
	      }
	      function menuList()
	      {
	          window.location = "'.SB_CMS_CONTENT_FILE.'?event=pl_menu";
	      }';

	$elems->addElemsMenuItem(KERNEL_LINK_PAGES_MENU_ITEM, 'linkPages();');
	$elems->addElemsMenuItem(KERNEL_LINK_TEMPS_MENU_ITEM, 'linkTemps();');
	$elems->addElemsMenuItem(PL_MENU_DESIGN_EDIT_MENUTREE_ITEM, 'menuList();', false);

    $elems->init();
}

function fMenu_Path_Temps_Edit($htmlStr = '', $footerStr = '', $add_level=false)
{
	// проверка прав доступа
	if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'], 'pl_menu_path_temps'))
		return;

	if (count($_POST) == 0 && isset($_GET['id']) && $_GET['id'] != '')
	{
   		$result = sql_param_query('SELECT mpt_title, mpt_lang, mpt_checked, mpt_top, mpt_item, mpt_last_item, mpt_bottom, mpt_fields_temps FROM sb_menu_path_temps WHERE mpt_id=?d', $_GET['id']);

   		if ($result)
	    {
        	list($mpt_title, $mpt_lang, $mpt_checked, $mpt_top, $mpt_item, $mpt_last_item, $mpt_bottom, $mpt_fields_temps) = $result[0];

        	if ($mpt_fields_temps != '')
		        $mpt_fields_temps = unserialize($mpt_fields_temps);
		    else
		        $mpt_fields_temps = array();

        	if ($mpt_checked != '')
			    $mpt_checked = explode(' ', $mpt_checked);
			else
			    $mpt_checked = array();
	    }
	    else
	    {
	        sb_show_message(PL_MENU_DESIGN_EDIT_ERROR, true, 'warning');
	        return;
	    }
	}
	elseif (count($_POST) > 0)
	{
		extract($_POST);
		if (!isset($_GET['id']))
            $_GET['id'] = '';
	}
	else
	{
	    $mpt_title = '';
	    $mpt_lang = SB_CMS_LANG;
	    $mpt_top = '';
	    $mpt_item = '';
	    $mpt_last_item = '';
	    $mpt_bottom = '';
	    $mpt_checked = array();
	    $mpt_fields_temps = array();

	    $_GET['id'] = '';
	}

    echo '<script>
	        function checkValues()
            {
                var el_title = sbGetE("mpt_title");
                if (el_title.value == "")
                {
          	         alert("'.PL_MENU_DESIGN_NO_TITLE_MSG.'");
          	         return false;
                }
            }
            function sbTabCheck(tab)
	    	{
	    	    if (window.tabs.getTitle(tab) == "+")
	    	    {
	    	    	main_form.action += "&add_level=1";
	    	    	main_form.onsubmit(null, true);
	    	    	main_form.submit();
	    	    	return false;
	    	    }

	    	    return true;
	    	}';

	if ($htmlStr != '')
	{
	    echo '
            function cancel()
            {
                var res = new Object();
		        res.html = "'.$htmlStr.'";
		        res.footer = "'.$footerStr.'";
		        res.footer_link = "";
				sbReturnValue(res);
            }
            sbAddEvent(window, "close", cancel);';
	}

	echo '</script>';

	require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

	$layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE.'?event=pl_menu_path_temps_submit'.($_SERVER['QUERY_STRING'] != '' ? '&'.$_SERVER['QUERY_STRING'] : ''), 'thisDialog', 'post', 'checkValues()', 'main_form');
	$layout->mTableWidth = '95%';

	$layout->addTab(PL_MENU_DESIGN_EDIT_TAB1);
	$layout->addHeader(PL_MENU_DESIGN_EDIT_TAB1);

	$layout->addField(PL_MENU_DESIGN_EDIT_TITLE, new sbLayoutInput('text', $mpt_title, 'mpt_title', '', 'style="width:600px;"', true));

	$layout->addField('', new sbLayoutDelim());

	$fld = new sbLayoutSelect($GLOBALS['sb_site_langs'], 'mpt_lang');
	$fld->mSelOptions = array($mpt_lang);
	$fld->mHTML = '<div class="hint_div" style="margin-top: 5px;">'.PL_MENU_DESIGN_EDIT_LANG_LABEL.'</div>';
	$layout->addField(PL_MENU_DESIGN_EDIT_LANG, $fld);

	$res_fields = sql_query('SELECT pd_fields FROM sb_plugins_data WHERE pd_plugin_ident="pl_menu"');
	$pd_fields = array();
	if ($res_fields)
	{
	    list($pd_fields) = $res_fields[0];
	    if ($pd_fields != '')
	    {
	        $options = array();
 	        $pd_fields = unserialize($pd_fields);
	        foreach ($pd_fields as $key => $value)
	        {
	            if ($value['type'] == 'checkbox')
	            {
	                $options[$value['id']] = $value['title'];
	            }
	        }

	        if (count($options) > 0)
	        {
	            $fld = new sbLayoutSelect($options, 'mpt_checked[]', '', 'multiple="multiple"');
	            $fld->mSelOptions = $mpt_checked;
	            $fld->mHTML = '<div class="hint_div" style="margin-top: 5px;">'.PL_MENU_DESIGN_EDIT_CHECKED_LABEL.'</div>';
	            $layout->addField(PL_MENU_DESIGN_EDIT_CHECKED, $fld);
   	        }
	    }
	}

	$tags = array('-', '{ID}', '{TEXT}', '{URL}', '{ALT}', '{TARGET}');
	$values = array(PL_MENU_DESIGN_EDIT_TAB1, PL_MENU_DESIGN_EDIT_TAGS_ID, PL_MENU_DESIGN_EDIT_TAGS_TITLE, PL_MENU_EDIT_URL, PL_MENU_EDIT_ALT, PL_MENU_EDIT_TARGET);

	if (count($pd_fields) > 0)
	{
		$layout->addTab(PL_MENU_DESIGN_EDIT_TAB_FIELD);
		$layout->addHeader(PL_MENU_DESIGN_EDIT_TAB_FIELD);

		$layout->addPluginFieldsTemps('pl_menu', $mpt_fields_temps, 'mpt_', $tags, $values, false);
	}

	$layout->addTab(PL_MENU_DESIGN_PATH_EDIT_TAB1);
	$layout->addHeader(PL_MENU_DESIGN_PATH_EDIT_TAB1);

	$menu_tags = array();
	$menu_tags_values = array();
	$layout->getPluginFieldsTags('pl_menu', $menu_tags, $menu_tags_values);

	$layout->addField(PL_MENU_DESIGN_PATH_EDIT_TOP, new sbLayoutTextarea($mpt_top, 'mpt_top', '', 'style="width:100%;height:50px;"'));

	$layout->addField('', new sbLayoutDelim());

	$fld = new sbLayoutTextarea($mpt_item, 'mpt_item', '', 'style="width:100%;height:100px;"');
	$fld->mTags = array_merge($tags, $menu_tags);
	$fld->mValues = array_merge($values, $menu_tags_values);
	$layout->addField(PL_MENU_DESIGN_PATH_EDIT_ITEM, $fld);

	$fld = new sbLayoutTextarea($mpt_last_item, 'mpt_last_item', '', 'style="width:100%;height:100px;"');
	$fld->mTags = array_merge($tags, $menu_tags);
	$fld->mValues = array_merge($values, $menu_tags_values);
	$layout->addField(PL_MENU_DESIGN_PATH_EDIT_LAST_ITEM, $fld);

	$layout->addField('', new sbLayoutDelim());

	$layout->addField(PL_MENU_DESIGN_PATH_EDIT_BOTTOM, new sbLayoutTextarea($mpt_bottom, 'mpt_bottom', '', 'style="width:100%;height:50px;"'));

	$layout->addButton('submit', KERNEL_SAVE, 'btn_save', '', ($_SESSION['sbPlugins']->isRightAvailable('pl_menu', 'design_edit') ? '' : 'disabled="disabled"'));
    if ($_GET['id'] != '')
        $layout->addButton('submit', KERNEL_APPLY, 'btn_apply', '', ($_SESSION['sbPlugins']->isRightAvailable('pl_menu', 'design_edit') ? '' : 'disabled="disabled"'));
    $layout->addButton('button', KERNEL_CANCEL, '', '', $htmlStr != '' ? 'onclick="cancel()"' : 'onclick="sbCloseDialog()"');

    $layout->show();
}

function fMenu_Path_Temps_Submit()
{
	// проверка прав доступа
	if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'], 'pl_menu_path_temps'))
		return;

	if (!isset($_GET['id']))
        $_GET['id'] = '';

    $mpt_checked = array();
    extract($_POST);

    if ($mpt_title == '')
    {
        sb_show_message(PL_MENU_DESIGN_NO_TITLE_MSG, false, 'warning');
        fMenu_Path_Temps_Edit();
        return;
    }

    $row = array();
    $row['mpt_title'] = $mpt_title;
    $row['mpt_lang'] = $mpt_lang;
    $row['mpt_checked'] = implode(' ', $mpt_checked);
    $row['mpt_top'] = $mpt_top;
    $row['mpt_item'] = $mpt_item;
    $row['mpt_last_item'] = $mpt_last_item;
    $row['mpt_bottom'] = $mpt_bottom;
    $row['mpt_fields_temps'] = isset($mpt_fields_temps) ? serialize($mpt_fields_temps) : '';
	$row['mpt_plugin_ident'] = 'pl_menu';

    if ($_GET['id'] != '')
	{
	    $res = sql_param_query('SELECT mpt_title FROM sb_menu_path_temps WHERE mpt_id=?d', $_GET['id']);
	    if ($res)
	    {
	        // редактирование
	        list($old_title) = $res[0];

    	    sql_param_query('UPDATE sb_menu_path_temps SET ?a WHERE mpt_id=?d', $row, $_GET['id'], sprintf(PL_MENU_DESIGN_PATH_EDIT_OK, $old_title));
            sbQueryCache::updateTemplate('sb_menu_path_temps', $_GET['id']);

            $footer_ar = fCategs_Edit_Elem('design_edit');
    	    if (!$footer_ar)
    	    {
    	        sb_show_message(PL_MENU_DESIGN_EDIT_ERROR, false, 'warning');
                sb_add_system_message(sprintf(PL_MENU_DESIGN_PATH_EDIT_SYSTEMLOG_ERROR, $old_title), SB_MSG_WARNING);

                fMenu_Path_Temps_Edit();
    		    return;
    	    }
    	    $footer_str = $GLOBALS['sbSql']->escape($footer_ar[0], false, false);

    	    $row['mpt_id'] = intval($_GET['id']);

            $html_str = fMenu_Path_Temps_Get($row);
    	    $html_str = sb_str_replace(array("\r\n", "\r", "\n"), '', $html_str);
            $html_str = $GLOBALS['sbSql']->escape($html_str, false, false);

    	    if (!isset($_POST['btn_apply']))
    	    {
        	    echo '<script>
        		        var res = new Object();
        		        res.html = "'.$html_str.'";
        		        res.footer = "'.$footer_str.'";
        		        res.footer_link = "";
        				sbReturnValue(res);
        			  </script>';
    	    }
    	    else
    	    {
    	        fMenu_Path_Temps_Edit($html_str, $footer_str);
    	    }
	    }
	    else
	    {
	        sb_show_message(PL_MENU_DESIGN_PATH_EDIT_ERROR, false, 'warning');
            sb_add_system_message(sprintf(PL_MENU_DESIGN_PATH_EDIT_SYSTEMLOG_ERROR, $mpt_title), SB_MSG_WARNING);

            fMenu_Path_Temps_Edit();
		    return;
	    }
	}
	else
	{
	    $error = true;
	    if (sql_param_query('INSERT INTO sb_menu_path_temps SET ?a', $row))
	    {
    		$id = sql_insert_id();

    		if (fCategs_Add_Elem($id, 'design_edit'))
    		{
                sbQueryCache::updateTemplate('sb_menu_path_temps', $id);
        		sb_add_system_message(sprintf(PL_MENU_DESIGN_PATH_ADD_OK, $mpt_title));

        		echo '<script>
        				sbReturnValue('.$id.');
        			  </script>';

        		$error = false;
    		}
    		else
    		{
    		    sql_query('DELETE FROM sb_menu_path_temps WHERE mpt_id="'.$id.'"');
    		}
	    }

	    if ($error)
	    {
	        sb_show_message(sprintf(PL_MENU_DESIGN_PATH_ADD_ERROR, $mpt_title), false, 'warning');
            sb_add_system_message(sprintf(PL_MENU_DESIGN_PATH_ADD_SYSTEMLOG_ERROR, $mpt_title), SB_MSG_WARNING);

            fMenu_Path_Temps_Edit();
		    return;
	    }
	}
}

function fMenu_Path_Temps_Delete()
{
	$id = intval($_GET['id']);

    $pages = sql_query('SELECT pages.p_id FROM sb_pages pages, sb_elems elems
	                    WHERE elems.e_link="page" AND elems.e_temp_id="'.$id.'" AND (elems.e_ident="pl_menu_path_html" OR elems.e_ident="pl_menu_path_plain" OR elems.e_ident="pl_pages_path_html" OR elems.e_ident="pl_pages_path_plain" OR elems.e_ident="pl_forum_forum_path") AND pages.p_id=elems.e_p_id LIMIT 1');

    $temps = sql_query('SELECT temps.t_id FROM sb_templates temps, sb_elems elems
	                    WHERE elems.e_link="temp" AND elems.e_temp_id="'.$id.'" AND (elems.e_ident="pl_menu_path_html" OR elems.e_ident="pl_menu_path_plain" OR elems.e_ident="pl_pages_path_html" OR elems.e_ident="pl_pages_path_plain" OR elems.e_ident="pl_forum_forum_path") AND temps.t_id=elems.e_p_id LIMIT 1');

    if ($pages || $temps)
    {
        echo PL_MENU_DESIGN_DELETE_ERROR;
    }
}
/**
 * Ф-ция копирования элементов меню, при вставке раздела с элементами
 *
 */
function fMenu_After_Paste_With_Elements()
{
	// Достаю элементы
	$res = sql_query('SELECT m_id FROM sb_menu WHERE m_cat_id = ?d', $_GET['paste_cat_id']);
	if($res)
	{
		foreach($res as $value)
		{
			$new_menu_id = $GLOBALS['sbSql']->duplicateRow($value[0], 'm_id', 'sb_menu');
			sql_query('UPDATE sb_menu SET m_cat_id = ?d WHERE m_id = ?d',$_GET['new_cat_id'], $new_menu_id);
		}
	}
}

?>