<?php
function fMessages_Read()
{
    require_once(SB_CMS_LIB_PATH.'/sbCustomElements.inc.php');
    
    $menuObj = new sbCustomElements('inbox');

    $menuObj->addItem('inbox', PL_MESSAGES_INBOX, 'pl_messages_inbox', 'inbox.png');
    $menuObj->addItem('send', PL_MESSAGES_SEND, 'pl_messages_send', 'sent.png');
    $menuObj->addItem('basket', PL_MESSAGES_BASKET, 'pl_messages_basket', 'basket.png');
    
    $menuObj->mCategsTreeLines = false;
    $menuObj->mImagePath = '/messages/';
    $menuObj->mCategsJavascriptStr = '
        document.body.onselectstart = "";
                
        function showFiles(id)
        {
           strPage = "'.SB_CMS_MODAL_DIALOG_FILE.'?event=pl_messages_list_files&id=" + id;
           strAttr = "resizable=1,width=800,height=600";
           sbShowModalDialog(strPage, strAttr);
        }
        function showFull(id)
        {
            sbElemsShow(sb_cms_empty_file + "?event=pl_messages_full&id=" + id + "&ident=" + sbCatTree.getSelectedItemId(), true); 
        }
        function addMessage(um_id)
        {
            if (typeof(um_id) == "undefined")
                um_id = "";
  
            var strPage = "'.SB_CMS_MODAL_DIALOG_FILE.'?event=pl_messages_add&id="+um_id;
            var strAttr = "resizable=1,width=700,height=550";
            sbShowModalDialog(strPage, strAttr, afterAddMessage);
        }
        function afterAddMessage()
        {
            if(sbModalDialog.returnValue)
            {
                sbShowMsgDiv("'.PL_MESSAGES_SEND_OK.'", "information.png");
            }
            
            if (sbModalDialog.returnValue == "1" && sbCatTree.getSelectedItemId() == "send")
            {
                setTimeout("sbElemsRefresh()", 0);
            }
        }
        function resendMessage(um_id)
        {
            var strPage = "'.SB_CMS_MODAL_DIALOG_FILE.'?event=pl_messages_resend&id="+um_id;
            var strAttr = "resizable=1,width=500,height=700";
            sbShowModalDialog(strPage, strAttr, afterResendMessage);
        }
        function afterResendMessage()
        {
            if(sbModalDialog.returnValue)
            {
                sbShowMsgDiv("'.PL_MESSAGES_RESEND_OK.'", "information.png");
            }
        }
        ';
    
    $menuObj->mHeaderStr = '
       <div class="sb_filter_header" style="font-weight: normal;padding-top: 5px;">
           <a href="javascript:void(0);" onclick="addMessage();"><img src="'.SB_CMS_IMG_URL.'/messages/add.png" border="0" align="absmiddle" width="16" height="11" />&nbsp;&nbsp;&nbsp;'.PL_MESSAGES_ADD.'</a>
       </div>';
    
    $menuObj->init();
}

function fMessages_Inbox()
{
    echo '<script>
    document.body.setAttribute("unselectable", "off");
    selectAll = function(chk)
    {
        var els = document.getElementsByTagName("input");
        for (var i = 0; i < els.length; i++)
        {
            els[i].checked = chk;
        }
    }
    deleteAll = function()
    {
        if(confirm("'.PL_MESSAGES_CONFIRM_DELETE.'"))
        {
            var els = document.getElementsByTagName("input");
            var ids = "0";
            for (var i = 0; i < els.length; i++)
            {
                if (els[i].checked)
                    ids += "," + els[i].value;
            }
        
            if (ids == "0")
            {
                alert("'.PL_MESSAGES_ERROR_DELETE_NO_MSG.'");
                return;
            }

            var res = sbLoadSync("'.SB_CMS_EMPTY_FILE.'?event=pl_messages_delete_restore&ids=" + ids);
            if(res == "TRUE")
            {
                sbElemsRefresh();
            }
            else
            {
                alert("'.PL_MESSAGES_ERROR_DELETE.'");
            }
        }
    }
    readAll = function()
    {
        var els = document.getElementsByTagName("input");
        var ids = "0";
        for (var i = 0; i < els.length; i++)
        {
            if (els[i].checked)
                ids += "," + els[i].value;
        }
    
        if (ids == "0")
        {
            alert("'.PL_MESSAGES_ERROR_DELETE_NO_MSG.'");
            return;
        }

        var res = sbLoadSync("'.SB_CMS_EMPTY_FILE.'?event=pl_messages_look&ids=" + ids);
        if(res == "TRUE")
        {
            sbElemsRefresh();
        }
        else
        {
            alert("'.PL_MESSAGES_ERROR_READ.'");
        }
    }
    </script>';
    
    require_once(SB_CMS_LIB_PATH.'/sbDBPager.inc.php');
    
    $total = true;
    $pager = new sbDBPager('um', 7, 15, 'content');
    $result = $pager->init($total, 'SELECT um.um_id, um.um_from_id, su.u_login, su.u_name, um.um_time, um.um_title, um.um_look, um.um_files FROM sb_users_messages um LEFT JOIN sb_users su ON um.um_from_id=su.u_id WHERE um_to_id=?d AND um_delete != "1" ORDER BY um.um_time DESC', $_SESSION['sbAuth']->getUserId());

    $pager->mBeginTemp = '<a href="javascript: sbElemsShow(\'{HREF}\');void(0);" target="{TARGET}"><img src="'.SB_CMS_IMG_URL.'/begin.gif" width="14" height="15" border="0" alt="'.KERNEL_PAGER_BEGIN.'" align="absmiddle"></a>';
    $pager->mBeginTempDisabled = '<img src="'.SB_CMS_IMG_URL.'/begin_gray.gif" width="14" height="15" border="0" alt="'.KERNEL_PAGER_BEGIN.'" align="absmiddle">';

    $pager->mPrevTemp = '<a href="javascript: sbElemsShow(\'{HREF}\');void(0);" target="{TARGET}"><img src="'.SB_CMS_IMG_URL.'/previous.gif" width="14" height="15" border="0" alt="'.KERNEL_PAGER_PREV.'" align="absmiddle"></a>';
    $pager->mPrevTempDisabled = '<img src="'.SB_CMS_IMG_URL.'/previous_gray.gif" width="14" height="15" border="0" alt="'.KERNEL_PAGER_PREV.'" align="absmiddle">';

    $pager->mNextTemp = '<a href="javascript: sbElemsShow(\'{HREF}\');void(0);" target="{TARGET}"><img src="'.SB_CMS_IMG_URL.'/next.gif" width="14" height="15" border="0" alt="'.KERNEL_PAGER_NEXT.'" align="absmiddle"></a>';
    $pager->mNextTempDisabled = '<img src="'.SB_CMS_IMG_URL.'/next_gray.gif" width="14" height="15" border="0" alt="'.KERNEL_PAGER_NEXT.'" align="absmiddle">';

    $pager->mEndTemp = '<a href="javascript: sbElemsShow(\'{HREF}\');void(0);" target="{TARGET}"><img src="'.SB_CMS_IMG_URL.'/end.gif" width="14" height="15" border="0" alt="'.KERNEL_PAGER_END.'" align="absmiddle"></a>';
    $pager->mEndTempDisabled = '<img src="'.SB_CMS_IMG_URL.'/end_gray.gif" width="14" height="15" border="0" alt="'.KERNEL_PAGER_END.'" align="absmiddle">';

    $pager->mNumberTemp = '&nbsp;<a href="javascript: sbElemsShow(\'{HREF}\');void(0);" target="{TARGET}">{NUMBER}</a>&nbsp;';
    
    echo '<center>';
    
    if($result)
    {
        echo '<div align="right" style="width: 95%; margin: 15px 0px 15px 0px;">
            &nbsp;&nbsp;&nbsp;<a href="javascript:void(0)" onclick="readAll()" ><img src="'.SB_CMS_IMG_URL.'/messages/read.png" width="16" height="16" border="0" align="absmiddle" />&nbsp;'.PL_MESSAGES_READ_ALL.'</a>
            &nbsp;&nbsp;&nbsp;<a href="javascript:void(0)" onclick="deleteAll()" ><img src="'.SB_CMS_IMG_URL.'/messages/delete.png" width="16" height="16" border="0" align="absmiddle" />&nbsp;'.PL_MESSAGES_DELETE_ALL.'</a>
        </div>';
    }
    else 
    {
        echo '<br /><br />';
    }
    
    if ($result)
    {
        echo '<div style="width:95%;text-align: left;">';
        $body = array();
        for($i = 0; $i < count($result); $i++)
        {
            list($um_id, $u_id, $u_login, $u_name, $um_time, $um_title, $um_look, $um_files) = $result[$i];
        
            if($um_files != '')
                $um_files = @unserialize($um_files);
            else 
                $um_files = array();
                
            $files = '&nbsp;';
            if(count($um_files) > 0)
            {
                $files = '<a href="javascript:void(0)" onclick="showFiles('.$um_id.')" title="'.PL_MESSAGES_SHOW_FILES.'"><img src="'.SB_CMS_IMG_URL.'/clip.gif" width="7" height="13" border="0" /></a>';
            }

            $chk = '<input type="checkbox" value="'.$um_id.'" name="u_mes" id="u_mes" style="margin-top:6px;width:12px;">';
            $img = '<a href="javascript:void(0)" onclick="showFull('.$um_id.')"><img src="'.SB_CMS_IMG_URL.'/messages/'.($um_look == 0? 'read_no' : 'read_ok').'.png" width="12" height="12" border="0" align="absmiddle" /></a>';
            $title = '<a href="javascript:void(0)" onclick="showFull('.$um_id.')">'.($um_look == 0 ? '<b>' : '').(strlen($um_title) > 50 ? substr($um_title, 0, 50).'...' : $um_title).($um_look == 0 ? '</b>' : '').'</a>';

            if ($u_login != '')
            {
                $reply = '<a href="javascript:void(0)" onclick="addMessage('.$um_id.')" title="'.PL_MESSAGES_REPLY.'"><img src="'.SB_CMS_IMG_URL.'/messages/reply.png" width="16" height="16" border="0" alt="'.PL_MESSAGES_REPLY.'" /></a>';
                $user = '<b>'.($_SESSION['sbPlugins']->isRightAvailable('pl_users', 'read') ? '<a href="javascript:void(0);" onclick="sbShowDialog(\''.SB_CMS_DIALOG_FILE.'?event=pl_kernel_user_info&id='.$u_id.'\', \'resizable=1,width=800,height=600\');">'.$u_login.'</a>' : $u_login).'</b>'.($u_name != '' ? '<br />('.$u_name.')' : '');
            }
            else 
            {
                $reply = '';
                $user = PL_MESSAGES_NO_USER;
            }                
            
            $resend = '<a href="javascript:void(0)" onclick="resendMessage('.$um_id.')" title="'.PL_MESSAGES_RESEND.'" ><img src="'.SB_CMS_IMG_URL.'/messages/resend.png" width="16" height="16" alt="'.PL_MESSAGES_RESEND.'" border="0" style="margin-top: 2px" /></a>';
            $body[] = array($files, $chk, $img, $title, $user, sb_date('d.m.Y H:i', $um_time), $reply, $resend);
        }
        
        require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
        
        $layout = new sbLayout();
        $layout->mTableWidth = '100%';

        $table = new sbLayoutTable(array('', '', '', PL_MESSAGES_TITLE, PL_MESSAGES_FROM_USER, PL_MESSAGES_DATE, '', ''), $body);
        $table->mWidth = array('10px', '10px', '10px', '70%', '15%', '15%', '20px', '20px');
        $table->mAlign = array('center', 'center', 'center', '', 'center', 'center', 'center', 'center');
        $table->mVAlign = array('middle', 'middle', 'middle', 'middle', 'middle', 'middle', 'middle', 'middle');
        
        $layout->addField('',  $table);
        $layout->show();   
        
        echo '<br />
        <img src="'.SB_CMS_IMG_URL.'/arrow_all.png" width="38" height="22" border="0" style="margin-left: 25px;"> <a href="javascript: selectAll(true); void(0);">'.PL_MESSAGES_SELECT_ALL.'</a>
        &nbsp; / &nbsp;<a href="javascript: selectAll(false); void(0);">'.PL_MESSAGES_UNSELECT_ALL.'</a><br /></div>'.$pager->show();
    }
    else 
    {
        sb_show_message(PL_MESSAGES_NO_MESSAGES_MSG, true);
    }
    
    echo '</center>';
}

function fMessages_List_Files()
{
    $result = sql_param_query('SELECT um_files FROM sb_users_messages WHERE um_id=?d', $_GET['id']);
    if (!$result)
    {
        sb_show_message(PL_MESSAGES_NO_MESSAGE_MSG, true);
        return;
    }
    
    list($um_files) = $result[0];
    if ($um_files != '')
        $um_files = unserialize($um_files);
    else 
        $um_files = array();
        
    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
    require_once(SB_CMS_LIB_PATH.'/sbFilesList.inc.php');
        
    echo '<center><br /><br />';
    
    $layout = new sbLayout();
    $layout->mTableWidth = '90%';
    
    $files = array();
    for($i = 0; $i < count($um_files); $i++)
    {
        if($um_files[$i] != '')
        {
            $ext = pathinfo($um_files[$i]);
            $ext = isset($ext['extension']) ? $ext['extension'] : '';
            
            $icon = sbFilesList::getFileIcon($ext);
            
            $files[] = array('<a href="'.SB_CMS_USER_UPLOAD_URL.'/messages/'.$um_files[$i].'" target="_blank">'.$icon.'&nbsp;&nbsp;'.$um_files[$i].'</a>');
        }
    }
    
    $layout->addField('',  new sbLayoutTable(array(PL_MESSAGES_FILES), $files)); 
    $layout->addButton('button', KERNEL_CLOSE, '', '', 'onclick="sbCloseDialog()"');
    $layout->show();
    
    echo '</center>';
}

function fMessages_Delete_Restore()
{
    $in_str = explode(',', $_GET['ids']); 
    if (isset($_GET['action']) && $_GET['action'] == 'delete')
    {
        // удаление
        $res = sql_param_query('SELECT um_files FROM sb_users_messages WHERE um_id IN (?a)', $in_str);
        if ($res)
        {
            for ($i = 0; $i < count($res); $i++)
            {
                list($um_files) = $res[$i];
                
                if ($um_files != '')
                    $files = unserialize($um_files);
                else 
                    $files = array();
                    
                for($j = 0; $j < count($files); $j++)
                {
                    $file = SB_CMS_USER_UPLOAD_PATH.'/messages/'.$files[$j];
                    if ($files[$j] != '' && @file_exists($file) && @is_file($file))
                        @unlink($file);
                }
            }
        }
        
        if (sql_param_query('DELETE FROM sb_users_messages WHERE um_id IN (?a)', $in_str))
        {
            echo 'TRUE';
        }
    }
    elseif (isset($_GET['action']) && $_GET['action'] == 'restore')
    {
        if (sql_param_query('UPDATE sb_users_messages SET um_delete="0" WHERE um_id IN (?a)', $in_str))
        {
            // восстановление
            echo 'TRUE';
        }
    }
    elseif (sql_param_query('UPDATE sb_users_messages SET um_delete="1" WHERE um_id IN (?a)', $in_str))
    {
        // в корзину
        echo 'TRUE';
    }
}

function fMessages_Look()
{
    $in_str = explode(',', $_GET['ids']); 
    
    if (sql_param_query('UPDATE sb_users_messages SET um_look="1" WHERE um_id IN (?a)', $in_str))
    {
        echo 'TRUE';
    }
}

function fMessages_Full()
{   
    if(isset($_GET['id']) && $_GET['id'] != '')
    {
        $id = intval($_GET['id']);
    }
    else 
    {
        sb_show_message(PL_MESSAGES_NO_MESSAGE_MSG, true, 'warning');
        return;
    }
    $ident = preg_replace('/^A-Za-z0-9\-_]+/', '', $_GET['ident']);
    
    $result = sql_param_query('SELECT um.um_from_id, um.um_to_id, um.um_to_ids, su.u_login, su.u_name, um.um_time, um.um_title, um.um_message, um.um_files FROM sb_users_messages um LEFT JOIN sb_users su ON um.um_from_id=su.u_id WHERE um_id=?d', $id);
   
    if (!$result)
    {
        sb_show_message(PL_MESSAGES_NO_MESSAGE_MSG, true, 'warning');
        return;
    }
    
    list($um_from_id, $um_to_id, $um_to_ids, $u_login, $u_name, $um_time, $um_title, $um_message, $um_files) = $result[0];
    
    if ($ident == 'inbox')
    {
        $res_prev = sql_param_query('SELECT um_id FROM sb_users_messages WHERE um_delete != "1" AND um_to_id=?d AND um_time <= ? AND um_id != ?d ORDER BY um_time DESC LIMIT 1', $_SESSION['sbAuth']->getUserId(), $um_time, $id);
        $res_next = sql_param_query('SELECT um_id FROM sb_users_messages WHERE um_delete != "1" AND um_to_id=?d AND um_time >= ? AND um_id != ?d ORDER BY um_time ASC LIMIT 1', $_SESSION['sbAuth']->getUserId(), $um_time, $id);
    }
    elseif ($ident == 'send')
    {
        $res_prev = sql_param_query('SELECT um_id FROM sb_users_messages WHERE um_delete != "1" AND um_from_id=?d AND um_to_ids != "" AND um_time <= ? AND um_id != ?d ORDER BY um_time DESC LIMIT 1', $_SESSION['sbAuth']->getUserId(), $um_time, $id);
        $res_next = sql_param_query('SELECT um_id FROM sb_users_messages WHERE um_delete != "1" AND um_from_id=?d AND um_to_ids != "" AND um_time >= ? AND um_id != ?d ORDER BY um_time ASC LIMIT 1', $_SESSION['sbAuth']->getUserId(), $um_time, $id);        
    }
    elseif ($ident == 'basket')
    {
        $res_prev = sql_param_query('SELECT um_id FROM sb_users_messages WHERE um_delete = "1" AND (um_to_id=?d OR um_from_id=?d) AND um_time <= ?d AND um_id != ? ORDER BY um_time DESC LIMIT 1', $_SESSION['sbAuth']->getUserId(), $_SESSION['sbAuth']->getUserId(), $um_time, $id);
        $res_next = sql_param_query('SELECT um_id FROM sb_users_messages WHERE um_delete = "1" AND (um_to_id=?d OR um_from_id=?d) AND um_time >= ?d AND um_id != ? ORDER BY um_time ASC LIMIT 1', $_SESSION['sbAuth']->getUserId(), $_SESSION['sbAuth']->getUserId(), $um_time, $id);        
    }

    if ($ident == 'basket')
    {
        echo '<script>
        document.body.setAttribute("unselectable", "off");
        deleteMessage = function()
        {
            if(confirm("'.PL_MESSAGES_CONFIRM_EMPTY_ONE.'"))
            {
                var res = sbLoadSync("'.SB_CMS_EMPTY_FILE.'?event=pl_messages_delete_restore&ids='.$id.'&action=delete");
                if(res == "TRUE")
                {
                    var next_id = "'.($res_next ? $res_next[0][0] : ($res_prev ? $res_prev[0][0] : -1)).'";
                    if (next_id != -1)
                        sbElemsShow(sb_cms_empty_file + "?event=pl_messages_full&id="+next_id+"&ident='.$ident.'");
                    else
                        sbElemsShow(sb_cms_empty_file + "?event=pl_messages_'.$ident.'");
                }
                else
                {
                    alert("'.PL_MESSAGES_ERROR_EMPTY_ONE.'");
                }
            }
        }
        restoreMessage = function()
        {
            if(confirm("'.PL_MESSAGES_CONFIRM_RESTORE_ONE.'"))
            {
                var res = sbLoadSync("'.SB_CMS_EMPTY_FILE.'?event=pl_messages_delete_restore&ids='.$id.'&action=restore");
                if(res == "TRUE")
                {
                    var next_id = "'.($res_next ? $res_next[0][0] : ($res_prev ? $res_prev[0][0] : -1)).'";
                    if (next_id != -1)
                        sbElemsShow(sb_cms_empty_file + "?event=pl_messages_full&id="+next_id+"&ident='.$ident.'");
                    else
                        sbElemsShow(sb_cms_empty_file + "?event=pl_messages_'.$ident.'");
                }
                else
                {
                    alert("'.PL_MESSAGES_ERROR_RESTORE_ONE.'");
                }
            }
        }
        </script>';
    }
    else 
    {
        echo '<script>
        deleteMessage = function()
        {
            if(confirm("'.PL_MESSAGES_CONFIRM_DELETE_ONE.'"))
            {
                var res = sbLoadSync("'.SB_CMS_EMPTY_FILE.'?event=pl_messages_delete_restore&ids='.$id.'");
                if(res == "TRUE")
                {
                    var next_id = "'.($res_next ? $res_next[0][0] : ($res_prev ? $res_prev[0][0] : -1)).'";
                    if (next_id != -1)
                        sbElemsShow(sb_cms_empty_file + "?event=pl_messages_full&id="+next_id+"&ident='.$ident.'");
                    else
                        sbElemsShow(sb_cms_empty_file + "?event=pl_messages_'.$ident.'");
                }
                else
                {
                    alert("'.PL_MESSAGES_ERROR_DELETE_ONE.'");
                }
            }
        }
        </script>';
    }
    
    echo '<center>
        <table style="width: 95%; margin: 15px 0px 15px 0px;" align="center">
        <tr>
        <td align="left">
            <a href="javascript:void(0);" onclick="resendMessage('.$id.');"><img src="'.SB_CMS_IMG_URL.'/messages/resend.png" width="16" height="16" border="0" align="absmiddle" />&nbsp;'.PL_MESSAGES_RESEND.'</a>
            '.($u_login != '' && $um_from_id != $_SESSION['sbAuth']->getUserId() ? '&nbsp;&nbsp;
            <a href="javascript:void(0);" onclick="addMessage('.$id.');"><img src="'.SB_CMS_IMG_URL.'/messages/reply.png" width="16" height="16" border="0" align="absmiddle" />&nbsp;'.PL_MESSAGES_REPLY.'</a>' : '').
        '</td>
        <td align="right">'.
        ($ident == 'basket' ? 
            '&nbsp;&nbsp;&nbsp;<a href="javascript:void(0)" onclick="restoreMessage()" ><img src="'.SB_CMS_IMG_URL.'/messages/restore.png" width="16" height="16" border="0" align="absmiddle" />&nbsp;'.PL_MESSAGES_RESTORE_ALL.'</a>
             &nbsp;&nbsp;&nbsp;<a href="javascript:void(0)" onclick="deleteMessage()" ><img src="'.SB_CMS_IMG_URL.'/messages/delete.png" width="16" height="16" border="0" align="absmiddle" />&nbsp;'.PL_MESSAGES_EMPTY_ALL.'</a>' 
            : 
            '&nbsp;&nbsp;&nbsp;<a href="javascript:void(0)" onclick="deleteMessage()" ><img src="'.SB_CMS_IMG_URL.'/messages/delete.png" width="16" height="16" border="0" align="absmiddle" />&nbsp;'.PL_MESSAGES_DELETE_ALL.'</a>').
        '</td>
        </tr></table>';
    
    if($_SESSION['sbAuth']->getUserId() == $um_to_id)
    {
        sql_param_query('UPDATE sb_users_messages SET um_look="1" WHERE um_id=?d', $id);
    }
    
    $user = '';
    
    if ($ident == 'inbox' || ($ident == 'basket' && $um_to_ids == ''))
    {
        if ($u_login != '')
            $user = '<b>'.($_SESSION['sbPlugins']->isRightAvailable('pl_users', 'read') ? '<a href="javascript:void(0);" onclick="sbShowDialog(\''.SB_CMS_DIALOG_FILE.'?event=pl_kernel_user_info&id='.$um_from_id.'\', \'resizable=1,width=800,height=600\');">'.$u_login.'</a>' : $u_login).'</b>'.($u_name != '' ? ' ('.$u_name.')' : '');
        else 
            $user = PL_MESSAGES_NO_USER;
    }
    elseif ($ident == 'send' || ($ident == 'basket' && $um_to_ids != ''))
    {
        $u_res = sql_param_query('SELECT u.u_id, u.u_name, u.u_login, um.um_look FROM sb_users u LEFT JOIN sb_users_messages um ON (um.um_to_id=u.u_id AND um.um_parent_id=?d) WHERE u_id IN ('.$um_to_ids.')', $id);   
        $user = '';
        if ($u_res)
        {
            $num = count($u_res);
            for ($i = 0; $i < count($u_res); $i++)
            {
                list($u_id, $u_name, $u_login, $um_look) = $u_res[$i];
                if (is_null($um_look)) 
                {
                    $user .= '<img src="'.SB_CMS_IMG_URL.'/messages/read_del.png" width="12" height="12" border="0" align="absmiddle" />';
                }
                else 
                {
                    $user .= '<img src="'.SB_CMS_IMG_URL.'/messages/'.($um_look == 0 ? 'read_no' : 'read_ok').'.png" width="12" height="12" border="0" align="absmiddle" />';
                }
                $user .= '&nbsp;<b>'.($_SESSION['sbPlugins']->isRightAvailable('pl_users', 'read') ? '<a href="javascript:void(0);" onclick="sbShowDialog(\''.SB_CMS_DIALOG_FILE.'?event=pl_kernel_user_info&id='.$u_id.'\', \'resizable=1,width=800,height=600\');">'.$u_login.'</a>' : $u_login).'</b>'.($u_name != '' ? ' ('.$u_name.')' : '').($i != $num - 1 ? ', ' : '');                     
            }
        }
        else 
        {
            $user = PL_MESSAGES_NO_USER;
        }
    }
        
    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
    
    $layout = new sbLayout();
    $layout->mTableWidth = '95%';
    
    $layout->addHeader($um_title);
        
    $layout->addField($ident == 'send' || ($ident == 'basket' && $um_to_ids != '') ? PL_MESSAGES_TO_USER : PL_MESSAGES_FROM_USER,  new sbLayoutLabel($user, '', '', false));
    $layout->addField(PL_MESSAGES_DATE,  new sbLayoutLabel(sb_date('d.m.Y H:i', $um_time)));
        
    $layout->addField('', new sbLayoutDelim());
    
    if ($um_files != '')
        $um_files = unserialize($um_files);
    else 
        $um_files = array();
        
    if(count($um_files) > 0)
    {
        $files = '<ul style="list-style-image: url(\''.SB_CMS_IMG_URL.'/clip.gif\');margin:5px;padding: 0px 0px 0px 20px;">';
        for($i = 0; $i < count($um_files); $i++)
        {
            if($um_files[$i] != '')
               $files .= '<li><a href="'.SB_DOMAIN.'/cms/upload/messages/'.$um_files[$i].'" target="_blank">'.$um_files[$i].'</a></li>';
        }
        $files .= '</ul>';
        $layout->addField(PL_MESSAGES_FILES,  new sbLayoutHTML($files));
        $layout->addField('', new sbLayoutDelim());
    }
    
    $layout->addField(PL_MESSAGES_MESSAGE,  new sbLayoutLabel($um_message, '', '', false));
    
    $layout->show();

    if ($res_prev)
    {
        $prev = '<a href="javascript: sbElemsShow(\''.SB_CMS_EMPTY_FILE.'?event=pl_messages_full&id='.$res_prev[0][0].'&ident='.$_GET['ident'].'\');void(0);"><img src="'.SB_CMS_IMG_URL.'/previous.gif" width="14" height="15" border="0" alt="'.PL_MESSAGES_PREV.'" align="absmiddle"></a>';
    }
    else 
    {
        $prev = '<img src="'.SB_CMS_IMG_URL.'/previous_gray.gif" width="14" height="15" border="0" alt="'.PL_MESSAGES_PREV.'" align="absmiddle">';
    }

    if ($res_next)
    {
        $next = '<a href="javascript: sbElemsShow(\''.SB_CMS_EMPTY_FILE.'?event=pl_messages_full&id='.$res_next[0][0].'&ident='.$_GET['ident'].'\');void(0);"><img src="'.SB_CMS_IMG_URL.'/next.gif" width="14" height="15" border="0" alt="'.PL_MESSAGES_NEXT.'" align="absmiddle"></a>';
    }
    else 
    {
        $next = '<img src="'.SB_CMS_IMG_URL.'/next_gray.gif" width="14" height="15" border="0" alt="'.PL_MESSAGES_NEXT.'" align="absmiddle">';
    }
    
    echo $prev.'&nbsp;&nbsp;&nbsp;'.$next;
    echo '<hr style="width:90%;"><a href="javascript:sbElemsBack();void(0);">['.KERNEL_BACK.']</a>';
    
}

function fMessages_Send()
{
    echo '<script>
    document.body.setAttribute("unselectable", "off");
    selectAll = function(chk)
    {
        var els = document.getElementsByTagName("input");
        for (var i = 0; i < els.length; i++)
        {
            els[i].checked = chk;
        }
    }
    deleteAll = function()
    {
        if(confirm("'.PL_MESSAGES_CONFIRM_DELETE.'"))
        {
            var els = document.getElementsByTagName("input");
            var ids = "0";
            for (var i = 0; i < els.length; i++)
            {
                if (els[i].checked)
                    ids += "," + els[i].value;
            }
        
            if (ids == "0")
            {
                alert("'.PL_MESSAGES_ERROR_DELETE_NO_MSG.'");
                return;
            }

            var res = sbLoadSync("'.SB_CMS_EMPTY_FILE.'?event=pl_messages_delete_restore&ids=" + ids);
            if(res == "TRUE")
            {
                sbElemsRefresh();
            }
            else
            {
                alert("'.PL_MESSAGES_ERROR_DELETE.'");
            }
        }
    }
    </script>';
    
    require_once(SB_CMS_LIB_PATH.'/sbDBPager.inc.php');
    
    $total = true;
    $pager = new sbDBPager('um', 7, 15, 'content');
    $result = $pager->init($total, 'SELECT um_id, um_to_ids, um_time, um_title, um_files FROM sb_users_messages WHERE um_from_id=?d AND um_delete != "1" AND um_to_ids != "" ORDER BY um_time DESC', $_SESSION['sbAuth']->getUserId());

    $pager->mBeginTemp = '<a href="javascript: sbElemsShow(\'{HREF}\');void(0);" target="{TARGET}"><img src="'.SB_CMS_IMG_URL.'/begin.gif" width="14" height="15" border="0" alt="'.KERNEL_PAGER_BEGIN.'" align="absmiddle"></a>';
    $pager->mBeginTempDisabled = '<img src="'.SB_CMS_IMG_URL.'/begin_gray.gif" width="14" height="15" border="0" alt="'.KERNEL_PAGER_BEGIN.'" align="absmiddle">';

    $pager->mPrevTemp = '<a href="javascript: sbElemsShow(\'{HREF}\');void(0);" target="{TARGET}"><img src="'.SB_CMS_IMG_URL.'/previous.gif" width="14" height="15" border="0" alt="'.KERNEL_PAGER_PREV.'" align="absmiddle"></a>';
    $pager->mPrevTempDisabled = '<img src="'.SB_CMS_IMG_URL.'/previous_gray.gif" width="14" height="15" border="0" alt="'.KERNEL_PAGER_PREV.'" align="absmiddle">';

    $pager->mNextTemp = '<a href="javascript: sbElemsShow(\'{HREF}\');void(0);" target="{TARGET}"><img src="'.SB_CMS_IMG_URL.'/next.gif" width="14" height="15" border="0" alt="'.KERNEL_PAGER_NEXT.'" align="absmiddle"></a>';
    $pager->mNextTempDisabled = '<img src="'.SB_CMS_IMG_URL.'/next_gray.gif" width="14" height="15" border="0" alt="'.KERNEL_PAGER_NEXT.'" align="absmiddle">';

    $pager->mEndTemp = '<a href="javascript: sbElemsShow(\'{HREF}\');void(0);" target="{TARGET}"><img src="'.SB_CMS_IMG_URL.'/end.gif" width="14" height="15" border="0" alt="'.KERNEL_PAGER_END.'" align="absmiddle"></a>';
    $pager->mEndTempDisabled = '<img src="'.SB_CMS_IMG_URL.'/end_gray.gif" width="14" height="15" border="0" alt="'.KERNEL_PAGER_END.'" align="absmiddle">';

    $pager->mNumberTemp = '&nbsp;<a href="javascript: sbElemsShow(\'{HREF}\');void(0);" target="{TARGET}">{NUMBER}</a>&nbsp;';
    
    echo '<center>';
    
    if($result)
    {
        echo '<div align="right" style="width: 95%; margin: 15px 0px 15px 0px;">
            &nbsp;&nbsp;&nbsp;<a href="javascript:void(0)" onclick="deleteAll()" ><img src="'.SB_CMS_IMG_URL.'/messages/delete.png" width="16" height="16" border="0" align="absmiddle" />&nbsp;'.PL_MESSAGES_DELETE_ALL.'</a>
        </div>';
    }
    else 
    {
        echo '<br /><br />';
    }

    if ($result)
    {
        echo '<div style="width:95%;text-align: left;">';
        $body = array();
        for($i = 0; $i < count($result); $i++)
        {
            list($um_id, $um_to_ids, $um_time, $um_title, $um_files) = $result[$i];
        
            if($um_files != '')
                $um_files = @unserialize($um_files);
            else 
                $um_files = array();
                
            $files = '&nbsp;';
            if(count($um_files) > 0)
            {
                $files = '<a href="javascript:void(0)" onclick="showFiles('.$um_id.')" title="'.PL_MESSAGES_SHOW_FILES.'"><img src="'.SB_CMS_IMG_URL.'/clip.gif" width="7" height="13" border="0" /></a>';
            }

            $chk = '<input type="checkbox" value="'.$um_id.'" name="u_mes" id="u_mes" style="margin-top:6px;width:12px;">';
            $title = '<a href="javascript:void(0)" onclick="showFull('.$um_id.')">'.(strlen($um_title) > 50 ? substr($um_title, 0, 50).'...' : $um_title).'</a>';

            $u_res = sql_param_query('SELECT u.u_id, u.u_name, u.u_login, um.um_look FROM sb_users u LEFT JOIN sb_users_messages um ON (um.um_to_id=u.u_id AND um.um_parent_id=?d) WHERE u_id IN ('.$um_to_ids.')', $um_id);   
            if ($u_res)
            {
                list($u_id, $u_name, $u_login, $um_look) = $u_res[0];  
                if (is_null($um_look)) 
                {
                    $user = '<img src="'.SB_CMS_IMG_URL.'/messages/read_del.png" width="12" height="12" border="0" align="absmiddle" />';
                }
                else 
                {
                    $user = '<img src="'.SB_CMS_IMG_URL.'/messages/'.($um_look == 0 ? 'read_no' : 'read_ok').'.png" width="12" height="12" border="0" align="absmiddle" />';
                }
                $user .= '&nbsp;<b>'.($_SESSION['sbPlugins']->isRightAvailable('pl_users', 'read') ? '<a href="javascript:void(0);" onclick="sbShowDialog(\''.SB_CMS_DIALOG_FILE.'?event=pl_kernel_user_info&id='.$u_id.'\', \'resizable=1,width=800,height=600\');">'.$u_login.'</a>' : $u_login).'</b>'.($u_name != '' ? '<br />('.$u_name.')' : '').(count($u_res) > 1 ? '<br />...' : '');
            }
            else 
            {
                $user = PL_MESSAGES_NO_USER;
            }        
            
            $resend = '<a href="javascript:void(0)" onclick="resendMessage('.$um_id.')" title="'.PL_MESSAGES_RESEND.'" ><img src="'.SB_CMS_IMG_URL.'/messages/resend.png" width="16" height="16" alt="'.PL_MESSAGES_RESEND.'" border="0" style="margin-top: 2px" /></a>';
            $body[] = array($files, $chk, $title, $user, sb_date('d.m.Y H:i', $um_time), $resend);
        }
        
        require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
        
        $layout = new sbLayout();
        $layout->mTableWidth = '100%';

        $table = new sbLayoutTable(array('', '', PL_MESSAGES_TITLE, PL_MESSAGES_TO_USER, PL_MESSAGES_DATE, ''), $body);
        $table->mWidth = array('10px', '10px', '70%', '15%', '15%', '20px');
        $table->mAlign = array('center', 'center', '', 'center', 'center', 'center');
        $table->mVAlign = array('middle', 'middle', 'middle', 'middle', 'middle', 'middle');
        
        $layout->addField('',  $table);
        $layout->show();   
        
        echo '<br />
        <img src="'.SB_CMS_IMG_URL.'/arrow_all.png" width="38" height="22" border="0" style="margin-left: 25px;"> <a href="javascript: selectAll(true); void(0);">'.PL_MESSAGES_SELECT_ALL.'</a>
        &nbsp; / &nbsp;<a href="javascript: selectAll(false); void(0);">'.PL_MESSAGES_UNSELECT_ALL.'</a><br /></div>'.$pager->show();
    }
    else 
    {
        sb_show_message(PL_MESSAGES_NO_MESSAGES_MSG, true);
    }
    
    echo '</center>';
}

function fMessages_Basket()
{
    echo '<script>
    document.body.setAttribute("unselectable", "off");
    selectAll = function(chk)
    {
        var els = document.getElementsByTagName("input");
        for (var i = 0; i < els.length; i++)
        {
            els[i].checked = chk;
        }
    }
    deleteAll = function()
    {
        if(confirm("'.PL_MESSAGES_CONFIRM_EMPTY.'"))
        {
            var els = document.getElementsByTagName("input");
            var ids = "0";
            for (var i = 0; i < els.length; i++)
            {
                if (els[i].checked)
                    ids += "," + els[i].value;
            }
        
            if (ids == "0")
            {
                alert("'.PL_MESSAGES_ERROR_DELETE_NO_MSG.'");
                return;
            }

            var res = sbLoadSync("'.SB_CMS_EMPTY_FILE.'?event=pl_messages_delete_restore&ids=" + ids + "&action=delete");
            if(res == "TRUE")
            {
                sbElemsRefresh();
            }
            else
            {
                alert("'.PL_MESSAGES_ERROR_EMPTY.'");
            }
        }
    }
    restoreAll = function()
    {
        if(confirm("'.PL_MESSAGES_CONFIRM_RESTORE.'"))
        {
            var els = document.getElementsByTagName("input");
            var ids = "0";
            for (var i = 0; i < els.length; i++)
            {
                if (els[i].checked)
                    ids += "," + els[i].value;
            }
        
            if (ids == "0")
            {
                alert("'.PL_MESSAGES_ERROR_DELETE_NO_MSG.'");
                return;
            }

            var res = sbLoadSync("'.SB_CMS_EMPTY_FILE.'?event=pl_messages_delete_restore&ids=" + ids + "&action=restore");
            if(res == "TRUE")
            {
                sbElemsRefresh();
            }
            else
            {
                alert("'.PL_MESSAGES_ERROR_RESTORE.'");
            }
        }
    }
    readAll = function()
    {
        var els = document.getElementsByTagName("input");
        var ids = "0";
        for (var i = 0; i < els.length; i++)
        {
            if (els[i].checked)
                ids += "," + els[i].value;
        }
    
        if (ids == "0")
        {
            alert("'.PL_MESSAGES_ERROR_DELETE_NO_MSG.'");
            return;
        }

        var res = sbLoadSync("'.SB_CMS_EMPTY_FILE.'?event=pl_messages_look&ids=" + ids);
        if(res == "TRUE")
        {
            sbElemsRefresh();
        }
        else
        {
            alert("'.PL_MESSAGES_ERROR_READ.'");
        }
    }
    </script>';
    
    require_once(SB_CMS_LIB_PATH.'/sbDBPager.inc.php');
    
    $total = true;
    $pager = new sbDBPager('um', 7, 15, 'content');
    $result = $pager->init($total, 'SELECT um.um_id, um.um_from_id, um.um_to_ids, su.u_login, su.u_name, um.um_time, um.um_title, um.um_look, um.um_files FROM sb_users_messages um LEFT JOIN sb_users su ON um.um_from_id=su.u_id WHERE (um_to_id=?d OR (um_from_id=?d AND um_to_ids != "")) AND um_delete = "1" ORDER BY um.um_time DESC', $_SESSION['sbAuth']->getUserId(), $_SESSION['sbAuth']->getUserId());

    $pager->mBeginTemp = '<a href="javascript: sbElemsShow(\'{HREF}\');void(0);" target="{TARGET}"><img src="'.SB_CMS_IMG_URL.'/begin.gif" width="14" height="15" border="0" alt="'.KERNEL_PAGER_BEGIN.'" align="absmiddle"></a>';
    $pager->mBeginTempDisabled = '<img src="'.SB_CMS_IMG_URL.'/begin_gray.gif" width="14" height="15" border="0" alt="'.KERNEL_PAGER_BEGIN.'" align="absmiddle">';

    $pager->mPrevTemp = '<a href="javascript: sbElemsShow(\'{HREF}\');void(0);" target="{TARGET}"><img src="'.SB_CMS_IMG_URL.'/previous.gif" width="14" height="15" border="0" alt="'.KERNEL_PAGER_PREV.'" align="absmiddle"></a>';
    $pager->mPrevTempDisabled = '<img src="'.SB_CMS_IMG_URL.'/previous_gray.gif" width="14" height="15" border="0" alt="'.KERNEL_PAGER_PREV.'" align="absmiddle">';

    $pager->mNextTemp = '<a href="javascript: sbElemsShow(\'{HREF}\');void(0);" target="{TARGET}"><img src="'.SB_CMS_IMG_URL.'/next.gif" width="14" height="15" border="0" alt="'.KERNEL_PAGER_NEXT.'" align="absmiddle"></a>';
    $pager->mNextTempDisabled = '<img src="'.SB_CMS_IMG_URL.'/next_gray.gif" width="14" height="15" border="0" alt="'.KERNEL_PAGER_NEXT.'" align="absmiddle">';

    $pager->mEndTemp = '<a href="javascript: sbElemsShow(\'{HREF}\');void(0);" target="{TARGET}"><img src="'.SB_CMS_IMG_URL.'/end.gif" width="14" height="15" border="0" alt="'.KERNEL_PAGER_END.'" align="absmiddle"></a>';
    $pager->mEndTempDisabled = '<img src="'.SB_CMS_IMG_URL.'/end_gray.gif" width="14" height="15" border="0" alt="'.KERNEL_PAGER_END.'" align="absmiddle">';

    $pager->mNumberTemp = '&nbsp;<a href="javascript: sbElemsShow(\'{HREF}\');void(0);" target="{TARGET}">{NUMBER}</a>&nbsp;';
    
    echo '<center>';
    
    if($result)
    {
        echo '<div align="right" style="width: 95%; margin: 15px 0px 15px 0px;">
            &nbsp;&nbsp;&nbsp;<a href="javascript:void(0)" onclick="readAll()" ><img src="'.SB_CMS_IMG_URL.'/messages/read.png" width="16" height="16" border="0" align="absmiddle" />&nbsp;'.PL_MESSAGES_READ_ALL.'</a>
            &nbsp;&nbsp;&nbsp;<a href="javascript:void(0)" onclick="restoreAll()" ><img src="'.SB_CMS_IMG_URL.'/messages/restore.png" width="16" height="16" border="0" align="absmiddle" />&nbsp;'.PL_MESSAGES_RESTORE_ALL.'</a>
            &nbsp;&nbsp;&nbsp;<a href="javascript:void(0)" onclick="deleteAll()" ><img src="'.SB_CMS_IMG_URL.'/messages/delete.png" width="16" height="16" border="0" align="absmiddle" />&nbsp;'.PL_MESSAGES_EMPTY_ALL.'</a>
        </div>';
    }
    else 
    {
        echo '<br /><br />';
    }

    if ($result)
    {
        echo '<div style="width:95%;text-align: left;">';
        $body = array();
        for($i = 0; $i < count($result); $i++)
        {
            list($um_id, $u_id, $um_to_ids, $u_login, $u_name, $um_time, $um_title, $um_look, $um_files) = $result[$i];
        
            if ($um_files != '')
                $um_files = @unserialize($um_files);
            else 
                $um_files = array();
                
            $files = '';
            if(count($um_files) > 0)
            {
                $files = '<a href="javascript:void(0)" onclick="showFiles('.$um_id.')" title="'.PL_MESSAGES_SHOW_FILES.'"><img src="'.SB_CMS_IMG_URL.'/clip.gif" width="7" height="13" border="0" /></a>';
            }

            $chk = '<input type="checkbox" value="'.$um_id.'" name="u_mes" id="u_mes" style="margin-top:6px;width:12px;">';
            
            if ($um_to_ids != '')
            {
                $title = '<a href="javascript:void(0)" onclick="showFull('.$um_id.')">'.(strlen($um_title) > 50 ? substr($um_title, 0, 50).'...' : $um_title).'</a>';
                
                // отправленные
                $img = '';
                $u_res = sql_param_query('SELECT u.u_id, u.u_name, u.u_login, um.um_look FROM sb_users u LEFT JOIN sb_users_messages um ON (um.um_to_id=u.u_id AND um.um_parent_id=?d) WHERE u_id IN ('.$um_to_ids.')', $um_id);   
                if ($u_res)
                {
                    list($u_id, $u_name, $u_login, $um_look) = $u_res[0];   
                    if (is_null($um_look)) 
                    {
                        $to_user = '<img src="'.SB_CMS_IMG_URL.'/messages/read_del.png" width="12" height="12" border="0" align="absmiddle" />';
                    }
                    else 
                    {
                        $to_user = '<img src="'.SB_CMS_IMG_URL.'/messages/'.($um_look == 0 ? 'read_no' : 'read_ok').'.png" width="12" height="12" border="0" align="absmiddle" />';
                    }
                
                    $to_user .= '&nbsp;<b>'.($_SESSION['sbPlugins']->isRightAvailable('pl_users', 'read') ? '<a href="javascript:void(0);" onclick="sbShowDialog(\''.SB_CMS_DIALOG_FILE.'?event=pl_kernel_user_info&id='.$u_id.'\', \'resizable=1,width=800,height=600\');">'.$u_login.'</a>' : $u_login).'</b>'.($u_name != '' ? '<br />('.$u_name.')' : '').(count($u_res) > 1 ? '<br />...' : '');                     
                }
                else 
                {
                    $to_user = PL_MESSAGES_NO_USER;
                }
                
                $from_user = '';
                $reply = '';
            }
            else 
            {
                $title = '<a href="javascript:void(0)" onclick="showFull('.$um_id.')">'.($um_look == 0 ? '<b>' : '').(strlen($um_title) > 50 ? substr($um_title, 0, 50).'...' : $um_title).($um_look == 0 ? '</b>' : '').'</a>';
                
                // входящие
                $img = '<a href="javascript:void(0)" onclick="showFull('.$um_id.')"><img src="'.SB_CMS_IMG_URL.'/messages/'.($um_look == 0 && $um_to_ids == '' ? 'read_no' : 'read_ok').'.png" width="12" height="12" border="0" align="absmiddle" /></a>';
                
                if ($u_login != '')
                {
                    $reply = ($um_to_ids == '' ? '<a href="javascript:void(0)" onclick="addMessage('.$um_id.')" title="'.PL_MESSAGES_REPLY.'"><img src="'.SB_CMS_IMG_URL.'/messages/reply.png" width="16" height="16" border="0" alt="'.PL_MESSAGES_REPLY.'" /></a>' : '');
                    $from_user = '<b>'.($_SESSION['sbPlugins']->isRightAvailable('pl_users', 'read') ? '<a href="javascript:void(0);" onclick="sbShowDialog(\''.SB_CMS_DIALOG_FILE.'?event=pl_kernel_user_info&id='.$u_id.'\', \'resizable=1,width=800,height=600\');">'.$u_login.'</a>' : $u_login).'</b>'.($u_name != '' ? '<br />('.$u_name.')' : '');
                }
                else 
                {
                    $reply = '';
                    $from_user = PL_MESSAGES_NO_USER;
                }
                
                $to_user = '';    
            } 
            
            $resend = '<a href="javascript:void(0)" onclick="resendMessage('.$um_id.')" title="'.PL_MESSAGES_RESEND.'" ><img src="'.SB_CMS_IMG_URL.'/messages/resend.png" width="16" height="16" alt="'.PL_MESSAGES_RESEND.'" border="0" style="margin-top: 2px" /></a>';
            $body[] = array($files, $chk, $img, $title, $from_user, $to_user, sb_date('d.m.Y H:i', $um_time), $reply, $resend);
        }
        
        require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
        
        $layout = new sbLayout();
        $layout->mTableWidth = '100%';

        $table = new sbLayoutTable(array('', '', '', PL_MESSAGES_TITLE, PL_MESSAGES_FROM_USER, PL_MESSAGES_TO_USER, PL_MESSAGES_DATE, '', ''), $body);
        $table->mWidth = array('10px', '10px', '10px', '55%', '15%', '15%', '15%', '20', '20');
        $table->mAlign = array('center', 'center', 'center', '', 'center', 'center', 'center', 'center', 'center');
        $table->mVAlign = array('middle', 'middle', 'middle', 'middle', 'middle', 'middle', 'middle', 'middle', 'middle');
        
        $layout->addField('',  $table);
        $layout->show();   
        
        echo '<br />
        <img src="'.SB_CMS_IMG_URL.'/arrow_all.png" width="38" height="22" border="0" style="margin-left: 25px;"> <a href="javascript: selectAll(true); void(0);">'.PL_MESSAGES_SELECT_ALL.'</a>
        &nbsp; / &nbsp;<a href="javascript: selectAll(false); void(0);">'.PL_MESSAGES_UNSELECT_ALL.'</a><br /></div>'.$pager->show();
    }
    else 
    {
        sb_show_message(PL_MESSAGES_NO_MESSAGES_MSG, true);
    }
    
    echo '</center>';
}

function fMessages_Add()
{
    if (isset($_POST['um_title']))
    {
        $um_title = $_POST['um_title'];
        $um_message  = $_POST['um_message'];
        $um_to_id  = $_POST['um_to_ids'];
        $um_to_name = $_POST['um_to_names'];
        $um_copy = isset($_POST['um_copy']) && $_POST['um_copy'] == 1 ? 1 : 0;
    }
    else if(isset($_GET['id']) && $_GET['id'] != '')
    {
        $id = intval($_GET['id']);
        
        $res = sql_query('SELECT u.u_id, u.u_name, u.u_login, um.um_time, um.um_title, um.um_message FROM sb_users_messages um LEFT JOIN sb_users u ON u.u_id=um.um_from_id WHERE um.um_id="'.$id.'"');
        if($res)
        {
            list($um_to_id, $u_name, $u_login, $um_time, $um_title, $um_message) = $res[0];
            
            $um_message = "\n\n____________________________________\n\n".PL_MESSAGES_FROM_USER.': '.$u_login.($u_name != '' ? ' ('.$u_name.')' : '')."\n".
                          PL_MESSAGES_DATE.': '.sb_date('d.m.Y H:i', $um_time)."\n".
                          PL_MESSAGES_TO_USER.': '.$_SESSION['sbAuth']->getUserLogin().($_SESSION['sbAuth']->mName != '' ? ' ('.$_SESSION['sbAuth']->mName.')' : '')."\n".
                          PL_MESSAGES_TITLE.': '.$um_title."\n\n".preg_replace('/<br\s*?\/?>/i'.SB_PREG_MOD, "", $um_message);
            
            $um_title = 'RE: '.$um_title;
            
            $um_to_name = $u_login.($u_name != '' ? ' ('.$u_name.')' : '');
        }
        else 
        {
            sb_show_message(PL_MESSAGES_NO_MESSAGE_MSG , true, 'warning');
            return;
        }
        
        $um_copy = 1;
    }
    else if (isset($_GET['u_id']) && $_GET['u_id'] != '')
    {
        $um_to_id = intval($_GET['u_id']);
        $res = sql_query('SELECT u_name, u_login FROM sb_users WHERE u_id="'.$um_to_id.'"');
        if($res)
        {
            list($u_name, $u_login) = $res[0];
            
            $um_title    = '';
            $um_message = '';
            
            $um_to_name = $u_login.($u_name != '' ? ' ('.$u_name.')' : '');
        }
        else 
        {
            sb_show_message(PL_MESSAGES_NO_USER_MSG , true, 'warning');
            return;
        }
        
        $um_copy = 1;
    }
    else 
    {
        $um_title    = '';
        $um_message  = '';
        $um_to_id  = '';
        $um_to_name = '';
        $um_copy = 1;
    }
    
    echo '<script>
               var num_files = 1
               
               function addFile()
               {
                   var el = sbGetE("span_files");
                   
                   var br = document.createElement("BR");
                   var file = document.createElement("INPUT");
                   
                   file.type = "file";
                   file.name = "um_files[" + num_files + "]";
                   file.style.margin = "2px";
                   file.size = "55";
                   el.appendChild(br);
                   el.appendChild(file);
                   num_files++;
               }
               function checkValues()
               {
                   var el_title = sbGetE("um_title");
                   var el_to_ids = sbGetE("um_to_ids");
                   
                   if(el_to_ids.value == "")
                   {
                       alert("'.PL_MESSAGES_NO_USERS_MSG.'");
                       return false;
                   }
                   if(el_title.value == "")
                   {
                       alert("'.PL_MESSAGES_NO_TITLE_OR_MSG.'");
                       return false;
                   }
                   
                   return true;
               }
               
               function selectUsers()
               {
                   var um_to_ids = sbGetE("um_to_ids");
                   strPage = "'.SB_CMS_MODAL_DIALOG_FILE.'?event=pl_messages_select_users&users=" + um_to_ids.value;
                   strAttr = "resizable=1,width=500,height=700";
                   sbShowModalDialog(strPage, strAttr, afterSelectUsers); 
               }
               
               function afterSelectUsers()
               {
                   if (sbModalDialog.returnValue)
                   {
                       sbGetE("um_to_names").value = sbModalDialog.returnValue.names;
                       sbGetE("um_to_ids").value = sbModalDialog.returnValue.ids;
                   }
               }
          </script>
    <br><br>';
    
    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
    
    if (isset($_GET['u_id']) && $_GET['u_id'] != '')
    {
        $layout = new sbLayout(SB_CMS_DIALOG_FILE.'?event=pl_messages_add_submit&u_id='.$_GET['u_id'], 'thisDialog', 'post', 'checkValues()', '', 'enctype="multipart/form-data"');        
    }
    else 
    {
        $layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE.'?event=pl_messages_add_submit', 'thisDialog', 'post', 'checkValues()', '', 'enctype="multipart/form-data"');
    }
    $layout->mTableWidth = '95%';
    $layout->addHeader(PL_MESSAGES_ADD);
    
    $layout->addField(PL_MESSAGES_TITLE, new sbLayoutInput('text', $um_title, 'um_title', '', 'style="width: 430px;"', true));
    $layout->addField(PL_MESSAGES_TO_USER, new sbLayoutHTML('<input type="text" name="um_to_names" value="'.$um_to_name.'" id="um_to_names" style="width:430px;" readonly="readonly" onclick="selectUsers();" />&nbsp;&nbsp;<img class="button" onmouseup="sbPress(this, false)" onmousedown="sbPress(this, true);selectUsers();" align="top" src="'.SB_CMS_IMG_URL.'/users.png" width="20" height="20" />
                                                             <input type="hidden" name="um_to_ids" value="'.$um_to_id.'" id="um_to_ids" /></nobr>'));
    $layout->addField(PL_MESSAGES_MESSAGE, new sbLayoutTextarea($um_message, 'um_message', '', 'style="width: 100%; height: 150px"'));
    $layout->addField(PL_MESSAGES_TO_SEND, new sbLayoutInput('checkbox', '1', 'um_copy', '', $um_copy == 1 ? 'checked' : ''));
    $layout->addField(PL_MESSAGES_FILES, new sbLayoutHTML('<div id="span_files"><input type="file" name="um_files[0]" size="55" style="margin:2px;">&nbsp;<img class="button" onmouseup="sbPress(this, false)" onmousedown="sbPress(this, true);addFile();" align="top" src="'.SB_CMS_IMG_URL.'/btn_add.png" width="20" height="20" /></div>'));
      
    $layout->addButton('submit', PL_MESSAGES_SEND_MESSAGE);
    if (isset($_GET['u_id']) && $_GET['u_id'] != '')
    {
        $layout->addButton('button', KERNEL_CLOSE, '', '', 'onclick="window.close()"');
    }
    else 
    {
        $layout->addButton('button', KERNEL_CLOSE, '', '', 'onclick="sbCloseDialog()"');
    }
    
    $layout->show();
}

function fMessages_Select_Users($action = '')
{
    $res = sql_param_query('SELECT categs.cat_title, u.u_id, u.u_name, u.u_login FROM sb_users u, sb_categs categs, sb_catlinks links WHERE categs.cat_ident="pl_users" AND links.link_cat_id=categs.cat_id AND links.link_el_id=u.u_id AND u.u_id <> ?d ORDER BY categs.cat_left, u.u_login', $_SESSION['sbAuth']->getUserId());
    if (!$res)
    {
        sb_show_message(PL_MESSAGES_NO_USERS_ERROR, true, 'warning');
        return;
    }
    
    if ($action == '')
    {
        echo '<script>
                function selectUsers()
                {
                    var ids = "";
                    var names = "";
                    
                    for(var i = 0; i < '.count($res).'; i++)
                    {
                        var el_id = sbGetE("users_" + i);
                        var el_name = sbGetE("names_" + i);
                        if(el_id.checked)
                        {
                            ids += el_id.value + ",";
                            names += el_name.innerHTML + ", ";
                        }
                    }
                    
                    if (ids != "")
                    {
                        ids = ids.substr(0, ids.length - 1);
                        names = names.substr(0, names.length - 2);
                    }
                    else
                    {
                        alert("'.PL_MESSAGES_NO_USERS_MSG.'");
                        return;
                    }
                    
                    var res = new Object();
                    res.ids = ids;
                    res.names = names;
     
                    sbReturnValue(res);
                }
              </script>';
    }
    else 
    {
        echo '<script>
        function checkValues()
        {
            var found = false;
            
            for(var i = 0; i < '.count($res).'; i++)
            {
                var el_id = sbGetE("users_" + i);
                if(el_id.checked)
                {
                    found = true;
                    break;
                }
            }
            
            if (!found)
            {
                alert("'.PL_MESSAGES_NO_USERS_MSG.'");
                return false;
            }
            
            return true;
        }
        </script>';
    }
    
    if ($action == '')
    {
        $users = explode(',', $_GET['users']);
    }
    else 
    {
        $users = array();    
    }
    
    $cur_title = '';
    $html = '';
    for ($i = 0; $i < count($res); $i++)
    {
        list($cat_title, $u_id, $u_name, $u_login) = $res[$i];
        
        if ($cat_title != $cur_title)
        {
            if ($cat_title != '')
                $html .= '</div>';
            $html .= '<div style="margin: 0px 0px 15px 0px;">&nbsp;<img src="'.SB_CMS_IMG_URL.'/tree/folderOpen.gif" width="18" height="18" align="absmiddle">&nbsp;'.$cat_title.'<br>';
            $cur_title = $cat_title;
        }
        
        $html .= '<div style="margin: 3px 0px 3px 30px;"><label for="users_'.$i.'"><input type="checkbox" value="'.$u_id.'" id="users_'.$i.'" name="users[]" style="margin: 2px;"'.(in_array($u_id, $users) ? ' checked' : '').'>&nbsp;<span id="names_'.$i.'">'.$u_login.($u_name != '' ? ' ('.$u_name.')' : '').'</span></label></div>';
    }

    if ($html != '')
    {
        $html .= '</div>';
    }
    echo '<br><br>';
    
    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
    
    $layout = new sbLayout($action);
    $layout->mTableWidth = '95%';
    $layout->addHeader(PL_MESSAGES_SELECT_USER);
    
    $layout->addField('', new sbLayoutHTML($html, true));
    
    if ($action == '')
    {
        $layout->addButton('button', KERNEL_CHOOSE, '', '', 'onclick="selectUsers();"');
    }
    else 
    {
        $layout->addButton('submit', PL_MESSAGES_SEND_MESSAGE);    
    }
    
    $layout->addButton('button', KERNEL_CLOSE, '', '', 'onclick="sbCloseDialog()"');
    
    $layout->show();
}

function fMessages_Add_Submit($cut_tags = true)
{
    $time = time();
    $users_files = array();
    $copy_files = array();
    $users = explode(',', $_POST['um_to_ids']);

    if(!function_exists('_deleteFiles'))
    {
        function _deleteFiles($files)
        {
            $GLOBALS['sbVfs']->mLocal = true;
            foreach ($files as $value)
            {
                $file = SB_CMS_USER_UPLOAD_PATH.'/messages/'.$value;
                
                if ($value != '' && $GLOBALS['sbVfs']->exists($file) && $GLOBALS['sbVfs']->is_file($file))
                    $GLOBALS['sbVfs']->delete($file);
            }
            $GLOBALS['sbVfs']->mLocal = false;
        }
    }

    if(isset($_FILES['um_files']))
    {
        // подключаем библиотеку работы с загрузкой файлов
        require_once(SB_CMS_LIB_PATH.'/sbUploader.inc.php');
    
        $accept_types = array();
        if (!$_SESSION['sbAuth']->isAdmin())
        {
            $accept_types = $_SESSION['sbAuth']->getUploadingExts();
            if (count($accept_types) == 0)
            {
                sb_show_message(PL_MESSAGES_UPLOAD_FILES_NO_ACCEPT_TYPES_ERROR, false, 'warning');
                fMessages_Add();
                return;
            }
        }
    
        $uploader = new sbUploader();
        $uploader->setMaxFileSize(sbPlugins::getSetting('sb_files_max_upload_size'));
        $uploader->setMaxImageSize(sbPlugins::getSetting('sb_files_max_upload_width'), sbPlugins::getSetting('sb_files_max_upload_height'));
    
        $files = array();
        for($i = 0; $i < count($_FILES['um_files']['name']); $i++)
        {
            if (@is_uploaded_file($_FILES['um_files']['tmp_name'][$i]))
            {
                $files['um_files'.$i] = array();
                $files['um_files'.$i]['name'] = $_FILES['um_files']['name'][$i];
                $files['um_files'.$i]['tmp_name'] = $_FILES['um_files']['tmp_name'][$i];
                $files['um_files'.$i]['error'] = $_FILES['um_files']['error'][$i];
                $files['um_files'.$i]['size'] = $_FILES['um_files']['size'][$i];
                $files['um_files'.$i]['type'] = $_FILES['um_files']['type'][$i];
            }
        }
        
        $_FILES = $files;
        $GLOBALS['sbVfs']->mLocal = true;
        
        foreach ($_FILES as $key => $value)
        {
            $success = $uploader->upload($key, $accept_types);
            if (!$success)
            {
                foreach ($users_files as $value)
                {
                    _deleteFiles($value);
                }
                _deleteFiles($copy_files);
                sb_show_message($uploader->getError(), false, 'warning');
                fMessages_Add();
                return;
            }
            
            for ($i = 0; $i < count($users); $i++)
            {
                if (!isset($users_files[$users[$i]]))
                {
                     $users_files[$users[$i]] = array();
                }
                $file_name = $uploader->copy(SB_CMS_USER_UPLOAD_PATH.'/messages', $time.'_'.$users[$i].'_'.$value['name']);
                if (!$file_name)
                {
                    foreach ($users_files as $value)
                    {
                        _deleteFiles($value);
                    }
                    _deleteFiles($copy_files);
                    sb_show_message($uploader->getError(), false, 'warning');
                    fMessages_Add();
                    return;
                }

                $users_files[$users[$i]][] = $file_name;
            }
            
            if (isset($_POST['um_copy']) && $_POST['um_copy'] == 1)
            {
                $file_name = $uploader->copy(SB_CMS_USER_UPLOAD_PATH.'/messages', $time.'_'.$value['name']);
                if (!$file_name)
                {
                    foreach ($users_files as $value)
                    {
                        _deleteFiles($value);
                    }
                    _deleteFiles($copy_files);
                    sb_show_message($uploader->getError(), false, 'warning');
                    fMessages_Add();
                    return;
                }
                
                $copy_files[] = $file_name;
            }
        }
        
        $GLOBALS['sbVfs']->mLocal = false;
    }

    if($cut_tags === false)
    {
        $message = nl2br($_POST['um_message']);
        $title = $_POST['um_title'];
    }
    elseif($cut_tags === true)
    {
        $message = nl2br(strip_tags($_POST['um_message']));
        $title = strip_tags($_POST['um_title']);
    }

    $parent_id = 0;
    if (isset($_POST['um_copy']) && $_POST['um_copy'] == 1)
    {
        sql_param_query('INSERT INTO sb_users_messages (um_to_id, um_to_ids, um_from_id, um_time, um_title, um_message, um_look, um_delete, um_parent_id, um_files) 
                                VALUES ("0", ?, ?d, ?d, ?, ?, "0", "0", "0", ?)', $_POST['um_to_ids'], $_SESSION['sbAuth']->getUserId(), $time, $title, $message, serialize($copy_files));
        
        $parent_id = sql_insert_id();
    }
    
    for($i = 0; $i < count($users); $i++)
    {
        $files = isset($users_files[$users[$i]]) ? serialize($users_files[$users[$i]]) : serialize(array());
        
        sql_param_query('INSERT INTO sb_users_messages (um_to_id, um_to_ids, um_from_id, um_time, um_title, um_message, um_look, um_delete, um_parent_id, um_files) 
                                VALUES (?d, "", ?d, ?d, ?, ?, "0", "0", ?d, ?)', $users[$i], $_SESSION['sbAuth']->getUserId(), $time, $title, $message, $parent_id, $files);
    }

    fMessages_Send_Mail($_POST['um_to_ids'], $title, $message);

    if (isset($_GET['u_id']) && $_GET['u_id'] != '')
    {
        echo '<script>
                 window.close();
            </script>';
    }
    else 
    {
        echo '<script>
                 sbReturnValue("'.(isset($_POST['um_copy']) && $_POST['um_copy'] == 1 ? 1 : 0).'");
            </script>';
    }
}

function fMessages_Resend()
{
    fMessages_Select_Users(SB_CMS_MODAL_DIALOG_FILE.'?event=pl_messages_resend_submit&id='.$_GET['id']);
}

function fMessages_Resend_Submit()
{
    $res = sql_param_query('SELECT u.u_login, u.u_name, um.um_time, um.um_title, um.um_message, um.um_files, um.um_to_ids FROM sb_users_messages um LEFT JOIN sb_users u ON um.um_from_id=u.u_id WHERE um.um_id=?d', $_GET['id']);
    if (!$res)
    {
        sb_show_message(PL_MESSAGES_NO_MESSAGE_MSG, true, 'warning');
        return;
    }
    
    list($u_login, $u_name, $um_time, $um_title, $um_message, $um_files, $um_to_ids) = $res[0];
    
    $um_message = "\n<br />____________________________________\n<br />\n<br />".PL_MESSAGES_FROM_USER.': '.$u_login.($u_name != '' ? ' ('.$u_name.')' : '')."\n<br />".
                          PL_MESSAGES_DATE.': '.sb_date('d.m.Y H:i', $um_time)."\n<br />".
                          PL_MESSAGES_TO_USER.': '.$_SESSION['sbAuth']->getUserLogin().($_SESSION['sbAuth']->mName != '' ? ' ('.$_SESSION['sbAuth']->mName.')' : '')."\n<br />".
                          PL_MESSAGES_TITLE.': '.$um_title."\n<br />\n<br />".$um_message;
    $um_title = 'FW: '.$um_title;
    
    if ($um_files != '')
        $um_files = unserialize($um_files);
    else 
        $um_files = array();
        
    $files = array();
    foreach ($um_files as $key => $value)
    {
        $pos = strpos($value, '_');
        if ($um_to_ids == '')
        {
            $pos = strpos($value, '_', $pos);    
        }
        $pos++;
               
        $files[$key] = substr($value, $pos);
    }
    
    $time = time();
    $GLOBALS['sbVfs']->mLocal = true;
    for ($i = 0; $i < count($_POST['users']); $i++)
    {
        $user = intval($_POST['users'][$i]);
        
        $user_files = array();
        foreach ($um_files as $key => $value)
        {
            $file_name = $time.'_'.$user.'_'.$files[$key];
            if ($GLOBALS['sbVfs']->copy(SB_CMS_USER_UPLOAD_PATH.'/messages/'.$value, SB_CMS_USER_UPLOAD_PATH.'/messages/'.$file_name))
            {
                $user_files[] = $file_name;
            }
        }
        
        sql_param_query('INSERT INTO sb_users_messages (um_to_id, um_to_ids, um_from_id, um_time, um_title, um_message, um_look, um_delete, um_parent_id, um_files)
                                VALUES (?d, "", ?d, ?d, ?, ?, "0", "0", "0", ?)', $user, $_SESSION['sbAuth']->getUserId(), $time, $um_title, $um_message, serialize($user_files));
    }
    $GLOBALS['sbVfs']->mLocal = false;
    
    echo '<script>
             sbReturnValue(true);
          </script>';
}

/**
 * Метод отправляет уведомления.
 *
 * @param string $uId    id пользователей.
 *
 * @return integer результат.
 */
function fMessages_Send_Mail($uId, $title, $message)
{
    $uMails = fMessages_Users_Mails($uId);
    if ($uMails){
        $text = PL_MESSAGES_SEND_BASE_MAIL;
        $text .= '<p>' . PL_MESSAGES_SEND_TITLE . $title . '</p>';
        $text .= '<p>' . PL_MESSAGES_RESEND_TXT . $message . '</p>';
        $mail = new sbMail();
        $mail->setSubject('Cообщение на сайте ' . SB_DOMAIN);
        $mail->setHtml($text);
        foreach ($uMails as $val) {
            $mail->send(array($val[0]));
        }
    }
}

/**
 * Метод определяет email пользователей которым отправляем уведомление.
 *
 * @param string $uId    id пользователей.
 *
 * @return integer результат.
 */
function fMessages_Users_Mails($uId){
    $arrId = explode(',', $uId);
    $res = sql_query('SELECT u_email FROM sb_users WHERE u_id IN(?a) AND u_notify=?d', $arrId, 1);
    if ($res) {
        return $res;
    } else {
        return false;
    }
}
