<?php
/**
 * Функция, выводящая поле выбора макет дизайна постраничного вывода
 *
 * @param object $layout Объект sbLayout, к которому будут добавлены поля.
 * @param string $field_value Идентификатор выбранного макета дизайна.
 * @param string $field_name Имя поля, в котором будет храниться идентификатор макета дизайна.
 * @param string $field_count_value Кол-во элементов на странице.
 * @param string $field_count_name Имя поля, в котором будет храниться кол-во элементов на странице.
 * @param bool $categs Выводить подсказки для разделов (TRUE) или для элементов (FALSE).
 * @param bool $field_title Заголовок поля макетов дизайна постраничного вывода.
 * @param bool $field_count_title Заголовок поля кол-ва элементов на странице.
 */
function fPager_Design_Get (&$layout, $field_value, $field_name, $field_count_value, $field_count_name, $categs = false, $field_title = '', $field_count_title = '')
{
	$layout->addField('', new sbLayoutDelim());
	
	$res = sql_query('SELECT categs.cat_title, pager.pt_id, pager.pt_title FROM sb_categs categs, sb_catlinks links, sb_pager_temps pager WHERE pager.pt_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident=? ORDER BY categs.cat_left, pager.pt_title', 'pl_pager_temps');
    if ($res)
    {
        $options = array();
        if(!$categs)
        {
            $options['0'] = PL_PAGER_TEMPS_H_GET_NOT_USE;
        }
        $old_cat_title = '';
        foreach ($res as $value)
        {
            list($cat_title, $pt_id, $pt_title) = $value;
            if ($old_cat_title != $cat_title)
            {
                $options[uniqid()] = '-'.$cat_title;
                $old_cat_title = $cat_title;
            }
            $options[$pt_id] = $pt_title;
        }
        $fld = new sbLayoutSelect($options, $field_name);
        $fld->mSelOptions = array($field_value);
        $layout->addField(($field_title != '' ? $field_title : PL_PAGER_TEMPS_H_GET_TITLE), $fld);
    }
	else 
	{
	    $layout->addField(($field_title != '' ? $field_title : PL_PAGER_TEMPS_H_GET_TITLE), new sbLayoutLabel('<div class="hint_div">'.PL_PAGER_TEMPS_H_GET_LABEL.'</div>', '', '', false));
	}
	
	$fld = new sbLayoutInput('text', $field_count_value, $field_count_name, 'spin_'.$field_count_name, 'style="width:100px;"');
	$fld->mMinValue = 0;
	$layout->addField(($field_count_title != '' ? $field_count_title : ($categs ? PL_PAGER_TEMPS_H_GET_CATEGS_COUNT_TITLE : PL_PAGER_TEMPS_H_GET_COUNT_TITLE))  , $fld);
    if(!$categs)
    {
        $layout->addField('', new sbLayoutLabel('<div class="hint_div" style="margin-top: 5px;">'.PL_PAGER_TEMPS_H_GET_NOT_USE_DESC.'</div>', '', '', false));
    }
	$layout->addField('', new sbLayoutLabel('<div class="hint_div" style="margin-top: 5px;">'.($categs ? PL_PAGER_TEMPS_H_GET_CATEGS_COUNT_LABEL : PL_PAGER_TEMPS_H_GET_COUNT_LABEL).'</div>', '', '', false));
	
}
?>