<?php
/********************************** вспомогательные функции, использующиеся дургими модулями ***********************************/
function fPages_Get($args)
{
	$state = '';
	$show_real_url = true;
	$show_demo_url = false;

	if ($_SESSION['sbPlugins']->isPluginAvailable('pl_workflow') && $_SESSION['sbPlugins']->isPluginInWorkflow('pl_pages'))
	{
		sb_get_workflow_status($state, 'pl_pages', $args['p_state']);
		$state = preg_replace('=<br.*?/?>=i', '', $state);

		$pos = sb_strpos($state, ':');
		$state = sb_substr($state, $pos+1);

		if ($args['p_state'] == 0)
		{
			$show_real_url = false;
		}
		else
		{
			$statuses = explode(',', sb_get_workflow_demo_statuses(false));
			if (in_array($args['p_state'], $statuses))
			{
				$show_demo_url = true;
			}
		}
	}
	else
	{
		switch($args['p_state'])
		{
			case 0:
				$show_real_url = false;
				$state = '<span style="color:red;">'.PL_PAGES_H_GET_STATE_NOT_PUBLISHED.'</span>';
				break;
			case 1:
				$state = PL_PAGES_H_GET_STATE_PUBLISHED;
				break;
		}
	}
	$state = PL_PAGES_H_GET_STATE.': <a href="javascript:void(0);" onclick="sbElemsEdit(event);">'.$state.'</a><br />';

	static $temps = array();

	$temp_name = '';
	if (!isset($temps[$args['p_temp_id']]))
	{
	    $res = sql_query('SELECT t_name FROM sb_templates WHERE t_id=?d', $args['p_temp_id']);
	    if ($res)
	    {
	        $temps[$args['p_temp_id']] = $res[0][0];
	        $temp_name = $res[0][0];
	    }
	}
	else
	{
	    $temp_name = $temps[$args['p_temp_id']];
	}

	static $view_temp = null;
	if (is_null($view_temp))
	{
	    $view_temp = $_SESSION['sbPlugins']->isRightAvailable('pl_templates', 'read') && ($_GET['event'] == 'pl_pages_init' || (isset($_GET['real_event']) && $_GET['real_event'] == 'pl_pages_init'));
	}

	if ($view_temp)
	{
	    $temp_name = '<a href="javascript:void(0);" onclick="window.location = sb_cms_content_file + \'?event=pl_templates_init&sb_sel_id='.$args['p_temp_id'].'\'; window.close();">'.$temp_name.'</a>';
	}
	else
	{
	    $temp_name = '<span style="color:green;">'.$temp_name.'</span>';
	}

	static $view_text = null;
	if (is_null($view_text))
	{
	    $view_text = $_SESSION['sbPlugins']->isRightAvailable('pl_texts', 'read') && ($_GET['event'] == 'pl_pages_init' || (isset($_GET['real_event']) && $_GET['real_event'] == 'pl_pages_init'));
	}

	$res = sql_query('SELECT DISTINCT t.t_id, t.t_name
                        FROM sb_texts t, sb_elems e
                        WHERE (e.e_ident=? OR e.e_ident=?) AND
                        ((e.e_p_id=?d AND e.e_link=?) OR (e.e_p_id=?d AND e.e_link=?))
                        AND t.t_id=e.e_el_id', 'pl_texts_plain', 'pl_texts_html', $args['p_id'], 'page', $args['p_temp_id'], 'temp');

	$texts_list = '';
	if ($res)
	{
		$texts_list = '<table cellpadding="0" cellspacing="0">
	                <tr>
	                    <td valign="top" nowrap="nowrap" class="smalltext">'.PL_PAGES_H_GET_TEXTS.':&nbsp;</td>
	                    <td class="smalltext"><span style="color:green;">';

	    $num = min(3, count($res));
	    for ($i = 0; $i < $num; $i++)
		{
			list($t_id, $t_name) = $res[$i];
			$texts_list .= ($view_text ? '<a href="'.SB_CMS_CONTENT_FILE.'?event=pl_texts_init&sb_sel_id='.$t_id.'">'.$t_name.'</a>' : $t_name).', ';
		}

		if ($num < count($res))
			$texts_list .= '&nbsp;<a href="javascript:void(0);" onclick="linkTexts(event);">...</a>';
	    else
	        $texts_list = substr($texts_list, 0, -2);

	    $texts_list .= '</span></td></tr></table>';
	}

	static $domain = '';
	static $page_domain = '';
	static $page_demo_domain = '';

	if (!$domain)
	{
	    $res = sql_query('SELECT categs.cat_left, categs.cat_right FROM sb_categs categs, sb_catlinks links WHERE links.link_el_id=?d AND links.link_cat_id=categs.cat_id AND categs.cat_ident=?', $args['p_id'], 'pl_pages');
	    list($left, $right) = $res[0];
	    $res = sql_query('SELECT cat_title FROM sb_categs WHERE cat_left <= ?d AND cat_right >= ?d AND cat_level=1 AND cat_ident=?', $left, $right, 'pl_pages');
	    list($domain) = $res[0];

	    $page_domain = $domain;
	    $page_demo_domain = 'www-demo.'.$domain;

	    if ($domain == SB_COOKIE_DOMAIN && SB_PORT != '80')
	    {
	    	$page_domain .= ':'.SB_PORT;
	    	$page_demo_domain .= ':'.SB_PORT;
	    }

	    if ('http://'.$page_domain != SB_DOMAIN && substr_count($domain, '.') > 0)
            $page_domain = 'www.'.$page_domain;

        require_once (SB_CMS_LIB_PATH.'/sbIDN.inc.php');
    	$idn = new sbIDN();

        $page_domain = 'http://'.$page_domain;
        $page_demo_domain = 'http://'.$page_demo_domain;
	}

	if ($_SESSION['sbPlugins']->isRightAvailable('pl_pages', 'elems_edit') && ($_GET['event'] == 'pl_pages_init' || (isset($_GET['real_event']) && $_GET['real_event'] == 'pl_pages_init')) && $domain == SB_COOKIE_DOMAIN)
	{
	    $result = '<b><a href="javascript:void(0);" onclick="pagesEdit(event);" id="title_'.$args['p_id'].'">'.$args['p_name'].'</a></b>';
	}
	else
	{
	    $result = '<b id="title_'.$args['p_id'].'">'.$args['p_name'].'</b>';
	}

	$old_domain = $GLOBALS['sbVfs']->mDomain;
    $GLOBALS['sbVfs']->mDomain = $domain;

    if ($GLOBALS['sbVfs']->exists(($args['p_filepath'] != '' ? $args['p_filepath'].'/' : '').$args['p_filename']))
    {
    	$html = $GLOBALS['sbVfs']->file_get_contents(($args['p_filepath'] != '' ? $args['p_filepath'].'/' : '').$args['p_filename']);
    	$crc = sb_crc($html);
    }
    else
    {
		$crc = null;
	}
	$GLOBALS['sbVfs']->mDomain = $old_domain;

	$result .= '<div class="smalltext" style="margin-top: 7px;">';

	if ($show_real_url)
	{
		$result .= PL_PAGES_H_GET_URL.': <a href="'.$page_domain.'/'.($args['p_filepath'] != '' ? $args['p_filepath'].'/' : '').$args['p_filename'].'" target="_blank" id="url_'.$args['p_id'].'">'.$page_domain.'/'.($args['p_filepath'] != '' ? $args['p_filepath'].'/' : '').$args['p_filename'].'</a><br />';
	}

	if ($show_demo_url)
	{
		$result .= PL_PAGES_H_GET_DEMO_URL.': <a href="'.$page_demo_domain.'/'.($args['p_filepath'] != '' ? $args['p_filepath'].'/' : '').$args['p_filename'].'" target="_blank" id="url_'.$args['p_id'].'">'.$page_demo_domain.'/'.($args['p_filepath'] != '' ? $args['p_filepath'].'/' : '').$args['p_filename'].'</a><br />';
	}

	$result .= PL_PAGES_H_GET_TEMP.': '.$temp_name.'<br />'.$state.$texts_list.($args['p_default'] == 1 ? '<span style="color:red;">'.PL_PAGES_H_GET_DEFAULT.'</span><br />' : '');

    if (SB_CLIENT_LIC != '0400000000000000000' && $args['p_state'] == 1 && $crc != $args['p_crc'] && !is_null($args['p_crc']) && ($_GET['event'] == 'pl_pages_init' || (isset($_GET['real_event']) && $_GET['real_event'] == 'pl_pages_init')))
    {
    	$result .= '<span style="color:red;font-weight:bold;" id="p_crc_'.$args['p_id'].'">'.PL_PAGES_H_GET_WRONG_CRC;

    	if ($_SESSION['sbPlugins']->isRightAvailable('pl_pages', 'elems_edit'))
    	{
    		$result .= '&nbsp;&nbsp;[ <a href="javascript:void(0);" onclick="pagesGen(event)">'.PL_PAGES_H_GET_FIX.'</a> ]</span>';
    	}

    	$result .= '</span>';
    }

    $result .= '</div>';

	return $result;
}

function fPages_Get_Domain_Name($cat_id, $cat_title, $cat_level, $cat_rubrik, $cat_closed)
{
	if ($cat_level == 1)
	{
		require_once (SB_CMS_LIB_PATH.'/sbIDN.inc.php');
    	$idn = new sbIDN();

    	$cat_title = $idn->decode($cat_title);
	}

	return $cat_title;
}

function fPages_Create_System_Cats()
{
    require_once(SB_CMS_LIB_PATH.'/sbTree.inc.php');
    $tree = new sbTree('pl_pages');

    $res = sql_query('SELECT cat_id FROM sb_categs WHERE cat_ident=? AND cat_level=0', 'pl_pages');
    if (!$res)
    {
        // создаем корневой раздел
        $fields = array();
        $fields['cat_title'] = PL_PAGES_H_ROOT_NAME;
        $fields['cat_closed'] = 0;
        $fields['cat_rubrik'] = 1;
        $fields['cat_rights'] = $_SESSION['sbAuth']->isAdmin() ? '' : 'u'.$_SESSION['sbAuth']->getUserId();

        $root_id = $tree->insertNode(0, $fields);

        if (!$root_id)
            return false;
    }
    else
    {
        $root_id = $res[0][0];
    }

    $result = array($root_id);

    $res = sql_query('SELECT u_domains FROM sb_users WHERE u_id=?d', $_SESSION['sbAuth']->getUserId());
    if ($res)
    {
        $u_domains = explode(',', $res[0][0]);
    }
    else
    {
        $u_domains = array();
    }

    // проверяем, есть ли разделы для доменов
    foreach ($GLOBALS['sb_domains'] as $domain => $value)
    {
        $res = sql_query('SELECT cat_left, cat_right FROM sb_categs WHERE cat_ident=? AND cat_level=1 AND cat_title=?', 'pl_pages', $domain);

        if (!$res)
        {
            $fields['cat_closed'] = 0;
            $fields['cat_rubrik'] = 1;
            $fields['cat_title'] = $domain;
            $fields['cat_rights'] = $_SESSION['sbAuth']->isAdmin() ? '' : 'u'.$_SESSION['sbAuth']->getUserId();

            if (!$cat_id = $tree->insertNode($root_id, $fields))
                return false;

            if (!$_SESSION['sbAuth']->isAdmin() && !in_array($domain, $u_domains))
            {
                $result[] = $cat_id;
            }
        }
        elseif (!$_SESSION['sbAuth']->isAdmin() && !in_array($domain, $u_domains))
        {
            list($left, $right) = $res[0];
            $res = sql_query('SELECT cat_id FROM sb_categs WHERE cat_left >= ?d AND cat_right <= ?d AND cat_ident=?', $left, $right, 'pl_pages');
            foreach ($res as $value)
            {
                $result[] = $value[0];
            }
        }
    }

    return $result;
}

function fPages_Get_Status()
{
	$id = intval($_GET['id']);
	$res = sql_query('SELECT p_state FROM sb_pages WHERE p_id=?d', $id);
	if (!$res)
	{
		sb_show_message(PL_PAGES_H_STATUS_ERROR, true, 'warning');
	    return;
	}

	list($p_state) = $res[0];

	require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

	$layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE.'?event=pl_pages_get_status_submit'.($_SERVER['QUERY_STRING'] != '' ? '&'.$_SERVER['QUERY_STRING'] : ''), 'thisDialog', 'post', '');
	$layout->mTableWidth = '95%';

	$layout->addHeader(PL_PAGES_H_ELEM_GET_STATUS);
	$layout->addField('', new sbLayoutHTML('<div class="hint_div">'.PL_PAGES_H_ELEM_GET_STATUS_DESC.'</div>', true));

	$edit_rights = $_SESSION['sbPlugins']->isRightAvailable('pl_pages', 'elems_edit');
	$edit_rights = $edit_rights && sb_add_workflow_status($layout, 'pl_pages', $id, 'p_state', $p_state);

	$layout->addButton('submit', KERNEL_SAVE, 'btn_save', '', ($edit_rights ? '' : 'disabled="disabled"'));
    $layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog()"');

    echo '<br /><br />';

    $layout->show();
}

function fPages_Get_Status_Submit()
{
	$id = intval($_GET['id']);

	$res = sql_query('SELECT p_name FROM sb_pages WHERE p_id=?d', $id);
	if (!$res)
	{
		sb_show_message(PL_PAGES_H_STATUS_ERROR, false, 'warning');
    	fPages_Get_Status();
	    return;
	}

	list($p_name) = $res[0];

	$p_state = 0;
	extract($_POST);

	$row = array();
	sb_submit_workflow_status($row, 'p_state');

    sql_query('UPDATE sb_pages SET ?a WHERE p_id=?d', $row, $id, sprintf(PL_PAGES_H_STATUS_OK, $p_name));

    $res_cat = sql_query('SELECT categs.cat_id, links.link_id FROM sb_categs categs, sb_catlinks links WHERE categs.cat_ident=? AND links.link_cat_id=categs.cat_id AND links.link_el_id=?d', 'pl_pages', $id);

    $_GET['plugin_ident'] = 'pl_pages';
    $_GET['link_src_cat_id'] = 0;
    $_GET['cat_id'] = $res_cat[0][0];
    $_GET['link_id'] = $res_cat[0][1];

	$footer_ar = fCategs_Edit_Elem();
    if (!$footer_ar)
    {
    	sb_show_message(PL_PAGES_H_STATUS_ERROR, false, 'warning');
    	fPages_Get_Status();
	    return;
    }

	fPages_Gen_Page($id);

    sb_mail_workflow_status('pl_pages', $id , $p_name , $p_state);

    echo '<script>
        sbReturnValue(true);
    </script>';
}

/**
 * Возвращает идентификатор и название страницы в системе для указанного URL-адреса.
 *
 * @param string $url URL-адрес.
 *
 * @return array Массив, первый элемент - идентификатор страницы, второй - название страницы. FALSE, если страница не найдена.
 */
function fPages_Get_Page_Id($url)
{
    if (sb_strpos($url, '://') === false)
    {
        $url = 'http://'.SB_COOKIE_DOMAIN.'/'.trim($url, '/');
    }
    elseif(trim($url) === 'http://' || trim($url) === 'https://')
    {
        $url = '';
    }

    $url = parse_url($url);
    if ($url && isset($url['path']) && $url['path'] != '')
    {
        $domain = isset($url['host']) ? str_ireplace('www.', '', $url['host']) : SB_COOKIE_DOMAIN;
        $res = sql_query('SELECT cat_left, cat_right FROM sb_categs WHERE cat_title = ? AND cat_ident = ? AND cat_level = 1', strtolower($domain), 'pl_pages');
        if ($res)
        {
        	list($left, $right) = $res[0];

        	$page = sbPlugins::getSetting('sb_directory_index');
			if (trim($page) == '')
			{
			    $page = 'index.php';
			}

			$path = explode('/', str_replace('\\', '/', $url['path']));

            if (strpos($path[count($path) - 1], '.') !== false)
            {
                $page = array_pop($path);
                $path = trim(implode('/', $path), '/\\');
            }
            else
            {
                $path = trim(implode('/', $path), '/\\');
            }

            $res = sql_query('SELECT p.p_id, p.p_title
                    FROM sb_categs c, sb_catlinks l, sb_pages p
                    WHERE p.p_filepath=? AND p.p_filename=?
                    AND l.link_el_id=p.p_id AND l.link_cat_id=c.cat_id
                    AND c.cat_ident=? AND c.cat_left >= ?d AND c.cat_right <= ?d', $path, $page, 'pl_pages', $left, $right);

            if ($res)
            {
            	return array($res[0][0], $res[0][1]);
            }
        }
    }

    return false;
}

function fPages_Get_Page()
{
    $never_show_cats = fPages_Create_System_Cats();
    if (!$never_show_cats)
    {
        sb_show_message(PL_PAGES_H_CREATE_CATEGS_ERROR, true, 'warning');
        return;
    }

    require_once(SB_CMS_LIB_PATH.'/sbElements.inc.php');

    $elems = new sbElements('sb_pages', 'p_id', 'p_name', 'fPages_Get', 'pl_pages_get_page', 'pl_pages');

    $elems->mCategsTitleHandler = 'fPages_Get_Domain_Name';

    $page = '';
    $title = '';
    $id = '';
    if (isset($_GET['page']) && trim($_GET['page']) != '')
    {
    	$page_info = fPages_Get_Page_Id($_GET['page']);

    	if ($page_info)
    	{
    		$id = $page_info[0];
    		$title = $page_info[1];

    		$elems->mElemsSelectedId = $id;
        }

        $page = $_GET['page'];
    }

    $elems->mElemsFooterStr = '<table cellspacing="0" cellpadding="7" width="100%" class="form">
        <tr>
            <th width="300">
                '.PL_PAGES_H_GET_URL.':
            </th>
            <td>
                <input type="text" id="page_url" value="'.$page.'" style="width: 400px;" onfocus="select()">
                <input type="hidden" id="page_title" value="'.$title.'">
                <input type="hidden" id="page_id" value="'.$id.'">
            </td>
        </tr>
        <tr>
            <td class="footer" colspan="2">
            <div class="footer">
            <button onclick="choosePage();">'.KERNEL_CHOOSE.'</button>&nbsp;&nbsp;
            <button onclick="sbCloseDialog();">'.KERNEL_CANCEL.'</button>
            </div>
        </td></tr></table>';

    $elems->mElemsJavascriptStr .= '
        function selPage(el)
        {
            var el_url = sbGetE("page_url");
            var el_title = sbGetE("page_title");
            var el_id = sbGetE("page_id");
            if (el_url && el_title && el_id)
            {
                el_url.value = sbGetE("url_" + el.getAttribute("el_id")).innerHTML;
                el_title.value = sbGetE("title_" + el.getAttribute("el_id")).innerHTML;
                el_id.value = el.getAttribute("el_id");
            }
        }
        function choosePage()
        {
            var el = sbGetE("page_url");
            var el_title = sbGetE("page_title");
            var el_id = sbGetE("page_id");
            if (!el || el.value == "" || !el_title || !el_id || el_id.value == "")
            {
                alert("'.PL_PAGES_H_NO_NAME_MSG.'");
                return;
            }

            var res = new Object();
            res.url = el.value;
            res.title = el_title.value;
            res.p_id = el_id.value;

            sbReturnValue(res);
        }
    ';

    $elems->mElemsClickFunc = 'selPage';

    $elems->mCategsRootName = PL_PAGES_H_ROOT_NAME;
    $elems->mCategsUseRights = false;

	$elems->addField('p_filepath');    // путь к файлу страницы
	$elems->addField('p_filename');    // имя файла страницы
	$elems->addField('p_state');       // состояние страницы
    $elems->addField('p_temp_id');     // ID макета дизайна страницы
	$elems->addField('p_default');     // страница по умолчанию или нет
	$elems->addField('p_crc');         // контрольная сумма

    $elems->addFilter(PL_PAGES_H_FILTER_TITLE,     'p_name', 'string');
    $elems->addFilter(PL_PAGES_H_FILTER_FILENAME,  'p_filename', 'string');
    $elems->addFilter(PL_PAGES_H_FILTER_STATUS,    'p_state', 'select', array(0 => PL_PAGES_H_GET_STATE_NOT_PUBLISHED, 1 => PL_PAGES_H_GET_STATE_PUBLISHED));

    $options = array();
    $res = sql_query('SELECT categs.cat_title, temps.t_id, temps.t_name FROM sb_categs categs, sb_catlinks links, sb_templates temps WHERE temps.t_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident=? ORDER BY categs.cat_left, temps.t_name', 'pl_templates');
    if ($res)
    {

        $old_cat_title = '';
        foreach ($res as $value)
        {
            list($cat_title, $t_id, $t_name) = $value;
            if ($old_cat_title != $cat_title)
            {
                $options[uniqid()] = '-'.$cat_title;
                $old_cat_title = $cat_title;
            }
            $options[$t_id] = $t_name;
        }
    }

    $elems->addFilter(PL_PAGES_H_FILTER_TEMP, 'p_temp_id', 'select', $options);

    $elems->addSorting(PL_PAGES_H_SORT_BY_NAME,     'p_name');
    $elems->addSorting(PL_PAGES_H_SORT_BY_FILENAME, 'p_filename');
    $elems->addSorting(PL_PAGES_H_SORT_BY_STATE, 'p_state');
    $elems->addSorting(PL_PAGES_H_SORT_BY_TEMP, 'p_temp_id');

    $elems->mCategsPasteElemsMenuTitle = PL_PAGES_H_CATEGS_PASTE_ELEMS_MENU_TITLE;
    $elems->mCategsPasteLinksMenuTitle = PL_PAGES_H_CATEGS_PASTE_LINKS_MENU_TITLE;

    $elems->mElemsAddMenuTitle  = PL_PAGES_H_ELEMS_ADD_MENU_TITLE;
    $elems->mElemsEditMenuTitle = PL_PAGES_H_ELEMS_EDIT_MENU_TITLE;
    $elems->mElemsDeleteMenuTitle = PL_PAGES_H_ELEMS_DELETE_MENU_TITLE;
    $elems->mElemsCopyMenuTitle = PL_PAGES_H_ELEMS_COPY_MENU_TITLE;
    $elems->mElemsCutMenuTitle  = PL_PAGES_H_ELEMS_CUT_MENU_TITLE;

    $elems->mElemsEditEvent = 'pl_pages_edit';
    $elems->mElemsEditDlgWidth = 'screen.availWidth - 100';
	$elems->mElemsEditDlgHeight = 'screen.availHeight - 100';

	$elems->mElemsAddEvent = 'pl_pages_edit';
    $elems->mElemsAddDlgWidth = 'screen.availWidth - 100';
	$elems->mElemsAddDlgHeight = 'screen.availHeight - 100';

	$elems->mElemsDeleteEvent = 'pl_pages_delete';
	$elems->mElemsBeforePasteEvent = 'pl_pages_before_paste';
	$elems->mElemsAfterPasteEvent = 'pl_pages_paste';
	$elems->mCategsBeforePasteEvent = 'pl_pages_paste_categs';

	$elems->mCategsAddEvent = 'pl_pages_cat_edit';
	$elems->mCategsAddDlgWidth = 800;
	$elems->mCategsAddDlgHeight = 400;

	$elems->mCategsEditEvent = 'pl_pages_cat_edit';
	$elems->mCategsEditDlgWidth = 800;
	$elems->mCategsEditDlgHeight = 400;

	$elems->mCategsClosed = true;
	$elems->mCategsRubrikator = true;
	$elems->mCategsRubrikatorLevel = 2;
	$elems->mCategsNeverShowCats = $never_show_cats;
	$elems->mCategsAddMenuLevel = 2;
	$elems->mCategsEditMenuLevel = 2;
	$elems->mCategsCopyMenuLevel = 3;
	$elems->mCategsCutMenuLevel = 3;
	$elems->mCategsDadStartLevel = 2;
	$elems->mCategsDeleteMenuLevel = 2;
	$elems->mCategsPasteCategsMenuLevel = 2;
	$elems->mCategsPasteElemsMenuLevel = 2;
	$elems->mElemsAddMenuLevel = 2;
	$elems->mElemsUseLinks = true;

	if ($_SESSION['sbPlugins']->isRightAvailable('pl_pages', 'categs_edit|elems_edit'))
	{
	    $elems->mCategsJavascriptStr .= '
          function pagesGen(cat_id)
		  {
		      if (typeof(cat_id) == "undefined")
		          var strPage = "'.SB_CMS_DIALOG_FILE.'?event=pl_pages_gen_pages&id=" + sbSelCat.id + "&subcategs=1";
		      else if (cat_id == "page")
		          var strPage = "'.SB_CMS_DIALOG_FILE.'?event=pl_pages_gen_pages&p_id=" + sbSelEl.getAttribute("el_id");
		      else
		          var strPage = "'.SB_CMS_DIALOG_FILE.'?event=pl_pages_gen_pages&id=" + cat_id;

		      sbSelCat = 0;
              var strAttr = "resizable=0,width=600,height=400";
              sbShowDialog(strPage, strAttr);
		  }';

        $elems->mCategsAfterEditFunc = 'pagesGen';
        $elems->addCategsMenuItem(PL_PAGES_H_GEN_PAGES_MENU_TITLE, 'pagesGen();');
        $elems->addElemsMenuItem(PL_PAGES_H_GEN_PAGE_MENU_TITLE, 'pagesGen("page");');
	}

    $elems->init();
}

function fPages_Get_Links()
{
    $where_str = '';
    if (isset($_GET['ident']) && is_array($_GET['ident']))
    {
        foreach ($_GET['ident'] as $value)
        {
            $value = preg_replace('/[^a-zA-Z0-9_]+/', '', $value);

            $where_str .= 'elems.e_ident="'.$value.'" OR ';
        }
    }

    if ($where_str != '')
    {
        $where_str = 'AND ('.substr($where_str, 0, -4).')';
    }

    require_once(SB_CMS_LIB_PATH.'/sbDBPager.inc.php');

    $total = true;
    $pager = new sbDBPager('lp', 7, 30, 'thisDialog');

    if (isset($_GET['id']))
    {
        $result = $pager->init($total, 'SELECT DISTINCT pages.p_id, pages.p_name, pages.p_filename, pages.p_filepath, pages.p_state, categs.cat_left, categs.cat_right FROM sb_pages pages, sb_elems elems, sb_categs categs, sb_catlinks links
	                                    WHERE elems.e_link="page" AND elems.e_temp_id=?d '.$where_str.' AND pages.p_id=elems.e_p_id AND links.link_el_id=pages.p_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_pages"', $_GET['id']);
    }
    elseif (isset($_GET['e_id']))
    {
        $result = $pager->init($total, 'SELECT DISTINCT pages.p_id, pages.p_name, pages.p_filename, pages.p_filepath, pages.p_state, categs.cat_left, categs.cat_right FROM sb_pages pages, sb_elems elems, sb_categs categs, sb_catlinks links
	                                    WHERE elems.e_link="page" AND elems.e_el_id=?d '.$where_str.' AND pages.p_id=elems.e_p_id AND links.link_el_id=pages.p_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_pages"', $_GET['e_id']);
    }

    $num_list = $pager->show();

    if ($result)
    {
        require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

        echo '<br />
        <script>
        function showPage(pid)
        {
            if (_isFF || _isIE)
                var wnd = dialogArguments;
            else
                var wnd = window.opener;
            wnd.location = sb_cms_content_file + "?event=pl_pages_init&sb_sel_id=" + pid;
            window.close();
        }
        </script>';

        $layout = new sbLayout();
        $layout->mTableWidth = '95%';

        $values = array();
        $view_info = $_SESSION['sbPlugins']->isRightAvailable('pl_pages', 'read');
        $res = sql_query('SELECT u_domains FROM sb_users WHERE u_id=?d', $_SESSION['sbAuth']->getUserId());
        if ($res)
        {
            $u_domains = explode(',', $res[0][0]);
        }
        else
        {
            $u_domains = array();
        }

        foreach ($result as $value)
        {

            list($p_id, $p_name, $p_filename, $p_filepath, $p_state, $left, $right) = $value;

            $res = sql_query('SELECT cat_title FROM sb_categs WHERE cat_left <= ?d AND cat_right >= ?d AND cat_level=1 AND cat_ident=?', $left, $right, 'pl_pages');
            list($p_domain) = $res[0];

            $page_domain = $p_domain;

            if ($p_domain == SB_COOKIE_DOMAIN && SB_PORT != '80')
                $page_domain .= ':'.SB_PORT;

            if ('http://'.$page_domain != SB_DOMAIN && substr_count($p_domain, '.') > 0)
                $page_domain = 'www.'.$page_domain;

            $page_domain = 'http://'.$page_domain;

            $state = '';
			if ($_SESSION['sbPlugins']->isPluginAvailable('pl_workflow') && $_SESSION['sbPlugins']->isPluginInWorkflow('pl_pages'))
			{
				sb_get_workflow_status($state, 'pl_pages', $p_state);
				$state = preg_replace('=<br.*?/?>=i', '', $state);
			}
			else
			{
	            switch($p_state)
	        	{
		       		case 0:
						$state = '<span style="color:red;">'.PL_PAGES_H_GET_STATE_NOT_PUBLISHED.'</span>';
	        			break;
	        		case 1:
	        			$state = '<span style="color:#33805E;">'.PL_PAGES_H_GET_STATE_PUBLISHED.'</span>';
						break;
	        	}
				$state = PL_PAGES_H_GET_STATE.': '.$state;
			}

            if($view_info && (in_array($p_domain, $u_domains) || $_SESSION['sbAuth']->isAdmin()))
            {
            	$page = '<b><a href="javascript:void(0);" onclick="showPage('.$p_id.');">'.$p_name.'</a></b>
	                     <div class="smalltext" style="margin-top: 7px;">'.
	                     PL_PAGES_H_GET_URL.': <a href="'.$page_domain.'/'.($p_filepath != '' ? $p_filepath.'/' : '').$p_filename.'" target="_blank" style="font-size:11px;">'.$page_domain.'/'.($p_filepath != '' ? $p_filepath.'/' : '').$p_filename.'</a><br />'.
                         $state.'</div>';
            }
            else
            {
                $page = '<b>'.$p_name.'</b>
	                     <div class="smalltext" style="margin-top: 7px;">'.
	                     PL_PAGES_H_GET_URL.': <a href="'.$page_domain.'/'.($p_filepath != '' ? $p_filepath.'/' : '').$p_filename.'" target="_blank" style="font-size:11px;">'.$page_domain.'/'.($p_filepath != '' ? $p_filepath.'/' : '').$p_filename.'</a><br />'.
                         $state.'</div>';
            }

            $values[] = array('<img src="'.SB_CMS_IMG_URL.'/plugins/pl_pages_32.png" align="absMiddle" width="32" height="32" border="0" title="ID - '.$p_id.'">', $page);
        }

        $width = array('1', '');
        $valign = array('top', 'top');
        $labels = array('', PL_PAGES_H_GET_LINKS_TITLE);
        $fld = new sbLayoutTable($labels, $values);
        $fld->mWidth = $width;
        $fld->mVAlign = $valign;

        $layout->addField('', $fld);

        $layout->show();

        echo '<br />'.$num_list;
    }
    else
    {
        sb_show_message(PL_PAGES_H_GET_LINKS_ERROR, true);
    }

    echo '<br /><br /><a href="javascript:window.close();">[ '.KERNEL_CLOSE.' ]</a><br /><br />';
}

function fPages_Gen_Page($page_id)
{
	require_once(SB_CMS_LIB_PATH.'/sbTemplates.inc.php');

	$template = new sbTemplates($page_id, $error);

	if ($error)
	    return false;

	return $template->saveToFile();
}

function fPages_Get_Page_By_Url($url)
{
	if (trim($url) == '')
		return -1;

	if (sb_strpos($url, '://') === false)
    {
    	$host = '';
	    if (!isset($GLOBALS['sb_domains'][SB_COOKIE_DOMAIN]))
		{
			foreach ($GLOBALS['sb_domains'] as $conf_host => $value)
		    {
		        if (isset($value['pointers']) && in_array(SB_COOKIE_DOMAIN, $value['pointers']))
		        {
		        	$host = $conf_host;
		        }
		    }
		}
		else
		{
			$host = SB_COOKIE_DOMAIN;
		}

		if ($host == '')
		{
			return -1;
		}

        $url = 'http://'.$host.'/'.trim($url, '/');
    }

    $url = parse_url($url);
    $page_id = -1;

    if ($url && isset($url['path']) && $url['path'] != '')
    {
      	$domain = isset($url['host']) ? str_ireplace('www.', '', $url['host']) : SB_COOKIE_DOMAIN;
        $res = sql_query('SELECT cat_left, cat_right FROM sb_categs WHERE cat_title=? AND cat_ident=? AND cat_level=1', strtolower($domain), 'pl_pages');
        if ($res)
        {
        	list($left, $right) = $res[0];

        	$page = sbPlugins::getSetting('sb_directory_index');
			if (trim($page) == '')
			{
			    $page = 'index.php';
			}

			$path = explode('/', str_replace('\\', '/', $url['path']));

            if (strpos($path[count($path) - 1], '.') !== false)
            {
                $page = array_pop($path);
                $path = trim(implode('/', $path), '/\\');
            }
            else
            {
                $path = trim(implode('/', $path), '/\\');
            }

            $res = sql_query('SELECT p.p_id
                    FROM sb_categs c, sb_catlinks l, sb_pages p
                    WHERE p.p_filepath=? AND p.p_filename=?
                    AND l.link_el_id=p.p_id AND l.link_cat_id=c.cat_id
                    AND c.cat_ident=? AND c.cat_left >= ?d AND c.cat_right <= ?d', $path, $page, 'pl_pages', $left, $right);

            if ($res)
            {
            	$page_id = $res[0][0];
            }
        }
    }

    return $page_id;
}
/********************************** функции построения диалоговых окон ***********************************/

/**
 * Связанная страница
 *
 */
function fPages_Get_Elem_Page()
{
    $params = unserialize($_GET['params']);

    echo '<script>
        function choose()
        {
            var res = new Object();
            var params = new Array();

            var el_page = sbGetE("page");
            if (el_page.value == "")
            {
                alert("'.PL_PAGES_H_ELEM_PAGE_NO_PAGE_MSG.'");
                return;
            }

            params["page"] = page.value;
            res.params = sb_serialize(params);

            sbReturnValue(res);
        }
    </script><br /><br />';

    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

    $layout = new sbLayout();
    $layout->mTableWidth = '90%';
    $layout->mTitleWidth = '100';
    $layout->addHeader(PL_PAGES_H_ELEM_PAGE);

    $layout->addField(PL_PAGES_H_ELEM_PAGE_TITLE, new sbLayoutPage(isset($params['page']) ? $params['page'] : '', 'page', '', 'style="width: 430px;"'));

    $layout->addButton('button', KERNEL_CHOOSE, '', '', 'onclick="choose();"');
    $layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');

    $layout->show();
}

/**
 * Вывод разделов
 *
 */
function fPages_Get_Elem_Categs()
{
    fCategs_Get_Elem_Categs('pl_pages', 'pl_menu_temps', PL_MENU_H_ELEM_TREE_NO_TEMPS_MSG);
}

/**
 * Вывод пути по разделам
 *
 */
function fPages_Get_Elem_Path()
{
    require_once(SB_CMS_LIB_PATH.'/sbJustCategs.inc.php');
    $params = unserialize($_GET['params']);

    echo '<script>
        function chooseCat()
        {
            var res = new Object();
            var params = new Array();

            var el_cats = sbCatTree.getAllSelected();
            if (el_cats.length == 0)
            {
                alert("'.PL_PAGES_H_ELEM_PATH_NO_CATEGS_MSG.'");
                return;
            }

            params["ids"] = el_cats;
            var el_temp = sbGetE("temp_id");
            if (el_temp)
            {
                params["temp_id"] = el_temp.value;
            }
            else
            {
                alert("'.PL_PAGES_H_ELEM_PATH_NO_TEMPS_ALERT.'");
                return;
            }

            params["num_items"] = sbGetE("spin_num_items").value;
            params["show_hidden"] = sbGetE("show_hidden").checked ? 1 : 0;
            params["show_closed"] = sbGetE("show_closed").checked ? 1 : 0;

            res.temp_id = el_temp.value;
            res.params = sb_serialize(params);

            sbReturnValue(res);
        }
    </script>';

    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

    $layout = new sbLayout();
    $layout->mTableWidth = '100%';
    $layout->mTitleWidth = '200';

    $layout->addTab(PL_PAGES_H_ELEM_PATH_CATEGS_TAB);

    $never_show_cats = array();
    $res = sql_query('SELECT cat_id FROM sb_categs WHERE cat_ident=? AND cat_level=0', 'pl_pages');
    if ($res)
    {
    	$never_show_cats[] = $res[0][0];
    }

    $categs = new sbJustCategs('pl_pages');
    $categs->mCategsNeverShowCats = $never_show_cats;
    $categs->mCategsUseRights = false;
    $categs->mCategsMenu = false;
    $categs->mCategsMultiSelect = true;
    $categs->mCategsCount = false;
    $categs->mCategsSelectedIds = (isset($params['ids']) && $params['ids'] != '' ? explode('^', $params['ids']) : array());

    $layout->addField('', new sbLayoutHTML($categs->showTree('', '', '', false), true));
    $categs->init();

    $layout->addTab(PL_PAGES_H_ELEM_PATH_PROPS_TAB);
    $layout->addHeader(PL_PAGES_H_ELEM_PATH_PROPS_TAB);

    $options = array();
    $res = sql_query('SELECT categs.cat_title, temps.mpt_id, temps.mpt_title FROM sb_categs categs, sb_catlinks links, sb_menu_path_temps temps WHERE temps.mpt_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident=? ORDER BY categs.cat_left, temps.mpt_title', 'pl_menu_path_temps');
    if ($res)
    {
        $old_cat_title = '';
        foreach ($res as $value)
        {
            list($cat_title, $mt_id, $mt_title) = $value;
            if ($old_cat_title != $cat_title)
            {
                $options[uniqid()] = '-'.$cat_title;
                $old_cat_title = $cat_title;
            }
            $options[$mt_id] = $mt_title;
        }
    }

    if (count($options) > 0)
    {
    	$fld = new sbLayoutSelect($options, 'temp_id');
        if (isset($_GET['temp_id']))
        {
            $fld->mSelOptions = array($_GET['temp_id']);
        }
    }
    else
    {
        $fld = new sbLayoutLabel('<div class="hint_div">'.PL_PAGES_H_ELEM_PATH_NO_TEMPS_MSG.'</div>', '', '', false);
    }

    $layout->addField(PL_PAGES_H_ELEM_PATH_TEMP, $fld);
    $layout->addField('', new sbLayoutDelim());

    $fld = new sbLayoutInput('text', (isset($params['num_items']) ? $params['num_items'] : '5'), 'spin_num_items', '', 'style="width: 50px;"');
    $fld->mMinValue = 1;
    $layout->addField(PL_PAGES_H_ELEM_PATH_COUNT, $fld);

    $fld = new sbLayoutInput('checkbox', '1', 'show_closed', '', (isset($params['show_closed']) && $params['show_closed'] == 1 ? 'checked="checked"' : ''));
    $fld->mHTML = '<div class="hint_div">'.PL_PAGES_H_ELEM_PATH_CLOSED_DESC.'</div>';
    $layout->addField(PL_PAGES_H_ELEM_PATH_SHOW_CLOSED, $fld);

    $layout->addField(PL_PAGES_H_ELEM_PATH_SHOW_HIDDEN, new sbLayoutInput('checkbox', '1', 'show_hidden', '', ((isset($params['show_hidden']) && $params['show_hidden'] == 1) || !isset($params['show_hidden']) ? 'checked="checked"' : '')));

    $layout->addButton('button', KERNEL_SAVE, '', '', 'onclick="chooseCat();"'.(count($options) > 0 ? '' : ' disabled="disabled"'));
    $layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');

    $layout->show();
}

/********************************** функции получения информации по элементам модуля ***********************************/

/**
 * Связанная страница
 *
 */
function fPages_Elem_Page_Info($params)
{
    echo '<div style="padding-bottom: 5px;"><b>'.PL_PAGES_H_ELEM_PAGE_TITLE.':</b> '.$params['page'].'</div>';
}

/**
 * Вывод разделов
 *
 */
function fPages_Elem_Categs_Info($params)
{
    fCategs_Elem_Categs_Info($params, 'pl_menu_temps');
}

/**
 * Вывод пути по разделам
 *
 */
function fPages_Elem_Path_Info($params)
{
    $in_str = implode(',', explode('^', $params['ids']));
    $in_str = '(0,'.$in_str.')';

    $categs_str = '';
    $res = sql_query('SELECT cat_title FROM sb_categs WHERE cat_id IN '.$in_str.' ORDER BY cat_left');
    if ($res)
    {
        $categs_str = '';
        foreach ($res as $value)
        {
            $categs_str .= $value[0].', ';
        }
        $categs_str = substr($categs_str, 0, -2);
    }

    $res = sql_query('SELECT categs.cat_title, temps.mpt_title FROM sb_categs categs, sb_catlinks links, sb_menu_path_temps temps
                          WHERE temps.mpt_id=?d AND links.link_el_id=temps.mpt_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident=?', $params['temp_id'], 'pl_menu_path_temps');

    echo '<div style="padding-bottom: 5px;"><b>'.PL_PAGES_H_ELEM_PATH_CATEGS_TAB.':</b> '.($categs_str != '' ? $categs_str : '<span style="color:red;">'.PL_PAGES_H_INFO_CATEGS_WAS_DELETED_MSG.'</span>').'</div>
          <div style="padding-bottom: 5px;"><b>'.PL_PAGES_H_ELEM_PATH_TEMP.':</b> '.($res ? $res[0][0].' -&gt; '.$res[0][1] : '<span style="color:red;">'.PL_PAGES_H_INFO_TEMP_WAS_DELETED_MSG.'</span>').'</div>
          <div class="delim"></div>
          <div style="padding-bottom: 5px;"><b>'.PL_PAGES_H_ELEM_PATH_COUNT.':</b> '.$params['num_items'].'</div>
          <div style="padding-bottom: 5px;"><b>'.PL_PAGES_H_ELEM_PATH_SHOW_CLOSED.':</b> '.(isset($params['show_closed']) && $params['show_closed'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>
          <div style="padding-bottom: 5px;"><b>'.PL_PAGES_H_ELEM_PATH_SHOW_HIDDEN.':</b> '.(isset($params['show_hidden']) && $params['show_hidden'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>';
}

/********************************** функции получения элементов модуля ***********************************/

/**
 * Связанная страница
 *
 */
function fPages_Elem_Page($el_id, $temp_id, $params, $tag_id)
{
    $page = $params['page'];
    $ar = array('http://');

    foreach (array_keys($GLOBALS['sb_domains']) as $setting_domain)
    {
    	$ar[] = 'www.'.$setting_domain;
        $ar[] = $setting_domain;
    }

    $page = str_ireplace($ar, '', $page);
    $result = '<?php
    $sb_no_footer = true;
    include_once(SB_BASEDIR.\''.$page.'\');
    $sb_no_footer = false;
    ?>';

    return $result;
}

/**
 * Вывод разделов
 *
 */

if (!function_exists('fPages_Elem_Categs'))
{
	function fPages_Elem_Categs($el_id, $temp_id, $params, $tag_id)
	{
	    return "<?php include_once SB_CMS_PL_PATH.'/pl_pages/prog/pl_pages.php';\n
	        fPages_Elem_Categs('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id');\n
	        ?>";
	}
}

/**
 * Вывод пути по разделам (HTML)
 *
 */
function fPages_Elem_Path_Html($el_id, $temp_id, $params, $tag_id)
{
    return "<?php include_once SB_CMS_PL_PATH.'/pl_pages/prog/pl_pages.php';\n
        fPages_Elem_Path('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id');\n
        ?>";
}

/**
 * Вывод пути по разделам (Plain)
 *
 */
function fPages_Elem_Path_Plain($el_id, $temp_id, $params, $tag_id)
{
    return "<?php include_once SB_CMS_PL_PATH.'/pl_pages/prog/pl_pages.php';\n
        fPages_Elem_Path('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id');\n
        ?>";
}
/**
 * Вывод заголовка страницы (Plain)
 *
 */
function fPages_Elem_Page_Name($el_id, $temp_id, $params, $tag_id)
{
    return "<?php include_once SB_CMS_PL_PATH.'/pl_pages/prog/pl_pages.php';\n
        fPages_Elem_Page_Name_Plain('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id', true);\n
        ?>";
}
?>