<?php
function fPages_Init()
{
    $never_show_cats = fPages_Create_System_Cats();

    if (!$never_show_cats) {
        sb_show_message(PL_PAGES_H_CREATE_CATEGS_ERROR, true, 'warning');
        return;
    }
    require_once(SB_CMS_LIB_PATH . '/sbElements.inc.php');

    $elems = new sbElements('sb_pages', 'p_id', 'p_name', 'fPages_Get', 'pl_pages_init', 'pl_pages');

    $elems->mCategsTitleHandler = 'fPages_Get_Domain_Name';

    if (isset($_GET['page'])) {
        $elems->mElemsSelectedId = intval($_GET['page']);
    }

    $elems->mCategsRootName = PL_PAGES_H_ROOT_NAME;

    $elems->addField('p_filepath');    // путь к файлу страницы
    $elems->addField('p_filename');    // имя файла страницы
    $elems->addField('p_state');       // состояние страницы
    $elems->addField('p_temp_id');     // ID макета дизайна страницы
    $elems->addField('p_default');     // страница по умолчанию или нет
    $elems->addField('p_crc');         // контрольная сумма

    $elems->addFilter(PL_PAGES_EDIT_ID, 'p_id', 'number');
    $elems->addFilter(PL_PAGES_EDIT_TITLE, 'p_name', 'string');
    $elems->addFilter(PL_PAGES_EDIT_FILENAME, 'p_filename', 'string');
    $elems->addFilter(PL_PAGES_EDIT_STATUS, 'p_state', 'select', array(0 => PL_PAGES_H_GET_STATE_NOT_PUBLISHED, 1 => PL_PAGES_H_GET_STATE_PUBLISHED));

    $options = array();
    $res = sql_query('SELECT categs.cat_title, temps.t_id, temps.t_name FROM sb_categs categs, sb_catlinks links, sb_templates temps WHERE temps.t_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident=? ORDER BY categs.cat_left, temps.t_name',
        'pl_templates');
    if ($res) {
        $old_cat_title = '';
        foreach ($res as $value) {
            list($cat_title, $t_id, $t_name) = $value;
            if ($old_cat_title != $cat_title) {
                $options[uniqid()] = '-' . $cat_title;
                $old_cat_title = $cat_title;
            }
            $options[$t_id] = $t_name;
        }
    }
    $elems->addFilter(PL_PAGES_EDIT_TEMP, 'p_temp_id', 'select', $options);

    $elems->addSorting(PL_PAGES_H_SORT_BY_ID, 'p_id');
    $elems->addSorting(PL_PAGES_H_SORT_BY_NAME, 'p_name');
    $elems->addSorting(PL_PAGES_H_SORT_BY_FILENAME, 'p_filename');
    $elems->addSorting(PL_PAGES_H_SORT_BY_STATE, 'p_state');
    $elems->addSorting(PL_PAGES_H_SORT_BY_TEMP, 'p_temp_id');

    $elems->mCategsPasteElemsMenuTitle = PL_PAGES_H_CATEGS_PASTE_ELEMS_MENU_TITLE;
    $elems->mCategsPasteLinksMenuTitle = PL_PAGES_H_CATEGS_PASTE_LINKS_MENU_TITLE;

    $elems->mCategsPasteWithElementsMenuTitle = PL_PAGES_H_CATEGS_PASTE_WITH_PAGES_MENU_TITLE;
    $elems->mCategsPasteWithElementsMenu = true;
    $elems->mCategsAfterPasteWithElementsEvent = 'pl_pages_after_paste_with_elements';

    $elems->mCategsDeleteWithElementsMenuTitle = PL_PAGES_H_CATEGS_DELETE_WITH_ELEMENTS_MENU_TITLE;
    $elems->mCategsDeleteWithElementsMenu = true;
    $elems->mCategsBeforeDeleteWithElementsEvent = 'pl_pages_delete_cat_with_elements';

    $elems->mElemsAddMenuTitle = PL_PAGES_H_ELEMS_ADD_MENU_TITLE;
    $elems->mElemsEditMenuTitle = PL_PAGES_H_ELEMS_EDIT_MENU_TITLE;
    $elems->mElemsDeleteMenuTitle = PL_PAGES_H_ELEMS_DELETE_MENU_TITLE;
    $elems->mElemsCopyMenuTitle = PL_PAGES_H_ELEMS_COPY_MENU_TITLE;
    $elems->mElemsCutMenuTitle = PL_PAGES_H_ELEMS_CUT_MENU_TITLE;

    $elems->mElemsEditEvent = 'pl_pages_edit&real_event=pl_pages_init';
    $elems->mElemsEditDlgWidth = 'screen.availWidth - 100';
    $elems->mElemsEditDlgHeight = 'screen.availHeight - 100';

    $elems->mElemsAddEvent = 'pl_pages_edit&real_event=pl_pages_init';
    $elems->mElemsAddDlgWidth = 'screen.availWidth - 100';
    $elems->mElemsAddDlgHeight = 'screen.availHeight - 100';

    $elems->mElemsDeleteEvent = 'pl_pages_delete';
    $elems->mElemsBeforePasteEvent = 'pl_pages_before_paste';
    $elems->mElemsAfterPasteEvent = 'pl_pages_paste';
    $elems->mCategsBeforePasteEvent = 'pl_pages_paste_categs';

    $elems->mCategsAddEvent = 'pl_pages_cat_edit';
    $elems->mCategsAddDlgWidth = 800;
    $elems->mCategsAddDlgHeight = 400;

    $elems->mCategsEditEvent = 'pl_pages_cat_edit';
    $elems->mCategsEditDlgWidth = 800;
    $elems->mCategsEditDlgHeight = 400;

    $elems->mCategsClosed = true;
    $elems->mCategsRubrikator = true;
    $elems->mCategsRubrikatorLevel = 2;
    $elems->mCategsNeverShowCats = $never_show_cats;
    $elems->mCategsAddMenuLevel = 2;
    $elems->mCategsEditMenuLevel = 2;
    $elems->mCategsCopyMenuLevel = 3;
    $elems->mCategsCutMenuLevel = 3;
    $elems->mCategsDadStartLevel = 2;
    $elems->mCategsDeleteMenuLevel = 2;
    $elems->mCategsPasteCategsMenuLevel = 2;
    $elems->mCategsPasteElemsMenuLevel = 2;
    $elems->mElemsAddMenuLevel = 2;
    $elems->mElemsUseLinks = true;

    if ($_SESSION['sbPlugins']->isRightAvailable('pl_pages', 'categs_edit|elems_edit')) {
        $elems->mCategsJavascriptStr .= '
          function pagesGen(cat_id)
          {
              if (typeof(cat_id) == "undefined")
              {
                  var strPage = "' . SB_CMS_DIALOG_FILE . '?event=pl_pages_gen_pages&id=" + sbSelCat.id + "&subcategs=1";
              }
              else if (typeof(cat_id) == "object")
              {
                    sbElemsClick(cat_id);

                    sbSelEl = sbGetE("el_" + sbSelectedEls[sbSelectedEls.length-1]);
                  if (!sbSelEl) return;

                  var el_id = sbSelEl.getAttribute("el_id");
                  var el = sbGetE("p_crc_"+el_id);
                  el.removeNode(true);

                  var strPage = "' . SB_CMS_DIALOG_FILE . '?event=pl_pages_gen_pages&p_id=" + el_id;
              }
              else if (cat_id == "page")
              {
                  var strPage = "' . SB_CMS_DIALOG_FILE . '?event=pl_pages_gen_pages&p_id=" + sbSelEl.getAttribute("el_id");
              }
              else
              {
                  var strPage = "' . SB_CMS_DIALOG_FILE . '?event=pl_pages_gen_pages&id=" + cat_id;
              }

              sbSelCat = 0;
              var strAttr = "resizable=0,width=600,height=400";
              sbShowDialog(strPage, strAttr);
          }
          function pagesEdit(e)
          {
              if (!e) return;

              if (e !== true)
                  sbElemsClick(e);

              sbSelEl = sbGetE("el_" + sbSelectedEls[sbSelectedEls.length-1]);

              if (!sbSelEl) return;

              var p_id = sbSelEl.getAttribute("el_id");

              var strPage = "' . SB_CMS_DIALOG_FILE . '?event=pl_pages_edit_content&p_id=" + p_id;
              var strAttr = "resizable=1, width="+screen.availWidth+", height="+screen.availHeight;

              window.open(strPage, "_blank", strAttr);
          }
          function setMainPage()
          {
                sbSelEl = sbGetE("el_" + sbSelectedEls[sbSelectedEls.length-1]);

              if (!sbSelEl) return;

              var p_id = sbSelEl.getAttribute("el_id");
              var cat_id = sbCatTree.getSelectedItemId();
              sbLoadSync(sb_cms_empty_file + "?event=pl_pages_set_main&id=" + p_id + "&cat_id=" + cat_id);

              var div_el = sbGetE("elems_list_div");
              var from = "";
              if (div_el)
              {
                  from = div_el.getAttribute("from");
              }
              var url = sb_cms_empty_file + "?event=pl_pages_init&id=" + cat_id + "&page_elems=" + from;
              setTimeout("sbElemsShow(\'"+url+"\')", 0);
          }';

        $elems->mCategsAfterEditFunc = 'pagesGen';
        $elems->addCategsMenuItem(PL_PAGES_H_GEN_PAGES_MENU_TITLE, 'pagesGen();');
        $elems->addElemsMenuItem(PL_PAGES_H_EDIT_PAGE_MENU_TITLE, 'pagesEdit(true);');

        $elems->addElemsMenuItem(PL_PAGES_H_GEN_PAGE_MENU_TITLE, 'pagesGen("page");');
        $elems->addElemsMenuItem(PL_PAGES_H_SET_MAIN_PAGE_MENU_TITLE, 'setMainPage();');
    }

    $elems->mElemsJavascriptStr = '
        function linkTexts(e)
        {
            if (!sbSelEl)
            {
                var el = sbEventTarget(e);

                while (el.parentNode && !el.getAttribute("true_id"))
                    el = el.parentNode;

                var el_id = el.getAttribute("el_id");
            }
            else
                var el_id = sbSelEl.getAttribute("el_id");

            strPage = "' . SB_CMS_MODAL_DIALOG_FILE . '?event=pl_texts_get_links&id=" + el_id;
            strAttr = "resizable=1,width=800,height=600";
            sbShowModalDialog(strPage, strAttr, null, window);
        }';

    $elems->addElemsMenuItem(PL_PAGES_TEXT_LINKS_ITEM, 'linkTexts();');
    $elems->init();
}

function fPages_Cat_Edit()
{
    if (!$_SESSION['sbPlugins']->isRightAvailable('pl_pages', 'categs_edit')) {
        sb_show_message(SB_ELEMS_DENY_MSG, true, 'warning');
        return;
    }

    $cat_rights = '';

    if (isset($_GET['cat_id']) && $_GET['cat_id'] != '') {
        if (!fCategs_Check_Rights($_GET['cat_id'])) {
            sb_show_message(SB_ELEMS_DENY_MSG, true, 'warning');
            return;
        }

        $res = sql_query('SELECT cat_level, cat_title, cat_rubrik, cat_closed, cat_fields, cat_rights FROM sb_categs WHERE cat_id=?d', $_GET['cat_id']);

        if ($res) {
            list($cat_level, $cat_title, $cat_rubrik, $cat_closed, $cat_fields, $cat_rights) = $res[0];
            $_GET['cat_id_p'] = '';

            if ($cat_fields != '') {
                $cat_fields = unserialize($cat_fields);
            } else {
                $cat_fields = array();
            }
        } else {
            sb_show_message(PL_PAGES_EDIT_CAT_ERROR_NO_CATEG, true, 'warning');
            return;
        }
    } else {
        if (!fCategs_Check_Rights($_GET['cat_id_p'])) {
            sb_show_message(SB_ELEMS_DENY_MSG, true, 'warning');
            return;
        }

        $res = sql_query('SELECT cat_level, cat_rubrik, cat_closed, cat_fields, cat_rights FROM sb_categs WHERE cat_id=?d', $_GET['cat_id_p']);
        if ($res) {
            list($cat_level, $cat_rubrik, $cat_closed, $cat_fields, $cat_rights) = $res[0];

            if ($cat_fields != '') {
                $cat_fields = unserialize($cat_fields);
            } else {
                $cat_fields = array();
            }

            $cat_title = '';
            $cat_level++;

            $_GET['cat_id'] = '';
        } else {
            sb_show_message(PL_PAGES_EDIT_CAT_ERROR_NO_CATEG, true, 'warning');
            return;
        }
    }

    echo '<script>
        function checkValues()
        {
            var cat_title = sbGetE("cat_title");
            if (cat_title.value == "")
            {
                alert("' . PL_PAGES_EDIT_CAT_NO_TITLE_MSG . '");
                return false;
            }

            var cat_closed = sbGetE("cat_closed");
            if (cat_closed && cat_closed.checked)
            {
                if (sbGetE("group_idspl_pages_read").value == "")
                {
                    alert("' . PL_PAGES_EDIT_NO_GROUPS_MSG . '");
                    return false;
                }

                if (sbGetE("cat_fields[page]").value == "")
                {
                    alert("' . PL_PAGES_EDIT_NO_PAGE_MSG . '");
                    return false;
                }
            }

            return true;
        }
        function browseGroups()
        {
            var group_ids = sbGetE("group_idspl_pages_read").value;
            var group_names = sbGetE("group_namespl_pages_read");

            if (!group_names.disabled)
            {
                strPage = "' . SB_CMS_MODAL_DIALOG_FILE . '?event=pl_site_users_get_groups&sel_cat_ids="+group_ids;
                strAttr = "resizable=1,width=500,height=500";
                sbShowModalDialog(strPage, strAttr, afterBrowseGroups);
            }
        }
        function afterBrowseGroups()
        {
            if (sbModalDialog.returnValue)
            {
                var group_ids = sbGetE("group_idspl_pages_read");
                var group_names = sbGetE("group_namespl_pages_read");

                group_ids.value = sbModalDialog.returnValue.ids;
                group_names.value = sbModalDialog.returnValue.text;
            }
        }
        function changeType(el)
        {
            if (el.checked)
            {
                sbGetE("group_namespl_pages_read").disabled = false;
                sbGetE("cat_fields[page]").disabled = false;
            }
            else
            {
                sbGetE("group_namespl_pages_read").disabled = true;
                sbGetE("cat_fields[page]").disabled = true;
                sbGetE("group_namespl_pages_read").value = "";
                sbGetE("group_idspl_pages_read").value = "";
                sbGetE("cat_fields[page]").value = "";
            }
        }
    </script>';

    require_once(SB_CMS_LIB_PATH . '/sbLayout.inc.php');

    $layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE . '?event=pl_pages_cat_edit_submit&cat_id=' . $_GET['cat_id'] . '&cat_id_p=' . $_GET['cat_id_p'],
        'thisDialog', 'post', 'checkValues()');
    $layout->mTitleWidth = 250;

    if ($cat_level > 1) {
        $layout->addTab(PL_PAGES_EDIT_CAT_TAB1);
        $layout->addHeader(PL_PAGES_EDIT_CAT_TAB1);
    } else {
        echo '<br><br>';
        $layout->addHeader(PL_PAGES_EDIT_CAT_DOMAIN);
    }

    $layout->addField($cat_level > 1 ? PL_PAGES_EDIT_CAT_TITLE : PL_PAGES_EDIT_CAT_DOMAIN_TITLE,
        new sbLayoutInput('text', $cat_title, 'cat_title', '', 'style="width:400px;"', true));

    if ($cat_level > 1) {
        $layout->addField('', new sbLayoutDelim());
        $fld = new sbLayoutInput('text', isset($cat_fields['path']) ? $cat_fields['path'] : '', 'cat_fields[path]', '', 'style="width:400px;"');
        $fld->mHTML = '<div class="hint_div" style="margin-top: 5px;">' . PL_PAGES_EDIT_CAT_PATH_LABEL . '</div>';
        $layout->addField(PL_PAGES_EDIT_CAT_PATH, $fld);

        $options = array('-1' => ' --- ');

        $res = sql_query('SELECT categs.cat_title, temps.t_id, temps.t_name FROM sb_categs categs, sb_catlinks links, sb_templates temps WHERE temps.t_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident=? ORDER BY categs.cat_left, temps.t_name',
            'pl_templates');
        if ($res) {

            $old_cat_title = '';
            foreach ($res as $value) {
                list($cat_title, $t_id, $t_name) = $value;
                if ($old_cat_title != $cat_title) {
                    $options[uniqid()] = '-' . $cat_title;
                    $old_cat_title = $cat_title;
                }
                $options[$t_id] = $t_name;
            }
        }
        $layout->addField('', new sbLayoutDelim());
        $fld = new sbLayoutSelect($options, 'cat_fields[temp_id]');
        if (isset($cat_fields['temp_id'])) {
            $fld->mSelOptions = array($cat_fields['temp_id']);
        }
        $fld->mHTML = '<div class="hint_div" style="margin-top: 5px;">' . PL_PAGES_EDIT_CAT_TEMP_LABEL . '</div>';

        $layout->addField(PL_PAGES_EDIT_CAT_TEMP, $fld);

        $layout->addTab(PL_PAGES_EDIT_CAT_TAB2);
        $layout->addHeader(PL_PAGES_EDIT_CAT_TAB2);

        $layout->addField(PL_PAGES_EDIT_CAT_CLOSED,
            new sbLayoutInput('checkbox', '1', 'cat_closed', '', 'onclick="changeType(this);"' . ($cat_closed ? ' checked="checked"' : '')));

        if (isset($_GET['cat_id']) && $_GET['cat_id'] != '') {
            $layout->addField(PL_PAGES_EDIT_CAT_CLOSE_SUB, new sbLayoutInput('checkbox', '1', 'cat_close_sub'));
        }

        $layout->addField('', new sbLayoutDelim());

        $ident = 'pl_pages_read';

        $group_ids = '';
        $group_names = '';

        $res = sql_query('SELECT group_ids FROM sb_catrights
                                WHERE cat_id=?d AND right_ident=?', $_GET['cat_id'] != '' ? $_GET['cat_id'] : $_GET['cat_id_p'], $ident);

        if ($res) {
            list($group_ids) = $res[0];
            $ids = explode('^', trim($group_ids, '^'));

            $res = sql_query('SELECT cat_title FROM sb_categs WHERE cat_id IN (?a)', $ids);

            if ($res) {
                $group_names = array();
                foreach ($res as $value) {
                    $group_names[] = $value[0];
                }

                $group_names = implode(', ', $group_names);
            } else {
                $group_ids = '';
            }
        }

        $layout->addField('', new sbLayoutInput('hidden', $group_ids, 'group_ids' . $ident));
        $layout->addField(PL_PAGES_EDIT_CAT_CLOSED_GROUPS, new sbLayoutHTML('
                 <input id="group_names' . $ident . '" name="group_names' . $ident . '"' . (!$cat_closed ? ' disabled="disabled"' : '') . ' readonly="readonly" style="width:75%;" value="' . $group_names . '">
                 &nbsp;&nbsp;<img class="button" src="' . SB_CMS_IMG_URL . '/users.png" align="absmiddle" id="group_btn' . $ident . '" onmouseup="sbPress(this, false);" onmousedown="sbPress(this, true);" onclick="browseGroups();" width="20" height="20" title="' . KERNEL_BROWSE . '" />
                 '));

        $layout->addField(PL_PAGES_EDIT_CAT_CLOSED_PAGE, new sbLayoutPage(isset($cat_fields['page']) ? $cat_fields['page'] : '', 'cat_fields[page]', '',
            (!$cat_closed ? ' disabled="disabled" ' : '') . 'style="width:75%;"'));
    } else {
        $layout->addField('', new sbLayoutInput('hidden', '0', 'cat_closed'));
        $layout->addField('', new sbLayoutInput('hidden', '', 'cat_fields'));
    }

    $layout->addField('', new sbLayoutInput('hidden', $cat_rubrik, 'cat_rubrik'));
    $layout->addField('', new sbLayoutInput('hidden', $cat_level, 'cat_level'));
    $layout->addField('', new sbLayoutInput('hidden', $cat_rights, 'cat_rights'));

    $layout->addButton('submit', KERNEL_SAVE);
    $layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog()"');

    $layout->show();
}

function fPages_Cat_Edit_Submit()
{
    if (!$_SESSION['sbPlugins']->isRightAvailable('pl_pages', 'categs_edit')) {
        sb_show_message(SB_ELEMS_DENY_MSG, true, 'warning');
        return;
    }

    $cat_closed = 0;
    $cat_close_sub = 0;
    extract($_POST);

    if ($cat_fields != '') {
        $fold = $cat_fields['path'];
        $fold = trim(str_replace('\\', '/', preg_replace('/[^0-9a-zA-Z\/\\\\_\-\.\[\]]+/', '', $fold)), '/');

        // запрещаем выход на более высокий уровень (..)
        $fold = preg_replace('/\.\.+/', '', $fold);
        $fold = preg_replace('/\/\/+/', '', $fold);

        $cat_fields['path'] = $fold;
    }

    if ($cat_level <= 1) {
        // изменение названия домена
        $cat_title = strtolower($cat_title);
        $cat_title = str_replace(array('www.', 'http://'), array('', ''), $cat_title);
        $cat_title = preg_replace('/[^0-9a-zA-Z\_\-\.]+/', '', $cat_title);
    }

    if ($_GET['cat_id'] != '') {
        if (!fCategs_Check_Rights($_GET['cat_id'])) {
            sb_show_message(SB_ELEMS_DENY_MSG, true, 'warning');
            return;
        }

        $cat_id = intval($_GET['cat_id']);

        //редактирование
        $res = sql_query('SELECT cat_left, cat_right, cat_fields, cat_closed FROM sb_categs WHERE cat_id=?d', $cat_id);
        if ($res) {
            sql_query('LOCK TABLES sb_categs WRITE, sb_catrights WRITE');
            $result = sql_query('UPDATE sb_categs SET cat_title=?, cat_closed=?d, cat_fields=? WHERE cat_id=?d', $cat_title, $cat_closed,
                serialize($cat_fields), $cat_id, sprintf(PL_PAGES_EDIT_CAT_SYSLOG_EDIT_OK, $cat_title));
            if ($result) {
                list($cat_left, $cat_right, $fields, $closed) = $res[0];

                $cat_ids = array($cat_id);
                if ($cat_close_sub == 1) {
                    $res_sub = sql_query('SELECT cat_id, cat_title FROM sb_categs WHERE cat_left > ?d AND cat_right < ?d AND cat_ident=?', $cat_left,
                        $cat_right, 'pl_pages');
                    if ($res_sub) {
                        foreach ($res_sub as $value) {
                            $cat_ids[] = $value[0];
                            sql_query('UPDATE sb_categs SET cat_closed=?d WHERE cat_id=?d', $cat_closed, $value[0],
                                sprintf(PL_PAGES_EDIT_CAT_SYSLOG_RIGHTS_OK, $value[1]));
                        }
                    }
                }

                sql_query('DELETE FROM sb_catrights WHERE cat_id IN (?a)', $cat_ids);

                if ($cat_closed == 1) {
                    // закрытый раздел
                    $ident = 'pl_pages_read';
                    foreach ($cat_ids as $value) {
                        sql_query('INSERT INTO sb_catrights (cat_id, group_ids, right_ident)
                                     VALUES (?d, ?, ?)', $value, $_POST['group_ids' . $ident], $ident);
                    }
                }
                sql_query('UNLOCK TABLES');

                $count_res = sql_query('SELECT COUNT(*) FROM sb_categs categs, sb_catlinks links WHERE categs.cat_ident=? AND categs.cat_left >= ?d AND categs.cat_right <= ?d AND links.link_cat_id=categs.cat_id',
                    'pl_pages', $cat_left, $cat_right);
                if ($count_res) {
                    $cat_count = $count_res[0][0];
                } else {
                    $cat_count = 0;
                }

                $fields = unserialize($fields);
                if (isset($fields['path'])) {
                    $old_path = $fields['path'];
                } else {
                    $old_path = '';
                }

                if (isset($fields['page'])) {
                    $old_page = $fields['page'];
                } else {
                    $old_page = '';
                }

                $new_page = isset($cat_fields['page']) ? $cat_fields['page'] : '';

                echo '<script>
                    var res = new Object();
                    res.cat_title = "' . str_replace('"', '\\"', $cat_title) . ' [' . $cat_count . ']";
                    res.cat_closed = ' . intval($cat_closed) . ';
                    res.cat_close_sub = ' . intval($cat_close_sub) . ';
                    res.cat_rubrik = ' . intval($cat_rubrik) . ';
                    ' . ($cat_level <= 1 || ($closed == $cat_closed && $old_page == $new_page && ($old_path == $cat_fields['path'] || $cat_count == 0)) ? 'res.not_call = 1;' : '') . '
                    sbReturnValue(res);
                  </script>';

                if ($cat_level > 1 && $old_path != $cat_fields['path']) {
                    // удаляем страницы раздела, если был изменен путь
                    $res = sql_query('SELECT cat_left, cat_right FROM sb_categs WHERE cat_id=?d', $_GET['cat_id']);
                    list($left, $right) = $res[0];
                    $res = sql_query('SELECT cat_title FROM sb_categs WHERE cat_left <= ?d AND cat_right >= ?d AND cat_level=1 AND cat_ident=?', $left, $right,
                        'pl_pages');
                    list($domain) = $res[0];

                    $res = sql_query('SELECT pages.p_id, pages.p_filepath, pages.p_filename FROM sb_pages pages, sb_catlinks links WHERE links.link_cat_id=?d AND pages.p_id=links.link_el_id',
                        $_GET['cat_id']);

                    if ($res) {
                        $old_domain = $GLOBALS['sbVfs']->mDomain;
                        $GLOBALS['sbVfs']->mDomain = $domain;

                        $in_str = '(0';
                        foreach ($res as $value) {
                            list($p_id, $p_filepath, $p_filename) = $value;
                            $in_str .= ',' . $p_id;

                            if ($GLOBALS['sbVfs']->exists($p_filepath . '/' . $p_filename) && $GLOBALS['sbVfs']->is_file($p_filepath . '/' . $p_filename)) {
                                $GLOBALS['sbVfs']->delete($p_filepath . '/' . $p_filename);
                            }

                            if ($GLOBALS['sbVfs']->exists($p_filepath . '/' . $p_filename . '.demo') && $GLOBALS['sbVfs']->is_file($p_filepath . '/' . $p_filename . '.demo')) {
                                $GLOBALS['sbVfs']->delete($p_filepath . '/' . $p_filename . '.demo');
                            }
                        }
                        $in_str .= ')';

                        $GLOBALS['sbVfs']->mDomain = $old_domain;

                        sql_query('UPDATE sb_pages SET p_filepath=? WHERE p_id IN ' . $in_str, $cat_fields['path']);
                    }
                }
            } else {
                sql_query('UNLOCK TABLES');
            }
        } else {
            sb_show_message(PL_PAGES_EDIT_CAT_EDIT_ERROR, true, 'warning');
            sb_add_system_message(sprintf(PL_PAGES_EDIT_CAT_SYSLOG_EDIT_ERROR, $cat_title), SB_MSG_WARNING);
        }
    } else {
        if (!fCategs_Check_Rights($_GET['cat_id_p'])) {
            sb_show_message(SB_ELEMS_DENY_MSG, true, 'warning');
            return;
        }

        //добавление
        require_once(SB_CMS_LIB_PATH . '/sbTree.inc.php');
        $tree = new sbTree('pl_pages');

        $fields = array();
        $fields['cat_title'] = $cat_title;
        $fields['cat_closed'] = $cat_closed;
        $fields['cat_rubrik'] = $cat_rubrik;
        $fields['cat_rights'] = $cat_rights;
        $fields['cat_fields'] = serialize($cat_fields);

        $cat_id = $tree->insertNode($_GET['cat_id_p'], $fields);
        if ($cat_id) {
            if ($cat_closed == 1) {
                // закрытый раздел
                $ident = 'pl_pages_read';
                sql_query('INSERT INTO sb_catrights (cat_id, group_ids, right_ident)
                                        VALUES (?d, ?, ?)', $cat_id, $_POST['group_ids' . $ident], $ident);
            }

            sb_add_system_message(sprintf(PL_PAGES_EDIT_CAT_SYSLOG_ADD_OK, $cat_title));

            echo '<script>
                var res = new Object();
                res.cat_id = ' . $cat_id . ';
                res.cat_title = "' . str_replace('"', '\\"', $cat_title) . ' [0]";
                res.cat_closed = ' . intval($cat_closed) . ';
                res.cat_rubrik = ' . intval($cat_rubrik) . ';
                sbReturnValue(res);
              </script>';
        } else {
            sb_show_message(PL_PAGES_EDIT_CAT_ADD_ERROR, true, 'warning');
            sb_add_system_message(sprintf(PL_PAGES_EDIT_CAT_SYSLOG_ADD_ERROR, $cat_title), SB_MSG_WARNING);
        }
    }
}

function fPages_Gen_Pages()
{
    if (isset($_GET['p_id'])) {
        //    генерация страницы
        if (fPages_Gen_Page(intval($_GET['p_id']))) {
            sb_show_message(PL_PAGES_H_GEN_PAGE_OK, true);
            echo '<br /><br /><a href="javascript:window.close();">[ ' . KERNEL_CLOSE . ' ]</a>';
        } else {
            sb_show_message(PL_PAGES_H_GEN_PAGE_ERROR, true, 'warning');
            echo '<br /><br /><a href="javascript:window.close();">[ ' . KERNEL_CLOSE . ' ]</a>';
        }

        return;
    } elseif (isset($_GET['subcategs']) && $_GET['subcategs'] != '') {
        // генерация всех страниц раздела и подразделов
        $res = sql_query('SELECT cat_left, cat_right FROM sb_categs WHERE cat_id=?d', $_GET['id']);
        if ($res) {
            list($cat_left, $cat_right) = $res[0];
            $res = sql_query('SELECT DISTINCT pages.p_id FROM sb_pages pages, sb_catlinks links, sb_categs categs WHERE categs.cat_ident=? AND categs.cat_left >= ?d AND categs.cat_right <= ?d AND links.link_cat_id=categs.cat_id AND pages.p_id=links.link_el_id',
                'pl_pages', $cat_left, $cat_right);
        }
    } else {
        // генерация страниц раздела
        $res = sql_query('SELECT DISTINCT pages.p_id FROM sb_pages pages, sb_catlinks links WHERE links.link_cat_id=?d AND pages.p_id=links.link_el_id',
            $_GET['id']);
        $_GET['subcategs'] = '';
    }

    if (!$res) {
        $num_res = 0;
    } else {
        $num_res = count($res);
    }

    if (!isset($_GET['num'])) {
        echo '<br /><br />' .
            '<div align="left" style="width: 80%;"><b>' . PL_PAGES_GEN_PAGES_ALL . '</b>: ' . $num_res . '</div><br />' .
            '<div align="left" style="width: 80%;"><b>' . PL_PAGES_GEN_PAGES_CUR . '</b>: <span id="num">0</span></div><br />
          <div style="border: 1px solid black; width: 80%; height: 17px; background-color: red; text-align:center;">
                 <b style="color: #fff;">0%</b>
          </div>
          <script>
              ' . ($_GET['subcategs'] == '' ? 'window.opener.sbElemsRefresh();' : '') . '
              function reloadWnd()
              {
                  window.location = "' . SB_CMS_DIALOG_FILE . '?event=pl_pages_gen_pages&id=' . $_GET['id'] . '&subcategs=' . $_GET['subcategs'] . '&num=0&good_num=0";
              }
              setTimeout("reloadWnd();", 100);
          </script>';
        return;
    }

    $num = intval($_GET['num']);
    $good_num = intval($_GET['good_num']);

    $time_end = ini_get('max_execution_time');
    if ($time_end > 0) {
        $time_end = time() + $time_end - 5;
    } else {
        $time_end = time() + 1000000;
    }

    $start_time = time();

    echo '<br /><br />' .
        '<div align="left" style="width: 80%;"><b>' . PL_PAGES_GEN_PAGES_ALL . '</b>: ' . $num_res . '</div><br />' .
        '<div align="left" style="width: 80%;"><b>' . PL_PAGES_GEN_PAGES_CUR . '</b>: <span id="num">0</span></div><br />
          <div style="border: 1px solid black; width: 80%; height: 17px; background-color: red; text-align:left;">
                 <div id="progress" style="width: 0%; height: 17px; background-color: green;text-align:center;">
                     <b id="percent" style="color: #fff;">0%</b>
                 </div>
             </div><br />
             <div id="close_link" style="display: none;"><a href="javascript:window.close();">[ ' . KERNEL_CLOSE . ' ]</a></div>';

    for ($i = $num; $i < $num_res; $i++) {
        if (time() > $time_end) {
            $percent = round($i / $num_res * 100);
            echo '<script>
                  function reloadWnd()
                     {
                         window.location = "' . SB_CMS_DIALOG_FILE . '?event=pl_pages_gen_pages&id=' . $_GET['id'] . '&num=' . $i . '&good_num=' . $good_num . '";
                     }

                     sbGetE("progress").style.width = "' . $percent . '%";
                  sbGetE("percent").innerHTML = "' . $percent . '%";
                  sbGetE("num").innerHTML = "' . $good_num . '";
                     setTimeout("reloadWnd();", 100);
              </script>';

            return;
        }

        if ($start_time - time() > 5) {
            header('SBuilder_Ping: Pong;', true);
        }

        if (fPages_Gen_Page($res[$i][0])) {
            $good_num++;
        }
    }

    if ($good_num != $num_res) {
        sb_show_message(PL_PAGES_GEN_PAGES_ERROR, false, 'warning');
        echo '<script>
            sbGetE("progress").style.width = "100%";
            sbGetE("progress").style.backgroundColor = "' . ($good_num != $num_res ? '#FF6600' : 'green') . '";
            sbGetE("percent").innerHTML = "100%";
            sbGetE("num").innerHTML = "' . $good_num . '";
            sbGetE("close_link").style.display = "";
        </script>';
    } else {
        echo '<script>
            sbGetE("progress").style.width = "100%";
            sbGetE("progress").style.backgroundColor = "' . ($good_num != $num_res ? '#FF6600' : 'green') . '";
            sbGetE("percent").innerHTML = "100%";
            sbGetE("num").innerHTML = "' . $good_num . '";
            setTimeout("window.close();", 500);
        </script>';
    }
}

function fPages_Check_Filename()
{
    //    запрещаем выход на более высокий уровень (..)
    $filepath = trim(str_replace('\\', '/', preg_replace('/[^0-9a-zA-Z\/\\\\_\-\.\[\]]+/', '', $_GET['filepath'])), '/');
    $filepath = preg_replace('/\.\.+/', '', $filepath);
    $filepath = preg_replace('/\/\/+/', '', $filepath);

    $filename = preg_replace('/[^0-9a-zA-Z_\-\.\[\]]+/', '', $_GET['filename']);
    $filename = preg_replace('/\.\.+/', '', $filename);
    $filename = preg_replace('/\/\/+/', '', $filename);

    $pos = strpos($filename, '.');
    if ($pos === false) {
        $filename .= '.php';
    } elseif (($pos + 1) == strlen($filename)) {
        $filename .= 'php';
    }

    // определяем домен
    $res = sql_query('SELECT cat_left, cat_right FROM sb_categs WHERE cat_id=?d', $_GET['cat_id']);
    list($left, $right) = $res[0];
    $res = sql_query('SELECT cat_title FROM sb_categs WHERE cat_left <= ?d AND cat_right >= ?d AND cat_level=1 AND cat_ident=?', $left, $right, 'pl_pages');
    list($domain) = $res[0];

    $res = sql_query('SELECT categs.cat_left, categs.cat_right FROM sb_pages pages, sb_categs categs, sb_catlinks links WHERE pages.p_filename=? AND pages.p_filepath=? AND pages.p_id != ?d AND links.link_el_id=pages.p_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident=?',
        $filename, $filepath, $_GET['id'], 'pl_pages');
    if ($res) {
        foreach ($res as $value) {
            list($left, $right) = $value;
            $res_cat = sql_query('SELECT cat_title FROM sb_categs WHERE cat_left <= ?d AND cat_right >= ?d AND cat_level=1 AND cat_ident=?', $left, $right,
                'pl_pages');
            list($cat_domain) = $res_cat[0];
            if ($cat_domain == $domain) {
                echo 'FALSE';
                return;
            }
        }
    }
}

function fPages_Edit($htmlStr = '', $footerStr = '', $footerLinkStr = '')
{
    //    проверка прав доступа
    if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'], 'pl_pages')) {
        return;
    }

    $edit_rights = $_SESSION['sbPlugins']->isRightAvailable('pl_pages', 'elems_edit');

    //    определяем группавое редактирование или нет.
    $edit_group = sbIsGroupEdit();

    #TODO: При изменении имени файла изменять ссылки на страницу в меню и таблице sb_elems
    require_once(SB_CMS_LIB_PATH . '/sbLayout.inc.php');

    $layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE . '?event=pl_pages_edit_submit' . ($_SERVER['QUERY_STRING'] != '' ? '&' . $_SERVER['QUERY_STRING'] : '') . (isset($_GET['real_event']) ? '&real_event=' . $_GET['real_event'] : ''),
        'thisDialog', 'post', 'checkValues()');

    $layout->mTableWidth = '95%';
    $layout->mTitleWidth = '200';

    $layout->addTab(PL_PAGES_EDIT_TAB1);
    $layout->addHeader(PL_PAGES_EDIT_TAB1);

    $res = sql_query('SELECT cat_fields FROM sb_categs WHERE cat_id=?d', $_GET['cat_id']);
    if ($res) {
        if (!is_null($res[0][0]) && $res[0][0] != '') {
            $cat_fields = unserialize($res[0][0]);
        } else {
            $cat_fields = array();
        }
    } else {
        sb_show_message(PL_PAGES_EDIT_CAT_ERROR, true, 'warning');
        return;
    }

    if (count($_POST) == 0 && isset($_GET['id']) && $_GET['id'] != '' && !$edit_group) {
        $result = sql_query('SELECT p_name, p_filename, p_state, p_temp_id, p_xslt, p_title, p_keywords, p_description, p_meta, p_default, p_ctype, p_nocache
                                      FROM sb_pages WHERE p_id=?d', $_GET['id']);

        if ($result) {
            list($p_name, $p_filename, $p_state, $p_temp_id, $p_xslt, $p_title, $p_keywords, $p_description, $p_meta, $p_default, $p_ctype, $p_nocache) = $result[0];
        } else {
            sb_show_message(PL_PAGES_EDIT_ERROR, true, 'warning');
            return;
        }
    } elseif (count($_POST) > 0) {
        $p_default = 0;
        $p_nocache = 0;

        extract($_POST);

        if (!isset($_GET['id'])) {
            $_GET['id'] = '';
        }
    } else {
        $p_name = $p_title = $p_xslt = $p_keywords = $p_description = $p_meta = '';
        $p_filename = 'page_' . str_replace('.', '_', microtime(true)) . '.php';

        $p_state = 1;
        $p_temp_id = isset($cat_fields['temp_id']) ? $cat_fields['temp_id'] : -1;

        $p_ctype = '';
        $p_default = 0;
        $p_nocache = 0;

        $_GET['id'] = '';
    }

    if (!$edit_group) {
        $pos = strrpos($p_filename, '/');

        if ($pos !== false) {
            $p_filename = substr($p_filename, $pos + 1);
        }

        $p_filepath = isset($cat_fields['path']) && $cat_fields['path'] != '' ? '/' . $cat_fields['path'] . '/' : '/';
    }

    echo '<script src="' . SB_CMS_JSCRIPT_URL . '/sbTemplates.js.php"></script>
        <script>
            var num_tags = 0;
            var old_temp = ' . $p_temp_id . ';

            function checkValues()
            {
                ' . ($edit_group ? '
                var ch_n = sbGetE("ch_p_name");
                ' : '') . '

                var el_name = sbGetE("p_name");
                if (el_name.value == "" ' . ($edit_group ? ' && ch_n.checked ' : '') . ')
                {
                      alert("' . PL_PAGES_EDIT_NO_TITLE_MSG . '");
                      return false;
                }

                ' . (!$edit_group ? '

                var el_temp = sbGetE("p_temp_id");
                if (!el_temp)
                {
                    alert("' . PL_PAGES_EDIT_NO_TEMP_MSG . '");
                      return false;
                }

                var el_filename = sbGetE("p_filename");
                if (el_filename.value == "")
                {
                    alert("' . PL_PAGES_EDIT_NO_FILE_MSG . '");
                    return false;
                }

                var myReg = /[^\w-\.]+/;
                if (myReg.test(el_filename.value))
                {
                    alert("' . PL_PAGES_EDIT_WRONG_FILENAME_MSG . '");
                    return false;
                }

                myReg = /[\.]+/;
                if (!myReg.test(el_filename.value))
                {
                    el_filename.value = el_filename.value + ".php";
                }

                if (el_filename.value.charAt(el_filename.value.length - 1) == ".")
                {
                    el_filename.value = el_filename.value + "php";
                }

                var el_filepath = sbGetE("p_filepath");
                var res = sbLoadSync("' . SB_CMS_EMPTY_FILE . '?event=pl_pages_check_filename&id=' . $_GET['id'] . '&cat_id=' . $_GET['cat_id'] . '&filename=" + el_filename.value + "&filepath=" + el_filepath.value);
                if (res == "FALSE")
                {
                    alert("' . PL_PAGES_EDIT_SAME_FILENAME_MSG . '");
                    return false;
                }

                if (num_tags > 0 && el_temp.value == old_temp)
                {
                    for (var i = 0; i < num_tags; i++)
                    {
                        var e_params = sbGetE("e_params" + i);
                        var e_ident = sbGetE("e_ident" + i);

                        if (e_ident.value != "" && typeof(sb_pl_elems[e_ident.value]) != "undefined" && e_params.value == "")
                        {
                            alert("' . PL_PAGES_EDIT_NO_PARAMS_MSG . '");
                            return false;
                        }
                    }

                    for (var i = 0; i < num_tags; i++)
                    {
                        var e_search = sbGetE("e_search" + i);
                        var e_edit = sbGetE("e_edit" + i);
                        var e_yandex = sbGetE("e_yandex" + i);

                        if (e_search) e_search.disabled = false;
                        if (e_edit) e_edit.disabled = false;
                        if (e_yandex) e_yandex.disabled = false;
                    }
                }' : '') . '

            }
            var was_changed = false;
            function onChangeTemplate(el)
            {
                if (el.value != old_temp)
                    was_changed = true;
                else
                    was_changed = false;
            }
            function sbTabCheck(tab)
            {
                if (tab == 3 && was_changed)
                {
                    alert("' . PL_PAGES_EDIT_HIDE_ELEMS_MSG . '");
                    return false;
                }

                return true;
            }';


    if ($htmlStr != '') {
        if ($edit_group) {
            echo '
                function cancel()
                {
                    sbReturnValue("refresh");
                }';
        } elseif ($footerStr == '') {
            echo '
                function cancel()
                {
                    sbReturnValue(' . intval($_GET['id']) . ');
                }';
        } else {
            echo '
                function cancel()
                {
                    var res = new Object();
                    res.html = "' . $htmlStr . '";
                    res.footer = "' . $footerStr . '";
                    res.footer_link = "' . $footerLinkStr . '";
                    sbReturnValue(res);
                }';
        }

        echo 'sbAddEvent(window, "close", cancel);';
    } elseif ($edit_group) {
        echo '
            function cancel()
            {
                sbReturnValue("refresh");
            }
            sbAddEvent(window, "close", cancel);';
    }
    echo '</script>';

    $fld = new sbLayoutInput('text', $p_name, 'p_name', '', 'style="width:500px;"', true);

    $layout->addField(PL_PAGES_EDIT_TITLE . sbGetGroupEditCheckbox('p_name', $edit_group), $fld);
    $layout->addField('', new sbLayoutDelim());

    if (!$edit_group) {
        $layout->addField(PL_PAGES_EDIT_FILEPATH, new sbLayoutLabel($p_filepath));
        $layout->addField('', new sbLayoutInput('hidden', $p_filepath, 'p_filepath'));
        $layout->addField(PL_PAGES_EDIT_FILENAME, new sbLayoutInput('text', $p_filename, 'p_filename', '', 'style="width:500px;"', true));

        $layout->addField('', new sbLayoutDelim());
    }

    $res_temp = sql_query('SELECT categs.cat_title, temps.t_id, temps.t_name FROM sb_categs categs, sb_catlinks links, sb_templates temps WHERE temps.t_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident=? ORDER BY categs.cat_left, temps.t_name',
        'pl_templates');
    if ($res_temp) {
        $options = array();
        $old_cat_title = '';
        foreach ($res_temp as $value) {
            list($cat_title, $t_id, $t_name) = $value;
            if ($old_cat_title != $cat_title) {
                $options[uniqid()] = '-' . $cat_title;
                $old_cat_title = $cat_title;
            }
            $options[$t_id] = $t_name;
        }

        $fld = new sbLayoutSelect($options, 'p_temp_id', '', (!$edit_group ? 'onchange="onChangeTemplate(this);" onkeyup="onChangeTemplate(this);"' : ''));
        $fld->mSelOptions = array($p_temp_id);
        $layout->addField(PL_PAGES_EDIT_TEMP . sbGetGroupEditCheckbox('p_temp_id', $edit_group), $fld);
    } else {
        $layout->addField(PL_PAGES_EDIT_TEMP, new sbLayoutLabel('<div class="hint_div">' . PL_PAGES_EDIT_NO_TEMPS_LABEL . '</div>', '', '', false));
    }

    if ($_SESSION['sbPlugins']->isPluginAvailable('pl_workflow') && $_SESSION['sbPlugins']->isPluginInWorkflow('pl_pages')) {
        if (!$edit_group) {
            $edit_rights = $edit_rights && sb_add_workflow_status($layout, 'pl_pages', $_GET['id'], 'p_state', $p_state);
        } else {
            $states_arr = array();
            $states = sql_query('SELECT p_state FROM sb_pages WHERE p_id IN (?a)', $_GET['ids']);
            if ($states) {
                foreach ($states as $val) {
                    $states_arr[] = $val[0];
                }
            }
            $edit_rights = $edit_rights && sb_add_workflow_status($layout, 'pl_pages', $_GET['ids'], 'p_state', $states_arr);
        }
    } else {
        if ($_SESSION['sbPlugins']->isRightAvailable('pl_pages', 'elems_public')) {
            $layout->addField('', new sbLayoutDelim());

            $options = array('0' => PL_PAGES_H_GET_STATE_NOT_PUBLISHED, '1' => PL_PAGES_H_GET_STATE_PUBLISHED);
            $fld = new sbLayoutSelect($options, 'p_state');
            $fld->mSelOptions = array($p_state);
            $layout->addField(PL_PAGES_EDIT_STATUS . sbGetGroupEditCheckbox('p_state', $edit_group), $fld);
        } else {
            if (!$edit_group) {
                if ($p_state == 1) {
                    $layout->addField('', new sbLayoutInput('hidden', $_GET['id'] != '' ? 1 : 0, 'p_state'));
                } else {
                    $layout->addField('', new sbLayoutInput('hidden', $p_state, 'p_state'));
                }
            }
        }
   }
    $userCatId = $_SESSION['sbAuth']->getUserCat();
    $edit_seo_rights = checkSeoOption($userCatId);

    $layout->addTab(PL_PAGES_EDIT_TAB2);
    $layout->addHeader(PL_PAGES_EDIT_TAB2);

    $fld = new sbLayoutTextarea($p_title, 'p_title', '', 'style="width: 100%;height: 50px;"');
    $layout->addField(PL_PAGES_EDIT_META_TITLE . sbGetGroupEditCheckbox('p_title', $edit_group), $fld);

    $fld = new sbLayoutTextarea($p_keywords, 'p_keywords', '', 'style="width: 100%;height: 50px;"');
    $layout->addField(PL_PAGES_EDIT_META_KEYWORDS . sbGetGroupEditCheckbox('p_keywords', $edit_group), $fld);

    $fld = new sbLayoutTextarea($p_description, 'p_description', '', 'style="width: 100%;height: 50px;"');
    $layout->addField(PL_PAGES_EDIT_META_DESCRIPTION . sbGetGroupEditCheckbox('p_description', $edit_group), $fld);

    $layout->addField('', new sbLayoutDelim());

    $fld = new sbLayoutTextarea($p_meta, 'p_meta', '', 'style="width: 100%;height: 150px;"');
    $layout->addField(PL_PAGES_EDIT_META . sbGetGroupEditCheckbox('p_meta', $edit_group), $fld);

       (!$edit_seo_rights) ? $layout->addTab(PL_PAGES_EDIT_TAB4): $layout->addTab(PL_PAGES_EDIT_TAB4, false);

        $layout->addHeader(PL_PAGES_EDIT_TAB4);

        if (!$edit_group) {
            $layout->addField(PL_PAGES_EDIT_DEFAULT, new sbLayoutInput('checkbox', '1', 'p_default', '', ($p_default == 1 ? 'checked="checked" ' : '')));
        }

        $layout->addField(PL_PAGES_EDIT_NOCACHE . sbGetGroupEditCheckbox('p_nocache', $edit_group),
            new sbLayoutInput('checkbox', '1', 'p_nocache', '', ($p_nocache == 1 ? 'checked="checked" ' : '')));

        $layout->addField('', new sbLayoutDelim());

        $fld = new sbLayoutFile($p_xslt, 'p_xslt', '', 'style="width:475px;"');
        $fld->mHTML .= '<div class="hint_div">' . PL_PAGES_EDIT_XSLT_LABEL . '</div>';
        $layout->addField(PL_PAGES_EDIT_XSLT . sbGetGroupEditCheckbox('p_xslt', $edit_group), $fld);

        $layout->addField('', new sbLayoutDelim());

        $fld = new sbLayoutInput('text', $p_ctype, 'p_ctype', '', 'style="width:500px;"');
        $layout->addField(PL_PAGES_EDIT_CONTENT_TYPE . sbGetGroupEditCheckbox('p_ctype', $edit_group), $fld);

        if (isset($_GET['id']) && $_GET['id'] != '' && !$edit_group) {
            (!$edit_seo_rights) ? $layout->addTab(PL_PAGES_EDIT_TAB3): $layout->addTab(PL_PAGES_EDIT_TAB3, false);

            $elems = $_SESSION['sbPlugins']->getElems();
            if (0 == count($elems)) {
                //    зарегистрированных элементов нет
                $layout->addHeader(PL_PAGES_EDIT_TAB3);
                $layout->addField('', new sbLayoutHTML(sb_show_message(PL_PAGES_EDIT_NO_ELEMS_MSG, true, 'information', true), true));
            } else {
                $res = sql_query('SELECT t_html FROM sb_templates WHERE t_id=?d', $p_temp_id);
                if ($res) {
                    $t_html = $res[0][0];
                } else {
                    $t_html = '';
                }

                $tags = array();
                preg_match_all('/\{[_A-Z0-9' . $GLOBALS['sb_reg_upper_interval'] . ']+\}/' . SB_PREG_MOD, $t_html, $tags);

                if (count($tags[0]) == 0) {
                    //    тегов нет
                    $layout->addHeader(PL_PAGES_EDIT_TAB3);
                    $layout->addField('', new sbLayoutHTML(sb_show_message(PL_PAGES_EDIT_NO_TAGS_MSG, true, 'information', true), true));
                } else {
                    echo '<script>
                      sbElemsIdent = "page";';

                    $js_str = '';
                    $link_tags = array();

                    $result = sql_query('SELECT e_id, e_tag, e_ident, e_temp_id, e_el_id, e_params, e_search, e_edit, e_yandex FROM sb_elems
                                                 WHERE e_p_id=?d AND e_link=? AND e_tag IN (?a)', $p_temp_id, 'temp', $tags[0]);

                    if ($result) {
                        foreach ($result as $value) {
                            list($te_id, $te_tag, $te_ident, $te_temp_id, $te_el_id, $te_params, $te_search, $te_edit, $te_yandex) = $value;

                            if (isset($elems[$te_ident]) || $te_ident == '') {
                                $link_tags[$te_tag] = array();
                                $link_tags[$te_tag]['e_ident'] = $te_ident;
                                $link_tags[$te_tag]['e_id'] = $te_id;
                                $link_tags[$te_tag]['e_temp_id'] = $te_temp_id;
                                $link_tags[$te_tag]['e_el_id'] = $te_el_id;
                                $link_tags[$te_tag]['e_params'] = $te_params;
                                $link_tags[$te_tag]['e_search'] = $te_search;
                                $link_tags[$te_tag]['e_edit'] = $te_edit;
                                $link_tags[$te_tag]['e_yandex'] = $te_yandex;
                                $link_tags[$te_tag]['e_link'] = 'temp';

                                $params = str_replace('\\\\"', '\\\\\\"', str_replace('"', '\\"', $te_params));

                                $js_str .= 'sb_pl_temp_elems["' . $te_tag . '"] = new Array();
                                          sb_pl_temp_elems["' . $te_tag . '"]["e_id"] = "' . $te_id . '";
                                          sb_pl_temp_elems["' . $te_tag . '"]["e_ident"] = "' . $te_ident . '";
                                          sb_pl_temp_elems["' . $te_tag . '"]["e_temp_id"] = "' . $te_temp_id . '";
                                          sb_pl_temp_elems["' . $te_tag . '"]["e_el_id"] = "' . $te_el_id . '";
                                          sb_pl_temp_elems["' . $te_tag . '"]["e_search"] = "' . $te_search . '";
                                          sb_pl_temp_elems["' . $te_tag . '"]["e_edit"] = "' . $te_edit . '";
                                          sb_pl_temp_elems["' . $te_tag . '"]["e_yandex"] = "' . $te_yandex . '";
                                          sb_pl_temp_elems["' . $te_tag . '"]["e_params"] = "' . $params . '";
                                          sb_pl_temp_elems["' . $te_tag . '"]["e_info"] = "event:pl_templates_load_info&e_id=' . $te_id . '";';
                            }
                        }
                    }

                    if (count($_POST) > 0 && isset($e_tag) && is_array($e_tag)) {
                        foreach ($e_tag as $key => $value) {
                            if ($e_ident[$key] == '') {
                                continue;
                            }

                            $pe_search = isset($e_search[$key]) ? $e_search[$key] : 'none';
                            $pe_edit = isset($e_edit[$key]) ? $e_edit[$key] : '0';
                            $pe_yandex = isset($e_yandex[$key]) ? $e_yandex[$key] : '0';

                            $link_tags[$value] = array();
                            $link_tags[$value]['e_ident'] = $e_ident[$key];
                            $link_tags[$value]['e_id'] = $e_id[$key];
                            $link_tags[$value]['e_temp_id'] = $e_temp_id[$key];
                            $link_tags[$value]['e_el_id'] = $e_el_id[$key];
                            $link_tags[$value]['e_params'] = $e_params[$key];
                            $link_tags[$value]['e_search'] = $pe_search;
                            $link_tags[$value]['e_edit'] = $pe_edit;
                            $link_tags[$value]['e_yandex'] = $pe_yandex;
                            $link_tags[$value]['e_link'] = $e_link[$key];
                        }
                    } else {
                        $result = sql_query('SELECT e_id, e_tag, e_ident, e_temp_id, e_el_id, e_params, e_search, e_edit, e_yandex FROM sb_elems
                                                 WHERE e_p_id=?d AND e_link=? AND e_tag IN (?a)', $_GET['id'], 'page', $tags[0]);

                        if ($result) {
                            foreach ($result as $value) {
                                list($e_id, $e_tag, $e_ident, $e_temp_id, $e_el_id, $e_params, $e_search, $e_edit, $e_yandex) = $value;

                                if (isset($elems[$e_ident]) || $e_ident == '') {
                                    $link_tags[$e_tag] = array();
                                    $link_tags[$e_tag]['e_ident'] = $e_ident;
                                    $link_tags[$e_tag]['e_id'] = $e_id;
                                    $link_tags[$e_tag]['e_temp_id'] = $e_temp_id;
                                    $link_tags[$e_tag]['e_el_id'] = $e_el_id;
                                    $link_tags[$e_tag]['e_params'] = $e_params;
                                    $link_tags[$e_tag]['e_search'] = $e_search;
                                    $link_tags[$e_tag]['e_edit'] = $e_edit;
                                    $link_tags[$e_tag]['e_yandex'] = $e_yandex;
                                    $link_tags[$e_tag]['e_link'] = 'page';
                                }
                            }
                        }
                    }

                    $options_str = '<option value="" style="color: red;">' . KERNEL_ELEM_NOT_CHOOSED_PAGES . '</option>';
                    $cur_group = '';
                    foreach ($elems as $ident => $value) {
                        $tmp = explode('|', $value['name']);
                        $e_group = $tmp[0];
                        $value['name'] = $tmp[1];

                        if ($e_group != $cur_group) {
                            if ($cur_group != '') {
                                $options_str .= '</optgroup>';
                            }
                            $options_str .= '<optgroup label="' . $e_group . '">';

                            $cur_group = $e_group;
                        }

                        $options_str .= '<option value="' . $ident . '">' . $value['name'] . '</option>';

                        if ($value['get_event'] != '') {
                            $js_str .= 'sb_pl_elems["' . $ident . '"] = new Array();
                                     sb_pl_elems["' . $ident . '"]["event"] = "' . $value['get_event'] . '";
                                     sb_pl_elems["' . $ident . '"]["width"] = "' . $value['dlg_width'] . '";
                                     sb_pl_elems["' . $ident . '"]["height"] = "' . $value['dlg_height'] . '";';
                        }
                    }

                    if ($cur_group != '') {
                        $options_str .= '</optgroup>';
                    }

                    $i = 0;
                    $table = array();
                    $search_options = array(
                        'none' => KERNEL_ELEM_TAGS_SEARCH_0,
                        '' => '-' . KERNEL_ELEM_TAGS_SEARCH_INDEX,
                        'all' => KERNEL_ELEM_TAGS_SEARCH_1,
                        'links' => KERNEL_ELEM_TAGS_SEARCH_2,
                        'text' => KERNEL_ELEM_TAGS_SEARCH_3
                    );

                    foreach ($tags[0] as $value) {
                        if ($value == '{SB_CSS_VERSION}' || $value == '{SB_JS_VERSION}') {
                            continue;
                        }

                        if (isset($link_tags[$value])) {
                            $e_id = $link_tags[$value]['e_id'];
                            $e_ident = $link_tags[$value]['e_ident'];
                            $e_temp_id = $link_tags[$value]['e_temp_id'];
                            $e_el_id = $link_tags[$value]['e_el_id'];
                            $e_params = $link_tags[$value]['e_params'];
                            $e_search = $link_tags[$value]['e_search'];
                            $e_edit = $link_tags[$value]['e_edit'];
                            $e_yandex = $link_tags[$value]['e_yandex'];
                            $e_link = $link_tags[$value]['e_link'];

                            $params = str_replace('"', '\\"', $e_params);
                            $params = str_replace('\\\\"', '\\\\\\"', $params);

                            $js_str .= 'sb_pl_old_elems["' . $value . '"] = new Array();
                                      sb_pl_old_elems["' . $value . '"]["e_id"] = "' . $e_id . '";
                                      sb_pl_old_elems["' . $value . '"]["e_ident"] = "' . $e_ident . '";
                                      sb_pl_old_elems["' . $value . '"]["e_temp_id"] = "' . $e_temp_id . '";
                                      sb_pl_old_elems["' . $value . '"]["e_el_id"] = "' . $e_el_id . '";
                                      sb_pl_old_elems["' . $value . '"]["e_params"] = "' . $params . '";
                                      sb_pl_old_elems["' . $value . '"]["e_info"] = "event:pl_tamplates_load_info&e_id=' . $e_id . '";
                                      sb_pl_old_elems["' . $value . '"]["e_link"] = "' . $e_link . '";';

                            $e_params = sb_htmlspecialchars($e_params, ENT_QUOTES);
                        } else {
                            $e_id = -1;
                            $e_ident = '';
                            $e_temp_id = -1;
                            $e_el_id = -1;
                            $e_params = '';
                            $e_search = 'none';
                            $e_edit = 1;
                            $e_yandex = 0;
                            $e_link = 'page';
                        }

                        $tag = str_replace('_', ' ', trim($value, '{}'));

                        if ($e_link == 'page' && $e_ident != '') {
                            if (isset($elems[$e_ident]) && $elems[$e_ident]['get_event'] != '' && $e_params == '') {
                                $tag = '<b id="e_tag_td' . $i . '" style="color:#990033; font-size: 12px;">' . $tag . '</b>';
                            } else {
                                $tag = '<b id="e_tag_td' . $i . '" style="font-size: 12px;">' . $tag . '</b>';
                            }
                        } elseif ($e_ident != '' || ($e_link == 'temp' && $e_ident == '' && ($e_search != 'none' || $e_edit != 1 || $e_yandex != 0))) {
                            $tag = '<b id="e_tag_td' . $i . '" style="color:#008000; font-size:12px;">' . $tag . '</b>';
                        } else {
                            $tag = '<b id="e_tag_td' . $i . '" style="color: #999;font-size: 12px;">' . $tag . '</b>';
                        }

                        $str = '<select id="e_ident' . $i . '" name="e_ident[' . $i . ']" onchange="changeIdent(' . $i . ', this)" onkeyup="changeIdent(' . $i . ', this)" style="font-size: 13px;">
                    ' . ($e_ident != '' ? sb_str_replace('"' . $e_ident . '"', '"' . $e_ident . '" selected="selected" style="background-color: #E2E2E2;"',
                                $options_str) : $options_str) . '</select>
                     <input type="hidden" id="e_id' . $i . '" name="e_id[' . $i . ']" value="' . $e_id . '">
                     <input type="hidden" id="e_el_id' . $i . '" name="e_el_id[' . $i . ']" value="' . $e_el_id . '">
                     <input type="hidden" id="e_temp_id' . $i . '" name="e_temp_id[' . $i . ']" value="' . $e_temp_id . '">
                     <input type="hidden" id="e_params' . $i . '" name="e_params[' . $i . ']" value="' . $e_params . '">
                     <input type="hidden" id="e_tag' . $i . '" name="e_tag[' . $i . ']" value="' . $value . '">
                     <input type="hidden" id="e_link' . $i . '" name="e_link[' . $i . ']" value="' . $e_link . '">';

                        if ($e_params != '') {
                            $info = '<img info="event:pl_templates_load_info&e_id=' . $e_id . '" src="' . SB_CMS_IMG_URL . '/info.png" id="e_info' . $i . '" style="cursor:help;" width="20" height="20" />';
                        } else {
                            $info = '<img info="" src="' . SB_CMS_IMG_URL . '/info.png" id="e_info' . $i . '" style="display:none;cursor:help;" width="20" height="20" />';
                        }

                        $btn = '<img src="' . SB_CMS_IMG_URL . '/btn_props.png" width="20" height="20" id="e_btn' . $i . '" onclick="browseEl(' . $i . ');" title="' . KERNEL_SETTINGS . '" style="cursor:hand;cursor:pointer;' . ('' == $e_ident || '' == $elems[$e_ident]['get_event'] ? 'display:none;' : '') . '" />';
                        $edit = '<input type="checkbox" name="e_edit[' . $i . ']" id="e_edit' . $i . '" value="1"' . ($e_edit == 1 ? ' checked="checked"' : '') . ($e_ident == '' ? ' disabled="disabled"' : '') . ' onclick="changeEl(\'' . $i . '\')" />';
                        $yandex = '<input type="checkbox" name="e_yandex[' . $i . ']" id="e_yandex' . $i . '" value="1"' . ($e_yandex == 1 ? ' checked="checked"' : '') . ($e_ident == '' ? ' disabled="disabled"' : '') . ' onclick="changeEl(\'' . $i . '\')" />';

                        if ($_SESSION['sbPlugins']->isPluginAvailable('pl_search')) {
                            $fld = new sbLayoutSelect($search_options, 'e_search[' . $i . ']', 'e_search' . $i,
                                'style="font-size: 13px;" onchange="changeEl(\'' . $i . '\')" onkeyup="changeEl(\'' . $i . '\')"' . ($e_ident == '' ? ' disabled="disabled"' : ''));
                            $fld->mSelOptions[] = $e_search;

                            $table[] = array($tag, $str, $fld->getField(), $edit, $yandex, $info, $btn);
                        } else {
                            $table[] = array($tag, $str, $edit, $yandex, $info, $btn);
                        }

                        $i++;
                    }

                    if ($_SESSION['sbPlugins']->isPluginAvailable('pl_search')) {
                        $label = array(KERNEL_ELEM_TAG, KERNEL_ELEM_TYPE, KERNEL_ELEM_SEARCH, KERNEL_ELEM_EDIT, KERNEL_ELEM_YANDEX, '', '');
                        $align = array('left', 'left', 'center', 'center', 'center', 'center', 'center');
                        $width = array('200', '', '1', '100', '100', '26', '26');
                    } else {
                        $label = array(KERNEL_ELEM_TAG, KERNEL_ELEM_TYPE, KERNEL_ELEM_EDIT, KERNEL_ELEM_YANDEX, '', '');
                        $align = array('left', 'left', 'center', 'center', 'center', 'center');
                        $width = array('200', '', '100', '100', '26', '26');
                    }

                    $fld = new sbLayoutTable($label, $table);
                    $fld->mAlign = $align;
                    $fld->mWidth = $width;

                    $layout->addField('', $fld);
                    $layout->mShowInfo = true;

                    echo $js_str . 'num_tags = ' . $i . ';</script>';
                }
            }
        }

    $layout->addButton('submit', KERNEL_SAVE, 'btn_save', '', ($edit_rights && $res_temp ? '' : 'disabled="disabled"'));
    if (!$edit_group) {
        $layout->addButton('submit', KERNEL_APPLY, 'btn_apply', '', ($edit_rights && $res_temp ? '' : 'disabled="disabled"'));
    }

    $layout->addButton('button', KERNEL_CANCEL, '', '', $htmlStr != '' || $edit_group ? 'onclick="cancel()"' : 'onclick="sbCloseDialog()"');
    $layout->show();
}

function fPages_Edit_Submit()
{
    $edit_group = sbIsGroupEdit();

    if (!$edit_group) {
        if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'], 'pl_pages')) {
            return;
        }
    } else {
        if (!fCategs_Check_Elems_Rights($_GET['ids'][0], $_GET['cat_id'], 'pl_pages')) {
            return;
        }
    }

    if (!isset($_GET['id'])) {
        $_GET['id'] = '';
    }

    $p_state = $p_default = $p_nocache = $ch_p_nocache = $ch_p_name = $ch_p_temp_id = $ch_p_state = $ch_p_title = $ch_p_keywords = $ch_p_description = $ch_p_meta = $ch_p_xslt = $ch_p_ctype = 0;
    extract($_POST);

    if ($p_name == '' && !$edit_group) {
        sb_show_message(PL_PAGES_EDIT_NO_TITLE_MSG, false, 'warning');
        fPages_Edit();
        return;
    }

    $row = array();

    if (!$edit_group) {
        //    запрещаем выход на более высокий уровень (..)
        $p_filepath = trim(str_replace('\\', '/', preg_replace('/[^0-9a-zA-Z\/\\\\_\-\.\[\]]+/', '', $p_filepath)), '/');
        $p_filepath = preg_replace('/\.\.+/', '', $p_filepath);
        $p_filepath = preg_replace('/\/\/+/', '', $p_filepath);

        $p_filename = preg_replace('/[^0-9a-zA-Z_\-\.\[\]]+/', '', $p_filename);
        $p_filename = preg_replace('/\.\.+/', '', $p_filename);
        $p_filename = preg_replace('/\/+/', '', $p_filename);

        $pos = strpos($p_filename, '.');
        if ($pos === false) {
            $p_filename .= '.php';
        } elseif (($pos + 1) == strlen($p_filename)) {
            $p_filename .= 'php';
        }

        $res = sql_query('SELECT t_html FROM sb_templates WHERE t_id=?d', $p_temp_id);
        if ($res) {
            list($t_html) = $res[0];
        } else {
            sb_show_message(PL_PAGES_EDIT_NO_TEMP_MSG, false, 'warning');

            fPages_Edit();
            return;
        }

        //проверка существования одноименной директории
        $pathinfo = pathinfo($p_filename);

        if ($pathinfo['filename'] != '') {
            $test_dir_name = $p_filepath . '/' . $pathinfo['filename'];
            $test_dir_name = sb_str_replace('//', '/', $test_dir_name);

            if ($GLOBALS['sbVfs']->is_dir($test_dir_name)) {
                sb_show_message(PL_PAGES_EDIT_DIR_EXISTS, false, 'warning');
                fPages_Edit();
                return;
            }
        }

        $row['p_filepath'] = $p_filepath;
        $row['p_filename'] = $p_filename;
        $row['p_default'] = $p_default;
    }

    if (!$edit_group || $edit_group && $ch_p_name == 1) {
        $row['p_name'] = strip_tags($p_name);
    }
    if (!$edit_group) {
        sb_submit_workflow_status($row, 'p_state', '', '');
    } elseif ($edit_group && $ch_p_state == 1) {
        sb_submit_workflow_status($row, 'p_state', '', '', true);
    }
    if (!$edit_group || $edit_group && $ch_p_temp_id == 1) {
        $row['p_temp_id'] = $p_temp_id;
    }
    if (!$edit_group || $edit_group && $ch_p_xslt == 1) {
        $row['p_xslt'] = $p_xslt;
    }
    if (!$edit_group || $edit_group && $ch_p_ctype == 1) {
        $row['p_ctype'] = $p_ctype;
    }
    if (!$edit_group || $edit_group && $ch_p_title == 1) {
        $row['p_title'] = $p_title;
    }
    if (!$edit_group || $edit_group && $ch_p_keywords == 1) {
        $row['p_keywords'] = $p_keywords;
    }
    if (!$edit_group || $edit_group && $ch_p_description == 1) {
        $row['p_description'] = $p_description;
    }
    if (!$edit_group || $edit_group && $ch_p_meta == 1) {
        $row['p_meta'] = $p_meta;
    }
    if (!$edit_group || $edit_group && $ch_p_nocache == 1) {
        $row['p_nocache'] = $p_nocache;
    }

    if (!$edit_group) {
        $old_default = 0;
        if ($_GET['id'] != '') {
            $res = sql_query('SELECT p_name, p_filename, p_temp_id, p_default FROM sb_pages WHERE p_id=?d', $_GET['id']);
            if ($res) {
                list($old_title, $old_filename, $old_temp_id, $old_default) = $res[0];
            }
        }

        if ($old_default != $p_default) {
            sql_query('UPDATE sb_pages, sb_catlinks SET sb_pages.p_default = 0 WHERE sb_pages.p_id=sb_catlinks.link_el_id AND sb_catlinks.link_cat_id=?d',
                $_GET['cat_id']);
        }
    } elseif ($edit_group) {
        //    $res объявляем в true просто для того чтобы чуть ниже пройти блок условия.
        $res = true;
    }

    if ($_GET['id'] != '' || $edit_group) {
        if ($res) {
            //    редактирование
            if (!$edit_group && $old_filename != $p_filename) {
                $res = sql_query('SELECT categs.cat_left, categs.cat_right FROM sb_categs categs, sb_catlinks links WHERE links.link_el_id=?d AND links.link_cat_id=categs.cat_id AND categs.cat_ident=?',
                    $_GET['id'], 'pl_pages');
                list($left, $right) = $res[0];

                $res = sql_query('SELECT cat_title FROM sb_categs WHERE cat_left <= ?d AND cat_right >= ?d AND cat_level=1 AND cat_ident=?', $left, $right,
                    'pl_pages');
                list($domain) = $res[0];

                $old_domain = $GLOBALS['sbVfs']->mDomain;
                $GLOBALS['sbVfs']->mDomain = $domain;

                if ($GLOBALS['sbVfs']->exists($p_filepath . '/' . $old_filename) && $GLOBALS['sbVfs']->is_file($p_filepath . '/' . $old_filename)) {
                    $GLOBALS['sbVfs']->delete($p_filepath . '/' . $old_filename);
                }

                if ($GLOBALS['sbVfs']->exists($p_filepath . '/' . $old_filename . '.demo') && $GLOBALS['sbVfs']->is_file($p_filepath . '/' . $old_filename . '.demo')) {
                    $GLOBALS['sbVfs']->delete($p_filepath . '/' . $old_filename . '.demo');
                }

                $GLOBALS['sbVfs']->mDomain = $old_domain;
            }

            if (!$edit_group) {
                sql_query('UPDATE sb_pages SET ?a WHERE p_id=?d', $row, $_GET['id'], sprintf(PL_PAGES_EDIT_OK, $old_title));
            } elseif ($edit_group && count($row) > 0) {
                sql_query('UPDATE sb_pages SET ?a WHERE p_id IN (?a)', $row, $_GET['ids'], PL_PAGES_EDIT_GROUP_OK);

//                если прав на публикацию нет то p_state в данном случае придет 0-ой. И нужно переопределить статус для измененных и публикуемых страниц.
                if (!$_SESSION['sbPlugins']->isRightAvailable('pl_pages', 'elems_public')) {
                    sql_query('UPDATE sb_pages SET p_state = 1 WHERE p_state = 1 AND p_id IN (?a)', $_GET['ids']);
                }
            }

            if (isset($_GET['link_id'])) {
                $footer_ar = fCategs_Edit_Elem();
                if (!$footer_ar) {
                    sb_show_message(PL_PAGES_EDIT_ERROR, false, 'warning');
                    sb_add_system_message(sprintf(PL_PAGES_EDIT_SYSTEMLOG_ERROR, $old_title), SB_MSG_WARNING);

                    fPages_Edit();
                    return;
                }

                $footer_str = $GLOBALS['sbSql']->escape($footer_ar[0], false, false);
                $footer_link_str = $GLOBALS['sbSql']->escape($footer_ar[1], false, false);
            } else {
                $footer_str = '';
                $footer_link_str = '';
            }

            if (!$edit_group) {
                $row['p_id'] = intval($_GET['id']);

                //    сохраняем элементы
                sql_query('DELETE FROM sb_elems WHERE e_link=? AND e_p_id=?d', 'page', $_GET['id']);

                $result = sql_query('SELECT e_id, e_tag, e_ident, e_temp_id, e_el_id, e_params, e_search, e_edit, e_yandex FROM sb_elems
                                        WHERE e_p_id=?d AND e_link=?', $p_temp_id, 'temp');
                if ($result) {
                    $temp_tags = array();
                    foreach ($result as $value) {
                        list($te_id, $te_tag, $te_ident, $te_temp_id, $te_el_id, $te_params, $te_search, $te_edit, $te_yandex) = $value;

                        $temp_tags[$te_tag] = array();
                        $temp_tags[$te_tag]['e_id'] = $te_id;
                        $temp_tags[$te_tag]['e_ident'] = $te_ident;
                        $temp_tags[$te_tag]['e_temp_id'] = $te_temp_id;
                        $temp_tags[$te_tag]['e_el_id'] = $te_el_id;
                        $temp_tags[$te_tag]['e_search'] = $te_search;
                        $temp_tags[$te_tag]['e_edit'] = $te_edit;
                        $temp_tags[$te_tag]['e_yandex'] = $te_yandex;
                        $temp_tags[$te_tag]['e_params'] = $te_params;
                    }
                }

                $tags = array();
                preg_match_all('/\{[_A-Z0-9' . $GLOBALS['sb_reg_upper_interval'] . ']+\}/' . SB_PREG_MOD, $t_html, $tags);

                if (isset($_POST['e_tag']) && count($tags[0]) != 0) {
                    $elems = $_SESSION['sbPlugins']->getElems();

                    foreach ($e_tag as $key => $value) {
                        if (in_array($value, $tags[0])) {
                            if (!isset($elems[$e_ident[$key]]) || $elems[$e_ident[$key]]['get_event'] != '' && $e_params[$key] == '') {
                                continue;
                            }

                            $pe_search = isset($e_search[$key]) ? $e_search[$key] : 'none';
                            $pe_edit = isset($e_edit[$key]) ? $e_edit[$key] : '0';
                            $pe_yandex = isset($e_yandex[$key]) ? $e_yandex[$key] : '0';

                            if ($e_link[$key] == 'temp' && $e_ident[$key] != '' && $old_temp_id != $p_temp_id) {
                                if (!isset($temp_tags) || !isset($temp_tags[$value])) {
                                    $e_link[$key] = 'page';
                                    $_POST['e_link'][$key] = 'page';
                                } else {
                                    if ($temp_tags[$value]['e_ident'] != $e_ident[$key] ||
                                        $temp_tags[$value]['e_temp_id'] != $e_temp_id[$key] ||
                                        $temp_tags[$value]['e_el_id'] != $e_el_id[$key] ||
                                        $temp_tags[$value]['e_search'] != $pe_search ||
                                        $temp_tags[$value]['e_edit'] != $pe_edit ||
                                        $temp_tags[$value]['e_yandex'] != $pe_yandex ||
                                        $temp_tags[$value]['e_params'] != $e_params[$key]
                                    ) {
                                        $e_link[$key] = 'page';
                                        $_POST['e_link'][$key] = 'page';
                                    }
                                }
                            }

                            if ($e_link[$key] == 'page' && $e_ident[$key] != '') {
                                $elems_raw = array();
                                $elems_raw['e_tag'] = $value;
                                $elems_raw['e_ident'] = $e_ident[$key];
                                $elems_raw['e_link'] = 'page';
                                $elems_raw['e_temp_id'] = intval($e_temp_id[$key]);
                                $elems_raw['e_el_id'] = intval($e_el_id[$key]);
                                $elems_raw['e_p_id'] = intval($_GET['id']);
                                $elems_raw['e_params'] = $e_params[$key];
                                $elems_raw['e_search'] = $pe_search;
                                $elems_raw['e_edit'] = $pe_edit;
                                $elems_raw['e_yandex'] = $pe_yandex;

                                if (!sql_query('INSERT INTO sb_elems (?#) VALUES (?a)', array_keys($elems_raw), array_values($elems_raw))) {
                                    sb_show_message(PL_PAGES_EDIT_ELEMS_ERROR, false, 'warning');
                                    sb_add_system_message(sprintf(PL_PAGES_EDIT_ELEMS_SYSTEMLOG_ERROR, $p_name), SB_MSG_WARNING);

                                    fPages_Edit($html_str, $footer_str, $footer_link_str);
                                    return;
                                }
                            }
                        }

                        $_POST['e_id'][$key] = sql_insert_id();
                    }
                }

                $crc = fPages_Gen_Page(intval($_GET['id']));

                if ($crc === true || $crc === false) {
                    $crc = null;
                }

                $row['p_crc'] = $crc;

                $html_str = fPages_Get($row);
                $html_str = sb_str_replace(array("\r\n", "\r", "\n"), '', $html_str);
                $html_str = $GLOBALS['sbSql']->escape($html_str, false, false);
            } else {
                foreach ($_GET['ids'] as $val) {
                    fPages_Gen_Page(intval($val));
                }
            }

            if (!isset($_POST['btn_apply'])) {
                if ($edit_group) {
                    echo '<script>
                               sbReturnValue("refresh");
                    </script>';
                } elseif (!isset($_GET['link_id'])) {
                    echo '<script>
                               sbReturnValue(' . intval($_GET['id']) . ');
                        </script>';
                } else {
                    if ($old_default != $p_default && $p_default == 1) {
                        echo '<script>
                            sbReturnValue("refresh");
                        </script>';
                    } else {
                        echo '<script>
                            var res = new Object();
                            res.html = "' . $html_str . '";
                            res.footer = "' . $footer_str . '";
                            res.footer_link = "' . $footer_link_str . '";
                            sbReturnValue(res);
                          </script>';
                    }
                }
            } else {
                if (!$edit_group) {
                    if ($old_temp_id != $p_temp_id && isset($_POST['e_tag']) && count($tags[0]) != 0 && isset($temp_tags)) {
                        $key = count($_POST['e_tag']);
                        foreach ($tags[0] as $value) {
                            if (!in_array($value, $_POST['e_tag']) && isset($temp_tags[$value])) {
                                $_POST['e_tag'][$key] = $value;
                                $_POST['e_id'][$key] = $temp_tags[$value]['e_id'];
                                $_POST['e_ident'][$key] = $temp_tags[$value]['e_ident'];
                                $_POST['e_temp_id'][$key] = $temp_tags[$value]['e_temp_id'];
                                $_POST['e_el_id'][$key] = $temp_tags[$value]['e_el_id'];
                                $_POST['e_params'][$key] = $temp_tags[$value]['e_params'];
                                $_POST['e_search'][$key] = $temp_tags[$value]['e_search'];
                                $_POST['e_edit'][$key] = $temp_tags[$value]['e_edit'];
                                $_POST['e_yandex'][$key] = $temp_tags[$value]['e_yandex'];
                                $_POST['e_link'][$key++] = 'temp';
                            }
                        }
                    }
                    fPages_Edit($html_str, $footer_str, $footer_link_str);
                } else {
                    fPages_Edit();
                }
            }

            sb_mail_workflow_status('pl_pages', (!$edit_group ? $_GET['id'] : $_GET['ids']), $p_name, $p_state);
        } else {
            sb_show_message(PL_PAGES_EDIT_ERROR, false, 'warning');
            sb_add_system_message(sprintf(PL_PAGES_EDIT_SYSTEMLOG_ERROR, $p_name), SB_MSG_WARNING);

            fPages_Edit();
            return;
        }
    } elseif (!$edit_group) {
        $error = true;
        if (sql_query('INSERT INTO sb_pages (?#) VALUES (?a)', array_keys($row), array_values($row))) {
            $id = sql_insert_id();
            $_GET['id'] = $id;

            $footer_ar = fCategs_Add_Elem($id);
            if ($footer_ar) {
                sb_add_system_message(sprintf(PL_PAGES_ADD_OK, $p_name));

                $crc = fPages_Gen_Page(intval($_GET['id']));

                if (!isset($_POST['btn_apply'])) {
                    echo '<script>
                               sbReturnValue(' . $id . ');
                          </script>';
                } else {
                    $footer_str = $GLOBALS['sbSql']->escape($footer_ar[0], false, false);
                    $footer_str = $GLOBALS['sbSql']->escape($footer_ar[0], false, false);

                    $_SERVER['QUERY_STRING'] .= '&id=' . $id;

                    $row['p_id'] = $id;

                    if ($crc === true || $crc === false) {
                        $crc = null;
                    }

                    $row['p_crc'] = $crc;

                    $html_str = fPages_Get($row);
                    $html_str = sb_str_replace(array("\r\n", "\r", "\n"), '', $html_str);
                    $html_str = $GLOBALS['sbSql']->escape($html_str, false, false);

                    fPages_Edit($html_str, $footer_str, '');
                }

                sb_mail_workflow_status('pl_pages', $id, $p_name, $p_state);
                $error = false;
            } else {
                sql_query('DELETE FROM sb_pages WHERE p_id=?d', $id);
            }
        }

        if ($error) {
            sb_show_message(sprintf(PL_PAGES_ADD_ERROR, $p_name), false, 'warning');
            sb_add_system_message(sprintf(PL_PAGES_ADD_SYSTEMLOG_ERROR, $p_name), SB_MSG_WARNING);

            fPages_Edit();
            return;
        }
    }
}

function fPages_Delete()
{
    $res = sql_query('SELECT pages.p_filepath, pages.p_filename, categs.cat_left, categs.cat_right FROM sb_pages pages, sb_categs categs, sb_catlinks links WHERE pages.p_id=?d AND links.link_el_id=pages.p_id AND links.link_cat_id=categs.cat_id AND categs.cat_ident=?',
        $_GET['id'], 'pl_pages');
    list($filepath, $filename, $left, $right) = $res[0];

    $res = sql_query('SELECT cat_title FROM sb_categs WHERE cat_left <= ?d AND cat_right >= ?d AND cat_ident=? AND cat_level=1', $left, $right, 'pl_pages');
    if ($res) {
        list($domain) = $res[0];

        if ($filepath != '') {
            $filename = $filepath . '/' . $filename;
        }

        sql_query('DELETE FROM sb_elems WHERE e_link=? AND e_p_id=?d', 'page', $_GET['id']);

        $old_domain = $GLOBALS['sbVfs']->mDomain;
        $GLOBALS['sbVfs']->mDomain = $domain;

        if ($GLOBALS['sbVfs']->exists($filename) && $GLOBALS['sbVfs']->is_file($filename)) {
            $GLOBALS['sbVfs']->delete($filename);
        }

        if ($GLOBALS['sbVfs']->exists($filename . '.demo') && $GLOBALS['sbVfs']->is_file($filename . '.demo')) {
            $GLOBALS['sbVfs']->delete($filename . '.demo');
        }

        $GLOBALS['sbVfs']->mDomain = $old_domain;
    }
}

function fPages_Before_Delete_Categs_With_Elements()
{
    if (isset($_GET['cat_id'])) {
        $res = sql_query('SELECT cat_left, cat_right, cat_title, cat_fields FROM sb_categs WHERE cat_id=?d', $_GET['cat_id']);
        if (!$res) {
            return;
        }

        list($left, $right, $title, $cat_fields) = $res[0];
        $cat_fields = unserialize($cat_fields);
        // Название домена
        $res = sql_query('SELECT cat_title FROM sb_categs WHERE cat_left <= ?d AND cat_right >= ?d AND cat_ident=? AND cat_level=1', $left, $right, 'pl_pages');
        if (!$res) {
            return;
        }

        $domain = $res[0][0];
        // Достаю все странички
        $res = sql_query('SELECT p.p_id, p.p_filepath, p.p_filename FROM sb_categs categs, sb_catlinks links, sb_pages p
                          WHERE categs.cat_left >= ?d AND categs.cat_right <= ?d AND categs.cat_ident="pl_pages"
                          AND links.link_cat_id=categs.cat_id AND p.p_id = links.link_el_id', $left, $right);
        if ($res) {
            $delete = array();
            $old_domain = $GLOBALS['sbVfs']->mDomain;
            $GLOBALS['sbVfs']->mDomain = $domain;
            foreach ($res as $value) {
                // Массив удаляемых страничек
                $delete[] = $value[0];
                // Удаляю файлы
                $filename = $value[2];
                if ($value[1] != '') {
                    $filename = $value[1] . '/' . $filename;
                }

                if ($GLOBALS['sbVfs']->exists($filename) && $GLOBALS['sbVfs']->is_file($filename)) {
                    $GLOBALS['sbVfs']->delete($filename);
                }

                if ($GLOBALS['sbVfs']->exists($filename . '.demo') && $GLOBALS['sbVfs']->is_file($filename . '.demo')) {
                    $GLOBALS['sbVfs']->delete($filename . '.demo');
                }
            }
            // Удаляю раздел
            if ($GLOBALS['sbVfs']->exists($cat_fields['path']) && $GLOBALS['sbVfs']->is_dir($cat_fields['path'])) {
                $GLOBALS['sbVfs']->delete($cat_fields['path']);
            }
            $GLOBALS['sbVfs']->mDomain = $old_domain;
            // Удаляю компоненты
            sql_query('DELETE FROM sb_elems WHERE e_link=? AND e_p_id IN (?a)', 'page', $delete);
        }
    }
}

function fPages_Before_Paste()
{
    if ($_GET['action'] != 'cut' || (!isset($_GET['e']) || !is_array($_GET['e']) || count($_GET['e']) <= 0)) {
        return;
    }

    $res = sql_query('SELECT p.p_filename FROM sb_pages p, sb_catlinks l WHERE l.link_cat_id=?d AND p.p_id=l.link_el_id AND p.p_filename IN
                                (SELECT p_filename FROM sb_pages WHERE p_id IN (?a))', $_GET['new_cat_id'], $_GET['e']);

    if ($res) {
        echo sprintf(PL_PAGES_PASTE_ERROR, trim($res[0][0], '/\\'));
    }
}

function fPages_Paste()
{
    if (!isset($_GET['action'])) {
        return;
    }

    $res = sql_query('SELECT cat_fields FROM sb_categs WHERE cat_id=?d', $_GET['new_cat_id']);
    if (!$res) {
        return;
    }

    $cat_fields = array();
    if ($res[0][0] != '') {
        $cat_fields = unserialize($res[0][0]);
    }

    if (isset($cat_fields['path'])) {
        $path = $cat_fields['path'];
    } else {
        $path = '';
    }

    if ($_GET['action'] == 'copy') {
        if (!isset($_GET['e']) || !is_array($_GET['e']) || count($_GET['e']) <= 0 || !isset($_GET['ne']) || !is_array($_GET['ne']) || count($_GET['ne']) <= 0) {
            return;
        }

        $els = array();
        foreach ($_GET['e'] as $key => $value) {
            $els[intval($value)] = intval($_GET['ne'][$key]);
        }

        $res = sql_query('SELECT e_tag, e_ident, e_temp_id, e_el_id, e_p_id, e_params, e_search, e_edit, e_yandex FROM sb_elems
                                WHERE e_link=? AND e_p_id IN (' . implode(',', array_keys($els)) . ')', 'page');

        if ($res) {
            foreach ($res as $value) {
                list($e_tag, $e_ident, $e_temp_id, $e_el_id, $e_p_id, $e_params, $e_search, $e_edit, $e_yandex) = $value;

                if (isset($els[$e_p_id])) {
                    $row = array();
                    $row['e_tag'] = $e_tag;
                    $row['e_ident'] = $e_ident;
                    $row['e_link'] = 'page';
                    $row['e_temp_id'] = $e_temp_id;
                    $row['e_el_id'] = $e_el_id;
                    $row['e_p_id'] = $els[$e_p_id];
                    $row['e_params'] = $e_params;
                    $row['e_search'] = $e_search;
                    $row['e_edit'] = $e_edit;
                    $row['e_yandex'] = $e_yandex;

                    sql_query('INSERT INTO sb_elems (?#) VALUES (?a)', array_keys($row), array_values($row));
                }
            }
        }

        $workflow = $_SESSION['sbPlugins']->isPluginAvailable('pl_workflow') && $_SESSION['sbPlugins']->isPluginInWorkflow('pl_pages');
        $domain = false;
        $old_domain = $GLOBALS['sbVfs']->mDomain;

        foreach ($_GET['ne'] as $id) {
            if (!$domain) {
                $res = sql_query('SELECT categs.cat_left, categs.cat_right FROM sb_categs categs, sb_catlinks links WHERE links.link_el_id=?d AND links.link_cat_id=categs.cat_id AND categs.cat_ident=?',
                    $id, 'pl_pages');
                list($left, $right) = $res[0];
                $res = sql_query('SELECT cat_title FROM sb_categs WHERE cat_left <= ?d AND cat_right >= ?d AND cat_level=1 AND cat_ident=?', $left, $right,
                    'pl_pages');
                list($domain) = $res[0];

                $GLOBALS['sbVfs']->mDomain = $domain;
            }

            $res = sql_query('SELECT p_filename, p_state FROM sb_pages WHERE p_id=?d', $id);
            if ($res) {
                list($filename, $p_state) = $res[0];

                if ($GLOBALS['sbVfs']->exists($path . '/' . $filename) && $GLOBALS['sbVfs']->is_file($path . '/' . $filename)) {
                    $ext = 'php';
                    $info = pathinfo($filename);
                    if (isset($info['extension']) && !empty($info['extension'])) {
                        $ext = $info['extension'];
                    }
                    $filename = 'page_' . str_replace('.', '_', microtime(true)) . '.' . $ext;

                    sql_query('UPDATE sb_pages SET p_filepath=?, p_filename=?, p_default=0 WHERE p_id=?d', $path, $filename, $id);
                } else {
                    sql_query('UPDATE sb_pages SET p_filepath=?, p_default=0 WHERE p_id=?d', $path, $id);
                }

                fPages_Gen_Page($id);

                if ($workflow) {
                    if (!sb_workflow_status_available($p_state, 'pl_pages', -1)) {
                        sql_query('UPDATE sb_pages SET p_state=?d WHERE p_id=?d', current(sb_get_avail_workflow_status('pl_pages')), $id);
                    }
                }
            }
        }

        $GLOBALS['sbVfs']->mDomain = $old_domain;
    } elseif ($_GET['action'] == 'cut') {
        if (!isset($_GET['e']) || !is_array($_GET['e']) || count($_GET['e']) <= 0) {
            return;
        }

        $domain = false;
        $old_domain = $GLOBALS['sbVfs']->mDomain;

        foreach ($_GET['e'] as $id) {
            if (!$domain) {
                $res = sql_query('SELECT categs.cat_left, categs.cat_right FROM sb_categs categs, sb_catlinks links WHERE links.link_el_id=?d AND links.link_cat_id=categs.cat_id AND categs.cat_ident=?',
                    $id, 'pl_pages');
                list($left, $right) = $res[0];
                $res = sql_query('SELECT cat_title FROM sb_categs WHERE cat_left <= ?d AND cat_right >= ?d AND cat_level=1 AND cat_ident=?', $left, $right,
                    'pl_pages');
                list($domain) = $res[0];

                $GLOBALS['sbVfs']->mDomain = $domain;
            }

            $res = sql_query('SELECT p_filepath, p_filename FROM sb_pages WHERE p_id=?d', $id);
            if ($res) {
                list($p_filepath, $p_filename) = $res[0];

                if ($GLOBALS['sbVfs']->exists($p_filepath . '/' . $p_filename) && $GLOBALS['sbVfs']->is_file($p_filepath . '/' . $p_filename)) {
                    $GLOBALS['sbVfs']->delete($p_filepath . '/' . $p_filename);
                }

                if ($GLOBALS['sbVfs']->exists($p_filepath . '/' . $p_filename . '.demo') && $GLOBALS['sbVfs']->is_file($p_filepath . '/' . $p_filename . '.demo')) {
                    $GLOBALS['sbVfs']->delete($p_filepath . '/' . $p_filename . '.demo');
                }
            }

            sql_query('UPDATE sb_pages SET p_filepath=? WHERE p_id=?d', $path, $id);
            fPages_Gen_Page($id);
        }

        $GLOBALS['sbVfs']->mDomain = $old_domain;
    }
}

function fPages_Paste_Categs()
{
    if (strtoupper($_GET['action']) == 'CUT') {
        $res = sql_query('SELECT cat_left, cat_right FROM sb_categs WHERE cat_id=?d', $_GET['paste_cat_id']);
        list($paste_left, $paste_right) = $res[0];

        $res = sql_query('SELECT cat_left, cat_right FROM sb_categs WHERE cat_id=?d', $_GET['cat_id']);
        list($left, $right) = $res[0];

        // сравниваем домены
        $res = sql_query('SELECT cat_title FROM sb_categs WHERE cat_left <= ?d AND cat_right >= ?d AND cat_ident=? AND cat_level=1', $paste_left, $paste_right,
            'pl_pages');
        list($paste_domain) = $res[0];

        $res = sql_query('SELECT cat_title, cat_left, cat_right FROM sb_categs WHERE cat_left <= ?d AND cat_right >= ?d AND cat_ident=? AND cat_level=1', $left,
            $right, 'pl_pages');
        list($domain, $cat_left, $cat_right) = $res[0];

        if ($paste_domain != $domain) {
            // домены не совпадают, удаляем старые файлы
            $res = sql_query('SELECT cat_id FROM sb_categs WHERE cat_left >= ?d AND cat_right <= ?d AND cat_ident=?', $paste_left, $paste_right, 'pl_pages');
            $in_str = '(0';
            foreach ($res as $value) {
                $in_str .= ',' . $value[0];
            }
            $in_str .= ')';

            $res = sql_query('SELECT pages.p_filepath, pages.p_filename FROM sb_pages pages, sb_catlinks links WHERE links.link_cat_id IN ' . $in_str . ' AND pages.p_id=links.link_el_id');
            $files = array();
            foreach ($res as $value) {
                list($p_filepath, $p_filename) = $value;

                $res_cat = sql_query('SELECT categs.cat_title FROM sb_pages pages, sb_catlinks links, sb_categs categs WHERE categs.cat_left >= ?d AND categs.cat_right <= ?d AND categs.cat_ident=?
                                                   AND links.link_cat_id=categs.cat_id AND links.link_el_id=pages.p_id AND pages.p_filepath=? AND pages.p_filename=?',
                    $cat_left, $cat_right, 'pl_pages', $p_filepath, $p_filename);
                if ($res_cat) {
                    printf(PL_PAGES_CATEGS_CUT_ERROR, $p_filepath . '/' . $p_filename, $res_cat[0][0]);
                    return;
                }

                $files[] = $p_filepath . '/' . $p_filename;
            }

            $old_domain = $GLOBALS['sbVfs']->mDomain;
            $GLOBALS['sbVfs']->mDomain = $paste_domain;
            foreach ($files as $value) {
                if ($GLOBALS['sbVfs']->exists($value) && $GLOBALS['sbVfs']->is_file($value)) {
                    $GLOBALS['sbVfs']->delete($value);
                }

                if ($GLOBALS['sbVfs']->exists($value . '.demo') && $GLOBALS['sbVfs']->is_file($value . '.demo')) {
                    $GLOBALS['sbVfs']->delete($value . '.demo');
                }
            }
            $GLOBALS['sbVfs']->mDomain = $old_domain;
        }
    }
}

function fPages_After_Paste_Categs_With_Elements()
{
    $page_gen = false;

    $res = sql_query('SELECT cat_left, cat_right FROM sb_categs WHERE cat_id = ?d', $_GET['new_cat_id']);
    if (!$res) {
        // Невозможно достать подразделы вставленного раздела
        return false;
    }

    list($cat_left, $cat_right) = $res[0];

    $res = sql_query('SELECT cat_left, cat_right FROM sb_categs WHERE cat_id = ?d', $_GET['paste_cat_id']);
    if (!$res) {
        return false;
    }

    list($old_cat_left, $old_cat_right) = $res[0];

    // Достаю список страниц
    $new_pages = array();
    $res_pages = sql_query('SELECT DISTINCT pages.p_id, pages.p_filename, pages.p_filepath FROM sb_pages pages, sb_catlinks links, sb_categs categs WHERE categs.cat_ident=? AND categs.cat_left >= ?d AND categs.cat_right <= ?d AND links.link_cat_id=categs.cat_id AND pages.p_id=links.link_el_id ORDER BY pages.p_id',
        'pl_pages', $cat_left, $cat_right);
    if ($res_pages) {
        foreach ($res_pages as $value) {
            $new_pages[] = $value[0];
        }
    }

    // Копирую компоненты страниц
    $old_pages_res = sql_query('SELECT DISTINCT pages.p_id FROM sb_pages pages, sb_catlinks links, sb_categs categs WHERE categs.cat_ident=? AND categs.cat_left >= ?d AND categs.cat_right <= ?d AND links.link_cat_id=categs.cat_id AND pages.p_id=links.link_el_id order by pages.p_id',
        'pl_pages', $old_cat_left, $old_cat_right);
    if ($old_pages_res) {
        $i = 0;
        foreach ($old_pages_res as $value) {
            $res = sql_query('SELECT e_id FROM sb_elems WHERE e_p_id = ?d AND e_link = "page"', $value[0]);
            if ($res) {
                foreach ($res as $value2) {
                    $new_component_id = $GLOBALS['sbSql']->duplicateRow($value2[0], 'e_id', 'sb_elems');
                    sql_query('UPDATE sb_elems SET e_p_id = ? WHERE e_id = ?d', $new_pages[$i], $new_component_id);
                }
            }
            $i++;
        }
        $page_gen = true;
    }

    // Редактируем пути у новых разделов и страниц
    $res = sql_query('SELECT cat_fields, cat_left, cat_right FROM sb_categs WHERE cat_id = ?d', $_GET['cat_id']);
    if ($res) {
        $settings = unserialize($res[0][0]); // Путь родительского раздела
        $left = $res[0][1];
        $right = $res[0][2];
    }

    // Названия доменов
    $res = sql_query('SELECT cat_title FROM sb_categs WHERE cat_left <= ?d AND cat_right >= ?d AND cat_ident=? AND cat_level=1', $old_cat_left, $old_cat_right,
        'pl_pages');
    list($paste_domain) = $res[0];

    $res = sql_query('SELECT cat_title FROM sb_categs WHERE cat_left <= ?d AND cat_right >= ?d AND cat_ident=? AND cat_level=1', $left, $right, 'pl_pages');
    list($domain) = $res[0];

    if (isset($settings['path']) && $settings['path'] != '') {
        // Меняю путь у вставленного раздела, и всех его подразделов
        $res = sql_query('SELECT cat_id, cat_fields FROM sb_categs WHERE cat_left >= ?d AND cat_right <= ?d AND cat_ident = ?', $cat_left, $cat_right,
            'pl_pages');
        if ($res) {
            foreach ($res as $value) {
                // Меняю путь у разделов
                $new_settings = unserialize($value[1]);
                $new_settings['path'] = $settings['path'] . '/' . $new_settings['path'];
                sql_query('UPDATE sb_categs SET cat_fields = ? WHERE cat_id = ?d', serialize($new_settings), $value[0]);

            }
        }

        // Меняю путь у страниц
        if (count($new_pages) > 0) {
            sql_query('UPDATE sb_pages SET p_filepath = CONCAT(?, "/", p_filepath) WHERE p_id IN (?a)', $settings['path'], $new_pages);
            $page_gen = true;
        }

        // проверяем страницы на повторяющиеся имена
        if (count($new_pages) > 0) {
            foreach ($res_pages as $value) {
                $res = sql_query('SELECT COUNT(*) FROM sb_pages WHERE p_filename = ? AND p_filepath = ?', $value[1], $value[2]);
                if ($res && $res[0][0] > 1) {
                    $postfix = date('U');
                    sql_query('UPDATE sb_pages SET p_filename = CONCAT(?, "_", p_filename) WHERE p_id = ?', $postfix, $value[0]);
                    $page_gen = true;
                }
            }
        }
    } elseif (count($new_pages) > 0 && $paste_domain == $domain) {
        // Если у директории, в которую вставляем, путь не прописан - меняем названия файлов
        $postfix = date('U');
        sql_query('UPDATE sb_pages SET p_filename = CONCAT(?, "_", p_filename) WHERE p_id IN (?a)', $postfix, $new_pages);
        $page_gen = true;
    }

    // Если нужна перегенерация страниц
    if ($page_gen) {
        echo '<script>
                var strPage = "' . SB_CMS_DIALOG_FILE . '?event=pl_pages_gen_pages&id=" + ' . $_GET['new_cat_id'] . ' + "&subcategs=1";
                 var strAttr = "resizable=0,width=600,height=400";
                sbShowDialog(strPage, strAttr);
             </script>';
    }
}


function fPages_Edit_Content()
{
    if (isset($_GET['p_url'])) {
        $p_info = fPages_Get_Page_Id($_GET['p_url']);

        if (!$p_info) {
            echo '-1';
            return;
        }

        $p_id = $p_info[0];
        if (!fCategs_Check_Elems_Rights($p_id, -1, 'pl_pages')) {
            echo '-1';
            return;
        }

        echo $p_id;
        return;
    }

    if (!fCategs_Check_Elems_Rights($_GET['p_id'], -1, 'pl_pages')) {
        return;
    }

    require_once SB_CMS_LIB_PATH . '/sbVisualEditor.inc.php';

    echo '<input type="hidden" id="sb_editor_page" value="' . intval($_GET['p_id']) . '" />';

    $editor = new sbVisualEditor();
    $editor->show(SB_CMS_EMPTY_FILE . '?event=pl_editor_full&p_id=' . intval($_GET['p_id']));
}

function fPages_Set_Main()
{
    if (!fCategs_Check_Elems_Rights($_GET['id'], -1, 'pl_pages', 'pl_pages', 'elems_edit')) {
        return;
    }

    $res = sql_query('SELECT p_name, p_default FROM sb_pages WHERE p_id=?d', $_GET['id']);

    if ($res) {
        list($p_name, $p_default) = $res[0];

        sql_query('UPDATE sb_pages, sb_catlinks SET sb_pages.p_default = 0 WHERE sb_pages.p_id=sb_catlinks.link_el_id AND sb_catlinks.link_cat_id=?d',
            $_GET['cat_id']);
        sql_query('UPDATE sb_pages SET p_default=' . ($p_default == 1 ? '0' : '1') . ' WHERE p_id=?d', $_GET['id']);

        sql_query('INSERT INTO sb_catchanges (el_id, cat_ident, change_date, change_user_id, action) VALUES (?d, ?, ?d, ?d, ?)', $_GET['id'], 'pl_pages',
            time(), $_SESSION['sbAuth']->getUserId(), 'edit');

        sb_add_system_message(sprintf(PL_PAGES_EDIT_OK, $p_name));
    }
}

function checkSeoOption($userCatId)
{
    $res=sql_query('SELECT ur_plugin_rights FROM sb_users_rights WHERE ur_plugin="pl_pages" AND ur_cat_id=?d LIMIT 1', $userCatId);
    if ($res) {
        $rightsArr = explode('|',$res[0][0]);
        if (array_search('elems_seo_edit', $rightsArr)) {
            return true;
        } else {
            return false;
        }
    }
}
