<?php
include_once(SB_CMS_LIB_PATH . '/sbTree.inc.php');

function fPayment_EditForm_Elem($name, $value, $fname = false)
{
    if (strlen($value) > 0 || $fname) {
        return "<tr>
          <td></td>
             <th width='200'>$name:</th>
          <td>" . (!$fname ? "<div style='margin:2px;'>$value</div>" : "<input type='text' name='$fname' value='{$value}' style='margin:2px;width:100%;'>") . "</td>
          <td></td>
          </tr>";
    }
}

function fPayment_Transaction_Props($system, $data)
{
    if (!isset($GLOBALS[$system])) {
        return '';
    }

    $return = '';

    foreach ($data as $key => $value) {
        if (isset($GLOBALS[$system][$key])) {
            $return .= fPayment_EditForm_Elem($GLOBALS[$system][$key], $value);
        }
    }

    return $return;
}

function createSystemCats()
{
    $tree = new sbTree('pl_payments');
    $res = sql_param_query('SELECT cat_id FROM sb_categs WHERE cat_ident="pl_payments" AND cat_level=0');
    if (!$res) {
        //        Добаление корневой категории
        $cat_props = array();
        $cat_props['cat_ident'] = 'pl_payment_root';

        $fields = array();
        $fields['cat_title'] = PL_PAYMENT_ROOT_NAME;
        $fields['cat_rubrik'] = 1;
        $fields['cat_closed'] = 0;
        $fields['cat_rights'] = $_SESSION['sbAuth']->isAdmin() ? '' : 'u' . $_SESSION['sbAuth']->getUserId();
        $fields['cat_fields'] = serialize($cat_props);
        $par_id = $tree->insertNode('0', $fields);

        $res = sql_param_query('SELECT categs.cat_id FROM sb_categs categs WHERE categs.cat_ident="pl_payments" AND cat_fields  LIKE "%pl_payment_assist%"');
        if (!$res) {
            // Добавление подкатегории ASSIST по умолчанию
            $cat_props = array();
            $cat_props['cat_ident'] = 'pl_payment_assist';

            $fields = array();
            $fields['cat_title'] = PL_PAYMENT_ASSIST;
            $fields['cat_rubrik'] = 1;
            $fields['cat_closed'] = 0;
            $fields['cat_rights'] = $_SESSION['sbAuth']->isAdmin() ? '' : 'u' . $_SESSION['sbAuth']->getUserId();
            $fields['cat_fields'] = serialize($cat_props);
            $tree->insertNode($par_id, $fields);
        }

        $res = sql_param_query('SELECT categs.cat_id FROM sb_categs categs WHERE categs.cat_ident="pl_payments" AND cat_fields LIKE "%pl_payment_chronopay%"');
        if (!$res) {
            //Добавление подкатегории CHRONOPAY по умолчанию
            $cat_props = array();
            $cat_props['cat_ident'] = 'pl_payment_chronopay';

            $fields = array();
            $fields['cat_title'] = PL_PAYMENT_CHRONOPAY;
            $fields['cat_rubrik'] = 1;
            $fields['cat_closed'] = 0;
            $fields['cat_rights'] = $_SESSION['sbAuth']->isAdmin() ? '' : 'u' . $_SESSION['sbAuth']->getUserId();
            $fields['cat_fields'] = serialize($cat_props);
            $tree->insertNode($par_id, $fields);
        }

        $res = sql_query('SELECT categs.cat_id FROM sb_categs categs WHERE categs.cat_ident="pl_payments" AND cat_fields LIKE "%pl_payment_rupay%"');
        if (!$res) {
            //Добавление подкатегории RUpay платежи по умолчанию
            $cat_props = array();
            $cat_props['cat_ident'] = 'pl_payment_rupay';

            $fields = array();
            $fields['cat_title'] = PL_PAYMENT_RUPAY;
            $fields['cat_rubrik'] = 1;
            $fields['cat_closed'] = 0;
            $fields['cat_rights'] = $_SESSION['sbAuth']->isAdmin() ? '' : 'u' . $_SESSION['sbAuth']->getUserId();
            $fields['cat_fields'] = serialize($cat_props);
            $tree->insertNode($par_id, $fields);
        }

        $res = sql_query('SELECT categs.cat_id FROM sb_categs categs WHERE categs.cat_ident="pl_payment" AND cat_fields LIKE "%pl_payment_rfi_bank%"');
        if (!$res) {
            //Добавление подкатегории РФИ Банк платежи по умолчанию
            $cat_props = array();
            $cat_props['cat_ident'] = 'pl_payment_rfi_bank';

            $fields = array();
            $fields['cat_title'] = PL_PAYMENT_RFI;
            $fields['cat_rubrik'] = 1;
            $fields['cat_closed'] = 0;
            $fields['cat_rights'] = $_SESSION['sbAuth']->isAdmin() ? '' : 'u'.$_SESSION['sbAuth']->getUserId();
            $fields['cat_fields'] = serialize($cat_props);
            $tree->insertNode($par_id, $fields);
        }

        $res = sql_query('SELECT categs.cat_id FROM sb_categs categs WHERE categs.cat_ident="pl_payment" AND cat_fields LIKE "%pl_payment_offline%"');
        if (!$res) {
            //Добавление подкатегории Off-line платежи по умолчанию
            $cat_props = array();
            $cat_props['cat_ident'] = 'pl_payment_offline';

            $fields = array();
            $fields['cat_title'] = PL_PAYMENT_OFFLINE;
            $fields['cat_rubrik'] = 1;
            $fields['cat_closed'] = 0;
            $fields['cat_rights'] = $_SESSION['sbAuth']->isAdmin() ? '' : 'u' . $_SESSION['sbAuth']->getUserId();
            $fields['cat_fields'] = serialize($cat_props);
            $tree->insertNode($par_id, $fields);
        }
    } else {
        list($par_id) = $res[0];
        $res = sql_param_query('SELECT categs.cat_id FROM sb_categs categs WHERE categs.cat_ident="pl_payments" AND cat_fields  LIKE "%pl_payment_assist%"');
        if (!$res) {
            // Добавление подкатегории ASSIST по умолчанию
            $cat_props = array();
            $cat_props['cat_ident'] = 'pl_payment_assist';

            $fields = array();
            $fields['cat_title'] = PL_PAYMENT_ASSIST;
            $fields['cat_rubrik'] = 1;
            $fields['cat_closed'] = 0;
            $fields['cat_rights'] = $_SESSION['sbAuth']->isAdmin() ? '' : 'u' . $_SESSION['sbAuth']->getUserId();
            $fields['cat_fields'] = serialize($cat_props);
            $tree->insertNode($par_id, $fields);
        }

        $res = sql_param_query('SELECT categs.cat_id FROM sb_categs categs WHERE categs.cat_ident="pl_payments" AND cat_fields LIKE "%pl_payment_chronopay%"');
        if (!$res) {
            //Добавление подкатегории CHRONOPAY по умолчанию
            $cat_props = array();
            $cat_props['cat_ident'] = 'pl_payment_chronopay';

            $fields = array();
            $fields['cat_title'] = PL_PAYMENT_CHRONOPAY;
            $fields['cat_rubrik'] = 1;
            $fields['cat_closed'] = 0;
            $fields['cat_rights'] = $_SESSION['sbAuth']->isAdmin() ? '' : 'u' . $_SESSION['sbAuth']->getUserId();
            $fields['cat_fields'] = serialize($cat_props);
            $tree->insertNode($par_id, $fields);
        }

        $res = sql_query('SELECT categs.cat_id FROM sb_categs categs WHERE categs.cat_ident="pl_payments" AND cat_fields LIKE "%pl_payment_rupay%"');
        if (!$res) {
            //Добавление подкатегории RUpay платежи по умолчанию
            $cat_props = array();
            $cat_props['cat_ident'] = 'pl_payment_rupay';

            $fields = array();
            $fields['cat_title'] = PL_PAYMENT_RUPAY;
            $fields['cat_rubrik'] = 1;
            $fields['cat_closed'] = 0;
            $fields['cat_rights'] = $_SESSION['sbAuth']->isAdmin() ? '' : 'u' . $_SESSION['sbAuth']->getUserId();
            $fields['cat_fields'] = serialize($cat_props);
            $tree->insertNode($par_id, $fields);
        }

        $res = sql_query('SELECT categs.cat_id FROM sb_categs categs WHERE categs.cat_ident="pl_payments" AND cat_fields LIKE "%pl_payment_rfi_bank%"');
        if (!$res) {
            //Добавление подкатегории РФИ Банк платежи по умолчанию
            $cat_props = array();
            $cat_props['cat_ident'] = 'pl_payment_rfi_bank';

            $fields = array();
            $fields['cat_title'] = PL_PAYMENT_RFI;
            $fields['cat_rubrik'] = 1;
            $fields['cat_closed'] = 0;
            $fields['cat_rights'] = $_SESSION['sbAuth']->isAdmin() ? '' : 'u'.$_SESSION['sbAuth']->getUserId();
            $fields['cat_fields'] = serialize($cat_props);
            $tree->insertNode($par_id, $fields);
        }

        $res = sql_query('SELECT categs.cat_id FROM sb_categs categs WHERE categs.cat_ident="pl_payments" AND cat_fields LIKE "%pl_payment_offline%"');
        if (!$res) {
            //Добавление подкатегории Off-line платежи по умолчанию
            $cat_props = array();
            $cat_props['cat_ident'] = 'pl_payment_offline';

            $fields = array();
            $fields['cat_title'] = PL_PAYMENT_OFFLINE;
            $fields['cat_rubrik'] = 1;
            $fields['cat_closed'] = 0;
            $fields['cat_rights'] = $_SESSION['sbAuth']->isAdmin() ? '' : 'u' . $_SESSION['sbAuth']->getUserId();
            $fields['cat_fields'] = serialize($cat_props);
            $tree->insertNode($par_id, $fields);
        }
    }
}


function fPayment_Get($args)
{
    switch ($args['sp_status']) {
        case 0:
            $string = PL_PAYMENT_STATUS_0;
            break;
        case 1:
            $string = '<font color=orange>' . PL_PAYMENT_STATUS_1 . '</font>';
            break;
        case 2:
            $string = '<font color=green>' . PL_PAYMENT_STATUS_2 . '</font>';
            break;
        case 3:
            $string = '<font color=red>' . PL_PAYMENT_STATUS_3 . '</font>';
            break;
        case 4:
            $string = '<font color=orange>' . PL_PAYMENT_STATUS_4 . '</font>';
            break;
        case 5:
            $string = '<font color=red>' . PL_PAYMENT_STATUS_5 . '</font>';
            break;
        case 6:
            $string = '<font color=red>' . PL_PAYMENT_STATUS_6 . '</font>';
            break;
        case 7:
            $string = '<font color=green>' . PL_PAYMENT_STATUS_7 . '</font>';
            break;
    }

    $result = '<b><a href="javascript:void(0);" onclick="sbElemsEdit(event);">' . $args['sp_title'] . '</a></b>
    <div class="smalltext" style="margin-top: 7px;">'
        . PL_PAYMENT_ID . ': <span style="color: #33805E;">' . (isset($args['sp_id']) ? $args['sp_id'] : '') . '</span><br />'
        . ($args['sp_date'] != 0 ? PL_PAYMENT_DESIGN_DATE_TAG . ': <span style="color: #33805E;">' . sb_date('d.m.Y H:i',
                $args['sp_date']) . '</span><br />' : '')
        . PL_PAYMENT_GET_FIO . ': <span style="color: #33805E;">' . $args['sp_surname'] . ' ' . $args['sp_name'] . ' ' . $args['sp_secname'] . '</span><br />'
        . PL_PAYMENT_STATUS_EDIT . ': <span style="color: #33805E;">' . $string . '</span><br />'
        . PL_PAYMENT_VALUT_SYSTEM . ': <span style="color: #33805E;">' . $args['sp_summ'] . ' y.e.</span><br />'
        . PL_PAYMENT_DESIGN_TEXT_TAG . ': <span style="color: #33805E;">' . $args['sp_text'] . '</span><br />';

    if ($args['sp_active'] == 1) {
        $result .= PL_PAYMENT_ACTIVE_PAYMENT . ': <span style="color: #33805E;">' . PL_PAYMENT_YES_PAYMENT . '</span><br />';
    } else {
        $result .= PL_PAYMENT_ACTIVE_PAYMENT . ': <span style="color: #FF0000;">' . PL_PAYMENT_NO_PAYMENT . '</span><br />';
    }

    $result .= '</div>';

    return $result;

}

function fPayment_Init()
{
    createSystemCats();

    require_once(SB_CMS_LIB_PATH . '/sbElements.inc.php');
    $elems = new sbElements('sb_payments', 'sp_id', 'sp_title', 'fPayment_Get', 'pl_payment_init', 'pl_payments');
    $elems->mElemsIcon = SB_CMS_IMG_URL . '/plugins/pl_payment_temps_list_32.png';

    $elems->addField('sp_date');         // Дата платежа
    $elems->addField('sp_surname');         // Фамилия плательщика
    $elems->addField('sp_name');         // Имя плательщик
    $elems->addField('sp_secname');         // Отчество плательщика
    $elems->addField('sp_status');         // Статус платежа
    $elems->addField('sp_summ');         // Сумма платежа
    $elems->addField('sp_text');         // Назначение платежа
    $elems->addField('sp_active');         // Публиковать на сайте

    $stat = array();
    $stat[0] = PL_PAYMENT_STATUS_0;
    $stat[1] = PL_PAYMENT_STATUS_1;
    $stat[2] = PL_PAYMENT_STATUS_2;
    $stat[3] = PL_PAYMENT_STATUS_3;
    $stat[4] = PL_PAYMENT_STATUS_4;
    $stat[5] = PL_PAYMENT_STATUS_5;
    $stat[6] = PL_PAYMENT_STATUS_6;
    $stat[7] = PL_PAYMENT_STATUS_7;

    $elems->addFilter(PL_PAYMENT_ID, 'sp_id', 'number');
    $elems->addFilter(PL_PAYMENT_TITLE, 'sp_title', 'string');
    $elems->addFilter(PL_PAYMENT_EDIT_DATE, 'sp_date', 'date');
    $elems->addFilter(PL_PAYMENT_STATUS_EDIT, 'sp_status', 'select', $stat);
    $elems->addFilter(PL_PAYMENT_EDIT_SUMM, 'sp_summ', 'number');

    $elems->addSorting(PL_PAYMENT_SORT_ID, 'sp_id');   // сортировать по id
    $elems->addSorting(PL_PAYMENT_SORT_DATE, 'sp_date');   // сортировать по дате
    $elems->addSorting(PL_PAYMENT_SORT_SUMM, 'sp_summ');   // сортировать по сумме

    $elems->mCategsRootName = PL_PAYMENT_ROOT_NAME;

    $elems->mCategsAddMenuLevel = 2;
    $elems->mCategsPasteCategsMenuLevel = 2;
    $elems->mCategsPasteElemsMenuLevel = 2;
    $elems->mCategsRubrikator = false;

    $elems->mCategsAddMenuTitle = PL_PAYMENT_CATEGS_ADD_MENU;
    $elems->mCategsEditMenuTitle = PL_PAYMENT_CATEGS_EDIT_MENU;
    $elems->mCategsDeleteMenuTitle = PL_PAYMENT_CATEGS_DELETE_MENU;
    $elems->mCategsPasteMenuTitle = PL_PAYMENT_CATEGS_PASTE_MENU;
    $elems->mCategsCopyMenuTitle = PL_PAYMENT_CATEGS_COPY_MENU;
    $elems->mCategsCutMenuTitle = PL_PAYMENT_CATEGS_CUT_MENU;

    $elems->mCategsPasteElemsMenuTitle = PL_PAYMENT_CATEGS_PASTE_ELEMS_MENU;

    $elems->mElemsAddMenuTitle = PL_PAYMENT_ELEMS_ADD_MENU;
    $elems->mElemsEditMenuTitle = PL_PAYMENT_ELEMS_EDIT_MENU;
    $elems->mElemsCopyMenuTitle = PL_PAYMENT_ELEMS_COPY_MENU;
    $elems->mElemsCutMenuTitle = PL_PAYMENT_ELEMS_CUT_MENU;

    $elems->mElemsEditEvent = 'pl_payment_edit';
    $elems->mElemsEditDlgWidth = 800;
    $elems->mElemsEditDlgHeight = 860;

    $elems->mElemsAddEvent = 'pl_payment_edit';
    $elems->mElemsAddDlgWidth = 800;
    $elems->mElemsAddDlgHeight = 860;

    $elems->mElemsBeforePasteEvent = 'pl_payment_paste';

    $elems->mCategsEditEvent = 'pl_payment_cat_edit';
    $elems->mCategsEditDlgWidth = 800;
    $elems->mCategsEditDlgHeight = 750;

    $elems->mCategsDeleteEvent = 'pl_payment_cat_delete';
    $elems->mCategsAfterAddEvent = 'pl_payment_add_cat_fields';

    if ($_SESSION['sbPlugins']->isRightAvailable('pl_payment', 'elems_public')) {
        $elems->mElemsJavascriptStr .= '
            function paymentSetActive()
            {
                var res = sbLoadSync("' . SB_CMS_EMPTY_FILE . '?event=pl_payment_set_active&id=" + sbSelEl.getAttribute("el_id"));
                if (res != "TRUE")
                {
                    alert("' . PL_PAYMENT_SHOWHIDE_ERROR . '");
                    return;
                }

                var div_el = sbGetE("elems_list_div");
                var from = "";
                if (div_el)
                {
                    from = div_el.getAttribute("from");
                }
                var url = sb_cms_empty_file + "?event=" + sb_elems_event + "&id=" + sbCatTree.getSelectedItemId() + "&page_elems=" + from;
                sbElemsShow(url);
            }';
        $elems->addElemsMenuItem(PL_PAYMENT_ACTIVE_PAYMENT_MENU, 'paymentSetActive();');
    }
    $elems->init();
}

function fPayment_Edit($htmlStr = '', $footerStr = '')
{
    // проверка прав доступа
    if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'],
        'pl_payments')
    ) {
        return;
    }

    $cat_id = intval($_GET['cat_id']);

    $edit = false;
    $sp_ident = array();
    if (count($_POST) == 0 && isset($_GET['id']) && $_GET['id'] != '') {
        $result = sql_param_query('SELECT c.cat_left, c.cat_right, c.cat_title, c.cat_fields, p.sp_title, p.sp_status, p.sp_summ, p.sp_attr3, p.sp_name, p.sp_surname, p.sp_secname, p.sp_text, p.sp_comment, p.sp_date, p.sp_public, p.sp_user_id, p.sp_address, p.sp_email, p.sp_phone, p.sp_active
                            FROM sb_payments p, sb_catlinks l, sb_categs c WHERE p.sp_id = l.link_el_id
                            AND l.link_cat_id = c.cat_id  AND p.sp_id=?d AND c.cat_ident = "pl_payments"', $_GET['id']);

        if ($result) {
            list($cat_left, $cat_right, $cat_title, $sp_ident, $sp_title, $sp_status, $sp_summ, $sp_attr3, $sp_name, $sp_surname, $sp_secname, $sp_text, $sp_comment, $sp_date, $sp_public, $sp_user_id, $sp_address, $sp_email, $sp_phone, $sp_active) = $result[0];
        } else {
            sb_show_message(PL_PAYMENT_EDIT_ERROR, true, 'warning');
            return;
        }

        $sp_ident = unserialize($sp_ident);
        if (strpos($sp_ident['cat_ident'], 'pl_payment') === false) {
            $result = sql_query('SELECT cat_title, cat_fields FROM sb_categs WHERE cat_ident="pl_payment" AND cat_right > ' . $cat_right . ' AND cat_left < ' . $cat_left . ' AND cat_level=1');
            list($cat_title, $sp_ident) = $result[0];
            $sp_ident = unserialize($sp_ident);
        }

        if ($sp_attr3 != '') {
            $trans_data = unserialize($sp_attr3);
        }
    } elseif (count($_POST) > 0) {
        $sp_active = 0;

        extract($_POST);
        if (!isset($_GET['id'])) {
            $_GET['id'] = '';
        }

        $sp_date = sb_datetoint($sp_date);
    } else {
        $edit = true;
        $_GET['id'] = '';
        $result = sql_param_query('SELECT cat_left, cat_right, cat_title, cat_fields FROM sb_categs WHERE cat_id=?d',
            $cat_id);

        list($cat_left, $cat_right, $cat_title, $sp_ident) = $result[0];

        $sp_ident = unserialize($sp_ident);
        if (strpos($sp_ident['cat_ident'], 'pl_payment') === false) {
            $result = sql_query('SELECT cat_title, cat_fields FROM sb_categs WHERE cat_ident="pl_payments" AND cat_right > ' . $cat_right . ' AND cat_left < ' . $cat_left . ' AND cat_level=1');
            list($cat_title, $sp_ident) = $result[0];
            $sp_ident = unserialize($sp_ident);
        }

        $sp_active = 1;
        $sp_date = time();
        $sp_status = 0;
        $sp_summ = 0;
        $sp_title = $sp_attr3 = $sp_name = $sp_surname = $sp_secname = $sp_text = $sp_comment = $sp_address = $sp_email = $sp_phone = '';
        $sp_public = 0;
        $sp_user_id = -1;
    }

    if ($sp_ident['cat_ident'] != 'pl_payment_offline' && !isset($_GET['id'])) {
        sb_show_message(PL_PAYMENT_ELEMS_ERROR, true, 'warning');
        return;
    } elseif ($sp_ident['cat_ident'] == 'pl_payment_offline') {
        $edit = true;
    }

    echo '<script>
            function checkValues()
            {
                var el_title = sbGetE("sp_title");
                if (el_title.value == "")
                {
                     alert("' . PL_PAYMENT_EDIT_NO_TITLE_MSG . '");
                     return false;
                }
            }';
    if ($htmlStr != '') {
        echo '
            function cancel()
            {
                var res = new Object();
                res.html = "' . $htmlStr . '";
                res.footer = "' . $footerStr . '";
                res.footer_link = "";
                sbReturnValue(res);
            }
            sbAddEvent(window, "close", cancel);';
    }
    echo '</script>';

    require_once(SB_CMS_LIB_PATH . '/sbLayout.inc.php');

    $layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE . '?event=pl_payment_update' . ($_SERVER['QUERY_STRING'] != '' ? '&' . $_SERVER['QUERY_STRING'] : ''),
        'thisDialog', 'post', 'checkValues()', 'main', 'enctype="multipart/form-data"');

    $layout->mTableWidth = '95%';
    $layout->mTitleWidth = '200';

    $layout->addTab(PL_PAYMENT_EDIT_TAB1);
    if (count($_POST) == 0 && isset($_GET['id']) && $_GET['id'] == '') {
        $layout->addHeader(PL_PAYMENT_ADD_SCHET_TAB1);
    } else {
        $layout->addHeader(PL_PAYMENT_EDIT_SCHET_TAB1 . ' ' . $_GET['id']);
    }

    $layout->addField(PL_PAYMENT_TITLE,
        new sbLayoutInput('text', $sp_title, 'sp_title', '', 'style="width:440px;"', false));
    $layout->addField('', new sbLayoutInput('hidden', $sp_user_id, 'sp_user_id', '', '', false));

//    $layout->addField(KERNEL_STATIC_URL, new sbLayoutInput('text', $sp_url, 'sp_url', '', 'style="width:440px;"'));
//    $layout->addField('', new sbLayoutLabel('<div class="hint_div">'.KERNEL_STATIC_URL_HINT.'</div>', '', '', false));

    $layout->addField(PL_PAYMENT_EDIT_TITLE, new sbLayoutLabel('<b>' . $cat_title . '</b>', '', '', false));

    $stat = array();
    $stat[0] = PL_PAYMENT_STATUS_0;
    $stat[1] = PL_PAYMENT_STATUS_1;
    $stat[2] = PL_PAYMENT_STATUS_2;
    $stat[3] = PL_PAYMENT_STATUS_3;
    $stat[4] = PL_PAYMENT_STATUS_4;
    $stat[5] = PL_PAYMENT_STATUS_5;
    $stat[6] = PL_PAYMENT_STATUS_6;
    $stat[7] = PL_PAYMENT_STATUS_7;

    $fld = new sbLayoutSelect($stat, 'sp_status', '', '');
    $fld->mSelOptions = array($sp_status);
    $layout->addField(PL_PAYMENT_STATUS_EDIT, $fld);

    $layout->addField(PL_PAYMENT_EDIT_SUMM,
        new sbLayoutInput('text', $sp_summ, 'sp_summ', '', (!$edit ? 'READONLY' : ''), false));

    $sp_date = sb_date('d.m.Y H:i', $sp_date);

    $layout->addField(PL_PAYMENT_EDIT_PAYMENT_DATE,
        new sbLayoutDate($sp_date, 'sp_date', '', (!$edit ? 'READONLY' : '')));

    $layout->addField(PL_PAYMENT_DESIGN_SURNAME_TAG,
        new sbLayoutInput('text', $sp_surname, 'sp_surname', '', (!$edit ? 'READONLY' : ''), false));
    $layout->addField(PL_PAYMENT_DESIGN_NAME_TAG,
        new sbLayoutInput('text', $sp_name, 'sp_name', '', (!$edit ? 'READONLY' : ''), false));
    $layout->addField(PL_PAYMENT_DESIGN_SECNAME_TAG,
        new sbLayoutInput('text', $sp_secname, 'sp_secname', '', (!$edit ? 'READONLY' : ''), false));
    $layout->addField(PL_PAYMENT_DESIGN_EMAIL_TAG,
        new sbLayoutInput('text', $sp_email, 'sp_email', '', (!$edit ? 'READONLY' : ''), false));
    $layout->addField(PL_PAYMENT_DESIGN_PHONE_TAG,
        new sbLayoutInput('text', $sp_phone, 'sp_phone', '', (!$edit ? 'READONLY' : ''), false));

    $layout->addField(PL_PAYMENT_DESIGN_ADDRESS_TAG, new sbLayoutTextarea($sp_address, 'sp_address', '',
            (!$edit ? 'READONLY style="width:100%; height:70px;"' : 'style="width:100%; height:70px;"'), false));
    $layout->addField(PL_PAYMENT_DESIGN_TEXT_TAG, new sbLayoutTextarea($sp_text, 'sp_text', '',
            (!$edit ? 'READONLY style="width:100%; height:70px;"' : 'style="width:100%; height:70px;"'), false));
    $layout->addField(PL_PAYMENT_DESIGN_COMMENT_TAG, new sbLayoutTextarea($sp_comment, 'sp_comment', '',
            (!$edit ? 'READONLY style="width:100%; height:70px;"' : 'style="width:100%; height:70px;"'), false));

    $layout->addField(PL_PAYMENT_DESIGN_ANONYMOUS_PAYMENT,
        new sbLayoutInput('checkbox', '1', 'sp_public', '', ($sp_public == 1 ? 'checked="checked"' : ''), false));

    if ($_SESSION['sbPlugins']->isRightAvailable('pl_payment', 'elems_public')) {
        $layout->addField('', new sbLayoutDelim());
        $layout->addField(PL_PAYMENT_ACTIVE_PAYMENT,
            new sbLayoutInput('checkbox', '1', 'sp_active', '', ($sp_active == 1 ? 'checked="checked"' : '')));
    } else {
        $layout->addField('', new sbLayoutInput('hidden', 0, 'sp_active'));
    }

    $layout->getPluginFields('pl_payment', $_GET['id'], 'sp_id');
    if ($sp_attr3 != '') {
        $tabStr2 = "<table cellspacing='0' cellpadding='0' border='0' width='95%'>";
        $tabStr2 .= fPayment_Transaction_Props($sp_ident['cat_ident'], $trans_data);
        $tabStr2 .= "</table>";

        $layout->addTab(PL_PAYMENT_EDIT_TAB2);
        $layout->addHeader(PL_PAYMENT_EDIT_TAB2);
        $layout->addField('', new sbLayoutHTML($tabStr2, true));
    }

    $layout->addButton('submit', KERNEL_SAVE, 'btp_save', '',
        ($_SESSION['sbPlugins']->isRightAvailable('pl_payment', 'elems_edit') ? '' : 'disabled="disabled"'));
    if ($_GET['id'] != '') {
        $layout->addButton('submit', KERNEL_APPLY, 'btp_apply', '',
            ($_SESSION['sbPlugins']->isRightAvailable('pl_payment', 'elems_edit') ? '' : 'disabled="disabled"'));
    }
    $layout->addButton('button', KERNEL_CANCEL, '', '',
        $htmlStr != '' ? 'onclick="cancel()"' : 'onclick="sbCloseDialog()"');

    $layout->show();
}

function fPayment_Update()
{
    // проверка прав доступа
    if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'],
        'pl_payments')
    ) {
        return;
    }

    if (!isset($_GET['id'])) {
        $_GET['id'] = '';
    }

    $sp_title = $sp_name = $sp_surname = $sp_secname = $sp_email = $sp_phone = $sp_address = $sp_text = $sp_comment = '';
    $sp_status = 0;
    $sp_summ = 0;
    $sp_public = 0;
    $sp_date = 0;
    $sp_user_id = -1;
    $sp_active = 1;

    extract($_POST);

    if (!isset($_POST['sp_active'])) {
        $sp_active = 0;
    } else {
        $sp_active = 1;
    }

    if ($sp_date != '') {
        $sp_date = sb_datetoint($sp_date);
    }

    require_once(SB_CMS_LIB_PATH . '/sbLayout.inc.php');

    $layout = new sbLayout();
    $row = $layout->checkPluginFields('pl_payment', $_GET['id'], 'sp_id');

    if ($row === false) {
        $layout->deletePluginFieldsFiles();
        fPayment_Edit();
        return;
    }

    $row['sp_title'] = $sp_title;
    $row['sp_name'] = $sp_name;
    $row['sp_status'] = $sp_status;
    $row['sp_summ'] = $sp_summ;
    $row['sp_date'] = $sp_date;
    $row['sp_active'] = $sp_active;
    $row['sp_surname'] = $sp_surname;
    $row['sp_secname'] = $sp_secname;
    $row['sp_email'] = $sp_email;
    $row['sp_phone'] = $sp_phone;
    $row['sp_address'] = $sp_address;
    $row['sp_text'] = $sp_text;
    $row['sp_comment'] = $sp_comment;
    $row['sp_public'] = $sp_public;
    $row['sp_attr1'] = '';
    $row['sp_attr2'] = '';
    $row['sp_attr3'] = '';
    $row['sp_user_id'] = $sp_user_id;

    if ($_GET['id'] != '') {
        $res = sql_param_query('SELECT sp_title FROM sb_payments WHERE sp_id=?d', $_GET['id']);
        if ($res) {
            // редактирование
            list($old_title) = $res[0];

            sql_param_query('UPDATE sb_payments SET ?a WHERE sp_id=?d', $row, $_GET['id'],
                sprintf(PL_PAYMENT_EDIT_OK, $old_title));

            $footer_ar = fCategs_Edit_Elem();

            if (!$footer_ar) {
                sb_show_message(PL_PAYMENT_EDIT_ERROR, false, 'warning');
                sb_add_system_message(sprintf(PL_PAYMENT_EDIT_SYSTEMLOG_ERROR, $old_title), SB_MSG_WARNING);

                $layout->deletePluginFieldsFiles();
                fPayment_Edit();
                return;
            }

            $footer_str = $GLOBALS['sbSql']->escape($footer_ar[0], false, false);
            $row['sp_id'] = intval($_GET['id']);

            $html_str = fPayment_Get($row);
            $html_str = sb_str_replace(array("\r\n", "\r", "\n"), '', $html_str);
            $html_str = $GLOBALS['sbSql']->escape($html_str, false, false);

            if (!isset($_POST['btp_apply'])) {
                echo '<script>
                        var res = new Object();
                        res.html = "' . $html_str . '";
                        res.footer = "' . $footer_str . '";
                        res.footer_link = "";
                        sbReturnValue(res);
                      </script>';
            } else {
                fPayment_Edit($html_str, $footer_str);
            }
        } else {
            sb_show_message(PL_PAYMENT_EDIT_ERROR, false, 'warning');
            sb_add_system_message(sprintf(PL_PAYMENT_EDIT_SYSTEMLOG_ERROR, $sp_title), SB_MSG_WARNING);

            $layout->deletePluginFieldsFiles();
            fPayment_Edit();
            return;
        }
    } else {
        $error = true;
        sql_param_query('INSERT INTO sb_payments SET ?a', $row);
        $id = sql_insert_id();
        if ($id) {
            if (fCategs_Add_Elem($id)) {
                sb_add_system_message(sprintf(PL_PAYMENT_ADD_OK, $id));
                echo '<script>
                        sbReturnValue(' . $id . ');
                      </script>';
                $error = false;
            } else {
                sql_query('DELETE FROM sb_payments WHERE sp_id="' . $id . '"');
            }
        }

        if ($error) {
            sb_show_message(sprintf(PL_PAYMENT_ADD_ERROR, $sp_title), false, 'warning');
            sb_add_system_message(sprintf(PL_PAYMENT_ADD_SYSTEMLOG_ERROR, $sp_title), SB_MSG_WARNING);

            $layout->deletePluginFieldsFiles();
            fPayment_Edit();
            return;
        }
    }
}

function fPayment_Set_Active()
{
    $res = sql_param_query('SELECT sp_title, sp_active FROM sb_payments WHERE sp_id=?d', $_GET['id']);
    if ($res) {
        list($sp_title, $sp_active) = $res[0];
        $sp_active = $sp_active == 1 ? 0 : 1;

        if ($sp_active == 1) {
            sql_param_query('UPDATE sb_payments SET sp_active="1" WHERE sp_id=?d', $_GET['id'],
                sprintf(PL_PAYMENT_EDIT_OK, $sp_title));
        } else {
            sql_param_query('UPDATE sb_payments SET sp_active="0" WHERE sp_id=?d', $_GET['id'],
                sprintf(PL_PAYMENT_EDIT_OK, $sp_title));
        }

        echo 'TRUE';
    }
}


function fPayment_Cat_Fields()
{
    $arr = serialize(array('cat_ident' => ''));
    sql_param_query('UPDATE sb_categs SET cat_fields=? WHERE cat_id=?', $arr, $_GET['cat_id']);
}

function fPayment_Cat_Edit()
{
    if (!fCategs_Check_Rights($_GET['cat_id'])) {
        sb_show_message(SB_ELEMS_DENY_MSG, true, 'warning');
        return;
    }

    $res = sql_param_query('SELECT c.cat_ident, c.cat_fields, c.cat_title, c.cat_closed, s.sps_name, s.sps_value FROM sb_categs c LEFT JOIN sb_payments_settings s ON s.sps_cat_id = c.cat_id WHERE c.cat_id =?d',
        $_GET['cat_id']);

    $data = array();
    for ($i = 0; $i < count($res); $i++) {
        list($cat_iden, $cat_fields, $cat_title, $cat_closed, $sps_name, $sps_value) = $res[$i];
        $cat_fields = unserialize($cat_fields);

        if (isset($cat_fields['cat_ident'])) {
            $cat_ident = $cat_fields['cat_ident'];
        } else {
            $cat_ident = '';
        }
        $data[$sps_name] = $sps_value;
    }

    echo '<script>
            function checkValues()
            {
                var cat_title = sbGetE("cat_title");
                if (cat_title.value == "")
                {
                    alert("' . PL_PAYMENT_NO_TITLE_MSG . '");
                    cat_title.focus();
                    return false;
                }
                var cat_closed = sbGetE("close_cat");
                if (cat_closed && cat_closed.checked)
                {
                    var frm = sbGetE("main");
                    for (var i = 0; i < frm.elements.length; i++)
                    {
                        if (frm.elements[i].id.indexOf("group_ids") != -1 && frm.elements[i].value == "")
                        {
                            alert("' . PL_PAYMENT_NO_GROUPS_MSG . '");
                            return false;
                        }
                    }
                }
                return true;
            }

            var group_ident = "";
            function browseGroups(ident)
            {
                var el = document.getElementById("group_names" + ident);
                if (!el || el.disabled)
                    return;

                group_ident = ident;
                var group_ids = document.getElementById("group_ids" + ident).value;

                var strPage = "' . SB_CMS_MODAL_DIALOG_FILE . '?event=pl_site_users_get_groups&sel_cat_ids="+group_ids;
                var strAttr = "resizable=1,width=500,height=500";
                sbShowModalDialog(strPage, strAttr, afterBrowseGroups);
            }

            function afterBrowseGroups()
            {
                if (sbModalDialog.returnValue)
                {
                    var group_ids = document.getElementById("group_ids" + group_ident);
                    var group_names = document.getElementById("group_names" + group_ident);

                    group_ids.value = sbModalDialog.returnValue.ids;
                    group_names.value = sbModalDialog.returnValue.text;
                }
                group_ident = "";
            }

            function changeType(el)
            {
                var btns = new Array();
                var ids = new Array();
                var names = new Array();

                var frm = document.getElementById("main");

                for (var i = 0; i < frm.elements.length; i++)
                {
                    if (frm.elements[i].id.indexOf("group_names") != -1)
                    {
                        if (el.checked)
                        {
                            frm.elements[i].disabled = false;
                        }
                        else
                        {
                            frm.elements[i].disabled = true;
                            frm.elements[i].value = "";
                        }
                    }
                    else if (!el.checked && frm.elements[i].id.indexOf("group_ids") != -1)
                    {
                        frm.elements[i].value = "";
                    }
                }
            };';
    echo '</script>';

    require_once(SB_CMS_LIB_PATH . '/sbLayout.inc.php');

    $layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE . '?event=pl_payment_cat_update&cat_payment_ident=' . ($cat_ident != '' ? $cat_ident : '') . ($_SERVER['QUERY_STRING'] != '' ? '&' . $_SERVER['QUERY_STRING'] : ''),
        'thisDialog', 'post', 'checkValues()', 'main', 'enctype="multipart/form-data"');

    if (in_array($cat_ident, array('pl_payment_assist', 'pl_payment_chronopay', 'pl_payment_rupay','pl_payment_rfi_bank'))) {
        $layout->addTab(PL_PAYMENT_CAT_PARAM);
        if ($cat_ident == 'pl_payment_assist') {
            $layout->addHeader(PL_PAYMENT_CAT_ASSIST);
            $layout->addField('', new sbLayoutLabel('<div class="hint_div" style="color:red;">' . PL_PAYMENT_CHACK_CODE . '</div>', '', '', false));
            $layout->addField(PL_PAYMENT_ID_MAGAZINA,
                new sbLayoutInput('text', (isset($data['sps_option_id']) ? $data['sps_option_id'] : ''),
                    'sps_option_id', '', 'style="width:440px;"', false));

            $fld = new sbLayoutSelect($GLOBALS['sb_site_langs'], 'sps_option_lang');
            $fld->mSelOptions = array(isset($data['sps_option_lang']) ? $data['sps_option_lang'] : '');
            $layout->addField(PL_PAYMENT_DESIGN_EDIT_LANG, $fld);

            $currency = array(
                'RUR' => PL_PAYMENT_CURRENCY_RUR,
                'EUR' => PL_PAYMENT_CURRENCY_EUR,
                'USD' => PL_PAYMENT_CURRENCY_USD
            );

            $fld = new sbLayoutSelect($currency, 'sps_option_currency');
            $fld->mSelOptions = array(isset($data['sps_option_currency']) ? $data['sps_option_currency'] : '');
            $layout->addField(PL_PAYMENT_CURRENCY, $fld);

            $layout->addField(PL_PAYMENT_SETTINGS_ASSIST_LOGIN,
                new sbLayoutInput('text', isset($data['sps_option_login']) ? $data['sps_option_login'] : '',
                    'sps_option_login', '', '', false));
            $layout->addField(PL_PAYMENT_SETTINGS_ASSIST_PASSWORD,
                new sbLayoutInput('password', isset($data['sps_option_pass']) ? $data['sps_option_pass'] : '',
                    'sps_option_pass', '', '', false));

            $fld_1 = new sbLayoutInput('checkbox', '1', 'sps_option_payment_card', '',
                (isset($data['sps_option_payment_card']) && $data['sps_option_payment_card'] == 1 ? 'checked="checked"' : ''),
                false);
            $fld_2 = new sbLayoutInput('checkbox', '1', 'sps_option_payment_yandex', '',
                (isset($data['sps_option_payment_yandex']) && $data['sps_option_payment_yandex'] == 1 ? 'checked="checked"' : ''),
                false);
            $fld_3 = new sbLayoutInput('checkbox', '1', 'sps_option_payment_webmoney', '',
                (isset($data['sps_option_payment_webmoney']) && $data['sps_option_payment_webmoney'] == 1 ? 'checked="checked"' : ''),
                false);
            $fld_4 = new sbLayoutInput('checkbox', '1', 'sps_option_payment_qiwi', '',
                (isset($data['sps_option_payment_qiwi']) && $data['sps_option_payment_qiwi'] == 1 ? 'checked="checked"' : ''),
                false);

            $html = '<table style="margin-left:-3px;">
                <tr>
                    <td style="width:150px; text-align:left; vertical-align:top;">' . $fld_1->getField() . ' <span class="smalltext">' . PL_PAYMENT_CARD . '</span></td>
                    <td style="width:140px; text-align:left; vertical-align:top;">' . $fld_2->getField() . ' <span class="smalltext">' . PL_PAYMENT_YANDEX . '</span></td>
                    <td style="width:110px; text-align:left; vertical-align:top;">' . $fld_3->getField() . ' <span class="smalltext">' . PL_PAYMENT_WEB_MONEY . '</span></td>
                    <td style="width:110px; text-align:left; vertical-align:top;">' . $fld_4->getField() . ' <span class="smalltext">' . PL_PAYMENT_QIWI . '</span></td>
                </tr>
            </table>';

            $layout->addField(PL_PAYMENT_SETTINGS_ASSIST_TYPES, new sbLayoutHTML($html, false));
            $layout->addField(PL_PAYMENT_SETTINGS_ASSIST_DEMO,
                new sbLayoutInput('checkbox', '1', 'sps_option_payment_demo', '',
                    (isset($data['sps_option_payment_demo']) && @$data['sps_option_payment_demo'] == 1 ? 'checked="checked"' : ''),
                    false));
            $layout->addField('',
                new sbLayoutLabel('<div class="hint_div" style="color:red;">' . PL_PAYMENT_SETTINGS_DEMO . '</div>', '',
                    '', false));
        } elseif ($cat_ident == 'pl_payment_rfi_bank') {
            $layout->addHeader(PL_PAYMENT_CAT_RFI_BANK);
            $layout->addField('', new sbLayoutLabel('<div class="hint_div" style="color:red;">' . PL_PAYMENT_CHACK_CODE . '</div>', '', '', false));
            $layout->addField(PL_PAYMENT_ID_SERV,
                new sbLayoutInput('text', (isset($data['sps_option_serv_id']) ? $data['sps_option_serv_id'] : ''),
                    'sps_option_serv_id', '', 'style="width:440px;"', false));
            $layout->addField(PL_PAYMENT_KEY_MAGAZINA,
                new sbLayoutInput('text', (isset($data['sps_option_key']) ? $data['sps_option_key'] : ''),
                    'sps_option_key', '', 'style="width:440px;"', false));
            $layout->addField(PL_PAYMENT_SECRET_KEY_MAGAZINA,
                new sbLayoutInput('text', (isset($data['sps_option_secret_key']) ? $data['sps_option_secret_key'] : ''),
                    'sps_option_secret_key', '', 'style="width:440px;"', false));
        } elseif ($cat_ident == 'pl_payment_chronopay') {
            $layout->addHeader(PL_PAYMENT_CAT_CHRONOPAY);
            $layout->addField('', new sbLayoutLabel('<div class="hint_div" style="color:red;">' . PL_PAYMENT_CHACK_CODE . '</div>', '', '', false));
            $layout->addField(PL_PAYMENT_SETTINGS_CHRONOPAY_ID,
                new sbLayoutInput('text', isset($data['sps_option_id']) ? $data['sps_option_id'] : '', 'sps_option_id',
                    '', 'style="width:440px;"', false));
            $layout->addField(PL_PAYMENT_SETTINGS_CHRONOPAY_SITE_ID,
                new sbLayoutInput('text', isset($data['sps_option_site_id']) ? $data['sps_option_site_id'] : '',
                    'sps_option_site_id', '', 'style="width:440px;"', false));

            $layout->addField(PL_PAYMENT_SETTINGS_CHRONOPAY_ID, new sbLayoutInput('text', isset($data['sps_option_id']) ? $data['sps_option_id'] : '', 'sps_option_id', '', 'style="width:440px;"', false));
            $layout->addField(PL_PAYMENT_SETTINGS_CHRONOPAY_SITE_ID, new sbLayoutInput('text', isset($data['sps_option_site_id']) ? $data['sps_option_site_id'] : '', 'sps_option_site_id', '', 'style="width:440px;"', false));

            $fld = new sbLayoutSelect($GLOBALS['sb_site_langs'], 'sps_option_lang');
            $fld->mSelOptions = array(isset($data['sps_option_lang']) ? $data['sps_option_lang'] : '');
            $layout->addField(PL_PAYMENT_DESIGN_EDIT_LANG, $fld);

            $layout->addField(PL_PAYMENT_IP_SERVER,
                new sbLayoutInput('text', isset($data['sps_option_ip']) ? $data['sps_option_ip'] : '', 'sps_option_ip',
                    '', 'style="width:440px;"', false));
        } elseif ($cat_ident == 'pl_payment_rupay') {
            $layout->addHeader(PL_PAYMENT_CAT_RUPAY);
            $layout->addField('', new sbLayoutLabel('<div class="hint_div" style="color:red;">' . PL_PAYMENT_CHACK_CODE . '</div>', '', '', false));
            $layout->addField(PL_PAYMENT_RUPAY_SHOP_ID,
                new sbLayoutInput('text', isset($data['sps_option_rupay_id']) ? $data['sps_option_rupay_id'] : '',
                    'sps_option_rupay_id', '', 'style="width:440px;"', false));
            $layout->addField(PL_PAYMENT_RUPAY_BILL_ID, new sbLayoutInput('text',
                    isset($data['sps_option_rupay_account']) ? $data['sps_option_rupay_account'] : '',
                    'sps_option_rupay_account', '', 'style="width:440px;"', false));
            $layout->addField(PL_PAYMENT_RUPAY_SKEY,
                new sbLayoutInput('text', isset($data['sps_option_rupay_skey']) ? $data['sps_option_rupay_skey'] : '',
                    'sps_option_rupay_skey', '', 'style="width:440px;"', false));
        }

        $layout->addTab(PL_PAYMENT_NOTIFICATION);
        $layout->addHeader(PL_PAYMENT_NOTIFICATION);

        $payment_tags = array();
        $payment_tags_values = array();
        $layout->getPluginFieldsTags('pl_payment', $payment_tags, $payment_tags_values);

        $html = '<div align="center" class="hint_div" style="margin-top: 5px;">' . PL_PAYMENT_NOTIFICATION_USER . '</div>';
        $layout->addField('', new sbLayoutHTML($html, true));
        $layout->addField('', new sbLayoutDelim());

        $fld = new sbLayoutTextarea(isset($data['sps_option_useremail_topic']) ? $data['sps_option_useremail_topic'] : '',
            'sps_option_useremail_topic', '', 'style="width:100%; height:70px;"', false);
        $fld->mTags = array_merge(array(
            '{SP_ID}',
            '{SP_SURNAME}',
            '{SP_NAME}',
            '{SP_SECNAME}',
            '{SP_EMAIL}',
            '{SP_PHONE}',
            '{SP_ADDRESS}',
            '{SP_TEXT}',
            '{SP_COMMENT}',
            '{SP_SUMM}',
            '{SP_FULL_TEXT}',
            '{SP_DATE}'
        ), $payment_tags);
        $fld->mValues = array_merge(array(
            PL_PAYMENT_DESIGN_NUM_SCH_TAG,
            PL_PAYMENT_DESIGN_SURNAME_TAG,
            PL_PAYMENT_DESIGN_NAME_TAG,
            PL_PAYMENT_DESIGN_SECNAME_TAG,
            PL_PAYMENT_DESIGN_EMAIL_TAG,
            PL_PAYMENT_DESIGN_PHONE_TAG,
            PL_PAYMENT_DESIGN_ADDRESS_TAG,
            PL_PAYMENT_DESIGN_TEXT_TAG,
            PL_PAYMENT_DESIGN_COMMENT_TAG,
            PL_PAYMENT_DESIGN_SUMM_TAG,
            PL_PAYMENT_DETAILED_INF,
            PL_PAYMENT_DESIGN_DATE_TAG
        ), $payment_tags_values);
        $layout->addField(PL_PAYMENT_TITLE_MSG, $fld);

        $fld = new sbLayoutTextarea(isset($data['sps_option_useremail_message']) ? $data['sps_option_useremail_message'] : '',
            'sps_option_useremail_message', '', 'style="width:100%; height:70px;"', false);
        $fld->mTags = array_merge(array(
            '{SP_ID}',
            '{SP_SURNAME}',
            '{SP_NAME}',
            '{SP_SECNAME}',
            '{SP_EMAIL}',
            '{SP_PHONE}',
            '{SP_ADDRESS}',
            '{SP_TEXT}',
            '{SP_COMMENT}',
            '{SP_SUMM}',
            '{SP_FULL_TEXT}',
            '{SP_DATE}'
        ), $payment_tags);
        $fld->mValues = array_merge(array(
            PL_PAYMENT_DESIGN_NUM_SCH_TAG,
            PL_PAYMENT_DESIGN_SURNAME_TAG,
            PL_PAYMENT_DESIGN_NAME_TAG,
            PL_PAYMENT_DESIGN_SECNAME_TAG,
            PL_PAYMENT_DESIGN_EMAIL_TAG,
            PL_PAYMENT_DESIGN_PHONE_TAG,
            PL_PAYMENT_DESIGN_ADDRESS_TAG,
            PL_PAYMENT_DESIGN_TEXT_TAG,
            PL_PAYMENT_DESIGN_COMMENT_TAG,
            PL_PAYMENT_DESIGN_SUMM_TAG,
            PL_PAYMENT_DETAILED_INF,
            PL_PAYMENT_DESIGN_DATE_TAG
        ), $payment_tags_values);
        $layout->addField(PL_PAYMENT_TEXT_MSG, $fld);

        $html = '<div align="center" class="hint_div" style="margin-top: 5px;">' . PL_PAYMENT_NOTIFICATION_ADMIN . '</div>';
        $layout->addField('', new sbLayoutHTML($html, true));
        $layout->addField('', new sbLayoutDelim());

        $layout->addField(PL_PAYMENT_EMAIL_ADMIN,
            new sbLayoutInput('text', isset($data['sps_option_adminemail']) ? $data['sps_option_adminemail'] : '',
                'sps_option_adminemail', '', 'style="width:440px;"', false));

        $fld = new sbLayoutTextarea(isset($data['sps_option_adminemail_topic']) ? $data['sps_option_adminemail_topic'] : '',
            'sps_option_adminemail_topic', '', 'style="width:100%; height:70px;"', false);
        $fld->mTags = array_merge(array(
            '{SP_ID}',
            '{SP_SURNAME}',
            '{SP_NAME}',
            '{SP_SECNAME}',
            '{SP_EMAIL}',
            '{SP_PHONE}',
            '{SP_ADDRESS}',
            '{SP_TEXT}',
            '{SP_COMMENT}',
            '{SP_SUMM}',
            '{SP_FULL_TEXT}',
            '{SP_DATE}'
        ), $payment_tags);
        $fld->mValues = array_merge(array(
            PL_PAYMENT_DESIGN_NUM_SCH_TAG,
            PL_PAYMENT_DESIGN_SURNAME_TAG,
            PL_PAYMENT_DESIGN_NAME_TAG,
            PL_PAYMENT_DESIGN_SECNAME_TAG,
            PL_PAYMENT_DESIGN_EMAIL_TAG,
            PL_PAYMENT_DESIGN_PHONE_TAG,
            PL_PAYMENT_DESIGN_ADDRESS_TAG,
            PL_PAYMENT_DESIGN_TEXT_TAG,
            PL_PAYMENT_DESIGN_COMMENT_TAG,
            PL_PAYMENT_DESIGN_SUMM_TAG,
            PL_PAYMENT_DETAILED_INF,
            PL_PAYMENT_DESIGN_DATE_TAG
        ), $payment_tags_values);
        $layout->addField(PL_PAYMENT_TITLE_MSG, $fld);

        $fld = new sbLayoutTextarea(isset($data['sps_option_adminemail_message']) ? $data['sps_option_adminemail_message'] : '',
            'sps_option_adminemail_message', '', 'style="width:100%; height:70px;"', false);
        $fld->mTags = array_merge(array(
            '{SP_ID}',
            '{SP_SURNAME}',
            '{SP_NAME}',
            '{SP_SECNAME}',
            '{SP_EMAIL}',
            '{SP_PHONE}',
            '{SP_ADDRESS}',
            '{SP_TEXT}',
            '{SP_COMMENT}',
            '{SP_SUMM}',
            '{SP_FULL_TEXT}',
            '{SP_DATE}'
        ), $payment_tags);
        $fld->mValues = array_merge(array(
            PL_PAYMENT_DESIGN_NUM_SCH_TAG,
            PL_PAYMENT_DESIGN_SURNAME_TAG,
            PL_PAYMENT_DESIGN_NAME_TAG,
            PL_PAYMENT_DESIGN_SECNAME_TAG,
            PL_PAYMENT_DESIGN_EMAIL_TAG,
            PL_PAYMENT_DESIGN_PHONE_TAG,
            PL_PAYMENT_DESIGN_ADDRESS_TAG,
            PL_PAYMENT_DESIGN_TEXT_TAG,
            PL_PAYMENT_DESIGN_COMMENT_TAG,
            PL_PAYMENT_DESIGN_SUMM_TAG,
            PL_PAYMENT_DETAILED_INF,
            PL_PAYMENT_DESIGN_DATE_TAG
        ), $payment_tags_values);
        $layout->addField(PL_PAYMENT_TEXT_MSG, $fld);

        $layout->addTab(PL_PAYMENT_EXECUTION_PHP_CODE);
        $layout->addHeader(PL_PAYMENT_EXECUTION_PHP_CODE);

        $fld = new sbLayoutTextarea(isset($data['sps_option_php_code']) ? $data['sps_option_php_code'] : '',
            'sps_option_php_code', '', 'style="width:100%; height:200px;"', false);
        $fld->mTags = array(
            '{SP_ID}',
            '{SP_SURNAME}',
            '{SP_NAME}',
            '{SP_SECNAME}',
            '{SP_EMAIL}',
            '{SP_PHONE}',
            '{SP_ADDRESS}',
            '{SP_TEXT}',
            '{SP_COMMENT}',
            '{SP_SUMM}',
            '{SP_DATE}'
        );
        $fld->mValues = array(
            PL_PAYMENT_DESIGN_NUM_SCH_TAG,
            PL_PAYMENT_DESIGN_SURNAME_TAG,
            PL_PAYMENT_DESIGN_NAME_TAG,
            PL_PAYMENT_DESIGN_SECNAME_TAG,
            PL_PAYMENT_DESIGN_EMAIL_TAG,
            PL_PAYMENT_DESIGN_PHONE_TAG,
            PL_PAYMENT_DESIGN_ADDRESS_TAG,
            PL_PAYMENT_DESIGN_TEXT_TAG,
            PL_PAYMENT_DESIGN_COMMENT_TAG,
            PL_PAYMENT_DESIGN_SUMM_TAG,
            PL_PAYMENT_DESIGN_DATE_TAG
        );
        $layout->addField(PL_PAYMENT_PHP_CODE, $fld);
    } else {
        echo '<br /><br />';
        $layout->addHeader(PL_PAYMENT_EDIT_CATEG);
        $layout->addField(PL_PAYMENT_DESIGN_EDIT_CAT_TITLE_TAG,
            new sbLayoutInput('text', $cat_title, 'cat_title', '', 'style="width:440px;"', false));

        $layout->addField(PL_PAYMENT_CLOSE_CAT, new sbLayoutInput('checkbox', '1', 'close_cat', '',
                'onClick="changeType(this);" ' . (@$cat_closed == 1 ? 'checked="checked"' : '')));

        if (count($_SESSION['sb_categs_closed_descr'][$cat_iden]) == 0) {
            $_SESSION['sb_categs_closed_descr'][$cat_iden]['read'] = PL_PAYMENT_GROUPS;
        }

        foreach ($_SESSION['sb_categs_closed_descr'][$cat_iden] as $ident => $name) {
            $ident = $cat_iden . '_' . $ident;

            if (isset($_POST['group_ids' . $ident]) && isset($_POST['group_names' . $ident])) {
                $group_ids = $_POST['group_ids' . $ident];
                $group_names = $_POST['group_names' . $ident];
            } else {
                $group_ids = '';
                $group_names = '';
                $res = sql_param_query('SELECT group_ids FROM sb_catrights
                                        WHERE cat_id=?d AND right_ident=?', $_GET['cat_id'], $ident);
                if ($res) {
                    list($group_ids) = $res[0];
                    $ids = explode('^', trim($group_ids, '^'));

                    $res = sql_param_query('SELECT cat_title FROM sb_categs WHERE cat_id IN (?a)', $ids);
                    if ($res) {
                        $group_names = array();
                        foreach ($res as $value) {
                            $group_names[] = $value[0];
                        }
                        $group_names = implode(', ', $group_names);
                    } else {
                        $group_ids = '';
                    }
                }
            }
            $layout->addField('', new sbLayoutInput('hidden', $ident, 'ident_catrights'));
            $layout->addField('', new sbLayoutInput('hidden', $group_ids, 'group_ids' . $ident));

            $layout->addField($name, new sbLayoutHTML('
                <input id="group_names' . $ident . '" name="group_names' . $ident . '" readonly="readonly"' . (!$cat_closed ? ' disabled="disabled"' : '') . ' style="width:75%;" value="' . $group_names . '">&nbsp;&nbsp;
                <img class="button" src="' . SB_CMS_IMG_URL . '/users.png" width="20" height="20" align="absmiddle" id="group_btn' . $ident . '" onmouseup="sbPress(this, false);" onmousedown="sbPress(this, true);" onclick="browseGroups(\'' . $ident . '\');" title="' . KERNEL_BROWSE . '" />
                '));
        }
    }

    $layout->addButton('submit', KERNEL_SAVE, 'btp_save', '',
        ($_SESSION['sbPlugins']->isRightAvailable('pl_payment', 'elems_edit') ? '' : 'disabled="disabled"'));
    $layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog()"');
    $layout->show();
}

function fPayment_Cat_Update()
{
    if (!fCategs_Check_Rights($_GET['cat_id'])) {
        sb_show_message(SB_ELEMS_DENY_MSG, true, 'warning');
        return;
    }
    $error = false;

    $cat_title = '';
    $close_cat = 0;
    $group_idspl_payments_read = '';

    extract($_POST);

    if (isset($_POST['ident_catrights'])) {

        $resu = sql_param_query('UPDATE sb_catrights SET group_ids=?, right_ident=?  WHERE cat_id =?d ',
            $group_idspl_payments_read, $_POST['ident_catrights'], $_GET['cat_id']);
        if (!$resu) {
            sql_param_query('INSERT INTO sb_catrights SET cat_id=?d, group_ids=?, right_ident=?', $_GET['cat_id'],
                $group_idspl_payments_read, $_POST['ident_catrights']);
            $ins = sql_insert_id();
        }

        if ((!isset($ins) || !$ins) && !$resu) {
            $error = true;
        }
    }

    if ($_GET['cat_payment_ident'] == 'pl_payment_offline') {
        sql_param_query('UPDATE sb_categs SET cat_title=?, cat_closed=?d, cat_rights=? WHERE cat_id =?d ', $cat_title,
            $close_cat, $group_idspl_payments_read, $_GET['cat_id']);
    }
    sql_param_query('DELETE FROM sb_payments_settings WHERE sps_ident =? AND sps_cat_id =?d ',
        $_GET['cat_payment_ident'], $_GET['cat_id']);

    foreach ($_POST as $key => $value) {
        if (substr($key, 0, 11) == 'sps_option_' && $_GET['cat_payment_ident'] != '') {
            sql_param_query('INSERT INTO sb_payments_settings SET sps_cat_id =?d, sps_ident =?, sps_name =?, sps_value =?',
                $_GET['cat_id'], $_GET['cat_payment_ident'], $key, $value);
            $id = sql_insert_id();
            if (!$id) {
                $error = true;
            }
        }
    }

    $res = sql_param_query('SELECT cat_left, cat_right, cat_title FROM sb_categs WHERE cat_id=?d', $_GET['cat_id']);
    list($cat_left, $cat_right, $cat_title) = $res[0];

    $count_res = sql_query('SELECT COUNT(*) FROM sb_categs categs, sb_catlinks links WHERE categs.cat_ident=\'pl_payments\' AND categs.cat_left >= ' . $cat_left . ' AND categs.cat_right <= ' . $cat_right . ' AND links.link_cat_id=categs.cat_id');
    if ($count_res) {
        $cat_count = $count_res[0][0];
    } else {
        $cat_count = 0;
    }

    echo '<script>
        var res = new Object();
        res.cat_title = "' . str_replace('"', '\\"', $cat_title) . ' [' . $cat_count . ']";
        res.cat_closed = ' . $close_cat . ';
        res.cat_rubrik = "";
        sbReturnValue(res);
    </script>';

    if ($error) {
        sb_show_message(PL_PAYMENT_ER_SETTINGS, '', 'warning');
        fPayment_Cat_Edit();
        return;
    }
}

function fPayment_Cat_Delete()
{
    $res = sql_param_query('SELECT cat_fields FROM sb_categs WHERE cat_id=?d', $_GET['cat_id']);
    if ($res) {
        $res = unserialize($res[0][0]);

        if ($res['cat_ident'] == 'pl_payment_offline' ||
            $res['cat_ident'] == 'pl_payment_assist' ||
            $res['cat_ident'] == 'pl_payment_rupay' ||
            $res['cat_ident'] == 'pl_payment_chronopay' ||
            $res['cat_ident'] == 'pl_payment_rfi_bank'
        ) {
            echo PL_PAYMENT_CATEG_DELETE_ERROR;
        }
    }
}

function fPayment_Paste()
{
    $result = sql_param_query('SELECT cat_left, cat_right, cat_fields  FROM sb_categs  WHERE cat_id=?d',
        $_GET['new_cat_id']);
    list($cat_left, $cat_right, $new_cat_ident) = $result[0];
    $new_cat_ident = unserialize($new_cat_ident);

    if (strpos($new_cat_ident['cat_ident'], 'pl_payment') === false) {
        $result = sql_param_query('SELECT cat_fields FROM sb_categs WHERE cat_ident="pl_payments" AND cat_right > ?d AND cat_left < ?d AND cat_level=1',
            $cat_right, $cat_left);
        list($new_cat_ident) = $result[0];
        $new_cat_ident = unserialize($new_cat_ident);
    }

    $result = sql_param_query('SELECT cat_left, cat_right, cat_fields FROM sb_categs WHERE cat_id=?d',
        $_GET['old_cat_id']);
    list($cat_left, $cat_right, $old_cat_ident) = $result[0];
    $old_cat_ident = unserialize($old_cat_ident);

    if (strpos($old_cat_ident['cat_ident'], 'pl_payment') === false) {
        $result = sql_param_query('SELECT cat_fields FROM sb_categs WHERE cat_ident="pl_payments" AND cat_right > ?d AND cat_left < ?d AND cat_level=1',
            $cat_right, $cat_left);
        list($old_cat_ident) = $result[0];
        $old_cat_ident = unserialize($old_cat_ident);
    }

    if ($old_cat_ident['cat_ident'] != $new_cat_ident['cat_ident']) {
        echo PL_PAYMENT_COPY_ERROR;
    }
}


function fPayment_Design_List_Get($args)
{
    $result = '<b><a href="javascript:void(0);" onclick="sbElemsEdit(event);">' . $args['sptl_title'] . '</a></b>
    <div class="smalltext" style="margin-top:7px;">';

    static $view_info_pages = null;
    static $view_info_temps = null;

    if (is_null($view_info_pages)) {
        $view_info_pages = $_SESSION['sbPlugins']->isRightAvailable('pl_pages', 'read');
    }

    if (is_null($view_info_temps)) {
        $view_info_temps = $_SESSION['sbPlugins']->isRightAvailable('pl_templates', 'read');
    }

    $id = intval($args['sptl_id']);
    $pages = sql_query('SELECT pages.p_id, pages.p_name FROM sb_pages pages, sb_elems elems
                        WHERE elems.e_link="page" AND elems.e_temp_id="' . $id . '" AND elems.e_ident="pl_payment_list_transaction" AND pages.p_id=elems.e_p_id GROUP BY pages.p_id ORDER BY pages.p_name LIMIT 4');

    $temps = sql_query('SELECT temps.t_id, temps.t_name FROM sb_templates temps, sb_elems elems
                        WHERE elems.e_link="temp" AND elems.e_temp_id="' . $id . '" AND elems.e_ident="pl_payment_list_transaction" AND temps.t_id=elems.e_p_id GROUP BY temps.t_id ORDER BY temps.t_name LIMIT 4');
    if ($pages) {
        $result .= '<table cellpadding="0" cellspacing="0">
                    <tr>
                        <td valign="top" nowrap="nowrap" class="smalltext">' . KERNEL_USED_ON_PAGES . ':&nbsp;</td>
                        <td class="smalltext"><span style="color:green;">';
        $num = min(3, count($pages));
        for ($i = 0; $i < $num; $i++) {
            list($p_id, $p_name) = $pages[$i];
            $result .= ($view_info_pages ? '<a href="' . SB_CMS_CONTENT_FILE . '?event=pl_pages_init&sb_sel_id=' . $p_id . '">' . $p_name . '</a>' : $p_name) . ', ';
        }

        if ($num < count($pages)) {
            $result .= '&nbsp;<a href="javascript:void(0);" onclick="linkPages(event);">...</a>';
        } else {
            $result = substr($result, 0, -2);
        }

        $result .= '</span></td></tr></table>';
    } else {
        $result .= KERNEL_USED_ON_PAGES . ': <span style="color: red;">' . KERNEL_NOT_USED . '</span><br />';
    }

    if ($temps) {
        $result .= '<table cellpadding="0" cellspacing="0">
                    <tr>
                        <td valign="top" nowrap="nowrap" class="smalltext">' . KERNEL_USED_ON_TEMPS . ':&nbsp;</td>
                        <td class="smalltext"><span style="color:green;">';
        $num = min(3, count($temps));
        for ($i = 0; $i < $num; $i++) {
            list($t_id, $t_name) = $temps[$i];
            $result .= ($view_info_temps ? '<a href="' . SB_CMS_CONTENT_FILE . '?event=pl_templates_init&sb_sel_id=' . $t_id . '">' . $t_name . '</a>' : $t_name) . ', ';
        }

        if ($num < count($temps)) {
            $result .= '&nbsp;<a href="javascript:void(0);" onclick="linkTemps(event);">...</a>';
        } else {
            $result = substr($result, 0, -2);
        }
        $result .= '</span></td></tr></table>';
    } else {
        $result .= KERNEL_USED_ON_TEMPS . ': <span style="color: red;">' . KERNEL_NOT_USED . '</span><br />';
    }
    $result .= '</div>';
    return $result;
}

function fPayment_Temps_List()
{
    require_once(SB_CMS_LIB_PATH . '/sbElements.inc.php');
    $elems = new sbElements('sb_payments_temps_list', 'sptl_id', 'sptl_title', 'fPayment_Design_List_Get',
        'pl_payment_temps_list', 'pl_payments_temps_list');
    $elems->mCategsDeleteWithElementsMenu = true;

    $elems->mCategsRootName = KERNEL_DESIGN_ROOT_NAME;
    $elems->mElemsIcon = SB_CMS_IMG_URL . '/plugins/pl_payment_temps_32.png';

    $elems->addSorting(PL_PAYMENT_SORTING_TITILE, 'sptl_title');
    $elems->mCategsPasteElemsMenuTitle = KERNEL_DESIGN_PASTE_ELEMS_MENU_TITLE;

    $elems->mElemsAddMenuTitle = KERNEL_DESIGN_ELEMS_ADD_MENU_TITLE;
    $elems->mElemsEditMenuTitle = KERNEL_DESIGN_ELEMS_EDIT_MENU_TITLE;
    $elems->mElemsCopyMenuTitle = KERNEL_DESIGN_ELEMS_COPY_MENU_TITLE;
    $elems->mElemsCutMenuTitle = KERNEL_DESIGN_ELEMS_CUT_MENU_TITLE;

    $elems->mElemsEditEvent = 'pl_payment_temps_edit_list';
    $elems->mElemsEditDlgWidth = 900;
    $elems->mElemsEditDlgHeight = 700;

    $elems->mElemsAddEvent = 'pl_payment_temps_edit_list';
    $elems->mElemsAddDlgWidth = 900;
    $elems->mElemsAddDlgHeight = 700;

    $elems->mElemsDeleteEvent = 'pl_payment_temps_delete_list';

    $elems->mCategsClosed = false;
    $elems->mCategsRubrikator = false;
    $elems->mElemsUseLinks = false;

    $elems->mElemsJavascriptStr .= '
          function linkPages(e)
          {
              if (!sbSelEl)
              {
                  var el = sbEventTarget(e);

                  while (el.parentNode && !el.getAttribute("true_id"))
                      el = el.parentNode;

                  var el_id = el.getAttribute("el_id");
              }
              else
                  var el_id = sbSelEl.getAttribute("el_id");

              strPage = "' . SB_CMS_DIALOG_FILE . '?event=pl_pages_get_links&id=" + el_id + "&ident[]=pl_payment_temps_list";
              strAttr = "resizable=1,width=800,height=600";
              sbShowModalDialog(strPage, strAttr, null, window);
          }
          function linkTemps(e)
          {
              if (!sbSelEl)
              {
                  var el = sbEventTarget(e);

                  while (el.parentNode && !el.getAttribute("true_id"))
                      el = el.parentNode;

                  var el_id = el.getAttribute("el_id");
              }
              else
                  var el_id = sbSelEl.getAttribute("el_id");

              strPage = "' . SB_CMS_DIALOG_FILE . '?event=pl_templates_get_links&id=" + el_id + "&ident[]=pl_payment_temps_list";
              strAttr = "resizable=1,width=800,height=600";
              sbShowModalDialog(strPage, strAttr, null, window);
          }
          function paymentList()
          {
              window.location = "' . SB_CMS_CONTENT_FILE . '?event=pl_payment_init";
          }';

    $elems->addElemsMenuItem(KERNEL_LINK_PAGES_MENU_ITEM, 'linkPages();');
    $elems->addElemsMenuItem(KERNEL_LINK_TEMPS_MENU_ITEM, 'linkTemps();');
    $elems->addElemsMenuItem(PL_PAYMENT_LINK_MOVIES, 'paymentList();', false);

    $elems->init();

}

function fPayment_Temps_Edit_List($htmlStr = '', $footerStr = '')
{
    // проверка прав доступа
    if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'],
        'pl_payment_temps_list')
    ) {
        return;
    }

    if (count($_POST) == 0 && isset($_GET['id']) && $_GET['id'] != '') {
        $result = sql_param_query('SELECT sptl_title, sptl_list_header, sptl_categ_top, sptl_list_main, sptl_categ_bottom, sptl_list_footer,
            sptl_empty, sptl_delim, sptl_pagelist_id, sptl_count, sptl_perpage, sptl_lang, sptl_checked, sptl_no_transaction, sptl_fields_temps, sptl_categs_temps
            FROM sb_payments_temps_list WHERE sptl_id=?d', $_GET['id']);

        if ($result) {
            list($sptl_title, $sptl_list_header, $sptl_categ_top, $sptl_list_main, $sptl_categ_bottom, $sptl_list_footer, $sptl_empty, $sptl_delim,
                $sptl_pagelist_id, $sptl_count, $sptl_perpage, $sptl_lang, $sptl_checked, $sptl_no_transaction, $sptl_fields_temps, $sptl_categs_temps) = $result[0];
        } else {
            sb_show_message(PL_PAYMENT_DESIGN_EDIT_ERROR, true, 'warning');
            return;
        }

        if ($sptl_fields_temps != '') {
            $sptl_fields_temps = unserialize($sptl_fields_temps);
        } else {
            $sptl_fields_temps = array();
        }

        if ($sptl_categs_temps != '') {
            $sptl_categs_temps = unserialize($sptl_categs_temps);
        } else {
            $sptl_categs_temps = array();
        }

        if ($sptl_checked != '') {
            $sptl_checked = explode(' ', $sptl_checked);
        } else {
            $sptl_checked = array();
        }

    } elseif (count($_POST) > 0) {
        extract($_POST);
        if (!isset($_GET['id'])) {
            $_GET['id'] = '';
        }
    } else {
        $sptl_title = $sptl_list_header = $sptl_categ_top = $sptl_list_main = $sptl_categ_bottom = $sptl_list_footer = $sptl_empty = $sptl_delim =
        $sptl_no_transaction = '';
        $sptl_pagelist_id = -1;
        $sptl_count = 1;
        $sptl_perpage = 10;
        $sptl_lang = SB_CMS_LANG;
        $sptl_checked = array();
        $sptl_fields_temps =
        $sptl_categs_temps =

        $sptl_fields_temps = array();
        $sptl_fields_temps['sptl_date'] = '{DAY}.{MONTH}.{LONG_YEAR} {HOUR}:{MINUTE}';
        $sptl_fields_temps['sptl_surname'] = '{VALUE}';
        $sptl_fields_temps['sptl_name'] = '{VALUE}';
        $sptl_fields_temps['sptl_secname'] = '{VALUE}';
        $sptl_fields_temps['sptl_email'] = '{VALUE}';
        $sptl_fields_temps['sptl_phone'] = '{VALUE}';
        $sptl_fields_temps['sptl_address'] = '{VALUE}';
        $sptl_fields_temps['sptl_naznachenie'] = '{VALUE}';
        $sptl_fields_temps['sptl_comment'] = '{VALUE}';
        $sptl_fields_temps['sptl_summ'] = '{VALUE}';

        $sptl_categs_temps = array();
        $_GET['id'] = '';
    }

    echo '<script language="JavaScript" type="text/javascript">
            function checkValues()
            {
                var el_title = sbGetE("sptl_title");
                if (el_title.value == "")
                {
                     alert("' . PL_PAYMENT_DESIGN_NO_TITLE_MSG . '");
                     return false;
                }
            }';

    if ($htmlStr != '') {
        echo '
            function cancel()
            {
                var res = new Object();
                res.html = "' . $htmlStr . '";
                res.footer = "' . $footerStr . '";
                res.footer_link = "";
                sbReturnValue(res);
            }
            sbAddEvent(window, "close", cancel);';
    }
    echo '</script>';

    require_once(SB_CMS_LIB_PATH . '/sbLayout.inc.php');

    $layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE . '?event=pl_payment_temps_update_list' . ($_SERVER['QUERY_STRING'] != '' ? '&' . $_SERVER['QUERY_STRING'] : ''),
        'thisDialog', 'post', 'checkValues()');

    $layout->mTableWidth = '95%';
    $layout->mTitleWidth = '200';

    $layout->addTab(PL_PAYMENT_DESIGN_EDIT_TAB1);
    $layout->addHeader(PL_PAYMENT_DESIGN_EDIT_TAB1);

    $layout->addField(PL_PAYMENT_DESIGN_EDIT_TITLE,
        new sbLayoutInput('text', $sptl_title, 'sptl_title', '', 'style="width:450px;"'));
    $layout->addField('', new sbLayoutDelim());

    $fld = new sbLayoutSelect($GLOBALS['sb_site_langs'], 'sptl_lang');
    $fld->mSelOptions = array($sptl_lang);
    $fld->mHTML = '<div class="hint_div" style="margin-top: 5px;">' . PL_PAYMENT_DESIGN_EDIT_LANG_LABEL . '</div>';
    $layout->addField(PL_PAYMENT_DESIGN_EDIT_LANG, $fld);

    $res = sql_query('SELECT pd_fields FROM sb_plugins_data WHERE pd_plugin_ident="pl_payment"');
    if ($res) {
        list($pd_fields) = $res[0];
        if ($pd_fields != '') {
            $options = array();
            $pd_fields = unserialize($pd_fields);
            foreach ($pd_fields as $value) {
                if ($value['type'] == 'checkbox') {
                    $options[$value['id']] = $value['title'];
                }
            }

            if (count($options) > 0) {
                $fld = new sbLayoutSelect($options, 'sptl_checked[]', '', 'multiple="multiple"');
                $fld->mSelOptions = $sptl_checked;
                $fld->mHTML = '<div class="hint_div" style="margin-top: 5px;">' . PL_PAYMENT_DESIGN_EDIT_CHECKED_LABEL . '</div>';
                $layout->addField(PL_PAYMENT_DESIGN_EDIT_CHECKED, $fld);
            }
        }
    }

    $tags = array('{ID}', '{CAT_ID}', '{CAT_TITLE}');
    $tags_values = array(
        PL_PAYMENT_DESIGN_EDIT_ID_TAG,
        PL_PAYMENT_DESIGN_EDIT_CAT_ID_TAG,
        PL_PAYMENT_DESIGN_EDIT_CAT_TITLE_TAG
    );

    $res = sql_query('SELECT categs.cat_title, pager.pt_id, pager.pt_title FROM sb_categs categs, sb_catlinks links, sb_pager_temps pager WHERE pager.pt_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident=? ORDER BY categs.cat_left, pager.pt_title',
        'pl_pager_temps');
    if ($res) {
        $options = array();
        $old_cat_title = '';
        foreach ($res as $value) {
            list($cat_title, $pt_id, $pt_title) = $value;
            if ($old_cat_title != $cat_title) {
                $options[uniqid()] = '-' . $cat_title;
                $old_cat_title = $cat_title;
            }
            $options[$pt_id] = $pt_title;
        }
        $fld = new sbLayoutSelect($options, 'sptl_pagelist_id');
        $fld->mSelOptions = array($sptl_pagelist_id);
        $layout->addField(PL_PAYMENT_DESIGN_EDIT_NO_PAGER_TEMPS, $fld);
    } else {
        $layout->addField(PL_PAYMENT_DESIGN_EDIT_NO_PAGER_TEMPS,
            new sbLayoutLabel('<div class="hint_div">' . PL_PAYMENT_DESIGN_EDIT_NO_PAGER_TEMPS_LABEL . '</div>', '', '',
                false));
    }

    $layout->addField(PL_PAYMENT_DESIGN_EDIT_PERPAGE,
        new sbLayoutInput('text', $sptl_perpage, 'sptl_perpage', 'spin_spt_perpage', ''));
    $layout->addField('',
        new sbLayoutLabel('<div class="hint_div" style="margin-top: 5px;">' . PL_PAYMENT_DESIGN_EDIT_PERPAGE_LABEL . '</div>',
            '', '', false));

    $layout->addField('', new sbLayoutDelim());

    $layout->addField(PL_PAYMENT_DESIGN_NO_TRANS,
        new sbLayoutTextarea($sptl_no_transaction, 'sptl_no_transaction', '', 'style="width:100%;height:100px;"'));

    $layout->addTab(PL_PAYMENT_DESIGN_EDIT_TAB2);
    $layout->addHeader(PL_PAYMENT_DESIGN_EDIT_TAB2);

    $html = '<div align="center" class="hint_div" style="margin-top: 5px;">' . PL_PAYMENT_DESIGN_EDIT_TAB1 . '</div>';
    $layout->addField('', new sbLayoutHTML($html, true));
    $layout->addField('', new sbLayoutDelim());

    $fld = new sbLayoutTextarea($sptl_fields_temps['sptl_date'], 'sptl_fields_temps[sptl_date]', '',
        'style="width:100%;height:50px;"');
    $fld->mTags = array(
        '{DAY}',
        '{WEEKDAY}',
        '{WEEKDAY_SHORT}',
        '{MONTH}',
        '{MONTH_TEXTUAL}',
        '{LONG_YEAR}',
        '{SHORT_YEAR}',
        '{HOUR}',
        '{MINUTE}'
    );
    $fld->mValues = array(
        KERNEL_DAY_TAG,
        KERNEL_WEEKDAY_TAG_FULL,
        KERNEL_WEEKDAY_TAG_SHORT,
        KERNEL_MONTH_TAG,
        KERNEL_MONTH_NAME_TAG,
        KERNEL_YEAR_4_TAG,
        KERNEL_YEAR_2_TAG,
        KERNEL_HOURS_TAG,
        KERNEL_MINUTES_TAG
    );
    $layout->addField(PL_PAYMENT_EDIT_DATE, $fld);

    $fld = new sbLayoutTextarea($sptl_fields_temps['sptl_surname'], 'sptl_fields_temps[sptl_surname]', '',
        'style="width:100%;height:50px;"');
    $fld->mTags = array_merge(array('{VALUE}'), $tags);
    $fld->mValues = array_merge(array(PL_PAYMENT_DESIGN_SURNAME_TAG), $tags_values);
    $layout->addField(PL_PAYMENT_DESIGN_SURNAME_TAG, $fld);

    $fld = new sbLayoutTextarea($sptl_fields_temps['sptl_name'], 'sptl_fields_temps[sptl_name]', '',
        'style="width:100%;height:50px;"');
    $fld->mTags = array_merge(array('{VALUE}'), $tags);
    $fld->mValues = array_merge(array(PL_PAYMENT_DESIGN_NAME_TAG), $tags_values);
    $layout->addField(PL_PAYMENT_DESIGN_NAME_TAG, $fld);

    $fld = new sbLayoutTextarea($sptl_fields_temps['sptl_secname'], 'sptl_fields_temps[sptl_secname]', '',
        'style="width:100%;height:50px;"');
    $fld->mTags = array_merge(array('{VALUE}'), $tags);
    $fld->mValues = array_merge(array(PL_PAYMENT_DESIGN_SECNAME_TAG), $tags_values);
    $layout->addField(PL_PAYMENT_DESIGN_SECNAME_TAG, $fld);

    $fld = new sbLayoutTextarea($sptl_fields_temps['sptl_email'], 'sptl_fields_temps[sptl_email]', '',
        'style="width:100%;height:50px;"');
    $fld->mTags = array_merge(array('{VALUE}'), $tags);
    $fld->mValues = array_merge(array(PL_PAYMENT_DESIGN_EMAIL_TAG), $tags_values);
    $layout->addField(PL_PAYMENT_DESIGN_EMAIL_TAG, $fld);

    $fld = new sbLayoutTextarea($sptl_fields_temps['sptl_phone'], 'sptl_fields_temps[sptl_phone]', '',
        'style="width:100%;height:50px;"');
    $fld->mTags = array_merge(array('{VALUE}'), $tags);
    $fld->mValues = array_merge(array(PL_PAYMENT_DESIGN_PHONE_TAG), $tags_values);
    $layout->addField(PL_PAYMENT_DESIGN_PHONE_TAG, $fld);

    $fld = new sbLayoutTextarea($sptl_fields_temps['sptl_address'], 'sptl_fields_temps[sptl_address]', '',
        'style="width:100%;height:50px;"');
    $fld->mTags = array_merge(array('{VALUE}'), $tags);
    $fld->mValues = array_merge(array(PL_PAYMENT_DESIGN_ADDRESS_TAG), $tags_values);
    $layout->addField(PL_PAYMENT_DESIGN_ADDRESS_TAG, $fld);

    $fld = new sbLayoutTextarea($sptl_fields_temps['sptl_naznachenie'], 'sptl_fields_temps[sptl_naznachenie]', '',
        'style="width:100%;height:50px;"');
    $fld->mTags = array_merge(array('{VALUE}'), $tags);
    $fld->mValues = array_merge(array(PL_PAYMENT_DESIGN_TEXT_TAG), $tags_values);
    $layout->addField(PL_PAYMENT_DESIGN_TEXT_TAG, $fld);

    $fld = new sbLayoutTextarea($sptl_fields_temps['sptl_comment'], 'sptl_fields_temps[sptl_comment]', '',
        'style="width:100%;height:50px;"');
    $fld->mTags = array_merge(array('{VALUE}'), $tags);
    $fld->mValues = array_merge(array(PL_PAYMENT_DESIGN_COMMENT_TAG), $tags_values);
    $layout->addField(PL_PAYMENT_DESIGN_COMMENT_TAG, $fld);

    $fld = new sbLayoutTextarea($sptl_fields_temps['sptl_summ'], 'sptl_fields_temps[sptl_summ]', '',
        'style="width:100%;height:50px;"');
    $fld->mTags = array_merge(array('{VALUE}'), $tags);
    $fld->mValues = array_merge(array(PL_PAYMENT_DESIGN_SUMM_TAG), $tags_values);
    $layout->addField(PL_PAYMENT_DESIGN_SUMM_TAG, $fld);

    $layout->addPluginFieldsTemps('pl_payment', $sptl_fields_temps, 'sptl_', $tags, $tags_values);

    $cat_tags = array();
    $cat_tags_values = array();
    $layout->getPluginFieldsTags('pl_payment', $cat_tags, $cat_tags_values, true);

    $payment_tags = array();
    $payment_tags_values = array();
    $layout->getPluginFieldsTags('pl_payment', $payment_tags, $payment_tags_values);

    if (count($cat_tags) != 0) {
        $layout->addTab(PL_PAYMENT_DESIGN_EDIT_TAB3);
        $layout->addHeader(PL_PAYMENT_DESIGN_EDIT_TAB3);
        $layout->addPluginFieldsTemps('pl_payment', $sptl_categs_temps, 'sptl_', $tags, $tags_values, true);
    }

    $layout->addTab(PL_PAYMENT_DESIGN_EDIT_TAB5);
    $layout->addHeader(PL_PAYMENT_DESIGN_EDIT_TAB5);

    $fld = new sbLayoutInput('text', $sptl_count, 'sptl_count', 'spin_sptl_count', 'style="width:100px;"');
    $fld->mMinValue = 0;
    $layout->addField(PL_PAYMENT_DESIGN_EDIT_COUNT, $fld);

    $fld = new sbLayoutTextarea($sptl_list_header, 'sptl_list_header', '', 'style="width:100%; height:100px;"');
    $fld->mTags = array('{NUM_LIST}', '{ALL_COUNT}');
    $fld->mValues = array(PL_PAYMENT_DESIGN_PAGELIST_TAG, PL_PAYMENT_DESIGN_ALLNUM_TAG);
    $layout->addField(PL_PAYMENT_DESIGN_EDIT_TOP, $fld);

    $fld = new sbLayoutTextarea($sptl_categ_top, 'sptl_categ_top', '', 'style="width:100%;height:100px;"');
    $fld->mTags = array_merge(array('-', '{CAT_ID}', '{CAT_TITLE}', '{CAT_COUNT}', '{CAT_LEVEL}'), $cat_tags);
    $fld->mValues = array_merge(array(
            PL_PAYMENT_DESIGN_EDIT_CATEG_GROUP_TAG,
            PL_PAYMENT_DESIGN_EDIT_CATEG_ID_TAG,
            PL_PAYMENT_DESIGN_EDIT_CATEG_TITLE_TAG,
            PL_PAYMENT_DESIGN_EDIT_CATEG_NUM_TAG,
            PL_PAYMENT_DESIGN_EDIT_CATEG_LEVEL_TAG
        ), $cat_tags_values);
    $layout->addField(PL_PAYMENT_DESIGN_EDIT_CAT_TOP, $fld);

    $fld = new sbLayoutTextarea($sptl_list_main, 'sptl_list_main', '', 'style="width:100%; height:150px;"');
    $fld->mTags = array(
        '{SP_NUMBER}',
        '{SP_ID}',
        '{SP_SURNAME}',
        '{SP_NAME}',
        '{SP_SECNAME}',
        '{SP_EMAIL}',
        '{SP_PHONE}',
        '{SP_ADDRESS}',
        '{SP_TEXT}',
        '{SP_COMMENT}',
        '{SP_SUMM}',
        '{SP_DATE}',
        '{SP_CHANGE_DATE}'
    );
    $fld->mValues = array(
        PL_PAYMENT_DESIGN_SP_NUMBER_TAG,
        PL_PAYMENT_DESIGN_NUM_SCH_TAG,
        PL_PAYMENT_DESIGN_SURNAME_TAG,
        PL_PAYMENT_DESIGN_NAME_TAG,
        PL_PAYMENT_DESIGN_SECNAME_TAG,
        PL_PAYMENT_DESIGN_EMAIL_TAG,
        PL_PAYMENT_DESIGN_PHONE_TAG,
        PL_PAYMENT_DESIGN_ADDRESS_TAG,
        PL_PAYMENT_DESIGN_TEXT_TAG,
        PL_PAYMENT_DESIGN_COMMENT_TAG,
        PL_PAYMENT_DESIGN_SUMM_TAG,
        PL_PAYMENT_DESIGN_DATE_TAG,
        PL_PAYMENT_DESIGN_CHANGE_DATE_TAG
    );
    $layout->addField(PL_PAYMENT_TRANSACTION_ELEM, $fld);

    $fld = new sbLayoutTextarea($sptl_empty, 'sptl_empty', '', 'style="width:100%;height:100px;"');
    $layout->addField(PL_PAYMENT_DESIGN_EDIT_EMPTY, $fld);

    $fld = new sbLayoutTextarea($sptl_delim, 'sptl_delim', '', 'style="width:100%;height:100px;"');
    $layout->addField(PL_PAYMENT_DESIGN_EDIT_DELIM, $fld);

    $fld = new sbLayoutTextarea($sptl_categ_bottom, 'sptl_categ_bottom', '', 'style="width:100%;height:100px;"');
    $fld->mTags = array_merge(array('-', '{CAT_ID}', '{CAT_TITLE}', '{CAT_COUNT}', '{CAT_LEVEL}'), $cat_tags);
    $fld->mValues = array_merge(array(
            PL_PAYMENT_DESIGN_EDIT_CATEG_GROUP_TAG,
            PL_PAYMENT_DESIGN_EDIT_CATEG_ID_TAG,
            PL_PAYMENT_DESIGN_EDIT_CATEG_TITLE_TAG,
            PL_PAYMENT_DESIGN_EDIT_CATEG_NUM_TAG,
            PL_PAYMENT_DESIGN_EDIT_CATEG_LEVEL_TAG
        ), $cat_tags_values);
    $layout->addField(PL_PAYMENT_DESIGN_EDIT_CAT_BOTTOM, $fld);

    $fld = new sbLayoutTextarea($sptl_list_footer, 'sptl_list_footer', '', 'style="width:100%; height:100px;"');
    $fld->mTags = array('{NUM_LIST}', '{ALL_COUNT}');
    $fld->mValues = array(PL_PAYMENT_DESIGN_PAGELIST_TAG, PL_PAYMENT_DESIGN_ALLNUM_TAG);
    $layout->addField(PL_PAYMENT_DESIGN_EDIT_BOTTOM, $fld);

    $layout->addButton('submit', KERNEL_SAVE, 'btf_save', '',
        ($_SESSION['sbPlugins']->isRightAvailable('pl_services_rutube', 'design_edit') ? '' : 'disabled="disabled"'));
    if ($_GET['id'] != '') {
        $layout->addButton('submit', KERNEL_APPLY, 'btf_apply', '',
            ($_SESSION['sbPlugins']->isRightAvailable('pl_services_rutube',
                'design_edit') ? '' : 'disabled="disabled"'));
    }

    $layout->addButton('button', KERNEL_CANCEL, '', '',
        $htmlStr != '' ? 'onclick="cancel()"' : 'onclick="sbCloseDialog()"');
    $layout->show();
}

function fPayment_Temps_Update_List()
{
    // проверка прав доступа
    if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'],
        'pl_payment_temps_list')
    ) {
        return;
    }

    if (!isset($_GET['id'])) {
        $_GET['id'] = '';
    }

    $sptl_pagelist_id = -1;
    $sptl_checked = array();
    $sptl_lang = SB_CMS_LANG;
    $sptl_fields_temps = array();
    $sptl_categs_temps = array();

    $sptl_title = $sptl_list_header = $sptl_categ_top = $sptl_list_main = $sptl_categ_bottom = $sptl_list_footer = $sptl_empty = $sptl_delim =
    $sptl_no_transaction = '';
    $sptl_count = 1;
    $sptl_perpage = 10;

    extract($_POST);
    if ($sptl_title == '') {
        sb_show_message(PL_PAYMENT_DESIGN_NO_TITLE_MSG, false, 'warning');
        fPayment_Temps_Edit_List();
        return;
    }
    $row = array();

    $row['sptl_title'] = $sptl_title;
    $row['sptl_lang'] = $sptl_lang;
    $row['sptl_checked'] = implode(' ', $sptl_checked);
    $row['sptl_list_header'] = $sptl_list_header;
    $row['sptl_categ_top'] = $sptl_categ_top;
    $row['sptl_list_main'] = $sptl_list_main;
    $row['sptl_categ_bottom'] = $sptl_categ_bottom;
    $row['sptl_list_footer'] = $sptl_list_footer;
    $row['sptl_empty'] = $sptl_empty;
    $row['sptl_delim'] = $sptl_delim;
    $row['sptl_count'] = $sptl_count;
    $row['sptl_no_transaction'] = $sptl_no_transaction;
    $row['sptl_perpage'] = $sptl_perpage;
    $row['sptl_pagelist_id'] = $sptl_pagelist_id;
    $row['sptl_fields_temps'] = serialize($sptl_fields_temps);
    $row['sptl_categs_temps'] = serialize($sptl_categs_temps);

    if ($_GET['id'] != '') {
        $res = sql_param_query('SELECT sptl_title FROM sb_payments_temps_list WHERE sptl_id=?d', $_GET['id']);
        if ($res) {
            //редактирование
            list($old_title) = $res[0];

            sql_param_query('UPDATE sb_payments_temps_list SET ?a WHERE sptl_id=?d', $row, $_GET['id'],
                sprintf(PL_PAYMENT_DESIGN_EDIT_OK, $old_title));
            sbQueryCache::updateTemplate('sb_payments_temps_list', $_GET['id']);

            $footer_ar = fCategs_Edit_Elem();
            if (!$footer_ar) {
                sb_show_message(PL_PAYMENT_DESIGN_EDIT_ERROR, false, 'warning');
                sb_add_system_message(sprintf(PL_PAYMENT_DESIGN_EDIT_SYSTEMLOG_ERROR, $old_title), SB_MSG_WARNING);
                fPayment_Temps_Edit();
                return;
            }
            $footer_str = $GLOBALS['sbSql']->escape($footer_ar[0], false, false);

            $row['sptl_id'] = intval($_GET['id']);

            $html_str = fPayment_Design_List_Get($row);
            $html_str = sb_str_replace(array("\r\n", "\r", "\n"), '', $html_str);
            $html_str = $GLOBALS['sbSql']->escape($html_str, false, false);

            if (!isset($_POST['btf_apply'])) {
                echo '<script type="text/javascript" language="JavaScript">
                        var res = new Object();
                        res.html = "' . $html_str . '";
                        res.footer = "' . $footer_str . '";
                        res.footer_link = "";
                        sbReturnValue(res);
                    </script>';
            } else {
                fPayment_Temps_Edit_List($html_str, $footer_str);
            }
        } else {
            sb_show_message(PL_PAYMENT_DESIGN_EDIT_ERROR, false, 'warning');
            sb_add_system_message(sprintf(PL_PAYMENT_DESIGN_EDIT_SYSTEMLOG_ERROR, $sptl_title), SB_MSG_WARNING);
            fPayment_Temps_Edit_List();
            return;
        }
    } else {
        $error = true;
        if (sql_param_query('INSERT INTO sb_payments_temps_list SET ?a', $row)) {
            $id = sql_insert_id();

            if (fCategs_Add_Elem($id)) {
                sbQueryCache::updateTemplate('sb_payments_temps_list', $id);
                sb_add_system_message(sprintf(PL_PAYMENT_DESIGN_ADD_OK, $sptl_title));
                echo '<script type="text/javascript" language="JavaScript">
                        sbReturnValue(' . $id . ');
                      </script>';
                $error = false;
            } else {
                sql_query('DELETE FROM sb_payments_temps_list WHERE sptl_id="' . $id . '"');
            }
        }

        if ($error) {
            sb_show_message(sprintf(PL_PAYMENT_DESIGN_ADD_ERROR, $sptl_title), false, 'warning');
            sb_add_system_message(sprintf(PL_PAYMENT_DESIGN_ADD_SYSTEMLOG_ERROR, $sptl_title), SB_MSG_WARNING);
            fPayment_Temps_Edit();
            return;
        }
    }
}

function fPayment_Temps_Delete_List()
{
    $id = intval($_GET['id']);
    $pages = sql_query('SELECT pages.p_id FROM sb_pages pages, sb_elems elems
                        WHERE elems.e_link="page" AND elems.e_temp_id="' . $id . '" AND elems.e_ident="pl_payment_temp_list" AND pages.p_id=elems.e_p_id LIMIT 1');

    $temps = sql_query('SELECT temps.t_id FROM sb_templates temps, sb_elems elems
                        WHERE elems.e_link="temp" AND elems.e_temp_id="' . $id . '" AND elems.e_ident="pl_payment_temp_list" AND temps.t_id=elems.e_p_id LIMIT 1');

    if ($pages || $temps) {
        echo PL_PAYMENT_DESIGN_DELETE_ERROR;
    }

}


function fPayment_Temps_Get($args)
{
    $result = '<b><a href="javascript:void(0);" onclick="sbElemsEdit(event);">' . $args['spt_title'] . '</a></b>
    <div class="smalltext" style="margin-top:7px;">';

    static $view_info_pages = null;
    static $view_info_temps = null;

    if (is_null($view_info_pages)) {
        $view_info_pages = $_SESSION['sbPlugins']->isRightAvailable('pl_pages', 'read');
    }

    if (is_null($view_info_temps)) {
        $view_info_temps = $_SESSION['sbPlugins']->isRightAvailable('pl_templates', 'read');
    }

    $id = intval($args['spt_id']);
    $pages = sql_query('SELECT pages.p_id, pages.p_name FROM sb_pages pages, sb_elems elems
                        WHERE elems.e_link="page" AND elems.e_temp_id="' . $id . '" AND elems.e_ident="pl_payment_preform" AND pages.p_id=elems.e_p_id GROUP BY pages.p_id ORDER BY pages.p_name LIMIT 4');

    $temps = sql_query('SELECT temps.t_id, temps.t_name FROM sb_templates temps, sb_elems elems
                        WHERE elems.e_link="temp" AND elems.e_temp_id="' . $id . '" AND elems.e_ident="pl_payment_preform" AND temps.t_id=elems.e_p_id GROUP BY temps.t_id ORDER BY temps.t_name LIMIT 4');
    if ($pages) {
        $result .= '<table cellpadding="0" cellspacing="0">
                    <tr>
                        <td valign="top" nowrap="nowrap" class="smalltext">' . KERNEL_USED_ON_PAGES . ':&nbsp;</td>
                        <td class="smalltext"><span style="color:green;">';
        $num = min(3, count($pages));
        for ($i = 0; $i < $num; $i++) {
            list($p_id, $p_name) = $pages[$i];
            $result .= ($view_info_pages ? '<a href="' . SB_CMS_CONTENT_FILE . '?event=pl_pages_init&sb_sel_id=' . $p_id . '">' . $p_name . '</a>' : $p_name) . ', ';
        }

        if ($num < count($pages)) {
            $result .= '&nbsp;<a href="javascript:void(0);" onclick="linkPages(event);">...</a>';
        } else {
            $result = substr($result, 0, -2);
        }

        $result .= '</span></td></tr></table>';
    } else {
        $result .= KERNEL_USED_ON_PAGES . ': <span style="color: red;">' . KERNEL_NOT_USED . '</span><br />';
    }

    if ($temps) {
        $result .= '<table cellpadding="0" cellspacing="0">
                    <tr>
                        <td valign="top" nowrap="nowrap" class="smalltext">' . KERNEL_USED_ON_TEMPS . ':&nbsp;</td>
                        <td class="smalltext"><span style="color:green;">';

        $num = min(3, count($temps));
        for ($i = 0; $i < $num; $i++) {
            list($t_id, $t_name) = $temps[$i];
            $result .= ($view_info_temps ? '<a href="' . SB_CMS_CONTENT_FILE . '?event=pl_templates_init&sb_sel_id=' . $t_id . '">' . $t_name . '</a>' : $t_name) . ', ';
        }

        if ($num < count($temps)) {
            $result .= '&nbsp;<a href="javascript:void(0);" onclick="linkTemps(event);">...</a>';
        } else {
            $result = substr($result, 0, -2);
        }
        $result .= '</span></td></tr></table>';
    } else {
        $result .= KERNEL_USED_ON_TEMPS . ': <span style="color: red;">' . KERNEL_NOT_USED . '</span><br />';
    }

    $result .= '</div>';
    return $result;
}

function fPayment_Temps()
{
    require_once(SB_CMS_LIB_PATH . '/sbElements.inc.php');
    $elems = new sbElements('sb_payments_temps', 'spt_id', 'spt_title', 'fPayment_Temps_Get', 'pl_payment_temps',
        'pl_payment_temps');
    $elems->mCategsDeleteWithElementsMenu = true;

    $elems->mCategsRootName = KERNEL_DESIGN_ROOT_NAME;
    $elems->mElemsIcon = SB_CMS_IMG_URL . '/plugins/pl_payment_temps_32.png';

    $elems->mElemsAddMenuTitle = KERNEL_DESIGN_ELEMS_ADD_MENU_TITLE;
    $elems->mElemsEditMenuTitle = KERNEL_DESIGN_ELEMS_EDIT_MENU_TITLE;
    $elems->mElemsCopyMenuTitle = KERNEL_DESIGN_ELEMS_COPY_MENU_TITLE;
    $elems->mElemsCutMenuTitle = KERNEL_DESIGN_ELEMS_CUT_MENU_TITLE;

    $elems->mElemsAddEvent = 'pl_payment_temps_edit';
    $elems->mElemsAddDlgHeight = '700';
    $elems->mElemsAddDlgWidth = '800';

    $elems->mElemsEditEvent = 'pl_payment_temps_edit';
    $elems->mElemsEditDlgHeight = '700';
    $elems->mElemsEditDlgWidth = '800';

    $elems->mElemsDeleteEvent = 'pl_payment_temps_delete';
    $elems->addSorting(PL_PAYMENT_SORTING_TITILE, 'spt_title');

    $elems->mCategsClosed = false;
    $elems->mCategsRubrikator = false;
    $elems->mElemsUseLinks = false;

    $elems->mElemsJavascriptStr .= '
          function linkPages(e)
          {
              if (!sbSelEl)
              {
                  var el = sbEventTarget(e);

                  while (el.parentNode && !el.getAttribute("true_id"))
                      el = el.parentNode;

                  var el_id = el.getAttribute("el_id");
              }
              else
                  var el_id = sbSelEl.getAttribute("el_id");

              strPage = "' . SB_CMS_DIALOG_FILE . '?event=pl_pages_get_links&id=" + el_id + "&ident[]=pl_payment_list";
              strAttr = "resizable=1,width=800,height=600";
              sbShowModalDialog(strPage, strAttr, null, window);
          }
          function linkTemps(e)
          {
              if (!sbSelEl)
              {
                  var el = sbEventTarget(e);

                  while (el.parentNode && !el.getAttribute("true_id"))
                      el = el.parentNode;

                  var el_id = el.getAttribute("el_id");
              }
              else
                  var el_id = sbSelEl.getAttribute("el_id");

              strPage = "' . SB_CMS_DIALOG_FILE . '?event=pl_templates_get_links&id=" + el_id + "&ident[]=pl_payment_list";
              strAttr = "resizable=1,width=800,height=600";
              sbShowModalDialog(strPage, strAttr, null, window);
          }
          function paymentList()
          {
              window.location = "' . SB_CMS_CONTENT_FILE . '?event=pl_payment_init";
          }';

    $elems->addElemsMenuItem(KERNEL_LINK_PAGES_MENU_ITEM, 'linkPages();');
    $elems->addElemsMenuItem(KERNEL_LINK_TEMPS_MENU_ITEM, 'linkTemps();');
    $elems->addElemsMenuItem(PL_PAYMENT_LINK_MOVIES, 'paymentList();', false);

    $elems->init();
}

function fPayment_Temps_Edit($htmlStr = '', $footerStr = '')
{
    // проверка прав доступа
    if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'],
        'pl_payment_temps')
    ) {
        return;
    }

    if (count($_POST) == 0 && isset($_GET['id']) && $_GET['id'] != '') {
        $result = sql_param_query('SELECT spt_title, spt_lang, spt_prerequest_main, spt_confirm, spt_payment_descr, spt_fields_temps,
         spt_categs_temps, spt_system_messages FROM sb_payments_temps WHERE spt_id=?d', $_GET['id']);

        if ($result) {
            list($spt_title, $spt_lang, $spt_prerequest_main, $spt_confirm, $spt_payment_descr, $spt_fields_temps,
                $spt_categs_temps, $spt_system_messages) = $result[0];
        } else {
            sb_show_message(PL_PAYMENT_DESIGN_EDIT_ERROR, true, 'warning');
            return;
        }

        if ($spt_fields_temps != '') {
            $spt_fields_temps = unserialize($spt_fields_temps);
        } else {
            $spt_fields_temps = array();
        }

        if ($spt_categs_temps != '') {
            $spt_categs_temps = unserialize($spt_categs_temps);
        } else {
            $spt_categs_temps = array();
        }

        if ($spt_system_messages != '') {
            $spt_system_messages = unserialize($spt_system_messages);
        } else {
            $spt_system_messages = array();
        }
    } elseif (count($_POST) > 0) {
        extract($_POST);
        if (!isset($_GET['id'])) {
            $_GET['id'] = '';
        }
    } else {
        $spt_title = $spt_lang = $spt_prerequest_main = $spt_confirm = $spt_payment_descr = '';
        $spt_lang = SB_CMS_LANG;

        $spt_fields_temps = array();
        $spt_fields_temps['spt_date'] = '{DAY}.{MONTH}.{LONG_YEAR} {HOUR}:{MINUTE}';
        $spt_fields_temps['spt_payment_name'] = '{VALUE}';
        $spt_fields_temps['spt_surname'] = '{VALUE}';
        $spt_fields_temps['spt_name'] = '{VALUE}';
        $spt_fields_temps['spt_secname'] = '{VALUE}';
        $spt_fields_temps['spt_email'] = '{VALUE}';
        $spt_fields_temps['spt_phone'] = '{VALUE}';
        $spt_fields_temps['spt_address'] = '{VALUE}';
        $spt_fields_temps['spt_naznachenie'] = '{VALUE}';
        $spt_fields_temps['spt_comment'] = '{VALUE}';
        $spt_fields_temps['spt_summ'] = '{VALUE}';
        $spt_system_messages = array();
        $spt_system_messages['spt_err_anonymous'] = '';
        $spt_system_messages['spt_err_form'] = '';
        $spt_system_messages['spt_err_captcha'] = '';

        $spt_categs_temps = array();
        $_GET['id'] = '';
    }

    echo '<script language="JavaScript" type="text/javascript">
            function checkValues()
            {
                var el_title = sbGetE("spt_title");
                if (el_title.value == "")
                {
                     alert("' . PL_PAYMENT_DESIGN_NO_TITLE_MSG . '");
                     return false;
                }
            }';

    if ($htmlStr != '') {
        echo '
            function cancel()
            {
                var res = new Object();
                res.html = "' . $htmlStr . '";
                res.footer = "' . $footerStr . '";
                res.footer_link = "";
                sbReturnValue(res);
            }
            sbAddEvent(window, "close", cancel);';
    }
    echo '</script>';

    require_once(SB_CMS_LIB_PATH . '/sbLayout.inc.php');

    $layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE . '?event=pl_payment_temps_update' . ($_SERVER['QUERY_STRING'] != '' ? '&' . $_SERVER['QUERY_STRING'] : ''),
        'thisDialog', 'post', 'checkValues()');

    $layout->mTableWidth = '95%';
    $layout->mTitleWidth = '200';

    $layout->addTab(PL_PAYMENT_DESIGN_EDIT_TAB1);
    $layout->addHeader(PL_PAYMENT_DESIGN_EDIT_TAB1);

    $layout->addField(PL_PAYMENT_DESIGN_EDIT_TITLE,
        new sbLayoutInput('text', $spt_title, 'spt_title', '', 'style="width:450px;"'));
    $layout->addField('', new sbLayoutDelim());

    $fld = new sbLayoutSelect($GLOBALS['sb_site_langs'], 'spt_lang');
    $fld->mSelOptions = array($spt_lang);
    $fld->mHTML = '<div class="hint_div" style="margin-top: 5px;">' . PL_PAYMENT_DESIGN_EDIT_LANG_LABEL . '</div>';
    $layout->addField(PL_PAYMENT_DESIGN_EDIT_LANG, $fld);

    $tags = array('{ID}', '{CAT_ID}', '{CAT_TITLE}');
    $tags_values = array(
        PL_PAYMENT_DESIGN_EDIT_ID_TAG,
        PL_PAYMENT_DESIGN_EDIT_CAT_ID_TAG,
        PL_PAYMENT_DESIGN_EDIT_CAT_TITLE_TAG
    );

    $fld = new sbLayoutTextarea($spt_payment_descr, 'spt_payment_descr', '', 'style="width:100%;height:80px;"');
    $fld->mTags = array(
        '{SP_ID}',
        '{SP_SURNAME}',
        '{SP_NAME}',
        '{SP_SECNAME}',
        '{SP_EMAIL}',
        '{SP_PHONE}',
        '{SP_ADDRESS}',
        '{SP_PAYMENT_NAME}',
        '{SP_COMMENT}',
        '{SP_SUMM}'
    );
    $fld->mValues = array(
        PL_PAYMENT_DESIGN_NUM_SCH_TAG,
        PL_PAYMENT_DESIGN_SURNAME_TAG,
        PL_PAYMENT_DESIGN_NAME_TAG,
        PL_PAYMENT_DESIGN_SECNAME_TAG,
        PL_PAYMENT_DESIGN_EMAIL_TAG,
        PL_PAYMENT_DESIGN_PHONE_TAG,
        PL_PAYMENT_DESIGN_ADDRESS_TAG,
        PL_PAYMENT_DESIGN_TEXT_TAG,
        PL_PAYMENT_DESIGN_COMMENT_TAG,
        PL_PAYMENT_DESIGN_SUMM_TAG
    );
    $layout->addField(PL_PAYMENT_DESIGN_TEXT, $fld);

    $layout->addField('', new sbLayoutDelim());

    $layout->addField(PL_PAYMENT_DESIGN_ANONYMOUS,
        new sbLayoutTextarea($spt_system_messages['spt_err_anonymous'], 'spt_system_messages[spt_err_anonymous]', '',
            'style="width:100%;height:50px;"', ''));
    $layout->addField(PL_PAYMENT_DESIGN_ERROR_FORM,
        new sbLayoutTextarea($spt_system_messages['spt_err_form'], 'spt_system_messages[spt_err_form]', '',
            'style="width:100%;height:50px;"', ''));
    $layout->addField(PL_PAYMENT_DESIGN_CAPTCHA,
        new sbLayoutTextarea($spt_system_messages['spt_err_captcha'], 'spt_system_messages[spt_err_captcha]', '',
            'style="width:100%;height:50px;"', ''));

    $layout->addTab(PL_PAYMENT_DESIGN_EDIT_TAB2);
    $layout->addHeader(PL_PAYMENT_DESIGN_EDIT_TAB2);

    $html = '<div align="center" class="hint_div" style="margin-top: 5px;">' . PL_PAYMENT_DESIGN_EDIT_TAB1 . '</div>';
    $layout->addField('', new sbLayoutHTML($html, true));
    $layout->addField('', new sbLayoutDelim());

    $fld = new sbLayoutTextarea($spt_fields_temps['spt_date'], 'spt_fields_temps[spt_date]', '',
        'style="width:100%;height:50px;"');
    $fld->mTags = array(
        '{DAY}',
        '{WEEKDAY}',
        '{WEEKDAY_SHORT}',
        '{MONTH}',
        '{MONTH_TEXTUAL}',
        '{LONG_YEAR}',
        '{SHORT_YEAR}',
        '{HOUR}',
        '{MINUTE}'
    );
    $fld->mValues = array(
        KERNEL_DAY_TAG,
        KERNEL_WEEKDAY_TAG_FULL,
        KERNEL_WEEKDAY_TAG_SHORT,
        KERNEL_MONTH_TAG,
        KERNEL_MONTH_NAME_TAG,
        KERNEL_YEAR_4_TAG,
        KERNEL_YEAR_2_TAG,
        KERNEL_HOURS_TAG,
        KERNEL_MINUTES_TAG
    );
    $layout->addField(PL_PAYMENT_EDIT_DATE, $fld);

    $fld = new sbLayoutTextarea($spt_fields_temps['spt_surname'], 'spt_fields_temps[spt_surname]', '',
        'style="width:100%;height:50px;"');
    $fld->mTags = array_merge(array('{VALUE}'), $tags);
    $fld->mValues = array_merge(array(PL_PAYMENT_DESIGN_SURNAME_TAG), $tags_values);
    $layout->addField(PL_PAYMENT_DESIGN_SURNAME_TAG, $fld);

    $fld = new sbLayoutTextarea($spt_fields_temps['spt_name'], 'spt_fields_temps[spt_name]', '',
        'style="width:100%;height:50px;"');
    $fld->mTags = array_merge(array('{VALUE}'), $tags);
    $fld->mValues = array_merge(array(PL_PAYMENT_DESIGN_NAME_TAG), $tags_values);
    $layout->addField(PL_PAYMENT_DESIGN_NAME_TAG, $fld);

    $fld = new sbLayoutTextarea($spt_fields_temps['spt_secname'], 'spt_fields_temps[spt_secname]', '',
        'style="width:100%;height:50px;"');
    $fld->mTags = array_merge(array('{VALUE}'), $tags);
    $fld->mValues = array_merge(array(PL_PAYMENT_DESIGN_SECNAME_TAG), $tags_values);
    $layout->addField(PL_PAYMENT_DESIGN_SECNAME_TAG, $fld);

    $fld = new sbLayoutTextarea($spt_fields_temps['spt_email'], 'spt_fields_temps[spt_email]', '',
        'style="width:100%;height:50px;"');
    $fld->mTags = array_merge(array('{VALUE}'), $tags);
    $fld->mValues = array_merge(array(PL_PAYMENT_DESIGN_EMAIL_TAG), $tags_values);
    $layout->addField(PL_PAYMENT_DESIGN_EMAIL_TAG, $fld);

    $fld = new sbLayoutTextarea($spt_fields_temps['spt_phone'], 'spt_fields_temps[spt_phone]', '',
        'style="width:100%;height:50px;"');
    $fld->mTags = array_merge(array('{VALUE}'), $tags);
    $fld->mValues = array_merge(array(PL_PAYMENT_DESIGN_PHONE_TAG), $tags_values);
    $layout->addField(PL_PAYMENT_DESIGN_PHONE_TAG, $fld);

    $fld = new sbLayoutTextarea($spt_fields_temps['spt_address'], 'spt_fields_temps[spt_address]', '',
        'style="width:100%;height:50px;"');
    $fld->mTags = array_merge(array('{VALUE}'), $tags);
    $fld->mValues = array_merge(array(PL_PAYMENT_DESIGN_ADDRESS_TAG), $tags_values);
    $layout->addField(PL_PAYMENT_DESIGN_ADDRESS_TAG, $fld);

    $fld = new sbLayoutTextarea($spt_fields_temps['spt_payment_name'], 'spt_fields_temps[spt_payment_name]', '',
        'style="width:100%;height:50px;"');
    $fld->mTags = array_merge(array('{VALUE}'), $tags);
    $fld->mValues = array_merge(array(PL_PAYMENT_DESIGN_TEXT_TAG), $tags_values);
    $layout->addField(PL_PAYMENT_DESIGN_TEXT_TAG, $fld);

    $fld = new sbLayoutTextarea($spt_fields_temps['spt_comment'], 'spt_fields_temps[spt_comment]', '',
        'style="width:100%;height:50px;"');
    $fld->mTags = array_merge(array('{VALUE}'), $tags);
    $fld->mValues = array_merge(array(PL_PAYMENT_DESIGN_COMMENT_TAG), $tags_values);
    $layout->addField(PL_PAYMENT_DESIGN_COMMENT_TAG, $fld);

    $fld = new sbLayoutTextarea($spt_fields_temps['spt_summ'], 'spt_fields_temps[spt_summ]', '',
        'style="width:100%;height:50px;"');
    $fld->mTags = array_merge(array('{VALUE}'), $tags);
    $fld->mValues = array_merge(array(PL_PAYMENT_DESIGN_SUMM_TAG), $tags_values);
    $layout->addField(PL_PAYMENT_DESIGN_SUMM_TAG, $fld);

    $layout->addPluginFieldsTemps('pl_payment', $spt_fields_temps, 'spt_', $tags, $tags_values, false, '', '', '',
        false, true);

    $cat_tags = array();
    $cat_tags_values = array();
    $layout->getPluginFieldsTags('pl_payment', $cat_tags, $cat_tags_values, true, false, false, false, true);

    $payment_tags = array();
    $payment_tags_values = array();
    $layout->getPluginFieldsTags('pl_payment', $payment_tags, $payment_tags_values, false, false, false, false, true);

    if (count($cat_tags) != 0) {
        $layout->addTab(PL_PAYMENT_DESIGN_EDIT_TAB3);
        $layout->addHeader(PL_PAYMENT_DESIGN_EDIT_TAB3);
        $layout->addPluginFieldsTemps('pl_payment', $spt_categs_temps, 'spt_', $tags, $tags_values, true, '', '', '',
            false, true);
    }

    $layout->addTab(PL_PAYMENT_DESIGN_EDIT_TAB4);
    $layout->addHeader(PL_PAYMENT_DESIGN_EDIT_TAB4);

    $fld = new sbLayoutTextarea($spt_prerequest_main, 'spt_prerequest_main', '', 'style="width:100%; height:150px;"');
    $fld->mTags = array_merge(array(
        "{SP_SYSTEM_MESSAGE}",
        PL_PAYMENT_DESIGN_FORM_FORM_TAG,
        "<input type='text' name='sp_surname' value='{SP_SURNAME}'>",
        "<input type='text' name='sp_name' value='{SP_NAME}'>",
        "<input type='text' name='sp_secname' value='{SP_SECNAME}'>",
        "<input type='checkbox' name='sp_public' value='1' {SP_PUBLIC}>",
        "<input type='text' name='sp_email' value='{SP_EMAIL}'>",
        "<input type='text' name='sp_phone' value='{SP_PHONE}'>",
        "<input type='text' name='sp_address' value='{SP_ADDRESS}'>",
        "<input type='text' name='sp_text' value='{SP_TEXT}'>",
        "<textarea name='sp_comment'>{SP_COMMENT}</textarea>",
        "<input type='text' name='sp_summ' value='{SP_SUMM}'>",
        "<input type='text' name='sp_turing' size='17'>",
        "<input type='hidden' name='sp_turing_hid' value='{TEST_TURING_VALUE_HIDDEN}' />
    <img src='{TEST_TURING_SRC}' />"
    ), $payment_tags);

    $fld->mValues = array_merge(array(
        PL_PAYMENT_DESIGN_SYSTEM_MESSAGE,
        PL_PAYMENT_DESIGN_FORM_TAG,
        PL_PAYMENT_DESIGN_SURNAME_TAG,
        PL_PAYMENT_DESIGN_NAME_TAG,
        PL_PAYMENT_DESIGN_SECNAME_TAG,
        PL_PAYMENT_DESIGN_ANONYMOUS,
        PL_PAYMENT_DESIGN_EMAIL_TAG,
        PL_PAYMENT_DESIGN_PHONE_TAG,
        PL_PAYMENT_DESIGN_ADDRESS_TAG,
        PL_PAYMENT_DESIGN_TEXT_TAG,
        PL_PAYMENT_DESIGN_COMMENT_TAG,
        PL_PAYMENT_DESIGN_SUMM_TAG,
        PL_PAYMENT_DESIGN_CAPTCHA_TAG,
        PL_PAYMENT_DESIGN_CAPTCHA_IMG_TAG
    ), $payment_tags_values);

    $layout->addField(PL_PAYMENT_DESIGN_FORM, $fld);

    $fld = new sbLayoutTextarea($spt_confirm, 'spt_confirm', '', 'style="width:100%; height:150px;"');
    $fld->mTags = array_merge(array(
        "<form action='{SP_ACTION}' method='{SP_METHOD}'>{SP_FORM}</form>",
        '{SP_ID}',
        '{SP_SURNAME}',
        '{SP_NAME}',
        '{SP_SECNAME}',
        '{SP_PUBLIC}',
        '{SP_EMAIL}',
        '{SP_PHONE}',
        '{SP_ADDRESS}',
        '{SP_TEXT}',
        '{SP_COMMENT}',
        '{SP_SUMM}'
    ), $payment_tags);

    $fld->mValues = array_merge(array(
        PL_PAYMENT_DESIGN_SYSTEM_FORM_TAG,
        PL_PAYMENT_DESIGN_NUM_SCH_TAG,
        PL_PAYMENT_DESIGN_SURNAME_TAG,
        PL_PAYMENT_DESIGN_NAME_TAG,
        PL_PAYMENT_DESIGN_SECNAME_TAG,
        PL_PAYMENT_DESIGN_ANONYMOUS,
        PL_PAYMENT_DESIGN_EMAIL_TAG,
        PL_PAYMENT_DESIGN_PHONE_TAG,
        PL_PAYMENT_DESIGN_ADDRESS_TAG,
        PL_PAYMENT_DESIGN_TEXT_TAG,
        PL_PAYMENT_DESIGN_COMMENT_TAG,
        PL_PAYMENT_DESIGN_SUMM_TAG
    ), $payment_tags_values);
    $layout->addField(PL_PAYMENT_DESIGN_CONFIRM_INF, $fld);

    $payment_tags = array();
    $payment_tags_values = array();
    $layout->getPluginFieldsTags('pl_payment', $payment_tags, $payment_tags_values);

    $layout->addButton('submit', KERNEL_SAVE, 'btf_save', '',
        ($_SESSION['sbPlugins']->isRightAvailable('pl_payment', 'design_edit') ? '' : 'disabled="disabled"'));
    if ($_GET['id'] != '') {
        $layout->addButton('submit', KERNEL_APPLY, 'btf_apply', '',
            ($_SESSION['sbPlugins']->isRightAvailable('pl_payment', 'design_edit') ? '' : 'disabled="disabled"'));
    }
    $layout->addButton('button', KERNEL_CANCEL, '', '',
        $htmlStr != '' ? 'onclick="cancel()"' : 'onclick="sbCloseDialog()"');

    $layout->show();
}

function fPayment_Temps_Update()
{
    // проверка прав доступа
    if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'],
        'pl_payment_temps')
    ) {
        return;
    }

    if (!isset($_GET['id'])) {
        $_GET['id'] = '';
    }

    $spt_lang = SB_CMS_LANG;
    $spt_fields_temps = array();
    $spt_categs_temps = array();
    $spt_title = $spt_prerequest_main = $spt_confirm = $spt_payment_descr = '';
    $spt_system_messages = array();

    extract($_POST);
    if ($spt_title == '') {
        sb_show_message(PL_PAYMENT_DESIGN_NO_TITLE_MSG, false, 'warning');
        fPayment_Temps_Edit();
        return;
    }

    $row = array();
    $row['spt_title'] = $spt_title;
    $row['spt_lang'] = $spt_lang;
    $row['spt_prerequest_main'] = $spt_prerequest_main;
    $row['spt_confirm'] = $spt_confirm;
    $row['spt_payment_descr'] = $spt_payment_descr;
    $row['spt_system_messages'] = serialize($spt_system_messages);
    $row['spt_fields_temps'] = serialize($spt_fields_temps);
    $row['spt_categs_temps'] = serialize($spt_categs_temps);

    if ($_GET['id'] != '') {
        $res = sql_param_query('SELECT spt_title FROM sb_payments_temps WHERE spt_id=?d', $_GET['id']);
        if ($res) {
            //редактирование
            list($old_title) = $res[0];

            sql_param_query('UPDATE sb_payments_temps SET ?a WHERE spt_id=?d', $row, $_GET['id'],
                sprintf(PL_PAYMENT_DESIGN_EDIT_OK, $old_title));
            sbQueryCache::updateTemplate('sb_payments_temps', $_GET['id']);

            $footer_ar = fCategs_Edit_Elem('design_edit');
            if (!$footer_ar) {
                sb_show_message(PL_PAYMENT_DESIGN_EDIT_ERROR, false, 'warning');
                sb_add_system_message(sprintf(PL_PAYMENT_DESIGN_EDIT_SYSTEMLOG_ERROR, $old_title), SB_MSG_WARNING);
                fPayment_Temps_Edit();
                return;
            }
            $footer_str = $GLOBALS['sbSql']->escape($footer_ar[0], false, false);

            $row['spt_id'] = intval($_GET['id']);

            $html_str = fPayment_Temps_Get($row);
            $html_str = sb_str_replace(array("\r\n", "\r", "\n"), '', $html_str);
            $html_str = $GLOBALS['sbSql']->escape($html_str, false, false);

            if (!isset($_POST['btf_apply'])) {
                echo '<script type="text/javascript" language="JavaScript">
                        var res = new Object();
                        res.html = "' . $html_str . '";
                        res.footer = "' . $footer_str . '";
                        res.footer_link = "";
                        sbReturnValue(res);
                    </script>';
            } else {
                fPayment_Temps_Edit($html_str, $footer_str);
            }
        } else {
            sb_show_message(PL_PAYMENT_DESIGN_EDIT_ERROR, false, 'warning');
            sb_add_system_message(sprintf(PL_PAYMENT_DESIGN_EDIT_SYSTEMLOG_ERROR, $spt_title), SB_MSG_WARNING);
            fPayment_Temps_Edit();
            return;
        }
    } else {
        $error = true;
        if (sql_param_query('INSERT INTO sb_payments_temps SET ?a', $row)) {
            $id = sql_insert_id();

            if (fCategs_Add_Elem($id, 'design_edit')) {
                sbQueryCache::updateTemplate('sb_payments_temps', $id);
                sb_add_system_message(sprintf(PL_PAYMENT_DESIGN_ADD_OK, $spt_title));
                echo '<script type="text/javascript" language="JavaScript">
                        sbReturnValue(' . $id . ');
                      </script>';
                $error = false;
            } else {
                sql_query('DELETE FROM sb_payments_temps WHERE spt_id="' . $id . '"');
            }
        }

        if ($error) {
            sb_show_message(sprintf(PL_PAYMENT_DESIGN_ADD_ERROR, $spt_title), false, 'warning');
            sb_add_system_message(sprintf(PL_PAYMENT_DESIGN_ADD_SYSTEMLOG_ERROR, $spt_title), SB_MSG_WARNING);
            fPayment_Temps_Edit();
            return;
        }
    }
}

function fPayment_Temps_Delete()
{
    $id = intval($_GET['id']);
    $pages = sql_query('SELECT pages.p_id FROM sb_pages pages, sb_elems elems
                        WHERE elems.e_link="page" AND elems.e_temp_id="' . $id . '" AND elems.e_ident="pl_payment_temp_list" AND pages.p_id=elems.e_p_id LIMIT 1');

    $temps = sql_query('SELECT temps.t_id FROM sb_templates temps, sb_elems elems
                        WHERE elems.e_link="temp" AND elems.e_temp_id="' . $id . '" AND elems.e_ident="pl_payment_temp_list" AND temps.t_id=elems.e_p_id LIMIT 1');

    if ($pages || $temps) {
        echo PL_PAYMENT_DESIGN_DELETE_ERROR;
    }
}
