<?php
require_once(SB_CMS_LANG_PATH.'/pl_plugin_data.lng.php');

function fPluginData_Get_Modules_Data()
{
	require_once(SB_CMS_LANG_PATH.'/pl_plugin_data.lng.php');
	$cats_ids = preg_replace('/[^0-9\,]+/i', '', $_GET['cats_ids']);
	if($cats_ids == '')
	{
		$cats_ids = '0';
	}

	$elem_ids = isset($_GET['ids']) ? explode(',', preg_replace('/[^0-9\,]+/i', '', $_GET['ids'])) : array();
    $subcategs = $_GET['subcateg'] == 1 ? true : false;

    $ajax = isset($_GET['ajax']) && $_GET['ajax'] == 1 ? true : false;
    $readonly = isset($_GET['readonly']) && $_GET['readonly'] == 1 ? true : false;

	$root_cat_id = -1;
    if ($ajax && isset($_GET['cat_id']))
    	$root_cat_id = intval($_GET['cat_id']);

    $sql_params = getPluginSqlParams($_GET['plugin']);

    if (isset($_GET['fld']) && trim($_GET['fld']) != '')
    {
    	$fld = preg_replace('/[^A-Za-z_0-9]/', '', $_GET['fld']);
    }
    else
    {

    	$fld = $sql_params['title'];
    }

    $res = sql_query('SELECT MIN(cat_level) FROM sb_categs WHERE cat_id IN (0, '.$cats_ids.')');
	if (!$res)
    {
        sb_show_message(PL_SPRAV_H_NO_DATA_MSG, true, 'warning');
        return;
    }
    list($min_level) = $res[0];

    $root_cat_title = '';
    $result = '';

    if ($root_cat_id == -1 && $ajax)
    {
    	// Подгружаем разделы
    	$res = sql_query('SELECT -1, "", c.cat_id, c.cat_title, c.cat_level FROM sb_categs c
    		WHERE c.cat_id IN (0, '.$cats_ids.') AND c.cat_level=?d AND
    		(SELECT COUNT(*) FROM sb_categs c1, sb_catlinks l WHERE l.link_cat_id=c1.cat_id AND c1.cat_left >= c.cat_left AND c1.cat_right <= c.cat_right AND c1.cat_ident = ?) > 0
    		ORDER BY c.cat_left', $min_level, $_GET['plugin']);

    	if (!$res)
    	{
			sb_show_message(PL_PLUGIN_DATA_H_NO_DATA_MSG, true, 'warning');
			return;
		}
	}
	else
    {
    	if ($ajax)
    	{
    		$cat_res = sql_query('SELECT cat_title, cat_left, cat_right, cat_level FROM sb_categs WHERE cat_id=?d', $root_cat_id);
    		if ($cat_res)
    		{
    			list($root_cat_title, $cat_left, $cat_right, $min_level) = $cat_res[0];
    		}

    		if ($subcategs)
    		{
    			// вытаскиваем разделы
    			if ($cat_res)
    			{
   					$cat_res = sql_query('SELECT -1, "", c.cat_id, c.cat_title, c.cat_level FROM sb_categs c
   						WHERE c.cat_ident=? AND c.cat_level=?d AND c.cat_left > ?d AND c.cat_right < ?d AND
   						(SELECT COUNT(*) FROM sb_categs c1, sb_catlinks l WHERE l.link_cat_id=c1.cat_id AND c1.cat_left >= c.cat_left AND c1.cat_right <= c.cat_right AND c1.cat_ident = ?) > 0
   						ORDER BY cat_left', $_GET['plugin'], $min_level + 1, $cat_left, $cat_right, $_GET['plugin']);
    			}

    			// вытаскиваем элементы
    			$res = sql_query('SELECT s.'.$sql_params['id'].', s.'.$fld.', c.cat_id, c.cat_title, c.cat_level FROM '.$sql_params['table'].' s, sb_catlinks l, sb_categs c WHERE c.cat_id = ?d'.(isset($sql_params['show']) ? ' AND s.'.$sql_params['show'].' = 1' : '').' AND l.link_cat_id = ?d AND l.link_el_id=s.'.$sql_params['id'].' ORDER BY s.'.$sql_params['sort'].', s.'.$fld, $root_cat_id, $root_cat_id);

    			if (!$cat_res && !$res)
    			{
    				if ($root_cat_title != '')
    					echo '<img src="'.SB_CMS_IMG_URL.'/tree/folderOpen.gif" width="18" height="18">&nbsp;<b>'.$root_cat_title.'</b><br>';
    				return;
    			}

    			if ($cat_res && $res)
    				$res = array_merge($res, $cat_res);
    			elseif (!$res)
    				$res = $cat_res;
    		}
    		else
    		{
    			// вытаскиваем элементы
    			$res = sql_query('SELECT s.'.$sql_params['id'].', s.'.$fld.', c.cat_id, c.cat_title, c.cat_level FROM '.$sql_params['table'].' s, sb_catlinks l, sb_categs c WHERE c.cat_id = ?d'.(isset($sql_params['show']) ? ' AND s.'.$sql_params['show'].' = 1' : '').' AND l.link_cat_id = ?d AND l.link_el_id=s.'.$sql_params['id'].' ORDER BY s.'.$sql_params['sort'].', s.'.$fld, $root_cat_id, $root_cat_id);

    			if (!$res)
    			{
    				if ($root_cat_title != '')
    					echo '<img src="'.SB_CMS_IMG_URL.'/tree/folderOpen.gif" width="18" height="18">&nbsp;<b>'.$root_cat_title.'</b><br>';
    				return;
    			}
    		}
    	}
    	else
    	{
		    if ($subcategs)
		    {
		    	$res = sql_query('SELECT cat_left, cat_right FROM sb_categs WHERE cat_id IN (0, '.$cats_ids.')');
		        if ($res)
		        {
		            $sql = '(';
		            $num = count($res);
		            for ($i = 0; $i < $num; $i++)
		            {
		                list($left, $right) = $res[$i];
		                $sql .= 'c.cat_left >= '.$left.' AND c.cat_right <= '.$right.($i != $num - 1 ? ' OR ' : '');
		            }
		            $sql .= ')';

		            $res = sql_query('SELECT DISTINCT s.'.$sql_params['id'].', s.'.$fld.', c.cat_id, c.cat_title, c.cat_level
				            FROM ?# s, sb_catlinks l, sb_categs c
				            WHERE c.cat_ident=?'.(isset($sql_params['show']) ? ' AND s.'.$sql_params['show'].' = 1' : '').' AND '.$sql.' AND l.link_cat_id=c.cat_id AND l.link_el_id=s.'.$sql_params['id'].'
				            ORDER BY c.cat_left, s.'.$sql_params['sort'].', s.'.$fld, $sql_params['table'], $_GET['plugin']);
		        }
		    }
			else
		    {
				$res = sql_query('SELECT DISTINCT s.'.$sql_params['id'].', s.'.$fld.', c.cat_id, c.cat_title, c.cat_level
		        	FROM ?# s, sb_catlinks l, sb_categs c
		        	WHERE c.cat_id IN (0, '.$cats_ids.')'.(isset($sql_params['show']) ? ' AND s.'.$sql_params['show'].' = 1' : '').' AND l.link_cat_id = c.cat_id AND l.link_el_id=s.'.$sql_params['id'].'
		        	ORDER BY c.cat_left, s.'.$sql_params['sort'].', s.'.$fld, $sql_params['table']);
		    }
    	}
	}

	if (!$res || count($res) == 0)
	{
        sb_show_message(PL_PLUGIN_DATA_H_NO_DATA_MSG, true, 'warning');
        return;
    }

    if ($root_cat_id == -1)
    {
	    echo '<script>
	    	var ids_ar=[];
	    	var names_ar=[];
	    	';

	    if (count($elem_ids) > 0)
	    {
		    $modules_res = sql_query('SELECT '.$sql_params['id'].', '.$sql_params['title'].' FROM '.$sql_params['table'].' WHERE '.$sql_params['id'].' IN (?a) ORDER BY '.$sql_params['sort'].', '.$sql_params['title'].'', $elem_ids);
		    if ($modules_res)
		    {
			    foreach($modules_res as $value)
			    {
			    	echo 'ids_ar[ids_ar.length]='.$value[0].'; names_ar[names_ar.length]="'.str_replace('"', '\\"', $value[1]).'";';
			    }
		    }
	    }
	    echo '	function setChecked(el)
	    		{
	    			if (el.checked)
	    			{
	    				ids_ar[ids_ar.length]=el.value;
	    				names_ar[names_ar.length]=sbGetE("lbl_"+el.value).innerHTML;
	    			}
	    			else
	    			{
	    				for (var i = 0; i < ids_ar.length; i++)
	    				{
	    					if (ids_ar[i] == el.value)
	    					{
	    						ids_ar.splice(i, 1);
	    						names_ar.splice(i, 1);
	    						break;
	    					}
	    				}
	    			}
	    		}
	            function chooseData()
	            {
	                var separator = "'.str_replace('"', '\\"', $_GET['separator']).'";
	                var ids = "";
	                var names = "";
	                var found = 0;

	                for (var i = 0; i < ids_ar.length; i++)
		            {
		            	ids += ids_ar[i] + ",";
		            	if (found < 4)
	                        names += names_ar[i] + separator;

	                    found++;
		            }

	                if (found > 0)
	                {
	                    ids = ids.substr(0, ids.length -1);
	                    names = names.substr(0, names.length - separator.length);
	                    if (found > 4)
	                        names += " ...";
	                }

	                var res = new Object();
	                res.ids = ids;
	                res.text = names;

	                sbReturnValue(res);
	            }

	            var loading_cat = -1;
	            function loadData(cat_id)
	            {
	            	if (loading_cat > 0)
	            		return;

	            	loading_cat = cat_id;
	            	sbLoadAsync(sb_cms_empty_file + "?event=pl_plugin_data_get_modules_data&plugin='.$_GET['plugin'].'&ids='.$_GET['ids'].'&cats_ids='.$cats_ids.'&subcateg='.$_GET['subcateg'].'&ajax='.($ajax ? '1' : '0').'&readonly='.($readonly ? '1' : '0').'&separator='.$_GET['separator'].'&fld='.$_GET['fld'].'&cat_id=" + cat_id, afterLoadData);
	            	sbShowMsgDiv("'.KERNEL_LOADING.'", "loading.gif", false);
	            }
	            function afterLoadData(res)
	            {
	            	sbHideMsgDiv();

	            	var div_el = sbGetE("cat_" + loading_cat);
	            	if (res != "")
	            	{
	            		div_el.innerHTML = res;
	            	}
	            	loading_cat = -1;
	            }
                function switchCheckbox(catId)
                {
                    elem = document.getElementById("sel_" + catId);
                    elemsBlock = document.getElementById("cat_" + catId);
                    cState = elem.checked ? true : false;

                    elems = elemsBlock.getElementsByTagName("input");
                    for(i = 0; i < elems.length; i++)
                    {
                        if(elems[i] !== elem)
                        {
                            elems[i].checked = cState;
                            setChecked(elems[i]);   
                        }
                    }
                }
                function checkCategCheckbox()
                {
                    elemsBlock = document.getElementsByClassName("categBlock");

                    for(i = 0; i < elemsBlock.length; i++)
                    {
                        cState = true;
                        elems = elemsBlock[i].getElementsByTagName("input"); 
                        if(elems.length)
                        {
                            for(j = 0; j < elems.length; j++)
                            {
                                if(j !== 0 && elems[j].checked == false)
                                {
                                    cState = false;
                                }
                            }
                            elems[0].checked = cState;
                        }
                    }
                }
	            function resizeArea()
	            {
	                var tab_con_el = sbGetE("sb_tabs_con");
	                var tab_bot_el = sbGetE("sb_tabs_bottom");
	                if (tab_con_el && tab_bot_el)
	                {
	                    tab_con_el.style.height = Math.max(0, parseInt(document.body.clientHeight) - (_isIE ? 26 : 46) - parseInt(tab_bot_el.offsetHeight));
	                }
                    
                    checkCategCheckbox();
	            }

	            sbAddEvent(window, "load", resizeArea);
	            sbAddEvent(window, "resize", resizeArea);
	          </script>
	          <table cellpadding="0" cellspacing="0" border="0" width="100%" height="100%" style="background-color: #FFF5E0;">
	          <tr><td valign="top" class="sbTabsPage"><div id="sb_tabs_con">';
    }

    $num = count($res);
    $old_cat_id = -1;
    $num_divs = 0;
    for ($i = 0; $i < $num; $i++)
    {
        list($s_id, $s_title, $cat_id, $cat_title, $cat_level) = $res[$i];

        if ($old_cat_id != $cat_id)
        {
            if ($old_cat_id != -1)
            {
                $result .= str_repeat('</div>', $num_divs);
                $num_divs = 0;
            }

            if ($cat_id != $root_cat_id)
            {
            	$num_divs += 2;
	            if ($ajax)
	            {
	 				$result .= '<div style="margin:5px 0 0 '.(($cat_level - $min_level) * 20).'px" id="cat_'.$cat_id.'" class="categBlock"><a href="#" onclick="loadData('.$cat_id.')"><img src="'.SB_CMS_IMG_URL.'/tree/folderClosed.gif" width="18" height="18" border="0">&nbsp;<b>'.$cat_title.'</b></a><br /><div style="margin:5px 0px 5px 20px;">';
	            }
	            else
	            {
	            	$result .= '<div style="margin:5px 0 0 '.(($cat_level - $min_level) * 20).'px" id="cat_'.$cat_id.'" class="categBlock"><img src="'.SB_CMS_IMG_URL.'/tree/folderOpen.gif" width="18" height="18">&nbsp;<label><input type="checkbox" id="sel_'.$cat_id.'" onClick="switchCheckbox('.$cat_id.')" />&nbsp;<b>'.$cat_title.'</b></label><br><div style="margin:5px 0px 5px 22px;">';
	            }
            }
            else
            {
            	$num_divs++;
            	$result .= '<div style="margin:5px 0px 5px 20px;">';
            }

            $old_cat_id = $cat_id;
        }

        if ($s_id > 0)
        	$result .= '<input type="checkbox"'.($readonly ? ' disabled="disabled"' : '').' value="'.$s_id.'" id="chk_'.$s_id.'"'.(in_array($s_id, $elem_ids) ? ' checked="checked"' :'').' onclick="setChecked(this)">&nbsp;<label for="chk_'.$s_id.'" id="lbl_'.$s_id.'">'.strip_tags($s_title).'</label><br>';
    }
    $result .= str_repeat('</div>', $num_divs);

    if ($root_cat_id > 0)
    {
    	if ($root_cat_title == '')
    	{
	    	$res = sql_query('SELECT cat_title FROM sb_categs WHERE cat_id=?d', $root_cat_id);
	    	if ($res)
	    	{
	    		list($root_cat_title) = $res[0];
	    	}
    	}

    	if ($root_cat_title != '')
    		$result = '<img src="'.SB_CMS_IMG_URL.'/tree/folderOpen.gif" width="18" height="18">&nbsp;<b>'.$root_cat_title.'</b><br>'.$result;
    }

    echo $result;

    if ($root_cat_id == -1)
    {
    	echo '</div></td></tr>
          <tr><td id="sb_tabs_bottom" style="text-align: center;">
            <button onclick="chooseData();">'.KERNEL_CHOOSE.'</button>&nbsp;&nbsp;
            <button onclick="sbCloseDialog();">'.KERNEL_CANCEL.'</button>
          </td></tr></table>';
    }
}

function fPluginData_Get_Elements()
{
	$plugin = preg_replace('/[^A-Za-z_0-9]/', '', $_GET['ident']);

	if (!$_SESSION['sbPlugins']->isRightAvailable($plugin, 'read'))
	{
		sb_show_message(PL_PLUGIN_H_GET_ELEMENT_ERROR, true, 'warning');
		return;
	}

	require_once(SB_CMS_LIB_PATH.'/sbElements.inc.php');

	$el_id = -1;
	if(isset($_GET['el_id']))
		$el_id = intval(preg_replace('/[^0-9\,]+/i', '', $_GET['el_id']));

	if(sb_strpos($plugin,'pl_plugin') === false)
	{
		require_once(SB_CMS_LANG_PATH.'/'.$plugin.'.lng.php');
		require_once SB_CMS_PL_PATH.'/'.$plugin.'/'.$plugin.'.php';
	}
	elseif(sb_strpos($plugin,'pl_plugin') !== false)
	{
		require_once(SB_CMS_LANG_PATH.'/pl_plugin_maker.lng.php');
		require_once SB_CMS_PL_PATH.'/pl_plugin_maker/pl_plugin_maker.php';
	}

	$elems = '';

	if ($plugin == 'pl_news')
	{
		$title_prefix = 'n_';
		fNews_Init($elems, true);
	}
	elseif ($plugin == 'pl_imagelib')
	{
		$title_prefix = 'pl_imagelib_';
		fImagelib_Init($elems, true);
	}
	elseif ($plugin == 'pl_services_rutube')
	{
		$title_prefix = 'rutube_';
		fServices_Rutube_Init($elems, true);
	}
	elseif ($plugin == 'pl_faq')
	{
		$title_prefix = 'f_';
		fFaq_Init($elems, true);
	}
	elseif ($plugin == 'pl_polls')
	{
		$title_prefix = 'sp_';
		fPolls_Init($elems, true);
	}
	elseif (sb_strpos($plugin,'pl_plugin') !== false)
	{
		$title_prefix = 'p_';
		fPlugin_Maker_Plugins_Init($elems, true);
	}
	elseif ($plugin == 'pl_site_users')
	{
		$title_prefix = 'su_';
		fSite_Users_Init($elems, true);
	}

    if(isset($_GET['cat_only_ids']) && $_GET['cat_only_ids'] != '')
    {
        $ids = preg_replace('/[^0-9\,]+/i', '', $_GET['cat_only_ids']);
        $elems->mCategsShowOnlyCats = explode(',', $ids);
    }

    if(isset($_GET['cat_never_ids']) && $_GET['cat_never_ids'] != '')
    {
        $ids = preg_replace('/[^0-9\,]+/i', '', $_GET['cat_never_ids']);
        $elems->mCategsNeverShowCats = explode(',', $ids);
    }

	$elems->mElemsFooterStr = '<table cellspacing="0" cellpadding="7" width="100%" class="form">
        <tr>
            <th width="300">
                '.PL_PLUGIN_H_GET_ELEMENT_NAME.':
            </th>
            <td>
                <input type="text" id="element_title" value="" style="width: 400px;" onfocus="select()">
                <input type="hidden" id="element_id" value="'.($el_id > 0 ? $el_id : '').'">
            </td>
        </tr>
        <tr>
            <td class="footer" colspan="2">
            <div class="footer">
            <button onclick="choosePage();">'.KERNEL_CHOOSE.'</button>&nbsp;&nbsp;
            <button onclick="sbCloseDialog();">'.KERNEL_CANCEL.'</button>
            </div>
        </td></tr></table>';

	$elems->mElemsJavascriptStr .= '
        function selPage(el)
        {
        	var el_title = sbGetE("element_title");
            var el_id = sbGetE("element_id");
            if (el_title && el_id)
            {
                el_title.value = sbGetE("'.$title_prefix.'title_" + el.getAttribute("el_id")).innerHTML;
                el_id.value = el.getAttribute("el_id");
            }

        }
        function choosePage()
        {
            var el_title = sbGetE("element_title");
            var el_id = sbGetE("element_id");
            if (!el_title || !el_id || el_id.value == "")
            {
                alert("'.PL_PLUGIN_H_NO_ELEMENT_NAME_MSG.'");
                return;
            }

            var res = new Object();
            res.title = el_title.value;
            res.id = el_id.value;

            sbReturnValue(res);
        }
    ';
	$elems->mElemsClickFunc = 'selPage';
	$elems->mElemsSelectedId = $el_id;
	$elems->init();
}
?>