<?php
require_once(SB_CMS_LANG_PATH.'/pl_plugin_maker.h.lng.php');

if ($_SESSION['sbPlugins']->register('pl_plugin_maker', PL_PLUGIN_MAKER_H_PLUGIN_NAME, 'http://www.sbuilder.ru/docs/helps40/constr_mod.doc'))
{
    $_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.PL_PLUGIN_MAKER_H_PLUGIN_NAME, 'init');

    $_SESSION['sbPlugins']->addUserEvent('init', 'fPlugin_Maker_Init', 'read', PL_PLUGIN_MAKER_H_PLUGIN_NAME);
    $_SESSION['sbPlugins']->addUserEvent('edit','fPlugin_Maker_Edit','read', PL_PLUGIN_MAKER_H_EDIT_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('edit_submit','fPlugin_Maker_Edit_Submit', 'elems_edit', PL_PLUGIN_MAKER_H_EDIT_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('delete','fPlugin_Maker_Delete', 'elems_delete');
    $_SESSION['sbPlugins']->addUserEvent('paste','fPlugin_Maker_Paste', 'elems_edit');
}

$_SESSION['sbPlugins']->addEventsRights('categs_edit', RIGHTS_H_CATEGS_EDIT_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('categs_delete', RIGHTS_H_CATEGS_DELETE_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('categs_rights', RIGHTS_H_CATEGS_RIGHTS_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('elems_edit', PL_PLUGIN_MAKER_H_ELEMS_EDIT_RIGHTS);
$_SESSION['sbPlugins']->addEventsRights('elems_delete', PL_PLUGIN_MAKER_H_ELEMS_DELETE_RIGHTS);

if ($_SESSION['sbAuth']->checkPlugin('pl_plugin_maker'))
{
    // Инициализация модулей, которые мы собрали
    $res = sql_query('SELECT c.cat_id, c.cat_left, c.cat_right, c.cat_title, c.cat_level, pm.pm_id, pm.pm_title, pm.pm_settings, pm.pm_categs_settings, pm.pm_elems_settings
                            FROM sb_plugins_maker pm, sb_catlinks l, sb_categs c
                            WHERE c.cat_ident=? AND l.link_cat_id=c.cat_id
                            AND pm.pm_id=l.link_el_id ORDER BY pm.pm_title', 'pl_plugin_maker');

    if ($res)
    {
        foreach ($res as $value)
        {
            list($cat_id, $cat_left, $cat_right, $cat_title, $cat_level, $pm_id, $pm_title, $pm_settings, $pm_categs_settings, $pm_elems_settings) = $value;

            if ($pm_settings != '')
                $pm_settings = unserialize($pm_settings);
            else
                $pm_settings = array();

            if ($pm_categs_settings != '')
                $pm_categs_settings = unserialize($pm_categs_settings);
            else
                $pm_categs_settings = array();

            if ($pm_elems_settings != '')
                $pm_elems_settings = unserialize($pm_elems_settings);
            else
                $pm_elems_settings = array();

            $menu = '';
            if ($cat_level > 1)
            {
                $res_cat = sql_query('SELECT cat_title FROM sb_categs WHERE cat_left < '.$cat_left.' AND cat_right > '.$cat_right.' AND cat_ident="pl_plugin_maker" AND cat_level > 0 ORDER BY cat_left');
                if ($res_cat)
                {
                    foreach($res_cat as $val_cat)
                    {
                        $menu .= $val_cat[0].'>';
                    }
                }

                $menu .= $cat_title;
            }
            else
            {
                $menu = $cat_title;
            }

            $menu .= '>'.$pm_title;
            $_SESSION['sbPlugins']->mIcon = (isset($pm_elems_settings['icon']) ? $pm_elems_settings['icon'] : '');
            if (SB_HTTPS)
            {
                $_SESSION['sbPlugins']->mIcon = str_ireplace(array('http://www.'.SB_COOKIE_DOMAIN, 'http://'.SB_COOKIE_DOMAIN), SB_DOMAIN, $_SESSION['sbPlugins']->mIcon);
            }
            $_SESSION['sbPlugins']->mFile = SB_CMS_PL_PATH.'/pl_plugin_maker/pl_plugin_maker.php';
            $_SESSION['sbPlugins']->mLangFile = SB_CMS_LANG_PATH.'/pl_plugin_maker.lng.php';

            $elem_list = isset($pm_settings['list_component_title']) ? $pm_settings['list_component_title'] : PL_PLUGIN_MAKER_H_ELEM_LIST;
            $elem_full = isset($pm_settings['full_component_title']) ? $pm_settings['full_component_title'] : PL_PLUGIN_MAKER_H_ELEM_FULL;
            $elem_categs = isset($pm_settings['categs_component_title']) ? $pm_settings['categs_component_title'] : PL_PLUGIN_MAKER_H_ELEM_CATEGS;
            $elem_sel_cat = isset($pm_settings['sel_cat_component_title']) ? $pm_settings['sel_cat_component_title'] : PL_PLUGIN_MAKER_H_ELEM_SEL_CAT;
            $elem_form = isset($pm_settings['form_component_title']) ? $pm_settings['form_component_title'] : PL_PLUGIN_MAKER_H_ELEM_FORM;
            $elem_form_edit = isset($pm_settings['form_edit_component_title']) ? $pm_settings['form_edit_component_title'] : PL_PLUGIN_MAKER_H_ELEM_FORM_EDIT;
            $elem_informer = isset($pm_settings['informer_component_title']) ? $pm_settings['informer_component_title'] : PL_PLUGIN_MAKER_H_ELEM_INFORMER;
            $elem_filter = isset($pm_settings['filter_component_title']) ? $pm_settings['filter_component_title'] : PL_PLUGIN_MAKER_H_ELEM_FILTER;
            $elem_title_html = isset($pm_settings['title_html_component_title']) ? $pm_settings['title_html_component_title'] : PL_PLUGIN_MAKER_H_ELEM_TITLE_HTML;
            $elem_title_plain = isset($pm_settings['title_plain_component_title']) ? $pm_settings['title_plain_component_title'] : PL_PLUGIN_MAKER_H_ELEM_TITLE_PLAIN;
            $elem_cloud = isset($pm_settings['cloud_component_title']) ? $pm_settings['cloud_component_title'] : PL_PLUGIN_MAKER_H_ELEM_CLOUD;
            $export_allow = isset($pm_settings['export_allow']) ? intval($pm_settings['export_allow']) : 1;
            $import_allow = isset($pm_settings['import_allow']) ? intval($pm_settings['import_allow']) : 1;

            if ($_SESSION['sbPlugins']->register('pl_plugin_'.$pm_id, $pm_title, ''))
            {
                if($export_allow)
                {
                    $_SESSION['sbPlugins']->addToExportImport($export_allow, false);
                }
                
                $_SESSION['sbPlugins']->addToMenu($menu, 'init&pm_id='.$pm_id);

                $_SESSION['sbPlugins']->setMainEvent('init&pm_id='.$pm_id);

                if ($_SESSION['sbPlugins']->isRightAvailable('pl_plugin_'.$pm_id, 'design_read'))
                {
                    if ($elem_list != '')
                        $_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.$pm_title.'>'.$elem_list, 'design_list&pm_id='.$pm_id, 'pl_default_list_24.png');
                    if ($elem_full != '')
                        $_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.$pm_title.'>'.$elem_full, 'design_full&pm_id='.$pm_id, 'pl_default_full_24.png');

                    if (isset($pm_categs_settings['use_rubrikator']) && $pm_categs_settings['use_rubrikator'] != 0)
                    {
                        if ($elem_categs != '')
                            $_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.$pm_title.'>'.$elem_categs, 'design_categs&pm_id='.$pm_id, 'pl_default_categs_24.png');
                        if ($elem_sel_cat != '')
                            $_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.$pm_title.'>'.$elem_sel_cat, 'design_sel_cat&pm_id='.$pm_id, 'pl_default_sel_cat_24.png');
                    }

                    if ($elem_form != '')
                        $_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.$pm_title.'>'.$elem_form, 'design_form&pm_id='.$pm_id, 'pl_default_form_24.png');
                    if ($elem_filter != '')
                        $_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.$pm_title.'>'.$elem_filter, 'design_filter&pm_id='.$pm_id, 'pl_default_filter_form_24.png');
                    if ($elem_informer != '')
                        $_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.$pm_title.'>'.$elem_informer, 'informer_init&pm_id='.$pm_id, 'pl_default_informer_24.png');
                }

                $dopTitle = ' «'.$pm_title.'»';

                $_SESSION['sbPlugins']->addUserEvent('init', 'fPlugin_Maker_Plugins_Init', 'read', $pm_title);
                $_SESSION['sbPlugins']->addUserEvent('edit', 'fPlugin_Maker_Plugins_Edit','read', isset($pm_elems_settings['edit_item_title']) ? $pm_elems_settings['edit_item_title'] : SB_ELEMS_EDIT_MENU);
                $_SESSION['sbPlugins']->addUserEvent('edit_submit', 'fPlugin_Maker_Plugins_Edit_Submit', 'elems_edit', isset($pm_elems_settings['edit_item_title']) ? $pm_elems_settings['edit_item_title'] : SB_ELEMS_EDIT_MENU);
                $_SESSION['sbPlugins']->addUserEvent('set_active', 'fPlugin_Maker_Plugins_Set_Active', 'elems_edit');
                $_SESSION['sbPlugins']->addUserEvent('delete', 'fPlugin_Maker_Plugins_Delete', 'elems_delete');
                $_SESSION['sbPlugins']->addUserEvent('before_delete_cat_with_elements', 'fPlugin_Maker_Plugins_Before_Delete_With_Elements', 'elems_delete');
                $_SESSION['sbPlugins']->addUserEvent('paste', 'fPlugin_Maker_Plugins_Paste', 'elems_edit');
                $_SESSION['sbPlugins']->addUserEvent('after_paste_with_elements', 'fPlugin_Maker_After_Paste_Categs_With_Elements', 'categs_edit|elems_edit');

                $_SESSION['sbPlugins']->addUserEvent('edit_list', 'fPlugin_Maker_Goods_Edit', 'elems_edit', PL_PLUGIN_MAKER_H_GOODS_EDIT);
                $_SESSION['sbPlugins']->addUserEvent('edit_list_submit', 'fPlugin_Maker_Goods_Edit_Submit', 'elems_edit');
                $_SESSION['sbPlugins']->addUserEvent('list_reload', 'fPlugin_Maker_Goods_Reload', 'elems_edit');
                $_SESSION['sbPlugins']->addUserEvent('add_goods', 'fPlugin_Maker_Goods_Add', 'elems_edit');
                $_SESSION['sbPlugins']->addUserEvent('add_goods_submit', 'fPlugin_Maker_Goods_Add_Submit', 'elems_edit');
                $_SESSION['sbPlugins']->addUserEvent('good_settings', 'fPlugin_Maker_Goods_Settings', 'read');

                $_SESSION['sbPlugins']->addUserEvent('design_list', 'fPlugin_Maker_Plugins_Design_List', 'design_read', PL_PLUGIN_MAKER_H_DESIGN_LIST_TITLE . $dopTitle);
                $_SESSION['sbPlugins']->addUserEvent('design_list_edit', 'fPlugin_Maker_Plugins_Design_List_Edit', 'design_read', PL_PLUGIN_MAKER_H_DESIGN_EDIT_TITLE);
                $_SESSION['sbPlugins']->addUserEvent('design_list_edit_submit', 'fPlugin_Maker_Plugins_Design_List_Edit_Submit', 'design_edit', PL_PLUGIN_MAKER_H_DESIGN_EDIT_TITLE);
                $_SESSION['sbPlugins']->addUserEvent('design_list_delete', 'fPlugin_Maker_Plugins_Design_List_Delete', 'design_edit');

                $_SESSION['sbPlugins']->addUserEvent('design_full', 'fPlugin_Maker_Plugins_Design_Full', 'design_read', PL_PLUGIN_MAKER_H_DESIGN_FULL_TITLE . $dopTitle);
                $_SESSION['sbPlugins']->addUserEvent('design_full_edit', 'fPlugin_Maker_Plugins_Design_Full_Edit', 'design_read', PL_PLUGIN_MAKER_H_DESIGN_EDIT_TITLE);
                $_SESSION['sbPlugins']->addUserEvent('design_full_edit_submit', 'fPlugin_Maker_Plugins_Design_Full_Edit_Submit', 'design_edit', PL_PLUGIN_MAKER_H_DESIGN_EDIT_TITLE);
                $_SESSION['sbPlugins']->addUserEvent('design_full_delete', 'fPlugin_Maker_Plugins_Design_Full_Delete', 'design_edit');

                $_SESSION['sbPlugins']->addUserEvent('design_form', 'fPlugin_Maker_Plugins_Design_Form', 'design_read', PL_PLUGIN_MAKER_H_DESIGN_FORM_TITLE . $dopTitle);
                $_SESSION['sbPlugins']->addUserEvent('design_form_edit', 'fPlugin_Maker_Plugins_Design_Form_Edit', 'design_read', PL_PLUGIN_MAKER_H_DESIGN_EDIT_TITLE);
                $_SESSION['sbPlugins']->addUserEvent('design_form_edit_submit', 'fPlugin_Maker_Plugins_Design_Form_Edit_Submit', 'design_edit', PL_PLUGIN_MAKER_H_DESIGN_EDIT_TITLE);
                $_SESSION['sbPlugins']->addUserEvent('design_form_delete', 'fPlugin_Maker_Plugins_Design_Form_Delete', 'design_edit');

                $_SESSION['sbPlugins']->addUserEvent('design_filter', 'fPlugin_Maker_Plugins_Design_Filter', 'design_read', PL_PLUGIN_MAKER_H_DESIGN_FILTER_TITLE . $dopTitle);
                $_SESSION['sbPlugins']->addUserEvent('design_filter_edit', 'fPlugin_Maker_Plugins_Design_Filter_Edit', 'design_read', PL_PLUGIN_MAKER_H_DESIGN_EDIT_TITLE);
                $_SESSION['sbPlugins']->addUserEvent('design_filter_edit_submit', 'fPlugin_Maker_Plugins_Design_Filter_Edit_Submit', 'design_edit', PL_PLUGIN_MAKER_H_DESIGN_EDIT_TITLE);
                $_SESSION['sbPlugins']->addUserEvent('design_filter_delete', 'fPlugin_Maker_Plugins_Design_Filter_Delete', 'design_edit');

                $_SESSION['sbPlugins']->addUserEvent('informer_init', 'fPlugin_Maker_Informer_Design_Init', 'design_read', PL_PLUGIN_MAKER_H_DESIGN_INFORMER_DESIGNS . $dopTitle);
                $_SESSION['sbPlugins']->addUserEvent('informer_edit', 'fPlugin_Maker_Informer_Design_Edit', 'design_read', PL_PLUGIN_MAKER_H_DESIGN_EDIT_TITLE);
                $_SESSION['sbPlugins']->addUserEvent('informer_submit', 'fPlugin_Maker_Informer_Design_Submit', 'design_edit', PL_PLUGIN_MAKER_H_DESIGN_EDIT_TITLE);
                $_SESSION['sbPlugins']->addUserEvent('informer_delete', 'fPlugin_Maker_Informer_Design_Delete', 'design_edit');

                if (isset($pm_categs_settings['use_rubrikator']) && $pm_categs_settings['use_rubrikator'] != 0)
                {
                    $_SESSION['sbPlugins']->addUserEvent('design_categs', 'fPlugin_Maker_Design_Categs', 'design_read', PL_PLUGIN_MAKER_H_DESIGN_CATEGS_TITLE . $dopTitle);
                    $_SESSION['sbPlugins']->addUserEvent('design_categs_edit', 'fPlugin_Maker_Design_Categs_Edit', 'design_read', PL_PLUGIN_MAKER_H_DESIGN_EDIT_TITLE);
                    $_SESSION['sbPlugins']->addUserEvent('design_categs_edit_submit', 'fPlugin_Maker_Design_Categs_Edit_Submit', 'design_edit', PL_PLUGIN_MAKER_H_DESIGN_EDIT_TITLE);
                    $_SESSION['sbPlugins']->addUserEvent('design_categs_delete', 'fPlugin_Maker_Design_Categs_Delete', 'design_edit');

                    $_SESSION['sbPlugins']->addUserEvent('design_sel_cat', 'fPlugin_Maker_Design_Selcat', 'design_read', PL_PLUGIN_MAKER_H_DESIGN_SEL_CAT_TITLE . $dopTitle);
                    $_SESSION['sbPlugins']->addUserEvent('design_sel_cat_edit', 'fPlugin_Maker_Design_Selcat_Edit', 'design_read', PL_PLUGIN_MAKER_H_DESIGN_EDIT_TITLE);
                    $_SESSION['sbPlugins']->addUserEvent('design_sel_cat_edit_submit', 'fPlugin_Maker_Design_Selcat_Edit_Submit', 'design_edit', PL_PLUGIN_MAKER_H_DESIGN_EDIT_TITLE);
                    $_SESSION['sbPlugins']->addUserEvent('design_sel_cat_delete', 'fPlugin_Maker_Design_Selcat_Delete', 'design_edit');
                }

                $_SESSION['sbPlugins']->addToConstructor('sb_plugins_'.$pm_id);
                $_SESSION['sbPlugins']->addToCache();
                $_SESSION['sbPlugins']->addToWorkflow();
                $_SESSION['sbPlugins']->addToComments('sb_plugins_'.$pm_id, 'p_id', 'p_title', 'p_url');

                $fields = array();
                $fields['p_id'] = array('title' => PL_PLUGIN_H_ID_LABEL, 'flags' => '8', 'link_title' => '0', 'tag' => '');
                $fields['p_title'] = array('title' => (isset($pm_elems_settings['title_field_title']) && $pm_elems_settings['title_field_title'] != '' ? $pm_elems_settings['title_field_title'] : PL_PLUGIN_H_TITLE_LABEL), 'flags' => '4', 'link_title' => '1', 'tag' => '{OPT_STD_P_TITLE}');
                $fields['p_url'] = array('title' => PL_PLUGIN_H_URL_LABEL, 'flags' => '4', 'link_title' => '1', 'tag' => '{OPT_STD_P_URL}');
                $fields['p_pub_start'] = array('title' => PL_PLUGIN_H_PUB_START_LABEL, 'flags' => '9', 'link_title' => '0', 'tag' => '');
                $fields['p_pub_end'] = array('title' => PL_PLUGIN_H_PUB_END_LABEL, 'flags' => '9', 'link_title' => '0', 'tag' => '');
                $fields['p_sort'] = array('title' => PL_PLUGIN_H_SORT_LABEL, 'flags' => '8', 'link_title' => '0', 'tag' => '');
                $fields['p_active'] = array('title' => PL_PLUGIN_H_ACTIVE_LABEL, 'flags' => '8', 'link_title' => '0', 'tag' => '');
                $fields['p_ext_id'] = array('title' => PL_PLUGIN_H_EXT_ID_LABEL, 'flags' => '8', 'link_title' => '0', 'tag' => '');
                $fields['p_user_id'] = array('title' => PL_PLUGIN_H_USER_ID_LABEL, 'flags' => '8', 'link_title' => '0', 'tag' => '');
                $fields['p_order'] = array('title' => PL_PLUGIN_H_ORDER_LABEL, 'flags' => '7', 'link_title' => '0', 'tag' => '');
                $fields['p_price1'] = array('title' => PL_PLUGIN_MAKER_H_CENA_1, 'flags' => '8', 'link_title' => '0', 'tag' => '');
                $fields['p_price2'] = array('title' => PL_PLUGIN_MAKER_H_CENA_2, 'flags' => '8', 'link_title' => '0', 'tag' => '');
                $fields['p_price3'] = array('title' => PL_PLUGIN_MAKER_H_CENA_3, 'flags' => '8', 'link_title' => '0', 'tag' => '');
                $fields['p_price4'] = array('title' => PL_PLUGIN_MAKER_H_CENA_4, 'flags' => '8', 'link_title' => '0', 'tag' => '');
                $fields['p_price5'] = array('title' => PL_PLUGIN_MAKER_H_CENA_5, 'flags' => '8', 'link_title' => '0', 'tag' => '');

                $cat_fields = array();
                $cat_fields['moderates_list'] = array('title' => PL_PLUGIN_MAKER_H_MODERATES_LIST, 'flags' => '20');
                $cat_fields['categs_moderate_email'] = array('title' => PL_PLUGIN_MAKER_H_MODERATES_EMAILS, 'flags' => '4');

                $_SESSION['sbPlugins']->addFieldsInfo('sb_plugins_'.$pm_id, 'p_id', 'p_title', $fields, $cat_fields);
            }

            if (isset($pm_elems_settings['show_tags_field']) && $pm_elems_settings['show_tags_field'] != 0)
            {
                $_SESSION['sbPlugins']->addSystemEvent('elem_cloud', 'fPlugin_Maker_Get_Elem_Cloud', $elem_cloud);

                if ($elem_cloud != '')
                    $_SESSION['sbPlugins']->addElem($elem_cloud, 'cloud', 'fPlugin_Maker_Elem_Cloud', 'fPlugin_Maker_Elem_Cloud_Info', 'elem_cloud&pm_id='.$pm_id, 800, 700);
            }
            if (isset($pm_categs_settings['use_rubrikator']) && $pm_categs_settings['use_rubrikator'] != 0)
            {
                $_SESSION['sbPlugins']->addSystemEvent('elem_categs', 'fPlugin_Maker_Get_Elem_Categs', $elem_categs);
                $_SESSION['sbPlugins']->addSystemEvent('elem_sel_cat', 'fPlugin_Maker_Get_Elem_Sel_Cat', $elem_sel_cat);

                $_SESSION['sbPlugins']->addToRubrikator('pl_plugin_'.$pm_id, $pm_title, 'pl'.$pm_id, 'pl_plugin_'.$pm_id.'_design_categs', 'pl_plugin_'.$pm_id.'_design_sel_cat');

                if ($elem_categs != '')
                    $_SESSION['sbPlugins']->addElem($elem_categs, 'categs', 'fPlugin_Maker_Elem_Categs', 'fPlugin_Maker_Elem_Categs_Info', 'elem_categs&pm_id='.$pm_id, 800, 700, 'design_categs_edit&pm_id='.$pm_id, 'pl_plugin_'.$pm_id.'_design_categs');
                if ($elem_sel_cat != '')
                    $_SESSION['sbPlugins']->addElem($elem_sel_cat, 'sel_cat', 'fPlugin_Maker_Elem_Sel_Cat', 'fPlugin_Maker_Elem_Sel_Cat_Info', 'elem_sel_cat&pm_id='.$pm_id, 800, 700, 'design_sel_cat_edit&pm_id='.$pm_id, 'pl_plugin_'.$pm_id.'_design_sel_cat');
            }

            $_SESSION['sbPlugins']->addToCalendar('list', 'fPlugin_Maker_Get_Calendar', 'pl_plugin_maker/prog/pl_plugin_maker.php', array());

            $_SESSION['sbPlugins']->addSystemEvent('elem_list', 'fPlugin_Maker_Get_Elem_List', $elem_list);
            $_SESSION['sbPlugins']->addSystemEvent('elem_full', 'fPlugin_Maker_Get_Elem_Full', $elem_full);
            $_SESSION['sbPlugins']->addSystemEvent('elem_form', 'fPlugin_Maker_Get_Elem_Form', $elem_form);
            $_SESSION['sbPlugins']->addSystemEvent('elem_form_edit', 'fPlugin_Maker_Get_Elem_Form_Edit', $elem_form_edit);

            $_SESSION['sbPlugins']->addSystemEvent('elem_filter', 'fPlugin_Maker_Get_Elem_Filter', $elem_form);
            $_SESSION['sbPlugins']->addSystemEvent('elem_informer', 'fPlugin_Maker_Get_Informer_Elem', $elem_informer);
            $_SESSION['sbPlugins']->addSystemEvent('elem_list_components', 'fPlugin_Maker_Elem_Components');

            if ($elem_list != '')
                $_SESSION['sbPlugins']->addElem($elem_list, 'list', 'fPlugin_Maker_Elem_List_Com', 'fPlugin_Maker_Elem_List_Info', 'elem_list&pm_id='.$pm_id, 800, 700, 'design_list_edit&pm_id='.$pm_id, 'pl_plugin_'.$pm_id.'_design_list');
            if ($elem_full != '')
                $_SESSION['sbPlugins']->addElem($elem_full, 'full', 'fPlugin_Maker_Elem_Full_Com', 'fPlugin_Maker_Elem_Full_Info', 'elem_full&pm_id='.$pm_id, 800, 720, 'design_full_edit&pm_id='.$pm_id, 'pl_plugin_'.$pm_id.'_design_full');
            if ($elem_title_html != '')
                $_SESSION['sbPlugins']->addElem($elem_title_html, 'header_html', 'fPlugin_Maker_Elem_Header_Html');
            if ($elem_title_plain != '')
                $_SESSION['sbPlugins']->addElem($elem_title_plain, 'header_plain', 'fPlugin_Maker_Elem_Header_Plain');
            if ($elem_form != '')
                $_SESSION['sbPlugins']->addElem($elem_form, 'form', 'fPlugin_Maker_Elem_Form', 'fPlugin_Maker_Elem_Form_Info', 'elem_form&pm_id='.$pm_id, 800, 700, 'design_form_edit&pm_id='.$pm_id, 'pl_plugin_'.$pm_id.'_design_form');
            if ($elem_form_edit != '')
                $_SESSION['sbPlugins']->addElem($elem_form_edit, 'form_edit', 'fPlugin_Maker_Elem_Form', 'fPlugin_Maker_Elem_Form_Info', 'elem_form_edit&pm_id='.$pm_id, 800, 700, 'design_form_edit&pm_id='.$pm_id, 'pl_plugin_'.$pm_id.'_design_form');
            if ($elem_filter != '')
                $_SESSION['sbPlugins']->addElem($elem_filter, 'filter', 'fPlugin_Maker_Elem_Filter', 'fPlugin_Maker_Elem_Flter_Info', 'elem_filter&pm_id='.$pm_id, 800, 300, 'design_filter_edit&pm_id='.$pm_id, 'pl_plugin_'.$pm_id.'_filter');
            if ($elem_informer != '')
                $_SESSION['sbPlugins']->addElem($elem_informer, 'informer', 'fPlugin_Maker_Elem_Informer_Prog', 'fPlugin_Maker_Elem_Informer_Info', 'elem_informer&pm_id='.$pm_id, 800, 300, 'informer_edit&pm_id='.$pm_id, 'pl_plugin_'.$pm_id.'_informer');

            sb_add_rights();

            $_SESSION['sbPlugins']->addEventsRights('elems_public', RIGHTS_H_ELEMS_PUBLIC_RIGHT);

            $_SESSION['sbPlugins']->addEventsRights('elems_com_show', RIGHTS_H_ELEMS_COM_SHOW_RIGHT);            
            $_SESSION['sbPlugins']->addEventsRights('elems_com_add', RIGHTS_H_ELEMS_COM_ADD_RIGHT);
            $_SESSION['sbPlugins']->addEventsRights('elems_com_del', RIGHTS_H_ELEMS_COM_DEL_RIGHT);
            $_SESSION['sbPlugins']->addEventsRights('elems_com_edit', RIGHTS_H_ELEMS_COM_EDIT_RIGHT);

            $_SESSION['sbPlugins']->addEventsRights('design_read', RIGHTS_H_DESIGN_READ_RIGHT);
            $_SESSION['sbPlugins']->addEventsRights('design_edit', RIGHTS_H_DESIGN_EDIT_RIGHT);
        }
    }
}
