<?php

function fPolls_Get($args)
{
	$res = sql_param_query('SELECT COUNT(*) FROM sb_polls_results r, sb_polls_options op
					WHERE op.spo_poll_id = ?d AND r.spr_option_id = op.spo_id', $args['sp_id']);
	if($res)
	{
		$all_count = isset($res[0][0]) ? $res[0][0] : 0;
	}
	else
	{
		$all_count = 0;
	}

	$result = '<b><a href="javascript:void(0);" onclick="sbElemsEdit(event);" id="sp_title_'.$args['sp_id'].'">'.$args['sp_question'].'</a></b>
			<div class="smalltext" style="margin-top: 7px;">'.
	PL_POLLS_EDIT_ID_QUESTION.': <span style="color: green;">'.(isset($args['sp_id']) ? $args['sp_id'] : '').'</span><br />'.
	PL_POLLS_GET_COUNT_VOTES.': <span style="color: green;">'.$all_count.'</span><br />'.
	PL_POLLS_GET_SORT.': <span style="color: #33805E;">'.$args['sp_sort'].'</span>';

	sb_get_workflow_status($result, 'pl_polls', $args['sp_active'], $args['sp_pub_start'], $args['sp_pub_end']);

	require_once (SB_CMS_LIB_PATH.'/sbLayout.inc.php');
	$result .= sbLayout::getPluginFieldsInfo('pl_polls', $args);
	$result .= '</div>';

	return $result;
}

function fPolls_Init(&$elems = '', $external = false)
{
	require_once (SB_CMS_LIB_PATH.'/sbElements.inc.php');

	$elems = new sbElements('sb_polls', 'sp_id', 'sp_question', 'fPolls_Get', 'pl_polls_init', 'pl_polls', 'sp_url');
	$elems->mCategsRootName = PL_POLLS_ROOT_NAME;

	$elems->addField('sp_sort');       //   Индекс сортировки
	$elems->addField('sp_active');     //   Публиковать / Не публиковать
	$elems->addField('sp_pub_start');  //   Дата начала публикации
	$elems->addField('sp_pub_end');    //   Дата окончания публикации

	$elems->addCategsClosedDescr('read', PL_POLLS_GROUP_READ);
	$elems->addCategsClosedDescr('edit', PL_POLLS_GROUP_EDIT);

	$elems->addFilter(PL_POLLS_EDIT_ID_QUESTION, 'sp_id', 'number');

	sb_add_workflow_filter($elems, 'pl_polls', 'sp_active');

	$elems->addFilter(PL_POLLS_GET_SORT, 'sp_sort', 'number');
	$elems->addFilter(PL_POLLS_EDIT_QUESTION, 'sp_question', 'string');

	$elems->addSorting(PL_POLLS_SORT_BY_ID,  'sp_id');
	$elems->addSorting(PL_POLLS_SORT_BY_ACTIVE,  'sp_active');
	$elems->addSorting(PL_POLLS_SORT_BY_SORT, 'sp_sort');

	$elems->mCategsDeleteWithElementsMenuTitle = PL_POLLS_CATEGS_DELETE_WITH_ELEMENTS_MENU_TITLE;
	$elems->mCategsPasteLinksMenuTitle = PL_POLLS_CATEGS_PASTE_LINKS_MENU_TITLE;
	$elems->mCategsPasteElemsMenuTitle = PL_POLLS_CATEGS_PASTE_ELEMS_MENU_TITLE;
	$elems->mCategsPasteWithElementsMenuTitle = PL_POLLS_CATEGS_PASTE_WITH_ELEMENTS_MENU_TITLE;
	$elems->mElemsAddMenuTitle = PL_POLLS_ELEMS_ADD_MENU_TITLE;
	$elems->mElemsEditMenuTitle = PL_POLLS_ELEMS_EDIT_MENU_TITLE;
	$elems->mElemsCopyMenuTitle = PL_POLLS_ELEMS_COPY_MENU_TITLE;
	$elems->mElemsCutMenuTitle = PL_POLLS_ELEMS_CUT_MENU_TITLE;

	$elems->mElemsEditEvent = 'pl_polls_edit';
	$elems->mElemsEditDlgWidth = 800;
	$elems->mElemsEditDlgHeight = 700;

	$elems->mElemsAddEvent = 'pl_polls_edit';
	$elems->mElemsAddDlgWidth = 800;
	$elems->mElemsAddDlgHeight = 700;

	$elems->mElemsDeleteEvent = 'pl_polls_delete';
	$elems->mCategsDeleteWithElementsMenu = true;
	$elems->mCategsAfterDeleteWithElementsEvent = 'pl_polls_delete_cat_with_elements';

	$elems->mElemsAfterPasteEvent = 'pl_polls_paste';
	$elems->mCategsPasteWithElementsMenu = true;
	$elems->mCategsAfterPasteWithElementsEvent = 'pl_polls_after_paste_with_elements';

	$elems->mCategsUrl = true;
	$elems->mCategsFields = true;
	$elems->mElemsUseLinks = true;

	if ($_SESSION['sbPlugins']->isRightAvailable('pl_polls', 'elems_public') && (!$_SESSION['sbPlugins']->isPluginAvailable('pl_workflow') || !$_SESSION['sbPlugins']->isPluginInWorkflow('pl_polls')))
	{
		$elems->mElemsJavascriptStr .= '
            function pollsSetActive()
            {
            	var ids = "0";
                for (var i = 0; i < sbSelectedEls.length; i++)
			    {
			        var el = sbGetE("el_" + sbSelectedEls[i]);
			        if (el)
			            ids += "," + el.getAttribute("el_id");
			    }

				var res = sbLoadSync("'.SB_CMS_EMPTY_FILE.'?event=pl_polls_set_active&ids=" + ids);
                if (res != "TRUE")
                {
					alert("'.PL_POLLS_SHOWHIDE_ERROR.'");
					return;
                }

				var div_el = sbGetE("elems_list_div");
				var from = "";

				if (div_el)
				{
					from = div_el.getAttribute("from");
                }
                var url = sb_cms_empty_file + "?event=" + sb_elems_event + "&id=" + sbCatTree.getSelectedItemId() + "&page_elems=" + from;
                sbElemsShow(url);
            }';
		$elems->addElemsMenuItem(PL_POLLS_SHOWHIDE_MENU, 'pollsSetActive();');
	}

	$elems->mElemsJavascriptStr .= '
		function sbPollsExport(c)
		{
			if(c && sbSelCat)
			{
				var cat_id = sbSelCat.id;
    		}
    		else
    		{
				var cat_id = sbCatTree.getSelectedItemId();
			}

			var args = new Object();
			var form = sbGetE("filter_form");
			if(form)
			{
				var els = form.elements;
				for(var i = 0; i < els.length; i++)
				{
					if(els[i] && els[i].type != "button" && els[i].value != "")
					{
						var reg_date = new RegExp("date_");
						var reg_spin = new RegExp("spin_");

						if(reg_date.test(els[i].id))
						{
							args[els[i].name] = {};
							args[els[i].name]["value"]= els[i].value;
							args[els[i].name]["type"]= "date";
						}
						else if(reg_spin.test(els[i].id))
						{
							args[els[i].name] = {};
							args[els[i].name]["value"]= els[i].value;
							args[els[i].name]["type"]= "number";
						}
						else if(els[i].nodeName == "SELECT" && els[i].multiple)
						{
							var str = "";
							for(var j = 0; j < els[i].length; j++)
							{
								if(els[i][j].selected)
									str += els[i][j].value+",";
							}
							str = str.slice(0, -1);

							args[els[i].name] = {};
							args[els[i].name]["value"]= str;
							args[els[i].name]["type"]= "multyselect";
						}
						else if(els[i].nodeName == "SELECT")
						{
							var reg_link = new RegExp("_link");
							if(els[i].value == -1 && reg_link.test(els[i].id))
							{
								var name = els[i].name.replace(/_link/, "");
								args[name] = "";
								continue;
							}
							else if(els[i].value == -1)
							{
								continue;
							}

							args[els[i].name] = {};
							args[els[i].name]["value"]= els[i].value;
							args[els[i].name]["type"]= "select";
						}
						else if(els[i].type == "ckeckbox")
						{
							args[els[i].name] = {};
							args[els[i].name]["value"]= els[i].value;
							args[els[i].name]["type"]= "checkbox";
						}
						else if(els[i].type == "text")
						{
							args[els[i].name] = {};
							args[els[i].name]["value"]= els[i].value;
							args[els[i].name]["type"]= "string";
						}
    				}
				}
    		}

			var strPage = "'.SB_CMS_DIALOG_FILE.'?event=pl_export_edit&ident=pl_polls&cat_id="+ cat_id;
			var strAttr = "resizable=1,width=700,height=600";
			sbShowModalDialog(strPage, strAttr, null, args);
		}
		function sbPollsExportResults(c, id)
		{
			var args = new Object();

			var strPage = "'.SB_CMS_DIALOG_FILE.'?event=pl_export_edit&ident=pl_polls_results&cat_id="+ c + (id ? "&id="+id : "");
			var strAttr = "resizable=1,width=700,height=600";
			sbShowModalDialog(strPage, strAttr, null, args);
		}
		function sbPollsImport(c)
		{
			if(c && sbSelCat)
			{
				var cat_id = sbSelCat.id;
    		}
    		else
    		{
				var cat_id = sbCatTree.getSelectedItemId();
			}

			var args = new Object();

			var strPage = "'.SB_CMS_DIALOG_FILE.'?event=pl_export_import_edit&ident=pl_polls&cat_id="+ cat_id;
			var strAttr = "resizable=1,width=650,height=370";
			sbShowModalDialog(strPage, strAttr, sbAfterPollsImport, args);
		}

		function sbAfterPollsImport()
		{
			window.location.href = "'.SB_CMS_CONTENT_FILE.'?event=pl_polls_init";
		}
		';
	$elems->addElemsMenuItem(PL_POLLS_EDIT_EXPORT, 'sbPollsExport()', false);
	//$elems->addElemsMenuItem(PL_POLLS_EDIT_IMPORT, 'sbPollsImport()', false);
	$elems->addElemsMenuItem(PL_POLLS_EDIT_EXPORT_RESULTS, 'sbPollsExportResults(sbCatTree.getSelectedItemId(), sbSelEl.getAttribute("el_id"))', false);

	$elems->addCategsMenuItem(PL_POLLS_EDIT_EXPORT, 'sbPollsExport(true)');
	//$elems->addCategsMenuItem(PL_POLLS_EDIT_IMPORT, 'sbPollsImport(true)');
	$elems->addCategsMenuItem(PL_POLLS_EDIT_EXPORT_RESULTS, 'sbPollsExportResults((sbSelCat ? sbSelCat.id : sbCatTree.getSelectedItemId()), "")');
	if(!$external)
		$elems->init();
}

/**
 * Функция выводит окно редактирования опроса
 */
function fPolls_Edit($htmlStr = '', $footerStr = '', $footerLinkStr = '')
{
	//	определяем групповое редактирование или нет.
	$edit_group = sbIsGroupEdit();

	if ($edit_group)
	{
		if (!fCategs_Check_Elems_Rights($_GET['ids'][0], $_GET['cat_id'], 'pl_polls'))
			return;
	}
	else if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'], 'pl_polls'))
	{
		return;
	}

	$edit_rights = $_SESSION['sbPlugins']->isRightAvailable('pl_polls', 'elems_edit');
	if (count($_POST) == 0 && isset($_GET['id']) && $_GET['id'] != '' && !$edit_group)
	{
		$result = sql_param_query('SELECT sp_url, sp_question, sp_active, sp_sort, sp_pub_start, sp_pub_end
									FROM sb_polls WHERE sp_id=?d', $_GET['id']);
		if ($result)
		{
			list($sp_url, $sp_question, $sp_active, $sp_sort, $sp_pub_start, $sp_pub_end) = $result [0];
		}
		else
		{
			sb_show_message(PL_POLLS_EDIT_ERROR, true, 'warning');
			return;
		}
		if (!is_null($sp_pub_start) && $sp_pub_start != 0 && $sp_pub_start != '')
			$sp_pub_start = sb_date('d.m.Y H:i', $sp_pub_start);
		else
			$sp_pub_start = '';

		if (!is_null($sp_pub_end) && $sp_pub_end != 0 && $sp_pub_end != '')
			$sp_pub_end = sb_date('d.m.Y H:i', $sp_pub_end);
		else
		    $sp_pub_end = '';
	}
	elseif (count($_POST) > 0)
	{
		$sp_active = 0;
		$sp_pub_start = '';
		$sp_pub_end = '';

		extract($_POST);
		if (!isset($_GET['id']))
			$_GET ['id'] = '';
	}
	else
	{
		$sp_url = $sp_question = $sp_pub_start = $sp_pub_end = '';
		$sp_active = 1;

		$max = sql_query('SELECT MAX(sp_sort) FROM sb_polls');
		if ($max)
		{
			list ($sp_sort) = $max[0];
			$sp_sort += 10;
		}
		else
		{
			$sp_sort = 0;
		}
		$_GET ['id'] = '';
	}

	$values = '';
	echo '<script src="'.SB_CMS_JSCRIPT_URL.'/sbPolls.js.php"></script>
		<script>
		function reload_graph()
		{
			var polls_graph = findSWF("polls_graph");
			polls_graph.reload("'.SB_CMS_EMPTY_FILE.'?event=pl_polls_stat_reload_graph&id='.$_GET['id'].'");
		}';

	if($edit_group)
	{
		echo 'var edit_group = true;';
	}
	else
	{
		echo 'var edit_group = false;';
	}

	require_once (SB_CMS_LIB_PATH.'/sbLayout.inc.php');
	if ($htmlStr != '')
	{
		echo '
			function cancel()
            {';
			if($edit_group)
			{
				echo 'sbReturnValue("refresh");';
			}
			else
			{
				echo 'var res = new Object();
			        res.html = "'.$htmlStr.'";
			        res.footer = "'.$footerStr.'";
			        res.footer_link = "'.$footerLinkStr.'";
					sbReturnValue(res);';
			}
		echo '}
			sbAddEvent(window, "close", cancel);';
	}
	elseif($edit_group)
	{
		echo '
			function cancel()
            {
				sbReturnValue("refresh");
			}
			sbAddEvent(window, "close", cancel);';
	}
	echo '</script>';

	$layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE.'?event=pl_polls_edit_submit'.($_SERVER['QUERY_STRING'] != '' ? '&'.$_SERVER['QUERY_STRING'] : ''), 'thisDialog', 'post', 'checkValues(edit_group)', 'main');

	$layout->mTableWidth = '95%';
	$layout->mTitleWidth = '200';

	$layout->addTab(PL_POLLS_EDIT_TAB1);
	$layout->addHeader(PL_POLLS_EDIT_TAB1);

	$fld = new sbLayoutTextarea($sp_question, 'sp_question', '', 'style="width:97%; height:150px;"');
	$fld->mShowEditorBtn = true;
	$layout->addField(PL_POLLS_EDIT_QUESTION.sbGetGroupEditCheckbox('sp_question', $edit_group), $fld);
	$layout->addField('', new sbLayoutDelim());

	if(!$edit_group)
	{
		$layout->addField (KERNEL_STATIC_URL, new sbLayoutInput('text', $sp_url, 'sp_url', '', 'style="width:450px;"', false));
		$layout->addField('', new sbLayoutLabel('<div class="hint_div">'.KERNEL_STATIC_URL_HINT.'</div>', '', '', false));
	}
	$layout->addField(PL_POLLS_GET_SORT.sbGetGroupEditCheckbox('sp_sort', $edit_group), new sbLayoutInput('text', $sp_sort, 'sp_sort', 'spin_sp_sort', 'style="width:80px;"'));

	if (!$edit_group)
	{
		$edit_rights = $edit_rights && sb_add_workflow_status($layout, 'pl_polls', $_GET['id'], 'sp_active', $sp_active, 'sp_pub_start', $sp_pub_start, 'sp_pub_end', $sp_pub_end);
	}
	else
	{
		$states_arr = array();
		$states = sql_query('SELECT sp_active FROM sb_polls WHERE sp_id IN (?a)', $_GET['ids']);

		if ($states)
		{
			foreach($states as $val)
			{
				$states_arr[] = $val[0];
			}
		}
		$edit_rights = $edit_rights && sb_add_workflow_status($layout, 'pl_polls', $_GET['ids'], 'sp_active', $sp_active, 'sp_pub_start', $sp_pub_start, 'sp_pub_end', $sp_pub_end);
	}

	if (!$edit_group)
	{
		$layout->getPluginFields('pl_polls', $_GET['id'], 'sp_id');
	}
	else
	{
		$layout->getPluginFields('pl_polls', '', 'sp_id', false, $edit_group);
	}

	$layout->addTab(PL_POLLS_EDIT_TAB2);
	$layout->addHeader(PL_POLLS_EDIT_HEADER_VARIANT);

	$fld1 = new sbLayoutTextarea( '', 'new_answer', 'new_answer', 'style="width:100%;height:100px"');
	$fld1->mShowToolbar = false;
	$fld1->mShowEnlargeBtn = false;
	$fld1->mShowEditorBtn = true;

	$options = array();
	$options['checkbox'] = PL_POLLS_EDIT_TYPE_CHECKBOX_OPTION;
	$options['radio'] = PL_POLLS_EDIT_TYPE_RADIO_OPTION;
	$options['text'] = PL_POLLS_EDIT_TYPE_TEXT_OPTION;
	$options['group'] = PL_POLLS_EDIT_TYPE_GROUP_OPTION;

	$fld2 = new sbLayoutSelect($options, 'type_variant', 'type_variant', 'onchange="changeDescr(this.value);" onkeyup="changeDescr(this.value);"');
	$label = new sbLayoutLabel('<div class="hint_div" id="desrc_type_opt">'.PL_POLLS_TYPE_MSG_CHECKBOX.'</div>', '', '', false);

	$html = '
		<table cellspacing="0" cellpadding="0" align="center" width="100%">
			<tr>
				<td>
					'.$fld1->getField().preg_replace('/^(.*?float[ ]*?:[ ]*?)(right)([ ]*?;.*)/is', '$1left$3', sbGetGroupEditCheckbox('new_answer', $edit_group)).'
				</td>
			</tr>
			<tr>
				<td>
					<table>
						<tr>
							<td style="vertical-align:top;">
								'.$fld2->getField().'
							</td>
							<td>
								'.$label->getField().'
							</td>
						</tr>
					</table>
				</td>
			</tr>
			<tr>
				<td align="center">
					<div style="border-bottom:1px dotted #CBB49A; margin:3px;">&nbsp;</div>
					<button onClick="return addAnswerClick();" id="answerAddButton"> '.KERNEL_ADD.'</button>&nbsp;&nbsp;<button onClick="return cancelClick();" style="display: none;" id="answerCancelButton">'.KERNEL_CANCEL.'</button>
				</td>
			</tr>
		</table><br />
		<table cellspacing="0" cellpadding="5" width="100%" style="empty-cells: show; -moz-user-select: none;-khtml-user-select: none;" id="pl_polls_answer_table" class="form">
	        <tr>
				<th class="header" width="30">&nbsp;</th>
				<th class="header" width="50">'.PL_POLLS_EDIT_TYPE_ANSWER.'</th>
				<th class="header" width="250">'.PL_POLLS_EDIT_NAME_ANSWER.'</th>
				<th class="header" width="30">&nbsp;</th>
				<th class="header" width="30">&nbsp;</th>
			</tr>';

	$class = '';
	if(isset($_GET['id']) && $_GET['id'] != '')
	{
		$res = sql_param_query('SELECT spo_id, spo_name, spo_type, spo_order FROM sb_polls_options WHERE spo_poll_id = ?d ORDER BY spo_order', $_GET['id']);
		if($res)
		{
			$class = ' class="even"';
			for($i = 0; $i < count($res); $i++)
			{
				if ($class == '')
					$class = ' class="even"';
				else
					$class = '';

				$type_label = '';
				switch($res[$i][2])
				{
					case 'checkbox':
						$src = '/data_types/checkbox.gif';
						$type_label = PL_POLLS_EDIT_TYPE_CHECKBOX_OPTION;
						break;

					case 'radio':
						$src = '/data_types/radio_sprav.gif';
						$type_label = PL_POLLS_EDIT_TYPE_RADIO_OPTION;
						break;

					case 'text':
						$src= '/data_types/string.gif';
						$type_label = PL_POLLS_EDIT_TYPE_TEXT_OPTION;
						break;

					case 'group':
						$src= '/data_types/tab.gif';
						$type_label = PL_POLLS_EDIT_TYPE_GROUP_OPTION;
						break;
				}

				$html .= '
					<tr '.$class.' id="'.$res[$i][0].'" onmousedown="sbPDStartDrag(event, this)" style="cursor:default;">
						<td style="vertical-align: middle; border-top: 1px solid FFF5E0; text-align:center;">
							<img id="img_type'.$res[$i][0].'" src="'.SB_CMS_IMG_URL.$src.'">
							<textarea style="width: 1px; height: 1px;visibility:hidden;" id="sp_polls_'.$res[$i][0].'_answer" name="sp_polls_'.$res[$i][0].'_answer" onmousedown="_sbPDPreventNsDrag(event, true);" ondragstart="_sbPDPreventNsDrag(event);">'.htmlspecialchars($res[$i][1], ENT_QUOTES).'</textarea><br />
							<input type="hidden" name="sp_polls[]" id="sp_polls_'.$res[$i][0].'_id" value="'.$res[$i][0].'">
						</td>
				        <td style="vertical-align: middle; border-top: 1px solid FFF5E0; width:150px; text-align:center;">
							<div id="sp_polls_'.$res[$i][0].'_type_answer">'.$type_label.'</div>
						</td>
						<td style="vertical-align: middle; text-align:center; border-top: 1px solid FFF5E0;">
							<span id="sp_polls_'.$res[$i][0].'_answer_text">'.($res[$i][1] != '' ? $res[$i][1] : '&nbsp;') . '</span>
						</td>
				        <td style="vertical-align: middle; text-align:center; border-top: 1px solid FFF5E0; width:30px;">
				        	<img src="/cms/images/btn_props.png" title="'.PL_POLLS_EDIT_PROPS_LABEL.'" onmousedown="_sbPDPreventNsDrag(event, true);" ondragstart="_sbPDPreventNsDrag(event);" onclick="return editAnswerClick(\''.$res[$i][0].'\');" style="cursor: pointer;" width="20" border="0" height="20">
						</td>
						<td style="vertical-align: middle; text-align:center; border-top: 1px solid FFF5E0; width:30px;">
							<img src="/cms/images/btn_delete.png" title="'.PL_POLLS_EDIT_DEL_LABEL.'" onmousedown="_sbPDPreventNsDrag(event, true);" ondragstart="_sbPDPreventNsDrag(event);" onclick="deleteAnswerClick(\''.$res[$i][0].'\');" style="cursor: pointer;" width="20" height="20">
							<input type="hidden" name="sp_polls_'.$res[$i][0].'_order" id="sp_polls_'.$res[$i][0].'_order" value="'.($i + 1).'">
							<input type="hidden" name="sp_polls_'.$res[$i][0].'_type" id="sp_polls_'.$res[$i][0].'_type" value="'.$res[$i][2].'">
						</td>
					</tr>';
			}
		}
	}

	if ($class != '')
		$class = '';
	else
		$class = 'class="even"';

	$html .= '
            <tr id="null_tr" '.$class.'>
                <td style="">&nbsp;</td>
                <td style="">&nbsp;</td>
                <td style="">&nbsp;</td>
                <td style="">&nbsp;</td>
                <td style="">&nbsp;</td>
            </tr>
		</table>
		<script>
			lastSortPosition = '.(isset($res) ? count($res) : 0).';
		</script>';
	$layout->addField('', new sbLayoutHTML($html, true));

	if(!$edit_group)
	{
		$layout->addTab(PL_POLLS_EDIT_TAB3);
		$layout->addHeader(PL_POLLS_EDIT_TAB3);

		$all_count = 0;
		if(isset($res) && $res)
		{
			$resu = sql_param_query('SELECT r.spr_id FROM sb_polls_results r, sb_polls_options op, sb_polls p
							WHERE r.spr_option_id = op.spo_id AND op.spo_poll_id = p.sp_id AND p.sp_id = ?d', $_GET['id']);

			$all_num = count($resu);
			if($resu)
			{
				echo '<script>
						function pie_on_click(pie_id)
						{
							sbShowResult(pie_id);
						}
					</script>';

				require_once (SB_CMS_LIB_PATH.'/graph/OFC_Chart.php');

				$tooltip = new OFC_Elements_Tooltip();
				$tooltip->set_shadow(false);
				$tooltip->set_stroke(1);
				$tooltip->set_colour( "#000000" );
				$tooltip->set_background_colour( "#FFFFE1" );
				$tooltip->set_title_style("{font-size: 10px; color: #000000;}");
				$tooltip->set_body_style("{font-size: 10px; color: #000000;}");
				$tooltip->set_hover();

				$x_axis = new OFC_Elements_Axis_X();
				$x_axis->set_stroke(1);
				$x_axis->set_colours('#909090', '#FFF5E0');

				$y_axis = new OFC_Elements_Axis_Y();
				$y_axis->set_stroke(1);
				$y_axis->set_colours('#909090', '#FFF5E0');

				$title = new OFC_Elements_Title(PL_POLLS_ROOT_NAME);
				$title->set_style('font-size:12px;font-weight:bold;color:#A50101');

				$chart = new OFC_Chart();
				$chart->set_bg_colour('#EFE5D0');
				$chart->set_tooltip($tooltip);
				$chart->set_x_axis($x_axis);
				$chart->set_y_axis($y_axis);
				$chart->set_title($title);

				$rgb = array();
				for($i = 0; $i < $all_num; $i++)
				{
					$rand_color = rand(0, 2);
					if($rand_color == 0)
						$rgb[] = '#'.dechex(rand(100, 200)).dechex(rand(0, 70)).dechex(rand(0, 70));
					elseif($rand_color == 1)
						$rgb[] = '#'.dechex(rand(0, 70)).dechex(rand(100, 200)).dechex(rand(0, 70));
					elseif($rand_color == 2)
						$rgb[] = '#'.dechex(rand(0, 70)).dechex(rand(0, 70)).dechex(rand(100, 200));
				}

				$pie = new OFC_Charts_Pie();
				$pie->set_label_colour('#000000');
				$pie->set_alpha(0.8);
				$pie->set_radius(130);
				$pie->set_colours($rgb);
				$pie->set_tooltip('#val#%');
				$pie->set_border(2);

				$values .= '<tr id="tr_0">
								<th class="header" style="height:20px; vertical-align:middle;">'.PL_POLLS_EDIT_HEADER_VARIANT.'</th>
								<th class="header" style="vertical-align:middle;">'.PL_POLLS_EDIT_OUNT_VOICE.'</th>
								<th class="header" style="vertical-align:middle;">'.PL_POLLS_EDIT_PROCENT.'</th>
								<th class="header" style="vertical-align:middle;"></th>
							</tr>';
				$class = '';

				$vals = array();
				foreach($res as $key => $value)
				{
					$count_res = sql_param_query('SELECT COUNT(*) FROM sb_polls_results WHERE spr_option_id = ?d', $value[0]);
					$proc = round(($count_res[0][0] * 100) / $all_num);

					if ($class == 'class="odd"')
						$class = 'class="even"';
					else
						$class = 'class="odd"';

					$values .= '<tr id = "tr_'.($key+1).'" '.$class.'>
									<td style="width:30%; height:30px; text-align:center; vertical-align:middle;">
										'.$value[1].'
									</td>
									<td style="width:20%; text-align:center;" id=count_'.$key.'>
										'.$count_res[0][0].'
									</td>
									<td style="width:20%; text-align:center;" id=proc_'.$key.'>
										'.$proc.'%
									</td>
									<td style="width:30%; text-align:center;">
										[<a href="#" onclick="sbShowResult('.$value[0].');">'.PL_POLLS_RESULT_LABEL.'</a>]
									</td>
								</tr>';
					$all_count += $count_res[0][0];

					$val = new OFC_Charts_Pie_Value($proc, $value[1].' ('.$proc.'%)');
					$val->on_click('pie_on_click('.$value[0].')');
					$vals[] = $val;
				}
				$pie->set_values($vals);
				$chart->add_element($pie);

				$fld = new sbLayoutGraph($chart->toString(), 'polls_graph', '650', '300');
				$fld->mHTML = '<div style="text-align:left;" id="save_graph">
								<a href="#" onclick="save_graph(\'polls_graph\')"><img height="20" width="20" align="absmiddle" src="'.SB_CMS_IMG_URL.'/images.png" class="button"/></a>&nbsp;&nbsp;
								<a href="#" onclick="save_graph(\'polls_graph\')">'.KERNEL_SAVE.'</a>
								&nbsp;&nbsp;&nbsp;<a onclick="sbPollsExportResults('.$_GET['cat_id'].', '.$_GET['id'].');" href="#"><img height="20" width="20" align="absmiddle" src="'.SB_CMS_IMG_URL.'/icon_excel.png" class="button"/></a>&nbsp;&nbsp;
								<a onclick="sbPollsExportResults('.$_GET['cat_id'].', '.$_GET['id'].');" href="#">'.PL_POLLS_EDIT_EXPORT_RESULTS.'</a>
							</div>';
				$layout->addField('', $fld, '', 'style="text-align:center;"');
				$layout->addField('', new sbLayoutDelim());

				$values .= '<tr id="tr_'.($key+2).'">
								<td colspan="3">
									<b>'.PL_POLLS_ALL_COUNT_VOTE.': '.$all_count.'</b>
								</td>
								<td style="text-align:center; padding:5px;">
									[<a href="#" onclick="sbDeleteResult(\'all\', '.$_GET['id'].');">'.PL_POLLS_DELETE_ALL.'</a>]
								</td>
							</tr>
							<tr id="last_tr">
								<td>&nbsp;</td>
							</tr>';
			}
		}
		if($values != '')
		{
			$htm = '<br /><div id="pl_polls_variant_table"><table style="width:100%;" border="0" cellpadding="0" cellspacing="0" id="variant_table">
						'.$values.'
					</table></div>';
			$layout->addField('', new sbLayoutHTML($htm, true));
		}
		else
		{
			$layout->addField('', new sbLayoutHTML('<br /><div class="hint_div" style="text-align:center;">'.PL_POLLS_EDIT_NO_RESULTS.'</div><br />', true));
		}
	}

	$layout->addButton('submit', KERNEL_SAVE, 'btn_save', '', ($edit_rights ? '' : 'disabled="disabled"'));
	$layout->addButton('button', KERNEL_CANCEL, '', '', $htmlStr != ''  || $edit_group ? 'onclick="cancel()"' : 'onclick="sbCloseDialog()"');

	$layout->show();
}

/**
 * Функция сохранения изменений опроса
 */
function fPolls_Edit_Submit()
{
	$edit_group = sbIsGroupEdit();

	//	проверка прав доступа
	if ($edit_group)
	{
		if (!fCategs_Check_Elems_Rights($_GET['ids'][0], $_GET['cat_id'], 'pl_polls'))
		{
			return;
		}
	}
	else if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'], 'pl_polls'))
	{
		return;
	}

	if (!isset($_GET['id']))
		$_GET ['id'] = '';

	$sp_url = $sp_question = '';
	$sp_sort = $sp_active = 0;

	$sp_polls = $sp_options = array();
	$ch_sp_question = $ch_sp_sort = $ch_sp_active = $ch_new_answer = 0;

	extract($_POST);
	require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

	$layout = new sbLayout();
	$row = $layout->checkPluginFields('pl_polls', ($edit_group ? '' : $_GET['id']), 'sp_id', false, $edit_group);
	if ($row === false)
	{
		$layout->deletePluginFieldsFiles();
		fPolls_Edit();
		return;
	}

	if (!$edit_group)
    {
	    $sp_url = sb_check_chpu($_GET['id'], $sp_url, $sp_question, 'sb_polls', 'sp_url', 'sp_id');
	    $_POST['sp_url'] = $sp_url;
    }

    $sp_active = intval($sp_active);
    if ($sp_active == 1)
    {
		if ($sp_pub_start != '')
		{
			$sp_pub_start = sb_datetoint($sp_pub_start);
		}
		else
		{
			$sp_pub_start = null;
		}

	    if ($sp_pub_end != '')
	    {
	        $sp_pub_end = sb_datetoint($sp_pub_end);
	    }
	    else
	    {
	        $sp_pub_end = null;
	    }
    }
    else
    {
		$sp_pub_start = null;
		$sp_pub_end = null;
	}

	sb_submit_workflow_status($row, 'sp_active', 'sp_pub_start', 'sp_pub_end', $edit_group);

	if(!$edit_group)
	{
		$row['sp_url'] = $sp_url;
	}
	if (!$edit_group || $edit_group && $ch_sp_question == 1)
	{
		$row['sp_question'] = $sp_question;
	}
	if (!$edit_group || $edit_group && $ch_sp_sort == 1)
	{
		$row['sp_sort'] = $sp_sort;
	}

	if ($edit_group || $_GET['id'] != '')
	{
		if (!$edit_group)
		{
			$res = sql_param_query('SELECT sp_question FROM sb_polls WHERE sp_id=?d', $_GET['id']);
		}
		else
		{
			//Обяъвляем в true просто для того чтобы пройти проверку ниже
			$res = true;
		}
		if ($res)
		{
	        if (!$edit_group)
	        {
				// редактирование
				list($old_question) = $res[0];
				sql_query('UPDATE sb_polls SET ?a WHERE sp_id=?d', $row, $_GET['id'], sprintf(PL_POLLS_EDIT_OK, sb_substr($old_question, 0, 50)));
	        }
	        else if(count($row) > 0)
	        {
				sql_query('UPDATE sb_polls SET ?a WHERE sp_id IN (?a)', $row, $_GET['ids'], PL_POLLS_EDIT_GROUP_OK);
	        }

			if(!$edit_group)
			{
				$footer_ar = fCategs_Edit_Elem ();
				if (! $footer_ar)
				{
					sb_show_message(PL_POLLS_EDIT_ERROR, false, 'warning');
					sb_add_system_message(sprintf(PL_POLLS_EDIT_SYSTEMLOG_ERROR, sb_substr($old_question, 0, 50)), SB_MSG_WARNING);

					$layout->deletePluginFieldsFiles ();
					fPolls_Edit();
					return;
				}

				$footer_str = $GLOBALS['sbSql']->escape($footer_ar [0], false, false);
				$footer_link_str = $GLOBALS['sbSql']->escape($footer_ar[1], false, false);

				$row['sp_id'] = intval($_GET['id']);

				$html_str = fPolls_Get($row);
				$html_str = sb_str_replace(array("\r\n", "\r", "\n" ), '', $html_str);
				$html_str = $GLOBALS['sbSql']->escape($html_str, false, false);
			}

			if (!$edit_group)
    	    {
				echo '<script>
        		        var res = new Object();
        		        res.html = "'.$html_str.'";
        		        res.footer = "'.$footer_str.'";
        		        res.footer_link = "'.$footer_link_str.'";
						sbReturnValue(res);
					</script>';
			}
			else
			{
				echo '<script>
						sbReturnValue("refresh");
					</script>';
			}

			sb_mail_workflow_status('pl_polls', (!$edit_group ? $_GET['id'] : $_GET['ids']), sb_substr($sp_question, 0, 50), $sp_active);
		}
		else
		{
			sb_show_message(PL_POLLS_EDIT_ERROR, false, 'warning');
			sb_add_system_message(sprintf(PL_POLLS_EDIT_SYSTEMLOG_ERROR, sb_substr($old_question, 0, 50)), SB_MSG_WARNING);
			$layout->deletePluginFieldsFiles ();
			fPolls_Edit();
			return;
		}
	}
	else
	{
		$error = true;
		if (sql_param_query('INSERT INTO sb_polls SET ?a', $row))
		{
			$id = sql_insert_id ();

			if (fCategs_Add_Elem($id))
			{
				sb_add_system_message(sprintf(PL_POLLS_ADD_OK, sb_substr($sp_question, 0, 50)));
				echo '<script>
						sbReturnValue('.$id.');
					</script>';

				sb_mail_workflow_status('pl_polls', $id, sb_substr($sp_question, 0, 50), $sp_active);
				$error = false;
			}
			else
			{
				sql_query('DELETE FROM sb_polls WHERE sp_id="'.$id.'"');
			}
		}

		if ($error)
		{
			sb_show_message(PL_POLLS_ADD_ERROR, false, 'warning');
			sb_add_system_message(sprintf(PL_POLLS_ADD_SYSTEMLOG_ERROR, sb_substr($sp_question, 0, 50)), SB_MSG_WARNING);

			$layout->deletePluginFieldsFiles ();
			fPolls_Edit();
			return;
		}
	}

	if(!$edit_group || $edit_group && $ch_new_answer == 1)
	{
		if(isset($_GET['id']) || isset($id))
		{
			for ($i = 0; $i < count($sp_polls) ; $i++)
			{
				$row = array();
				$row['spo_name'] = $_POST['sp_polls_'.$sp_polls[$i].'_answer'];
				$row['spo_type'] = $_POST['sp_polls_'.$sp_polls[$i].'_type'];
				$row['spo_order'] = $_POST['sp_polls_'.$sp_polls[$i].'_order'];

				if($edit_group && $ch_new_answer == 1)
				{
					foreach($_GET['ids'] as $value)
					{
						$row['spo_poll_id'] = $value;

						sql_query('INSERT INTO sb_polls_options SET ?a', $row);
						$exis_opt[] = sql_insert_id();
					}
				}
				else
				{
					$row['spo_poll_id'] = (isset($id) ? $id : $_GET['id']);
					if(isset($sp_polls[$i]) && sb_strlen($sp_polls[$i]) <= 8)
					{
						sql_query('UPDATE sb_polls_options SET ?a WHERE spo_id = ?d', $row, $sp_polls[$i]);
						$exis_opt[] = $sp_polls[$i];
					}
					else
					{
						sql_query('INSERT INTO sb_polls_options SET ?a', $row);
						$exis_opt[] = sql_insert_id();
					}
				}
			}
			if($edit_group)
			{
				$ids = $_GET['ids'];
			}
			else
			{
				$ids = array((isset($id) ? $id : $_GET['id']));
			}

			sql_query('DELETE FROM sb_polls_options WHERE spo_poll_id IN (?a) {AND spo_id NOT IN (?a)}', $ids, (count($exis_opt) > 0 ? $exis_opt : SB_SQL_SKIP));
		}
	}
}

/**
 * Функция выводит окно с результатами опроса
 */
function fPolls_Show_Result()
{
	echo '<script>
			var is_changed = "0";

			function sbEditResult(id, option_id)
			{
				if(id == "add")
				{
					var strPage = sb_cms_modal_dialog_file + "?event=pl_polls_edit_result&id=add&option_id="+option_id;
					sbGetE("last_tr").style.visibility = "visible";
				}
				else
				{
					var strPage = sb_cms_modal_dialog_file + "?event=pl_polls_edit_result&id="+id;
				}

				var strAttr = "resizable=1,width=670,height=400";
				sbShowModalDialog(strPage, strAttr, afterEditResult);

				if(res.changed)
					res.changed = "1";
	        }

			function afterEditResult(id)
			{
				var returnV = sbModalDialog.returnValue;

				if(returnV && returnV.action == "add")
				{
					var table = sbGetE("pl_polls_result_table");
					if(table == null)
					{
						return false;
	                }

	                var exists = sbGetE("msg");
	                if(exists)
	                {
						exists.removeNode(exists);
					}

	                var tr = document.createElement("TR");
	                var last = sbGetE("last_tr");

			        if (_isIE)
					{
			            tr.setAttribute("className", last.className);
						if(last.className == "odd")
	                        last.className = "even";
	                	else if(last.className == "even")
	                    	last.className = "odd";
	                }
			        else
					{
			            tr.setAttribute("class", last.className);
						if(last.className == "odd")
	                    	last.className = "even";
						else if(last.className == "even")
	                		last.className = "odd";
	                }

	                tr.id = returnV.id;

	                var td1 = document.createElement("TD");
					td1.align = "center";
					td1.setAttribute("id", "ip_"+returnV.id);
					td1.innerHTML = returnV.ip;
	                tr.appendChild(td1);

	                var td2 = document.createElement("TD");
	                td2.align = "center";
					td2.setAttribute("id", "date_"+returnV.id);
	                td2.innerHTML = returnV.date;
	                tr.appendChild(td2);

					var td3 = document.createElement("TD");
					td3.align = "center";
					td3.setAttribute("id", "text_"+returnV.id);
					td3.innerHTML = returnV.text;
					tr.appendChild(td3);

	                var td4 = document.createElement("TD");
	                td4.align = "center";
					td4.style.width = "50";
					td4.innerHTML = "<div style=\'height:30px; padding-top:5px;\'><img height=\'20\' width=\'20\' border=\'0\' onclick = \'sbEditResult("+returnV.id+");\' title=\''.PL_POLLS_EDIT_EDIT_LABEL.'\' src=\''.SB_CMS_IMG_URL.'/btn_props.png\'/></div>";
	                tr.appendChild(td4);

	                var td5 = document.createElement("TD");
	                td5.align = "center";
	                td5.style.width = "50";
	                td5.innerHTML = "<img height=\'20\' width=\'20\' onClick = \'sbDeleteResult("+returnV.id+");\' title=\''.PL_POLLS_EDIT_DEL_LABEL.'\' src=\''.SB_CMS_IMG_URL.'/btn_delete.png\'/>";
	                tr.appendChild(td5);

					var el = table.tBodies[0];
					if(el)
					{
						el.insertBefore(tr, last);
						var el = sbGetE("last_tr");
						el.style.display = "table-row";

						var el = sbGetE("first_tr");
						el.style.display = "table-row";
					}
				}
				else if(returnV)
				{
					var ip = sbGetE("ip_"+returnV.id);
					var date = sbGetE("date_"+returnV.id);
					var text = sbGetE("text_"+returnV.id);

					ip.innerHTML = returnV.ip;
					date.innerHTML = returnV.date;
					text.innerHTML = returnV.text;
				}
			}

			function sbDeleteResult(id, option_id)
			{
				if(res.changed)
					res.changed = "1";

				if(confirm("'.PL_POLLS_CONFIRM_DELETE.'"))
				{
					if(id == "all")
					{
						sbLoadAsync(sb_cms_empty_file + "?event=pl_polls_delete_result&option_id="+option_id+"&all=1", afterLoadDeleteResult);
						sbGetE("last_tr").style.visibility = "hidden";
					}
					else
					{
						sbLoadAsync(sb_cms_empty_file + "?event=pl_polls_delete_result&id="+id, afterLoadDeleteResult);
					}
				}
			}

			function afterLoadDeleteResult(res)
            {
               	if(res == "ERROR")
               	{
					alert("'.PL_POLLS_DELETE_RESULT_ERROR.'");
				}

				var table = sbGetE("pl_polls_result_table");
				table = table.tBodies[0];

				var reg = /count/;
				if(reg.test(res))
				{
					var count = table.rows.length;
					var t = count-1;

					while(t >= 0)
					{
						if(table.rows[t].id != "first_tr" && table.rows[t].id != "last_tr")
						{
							var curRow = sbGetE(table.rows[t].id);
							table.removeChild(curRow);
						}
						t--;
					}
				}
				else if (res != "ERROR")
				{
					var curRow = sbGetE(res);
					curRow.removeNode(curRow);

					if(table.rows.length > 2)
					{
						for (var i = 1; i < table.rows.length; i++)
						{
							if (i % 2 == 0)
							{
				                if (_isIE)
				                    table.rows[i].setAttribute("className", "even");
				                else
				                    table.rows[i].setAttribute("class", "even");
								table.rows[i].setAttribute("oldClassName", "even");
				            }
				            else
				            {
				                if (_isIE)
				                    table.rows[i].removeAttribute("className");
				                else
				                    table.rows[i].removeAttribute("class");
								table.rows[i].removeAttribute("oldClassName");
				            }
				        }
					}
				}

				if(table.rows.length == 2)
				{
					var tr = document.createElement("TR");
					tr.id = "msg";
					td = document.createElement("TD");
					td.setAttribute("colSpan", 5);
					td.align = "center";
					td.innerHTML = "<br /><br /><div class=\'hint_div\'>'.PL_POLLS_NO_RESULT_MSG.'</div>";
					tr.appendChild(td);

					if(table)
					{
						table.insertBefore(tr, sbGetE("last_tr"));
						var el = sbGetE("last_tr");
						el.style.display = "none";

						var el = sbGetE("first_tr");
						el.style.display = "none";
					}
				}

				if(reg.test(res))
				{
					alert("'.PL_POLLS_DELETE_COUNT_MSG.' " + res.substr(5, res.length));
				}
			}
		</script>';

	$res = sql_param_query('SELECT spr_date, spr_ip, spr_text, spr_id FROM sb_polls_results WHERE spr_option_id = ?d', $_GET['id']);

	$trs = '<tr id="first_tr">
					<th class="header" align="center" style="height:20px; vertical-align:middle;">'.PL_POLLS_IP_RESULT.'</th>
					<th class="header" align="center" style="vertical-align:middle;">'.PL_POLLS_DATE_RESULT.'</th>
					<th class="header" align="center" style="vertical-align:middle;">'.PL_POLLS_TEXT_RESULT.'</th>
					<th class="header">&nbsp;</th>
					<th class="header">&nbsp;</th>
				</tr>';

	$class = ' class="odd"';
	if($res)
	{
		$values = array();
		foreach($res as $key => $value)
		{
			if ($class == 'class="odd"')
				$class = ' class="even"';
			else
				$class = 'class="odd"';

			$trs .= '<tr id="'.$value[3].'" '.$class.'>
						<td style="text-align:center;" id="ip_'.$value[3].'">'.$value[1].'</td>
						<td style="text-align:center;" id="date_'.$value[3].'">'.sb_date('d.m.Y H:i', $value[0]).'</td>
						<td style="text-align:center;" id="text_'.$value[3].'">'.$value[2].'</td>
						<td style="text-align:center; width:50px;">
							<div style="height:30px; padding-top:5px;"><img src=\''.SB_CMS_IMG_URL.'/btn_props.png\' onclick="sbEditResult('.$value[3].')" title=\''.PL_POLLS_EDIT_EDIT_LABEL.'\' width=\'20\' border=\'0\' height=\'20\'></div>
						</td>
						<td style="text-align:center; width:50px;">
							<img src=\''.SB_CMS_IMG_URL.'/btn_delete.png\' onclick="sbDeleteResult('.$value[3].')" title=\''.PL_POLLS_EDIT_DEL_LABEL.'\' width=\'20\' border=\'0\' height=\'20\'>
						</td>
				</tr>';
		}
		$visible = true;
	}
	else
	{
		$trs .= '<tr id="msg"><td align="center" colspan="5"><br /><div class="hint_div">'.PL_POLLS_NO_RESULT_MSG.'</div></td></tr>';
		$visible = false;
	}

	$class = ($class == 'class="odd"' ? 'even' : 'odd');
	$trs .= '<tr id="last_tr" class="'.$class.'" style="'.($visible ? 'visibility:visible;' : 'visibility:hidden;').'">
					<td>&nbsp;</td>
					<td>&nbsp;</td>
					<td>&nbsp;</td>
					<td colspan="2" style="padding:4px 0px 0px 1px;">[<a href="#" onclick="sbDeleteResult(\'all\', this.id)" id="'.$_GET['id'].'">'.PL_POLLS_DELETE_ALL.'</a>]</td>
				</tr>';

	require_once (SB_CMS_LIB_PATH.'/sbLayout.inc.php');
	$layout = new sbLayout();

	$poll_id = sql_param_query('SELECT spo_poll_id, spo_name FROM sb_polls_options WHERE spo_id = ?d', $_GET['id']);

	echo '<br />';
	$htm = '<br />
			<div class="hint_div"><b>'.PL_POLLS_EDIT_HEADER_VARIANT.':</b> '.$poll_id[0][1].'</div><br />
			<table style="width:100%;" border="0" cellpadding="0" cellspacing="0" id="pl_polls_result_table">
				'.$trs.'
			</table>';

	$layout->addField('', new sbLayoutHTML($htm, true));
	$layout->addButton('submit', KERNEL_ADD, 'btn_add_save', $_GET['id'], ($_SESSION['sbPlugins']->isRightAvailable('pl_polls', 'elems_edit') ? ' onclick="sbEditResult(\'add\', this.id);"' : 'disabled="disabled"'));

	echo '<script>
				var res = new Object();
				res.spr_id = "'.$poll_id[0][0].'";
				res.changed = is_changed;
		</script>';

	$layout->addButton('button', KERNEL_CLOSE, '', '', 'onclick="sbCloseDialog(res);"');
	$layout->show();
}

// Функция выводит окно редактирования(добавления) конкретного результата опроса
function fPolls_Edit_Result()
{
	if($_GET['id'] != "add")
	{
		$res = sql_param_query('SELECT r.spr_date, r.spr_ip, r.spr_text, op.spo_name FROM sb_polls_results r, sb_polls_options op
							WHERE op.spo_id = r.spr_option_id AND r.spr_id = ?d', $_GET['id']);
		if ($res)
		{
			list($spr_date, $spr_ip, $spr_text, $spo_name) = $res [0];
		}
		else
		{
			sb_show_message(PL_POLLS_EDIT_VARIANT_ERROR, true, 'warning');
			return;
		}

		if(sb_strlen($spo_name) > 50)
		{
			$answer = sb_substr($spo_name, 0, 50).'...';
		}
		else
		{
			$answer = $spo_name;
		}

		if ($spr_date != 0)
			$spr_date = sb_date('d.m.Y H:i', $spr_date);
		else
			$spr_date = '';
	}
	else
	{
		$spr_ip = $spr_text = $spo_name = $answer = '';
		$spr_date = sb_date('d.m.Y H:i');
	}

	echo '<br /><br /><br /><br />';

	require_once (SB_CMS_LIB_PATH.'/sbLayout.inc.php');

	$layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE.'?event=pl_polls_edit_result_submit'.($_SERVER['QUERY_STRING'] != '' ? '&'.$_SERVER['QUERY_STRING'] : ''), 'thisDialog', 'post', ' ');

	$layout->mTitleWidth = '200';

	if($_GET['id'] != "add")
	{
		$layout->addHeader(sprintf(PL_POLLS_HEADER_EDIT_ANSWER, $answer));
	}
	else
	{
		$layout->addHeader(PL_POLLS_HEADER_ADD_RESULT);
	}

	$layout->addField(PL_POLLS_DATE_RESULT, new sbLayoutDate($spr_date, 'date'));
	$layout->addField(PL_POLLS_IP_RESULT, new sbLayoutInput('text', $spr_ip, 'ip', '', 'style="width:180px;"'));
	$layout->addField(PL_POLLS_TEXT_RESULT, new sbLayoutInput('text', $spr_text, 'text', '', 'style="width:400px;"'));

	$layout->addButton('submit', KERNEL_SAVE, 'btne_save', '', ($_SESSION['sbPlugins']->isRightAvailable('pl_polls', 'elems_edit') ? '' : 'disabled="disabled"'));
	$layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog()"');

	$layout->show();
}


// Функция сохранения изменений результата опроса
function fPolls_Edit_Result_Submit()
{
	$ip = isset($_POST['ip']) && trim($_POST['ip']) != '' ? strip_tags(trim($_POST['ip'])) : '';
	$text = isset($_POST['text']) && trim($_POST['text']) != '' ? strip_tags(trim($_POST['text'])) : '';

	$row = array();
	$row['spr_date'] = sb_datetoint($_POST['date']);
	$row['spr_ip'] = $ip;
	$row['spr_text'] = $text;

	if($_GET['id'] != 'add')
	{
		$res = sql_param_query('UPDATE sb_polls_results SET ?a WHERE spr_id = ?d', $row, $_GET['id']);

		if($res < 1)
		{
			if(sb_strlen($text) > 50)
				$text = sb_substr($text, 0, 50).'...';

			sb_show_message(PL_POLLS_EDIT_RESULT_MSG_ERROR, false, 'warning');
			sb_add_system_message(sprintf(PL_POLLS_EDIT_RESULT_ERROR, $text), SB_MSG_WARNING);

			fPolls_Edit_Result();
			return;
		}
		else
		{
			echo '<script>
					var res = new Object();
					res.id = "'.intval($_GET['id']).'";
					res.ip = "'.$ip.'";
					res.date = "'.$_POST['date'].'";
					res.text = "'.$text.'";
					sbReturnValue(res);
				</script>';
		}
	}
	else
	{
		$row['spr_option_id'] = $_GET['option_id'];

		sql_param_query('INSERT INTO sb_polls_results SET ?a', $row);
		$id = sql_insert_id();

		if(sb_strlen($text) > 50)
			$text = sb_substr($text, 0, 50).'...';

		if($id == 0)
		{
			sb_show_message(sprintf(PL_POLLS_ADD_RESULT_ERROR, $text), false, 'warning');
			sb_add_system_message(sprintf(PL_POLLS_ADD_RESULT_ERROR, $text), SB_MSG_WARNING);

			fPolls_Edit_Result();
			return;
		}
		else
		{
			sb_add_system_message(sprintf(PL_POLLS_ADD_RESULT_OK, $text));
			echo '<script>
					var res = new Object();
					res.id = "'.$id.'";
					res.ip = "'.$ip.'";
					res.date = "'.$_POST['date'].'";
					res.text = "'.$text.'";
					res.action = "add";
					sbReturnValue(res);
				</script>';
		}
	}
}

// Функция удаления результатов опроса
function fPolls_Delete_Result()
{
	if(isset($_GET['option_id']) && $_GET['option_id'] != '')
	{
		$res = sql_param_query('DELETE FROM sb_polls_results WHERE spr_option_id = ?d', $_GET['option_id']);

		if($res > 0)
			echo 'count'.$GLOBALS['sbSql']->getAffectedRows();
		else
			echo 'ERROR';
	}
	else
	{
		if(isset($_GET['id']) && $_GET['id'] != '')
		{
			$res = sql_param_query('DELETE FROM sb_polls_results WHERE spr_id = ?d', $_GET['id']);
		}
		elseif(isset($_GET['poll_id']) && $_GET['poll_id'] != '')
		{
			$result = sql_param_query('SELECT spo_id FROM sb_polls_options WHERE spo_poll_id=?d', $_GET['poll_id']);

			foreach($result as $key => $value)
			{
				$res = sql_param_query('DELETE FROM sb_polls_results WHERE spr_option_id = ?d', $value[0]);
			}
		}

		if($res >= 1)
			echo (isset($_GET['id']) ? $_GET['id'] : $_GET['poll_id']);
		else
			echo 'ERROR';
	}
}

// перезагрузка(обновление) графика
function fPolls_Stat_Reload_Graph()
{
	$res = sql_param_query('SELECT spo_id, spo_name, spo_type, spo_order FROM sb_polls_options WHERE spo_poll_id = ?d ORDER BY spo_order', $_GET['id']);
	if(isset($res) && $res != '')
	{
		$resu = sql_param_query('SELECT r.spr_id FROM sb_polls_results r, sb_polls_options op, sb_polls p
					WHERE r.spr_option_id = op.spo_id AND op.spo_poll_id = p.sp_id AND p.sp_id = ?d', $_GET['id']);

		$all_num = count($resu);
		if($resu)
		{
			require_once (SB_CMS_LIB_PATH.'/graph/OFC_Chart.php');

			$tooltip = new OFC_Elements_Tooltip();
			$tooltip->set_shadow(false);
			$tooltip->set_stroke(1);
			$tooltip->set_colour( "#000000" );
			$tooltip->set_background_colour( "#FFFFE1" );
			$tooltip->set_title_style( "{font-size: 10px; color: #000000;}" );
			$tooltip->set_body_style( "{font-size: 10px; color: #000000;}" );
			$tooltip->set_hover();

			$x_axis = new OFC_Elements_Axis_X();
			$x_axis->set_stroke(1);
			$x_axis->set_colours('#909090', '#FFF5E0');

			$y_axis = new OFC_Elements_Axis_Y();
			$y_axis->set_stroke(1);
			$y_axis->set_colours('#909090', '#FFF5E0');

			$title = new OFC_Elements_Title(PL_POLLS_ROOT_NAME);
			$title->set_style('font-size:12px;font-weight:bold;color:#A50101');

			$chart = new OFC_Chart();
			$chart->set_bg_colour('#EFE5D0');
			$chart->set_tooltip($tooltip);
			$chart->set_x_axis($x_axis);
			$chart->set_y_axis($y_axis);
			$chart->set_title($title);

			$rgb = array();
			for($i = 0; $i < $all_num; $i++)
			{
				$rand_color = rand(0, 2);
				if($rand_color == 0)
					$rgb[] = '#'.dechex(rand(100, 200)).dechex(rand(0, 70)).dechex(rand(0, 70));
				elseif($rand_color == 1)
					$rgb[] = '#'.dechex(rand(0, 70)).dechex(rand(100, 200)).dechex(rand(0, 70));
				elseif($rand_color == 2)
					$rgb[] = '#'.dechex(rand(0, 70)).dechex(rand(0, 70)).dechex(rand(100, 200));
			}

			$pie = new OFC_Charts_Pie();
			$pie->set_label_colour('#000000');
			$pie->set_alpha(0.8);
			$pie->set_radius(130);
			$pie->set_colours($rgb);
			$pie->set_tooltip('#val#%');
			$pie->set_border(2);

			foreach($res as $key => $value)
			{
				$count_res = sql_param_query('SELECT COUNT(*) FROM sb_polls_results WHERE spr_option_id = ?d', $value[0]);
				$proc = round(($count_res[0][0] * 100) / $all_num);

				$val = new OFC_Charts_Pie_Value($proc, $value[1].' ('.$proc.'%)');
				$val->on_click('pie_on_click('.$value[0].')');
				$vals[] = $val;

			}

			$pie->set_values($vals);
			$chart->add_element($pie);
			echo $chart->toString();
		}
		else
		{
			return;
		}
	}
	else
	{
		return;
	}
}

function fPolls_Stat()
{
	$values = '';
	$all_count = 0;

	$res = sql_param_query('SELECT spo_id, spo_name, spo_type, spo_order FROM sb_polls_options WHERE spo_poll_id = ?d ORDER BY spo_order', $_GET['id']);

	if(isset($res) && $res != '')
	{
		$resu = sql_param_query('SELECT r.spr_id FROM sb_polls_results r, sb_polls_options op, sb_polls p
					WHERE r.spr_option_id = op.spo_id AND op.spo_poll_id = p.sp_id AND p.sp_id = ?d', $_GET['id']);

		$all_num = count($resu);
		if($resu)
		{
			$values .= '<tr id="tr_0">
							<th class="header" style="height:20px; vertical-align:middle;">'.PL_POLLS_EDIT_HEADER_VARIANT.'</th>
							<th class="header" style="vertical-align:middle;">'.PL_POLLS_EDIT_OUNT_VOICE.'</th>
							<th class="header" style="vertical-align:middle;">'.PL_POLLS_EDIT_PROCENT.'</th>
							<th class="header" style="vertical-align:middle;"></th>
						</tr>';

			$class = '';
			foreach($res as $key => $value)
			{
				$count_res = sql_param_query('SELECT COUNT(*) FROM sb_polls_results WHERE spr_option_id = ?d', $value[0]);
				$proc = round(($count_res[0][0] * 100) / $all_num);

				if ($class == 'class="odd"')
					$class = 'class="even"';
				else
					$class = 'class="odd"';

				$values .= '<tr id = "tr_'.($key+1).'" '.$class.'>
								<td style="width:30%; height:30px; text-align:center;">
									'.$value[1].'
								</td>
								<td style="width:20%; text-align:center;" id=count_'.$key.'>
									'.$count_res[0][0].'
								</td>
								<td style="width:20%; text-align:center;" id=proc_'.$key.'>
									'.$proc.'%
								</td>
								<td style="width:30%; text-align:center;">
									[<a href="#" onclick="sbShowResult('.$value[0].');">'.PL_POLLS_RESULT_LABEL.'</a>]
								</td>
							</tr>';
				$all_count += $count_res[0][0];
			}

			$values .= '<tr id="tr_'.($key + 2).'">
							<td colspan="3" style="padding-left:4px;">
								<b>'.PL_POLLS_ALL_COUNT_VOTE.': '.$all_count.'</b>
							</td>
							<td style="text-align:center; padding:5px;">
								[<a href="#" onclick="sbDeleteResult(\'all\', '.$_GET['id'].');">'.PL_POLLS_DELETE_ALL.'</a>]
							</td>
						</tr>
						<tr id="last_tr">
							<td>&nbsp;</td>
						</tr>';
		}
	}

	if ($values != '')
	{
		echo '<table style="width:100%;" border="0" cellpadding="0" cellspacing="0" id="variant_table">
		 		'.$values.'
		 	</table>';
	}
	else
	{
		echo '<br /><div class="hint_div" style="text-align:center;">'.PL_POLLS_EDIT_NO_RESULTS.'</div><br />';
	}
}

/**
 * Функция изменения активности опроса
 */
function fPolls_Set_Active()
{
	if (!$_SESSION['sbPlugins']->isRightAvailable('pl_polls', 'elems_public'))
		return;

	sbIsGroupEdit(false);

	$date = time();
	foreach ($_GET['ids'] as $val)
    {
       	sql_query('INSERT INTO sb_catchanges (el_id, cat_ident, change_date, change_user_id, action) VALUES (?d, ?, ?d, ?d, ?)', $val, 'pl_polls', $date, $_SESSION['sbAuth']->getUserId(), 'edit');
    }

    $res = sql_param_query('UPDATE sb_polls SET sp_active=IF(sp_active=0,1,0) WHERE sp_id IN (?a)', $_GET['ids'], PL_POLLS_SET_ACTIVE);
    if ($res)
    	echo 'TRUE';
}

function fPolls_Delete()
{
	$res = sql_param_query('SELECT spo_id FROM sb_polls_options WHERE spo_poll_id = ?d', $_GET['id']);

	if($res)
	{
		foreach($res as $key => $value)
		{
			sql_param_query('DELETE FROM sb_polls_results WHERE spr_option_id = ?d', $value[0]);
			sql_param_query('DELETE FROM sb_polls_options WHERE spo_id = ?d', $value[0]);
		}
	}
}

function fPolls_Delete_With_Elements()
{
	if(isset($_GET['elems_id']) && $_GET['elems_id'] != '')
	{
		$elems = explode(',',$_GET['elems_id']);
		$res = sql_param_query('SELECT spo_id FROM sb_polls_options WHERE spo_poll_id IN (?a)', $elems);

		if($res)
		{
			foreach($res as $key => $value)
			{
				sql_param_query('DELETE FROM sb_polls_results WHERE spr_option_id = ?d', $value[0]);
				sql_param_query('DELETE FROM sb_polls_options WHERE spo_id = ?d', $value[0]);
			}
		}
	}
}

function fPolls_Paste()
{
	if (!isset($_GET['action']) || $_GET['action'] != 'copy' || !isset($_GET['e']) || !is_array($_GET['e']) || count($_GET['e']) <= 0 || !isset($_GET['ne']) || !is_array($_GET['ne']) || count($_GET['ne']) <= 0)
        return;

	$els = array();
    foreach ($_GET['e'] as $key => $value)
    {
        $els[intval($value)] = intval($_GET['ne'][$key]);
    }

    $in_str = implode(',', array_keys($els));

	$res = sql_query('SELECT spo_poll_id, spo_name, spo_type, spo_order FROM sb_polls_options WHERE spo_poll_id IN ('.$in_str.')');
	if ($res)
	{
		foreach($res as $value)
	    {
			list($spo_poll_id, $spo_name, $spo_type, $spo_order) = $value;

			sql_query('INSERT INTO sb_polls_options (spo_poll_id, spo_name, spo_type, spo_order) VALUES (?d, ?, ?, ?d)', $els[$spo_poll_id], $spo_name, $spo_type, $spo_order);
	    }
	}

	if (!$_SESSION['sbPlugins']->isPluginAvailable('pl_workflow') || !$_SESSION['sbPlugins']->isPluginInWorkflow('pl_polls'))
		return;

	$res = sql_query('SELECT sp_id, sp_active FROM sb_polls WHERE sp_id IN ('.implode(',', $_GET['ne']).')');

	if ($res)
	{
		foreach ($res as $value)
		{
			list($sp_id, $sp_active) = $value;

			if (!sb_workflow_status_available($sp_active, 'pl_polls', -1))
			{
				sql_query('UPDATE sb_polls SET sp_active=?d WHERE sp_id=?d', current(sb_get_avail_workflow_status('pl_polls')), $sp_id);
			}
		}
	}
}

function fPolls_After_Paste_Categs_With_Elements()
{
	if (!isset($_SESSION['paste_categs_with_elems_ids']) ||
		!isset($_SESSION['paste_categs_with_elems_ids']['old']) ||
		!isset($_SESSION['paste_categs_with_elems_ids']['new']))
	{
		return;
	}

	$_GET['e'] = array_values($_SESSION['paste_categs_with_elems_ids']['old']);
	$_GET['ne'] = array_values($_SESSION['paste_categs_with_elems_ids']['new']);
	$_GET['action'] = 'copy';

	fPolls_Paste();
}


function fPolls_Design_Get($args)
{
	$result = '<b><a href="javascript:void(0);" onclick="sbElemsEdit(event);">'.$args['spt_title'].'</a></b>
	<div class="smalltext" style="margin-top:7px;">';

	static $view_info_pages = null;
	static $view_info_temps = null;

	if (is_null($view_info_pages))
	{
		$view_info_pages = $_SESSION['sbPlugins']->isRightAvailable('pl_pages', 'read');
	}

	if (is_null($view_info_temps))
	{
		$view_info_temps = $_SESSION['sbPlugins']->isRightAvailable('pl_templates', 'read');
	}

	$id = intval($args['spt_id']);
	$pages = sql_query('SELECT pages.p_id, pages.p_name FROM sb_pages pages, sb_elems elems
	                    WHERE elems.e_link="page" AND elems.e_temp_id="'.$id.'" AND elems.e_ident="pl_polls_list" AND pages.p_id=elems.e_p_id GROUP BY pages.p_id ORDER BY pages.p_name LIMIT 4');

	$temps = sql_query('SELECT temps.t_id, temps.t_name FROM sb_templates temps, sb_elems elems
	                    WHERE elems.e_link="temp" AND elems.e_temp_id="'.$id.'" AND elems.e_ident="pl_polls_list" AND temps.t_id=elems.e_p_id GROUP BY temps.t_id ORDER BY temps.t_name LIMIT 4');

	if ($pages)
	{
	    $result .= '<table cellpadding="0" cellspacing="0">
	                <tr>
	                    <td valign="top" nowrap="nowrap" class="smalltext">'.KERNEL_USED_ON_PAGES.':&nbsp;</td>
	                    <td class="smalltext"><span style="color:green;">';

		$num = min(3, count($pages));
		for ($i = 0; $i < $num; $i++)
		{
			list($p_id, $p_name) = $pages[$i];
			$result .= ($view_info_pages ? '<a href="'.SB_CMS_CONTENT_FILE.'?event=pl_pages_init&sb_sel_id='.$p_id.'">'.$p_name.'</a>' : $p_name).', ';
		}

		if ($num < count($pages))
			$result .= '&nbsp;<a href="javascript:void(0);" onclick="linkPages(event);">...</a>';
	    else
	        $result = substr($result, 0, -2);

	    $result .= '</span></td></tr></table>';
	}
	else
	{
	    $result .= KERNEL_USED_ON_PAGES.': <span style="color: red;">'.KERNEL_NOT_USED.'</span><br />';
	}

	if ($temps)
	{
	    $result .= '<table cellpadding="0" cellspacing="0">
	                <tr>
	                    <td valign="top" nowrap="nowrap" class="smalltext">'.KERNEL_USED_ON_TEMPS.':&nbsp;</td>
	                    <td class="smalltext"><span style="color:green;">';

	    $num = min(3, count($temps));
	    for ($i = 0; $i < $num; $i++)
		{
			list($t_id, $t_name) = $temps[$i];
			$result .= ($view_info_temps ? '<a href="'.SB_CMS_CONTENT_FILE.'?event=pl_templates_init&sb_sel_id='.$t_id.'">'.$t_name.'</a>' : $t_name).', ';
		}

		if ($num < count($temps))
			$result .= '&nbsp;<a href="javascript:void(0);" onclick="linkTemps(event);">...</a>';
	    else
	        $result = substr($result, 0, -2);
		$result .= '</span></td></tr></table>';
	}
	else
	{
		$result .= KERNEL_USED_ON_TEMPS.': <span style="color: red;">'.KERNEL_NOT_USED.'</span><br />';
	}
    $result .= '</div>';
    return $result;
}

function fPolls_Design_Init()
{
	require_once(SB_CMS_LIB_PATH.'/sbElements.inc.php');
	$elems = new sbElements('sb_polls_temps', 'spt_id', 'spt_title', 'fPolls_Design_Get', 'pl_polls_design_init', 'pl_polls_design_list');
    $elems->mCategsDeleteWithElementsMenu = true;

	$elems->mCategsRootName = KERNEL_DESIGN_ROOT_NAME;
    $elems->mElemsIcon = SB_CMS_IMG_URL.'/plugins/pl_polls_elem_32.png';

    $elems->addSorting(PL_POLLS_DESIGN_EDIT_SORT_BY_TITLE, 'spt_title');
    $elems->mCategsPasteElemsMenuTitle = KERNEL_DESIGN_PASTE_ELEMS_MENU_TITLE;

    $elems->mElemsAddMenuTitle  = KERNEL_DESIGN_ELEMS_ADD_MENU_TITLE;
    $elems->mElemsEditMenuTitle = KERNEL_DESIGN_ELEMS_EDIT_MENU_TITLE;
    $elems->mElemsCopyMenuTitle = KERNEL_DESIGN_ELEMS_COPY_MENU_TITLE;
    $elems->mElemsCutMenuTitle  = KERNEL_DESIGN_ELEMS_CUT_MENU_TITLE;

    $elems->mElemsEditEvent =  'pl_polls_design_edit';
    $elems->mElemsEditDlgWidth = 900;
	$elems->mElemsEditDlgHeight = 700;

	$elems->mElemsAddEvent =  'pl_polls_design_edit';
    $elems->mElemsAddDlgWidth = 900;
	$elems->mElemsAddDlgHeight = 700;

	$elems->mElemsDeleteEvent = 'pl_polls_design_delete';

	$elems->mCategsClosed = false;
	$elems->mCategsRubrikator = false;

	$elems->mElemsJavascriptStr .= '
		function linkPages(e)
		{
	    	if (!sbSelEl)
	        {
	        	var el = sbEventTarget(e);

                while (el.parentNode && !el.getAttribute("true_id"))
                	el = el.parentNode;

					var el_id = el.getAttribute("el_id");
	        }
	        else
				var el_id = sbSelEl.getAttribute("el_id");

	        strPage = "'.SB_CMS_DIALOG_FILE.'?event=pl_pages_get_links&id=" + el_id + "&ident[]=pl_polls_list";
            strAttr = "resizable=1,width=800,height=600";
            sbShowModalDialog(strPage, strAttr, null, window);
	    }

	    function linkTemps(e)
	    {
			if (!sbSelEl)
	        {
	        	var el = sbEventTarget(e);

	            while (el.parentNode && !el.getAttribute("true_id"))
                	el = el.parentNode;

				var el_id = el.getAttribute("el_id");
			}
	        else
	        	var el_id = sbSelEl.getAttribute("el_id");

	        strPage = "'.SB_CMS_DIALOG_FILE.'?event=pl_templates_get_links&id=" + el_id + "&ident[]=pl_polls_list";
            strAttr = "resizable=1,width=800,height=600";
            sbShowModalDialog(strPage, strAttr, null, window);
		}

	    function PollsList()
	    {
			window.location = "'.SB_CMS_CONTENT_FILE.'?event=pl_polls_init";
		}';

	$elems->addElemsMenuItem(KERNEL_LINK_PAGES_MENU_ITEM, 'linkPages();');
	$elems->addElemsMenuItem(KERNEL_LINK_TEMPS_MENU_ITEM, 'linkTemps();');
	$elems->addElemsMenuItem(PL_POLLS_POLLS_LIST_MENU, 'PollsList();', false);

	$elems->init();
}

function fPolls_Design_Edit($htmlStr = '', $footerStr = '')
{
	// проверка прав доступа
	if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'], 'pl_polls_design_list'))
		return;

	if (count($_POST) == 0 && isset($_GET['id']) && $_GET['id'] != '')
	{
		$result =sql_param_query ('SELECT spt_title, spt_lang, spt_checked, spt_count, spt_perpage,
									spt_delim, spt_empty, spt_top, spt_cat_top, spt_polls_top, spt_element, spt_polls_bottom, spt_cat_bottom, spt_bottom, spt_pagelist_id,
									spt_fields_temps, spt_categs_temps, spt_messages
									FROM sb_polls_temps WHERE spt_id=?d ', $_GET['id'] );
   		if ($result)
	    {
			list($spt_title, $spt_lang, $spt_checked, $spt_count, $spt_perpage, $spt_delim, $spt_empty,
					$spt_top, $spt_categ_top, $spt_polls_top, $spt_element, $spt_polls_bottom, $spt_categ_bottom, $spt_bottom, $spt_pagelist_id,
					$spt_fields_temps, $spt_categs_temps, $spt_messages) = $result[0];
		}
		else
		{
			sb_show_message(PL_POLLS_DESIGN_EDIT_ERROR, true, 'warning');
			return;
		}

	    if ($spt_fields_temps != '')
	        $spt_fields_temps = unserialize($spt_fields_temps);
	    else
	        $spt_fields_temps = array();


	    if ($spt_categs_temps != '')
	        $spt_categs_temps = unserialize($spt_categs_temps);
	    else
	        $spt_categs_temps = array();

	    if ($spt_messages != '')
	        $spt_messages = unserialize($spt_messages);
	    else
	        $spt_messages = array();


	    if ($spt_checked != '')
		    $spt_checked = explode(' ', $spt_checked);
		else
		    $spt_checked = array();
		 if(!isset($spt_fields_temps['sp_change_date']))
		 	$spt_fields_temps['sp_change_date'] = PL_POLLS_DESIGN_CHANGE_DATE_VARIANT;
	}
	elseif (count($_POST) > 0)
	{
		$spt_pagelist_id = 0;
		$spt_checked = array();

		extract($_POST);
		if (!isset($_GET['id']))
            $_GET['id'] = '';
	}
	else
	{
		$spt_title = $spt_top = $spt_categ_top = $spt_element = $spt_categ_bottom = $spt_bottom =
		$spt_delim = $spt_empty =  $spt_polls_top = $spt_polls_bottom = '';

		$spt_categs_temps = $spt_checked = $spt_fields_temps = array();
		$spt_lang = SB_CMS_LANG;
		$spt_count = 1;
		$spt_perpage = 10;
		$spt_pagelist_id = 0;

		$spt_messages = array();
		$spt_messages['success_add'] = PL_POLLS_DESIGN_SUCCESS_VOTED_MSG;
		$spt_messages['err_add'] = PL_POLLS_DESIGN_ERR_ADD_MSG;
		$spt_messages['err_voted'] = PL_POLLS_DESIGN_ERR_VOTED;
		$spt_messages['no_polls'] = PL_POLLS_DESIGN_ERR_NO_POLLS;
		$spt_messages['not_have_rights_add'] = PL_POLLS_DESIGN_ERR_RIGHT_ADD;

		$spt_fields_temps['sp_checkbox'] = PL_POLLS_DESIGN_HTML_COD_CHEKCBOX;
		$spt_fields_temps['sp_radio'] = PL_POLLS_DESIGN_HTML_COD_RADIO;
		$spt_fields_temps['sp_text'] = PL_POLLS_DESIGN_HTML_COD_TEXT;
		$spt_fields_temps['sp_group_start'] = '<hr />';
		$spt_fields_temps['sp_change_date'] = PL_POLLS_DESIGN_CHANGE_DATE_VARIANT;

		$_GET['id'] = '';
	}

	echo '<script>
	        function checkValues()
            {
                var el_title = sbGetE("spt_title");
                if (el_title.value == "")
                {
          	         alert("'.PL_POLLS_DESIGN_NO_TITLE_MSG.'");
          	         return false;
                }
            }';

	if ($htmlStr != '')
	{
		echo '
			function cancel()
			{
                var res = new Object();
		        res.html = "'.$htmlStr.'";
		        res.footer = "'.$footerStr.'";
		        res.footer_link = "";
				sbReturnValue(res);
			}
			sbAddEvent(window, "close", cancel);';
	}
	echo '</script>';

	require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

	$layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE.'?event=pl_polls_design_submit'.($_SERVER['QUERY_STRING'] != '' ? '&'.$_SERVER['QUERY_STRING'] : ''), 'thisDialog', 'post', 'checkValues()');
	$layout->mTableWidth = '95%';
	$layout->mTitleWidth = '200';

	$layout->addTab(PL_POLLS_DESIGN_EDIT_TAB1);
	$layout->addHeader(PL_POLLS_DESIGN_EDIT_TAB1);

	$layout->addField(PL_POLLS_DESIGN_EDIT_TITLE, new sbLayoutInput('text', $spt_title, 'spt_title', '', 'style="width:97%;"', true));
	$layout->addField('', new sbLayoutDelim());

	$fld = new sbLayoutSelect($GLOBALS['sb_site_langs'], 'spt_lang');
	$fld->mSelOptions = array($spt_lang);
	$fld->mHTML = '<div class="hint_div" style="margin-top: 5px;">'.PL_POLLS_DESIGN_EDIT_LANG_LABEL.'</div>';
	$layout->addField(PL_POLLS_DESIGN_EDIT_LANG, $fld);

	$layout->addPluginFieldsTempsCheckboxes('pl_polls', $spt_checked, 'spt_checked');

	fPager_Design_Get($layout, $spt_pagelist_id, 'spt_pagelist_id', $spt_perpage, 'spt_perpage');

	$layout->addTab(PL_POLLS_DESIGN_EDIT_TAB2);
	$layout->addHeader(PL_POLLS_DESIGN_EDIT_TAB2);

	$html = '<div align="center" class="hint_div" style="margin-top: 5px;">'.PL_POLLS_DESIGN_EDIT_TAB1.'</div>';
	$layout->addField('', new sbLayoutHTML($html, true));
	$layout->addField('', new sbLayoutDelim());

	$tags = array('{ID}', '{ELEM_URL}', '{CAT_ID}', '{CAT_URL}', '{CAT_TITLE}', '{LINK}');
	$tags_values = array(PL_POLLS_DESIGN_EDIT_ID_TAG, PL_POLLS_DESIGN_EDIT_ELEM_URL_TAG, PL_POLLS_DESIGN_EDIT_CAT_ID_TAG,
			PL_POLLS_DESIGN_EDIT_CATEG_URL_TAG, PL_POLLS_DESIGN_EDIT_CAT_TITLE_TAG, PL_POLLS_DESIGN_EDIT_LINK_TAG);

	$fld = new sbLayoutTextarea($spt_fields_temps['sp_checkbox'], 'spt_fields_temps[sp_checkbox]', '', 'style="width:100%;height:50px;"');
	$fld->mTags = array_merge(array(PL_POLLS_DESIGN_HTML_COD_CHEKCBOX), $tags);
	$fld->mValues = array_merge(array(SB_LAYOUT_PLUGIN_INPUT_FIELDS_HTML_TAG), $tags_values);
	$layout->addField(PL_POLLS_DESIGN_CHECKBOX_FIELD, $fld);

	$fld = new sbLayoutTextarea($spt_fields_temps['sp_radio'], 'spt_fields_temps[sp_radio]', '', 'style="width:100%;height:50px;"');
	$fld->mTags = array_merge(array(PL_POLLS_DESIGN_HTML_COD_RADIO), $tags);
	$fld->mValues = array_merge(array(SB_LAYOUT_PLUGIN_INPUT_FIELDS_HTML_TAG), $tags_values);
	$layout->addField(PL_POLLS_DESIGN_RADIO_FIELD, $fld);

	$fld = new sbLayoutTextarea($spt_fields_temps['sp_text'], 'spt_fields_temps[sp_text]', '', 'style="width:100%;height:50px;"');
	$fld->mTags = array_merge(array(PL_POLLS_DESIGN_HTML_COD_TEXT), $tags);
	$fld->mValues = array_merge(array(SB_LAYOUT_PLUGIN_INPUT_FIELDS_HTML_TAG), $tags_values);
	$layout->addField(PL_POLLS_DESIGN_TEXT_FIELD, $fld);

	// Начало вывода групп
	$fld = new sbLayoutTextarea(isset($spt_fields_temps['sp_group_start']) ? $spt_fields_temps['sp_group_start'] : '', 'spt_fields_temps[sp_group_start]', '', 'style="width:100%;height:50px;"');
	$fld->mTags = array_merge(array(PL_POLLS_DESIGN_NAME_TAG_VAl), $tags);
	$fld->mValues = array_merge(array(PL_POLLS_DESIGN_NAME_TAG), $tags_values);
	$layout->addField(PL_POLLS_DESIGN_GROUP_START_FIELD, $fld);

	// Конец вывода групп
	$fld = new sbLayoutTextarea(isset($spt_fields_temps['sp_group_end']) ? $spt_fields_temps['sp_group_end'] : '', 'spt_fields_temps[sp_group_end]', '', 'style="width:100%;height:50px;"');
	$fld->mTags = array_merge(array(PL_POLLS_DESIGN_NAME_TAG_VAl), $tags);
	$fld->mValues = array_merge(array(PL_POLLS_DESIGN_NAME_TAG), $tags_values);
	$layout->addField(PL_POLLS_DESIGN_GROUP_END_FIELD, $fld);

	// Дата последнего изменения
	$fld = new sbLayoutTextarea($spt_fields_temps['sp_change_date'], 'spt_fields_temps[sp_change_date]', '', 'style="width:100%;height:50px;"');
	$fld->mTags = array('{DAY}', '{WEEKDAY}', '{WEEKDAY_SHORT}', '{MONTH}', '{MONTH_TEXTUAL}', '{LONG_YEAR}', '{SHORT_YEAR}', '{HOUR}', '{MINUTE}');
	$fld->mValues = array(KERNEL_DAY_TAG, KERNEL_WEEKDAY_TAG_FULL, KERNEL_WEEKDAY_TAG_SHORT, KERNEL_MONTH_TAG, KERNEL_MONTH_NAME_TAG, KERNEL_YEAR_4_TAG, KERNEL_YEAR_2_TAG, KERNEL_HOURS_TAG, KERNEL_MINUTES_TAG);
	$layout->addField(PL_POLLS_DESIGN_CHANGE_DATE_FIELD, $fld);

	$polls_tags = array();
	$polls_tags_values = array();
	$layout->getPluginFieldsTags('pl_polls', $polls_tags, $polls_tags_values);

	if(count($polls_tags) > 0)
	{
		$html = '<div align="center" class="hint_div" style="margin-top: 5px;">'.PL_POLLS_DESIGN_EDIT_USERS.'</div>';
		$layout->addField('', new sbLayoutHTML($html, true));

		$layout->addPluginFieldsTemps('pl_polls', $spt_fields_temps, 'spt_', $tags, $tags_values);
	}

	$cat_tags = array();
	$cat_tags_values = array();
	$layout->getPluginFieldsTags('pl_polls', $cat_tags, $cat_tags_values, true);

	if (count($cat_tags) > 0)
	{
		$layout->addTab(PL_POLLS_DESIGN_EDIT_TAB3);
		$layout->addHeader(PL_POLLS_DESIGN_EDIT_TAB3);
		$layout->addPluginFieldsTemps('pl_polls', $spt_categs_temps, 'spt_', $tags, $tags_values, true);
	}

	$layout->addTab(PL_POLLS_POLLS_LIST_MENU);
	$layout->addHeader(PL_POLLS_POLLS_LIST_MENU);

	$layout->addField(PL_POLLS_DESIGN_EDIT_COUNT, new sbLayoutInput('text', $spt_count, 'spt_count', 'spin_spt_count', 'style="width:100px;"'));

	$fld = new sbLayoutTextarea($spt_top, 'spt_top', '', 'style="width:100%; height:100px;"');
	$fld->mTags = array('{MESSAGES}', PL_POLLS_DESIGN_EDIT_FORM, '{NUM_LIST}', '{VOTES_COUNT}', '{POLLS_COUNT}');
	$fld->mValues = array(PL_POLLS_DESIGN_EDIT_MESSAGES, PL_POLLS_DESIGN_EDIT_FORM_TAG, PL_POLLS_DESIGN_EDIT_PAGELIST_TAG,
			PL_POLLS_DESIGN_EDIT_ALL_COUNT_VOTES, PL_POLLS_DESIGN_EDIT_ALL_COUNT_POLLS);
	$layout->addField(PL_POLLS_DESIGN_EDIT_TOP, $fld);

	$layout->addField('', new sbLayoutDelim());

	$fld = new sbLayoutTextarea($spt_categ_top, 'spt_categ_top', '', 'style="width:100%;height:100px;"');
	$fld->mTags = array_merge(array('-', '{CAT_TITLE}', '{CAT_COUNT_VOTES}', '{CAT_COUNT}', '{CAT_LEVEL}', '{CAT_ID}', '{CAT_URL}'), $cat_tags);
	$fld->mValues = array_merge(array(PL_POLLS_DESIGN_EDIT_CATEG_GROUP_TAG, PL_POLLS_DESIGN_EDIT_CAT_TITLE_TAG,
			PL_POLLS_DESIGN_EDIT_ALL_COUNT_VOTES_CAT, PL_POLLS_DESIGN_EDIT_CATEG_COUNT_POLLS_TAG, PL_POLLS_DESIGN_EDIT_CATEG_LEVEL_TAG,
			PL_POLLS_DESIGN_EDIT_CAT_ID_TAG, PL_POLLS_DESIGN_EDIT_CATEG_URL_TAG), $cat_tags_values);
	$layout->addField(PL_POLLS_DESIGN_EDIT_CAT_TOP, $fld);

	$fld = new sbLayoutTextarea($spt_polls_top, 'spt_polls_top', '', 'style="width:100%;height:100px;"');
	$fld->mTags = array_merge(array('-', '{QUESTION}', '{COUNT_VOTES}', '{LINK}', '{CHANGE_DATE}'), $polls_tags);
	$fld->mValues = array_merge(array(PL_POLLS_DESIGN_EDIT_POLL, PL_POLLS_EDIT_QUESTION, PL_POLLS_DESIGN_EDIT_COUNT_VOTES, PL_POLLS_DESIGN_EDIT_LINK_TAG, PL_POLLS_DESIGN_CHANGE_DATE_FIELD), $polls_tags_values);
	$layout->addField(PL_POLLS_DESIGN_EDIT_POLLS_TOP, $fld);

	$fld = new sbLayoutTextarea($spt_element, 'spt_element', '', 'style="width:100%;height:200px;"');
	$fld->mTags = array_merge(array('-', '{TEXT_VARIANT}', '{FIELD_VARIANT}', '{COUNT_VOTES}', '{ALL_COUNT}'), $polls_tags,
				array('-', '{CAT_TITLE}', '{CAT_COUNT_VOTES}', '{CAT_COUNT}', '{CAT_LEVEL}', '{CAT_ID}', '{CAT_URL}'), $cat_tags);

	$fld->mValues = array_merge(array(PL_POLLS_EDIT_TAB1, PL_POLLS_DESIGN_TEXT_VARIANT, PL_POLLS_DESIGN_FIELD_VARIANT,
				PL_POLLS_DESIGN_COUNT_VOTES_TAG, PL_POLLS_DESIGN_EDIT_ALL_COUNT_VOTES), $polls_tags_values,
				array(PL_POLLS_DESIGN_EDIT_CATEG_GROUP_TAG, PL_POLLS_DESIGN_EDIT_CAT_TITLE_TAG, PL_POLLS_DESIGN_EDIT_ALL_COUNT_VOTES_CAT,
				PL_POLLS_DESIGN_EDIT_CATEG_COUNT_POLLS_TAG, PL_POLLS_DESIGN_EDIT_CATEG_LEVEL_TAG, PL_POLLS_DESIGN_EDIT_CAT_ID_TAG,
				PL_POLLS_DESIGN_EDIT_CATEG_URL_TAG), $cat_tags_values);
	$layout->addField(PL_POLLS_DESIGN_EDIT_POLL, $fld);

	$fld = new sbLayoutTextarea($spt_polls_bottom, 'spt_polls_bottom', '', 'style="width:100%;height:100px;"');
	$fld->mTags = array_merge(array('-', '{QUESTION}', '{COUNT_VOTES}', '{LINK}', '{CHANGE_DATE}'), $polls_tags);
	$fld->mValues = array_merge(array(PL_POLLS_DESIGN_EDIT_POLL, PL_POLLS_EDIT_QUESTION, PL_POLLS_DESIGN_EDIT_COUNT_VOTES, PL_POLLS_DESIGN_EDIT_LINK_TAG, PL_POLLS_DESIGN_CHANGE_DATE_FIELD), $polls_tags_values);
	$layout->addField(PL_POLLS_DESIGN_EDIT_POLLS_BOTTOM, $fld);

	$fld = new sbLayoutTextarea($spt_empty, 'spt_empty', '', 'style="width:100%;height:100px;"');
	$layout->addField(PL_POLLS_DESIGN_EDIT_EMPTY, $fld);

	$fld = new sbLayoutTextarea($spt_delim, 'spt_delim', '', 'style="width:100%;height:100px;"');
	$layout->addField(PL_POLLS_DESIGN_EDIT_DELIM, $fld);

	$fld = new sbLayoutTextarea($spt_categ_bottom, 'spt_categ_bottom', '', 'style="width:100%;height:100px;"');
	$fld->mTags = array_merge(array('-', '{CAT_TITLE}', '{CAT_COUNT_VOTES}', '{CAT_COUNT}', '{CAT_LEVEL}', '{CAT_ID}', '{CAT_URL}'), $cat_tags);

	$fld->mValues = array_merge(array(PL_POLLS_DESIGN_EDIT_CATEG_GROUP_TAG, PL_POLLS_DESIGN_EDIT_CAT_TITLE_TAG,
			PL_POLLS_DESIGN_EDIT_ALL_COUNT_VOTES_CAT, PL_POLLS_DESIGN_EDIT_CATEG_COUNT_POLLS_TAG, PL_POLLS_DESIGN_EDIT_CATEG_LEVEL_TAG,
			PL_POLLS_DESIGN_EDIT_CAT_ID_TAG, PL_POLLS_DESIGN_EDIT_CATEG_URL_TAG), $cat_tags_values);
	$layout->addField(PL_POLLS_DESIGN_EDIT_CAT_BOTTOM, $fld);

	$layout->addField('', new sbLayoutDelim());

	$fld = new sbLayoutTextarea($spt_bottom, 'spt_bottom', '', 'style="width:100%; height:100px;"');
	$fld->mTags = array('{MESSAGES}', PL_POLLS_DESIGN_EDIT_FORM, '{NUM_LIST}', '{VOTES_COUNT}', '{POLLS_COUNT}');
	$fld->mValues = array(PL_POLLS_DESIGN_EDIT_MESSAGES, PL_POLLS_DESIGN_EDIT_FORM_TAG, PL_POLLS_DESIGN_EDIT_PAGELIST_TAG,
			PL_POLLS_DESIGN_EDIT_ALL_COUNT_VOTES, PL_POLLS_DESIGN_EDIT_ALL_COUNT_POLLS);
	$layout->addField(PL_POLLS_DESIGN_EDIT_BOTTOM, $fld);

	$layout->addTab(PL_POLLS_MESSAGES_TAB);
	$layout->addHeader(PL_POLLS_MESSAGES_TAB);

	$layout->addField(PL_POLLS_DESIGN_SUCCESS_VOTED_MSG, new sbLayoutTextarea($spt_messages['success_add'], 'spt_messages[success_add]', '', 'style="width:100%;height:50px;"'));
	$layout->addField('', new sbLayoutDelim());

	$layout->addField(PL_POLLS_DESIGN_MESSAGES_ERRORS, new sbLayoutTextarea($spt_messages['err_add'], 'spt_messages[err_add]', '', 'style="width:100%;height:50px;"'));

	$layout->addField('', new sbLayoutTextarea($spt_messages['err_voted'], 'spt_messages[err_voted]', '', 'style="width:100%;height:50px;"'));
	$layout->addField('', new sbLayoutTextarea($spt_messages['no_polls'], 'spt_messages[no_polls]', '', 'style="width:100%;height:50px;"'));
	$layout->addField('', new sbLayoutTextarea($spt_messages['not_have_rights_add'], 'spt_messages[not_have_rights_add]', '', 'style="width:100%; height:60px;"'));

	$layout->addButton('submit', KERNEL_SAVE, 'btn_save', '', ($_SESSION['sbPlugins']->isRightAvailable('pl_polls', 'design_edit') ? '' : 'disabled="disabled"'));
	if ($_GET['id'] != '')
		$layout->addButton('submit', KERNEL_APPLY, 'btn_apply', '', ($_SESSION['sbPlugins']->isRightAvailable('pl_polls', 'design_edit') ? '' : 'disabled="disabled"'));

	$layout->addButton('button', KERNEL_CANCEL, '', '', $htmlStr != '' ? 'onclick="cancel()"' : 'onclick="sbCloseDialog()"');

	$layout->show();
}

function fPolls_Design_Submit()
{
	// проверка прав доступа
	if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'], 'pl_polls_design_list'))
		return;

    if (!isset($_GET['id']))
        $_GET['id'] = '';

	$spt_top = $spt_bottom = $spt_categ_bottom = $spt_categ_top = $spt_polls_top = $spt_polls_bottom = '';

    $spt_pagelist_id = 0;
    $spt_messages = $spt_checked = array();

    $spt_lang = SB_CMS_LANG;

    $spt_fields_temps = array();
    $spt_categs_temps = array();

	extract($_POST);

	if ($spt_title == '')
	{
		sb_show_message(PL_POLLS_DESIGN_NO_TITLE_MSG, false, 'warning');
		fPolls_Design_Edit();
		return;
	}

	$row = array();
	$row['spt_title'] = $spt_title;
	$row['spt_lang'] = $spt_lang;
	$row['spt_checked'] = implode(' ', $spt_checked);
	$row['spt_count'] = $spt_count;
    $row['spt_perpage'] = $spt_perpage;
	$row['spt_delim'] = $spt_delim;
    $row['spt_empty'] = $spt_empty;
    $row['spt_top'] = $spt_top;
    $row['spt_cat_top'] = $spt_categ_top;
    $row['spt_polls_top'] = $spt_polls_top;
    $row['spt_element'] = $spt_element;
    $row['spt_polls_bottom'] = $spt_polls_bottom;
    $row['spt_cat_bottom'] = $spt_categ_bottom;
	$row['spt_bottom'] = $spt_bottom;
	$row['spt_pagelist_id'] = $spt_pagelist_id;
	$row['spt_fields_temps'] = serialize($spt_fields_temps);
	$row['spt_categs_temps'] = serialize($spt_categs_temps);
	$row['spt_messages'] = serialize($spt_messages);

	if ($_GET['id'] != '')
	{
		$res = sql_param_query('SELECT spt_title FROM sb_polls_temps WHERE spt_id=?d', $_GET['id']);
		if ($res)
	    {
	        // редактирование
	        list($old_title) = $res[0];

    	    sql_param_query('UPDATE sb_polls_temps SET ?a WHERE spt_id=?d', $row, $_GET['id'], sprintf(PL_POLLS_DESIGN_EDIT_OK, $old_title));
            sbQueryCache::updateTemplate('sb_polls_temps', $_GET['id']);

			$footer_ar = fCategs_Edit_Elem('design_edit');
			if (!$footer_ar)
			{
				sb_show_message(PL_POLLS_DESIGN_EDIT_ERROR, false, 'warning');
				sb_add_system_message(sprintf(PL_POLLS_DESIGN_EDIT_SYSTEMLOG_ERROR, $old_title), SB_MSG_WARNING);

				fPolls_Design_Edit();
				return;
			}

			$footer_str = $GLOBALS['sbSql']->escape($footer_ar[0], false, false);

    	    $row['spt_id'] = intval($_GET['id']);

            $html_str = fPolls_Design_Get($row);
    	    $html_str = sb_str_replace(array("\r\n", "\r", "\n"), '', $html_str);
            $html_str = $GLOBALS['sbSql']->escape($html_str, false, false);

    	    if (!isset($_POST['btn_apply']))
    	    {
        	    echo '<script>
        		        var res = new Object();
        		        res.html = "'.$html_str.'";
        		        res.footer = "'.$footer_str.'";
        		        res.footer_link = "";
        				sbReturnValue(res);
        			  </script>';
    	    }
    	    else
    	    {
    	        fPolls_Design_Edit($html_str, $footer_str);
    	    }
	    }
	    else
	    {
	        sb_show_message(PL_POLLS_DESIGN_EDIT_ERROR, false, 'warning');
            sb_add_system_message(sprintf(PL_POLLS_DESIGN_EDIT_SYSTEMLOG_ERROR, $spt_title), SB_MSG_WARNING);

            fPolls_Design_Edit();
		    return;
	    }
	}
	else
	{
	    $error = true;
	    if (sql_param_query('INSERT INTO sb_polls_temps SET ?a', $row))
	    {
    		$id = sql_insert_id();

    		if (fCategs_Add_Elem($id, 'design_edit'))
    		{
                sbQueryCache::updateTemplate('sb_polls_temps', $id);
				sb_add_system_message(sprintf(PL_POLLS_DESIGN_ADD_OK, $spt_title));
				echo '<script>
						sbReturnValue('.$id.');
					</script>';

				$error = false;
			}
			else
			{
				sql_query('DELETE FROM sb_polls_temps WHERE spt_id="'.$id.'"');
    		}
	    }

		if ($error)
		{
			sb_show_message(sprintf(PL_POLLS_DESIGN_ADD_ERROR, $spt_title), false, 'warning');
			sb_add_system_message(sprintf(PL_POLLS_DESIGN_ADD_SYSTEMLOG_ERROR, $spt_title), SB_MSG_WARNING);

			fPolls_Design_Edit();
			return;
		}
	}
}

function fPolls_Design_Delete()
{
	$id = intval($_GET['id']);
	$pages = sql_query('SELECT pages.p_id FROM sb_pages pages, sb_elems elems
						WHERE elems.e_link="page" AND elems.e_temp_id="'.$id.'" AND elems.e_ident="pl_polls_list" AND pages.p_id=elems.e_p_id LIMIT 1');

	$temps = false;
	if (!$pages)
	{
		$temps = sql_query('SELECT temps.t_id FROM sb_templates temps, sb_elems elems
						WHERE elems.e_link="temp" AND elems.e_temp_id="'.$id.'" AND elems.e_ident="pl_polls_list" AND temps.t_id=elems.e_p_id LIMIT 1');
    }

    if ($pages || $temps)
    {
		echo PL_POLLS_DESIGN_DELETE_ERROR;
    }
}



function fPolls_Design_Result_Get($args)
{
	$result = '<b><a href="javascript:void(0);" onclick="sbElemsEdit(event);">'.$args['sptr_title'].'</a></b>
	<div class="smalltext" style="margin-top:7px;">';

	static $view_info_pages = null;
	static $view_info_temps = null;

	if (is_null($view_info_pages))
	{
		$view_info_pages = $_SESSION['sbPlugins']->isRightAvailable('pl_pages', 'read');
	}

	if (is_null($view_info_temps))
	{
		$view_info_temps = $_SESSION['sbPlugins']->isRightAvailable('pl_templates', 'read');
	}

	$id = intval($args['sptr_id']);
	$pages = sql_query('SELECT pages.p_id, pages.p_name FROM sb_pages pages, sb_elems elems
				WHERE elems.e_link="page" AND elems.e_temp_id="'.$id.'" AND elems.e_ident="pl_polls_results" AND pages.p_id=elems.e_p_id GROUP BY pages.p_id ORDER BY pages.p_name LIMIT 4');

	$temps = sql_query('SELECT temps.t_id, temps.t_name FROM sb_templates temps, sb_elems elems
				WHERE elems.e_link="temp" AND elems.e_temp_id="'.$id.'" AND elems.e_ident="pl_polls_results" AND temps.t_id=elems.e_p_id GROUP BY temps.t_id ORDER BY temps.t_name LIMIT 4');

	if ($pages)
	{
		$result .= '<table cellpadding="0" cellspacing="0">
	                <tr>
	                    <td valign="top" nowrap="nowrap" class="smalltext">'.KERNEL_USED_ON_PAGES.':&nbsp;</td>
	                    <td class="smalltext"><span style="color:green;">';

		$num = min(3, count($pages));
		for ($i = 0; $i < $num; $i++)
		{
			list($p_id, $p_name) = $pages[$i];
			$result .= ($view_info_pages ? '<a href="'.SB_CMS_CONTENT_FILE.'?event=pl_pages_init&sb_sel_id='.$p_id.'">'.$p_name.'</a>' : $p_name).', ';
		}

		if ($num < count($pages))
			$result .= '&nbsp;<a href="javascript:void(0);" onclick="linkPages(event);">...</a>';
	    else
	        $result = substr($result, 0, -2);

		$result .= '</span></td></tr></table>';
	}
	else
	{
		$result .= KERNEL_USED_ON_PAGES.': <span style="color: red;">'.KERNEL_NOT_USED.'</span><br />';
	}

	if ($temps)
	{
	    $result .= '<table cellpadding="0" cellspacing="0">
	                <tr>
	                    <td valign="top" nowrap="nowrap" class="smalltext">'.KERNEL_USED_ON_TEMPS.':&nbsp;</td>
	                    <td class="smalltext"><span style="color:green;">';

	    $num = min(3, count($temps));
	    for ($i = 0; $i < $num; $i++)
		{
			list($t_id, $t_name) = $temps[$i];
			$result .= ($view_info_temps ? '<a href="'.SB_CMS_CONTENT_FILE.'?event=pl_templates_init&sb_sel_id='.$t_id.'">'.$t_name.'</a>' : $t_name).', ';
		}

		if ($num < count($temps))
			$result .= '&nbsp;<a href="javascript:void(0);" onclick="linkTemps(event);">...</a>';
	    else
	        $result = substr($result, 0, -2);
		$result .= '</span></td></tr></table>';
	}
	else
	{
		$result .= KERNEL_USED_ON_TEMPS.': <span style="color: red;">'.KERNEL_NOT_USED.'</span><br />';
	}
    $result .= '</div>';
    return $result;

}

function fPolls_Design_Result_Init()
{
	require_once(SB_CMS_LIB_PATH.'/sbElements.inc.php');
	$elems = new sbElements('sb_polls_temps_results', 'sptr_id', 'sptr_title', 'fPolls_Design_Result_Get', 'pl_polls_design_result_init', 'pl_polls_design_result');
    $elems->mCategsDeleteWithElementsMenu = true;
	$elems->mCategsRootName = KERNEL_DESIGN_ROOT_NAME;
    $elems->mElemsIcon = SB_CMS_IMG_URL.'/plugins/pl_polls_result_elem_32.png';

    $elems->addSorting(PL_POLLS_DESIGN_EDIT_SORT_BY_TITLE, 'sptr_title');
    $elems->mCategsPasteElemsMenuTitle = KERNEL_DESIGN_PASTE_ELEMS_MENU_TITLE;

    $elems->mElemsAddMenuTitle  = KERNEL_DESIGN_ELEMS_ADD_MENU_TITLE;
    $elems->mElemsEditMenuTitle = KERNEL_DESIGN_ELEMS_EDIT_MENU_TITLE;
    $elems->mElemsCopyMenuTitle = KERNEL_DESIGN_ELEMS_COPY_MENU_TITLE;
    $elems->mElemsCutMenuTitle  = KERNEL_DESIGN_ELEMS_CUT_MENU_TITLE;

    $elems->mElemsEditEvent =  'pl_polls_design_result_edit';
    $elems->mElemsEditDlgWidth = 900;
	$elems->mElemsEditDlgHeight = 700;

	$elems->mElemsAddEvent =  'pl_polls_design_result_edit';
    $elems->mElemsAddDlgWidth = 900;
	$elems->mElemsAddDlgHeight = 700;

	$elems->mElemsDeleteEvent = 'pl_polls_design_result_delete';

	$elems->mCategsClosed = false;
	$elems->mCategsRubrikator = false;

	$elems->mElemsJavascriptStr .= '
		function linkPages(e)
		{
	    	if (!sbSelEl)
	        {
	        	var el = sbEventTarget(e);

                while (el.parentNode && !el.getAttribute("true_id"))
                	el = el.parentNode;

					var el_id = el.getAttribute("el_id");
	        }
	        else
				var el_id = sbSelEl.getAttribute("el_id");

	        strPage = "'.SB_CMS_DIALOG_FILE.'?event=pl_pages_get_links&id=" + el_id + "&ident[]=pl_polls_results";
            strAttr = "resizable=1,width=800,height=600";
            sbShowModalDialog(strPage, strAttr, null, window);
	    }

	    function linkTemps(e)
	    {
			if (!sbSelEl)
	        {
	        	var el = sbEventTarget(e);

	            while (el.parentNode && !el.getAttribute("true_id"))
                	el = el.parentNode;

				var el_id = el.getAttribute("el_id");
			}
	        else
	        	var el_id = sbSelEl.getAttribute("el_id");

	        strPage = "'.SB_CMS_DIALOG_FILE.'?event=pl_templates_get_links&id=" + el_id + "&ident[]=pl_polls_results";
            strAttr = "resizable=1,width=800,height=600";
			sbShowModalDialog(strPage, strAttr, null, window);
		}

		function PollsList()
		{
			window.location = "'.SB_CMS_CONTENT_FILE.'?event=pl_polls_init";
		}';

	$elems->addElemsMenuItem(KERNEL_LINK_PAGES_MENU_ITEM, 'linkPages();');
	$elems->addElemsMenuItem(KERNEL_LINK_TEMPS_MENU_ITEM, 'linkTemps();');
	$elems->addElemsMenuItem(PL_POLLS_POLLS_LIST_MENU, 'PollsList();', false);

	$elems->init();
}

function fPolls_Design_Result_Edit($htmlStr = '', $footerStr = '')
{
	// проверка прав доступа
	if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'], 'pl_polls_design_result'))
		return;

	if (count($_POST) == 0 && isset($_GET['id']) && $_GET['id'] != '')
	{
		$result =sql_param_query ('SELECT sptr_title, sptr_lang, sptr_perpage, sptr_pagelist_id, sptr_count, sptr_checked, sptr_top,
									sptr_categs_top, sptr_result_top, sptr_element, sptr_result_bottom, sptr_categs_bottom, sptr_bottom,
									sptr_empty, sptr_delim, sptr_fields_temps, sptr_categs_temps, sptr_no_results
									FROM sb_polls_temps_results WHERE sptr_id=?d ', $_GET['id'] );
		if ($result)
	    {
			list($sptr_title, $sptr_lang, $sptr_perpage, $sptr_pagelist_id, $sptr_count, $sptr_checked, $sptr_top, $sptr_categs_top,
				$sptr_result_top, $sptr_element, $sptr_result_bottom, $sptr_categs_bottom, $sptr_bottom, $sptr_empty, $sptr_delim, $sptr_fields_temps,
				$sptr_categs_temps, $sptr_no_results) = $result[0];
		}
		else
		{
			sb_show_message(PL_POLLS_DESIGN_EDIT_ERROR, true, 'warning');
			return;
		}

	    if ($sptr_fields_temps != '')
	        $sptr_fields_temps = unserialize($sptr_fields_temps);
	    else
	        $sptr_fields_temps = array();

		if ($sptr_categs_temps != '')
			$sptr_categs_temps = unserialize($sptr_categs_temps);
	    else
			$sptr_categs_temps = array();

		if ($sptr_checked != '')
			$sptr_checked = explode(' ', $sptr_checked);
		else
			$sptr_checked = array();
		if(!isset($sptr_fields_temps['sp_change_date']))
			$sptr_fields_temps['sp_change_date'] = PL_POLLS_DESIGN_CHANGE_DATE_VARIANT;
	}
	elseif (count($_POST) > 0)
	{
		$sptr_checked = array();
 		$sptr_pagelist_id = 0;

		extract($_POST);
		if (!isset($_GET['id']))
			$_GET['id'] = '';
	}
	else
	{
		$sptr_title = $sptr_top = $sptr_categs_top = $sptr_element = $sptr_categs_bottom = $sptr_bottom =
		$sptr_no_results = $sptr_delim = $sptr_empty = $sptr_result_bottom = $sptr_result_top = '';

		$sptr_categs_temps = $sptr_checked = $sptr_fields_temps = array();
		$sptr_fields_temps['sp_group_start'] = '<hr />';
		$sptr_lang = SB_CMS_LANG;
		$sptr_count = 1;
		$sptr_pagelist_id = 0;
		$sptr_perpage = 10;

		$sptr_no_results = PL_POLLS_DESIGN_NO_RESULTS_MSG;
		$sptr_fields_temps['sp_change_date'] = PL_POLLS_DESIGN_CHANGE_DATE_VARIANT;

		$_GET['id'] = '';
	}

		echo '<script>
	        function checkValues()
            {
                var el_title = sbGetE("sptr_title");
                if (el_title.value == "")
                {
          	         alert("'.PL_POLLS_DESIGN_NO_TITLE_MSG.'");
          	         return false;
                }
            }';

	if ($htmlStr != '')
	{
	    echo '
            function cancel()
            {
                var res = new Object();
		        res.html = "'.$htmlStr.'";
		        res.footer = "'.$footerStr.'";
				res.footer_link = "";
				sbReturnValue(res);
            }
			sbAddEvent(window, "close", cancel);';

	}
	echo '</script>';

	require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

	$layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE.'?event=pl_polls_design_result_submit'.($_SERVER['QUERY_STRING'] != '' ? '&'.$_SERVER['QUERY_STRING'] : ''), 'thisDialog', 'post', 'checkValues()');

	$layout->mTableWidth = '95%';
	$layout->mTitleWidth = '200';

	$layout->addTab(PL_POLLS_DESIGN_EDIT_TAB1);
	$layout->addHeader(PL_POLLS_DESIGN_EDIT_TAB1);

	$layout->addField(PL_POLLS_DESIGN_EDIT_TITLE, new sbLayoutInput('text', $sptr_title, 'sptr_title', '', 'style="width:97%;"', true));
	$layout->addField('', new sbLayoutDelim());

	$fld = new sbLayoutSelect($GLOBALS['sb_site_langs'], 'sptr_lang');
	$fld->mSelOptions = array($sptr_lang);
	$fld->mHTML = '<div class="hint_div" style="margin-top: 5px;">'.PL_POLLS_DESIGN_EDIT_LANG_LABEL.'</div>';
	$layout->addField(PL_POLLS_DESIGN_EDIT_LANG, $fld);

	$layout->addPluginFieldsTempsCheckboxes('pl_polls', $sptr_checked, 'sptr_checked');

	fPager_Design_Get($layout, $sptr_pagelist_id, 'sptr_pagelist_id', $sptr_perpage, 'sptr_perpage');

	$layout->addField('', new sbLayoutDelim());
	$layout->addField(PL_POLLS_DESIGN_ERR_NO_RESULTS, new sbLayoutTextarea($sptr_no_results, 'sptr_no_results', '', 'style="width:100%; height:50px;"'));

	$res_tags = array();
	$res_tags_values = array();
	$layout->getPluginFieldsTags('pl_polls', $res_tags, $res_tags_values);

	$layout->addTab(PL_POLLS_DESIGN_EDIT_RESULT_TAB2);
	$layout->addHeader(PL_POLLS_DESIGN_EDIT_RESULT_TAB2);

	$tags = array('{ID}', '{ELEM_URL}', '{CAT_ID}', '{CAT_URL}', '{CAT_TITLE}') ;
	$tags_values = array(PL_POLLS_DESIGN_EDIT_ID_TAG, PL_POLLS_DESIGN_EDIT_ELEM_URL_TAG, PL_POLLS_DESIGN_EDIT_CAT_ID_TAG,
			PL_POLLS_DESIGN_EDIT_CATEG_URL_TAG, PL_POLLS_DESIGN_EDIT_CAT_TITLE_TAG);

	// Начало вывода групп
	$fld = new sbLayoutTextarea(isset($sptr_fields_temps['sp_group_start']) ? $sptr_fields_temps['sp_group_start'] : '', 'sptr_fields_temps[sp_group_start]', '', 'style="width:100%;height:50px;"');
	$fld->mTags = array_merge(array(PL_POLLS_DESIGN_NAME_TAG_VAl), $tags);
	$fld->mValues = array_merge(array(PL_POLLS_DESIGN_NAME_TAG), $tags_values);
	$layout->addField(PL_POLLS_DESIGN_GROUP_START_FIELD, $fld);

	// Конец вывода групп
	$fld = new sbLayoutTextarea(isset($sptr_fields_temps['sp_group_end']) ? $sptr_fields_temps['sp_group_end'] : '', 'sptr_fields_temps[sp_group_end]', '', 'style="width:100%;height:50px;"');
	$fld->mTags = array_merge(array(PL_POLLS_DESIGN_NAME_TAG_VAl), $tags);
	$fld->mValues = array_merge(array(PL_POLLS_DESIGN_NAME_TAG), $tags_values);
	$layout->addField(PL_POLLS_DESIGN_GROUP_END_FIELD, $fld);

	// Дата последнего изменения
	$fld = new sbLayoutTextarea($sptr_fields_temps['sp_change_date'], 'sptr_fields_temps[sp_change_date]', '', 'style="width:100%;height:50px;"');
	$fld->mTags = array('{DAY}', '{WEEKDAY}', '{WEEKDAY_SHORT}', '{MONTH}', '{MONTH_TEXTUAL}', '{LONG_YEAR}', '{SHORT_YEAR}', '{HOUR}', '{MINUTE}');
	$fld->mValues = array(KERNEL_DAY_TAG, KERNEL_WEEKDAY_TAG_FULL, KERNEL_WEEKDAY_TAG_SHORT, KERNEL_MONTH_TAG, KERNEL_MONTH_NAME_TAG, KERNEL_YEAR_4_TAG, KERNEL_YEAR_2_TAG, KERNEL_HOURS_TAG, KERNEL_MINUTES_TAG);
	$layout->addField(PL_POLLS_DESIGN_CHANGE_DATE_FIELD, $fld);

	if(count($res_tags) > 0)
	{
		$layout->addPluginFieldsTemps('pl_polls', $sptr_fields_temps, 'sptr_');
	}

	$cat_tags = array();
	$cat_tags_values = array();

	$layout->getPluginFieldsTags('pl_polls', $cat_tags, $cat_tags_values, true);

	if (count($cat_tags) > 0)
	{
		$layout->addTab(PL_POLLS_DESIGN_EDIT_TAB3);
		$layout->addHeader(PL_POLLS_DESIGN_EDIT_TAB3);

		$layout->addPluginFieldsTemps('pl_polls', $sptr_categs_temps, 'sptr_', array(), array(), true);
	}

	$layout->addTab(PL_POLLS_DESIGN_EDIT_RESULT_TAB4);
	$layout->addHeader(PL_POLLS_DESIGN_EDIT_RESULT_TAB4);

	$layout->addField(PL_POLLS_DESIGN_EDIT_RESULTS_COUNT, new sbLayoutInput('text', $sptr_count, 'sptr_count', 'spin_sptr_count', 'style="width:100px;"'));

	$fld = new sbLayoutTextarea($sptr_top, 'sptr_top', '', 'style="width:100%; height:100px;"');
	$fld->mTags = array('{NUM_LIST}', '{ALL_VOTES_COUNT}');
	$fld->mValues = array(PL_POLLS_DESIGN_EDIT_PAGELIST_TAG, PL_POLLS_DESIGN_EDIT_ALL_COUNT_VOTES);
	$layout->addField(PL_POLLS_DESIGN_EDIT_TOP, $fld);

	$layout->addField('', new sbLayoutDelim());

	$fld = new sbLayoutTextarea($sptr_categs_top, 'sptr_categs_top', '', 'style="width:100%;height:100px;"');
	$fld->mTags = array_merge(array('-', '{CAT_TITLE}', '{CAT_COUNT_VOTES}', '{CAT_LEVEL}', '{CAT_ID}', '{CAT_URL}'), $cat_tags);
	$fld->mValues = array_merge(array(PL_POLLS_DESIGN_EDIT_CATEG_GROUP_TAG, PL_POLLS_DESIGN_EDIT_CAT_TITLE_TAG,
			PL_POLLS_DESIGN_EDIT_ALL_COUNT_VOTES_CAT, PL_POLLS_DESIGN_EDIT_CATEG_LEVEL_TAG,
			PL_POLLS_DESIGN_EDIT_CAT_ID_TAG, PL_POLLS_DESIGN_EDIT_CATEG_URL_TAG), $cat_tags_values);
	$layout->addField(PL_POLLS_DESIGN_EDIT_CAT_TOP, $fld);

	$fld = new sbLayoutTextarea($sptr_result_top, 'sptr_result_top', '', 'style="width:100%;height:100px;"');
	$fld->mTags = array_merge(array('-', '{ELEM_NUMBER}',  '{ID}',  '{QUESTION}', '{COUNT_VOTES}', '{CHANGE_DATE}'), $res_tags);
	$fld->mValues = array_merge(array(PL_POLLS_DESIGN_EDIT_RESULT, PL_POLLS_EDIT_ELEM_NUMBER, PL_POLLS_EDIT_ID_QUESTION, PL_POLLS_EDIT_QUESTION, PL_POLLS_DESIGN_EDIT_COUNT_VOTES, PL_POLLS_DESIGN_EDIT_CHANGE_DATE_VOTES), $res_tags_values);
	$layout->addField(PL_POLLS_DESIGN_EDIT_RESULT_TOP, $fld);

	$fld = new sbLayoutTextarea($sptr_element, 'sptr_element', '', 'style="width:100%;height:200px;"');
	$fld->mTags = array_merge(array('-', '{ID_QUESTION}', '{ID}', '{TEXT_VARIANT}', '{COUNT_VOTES}', '{ALL_COUNT}'), $res_tags,
								array('-', '{CAT_TITLE}', '{CAT_COUNT_VOTES}', '{CAT_LEVEL}', '{CAT_ID}', '{CAT_URL}'), $cat_tags);

	$fld->mValues = array_merge(array(PL_POLLS_EDIT_TAB1, PL_POLLS_EDIT_ID_QUESTION, PL_POLLS_DESIGN_EDIT_VARIANT_ID_TAG, PL_POLLS_DESIGN_TEXT_VARIANT, PL_POLLS_DESIGN_COUNT_VOTES_TAG, PL_POLLS_DESIGN_EDIT_ALL_COUNT_VOTES), $res_tags_values,
				array(PL_POLLS_DESIGN_EDIT_CATEG_GROUP_TAG, PL_POLLS_DESIGN_EDIT_CAT_TITLE_TAG, PL_POLLS_DESIGN_EDIT_ALL_COUNT_VOTES_CAT, PL_POLLS_DESIGN_EDIT_CATEG_LEVEL_TAG, PL_POLLS_DESIGN_EDIT_CAT_ID_TAG, PL_POLLS_DESIGN_EDIT_CATEG_URL_TAG), $cat_tags_values);

	$layout->addField(PL_POLLS_DESIGN_EDIT_RESULT, $fld);

	$fld = new sbLayoutTextarea($sptr_result_bottom, 'sptr_result_bottom', '', 'style="width:100%;height:100px;"');
	$fld->mTags = array_merge(array('-', '{ELEM_NUMBER}', '{ID}', '{QUESTION}', '{COUNT_VOTES}', '{CHANGE_DATE}'), $res_tags);
	$fld->mValues = array_merge(array(PL_POLLS_DESIGN_EDIT_RESULT, PL_POLLS_EDIT_ELEM_NUMBER, PL_POLLS_EDIT_ID_QUESTION, PL_POLLS_EDIT_QUESTION, PL_POLLS_DESIGN_EDIT_COUNT_VOTES, PL_POLLS_DESIGN_EDIT_CHANGE_DATE_VOTES), $res_tags_values);
	$layout->addField(PL_POLLS_DESIGN_EDIT_RESULT_BOTTOM, $fld);

	$fld = new sbLayoutTextarea($sptr_empty, 'sptr_empty', '', 'style="width:100%;height:100px;"');
	$layout->addField(PL_POLLS_DESIGN_EDIT_EMPTY, $fld);

	$fld = new sbLayoutTextarea($sptr_delim, 'sptr_delim', '', 'style="width:100%;height:100px;"');
	$layout->addField(PL_POLLS_DESIGN_EDIT_DELIM, $fld);

	$fld = new sbLayoutTextarea($sptr_categs_bottom, 'sptr_categs_bottom', '', 'style="width:100%;height:100px;"');
	$fld->mTags = array_merge(array('-', '{CAT_TITLE}', '{CAT_COUNT_VOTES}', '{CAT_LEVEL}', '{CAT_ID}', '{CAT_URL}'), $cat_tags);
	$fld->mValues = array_merge(array(PL_POLLS_DESIGN_EDIT_CATEG_GROUP_TAG, PL_POLLS_DESIGN_EDIT_CAT_TITLE_TAG,
			PL_POLLS_DESIGN_EDIT_ALL_COUNT_VOTES_CAT, PL_POLLS_DESIGN_EDIT_CATEG_LEVEL_TAG,
			PL_POLLS_DESIGN_EDIT_CAT_ID_TAG, PL_POLLS_DESIGN_EDIT_CATEG_URL_TAG), $cat_tags_values);
	$layout->addField(PL_POLLS_DESIGN_EDIT_CAT_BOTTOM, $fld);

	$layout->addField('', new sbLayoutDelim());

	$fld = new sbLayoutTextarea($sptr_bottom, 'sptr_bottom', '', 'style="width:100%; height:100px;"');
	$fld->mTags = array('{NUM_LIST}', '{ALL_VOTES_COUNT}');
	$fld->mValues = array(PL_POLLS_DESIGN_EDIT_PAGELIST_TAG, PL_POLLS_DESIGN_EDIT_ALL_COUNT_VOTES);
	$layout->addField(PL_POLLS_DESIGN_EDIT_BOTTOM, $fld);

	$layout->addButton('submit', KERNEL_SAVE, 'btn_save', '', ($_SESSION['sbPlugins']->isRightAvailable('pl_polls', 'design_edit') ? '' : 'disabled="disabled"'));
	if ($_GET['id'] != '')
		$layout->addButton('submit', KERNEL_APPLY, 'btn_apply', '', ($_SESSION['sbPlugins']->isRightAvailable('pl_polls', 'design_edit') ? '' : 'disabled="disabled"'));
	$layout->addButton('button', KERNEL_CANCEL, '', '', $htmlStr != '' ? 'onclick="cancel()"' : 'onclick="sbCloseDialog()"');

	$layout->show();
}

function fPolls_Design_Result_Submit()
{
	// проверка прав доступа
	if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'], 'pl_polls_design_result'))
		return;

	if (!isset($_GET['id']))
		$_GET['id'] = '';

	$sptr_top = $sptr_bottom = $sptr_categs_bottom = $sptr_categs_top = $sptr_result_top = $sptr_result_bottom = $sptr_no_results = '';

	$sptr_pagelist_id = 0;
	$sptr_checked = array();

    $sptr_lang = SB_CMS_LANG;
	$sptr_categs_temps = $sptr_fields_temps = array();

	extract($_POST);

	if ($sptr_title == '')
	{
		sb_show_message(PL_POLLS_DESIGN_NO_TITLE_MSG, false, 'warning');
		fPolls_Design_Result_Edit();
		return;
    }

	$row = array();
	$row['sptr_title'] = $sptr_title;
	$row['sptr_lang'] = $sptr_lang;
	$row['sptr_perpage'] = $sptr_perpage;
	$row['sptr_pagelist_id'] = $sptr_pagelist_id;
	$row['sptr_count'] = $sptr_count;
	$row['sptr_checked'] = implode(' ', $sptr_checked);
	$row['sptr_top'] = $sptr_top;
	$row['sptr_categs_top'] = $sptr_categs_top;
	$row['sptr_result_top'] = $sptr_result_top;
	$row['sptr_element'] = $sptr_element;
    $row['sptr_result_bottom'] = $sptr_result_bottom;
    $row['sptr_categs_bottom'] = $sptr_categs_bottom;
    $row['sptr_bottom'] = $sptr_bottom;
    $row['sptr_empty'] = $sptr_empty;
    $row['sptr_delim'] = $sptr_delim;
	$row['sptr_fields_temps'] = serialize($sptr_fields_temps);
	$row['sptr_categs_temps'] = serialize($sptr_categs_temps);
	$row['sptr_no_results'] = $sptr_no_results;

	if ($_GET['id'] != '')
	{
		$res = sql_param_query('SELECT sptr_title FROM sb_polls_temps_results WHERE sptr_id=?d', $_GET['id']);
		if ($res)
	    {
	        // редактирование
	        list($old_title) = $res[0];

    	    sql_param_query('UPDATE sb_polls_temps_results SET ?a WHERE sptr_id=?d', $row, $_GET['id'], sprintf(PL_POLLS_DESIGN_EDIT_RESULT_OK, $old_title));
            sbQueryCache::updateTemplate('sb_polls_temps_results', $_GET['id']);

			$footer_ar = fCategs_Edit_Elem('design_edit');
			if (!$footer_ar)
			{
				sb_show_message(PL_POLLS_DESIGN_EDIT_ERROR, false, 'warning');
				sb_add_system_message(sprintf(PL_POLLS_DESIGN_EDIT_SYSTEMLOG_ERROR, $old_title), SB_MSG_WARNING);

				fPolls_Design_Result_Edit();
				return;
			}

			$footer_str = $GLOBALS['sbSql']->escape($footer_ar[0], false, false);

    	    $row['sptr_id'] = intval($_GET['id']);

            $html_str = fPolls_Design_Result_Get($row);
    	    $html_str = sb_str_replace(array("\r\n", "\r", "\n"), '', $html_str);
            $html_str = $GLOBALS['sbSql']->escape($html_str, false, false);

    	    if (!isset($_POST['btn_apply']))
    	    {
        	    echo '<script>
        		        var res = new Object();
        		        res.html = "'.$html_str.'";
        		        res.footer = "'.$footer_str.'";
        		        res.footer_link = "";
        				sbReturnValue(res);
        			  </script>';
    	    }
    	    else
    	    {
    	        fPolls_Design_Result_Edit($html_str, $footer_str);
    	    }
	    }
	    else
	    {
	        sb_show_message(PL_POLLS_DESIGN_EDIT_ERROR, false, 'warning');
            sb_add_system_message(sprintf(PL_POLLS_DESIGN_EDIT_RESULT_SYSTEMLOG_ERROR, $sptr_title), SB_MSG_WARNING);

            fPolls_Design_Result_Edit();
		    return;
	    }
	}
	else
	{
	    $error = true;
	    if (sql_param_query('INSERT INTO sb_polls_temps_results SET ?a', $row))
	    {
			$id = sql_insert_id();

			if (fCategs_Add_Elem($id, 'design_edit'))
			{
                sbQueryCache::updateTemplate('sb_polls_temps_results', $id);
				sb_add_system_message(sprintf(PL_POLLS_DESIGN_ADD_RESULT_OK, $sptr_title));
				echo '<script>
						sbReturnValue('.$id.');
					</script>';

				$error = false;
			}
			else
			{
				sql_query('DELETE FROM sb_polls_temps_results WHERE sptr_id="'.$id.'"');
    		}
	    }

		if ($error)
		{
			sb_show_message(sprintf(PL_POLLS_DESIGN_ADD_RESULT_ERROR, $sptr_title), false, 'warning');
			sb_add_system_message(sprintf(PL_POLLS_DESIGN_ADD_RESULT_SYSTEMLOG_ERROR, $sptr_title), SB_MSG_WARNING);

			fPolls_Design_Result_Edit();
			return;
		}
	}
}

function fPolls_Design_Result_Delete()
{
	$id = intval($_GET['id']);
	$pages = sql_query('SELECT pages.p_id FROM sb_pages pages, sb_elems elems
						WHERE elems.e_link="page" AND elems.e_temp_id="'.$id.'" AND elems.e_ident="pl_polls_results" AND pages.p_id=elems.e_p_id LIMIT 1');

	$temps = false;
	if (!$pages)
	{
		$temps = sql_query('SELECT temps.t_id FROM sb_templates temps, sb_elems elems
						WHERE elems.e_link="temp" AND elems.e_temp_id="'.$id.'" AND elems.e_ident="pl_polls_results" AND temps.t_id=elems.e_p_id LIMIT 1');
    }

	if ($pages || $temps)
    {
		echo PL_POLLS_DESIGN_DELETE_ERROR;
    }
}



/**
 * Функции управления макетами дизайна вывода разделов
 */
function fPolls_Design_Categs_Get($args)
{
    return fCategs_Design_Get($args, 'pl_polls_categs', 'pl_polls');
}

function fPolls_Design_Categs()
{
    require_once(SB_CMS_LIB_PATH.'/sbElements.inc.php');

    $elems = new sbElements('sb_categs_temps_list', 'ctl_id', 'ctl_title', 'fPolls_Design_Categs_Get', 'pl_polls_design_categs', 'pl_polls_design_categs');
    $elems->mCategsDeleteWithElementsMenu = true;

    $elems->mCategsRootName = KERNEL_DESIGN_ROOT_NAME;
    $elems->mElemsIcon = SB_CMS_IMG_URL.'/plugins/pl_polls_categs_32.png';

    $elems->addSorting(PL_POLLS_DESIGN_EDIT_SORT_BY_TITLE, 'ctl_title');
    $elems->mCategsPasteElemsMenuTitle = KERNEL_DESIGN_PASTE_ELEMS_MENU_TITLE;

    $elems->mElemsAddMenuTitle  = KERNEL_DESIGN_ELEMS_ADD_MENU_TITLE;
    $elems->mElemsEditMenuTitle = KERNEL_DESIGN_ELEMS_EDIT_MENU_TITLE;
    $elems->mElemsCopyMenuTitle = KERNEL_DESIGN_ELEMS_COPY_MENU_TITLE;
    $elems->mElemsCutMenuTitle  = KERNEL_DESIGN_ELEMS_CUT_MENU_TITLE;

    $elems->mElemsEditEvent =  'pl_polls_design_categs_edit';
    $elems->mElemsEditDlgWidth = 900;
    $elems->mElemsEditDlgHeight = 700;

    $elems->mElemsAddEvent =  'pl_polls_design_categs_edit';
    $elems->mElemsAddDlgWidth = 900;
    $elems->mElemsAddDlgHeight = 700;

    $elems->mElemsDeleteEvent = 'pl_polls_design_categs_delete';

    $elems->mCategsClosed = false;
    $elems->mCategsRubrikator = false;

    $elems->mElemsJavascriptStr .= '
          function linkPages(e)
          {
              if (!sbSelEl)
              {
                  var el = sbEventTarget(e);

                  while (el.parentNode && !el.getAttribute("true_id"))
                      el = el.parentNode;

                  var el_id = el.getAttribute("el_id");
              }
              else
                  var el_id = sbSelEl.getAttribute("el_id");

              strPage = "'.SB_CMS_DIALOG_FILE.'?event=pl_pages_get_links&id=" + el_id + "&ident[]=pl_polls_categs";
              strAttr = "resizable=1,width=800,height=600";
              sbShowModalDialog(strPage, strAttr, null, window);
          }
          function linkTemps(e)
          {
              if (!sbSelEl)
              {
                  var el = sbEventTarget(e);

                  while (el.parentNode && !el.getAttribute("true_id"))
                      el = el.parentNode;

                  var el_id = el.getAttribute("el_id");
              }
              else
                  var el_id = sbSelEl.getAttribute("el_id");

              strPage = "'.SB_CMS_DIALOG_FILE.'?event=pl_templates_get_links&id=" + el_id + "&ident[]=pl_polls_categs";
              strAttr = "resizable=1,width=800,height=600";
              sbShowModalDialog(strPage, strAttr, null, window);
          }

          function menuList()
          {
              window.location = "'.SB_CMS_CONTENT_FILE.'?event=pl_polls_init";
          }';

    $elems->addElemsMenuItem(KERNEL_LINK_PAGES_MENU_ITEM, 'linkPages();');
    $elems->addElemsMenuItem(KERNEL_LINK_TEMPS_MENU_ITEM, 'linkTemps();');
    $elems->addElemsMenuItem(PL_POLLS_POLLS_LIST_MENU, 'menuList();', false);

    $elems->init();
}

function fPolls_Design_Categs_Edit()
{
    fCategs_Design_Edit('pl_polls_design_categs', 'pl_polls', 'pl_polls_design_categs_edit_submit');
}

function fPolls_Design_Categs_Edit_Submit()
{
    fCategs_Design_Edit_Submit('pl_polls_design_categs', 'pl_polls', 'pl_polls_design_categs_edit_submit', 'pl_polls_categs', 'pl_polls');
}

function fPolls_Design_Categs_Delete ()
{
    fCategs_Design_Delete('pl_polls_categs', 'pl_polls');
}



/**
 * Функции управления макетами дизайна вывода выбранного раздела
 */
function fPolls_Design_Selcat_Get($args)
{
    return fCategs_Design_Get($args, 'pl_polls_selcat', 'pl_polls', true);
}

function fPolls_Design_Selcat()
{
    require_once(SB_CMS_LIB_PATH.'/sbElements.inc.php');

    $elems = new sbElements('sb_categs_temps_full', 'ctf_id', 'ctf_title', 'fPolls_Design_Selcat_Get', 'pl_polls_design_selcat', 'pl_polls_design_selcat');
    $elems->mCategsDeleteWithElementsMenu = true;

    $elems->mCategsRootName = KERNEL_DESIGN_ROOT_NAME;
    $elems->mElemsIcon = SB_CMS_IMG_URL.'/plugins/pl_polls_sel_cat_32.png';

    $elems->addSorting(PL_POLLS_DESIGN_EDIT_SORT_BY_TITLE, 'ctf_title');
    $elems->mCategsPasteElemsMenuTitle = KERNEL_DESIGN_PASTE_ELEMS_MENU_TITLE;

    $elems->mElemsAddMenuTitle  = KERNEL_DESIGN_ELEMS_ADD_MENU_TITLE;
    $elems->mElemsEditMenuTitle = KERNEL_DESIGN_ELEMS_EDIT_MENU_TITLE;
    $elems->mElemsCopyMenuTitle = KERNEL_DESIGN_ELEMS_COPY_MENU_TITLE;
    $elems->mElemsCutMenuTitle  = KERNEL_DESIGN_ELEMS_CUT_MENU_TITLE;

    $elems->mElemsEditEvent =  'pl_polls_design_selcat_edit';
    $elems->mElemsEditDlgWidth = 900;
    $elems->mElemsEditDlgHeight = 700;

    $elems->mElemsAddEvent =  'pl_polls_design_selcat_edit';
    $elems->mElemsAddDlgWidth = 900;
    $elems->mElemsAddDlgHeight = 700;

    $elems->mElemsDeleteEvent = 'pl_polls_design_selcat_delete';

    $elems->mCategsClosed = false;
    $elems->mCategsRubrikator = false;
    $elems->mElemsUseLinks = false;

    $elems->mElemsJavascriptStr .= '
          function linkPages(e)
          {
              if (!sbSelEl)
              {
                  var el = sbEventTarget(e);

                  while (el.parentNode && !el.getAttribute("true_id"))
                      el = el.parentNode;

                  var el_id = el.getAttribute("el_id");
              }
              else
                  var el_id = sbSelEl.getAttribute("el_id");

              strPage = "'.SB_CMS_DIALOG_FILE.'?event=pl_pages_get_links&id=" + el_id + "&ident[]=pl_polls_selcat";
              strAttr = "resizable=1,width=800,height=600";
              sbShowModalDialog(strPage, strAttr, null, window);
          }
          function linkTemps(e)
          {
              if (!sbSelEl)
              {
                  var el = sbEventTarget(e);

                  while (el.parentNode && !el.getAttribute("true_id"))
                      el = el.parentNode;

                  var el_id = el.getAttribute("el_id");
              }
              else
                  var el_id = sbSelEl.getAttribute("el_id");

              strPage = "'.SB_CMS_DIALOG_FILE.'?event=pl_templates_get_links&id=" + el_id + "&ident[]=pl_polls_selcat";
              strAttr = "resizable=1,width=800,height=600";
              sbShowModalDialog(strPage, strAttr, null, window);
          }

          function menuList()
          {
              window.location = "'.SB_CMS_CONTENT_FILE.'?event=pl_polls_init";
          }';

    $elems->addElemsMenuItem(KERNEL_LINK_PAGES_MENU_ITEM, 'linkPages();');
    $elems->addElemsMenuItem(KERNEL_LINK_TEMPS_MENU_ITEM, 'linkTemps();');
    $elems->addElemsMenuItem(PL_POLLS_POLLS_LIST_MENU, 'menuList();', false);

    $elems->init();
}

function fPolls_Design_Selcat_Edit($htmlStr = '', $footerStr = '')
{
    fCategs_Design_Sel_Cat_Edit('pl_polls_design_selcat', 'pl_polls', 'pl_polls_design_selcat_submit');
}

function fPolls_Design_Selcat_Edit_Submit()
{
    fCategs_Design_Sel_Cat_Edit_Submit('pl_polls_design_selcat', 'pl_polls', 'pl_polls_design_selcat_submit', 'pl_polls_selcat', 'pl_polls');
}

function fPolls_Design_Selcat_Delete()
{
    fCategs_Design_Delete('pl_polls_selcat', 'pl_polls');
}

?>