<?php

function fRedirect_Get($args)
{
	static $domain = '';
	static $page_domain = '';

	if (!$domain)
	{
	    $res = sql_param_query('SELECT categs.cat_left, categs.cat_right FROM sb_categs categs, sb_catlinks links WHERE links.link_el_id=?d AND links.link_cat_id=categs.cat_id AND categs.cat_ident="pl_redirect"', $args['sr_id']);
	    list($left, $right) = $res[0];
	    $res = sql_query('SELECT cat_title FROM sb_categs WHERE cat_left <= '.$left.' AND cat_right >= '.$right.' AND cat_level=1 AND cat_ident="pl_redirect"');
	    list($domain) = $res[0];

	    $page_domain = $domain;

	    if ($domain == SB_COOKIE_DOMAIN && SB_PORT != '80')
            $page_domain .= ':'.SB_PORT;

	    if ('http://'.$page_domain != SB_DOMAIN && substr_count($domain, '.') > 0)
            $page_domain = 'www.'.$page_domain;

        $page_domain = 'http://'.$page_domain;
	}

	$result = '<b><a href="javascript:void(0);" onclick="sbElemsEdit(event);">'.$page_domain.$args['sr_old_url'].'</a></b>
	<div class="smalltext" style="margin-top:7px;">';

	$result .= PL_REDIRECT_INIT_FILTER_NEW_URL.': <a target="_blank" href="'.$page_domain.$args['sr_new_url'].'">'.$page_domain.$args['sr_new_url'].'</a><br />'.
	PL_REDIRECT_INIT_FILTER_OLD_URL.': <a target="_blank" href="'.$page_domain.$args['sr_old_url'].'">'.$page_domain.$args['sr_old_url'].'</a><br />'.
    PL_REDIRECT_INIT_FILTER_TYPE_REDIRECT.': <span style="color: #33805E;">'.$args['sr_redirect_type'].'</span><br />';

	if($args['sr_active'] == 0)
		$args['sr_active'] = '<span style="color: red;">'.KERNEL_NO.'</span>';
	else
		$args['sr_active'] = '<span style="color: green;">'.KERNEL_YES.'</span>';

	$result .= PL_REDIRECT_GET_ACTIVE.': '.$args['sr_active'].'<br />'.
			   PL_REDIRECT_GET_COUNT.': <span style="color: green;">'.$args['sr_count'].'</span></div>';

	return $result;
}

function fRedirect_Create_Cats()
{
	require_once(SB_CMS_LIB_PATH.'/sbTree.inc.php');
    $tree = new sbTree('pl_redirect');

    $res = sql_query('SELECT cat_id FROM sb_categs WHERE cat_ident="pl_redirect" AND cat_level="0"');
    if (!$res)
    {
        // создаем корневой раздел
        $fields = array();
        $fields['cat_title'] = PL_REDIRECT_ROOT_NAME;
        $fields['cat_closed'] = 0;
        $fields['cat_rubrik'] = 0;
        $fields['cat_rights'] = $_SESSION['sbAuth']->isAdmin() ? '' : 'u'.$_SESSION['sbAuth']->getUserId();

        $root_id = $tree->insertNode(0, $fields);

        if (!$root_id)
            return false;
    }
    else
    {
        $root_id = $res[0][0];
    }

    $result = array($root_id);

    // проверяем, есть ли разделы для доменов
    foreach ($GLOBALS['sb_domains'] as $domain => $value)
    {
        $res = sql_param_query('SELECT cat_id FROM sb_categs WHERE cat_ident="pl_redirect" AND cat_level="1" AND cat_title=?', $domain);

        if (!$res)
        {
            $fields['cat_closed'] = 0;
            $fields['cat_rubrik'] = 0;
            $fields['cat_title'] = $domain;
            $fields['cat_rights'] = $_SESSION['sbAuth']->isAdmin() ? '' : 'u'.$_SESSION['sbAuth']->getUserId();

            if (!$cat_id = $tree->insertNode($root_id, $fields))
                return false;
        }
    }

    return $result;
}

function fRedirect_Init()
{
	$never_show_cats = fRedirect_Create_Cats();
    if (!$never_show_cats)
    {
        sb_show_message(PL_REDIRECT_CREATE_CATEGS_ERROR, true, 'warning');
        return;
    }

	require_once(SB_CMS_LIB_PATH.'/sbElements.inc.php');

	$elems = new sbElements('sb_redirect', 'sr_id', 'sr_old_url', 'fRedirect_Get', 'pl_redirect_init', 'pl_redirect');

	$elems->mCategsTitleHandler = 'fRedirect_Get_Domain_Name';
	$elems->mCategsRootName = PL_REDIRECT_ROOT_NAME;
	$elems->mCategsNeverShowCats = $never_show_cats;

	$elems->addField('sr_active');    		// активна переадресация или нет
	$elems->addField('sr_new_url');   		// новый url
	$elems->addField('sr_old_url');   		// старый url
	$elems->addField('sr_redirect_type');   // тип редиректа
	$elems->addField('sr_count');   		// кол-во переходов

	$elems->addFilter(PL_REDIRECT_INIT_FILTER_NEW_URL, 'sr_new_url', 'string');
	$elems->addFilter(PL_REDIRECT_INIT_FILTER_OLD_URL, 'sr_old_url', 'string');
	$elems->addFilter(PL_REDIRECT_INIT_FILTER_ACTIVE, 'sr_active', 'checkbox');

	$options = array();
	$options['301'] = PL_REDIRECT_EDIT_TYPE_301_REDIRECT;
	$options['302'] = PL_REDIRECT_EDIT_TYPE_302_REDIRECT;

	$elems->addFilter(PL_REDIRECT_INIT_FILTER_TYPE_REDIRECT, 'sr_redirect_type', 'select', $options);

	$elems->addSorting(PL_REDIRECT_INIT_SORT_BY_NEW_URL, 'sr_new_url');
    $elems->addSorting(PL_REDIRECT_INIT_SORT_BY_OLD_URL, 'sr_old_url');
	$elems->addSorting(PL_REDIRECT_INIT_SORT_BY_ACTIVE, 'sr_active');
	$elems->addSorting(PL_REDIRECT_INIT_SORT_BY_TYPE_REDIRECT, 'sr_redirect_type');

    $elems->mCategsPasteElemsMenuTitle = PL_REDIRECT_INIT_PASTE_ELEMS_MENU_TITLE;
    $elems->mCategsPasteLinksMenuTitle = PL_REDIRECT_INIT_PASTE_LINKS_MENU_TITLE;

    $elems->mElemsAddMenuTitle  = PL_REDIRECT_INIT_ELEMS_ADD_MENU_TITLE;
    $elems->mElemsEditMenuTitle = PL_REDIRECT_INIT_ELEMS_EDIT_MENU_TITLE;
    $elems->mElemsCopyMenuTitle = PL_REDIRECT_INIT_ELEMS_COPY_MENU_TITLE;
    $elems->mElemsCutMenuTitle  = PL_REDIRECT_INIT_ELEMS_CUT_MENU_TITLE;

	$elems->mElemsEditEvent =  'pl_redirect_edit';
	$elems->mElemsEditDlgWidth = 700;
	$elems->mElemsEditDlgHeight = 380;

	$elems->mElemsAddEvent =  'pl_redirect_edit';
    $elems->mElemsAddDlgWidth = 700;
	$elems->mElemsAddDlgHeight = 380;

	if ($_SESSION['sbPlugins']->isRightAvailable('pl_redirect', 'elems_edit'))
	{
		$elems->mElemsJavascriptStr = '
			function redirectSetActive()
            {
				var ids = "0";
				for (var i = 0; i < sbSelectedEls.length; i++)
                {
                    var el = sbGetE("el_" + sbSelectedEls[i]);
                    if (el)
                        ids += "," + el.getAttribute("el_id");
                }

            	var res = sbLoadSync("'.SB_CMS_EMPTY_FILE.'?event=pl_redirect_set_active&ids=" + ids);
            	if (res != "TRUE")
                {
                    alert("'.PL_REDIRECT_INIT_SHOWHIDE_ERROR.'");
                    return;
                }

                var div_el = sbGetE("elems_list_div");
                var from = "";
                if (div_el)
                {
                    from = div_el.getAttribute("from");
                }
                var url = sb_cms_empty_file + "?event=" + sb_elems_event + "&id=" + sbCatTree.getSelectedItemId() + "&page_elems=" + from;
                sbElemsShow(url);
            }';
		$elems->addElemsMenuItem (PL_REDIRECT_INIT_EDIT_ACTIVE, 'redirectSetActive();');
	}

	$elems->mCategsClosed = false;
	$elems->mCategsRubrikator = false;

	$elems->mCategsPasteElemsMenuLevel = 2;
	$elems->mCategsDadStartLevel = 2;
	$elems->mCategsMenuLevel = 2;
	$elems->mCategsEditMenuLevel = 3;
	$elems->mCategsDeleteMenuLevel = 3;
	$elems->mCategsCopyMenuLevel = 3;
	$elems->mCategsCutMenuLevel = 3;
	$elems->mCategsPasteCategsMenuLevel = 2;

	$elems->mElemsAddMenuLevel = 2;
	$elems->mElemsUseLinks = true;

	if(isset($_GET['l_id']))
    {
		$res = sql_param_query('SELECT c.cat_id, c.cat_level FROM sb_categs c, sb_404_log l
			 					WHERE c.cat_ident="pl_redirect" AND c.cat_title=l.l_domain AND c.cat_level=1
			 					AND l.l_id=?d', $_GET['l_id']);
		if ($res)
		{
	    	$elems->mCategsSelectedId = $res[0][0];
	    	$elems->mElemsAfterLoadFunc = 'showAddDialog';
			$elems->mElemsJavascriptStr .= '
				var showFirst = true;
				function showAddDialog()
				{
					if (showFirst)
					{
						showFirst = false;

						var strPage = sb_cms_modal_dialog_file + "?event=pl_redirect_edit&plugin_ident=pl_redirect&cat_id='.$res[0][0].'&cat_level='.$res[0][1].'&cat_closed=0&l_id='.$_GET['l_id'].'";
						var strAttr = "resizable=1,width=700,height=380";
						sbShowModalDialog(strPage, strAttr, sbElemsAfterAdd);
					}
				}';
		}
	}

	$elems->init();
}

function fRedirect_Edit($htmlStr = '', $footerStr = '', $footerLinkStr = '')
{
	// проверка прав доступа
	if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'], 'pl_redirect'))
		return;

	$res = sql_param_query('SELECT cat_left, cat_right FROM sb_categs WHERE cat_id=?d', $_GET['cat_id']);
	list($cat_left, $cat_right) = $res[0];
	$res = sql_param_query('SELECT cat_title FROM sb_categs WHERE cat_left <= '.$cat_left.' AND cat_right >= '.$cat_right.'
							AND cat_ident="pl_redirect" AND cat_level = 1 LIMIT 1');
	list($domain) = $res[0];

	if (count($_POST) == 0 && isset($_GET['id']) && $_GET['id'] != '')
	{
		$result = sql_param_query('SELECT sr_old_url, sr_new_url, sr_redirect_type, sr_active, sr_count
									FROM sb_redirect WHERE sr_id=?d', $_GET['id']);
		if ($result)
		{
			list($sr_old_url, $sr_new_url, $sr_redirect_type, $sr_active, $sr_count) = $result[0];
		}
		else
		{
		    sb_show_message(PL_REDIRECT_EDIT_ERROR, true, 'warning');
	        return;
		}
	}
	elseif (count($_POST) > 0)
	{
		extract($_POST);
		if (!isset($_POST['sr_active']))
    	{
    		$sr_active = 0;
    	}

    	if (!isset($_GET['id']))
            $_GET['id'] = '';
	}
	else
	{
		if (isset($_GET['l_id']))
		{
			$res_log = sql_param_query('SELECT l_domain, l_url FROM sb_404_log WHERE l_id=?d', $_GET['l_id']);
			if ($res_log)
			{
				$sr_old_url = 'http://'.$res_log[0][0].'/'.$res_log[0][1];
			}
			else
			{
				$sr_old_url = '';
			}
		}
		else
		{
			$sr_old_url = '';
		}

		$sr_new_url = '';
		$sr_redirect_type = 301;
		$sr_active = 1;
		$sr_count = 0;

		$_GET['id'] = '';
	}

	echo '<script>
			function checkValues()
            {
                var url_new = sbGetE("sr_new_url");
                var url_old = sbGetE("sr_old_url");

                if (url_new.value == "" || url_old.value == "")
                {
                    alert("'.PL_REDIRECT_EDIT_NO_PAGES_URLS.'");
                    return false;
                }
			}

			function selectOldURL()
            {
            	var strPage = sb_cms_modal_dialog_file + "?event=pl_redirect_404_get_list&l_domain='.$domain.'";
                var strAttr = "resizable=1,width="+(screen.availWidth - 100)+",height="+(screen.availHeight - 100);

                sbShowModalDialog(strPage, strAttr, afterSelectOldURL);
            }

            function afterSelectOldURL()
            {
                if (sbModalDialog.returnValue)
                {
                    sbGetE("sr_old_url").value = sbModalDialog.returnValue;
                }
            }';

	if ($htmlStr != '')
	{
		echo '
            function cancel()
            {
                var res = new Object();
		        res.html = "'.$htmlStr.'";
		        res.footer = "'.$footerStr.'";
		        res.footer_link = "'.$footerLinkStr.'";
		        sbReturnValue(res);
            }
            sbAddEvent(window, "close", cancel);';
	}

	echo '</script>';

	require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

	$layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE.'?event=pl_redirect_edit_submit'.($_SERVER['QUERY_STRING'] != '' ? '&'.$_SERVER['QUERY_STRING'] : ''), 'thisDialog', 'post', 'checkValues()', 'main');

	$layout->mTableWidth = '95%';
	$layout->mTitleWidth = '200';

	echo '<br /><br />';
	$layout->addHeader(PL_REDIRECT_H_EDIT_TITLE);

	$layout->addField(PL_REDIRECT_INIT_FILTER_OLD_URL,
		new sbLayoutHTML('<input type="text" name="sr_old_url" value="'.$sr_old_url.'" id="sr_old_url" style="width:89%;" /><sup class="red">&nbsp;*</sup>&nbsp;&nbsp;<img class="button" onmouseup="sbPress(this, false)" onmousedown="sbPress(this, true);selectOldURL();" align="top" src="'.SB_CMS_IMG_URL.'/pages.png" width="20" height="20" />'));

	//$layout->addField (, new sbLayoutPage(, 'sr_old_url', '', 'style="width:89%;"', true));
	$layout->addField (PL_REDIRECT_INIT_FILTER_NEW_URL, new sbLayoutPage($sr_new_url, 'sr_new_url', '', 'style="width:89%;"', true));

	$layout->addField ('', new sbLayoutDelim());

	$options = array();
	$options['301'] = PL_REDIRECT_EDIT_TYPE_301_REDIRECT;
	$options['302'] = PL_REDIRECT_EDIT_TYPE_302_REDIRECT;

	$fld = new sbLayoutSelect($options, 'sr_redirect_type');
	$fld->mSelOptions = array($sr_redirect_type);
	$layout->addField (PL_REDIRECT_INIT_FILTER_TYPE_REDIRECT, $fld);

	$layout->addField (PL_REDIRECT_INIT_FILTER_ACTIVE, new sbLayoutInput('checkbox', '1', 'sr_active', '', ($sr_active == 1 ? 'checked="checked"' : '')));

	$layout->addField ('', new sbLayoutInput('hidden', $sr_count, 'sr_count'));

	$layout->addButton('submit', KERNEL_SAVE, 'btf_save', '', ($_SESSION['sbPlugins']->isRightAvailable('pl_redirect', 'elems_edit') ? '' : 'disabled="disabled"'));
	if ($_GET['id'] != '')
        $layout->addButton('submit', KERNEL_APPLY, 'btf_apply', '', ($_SESSION['sbPlugins']->isRightAvailable('pl_redirect', 'elems_edit') ? '' : 'disabled="disabled"'));
    $layout->addButton('button', KERNEL_CANCEL, '', '', $htmlStr != '' ? 'onclick="cancel()"' : 'onclick="sbCloseDialog()"');

    $layout->show();
}

function fRedirect_Edit_Submit()
{
	// проверка прав доступа
	if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'], 'pl_redirect', 'pl_redirect'))
		return;

	if (!isset($_GET['id']))
		$_GET['id'] = '';

	extract($_POST);

	if(!isset($_POST['sr_active']))
		$sr_active = 0;

	if (stripos($sr_new_url, 'http:') !== false || stripos($sr_new_url, 'https:') !== false)
	{
		$sr_new_url = str_ireplace(array('http://', 'http:\\\\', 'https://', 'https:\\\\'), '', $sr_new_url);
		$pos = strpos($sr_new_url, '/');
		if ($pos === false)
			$pos = strpos($sr_new_url, '\\');

		if ($pos !== false)
		{
			$sr_new_url = substr($sr_new_url, $pos);
		}
	}

	if (stripos($sr_old_url, 'http:') !== false || stripos($sr_old_url, 'https:') != false)
	{
		$sr_old_url = str_ireplace(array('http://', 'http:\\\\', 'https://', 'https:\\\\'), '', $sr_old_url);
		$pos = strpos($sr_old_url, '/');
		if ($pos === false)
			$pos = strpos($sr_old_url, '\\');

		if ($pos !== false)
		{
			$sr_old_url = substr($sr_old_url, $pos);
		}
	}

	$sr_new_url = '/'.trim($sr_new_url, '\\/');
	$sr_old_url = '/'.trim($sr_old_url, '\\/');

	$_POST['sr_new_url'] = $sr_new_url;
	$_POST['sr_old_url'] = $sr_old_url;

	$row = array();
	$row['sr_old_url'] = $sr_old_url;
	$row['sr_new_url'] = $sr_new_url;
	$row['sr_redirect_type'] = $sr_redirect_type;
	$row['sr_active'] = $sr_active;
	$row['sr_count'] = $sr_count;

	if($_GET['id'] != '')
	{
		$res = sql_param_query('SELECT sr_old_url FROM sb_redirect WHERE sr_id=?d', $_GET['id']);
		if ($res)
		{
			// редактирование
			list($old_url) = $res[0];
			sql_param_query('UPDATE sb_redirect SET ?a WHERE sr_id=?d', $row, $_GET['id'], sprintf(PL_REDIRECT_EDIT_SUBMIT_EDIT_OK, $sr_old_url));

			$footer_ar = fCategs_Edit_Elem();
    	    if (!$footer_ar)
    	    {
				sb_show_message(PL_REDIRECT_EDIT_SUBMIT_EDIT_ERROR, false, 'warning');
                sb_add_system_message(sprintf(PL_REDIRECT_EDIT_SUBMIT_EDIT_SYSTEMLOG_ERROR, $old_url), SB_MSG_WARNING);

                fRedirect_Edit();
                return;
    	    }

    	    $footer_str = $GLOBALS['sbSql']->escape($footer_ar[0], false, false);
    	    $footer_link_str = $GLOBALS['sbSql']->escape($footer_ar[1], false, false);

            $row['sr_id'] = intval($_GET['id']);

    	    $html_str = fRedirect_Get($row);
    	    $html_str = sb_str_replace(array("\r\n", "\r", "\n"), '', $html_str);
            $html_str = $GLOBALS['sbSql']->escape($html_str, false, false);

    	    if (!isset($_POST['btf_apply']))
    	    {
					echo '<script>
						var res = new Object();
						res.html = "'.$html_str.'";
						res.footer = "'.$footer_str.'";
						res.footer_link = "'.$footer_link_str.'";
						sbReturnValue(res);
					</script>';
    	    }
    	    else
    	    {
    	    	fRedirect_Edit($html_str, $footer_str, $footer_link_str);
    	    }
	    }
	    else
	    {
	    	sb_show_message(PL_REDIRECT_EDIT_SUBMIT_EDIT_ERROR, false, 'warning');
	    	sb_add_system_message(sprintf(PL_REDIRECT_EDIT_SUBMIT_EDIT_SYSTEMLOG_ERROR, $sr_old_url), SB_MSG_WARNING);

	    	fRedirect_Edit();
			return;
	    }
	}
	else
	{
		$error = true;
	    if (sql_param_query('INSERT INTO sb_redirect SET ?a', $row))
	    {
    		$id = sql_insert_id();

    		if (fCategs_Add_Elem($id))
    		{
        		sb_add_system_message(sprintf(PL_REDIRECT_EDIT_SUBMIT_ADD_OK, $sr_old_url));
				echo '<script>
						sbReturnValue('.$id.');
        			  </script>';
				$error = false;
    		}
    		else
    		{
    			sql_query('DELETE FROM sb_redirect WHERE sr_id="'.$id.'"');
    		}
	    }

	    if ($error)
	    {
	    	sb_show_message(PL_REDIRECT_EDIT_SUBMIT_ADD_ERROR, false, 'warning');
            sb_add_system_message(sprintf(PL_REDIRECT_EDIT_SUBMIT_ADD_SYSTEMLOG_ERROR, $sr_old_url), SB_MSG_WARNING);

			fRedirect_Edit();
		    return;
	    }
	}
}

function fRedirect_Set_Active ()
{
	if(isset($_GET['ids']) && $_GET['ids'] != '')
	{
	    $res = sql_param_query('SELECT sr_id, sr_old_url, sr_active FROM sb_redirect WHERE sr_id IN ('.preg_replace('/[^0-9,]+/'.SB_PREG_MOD, '', $_GET['ids']).')');
	    if ($res)
	    {
	    	$date = time();
	    	foreach($res as $value)
	    	{
		        list($sr_id, $sr_old_url, $sr_active) = $value;
		        $sr_active = ($sr_active == 1 ? 0 : 1);

	            sql_query('UPDATE sb_redirect SET sr_active="'.$sr_active.'" WHERE sr_id="'.$sr_id.'"', sprintf(PL_REDIRECT_EDIT_SUBMIT_EDIT_OK, $sr_old_url));
	            sql_param_query('INSERT INTO sb_catchanges (el_id, cat_ident, change_date, change_user_id, action) VALUES (?d, "pl_redirect", ?d, ?d, "edit")', $sr_id, $date, $_SESSION['sbAuth']->getUserId());
	    	}
			echo 'TRUE';
	    }
	}
}

function fRedirect_404_Read()
{
	echo '<style type="text/css">
    	#event_content table.form tr.even:hover,
		#event_content table.form tr.odd:hover
		{
		    background-color: #E1FFE1;
		}

		#event_content
		{
			overflow-x: auto;
		}
	</style>
    <script>
    document.body.onselectstart = "";
    document.body.setAttribute("unselectable", "off");

    function showFilter()
    {
        var filter = sbGetE("sb_filter");
        var filter_arr = sbGetE("filter_arrow");
        if (!filter) return;
        if (filter.style.display == "none")
        {
            filter.style.display = "";
            filter_arr.src = sb_cms_img_url + "/fil_arrow_up.gif";
        }
        else
        {
            filter.style.display = "none";
            filter_arr.src = sb_cms_img_url + "/fil_arrow_down.gif";
        }
    }
    function setFilter()
    {
        var str = "'.SB_CMS_CONTENT_FILE.'?event=pl_redirect_404_read'.(isset($_GET['order']) ? '&order='.$_GET['order'] : '').'";
        var found = false;
        var frm = sbGetE("filter_form");
        for (var i = 0; i < frm.elements.length; i++)
        {
            var el = frm.elements[i];
            if (el.type == "select-one")
            {
                if (el.value != -1)
                {
                    str += "&"+el.name+"="+el.value;
                    found = true;
                }
            }
            else
            {
                if (el.name != "" && el.value != "")
                {
                    str += "&"+el.name+"="+el.value;
                    found = true;
                }
            }
        }
        if (!found)
        {
            return false;
        }

        window.location = str;
        return false;
    }
    function removeFilter(e)
    {
        window.location = "'.SB_CMS_CONTENT_FILE.'?event=pl_redirect_404_read'.(isset($_GET['order']) ? '&order='.$_GET['order'] : '').'";
        return sbCancelEvent(e);
    }
    function refreshJournal()
    {
    	window.location = "'.SB_CMS_CONTENT_FILE.'?event=pl_redirect_404_read'.(isset($_GET['order']) ? '&order='.$_GET['order'] : '').(isset($_GET['l_date_from']) ? '&l_date_from='.$_GET['l_date_from'] : '').(isset($_GET['l_date_to']) ? '&l_date_to='.$_GET['l_date_to'] : '').(isset($_GET['l_ip']) ? '&l_ip='.$_GET['l_ip'] : '').(isset($_GET['l_domain']) ? '&l_domain='.$_GET['l_domain'] : '').(isset($_GET['l_url']) ? '&l_url='.$_GET['l_url'] : '').'";
    }
    </script>';

	$time = time() - intval(sbPlugins::getSetting('sb_404_log_date')) * 24 * 60 * 60;
    sql_param_query('DELETE FROM sb_404_log WHERE l_date < ?', $time);

    if (!isset($_GET['order']))
    {
        $_GET['order'] = 'l_date|desc';
    }
    else
    {
        $_GET['order'] = preg_replace('/[^a-zA-Z0-9_|]+/', '', $_GET['order']);
        if (empty($_GET['order']))
            $_GET['order'] = 'l_date|desc';
    }

    $order_str = explode('|', $_GET['order']);
    if ($_GET['order'] != 'l_date|desc' && count($order_str) == 2)
    {
        $order_str = 'ORDER BY l.'.$order_str[0].' '.strtoupper($order_str[1]).', l.l_date DESC';
    }
    else
    {
    	$order_str = 'ORDER BY l.l_date DESC';
    }

    $filter_str = '';
    if (isset($_GET['l_date_from']) && !empty($_GET['l_date_from']))
    {
        $_GET['l_date_from'] = preg_replace('/[^0-9\.: ]+/', '', $_GET['l_date_from']);
        $date_time = explode(' ', $_GET['l_date_from']);
        if (count($date_time) > 0)
        {
            $filter_str .= ' AND l.l_date >= '.sb_datetoint($_GET['l_date_from']);
        }
    }

    if (isset($_GET['l_date_to']) && !empty($_GET['l_date_to']))
    {
        $_GET['l_date_to'] = preg_replace('/[^0-9\.: ]+/', '', $_GET['l_date_to']);
        $date_time = explode(' ', $_GET['l_date_to']);
        if (count($date_time) > 0)
        {
            $filter_str .= ' AND l.l_date <= '.sb_datetoint($_GET['l_date_to']);
        }
    }

    if (isset($_GET['l_ip']) && !empty($_GET['l_ip']))
    {
        $_GET['l_ip'] = preg_replace('/[^0-9\.]+/', '', $_GET['l_ip']);
        if (!empty($_GET['l_ip']))
            $filter_str .= ' AND l.l_ip LIKE "'.$_GET['l_ip'].'%"';
    }

    if (isset($_GET['l_domain']) && !empty($_GET['l_domain']))
    {
        $_GET['l_domain'] = preg_replace('/[^a-zA-Z0-9\-\.]+/', '', $_GET['l_domain']);

        if (!empty($_GET['l_domain']))
            $filter_str .= ' AND l.l_domain = "'.$_GET['l_domain'].'"';
    }

	if (isset($_GET['l_url']) && !empty($_GET['l_url']))
    {
        $filter_str .= ' AND l.l_url LIKE '.$GLOBALS['sbSql']->escape('%'.trim($_GET['l_url']).'%');
    }

    $href = SB_CMS_CONTENT_FILE.'?event=pl_redirect_404_read';
    $excel_href = SB_CMS_EMPTY_FILE.'?event=pl_redirect_404_excel';
    $archive_href = SB_CMS_CONTENT_FILE.'?event=pl_redirect_404_archive';

    foreach ($_GET as $key => $value)
    {
        if ($key != 'event')
        {
            if (!is_array($value))
            {
                if ($key != 'order')
                {
                    $href .= '&'.$key.'='.urlencode($value);
                }
                $excel_href .= '&'.$key.'='.urlencode($value);
            }
            else
            {
                foreach ($value as $value2)
                {
                    if ($key != 'order')
                    {
                        $href .= '&'.$key.'[]'.'='.urlencode($value2);
                    }
                    $excel_href .= '&'.$key.'[]'.'='.urlencode($value2);
                }
            }
        }
    }

    echo '
    <table cellpadding="0" cellspacing="0" width="100%" align="center">
    <tr id="filter_header">
        <td width="100%" class="sb_filter_header">
        	<table cellpadding="0" cellspacing="0">
        	<tr>
            	<td class="sb_filter_text"><span onclick="showFilter();" ondblclick="showFilter();" style="cursor:hand;cursor:pointer;">'.KERNEL_FILTER.'&nbsp;&nbsp;<img src="'.SB_CMS_IMG_URL.'/'.($filter_str != '' ? 'fil_arrow_up' : 'fil_arrow_down').'.gif" id="filter_arrow" align="absmiddle" /></span></td>
            	<td class="sb_filter_on" id="sb_filter_on" style="'.($filter_str != '' ? '' : 'visibility: hidden;').'"><nobr><img src="'.SB_CMS_IMG_URL.'/filter_on.png" align="absmiddle" width="12" height="12">&nbsp;&nbsp;'.SB_ELEMS_FILTER_ON.'&nbsp;&nbsp;<img src="'.SB_CMS_IMG_URL.'/filter_delim.gif" align="absmiddle" width="1" height="14">&nbsp;&nbsp;<span style="cursor: hand; cursor: pointer;" onclick="removeFilter(event);"><img src="'.SB_CMS_IMG_URL.'/filter_off.png" align="absmiddle" width="12" height="12">&nbsp;&nbsp;'.KERNEL_CANCEL.'</span></nobr></td>
            </tr></table>
        </td>
    </tr>
    <tr><td valign="top">
            <form id="filter_form" action="" method="get" onsubmit="return setFilter();">
            <div id="sb_filter"'.($filter_str != '' ? '' : ' style="display:none;"').'>
            <table cellpadding="0" cellspacing="0" class="sb_filter_table">
            <tr>
                <th class="sb_filter_th">'.PL_REDIRECT_404_DATE.':</th>
                <td class="sb_filter_td"><nobr>';

    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

    $fld_lo = new sbLayoutDate((isset($_GET['l_date_from']) ? $_GET['l_date_from'] : ''), 'l_date_from');
    $fld_lo->mDropButton = true;

    $fld_hi = new sbLayoutDate((isset($_GET['l_date_to']) ? $_GET['l_date_to'] : ''), 'l_date_to');
    $fld_hi->mDropButton = true;

    echo $fld_lo->getJavaScript().
    	'<table cellpadding="0" cellspacing="0"><tr><td>'.KERNEL_FROM.'&nbsp;&nbsp;</td><td>'.$fld_lo->getField().'</td><td>&nbsp;&nbsp;'.KERNEL_TO.'&nbsp;&nbsp;</td><td>'.$fld_hi->getField().'</td></tr></table>
    	</nobr>
                </td>
                <th class="sb_filter_th">'.PL_REDIRECT_404_DOMAIN.':</th>
                <td class="sb_filter_td_noborder">';

    require_once (SB_CMS_LIB_PATH.'/sbIDN.inc.php');
    $idn = new sbIDN();

    $options = array('-1' => ' --- ');
    $u_domains = array();
    foreach ($GLOBALS['sb_domains'] as $domain => $value)
    {
        $options[$domain] = $idn->decode($domain);
        $u_domains[] = $domain;
    }

    $fld = new sbLayoutSelect($options, 'l_domain');
    if (isset($_GET['l_domain']))
        $fld->mSelOptions[] = $_GET['l_domain'];
    echo $fld->getField();

    echo '      </td>
            </tr>
            <tr>
                <th class="sb_filter_th">'.PL_REDIRECT_404_IP.':</th>
                <td class="sb_filter_td">';

    $fld = new sbLayoutInput('text', isset($_GET['l_ip']) ? $_GET['l_ip'] : '', 'l_ip', '', 'style="width: 100%;"');
    echo $fld->getField();

    echo '      </td>
                <th class="sb_filter_th">'.PL_REDIRECT_404_URL.':</th>
                <td class="sb_filter_td_noborder">';

    $fld = new sbLayoutInput('text', isset($_GET['l_url']) ? $_GET['l_url'] : '', 'l_url', '', 'style="width: 100%;"');
    echo $fld->getField();

    echo '      </td>
            </tr>
            </table>
            <div class="sb_filter_footer">
                    <input type="submit" value="'.KERNEL_APPLY.'">&nbsp;&nbsp;
            </div>
            </div>
            </form>
        </table>
    </td></tr></table>
    <br>
    <center>
    <div align="right" style="width:95%">
    <a href="javascript:refreshJournal();"><img src="'.SB_CMS_IMG_URL.'/link.png" width="12" height="12" border="0" align="absmiddle">&nbsp;'.PL_REDIRECT_404_REFRESH.'</a>
	&nbsp;&nbsp;&nbsp;
    <a href="'.$excel_href.'" target="_blank"><img src="'.SB_CMS_IMG_URL.'/icon_excel.png" width="20" height="20" border="0" align="absmiddle">&nbsp;'.PL_REDIRECT_404_EXCEL.'</a>
    &nbsp;&nbsp;&nbsp;
    <a href="'.$archive_href.'"><img src="'.SB_CMS_IMG_URL.'/icon_archive.png" width="20" height="20" border="0" align="absmiddle">&nbsp;'.PL_REDIRECT_404_ARCHIVE.'</a>
    </div>';

    require_once(SB_CMS_LIB_PATH.'/sbDBPager.inc.php');

    $res = sql_param_query('SELECT u_admin, u_domains FROM sb_users WHERE u_id=?d', $_SESSION['sbAuth']->getUserId());
    list($u_admin, $domains) = $res[0];

    $total = true;
    $pager = new sbDBPager('l', 7, 25, 'content');

    if ($u_admin != 1)
    {
        $u_domains = explode(',', $domains);
        $result = $pager->init($total, 'SELECT l.l_id, l.l_date, l.l_count, l.l_ip, l.l_url, l.l_domain FROM sb_404_log l WHERE l.l_domain IN (?a) '.$filter_str.' '.$order_str, $u_domains);
    }
	else
	{
		$result = $pager->init($total, 'SELECT l.l_id, l.l_date, l.l_count, l.l_ip, l.l_url, l.l_domain FROM sb_404_log l '.($filter_str != '' ? 'WHERE '.substr($filter_str, 5) : '').' '.$order_str);
	}

    $num_list = $pager->show();

    echo '<br>'.$num_list.'<br><br>
    <table width="98%" cellspacing="0" cellpadding="5" class="form">
    <tr>
        <th class="header" width="50">
            &nbsp;
        </th>
        <th class="header" width="150">
            <table cellpadding="2" cellspacing="0" width="100%">
            <tr style="background-color: transparent;">
            	<td><a href="'.$href.'&order=l_date|asc"><img src="'.SB_CMS_IMG_URL.'/'.($_GET['order'] == 'l_date|asc' ? 's_asc_sel.gif' : 's_asc.gif').'" border="0" width="11" height="9"></a></td>
            	<th class="header" style="background-image: none;">
		            <nobr>
		                &nbsp;'.PL_REDIRECT_404_DATE.'&nbsp;
		            </nobr>
		        </th>
		        <td><a href="'.$href.'&order=l_date|desc"><img src="'.SB_CMS_IMG_URL.'/'.($_GET['order'] == 'l_date|desc' ? 's_desc_sel.gif' : 's_desc.gif').'" border="0" width="11" height="9"></a></td>
		    </tr>
		    </table>
        </th>
        <th class="header" width="150">
        	<table cellpadding="2" cellspacing="0" width="100%">
            <tr style="background-color: transparent;">
            	<td><a href="'.$href.'&order=l_ip|asc"><img src="'.SB_CMS_IMG_URL.'/'.($_GET['order'] == 'l_ip|asc' ? 's_asc_sel.gif' : 's_asc.gif').'" border="0" width="11" height="9"></a></td>
            	<th class="header" style="background-image: none;">
		            <nobr>
		                &nbsp;'.PL_REDIRECT_404_IP.'&nbsp;
		            </nobr>
		        </th>
		        <td><a href="'.$href.'&order=l_ip|desc"><img src="'.SB_CMS_IMG_URL.'/'.($_GET['order'] == 'l_ip|desc' ? 's_desc_sel.gif' : 's_desc.gif').'" border="0" width="11" height="9"></td>
		    </tr>
		    </table>
        </th>
        <th class="header" width="100" style="padding-top: 14px;">
            <nobr>
                <a href="'.$href.'&order=l_count|asc"><img src="'.SB_CMS_IMG_URL.'/'.($_GET['order'] == 'l_count|asc' ? 's_asc_sel.gif' : 's_asc.gif').'" border="0" width="11" height="9"></a>
                &nbsp;'.PL_REDIRECT_404_COUNT.'&nbsp;
                <a href="'.$href.'&order=l_count|desc"><img src="'.SB_CMS_IMG_URL.'/'.($_GET['order'] == 'l_count|desc' ? 's_desc_sel.gif' : 's_desc.gif').'" border="0" width="11" height="9"></a>
            </nobr>
        </th>
        <th class="header" width="100" style="padding-top: 14px;">
            <nobr>
                <a href="'.$href.'&order=l_domain|asc"><img src="'.SB_CMS_IMG_URL.'/'.($_GET['order'] == 'l_domain|asc' ? 's_asc_sel.gif' : 's_asc.gif').'" border="0" width="11" height="9"></a>
                &nbsp;'.PL_REDIRECT_404_DOMAIN.'&nbsp;
                <a href="'.$href.'&order=l_domain|desc"><img src="'.SB_CMS_IMG_URL.'/'.($_GET['order'] == 'l_domain|desc' ? 's_desc_sel.gif' : 's_desc.gif').'" border="0" width="11" height="9"></a>
            </nobr>
        </th>
        <th class="header" style="padding-top: 14px;">
            <nobr>
                <a href="'.$href.'&order=l_url|asc"><img src="'.SB_CMS_IMG_URL.'/'.($_GET['order'] == 'l_url|asc' ? 's_asc_sel.gif' : 's_asc.gif').'" border="0" width="11" height="9"></a>
                &nbsp;'.PL_REDIRECT_404_URL.'&nbsp;
                <a href="'.$href.'&order=l_url|desc"><img src="'.SB_CMS_IMG_URL.'/'.($_GET['order'] == 'l_url|desc' ? 's_desc_sel.gif' : 's_desc.gif').'" border="0" width="11" height="9"></a>
            </nobr>
        </th>
    </tr>';

    if ($result)
    {
        /**
         * Вывод таблицы
         */
    	$domains = array();
    	$res = sql_query('SELECT cat_title, cat_left, cat_right FROM sb_categs WHERE cat_ident="pl_redirect" AND cat_level=1');
    	if ($res)
    	{
    		foreach ($res as $value)
    		{
    			list($cat_title, $cat_left, $cat_right) = $value;

    			$domains[$cat_title] = array();
    			$domains[$cat_title]['cat_left'] = $cat_left;
    			$domains[$cat_title]['cat_right'] = $cat_right;
    		}
    	}

        for($i = 0; $i < count($result); $i++)
        {
            list($l_id, $l_date, $l_count, $l_ip, $l_url, $l_domain) = $result[$i];

            $l_idn_domain = $idn->decode($l_domain);

            $ok = false;
            if (isset($domains[$l_domain]))
            {
	            $res = sql_param_query('SELECT COUNT(*) FROM sb_categs c, sb_catlinks l, sb_redirect r
	            		WHERE c.cat_left >= ?d AND c.cat_right <= ?d AND c.cat_ident="pl_redirect"
	            		AND l.link_cat_id=c.cat_id AND l.link_el_id=r.sr_id
	            		AND r.sr_old_url=?', $domains[$l_domain]['cat_left'], $domains[$l_domain]['cat_right'], '/'.$l_url);

	            if ($res && $res[0][0] > 0)
	            {
	            	$ok = true;
	            }
            }

            echo '<tr'.($i % 2 != 0 ? ' class="even"' : ' class="odd"').'>
                    <td style="text-align:center;">
                        <img src="'.SB_CMS_IMG_URL.'/'.($ok ? 'information' : 'warning').'_log.png" alt="'.($ok ? PL_REDIRECT_404_IMG_TITLE_OK : PL_REDIRECT_404_IMG_TITLE_ERROR).'" title="'.($ok ? PL_REDIRECT_404_IMG_TITLE_OK : PL_REDIRECT_404_IMG_TITLE_ERROR).'" \>
                    </td>
                    <td style="font-size: 10px;text-align: center;">
                        '.sb_date('d.m.Y', $l_date).'<br />'.KERNEL_IN.'<br />'.sb_date('H:i:s', $l_date).'
                    </td>
                    <td style="font-size: 10px;text-align: center;">
                        '.$l_ip.'
                    </td>
                    <td style="font-size: 10px;text-align: center;">
                        <b>'.$l_count.'</b>
                    </td>
                    <td style="font-size: 10px;text-align: center;">
                        <b>'.$l_idn_domain.'</b>
                    </td>
                    <td>
                    	<div class="hint_div"><a href="'.SB_CMS_CONTENT_FILE.'?event=pl_redirect_init&l_id='.$l_id.'">http://'.$l_idn_domain.'/'.$l_url.'</a></div>
            		</td>
                </tr>';
        }
    }
    else
    {
        $num_list = PL_REDIRECT_404_NO_MESSAGES;
    }

    echo '</table>
          <br>'.$num_list.'<br><br></center>';
}

function fRedirect_404_Excel()
{
    header('Content-type: application/vnd.ms-excel; charset='.strtolower(SB_CHARSET), true);
    header('Content-Disposition: attachment; filename="sbuilder_404_log.xls"');

    echo '<html>
        <head>
        <title></title>
        <meta http-equiv="Content-Type" content="text/html; charset='.strtolower(SB_CHARSET).'">
        <body>';

    if (!isset($_GET['order']))
    {
        $_GET['order'] = 'l_date|desc';
    }
    else
    {
        $_GET['order'] = preg_replace('/[^a-zA-Z0-9_|]+/', '', $_GET['order']);
        if (empty($_GET['order']))
            $_GET['order'] = 'l_date|desc';
    }

	$order_str = explode('|', $_GET['order']);
    if ($_GET['order'] != 'l_date|desc' && count($order_str) == 2)
    {
        $order_str = 'ORDER BY l.'.$order_str[0].' '.strtoupper($order_str[1]).', l.l_date DESC';
    }
    else
    {
    	$order_str = 'ORDER BY l.l_date DESC';
    }

    $res = sql_param_query('SELECT u_admin, u_domains FROM sb_users WHERE u_id=?d', $_SESSION['sbAuth']->getUserId());
    list($u_admin, $domains) = $res[0];

    $u_domains = explode(',', $domains);

    $result = sql_param_query('SELECT l.l_date, l.l_count, l.l_ip, l.l_url, l.l_domain FROM sb_404_log l {WHERE l.l_domain IN (?a)} '.$order_str, ($u_admin != 1 ? $u_domains : SB_SQL_SKIP));

    if ($result)
    {
        /**
         * Вывод таблици
         */
        echo '<table border="1">
              <tr>
                <th width="160">
                    &nbsp;'.PL_REDIRECT_404_DATE.'&nbsp;
                </th>
                <th width="80">
                    &nbsp;'.PL_REDIRECT_404_IP.'&nbsp;
                </th>
                <th width="100">
                    &nbsp;'.PL_REDIRECT_404_COUNT.'&nbsp;
                </th>
                <th width="100">
                    &nbsp;'.PL_REDIRECT_404_DOMAIN.'&nbsp;
                </th>
                <th>
                    &nbsp;'.PL_REDIRECT_404_URL.'&nbsp;
                </th>
             </tr>';

        require_once (SB_CMS_LIB_PATH.'/sbIDN.inc.php');
    	$idn = new sbIDN();

        for($i = 0; $i < count($result); $i++)
        {
            list($l_date, $l_count, $l_ip, $l_url, $l_domain) = $result[$i];

            $l_idn_domain = $idn->decode($l_domain);

            echo '<tr>
                    <td align="center" width="160" valign="top">
                        '.sb_date('d.m.Y '.KERNEL_IN.' H:i:s', $l_date).'
                    </td>
                    <td align="center" width="80" valign="top">
                        '.$l_ip.'
                    </td>
                    <td align="center" width="100" valign="top">
                        <b>'.$l_count.'</b>
                    </td>
                    <td align="center" width="100" valign="top">
                        <b>'.$l_idn_domain.'</b>
                    </td>
                    <td valign="top">
                        <a href="http://'.$l_domain.'/'.$l_url.'" target="_blank">http://'.$l_idn_domain.'/'.$l_url.'</a>
                    </td>
                </tr>';
        }

        echo '</table>';
    }

    echo '</body></html>';
}

function fRedirect_404_Archive()
{
	require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

	$layout = new sbLayout();
	$layout->mShowTitle = false;

	echo '<script>
	function deleteFile(file, page)
    {
    	var str = file == "all" ? "'.PL_REDIRECT_404_ARCHIVE_DELETE_ALL_REQUEST.'" : "'.PL_REDIRECT_404_ARCHIVE_REQUEST.'";

        if(confirm(str))
        {
        	var res = sbLoadSync("'.SB_CMS_EMPTY_FILE.'?event=pl_redirect_404_archive_delete&file="+file);
            if(res != "")
            {
            	sbShowMsgDiv(res, "warning.png");
            }

            if (file == "all")
            {
            	window.location = sb_cms_content_file + "?event=pl_redirect_404_archive";
            }
            else if (res == "")
            {
                window.location = sb_cms_content_file + "?event=pl_redirect_404_archive&page_archive=" + page;
            }
        }
    }
	</script>
	<br /><br />';

	$dir = $GLOBALS['sbVfs']->scandir('cms/backup/');

    $pagesCount = 25;  // Кол-во архивов на одной странице
	$points = array(); // Массив точек восстановления

    // Сканируем папку
    for($i = count($dir) - 1; $i >= 0; $i--)
    {
       	if ($GLOBALS['sbVfs']->is_file('cms/backup/'.$dir[$i]) && strpos($dir[$i], 'log404_') === 0)
       	{
       		$ext = explode('.', $dir[$i]);
       		if (count($ext) != 2)
       			continue;

       		$file = $ext[0];
       		if (!isset($points[$file]))
       			$points[$file] = array();

       		$points[$file]['date_end'] = str_replace('_', '.', substr($file, 7, 10));
       		$points[$file]['time_end'] = str_replace('_', ':', substr($file, 18, 8));
       		$points[$file]['date_start'] = str_replace('_', '.', substr($file, 28, 10));
       		$points[$file]['time_start'] = str_replace('_', ':', substr($file, 39, 8));

       		$points[$file]['type'] = $ext[1];
       	}
    }

	function cmp_dates(&$ar1, &$ar2)
    {
        $time1 = sb_datetoint($ar1['date_end'].' '.$ar1['time_end']);
        $time2 = sb_datetoint($ar2['date_end'].' '.$ar2['time_end']);

        if ($time1 > $time2)
            return -1;
        if ($time1 < $time2)
            return 1;

        return 0;
    }

    uasort($points, 'cmp_dates');

    // Настраиваем страницы
    $num = count($points); // Всего архивов
    if($num > 0)
    {
    	// Всего страниц
      	$totalPages = ceil($num / $pagesCount);

       	// Номер текущей страницы
    	if(isset($_GET['page_archive']))
    	{
    		$page = min(max(1, intval($_GET['page_archive'])), $totalPages);
    		$_GET['page_archive'] = $page;
    	}
       	else
       	{
       		$page = 1;
       	}

      	require_once(SB_CMS_LIB_PATH.'/sbDBPager.inc.php');

    	$pager = new sbDBPager('archive', 7, $pagesCount);

    	$pager->mNumberTemp = '&nbsp;<a href="{HREF}">{NUMBER}</a>&nbsp;';

    	$pager->mBeginTemp = '<a href="{HREF}"><img src="'.SB_CMS_IMG_URL.'/begin.gif" width="14" height="15" border="0" alt="'.KERNEL_PAGER_BEGIN.'" align="absmiddle"></a>';
        $pager->mBeginTempDisabled = '<img src="'.SB_CMS_IMG_URL.'/begin_gray.gif" width="14" height="15" border="0" alt="'.KERNEL_PAGER_BEGIN.'" align="absmiddle">';

        $pager->mPrevTemp = '<a href="{HREF}"><img src="'.SB_CMS_IMG_URL.'/previous.gif" width="14" height="15" border="0" alt="'.KERNEL_PAGER_PREV.'" align="absmiddle"></a>';
        $pager->mPrevTempDisabled = '<img src="'.SB_CMS_IMG_URL.'/previous_gray.gif" width="14" height="15" border="0" alt="'.KERNEL_PAGER_PREV.'" align="absmiddle">';

        $pager->mNextTemp = '<a href="{HREF}"><img src="'.SB_CMS_IMG_URL.'/next.gif" width="14" height="15" border="0" alt="'.KERNEL_PAGER_NEXT.'" align="absmiddle"></a>';
        $pager->mNextTempDisabled = '<img src="'.SB_CMS_IMG_URL.'/next_gray.gif" width="14" height="15" border="0" alt="'.KERNEL_PAGER_NEXT.'" align="absmiddle">';

        $pager->mEndTemp =  '<a href="{HREF}"><img src="'.SB_CMS_IMG_URL.'/end.gif" width="14" height="15" border="0" alt="'.KERNEL_PAGER_END.'" align="absmiddle"></a>';
        $pager->mEndTempDisabled = '<img src="'.SB_CMS_IMG_URL.'/end_gray.gif" width="14" height="15" border="0" alt="'.KERNEL_PAGER_END.'" align="absmiddle">';

    	$pager->mNumElemsAll = $num;

       	$labels = array(PL_REDIRECT_404_ARCHIVE_TITLE, '');
        $values = array();

        $from = ($page - 1) * $pagesCount; // номер точки восстановления с которой нужно начать выводить список
        $to = min($num, $from + $pagesCount);
        $i = 0;
        foreach($points as $file => $point)
       	{
       		if ($i < $from)
       		{
       			$i++;
       			continue;
       		}

       		if ($i >= $to)
       			break;

       		if (isset($point['date_start']) && isset($point['date_end']) && isset($point['time_start']) && isset($point['time_end']))
       	    {
       			$values[] = array(PL_REDIRECT_404_ARCHIVE_PERIOD.' '.KERNEL_DATE_FROM.' <i>'.$point['date_start'].' '.$point['time_start'].'</i> '.KERNEL_DATE_TO.' <i>'.$point['date_end'].' '.$point['time_end'].'</i> &nbsp; <a href="'.SB_CMS_CONTENT_FILE.'?event=pl_redirect_404_archive_view&file='.$file.'">'.KERNEL_MORE.'</a>',
       						  '<img class="button" src="'.SB_CMS_IMG_URL.'/files_drop.png" width="20" height="20" onmouseup="sbPress(this, false);" onmousedown="sbPress(this, true);" alt="'.PL_REDIRECT_404_ARCHIVE_DELETE_POINT.'" onclick="deleteFile(\''.$file.'\', '.$page.');">');
       	    }
       	    else
       	    {
       	    	$values[] = array('<div class="hint_div">'.PL_REDIRECT_404_ARCHIVE_CORRUPTED.'</div>', '<img class="button" src="'.SB_CMS_IMG_URL.'/files_drop.png" width="20" height="20" onmouseup="sbPress(this, false);" onmousedown="sbPress(this, true);" alt="'.PL_REDIRECT_404_ARCHIVE_DELETE_POINT.'" onclick="deleteFile(\''.$file.'\', '.$page.');">');
       	    }

       		$i++;
       	}

     	$field = new sbLayoutTable($labels, $values);
     	$field->mWidth = array('', '20');
     	$field->mAlign = array('left', '');
     	$field->mShowTable = true;
     	$layout->addField('', $field);

     	$html = '<a href="'.SB_CMS_CONTENT_FILE.'?event=pl_redirect_404_read">[ '.KERNEL_BACK.' ]</a> &nbsp;&nbsp;&nbsp; <a href="javascript:deleteFile(\'all\');">[ '.PL_REDIRECT_404_ARCHIVE_DELETE_ALL.' ]</a>';
     	$layout->addField('', new sbLayoutHTML($html), '', 'align = "right"');

     	$pages = $pager->show();

     	if ($pages != '')
     	{
     		$layout->addField('', new sbLayoutDelim());
        	$layout->addField('', new sbLayoutHTML('<center>'.$pages.'</center>'));
     	}
    }
    else
    {
    	$layout->addField('', new sbLayoutHTML(sb_show_message(PL_REDIRECT_404_ARCHIVE_EMPTY.'<br /><br /><div align="center"><a href="'.SB_CMS_CONTENT_FILE.'?event=pl_redirect_404_read">[ '.KERNEL_BACK.' ]</a></div>', true, 'information', true).'<br /><br />'));
    }

    $layout->show();
}

function fRedirect_404_Archive_Delete()
{
	if (!isset($_GET['file']) || (strpos($_GET['file'], 'log404_') !== 0 && $_GET['file'] != 'all'))
    {
    	echo PL_REDIRECT_404_ARCHIVE_DELETE_ERROR;
        return;
    }

    $_GET['file'] = preg_replace('/[^a-zA-Z_0-9]/', '', $_GET['file']);

	$error = false;   // флаг ошибки

	if ($_GET['file'] == 'all')
	{
		$dir = $GLOBALS['sbVfs']->scandir('cms/backup/');
		foreach($dir as $value)
		{
		    if ($GLOBALS['sbVfs']->is_file('cms/backup/'.$value) && strpos($value, 'log404_') === 0)
			    $error = !$GLOBALS['sbVfs']->delete('cms/backup/'.$value);
		}
	}
	else
	{
		$file_zip = 'cms/backup/'.$_GET['file'].'.zip';
		$file_xml = 'cms/backup/'.$_GET['file'].'.xml';

		if ($GLOBALS['sbVfs']->exists($file_zip) && !$GLOBALS['sbVfs']->delete($file_zip))
			$error = true;

		if ($GLOBALS['sbVfs']->exists($file_xml) && !$GLOBALS['sbVfs']->delete($file_xml))
			$error = true;
	}

	if($error && $_GET['file'] != 'all')
	{
		sb_add_system_message(PL_REDIRECT_404_ARCHIVE_DELETE_SYSTEMLOG_ERROR, SB_MSG_WARNING);
		echo PL_REDIRECT_404_ARCHIVE_DELETE_ERROR;
		return;
	}

	if ($_GET['file'] == 'all')
	{
		sb_add_system_message(PL_REDIRECT_404_ARCHIVE_DELETE_ALL_OK);
	}
	else
	{
		sb_add_system_message(sprintf(PL_REDIRECT_404_ARCHIVE_DELETE_OK, $_GET['file']));
	}
}

function fRedirect_404_Archive_View()
{
	if (!isset($_GET['file']) || strpos($_GET['file'], 'log404_') !== 0)
    {
    	sb_show_message(PL_REDIRECT_404_ARCHIVE_CORRUPTED.'<br /><br /><div align="center"><a href="'.SB_CMS_CONTENT_FILE.'?event=pl_redirect_404_archive">[ '.KERNEL_BACK.' ]</a></div>', true, 'information');
        return;
    }

    $_GET['file'] = preg_replace('/[^a-zA-Z_0-9]/', '', $_GET['file']);

    $file_zip = 'cms/backup/'.$_GET['file'].'.zip';
	$file_xml = 'cms/backup/'.$_GET['file'].'.xml';

	$zip = false;
	$xml = false;

	if ($GLOBALS['sbVfs']->exists($file_zip))
		$zip = true;

	if ($GLOBALS['sbVfs']->exists($file_xml))
		$xml = true;

	if (!$zip && !$xml)
    {
    	sb_show_message(PL_REDIRECT_404_ARCHIVE_CORRUPTED.'<br /><br /><div align="center"><a href="'.SB_CMS_CONTENT_FILE.'?event=pl_redirect_404_archive">[ '.KERNEL_BACK.' ]</a></div>', true, 'information');
        return;
    }

    if ($zip)
    {
    	$tmp_id = uniqid();
        $tmp_dir = SB_CMS_TMP_PATH.'/'.$tmp_id;

        $GLOBALS['sbVfs']->mLocal = true;

        if (!$GLOBALS['sbVfs']->exists($tmp_dir))
        {
            if (!$GLOBALS['sbVfs']->mkdir($tmp_dir))
            {
                sb_show_message(PL_REDIRECT_404_ARCHIVE_VIEW_UNZIP_ERROR.'<br /><br /><div align="center"><a href="'.SB_CMS_CONTENT_FILE.'?event=pl_redirect_404_archive">[ '.KERNEL_BACK.' ]</a></div>', true, 'information');
        		$GLOBALS['sbVfs']->mLocal = false;
        		return;
            }
        }

        if (!$GLOBALS['sbVfs']->is_writable($tmp_dir))
        {
            sb_show_message(PL_REDIRECT_404_ARCHIVE_VIEW_UNZIP_ERROR.'<br /><br /><div align="center"><a href="'.SB_CMS_CONTENT_FILE.'?event=pl_redirect_404_archive">[ '.KERNEL_BACK.' ]</a></div>', true, 'information');
            $GLOBALS['sbVfs']->mLocal = false;
            return;
        }

        $file = $tmp_dir.str_replace('cms/backup', '', $file_xml);

        if (function_exists('gzopen64'))
    		$gz = @gzopen64(SB_BASEDIR.'/'.$file_zip, 'rb');
    	else
    		$gz = @gzopen(SB_BASEDIR.'/'.$file_zip, 'rb');

        $fl = $GLOBALS['sbVfs']->fopen($file, 'ab');

        if (!$gz || !$fl)
        {
            sb_show_message(PL_REDIRECT_404_ARCHIVE_VIEW_UNZIP_ERROR.'<br /><br /><div align="center"><a href="'.SB_CMS_CONTENT_FILE.'?event=pl_redirect_404_archive">[ '.KERNEL_BACK.' ]</a></div>', true, 'information');
        	if ($fl)
            {
            	$GLOBALS['sbVfs']->fclose();
            }
            $GLOBALS['sbVfs']->delete($tmp_dir);
            $GLOBALS['sbVfs']->mLocal = false;
            return;
        }

        $GLOBALS['sbVfs']->mLocal = false;

        while (!@gzeof($gz))
        {
        	$str = trim(@gzgets($gz, 4096));
        	$GLOBALS['sbVfs']->fwrite($str);
        }

        @gzclose($gz);
        $GLOBALS['sbVfs']->fclose();
        $GLOBALS['sbVfs']->mLocal = false;
    }
    else
    {
    	$file = SB_BASEDIR.'/'.$file_xml;
    }

    $xml = simplexml_load_file($file);
	if (!$xml)
    {
        sb_show_message(PL_REDIRECT_404_ARCHIVE_VIEW_XML_ERROR.'<br /><br /><div align="center"><a href="'.SB_CMS_CONTENT_FILE.'?event=pl_redirect_404_archive">[ '.KERNEL_BACK.' ]</a></div>', true, 'information');
	    if ($zip)
	    {
	    	$GLOBALS['sbVfs']->mLocal = true;
	    	$GLOBALS['sbVfs']->delete($tmp_dir);
	    	$GLOBALS['sbVfs']->mLocal = false;
	    }
        return;
    }

    $xpath = '/db/sb_404_log';
	$domain_xpath = '';
	$filter_xpath = '';

    if (isset($_GET['l_date_from']) && !empty($_GET['l_date_from']))
    {
        $_GET['l_date_from'] = preg_replace('/[^0-9\.: ]+/', '', $_GET['l_date_from']);
        $date_time = explode(' ', $_GET['l_date_from']);
        if (count($date_time) > 0)
        {
            $filter_xpath .= 'l_date >= "'.sb_datetoint($_GET['l_date_from']).'" and ';
        }
    }

    if (isset($_GET['l_date_to']) && !empty($_GET['l_date_to']))
    {
        $_GET['l_date_to'] = preg_replace('/[^0-9\.: ]+/', '', $_GET['l_date_to']);
        $date_time = explode(' ', $_GET['l_date_to']);
        if (count($date_time) > 0)
        {
            $filter_xpath .= 'l_date <= "'.sb_datetoint($_GET['l_date_to']).'" and ';
        }
    }

    if (isset($_GET['l_ip']) && !empty($_GET['l_ip']))
    {
        $_GET['l_ip'] = preg_replace('/[^0-9\.]+/', '', $_GET['l_ip']);
        if (!empty($_GET['l_ip']))
        {
        	$filter_xpath .= 'l_ip = "'.$_GET['l_ip'].'" and ';
        }
    }

    if (isset($_GET['l_domain']) && !empty($_GET['l_domain']))
    {
        $_GET['l_domain'] = preg_replace('/[^a-zA-Z0-9\-\.]+/', '', $_GET['l_domain']);

        if (!empty($_GET['l_domain']))
        {
        	$filter_xpath.= 'l_domain = "'.$_GET['l_domain'].'" and ';
        }
    }

	if ($filter_xpath != '')
    {
    	$filter_xpath = sb_substr($filter_xpath, 0, -5);
    }

    $res = sql_param_query('SELECT u_admin, u_domains FROM sb_users WHERE u_id=?d', $_SESSION['sbAuth']->getUserId());
    list($u_admin, $u_domains) = $res[0];

    if ($u_admin != 1)
    {
    	$u_domains = explode(',', $u_domains);

    	$domain_xpath = array();
    	foreach($u_domains as $domain)
    	{
    		$domain_xpath[] = 'l_domain="'.trim($domain).'"';
    	}

    	$domain_xpath = '('.implode(' or ', $domain_xpath).')';
    }

    if ($domain_xpath != '' || $filter_xpath != '')
    {
    	$xpath .= '['.$filter_xpath.($filter_xpath != '' && $domain_xpath != '' ? ' and ' : '').$domain_xpath.']';
    }

    $xml = $xml->xpath($xpath);

    // Настраиваем страницы
    $pagesCount = 25;  // Кол-во сообщений на одной странице
    $num = 0;

   	if ($xml)
   	{
    	$num = count($xml); // Всего сообщений
   	}

    if($num > 0)
    {
    	echo '<style type="text/css">
	    	#event_content table.form tr.even:hover,
			#event_content table.form tr.odd:hover
			{
			    background-color: #E1FFE1;
			}

			#event_content
			{
				overflow-x: auto;
			}
		</style>
	    <script>
	    document.body.onselectstart = "";
	    document.body.setAttribute("unselectable", "off");

	    function showFilter()
	    {
	        var filter = sbGetE("sb_filter");
	        var filter_arr = sbGetE("filter_arrow");
	        if (!filter) return;
	        if (filter.style.display == "none")
	        {
	            filter.style.display = "";
	            filter_arr.src = sb_cms_img_url + "/fil_arrow_up.gif";
	        }
	        else
	        {
	            filter.style.display = "none";
	            filter_arr.src = sb_cms_img_url + "/fil_arrow_down.gif";
	        }
	    }
	    function setFilter()
	    {
	        var str = "'.SB_CMS_CONTENT_FILE.'?event=pl_redirect_404_archive_view&file='.$_GET['file'].'";
	        var found = false;
	        var frm = sbGetE("filter_form");
	        for (var i = 0; i < frm.elements.length; i++)
	        {
	            var el = frm.elements[i];
	            if (el.type == "select-one")
	            {
	                if (el.value != -1)
	                {
	                    str += "&"+el.name+"="+el.value;
	                    found = true;
	                }
	            }
	            else
	            {
	                if (el.name != "" && el.value != "")
	                {
	                    str += "&"+el.name+"="+el.value;
	                    found = true;
	                }
	            }
	        }
	        if (!found)
	        {
	            return false;
	        }

	        window.location = str;
	        return false;
	    }
	    function removeFilter(e)
	    {
	        window.location = "'.SB_CMS_CONTENT_FILE.'?event=pl_redirect_404_archive_view&file='.$_GET['file'].'";
	        return sbCancelEvent(e);
	    }
	    </script>';

    	// Всего страниц
      	$totalPages = ceil($num / $pagesCount);

       	// Номер текущей страницы
    	if(isset($_GET['page_archive']))
    	{
    		$page = min(max(1, intval($_GET['page_archive'])), $totalPages);
    		$_GET['page_archive'] = $page;
    	}
       	else
       	{
       		$page = 1;
       	}

      	require_once(SB_CMS_LIB_PATH.'/sbDBPager.inc.php');

    	$pager = new sbDBPager('archive', 7, $pagesCount);

    	$pager->mNumberTemp = '&nbsp;<a href="{HREF}">{NUMBER}</a>&nbsp;';

    	$pager->mBeginTemp = '<a href="{HREF}"><img src="'.SB_CMS_IMG_URL.'/begin.gif" width="14" height="15" border="0" alt="'.KERNEL_PAGER_BEGIN.'" align="absmiddle"></a>';
        $pager->mBeginTempDisabled = '<img src="'.SB_CMS_IMG_URL.'/begin_gray.gif" width="14" height="15" border="0" alt="'.KERNEL_PAGER_BEGIN.'" align="absmiddle">';

        $pager->mPrevTemp = '<a href="{HREF}"><img src="'.SB_CMS_IMG_URL.'/previous.gif" width="14" height="15" border="0" alt="'.KERNEL_PAGER_PREV.'" align="absmiddle"></a>';
        $pager->mPrevTempDisabled = '<img src="'.SB_CMS_IMG_URL.'/previous_gray.gif" width="14" height="15" border="0" alt="'.KERNEL_PAGER_PREV.'" align="absmiddle">';

        $pager->mNextTemp = '<a href="{HREF}"><img src="'.SB_CMS_IMG_URL.'/next.gif" width="14" height="15" border="0" alt="'.KERNEL_PAGER_NEXT.'" align="absmiddle"></a>';
        $pager->mNextTempDisabled = '<img src="'.SB_CMS_IMG_URL.'/next_gray.gif" width="14" height="15" border="0" alt="'.KERNEL_PAGER_NEXT.'" align="absmiddle">';

        $pager->mEndTemp =  '<a href="{HREF}"><img src="'.SB_CMS_IMG_URL.'/end.gif" width="14" height="15" border="0" alt="'.KERNEL_PAGER_END.'" align="absmiddle"></a>';
        $pager->mEndTempDisabled = '<img src="'.SB_CMS_IMG_URL.'/end_gray.gif" width="14" height="15" border="0" alt="'.KERNEL_PAGER_END.'" align="absmiddle">';

    	$pager->mNumElemsAll = $num;

    	$num_list = $pager->show();

    	$excel_href = SB_CMS_EMPTY_FILE.'?event=pl_redirect_404_archive_excel&file='.$_GET['file'];
    	$archive_href = SB_CMS_CONTENT_FILE.'?event=pl_redirect_404_archive';

	    echo '<table cellpadding="0" cellspacing="0" width="100%" align="center">
	    <tr id="filter_header">
	        <td width="100%" class="sb_filter_header">
	        	<table cellpadding="0" cellspacing="0">
	        	<tr>
	            	<td class="sb_filter_text"><span onclick="showFilter();" ondblclick="showFilter();" style="cursor:hand;cursor:pointer;">'.KERNEL_FILTER.'&nbsp;&nbsp;<img src="'.SB_CMS_IMG_URL.'/'.($filter_xpath != '' ? 'fil_arrow_up' : 'fil_arrow_down').'.gif" id="filter_arrow" align="absmiddle" /></span></td>
	            	<td class="sb_filter_on" id="sb_filter_on" style="'.($filter_xpath != '' ? '' : 'visibility: hidden;').'"><nobr><img src="'.SB_CMS_IMG_URL.'/filter_on.png" align="absmiddle" width="12" height="12">&nbsp;&nbsp;'.SB_ELEMS_FILTER_ON.'&nbsp;&nbsp;<img src="'.SB_CMS_IMG_URL.'/filter_delim.gif" align="absmiddle" width="1" height="14">&nbsp;&nbsp;<span style="cursor: hand; cursor: pointer;" onclick="removeFilter(event);"><img src="'.SB_CMS_IMG_URL.'/filter_off.png" align="absmiddle" width="12" height="12">&nbsp;&nbsp;'.KERNEL_CANCEL.'</span></nobr></td>
	            </tr></table>
	        </td>
	    </tr>
	    <tr><td valign="top">
	            <form id="filter_form" action="" method="get" onsubmit="return setFilter();">
            <div id="sb_filter"'.($filter_xpath != '' ? '' : ' style="display:none;"').'>
            <table cellpadding="0" cellspacing="0" class="sb_filter_table">
            <tr>
                <th class="sb_filter_th">'.PL_REDIRECT_404_DATE.':</th>
                <td class="sb_filter_td"><nobr>';

    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

    $fld_lo = new sbLayoutDate((isset($_GET['l_date_from']) ? $_GET['l_date_from'] : ''), 'l_date_from');
    $fld_lo->mDropButton = true;

    $fld_hi = new sbLayoutDate((isset($_GET['l_date_to']) ? $_GET['l_date_to'] : ''), 'l_date_to');
    $fld_hi->mDropButton = true;

    echo $fld_lo->getJavaScript().
    	'<table cellpadding="0" cellspacing="0"><tr><td>'.KERNEL_FROM.'&nbsp;&nbsp;</td><td>'.$fld_lo->getField().'</td><td>&nbsp;&nbsp;'.KERNEL_TO.'&nbsp;&nbsp;</td><td>'.$fld_hi->getField().'</td></tr></table>
    	</nobr>
                </td>
                <th class="sb_filter_th">'.PL_REDIRECT_404_DOMAIN.':</th>
                <td class="sb_filter_td_noborder">';

    require_once (SB_CMS_LIB_PATH.'/sbIDN.inc.php');
    $idn = new sbIDN();

    $options = array('-1' => ' --- ');
    $u_domains = array();
    foreach ($GLOBALS['sb_domains'] as $domain => $value)
    {
        $options[$domain] = $idn->decode($domain);
        $u_domains[] = $domain;
    }

    $fld = new sbLayoutSelect($options, 'l_domain');
    if (isset($_GET['l_domain']))
        $fld->mSelOptions[] = $_GET['l_domain'];
    echo $fld->getField();

    echo '      </td>
            </tr>
            <tr>
                <th class="sb_filter_th">'.PL_REDIRECT_404_IP.':</th>
                <td class="sb_filter_td">';

    $fld = new sbLayoutInput('text', isset($_GET['l_ip']) ? $_GET['l_ip'] : '', 'l_ip', '', 'style="width: 100%;"');
    echo $fld->getField();

    echo '      </td>
                <th class="sb_filter_th">&nbsp;</th>
                <td class="sb_filter_td_noborder">&nbsp;</td>
            </tr>
            </table>
            <div class="sb_filter_footer">
                    <input type="submit" value="'.KERNEL_APPLY.'">&nbsp;&nbsp;
            </div>
            </div>
            </form>
	        </table>
	    </td></tr></table>
	    <br>
    	<center><div align="right" style="width:95%">
	    <a href="'.$excel_href.'" target="_blank"><img src="'.SB_CMS_IMG_URL.'/icon_excel.png" width="20" height="20" border="0" align="absmiddle">&nbsp;'.PL_REDIRECT_404_EXCEL.'</a>
	    &nbsp;&nbsp;&nbsp;
	    <a href="'.$archive_href.'"><img src="'.SB_CMS_IMG_URL.'/icon_archive.png" width="20" height="20" border="0" align="absmiddle">&nbsp;'.PL_REDIRECT_404_ARCHIVE.'</a>
	    </div>
    	<br>'.$num_list.'<br><br>
	    <table width="98%" cellspacing="0" cellpadding="5" class="form">
	    <tr>
	        <th class="header" width="50">
	            &nbsp;
	        </th>
	        <th class="header" width="150">
	            <nobr>
	                &nbsp;'.PL_REDIRECT_404_DATE.'&nbsp;
	            </nobr>
	        </th>
	        <th class="header" width="150">
	            <nobr>
	                &nbsp;'.PL_REDIRECT_404_IP.'&nbsp;
	            </nobr>
	        </th>
	        <th class="header" width="100">
	            <nobr>
	                &nbsp;'.PL_REDIRECT_404_COUNT.'&nbsp;
	            </nobr>
	        </th>
	        <th class="header" width="100">
	            <nobr>
	                &nbsp;'.PL_REDIRECT_404_DOMAIN.'&nbsp;
	            </nobr>
	        </th>
	        <th class="header">
	            <nobr>
	                &nbsp;'.PL_REDIRECT_404_URL.'&nbsp;
	            </nobr>
	        </th>
	    </tr>';

    	/**
         * Вывод таблицы
         */
        $from = ($page - 1) * $pagesCount; // номер точки восстановления с которой нужно начать выводить список
        $to = min($num, $from + $pagesCount);

    	$domains = array();
    	$res = sql_query('SELECT cat_title, cat_left, cat_right FROM sb_categs WHERE cat_ident="pl_redirect" AND cat_level=1');
    	if ($res)
    	{
    		foreach ($res as $value)
    		{
    			list($cat_title, $cat_left, $cat_right) = $value;

    			$domains[$cat_title] = array();
    			$domains[$cat_title]['cat_left'] = $cat_left;
    			$domains[$cat_title]['cat_right'] = $cat_right;
    		}
    	}

        for($i = $from; $i < $to; $i++)
        {
            $l_id = (string) $xml[$i]->l_id;
            $l_date = (string) $xml[$i]->l_date;
            $l_count = (string) $xml[$i]->l_count;
            $l_ip = (string) $xml[$i]->l_ip;
            $l_url = (string) $xml[$i]->l_url;
            $l_domain = (string) $xml[$i]->l_domain;
			$l_idn_domain = $idn->decode($l_idn_domain);

        	$ok = false;
            if (isset($domains[$l_domain]))
            {
	            $res = sql_param_query('SELECT COUNT(*) FROM sb_categs c, sb_catlinks l, sb_redirect r
	            		WHERE c.cat_left >= ?d AND c.cat_right <= ?d AND c.cat_ident="pl_redirect"
	            		AND l.link_cat_id=c.cat_id AND l.link_el_id=r.sr_id
	            		AND r.sr_old_url=?', $domains[$l_domain]['cat_left'], $domains[$l_domain]['cat_right'], '/'.$l_url);

	            if ($res && $res[0][0] > 0)
	            {
	            	$ok = true;
	            }
            }

            echo '<tr'.($i % 2 != 0 ? ' class="even"' : ' class="odd"').'>
                    <td style="text-align:center;">
                        <img src="'.SB_CMS_IMG_URL.'/'.($ok ? 'information' : 'warning').'_log.png" alt="'.($ok ? PL_REDIRECT_404_IMG_TITLE_OK : PL_REDIRECT_404_IMG_TITLE_ERROR).'" title="'.($ok ? PL_REDIRECT_404_IMG_TITLE_OK : PL_REDIRECT_404_IMG_TITLE_ERROR).'" \>
                    </td>
                    <td style="font-size: 10px;text-align: center;">
                        '.sb_date('d.m.Y', $l_date).'<br />'.KERNEL_IN.'<br />'.sb_date('H:i:s', $l_date).'
                    </td>
                    <td style="font-size: 10px;text-align: center;">
                        '.$l_ip.'
                    </td>
                    <td style="font-size: 10px;text-align: center;">
                        <b>'.$l_count.'</b>
                    </td>
                    <td style="font-size: 10px;text-align: center;">
                        <b>'.$l_idn_domain.'</b>
                    </td>
                    <td>
                    	<div class="hint_div"><a href="'.SB_CMS_CONTENT_FILE.'?event=pl_redirect_init&l_id='.$l_id.'">http://'.$l_idn_domain.'/'.$l_url.'</a></div>
            		</td>
                </tr>';
        }

        echo '</table><br>'.$num_list.'<br><br></center>';
    }
    else
    {
    	sb_show_message(PL_REDIRECT_404_NO_MESSAGES, true);
    }

    if ($zip)
    {
    	$GLOBALS['sbVfs']->mLocal = true;
    	$GLOBALS['sbVfs']->delete($tmp_dir);
    	$GLOBALS['sbVfs']->mLocal = false;
    }
}

function fRedirect_404_Archive_Excel()
{
	if (!isset($_GET['file']) || strpos($_GET['file'], 'log404_') !== 0)
    {
    	return;
    }

    $_GET['file'] = preg_replace('/[^a-zA-Z_0-9]/', '', $_GET['file']);

    $file_zip = 'cms/backup/'.$_GET['file'].'.zip';
	$file_xml = 'cms/backup/'.$_GET['file'].'.xml';

	$zip = false;
	$xml = false;

	if ($GLOBALS['sbVfs']->exists($file_zip))
		$zip = true;

	if ($GLOBALS['sbVfs']->exists($file_xml))
		$xml = true;

	if (!$zip && !$xml)
    {
    	return;
    }

    if ($zip)
    {
    	$tmp_id = uniqid();
        $tmp_dir = SB_CMS_TMP_PATH.'/'.$tmp_id;

        $GLOBALS['sbVfs']->mLocal = true;

        if (!$GLOBALS['sbVfs']->exists($tmp_dir))
        {
            if (!$GLOBALS['sbVfs']->mkdir($tmp_dir))
            {
        		$GLOBALS['sbVfs']->mLocal = false;
        		return;
            }
        }

        if (!$GLOBALS['sbVfs']->is_writable($tmp_dir))
        {
            $GLOBALS['sbVfs']->mLocal = false;
            return;
        }

        $file = $tmp_dir.str_replace('cms/backup', '', $file_xml);

        if (function_exists('gzopen64'))
    		$gz = @gzopen64(SB_BASEDIR.'/'.$file_zip, 'rb');
    	else
    		$gz = @gzopen(SB_BASEDIR.'/'.$file_zip, 'rb');

        $fl = $GLOBALS['sbVfs']->fopen($file, 'ab');

        if (!$gz || !$fl)
        {
            $GLOBALS['sbVfs']->delete($tmp_dir);
            if ($fl)
            {
            	$GLOBALS['sbVfs']->delete($file);
            }

            $GLOBALS['sbVfs']->mLocal = false;
            return;
        }

        $GLOBALS['sbVfs']->mLocal = false;

        while (!@gzeof($gz))
        {
        	$str = trim(@gzgets($gz, 4096));
        	$GLOBALS['sbVfs']->fwrite($str);
        }

        @gzclose($gz);
        $GLOBALS['sbVfs']->fclose();
        $GLOBALS['sbVfs']->mLocal = false;
    }
    else
    {
    	$file = SB_BASEDIR.'/'.$file_xml;
    }

    $xml = simplexml_load_file($file);
	$xpath = '/db/sb_404_log';

    $res = sql_param_query('SELECT u_admin, u_domains FROM sb_users WHERE u_id=?d', $_SESSION['sbAuth']->getUserId());
    list($u_admin, $u_domains) = $res[0];

    if ($u_admin != 1)
    {
    	$u_domains = explode(',', $u_domains);
    	$xpath = array();
    	foreach($u_domains as $domain)
    	{
    		$xpath[] = 'l_domain="'.trim($domain).'"';
    	}

    	$xpath = '/db/sb_404_log['.implode(' or ', $xpath).']';
    }

    $xml = $xml->xpath($xpath);

    header('Content-type: application/vnd.ms-excel; charset='.strtolower(SB_CHARSET), true);
    header('Content-Disposition: attachment; filename="sbuilder_404_log.xls"');

    echo '<html>
        <head>
        <title></title>
        <meta http-equiv="Content-Type" content="text/html; charset='.strtolower(SB_CHARSET).'">
        <body>';

    $num = 0;

   	if ($xml)
   	{
    	$num = count($xml); // Всего сообщений
   	}

    if($num > 0)
    {
        /**
         * Вывод таблици
         */
        echo '<table border="1">
              <tr>
                <th width="160">
                    &nbsp;'.PL_REDIRECT_404_DATE.'&nbsp;
                </th>
                <th width="80">
                    &nbsp;'.PL_REDIRECT_404_IP.'&nbsp;
                </th>
                <th width="100">
                    &nbsp;'.PL_REDIRECT_404_COUNT.'&nbsp;
                </th>
                <th width="100">
                    &nbsp;'.PL_REDIRECT_404_DOMAIN.'&nbsp;
                </th>
                <th>
                    &nbsp;'.PL_REDIRECT_404_URL.'&nbsp;
                </th>
             </tr>';

        require_once (SB_CMS_LIB_PATH.'/sbIDN.inc.php');
    	$idn = new sbIDN();

        for($i = 0; $i < $num; $i++)
        {
        	$l_date = (string) $xml[$i]->l_date;
            $l_ip = (string) $xml[$i]->l_ip;
            $l_url = (string) $xml[$i]->l_url;
            $l_domain = (string) $xml[$i]->l_domain;
            $l_count = (string) $xml[$i]->l_count;
			$l_idn_domain = $idn->decode($l_domain);

            echo '<tr>
                    <td align="center" width="160" valign="top">
                        '.sb_date('d.m.Y '.KERNEL_IN.' H:i:s', $l_date).'
                    </td>
                    <td align="center" width="80" valign="top">
                        '.$l_ip.'
                    </td>
                    <td align="center" width="100" valign="top">
                        <b>'.$l_count.'</b>
                    </td>
                    <td align="center" width="100" valign="top">
                        <b>'.$l_idn_domain.'</b>
                    </td>
                    <td valign="top">
                        <a href="http://'.$l_domain.'/'.$l_url.'" target="_blank">http://'.$l_idn_domain.'/'.$l_url.'</a>
                    </td>
                </tr>';
        }

        echo '</table>';
    }

    echo '</body></html>';

	if ($zip)
    {
    	$GLOBALS['sbVfs']->mLocal = true;
    	$GLOBALS['sbVfs']->delete($tmp_dir);
    	$GLOBALS['sbVfs']->mLocal = false;
    }
}
?>