<?php

/*
 * Функции управления файлом robots.txt
 */
function fRobots_Init()
{
	if (isset($_GET['domain']))
	{
		$domain = preg_replace('/[^A-Za-z0-9\-\._]+/'.SB_PREG_MOD, '', $_GET['domain']);
		if(!isset($GLOBALS['sb_domains'][$domain]))
		{
			sb_show_message(PL_ROBOTS_DOMAIN_ERROR, true, 'warning');
			return;
		}
	}
	else
	{
		sb_show_message(PL_ROBOTS_DOMAIN_ERROR, true, 'warning');
		return;
	}
	
	$GLOBALS['sbVfs']->mLocal = true;
	$file_patch = $GLOBALS['sb_domains'][$domain]['basedir'].'/robots.txt';
	$file_patch = str_replace('//', '/', $file_patch);

	if(!$GLOBALS['sbVfs']->is_file($file_patch))
	{
		//Создаю файл если он не существует
		$fp = $GLOBALS['sbVfs']->fopen($file_patch, 'a+');	
		$GLOBALS['sbVfs']->fclose($fp);
	}
	
	$readonly = '';
	if(!$_SESSION['sbPlugins']->isRightAvailable('pl_robots', 'file_edit'))
	{
		$readonly = ' readonly="readonly" ';
	}
	elseif(!$GLOBALS['sbVfs']->is_readable($file_patch))
	{
		sb_show_message(PL_ROBOTS_READ_ERROR, true, 'warning');
		return;
	}
	elseif(!$GLOBALS['sbVfs']->is_writable($file_patch))
	{
		sb_show_message(PL_ROBOTS_WRITE_ERROR, false, 'warning');
		$readonly = ' readonly="readonly" ';
	}
	
	require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
	
	$content = $GLOBALS['sbVfs']->file_get_contents($file_patch);
	
	echo '<div align="center">';
	
	$layout = new sbLayout(SB_CMS_CONTENT_FILE.'?event=pl_robots_submit&domain='.$domain, '', 'post', '', '', 'style="width:95%; margin-top:20px;"');
	$layout->mShowTitle = false;
	
	$layout->addHeader(sprintf(PL_ROBOTS_PLUGIN_NAME.' '.$domain));
	
	$fld = new sbLayoutTextarea($content, 'r_content', 'r_content', 'style="width:100%;height:400px;"'.$readonly);
	$layout->addField('', $fld, '', '', '');
	
	if ($readonly == '')
		$layout->addButton('submit', KERNEL_SAVE, 'btn_save', '', '');
		
	$layout->show();
	
	echo '</div';
}

function fRobots_Edit_Submit()
{
	if(!isset($_POST['r_content']))
	{
		fRobots_Init();
		return;
	}
	
	if (isset($_GET['domain']))
	{
		$domain = preg_replace('/[^A-Za-z0-9\-\._]+/'.SB_PREG_MOD, '', $_GET['domain']);
		if(!isset($GLOBALS['sb_domains'][$domain]))
		{
			sb_show_message(PL_ROBOTS_DOMAIN_ERROR, false, 'warning');
			fRobots_Init();
			return;
		}
	}
	else
	{
		sb_show_message(PL_ROBOTS_DOMAIN_ERROR, false, 'warning');
		fRobots_Init();
		return;
	}
	
	$GLOBALS['sbVfs']->mLocal = true;
	$file_patch = $GLOBALS['sb_domains'][$domain]['basedir'].'/robots.txt';
	$file_patch = str_replace('//', '/', $file_patch);
	
	if(!$GLOBALS['sbVfs']->is_writable($file_patch))
	{
		sb_show_message(PL_ROBOTS_WRITE_ERROR, false, 'warning');
		fRobots_Init();
		return;
	}
	
	$GLOBALS['sbVfs']->file_put_contents($file_patch, $_POST['r_content']);
	
	sb_add_system_message(sprintf(PL_ROBOTS_ADD_SYSTEM_MESAGE_OK, $domain));
	sb_show_message(PL_ROBOTS_MESSAGE_ADD_OK);
	fRobots_Init();
}
?>