<?php
function fRss_Parse_Tags($key)
{
	$result = array('tag1' => '', 'tag2' => '', 'att1' => '', 'att2' => '');
	
	$key = explode(' ', $key);

	if (count($key) > 1)
	{
		$result['tag1'] = $key[0];
		$key[1] = explode('_', $key[1]);
		
		if (count($key[1]) > 1)
		{
			$result['tag2'] = $key[1][0];
			$result['att2'] = $key[1][1];
		}
		else
		{
			$result['tag2'] = $key[1][0];
		}
	}
	else
	{
		$key[0] = explode('_', $key[0]);
		
		if (count($key[0]) > 1)
		{
			$result['tag1'] = $key[0][0];
			$result['att1'] = $key[0][1];
		}
		else
		{
			$result['tag1'] = $key[0][0];
		}
	}
	
	return $result;
}

function fRss_Get_Value($item, $settings)
{
	$settings = fRss_Parse_Tags($settings);
	if (!isset($item->{$settings['tag1']}))
	{
		return false;
	}
	
	$item = $item->{$settings['tag1']};
	
	if (isset($settings['tag2']) && $settings['tag2'] != '')
	{
		if (!isset($item->{$settings['tag2']}))
		{
			return false;
		}	
		
		$item = $item->{$settings['tag2']};
		
		if (isset($settings['att2']) && $settings['att2'] != '')
		{
			if (!isset($item[$settings['att2']]))
			{
				return false;
			}
		
			$item = $item[$settings['att2']];
		}
	}
	elseif (isset($settings['att1']) && $settings['att1'] != '')
	{
		if (!isset($item[$settings['att1']]))
		{
			return false;
		}
		
		$item = $item[$settings['att1']];	 
	}
	
	return (string) $item;	
}

function fRss_Cron_Refresh($id = array())
{
	if (count($id) == 0)
	{
		$res = sql_query('SELECT r_id, r_title, r_url, r_plugin_ident, r_settings FROM sb_rss WHERE r_active=1');
	}
	else 
	{
    	$res = sql_param_query('SELECT r_id, r_title, r_url, r_plugin_ident, r_settings FROM sb_rss WHERE r_id IN (?a) AND r_active=1', $id);
	}
	
    if (!$res)
    	return false;

    $result = array();
    $fields = array();
    
    foreach ($res as $res_value)
    {
	    list($r_id, $r_title, $r_url, $r_plugin_ident, $r_settings) = $res_value;
	
	    if (trim($r_settings) != '')
	    {
	        $r_settings = unserialize($r_settings);
	    }
	
	    if (!$r_settings)
	    {
	    	sql_query('UPDATE sb_rss SET r_error=1 WHERE r_id="'.$r_id.'"');
	    	sb_add_system_message(sprintf(KERNEL_PROG_PL_RSS_PROPS_ERROR, $r_title), SB_MSG_WARNING);
	    	continue;
	    }
	    
		if (!isset($r_settings['el_cat_id']) || !isset($r_settings['el_title']) || !isset($r_settings['el_id']))
		{
			sql_query('UPDATE sb_rss SET r_error=1 WHERE r_id="'.$r_id.'"');
			sb_add_system_message(sprintf(KERNEL_PROG_PL_RSS_PROPS_ERROR, $r_title), SB_MSG_WARNING);
			continue;
		}
				
		$res = sql_param_query('SELECT cat_id FROM sb_categs WHERE cat_id IN (?a) ORDER BY cat_left', explode('^', $r_settings['el_cat_id']));
		if (!$res)
		{
			sql_query('UPDATE sb_rss SET r_error=1 WHERE r_id="'.$r_id.'"');
			sb_add_system_message(sprintf(KERNEL_PROG_PL_RSS_CATS_ERROR, $r_title), SB_MSG_WARNING);
			continue;
		}
				
		$cat_ids = array();
		foreach ($res as $value)
		{
			$cat_ids[] = $value[0];
		}

	    try 
		{
			require_once(SB_CMS_LIB_PATH.'/sbDownload.inc.php');
			
			$http = new sbDownload(trim($r_url));
	    	$xml_str = $http->download();
	    
	    	if ($xml_str)
	    	{
				$rss = simplexml_load_string(preg_replace('/<(\/)?([a-z0-9]+):([a-z0-9]+)/i', '<$1$2-$3', $xml_str));
	    	}
		}
		catch (Exception $e)
		{
			sql_query('UPDATE sb_rss SET r_error=1 WHERE r_id="'.$r_id.'"');
			sb_add_system_message(sprintf(KERNEL_PROG_PL_RSS_READ_ERROR, $r_title, $r_url, $r_url), SB_MSG_WARNING);
			continue;
		}
		
		if (!isset($rss->channel) && !isset($rss->title))
		{
			sql_query('UPDATE sb_rss SET r_error=1 WHERE r_id="'.$r_id.'"');
			sb_add_system_message(sprintf(KERNEL_PROG_PL_RSS_FORMAT_ERROR, $r_title, $r_url, $r_url), SB_MSG_WARNING);
			continue;
		}

		$atom = !isset($rss->channel);
		
		$count = $atom ? (isset($rss->entry) ? count($rss->entry) : 0) : (isset($rss->channel->item) ? count($rss->channel->item) : 0);
		if ($count == 0)
		{
			$result[$r_id] = '0,0';
			continue;
		}
	
		$pm_id = -1;
		
		if ($r_plugin_ident != 'pl_news')
		{
			$pm_id = intval(str_replace('pl_plugin_', '', $r_plugin_ident));
			if ($pm_id <= 0)
			{
				sql_query('UPDATE sb_rss SET r_error=1 WHERE r_id="'.$r_id.'"');
		    	sb_add_system_message(sprintf(KERNEL_PROG_PL_RSS_PROPS_ERROR, $r_title), SB_MSG_WARNING);
		    	continue;
			}
		}
	
		if (!isset($fields[$r_plugin_ident]))
		{
			$fields[$r_plugin_ident] = array();
		
			$res = sql_param_query('SELECT pd_fields FROM sb_plugins_data WHERE pd_plugin_ident=?', $r_plugin_ident);
			if ($res && trim($res[0][0]) != '')
			{
		        $pd_fields = unserialize($res[0][0]);
		        if (!$pd_fields)
		        {
		        	$pd_fields = array();
		        }
			}
			else
			{
				$pd_fields = array();	
			}
		
			foreach($pd_fields as $value)
			{
				$fields[$r_plugin_ident]['user_f_'.$value['id']] = $value['type'];	
			}
		}
		
		$r_error = false;
		$num_import = 0;
		$num_all = 0;
		
		$ar = $atom ? $rss->entry : $rss->channel->item;
		
		foreach($ar as $item)
		{
			$num_all++;
			
			$title = fRss_Get_Value($item, $r_settings['el_title']);
			$ext_id = fRss_Get_Value($item, $r_settings['el_id']);

			if (!$title || !$ext_id)
			{
				$r_error = true;
				continue;
			}
			
			$row = array();
			if ($r_plugin_ident == 'pl_news')
			{
				$res = sql_param_query('SELECT COUNT(*) FROM sb_news WHERE n_ext_id=?', $ext_id);
				if ($res && $res[0][0] > 0)
					continue;
					
				$row['n_title'] = $title;
				$row['n_ext_id'] = $ext_id;
				$row['n_url'] = sb_check_chpu('', '', $title, 'sb_news', 'n_url', 'n_id');
				$row['n_active'] = isset($r_settings['el_active']) && $r_settings['el_active'] == 1 ? 1 : 0;
			}
			else 
			{
				$res = sql_param_query('SELECT COUNT(*) FROM sb_plugins_'.$pm_id.' WHERE p_ext_id=?', $ext_id);
				if ($res && $res[0][0] > 0)
					continue;
					
				$row['p_title'] = $title;
				$row['p_ext_id'] = $ext_id;
				$row['p_url'] = sb_check_chpu('', '', $title, 'sb_plugins_'.$pm_id, 'p_url', 'p_id');
				$row['p_active'] = isset($r_settings['el_active']) && $r_settings['el_active'] == 1 ? 1 : 0;
			}
			
			if (isset($r_settings['el_fields']))
			{
				foreach ($r_settings['el_fields'] as $key => $value)
				{
					if (trim($value) == '')
						continue;
					
					$value = fRss_Get_Value($item, $value);

					if (!$value)
						continue;
						
					if ($key == 'n_date' || (isset($fields[$r_plugin_ident][$key]) && $fields[$r_plugin_ident][$key] == 'date'))
					{
						if (is_numeric($value))
							$row[$key] = $value;
						else 
							$row[$key] = trim($value) != '' ? intval(strtotime($value)) : null;
					}
					else 
					{
						$row[$key] = trim($value) != '' ? $value : null;
					}
				}
			}
			
			$ok = true;
			if ($r_plugin_ident == 'pl_news')
			{
				$ok = sbProgAddElement('sb_news', 'n_id', $row, $cat_ids);
			}
			else
			{
				$ok = sbProgAddElement('sb_plugins_'.$pm_id, 'p_id', $row, $cat_ids);
			}
			
			if (!$ok)
			{
				$r_error = true;
				sb_add_system_message(sprintf(KERNEL_PROG_PL_RSS_ITEM_ADD_ERROR, $title, $r_title), SB_MSG_WARNING);
			}
			else 
			{
				$num_import++;
				sb_add_system_message(sprintf(KERNEL_PROG_PL_RSS_ITEM_ADD_OK, $title, $r_title));
			}
		}

		$row = array();
		$row['r_error'] = $r_error ? 1 : 0;
		$row['r_date'] = time();
		
		sql_param_query('UPDATE sb_rss SET ?a WHERE r_id=?d', $row, $r_id);
		
		if ($r_error)
		{
			sb_add_system_message(sprintf(KERNEL_PROG_PL_RSS_IMPORT_ERROR, $r_title), SB_MSG_WARNING);
		}
		else
		{
			sb_add_system_message(sprintf(KERNEL_PROG_PL_RSS_IMPORT_OK, $r_title));
		}
		
		$result[$r_id] = $num_import.','.$num_all;
    }
    
    return $result;
}
?>