<?php
/**
 * Функции управления RSS-каналами
 */
function fRss_Get($args)
{
	static $plugins_info = false;
	if (!$plugins_info)
	{
		$plugins_info = $_SESSION['sbPlugins']->getPluginsInfo();
	}

	$result = '<b><a href="javascript:void(0);" onclick="sbElemsEdit(event);">'.$args['r_title'].'</a></b>
    <div class="smalltext" style="margin-top: 7px;">'.
	PL_RSS_EDIT_URL.': <a href="'.$args['r_url'].'" target="_blank">'.$args['r_url'].'</a><br />'.
	PL_RSS_GET_PLUGIN.': <span style="color: #CC0066;">'.$plugins_info[$args['r_plugin_ident']]['title'].'</span><br />'.
	PL_RSS_EDIT_ACTIVE.': ';

	if ($args['r_active'] == 1)
	{
		$result .= '<span style="color: green;">'.KERNEL_YES.'</span>';
	}
	else
	{
		$result .= '<span style="color: red;">'.KERNEL_NO.'</span>';
	}

	if (!is_null($args['r_date']))
	{
		$result .= '<br />'.PL_RSS_GET_DATE.': <span style="color: #33805E;">'.sb_date('d.m.Y '.KERNEL_IN.' H:i', $args['r_date']).'</span>';
	}

	if ($args['r_error'] == 1)
	{
		$result .= '<br /><span style="color: red;">'.PL_RSS_GET_ERROR.'</span>';
	}

    $result .= '</div>';

    return $result;
}

function fRss_Init()
{
	require_once(SB_CMS_LIB_PATH.'/sbElements.inc.php');

	$elems = new sbElements('sb_rss', 'r_id', 'r_title', 'fRss_Get', 'pl_rss_init', 'pl_rss');
	$elems->mCategsRootName = PL_RSS_ROOT_NAME;

	$elems->addField('r_active');
	$elems->addField('r_url');
	$elems->addField('r_plugin_ident');
	$elems->addField('r_date');
	$elems->addField('r_error');

	$elems->addFilter(PL_RSS_EDIT_ELEM_EXT_ID, 'r_id', 'number');
	$elems->addFilter(PL_RSS_EDIT_TITLE, 'r_title', 'string');
	$elems->addFilter(PL_RSS_EDIT_URL, 'r_url', 'string');
	$elems->addFilter(PL_RSS_EDIT_ACTIVE, 'r_active', 'checkbox');
	$elems->addFilter(PL_RSS_GET_DATE, 'r_date', 'date');

    $elems->addSorting(PL_RSS_SORT_BY_TITLE,    'r_title');
    $elems->addSorting(PL_RSS_SORT_BY_URL,      'r_url');
    $elems->addSorting(PL_RSS_SORT_BY_ACTIVE,   'r_active');
    $elems->addSorting(PL_RSS_SORT_BY_PLUGIN,   'r_plugin_ident');
    $elems->addSorting(PL_RSS_SORT_BY_DATE, 	'r_date');

    $elems->mCategsPasteElemsMenuTitle = PL_RSS_CATEGS_PASTE_ELEMS_MENU_TITLE;
    $elems->mElemsAddMenuTitle  = PL_RSS_ELEMS_ADD_MENU_TITLE;
    $elems->mElemsEditMenuTitle = PL_RSS_ELEMS_EDIT_MENU_TITLE;
    $elems->mElemsCopyMenuTitle = PL_RSS_ELEMS_COPY_MENU_TITLE;
    $elems->mElemsCutMenuTitle  = PL_RSS_ELEMS_CUT_MENU_TITLE;

	$elems->mCategsDeleteWithElementsMenu = true;

    $elems->mElemsEditEvent = 'pl_rss_edit';
    $elems->mElemsEditDlgWidth = 800;
	$elems->mElemsEditDlgHeight = 700;

	$elems->mElemsAddEvent = 'pl_rss_edit';
    $elems->mElemsAddDlgWidth = 800;
	$elems->mElemsAddDlgHeight = 700;

	$elems->mCategsUrl = false;
	$elems->mCategsFields = false;
	$elems->mElemsUseLinks = false;

	if ($_SESSION['sbPlugins']->isRightAvailable('pl_rss', 'elems_edit'))
	{
		$elems->mElemsJavascriptStr .= '
            function rssSetActive()
            {
            	var ids = "0";
                for (var i = 0; i < sbSelectedEls.length; i++)
			    {
			        var el = sbGetE("el_" + sbSelectedEls[i]);
			        if (el)
			            ids += "," + el.getAttribute("el_id");
			    }

                var res = sbLoadSync("'.SB_CMS_EMPTY_FILE.'?event=pl_rss_set_active&ids=" + ids);
                if (res != "TRUE")
                {
                    alert("'.PL_RSS_SHOWHIDE_ERROR.'");
                    return;
                }

                var div_el = sbGetE("elems_list_div");
                var from = "";
                if (div_el)
                {
                    from = div_el.getAttribute("from");
                }
                var url = sb_cms_empty_file + "?event=" + sb_elems_event + "&id=" + sbCatTree.getSelectedItemId() + "&page_elems=" + from;
                sbElemsShow(url);
            }';

        $elems->addElemsMenuItem(PL_RSS_SHOWHIDE_MENU, 'rssSetActive();');
	}

	if ($_SESSION['sbPlugins']->isRightAvailable('pl_rss', 'elems_refresh'))
	{
		$elems->mElemsJavascriptStr .= '
            function rssRefresh()
            {
            	var ids = "0";
                for (var i = 0; i < sbSelectedEls.length; i++)
			    {
			        var el = sbGetE("el_" + sbSelectedEls[i]);
			        if (el)
			            ids += "," + el.getAttribute("el_id");
			    }

			    sbShowMsgDiv("'.PL_RSS_REFRESH_MSG.'", "loading.gif", false);
			    sbShowDisDiv();
                sbLoadAsync("'.SB_CMS_EMPTY_FILE.'?event=pl_rss_refresh&ids=" + ids, afterRssRefresh);
            }

            function afterRssRefresh(res)
            {
            	sbHideMsgDiv();
            	sbHideDisDiv();
            	if (!res)
                {
                    alert("'.PL_RSS_REFRESH_ERROR.'");
                    return;
                }

				sbShowMsgDiv(res, "information.png", false);
            }

            function afterRssRefreshClick()
            {
            	var div_el = sbGetE("elems_list_div");
                var from = "";
                if (div_el)
                {
                    from = div_el.getAttribute("from");
                }
                var url = sb_cms_empty_file + "?event=" + sb_elems_event + "&id=" + sbCatTree.getSelectedItemId() + "&page_elems=" + from;
                sbElemsShow(url);
            }
            ';

        $elems->addElemsMenuItem(PL_RSS_REFRESH_MENU, 'rssRefresh();');
	}

    $elems->init();
}

function fRss_Edit()
{
	// проверка прав доступа
	if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'], 'pl_rss'))
		return;

	if (count($_POST) == 0 && isset($_GET['id']) && $_GET['id'] != '')
	{
   		$result = sql_param_query('SELECT r_title, r_active, r_url FROM sb_rss WHERE r_id=?d', $_GET['id']);

   		if ($result)
	    {
        	list($r_title, $r_active, $r_url) = $result[0];
	    }
	    else
	    {
	        sb_show_message(PL_RSS_EDIT_ERROR, true, 'warning');
	        return;
	    }
	}
	elseif (count($_POST) > 0)
	{
		$r_active = 0;

    	extract($_POST);
    	if (!isset($_GET['id']))
            $_GET['id'] = '';
	}
	else
	{
	    $r_title = $r_url = '';
	    $r_active = 1;

	    $_GET['id'] = '';
	}

	echo '<script>
		var info_tab_url = "";
		var prop_tab_url = "";
		var cur_tab = -1;
		var keys = "";
		var edit = '.($_GET['id'] != '' ? 'true' : 'false').';

		var old_cat_el_value = "";
        var old_text_el_value = "";
        var old_cat_cat_el_value = "";
        var old_ident_el_value = "";

        function checkValues()
        {
            if (sbGetE("r_title").value == "")
            {
               alert("'.PL_RSS_EDIT_NO_TITLE_MSG.'");
               return false;
            }

            if (sbGetE("r_url").value == "")
            {
               alert("'.PL_RSS_EDIT_NO_URL_MSG.'");
               return false;
            }

            var el_ident = sbGetE("r_plugin_ident");
            var el_cat_id = sbGetE("r_settings_cat_id");

            if (!edit && (!el_ident || !el_cat_id || el_cat_id.value == ""))
            {
                 if (!el_ident || !el_cat_id)
                 {
                 	 alert("'.PL_RSS_EDIT_NO_PROPS_MSG.'");
                 }
                 else if(el_cat_id.value == "")
                 {
                     alert("'.PL_RSS_EDIT_NO_CATS_MSG.'");
                 }
                   return false;
            }

            if (edit && el_cat_id && el_cat_id.value == "")
            {
                alert("'.PL_RSS_EDIT_NO_CATS_MSG.'");
                return false;
            }
        }

        function sbTabCheck(tab)
    	{
    		if (tab == 1 || tab == 2)
    		{
	    	    if (sbGetE("r_url").value == "")
	    	    {
	    	        alert("'.PL_RSS_EDIT_NO_URL_MSG.'");
	    	    	return false;
	    	    }

	    	    if ((tab == 1 && info_tab_url != sbGetE("r_url").value) || (tab == 2 && prop_tab_url != sbGetE("r_url").value))
		    	{
		    	    sbGetE("sb_tab" + tab).innerHTML = \''.sb_show_message(KERNEL_LOADING, true, 'loading', true).'\';
		    	    cur_tab = tab;

					sbLoadAsync("'.SB_CMS_EMPTY_FILE.'?event=" + (tab == 1 ? "pl_rss_get_channel_info" : "pl_rss_get_channel_props") + "&url=" + encodeURIComponent(sbGetE("r_url").value) + "&id='.$_GET['id'].'", sbAfterLoadInfo);
		    	}
    	    }

    	    return true;
    	}

    	function sbAfterLoadInfo(res)
    	{
    		if(res != "")
	        {
	            sbGetE("sb_tab" + cur_tab).innerHTML = res;
	            if (cur_tab == 1)
	            	info_tab_url = sbGetE("r_url").value;
	            else
	            	prop_tab_url = sbGetE("r_url").value;
	        }
	        else
	        {
	            sbGetE("sb_tab" + cur_tab).innerHTML = \''.sb_show_message(PL_RSS_EDIT_CHANNEL_ERROR, true, 'warning', true).'\';
	        }
    	}

    	function changeIdent(el)
        {
            var cat_el = sbGetE("r_settings_cat_id");
            var text_el = sbGetE("r_settings_cat_id_text");
            var cat_cat_el = sbGetE("r_settings_cat_id_cat");
            var ident_el = sbGetE("r_settings_cat_id_ident");

            if (el.value == old_ident_el_value)
            {
	            cat_el.value = old_cat_el_value;
	            text_el.innerHTML = old_text_el_value;
	            cat_cat_el.value = old_cat_cat_el_value;
            }
            else
            {
            	cat_el.value = "";
	            text_el.innerHTML = "<b style=\'font-size:11px;\'>'.SB_LAYOUT_NO_CATEG.'</b>";
	            cat_cat_el.value = "";
            }
            ident_el.value = el.value;

            sbGetE("fields").innerHTML = \''.sb_show_message(KERNEL_LOADING, true, 'loading', true).'\';
            sbLoadAsync("'.SB_CMS_EMPTY_FILE.'?event=pl_rss_get_fields&ident=" + el.value + "&keys=" + keys + "&id='.$_GET['id'].'", sbAfterLoadFields);
        }

        function sbAfterLoadFields(res)
    	{
    		sbGetE("fields").innerHTML = res;
    	}
	</script>';

	require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

	$layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE.'?event=pl_rss_edit_submit'.($_SERVER['QUERY_STRING'] != '' ? '&'.$_SERVER['QUERY_STRING'] : ''), 'thisDialog', 'post', 'checkValues()');
	$layout->mTableWidth = '95%';
	$layout->mTitleWidth = '150';

	$layout->addTab(PL_RSS_EDIT_TAB1);
	$layout->addHeader(PL_RSS_EDIT_TAB1);

	$layout->addField(PL_RSS_EDIT_TITLE, new sbLayoutInput('text', $r_title, 'r_title', '', 'style="width:500px;"', true));
	$layout->addField(PL_RSS_EDIT_URL, new sbLayoutInput('text', $r_url, 'r_url', '', 'style="width:500px;"', true));

	$layout->addField('', new sbLayoutDelim());

	$layout->addField(PL_RSS_EDIT_ACTIVE, new sbLayoutInput('checkbox', '1', 'r_active', '', ($r_active == 1 ? ' checked="checked"' : '')));

	$layout->addTab(PL_RSS_EDIT_TAB2);

	$layout->addTab(PL_RSS_EDIT_TAB3);

    $layout->addButton('submit', KERNEL_SAVE, 'btn_save', '', ($_SESSION['sbPlugins']->isRightAvailable('pl_rss', 'elems_edit') ? '' : 'disabled="disabled"'));
    $layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog()"');

    $layout->show();
}

function fRss_Get_Channel_Info()
{
	require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

	if (!isset($_GET['url']) || trim($_GET['url']) == '')
	{
		return;
	}

	try
	{
    	$rss = new SimpleXMLElement(trim($_GET['url']), null, true);
	}
	catch (Exception $e)
	{
		return;
	}

	if (!isset($rss->channel) && !isset($rss->title))
	{
		return;
	}

	$atom = !isset($rss->channel);

	$layout = new sbLayout();
	$layout->mTableWidth = '95%';
	$layout->mTitleWidth = '150';

	$layout->addHeader(PL_RSS_EDIT_TAB2);

	if ($atom)
	{
		$layout->addField(PL_RSS_GET_INFO_VERSION, new sbLayoutLabel('atom'));
	}
	elseif (isset($rss['version']))
	{
		$layout->addField(PL_RSS_GET_INFO_VERSION, new sbLayoutLabel($rss['version']));
	}

	$delim = false;

	if (($atom && isset($rss->title) && (string) $rss->title != '') || (!$atom && isset($rss->channel->title) && (string) $rss->channel->title != ''))
	{
		$title = $atom ? (string) $rss->title : (string) $rss->channel->title;
		$title = SB_CHARSET == 'UTF-8' ? $title : iconv('UTF-8', SB_CHARSET.'//IGNORE', $title);
		$fld = new sbLayoutLabel('<b>'.$title.'</b>', '', '', false);
		$fld->mHint = true;
		$layout->addField(PL_RSS_GET_INFO_TITLE, $fld);

		$delim = true;
	}

	if (($atom && isset($rss->subtitle) && (string) $rss->subtitle != '') || (!$atom && isset($rss->channel->description) && (string) $rss->channel->description != ''))
	{
		$descr = $atom ? (string) $rss->subtitle : (string) $rss->channel->description;
		$descr = SB_CHARSET == 'UTF-8' ? $descr : iconv('UTF-8', SB_CHARSET.'//IGNORE', $descr);
		$fld = new sbLayoutLabel($descr, '', '', false);
		$fld->mHint = true;
		$layout->addField(PL_RSS_GET_INFO_DESCR, $fld);

		$delim = true;
	}

	if ($delim)
	{
		$layout->addField('', new sbLayoutDelim());
	}

	if (($atom && isset($rss->logo) && (string) $rss->logo != '') || (!$atom && isset($rss->channel->image) && (string) $rss->channel->image->url != ''))
	{
		$fld = new sbLayoutHTML('<img src="'.($atom ? (string) $rss->logo : (string) $rss->channel->image->url).'" /><br /><br />');
		$fld->mHint = true;
		$layout->addField(PL_RSS_GET_INFO_IMAGE, $fld);

		$layout->addField('', new sbLayoutDelim());
	}

	if (($atom && isset($rss->link) && (string) $rss->link['href'] != '') || (!$atom && isset($rss->channel->link) && (string) $rss->channel->link != ''))
	{
		$layout->addField(PL_RSS_GET_INFO_LINK, new sbLayoutLabel('<a href="'.($atom ? (string) $rss->link['href'] : (string) $rss->channel->link).'" target="_blank">'.($atom ? (string) $rss->link['href'] : (string) $rss->channel->link).'</a>', '', '', false));
	}

	if (($atom && isset($rss->updated) && (string) $rss->updated != '') || (!$atom && isset($rss->channel->lastBuildDate) && (string) $rss->channel->lastBuildDate != ''))
	{
		$layout->addField(PL_RSS_GET_INFO_LASTBUILDDATE, new sbLayoutLabel(sb_date('d.m.Y '.KERNEL_IN.' H:i', strtotime($atom ? (string) $rss->updated : (string) $rss->channel->lastBuildDate))));
	}

	if (!$atom && isset($rss->channel->language) && (string) $rss->channel->language != '')
	{
		$layout->addField(PL_RSS_GET_INFO_LANGUAGE, new sbLayoutLabel((string) $rss->channel->language));
	}

	if (($atom && isset($rss->generator) && (string) $rss->generator != '') || (!$atom && isset($rss->channel->generator) && (string) $rss->channel->generator != ''))
	{
		$layout->addField(PL_RSS_GET_INFO_GENERATOR, new sbLayoutLabel($atom ? (string) $rss->generator : (string) $rss->channel->generator));
	}

	$layout->show();
}

function fRss_Get_Channel_Props()
{
	require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

	$_GET['url'] = urldecode($_GET['url']);
	if (!isset($_GET['url']) || trim($_GET['url']) == '')
		return;

	try
	{
		require_once(SB_CMS_LIB_PATH.'/sbDownload.inc.php');

		$http = new sbDownload(trim($_GET['url']));
    	$xml_str = $http->download();

    	if ($xml_str)
    	{
			$rss = simplexml_load_string(preg_replace('/<(\/)?([a-z0-9]+):([a-z0-9]+)/i', '<$1$2-$3', $xml_str));
		}
	}
	catch (Exception $e)
	{
		return;
	}

	if ((!isset($rss->channel) || !isset($rss->channel->item) || !isset($rss->channel->item[0])) && (!isset($rss->title) || !isset($rss->entry) || !isset($rss->entry[0])))
	{
		return;
	}

	$atom = !isset($rss->channel);

	$r_settings = array();
	$r_plugin_ident = 'pl_news';
	if (isset($_GET['id']) && trim($_GET['id']) != '')
	{
		$res = sql_param_query('SELECT r_plugin_ident, r_settings FROM sb_rss WHERE r_id=?d', $_GET['id']);
		if ($res)
		{
			list($r_plugin_ident, $r_settings) = $res[0];

			if (trim($r_settings) != '')
	        	$r_settings = unserialize($r_settings);
		    else
		        $r_settings = array();
		}
	}
	elseif(!isset($r_settings['el_active']))
	{
		$r_settings['el_active'] = 1;
	}

	$layout = new sbLayout();
	$layout->mTableWidth = '95%';
	$layout->mTitleWidth = '200';

	$layout->addHeader(PL_RSS_EDIT_TAB3);

	$item_info = '';
	$keys = array();

	$ar = $atom ? $rss->entry[0] : $rss->channel->item[0];
	foreach ($ar as $key => $value)
	{
		$keys[$key] = $key;

		$attrs = '';
		foreach ($value->attributes() as $atName => $atVal)
		{
			$keys[$key.'_'.$atName] = '&nbsp;&nbsp;'.$atName;

			$attrs .= ' '.$atName.'="'.$atVal.'"';
		}

		$item_info .= '<span style="color:green;">&lt;'.$key.$attrs.'&gt;</span>';

		foreach ($value->children() as $key2 => $value2)
		{
			$keys[$key.' '.$key2] = '&nbsp;&nbsp;'.$key2;

			$attrs = '';
			foreach ($value2->attributes() as $atName => $atVal)
			{
				$keys[$key.' '.$key2.'_'.$atName] = '&nbsp;&nbsp;&nbsp;&nbsp;'.$key2.' '.$atName;

				$attrs .= ' '.$atName.'="'.$atVal.'"';
			}

			$value2 = strip_tags(SB_CHARSET == 'UTF-8' ? (string) $value2 : iconv('UTF-8', SB_CHARSET.'//IGNORE', (string) $value2));
			$item_info .= '<br />&nbsp;&nbsp;&nbsp;<span style="color:green;">&lt;'.$key2.$attrs.'&gt;</span>'.$value2.'<span style="color:green;">&lt;'.$key2.'&gt;</span><br />';
		}

		$value = strip_tags(SB_CHARSET == 'UTF-8' ? (string) $value : iconv('UTF-8', SB_CHARSET.'//IGNORE', (string) $value));
		$item_info .= $value.'<span style="color:green;">&lt;'.$key.'&gt;</span><br /><br />';
	}

	echo '<script>
		keys = "'.implode('|', array_keys($keys)).'";
	</script>
	<div class="hint_div" style="width:95%; text-align:left;">'.$item_info.'</div><br />';

	$plugins = array('pl_news' => PL_NEWS_H_PLUGIN_NAME);
	if ($_SESSION['sbPlugins']->isPluginAvailable('pl_plugin_maker'))
	{
		$res = sql_query('SELECT pm_id, pm_title FROM sb_plugins_maker ORDER BY pm_id');
		if ($res)
		{
			foreach ($res as $value)
			{
				$plugins['pl_plugin_'.$value[0]] = $value[1];
			}
		}
	}

	$fld = new sbLayoutSelect($plugins, 'r_plugin_ident', '', 'onkeydown="changeIdent(this);" onchange="changeIdent(this);"');
	$fld->mSelOptions = array($r_plugin_ident);
	$layout->addField(PL_RSS_EDIT_PLUGIN, $fld);

	$fld = new sbLayoutCategs(($r_plugin_ident != '' ? $r_plugin_ident : 'pl_news'), '', (isset($r_settings['el_cat_id']) ? $r_settings['el_cat_id'] : ''), 'r_settings[el_cat_id]', 'r_settings_cat_id', '', true);
    $fld->mHTML = '<br />';
    $fld->mDropButton = false;
    $fld->mMultiSelect = true;

    $layout->addField(PL_RSS_EDIT_CAT, $fld);

    $layout->addField('', new sbLayoutDelim());

    $fld = new sbLayoutSelect($keys, 'r_settings[el_title]');
    $fld->mSelOptions = isset($r_settings['el_title']) ? array($r_settings['el_title']) : array('title');
    $layout->addField(PL_RSS_EDIT_ELEM_TITLE, $fld);

    $fld = new sbLayoutSelect($keys, 'r_settings[el_id]');
    $fld->mSelOptions = isset($r_settings['el_id']) ? array($r_settings['el_id']) : ($atom ? array('id') : array('guid'));
    $layout->addField(PL_RSS_EDIT_ELEM_EXT_ID, $fld);

    $layout->addField(PL_RSS_EDIT_ELEM_ACTIVE, new sbLayoutInput('checkbox', '1', 'r_settings[el_active]', '', (isset($r_settings['el_active']) && $r_settings['el_active'] == 1 ? 'checked="checked"' : '')));

    $layout->addField('', new sbLayoutDelim());

    $layout->addField(PL_RSS_EDIT_ELEM_FIELDS, new sbLayoutHTML('<div id="fields">'.fRss_Get_Fields($r_plugin_ident, $keys, $r_settings).'</div>'));

	$layout->show();

	echo '<script>
	function setOldValues()
	{
	    if (old_ident_el_value == "")
	    {
			old_cat_el_value = sbGetE("r_settings_cat_id").value;
			old_text_el_value = sbGetE("r_settings_cat_id_text").innerHTML;
			old_cat_cat_el_value = sbGetE("r_settings_cat_id_cat").value;
	    	old_ident_el_value = sbGetE("r_settings_cat_id_ident").value;
	    }
	}
	setTimeout("setOldValues()", 1);
	</script>';
}

function fRss_Get_Fields($pl_ident = '', $keys = array(), $r_settings = array())
{
	$result = '';
	$echo = false;
	if ($pl_ident == '')
	{
		if (!isset($_GET['ident']) || !isset($_GET['keys']))
			return $result;

		$echo = true;
		$pl_ident = trim($_GET['ident']);
		if ($pl_ident == '')
			return $result;

		$keys = explode('|', $_GET['keys']);
	}

	if (isset($_GET['id']))
	{
		$res = sql_param_query('SELECT r_settings FROM sb_rss WHERE r_id=?d AND r_plugin_ident=?', $_GET['id'], $pl_ident);
		if ($res)
		{
			list($r_settings) = $res[0];

			if (trim($r_settings) != '')
				$r_settings = unserialize($r_settings);
			else
				$r_settings = array();
		}
	}

	if ($pl_ident == 'pl_news')
	{
		$fields = array('n_date' => PL_RSS_GET_FIELDS_NEWS_DATE,
		  			    'n_short' => PL_RSS_GET_FIELDS_NEWS_SHORT,
						'n_full' => PL_RSS_GET_FIELDS_NEWS_FULL);
	}
	else
	{
		$fields = array();
	}

	$res = sql_param_query('SELECT pd_fields FROM sb_plugins_data WHERE pd_plugin_ident=?', $pl_ident);

	if ($res && trim($res[0][0]) != '')
    {
        $pd_fields = unserialize($res[0][0]);
    	if ($pd_fields && count($pd_fields) > 0)
        {
            foreach ($pd_fields as $value)
        	{
            	switch($value['type'])
            	{
            		case 'string':
            		case 'text':
            		case 'longtext':
            		case 'date':
	            		$fields['user_f_'.$value['id']] = $value['title'];
	            		break;
            	}
        	}
        }
    }

    if (count($fields) > 0)
    {
    	$options = '<option value=""> --- </option>';
    	foreach ($keys as $key => $value)
	    {
	    	if ($echo)
	    	{
		    	$count = 0;

		    	$val = explode(' ', $value);
		    	$val[0] = explode('_', $val[0]);
		    	$count += count($val[0]);

		    	if (isset($val[1]))
		    	{
		    		$val[1] = explode('_', $val[1]);
		    		$count += count($val[1]);
		    	}

		    	switch ($count)
		    	{
		    		case 1:
		    			$val = $val[0][0];
		    			break;

		    		case 2:
		    			$val = '&nbsp;&nbsp;'.(isset($val[1]) ? $val[1][0] : $val[0][1]);
		    			break;

		    		case 3:
		    			$val = '&nbsp;&nbsp;&nbsp;&nbsp;'.$val[1][0].' '.$val[1][1];
		    			break;

		    		default:
		    			$val = '';
		    			break;
		    	}

		    	$options .= '<option value="'.$value.'">'.$val.'</option>';
	    	}
	    	else
	    	{
	    		$options .= '<option value="'.$key.'">'.$value.'</option>';
	    	}
	    }

	    $result = '<table>';

	    foreach ($fields as $key => $value)
	    {
	    	$real_options = $options;
	    	if (isset($r_settings['el_fields']) && isset($r_settings['el_fields'][$key]))
	    	{
	    		$real_options = sb_str_replace('value="'.$r_settings['el_fields'][$key].'"', 'value="'.$r_settings['el_fields'][$key].'" selected="selected"', $real_options);
	    	}

		    $result .= '<tr><td>'.$value.':&nbsp;&nbsp;</td><td><select name="r_settings[el_fields]['.$key.']>">'.$real_options.'</select></td><tr>
		    			<tr><td class="delim" colspan="2"></td></tr>';
	    }

	    $result .= '</table>';
    }

    if ($result == '')
    {
    	$result = sb_show_message(PL_RSS_GET_FIELDS_ERROR, true, 'information', true);
    }

    if ($echo)
    	echo $result;
    else
    	return $result;
}

function fRss_Edit_Submit()
{
	// проверка прав доступа
	if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'], 'pl_rss'))
		return;

	if (!isset($_GET['id']))
    	$_GET['id'] = '';

    $r_active = 0;
    extract($_POST);

    if (trim($r_title) == '')
    {
        sb_show_message(PL_RSS_EDIT_NO_TITLE_MSG, false, 'warning');
        fRss_Edit();
        return;
    }

    if (trim($r_url) == '')
    {
        sb_show_message(PL_RSS_EDIT_NO_URL_MSG, false, 'warning');
        fRss_Edit();
        return;
    }

    if ($_GET['id'] == '' && (!isset($r_settings) || !isset($r_plugin_ident) || (!isset($r_settings['el_cat_id']))))
    {
    	sb_show_message(PL_RSS_EDIT_NO_PROPS_MSG, false, 'warning');
        fRss_Edit();
        return;
    }

    $r_active = intval($r_active);

    $row['r_title'] = strip_tags($r_title);
    $row['r_active'] = $r_active;
    $row['r_url'] = trim($r_url);

    if (isset($r_plugin_ident))
    	$row['r_plugin_ident'] = $r_plugin_ident;

    if (isset($r_settings))
    	$row['r_settings'] = serialize($r_settings);

    if ($_GET['id'] != '')
	{
	    $res = sql_param_query('SELECT r_title, r_url, r_date, r_error, r_plugin_ident FROM sb_rss WHERE r_id=?d', $_GET['id']);
	    if ($res)
	    {
	        // редактирование
	        list($old_title, $old_url, $old_date, $old_error, $old_plugin_ident) = $res[0];

	        if (trim($r_url) != $old_url)
    	    {
    	    	$row['r_date'] = null;
    	    	$row['r_error'] = 0;
    	    }
    	    else
    	    {
    	    	$row['r_date'] = $old_date;
    	    	$row['r_error'] = $old_error;
    	    }

    	    if (!isset($r_plugin_ident))
    	    {
    	    	$row['r_plugin_ident'] = $old_plugin_ident;
    	    }

    	    sql_param_query('UPDATE sb_rss SET ?a WHERE r_id=?d', $row, $_GET['id'], sprintf(PL_RSS_EDIT_OK, $old_title));

            $footer_ar = fCategs_Edit_Elem();

    	    if (!$footer_ar)
    	    {
    	        sb_show_message(PL_RSS_EDIT_ERROR, false, 'warning');
                sb_add_system_message(sprintf(PL_RSS_EDIT_SYSTEMLOG_ERROR, $old_title), SB_MSG_WARNING);

                fRss_Edit();
    		    return;
    	    }
    	    $footer_str = $GLOBALS['sbSql']->escape($footer_ar[0], false, false);
    	    $footer_link_str = $GLOBALS['sbSql']->escape($footer_ar[1], false, false);

    	    $row['r_id'] = intval($_GET['id']);

            $html_str = fRss_Get($row);
    	    $html_str = sb_str_replace(array("\r\n", "\r", "\n"), '', $html_str);
            $html_str = $GLOBALS['sbSql']->escape($html_str, false, false);

    	    echo '<script>
        		    var res = new Object();
        		    res.html = "'.$html_str.'";
        		    res.footer = "'.$footer_str.'";
        		    res.footer_link = "'.$footer_link_str.'";
        			sbReturnValue(res);
        		  </script>';
	    }
	    else
	    {
	        sb_show_message(PL_RSS_EDIT_ERROR, false, 'warning');
            sb_add_system_message(sprintf(PL_RSS_EDIT_SYSTEMLOG_ERROR, $r_title), SB_MSG_WARNING);

            fRss_Edit();
		    return;
	    }
	}
	else
	{
	    $error = true;
	    if (sql_param_query('INSERT INTO sb_rss SET ?a', $row))
	    {
    		$id = sql_insert_id();

    		if (fCategs_Add_Elem($id))
    		{
        		sb_add_system_message(sprintf(PL_RSS_ADD_OK, $r_title));

        		echo '<script>
        				sbReturnValue('.$id.');
        			  </script>';

        		$error = false;
    		}
    		else
    		{
    		    sql_query('DELETE FROM sb_rss WHERE r_id="'.$id.'"');
    		}
	    }

	    if ($error)
	    {
	        sb_show_message(PL_RSS_ADD_ERROR, false, 'warning');
            sb_add_system_message(sprintf(PL_RSS_ADD_SYSTEMLOG_ERROR, $r_title), SB_MSG_WARNING);

            fRss_Edit();
		    return;
	    }
	}
}

function fRss_Set_Active()
{
	if(isset($_GET['ids']) && $_GET['ids'] != '')
	{
	    $res = sql_query('SELECT r_id, r_title, r_active FROM sb_rss WHERE r_id IN ('.preg_replace('/[^0-9,]+/'.SB_PREG_MOD, '', $_GET['ids']).')');
	    if ($res)
	    {
	    	$date = time();
	    	foreach ($res as $value)
	    	{
		        list($r_id, $r_title, $r_active) = $value;

		        sql_query('UPDATE sb_rss SET r_active="'.($r_active == 1 ? 0 : 1).'" WHERE r_id="'.$r_id.'"', sprintf(PL_RSS_EDIT_OK, $r_title));
		        sql_param_query('INSERT INTO sb_catchanges (el_id, cat_ident, change_date, change_user_id, action) VALUES (?d, "pl_rss", ?d, ?d, "edit")', $r_id, $date, $_SESSION['sbAuth']->getUserId());
	    	}

	    	echo 'TRUE';
	    }
	}
}

function fRss_Refresh()
{
	if (!isset($_GET['ids']) || trim($_GET['ids']) == '')
		return;

	require_once SB_CMS_LIB_PATH.'/prog/sbFunctions.inc.php';
	require_once SB_CMS_PL_PATH.'/pl_rss/cron/pl_rss.php';
	$result = fRss_Cron_Refresh(explode(',', $_GET['ids']));

	if ($result)
	{
		$res = sql_param_query('SELECT r_id, r_title FROM sb_rss WHERE r_id IN (?a)', array_keys($result));

		$r_title = array();
		foreach ($res as $value)
		{
			$r_title[$value[0]] = $value[1];
		}

		$message = PL_RSS_REFRESH_RESULTS.':<br /><br /><div class="smalltext" style="text-align:left;">';

		foreach ($result as $key => $value)
		{
			$value = explode(',', $value);
			$message .= '<b>'.$r_title[$key].'</b> - <i>'.$value[0].'</i> '.PL_RSS_REFRESH_FROM.' <i>'.$value[1].'</i> '.PL_RSS_REFRESH_ELEMS.'<br />';
		}

		$message .= '</div><br />'.PL_RSS_REFRESH_DETAILS;

		echo $message;
	}
}

?>