<?php
require_once(SB_CMS_LANG_PATH.'/pl_search.h.lng.php');

if ($_SESSION['sbPlugins']->register('pl_search', PL_SEARCH_H_PLUGIN_NAME, ''))
{
	$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.PL_SEARCH_H_PLUGIN_NAME, 'init');

	if ($_SESSION['sbPlugins']->isRightAvailable('pl_search', 'design_read'))
    {
		$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_SEARCH_H_PLUGIN_NAME.'>'.PL_SEARCH_H_DESIGN_FORM_SEARCH , 'design_form', 'pl_search_form_search_24.png');
		$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_SEARCH_H_PLUGIN_NAME.'>'.PL_SEARCH_H_DESIGN_RESULT_SEARCH , 'design_results', 'pl_search_results_24.png');
	}

	$_SESSION['sbPlugins']->addUserEvent('init', 'fSearch_Init', 'read', PL_SEARCH_H_PLUGIN_NAME);
	$_SESSION['sbPlugins']->addUserEvent('edit', 'fSearch_Edit', 'read', PL_SEARCH_H_EDIT_ELEMENT);
	$_SESSION['sbPlugins']->addUserEvent('submit', 'fSearch_Submit', 'elems_edit', PL_SEARCH_H_EDIT_ELEMENT);
	$_SESSION['sbPlugins']->addUserEvent('delete', 'fSearch_Delete', 'delete');

	$_SESSION['sbPlugins']->addUserEvent('indexing_log', 'fSearch_Indexing_Log', 'read', PL_SEARCH_H_EDIT_INDEXING_LOG);
	$_SESSION['sbPlugins']->addUserEvent('clear_indexing_log', 'fSearch_Clear_Indexing_Log', 'delete');

	$_SESSION['sbPlugins']->addUserEvent('design_form', 'fSearch_Design_Form_Init', 'design_read', PL_SEARCH_H_DESIGN_FORM_SEARCH);
	$_SESSION['sbPlugins']->addUserEvent('design_form_edit', 'fSearch_Design_Form_Edit', 'design_read', PL_SEARCH_H_DESIGN_FORM_EDIT);
	$_SESSION['sbPlugins']->addUserEvent('design_form_submit', 'fSearch_Design_Form_Submit', 'design_edit', PL_SEARCH_H_DESIGN_FORM_EDIT);
	$_SESSION['sbPlugins']->addUserEvent('design_form_delete', 'fSearch_Design_Form_Delete', 'design_edit');

	$_SESSION['sbPlugins']->addUserEvent('design_results', 'fSearch_Design_Results_Init', 'design_read', PL_SEARCH_H_DESIGN_RESULT_SEARCH);
	$_SESSION['sbPlugins']->addUserEvent('design_results_edit', 'fSearch_Design_Results_Edit', 'design_read', PL_SEARCH_H_DESIGN_RESULT_EDIT);
	$_SESSION['sbPlugins']->addUserEvent('design_results_submit', 'fSearch_Design_Results_Submit', 'design_edit', PL_SEARCH_H_DESIGN_RESULT_EDIT);
	$_SESSION['sbPlugins']->addUserEvent('design_results_delete', 'fSearch_Design_Results_Delete', 'design_edit');

	$old_ss_domains = '';
	foreach($GLOBALS['sb_domains'] as $key => $value)
	{
		$res = sql_query('SELECT ss_id, ss_domains FROM sb_search WHERE CONCAT(",", ss_domains, ",") LIKE "%,'.$key.',%" OR CONCAT(",", ss_domains, ",") LIKE "%,www.'.$key.',%"');
		if(!$res)
			continue;

		list($ss_id, $ss_domains) = $res[0];

		if(($old_ss_domains != '' && strpos($old_ss_domains, $key) === false) || $old_ss_domains == '')
		{
			$_SESSION['sbPlugins']->addToCron('pl_search/cron/pl_search.php', 'fSearch_Cron_Refresh('.$ss_id.')', sprintf(PL_SEARCH_H_CRON_INDEXING, $ss_domains), PL_SEARCH_H_CRON_INDEXING_DESCR);
		}

		if($old_ss_domains == '')
			$old_ss_domains = $ss_domains;
	}

	$_SESSION['sbPlugins']->addToCache();

	$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_search_delim', PL_SEARCH_H_PLUGIN_NAME, '', '', '', 'all');
	$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_search_delay_microsecond', PL_SEARCH_H_SETTINGS_DELAY_MICROSECOND, 'number', '', '300000', 'all');
}

$_SESSION['sbPlugins']->addSystemEvent('search_form', 'fSearch_Get_Elem_Form', PL_SEARCH_H_FORM_ELEM);
$_SESSION['sbPlugins']->addSystemEvent('search_results', 'fSearch_Get_Elem_Results', PL_SEARCH_H_RESULTS_ELEM);


$_SESSION['sbPlugins']->addElem(PL_SEARCH_H_FORM_ELEM, 'form', 'fSearch_Elem_Form_Prog', 'fSearch_Elem_Form_Info', 'search_form', 700, 300, 'design_form_edit', 'design_search_form');
$_SESSION['sbPlugins']->addElem(PL_SEARCH_H_RESULTS_ELEM, 'results', 'fSearch_Elem_Results_Prog', 'fSearch_Elem_Results_Info', 'search_results', 700, 320, 'design_results_edit', 'design_results');

$_SESSION['sbPlugins']->addEventsRights('read', PL_SEARCH_H_RIGHTS_READ_DESC);
$_SESSION['sbPlugins']->addEventsRights('elems_edit', PL_SEARCH_H_RIGHTS_WRITE_DESC);
$_SESSION['sbPlugins']->addEventsRights('delete', PL_SEARCH_H_RIGHTS_DELETE_DESC);
$_SESSION['sbPlugins']->addEventsRights('design_read', RIGHTS_H_DESIGN_READ_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('design_edit', RIGHTS_H_DESIGN_EDIT_RIGHT);
?>