<?php

function fSearch_Sort($a, $b)
{
	$l1 = sb_strlen($a);
	$l2 = sb_strlen($b);

	if($l1 == $l2)
    {
    	return 0;
    }

    return ($l1 > $l2) ? -1 : 1;
}

function fSearch_Sort_Chains($a, $b)
{
	$l1 = count($a['words']);
	$l2 = count($b['words']);

	if($l1 == $l2)
    {
    	if ($a['start'] == $b['start'])
    	{
    		return 0;
    	}

    	return ($a['start'] < $b['start']) ? -1 : 1;
    }

    return ($l1 > $l2) ? -1 : 1;
}

/**
 * Вывод формы поиска
 */
function fSearch_Elem_Form($el_id, $temp_id, $params, $tag_id)
{
	if ($GLOBALS['sbCache']->check('pl_search', $tag_id, array($el_id, $temp_id, $params)))
		return;

	$res = sbQueryCache::getTemplate('sb_search_temps_form', $temp_id);
	if (!$res)
	{
		sb_add_system_message(sprintf(KERNEL_PROG_NO_TEMPLATE, $_SERVER['PHP_SELF'], KERNEL_PROG_SEARCH_PLUGIN), SB_MSG_WARNING);
		$GLOBALS['sbCache']->save('pl_search', '');
		return;
    }

	list($sstf_title, $sstf_form) = $res[0];
	$params = unserialize(stripslashes($params));

	$result = '';
	if (trim($sstf_form) == '')
	{
		$GLOBALS['sbCache']->save('pl_search', '');
		return;
	}

	$sb_search_words = isset($_GET['sb_search_words']) ? $_GET['sb_search_words'] : '';
	$sb_search_logic = isset($_GET['sb_search_logic']) ? preg_replace('/[^a-z]+/', '', $_GET['sb_search_logic']) : 'and';

	$tags = array('{ACTION}', '{VALUE}', '{OPT_SELECTED_AND}', '{OPT_SELECTED_OR}');
	if (isset($params['page']) && trim($params['page']) != '')
	{
		$action = $params['page'].($_SERVER['QUERY_STRING'] != '' ? '?'.$_SERVER['QUERY_STRING'] : '');
	}
	else
	{
		$action = $GLOBALS['PHP_SELF'].($_SERVER['QUERY_STRING'] != '' ? '?'.$_SERVER['QUERY_STRING'] : '');
	}

//	вывод полей формы input
	$values = array();
	$values[] = $action;
	$values[] = $sb_search_words;
	$values[] = (isset($sb_search_logic) && $sb_search_logic == 'and') ? ' checked="checked"' : '';
	$values[] = (isset($sb_search_logic) && $sb_search_logic == 'or') ? ' checked="checked"' : '';

	$result = str_replace($tags, $values, $sstf_form);
	$result = preg_replace('/\{[_A-Z0-9'.$GLOBALS['sb_reg_upper_interval'].']+\}/'.SB_PREG_MOD, '', $result);

	$GLOBALS['sbCache']->save('pl_search', $result);
}

/**
 * Вывод результатов поиска
 */
function fSearch_Elem_Results($el_id, $temp_id, $params, $tag_id)
{
    $params = unserialize(stripslashes($params));
    if(!isset($params['ss_id']))
    {
        return;
    }

    if (!isset($_GET['sb_search_words']) || trim($_GET['sb_search_words']) == '')
    {
        // если ничего не ищем
        return;
    }

	$tm = microtime(true);

	require_once SB_CMS_PL_PATH . '/pl_search_history/pl_search_history.inc.php';

	if ($GLOBALS['sbCache']->check('pl_search', $tag_id, array($el_id, $temp_id, $params)))
	{
	    fSearch_History_Save($_GET['sb_search_words'], intval($params['ss_id']), -1);
		return;
	}

	if (!isset($params['sort']))
		$params['sort'] = 'relevancy';

	if (!isset($params['order']))
		$params['order'] = 'DESC';

	// макет вывода результатов поиска
	//$query = sql_param_query('SELECT sstr_top, sstr_element, sstr_bottom, sstr_no_results, sstr_found_word, sstr_lang, sstr_perpage, sstr_pagelist_id
	//						FROM sb_search_temps_results WHERE sstr_id = ?d', $temp_id);
    $query = sbQueryCache::getTemplate('sb_search_temps_results', $temp_id);
	if(!$query)
	{
		sb_add_system_message(sprintf(KERNEL_PROG_NO_TEMPLATE, $_SERVER['PHP_SELF'], KERNEL_PROG_SEARCH_PLUGIN), SB_MSG_WARNING);
		$GLOBALS['sbCache']->save('pl_search', '');
		return;
	}

	list($top, $elems, $bottom, $no_result, $found_word, $lang, $sstr_perpage, $sstr_pagelist_id) = $query[0];

	// настройки поиска
	$query = sql_param_query('SELECT ss_settings FROM sb_search WHERE ss_id = ?d', $params['ss_id']);
	if(!$query)
	{
		$GLOBALS['sbCache']->save('pl_search', '');
		return;
	}

	$arr_settings = unserialize($query[0][0]);
	$arr_settings['words_no_indexing'] = explode(' ', $arr_settings['words_no_indexing']);
	$arr_settings['meta_tags'] = isset($arr_settings['meta_tags']) ? $arr_settings['meta_tags'] : 0;
	$arr_settings['full_index'] = isset($arr_settings['full_index']) ? $arr_settings['full_index'] : 0;

	if (trim($found_word) != '')
	{
		$found_word = unserialize($found_word);
	}
	else
	{
		$found_word = array();
		$found_word['start'] = '';
		$found_word['end'] = '';
		$found_word['date'] = '';
	}

    // вытаскиваем макет дизайна постраничного вывода
    $res = sbQueryCache::getTemplate('sb_pager_temps', $sstr_pagelist_id);

	if ($res)
    {
		list($pt_perstage, $pt_begin, $pt_next, $pt_previous, $pt_end, $pt_number, $pt_sel_number, $pt_page_list, $pt_delim) = $res[0];
	}
	else
	{
		$pt_page_list = '';
		$pt_perstage = 1;
	}

	// подключаем класс морфологии
	require_once(SB_CMS_LIB_PATH.'/sbSearch.inc.php');

	// преобразовываем строку поиска в последовательность ИД
	$search_words = trim($_GET['sb_search_words']);
	// переводим в нижний регистр
	$search_words = sb_strtolower($search_words);
	$search_words = str_replace('ё', 'е', $search_words);
	// HTML-теги заменяем на пробелы
   	$search_words = preg_replace('/<[^>]*>/u', ' ', $search_words);
   	// убираем escape-последовательности
   	$search_words = sb_html_entity_decode($search_words);
    // убираем все символы, которые не могут входить в слова
	$search_words = preg_replace('/[^a-z'.$GLOBALS['sb_reg_lower_interval'].$arr_settings['characters_allow'].' ]/u', ' ', $search_words);
    // убираем повторяющиеся пробелы
    $search_words = trim(preg_replace('/\s+/u', ' ', $search_words));

	if (trim($search_words) == '')
	{
		// если ничего не ищем
		$GLOBALS['sbCache']->save('pl_search', $no_result);
		return;
	}

    $search_words = explode(' ', $search_words);
    // класс для работы с морфологией
    $morf = new sbSearch();
    // все формы слова
    $all_forms = array();
    $count_words = 0;
    // все формы всех слов
    $forms = array();
    // строка запроса к базе
    $query_str = '';

    if (isset($params['partial_matching']) && $params['partial_matching'] == 1)
    {
	    foreach($search_words as $word)
		{
			if($query_str != '')
			{
				$query_str .= ' OR ';
			}

			$query_str .= 'sw_word LIKE '.$GLOBALS['sbSql']->escape('%'.$word.'%');
		}

		if ($query_str != '')
		{
			$query = sql_query('SELECT sw_word FROM sb_search_words WHERE '.$query_str);
			if ($query)
			{
				foreach ($query as $all_word)
				{
					if (!in_array($all_word, $search_words))
						$search_words[] = $all_word[0];
				}
			}
		}
    }

    $query_str = '';

	foreach($search_words as $word)
	{
		// если длина слова меньше Х - пропускаем его
		if(sb_strlen($word) < $arr_settings['min_length_word'])
			continue;

		// проверить на список запрещенных слов
		if(in_array($word, $arr_settings['words_no_indexing']))
			continue;

		// привести слово к "базовой" форме
		$base = $morf->get_base_form($word);
		if(isset($base[0]))
		{
			// проверить на список запрещенных слов
			if(in_array($base[0], $arr_settings['words_no_indexing']))
				continue;
		}

		// взять все словоформы этого слова
		$all_forms[$count_words] = $morf->get_all_forms($word);
		if(count($all_forms[$count_words]) == 0)
		{
			$all_forms[$count_words] = array($word);
		}
		$forms = array_merge($forms, $all_forms[$count_words]);
		$count_words++;

		if(isset($base[0]))
		{
			$word = $base[0];
		}

		if($query_str != '')
		{
			$query_str .= ' OR ';
		}

		$query_str .= 'sw_word = '.$GLOBALS['sbSql']->escape($word);
	}

	if ($query_str == '')
	{
		// если ничего не ищем
		$GLOBALS['sbCache']->save('pl_search', $no_result);
		return;
	}

	// сортируем слова по длине
	usort($forms, 'fSearch_Sort');

	// логика поиска
	$logic = isset($_GET['sb_search_logic']) ? preg_replace('/[^a-z]+/', '', $_GET['sb_search_logic']) : 'and';
	if (isset($params['partial_matching']) && $params['partial_matching'] == 1)
	{
		$logic = 'or';
	}

    // найти идентификаторы всех слов запроса
	$query = sql_query('SELECT sw_id FROM sb_search_words WHERE '.$query_str);
	if(!$query || ($logic == 'and' && count($query) != $count_words))
	{
		// таких слов нет
        fSearch_History_Save($_GET['sb_search_words'], intval($params['ss_id']), 0);
		$GLOBALS['sbCache']->save('pl_search', $no_result);
		return;
	}

	// список идентификаторов слов
	$ids_words = '';
	$order_str = 'CHAR_LENGTH(p.sp_words_ids)-CHAR_LENGTH(%s)+2';
	$replace_str = '';
	foreach($query as $val)
	{
		list($id) = $val;
		$len = sb_strlen($id);
		if($len < 4)
		{
			$id = str_repeat('0', 4 - $len).$id;
		}

		$ids_words .= ($logic == 'and' ? '+' : '').$id.' ';

		if ($replace_str == '')
		{
			$replace_str = 'REPLACE(CONCAT(" ", p.sp_words_ids, " "), " '.$id.' ", " ")';
		}
		else
		{
			$replace_str = 'REPLACE(CONCAT(" ", '.$replace_str.', " "), " '.$id.' ", " ")';
		}
	}

	$order_str = sprintf($order_str, $replace_str);

	// подключаем класс пейджирования
	require_once(SB_CMS_LIB_PATH.'/sbDBPager.inc.php');
	$pager = new sbDBPager($tag_id, $pt_perstage, $sstr_perpage);

	$all_pages = true;
	// вытаскиваем из базы
	if ($params['sort'] == 'relevancy')
	{
		$query = $pager->init($all_pages, 'SELECT p.sp_text, p.sp_url, p.sp_title, p.sp_last_modified,
											MATCH (p.sp_words_ids) AGAINST ("'.$ids_words.'") AS relevancy
											FROM sb_search_pages_'.intval($params['ss_id']).' p
											WHERE p.sp_flags = 1 AND MATCH(p.sp_words_ids) AGAINST("' . $ids_words . '" IN BOOLEAN MODE)
											ORDER BY relevancy '.$params['order'].', '.$order_str.' '.$params['order']);
	}
	else
	{
		$query = $pager->init($all_pages, 'SELECT p.sp_text, p.sp_url, p.sp_title, p.sp_last_modified,
											MATCH (p.sp_words_ids) AGAINST ("'.$ids_words.'") AS relevancy
											FROM sb_search_pages_'.intval($params['ss_id']).' p
											WHERE p.sp_flags = 1 AND MATCH(p.sp_words_ids) AGAINST("' . $ids_words . '" IN BOOLEAN MODE)
											ORDER BY '.$order_str.' '.$params['order'].', relevancy '.$params['order']);
	}


    //Сохраняем запрос в историю если это не листание по страницам
    fSearch_History_Save($_GET['sb_search_words'], intval($params['ss_id']), $pager->mNumElemsAll);

    if (!$query)
	{
		// результата нет
		$GLOBALS['sbCache']->save('pl_search', $no_result);
		return;
	}


	// результат
	$result = '';
	$tags = array('{PAGE_NAME}', '{LINK}', '{PAGE_DATE}', '{PAGE_NUM}', '{ARCHIVE_LINK}', '{WORDS_COUNT}', '{DESCRIPTION}');
	$count_search = $pager->mFrom + 1;

	if (strpos($elems, '{DESCRIPTION}') !== false && ($arr_settings['full_index'] == 1 || $arr_settings['meta_tags'] == 1))
	{
		$show_descr = true;
	}
	else
	{
		$show_descr = false;
	}

	$matches = array();
	foreach($query as $value)
	{
		list($text, $url, $title, $modified, ) = $value;

		$values = array();
		$values[] = trim($title) != '' ? trim($title) : $url;
		$values[] = $url;
		$values[] = sb_parse_date($modified, $found_word['date'], $lang);
		$values[] = $count_search++;
		$values[] = '/cms/admin/search.php?ss_id='.$params['ss_id'].'&url='.urlencode($url);

		if ($show_descr && !is_null($text) && trim($text) != '')
		{
			// распаковать текст страницы, если надо
    		if(function_exists('gzuncompress'))
    		{
    			$text = gzuncompress($text);
    		}

			if (!$text || $arr_settings['full_index'] != 1)
			{
				$values[] = 0;
				$values[] = $text;
			}
			else
			{
				$meta_keys = '';
				$meta_desc = '';
				// вытащить значения тегов <META>
				if ($arr_settings['meta_tags'] == 1)
				{
					// keywords
					if(preg_match('/<meta\s*name=(\'|")?\s*keywords\\1\s*content=(\'|")?(.*?)\\2.*>/siu', $text, $matches))
						$meta_keys = $matches[3];

					// description
					if(preg_match('/<meta\s*name=(\'|")?\s*description\\1\s*content=(\'|")?(.*?)\\2.*>/siu', $text, $matches))
						$meta_desc = $matches[3];
				}

	    		// индексируем только внутри <!--sb_index_start--> и <!--sb_index_end-->
				$text = '<!--sb_index_end-->'.$text.'<!--sb_index_start-->';
		        $text = preg_replace('/<!--\s*sb_index_end\s*-->\s*(.*?)\s*<!--\s*sb_index_start\s*-->/isu', ' ', $text);
		        $text = preg_replace('/<!--\s*sb_index_start\s*-->\s*(.*?)\s*<!--\s*sb_index_end\s*-->/isu', ' ', $text);
		        // вырезаем стили и скрипты
		        $text = preg_replace('/<script.*?<\/script>/siu', ' ', $text);
		    	$text = preg_replace('/<style.*?<\/style>/siu', ' ', $text);
	    		// вырезаем текст, в котором надо индексировать только ссылки
			   	$text = preg_replace('/<!--\s*sb_index_links_start\s*-->(.*?)<!--\s*sb_index_links_end\s*-->/siu', '', $text);
			   	// HTML-теги заменяем на пробелы
			   	$text = preg_replace('/<[^>]*>/u', ' ', $text);

			   	$text = $title.' '.$meta_keys.' '.$meta_desc.' '.$text;
   				$text = str_replace(array('ё', 'Ё'), array('е', 'Е'), $text);
   				// убираем повторяющиеся пробелы
    			$text = ' '.trim(preg_replace('/\s+/u', ' ', $text)).' ';
    			$text = sb_html_entity_decode($text);

    			// подсвечиваем все слова в тексте, совпадающие со словоформами
				$pattern = implode('|', $forms);
				$pattern_match = '/(?<=[^a-z' . $GLOBALS['sb_reg_lower_interval'] . $arr_settings['characters_allow'] . '])(' . $pattern . ')(?=[^a-z' . $GLOBALS['sb_reg_lower_interval'] . $arr_settings['characters_allow'] . '])/';

				// без конвертации preg_match не отрабатывает корректно
				if (!preg_match_all(iconv('UTF-8', 'WINDOWS-1251//IGNORE', $pattern_match), iconv('UTF-8', 'WINDOWS-1251//IGNORE', sb_strtolower($text)), $matches, PREG_OFFSET_CAPTURE))
				{
					$values[] = 0;
					$values[] = '';
				}
				else
				{
					// получаем позиции всех найденных слов
					$matches = $matches[1];
					$values[] = count($matches);

					$word_pos = array();
					foreach ($matches as $i => $match)
					{
						$match[0] = sb_strtolower(iconv('WINDOWS-1251', 'UTF-8//IGNORE', $match[0]));
						$word_pos[$i] = array();
						$word_pos[$i]['word'] = $match[0];
						$word_pos[$i]['pos'] = $match[1];
					}

					// ищем цепочки слов, расстояние между которыми менее 150 символов
					$chains = array();
					$i = 0;
					foreach($word_pos as $pos)
					{
						$word = $pos['word'];
						$word_len = sb_strlen($word);

						for ($j = 0; $j < count($all_forms); $j++)
						{
							if (in_array($word, $all_forms[$j]))
							{
								$pos['word'] = $j;
								break;
							}
						}

						$found1 = false;
						for ($j = 0; $j < $i; $j++)
						{
							if (in_array($pos['word'], $chains[$j]['words']))
							{
								continue;
							}

							$found2 = false;
							if (abs($pos['pos'] - $chains[$j]['start']) < 150)
							{
								if ($pos['pos'] < $chains[$j]['start'])
								{
									$chains[$j]['start'] = $pos['pos'];
								}
								elseif ($pos['pos'] > $chains[$j]['end'])
								{
									$chains[$j]['end'] = $pos['pos'] + $word_len;
								}

								$found2 = true;
							}
							elseif (abs($pos['pos'] + $word_len - $chains[$j]['end']) < 150)
							{
								if ($pos['pos'] < $chains[$j]['start'])
								{
									$chains[$j]['start'] = $pos['pos'];
								}
								elseif ($pos['pos'] + $word_len > $chains[$j]['end'])
								{
									$chains[$j]['end'] = $pos['pos'] + $word_len;
								}

								$found2 = true;
							}

							if ($found2)
							{
								$chains[$j]['words'][] = $pos['word'];
								$found1 = true;
							}
						}

						if (!$found1)
						{
							$chains[$i] = array();
							$chains[$i]['pos'] = $i;
							$chains[$i]['start'] = $pos['pos'];
							$chains[$i]['end'] = $pos['pos'] + $word_len;
							$chains[$i]['words'] = array();
							$chains[$i]['words'][] = $pos['word'];
							$i++;
						}
					}

					// сортируем цепочки по длине
					usort($chains, 'fSearch_Sort_Chains');

					$ar_start = array();
					$ar_end = array();
					$ar_words = array();

					foreach ($chains as $chain)
					{
						if (count($ar_start) > 2 || count($ar_words) >= $count_words)
							break;

						foreach ($chain['words'] as $word)
						{
							if (!in_array($word, $ar_words))
							{
								$ar_start[$chain['pos']] = $chain['start'];
								$ar_end[$chain['pos']] = $chain['end'];
								$ar_words = array_merge($ar_words, array_diff($chain['words'], $ar_words));

								break;
							}
						}
					}

					ksort($ar_start);

					$txt = '';
					foreach ($ar_start as $key => $pos_start)
					{
						$pos_start = max(0, $pos_start - 50);
						$pos_end = $ar_end[$key] + 50;

						$txt .= sb_htmlentities(sb_substr($text, $pos_start, $pos_end - $pos_start)).'... ';
					}
					$txt = '...'.$txt;

					$search = array();
					foreach ($matches as $match)
					{
						$match[0] = sb_strtolower(iconv('WINDOWS-1251', 'UTF-8//IGNORE', $match[0]));
						$search[] = '/([^a-zA-Z' . $GLOBALS['sb_reg_lower_interval'] . $GLOBALS['sb_reg_upper_interval'] . preg_quote($arr_settings['characters_allow']) . '])(' . $match[0] . ')([^a-zA-Z' . $GLOBALS['sb_reg_lower_interval'] . $GLOBALS['sb_reg_upper_interval'] . preg_quote($arr_settings['characters_allow']) . '])/iu';
					}

					$txt = preg_replace($search, '\\1sbindexhighlightedstart\\2sbindexhighlightedend\\3', $txt);
					$txt = preg_replace('/sbindexhighlightedend([^a-zA-Z' . $GLOBALS['sb_reg_lower_interval'] . $GLOBALS['sb_reg_upper_interval'] . $arr_settings['characters_allow'] . '])sbindexhighlightedstart/u', '\\1', $txt);

					$txt = str_replace(
						array('sbindexhighlightedstart', 'sbindexhighlightedend'),
						array($found_word['start'], $found_word['end']),
						preg_replace('/(sbindexhighlightedstart|sbindexhighlightedend)+/u', '\\1', $txt));

					$values[] = $txt;
				}
			}
		}
		else
		{
			$values[] = 0;
			$values[] = '';
		}

		$result .= str_replace($tags, $values, $elems);
	}

    if ($pt_page_list != '')
    {
    	$pager->mBeginTemp = $pt_begin;
        $pager->mBeginTempDisabled = '';
        $pager->mNextTemp = $pt_next;
        $pager->mNextTempDisabled = '';

        $pager->mPrevTemp = $pt_previous;
        $pager->mPrevTempDisabled = '';
        $pager->mEndTemp = $pt_end;
        $pager->mEndTempDisabled = '';

        $pager->mNumberTemp = $pt_number;
        $pager->mCurNumberTemp = $pt_sel_number;
        $pager->mDelimTemp = $pt_delim;
        $pager->mListTemp = $pt_page_list;

        $pt_page_list = $pager->show();
    }

    $tags = array('{NUM_LIST}', '{QUERY}', '{COUNT_RESULTS}', '{TIME_RESULTS}');
	$tm = round(microtime(true) - $tm, 3);

	// верх вывода
	$result = str_replace($tags, array($pt_page_list, trim($_GET['sb_search_words']), $all_pages, $tm), $top).$result;
	// низ вывода
	$result .= str_replace($tags, array($pt_page_list, trim($_GET['sb_search_words']), $all_pages, $tm), $bottom);
	$result = preg_replace('/\{[_A-Z0-9'.$GLOBALS['sb_reg_upper_interval'].']+\}/'.SB_PREG_MOD, '', $result);

	$GLOBALS['sbCache']->save('pl_search', $result);
}
?>