<?php
/**
 * Функция сохраняет поисковый запрос в историю
 * @param type $words
 * @param type $count
 */
function fSearch_History_Save($words, $ss_id, $count)
{
    $words = sb_substr($words, 0, 255);

    if (!isset($_COOKIE['search_hash']) || $_COOKIE['search_hash'] != md5($words))
    {
        //Сохраняем историю
        sb_setcookie('search_hash', md5($words));

        $res_history = sql_param_query('SELECT sh_id FROM sb_search_history WHERE sh_text=?s AND sh_search_page=?d', $words, $ss_id);
        if (!$res_history)
        {
            if ($count >= 0)
                sql_param_query('INSERT INTO sb_search_history (sh_text, sh_count, sh_pages_count, sh_date, sh_search_page) VALUES (?s, 1, ?d, ?d, ?d)', $words, $count, time(), $ss_id);
        }
        else
        {
            $row['sh_date'] = time();

            if ($count >= 0)
                $row['sh_pages_count'] = $count;

            sql_param_query('UPDATE sb_search_history SET sh_count=sh_count+1, ?a WHERE sh_id=?', $row, $res_history[0][0]);
        }
    }
}

function fSearch_History_Show()
{
    require_once(SB_CMS_LANG_PATH.'/pl_search_history.h.lng.php');

    if(!isset($_GET['id']) || $_GET['id'] == '')
    {
        sb_show_message(PL_SEARCH_HISTORY_NO_ELEMS_MSG.'<br /><br />[<a href="'.SB_CMS_CONTENT_FILE.'?event=pl_search_init">'.KERNEL_BACK.'</a>]', true, 'warning');
        return;
    }

    //Если есть запрос на удаление, то сначала удаляем элемент
    if(isset($_GET['del_elem']) && $_GET['del_elem'] != '')
    {
        $res = sql_param_query('DELETE FROM sb_search_history WHERE sh_id=?d', intval($_GET['del_elem']));
        if(!$res)
        {
            sb_show_message(PL_SEARCH_HISTORY_DELETE_ELEM_ERROR, false, 'warning');
        }
    }

    $order_by = 'sh_date DESC';
    $filter_str = fSearch_History_Get_Filter();

    if(isset($_GET['type_sort']) && $_GET['type_sort'] != '')
    {
        $order_by = 'sh_pages_count '.($_GET['type_sort'] == 'up'? 'ASC' : 'DESC');
    }
    elseif(isset($_GET['date_sort']) && $_GET['date_sort'] != '')
    {
        $order_by = 'sh_date '.($_GET['date_sort'] == 'up'? 'ASC' : 'DESC');
    }
    elseif(isset($_GET['pages_sort']) && $_GET['pages_sort'] != '')
    {
        $order_by = 'sh_pages_count '.($_GET['pages_sort'] == 'up'? 'ASC' : 'DESC');
    }
    elseif(isset($_GET['count_sort']) && $_GET['count_sort'] != '')
    {
        $order_by = 'sh_count '.($_GET['count_sort'] == 'up'? 'ASC' : 'DESC');
    }

    require_once(SB_CMS_LIB_PATH.'/sbDBPager.inc.php');

	$pager = new sbDBPager('shistory', 7, 20, '');

    if (isset($_GET['page_shistory']) && $_GET['page_shistory'] != '')
    {
        $pager->mPage = intval($_GET['page_shistory']);
    }

    $total = true;
    $res = $pager->init($total, 'SELECT sh_id, sh_text, sh_count, sh_pages_count, sh_date FROM sb_search_history WHERE sh_search_page=?d '.$filter_str.' ORDER BY '.$order_by, $_GET['id']);

    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

    $layout = new sbLayout();
    $layout->mTableWidth="100%";

    require_once (SB_CMS_LIB_PATH.'/sbIDN.inc.php');
    $idn = new sbIDN();

    $num_list = $pager->show();

    $label = array(
        PL_SEARCH_HISTORY_LIST_H_TYPE,
        PL_SEARCH_HISTORY_LIST_H_DATE,
        PL_SEARCH_HISTORY_LIST_H_WORDS,
        PL_SEARCH_HISTORY_LIST_H_COUNT_PAGES,
        PL_SEARCH_HISTORY_LIST_H_COUNT,
        ''
    );

    $sort = array(
        0 => 'id='.intval($_GET['id']).'&type_sort',
        1 => 'id='.intval($_GET['id']).'&date_sort',
        3 => 'id='.intval($_GET['id']).'&pages_sort',
        4 => 'id='.intval($_GET['id']).'&count_sort'
    );

    $value = array();

    echo '<script type="text/javascript">
        function showFilter()
		{
		    var filter = sbGetE("sb_filter");
		    var filter_arr = sbGetE("filter_arrow");

		    if (!filter) return;
		    if (filter.style.display == "none")
		    {
		        filter.style.display = "";
		        filter_arr.src = sb_cms_img_url + "/fil_arrow_up.gif";
		    }
		    else
		    {
		        filter.style.display = "none";
                filter_arr.src = sb_cms_img_url + "/fil_arrow_down.gif";
            }
        }

        function setFilter()
		{
            var str = "'.SB_CMS_CONTENT_FILE.'?event=pl_search_history_show&id='.$_GET['id'].fSearch_History_Get_Sort_Request().'";
			var found = false;
			var frm = sbGetE("filter_form");

		    for (var i = 0; i < frm.elements.length; i++)
		    {
		        var el = frm.elements[i];
		        if (el.type == "select-one")
		        {
		            if (el.value != -1)
		            {
		                str += "&"+el.name+"="+el.value;
		                found = true;
		            }
		        }
		        else
		        {
		            if (el.name != "" && el.value != "")
		            {
		                str += "&"+el.name+"="+el.value;
		                found = true;
		            }
		        }
		    }

		    if (!found)
		    {
		        return false;
		    }

			window.location.href = str;
			return false;
		}

        function removeFilter(e)
		{
		    window.location = "'.SB_CMS_CONTENT_FILE.'?event=pl_search_history_show&id='.$_GET['id'].fSearch_History_Get_Sort_Request().'";
		    return sbCancelEvent(e);
		}

        function sbDeleteFromHistory(id)
        {
            if (confirm("'.PL_SEARCH_HISTORY_DELETE_ELEM_MSG.'"))
            {
				var from = sbGetE("from").value;
		        window.location = "'.SB_CMS_CONTENT_FILE.'?event=pl_search_history_show&id='.$_GET['id'].fSearch_History_Get_Sort_Request().'&page_shistory=" + from+"&del_elem="+id;
            }
        }
    </script>';

    //Фильтр
    echo '<table cellpadding="0" cellspacing="0" width="100%" align="center">
    <tr id="filter_header">
        <td width="100%" class="sb_filter_header">
        	<table cellpadding="0" cellspacing="0">
        	<tr>
            	<td class="sb_filter_text">
                    <span onclick="showFilter();" ondblclick="showFilter();" style="cursor:hand;cursor:pointer;">
                        '.KERNEL_FILTER.'&nbsp;&nbsp;<img src="'.SB_CMS_IMG_URL.'/'.($filter_str != '' ? 'fil_arrow_up' : 'fil_arrow_down').'.gif" id="filter_arrow" align="absmiddle" />
                    </span>
                </td>
            	<td class="sb_filter_on" id="sb_filter_on" style="'.($filter_str != '' ? '' : 'visibility: hidden;').'">
                    <nobr><img src="'.SB_CMS_IMG_URL.'/filter_on.png" align="absmiddle" width="12" height="12">&nbsp;&nbsp;'.SB_ELEMS_FILTER_ON.'&nbsp;&nbsp;
                    <img src="'.SB_CMS_IMG_URL.'/filter_delim.gif" align="absmiddle" width="1" height="14">&nbsp;&nbsp;
                    <span style="cursor: hand; cursor: pointer;" onclick="removeFilter(event);">
                        <img src="'.SB_CMS_IMG_URL.'/filter_off.png" align="absmiddle" width="12" height="12">&nbsp;&nbsp;'.KERNEL_CANCEL.'
                    </span></nobr>
                </td>
            </tr>
            </table>
        </td>
    </tr>
    <tr><td valign="top">
            <form id="filter_form" action="" method="get" onsubmit="return setFilter();">
            <div id="sb_filter" '.($filter_str != '' ? '' : ' style="display:none;"').'>
            <table cellpadding="0" cellspacing="0" class="sb_filter_table">
            <tr>
                <th class="sb_filter_th">'.PL_SEARCH_HISTORY_FILTER_DATE.':</th>
                <td class="sb_filter_td"><nobr>';

	$fld_lo = new sbLayoutDate((isset($_GET['sh_date_from']) ? $_GET['sh_date_from'] : ''), 'sh_date_from');
	$fld_lo->mDropButton = true;

	$fld_hi = new sbLayoutDate((isset($_GET['sh_date_to']) ? $_GET['sh_date_to'] : ''), 'sh_date_to');
	$fld_hi->mDropButton = true;

	echo $fld_lo->getJavaScript().'
					<table cellpadding="0" cellspacing="0">
					<tr>
				    	<td>'.KERNEL_FROM.'&nbsp;&nbsp;</td>
				    	<td>'.$fld_lo->getField().'</td>
				    	<td>&nbsp;&nbsp;'.KERNEL_TO.'&nbsp;&nbsp;</td>
				    	<td>'.$fld_hi->getField().'</td>
				    </tr>
					</table>
				    </nobr>
                </td>
                <th class="sb_filter_th">'.PL_SEARCH_HISTORY_FILTER_WORDS.':</th>
                <td class="sb_filter_td_noborder">';
	$fld = new sbLayoutInput('text', isset($_GET['sh_words']) ? $_GET['sh_words'] : '', 'sh_words', '', 'style="width: 100%;"');
	echo $fld->getField().
				'</td>
          	</tr>
			<tr>
				<th class="sb_filter_th">'.PL_SEARCH_HISTORY_FILTER_TYPE.':</th>
				<td class="sb_filter_td">';

	$options = array();
	$options[0] = ' --- ';
	$options[1] = PL_SEARCH_HISTORY_FILTER_TYPE_RESULT_1;
	$options[2] = PL_SEARCH_HISTORY_FILTER_TYPE_RESULT_2;

	$fld = new sbLayoutSelect($options, 'sh_flags');
	$fld->mSelOptions = array(isset($_GET['sh_flags']) ? $_GET['sh_flags'] : '');
	echo $fld->getField().'
				</td>
				<th class="sb_filter_th">'.PL_SEARCH_HISTORY_FILTER_PAGES_COUNT.':</th>
				<td class="sb_filter_td_noborder"><table><tr><td>'.KERNEL_FROM.'&nbsp;&nbsp;';
	$fld = new sbLayoutInput('text', isset($_GET['sh_pages_count_from']) ? $_GET['sh_pages_count_from'] : '', 'sh_pages_count_from', 'spin_sh_pages_count_from', 'style="width: 100px"');
	$fld->mMinValue = 0;
    echo $fld->getField(), $fld->getJavaScript(), '</td><td>&nbsp;&nbsp;</td><td>'.KERNEL_TO;
    $fld = new sbLayoutInput('text', isset($_GET['sh_pages_count_to']) ? $_GET['sh_pages_count_to'] : '', 'sh_pages_count_to', 'spin_sh_pages_count_to', 'style="width: 100px"');
    $fld->mMinValue = 0;
    echo $fld->getField().'</td></tr></table></td>
			</tr>
            <tr>
            <th></th>
            <td></td>
            <th class="sb_filter_th">'.PL_SEARCH_HISTORY_FILTER_COUNT.'</th>
            <td class="sb_filter_td_noborder"><table><tr><td>'.KERNEL_FROM.'&nbsp;&nbsp;';
    $fld = new sbLayoutInput('text', isset($_GET['sh_count_from']) ? $_GET['sh_count_from'] : '', 'sh_count_from', 'spin_sh_count_from', 'style="width: 100px"');
	$fld->mMinValue = 0;
    echo $fld->getField(), $fld->getJavaScript(), '</td><td>&nbsp;&nbsp;</td><td>'.KERNEL_TO;
    $fld = new sbLayoutInput('text', isset($_GET['sh_count_to']) ? $_GET['sh_count_to'] : '', 'sh_count_to', 'spin_sh_count_to', 'style="width: 100px"');
    $fld->mMinValue = 0;
    echo $fld->getField(), '
            </td></tr></table></td>
            </tr>
			</table>
				<div class="sb_filter_footer"><input type="submit" value="'.KERNEL_APPLY.'">&nbsp;&nbsp;</div>
			</div>
			</form>
		</table>
	</td></tr></table><br/><br/>';

    if(!$res)
    {
        sb_show_message(PL_SEARCH_HISTORY_NO_ELEMS_MSG.'<br /><br />[<a href="'.SB_CMS_CONTENT_FILE.'?event=pl_search_init">'.KERNEL_BACK.'</a>]', true, 'warning');
        return;
    }

    $href = fSearch_History_Get_Result_Pages($_GET['id']);
    foreach($res as $row)
    {
        if($row[3] > 0)
        {
            $type_title = PL_SEARCH_HISTORY_TYPE_FOUND;
            $img_src = '/information_log.png';
        }
        else
        {
            $type_title = PL_SEARCH_HISTORY_TYPE_NOT_FOUND;
            $img_src = '/prevention_log.png';
        }

        $value[] = array(
            '<img src="'.SB_CMS_IMG_URL.$img_src.'" title="'.$type_title.'">',
            ($row[4] == 0)? '-' : sb_date('d.m.Y '.KERNEL_IN.' H:i:s', $row[4]),
            $href != ''? '<a href="'.$idn->decode(sprintf($href, urlencode($row[1]))).'" target="_blank">'.$row[1].'</a>' : $row[1],
            $row[3],
            $row[2],
            ($_SESSION['sbPlugins']->isRightAvailable('pl_search', 'delete') ? '<img height="20" width="20" style="cursor: pointer;" onClick = "sbDeleteFromHistory('.$row[0].');" title="'.PL_SEARCH_HISTORY_DELETE_FROM_HISTORY.'" src="'.SB_CMS_IMG_URL.'/btn_delete.png"/>' : '&nbsp;')
        );
    }
    $table = new sbLayoutTable($label, $value, $sort);
    $table->mShowTable = false;
    $table->mHTML = '<input type="hidden" value="'.$pager->mPage.'" name="from" id="from"/>';
    $table->mAlign = array(
        'center',
        'center',
        'left',
        'center',
        'center',
        'center',
    );

    $layout->addField('', $table);

    echo '<center><div align="right" style="width:95%;">[<a href="'.SB_CMS_CONTENT_FILE.'?event=pl_search_init">'.PL_SEARCH_HISTORY_BACK_LINK.']</a>';
    echo '<center>', $num_list, '</center><br/>';
    $layout->show();
    echo '<br/><center>', $num_list, '</center>';
    echo '</center>';
}

function fSearch_History_Get_Sort_Request()
{
    $sort_str = '';
    if(isset($_GET['type_sort']) && $_GET['type_sort'] != '')
    {
        $sort_str = '&type_sort='.$_GET['type_sort'];
    }
    elseif(isset($_GET['date_sort']) && $_GET['date_sort'] != '')
    {
        $sort_str = '&date_sort='.$_GET['date_sort'];
    }
    elseif(isset($_GET['pages_sort']) && $_GET['pages_sort'] != '')
    {
        $sort_str = '&pages_sort='.$_GET['pages_sort'];
    }
    elseif(isset($_GET['count_sort']) && $_GET['count_sort'] != '')
    {
        $sort_str = '&count_sort='.$_GET['count_sort'];
    }
    return $sort_str;
}

function fSearch_History_Get_Filter()
{
    $filter_str = '';

    if(isset($_GET['sh_date_from']) && $_GET['sh_date_from'] != '')
    {
        $_GET['sh_date_from'] = preg_replace('/[^0-9\.: ]+/', '', $_GET['sh_date_from']);

        $date_time = explode(' ', $_GET['sh_date_from']);
        if (count($date_time) > 0)
        {
			$filter_str .= ' AND sh_date >= '.sb_datetoint($_GET['sh_date_from']);
        }
    }

    if(isset($_GET['sh_date_to']) && $_GET['sh_date_to'] != '')
    {
        $_GET['sh_date_to'] = preg_replace('/[^0-9\.: ]+/', '', $_GET['sh_date_to']);

        $date_time = explode(' ', $_GET['sh_date_to']);
        if (count($date_time) > 0)
        {
			$filter_str .= ' AND sh_date <= '.sb_datetoint($_GET['sh_date_to']);
        }
    }

    if(isset($_GET['sh_words']) && $_GET['sh_words'] != '')
    {
        $_GET['sh_words'] = preg_replace('/\s{2,}/', ' ', trim($_GET['sh_words']));

        $words = '%'.sb_str_replace(' ', '%', $_GET['sh_words']).'%';
        if ($_GET['sh_words'] != '')
        {
			$filter_str .= ' AND sh_text LIKE "'.$words.'"';
        }
    }

    if(isset($_GET['sh_flags']) && $_GET['sh_flags'] != '')
    {
        if ($_GET['sh_flags'] == 1)
        {
			$filter_str .= ' AND sh_pages_count > 0';
        }
        elseif($_GET['sh_flags'] == 2)
        {
            $filter_str .= ' AND sh_pages_count = 0';
        }
    }

    if(isset($_GET['sh_pages_count_from']) && $_GET['sh_pages_count_from'] != '')
    {
        $_GET['sh_pages_count_from'] = preg_replace('/[^0-9]+/', '', $_GET['sh_pages_count_from']);

        if ($_GET['sh_pages_count_from'] > 0)
        {
			$filter_str .= ' AND sh_pages_count >= '.$_GET['sh_pages_count_from'];
        }
    }

    if(isset($_GET['sh_pages_count_to']) && $_GET['sh_pages_count_to'] != '')
    {
        $_GET['sh_pages_count_to'] = preg_replace('/[^0-9]+/', '', $_GET['sh_pages_count_to']);

        if ($_GET['sh_pages_count_to'] > 0)
        {
			$filter_str .= ' AND sh_pages_count <= '.$_GET['sh_pages_count_to'];
        }
    }

    if(isset($_GET['sh_count_from']) && $_GET['sh_count_from'] != '')
    {
        $_GET['sh_count_from'] = preg_replace('/[^0-9]+/', '', $_GET['sh_count_from']);

        if ($_GET['sh_count_from'] > 0)
        {
			$filter_str .= ' AND sh_count >= '.$_GET['sh_count_from'];
        }
    }

    if(isset($_GET['sh_count_to']) && $_GET['sh_count_to'] != '')
    {
        $_GET['sh_count_to'] = preg_replace('/[^0-9]+/', '', $_GET['sh_count_to']);

        if ($_GET['sh_count_to'] > 0)
        {
			$filter_str .= ' AND sh_count <= '.$_GET['sh_count_to'];
        }
    }

    return $filter_str;
}

/**
 * Поиск страниц для вывода результатов поискового запроса
 *
 * @param int $ss_id    ID поисковой базы
 */
function fSearch_History_Get_Result_Pages($ss_id)
{
    static $pages = array();
    static $query = false;

    if(!$query)
    {
        $query = true;
        $res = sql_param_assoc('SELECT se.e_p_id, se.e_params, sp.p_filepath, sp.p_filename
            FROM sb_elems se, sb_pages sp
            WHERE se.e_ident="pl_search_results" AND se.e_link="page" AND sp.p_id=se.e_p_id AND sp.p_state=1');

        if($res)
        {
            foreach($res as $row)
            {
                $params = unserialize($row['e_params']);
                if(!isset($pages[$params['ss_id']]))
                {
                    $file = $row['p_filename'] == 'index.php'? '' : $row['p_filename'];
                    $row['p_filepath'] = $row['p_filepath'] != ''? $row['p_filepath'].'/' : '';
                    $pages[$params['ss_id']] = $row['p_filepath'].$file.'?sb_search_words=%s';
                }
            }
        }
    }

    if(isset($pages[$ss_id]))
    {
        $res = sql_param_query('SELECT ss_domains, ss_settings FROM sb_search WHERE ss_id=?d', $ss_id);
        if($res)
        {
            $settings = $res[0][1] != ''? unserialize($res[0][1]) : array();
            $domains = explode(',', $res[0][0]);
            if(isset($settings['scheme']))
            {
                return $settings['scheme'].'://'.$domains[0].'/'.$pages[$ss_id];
            }
        }
    }

    return '';
}
?>
