<?php
function fSettings_Read()
{
	if (isset($_GET['domain']))
		$domain = preg_replace('/[^A-Za-z0-9\-\._]+/'.SB_PREG_MOD, '', $_GET['domain']);
	else
		$domain = 'all';

	if (!$_SESSION['sbAuth']->isAdmin() && $domain != 'all')
	{
		$res = sql_query('SELECT u_domains FROM sb_users WHERE u_id=?d', $_SESSION['sbAuth']->getUserId());
	    if ($res)
	    {
	        $u_domains = explode(',', $res[0][0]);
	    }
	    else
	    {
	        $u_domains = array();
	    }

	    if (!in_array($domain, $u_domains))
	    	return;
	}

    $tabId = (isset($_GET['tab_id']) ? intval($_GET['tab_id']) : -1);
    $tabStrs = array();
    $tabNum = 0;

    $settings = array();
    $all_settings_props = $_SESSION['sbPlugins']->getAllSettingsProps($domain);
    $all_settings = sbPlugins::getAllSettings($domain);

    foreach ($all_settings_props as $setting_ident => $setting_value)
    {
    	$tab = $setting_value['tab_name'];
        if ($tab == '')
            continue;

        // раскладываем настройки по закладкам
        if (!isset($settings[$tab]))
            $settings[$tab] = array();

        if (isset($all_settings[$setting_ident]) && isset($all_settings[$setting_ident]['value']))
        	$setting_value['value'] = $all_settings[$setting_ident]['value'];
        else
        	$setting_value['value'] = null;

        $settings[$tab][$setting_ident] = $setting_value;
    }

    foreach ($settings as $key => $value)
    {
        // выводим закладки
        if ($tabNum != $tabId)
        {
            // если запрос на подгрузку закладки не пришел, выводим пустую строку
            $tabStrs[$key] = '';
        }
        else
        {
            // иначе выводим закладку
            $tabStrs[$key] = '<table width="100%" cellspacing="0" cellpadding="5" class="form">';
            foreach ($value as $subKey => $subValue)
            {
            	if ($subValue['type'] == '')
                {
                	if (trim($subValue['desc']) != '')
                	{
                		$tabStrs[$key] .= '<tr>
    			        	<td colspan="2"><div class="hint_div" style="text-align:center;">'.$subValue['desc'].'</div></td>
    		        	</tr>';
                	}

                	$tabStrs[$key] .= '<tr>
	    			        <td colspan="2" style="padding: 0px; height: 1px; font-size: 1px; background: url('.SB_CMS_IMG_URL.'/hdelim.gif) repeat-x;"></td>
	    		        </tr>';
                    continue;
                }

                if ($subValue['type'] != 'hidden')
                {
                	$tabStrs[$key] .= '<tr>
        			 <th width="50%" style="vertical-align:top;">'.$subValue['desc'].':</th>
        			 <td>';
                }

                switch ($subValue['type'])
                {
                    case 'string':
                        // строка
                        $tabStrs[$key] .= '<input type="text" size="40" value="'.sb_htmlspecialchars($subValue['value']).'" name="'.$subKey.'" />';
                        if($subKey == 'sb_google_analytics_id' || $subKey == 'sb_yandex_maps_metrika')
						{
							$tabStrs[$key] .= '<input type="hidden" value="'.sb_htmlspecialchars($subValue['value']).'" name="'.$subKey.'_old" />';
						}
                        break;

                    case 'hidden':
                        // hidden
                        $tabStrs[$key] .= '<input type="hidden" value="'.sb_htmlspecialchars($subValue['value']).'" name="'.$subKey.'" />';
                        break;

                    case 'number':
                        // число
                        $tabStrs[$key] .= '<input type="text" value="'.sb_htmlspecialchars($subValue['value']).'" style="width:60px;" name="'.$subKey.'" id="spin_'.$subKey.'"/>';
                        if($subKey == 'sb_new_version_css' || $subKey == 'sb_new_version_js')
						{
							$tabStrs[$key] .= '<input type="hidden" value="'.sb_htmlspecialchars($subValue['value']).'" name="'.$subKey.'_old" />';
						}
                        break;

                    case 'checkbox':
                        // чекбокс (булево)
                        // Так как непомеченные чекбоксы не передаются, то сохраняем значение в хиден-поле
                        $tabStrs[$key] .= '<input type="checkbox" value="1"'.($subValue['value'] == 1 ? ' checked' : '').' onclick="sbGetE(\''.$subKey.'\').value=(this.checked ? 1 : 0);" />
                                           <input type="hidden" id="'.$subKey.'" value="'.$subValue['value'].'" name="'.$subKey.'" />';
                        if($subKey == 'sb_profiler_plugins')
                        {
                            $tabStrs[$key] .= '<input type="hidden" value="'.($subValue['value'] == 1 ? '1' : '0').'" name="'.$subKey.'_old" />';
                        }
                        break;

                    case 'checkboxes':
                    	// набор чекбоксов, считываем все значения и описания набора
                        if (count($subValue['type_values']))
                        {
                        	$i = 0;
                            foreach ($subValue['type_values'] as $ch_val => $ch_desc)
                            {
                                // так как непомеченные чекбоксы не передаются, то устанавливаем в хиден-поле флаг, что таковые имеются
                                $tabStrs[$key] .= '<input type="checkbox" value="'.$ch_val.'" id="'.$subKey.$i.'" name="'.$subKey.'[]"'.(in_array($ch_val, $subValue['value']) ? ' checked' : '').' /> - <label for="'.$subKey.$i.'">'.$ch_desc.'</label><br />
                                                   <input type="hidden" name="empty_'.$subKey.'" value="1" />';
                                $i++;
                            }
                        }
                    	break;

                    case 'select':
                        // выпадающий список
                        if (count($subValue['type_values']) != 0)
                        {
                            $tabStrs[$key] .= '<select name="'.$subKey.'">';

                            $was_group = false;
                            foreach ($subValue['type_values'] as $opt_val => $opt_desc)
                            {
	                            if (sb_substr($opt_desc, 0, 1) == '-')
					            {
					                if ($was_group)
					                    $tabStrs[$key] .= '</optgroup>';

					                $tabStrs[$key] .= '<optgroup label="'.sb_substr($opt_desc, 1).'">';
					                $was_group = true;
					                continue;
					            }

                                $tabStrs[$key] .= '<option value="'.$opt_val.'"'.($opt_val == $subValue['value'] ? ' selected' : '').'>'.$opt_desc.'</option>';
                            }

                        	if ($was_group)
					        {
					            $tabStrs[$key] .= '</optgroup>';
					        }

                            $tabStrs[$key] .= '</select>';
                        }
                        break;

                    case 'multiselect':
                        // список с множественным выбором
                        if (count($subValue['type_values']) != 0)
                        {
                            $tabStrs[$key] .= '<select name="'.$subKey.'[]" multiple="multiple">';

                            foreach ($subValue['type_values'] as $opt_val => $opt_desc)
                            {
                                $tabStrs[$key] .= '<option value="'.$opt_val.'"'.(in_array($opt_val, $subValue['value']) ? ' selected' : '').'>'.$opt_desc.'</option>';
                            }
                            $tabStrs[$key] .= '</select>';
                        }
                        break;

                    case 'radio':
                        // набор радио-кнопок
                        if (count($subValue['type_values']))
                        {
                        	$i = 0;
                            foreach ($subValue['type_values'] as $opt_val => $opt_desc)
                            {
                                $tabStrs[$key] .= '<input type="radio" id="'.$subKey.$i.'" name="'.$subKey.'" value="'.$opt_val.'"'.($opt_val == $subValue['value'] ? ' checked' : '').' /> - <label for="'.$subKey.$i.'">'.$opt_desc.'</label><br />';
                                $i++;
                            }
                        }
                        break;

                    case 'file':
                        $tabStrs[$key] .= '<input type="text" name="'.$subKey.'" id="'.$subKey.'" value="'.$subValue['value'].'" size="55" />
                                           &nbsp;<img class="button" src="'.SB_CMS_IMG_URL.'/images.png" width="20" height="20" align="absmiddle" onmouseup="sbPress(this, false);" onmousedown="sbPress(this, true);" onclick="sbGetFile(\''.$subKey.'\', \''.$subValue['type_values'].'\');" title="'.KERNEL_BROWSE.'">
                                          ';
                        break;

                    case 'color':
                    	$tabStrs[$key] .= '<input type="text" name="'.$subKey.'" id="'.$subKey.'" value="'.$subValue['value'].'" readonly="readonly" style="width: 120px;'.($subValue['value'] != '' ? 'background-color:'.$subValue['value'].';' : '').'">
                            			   <img class="button" src="'.SB_CMS_IMG_URL.'/color.png" width="20" height="20" align="absmiddle" onmouseup="sbPress(this, false);" onmousedown="sbPress(this, true);" onclick="sbCDlg(\''.$subKey.'\');">
                            			   <img class="button" src="'.SB_CMS_IMG_URL.'/color_drop.png" width="20" height="20" align="absmiddle" onmouseup="sbPress(this, false);" onmousedown="sbPress(this, true);" onclick="sbCDlgDrop(\''.$subKey.'\');">';
                        break;

                    case 'password':
                        // пароль
						$tabStrs[$key] .= '<input type="password" size="40" value="'.sb_htmlspecialchars($subValue['value']).'" name="'.$subKey.'" />';
						break;
				}

				if ($subValue['type'] != 'hidden')
				{
					$tabStrs[$key] .= '</td></tr>';
				}
			}
			$tabStrs[$key] .= '</table>';
		}
		$tabNum++;
	}

    if ($tabId == -1)
    {
        echo '<script src="'.SB_CMS_JSCRIPT_URL.'/sbSpinButton.js.php"></script>
        <script>
        var sbFileElId = null;
        function sbGetFile(el_id, types)
        {
            var el = sbGetE(el_id);
            if (el.disabled)
                return;

            if (el)
            {
                sbFileElId = el_id;
                var strPage = sb_cms_modal_dialog_file + "?event=pl_filelist_get_files&path="+sbEscapeEx(el.value)+"&types=" + types;
                var strAttr = "resizable=0,width="+(screen.availWidth - 50)+",height="+(screen.availHeight - 50);

                sbShowModalDialog(strPage, strAttr, sbAfterGetFile);
            }
        }
        function sbAfterGetFile()
        {
            if (sbModalDialog.returnValue && sbFileElId)
            {
                var el = sbGetE(sbFileElId);
                el.value = sbModalDialog.returnValue.path;
            }
        }
        var sbCDlgEl = null;
        function sbCDlg(el_id)
        {
            var el = sbGetE(el_id);
            if (el.disabled)
                return;
            if (el)
            {
                sbCDlgEl = el_id;
                var strPage = sb_cms_modal_dialog_file + "?event=pl_editor_color&color=" + sbEscapeEx(el.value);
                if (/MSIE (5\.5|6\.)/.test(navigator.userAgent))
                    var strAttr = "resizable=0,width=700,height=470";
                else
                    var strAttr = "resizable=0,width=700,height=450";

                sbShowModalDialog(strPage, strAttr, sbAfterCDlg);
            }
        }
        function sbAfterCDlg()
        {
            if (sbModalDialog.returnValue && sbCDlgEl)
            {
                var el = sbGetE(sbCDlgEl);
                el.value = sbModalDialog.returnValue;
                el.style.background = el.value;
            }
        }
        function sbCDlgDrop(el_id)
        {
            var el = sbGetE(el_id);
            if (el)
            {
                el.value = "";
                el.style.background = "#FFFFFF";
            }
        }
        </script>';
    }

    require_once(SB_CMS_LIB_PATH.'/sbTabs.inc.php');

    $tabs = new sbTabs(SB_CMS_CONTENT_FILE.'?event=pl_settings_submit&domain='.$domain, '', 'post', '');
    $tabs->setBottom('<input type="submit" value="'.KERNEL_SAVE.'" />');
    $tabs->setAutoLoading(SB_CMS_EMPTY_FILE.'?event=pl_settings_read&domain='.$domain);
    $tabs->mTabsOnLoad = 'sbSetSpin';

    $i = 0;
    foreach ($tabStrs as $key => $value)
    {
        if ($i % 5 == 0 && $i != 0) $key = '$'.$key;
	    $tabs->addTab($key, $value);
	    $i++;
    }

    // вывод закладок
    $tabs->show();
}

function fSettings_Submit()
{
	if (!isset($_GET['domain']))
	{
		fSettings_Read();
		return;
	}

	$domain = preg_replace('/[^A-Za-z0-9\-\._]+/'.SB_PREG_MOD, '', $_GET['domain']);

	echo '<script>
	function pagesGen(cat_id)
	{
		var strPage = "'.SB_CMS_DIALOG_FILE.'?event=pl_pages_gen_pages&id=" + cat_id + "&subcategs=1";
	 	var strAttr = "resizable=0,width=600,height=400";
        sbShowDialog(strPage, strAttr);
	}
	</script>
	';

    $regeneration = false; // Показывает, нужна ли перегенерация страниц после цикла
    foreach ($_POST as $key => $value)
    {
    	if ($key == 'tabidx' || $key == 'domain')
            continue;

        if (substr($key, 0, 6) == 'empty_')
        {
            // проверяем, есть ли помеченные чекбоксы в наборе чекбоксов
            $key = substr($key, 6);
            if (isset($_POST[$key]))
            {
                // если есть, они будут добавлены
                continue;
            }
            else
            {
                // если нет, то значение набора - пустой массив
                $value = array();
            }
        }

        // сохраняем настройку
        $_SESSION['sbPlugins']->setSetting($key, $value, $domain);

        switch ($key)
        {
            case 'sb_deny_index':
                $old_domain                = $GLOBALS['sbVfs']->mDomain;
                $GLOBALS['sbVfs']->mDomain = $domain;

                // включено запрещение индексации сайта, правим файл robots.txt
                if ($GLOBALS['sbVfs']->exists('robots.txt'))
                    $filestr = $GLOBALS['sbVfs']->file_get_contents('robots.txt');
                else
                    $filestr = false;

                if ($value == 1)
                {
                    if ($filestr)
                    {
                        if (!stristr($filestr, "\nUser-agent:   *\nDisallow: /"))
                        {
                            $filestr .= "\nUser-agent:   *\nDisallow: /";
                            $GLOBALS['sbVfs']->file_put_contents('robots.txt', $filestr);
                        }
                    }
                    else
                    {
                        $filestr = "\nUser-agent:   *\nDisallow: /";
                        $GLOBALS['sbVfs']->file_put_contents('robots.txt', $filestr);
                    }
                }
                else
                {
                    if ($filestr)
                    {
                        if ($filestr == "\nUser-agent:   *\nDisallow: /")
                        {
                            $GLOBALS['sbVfs']->delete('robots.txt');
                        }
                        else
                        {
                            $filestr = str_ireplace("\nUser-agent:   *\nDisallow: /", '', $filestr);
                            $GLOBALS['sbVfs']->file_put_contents('robots.txt', $filestr);
                        }
                    }
                }

                $GLOBALS['sbVfs']->mDomain = $old_domain;
                break;
            case 'sb_google_analytics_id':
                // Если редактировался идентификатор пользователя для Google Analytics
                if ($_POST['sb_google_analytics_id'] != $_POST['sb_google_analytics_id_old'])
                {
                    // нужна перегенерация
                    $regeneration = true;
                    // если в базе нет кода счетчика - добаляем код поумолчанию
                    $res2         = sql_query('SELECT cs_id FROM sb_counts WHERE cs_service = "google" AND cs_domain = ?', $domain);
                    if (!$res2)
                    {
                        sql_query('INSERT INTO sb_counts (cs_domain, cs_service, cs_code) values(?,"google",?)', $domain, PL_SETTINGS_GOOGLE_ANALYTICS_CODE);
                    }
                }
                break;
            case 'sb_yandex_maps_metrika':
                // Если редактировался идентификатор пользователя для Yandex Метрика
                if ($_POST['sb_yandex_maps_metrika'] != $_POST['sb_yandex_maps_metrika_old'])
                {
                    // нужна перегенерация
                    $regeneration = true;
                    // если в базе нет кода счетчика - добаляем код поумолчанию
                    $res2         = sql_query('SELECT cs_id FROM sb_counts WHERE cs_service = "yandex" AND cs_domain = ?', $domain);
                    if (!$res2)
                    {
                        sql_query('INSERT INTO sb_counts (cs_domain, cs_service, cs_code) values(?,"yandex",?)', $domain, PL_SETTINGS_YANDEX_METRIKA_CODE);
                    }
                }
                break;
            case 'sb_new_version_css':
                // Если редактировалась версия стилей
                if ($_POST['sb_new_version_css'] != $_POST['sb_new_version_css_old'])
                {
                    //	нужна перегенерация
                    $regeneration = true;
                }
                break;
            case 'sb_new_version_js':
                // Если редактировалась версия js-скриптов
                if ($_POST['sb_new_version_js'] != $_POST['sb_new_version_js_old'])
                {
                    //	нужна перегенерация
                    $regeneration = true;
                }
                break;
            case 'sb_profiler_plugins':
                //Если включили/отключили профилирование модулей
                if ($_POST['sb_profiler_plugins'] != $_POST['sb_profiler_plugins_old'])
                {
                    //	нужна перегенерация
                    $regeneration = true;
                }
                break;
        }
    }

    // Если нужна перегенерация страниц
	if($regeneration)
    {
    	$res = sql_query('SELECT cat_id FROM sb_categs WHERE cat_title = ? AND cat_ident = "pl_pages"', $domain);

		if($res)
		{
			echo '<script> pagesGen('.$res[0][0].'); </script>';
		}
    }
    // записываем сообщение об изменении настроек в системный журнал
    sb_add_system_message(PL_SETTINGS_LOG_MESSAGE);
    // выводим сообщение об успешном сохранении настроек
    sb_show_message(PL_SETTINGS_SUCCESSFULLY_SAVED);
    // выводим окно изменения настроек
    fSettings_Read();
}
function fSettings_Count()
{
	if(isset($_GET['domain']))
		$domain = preg_replace('/[^A-Za-z0-9\-\._]+/'.SB_PREG_MOD, '', $_GET['domain']);
	$service = $_GET['service'];
	if(($service != 'yandex' && $service != 'google') || !isset($domain) || !isset($GLOBALS['sb_domains'][$domain]))
	{
		sb_add_system_message(PL_SETTINGS_COUNTS_SERVICE_ERROR, SB_MSG_ERROR);
		sb_show_message(PL_SETTINGS_COUNTS_SERVICE_ERROR, true, 'warning');
    	return;
	}
	// Достаю контент
	$content = '';
	$readonly = false;

	$res = sql_query('SELECT cs_id, cs_code FROM sb_counts WHERE cs_service = ? AND cs_domain = ?', $service, $domain);
	if(!$res)
	{
		//Добавление
		$cs_id = -1;
		if($service == 'google')
			$content = PL_SETTINGS_GOOGLE_ANALYTICS_CODE;
		elseif($service == 'yandex')
			$content = PL_SETTINGS_YANDEX_METRIKA_CODE;
	}
	else
	{
		// Редактирование
		$cs_id = $res[0][0];
		$content = $res[0][1];
	}
	require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
	echo '<div align="center">';

	$layout = new sbLayout(SB_CMS_CONTENT_FILE.'?event=pl_settings_counts_'.$service.'_submit', '', 'post', '', '', 'style="width:95%; margin-top:20px;"');
	$layout->mShowTitle = false;

	if($service == 'google')
		$layout->addHeader(sprintf(PL_SETTINGS_COUNTS_GOOGLE_FORM_HEADER.' '.$domain));
	elseif($service == 'yandex')
		$layout->addHeader(sprintf(PL_SETTINGS_COUNTS_YANDEX_FORM_HEADER.' '.$domain));

	// Текстовое поле
	$fld = new sbLayoutTextarea($content, 'cs_content', 'cs_content', 'style="width:100%;height:400px;"'.$readonly);
	if($service == 'google')
	{
		$fld->mTags = array('{GOOGLE_ID}',  PL_SETTINGS_GOOGLE_ANALYTICS_CODE);
		$fld->mValues = array(PL_SETTINGS_COUNTS_GOOGLE_SITE_ID, PL_SETTINGS_COUNTS_TAG);
	}
	elseif($service == 'yandex')
	{
		$fld->mTags = array('{YANDEX_METRIKA_ID}', PL_SETTINGS_YANDEX_METRIKA_CODE);
		$fld->mValues = array(PL_SETTINGS_COUNTS_YANDEX_SITE_ID, PL_SETTINGS_COUNTS_TAG);
	}


	$layout->addField('', $fld);
	// Hidden для названия сервиса
	$layout->addField('', new sbLayoutInput('hidden',$service,'cs_service', 'cs_service'));
	// Hidden для названия домена
	$layout->addField('', new sbLayoutInput('hidden',$domain,'cs_domain', 'cs_domain'));
	// Hidden для идентификатора
	$layout->addField('', new sbLayoutInput('hidden',$cs_id,'cs_id', 'cs_id'));

	if ($readonly == '')
		$layout->addButton('submit', KERNEL_SAVE, 'btn_save', '', '');

	$layout->show();

	echo '</div';


}

function fSettings_Counts_Submit()
{
	if(isset($_POST['cs_domain']))
		$domain = preg_replace('/[^A-Za-z0-9\-\._]+/'.SB_PREG_MOD, '', $_POST['cs_domain']);
	$service = $_POST['cs_service'];
	$id = intval($_POST['cs_id']);
	echo '<script>
	function pagesGen(cat_id)
	{
		var strPage = "'.SB_CMS_DIALOG_FILE.'?event=pl_pages_gen_pages&id=" + cat_id + "&subcategs=1";
	 	var strAttr = "resizable=0,width=600,height=400";
        sbShowDialog(strPage, strAttr);
	}
	</script>
	';
	if(($service != 'yandex' && $service != 'google') || !isset($domain) || !isset($GLOBALS['sb_domains'][$domain]))
	{
		sb_add_system_message(PL_SETTINGS_COUNTS_SERVICE_SUBMIT_ERROR, SB_MSG_ERROR);
		sb_show_message(PL_SETTINGS_COUNTS_SERVICE_SUBMIT_ERROR, true, 'warning');
		return;
	}
	if($id > 0)
	{
		// Редактирование
		$res = sql_query('UPDATE sb_counts SET cs_code = ? WHERE cs_id = ?d', $_POST['cs_content'], $id);
	}
	else
	{
		// Добавление
		$res = sql_query('INSERT INTO sb_counts (cs_domain, cs_service, cs_code) values(?,?,?)', $domain, $service, $_POST['cs_content']);
	}
	if(!$res)
	{
		sb_add_system_message(PL_SETTINGS_COUNTS_SERVICE_SUBMIT_ERROR, SB_MSG_ERROR);
		sb_show_message(PL_SETTINGS_COUNTS_SERVICE_SUBMIT_ERROR, true, 'warning');
    	return;
	}
	// Перегенерация страниц
	@include_once SB_CMS_PL_PATH.'/pl_pages/pl_pages.php';
	$res = sql_query('SELECT cat_id FROM sb_categs WHERE cat_title = ? AND cat_ident = "pl_pages"', $domain);

	if($res)
	{
		echo '<script> pagesGen('.$res[0][0].'); </script>';
	}
	// Сообщение об успешном применении настроек
	if($service == 'google')
	{
		sb_add_system_message(sprintf(PL_SETTINGS_COUNTS_GOOGLE_SUBMIT_OK,$domain));
		sb_show_message(sprintf(PL_SETTINGS_COUNTS_GOOGLE_SUBMIT_OK,$domain));
	}
	elseif($service == 'yandex')
	{
		sb_add_system_message(sprintf(PL_SETTINGS_COUNTS_YANDEX_SUBMIT_OK,$domain));
		sb_show_message(sprintf(PL_SETTINGS_COUNTS_YANDEX_SUBMIT_OK,$domain));
	}
	$_GET['domain'] = $domain;
	$_GET['service'] = $service;
    fSettings_Count();
}
?>