<?php
/**
 * Функция перенаправления на страницу авторизации соц. сети
 * @param string $netName
 */
function fRedirectToLogin($netName){
    if('livejournal' == $netName){
        fParseResponse($netName);
    }else{
        require_once (SB_CMS_LIB_PATH . '/oauth/sbSocAuth.php');
        $obj = sbSocAuth::getInstance($netName);
        $obj->sendAuthRequest();

        if($obj->hasError()){
            fSocial_Login_Set_System_Error($obj->getSystemErrors());
            fSocial_Login_Set_UserError($obj->getUserErrors());
            unset($_SESSION['scmedia']);
            header('Location: '.sb_sanitize_header(SB_DOMAIN.'/?su_action=soc_error'));
        }
    }
}

/**
 * Функция авторизации или регистрации пользователя на сайте
 * @param string $netName
 */
function fParseResponse($netName){
    require_once (SB_CMS_LIB_PATH . '/oauth/sbSocAuth.php');
    $obj = sbSocAuth::getInstance($netName)->getUserData()->doLogin();

    if(!$obj->hasError()){
        if(!isset($_SERVER['HTTP_REFERER'])
        || strpos($_SERVER['HTTP_REFERER'], SB_DOMAIN) === false
        || strpos($_SERVER['HTTP_REFERER'], 'logout') !== false
        || strpos($_SERVER['HTTP_REFERER'], 'soc_error') !== false)
        {
            $referer = SB_DOMAIN;
        }
        else
        {
            $referer = $_SERVER['HTTP_REFERER'];
        }
        sb_setcookie('su_show_info', 1);

        header('Location: ' . sb_sanitize_header($referer));
        exit(0);
    }else{
        fSocial_Login_Set_System_Error($obj->getSystemErrors());
        fSocial_Login_Set_UserError($obj->getUserErrors());
        unset($_SESSION['scmedia']);
        header('Location: '.sb_sanitize_header(SB_DOMAIN.'/?su_action=soc_error'));
        exit(0);
    }
    unset($_SESSION['scmedia']);
}

/**
 * Добавление ошибок, возвращаемых классами работы с соц. сетями, в системный журнал
 * @param array $errors
 */
function fSocial_Login_Set_System_Error($errors){
    if(!empty($errors)){
        sb_add_system_message(implode('<br/>', $errors), SB_MSG_WARNING);
    }
}

/**
 * Сохранение сообщений для последующего показа пользователю на сайте
 * @param array $errors
 */
function fSocial_Login_Set_UserError($errors){
    if(!empty($errors)){
        $messages = implode('<br/>', $errors);
        $_SESSION['error_message'] = trim($messages);
    }
}
