<?php
require_once(SB_CMS_LANG_PATH.'/pl_sprav.h.lng.php');

if ($_SESSION['sbPlugins']->register('pl_sprav', PL_SPRAV_H_PLUGIN_NAME, 'http://www.sbuilder.ru/docs/helps40/sprav.doc'))
{
	$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.PL_SPRAV_H_PLUGIN_NAME, 'init');
    $_SESSION['sbPlugins']->addToExportImport(true, false);

	if ($_SESSION['sbPlugins']->isRightAvailable('pl_sprav', 'design_read'))
	{
		$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_SPRAV_H_MENU_NAME.'>'.PL_SPRAV_H_MENU_ITEM, 'design', 'pl_sprav_design_24.png');
	}

	$_SESSION['sbPlugins']->addUserEvent('init', 'fSprav_Init', 'read', PL_SPRAV_H_PLUGIN_NAME);
	$_SESSION['sbPlugins']->addUserEvent('edit', 'fSprav_Edit', 'read', PL_SPRAV_H_EDIT_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('edit_submit', 'fSprav_Edit_Submit', 'elems_edit', PL_SPRAV_H_EDIT_TITLE);

	$_SESSION['sbPlugins']->addUserEvent('edit_cat', 'fSprav_Edit_Cat', 'read', PL_SPRAV_H_CAT_EDIT_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('edit_cat_submit', 'fSprav_Edit_Cat_Submit', 'categs_edit', PL_SPRAV_H_CAT_EDIT_TITLE);

	$_SESSION['sbPlugins']->addUserEvent('design', 'fSprav_Design', 'design_read', PL_SPRAV_H_DESIGN_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('design_edit', 'fSprav_Design_Edit', 'design_read', PL_SPRAV_H_DESIGN_EDIT_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('design_edit_submit', 'fSprav_Design_Edit_Submit', 'design_edit', PL_SPRAV_H_DESIGN_EDIT_TITLE);

    $_SESSION['sbPlugins']->addUserEvent('set_active', 'fSprav_Set_Active', 'elems_edit');
    $_SESSION['sbPlugins']->addUserEvent('field_reload', 'fSprav_Field_Reload', 'read');

	$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'pl_sprav_delim', PL_SPRAV_H_PLUGIN_NAME, '', '');
	$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_sprav_increment', PL_SPRAV_H_SETTING_INCREMENT, 'number', '', '10');

	$fields = array();
	$fields['s_id'] = array('title' => PL_SPAV_H_S_ID_LABEL, 'flags' => '8');
	$fields['s_title'] = array('title' => PL_SPAV_H_S_TITLE_LABEL, 'flags' => '4');
	$fields['s_prop1'] = array('title' => PL_SPAV_H_S_PROP1_LABEL, 'flags' => '5');
	$fields['s_prop2'] = array('title' => PL_SPAV_H_S_PROP2_LABEL, 'flags' => '5');
	$fields['s_prop3'] = array('title' => PL_SPAV_H_S_PROP3_LABEL, 'flags' => '5');
	$fields['s_sort'] = array('title' => PL_SPAV_H_S_SORT_LABEL, 'flags' => '8');
	$fields['s_ext_id'] = array('title' => PL_SPAV_H_S_EXT_ID_LABEL, 'flags' => '8');
    $fields['s_active'] = array('title' => PL_SPRAV_H_S_ACTIVE_LABEL, 'flags' => '4');

	$cat_fields = array();
	$cat_fields['show_prop1'] = array('title' => PL_SPAV_H_SHOW_DESRC_1, 'flags' => '10');
	$cat_fields['show_prop2'] = array('title' => PL_SPAV_H_SHOW_DESRC_2, 'flags' => '10');
	$cat_fields['show_prop3'] = array('title' => PL_SPAV_H_SHOW_DESRC_3, 'flags' => '10');

	$_SESSION['sbPlugins']->addFieldsInfo('sb_sprav', 's_id', 's_title', $fields, $cat_fields);

	$_SESSION['sbPlugins']->addToCache();
}

$_SESSION['sbPlugins']->addSystemEvent('get_sprav', 'fSprav_Get_Sprav', PL_SPRAV_H_GET_SPRAV_TITLE);
$_SESSION['sbPlugins']->addSystemEvent('get_sprav_data', 'fSprav_Get_Sprav_Data', PL_SPRAV_H_GET_SPRAV_DATA_TITLE);
$_SESSION['sbPlugins']->addSystemEvent('get_options', 'fSprav_Get_Options');

$_SESSION['sbPlugins']->addSystemEvent('elem_list', 'fSprav_Get_Elem_List', PL_SPRAV_H_ELEM_LIST);
$_SESSION['sbPlugins']->addSystemEvent('elem_full', 'fSprav_Get_Elem_Full', PL_SPRAV_H_ELEM_FULLTEXT);

$_SESSION['sbPlugins']->addElem(PL_SPRAV_H_ELEM_LIST, 'list', 'fSprav_Elem_List_Comp', 'fSprav_Elem_List_Info', 'elem_list', 700, 700, 'design_edit', 'pl_sprav_design');
$_SESSION['sbPlugins']->addElem(PL_SPRAV_H_ELEM_FULLTEXT, 'full', 'fSprav_Elem_Full_Comp', 'fSprav_Elem_Full_Info', 'elem_full', 700, 250, 'design_edit', 'pl_sprav_design');

sb_add_rights();

$_SESSION['sbPlugins']->addEventsRights('design_read', RIGHTS_H_DESIGN_READ_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('design_edit', RIGHTS_H_DESIGN_EDIT_RIGHT);
?>