<?php
/********************************** вспомогательные функции, использующиеся дургими модулями ***********************************/
function fSprav_Get_Sprav()
{
    require_once(SB_CMS_LIB_PATH.'/sbJustCategs.inc.php');

    $categs = new sbJustCategs('pl_sprav');

    $multi = intval($_GET['multi']) == 1 ? true : false;

    if ($multi)
    {
        $js_str = '
            function chooseCat()
            {
                var id_ar = sbCatTree.getAllSelected();
                var text_ar = sbCatTree.getAllSelectedText();

                var res = new Object();
                res.ids = id_ar.replace(/\^/g, ",");
                res.text = text_ar;

                sbReturnValue(res);
            }';

        $categs->mCategsSelectedIds = array();
        if (isset($_GET['ids']) && $_GET['ids'] != '')
        {
            $categs->mCategsSelectedIds = explode(',', $_GET['ids']);
        }

        $categs->mCategsMultiSelect = true;
    }
    else
    {
        $js_str = '
            function chooseCat()
            {
                var id = sbCatTree.getSelectedItemId();
                var text = sbCatTree.getItemText(id);

                var res = new Object();
                res.ids = id;
                res.text = text;

                sbReturnValue(res);
            }';

        $categs->mCategsSelectedId = isset($_GET['ids']) ? intval($_GET['ids']) : -1;
    }

    $footer_str = '<table cellspacing="0" cellpadding="7" width="100%" class="form">
    <tr><td class="footer" style="padding-top: 2px;">
        <div class="footer" style="margin:0;">
        <button onclick="chooseCat();">'.KERNEL_CHOOSE.'</button>&nbsp;&nbsp;&nbsp;
        <button onclick="sbCloseDialog();">'.KERNEL_CANCEL.'</button>
        </div>
    </td></tr></table>';

    $categs->mCategsUseRights = false;
    $categs->mCategsMenu = false;
    $categs->mCategsClosed = false;
    $categs->mCategsRubrikator = false;
    $categs->mCategsCount = false;

    $categs->mCategsJavascriptStr = $js_str;

    $categs->showTree($footer_str);
    $categs->init();
}

function fSprav_Get_Sprav_Data()
{
    $sprav_ids = preg_replace('/[^0-9\,]+/i', '', $_GET['sprav']);
    $elem_ids = isset($_GET['ids']) ? explode(',', preg_replace('/[^0-9\,]+/i', '', $_GET['ids'])) : array();
    $subcategs = $_GET['subcateg'] == 1 ? true : false;
    $ajax = isset($_GET['ajax']) && $_GET['ajax'] == 1 ? true : false;
    $readonly = isset($_GET['readonly']) && $_GET['readonly'] == 1 ? true : false;

    $root_cat_id = -1;
    if ($ajax && isset($_GET['cat_id']))
    	$root_cat_id = intval($_GET['cat_id']);

    if (isset($_GET['fld']) && trim($_GET['fld']) != '')
    {
    	$fld = preg_replace('/[^A-Za-z_0-9]/', '', $_GET['fld']);
    }
    else
    {
    	$fld = 's_title';
    }

    $res = sql_query('SELECT MIN(cat_level) FROM sb_categs WHERE cat_id IN (0, '.$sprav_ids.')');
	if (!$res)
    {
        sb_show_message(PL_SPRAV_H_NO_DATA_MSG, true, 'warning');
        return;
    }

    list($min_level) = $res[0];

    $root_cat_title = '';
    $result = '';

    if ($root_cat_id == -1 && $ajax)
    {
    	// Подгружаем разделы
    	$res = sql_query('SELECT -1, "", c.cat_id, c.cat_title, c.cat_level FROM sb_categs c
    		WHERE c.cat_id IN (0, '.$sprav_ids.') AND c.cat_level=?d AND
    		(SELECT COUNT(*) FROM sb_categs c1, sb_catlinks l WHERE l.link_cat_id=c1.cat_id AND c1.cat_left >= c.cat_left AND c1.cat_right <= c.cat_right AND c.cat_ident = "pl_sprav") > 0
    		ORDER BY c.cat_left', $min_level);

    	if (!$res)
    	{
    		sb_show_message(PL_SPRAV_H_NO_DATA_MSG, true, 'warning');
        	return;
    	}
    }
    else
    {
    	if ($ajax)
    	{
    		$cat_res = sql_query('SELECT cat_title, cat_left, cat_right, cat_level FROM sb_categs WHERE cat_id=?d', $root_cat_id);
    		if ($cat_res)
    		{
    			list($root_cat_title, $cat_left, $cat_right, $min_level) = $cat_res[0];
    		}

    		if ($subcategs)
    		{
    			// вытаскиваем разделы
    			if ($cat_res)
   					$cat_res = sql_query('SELECT -1, "", c.cat_id, c.cat_title, c.cat_level FROM sb_categs c
   						WHERE c.cat_ident="pl_sprav" AND c.cat_level=?d AND c.cat_left > ?d AND c.cat_right < ?d AND
   						(SELECT COUNT(*) FROM sb_categs c1, sb_catlinks l WHERE l.link_cat_id=c1.cat_id AND c1.cat_left >= c.cat_left AND c1.cat_right <= c.cat_right AND c.cat_ident = "pl_sprav") > 0
   						ORDER BY cat_left', $min_level + 1, $cat_left, $cat_right);

    			// вытаскиваем элементы
    			$res = sql_query('SELECT s.s_id, s.'.$fld.', c.cat_id, c.cat_title, c.cat_level FROM sb_sprav s, sb_catlinks l, sb_categs c WHERE c.cat_id = ?d AND l.link_cat_id = ?d AND l.link_el_id=s.s_id ORDER BY s.s_sort, s.'.$fld, $root_cat_id, $root_cat_id);

    			if (!$cat_res && !$res)
    			{
    				if ($root_cat_title != '')
    					echo '<img src="'.SB_CMS_IMG_URL.'/tree/folderOpen.gif" width="18" height="18">&nbsp;<b>'.$root_cat_title.'</b><br>';
    				return;
    			}

    			if ($cat_res && $res)
    				$res = array_merge($res, $cat_res);
    			elseif (!$res)
    				$res = $cat_res;
    		}
    		else
    		{
    			// вытаскиваем элементы
    			$res = sql_query('SELECT s.s_id, s.'.$fld.', c.cat_id, c.cat_title, c.cat_level FROM sb_sprav s, sb_catlinks l, sb_categs c WHERE c.cat_id = ?d AND l.link_cat_id = ?d AND l.link_el_id=s.s_id  ORDER BY s.s_sort, s.'.$fld, $root_cat_id, $root_cat_id);

    			if (!$res)
    			{
    				if ($root_cat_title != '')
    					echo '<img src="'.SB_CMS_IMG_URL.'/tree/folderOpen.gif" width="18" height="18">&nbsp;<b>'.$root_cat_title.'</b><br>';
    				return;
    			}
    		}
    	}
    	else
    	{
		    if ($subcategs)
		    {
		    	$res = sql_query('SELECT cat_left, cat_right FROM sb_categs WHERE cat_id IN (0, '.$sprav_ids.')');
		        if ($res)
		        {
		            $sql = '(';
		            $num = count($res);
		            for ($i = 0; $i < $num; $i++)
		            {
		                list($left, $right) = $res[$i];
		                $sql .= 'c.cat_left >= '.$left.' AND c.cat_right <= '.$right.($i != $num - 1 ? ' OR ' : '');
		            }
		            $sql .= ')';

		            $res = sql_query('SELECT DISTINCT s.s_id, s.'.$fld.', c.cat_id, c.cat_title, c.cat_level FROM sb_sprav s, sb_catlinks l, sb_categs c WHERE c.cat_ident="pl_sprav" AND '.$sql.' AND l.link_cat_id=c.cat_id AND l.link_el_id=s.s_id  ORDER BY c.cat_left, s.s_sort, s.'.$fld);
		        }
		    }
		    else
		    {
		        $res = sql_query('SELECT DISTINCT s.s_id, s.'.$fld.', c.cat_id, c.cat_title, c.cat_level FROM sb_sprav s, sb_catlinks l, sb_categs c WHERE c.cat_id IN (0, '.$sprav_ids.') AND l.link_cat_id = c.cat_id AND l.link_el_id=s.s_id  ORDER BY c.cat_left, s.s_sort, s.'.$fld);
		    }
    	}
    }

    if (!$res || count($res) == 0)
    {
        sb_show_message(PL_SPRAV_H_NO_DATA_MSG, true, 'warning');
        return;
    }

    if ($root_cat_id == -1)
    {
	    echo '<script>
	    	var ids_ar=[];
	    	var names_ar=[];
	    	';

	    if (count($elem_ids) > 0)
	    {
		    $sprav_res = sql_query('SELECT s_id, s_title FROM sb_sprav WHERE s_id IN (?a) AND s_active=1 ORDER BY s_sort, s_title', $elem_ids);
		    if ($sprav_res)
		    {
			    foreach($sprav_res as $value)
			    {
			    	echo 'ids_ar[ids_ar.length]='.$value[0].'; names_ar[names_ar.length]="'.str_replace('"', '\\"', $value[1]).'";';
			    }
		    }
	    }

	    echo '	function setChecked(el)
	    		{
	    			if (el.checked)
	    			{
	    				ids_ar[ids_ar.length]=el.value;
	    				names_ar[names_ar.length]=sbGetE("lbl_"+el.value).innerHTML;
	    			}
	    			else
	    			{
	    				for (var i = 0; i < ids_ar.length; i++)
	    				{
	    					if (ids_ar[i] == el.value)
	    					{
	    						ids_ar.splice(i, 1);
	    						names_ar.splice(i, 1);
	    						break;
	    					}
	    				}
	    			}
	    		}
	            function chooseData()
	            {
	                var separator = "'.str_replace('"', '\\"', $_GET['separator']).'";
	                var ids = "";
	                var names = "";
	                var found = 0;

	                for (var i = 0; i < ids_ar.length; i++)
		            {
		            	ids += ids_ar[i] + ",";
		            	if (found < 4)
	                        names += names_ar[i] + separator;

	                    found++;
		            }

	                if (found > 0)
	                {
	                    ids = ids.substr(0, ids.length -1);
	                    names = names.substr(0, names.length - separator.length);
	                    if (found > 4)
	                        names += " ...";
	                }

	                var res = new Object();
	                res.ids = ids;
	                res.text = names;

	                sbReturnValue(res);
	            }

	            var loading_cat = -1;
	            function loadData(cat_id)
	            {
	            	if (loading_cat > 0)
	            		return;

	            	loading_cat = cat_id;
	            	sbLoadAsync(sb_cms_empty_file + "?event=pl_sprav_get_sprav_data&ids='.$_GET['ids'].'&sprav='.$sprav_ids.'&subcateg='.$_GET['subcateg'].'&ajax='.($ajax ? '1' : '0').'&readonly='.($readonly ? '1' : '0').'&separator='.'&fld='.$_GET['fld'].'&cat_id=" + cat_id, afterLoadData);
				    sbShowMsgDiv("'.KERNEL_LOADING.'", "loading.gif", false);
	            }
	            function afterLoadData(res)
	            {
	            	sbHideMsgDiv();

	            	var div_el = sbGetE("cat_" + loading_cat);
	            	if (res != "")
	            	{
	            		div_el.innerHTML = res;
	            	}
	            	loading_cat = -1;
	            }
	            function resizeArea()
	            {
	                var tab_con_el = sbGetE("sb_tabs_con");
	                var tab_bot_el = sbGetE("sb_tabs_bottom");
	                if (tab_con_el && tab_bot_el)
	                {
	                    tab_con_el.style.height = Math.max(0, parseInt(document.body.clientHeight) - (_isIE ? 26 : 46) - parseInt(tab_bot_el.offsetHeight));
	                }
	            }

	            sbAddEvent(window, "load", resizeArea);
	            sbAddEvent(window, "resize", resizeArea);
	          </script>
	          <table cellpadding="0" cellspacing="0" border="0" width="100%" height="100%" style="background-color: #FFF5E0;">
	          <tr><td valign="top" class="sbTabsPage"><div id="sb_tabs_con">';
    }

    $num = count($res);
    $old_cat_id = -1;
    $num_divs = 0;
    for ($i = 0; $i < $num; $i++)
    {
        list($s_id, $s_title, $cat_id, $cat_title, $cat_level) = $res[$i];

        if ($old_cat_id != $cat_id)
        {
            if ($old_cat_id != -1)
            {
                $result .= str_repeat('</div>', $num_divs);
                $num_divs = 0;
            }

            if ($cat_id != $root_cat_id)
            {
            	$num_divs += 2;
	            if ($ajax)
	            {
	 				$result .= '<div style="margin:5px 0 0 '.(($cat_level - $min_level) * 20).'px" id="cat_'.$cat_id.'"><a href="#" onclick="loadData('.$cat_id.')"><img src="'.SB_CMS_IMG_URL.'/tree/folderClosed.gif" width="18" height="18" border="0">&nbsp;<b>'.$cat_title.'</b></a><br /><div style="margin:5px 0px 5px 20px;">';
	            }
	            else
	            {
	            	$result .= '<div style="margin:5px 0 0 '.(($cat_level - $min_level) * 20).'px" id="cat_'.$cat_id.'"><img src="'.SB_CMS_IMG_URL.'/tree/folderOpen.gif" width="18" height="18">&nbsp;<b>'.$cat_title.'</b><br><div style="margin:5px 0px 5px 20px;">';
	            }
            }
            else
            {
            	$num_divs++;
            	$result .= '<div style="margin:5px 0px 5px 20px;">';
            }

            $old_cat_id = $cat_id;
        }

        if ($s_id > 0)
        	$result .= '<input type="checkbox"'.($readonly ? ' disabled="disabled"' : '').' value="'.$s_id.'" id="chk_'.$s_id.'"'.(in_array($s_id, $elem_ids) ? ' checked="checked"' :'').' onclick="setChecked(this)">&nbsp;<label for="chk_'.$s_id.'" id="lbl_'.$s_id.'">'.$s_title.' <sup>('.$s_id.')</sup></label><br>';
    }
    $result .= str_repeat('</div>', $num_divs);

    if ($root_cat_id > 0)
    {
    	if ($root_cat_title == '')
    	{
	    	$res = sql_query('SELECT cat_title FROM sb_categs WHERE cat_id=?d', $root_cat_id);
	    	if ($res)
	    	{
	    		list($root_cat_title) = $res[0];
	    	}
    	}

    	if ($root_cat_title != '')
    		$result = '<img src="'.SB_CMS_IMG_URL.'/tree/folderOpen.gif" width="18" height="18">&nbsp;<b>'.$root_cat_title.'</b><br>'.$result;
    }

    echo $result;

    if ($root_cat_id == -1)
    {
    	echo '</div></td></tr>
          <tr><td id="sb_tabs_bottom" style="text-align: center;">
            <button onclick="chooseData();">'.KERNEL_CHOOSE.'</button>&nbsp;&nbsp;
            <button onclick="sbCloseDialog();">'.KERNEL_CANCEL.'</button>
          </td></tr></table>';
    }
}

function fSprav_Get_Options()
{
    $subcategs = $_GET['subcategs'] == 1 ? true : false;
	if (isset($_GET['fld']) && trim($_GET['fld']) != '')
    {
    	$fld = preg_replace('/[^A-Za-z_0-9]/', '', $_GET['fld']);
    }
    else
    {
    	$fld = 's_title';
    }

    if ($subcategs)
    {
        $res = sql_param_query('SELECT cat_left, cat_right FROM sb_categs WHERE cat_id=?d', $_GET['cat_id']);
        if ($res)
        {
            list($left, $right) = $res[0];
            $res = sql_query('SELECT DISTINCT s.s_id, s.'.$fld.' FROM sb_sprav s, sb_catlinks l, sb_categs c WHERE c.cat_ident="pl_sprav" AND c.cat_left >= '.$left.' AND c.cat_right <= '.$right.' AND l.link_cat_id=c.cat_id AND l.link_el_id=s.s_id ORDER BY s.s_sort, s.'.$fld);
        }
    }
    else
    {
        $res = sql_param_query('SELECT DISTINCT s.s_id, s.'.$fld.' FROM sb_sprav s, sb_catlinks l WHERE l.link_cat_id = ?d AND l.link_el_id=s.s_id ORDER BY s.s_sort, s.'.$fld, $_GET['cat_id']);
    }

    $result = '';
    if ($res)
    {
        $num = count($res);
        foreach($res as $key => $value)
        {
            list($s_id, $s_title) = $value;

            $result .= $s_id.'^^'.$s_title.($key != $num - 1 ? '::' : '');
        }
    }

    echo $result;
}

/********************************** функции построения диалоговых окон ***********************************/

/**
 * Вывод списка элементов справочника
 *
 */
function fSprav_Get_Elem_List()
{
	require_once(SB_CMS_LIB_PATH.'/sbJustCategs.inc.php');
    $params = unserialize($_GET['params']);
    echo '<script>
        function chooseCat()
        {
            var res = new Object();
            var params = new Array();

            var el_cats = sbCatTree.getAllSelected();
            if (el_cats.length == 0)
            {
                alert("'.PL_SPRAV_H_NO_CATS_MSG.'");
                return;
            }

            params["ids"] = el_cats;
            var el_temp = sbGetE("temp_id");
            if (el_temp)
            {
                params["temp_id"] = el_temp.value;
            }
            else
            {
                alert("'.PL_SPRAV_H_NO_TEMPS_MSG.'");
                return;
            }

            params["sort_field"] = sbGetE("sort_field").value;
            params["order"] = sbGetE("order").value;
            params["page"] = sbGetE("page").value;
            params["subcategs"] = sbGetE("subcategs").checked ? 1 : 0;
            params["show_selected"] = sbGetE("show_selected").checked ? 1 : 0;
            params["use_sort"] = sbGetE("use_sort").checked ? 1 : 0;

            res.temp_id = el_temp.value;
            res.params = sb_serialize(params);

            sbReturnValue(res);
        }
    </script>';

    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

    $layout = new sbLayout();
    $layout->mTableWidth = '100%';
    $layout->mTitleWidth = '200';

    $layout->addTab(PL_SPRAV_H_CATEGS);

    $categs = new sbJustCategs('pl_sprav');
    $categs->mCategsUseRights = false;
    $categs->mCategsMenu = false;
    $categs->mCategsMultiSelect = true;
    $categs->mCategsCount = false;
    $categs->mCategsSelectedIds = (isset($params['ids']) && $params['ids'] != '' ? explode('^', $params['ids']) : array());

    $layout->addField('', new sbLayoutHTML($categs->showTree('', '', '', false), true));
    $categs->init();

    $layout->addTab(PL_SPRAV_H_PROPS_TAB);
    $layout->addHeader(PL_SPRAV_H_PROPS_TAB);

    $options = array();
    $res = sql_query('SELECT categs.cat_title, sprav.st_id, sprav.st_title FROM sb_categs categs, sb_catlinks links, sb_sprav_temps sprav WHERE sprav.st_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_sprav_design" ORDER BY categs.cat_left, sprav.st_title');
    if ($res)
    {
        $old_cat_title = '';
        foreach ($res as $value)
        {
            list($cat_title, $st_id, $st_title) = $value;
            if ($old_cat_title != $cat_title)
            {
                $options[uniqid()] = '-'.$cat_title;
                $old_cat_title = $cat_title;
            }
            $options[$st_id] = $st_title;
        }
    }

    if (count($options) > 0)
    {
    	$fld = new sbLayoutSelect($options, 'temp_id');
        if (isset($_GET['temp_id']))
        {
            $fld->mSelOptions = array($_GET['temp_id']);
        }
    }
    else
    {
        $fld = new sbLayoutLabel('<div class="hint_div">'.PL_SPRAV_H_NO_TEMPS_LABEL.'</div>', '', '', false);
    }

    $layout->addField(PL_SPRAV_H_TEMPS_TITLE, $fld);

    $layout->addField('', new sbLayoutDelim());

	$fld = new sbLayoutPage(isset($params['page']) ? $params['page'] : '', 'page', '', 'style="width: 350px;"');
    $fld->mHTML = '<div class="hint_div">'.PL_SPRAV_H_PAGE_HINT.'</div>';

    $layout->addField(PL_SPRAV_H_PAGE, $fld);
	$layout->addField(PL_SPRAV_H_SUBCATEGS, new sbLayoutInput('checkbox', '1', 'subcategs', '', (isset($params['subcategs']) && $params['subcategs'] == 1 ? 'checked="checked"' : '')));
	$layout->addField(PL_SPRAV_H_SHOW_SELECTED, new sbLayoutInput('checkbox', '1', 'show_selected', '', (isset($params['show_selected']) && $params['show_selected'] == 1 ? 'checked="checked"' : '')));

	$layout->addField('', new sbLayoutDelim());

	$order = array('DESC' => PL_SPRAV_H_SORT_DESC,
                   'ASC'  => PL_SPRAV_H_SORT_ASC);

	$fields = array('s_title' => PL_SPRAV_H_SORT_TITLE,
                    's_sort' => PL_SPRAV_H_SORT_SORT);

    $fld1 = new sbLayoutSelect($fields, 'sort_field');
    $fld1->mSelOptions = array((isset($params['sort_field']) ? $params['sort_field'] : 's_title'));
    $fld2 = new sbLayoutSelect($order, 'order');
    $fld2->mSelOptions = array((isset($params['order']) && $params['order'] != '' ? $params['order'] : 'ASC'));
    $fld1->mHTML = '&nbsp;&nbsp;'.$fld2->getField();

    $layout->addField(PL_SPRAV_H_SORT_FIELD, $fld1);

    //Использовать сортировку
   	$layout->addField('', new sbLayoutDelim());
	$layout->addField(PL_NEWS_H_ELEM_USE_SORT, new sbLayoutInput('checkbox', '0', '', 'use_sort', (isset($params['use_sort']) && $params['use_sort'] == 1 ? 'checked="checked"' : '')));

    $layout->addButton('button', KERNEL_SAVE, '', '', 'onclick="chooseCat();"'.($res ? '' : ' disabled="disabled"'));
    $layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');

	$layout->show();
}

/**
 * Вывод элемента справочника
 *
 */
function fSprav_Get_Elem_Full()
{
    $params = unserialize($_GET['params']);

    echo '<script>
        function choose()
        {
            var res = new Object();
            var params = new Array();

            var el_temp = sbGetE("temp_id");
            if (el_temp)
            {
                params["temp_id"] = el_temp.value;
            }
            else
            {
                alert("'.PL_SPRAV_H_NO_TEMPS_MSG.'");
                return;
            }

            res.temp_id = el_temp.value;
            res.params = sb_serialize(params);

            sbReturnValue(res);
        }
    </script><br /><br />';

    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

    $layout = new sbLayout();
    $layout->mTableWidth = '95%';
    $layout->mTitleWidth = '150';

    $layout->addHeader(PL_SPRAV_H_ELEM_FULLTEXT);

    $res = sql_query('SELECT categs.cat_title, sprav.st_id, sprav.st_title FROM sb_categs categs, sb_catlinks links, sb_sprav_temps sprav WHERE sprav.st_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_sprav_design" ORDER BY categs.cat_left, sprav.st_title');
    if ($res)
    {
        $options = array();
        $old_cat_title = '';
        foreach ($res as $value)
        {
            list($cat_title, $st_id, $st_title) = $value;
            if ($old_cat_title != $cat_title)
            {
                $options[uniqid()] = '-'.$cat_title;
                $old_cat_title = $cat_title;
            }
            $options[$st_id] = $st_title;
        }

        $fld = new sbLayoutSelect($options, 'temp_id');
        $fld->mSelOptions = array($params['temp_id']);

        $layout->addField(PL_SPRAV_H_TEMPS_TITLE, $fld);
    }
	else
	{
	    $layout->addField(PL_SPRAV_H_TEMPS_TITLE, new sbLayoutLabel('<div class="hint_div">'.PL_SPRAV_H_NO_TEMPS_LABEL.'</div>', '', '', false));
	}

    $layout->addButton('button', KERNEL_SAVE, '', '', 'onclick="choose();"'.($res ? '' : ' disabled="disabled"'));
    $layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');

    $layout->show();
}

/********************************** функции получения информации по элементам модуля ***********************************/

/**
 * Вывод списка элементов справочника
 *
 */
function fSprav_Elem_List_Info($params)
{
	$in_str = implode(',', explode('^', $params['ids']));
    $in_str = '(0,'.$in_str.')';

    $categs_str = '';
    $res = sql_query('SELECT cat_title FROM sb_categs WHERE cat_id IN '.$in_str.' ORDER BY cat_left');
    if ($res)
    {
        $categs_str = '';
        foreach ($res as $value)
        {
            $categs_str .= $value[0].', ';
        }
        $categs_str = substr($categs_str, 0, -2);
    }

    $res = sql_param_query('SELECT categs.cat_title, temps.st_title FROM sb_categs categs, sb_catlinks links, sb_sprav_temps temps
                          WHERE temps.st_id=?d AND links.link_el_id=temps.st_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_sprav_design"', $params['temp_id']);

    echo '<div style="padding-bottom: 5px;"><b>'.PL_SPRAV_H_INFO_CATEG.':</b> '.($categs_str != '' ? $categs_str : '<span style="color:red;">'.PL_SPRAV_H_INFO_CATEGS_WAS_DELETED_MSG.'</span>').'</div>
          <div style="padding-bottom: 5px;"><b>'.PL_SPRAV_H_TEMPS_TITLE.':</b> '.($res ? $res[0][0].' -&gt; '.$res[0][1] : '<span style="color:red;">'.PL_SPRAV_H_INFO_TEMP_WAS_DELETED_MSG.'</span>').'</div>
          '.(isset($params['page']) && $params['page'] != '' ? '<div style="padding-bottom: 5px;"><b>'.PL_SPRAV_H_PAGE_TITLE.':</b> '.$params['page'].'</div>' : '').'
          <div style="padding-bottom: 5px;"><b>'.PL_SPRAV_H_SUBCATEGS.':</b> '.(isset($params['subcategs']) && $params['subcategs'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>';
}

/**
 * Вывод элемента справочника
 *
 */
function fSprav_Elem_Full_Info($params)
{
    $res = sql_param_query('SELECT categs.cat_title, temps.st_title FROM sb_categs categs, sb_catlinks links, sb_sprav_temps temps
                          WHERE temps.st_id=?d AND links.link_el_id=temps.st_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_sprav_design"', $params['temp_id']);

    echo '<div style="padding-bottom: 5px;"><b>'.PL_SPRAV_H_TEMPS_TITLE.':</b> '.($res ? $res[0][0].' -&gt; '.$res[0][1] : '<span style="color:red;">'.PL_SPRAV_H_INFO_TEMP_WAS_DELETED_MSG.'</span>').'</div>';
}

/********************************** функции получения элементов модуля ***********************************/

/**
 * Вывод списка элементов справочника
 *
 */
function fSprav_Elem_List_Comp($el_id, $temp_id, $params, $tag_id)
{
    return "<?php include_once SB_CMS_PL_PATH.'/pl_sprav/prog/pl_sprav.php';\n
        fSprav_Elem_List('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id');\n
        ?>";
}

/**
 * Вывод элемента справочника
 *
 */
function fSprav_Elem_Full_Comp($el_id, $temp_id, $params, $tag_id)
{
    return "<?php include_once SB_CMS_PL_PATH.'/pl_sprav/prog/pl_sprav.php';\n
        fSprav_Elem_Full('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id');\n
        ?>";
}

function fSprav_Field_Reload()
{
    if(!isset($_GET['fld_type']) || $_GET['fld_type'] == ''
    || !isset($_GET['sprav_ids']) || $_GET['sprav_ids'] == ''
    || !isset($_GET['fld_name']) || $_GET['fld_name'] == '')
    {
        echo 'FALSE';
        return;
    }

    $_GET['sprav_ids'] = preg_replace('/[^0-9,]/'.SB_PREG_MOD, '', $_GET['sprav_ids']);
    $_GET['fld_name'] = preg_replace('/[^a-zA-Z0-9_]/'.SB_PREG_MOD, '', $_GET['fld_name']);

    $fld_id = preg_replace('/^user_f_(\d+).*/', '$1', $_GET['fld_name']);

    $pl_fields_settings = array();
    $pl_categs_settings = array();

    $res = sql_param_query('SELECT pd_plugin_ident, pd_fields, pd_categs FROM sb_plugins_data WHERE pd_fields REGEXP \'s:2:"id";(s:[[:digit:]]+:"'.$fld_id.'")|(i:'.$fld_id.')\' OR pd_categs REGEXP \'s:2:"id";(s:[[:digit:]]+:"'.$fld_id.'")|(i:'.$fld_id.')\'');
    if($res)
    {
        $ident = $res[0][0];
        $pl_fields_settings = unserialize($res[0][1]);
        $pl_categs_settings = unserialize($res[0][2]);
    }

    $settings = array();
    $categs = false;

    if(!empty($pl_fields_settings))
    {
        foreach ($pl_fields_settings as $fld)
        {
            if ($fld['id'] == $fld_id)
            {
                $settings = $fld;
                break;
            }
        }
    }

    if(empty($settings) && !empty($pl_categs_settings))
    {
        foreach ($pl_categs_settings as $fld)
        {
            if ($fld['id'] == $fld_id)
            {
                $settings = $fld;
                $categs = true;
                break;
            }
        }
    }

    if(empty($settings))
    {
        echo 'FALSE';
        return;
    }

    $f_value = '';
    if(!$categs && isset($_GET['id']))
    {
        $pl_data = $_SESSION['sbPlugins']->getPluginsInfo();
        $table = $pl_data[$ident]['meta_data']['table'];
        $pkey = $pl_data[$ident]['meta_data']['id'];

        $res = sql_param_query('SELECT ?# FROM ?# WHERE ?#=?d', 'user_f_'.$fld_id, $table, $pkey, intval($_GET['id']));
        if($res)
        {
            $f_value = $res[0][0];
        }
    }
    elseif($categs && isset($_GET['cat_id']))
    {
        $res = sql_param_query('SELECT cat_fields FROM sb_categs WHERE cat_id=?d', intval($_GET['cat_id']));
        if($res)
        {
            $fields = unserialize($res[0][0]);
            if(isset($fields[$_GET['fld_name']]))
            {
                $f_value = $fields[$_GET['fld_name']];
            }
        }
    }


    $f_mandatory = isset($settings['mandatory']) && $settings['mandatory'] == 1 ? true : false;
    $f_style = '';
    $f_attribs = isset($settings['attribs']) ? $settings['attribs'] : '';


        $settings = $settings['settings'];

        $field_right = 'edit';
        $f_right = $_SESSION['sbAuth']->getFieldRight($ident, array($_GET['fld_name']), array('view', 'edit'), $categs, ($categs? $pl_categs_settings : $pl_fields_settings));

        if (isset($f_right[$_GET['fld_name']]['view']) && $f_right[$_GET['fld_name']]['view'] == 0 &&
        isset($f_right[$_GET['fld_name']]['edit']) && $f_right[$_GET['fld_name']]['edit'] == 0)
        {
            //continue;
        }
        elseif (isset($f_right[$_GET['fld_name']]['view']) && $f_right[$_GET['fld_name']]['view'] == 1 &&
        isset($f_right[$_GET['fld_name']]['edit']) && $f_right[$_GET['fld_name']]['edit'] == 0)
        {
            $f_attribs .= ' disabled="disabled"';
            $field_right = 'view';
        }

        if (isset($settings['width']) && $settings['width'] != '')
        {
            $f_style .= 'width: ' . $settings['width'] . ';';
        }

        if (isset($settings['widths']) && $settings['widths'] != '')
        {
            $f_style .= 'width: ' . $settings['widths'] . ';';
        }

        if (isset($settings['height']) && $settings['height'] != '')
        {
            $f_style .= 'height: ' . $settings['height'] . ';';
        }

        $matches = array();
        if (preg_match_all('/style[\s]*=[\s]*["\']([^"\'].*?)["\']/si' . SB_PREG_MOD, $f_attribs, $matches))
        {
            foreach ($matches[1] as $style)
            {
                $f_style .= $style;
            }

            $f_attribs = trim(preg_replace('/style[\s]*=[\s]*["\']([^"\'].*?)["\']/si' . SB_PREG_MOD, '', $f_attribs));
        }

        if ($f_style != '')
            $f_style = 'style="' . $f_style . '"';

        $f_style .= ' ' . $f_attribs;


    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

    if($_GET['fld_type'] == 'checkbox')
    {
        $fld_type = 'checkboxes';
    }
    else
    {
        $fld_type = $_GET['fld_type'];
    }

    if($_GET['fld_type'] != 'sprav_link')
    {
        $fld = new sbLayoutSpravData($fld_type, $_GET['sprav_ids'], $f_value, $_GET['fld_name'], '', $f_style, $f_mandatory);

        $fld->mSubCategs = (isset($settings['subcategs']) && $settings['subcategs'] == 1);

        switch($_GET['fld_type'])
        {
            case 'select':
                $fld->mRows = isset($settings['rows'])? $settings['rows'] : 1;
                break;
            case 'multiselect_sprav':
                $fld->mAJAX = isset($settings['sprav_ajax']) && $settings['sprav_ajax'] == 1;
                $fld->mSeparator = isset($settings['separator']) ? $settings['separator'] : ',&nbsp;';
                $fld->mReadOnly = ($field_right != 'edit');
        }
    }
    else
    {
        $fld = new sbLayoutSpravLink($_GET['sprav_ids'], $f_value, $_GET['fld_name']);
        $fld->mSpravTitle = isset($settings['sprav_title'])? $settings['sprav_title'] : '';
    }
    echo $fld->getField();
}
?>