<?php
function fSprav_Get($args)
{
	static $cat_fields = null;

	if (is_null($cat_fields))
	{
		$cat_fields = array();

		if (!isset($_GET['id']))
			$_GET['id'] = '';

		$res = sql_query('SELECT cat_fields FROM sb_categs WHERE cat_id=?d', isset($_GET['cat_id']) ? $_GET['cat_id'] : $_GET['id']);
		if ($res)
		{
			list($cat_fields) = $res[0];

			if (trim($cat_fields) != '')
			{
				$cat_fields = unserialize($cat_fields);
			}
		}
	}

    if($args['s_active']){
        $active_color = 'green';
        $active_text = KERNEL_YES;
    }else{
        $active_color = 'red';
        $active_text = KERNEL_NO;
    }

	$result = '<b><a href="javascript:void(0);" onclick="sbElemsEdit(event);">'.$args['s_title'].'</a></b>
	<div class="smalltext" style="margin-top: 7px;">'.
    	(isset($args['s_id']) ? PL_SPRAV_DESIGN_EDIT_ID_TAG.': <span style="color:#33805E;">'.$args['s_id'].'</span><br/>' : '').
		(isset($cat_fields['show_prop1']) && $cat_fields['show_prop1'] == 1 && trim($args['s_prop1']) != '' ? sprintf(PL_SPRAV_GET_PROP, '1').': <span style="color: #33805E;">'.$args['s_prop1'].'</span><br />' : '').
		(isset($cat_fields['show_prop2']) && $cat_fields['show_prop2'] == 1 && trim($args['s_prop2']) != '' ? sprintf(PL_SPRAV_GET_PROP, '2').': <span style="color: #33805E;">'.$args['s_prop2'].'</span><br />' : '').
		(isset($cat_fields['show_prop3']) && $cat_fields['show_prop3'] == 1 && trim($args['s_prop3']) != '' ? sprintf(PL_SPRAV_GET_PROP, '3').': <span style="color: #33805E;">'.$args['s_prop3'].'</span><br />' : '').
		PL_SPRAV_GET_ORDER.': <span style="color: #33805E;">'.$args['s_sort'].'</span><br/>'.
        PL_SPRAV_EDIT_ACTIVE.': <span style="color: '.$active_color.';">'.$active_text.'</span>
	</div>';

    return $result;
}

function fSprav_Init()
{
	require_once(SB_CMS_LIB_PATH.'/sbElements.inc.php');

	$elems = new sbElements('sb_sprav', 's_id', 's_title', 'fSprav_Get', 'pl_sprav_init', 'pl_sprav');

    if(isset($_GET['show_only']) && trim($_GET['show_only']) != '')
    {
        //Выбираем подкатегории выводимых категорий и добавляем в список показываемых
        if(isset($_GET['subcategs']) && $_GET['subcategs'] == 1)
        {
            $res = sql_param_assoc('SELECT cat_left, cat_right FROM sb_categs WHERE cat_ident="pl_sprav" AND cat_id IN ('.trim($_GET['show_only']).')');
            $where = '';
            if($res)
            {
                foreach($res as $row)
                {
                    $where .= '(cat_left > '.$row['cat_left'].' AND cat_right < '.$row['cat_right'].') OR';
                }

                if($where != '')
                {
                    $where = substr($where, 0, -2);
                    $res = sql_param_query('SELECT cat_id FROM sb_categs WHERE cat_ident="pl_sprav" AND '.$where);
                    if($res)
                    {
                        $tmp = array();
                        foreach($res as $row)
                        {
                            $tmp[] = $row[0];
                        }

                        $_GET['show_only'] = trim($_GET['show_only']).','.implode(',', $tmp);
                    }
                }
            }
        }

        //Отсеиваем разделы на доступ к которым у пользователя нет прав
        $where_str = '';
        if(!$_SESSION['sbAuth']->isAdmin())
        {
            $uid = 'u'.$_SESSION['sbAuth']->getUserId();

        	foreach ($_SESSION['sbAuth']->getUserGroups() as $gid)
        	{
        		$where_str .= "CONCAT('^', cat_rights, '^') NOT LIKE '%^g$gid^%' AND ";
        	}

        	$where_str .= "CONCAT('^', cat_rights, '^') NOT LIKE '%^".$uid."^%'";
        	$where_str = 'OR ('.$where_str.')';
        }

        $res = sql_param_query('SELECT cat_id FROM sb_categs WHERE cat_ident="pl_sprav" AND (cat_id NOT IN ('.trim($_GET['show_only']).') '.$where_str.')');
        if($res)
        {
            $elems->mCategsNeverShowCats = array();
            foreach($res as $row)
            {
                $elems->mCategsNeverShowCats[] = $row[0];
            }
        }
        $elems->mCategsSelectedId = -1;
    }

	$elems->mCategsRootName = PL_SPRAV_ROOT_NAME;

	$elems->addField('s_sort');   // номер сортировки элемента справочника
	$elems->addField('s_prop1');  // описание 1
	$elems->addField('s_prop2');  // описание 2
	$elems->addField('s_prop3');  // описание 3
    $elems->addField('s_active'); // статус публикации

	$elems->addFilter(PL_SPRAV_FILTER_ID, 's_id', 'number');
	$elems->addFilter(PL_SPRAV_EDIT_TITLE, 's_title', 'string');

    $elems->addSorting(PL_SPRAV_SORT_BY_ID,  's_id');
    $elems->addSorting(PL_SPRAV_SORT_BY_NAME,  's_title');
    $elems->addSorting(PL_SPRAV_SORT_BY_ORDER, 's_sort');

    $elems->mElemsEditEvent =  'pl_sprav_edit';
    $elems->mElemsEditDlgWidth = 800;
	$elems->mElemsEditDlgHeight = 700;

	$elems->mElemsAddEvent =  'pl_sprav_edit';
    $elems->mElemsAddDlgWidth = 800;
	$elems->mElemsAddDlgHeight = 700;

	$elems->mCategsAddEvent = 'pl_sprav_edit_cat';
	$elems->mCategsAddDlgWidth = 750;
	$elems->mCategsAddDlgHeight = 400;

	$elems->mCategsEditEvent = 'pl_sprav_edit_cat';
	$elems->mCategsEditDlgWidth = 750;
	$elems->mCategsEditDlgHeight = 400;

	$elems->mElemsUseLinks = true;
	$elems->mCategsClosed = false;

    $elems->mCategsDeleteWithElementsMenu = true;
    $elems->mCategsPasteWithElementsMenu = true;

    $elems->mElemsJavascriptStr .= '
		function sbSpravExport(c)
		{
			if(c && sbSelCat)
			{
				var cat_id = sbSelCat.id;
    		}
    		else
    		{
				var cat_id = sbCatTree.getSelectedItemId();
			}

			var args = new Object();
			var form = sbGetE("filter_form");
			if(form)
			{
				var els = form.elements;
				for(var i = 0; i < els.length; i++)
				{
					if(els[i] && els[i].type != "button" && els[i].value != "")
					{
						var reg_spin = new RegExp("spin_");

						if(reg_spin.test(els[i].id))
						{
							args[els[i].name] = {};
							args[els[i].name]["value"]= els[i].value;
							args[els[i].name]["type"]= "number";
						}
						else if(els[i].type == "text")
						{
							args[els[i].name] = {};
							args[els[i].name]["value"]= els[i].value;
							args[els[i].name]["type"]= "string";
						}
    				}
				}
    		}

			var strPage = "'.SB_CMS_DIALOG_FILE.'?event=pl_export_edit&ident=pl_sprav&cat_id="+ cat_id;
			var strAttr = "resizable=1,width=765,height=600";
			sbShowModalDialog(strPage, strAttr, null, args);
		}

		function sbSpravImport(c)
		{
			if(c && sbSelCat)
			{
				var cat_id = sbSelCat.id;
    		}
    		else
    		{
				var cat_id = sbCatTree.getSelectedItemId();
			}

			var args = new Object();

			var strPage = "'.SB_CMS_DIALOG_FILE.'?event=pl_export_import_edit&ident=pl_sprav&cat_id="+ cat_id;
			var strAttr = "resizable=1,width=650,height=370";

			sbShowModalDialog(strPage, strAttr, sbAfterSpravImport, args);
		}

		function sbAfterSpravImport()
		{
			window.location.href = "'.SB_CMS_CONTENT_FILE.'?event=pl_sprav_init";
		}';

    if ($_SESSION['sbPlugins']->isRightAvailable('pl_sprav', 'elems_edit'))
    {
        $elems->mElemsJavascriptStr .= '
        function sbPublishStatus(c){
            var cat_id = "";
            var ids = "0";
            if(c && sbSelCat)
			{
				var cat_id = sbSelCat.id;
    		}

            for (var i = 0; i < sbSelectedEls.length; i++)
			{
			    var el = sbGetE("el_" + sbSelectedEls[i]);
			    if (el)
			    {
			        ids += "," + el.getAttribute("el_id");
			    }
			}

            var query = "'.SB_CMS_EMPTY_FILE.'?event=pl_sprav_set_active";
            if(cat_id != "")
            {
                query += "&cat_id="+cat_id;
            }else{
                query += "&ids="+ids;
            }

            var res = sbLoadSync(query);

            if (res != "TRUE")
            {
                alert("'.PL_SPRAV_SHOWHIDE_ERROR.'");
                return;
            }

            var div_el = sbGetE("elems_list_div");
            var from = "";
            if (div_el)
            {
                from = div_el.getAttribute("from");
            }
            var url = sb_cms_empty_file + "?event=" + sb_elems_event + "&id=" + sbCatTree.getSelectedItemId() + "&page_elems=" + from;
            sbElemsShow(url);
        }';

        $elems->addElemsMenuItem(PL_SPRAV_SHOWHIDE_MENU, 'sbPublishStatus()');
        $elems->addCategsMenuItem(PL_SPRAV_SHOWHIDE_MENU, 'sbPublishStatus(true)');
    }

	$elems->addElemsMenuItem(PL_SPRAV_EDIT_EXPORT, 'sbSpravExport()', false);
	//$elems->addElemsMenuItem(PL_SPRAV_EDIT_IMPORT, 'sbSpravImport()', false);

	$elems->addCategsMenuItem(PL_SPRAV_EDIT_EXPORT, 'sbSpravExport(true)');
	//$elems->addCategsMenuItem(PL_SPRAV_EDIT_IMPORT, 'sbSpravImport(true)');

	$elems->init();
}

function fSprav_Edit()
{
	$edit_group = sbIsGroupEdit();
	// проверка прав доступа
	if ($edit_group)
    {
    	if (!fCategs_Check_Elems_Rights($_GET['ids'][0], $_GET['cat_id'], 'pl_sprav'))
			return;
    }
    elseif (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'], 'pl_sprav'))
    {
		return;
    }

	if (isset($_GET['id']) && $_GET['id'] != '' && !$edit_group)
	{
   		$result = sql_param_query('SELECT s_title, s_prop1, s_prop2, s_prop3, s_sort, s_active FROM sb_sprav WHERE s_id=?d', $_GET['id']);

   		if ($result)
	    {
        	list($s_title, $s_prop1, $s_prop2, $s_prop3, $s_sort, $s_active) = $result[0];
	    }
	    else
	    {
	        sb_show_message(PL_SPRAV_EDIT_ERROR, true, 'warning');
	        return;
	    }
	}
	else
	{
	    $s_title = $s_prop1 = $s_prop2 = $s_prop3 = '';
        $s_active = 1;
	    $incr = sbPlugins::getSetting('sb_sprav_increment');

	    if ($incr != 0)
	    {
		    $res = sql_query('SELECT MAX(s_sort) FROM sb_sprav');
		    if ($res)
		    {
		        list($max) = $res[0];
		    }
		    else
		    {
		        $max = 0;
		    }
		    $s_sort = $max + $incr;
	    }
	    else
	    {
	    	$s_sort = 0;
	    }

	    $_GET['id'] = '';
	}

    echo '<script>
		function checkValues()
		{
		    var el = sbGetE("s_title");
			'.($edit_group ? '
            var ch_s = sbGetE("ch_s_title");
            ' : '').'
            if (el.value == "" '.($edit_group ? ' && ch_s.checked' : '').')
			{
				alert("'.PL_SPRAV_EDIT_NO_TITLE_MSG.'");
				return false;
			}
		}';

	if($edit_group)
	{
		echo '
			function cancel()
            {
				sbReturnValue("refresh");
			}
			sbAddEvent(window, "close", cancel);';
	}
	echo '</script>';

    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

    $layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE.'?event=pl_sprav_edit_submit'.($_SERVER['QUERY_STRING'] != '' ? '&'.$_SERVER['QUERY_STRING'] : ''));

    $layout->addTab(PL_SPRAV_EDIT_TAB1);
    $layout->addHeader(PL_SPRAV_H_EDIT_TITLE);

    $layout->addField(PL_SPRAV_EDIT_TITLE.sbGetGroupEditCheckbox('s_title', $edit_group), new sbLayoutInput('text', $s_title, 's_title', '', 'style="width:530px;"', true));

    $layout->addField('', new sbLayoutDelim());
	$layout->addField(PL_SPRAV_EDIT_SORT.sbGetGroupEditCheckbox('s_sort', $edit_group), new sbLayoutInput('text', $s_sort, 's_sort', 'spin_s_sort', 'style="width:50px;"'));

    $layout->addField(PL_SPRAV_EDIT_ACTIVE.sbGetGroupEditCheckbox('s_active', $edit_group), new sbLayoutInput('checkbox', '1', 's_active', 's_active', $s_active == 1?'checked="checked"':''));

    $layout->addTab(PL_SPRAV_EDIT_TAB2);
    $layout->addField('', new sbLayoutDelim());

    $fld = new sbLayoutTextarea($s_prop1, 's_prop1', '', 'style="width:100%;height:90px;"');
    $fld->mShowEditorBtn = true;
    $layout->addField(PL_SPRAV_EDIT_PROP1.sbGetGroupEditCheckbox('s_prop1', $edit_group), $fld);

    $fld = new sbLayoutTextarea($s_prop2, 's_prop2', '', 'style="width:100%;height:90px;"');
    $fld->mShowEditorBtn = true;
    $layout->addField(PL_SPRAV_EDIT_PROP2.sbGetGroupEditCheckbox('s_prop2', $edit_group), $fld);

	$fld = new sbLayoutTextarea($s_prop3, 's_prop3', '', 'style="width:100%;height:90px;"');
	$fld->mShowEditorBtn = true;
	$layout->addField(PL_SPRAV_EDIT_PROP3.sbGetGroupEditCheckbox('s_prop3', $edit_group), $fld);


	$layout->addButton('submit', KERNEL_SAVE, '', '', ($_SESSION['sbPlugins']->isRightAvailable('pl_sprav', 'elems_edit') ? '' : 'disabled'));
	$layout->addButton('button', KERNEL_CANCEL, '', '', ($edit_group ? 'onclick="cancel()"' : 'onclick="sbCloseDialog()"'));

	$layout->show();
}

function fSprav_Edit_Submit()
{
	$edit_group = sbIsGroupEdit();

	//	проверка прав доступа
	if ($edit_group)
	{
		if (!fCategs_Check_Elems_Rights($_GET['ids'][0], $_GET['cat_id'], 'pl_sprav'))
		{
			return;
		}
	}
	else if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'], 'pl_sprav'))
	{
		return;
	}

	if (!isset($_GET['id']))
        $_GET['id'] = '';

    $ch_s_title = $ch_s_prop1 = $ch_s_prop2 = $ch_s_prop3 = $ch_s_sort = $ch_s_active = 0;
    $s_title = $s_prop1 = $s_prop2 = $s_prop3 = $s_sort = '';
    $s_active = 0;

	extract($_POST);

	if ((!$edit_group || $edit_group && $ch_s_title == 1) && $s_title == '')
    {
		sb_show_message(PL_SPRAV_EDIT_NO_TITLE_MSG, false, 'warning');
		fSprav_Edit();
		return;
	}

	$row = array();

	if (!$edit_group || $edit_group && $ch_s_title == 1)
		$row['s_title'] = $s_title;

	if (!$edit_group || $edit_group && $ch_s_prop1 == 1)
		$row['s_prop1'] = $s_prop1;

	if (!$edit_group || $edit_group && $ch_s_prop2 == 1)
		$row['s_prop2'] = $s_prop2;

	if (!$edit_group || $edit_group && $ch_s_prop3 == 1)
		$row['s_prop3'] = $s_prop3;

	if (!$edit_group || $edit_group && $ch_s_sort == 1)
		$row['s_sort'] = $s_sort;

    if (!$edit_group || $edit_group && $ch_s_active == 1)
		$row['s_active'] = $s_active;

	if ($edit_group || $_GET['id'] != '')
	{
		if (!$edit_group)
    	{
	    	$res = sql_param_query('SELECT s_title FROM sb_sprav WHERE s_id=?d', $_GET['id']);
    	}
	    else
	    {
	    	$res = true;
	    }

	    if ($res)
	    {
	        if (!$edit_group)
            {
				sql_param_query('UPDATE sb_sprav SET ?a WHERE s_id=?d', $row, $_GET['id'], sprintf(PL_SPRAV_EDIT_OK, $s_title));

				$row['s_id'] = intval($_GET['id']);

	            $footer_ar = fCategs_Edit_Elem();
	    	    if (!$footer_ar)
	    	    {
	    	        sb_show_message(PL_SPRAV_EDIT_ERROR, false, 'warning');
	                sb_add_system_message(sprintf(PL_SPRAV_EDIT_SYSTEMLOG_ERROR, $s_title), SB_MSG_WARNING);

	                fSprav_Edit();
	    		    return;
	    	    }
	    	    $footer_str = $GLOBALS['sbSql']->escape($footer_ar[0], false, false);
	    	    $footer_link_str = $GLOBALS['sbSql']->escape($footer_ar[1], false, false);

	            $html_str = fSprav_Get($row);
	    	    $html_str = sb_str_replace(array("\r\n", "\r", "\n"), '', $html_str);
	            $html_str = $GLOBALS['sbSql']->escape($html_str, false, false);

	    	    echo '<script>
	    		        var res = new Object();
	    		        res.html = "'.$html_str.'";
	    		        res.footer = "'.$footer_str.'";
	    		        res.footer_link = "'.$footer_link_str.'";
	    				sbReturnValue(res);
	    			  </script>';
            }
            else
            {
            	if (count($row) > 0)
            	{
            		sql_param_query('UPDATE sb_sprav SET ?a WHERE s_id IN (?a)', $row, $_GET['ids'], PL_SPRAV_EDIT_GROUP_OK);
					$date = time();

            		foreach ($_GET['ids'] as $val)
					{
            			sql_query('INSERT INTO sb_catchanges (el_id, cat_ident, change_date, change_user_id, action) VALUES (?d, ?, ?d, ?d, ?)', $val, 'pl_sprav', $date, $_SESSION['sbAuth']->getUserId(), 'edit');
					}
            	}

	            echo '<script>
						  sbReturnValue("refresh");
					  </script>';
			}
	    }
	    else
	    {
	        sb_show_message(PL_SPRAV_EDIT_ERROR, false, 'warning');
            sb_add_system_message(sprintf(PL_SPRAV_EDIT_SYSTEMLOG_ERROR, $s_title), SB_MSG_WARNING);

            fSprav_Edit();
		    return;
	    }
	}
	else
	{
	    $error = true;
	    if (sql_param_query('INSERT INTO sb_sprav SET ?a', $row))
	    {
    		$id = sql_insert_id();

    		if (fCategs_Add_Elem($id))
    		{
        		sb_add_system_message(sprintf(PL_SPRAV_ADD_OK, $s_title));

        		echo '<script>
        				sbReturnValue('.$id.');
        			  </script>';

        		$error = false;
    		}
    		else
    		{
    		    sql_query('DELETE FROM sb_sprav WHERE s_id="'.$id.'"');
    		}
	    }

	    if ($error)
	    {
			sb_show_message(sprintf(PL_SPRAV_ADD_ERROR, $s_title), false, 'warning');
			sb_add_system_message(sprintf(PL_SPRAV_ADD_SYSTEMLOG_ERROR, $s_title), SB_MSG_WARNING);

			fSprav_Edit();
			return;
		}
	}
}

function fSprav_Edit_Cat()
{
    $rights = array();
    $cat_rights = '';
    $cat_fields = array();

    if (isset($_GET['cat_id']))
    {
        if (!fCategs_Check_Rights($_GET['cat_id']))
        {
            sb_show_message(SB_ELEMS_DENY_MSG, true, 'warning');
            return;
        }

        $res = sql_param_query('SELECT cat_title, cat_fields, cat_rights FROM sb_categs WHERE cat_id=?d', $_GET['cat_id']);

        if ($res)
        {
            list($cat_title, $cat_fields, $cat_rights) = $res[0];

            if (trim($cat_fields) != '')
            {
            	$cat_fields = unserialize($cat_fields);
            }

            $_GET['cat_id_p'] = '';
        }
        else
        {
            sb_show_message(PL_SPRAV_EDIT_CAT_ERROR_NO_CATEG, true, 'warning');
            return;
        }
    }
    else
    {
        if (!fCategs_Check_Rights($_GET['cat_id_p']))
        {
            sb_show_message(SB_ELEMS_DENY_MSG, true, 'warning');
            return;
        }

        $res = sql_param_query('SELECT cat_fields, cat_rights FROM sb_categs WHERE cat_id=?d', $_GET['cat_id_p']);
        if ($res)
        {
            $cat_title = '';

            list($cat_fields, $cat_rights) = $res[0];

            if (trim($cat_fields) != '')
            {
            	$cat_fields = unserialize($cat_fields);
            }

            $_GET['cat_id'] = '';
        }
        else
        {
            sb_show_message(PL_SPRAV_EDIT_CAT_ERROR_NO_CATEG, true, 'warning');
            return;
        }
    }

    echo '<script>
    	function checkValues()
    	{
    	    var cat_title = sbGetE("cat_title");
            if (cat_title.value == "")
    		{
    			alert("'.PL_SPRAV_EDIT_CAT_NO_TITLE_MSG.'");
        		return false;
    		}

    		return true;
    	}
	</script><br /><br />';

    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

    $layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE.'?event=pl_sprav_edit_cat_submit&cat_id='.$_GET['cat_id'].'&cat_id_p='.$_GET['cat_id_p'], 'thisDialog', 'post', 'checkValues()');
    $layout->mTableWidth = '95%';
    $layout->mTitleWidth = 250;

    $layout->addHeader($_GET['cat_id'] != '' ? PL_SPRAV_EDIT_CAT_EDIT_TITLE : PL_SPRAV_EDIT_CAT_ADD_TITLE);

    $layout->addField(PL_SPRAV_EDIT_CAT_TITLE, new sbLayoutInput('text', $cat_title, 'cat_title', '', 'style="width:400px;"', true));

    $layout->addField('', new sbLayoutDelim());

    $layout->addField(sprintf(PL_SPRAV_EDIT_CAT_PROP, '1'), new sbLayoutInput('checkbox', '1', 'show_prop1', '', (isset($cat_fields['show_prop1']) && $cat_fields['show_prop1'] == 1 ? 'checked' : '')));
    $layout->addField(sprintf(PL_SPRAV_EDIT_CAT_PROP, '2'), new sbLayoutInput('checkbox', '1', 'show_prop2', '', (isset($cat_fields['show_prop2']) && $cat_fields['show_prop2'] == 1 ? 'checked' : '')));
    $layout->addField(sprintf(PL_SPRAV_EDIT_CAT_PROP, '3'), new sbLayoutInput('checkbox', '1', 'show_prop3', '', (isset($cat_fields['show_prop3']) && $cat_fields['show_prop3'] == 1 ? 'checked' : '')));

    $layout->addField('', new sbLayoutInput('hidden', $cat_rights, 'cat_rights'));

    $layout->addButton('submit', KERNEL_SAVE);
    $layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog()"');

    $layout->show();
}

function fSprav_Edit_Cat_Submit()
{
    $show_prop1 = 0;
    $show_prop2 = 0;
    $show_prop3 = 0;

    extract($_POST);

    $cat_fields = array();
    $cat_fields['show_prop1'] = $show_prop1;
    $cat_fields['show_prop2'] = $show_prop2;
    $cat_fields['show_prop3'] = $show_prop3;

    $cat_fields = serialize($cat_fields);

    if($_GET['cat_id'] != '')
    {
        if (!fCategs_Check_Rights($_GET['cat_id']))
        {
            sb_show_message(SB_ELEMS_DENY_MSG, true, 'warning');
            return;
        }

        $cat_id = intval($_GET['cat_id']);

        //редактирование
        $res = sql_param_query('SELECT cat_left, cat_right FROM sb_categs WHERE cat_id=?d', $cat_id);
        if ($res)
        {
            $result = sql_param_query('UPDATE sb_categs SET cat_title=?, cat_fields=? WHERE cat_id=?d', $cat_title, $cat_fields, $cat_id, sprintf(PL_SPRAV_EDIT_CAT_SYSLOG_EDIT_OK, $cat_title));
            if ($result)
            {
                list($cat_left, $cat_right) = $res[0];

                $count_res = sql_query('SELECT COUNT(*) FROM sb_categs categs, sb_catlinks links WHERE categs.cat_ident="pl_sprav" AND categs.cat_left >= '.$cat_left.' AND categs.cat_right <= '.$cat_right.' AND links.link_cat_id=categs.cat_id');
                if ($count_res)
                {
                    $cat_count = $count_res[0][0];
                }
                else
                {
                    $cat_count = 0;
                }

                echo '<script>
        	        var res = new Object();
                    res.cat_title = "'.str_replace('"', '\\"', $cat_title).' ['.$cat_count.']";
                    res.cat_closed = 0;
                    res.cat_rubrik = 0;
                    sbReturnValue(res);
        		  </script>';
            }
        }
        else
        {
            sb_show_message(PL_SPRAV_EDIT_CAT_EDIT_ERROR, true, 'warning');
            sb_add_system_message(sprintf(PL_SPRAV_EDIT_CAT_SYSLOG_EDIT_ERROR, $cat_title), SB_MSG_WARNING);
        }
    }
    else
    {
        if (!fCategs_Check_Rights($_GET['cat_id_p']))
        {
            sb_show_message(SB_ELEMS_DENY_MSG, true, 'warning');
            return;
        }

        //добавление
        require_once(SB_CMS_LIB_PATH.'/sbTree.inc.php');
        $tree = new sbTree('pl_sprav');

        $fields = array();
        $fields['cat_title'] = $cat_title;
        $fields['cat_closed'] = 0;
        $fields['cat_rubrik'] = 0;
        $fields['cat_rights'] = $cat_rights;
        $fields['cat_fields'] = $cat_fields;

        $cat_id = $tree->insertNode($_GET['cat_id_p'], $fields);
        if ($cat_id)
        {
            sb_add_system_message(sprintf(PL_SPRAV_EDIT_CAT_SYSLOG_ADD_OK, $cat_title));

            echo '<script>
    	        var res = new Object();
        	    res.cat_id = '.$cat_id.';
                res.cat_title = "'.str_replace('"', '\\"', $cat_title).' [0]";
                res.cat_closed = 0;
                res.cat_rubrik = 0;
                sbReturnValue(res);
    		  </script>';
        }
        else
        {
            sb_show_message(PL_SPRAV_EDIT_CAT_ADD_ERROR, true, 'warning');
            sb_add_system_message(sprintf(PL_SPRAV_EDIT_CAT_SYSLOG_ADD_ERROR, $cat_title), SB_MSG_WARNING);
        }
    }
}

function fSprav_Set_Active()
{
    if (!$_SESSION['sbPlugins']->isRightAvailable('pl_sprav', 'elems_edit'))
    {
		return;
	}

    if((!isset($_GET['cat_id']) || empty($_GET['cat_id'])) && (!isset($_GET['ids']) || empty($_GET['ids'])))
    {
        return;
    }

    $date = time();

    if(isset($_GET['cat_id']))
    {
        // выбираем элементы справочников
        $res = sql_query('SELECT link_el_id FROM sb_catlinks WHERE link_cat_id=?d', $_GET['cat_id']);
        if(!$res)
        {
            return;
        }

        $GET['ids'] = array();
        foreach($res as $row)
        {
            $_GET['ids'][] = $row[0];
            sql_query('INSERT INTO sb_catchanges (el_id, cat_ident, change_date, change_user_id, action) VALUES (?d, ?, ?d, ?d, ?)', $row[0], 'pl_sprav', $date, $_SESSION['sbAuth']->getUserId(), 'edit');
        }
    }
    else
    {
        sbIsGroupEdit(false);

        foreach ($_GET['ids'] as $val)
        {
        	sql_query('INSERT INTO sb_catchanges (el_id, cat_ident, change_date, change_user_id, action) VALUES (?d, ?, ?d, ?d, ?)', $val, 'pl_sprav', $date, $_SESSION['sbAuth']->getUserId(), 'edit');
        }
    }

    $res = sql_query('UPDATE sb_sprav SET s_active=IF(s_active=0,1,0) WHERE s_id IN (?a)', $_GET['ids'], PL_SPRAV_SET_ACTIVE_SYSTEMLOG_OK);
    if ($res)
    	echo 'TRUE';
}


function fSprav_Design_Get($args)
{
    $result = '<b><a href="javascript:void(0);" onclick="sbElemsEdit(event);">'.$args['st_title'].'</a></b>';

    return $result;
}

function fSprav_Design()
{
    require_once(SB_CMS_LIB_PATH.'/sbElements.inc.php');

    $elems = new sbElements('sb_sprav_temps', 'st_id', 'st_title', 'fSprav_Design_Get', 'pl_sprav_design', 'pl_sprav_design');
    $elems->mCategsDeleteWithElementsMenu = true;
    $elems->mElemsIcon = SB_CMS_IMG_URL.'/plugins/pl_sprav_design_32.png';
    $elems->mCategsRootName = KERNEL_DESIGN_ROOT_NAME;

    $elems->addField('st_title');      // название макета дизайна

    $elems->addSorting(PL_SPRAV_SORT_BY_NAME, 'pt_title');

    $elems->mCategsPasteElemsMenuTitle = KERNEL_DESIGN_PASTE_ELEMS_MENU_TITLE;

    $elems->mElemsAddMenuTitle  = KERNEL_DESIGN_ELEMS_ADD_MENU_TITLE;
    $elems->mElemsEditMenuTitle = KERNEL_DESIGN_ELEMS_EDIT_MENU_TITLE;
    $elems->mElemsCopyMenuTitle = KERNEL_DESIGN_ELEMS_COPY_MENU_TITLE;
    $elems->mElemsCutMenuTitle  = KERNEL_DESIGN_ELEMS_CUT_MENU_TITLE;

    $elems->mElemsEditEvent =  'pl_sprav_design_edit';
    $elems->mElemsEditDlgWidth = 900;
	$elems->mElemsEditDlgHeight = 700;

	$elems->mElemsAddEvent =  'pl_sprav_design_edit';
    $elems->mElemsAddDlgWidth = 900;
	$elems->mElemsAddDlgHeight = 700;

	$elems->mCategsClosed = false;
	$elems->mCategsRubrikator = false;
	$elems->mElemsUseLinks = false;

	$elems->init();
}

function fSprav_Design_Edit($htmlStr = '', $footerStr = '')
{
	// проверка прав доступа
	if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'], 'pl_sprav_design'))
		return;

    if (count($_POST) == 0 && isset($_GET['id']) && $_GET['id'] != '')
	{
   		$result = sql_param_query('SELECT st_title, st_pagelist_id, st_perpage, st_no_elems, st_fields_temps, st_count, st_top, st_cat_top, st_element, st_empty, st_delim, st_cat_bottom, st_bottom, st_full_element
   		                           FROM sb_sprav_temps WHERE st_id=?d', $_GET['id']);

   		if ($result)
	    {
        	list($st_title, $st_pagelist_id, $st_perpage, $st_no_elems, $st_fields_temps, $st_count, $st_top, $st_cat_top, $st_element, $st_empty, $st_delim, $st_cat_bottom, $st_bottom, $st_full_element) = $result[0];
	    }
	    else
	    {
	        sb_show_message(PL_SPRAV_DESIGN_EDIT_ERROR, true, 'warning');
	        return;
	    }

	    if ($st_fields_temps != '')
	        $st_fields_temps = unserialize($st_fields_temps);
	    else
	        $st_fields_temps = array();
	    if(!isset($st_fields_temps['s_change_date']))
	    	$st_fields_temps['s_change_date'] = '{DAY}.{MONTH}.{LONG_YEAR} {HOUR}:{MINUTE}';
	}
	elseif (count($_POST) > 0)
	{
		$st_pagelist_id = -1;

    	extract($_POST);

    	if (!isset($_GET['id']))
            $_GET['id'] = '';
	}
	else
	{
	    $st_title = $st_no_elems = $st_top = $st_cat_top = $st_element = $st_empty = $st_delim = $st_cat_bottom = $st_bottom = $st_full_element = '';

	    $st_pagelist_id = -1;
	    $st_perpage = 0;
	    $st_count = 1;

	    $st_fields_temps = array();
	    $st_fields_temps['s_prop1'] = '{VALUE}';
	    $st_fields_temps['s_prop2'] = '{VALUE}';
	    $st_fields_temps['s_prop3'] = '{VALUE}';
	    $st_fields_temps['s_change_date'] = '{DAY}.{MONTH}.{LONG_YEAR} {HOUR}:{MINUTE}';

	    $_GET['id'] = '';
	}

    echo '<script>
	        function checkValues()
            {
                var el_title = sbGetE("st_title");
                if (el_title.value == "")
                {
          	         alert("'.PL_SPRAV_DESIGN_EDIT_NO_TITLE_MSG.'");
          	         return false;
                }
            }';

	if ($htmlStr != '')
	{
	    echo '
            function cancel()
            {
                var res = new Object();
		        res.html = "'.$htmlStr.'";
		        res.footer = "'.$footerStr.'";
		        res.footer_link = "";
				sbReturnValue(res);
            }
            sbAddEvent(window, "close", cancel);';
	}

	echo '</script>';

	require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

	$layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE.'?event=pl_sprav_design_edit_submit'.($_SERVER['QUERY_STRING'] != '' ? '&'.$_SERVER['QUERY_STRING'] : ''), 'thisDialog', 'post', 'checkValues()');
	$layout->mTableWidth = '95%';
	$layout->mTitleWidth = '200';

	$layout->addTab(PL_SPRAV_DESIGN_EDIT_TAB1);
	$layout->addHeader(PL_SPRAV_DESIGN_EDIT_TAB1);

	$layout->addField(PL_SPRAV_DESIGN_EDIT_TITLE, new sbLayoutInput('text', $st_title, 'st_title', '', 'style="width:450px;"', true));

	fPager_Design_Get($layout, $st_pagelist_id, 'st_pagelist_id', $st_perpage, 'st_perpage');

	$layout->addField('', new sbLayoutDelim());

	$layout->addField(PL_SPRAV_DESIGN_EDIT_NO_ELEMS, new sbLayoutTextarea($st_no_elems, 'st_no_elems', '', 'style="width:100%;height:50px;"'));

	$layout->addTab(PL_SPRAV_DESIGN_EDIT_TAB2);
	$layout->addHeader(PL_SPRAV_DESIGN_EDIT_TAB2);

	$tags = array('{VALUE}', '{ID}', '{TITLE}', '{CAT_ID}', '{CAT_TITLE}', '{LINK}');
	$tags_values = array(PL_SPRAV_DESIGN_EDIT_VALUE_TAG, PL_SPRAV_DESIGN_EDIT_ID_TAG, PL_SPRAV_DESIGN_EDIT_TITLE_TAG, PL_SPRAV_DESIGN_EDIT_CAT_ID_TAG, PL_SPRAV_DESIGN_EDIT_CAT_TITLE_TAG, PL_SPRAV_DESIGN_EDIT_LINK_TAG);

	$fld = new sbLayoutTextarea($st_fields_temps['s_prop1'], 'st_fields_temps[s_prop1]', '', 'style="width:100%;height:50px;"');
	$fld->mTags = $tags;
	$fld->mValues = $tags_values;
	$layout->addField(PL_SPRAV_EDIT_PROP1, $fld);

	$fld = new sbLayoutTextarea($st_fields_temps['s_prop2'], 'st_fields_temps[s_prop2]', '', 'style="width:100%;height:50px;"');
	$fld->mTags = $tags;
	$fld->mValues = $tags_values;
	$layout->addField(PL_SPRAV_EDIT_PROP2, $fld);

	$fld = new sbLayoutTextarea($st_fields_temps['s_prop3'], 'st_fields_temps[s_prop3]', '', 'style="width:100%;height:50px;"');
	$fld->mTags = $tags;
	$fld->mValues = $tags_values;
	$layout->addField(PL_SPRAV_EDIT_PROP3, $fld);

	// Дата последнего изменения
	$fld = new sbLayoutTextarea($st_fields_temps['s_change_date'], 'st_fields_temps[s_change_date]', '', 'style="width:100%;height:50px;"');
	$fld->mTags = array('{DAY}', '{WEEKDAY}', '{WEEKDAY_SHORT}', '{MONTH}', '{MONTH_TEXTUAL}', '{LONG_YEAR}', '{SHORT_YEAR}', '{HOUR}', '{MINUTE}');
	$fld->mValues = array(KERNEL_DAY_TAG, KERNEL_WEEKDAY_TAG_FULL, KERNEL_WEEKDAY_TAG_SHORT, KERNEL_MONTH_TAG, KERNEL_MONTH_NAME_TAG, KERNEL_YEAR_4_TAG, KERNEL_YEAR_2_TAG, KERNEL_HOURS_TAG, KERNEL_MINUTES_TAG);
	$layout->addField(PL_SPRAV_EDIT_LAST_CHANGE, $fld);

	$layout->addTab(PL_SPRAV_DESIGN_EDIT_TAB3);
	$layout->addHeader(PL_SPRAV_DESIGN_EDIT_TAB3);

	$layout->addField(PL_SPRAV_DESIGN_EDIT_COUNT, new sbLayoutInput('text', $st_count, 'st_count', 'spin_st_count', 'style="width:100px;"'));

	$fld = new sbLayoutTextarea($st_top, 'st_top', '', 'style="width:100%;height:100px;"');

	$flds_tags = array('{NUM_LIST}', '{ALL_COUNT}',
						'<a href=\'{SORT_ID_ASC}\'>'.PL_SPRAV_DESIGN_EDIT_SORT_ID_ASC_TAG.'</a>','<a href=\'{SORT_ID_DESC}\'>'.PL_SPRAV_DESIGN_EDIT_SORT_ID_DESC_TAG.'</a>',
						'<a href=\'{SORT_TITLE_ASC}\'>'.PL_SPRAV_DESIGN_EDIT_SORT_TITLE_ASC_TAG.'</a>','<a href=\'{SORT_TITLE_DESC}\'>'.PL_SPRAV_DESIGN_EDIT_SORT_TITLE_DESC_TAG.'</a>',
						'<a href=\'{SORT_PROP1_ASC}\'>'.PL_SPRAV_DESIGN_EDIT_SORT_PROP1_ASC_TAG.'</a>','<a href=\'{SORT_PROP1_DESC}\'>'.PL_SPRAV_DESIGN_EDIT_SORT_PROP1_DESC_TAG.'</a>',
						'<a href=\'{SORT_PROP2_ASC}\'>'.PL_SPRAV_DESIGN_EDIT_SORT_PROP2_ASC_TAG.'</a>','<a href=\'{SORT_PROP2_DESC}\'>'.PL_SPRAV_DESIGN_EDIT_SORT_PROP2_DESC_TAG.'</a>',
						'<a href=\'{SORT_PROP3_ASC}\'>'.PL_SPRAV_DESIGN_EDIT_SORT_PROP3_ASC_TAG.'</a>','<a href=\'{SORT_PROP3_DESC}\'>'.PL_SPRAV_DESIGN_EDIT_SORT_PROP3_DESC_TAG.'</a>',
						'<a href=\'{SORT_SORT_ASC}\'>'.PL_SPRAV_DESIGN_EDIT_SORT_SORT_ASC_TAG.'</a>','<a href=\'{SORT_SORT_DESC}\'>'.PL_SPRAV_DESIGN_EDIT_SORT_SORT_DESC_TAG.'</a>');
    $flds_vals = array(PL_SPRAV_DESIGN_EDIT_PAGELIST_TAG, PL_SPRAV_DESIGN_EDIT_ALLNUM_TAG,
							PL_SPRAV_DESIGN_EDIT_SORT_ID_ASC_TAG, PL_SPRAV_DESIGN_EDIT_SORT_ID_DESC_TAG,
							PL_SPRAV_DESIGN_EDIT_SORT_TITLE_ASC_TAG, PL_SPRAV_DESIGN_EDIT_SORT_TITLE_DESC_TAG,
							PL_SPRAV_DESIGN_EDIT_SORT_PROP1_ASC_TAG, PL_SPRAV_DESIGN_EDIT_SORT_PROP1_DESC_TAG,
							PL_SPRAV_DESIGN_EDIT_SORT_PROP2_ASC_TAG, PL_SPRAV_DESIGN_EDIT_SORT_PROP2_DESC_TAG,
							PL_SPRAV_DESIGN_EDIT_SORT_PROP3_ASC_TAG, PL_SPRAV_DESIGN_EDIT_SORT_PROP3_DESC_TAG,
							PL_SPRAV_DESIGN_EDIT_SORT_SORT_ASC_TAG, PL_SPRAV_DESIGN_EDIT_SORT_SORT_DESC_TAG);

    $fld->mTags = $flds_tags;
	$fld->mValues = $flds_vals;
	$layout->addField(PL_SPRAV_DESIGN_EDIT_TOP, $fld);

	$layout->addField('', new sbLayoutDelim());

	$fld = new sbLayoutTextarea($st_cat_top, 'st_cat_top', '', 'style="width:100%;height:100px;"');
	$fld->mTags = array('{CAT_TITLE}', '{CAT_COUNT}', '{CAT_LEVEL}', '{CAT_ID}');
	$fld->mValues = array(PL_SPRAV_DESIGN_EDIT_CATEG_TITLE_TAG, PL_SPRAV_DESIGN_EDIT_CATEG_NUM_TAG, PL_SPRAV_DESIGN_EDIT_CATEG_LEVEL_TAG, PL_SPRAV_DESIGN_EDIT_CATEG_ID_TAG);
	$layout->addField(PL_SPRAV_DESIGN_EDIT_CAT_TOP, $fld);

	$fld = new sbLayoutTextarea($st_element, 'st_element', '', 'style="width:100%;height:250px;"');
	$fld->mTags = array('-', '{ELEM_NUMBER}', '{ID}', '{TITLE}', '{CHANGE_DATE}', '{PROP1}', '{PROP2}', '{PROP3}', '{LINK}', '-', '{CAT_TITLE}', '{CAT_COUNT}', '{CAT_LEVEL}', '{CAT_ID}');
	$fld->mValues = array(PL_SPRAV_DESIGN_EDIT_ELEMS_GROUP_TAG, PL_SPRAV_DESIGN_EDIT_ELEM_NUMBER_TAG, PL_SPRAV_DESIGN_EDIT_ID_TAG, PL_SPRAV_DESIGN_EDIT_TITLE_TAG, PL_SPRAV_DESIGN_EDIT_LAST_CHANGE_TAG, PL_SPRAV_DESIGN_EDIT_PROP1_TAG,
	                      PL_SPRAV_DESIGN_EDIT_PROP2_TAG, PL_SPRAV_DESIGN_EDIT_PROP3_TAG, PL_SPRAV_DESIGN_EDIT_LINK_TAG,
                          PL_SPRAV_DESIGN_EDIT_CATEG_GROUP_TAG, PL_SPRAV_DESIGN_EDIT_CATEG_TITLE_TAG, PL_SPRAV_DESIGN_EDIT_CATEG_NUM_TAG, PL_SPRAV_DESIGN_EDIT_CATEG_LEVEL_TAG, PL_SPRAV_DESIGN_EDIT_CATEG_ID_TAG);
	$layout->addField(PL_SPRAV_DESIGN_EDIT_ELEMENT, $fld);

	$fld = new sbLayoutTextarea($st_empty, 'st_empty', '', 'style="width:100%;height:100px;"');
	$layout->addField(PL_SPRAV_DESIGN_EDIT_EMPTY, $fld);

	$fld = new sbLayoutTextarea($st_delim, 'st_delim', '', 'style="width:100%;height:100px;"');
	$layout->addField(PL_SPRAV_DESIGN_EDIT_DELIM, $fld);

	$fld = new sbLayoutTextarea($st_cat_bottom, 'st_cat_bottom', '', 'style="width:100%;height:100px;"');
	$fld->mTags = array('{CAT_TITLE}', '{CAT_COUNT}', '{CAT_LEVEL}', '{CAT_ID}');
	$fld->mValues = array(PL_SPRAV_DESIGN_EDIT_CATEG_TITLE_TAG, PL_SPRAV_DESIGN_EDIT_CATEG_NUM_TAG, PL_SPRAV_DESIGN_EDIT_CATEG_LEVEL_TAG, PL_SPRAV_DESIGN_EDIT_CATEG_ID_TAG);
	$layout->addField(PL_SPRAV_DESIGN_EDIT_CAT_BOTTOM, $fld);

	$layout->addField('', new sbLayoutDelim());

	$fld = new sbLayoutTextarea($st_bottom, 'st_bottom', '', 'style="width:100%;height:100px;"');
	$fld->mTags = $flds_tags;
	$fld->mValues = $flds_vals;
	$layout->addField(PL_SPRAV_DESIGN_EDIT_BOTTOM, $fld);

	$layout->addTab(PL_SPRAV_DESIGN_EDIT_TAB4);
	$layout->addHeader(PL_SPRAV_DESIGN_EDIT_TAB4);

	$fld = new sbLayoutTextarea($st_full_element, 'st_full_element', '', 'style="width:100%;height:450px;"');
	$fld->mTags = array('-', '{ID}', '{TITLE}' ,'{CHANGE_DATE}', '{PROP1}', '{PROP2}', '{PROP3}', '-', '{CAT_TITLE}', '{CAT_COUNT}', '{CAT_LEVEL}', '{CAT_ID}');
	$fld->mValues = array(PL_SPRAV_DESIGN_EDIT_ELEMS_GROUP_TAG, PL_SPRAV_DESIGN_EDIT_ID_TAG, PL_SPRAV_DESIGN_EDIT_TITLE_TAG, PL_SPRAV_DESIGN_EDIT_LAST_CHANGE_TAG, PL_SPRAV_DESIGN_EDIT_PROP1_TAG,
	                      PL_SPRAV_DESIGN_EDIT_PROP2_TAG, PL_SPRAV_DESIGN_EDIT_PROP3_TAG,
                          PL_SPRAV_DESIGN_EDIT_CATEG_GROUP_TAG, PL_SPRAV_DESIGN_EDIT_CATEG_TITLE_TAG, PL_SPRAV_DESIGN_EDIT_CATEG_NUM_TAG, PL_SPRAV_DESIGN_EDIT_CATEG_LEVEL_TAG, PL_SPRAV_DESIGN_EDIT_CATEG_ID_TAG);
	$layout->addField(PL_SPRAV_DESIGN_EDIT_ELEMENT, $fld);

	$layout->addButton('submit', KERNEL_SAVE, 'btn_save', '', ($_SESSION['sbPlugins']->isRightAvailable('pl_sprav', 'design_edit') ? '' : 'disabled="disabled"'));
    if ($_GET['id'] != '')
        $layout->addButton('submit', KERNEL_APPLY, 'btn_apply', '', ($_SESSION['sbPlugins']->isRightAvailable('pl_sprav', 'design_edit') ? '' : 'disabled="disabled"'));
    $layout->addButton('button', KERNEL_CANCEL, '', '', $htmlStr != '' ? 'onclick="cancel()"' : 'onclick="sbCloseDialog()"');

    $layout->show();
}

function fSprav_Design_Edit_Submit()
{
	// проверка прав доступа
	if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'], 'pl_sprav_design'))
		return;

    if (!isset($_GET['id']))
        $_GET['id'] = '';

    $st_pagelist_id = 0;
    $st_fields_temps = array();

    extract($_POST);

    if ($st_title == '')
    {
        sb_show_message(PL_SPRAV_DESIGN_EDIT_NO_TITLE_MSG, false, 'warning');
        fSprav_Design_Edit();
        return;
    }

    $row['st_title'] = $st_title;
    $row['st_pagelist_id'] = $st_pagelist_id;
    $row['st_perpage'] = $st_perpage;
    $row['st_no_elems'] = $st_no_elems;
    $row['st_fields_temps'] = serialize($st_fields_temps);

    $row['st_count'] = $st_count;
    $row['st_top'] = $st_top;
    $row['st_cat_top'] = $st_cat_top;
    $row['st_element'] = $st_element;
    $row['st_empty'] = $st_empty;
    $row['st_delim'] = $st_delim;
    $row['st_cat_bottom'] = $st_cat_bottom;
    $row['st_bottom'] = $st_bottom;
    $row['st_full_element'] = $st_full_element;

    if ($_GET['id'] != '')
	{
	    $res = sql_param_query('SELECT st_title FROM sb_sprav_temps WHERE st_id=?d', $_GET['id']);
	    if ($res)
	    {
	        // редактирование
	        list($old_title) = $res[0];

    	    sql_param_query('UPDATE sb_sprav_temps SET ?a WHERE st_id=?d', $row, $_GET['id'], sprintf(PL_SPRAV_DESIGN_EDIT_OK, $old_title));
            sbQueryCache::updateTemplate('sb_sprav_temps', $_GET['id']);

            $footer_ar = fCategs_Edit_Elem('design_edit');
    	    if (!$footer_ar)
    	    {
    	        sb_show_message(PL_SPRAV_DESIGN_EDIT_ERROR, false, 'warning');
                sb_add_system_message(sprintf(PL_SPRAV_DESIGN_EDIT_SYSTEMLOG_ERROR, $old_title), SB_MSG_WARNING);

                fSprav_Design_Edit();
    		    return;
    	    }
    	    $footer_str = $GLOBALS['sbSql']->escape($footer_ar[0], false, false);

    	    $row['st_id'] = intval($_GET['id']);

            $html_str = fSprav_Design_Get($row);
    	    $html_str = sb_str_replace(array("\r\n", "\r", "\n"), '', $html_str);
            $html_str = $GLOBALS['sbSql']->escape($html_str, false, false);

    	    if (!isset($_POST['btn_apply']))
    	    {
        	    echo '<script>
        		        var res = new Object();
        		        res.html = "'.$html_str.'";
        		        res.footer = "'.$footer_str.'";
        		        res.footer_link = "";
        				sbReturnValue(res);
        			  </script>';
    	    }
    	    else
    	    {
    	        fSprav_Design_Edit($html_str, $footer_str);
    	    }
	    }
	    else
	    {
	        sb_show_message(PL_SPRAV_DESIGN_EDIT_ERROR, false, 'warning');
            sb_add_system_message(sprintf(PL_SPRAV_DESIGN_EDIT_SYSTEMLOG_ERROR, $st_title), SB_MSG_WARNING);

            fSprav_Design_Edit();
		    return;
	    }
	}
	else
	{
	    $error = true;
	    if (sql_param_query('INSERT INTO sb_sprav_temps SET ?a', $row))
	    {
    		$id = sql_insert_id();

    		if (fCategs_Add_Elem($id, 'design_edit'))
    		{
                sbQueryCache::updateTemplate('sb_sprav_temps', $id);
        		sb_add_system_message(sprintf(PL_SPRAV_DESIGN_ADD_OK, $st_title));

        		echo '<script>
        				sbReturnValue('.$id.');
        			  </script>';

        		$error = false;
    		}
    		else
    		{
    		    sql_query('DELETE FROM sb_sprav_temps WHERE st_id="'.$id.'"');
    		}
	    }

	    if ($error)
	    {
	        sb_show_message(sprintf(PL_SPRAV_DESIGN_ADD_ERROR, $st_title), false, 'warning');
            sb_add_system_message(sprintf(PL_SPRAV_DESIGN_ADD_SYSTEMLOG_ERROR, $st_title), SB_MSG_WARNING);

            fSprav_Design_Edit();
		    return;
	    }
	}
}

?>