<?php
/**
 * Вывод списка элементов справочника
 *
 */
function fSprav_Elem_List($el_id, $temp_id, $params, $tag_id)
{
	if ($GLOBALS['sbCache']->check('pl_sprav', $tag_id, array($el_id, $temp_id, $params)))
        return;

    $params = unserialize(stripslashes($params));
    $cat_ids = explode('^', $params['ids']);

	// если следует выводить подразделы, то вытаскиваем их ID
    if (isset($params['subcategs']) && $params['subcategs'] == 1)
    {
		$res = sbQueryCache::query('SELECT c.cat_id FROM sb_categs AS c, sb_categs AS c2
							WHERE c2.cat_left <= c.cat_left
							AND c2.cat_right >= c.cat_right
							AND c.cat_ident="pl_sprav"
							AND c2.cat_ident = "pl_sprav"
							AND c2.cat_id IN (?a)
							ORDER BY c.cat_left', $cat_ids);

        $cat_ids = array();
        if ($res)
        {
            foreach ($res as $value)
            {
                $cat_ids[] = $value[0];
            }
        }
        else
        {
            // указанные разделы были удалены
            $GLOBALS['sbCache']->save('pl_sprav', '');
            return;
        }
    }

	// вытаскиваем макет дизайна
    //$res = sql_param_query('SELECT st_count, st_top, st_cat_top, st_element, st_empty, st_delim,
    //            st_cat_bottom, st_bottom, st_pagelist_id, st_perpage, st_no_elems, st_fields_temps
    //            FROM sb_sprav_temps WHERE st_id=?d', $temp_id);
    $res = sbQueryCache::getTemplate('sb_sprav_temps', $temp_id);

    if (!$res)
    {
        sb_add_system_message(sprintf(KERNEL_PROG_NO_TEMPLATE, $_SERVER['PHP_SELF'], KERNEL_PROG_SPRAV_PLUGIN), SB_MSG_WARNING);
        $GLOBALS['sbCache']->save('pl_sprav', '');
        return;
    }

	list($st_count, $st_top, $st_cat_top, $st_element, $st_empty, $st_delim,
         $st_cat_bottom, $st_bottom, $st_pagelist_id, $st_perpage, $st_no_elems, $st_fields_temps) = $res[0];

    $st_fields_temps = unserialize($st_fields_temps);

    // вытаскиваем макет дизайна постраничного вывода
    $res = sbQueryCache::getTemplate('sb_pager_temps', $st_pagelist_id);

    if ($res)
    {
        list($pt_perstage, $pt_begin, $pt_next, $pt_previous, $pt_end, $pt_number, $pt_sel_number, $pt_page_list, $pt_delim) = $res[0];
    }
    else
    {
        $pt_page_list = '';
        $pt_perstage = 1;
    }

	// формируем SQL-запрос для сортировки
    if(isset($params['use_sort']) && $params['use_sort'] == '1' && isset($_REQUEST['s_f_spr']) && $_REQUEST['s_f_spr'] != '')
	{
		require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
		$elems_fields_sort_sql = sbLayout::getPluginFieldsSortSql('spr', 's');
	}
	else
	{
		$order = (isset($params['order']) && $params['order'] != '' ? ' '.$params['order'] : ' ASC');
		if ($params['sort_field'] != 's_title')
	    {
	    	$elems_fields_sort_sql =  ', s.s_sort'.$order.', s.s_title'.$order;
	    }
	    else
	    {
	    	$elems_fields_sort_sql =  ', s.s_title'.$order.', s.s_sort'.$order;
	    }
	}
	// используется ли группировка по разделам
    if ($st_cat_top != '' || $st_cat_bottom != '')
    {
        $categs_output = true;
    }
    else
    {
        $categs_output = false;
    }

    $elems_fields_where_sql = '';
	// Отключаем выводимый элемент, если выводится подробный элемент
	if (isset($params['show_selected']) && $params['show_selected'] == 1 && isset($_GET['sprav_id']))
	{
		$elems_fields_where_sql .= ' AND s.s_id != "'.intval($_GET['sprav_id']).'" ';
	}

    @require_once(SB_CMS_LIB_PATH.'/sbDBPager.inc.php');

    $pager = new sbDBPager($tag_id, $pt_perstage, $st_perpage);

    // выборка новостей, которые следует выводить
    $elems_total = true;

	$group_str = '';
	$group_res = sbQueryCache::query('SELECT COUNT(*) FROM sb_catlinks WHERE link_cat_id IN (?a) AND link_src_cat_id != 0', $cat_ids);
	if ($group_res && $group_res[0][0] > 0)
	{
	  	$group_str = ' GROUP BY s.s_id ';
	}

	if ($categs_output)
    {
        $res = $pager->init($elems_total, 'SELECT l.link_cat_id, s.s_id, s.s_title, s.s_prop1, s.s_prop2, s.s_prop3
                            FROM sb_sprav s, sb_catlinks l, sb_categs c
                            WHERE c.cat_id IN (?a) AND c.cat_id=l.link_cat_id AND l.link_el_id=s.s_id AND s.s_active=1
                            '.$elems_fields_where_sql.' '.$group_str.'
                            ORDER BY c.cat_left'.$elems_fields_sort_sql, $cat_ids);
    }
    else
    {
        $res = $pager->init($elems_total, 'SELECT l.link_cat_id, s.s_id, s.s_title, s.s_prop1, s.s_prop2, s.s_prop3
                            FROM sb_sprav s, sb_catlinks l
                            WHERE l.link_cat_id IN (?a) AND l.link_el_id=s.s_id AND s.s_active=1
                            '.$elems_fields_where_sql.' '.$group_str.'
                            '.($elems_fields_sort_sql != '' ? ' ORDER BY'.substr($elems_fields_sort_sql, 1) : ' ORDER BY s.s_title DESC'), $cat_ids);
    }

	if (!$res)
    {
        $GLOBALS['sbCache']->save('pl_sprav', $st_no_elems);
        return;
    }

	$count_sprav = $pager->mFrom + 1;
	$categs = array();
    if (sb_substr_count($st_cat_top, '{CAT_COUNT}') > 0 ||
        sb_substr_count($st_cat_bottom, '{CAT_COUNT}') > 0 ||
        sb_substr_count($st_element, '{CAT_COUNT}') > 0)
    {
    	$res_cat = sbQueryCache::query('SELECT c1.cat_id, c1.cat_title, c1.cat_level,
                (

                SELECT COUNT(l.link_el_id) FROM sb_categs c LEFT JOIN sb_catlinks l ON l.link_cat_id = c.cat_id, sb_sprav s
                WHERE c.cat_id = c1.cat_id
                AND l.link_el_id=s.s_id
                AND l.link_src_cat_id NOT IN (?a)
                AND s.s_active=1

                ) AS cat_count
                FROM sb_categs c1 WHERE c1.cat_id IN (?a)', $cat_ids, $cat_ids);
    }
    else
    {
        $res_cat = sbQueryCache::query('SELECT cat_id, cat_title, cat_level, "" AS cat_count
                FROM sb_categs WHERE cat_id IN (?a)', $cat_ids);
    }

	if ($res_cat)
    {
        foreach ($res_cat as $value)
        {
            $categs[$value[0]] = array();
            $categs[$value[0]]['title'] = $value[1];
            $categs[$value[0]]['level'] = $value[2] + 1;
            $categs[$value[0]]['count'] = $value[3];
        }
    }

    // строим список номеров страниц
    if ($pt_page_list != '')
    {
        $pager->mBeginTemp = $pt_begin;
        $pager->mBeginTempDisabled = '';
        $pager->mNextTemp = $pt_next;
        $pager->mNextTempDisabled = '';

        $pager->mPrevTemp = $pt_previous;
        $pager->mPrevTempDisabled = '';
        $pager->mEndTemp = $pt_end;
        $pager->mEndTempDisabled = '';

        $pager->mNumberTemp = $pt_number;
        $pager->mCurNumberTemp = $pt_sel_number;
        $pager->mDelimTemp = $pt_delim;
        $pager->mListTemp = $pt_page_list;

        $pt_page_list = $pager->show();
    }

    // верх вывода новостной ленты
     $flds_tags = array( '{SORT_ID_ASC}' ,'{SORT_ID_DESC}',
    					 '{SORT_TITLE_ASC}' ,'{SORT_TITLE_DESC}',
     					 '{SORT_PROP1_ASC}' ,'{SORT_PROP1_DESC}',
     					 '{SORT_PROP2_ASC}' ,'{SORT_PROP2_DESC}',
     					 '{SORT_PROP3_ASC}' ,'{SORT_PROP3_DESC}',
     					 '{SORT_SORT_ASC}' ,'{SORT_SORT_DESC}',);

    $query_str = $_SERVER['QUERY_STRING'];
    if(isset($_GET['s_f_spr']))
    {
    	$query_str = preg_replace('/[?&]?s_f_spr['.urlencode('[]').']*?=[A-z0-9%]+/i', '', $_SERVER['QUERY_STRING']);
    }

    $flds_href = $GLOBALS['PHP_SELF'].(!empty($query_str) ? '?'.$query_str.'&':'?').'s_f_spr=';

    $flds_vals = array( $flds_href.urlencode('s_id=ASC'),
    					$flds_href.urlencode('s_id=DESC'),
    					$flds_href.urlencode('s_title=ASC'),
    					$flds_href.urlencode('s_title=DESC'),
    					$flds_href.urlencode('s_prop1=ASC'),
    					$flds_href.urlencode('s_prop1=DESC'),
    					$flds_href.urlencode('s_prop2=ASC'),
    					$flds_href.urlencode('s_prop2=DESC'),
    					$flds_href.urlencode('s_prop3=ASC'),
    					$flds_href.urlencode('s_prop3=DESC'),
    					$flds_href.urlencode('s_sort=ASC'),
    					$flds_href.urlencode('s_sort=DESC'));

    $result = str_replace(array_merge(array('{NUM_LIST}', '{ALL_COUNT}'),$flds_tags), array_merge(array($pt_page_list, $elems_total),$flds_vals), $st_top);

    $tags = array('{CAT_TITLE}',
                  '{CAT_LEVEL}',
                  '{CAT_COUNT}',
                  '{CAT_ID}',
    			  '{ELEM_NUMBER}',
                  '{ID}',
                  '{TITLE}',
                  '{LINK}',
    			  '{CHANGE_DATE}',
    			  '{PROP1}',
    			  '{PROP2}',
    			  '{PROP3}');

    $dop_tags = array('{ID}',
    			  '{TITLE}',
    			  '{CAT_ID}',
    			  '{CAT_TITLE}',
    			  '{LINK}');

    $cur_cat_id = 0;
    $col = 0;
	$values = array();

    foreach ($res as $value)
    {
        $old_values = $values;
        $values = array();

        $href = ($params['page'] != '' ? $params['page'].'?sprav_id='.$value[1] : 'javascript: void(0);');
        $dop_values = array($value[1], $value[2], $value[0], strip_tags($categs[$value[0]]['title']), $href);

        $values[] = $categs[$value[0]]['title'];  // CAT_TITLE
        $values[] = $categs[$value[0]]['level'];  // CAT_LEVEL
        $values[] = $categs[$value[0]]['count'];  // CAT_COUNT
        $values[] = $value[0]; // CAT_ID
		$values[] = $count_sprav++;	//	ELEM_NUMBER
        $values[] = $value[1]; // ID
        $values[] = $value[2]; // TITLE
        $values[] = $href;     // LINK
    	// Дата последнего изменения
        if(sb_strpos($st_element, '{CHANGE_DATE}') !== false)
        {
        	$res1 = sbQueryCache::query('SELECT change_date FROM sb_catchanges WHERE el_id = ? AND cat_ident = ? ORDER BY change_date DESC LIMIT 0, 1', $value[1],'pl_sprav');
        	$values[] = isset($res1[0][0]) ? sb_parse_date($res1[0][0], $st_fields_temps['s_change_date']) : ''; //   CHANGE_DATE
        }
        else
       	{
        	$values[] = '';
       	}
        $values[] = ($value[3] != '' && !is_null($value[3]) ? str_replace(array_merge(array('{VALUE}'), $dop_tags),
                                   array_merge(array($value[3]), $dop_values),
                                   $st_fields_temps['s_prop1']) : ''); // PROP1

        $values[] = ($value[4] != '' && !is_null($value[4]) ? str_replace(array_merge(array('{VALUE}'), $dop_tags),
                                   array_merge(array($value[4]), $dop_values),
                                   $st_fields_temps['s_prop2']) : ''); // PROP2

        $values[] = ($value[5] != '' && !is_null($value[5]) ? str_replace(array_merge(array('{VALUE}'), $dop_tags),
                                   array_merge(array($value[5]), $dop_values),
                                   $st_fields_temps['s_prop3']) : ''); // PROP3

        if ($categs_output && $value[0] != $cur_cat_id)
        {
            if ($cur_cat_id != 0)
            {
                // низ вывода раздела
                while ($col < $st_count)
                {
                    $result .= $st_empty;
                    $col++;
                }
                $result .= str_replace($tags, $old_values, $st_cat_bottom);
            }
            // верх вывода раздела
            $result .= str_replace($tags, $values, $st_cat_top);
            $col = 0;
        }

        if ($col >= $st_count)
        {
            $result .= $st_delim;
            $col = 0;
        }

        $result .= str_replace($tags, $values, $st_element);

        $cur_cat_id = $value[0];
        $col++;
    }

    while ($col < $st_count)
    {
        $result .= $st_empty;
        $col++;
    }

    if ($categs_output)
    {
        // низ вывода раздела
        $result .= str_replace($tags, $values, $st_cat_bottom);
    }

    // низ вывода новостной ленты
    $result .= str_replace(array_merge(array('{NUM_LIST}', '{ALL_COUNT}'),$flds_tags), array_merge(array($pt_page_list, $elems_total),$flds_vals), $st_bottom);

    $result = preg_replace('/\{[_A-Z0-9'.$GLOBALS['sb_reg_upper_interval'].']+\}/'.SB_PREG_MOD, '', $result);
    $GLOBALS['sbCache']->save('pl_sprav', $result);
}

/**
 * Вывод элемента справочника
 *
 */
function fSprav_Elem_Full($el_id, $temp_id, $params, $tag_id)
{
	if ($GLOBALS['sbCache']->check('pl_sprav', $tag_id, array($el_id, $temp_id, $params)))
        return;

    $params = unserialize(stripslashes($params));

    if (!isset($_GET['sprav_id']))
    {
        return;
    }

	// вытаскиваем макет дизайна
    $res = sbQueryCache::query('SELECT st_full_element, st_fields_temps FROM sb_sprav_temps WHERE st_id=?d', $temp_id);

    if (!$res)
    {
        sb_add_system_message(sprintf(KERNEL_PROG_NO_TEMPLATE, $_SERVER['PHP_SELF'], KERNEL_PROG_SPRAV_PLUGIN), SB_MSG_ERROR);
        $GLOBALS['sbCache']->save('pl_sprav', '');
        return;
    }

    list($st_full_element, $st_fields_temps) = $res[0];

    $st_fields_temps = unserialize($st_fields_temps);

    $res = sbQueryCache::query('SELECT c.cat_id, c.cat_title, c.cat_level, s.s_id, s.s_title, s.s_prop1, s.s_prop2, s.s_prop3
                          FROM sb_sprav s, sb_categs c, sb_catlinks l
                          WHERE s.s_id=?d AND l.link_el_id=s.s_id AND c.cat_id=l.link_cat_id AND c.cat_ident="pl_sprav" AND s.s_active=1', $_GET['sprav_id']);

	if (!$res)
    {
        sb_404();
    }

	$cat_count = '';
    if (sb_strpos($st_full_element, '{CAT_COUNT}') !== false)
    {
        $res_cat = sbQueryCache::query('SELECT COUNT(link_el_id) FROM sb_catlinks
                WHERE link_cat_id=?d AND link_src_cat_id != ?d', $res[0][0], $res[0][0]);

        if ($res_cat)
        {
            $cat_count = $res_cat[0][0];
        }
    }

    $dop_tags = array('{ID}',
    			  '{TITLE}',
    			  '{CAT_ID}',
    			  '{CAT_TITLE}',
    			  '{LINK}');

    $dop_values = array($res[0][3], $res[0][4], $res[0][0], $res[0][1], '');

    $tags = array('{CAT_TITLE}',
                  '{CAT_LEVEL}',
                  '{CAT_COUNT}',
                  '{CAT_ID}',
                  '{ID}',
                  '{TITLE}',
    			  '{CHANGE_DATE}',
                  '{PROP1}',
                  '{PROP2}',
                  '{PROP3}');

    $values = array();
    $values[] = $res[0][1]; // CAT_TITLE
    $values[] = $res[0][2] + 1; // CAT_LEVEL
    $values[] = $cat_count; // CAT_COUNT
    $values[] = $res[0][0]; // CAT_ID
    $values[] = $res[0][3]; // ID
    $values[] = $res[0][4]; // TITLE

	// Дата последнего изменения
    if(sb_strpos($st_full_element, '{CHANGE_DATE}') !== false)
    {
        $res1 = sql_query('SELECT change_date FROM sb_catchanges WHERE el_id = ? AND cat_ident = ? ORDER BY change_date DESC LIMIT 0, 1', $res[0][3],'pl_sprav');
        $values[] = isset($res1[0][0]) ? sb_parse_date($res1[0][0], $st_fields_temps['s_change_date']) : ''; //   CHANGE_DATE
    }
    else
    {
        $values[] = '';
    }
    $values[] = ($res[0][5] != '' && !is_null($res[0][5]) ? str_replace(array_merge(array('{VALUE}'), $dop_tags),
                               array_merge(array($res[0][5]), $dop_values),
                               $st_fields_temps['s_prop1']) : ''); // PROP1
    $values[] = ($res[0][6] != '' && !is_null($res[0][6]) ? str_replace(array_merge(array('{VALUE}'), $dop_tags),
                               array_merge(array($res[0][6]), $dop_values),
                               $st_fields_temps['s_prop2']) : ''); // PROP2
    $values[] = ($res[0][7] != '' && !is_null($res[0][7]) ? str_replace(array_merge(array('{VALUE}'), $dop_tags),
                               array_merge(array($res[0][7]), $dop_values),
                               $st_fields_temps['s_prop3']) : ''); // PROP3

    $result = str_replace($tags, $values, $st_full_element);
    $result = preg_replace('/\{[_A-Z0-9'.$GLOBALS['sb_reg_upper_interval'].']+\}/'.SB_PREG_MOD, '', $result);

    $GLOBALS['sbCache']->save('pl_sprav', $result);
}

/**
 * Парсинг списка элементов справочника по заданному макету дизайна справочника
 *
 * @param int $id Идентификатор макета дизайна справочника.
 * @param string $elems Идентификаторы элементов справочника через запятую.
 *
 * @return string Вывод элементов справочника.
 */
function fSprav_Elem_Parse_List($id, $elems)
{
	static $cache = array();

    $hash = md5($id.'|'.$elems);

	if (isset($cache[$hash]))
	    return $cache[$hash];

	$res = sbQueryCache::query('SELECT st_no_elems, st_fields_temps, st_count, st_top, st_cat_top, st_element, st_empty, st_delim, st_cat_bottom, st_bottom, st_perpage FROM sb_sprav_temps WHERE st_id = ?d', $id);
	if (!$res)
	{
	    sb_add_system_message(sprintf(KERNEL_PROG_NO_TEMPLATE, $_SERVER['PHP_SELF'], KERNEL_PROG_SPRAV_PLUGIN), SB_MSG_WARNING);
        return '';
	}
 
	$result = '';
	list($st_no_elems, $st_fields_temps, $st_count, $st_top, $st_cat_top, $st_element, $st_empty, $st_delim, $st_cat_bottom, $st_bottom, $st_perpage) = $res[0];

	$elems = trim($elems);
	if($elems == '')
	{
	    return $st_no_elems;
	}

	$st_fields_temps = unserialize($st_fields_temps);
    $sql_workflow = (!defined('SB_SITE_MODE') || !SB_SITE_MODE)? '' : ' AND sprav.s_active=1 '; //Если запрос с сайта, то учитываем статус публикации
    
    //ограничение количества элементов
    $limit = '';
    if($st_perpage)
    {
        $limit = ' LIMIT 0, '.intval($st_perpage);
    }
    
	// используется ли группировка по разделам
	$elems = explode(',', $elems);
    if ($st_cat_top != '' || $st_cat_bottom != '')
    {
        $categs_output = true;
        $res = sbQueryCache::query('SELECT cat.cat_id, cat.cat_title, sprav.s_id, sprav.s_title, sprav.s_prop1, sprav.s_prop2, sprav.s_prop3
	        				FROM sb_sprav sprav, sb_categs cat, sb_catlinks link
	        				WHERE sprav.s_id IN (?a) AND link.link_el_id = sprav.s_id AND link.link_cat_id = cat.cat_id AND cat.cat_ident="pl_sprav" '.$sql_workflow.'
							GROUP BY sprav.s_id
							ORDER BY cat.cat_left, sprav.s_sort, sprav.s_title
							'.$limit, $elems);
    }
    else
    {
        $categs_output = false;
        $res = sbQueryCache::query('SELECT cat.cat_id, cat.cat_title, sprav.s_id, sprav.s_title, sprav.s_prop1, sprav.s_prop2, sprav.s_prop3
	        				FROM sb_sprav sprav, sb_categs cat, sb_catlinks link
	        				WHERE sprav.s_id IN (?a) AND link.link_el_id = sprav.s_id AND link.link_cat_id = cat.cat_id AND cat.cat_ident="pl_sprav" '.$sql_workflow.'
							GROUP BY sprav.s_id
							ORDER BY sprav.s_sort, sprav.s_title
							'.$limit, $elems);
	}

	if (!$res)
	{
		$cache[$hash] = $st_no_elems;
		return $st_no_elems;
	}

	$cat_ids = array();
	foreach ($res as $value)
	{
	    if (!in_array($value[0], $cat_ids))
	       $cat_ids[] = $value[0];
	}

    $sql_workflow = (!defined('SB_SITE_MODE') || !SB_SITE_MODE)? '' : ' AND s.s_active=1 '; //Если запрос с сайта, то учитываем статус публикации

	$res_cat = sbQueryCache::query('SELECT c1.cat_id,
            (

            	SELECT COUNT(l.link_el_id) FROM sb_categs c LEFT JOIN sb_catlinks l ON l.link_cat_id = c.cat_id, sb_sprav s
            	WHERE c.cat_id = c1.cat_id
                AND l.link_el_id=s.s_id
                AND l.link_src_cat_id NOT IN (?a)
                '.$sql_workflow.'

            ) AS cat_count
            FROM sb_categs c1 WHERE c1.cat_id IN (?a)', $cat_ids, $cat_ids);

	$categs = array();
    if ($res_cat)
    {
        foreach ($res_cat as $value)
        {
            $categs[$value[0]] = $value[1];
        }
    }

    $total = count($res);
    $result = str_replace(array('{NUM_LIST}', '{ALL_COUNT}'), array('', $total), $st_top);

	$cur_cat_id = 0;
    $col = 0;
	$values = array();
    $tags = array('{CAT_TITLE}',
                  '{CAT_COUNT}',
                  '{CAT_ID}',
                  '{ID}',
                  '{TITLE}',
                  '{PROP1}',
                  '{PROP2}',
                  '{PROP3}'
                 );

    $prop1 = $st_fields_temps['s_prop1']; // Описание 1
    $prop2 = $st_fields_temps['s_prop2']; // Описание 2
    $prop3 = $st_fields_temps['s_prop3']; // Описание 3

    foreach ($res as $value)
    {
        $old_values = $values;
        $values = array();

        $values[] = $value[1]; // CAT_TITLE
        $values[] = $categs[$value[0]]; // CAT_COUNT
        $values[] = $value[0]; // CAT_ID
        $values[] = $value[2]; // ID
        $values[] = $value[3]; // TITLE

        for ($i = 4; $i < 7; $i++)
        {
            if (is_null($value[$i]) || $value[$i] == '')
            {
                $values[] = '';
            }
            else
            {
                $values[] = str_replace(array('{VALUE}', '{ID}', '{TITLE}', '{CAT_ID}', '{CAT_TITLE}', '{LINK}'),
                                        array($value[$i], $value[2], $value[3], $value[0], $value[1], ''),
                                        $prop1); // Значение поля
            }
        }

        if ($categs_output && $value[0] != $cur_cat_id)
        {
            if ($cur_cat_id != 0)
            {
                // низ вывода раздела
                while ($col < $st_count)
                {
                    $result .= $st_empty;
                    $col++;
                }

                $result .= str_replace($tags, $old_values, $st_cat_bottom);
            }

            // верх вывода раздела
            $result .= str_replace($tags, $values, $st_cat_top);
            $col = 0;
        }

        if ($col >= $st_count)
        {
            $result .= $st_delim;
            $col = 0;
        }

        $result .= str_replace($tags, $values, $st_element);

        $cur_cat_id = $value[0];
        $col++;
    }

    while ($col < $st_count)
    {
        $result .= $st_empty;
        $col++;
    }

    if ($categs_output)
    {
        // низ вывода раздела
        $result .= str_replace($tags, $values, $st_cat_bottom);
    }

    // низ вывода новостной ленты
    $result .= str_replace(array('{NUM_LIST}', '{ALL_COUNT}'), array('', $total), $st_bottom);

    $cache[$hash] = $result;
	return $result;
}
?>