<?php


/********************************** функции построения диалоговых окон ***********************************/
function fTester_Elem_Test_Get()
{
    require_once(SB_CMS_LIB_PATH . '/sbJustCategs.inc.php');
    $params = unserialize($_GET['params']);

    if (!isset($params['filter'])) {
        $params['filter'] = 'all';
    }

    if (!isset($params['subcategs'])) {
        $params['subcategs'] = 1;
    }

    echo '<script>
        function chooseCat()
        {
            var res = new Object();
            var params = new Array();

            var el_cats = sbCatTree.getAllSelected();
            if (el_cats.length == 0)
            {
                alert("' . PL_TESTER_H_ELEM_LIST_NO_CATEGS_MSG . '");
                return;
            }

            params["id"] = el_cats;
            var el_temp = sbGetE("temp_id");
            if (el_temp)
            {
                params["temp_id"] = el_temp.value;
            }
            else
            {
                alert("' . PL_TESTER_H_ELEM_LIST_NO_TEMPS_ALERT . '");
                return;
            }

            var r_filter_all = sbGetE("r_filter_all");
            var r_filter_order = sbGetE("r_filter_order");
            var r_filter_order_from = sbGetE("r_filter_order_from");
            var r_filter_order_to = sbGetE("r_filter_order_to");

            if (r_filter_all.checked)
            {
                params["filter"] = r_filter_all.value;
            }
            else if (r_filter_order.checked)
            {
                params["filter"] = r_filter_order.value;
                var el_filter_order_from = sbGetE("spin_filter_order_from");
                var el_filter_order_to = sbGetE("spin_filter_order_to");

                if (el_filter_order_to.value != "" && el_filter_order_to.value != 0 && parseInt(el_filter_order_from.value) > parseInt(el_filter_order_to.value))
                {
                    alert("' . PL_TESTER_H_ELEM_LIST_FILTER_FROM_TO_ERROR . '");
                    return;
                }

                params["filter_order_from"] = el_filter_order_from.value;
                params["filter_order_to"] = el_filter_order_to.value;
            }
                
            var el_sort1 = sbGetE("sort1");
            var el_order1 = sbGetE("order1");
            
            params["sort1"] = el_sort1.value;
            params["order1"] = el_order1.disabled ? "" : el_order1.value;

            params["num_interrups"] = sbGetE("spin_num_interrups").value;
            params["show_hidden"] = sbGetE("show_hidden").checked ? 1 : 0;
            params["subcategs"] = sbGetE("subcategs").checked ? 1 : 0;
            params["rubrikator"] = sbGetE("rubrikator").checked ? 1 : 0;

            res.temp_id = el_temp.value;
            res.params = sb_serialize(params);

            sbReturnValue(res);
        }

        function changeSort(el, el_id)
        {
            var order_el = sbGetE("order" + el_id);
            if (el.value == "RAND()" || el.value == "")
            {
                order_el.disabled = true;
            }
            else
            {
                order_el.disabled = false;
            }
        }
    </script>';

    require_once(SB_CMS_LIB_PATH . '/sbLayout.inc.php');

    $layout = new sbLayout();
    $layout->mTableWidth = '100%';
    $layout->mTitleWidth = '200';

    $layout->addTab(PL_TESTER_H_ELEM_CATEGS_TAB);
    $categs = new sbJustCategs('pl_tester');

    $categs->mCategsMenu = false;
    $categs->mCategsSelectedId = (isset($params['id']) && $params['id'] != '' ? $params['id'] : array());

    $layout->addField('', new sbLayoutHTML($categs->showTree('', '', '', false), true));
    $categs->init();

    $layout->addTab(PL_TESTER_H_ELEM_LIST_PROPS_TAB);
    $layout->addHeader(PL_TESTER_H_ELEM_LIST_PROPS_TAB);

    $options = array();
    $res = sql_query('SELECT categs.cat_title, temps.stt_id, temps.stt_title FROM sb_categs categs, sb_catlinks links, sb_tester_temps temps WHERE temps.stt_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_tester_design" ORDER BY categs.cat_left, temps.stt_title');
    if ($res) {
        $old_cat_title = '';
        foreach ($res as $value) {
            list($cat_title, $stt_id, $stt_title) = $value;
            if ($old_cat_title != $cat_title) {
                $options[uniqid()] = '-' . $cat_title;
                $old_cat_title = $cat_title;
            }
            $options[$stt_id] = $stt_title;
        }
    }

    if (count($options) > 0) {
        $fld = new sbLayoutSelect($options, 'temp_id');
        if (isset($_GET['temp_id'])) {
            $fld->mSelOptions = array($_GET['temp_id']);
        }
    } else {
        $fld = new sbLayoutLabel('<div class="hint_div">' . PL_TESTER_H_ELEM_LIST_NO_TEMPS_MSG . '</div>', '', '', false);
    }

    $layout->addField(PL_TESTER_H_ELEM_TEMP, $fld);
    $layout->addField('', new sbLayoutDelim());

    $fields = sbPlugins::getSortFields('pl_tester');

    $order = array(
        'DESC' => PL_TESTER_H_ELEM_LIST_SORT_DESC,
        'ASC' => PL_TESTER_H_ELEM_LIST_SORT_ASC
    );

    $fld1 = new sbLayoutSelect($fields, 'sort1', '', 'onchange="changeSort(this, 1);"');
    $fld1->mSelOptions = array((isset($params['sort1']) ? $params['sort1'] : ''));

    $fld2 = new sbLayoutSelect($order, 'order1');
    $fld2->mSelOptions = array((isset($params['order1']) && $params['order1'] != '' ? $params['order1'] : 'DESC'));
    $fld1->mHTML = '&nbsp;&nbsp;' . $fld2->getField();

    $layout->addField(PL_TESTER_H_ELEM_LIST_SORT_FIELD, $fld1);

    $layout->addField('', new sbLayoutDelim());

    $layout->addField(PL_TESTER_H_ELEM_PROP_OBRIV,
        new sbLayoutInput('text', (isset($params['num_interrups']) ? $params['num_interrups'] : 10), 'num_interrups', 'spin_num_interrups',
            'style="width:80px;"'));
    $layout->addField(PL_TESTER_H_ELEM_LIST_SUBCATEGS,
        new sbLayoutInput('checkbox', '1', 'subcategs', '', (isset($params['subcategs']) && $params['subcategs'] == 1 ? 'checked="checked"' : '')));
    $layout->addField(PL_TESTER_H_ELEM_LIST_SHOW_HIDDEN,
        new sbLayoutInput('checkbox', '1', 'show_hidden', '', (isset($params['show_hidden']) && $params['show_hidden'] == 1 ? 'checked="checked"' : '')));
    $layout->addField(PL_TESTER_H_ELEM_LIST_RUBRIK_LINK,
        new sbLayoutInput('checkbox', '1', 'rubrikator', '', (isset($params['rubrikator']) && $params['rubrikator'] == 1 ? 'checked="checked"' : '')));

    $layout->addTab(PL_TESTER_H_ELEM_LIST_FILTER_TAB);
    $layout->addHeader(PL_TESTER_H_ELEM_LIST_FILTER_TAB);

    $html = '';
    $fld1 = new sbLayoutInput('radio', 'all', 'filter', 'r_filter_all', ($params['filter'] == 'all' ? ' checked="checked"' : ''));
    $fld1->mHTML = '&nbsp;&nbsp;' . PL_TESTER_H_ELEM_LIST_FILTER_ALL;
    $html .= $fld1->getField() . '<br /><br />';

    $fld3 = new sbLayoutInput('radio', 'order', 'filter', 'r_filter_order', ($params['filter'] == 'order' ? ' checked="checked"' : ''));
    $fld3_1 = new sbLayoutInput('input', (isset($params['filter_order_from']) ? $params['filter_order_from'] : ''), 'filter_order_from',
        'spin_filter_order_from', 'style="width: 50px;"');
    $fld3_2 = new sbLayoutInput('input', (isset($params['filter_order_to']) ? $params['filter_order_to'] : ''), 'filter_order_to', 'spin_filter_order_to',
        'style="width: 50px;"');
    $fld3_1->mMinValue = 1;
    $html .= '<table cellpadding="0" cellspacing="0"><tr><td>' . $fld3_1->getJavaScript() . ' ' . $fld3->getField() . '</td><td>&nbsp;' . PL_TESTER_H_ELEM_LIST_FILTER_ORDER . ' &nbsp;&nbsp;&nbsp;' . KERNEL_FROM . '&nbsp;&nbsp;</td><td>' . $fld3_1->getField() . '</td><td>&nbsp;&nbsp;' . KERNEL_TO . '&nbsp;&nbsp;</td><td>' . $fld3_2->getField() . '</td></tr></table>
              <div class="hint_div">' . PL_TESTER_H_ELEM_LIST_FILTER_FROM_TO_HINT . '</div>';

    $fld = new sbLayoutHTML($html);
    $layout->addField(PL_TESTER_H_ELEM_LIST_FILTER, $fld);

    $layout->addButton('button', KERNEL_SAVE, '', '', 'onclick="chooseCat();"' . (count($options) > 0 ? '' : ' disabled="disabled"'));
    $layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');

    $layout->show();
}

function fTester_Elem_Results_Get()
{
    require_once(SB_CMS_LIB_PATH . '/sbJustCategs.inc.php');
    $params = unserialize($_GET['params']);

    if (!isset($params['filter'])) {
        $params['filter'] = 'all';
    }

    echo '<script>
        function chooseCat()
        {
            var res = new Object();
            var params = new Array();
            
            var el_cats = sbCatTree.getAllSelected();
            if (el_cats.length == 0)
            {
                alert("' . PL_TESTER_H_ELEM_RESULT_NO_CATEGS_MSG . '");
                return;
            }

            params["ids"] = el_cats;
            var el_temp = sbGetE("temp_id");
            if (el_temp)
            {
                params["temp_id"] = el_temp.value;
            }
            else
            {
                alert("' . PL_TESTER_H_ELEM_RESULTS_NO_TEMPS_ALERT . '");
                return;
            }

            var r_filter_all = sbGetE("r_filter_all");
            var r_filter_date = sbGetE("r_filter_date");
            var r_filter_date_from = sbGetE("r_filter_date_from");
            var r_filter_date_to = sbGetE("r_filter_date_to");

            if (r_filter_all.checked)
            {
                params["filter"] = r_filter_all.value;
            }
            else if (r_filter_date.checked)
            {
                params["filter"] = r_filter_date.value;
                var el_filter_date_from = sbGetE("spin_filter_date_from");
                var el_filter_date_to = sbGetE("spin_filter_date_to");

                if (el_filter_date_to.value != "" && el_filter_date_to.value != 0 && el_filter_date_from.value > el_filter_date_to.value)
                {
                    alert("' . PL_TESTER_H_ELEM_LIST_FILTER_FROM_TO_ERROR . '");
                    return;
                }

                params["filter_date_from"] = el_filter_date_from.value;
                params["filter_date_to"] = el_filter_date_to.value;
            }

            var el_sort1 = sbGetE("sort1");
            var el_order1 = sbGetE("order1");
            var el_sort2 = sbGetE("sort2");
            var el_order2 = sbGetE("order2");
            var el_sort3 = sbGetE("sort3");
            var el_order3 = sbGetE("order3");

            params["sort1"] = el_sort1.value;
            params["sort2"] = el_sort2.value;            
            params["sort3"] = el_sort3.value;            

            params["order1"] = el_order1.disabled ? "" : el_order1.value;
            params["order2"] = el_order2.disabled ? "" : el_order2.value;            
            params["order3"] = el_order3.disabled ? "" : el_order3.value;
            
            res.temp_id = el_temp.value;
            res.params = sb_serialize(params);
    
            sbReturnValue(res);
        }

        function changeSort(el, el_id)
        {
            var order_el = sbGetE("order" + el_id);
            if (el.value == "RAND()" || el.value == "")
            {
                order_el.disabled = true;
            }
            else
            {
                order_el.disabled = false;
            }
        }
    </script>';

    require_once(SB_CMS_LIB_PATH . '/sbLayout.inc.php');

    $layout = new sbLayout();
    $layout->mTableWidth = '100%';
    $layout->mTitleWidth = '200';

    $layout->addTab(PL_TESTER_H_ELEM_CATEGS_TAB);
    $categs = new sbJustCategs('pl_tester');

    $categs->mCategsMenu = false;
    $categs->mCategsMultiSelect = true;
    $categs->mCategsSelectedIds = (isset($params['ids']) && $params['ids'] != '' ? explode('^', $params['ids']) : array());

    $layout->addField('', new sbLayoutHTML($categs->showTree('', '', '', false), true));
    $categs->init();

    $layout->addTab(PL_TESTER_H_ELEM_LIST_PROPS_TAB);
    $layout->addHeader(PL_TESTER_H_ELEM_LIST_PROPS_TAB);

    $options = array();
    $res = sql_query('SELECT categs.cat_title, temps.strt_id, temps.strt_title FROM sb_categs categs, sb_catlinks links, sb_tester_result_temps temps WHERE temps.strt_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_tester_result_design" ORDER BY categs.cat_left, temps.strt_title');
    if ($res) {
        $old_cat_title = '';
        foreach ($res as $value) {
            list($cat_title, $stt_id, $stt_title) = $value;
            if ($old_cat_title != $cat_title) {
                $options[uniqid()] = '-' . $cat_title;
                $old_cat_title = $cat_title;
            }
            $options[$stt_id] = $stt_title;
        }
    }

    if (count($options) > 0) {
        $fld = new sbLayoutSelect($options, 'temp_id');
        if (isset($_GET['temp_id'])) {
            $fld->mSelOptions = array($_GET['temp_id']);
        }
    } else {
        $fld = new sbLayoutLabel('<div class="hint_div">' . PL_TESTER_H_ELEM_RESULTS_NO_TEMPS_MSG . '</div>', '', '', false);
    }

    $layout->addField(PL_TESTER_H_ELEM_TEMP, $fld);
    $layout->addField('', new sbLayoutDelim());

    $fields = array(
        '' => ' --- ',
        'str_id' => PL_TESTER_H_ELEM_LIST_SORT_ID,
        'str_time' => PL_TESTER_H_ELEM_LIST_SORT_DATE,
        'max_mark' => PL_TESTER_H_ELEM_LIST_SORT_MARK,
        'min_time' => PL_TESTER_H_ELEM_LIST_SORT_TIME
    );

    $order = array(
        'DESC' => PL_TESTER_H_ELEM_LIST_SORT_DESC,
        'ASC' => PL_TESTER_H_ELEM_LIST_SORT_ASC
    );

    $fld1 = new sbLayoutSelect($fields, 'sort1', '', 'onchange="changeSort(this, 1);"');
    $fld1->mSelOptions = array((isset($params['sort1']) ? $params['sort1'] : 'RAND()'));

    $fld2 = new sbLayoutSelect($order, 'order1');
    $fld2->mSelOptions = array((isset($params['order1']) && $params['order1'] != '' ? $params['order1'] : 'DESC'));
    $fld1->mHTML = '&nbsp;&nbsp;' . $fld2->getField();

    $layout->addField(PL_TESTER_H_ELEM_LIST_SORT_FIELD . ' 1', $fld1);

    $fld1 = new sbLayoutSelect($fields, 'sort2', '', 'onchange="changeSort(this, 2);"');
    $fld1->mSelOptions = array((isset($params['sort2']) && $params['sort1'] != '' ? $params['sort2'] : ''));
    $fld2 = new sbLayoutSelect($order, 'order2');
    $fld2->mSelOptions = array((isset($params['order2']) && $params['order1'] != '' ? $params['order2'] : ''));
    $fld1->mHTML = '&nbsp;&nbsp;' . $fld2->getField();

    $layout->addField(PL_TESTER_H_ELEM_LIST_SORT_FIELD . ' 2', $fld1);

    $fld1 = new sbLayoutSelect($fields, 'sort3', '', 'onchange="changeSort(this, 3);"');
    $fld1->mSelOptions = array((isset($params['sort3']) && $params['sort1'] != '' ? $params['sort3'] : ''));
    $fld2 = new sbLayoutSelect($order, 'order3');
    $fld2->mSelOptions = array((isset($params['order3']) && $params['order3'] != '' ? $params['order3'] : ''));
    $fld1->mHTML = '&nbsp;&nbsp;' . $fld2->getField();

    $layout->addField(PL_TESTER_H_ELEM_LIST_SORT_FIELD . ' 3', $fld1);

    $layout->addField('', new sbLayoutDelim());

    $layout->addTab(PL_TESTER_H_ELEM_LIST_FILTER_TAB);
    $layout->addHeader(PL_TESTER_H_ELEM_LIST_FILTER_TAB);

    $html = '';
    $fld1 = new sbLayoutInput('radio', 'all', 'filter', 'r_filter_all', ($params['filter'] == 'all' ? ' checked="checked"' : ''));
    $fld1->mHTML = '&nbsp;&nbsp;' . PL_TESTER_H_ELEM_LIST_FILTER_ALL;
    $html .= $fld1->getField() . '<br /><br />';

    $fld3 = new sbLayoutInput('radio', 'date', 'filter', 'r_filter_date', ($params['filter'] == 'date' ? ' checked="checked"' : ''));
    $fld3_1 = new sbLayoutDate((isset($params['filter_date_from']) ? $params['filter_date_from'] : ''), 'filter_date_from', 'spin_filter_date_from', '');
    $fld3_2 = new sbLayoutDate((isset($params['filter_date_to']) ? $params['filter_date_to'] : ''), 'filter_date_to', 'spin_filter_date_to', '');
    $html .= '<table cellpadding="0" cellspacing="0"><tr><td>' . $fld3_1->getJavaScript() . ' ' . $fld3->getField() . '</td><td>&nbsp;' . PL_TESTER_H_ELEM_LIST_FILTER_DATE . ' &nbsp;&nbsp;&nbsp;' . KERNEL_FROM . '&nbsp;&nbsp;</td><td>' . $fld3_1->getField() . '</td><td>&nbsp;&nbsp;' . KERNEL_TO . '&nbsp;&nbsp;</td><td>' . $fld3_2->getField() . '</td></tr></table>
            <div class="hint_div">' . PL_TESTER_H_ELEM_RESULTS_FILTER_FROM_TO_HINT . '</div>';

    $fld = new sbLayoutHTML($html);
    $layout->addField(PL_TESTER_H_ELEM_RESULTS_FILTER, $fld);

    $layout->addButton('button', KERNEL_SAVE, '', '', 'onclick="chooseCat();"' . (count($options) > 0 ? '' : ' disabled="disabled"'));
    $layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');

    $layout->show();
}

function fTester_Elem_Rating_Get()
{
    require_once(SB_CMS_LIB_PATH . '/sbJustCategs.inc.php');
    $params = unserialize($_GET['params']);

    if (!isset($params['filter'])) {
        $params['filter'] = 'all';
    }

    if (!isset($params['subcategs'])) {
        $params['subcategs'] = 1;
    }

    echo '<script>
        function chooseCat()
        {
            var res = new Object();
            var params = new Array();
            
            var el_cats = sbCatTree.getAllSelected();
            if (el_cats.length == 0)
            {
                alert("' . PL_TESTER_H_ELEM_RATING_NO_CATEGS_MSG . '");
                return;
            }

            params["ids"] = el_cats;
            var el_temp = sbGetE("temp_id");
            if (el_temp)
            {
                params["temp_id"] = el_temp.value;
            }
            else
            {
                alert("' . PL_TESTER_H_ELEM_RATING_NO_TEMPS_ALERT . '");
                return;
            }

            var r_filter_all = sbGetE("r_filter_all");
            var r_filter_date = sbGetE("r_filter_date");
            var r_filter_date_from = sbGetE("r_filter_date_from");
            var r_filter_date_to = sbGetE("r_filter_date_to");

            var r_filter_mark = sbGetE("r_filter_mark");
            var r_filter_mark_from = sbGetE("r_filter_mark_from");
            var r_filter_mark_to = sbGetE("r_filter_mark_to");
            
            var r_filter_attempts = sbGetE("r_filter_attempts");
            var r_filter_attempts_from = sbGetE("r_filter_attempts_from");
            var r_filter_attempts_to = sbGetE("r_filter_attempts_to");
            
            if (r_filter_all.checked)
            {
                params["filter"] = r_filter_all.value;
            }
            else if (r_filter_date.checked)
            {
                params["filter"] = r_filter_date.value;
                var el_filter_date_from = sbGetE("filter_date_from");
                var el_filter_date_to = sbGetE("filter_date_to");

                var day = el_filter_date_from.value.substr(0, 2);
                var mounth =el_filter_date_from.value.substr(3, 2);
                var year = el_filter_date_from.value.substr(6, 4);
                var hour = el_filter_date_from.value.substr(11, 2);
                var min =el_filter_date_from.value.substr(14, 2);

                var day_to = el_filter_date_to.value.substr(0, 2);
                var mounth_to =el_filter_date_to.value.substr(3, 2);
                var year_to = el_filter_date_to.value.substr(6, 4);
                var hour_to = el_filter_date_to.value.substr(11, 2);
                var min_to =el_filter_date_to.value.substr(14, 2);

                if(mounth != 1)
                {
                    mounth = mounth-1;
                }
                if(mounth_to != 1)
                {
                    mounth_to = mounth_to-1;
                }
                var from = new Date(year,mounth,day,hour,min,0);
                var to = new Date(year_to,mounth_to,day_to,hour_to,min_to,0);

                from = Date.parse(from);
                to = Date.parse(to);

                if (to != "" && to != 0 && from > to)
                {
                    alert("' . PL_TESTER_H_ELEM_LIST_FILTER_FROM_TO_ERROR . '");
                    return;
                }

                params["filter_date_from"] = el_filter_date_from.value;
                params["filter_date_to"] = el_filter_date_to.value;
            }
            else if (r_filter_mark.checked)
            {
                params["filter"] = r_filter_mark.value;
                var el_filter_mark_from = sbGetE("spin_filter_mark_from");
                var el_filter_mark_to = sbGetE("spin_filter_mark_to");

                if (el_filter_mark_to.value != "" && el_filter_mark_to.value != 0 && parseInt(el_filter_mark_from.value) > parseInt(el_filter_mark_to.value))
                {
                    alert("' . PL_TESTER_H_ELEM_LIST_FILTER_FROM_TO_ERROR . '");
                    return;
                }

                params["filter_mark_from"] = el_filter_mark_from.value;
                params["filter_mark_to"] = el_filter_mark_to.value;
            }

            var el_sort1 = sbGetE("sort1");
            var el_order1 = sbGetE("order1");
            var el_sort2 = sbGetE("sort2");
            var el_order2 = sbGetE("order2");
            var el_sort3 = sbGetE("sort3");
            var el_order3 = sbGetE("order3");

            params["sort1"] = el_sort1.value;
            params["sort2"] = el_sort2.value;            
            params["sort3"] = el_sort3.value;            

            params["order1"] = el_order1.disabled ? "" : el_order1.value;
            params["order2"] = el_order2.disabled ? "" : el_order2.value;            
            params["order3"] = el_order3.disabled ? "" : el_order3.value;

            params["user_rights"] = sbGetE("user_rights").checked ? 1 : 0;
            params["passed_tests"] = sbGetE("passed_tests").checked ? 1 : 0;
            params["subcategs"] = sbGetE("subcategs").checked ? 1 : 0;
            params["rubrikator"] = sbGetE("rubrikator").checked ? 1 : 0;
            
            res.temp_id = el_temp.value;
            res.params = sb_serialize(params);
    
            sbReturnValue(res);
        }

        function changeSort(el, el_id)
        {
            var order_el = sbGetE("order" + el_id);
            if (el.value == "RAND()" || el.value == "")
            {
                order_el.disabled = true;
            }
            else
            {
                order_el.disabled = false;
            }
        }
    </script>';

    require_once(SB_CMS_LIB_PATH . '/sbLayout.inc.php');

    $layout = new sbLayout();
    $layout->mTableWidth = '100%';
    $layout->mTitleWidth = '200';

    $layout->addTab(PL_TESTER_H_ELEM_CATEGS_TAB);
    $categs = new sbJustCategs('pl_tester');

    $categs->mCategsMenu = false;
    $categs->mCategsMultiSelect = true;
    $categs->mCategsSelectedIds = (isset($params['ids']) && $params['ids'] != '' ? explode('^', $params['ids']) : array());

    $layout->addField('', new sbLayoutHTML($categs->showTree('', '', '', false), true));
    $categs->init();

    $layout->addTab(PL_TESTER_H_ELEM_LIST_PROPS_TAB);
    $layout->addHeader(PL_TESTER_H_ELEM_LIST_PROPS_TAB);

    $options = array();
    $res = sql_query('SELECT categs.cat_title, temps.strt_id, temps.strt_title FROM sb_categs categs, sb_catlinks links, sb_tester_rating_temps temps WHERE temps.strt_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_tester_rating_design" ORDER BY categs.cat_left, temps.strt_title');
    if ($res) {
        $old_cat_title = '';
        foreach ($res as $value) {
            list($cat_title, $stt_id, $stt_title) = $value;
            if ($old_cat_title != $cat_title) {
                $options[uniqid()] = '-' . $cat_title;
                $old_cat_title = $cat_title;
            }
            $options[$stt_id] = $stt_title;
        }
    }

    if (count($options) > 0) {
        $fld = new sbLayoutSelect($options, 'temp_id');
        if (isset($_GET['temp_id'])) {
            $fld->mSelOptions = array($_GET['temp_id']);
        }
    } else {
        $fld = new sbLayoutLabel('<div class="hint_div">' . PL_TESTER_H_ELEM_RATING_NO_TEMPS_MSG . '</div>', '', '', false);
    }

    $layout->addField(PL_TESTER_H_ELEM_TEMP, $fld);
    $layout->addField('', new sbLayoutDelim());

    $fields = array(
        '' => ' --- ',
        'str_time' => PL_TESTER_H_ELEM_LIST_SORT_RATING_TIME,
        'str_mark' => PL_TESTER_H_ELEM_LIST_SORT_RATING_MARK
    );

    $order = array(
        'DESC' => PL_TESTER_H_ELEM_LIST_SORT_DESC,
        'ASC' => PL_TESTER_H_ELEM_LIST_SORT_ASC
    );

    $fld1 = new sbLayoutSelect($fields, 'sort1', '', 'onchange="changeSort(this, 1);"');
    $fld1->mSelOptions = array((isset($params['sort1']) ? $params['sort1'] : 'RAND()'));

    $fld2 = new sbLayoutSelect($order, 'order1');
    $fld2->mSelOptions = array((isset($params['order1']) && $params['order1'] != '' ? $params['order1'] : 'DESC'));
    $fld1->mHTML = '&nbsp;&nbsp;' . $fld2->getField();

    $layout->addField(PL_TESTER_H_ELEM_LIST_SORT_FIELD . ' 1', $fld1);

    $fld1 = new sbLayoutSelect($fields, 'sort2', '', 'onchange="changeSort(this, 2);"');
    $fld1->mSelOptions = array((isset($params['sort2']) && $params['sort1'] != '' ? $params['sort2'] : ''));
    $fld2 = new sbLayoutSelect($order, 'order2');
    $fld2->mSelOptions = array((isset($params['order2']) && $params['order1'] != '' ? $params['order2'] : ''));
    $fld1->mHTML = '&nbsp;&nbsp;' . $fld2->getField();

    $layout->addField(PL_TESTER_H_ELEM_LIST_SORT_FIELD . ' 2', $fld1);

    $fld1 = new sbLayoutSelect($fields, 'sort3', '', 'onchange="changeSort(this, 3);"');
    $fld1->mSelOptions = array((isset($params['sort3']) && $params['sort1'] != '' ? $params['sort3'] : ''));
    $fld2 = new sbLayoutSelect($order, 'order3');
    $fld2->mSelOptions = array((isset($params['order3']) && $params['order3'] != '' ? $params['order3'] : ''));
    $fld1->mHTML = '&nbsp;&nbsp;' . $fld2->getField();

    $layout->addField(PL_TESTER_H_ELEM_LIST_SORT_FIELD . ' 3', $fld1);
    $layout->addField('', new sbLayoutDelim());

    $layout->addField(PL_TESTER_H_ELEM_LIST_SUBTEST,
        new sbLayoutInput('checkbox', '1', 'subcategs', '', (isset($params['subcategs']) && $params['subcategs'] == 1 ? 'checked="checked"' : '')));
    $layout->addField(PL_TESTER_H_ELEM_LIST_PASSED_TEST,
        new sbLayoutInput('checkbox', '1', 'passed_tests', '', (isset($params['passed_tests']) && $params['passed_tests'] == 1 ? 'checked="checked"' : '')));
    $layout->addField(PL_TESTER_H_ELEM_LIST_RUBRIK_LINK,
        new sbLayoutInput('checkbox', '1', 'rubrikator', '', (isset($params['rubrikator']) && $params['rubrikator'] == 1 ? 'checked="checked"' : '')));
    $layout->addField(PL_TESTER_H_ELEM_LIST_USER_RIGHTS,
        new sbLayoutInput('checkbox', '1', 'user_rights', '', (isset($params['user_rights']) && $params['user_rights'] == 1 ? 'checked="checked"' : '')));

    $layout->addTab(PL_TESTER_H_ELEM_LIST_FILTER_TAB);
    $layout->addHeader(PL_TESTER_H_ELEM_LIST_FILTER_TAB);

    $html = '';
    $fld1 = new sbLayoutInput('radio', 'all', 'filter', 'r_filter_all', ($params['filter'] == 'all' ? ' checked="checked"' : ''));
    $fld1->mHTML = '&nbsp;&nbsp;' . PL_TESTER_H_ELEM_LIST_FILTER_ALL;
    $html .= $fld1->getField() . '<br /><br />';

    $fld1 = new sbLayoutInput('radio', 'date', 'filter', 'r_filter_date', ($params['filter'] == 'date' ? ' checked="checked"' : ''));
    $fld1_1 = new sbLayoutDate((isset($params['filter_date_from']) ? $params['filter_date_from'] : ''), 'filter_date_from', 'filter_date_from', '');
    $fld1_2 = new sbLayoutDate((isset($params['filter_date_to']) ? $params['filter_date_to'] : ''), 'filter_date_to', 'filter_date_to', '');

    $fld2 = new sbLayoutInput('radio', 'mark', 'filter', 'r_filter_mark', ($params['filter'] == 'mark' ? ' checked="checked"' : ''));
    $fld2_1 = new sbLayoutInput('text', (isset($params['filter_mark_from']) ? $params['filter_mark_from'] : ''), 'filter_mark_from', 'spin_filter_mark_from',
        'style="width:80px;"');
    $fld2_2 = new sbLayoutInput('text', (isset($params['filter_mark_to']) ? $params['filter_mark_to'] : ''), 'filter_mark_to', 'spin_filter_mark_to',
        'style="width:80px;"');

    $html .= '<table cellpadding="0" cellspacing="0">
                <tr>
                    <td>' . $fld1_1->getJavaScript() . ' ' . $fld1->getField() . '</td>
                    <td>&nbsp;' . PL_TESTER_H_ELEM_LIST_FILTER_RATING_DATE . ' &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . KERNEL_FROM . '&nbsp;&nbsp;</td>
                    <td>' . $fld1_1->getField() . '</td><td>&nbsp;&nbsp;' . KERNEL_TO . '&nbsp;&nbsp;</td>
                    <td>' . $fld1_2->getField() . '</td>
                </tr>
                <tr>
                    <td><br />' . $fld2_1->getJavaScript() . ' ' . $fld2->getField() . '</td>
                    <td><br />&nbsp;' . PL_TESTER_H_ELEM_LIST_FILTER_RATING_MARK . ' &nbsp;' . KERNEL_FROM . '&nbsp;&nbsp;</td>
                    <td><br />' . $fld2_1->getField() . '</td><td><br />&nbsp;&nbsp;' . KERNEL_TO . '&nbsp;&nbsp;</td>
                    <td><br />' . $fld2_2->getField() . '</td>
                </tr>
            </table>
    <div class="hint_div">' . PL_TESTER_H_ELEM_RATING_FILTER_FROM_TO_HINT . '</div>';

    $fld = new sbLayoutHTML($html);
    $layout->addField(PL_TESTER_H_ELEM_RESULTS_FILTER, $fld);

    $layout->addButton('button', KERNEL_SAVE, '', '', 'onclick="chooseCat();"' . (count($options) > 0 ? '' : ' disabled="disabled"'));
    $layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');

    $layout->show();
}

function fTester_Elem_Categs_Get()
{
    fCategs_Get_Elem_Categs('pl_tester', 'pl_tester_categs_design', PL_TESTER_H_ELEM_CATEGS_NO_TEMPS_MSG);
}

function fTester_Elem_Selcat_Get()
{
    fCategs_Get_Elem_Sel_Cat('pl_tester', 'pl_tester_selcat_design', PL_TESTER_H_ELEM_SELCAT_NO_TEMPS_MSG);
}

/********************************** функции получения информации по элементам модуля ***********************************/
function fTester_Elem_Test_Info($params)
{
    $in_str = '(0,' . $params['id'] . ')';
    $categs_str = '';
    $res = sql_query('SELECT cat_title FROM sb_categs WHERE cat_id IN ' . $in_str . ' ORDER BY cat_left');

    if ($res) {
        $categs_str = $res[0][0];
    }

    $res = sql_param_query('SELECT categs.cat_title, temps.stt_title FROM sb_categs categs, sb_catlinks links, sb_tester_temps temps
                            WHERE temps.stt_id=?d AND links.link_el_id=temps.stt_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_tester_design"',
        $params['temp_id']);

    echo '<div style="padding-bottom: 5px;"><b>' . PL_TESTER_H_INFO_CATEGS . ':</b> ' . ($categs_str != '' ? $categs_str : '<span style="color:red;">' . PL_TESTER_H_INFO_CATEGS_WAS_DELETED_MSG . '</span>') . '</div>
          <div style="padding-bottom: 5px;"><b>' . PL_TESTER_H_ELEM_TEMP . ':</b> ' . ($res ? $res[0][0] . ' -&gt; ' . $res[0][1] : '<span style="color:red;">' . PL_TESTER_H_INFO_TEMP_WAS_DELETED_MSG . '</span>') . '</div>
          <div class="delim"></div>
          <div style="padding-bottom: 5px;"><b>' . PL_TESTER_H_INFO_SUBCATEGS . ':</b> ' . (isset($params['subcategs']) && $params['subcategs'] == 1 ? KERNEL_YES : KERNEL_NO) . '</div>
          <div style="padding-bottom: 5px;"><b>' . PL_TESTER_H_INFO_RUBRIK_LINK . ':</b> ' . (isset($params['rubrikator']) && $params['rubrikator'] == 1 ? KERNEL_YES : KERNEL_NO) . '</div>';
}

function fTester_Elem_Results_Info($params)
{
    $res = sql_param_query('SELECT categs.cat_title, temps.strt_title FROM sb_categs categs, sb_catlinks links, sb_tester_result_temps temps
                            WHERE temps.strt_id=?d AND links.link_el_id=temps.strt_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_tester_result_design"',
        $params['temp_id']);

    echo '<div style="padding-bottom: 5px;"><b>' . PL_TESTER_H_ELEM_TEMP . ':</b> ' . ($res ? $res[0][0] . ' -&gt; ' . $res[0][1] : '<span style="color:red;">' . PL_SR_H_INFO_TEMP_WAS_DELETED_MSG . '</span>') . '</div>';
}

function fTester_Elem_Rating_Info($params)
{
    $in_str = implode(',', explode('^', $params['ids']));
    $in_str = '(0,' . $in_str . ')';
    $categs_str = '';

    $res = sql_query('SELECT cat_title FROM sb_categs WHERE cat_id IN ' . $in_str . ' ORDER BY cat_left');

    if ($res) {
        foreach ($res as $value) {
            $categs_str .= $value[0] . ', ';
        }
        $categs_str = substr($categs_str, 0, -2);
    }

    $res = sql_param_query('SELECT categs.cat_title, temps.strt_title FROM sb_categs categs, sb_catlinks links, sb_tester_rating_temps temps
            WHERE temps.strt_id=?d AND links.link_el_id=temps.strt_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_tester_rating_design"',
        $params['temp_id']);

    echo '<div style="padding-bottom: 5px;"><b>' . PL_TESTER_H_INFO_CATEGS . ':</b> ' . ($categs_str != '' ? $categs_str : '<span style="color:red;">' . PL_TESTER_H_INFO_CATEGS_WAS_DELETED_MSG . '</span>') . '</div>
          <div style="padding-bottom: 5px;"><b>' . PL_TESTER_H_ELEM_TEMP . ':</b> ' . ($res ? $res[0][0] . ' -&gt; ' . $res[0][1] : '<span style="color:red;">' . PL_TESTER_H_INFO_TEMP_WAS_DELETED_MSG . '</span>') . '</div>
          <div class="delim"></div>
          <div style="padding-bottom: 5px;"><b>' . PL_TESTER_H_INFO_SUBCATEGS . ':</b> ' . (isset($params['subcategs']) && $params['subcategs'] == 1 ? KERNEL_YES : KERNEL_NO) . '</div>
          <div style="padding-bottom: 5px;"><b>' . PL_TESTER_H_INFO_RUBRIK_TEST_LINK . ':</b> ' . (isset($params['rubrikator']) && $params['rubrikator'] == 1 ? KERNEL_YES : KERNEL_NO) . '</div>';
}

function fTester_Elem_Categs_Info($params)
{
    fCategs_Elem_Categs_Info($params, 'pl_tester_categs_design');
}

function fTester_Elem_Selcat_Info($params)
{
    fCategs_Elem_Sel_Cat_Info($params, 'pl_tester_selcat_design');
}

/********************************** функции получения элементов модуля ***********************************/
function fTester_Elem_Test($el_id, $temp_id, $params, $tag_id)
{
    return "<?php include_once SB_CMS_PL_PATH.'/pl_tester/prog/pl_tester.php';\n
        fTester_Elem_Test('$el_id', '$temp_id', '" . addslashes(serialize($params)) . "', '$tag_id');\n
        ?>";
}

function fTester_Elem_Results($el_id, $temp_id, $params, $tag_id)
{
    return "<?php include_once SB_CMS_PL_PATH.'/pl_tester/prog/pl_tester.php';\n
        fTester_Elem_Results('$el_id', '$temp_id', '" . addslashes(serialize($params)) . "', '$tag_id');\n
        ?>";
}

function fTester_Elem_Rating($el_id, $temp_id, $params, $tag_id)
{
    return "<?php include_once SB_CMS_PL_PATH.'/pl_tester/prog/pl_tester.php';\n
        fTester_Elem_Rating('$el_id', '$temp_id', '" . addslashes(serialize($params)) . "', '$tag_id');\n
        ?>";

}

function fTester_Elem_Categs_Prog($el_id, $temp_id, $params, $tag_id)
{
    return "<?php include_once SB_CMS_PL_PATH.'/pl_tester/prog/pl_tester.php';\n
        fTester_Elem_Categs('$el_id', '$temp_id', '" . addslashes(serialize($params)) . "', '$tag_id');\n
        ?>";
}

function fTester_Elem_Selcat_Prog($el_id, $temp_id, $params, $tag_id)
{
    return "<?php include_once SB_CMS_PL_PATH.'/pl_tester/prog/pl_tester.php';\n
        fTester_Elem_Selcat('$el_id', '$temp_id', '" . addslashes(serialize($params)) . "', '$tag_id');\n
        ?>";
}
