<?php
require_once(SB_CMS_LANG_PATH.'/pl_texts.h.lng.php');

if ($_SESSION['sbPlugins']->register('pl_texts', PL_TEXTS_H_PLUGIN_NAME, ''))
{
	$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_USER.'>'.PL_TEXTS_H_PLUGIN_NAME, 'init');
    $_SESSION['sbPlugins']->addToExportImport(true, false);

	$_SESSION['sbPlugins']->setMainEvent('init');

	$_SESSION['sbPlugins']->addUserEvent('init', 'fTexts_Init', 'read', PL_TEXTS_H_PLUGIN_NAME);
	$_SESSION['sbPlugins']->addUserEvent('edit', 'fTexts_Edit', 'read', PL_TEXTS_H_EDIT_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('edit_submit', 'fTexts_Edit_Submit', 'elems_edit', PL_TEXTS_H_EDIT_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('delete', 'fTexts_Delete', 'elems_delete');
	
	$_SESSION['sbPlugins']->addUserEvent('gen_pages', 'fTexts_Gen_Pages', 'elems_edit', PL_TEXTS_H_GEN_PAGES_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('after_paste', 'fTexts_After_Paste', 'elems_edit');
	$_SESSION['sbPlugins']->addUserEvent('after_paste_categs_with_elements', 'fTexts_After_Paste_Categs_With_Elements', 'categs_edit|elems_edit');
	$_SESSION['sbPlugins']->addUserEvent('delete_cat_with_elements', 'fTexts_Before_Delete_Cat_With_Elements', 'elems_edit');
	
	$_SESSION['sbPlugins']->addToWorkflow();
	
	$fields = array();
	$fields['t_id'] = array('title' => PL_TEXTS_H_ID_LABEL, 'flags' => '8');
	$fields['t_name'] = array('title' => PL_TEXTS_H_NAME_LABEL, 'flags' => '4');
	$fields['t_html'] = array('title' => PL_TEXTS_H_HTML_LABEL, 'flags' => '7');
	$fields['t_status'] = array('title' => PL_TEXTS_H_STATUS_LABEL, 'flags' => '8');
	$fields['t_old_html'] = array('title' => PL_TEXTS_H_OLD_HTML_LABEL, 'flags' => '7');

	$_SESSION['sbPlugins']->addFieldsInfo('sb_texts', 't_id', 't_name', $fields);
}

$_SESSION['sbPlugins']->addSystemEvent('get_links', 'fTexts_Get_Links', PL_TEXTS_H_GET_LINKS_TITLE);
$_SESSION['sbPlugins']->addSystemEvent('text', 'fTexts_Get_Text', PL_TEXTS_H_ELEM_TEXT);
$_SESSION['sbPlugins']->addSystemEvent('random', 'fTexts_Get_Random', PL_TEXTS_H_ELEM_RANDOM);
$_SESSION['sbPlugins']->addSystemEvent('get_status', 'fTexts_Get_Status', PL_TEXTS_H_ELEM_GET_STATUS);
$_SESSION['sbPlugins']->addSystemEvent('get_status_submit', 'fTexts_Get_Status_Submit', PL_TEXTS_H_ELEM_GET_STATUS);

$_SESSION['sbPlugins']->addElem(PL_TEXTS_H_ELEM_HTML, 'html', 'fTexts_Elem_Html', 'fTexts_Elem_Text_Info', 'text', '(screen.availWidth - 100)', '(screen.availHeight - 100)');
$_SESSION['sbPlugins']->addElem(PL_TEXTS_H_ELEM_PLAIN, 'plain', 'fTexts_Elem_Plain', 'fTexts_Elem_Text_Info', 'text', '(screen.availWidth - 100)', '(screen.availHeight - 100)');
$_SESSION['sbPlugins']->addElem(PL_TEXTS_H_ELEM_RANDOM, 'random', 'fTexts_Elem_Random', 'fTexts_Elem_Random_Info', 'random', 600, 800);
$_SESSION['sbPlugins']->addElem(PL_TEXTS_H_ELEM_EMPTY, 'empty', 'fTexts_Elem_Empty');

$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_texts_delim', PL_TEXTS_H_PLUGIN_NAME, '', '', '', SB_COOKIE_DOMAIN, false);

$options = array();
$options['0'] = PL_TEXTS_H_SETTING_USE_DELIM_DEFAULT;

$res = sql_query('SELECT categs.cat_title, temps.pt_id, temps.pt_title FROM sb_categs categs, sb_catlinks links, sb_pager_temps temps WHERE temps.pt_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident=? ORDER BY categs.cat_left, temps.pt_title', 'pl_pager_temps');
if ($res)
{
    $old_cat_title = '';
    foreach ($res as $value)
    {
        list($cat_title, $pt_id, $pt_title) = $value;
        if ($old_cat_title != $cat_title)
        {
            $options['-'.uniqid()] = '-'.$cat_title;
            $old_cat_title = $cat_title;
        }
        $options[$pt_id] = $pt_title;
    }
}
    
$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_texts_use_delim', PL_TEXTS_H_SETTING_USE_DELIM, 'select', $options, '0', SB_COOKIE_DOMAIN, false);

sb_add_rights();

?>