<?php
function fTexts_Init()
{
    require_once(SB_CMS_LIB_PATH.'/sbElements.inc.php');

    $elems = new sbElements('sb_texts', 't_id', 't_name', 'fTexts_Get', 'pl_texts_init', 'pl_texts');

    $elems->mCategsRootName = PL_TEXTS_H_ROOT_NAME;
    $elems->mCategsClosed = false;

	$elems->addField('t_name');       // название текстового блока
	$elems->addField('t_status');       // название текстового блока

	$elems->addFilter(PL_TEXTS_H_ID_FILTER, 't_id', 'number');
	$elems->addFilter(PL_TEXTS_H_NAME_FILTER, 't_name', 'string');
    $elems->addFilter(PL_TEXTS_H_TEXT_FILTER, 't_html', 'string');

    sb_add_workflow_filter($elems, 'pl_texts', 't_status', false);

    $elems->addSorting(PL_TEXTS_H_SORT_BY_ID, 't_id');
    $elems->addSorting(PL_TEXTS_H_SORT_BY_NAME, 't_name');

    $elems->mCategsPasteElemsMenuTitle = PL_TEXTS_H_CATEGS_PASTE_ELEMS_MENU_TITLE;
    $elems->mCategsPasteLinksMenuTitle = PL_TEXTS_H_CATEGS_PASTE_LINKS_MENU_TITLE;

    $elems->mElemsAddMenuTitle  = PL_TEXTS_H_ELEMS_ADD_MENU_TITLE;
    $elems->mElemsEditMenuTitle = PL_TEXTS_H_ELEMS_EDIT_MENU_TITLE;
    $elems->mElemsCopyMenuTitle = PL_TEXTS_H_ELEMS_COPY_MENU_TITLE;
    $elems->mElemsCutMenuTitle  = PL_TEXTS_H_ELEMS_CUT_MENU_TITLE;

    $elems->mElemsEditEvent =  'pl_texts_edit&real_event=pl_texts_init';
    $elems->mElemsEditDlgWidth = 800;
	$elems->mElemsEditDlgHeight = 600;

	$elems->mElemsAddEvent =  'pl_texts_edit&real_event=pl_texts_init';
    $elems->mElemsAddDlgWidth = 800;
	$elems->mElemsAddDlgHeight = 600;

	$elems->mElemsDeleteEvent = 'pl_texts_delete';
	$elems->mCategsDeleteWithElementsMenu = true;
	$elems->mCategsBeforeDeleteWithElementsEvent = 'pl_texts_delete_cat_with_elements';

	$elems->mElemsAfterPasteEvent = 'pl_texts_after_paste';
	$elems->mCategsPasteWithElementsMenu = true;
	$elems->mCategsAfterPasteWithElementsEvent = 'pl_texts_after_paste_categs_with_elements';

	$elems->mElemsUseLinks = true;
	$elems->mElemsJavascriptStr .= '
		function linkPages(e)
		{
			if (!sbSelEl)
			{
				var el = sbEventTarget(e);

				while (el.parentNode && !el.getAttribute("true_id"))
					el = el.parentNode;

				var el_id = el.getAttribute("el_id");
			}
			else
				var el_id = sbSelEl.getAttribute("el_id");

			strPage = "'.SB_CMS_MODAL_DIALOG_FILE.'?event=pl_pages_get_links&e_id=" + el_id + "&ident[]=pl_texts_html&ident[]=pl_texts_plain";
			strAttr = "resizable=1,width=800,height=600";
			sbShowModalDialog(strPage, strAttr, null, window);
		}

		function linkTemps(e)
		{
			if(!sbSelEl)
			{
				var el = sbEventTarget(e);

				while (el.parentNode && !el.getAttribute("true_id"))
					el = el.parentNode;

				var el_id = el.getAttribute("el_id");
			}
			else
				var el_id = sbSelEl.getAttribute("el_id");

			strPage = "'.SB_CMS_MODAL_DIALOG_FILE.'?event=pl_templates_get_links&e_id=" + el_id + "&ident[]=pl_texts_html&ident[]=pl_texts_plain";
			strAttr = "resizable=1,width=800,height=600";
			sbShowModalDialog(strPage, strAttr, null, window);
		}';

	$elems->addElemsMenuItem(KERNEL_LINK_PAGES_MENU_ITEM, 'linkPages();');
	$elems->addElemsMenuItem(KERNEL_LINK_TEMPS_MENU_ITEM, 'linkTemps();');

	if ($_SESSION['sbPlugins']->isRightAvailable('pl_texts', 'elems_edit'))
	{
		$elems->mElemsJavascriptStr .= '
          function pagesGen(el_id)
		  {
				if(sbSelectedEls.length > 1)
		  		{
					var el_ids = "";
					for (var i = 0; i < sbSelectedEls.length; i++)
					{
						var el = sbGetE("el_" + sbSelectedEls[i]);
						if (el)
						{
							el_ids += el.getAttribute("el_id") + ",";
						}
					}

					el_ids = el_ids.substr(0, el_ids.length - 1);

					var strPage = "'.SB_CMS_DIALOG_FILE.'?event=pl_texts_gen_pages&ids=" + el_ids;
					var strAttr = "resizable=0,width=600,height=400";
					sbShowDialog(strPage, strAttr);
					return;
				}
				else if (typeof(el_id) == "undefined")
				{
					el_id = sbSelEl.getAttribute("el_id");
					var num_el = true;
				}
				else
				{
					var num_el = sbGetE(el_id + "_num");
				}

				if (num_el)
				{
					var strPage = "'.SB_CMS_DIALOG_FILE.'?event=pl_texts_gen_pages&id=" + el_id;
					var strAttr = "resizable=0,width=600,height=400";
					sbShowDialog(strPage, strAttr);
				}
			}';

		$elems->addElemsMenuItem(PL_TEXTS_H_PAGES_GEN_MENU_ITEM, 'pagesGen();');
		$elems->mElemsAfterEditFunc = 'pagesGen';
	}

	$elems->mElemsJavascriptStr .= '
		function sbTextExport(c)
		{
			if(c && sbSelCat)
			{
				var cat_id = sbSelCat.id;
    		}
    		else
    		{
				var cat_id = sbCatTree.getSelectedItemId();
			}

			var args = new Object();
			var form = sbGetE("filter_form");
			if(form)
			{
				var els = form.elements;
				for(var i = 0; i < els.length; i++)
				{
					if(els[i] && els[i].type != "button" && els[i].value != "")
					{
						var reg_date = new RegExp("date_");
						var reg_spin = new RegExp("spin_");

						if(reg_date.test(els[i].id))
						{
							args[els[i].name] = {};
							args[els[i].name]["value"]= els[i].value;
							args[els[i].name]["type"]= "date";
						}
						else if(reg_spin.test(els[i].id))
						{
							args[els[i].name] = {};
							args[els[i].name]["value"]= els[i].value;
							args[els[i].name]["type"]= "number";
						}
						else if(els[i].nodeName == "SELECT")
						{
							var reg_link = new RegExp("_link");
							if(els[i].value == -1 && reg_link.test(els[i].id))
							{
								var name = els[i].name.replace(/_link/, "");
								args[name] = "";
								continue;
							}
							else if(els[i].value == -1)
							{
								continue;
							}

							args[els[i].name] = {};
							args[els[i].name]["value"]= els[i].value;
							args[els[i].name]["type"]= "select";
						}
						else if(els[i].type == "ckeckbox")
						{
							args[els[i].name] = {};
							args[els[i].name]["value"]= els[i].value;
							args[els[i].name]["type"]= "checkbox";
						}
						else if(els[i].type == "text")
						{
							args[els[i].name] = {};
							args[els[i].name]["value"]= els[i].value;
							args[els[i].name]["type"]= "string";
						}
    				}
				}
			}

			var strPage = "'.SB_CMS_DIALOG_FILE.'?event=pl_export_edit&ident=pl_texts&cat_id="+ cat_id;
			var strAttr = "resizable=1,width=700,height=600";
			sbShowModalDialog(strPage, strAttr, null, args);
		}

		function sbTextImport(c)
		{
			if(c && sbSelCat)
			{
				var cat_id = sbSelCat.id;
    		}
    		else
    		{
				var cat_id = sbCatTree.getSelectedItemId();
			}

			var args = new Object();

			var strPage = "'.SB_CMS_DIALOG_FILE.'?event=pl_export_import_edit&ident=pl_texts&cat_id="+ cat_id;
			var strAttr = "resizable=1,width=650,height=370";
			sbShowModalDialog(strPage, strAttr, sbAfterTextImport, args);
		}

		function sbAfterTextImport()
		{
			window.location.href = "'.SB_CMS_CONTENT_FILE.'?event=pl_texts_init";
		}';

	$elems->addElemsMenuItem(PL_TEXTS_H_EDIT_EXPORT, 'sbTextExport()', false);
	//$elems->addElemsMenuItem(PL_TEXTS_H_EDIT_IMPORT, 'sbTextImport()', false);
	$elems->addCategsMenuItem(PL_TEXTS_H_EDIT_EXPORT, 'sbTextExport(true)');
	$elems->addCategsMenuItem(PL_TEXTS_H_EDIT_IMPORT, 'sbTextImport(true)');

	$elems->init();

}

function fTexts_Edit($htmlStr = '', $footerStr = '', $footerLinkStr = '')
{
	$edit_group = sbIsGroupEdit();

	// проверка прав доступа
	if ($edit_group)
    {
    	if (!fCategs_Check_Elems_Rights($_GET['ids'][0], $_GET['cat_id'], 'pl_texts'))
			return;
    }
    elseif (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'], 'pl_texts'))
    {
		return;
	}

	$edit_rights = $_SESSION['sbPlugins']->isRightAvailable('pl_texts', 'elems_edit');
	if (count($_POST) == 0 && isset($_GET['id']) && $_GET['id'] != '' && !$edit_group)
	{
   		$result = sql_param_query('SELECT t_name, t_html, t_old_html, t_status FROM sb_texts WHERE t_id=?d', $_GET['id']);

   		if ($result)
	    {
        	list($t_name, $t_html, $t_old_html, $t_status) = $result[0];
	    }
	    else
	    {
	        sb_show_message(PL_TEXTS_EDIT_ERROR, true, 'warning');
	        return;
	    }
	}
	elseif (count($_POST) > 0)
	{
		$t_old_html = '';
		$t_status = 0;

    	extract($_POST);

    	if (!isset($_GET['id']))
            $_GET['id'] = '';
	}
	else
	{
	    $t_name = $t_html = $t_old_html = '';
        $t_status = 1;

	    $_GET['id'] = '';
	}

	echo '<script>
	        function checkValues()
            {
                var el_name = sbGetE("t_name");
                '.($edit_group ? '
            	var ch_n = sbGetE("ch_t_name");
            	' : '').'
                if (el_name.value == "" '.($edit_group ? ' && ch_n.checked' : '').')
                {
          	         alert("'.PL_TEXTS_EDIT_NO_TITLE_MSG.'");
          	         return false;
                }
            }';

	if($htmlStr != '')
	{
		if($edit_group)
		{
			echo '
	            function cancel()
                {
					sbReturnValue("refresh");
				}';
		}
		elseif ($footerStr == '')
		{
	        echo '
	            function cancel()
                {
                    sbReturnValue('.intval($_GET['id']).');
                }';
	    }
	    else
	    {
    	    echo '
                function cancel()
                {
                    var res = new Object();
    		        res.html = "'.$htmlStr.'";
    		        res.footer = "'.$footerStr.'";
    		        res.footer_link = "'.$footerLinkStr.'";
    		        res.not_call = 1;
    				sbReturnValue(res);
				}';
		}
		echo 'sbAddEvent(window, "close", cancel);';
	}
	elseif($edit_group)
	{
		echo '
			function cancel()
            {
				sbReturnValue("refresh");
			}
			sbAddEvent(window, "close", cancel);';
	}
	echo '</script><br />';

	require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

	$layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE.'?event=pl_texts_edit_submit'.($_SERVER['QUERY_STRING'] != '' ? '&'.$_SERVER['QUERY_STRING'] : ''), 'thisDialog', 'post', 'checkValues()');
	$layout->mTableWidth = '95%';

	$layout->addHeader(PL_TEXTS_EDIT_HEADER);

	$layout->addField(PL_TEXTS_EDIT_NAME.sbGetGroupEditCheckbox('t_name', $edit_group), new sbLayoutInput('text', $t_name, 't_name', '', 'style="width:550px;"', true));

	$fld = new sbLayoutTextarea($t_html, 't_html', '', 'style="width:100%;height:270px;"');

	$use_php = sb_stripos($t_html, '<?') !== false && sb_stripos($t_html, '?>') !== false;
	if($use_php)
	{
		sb_show_message(PL_TEXTS_EDIT_PHP_MSG);
	}
	else
	{
		$fld->mShowEditorBtn = true;
	}
	$layout->addField(PL_TEXTS_EDIT_HTML.sbGetGroupEditCheckbox('t_html', $edit_group), $fld);

	if ($_SESSION['sbPlugins']->isPluginAvailable('pl_workflow') && $_SESSION['sbPlugins']->isPluginInWorkflow('pl_texts'))
	{
		if (!$edit_group)
		{
			$edit_rights = $edit_rights && sb_add_workflow_status($layout, 'pl_texts', $_GET['id'], 't_status', isset($t_status) ? $t_status : '');
		}
		else
		{
			$states_arr = array();
			$states = sql_query('SELECT t_status FROM sb_texts WHERE t_id IN (?a)', $_GET['ids']);

			if ($states)
			{
				foreach($states as $val)
				{
					$states_arr[] = $val[0];
				}
			}

			$edit_rights = $edit_rights && sb_add_workflow_status($layout, 'pl_texts', $_GET['ids'], 't_status', $states_arr);
		}
	}

	$layout->addButton('submit', KERNEL_SAVE, 'btn_save', '', ($edit_rights ? '' : 'disabled="disabled"'));
    if ($_GET['id'] != '' && !$edit_group)
    {
		$layout->addButton('submit', KERNEL_APPLY, 'btn_apply', '', ($edit_rights ? '' : 'disabled="disabled"'));
	}

	$layout->addButton('button', KERNEL_CANCEL, '', '', $htmlStr != '' || $edit_group ? 'onclick="cancel()"' : 'onclick="sbCloseDialog()"');
	$layout->show();
}

function fTexts_Edit_Submit()
{
	$edit_group = sbIsGroupEdit();

    //	проверка прав доступа
	if ($edit_group)
	{
		if (!fCategs_Check_Elems_Rights($_GET['ids'][0], $_GET['cat_id'], 'pl_texts'))
		{
			return;
		}
	}
	else if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'], 'pl_texts'))
	{
		return;
	}

	if (!isset($_GET['id']))
		$_GET['id'] = '';

	$t_old_html = '';

    if ($_GET['id'] != '')
	{
	    $res = sql_param_query('SELECT t_name, t_html, t_old_html FROM sb_texts WHERE t_id=?d', $_GET['id']);
	    if (!$res)
	    {
	    	sb_show_message(PL_TEXTS_EDIT_ERROR, false, 'warning');
            sb_add_system_message(sprintf(PL_TEXTS_EDIT_SYSTEMLOG_ERROR, $t_name), SB_MSG_WARNING);

            fTexts_Edit();
		    return;
	    }

		list($old_title, $t_html, $t_old_html) = $res[0];
	    if (isset($_POST['old_workflow']) && $_POST['old_workflow'] == 1)
	    {
			$t_old_html = $t_html;
		}
	}

	$ch_t_name = $ch_t_html = $t_status = 0;
	$t_name = $t_html = '';

	extract($_POST);
	$t_status = intval($t_status);

	if ((!$edit_group || $edit_group && $ch_t_name == 1) && $t_name == '')
	{
        sb_show_message(PL_TEXTS_EDIT_NO_TITLE_MSG, false, 'warning');
        fTexts_Edit();
        return;
    }

    $t_name = strip_tags($t_name);

	if($_SESSION['sbPlugins']->isPluginAvailable('pl_workflow') && $_SESSION['sbPlugins']->isPluginInWorkflow('pl_texts'))
	{
		if($t_status == 1)
		{
			$t_old_html = '';
		}
	}
	else
	{
		$t_status = 1;
		$_POST['t_status'] = 1;
		$t_old_html = '';
	}

	$row = array();
	sb_submit_workflow_status($row, 't_status', '', '', $edit_group);

	if (!$edit_group || $edit_group && $ch_t_name == 1)
    	$row['t_name'] = $t_name;

    if (!$edit_group || $edit_group && $ch_t_html == 1)
    	$row['t_html'] = $t_html;

    $row['t_old_html'] = $t_old_html;

    if ($edit_group || $_GET['id'] != '')
	{
        // редактирование
        if (!$edit_group)
        {
			sql_param_query('UPDATE sb_texts SET ?a WHERE t_id=?d', $row, $_GET['id'], sprintf(PL_TEXTS_EDIT_OK, $old_title));
        }
        else
        {
			sql_param_query('UPDATE sb_texts SET ?a WHERE t_id IN (?a)', $row, $_GET['ids'], PL_TEXTS_EDIT_GROUP_OK);

		}

        if (!$edit_group)
        {
	        $footer_ar = fCategs_Edit_Elem();
	        if (!$footer_ar)
	        {
	            sb_show_message(PL_TEXTS_EDIT_ERROR, false, 'warning');
	            sb_add_system_message(sprintf(PL_TEXTS_EDIT_SYSTEMLOG_ERROR, $old_title), SB_MSG_WARNING);

	            fTexts_Edit();
	    	    return;
	        }
	        $footer_str = $GLOBALS['sbSql']->escape($footer_ar[0], false, false);
	        $footer_link_str = $GLOBALS['sbSql']->escape($footer_ar[1], false, false);

	        $row['t_id'] = intval($_GET['id']);

	        $html_str = fTexts_Get($row);
	        $html_str = sb_str_replace(array("\r\n", "\r", "\n"), '', $html_str);
	        $html_str = $GLOBALS['sbSql']->escape($html_str, false, false);
        }

        if (!$edit_group)
        {
	        $res_pages = sql_param_query('SELECT DISTINCT pages.p_id FROM sb_pages pages, sb_elems elems, sb_templates temps
    	                    WHERE (elems.e_link="page" AND elems.e_el_id=?d AND (elems.e_ident="pl_texts_html" OR elems.e_ident="pl_texts_plain") AND pages.p_id=elems.e_p_id)
        	                OR (elems.e_link="temp" AND elems.e_el_id=?d AND (elems.e_ident="pl_texts_html" OR elems.e_ident="pl_texts_plain") AND pages.p_temp_id=elems.e_p_id)', $_GET['id'], $_GET['id']);
        }

        if (!isset($_POST['btn_apply']) && !$edit_group)
        {
            echo '<script>
        	        var res = new Object();
        	        res.html = "'.$html_str.'";
        	        res.footer = "'.$footer_str.'";
        	        res.footer_link = "'.$footer_link_str.'";
        			sbReturnValue(res);
        		  </script>';
        }
        elseif (!$edit_group)
        {
			if ($res_pages)
    		{
    			echo '<script>
    				var strPage = "'.SB_CMS_DIALOG_FILE.'?event=pl_texts_gen_pages&id='.intval($_GET['id']).'";
                  	var strAttr = "resizable=0,width=600,height=400";
                  	sbShowDialog(strPage, strAttr);
    	    	</script>';
    		}

            fTexts_Edit($html_str, $footer_str, $footer_link_str);
        }
        else
        {
			echo '<script>
					  sbReturnValue("refresh");
				  </script>';
		}

        sb_mail_workflow_status('pl_texts', (!$edit_group ? $_GET['id'] : $_GET['ids']), $t_name, $t_status);
	}
	else
	{
		$error = true;

		if (sql_param_query('INSERT INTO sb_texts SET ?a', $row))
	    {
			$id = sql_insert_id();

			if (fCategs_Add_Elem($id))
    		{
				sb_add_system_message(sprintf(PL_TEXTS_ADD_OK, $t_name));
        		echo '<script>
        				sbReturnValue('.$id.');
        			  </script>';
				$error = false;
    		}
			else
    		{
				sql_query('DELETE FROM sb_texts WHERE t_id="'.$id.'"');
    		}
	    }

	    if ($error)
	    {
	        sb_show_message(sprintf(PL_TEXTS_ADD_ERROR, $t_name), false, 'warning');
            sb_add_system_message(sprintf(PL_TEXTS_ADD_SYSTEMLOG_ERROR, $t_name), SB_MSG_WARNING);
            fTexts_Edit();
			return;
	    }
	    else
	    {
			sb_mail_workflow_status('pl_texts', $id, $t_name, $t_status);
	    }
	}
}

function fTexts_Gen_Pages()
{
	if(isset($_GET['ids']) && $_GET['ids'] != '')
	{
		sbIsGroupEdit(false);

		$res = sql_query('SELECT DISTINCT pages.p_id FROM sb_pages pages, sb_elems elems, sb_templates temps
			                        WHERE (elems.e_link="page" AND elems.e_el_id IN (?a) AND (elems.e_ident="pl_texts_html" OR elems.e_ident="pl_texts_plain") AND pages.p_id=elems.e_p_id)
							OR (elems.e_link="temp" AND elems.e_el_id IN (?a) AND (elems.e_ident="pl_texts_html" OR elems.e_ident="pl_texts_plain") AND pages.p_temp_id=elems.e_p_id)', $_GET['ids'], $_GET['ids']);
	}
	else
	{
    	$id = intval($_GET['id']);
    	$res = sql_query('SELECT DISTINCT pages.p_id FROM sb_pages pages, sb_elems elems, sb_templates temps
	                        WHERE (elems.e_link="page" AND elems.e_el_id="'.$id.'" AND (elems.e_ident="pl_texts_html" OR elems.e_ident="pl_texts_plain") AND pages.p_id=elems.e_p_id)
							OR (elems.e_link="temp" AND elems.e_el_id="'.$id.'" AND (elems.e_ident="pl_texts_html" OR elems.e_ident="pl_texts_plain") AND pages.p_temp_id=elems.e_p_id)');
	}

    if (!$res)
    {
        sb_show_message(PL_TEXTS_SHOW_PAGES_ERROR, true);

        echo '<br /><br /><a href="javascript:window.close();">[ '.KERNEL_CLOSE.' ]</a>';
        return;
    }

    $num_res = count($res);

    if (!isset($_GET['num']))
    {
        echo '<br /><br />'.
         '<div align="left" style="width: 80%;"><b>'.PL_TEXTS_GEN_PAGES_ALL.'</b>: '.$num_res.'</div><br />'.
         '<div align="left" style="width: 80%;"><b>'.PL_TEXTS_GEN_PAGES_CUR.'</b>: <span id="num">0</span></div><br />
          <div style="border: 1px solid black; width: 80%; height: 17px; background-color: red; text-align:center;">
   	          <b style="color: #fff;">0%</b>
          </div>
          <script>
              function reloadWnd()
              {
                  window.location = "'.SB_CMS_DIALOG_FILE.'?event=pl_texts_gen_pages&'.(isset($_GET['id']) ? 'id='.$_GET['id'] : 'ids='.implode(',', $_GET['ids'])).'&num=0&good_num=0";
              }
              setTimeout("reloadWnd();", 100);
          </script>';
        return;
    }

    $num = intval($_GET['num']);
    $good_num = intval($_GET['good_num']);

    $time_end = ini_get('max_execution_time');
    if ($time_end > 0)
    {
        $time_end = time() + $time_end - 5;
    }
    else
    {
        $time_end = time() + 1000000;
    }

    $start_time = time();

    echo '<br /><br />'.
         '<div align="left" style="width: 80%;"><b>'.PL_TEXTS_GEN_PAGES_ALL.'</b>: '.$num_res.'</div><br />'.
         '<div align="left" style="width: 80%;"><b>'.PL_TEXTS_GEN_PAGES_CUR.'</b>: <span id="num">0</span></div><br />
          <div style="border: 1px solid black; width: 80%; height: 17px; background-color: red; text-align:left;">
   	          <div id="progress" style="width: 0%; height: 17px; background-color: green;text-align:center;">
   	              <b id="percent" style="color: #fff;">0%</b>
   	          </div>
   	      </div><br />
   	      <div id="close_link" style="display: none;"><a href="javascript:window.close();">[ '.KERNEL_CLOSE.' ]</a></div>';

    for ($i = $num; $i < $num_res; $i++)
   	{
   	    if(time() > $time_end)
   	    {
   	        $percent = round($i / $num_res * 100);
   	        echo '<script>
                  function reloadWnd()
   	              {
   	                  window.location = "'.SB_CMS_DIALOG_FILE.'?event=pl_texts_gen_pages&'.(isset($_GET['id']) ? 'id='.$_GET['id'] : 'ids='.implode(',', $_GET['ids'])).'&num='.$i.'&good_num='.$good_num.'";
   	              }

   	              sbGetE("progress").style.width = "'.$percent.'%";
                  sbGetE("percent").innerHTML = "'.$percent.'%";
                  sbGetE("num").innerHTML = "'.$good_num.'";
   	              setTimeout("reloadWnd();", 100);
		      </script>';

            return;
   	    }

   	    if ($start_time - time() > 5)
   	    {
   	        header('SBuilder_Ping: Pong;', true);
   	    }

   	    if (fPages_Gen_Page($res[$i][0]))
   	        $good_num++;
	}

	if ($good_num != $num_res)
	{
	   sb_show_message(PL_TEXTS_GEN_PAGES_ERROR, false, 'warning');
	   echo '<script>
	        sbGetE("progress").style.width = "100%";
	        sbGetE("progress").style.backgroundColor = "'.($good_num != $num_res ? '#FF6600' : 'green').'";
	        sbGetE("percent").innerHTML = "100%";
	        sbGetE("num").innerHTML = "'.$good_num.'";
	        sbGetE("close_link").style.display = "";
	    </script>';
	}
	else
	{
		echo '<script>
	        sbGetE("progress").style.width = "100%";
	        sbGetE("progress").style.backgroundColor = "'.($good_num != $num_res ? '#FF6600' : 'green').'";
	        sbGetE("percent").innerHTML = "100%";
	        sbGetE("num").innerHTML = "'.$good_num.'";
	        setTimeout("window.close();", 500);
	    </script>';
	}
}

function fTexts_Delete()
{
    $id = intval($_GET['id']);

    $pages = sql_query('SELECT pages.p_id, pages.p_name FROM sb_pages pages, sb_elems elems
	                    WHERE elems.e_link="page" AND elems.e_el_id="'.$id.'" AND (elems.e_ident="pl_texts_html" OR elems.e_ident="pl_texts_plain") AND pages.p_id=elems.e_p_id');

	$temps = sql_query('SELECT temps.t_id, temps.t_name FROM sb_templates temps, sb_elems elems
	                    WHERE elems.e_link="temp" AND elems.e_el_id="'.$id.'" AND (elems.e_ident="pl_texts_html" OR elems.e_ident="pl_texts_plain") AND temps.t_id=elems.e_p_id');

    if ($pages && count($pages) > 0)
    {
        echo PL_TEXTS_DELETE_PAGES_ERROR;
        return;
    }

    if ($temps && count($temps) > 0)
    {
        echo PL_TEXTS_DELETE_TEMPS_ERROR;
        return;
    }
}

function fTexts_Before_Delete_Cat_With_Elements()
{
	if(isset($_GET['cat_id']))
	{
		$res = sql_query('SELECT cat_left, cat_right FROM sb_categs WHERE cat_id=?d', $_GET['cat_id']);
		if(!$res)
			return;
		list($left, $right) = $res[0];
    	// Достаю все тексты
    	$res = sql_query('SELECT t.t_id FROM sb_categs categs, sb_catlinks links, sb_texts t
                          WHERE categs.cat_left >= ?d AND categs.cat_right <= ?d AND categs.cat_ident="pl_texts"
                          AND links.link_cat_id=categs.cat_id AND t.t_id = links.link_el_id', $left, $right);

    	foreach($res as $value)
    	{
			$elems[] = $value[0];
    	}

		$pages = sql_query('SELECT pages.p_id, pages.p_name FROM sb_pages pages, sb_elems elems
	                    WHERE elems.e_link="page" AND elems.e_el_id IN (?a) AND (elems.e_ident="pl_texts_html" OR elems.e_ident="pl_texts_plain") AND pages.p_id=elems.e_p_id', $elems);

		$temps = sql_query('SELECT temps.t_id, temps.t_name FROM sb_templates temps, sb_elems elems
	                    WHERE elems.e_link="temp" AND elems.e_el_id IN (?a) AND (elems.e_ident="pl_texts_html" OR elems.e_ident="pl_texts_plain") AND temps.t_id=elems.e_p_id', $elems);


		if ($pages && count($pages) > 0)
    	{
    	    echo PL_TEXTS_DELETE_PAGES_ERROR;
    	    return;
    	}

    	if ($temps && count($temps) > 0)
    	{
    	    echo PL_TEXTS_DELETE_TEMPS_ERROR;
    	    return;
    	}
	}
}

function fTexts_After_Paste()
{
	if (!isset($_GET['action']) || $_GET['action'] != 'copy' || !isset($_GET['ne']) || !is_array($_GET['ne']) || count($_GET['ne']) <= 0)
		return;

	if (!$_SESSION['sbPlugins']->isPluginAvailable('pl_workflow') || !$_SESSION['sbPlugins']->isPluginInWorkflow('pl_texts'))
		return;

	$res = sql_query('SELECT t_id, t_status FROM sb_texts WHERE t_id IN ('.implode(',', $_GET['ne']).')');

	if ($res)
	{
		foreach ($res as $value)
		{
			list($t_id, $t_status) = $value;

			if (!sb_workflow_status_available($t_status, 'pl_texts', -1))
			{
				sql_query('UPDATE sb_texts SET t_status=?d WHERE t_id=?d', current(sb_get_avail_workflow_status('pl_texts')), $t_id);
			}
		}
	}
}

function fTexts_After_Paste_Categs_With_Elements()
{
	if (!isset($_SESSION['paste_categs_with_elems_ids']) ||
		!isset($_SESSION['paste_categs_with_elems_ids']['old']) ||
		!isset($_SESSION['paste_categs_with_elems_ids']['new']))
	{
		return;
	}

	$_GET['e'] = array_values($_SESSION['paste_categs_with_elems_ids']['old']);
	$_GET['ne'] = array_values($_SESSION['paste_categs_with_elems_ids']['new']);
	$_GET['action'] = 'copy';

	fTexts_After_Paste();
}
?>