<?php
function fUpdate_Info()
{   
	$res = sql_query('SELECT MAX(u_update_id) FROM sb_updates');
    if ($res)
    {
        list($u_update_id) = $res[0];
        
        $major_ver = trim(substr($u_update_id, 0, 2), '0');
        $minor_ver = trim(substr($u_update_id, 2));
    
        $ver = $major_ver.'.'.$minor_ver;
        
        if (empty($ver) || $ver < CMS_DISTR_VERSION)
        {
            $ver = CMS_DISTR_VERSION;
        }
    }
    else
    {
        $ver = CMS_DISTR_VERSION;
    }
    
    
    
    $res = sql_query('SELECT u_update_id, u_release_date, u_setup_date FROM sb_updates ORDER BY u_setup_date DESC LIMIT 1');
    $key = urlencode(base64_encode(file_get_contents(SB_CMS_KERNEL_PATH.'/key.php')));
    
    if ($res)
    {
        list($u_update_id, $u_release_date, $u_setup_date) = $res[0];
        
        $major_ver = trim(substr($u_update_id, 0, 2), '0');
        $minor_ver = trim(substr($u_update_id, 2));
            
        $cms_version = $major_ver.'.'.$minor_ver;
    	if ($cms_version == '.' || $cms_version < CMS_DISTR_VERSION)
        {
            $cms_version = CMS_DISTR_VERSION;
            $cms_date_setup = PL_UPDATE_H_NO_UPDATING;
    
        	$u_update_id = '0'.preg_replace('/[^0-9]+/', '', CMS_DISTR_VERSION);
        }
        else 
        {
        	$cms_date_setup = date('d.m.Y '.KERNEL_IN.' H:i', $u_setup_date);
        }
    }
    else 
    {
        $cms_version = CMS_DISTR_VERSION;
        $cms_date_setup = PL_UPDATE_H_NO_UPDATING;
    
        $u_update_id = '0'.preg_replace('/[^0-9]+/', '', CMS_DISTR_VERSION);
    }
        
    // сервер возвращает код ошибки или XML со списком обновлений
    require_once (SB_CMS_LIB_PATH.'/sbDownload.inc.php');
    $download = new sbDownload('http://update.sbuilder.ru/billing/index.php?key='.$key);
    $code = $download->download();
    
    $error_str = '';
    $new_updates_str = '';
    $expire_str = '';
    
    if (substr_count($code, '|') > 0)
    {
        $code = explode('|', $code);
    }
    else 
    {
        $code = array($code, '');
    }
    
    if (is_numeric($code[0]))
    {
        switch ($code[0])
        {
            case '001':
                $error_str = PL_UPDATE_H_ERROR_UPDATE;
                break;
                
            case '002':
                $expire_str = sprintf(PL_UPDATE_H_ERROR_CODE_002, $code[1]);
                break;
                
            case '003':
                $date = explode('.', $code[1]);
                $time = mktime(0, 0, 0, $date[1], $date[0], $date[2]);
                
                $time = $time - time();
                
                if ($time < 30 * 24 * 60 * 60)
                {
                    $expire_str = sprintf(PL_UPDATE_H_ERROR_CODE_003, implode('.', $date)); 
                }
                break;
        }
    }
    else 
    {
        $error_str = PL_UPDATE_H_ERROR_UPDATE;
    }

    if ($error_str == '')
    {
        $download->setURL('http://update.sbuilder.ru/billing/index.php?key='.$key.'&cid='.$u_update_id);
        $code = $download->download();
        
        if (substr_count($code, '|') > 0)
        {
            $code = explode('|', $code);
        }
        else 
        {
            $code = array($code, '');
        }
    
        if (is_numeric($code[0]))
        {
            switch ($code[0])
            {
                case '001':
                case '005':
                default:
                    $error_str = PL_UPDATE_H_ERROR_UPDATE;
                    break;
                    
                case '004':
                    $new_updates_str = PL_UPDATE_H_NO_UPDATES;
                    break; 
            }
        }
        elseif (!$code[0])
        {
            $error_str = PL_UPDATE_H_ERROR_UPDATE;
        }
        else 
        {
            $xml = new SimpleXMLElement($code[0]);
            $new_updates_str = count($xml->update);
        }
    }
    
    $result = '<table width="100%" cellspacing="0" cellpadding="5" class="form" style="border:0;">
            <tr><td width="1"><nobr>'.PL_UPDATE_H_CURRENT_RELEASE_SYSTEM.':</nobr></td><td><b>'. $cms_version .'</b></td></tr>
            <tr><td width="1"><nobr>'.PL_UPDATE_H_DATE_LAST_UPDATING.':</nobr></td><td><b>'.$cms_date_setup.'</b></td></tr>';
    
    if ($error_str == '')
    {
            $result .= '<tr><td width="1"><nobr>'.PL_UPDATE_H_NEW_UPDATES.':</nobr></td><td><b>'.$new_updates_str.'</td></tr>
            </table>'.(is_numeric($new_updates_str) ? '</b><div class="hint_div" style="margin: 5px; color:green;">'.PL_UPDATE_H_NEW_UPDATES_HINT.'</div>' : '');
    }
    else 
    {
        $result .= '</table>';
    }
            
    if ($error_str != '')
    {
        $result .= '<div style="text-align:center; padding: 10px; color: red;">'.$error_str.'</div>';
    }
    elseif ($expire_str != '')
    {
        $result .= '<div style="text-align:center; padding: 10px; color: red;">'.$expire_str.'</div>';
    }
    
    if ($_SESSION['sbPlugins']->isRightAvailable('pl_update', 'read'))
    {
        $result .= '<br><div class="sbDS_more"><a href="'.SB_CMS_CONTENT_FILE.'?event=pl_update_init">'.KERNEL_MORE.'</a></div>';
    }
    
    echo $result;
}

function fUpdate_Dump($update_id)
{
    // передаем ключ на сервер и проверяем подписку
    $key = urlencode(base64_encode(file_get_contents(SB_CMS_KERNEL_PATH.'/key.php')));
    
    // сервер возвращает код ошибки или XML запрошенного апдейта
    require_once (SB_CMS_LIB_PATH.'/sbDownload.inc.php');
    $download = new sbDownload('http://update.sbuilder.ru/billing/index.php?key='.$key.'&uid='.$update_id.'&zip=0');
    $code = $download->download();
    
    if (substr_count($code, '|') > 0)
    {
        $code = explode('|', $code);
    }
    else 
    {
        $code = array($code, '');
    }
    
    if (is_numeric($code[0]))
    {
        // произошла ошибка
        switch ($code[0])
        {
            case '001':
                sb_add_system_message(PL_UPDATE_H_ERROR_CODE_001, SB_MSG_WARNING);
                return false;
                
            case '002':
                sb_add_system_message(sprintf(PL_UPDATE_H_ERROR_CODE_002, $code[1]), SB_MSG_WARNING);
                return false;
                
            case '005':
                sb_add_system_message(PL_UPDATE_H_ERROR_CODE_005, SB_MSG_WARNING);
                return false;
            
            case '006':
                sb_add_system_message(PL_UPDATE_H_ERROR_CODE_006, SB_MSG_WARNING);
                return false;
                    
            case '007':
                sb_add_system_message(PL_UPDATE_H_ERROR_CODE_007, SB_MSG_WARNING);
                return false;
                
            default:
                sb_add_system_message(PL_UPDATE_H_ERROR_UPDATE, SB_MSG_WARNING);
                return false;  
        }
    }
    
    $sql = false;
    $xml = new SimpleXMLElement($code[0]);
    if(isset($xml->update[0]->dir))
    {
        $dir_node = $xml->update[0]->dir[0];
        
        foreach ($dir_node->file as $file_node)
        {
            if ($file_node['name'] == 'dump.sql')
            {
                $sql = true;
                $GLOBALS['sbVfs']->mLocal = true;

                // проверяем права на папки и файлы
                if (!$GLOBALS['sbVfs']->exists(SB_CMS_TMP_PATH))
                {
                    if (!$GLOBALS['sbVfs']->mkdir(SB_CMS_TMP_PATH))
                    {
                        sb_add_system_message(sprintf(PL_UPDATE_H_ERROR_MKDIR, substr(SB_CMS_TMP_PATH, strlen(SB_BASEDIR))), SB_MSG_WARNING);
                        $GLOBALS['sbVfs']->mLocal = false;
                        return false;
                    }
                }
            
                if (!$GLOBALS['sbVfs']->is_writable(SB_CMS_TMP_PATH))
                {
                    sb_add_system_message(sprintf(PL_UPDATE_H_ERROR_DIR_RIGHTS, substr(SB_CMS_TMP_PATH, strlen(SB_BASEDIR))), SB_MSG_WARNING);
                    $GLOBALS['sbVfs']->mLocal = false;
                    return false;
                }
                
                $tmp_id = uniqid();
                $tmp_dir = SB_CMS_TMP_PATH.'/'.$tmp_id;
                
                if (!$GLOBALS['sbVfs']->exists($tmp_dir))
                {
                    if (!$GLOBALS['sbVfs']->mkdir($tmp_dir))
                    {
                        sb_add_system_message(sprintf(PL_UPDATE_H_ERROR_MKDIR, substr($tmp_dir, strlen(SB_BASEDIR))), SB_MSG_WARNING);
                        $GLOBALS['sbVfs']->mLocal = false;
                        return false;
                    }
                }
                
                if (!$GLOBALS['sbVfs']->is_writable($tmp_dir))
                {
                    sb_add_system_message(sprintf(PL_UPDATE_H_ERROR_DIR_RIGHTS, substr($tmp_dir, strlen(SB_BASEDIR))), SB_MSG_WARNING);
                    $GLOBALS['sbVfs']->mLocal = false;
                    return false;
                }
                
                require_once (SB_CMS_LIB_PATH.'/sbDownload.inc.php');
    
                $file_path = $tmp_dir.'/'.$file_node['name'];
                
                // скачиваем файл
                $download = new sbDownload(trim((string) $file_node));
                $file = $download->download();
                
                if (!$file || sb_crc($file) != $file_node['checksum'])
                {
                    sb_add_system_message(sprintf(PL_UPDATE_H_ERROR_FILE_GET, $dir_node['path'].'/'.$file_node['name']), SB_MSG_ERROR); 
                    $GLOBALS['sbVfs']->mLocal = false;
                    return false;
                }
                
                if ($GLOBALS['sbVfs']->file_put_contents($file_path, $file) === false)
                {
                    sb_add_system_message(sprintf(PL_UPDATE_H_ERROR_FILE_PUT, substr($file_path, strlen(SB_BASEDIR))), SB_MSG_ERROR); 
                    $GLOBALS['sbVfs']->mLocal = false;
                    return false;
                }
                
                if (!$GLOBALS['sbVfs']->exists($tmp_dir.'/dump.sql'))
                {
                    sb_add_system_message(sprintf(PL_UPDATE_H_ERROR_UPDATE_SQL_EXISTS, substr($tmp_dir.'/dump.sql', strlen(SB_BASEDIR))), SB_MSG_ERROR);
                    $GLOBALS['sbVfs']->mLocal = false;
                    return false;
                }
                
                $GLOBALS['sbVfs']->mLocal = false;
                require_once(SB_CMS_LIB_PATH.'/sbDumper.inc.php');
                $dumper = new sbDumper();
                
                if (!$dumper->loadDumpFile(substr($tmp_dir.'/dump.sql', strlen(SB_BASEDIR))))
                {
                    sb_add_system_message(sprintf(PL_UPDATE_H_ERROR_UPDATE_SQL, substr($tmp_dir.'/dump.sql', strlen(SB_BASEDIR))), SB_MSG_ERROR);
                    return false;
                }
                
                $GLOBALS['sbVfs']->mLocal = true;
                $GLOBALS['sbVfs']->delete($tmp_dir);
                $GLOBALS['sbVfs']->mLocal = false;
    
                break;
            }
        }
    }
    else 
    {
        sb_add_system_message(PL_UPDATE_H_ERROR_CODE_005, SB_MSG_WARNING);
        return false;
    }
    
    // записываем результат в базу
    $row = array();
    $row['u_update_id'] = $xml->update[0]['id'];
    $row['u_release_date'] = $xml->update[0]['time'];
    $row['u_setup_date'] = time();
    $row['u_info'] = SB_CHARSET == 'UTF-8' ? (string) $xml->update[0] : iconv('UTF-8', SB_CHARSET.'//IGNORE', (string) $xml->update[0]); 
    $row['u_sql'] = $sql ? '1' : '0';
    $row['u_type'] = $xml->update[0]['type'];
    
    $major_ver = trim(substr($xml->update[0]['id'], 0, 2), '0');
    $minor_ver = substr($xml->update[0]['id'], 2);
    
    sql_query('INSERT INTO sb_updates (?#) VALUES (?a)', array_keys($row), array_values($row), sprintf(PL_UPDATE_H_OK, $major_ver.'.'.$minor_ver, sb_date('d.m.Y', $xml->update[0]['time'])));
    
    return true;
}
?>