<?php
/**
 * Функция возвращает необходимый номер версии PHP для получения обновлений
 * 
 * Если в cms/kernel/config.inc.php установлена в true переменная $GLOBALS['sbNB'], 
 * то будет проверяться наличие следующей версии CMS в папке new 
 * 
 * Предназначено только для тестирования обновления
 */
function fUpdate_Version()
{
    $versionString = '&version='.phpversion();
    
    if(isset($GLOBALS['sbNB']) && $GLOBALS['sbNB'])
    {
        $versionString .= '&nbuild=new';
    }

    return $versionString;
}

function fUpdate_Init()
{
    // передаем ключ на сервер и проверяем подписку
    $key = urlencode(base64_encode(file_get_contents(SB_CMS_KERNEL_PATH.'/key.php')));
    $dopString = fUpdate_Version(); 
    // сервер возвращает код
    require_once (SB_CMS_LIB_PATH.'/sbDownload.inc.php');
    $download = new sbDownload('http://update.sbuilder.ru/billing/index.php?key='.$key.$dopString);
    $code = $download->download();

    if (substr_count($code, '|') > 0)
    {
        $code = explode('|', $code);
    }
    else
    {
        $code = array($code, '');
    }

    if (is_numeric($code[0]))
    {
        switch ($code[0])
        {
            case '001':
                sb_show_message(PL_UPDATE_H_ERROR_CODE_001, true, 'warning');
                return;

            case '002':
                sb_show_message(sprintf(PL_UPDATE_H_ERROR_CODE_002, $code[1]), true, 'warning');
                return;

            case '003':
                $date = explode('.', $code[1]);
                $time = mktime(0, 0, 0, $date[1], $date[0], $date[2]);

                $time = $time - time();

                if ($time < 30 * 24 * 60 * 60)
                {
                    sb_show_message(sprintf(PL_UPDATE_H_ERROR_CODE_003, implode('.', $date)), false, 'information');
                }
                break;
        }
    }
    else
    {
        sb_show_message(PL_UPDATE_ERROR, false, 'warning');
    }

    echo '
        <script>
	    document.body.onselectstart = "";
	    document.body.setAttribute("unselectable", "off");

	    var was_updates = false;
        function sbHideBtn()
        {
            var el = sbGetE("sb_tabs_bottom");
            if (el)
            {
                el.style.display = "none";
            }
        }
        function sbTabCheck(tab)
    	{
    	    var el = sbGetE("sb_tabs_bottom");
    	    if (!el)
    	       return;

    	    if (tab == 0)
    	    {
                el.style.display = "";
    	    }
    	    else
    	    {
    	        el.style.display = "none";
    	    }

    	    return true;
    	}

    	var tab_id = 0;
		function sbGetTabContent(i, u)
		{
			tab_id = i;
			var el = sbGetE("sb_tab"+i);
			el.innerHTML = "'.str_replace('"', '\\"', sb_show_message(KERNEL_LOADING, true, 'loading', true)).'";
			sbLoadAsync("'.SB_CMS_EMPTY_FILE.'?event=pl_update_list&tab_id="+ i +"&page_updates="+ u, afterGetTabContent);
		}

		function afterGetTabContent(res)
		{
			var el = sbGetE("sb_tab"+tab_id);
			el.innerHTML = res;
		}

	</script>';

    if (isset($_GET['success']))
    {
        sb_show_message(PL_UPDATE_OK_UPDATING);
    }

    require_once(SB_CMS_LIB_PATH.'/sbTabs.inc.php');

    $tabs = new sbTabs(SB_CMS_CONTENT_FILE.'?event=pl_update_setup', '', 'post', '');

	$tabs->setBottom('<input type="submit" value="'.PL_UPDATE_SETUP_ONE_BTN.'" name="setup_one" id="setup_one" disabled="disabled">&nbsp;&nbsp;&nbsp;<input type="submit" value="'.PL_UPDATE_SETUP_ALL_BTN.'" name="setup_all" id="setup_all" disabled="disabled">');

	$tabs->setAutoLoading(SB_CMS_EMPTY_FILE.'?event=pl_update_list');

    $tabs->addTab(PL_UPDATE_TAB2, '');
    $tabs->addTab(PL_UPDATE_TAB1, '');

	// вывод закладок
	$tabs->show();
}

function fUpdate_List()
{
	$tabId = (isset($_GET['tab_id']) ? intval($_GET['tab_id']) : -1);

	require_once(SB_CMS_LIB_PATH.'/sbTabs.inc.php');
	$tabs = new sbTabs(SB_CMS_CONTENT_FILE.'?event=pl_update_setup', '', 'post', '');

	if ($tabId == 1)
    {
		require_once(SB_CMS_LIB_PATH.'/sbDBPager.inc.php');
		$pager = new sbDBPager('updates', 7, 25);
		$total = true;
		$res = $pager->init($total, 'SELECT u_update_id, u_release_date, u_setup_date, u_info, u_type FROM sb_updates ORDER BY u_update_id DESC');

		$from = $pager->mPage;
		$pager->mNumberTemp = '&nbsp;<a href="javascript:sbGetTabContent(\'1\', \'{NUMBER}\');">{NUMBER}</a>&nbsp;';

		$pager->mBeginTemp = '<img id="begin_btn" src="'.SB_CMS_IMG_URL.'/begin.gif" width="14" height="15" alt="'.SB_ELEMS_BEGIN.'" onclick="sbGetTabContent(\'1\', \'1\');" style="cursor: hand;cursor:pointer;" align="absmiddle">&nbsp;';
		$pager->mBeginTempDisabled = '<img id="begin_btn" src="'.SB_CMS_IMG_URL.'/begin_gray.gif" width="14" height="15" alt="'.SB_ELEMS_BEGIN.'" align="absmiddle">&nbsp;';

		$pager->mPrevTemp = '<img src="'.SB_CMS_IMG_URL.'/previous.gif" width="14" height="15" alt="'.SB_ELEMS_PREV.'" onclick="sbGetTabContent(\'1\', \''.($from - 1).'\');" style="cursor: hand;cursor:pointer;" align="absmiddle">&nbsp;';
		$pager->mPrevTempDisabled = '<img src="'.SB_CMS_IMG_URL.'/previous_gray.gif" width="14" height="15" alt="'.SB_ELEMS_PREV.'" align="absmiddle">&nbsp;';

		$pager->mNextTemp = '<img src="'.SB_CMS_IMG_URL.'/next.gif" width="14" height="15" alt="'.SB_ELEMS_NEXT.'" onclick="sbGetTabContent(\'1\', \''.($from + 1).'\');" style="cursor: hand;cursor:pointer;" align="absmiddle">&nbsp;';
		$pager->mNextTempDisabled = '<img src="'.SB_CMS_IMG_URL.'/next_gray.gif" width="14" height="15" alt="'.SB_ELEMS_NEXT.'" align="absmiddle">&nbsp;';

		$pager->mEndTemp = '<img id="begin_btn" src="'.SB_CMS_IMG_URL.'/end.gif" width="14" height="15" alt="'.SB_ELEMS_END.'" onclick="sbGetTabContent(\'1\', \'{ALL_PAGES}\');" style="cursor: hand;cursor:pointer;" align="absmiddle">&nbsp;';
		$pager->mEndTempDisabled = '<img id="begin_btn" src="'.SB_CMS_IMG_URL.'/end_gray.gif" width="14" height="15" alt="'.SB_ELEMS_END.'" align="absmiddle">&nbsp;';

		$num_list = $pager->show();

		// вывод установленных обновлений
        if ($res)
        {
			list($u_update_id, $u_release_date, $u_setup_date, $u_info, $u_type) = $res[0];
            if (trim($u_info) == '')
            {
                $u_info = PL_UPDATE_NO_DESC;
            }

			$last_update = sql_query('SELECT u_update_id, u_setup_date FROM sb_updates ORDER BY u_update_id DESC LIMIT 0,1');
			if($last_update)
			{
	            list($u_update_id, $u_setup_date) = $last_update[0];
			}

            $major_ver = trim(substr($u_update_id, 0, 2), '0');
            $minor_ver = substr($u_update_id, 2);

            echo '<table width="100%"><tr><td width="1"><img src="'.SB_CMS_IMG_URL.'/plugins/pl_update_32.png" width="32" height="32" align="absmiddle" /></td>
				<td><div class="hint_div" style="text-align: left;">'.PL_UPDATE_CURRENT_VERSION.': <b>'.$major_ver.'.'.$minor_ver.'</b><br>
				'.PL_UPDATE_LAST_SETUP_DATE.': <b>'.sb_date('d.m.Y '.KERNEL_IN.' H:i', $u_setup_date) .'</b></div></td></tr>
				<tr><td colspan="2" style="padding:10px 0px 5px 0px;text-align:center;">'.$num_list.'</td></tr>
				</table>';

            $values = array();
            $labels = array('', PL_UPDATE_INFO_VERSION, PL_UPDATE_INFO_DATE_RELEASE, PL_UPDATE_INFO_DATE_SETUP, PL_UPDATE_INFO_DESC);

            foreach ($res as $value)
            {
                list($u_update_id, $u_release_date, $u_setup_date, $u_info, $u_type) = $value;

                if (trim($u_info) == '')
                {
                    $u_info = PL_UPDATE_NO_DESC;
                }

                $major_ver = trim(substr($u_update_id, 0, 2), '0');
                $minor_ver = substr($u_update_id, 2);

                if ($u_type == 'high')
                {
                    $img = '<img src="'.SB_CMS_IMG_URL.'/prevention_log.png" \>';
                }
                else
                {
                    $img = '';
                }

                $values[] = array($img, '<b>'.$major_ver.'.'.$minor_ver.'</b>', '<nobr>'.sb_date('d.m.Y', $u_release_date).'</nobr>', '<nobr>'.sb_date('d.m.Y '.KERNEL_IN.' H:i', $u_setup_date).'</nobr>', '<div class="hint_div">'.$u_info.'</div>');
            }

            require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

            $layout = new sbLayout();
            $layout->mTableWidth = '100%';

            $fld = new sbLayoutTable($labels, $values);
			$fld->mHTML = '<tr><td colspan="5" style="text-align:center;padding:5px;">'.$num_list.'</td></tr>';
            $fld->mWidth = array('1', '50', '130', '130', '');
            $fld->mAlign = array('center', 'center', 'center', 'center', '');

            $layout->addField('', $fld);
            $layout->show();
        }
        else
        {
            echo '<table width="100%"><tr><td width="1"><img src="'.SB_CMS_IMG_URL.'/plugins/pl_update_32.png" width="32" height="32" align="absmiddle" /></td>
                 <td><div class="hint_div" style="text-align: left;">'.PL_UPDATE_CURRENT_VERSION.': <b>'.CMS_DISTR_VERSION.'</b><br>
                 '.PL_UPDATE_LAST_SETUP_DATE.': <b>'.PL_UPDATE_NO_LAST_SETUP_DATE.'</b></div></td></tr></table>
                 <br>';

			sb_show_message(PL_UPDATE_NO_SETUP_UPDATE, true);
        }
    }
    elseif ($tabId == 0)
    {
		$res = sql_query('SELECT u_update_id, u_release_date, u_setup_date, u_info, u_type FROM sb_updates ORDER BY u_update_id DESC');

        // вывод новых обновлений
        $disable_updates = true;
        // версия системы
        $u_update_id = '0'.preg_replace('/[^0-9]+/', '', CMS_DISTR_VERSION);

        // передаем ключ на сервер и проверяем подписку
		$key = urlencode(base64_encode(file_get_contents(SB_CMS_KERNEL_PATH.'/key.php')));
        if ($res)
        {
            list($u_installed_update_id, $u_release_date, $u_setup_date, $u_info, $u_type) = $res[0];

            if ($u_installed_update_id > $u_update_id)
            {
                $u_update_id = $u_installed_update_id;
            }
        }
        $dopString = fUpdate_Version();
		// сервер возвращает код ошибки или XML со списком обновлений
		require_once (SB_CMS_LIB_PATH.'/sbDownload.inc.php');
		$download = new sbDownload('http://update.sbuilder.ru/billing/index.php?key='.$key.'&cid='.$u_update_id.$dopString);
		$code = $download->download();

		if (substr_count($code, '|') > 0)
		{
			$code = explode('|', $code);
		}
		else
		{
			$code = array($code, '');
		}

        if (is_numeric($code[0]))
        {
            switch ($code[0])
            {
                case '001':
                    sb_show_message(PL_UPDATE_H_ERROR_CODE_001, true, 'warning');
                    return;

                case '004':
                    sb_show_message(PL_UPDATE_NO_UPDATE, true);
                    break;

                case '005':
                    sb_show_message(PL_UPDATE_H_ERROR_CODE_005, true);
                    break;

                default:
                    sb_show_message(PL_UPDATE_ERROR, true, 'warning');
                    break;
            }
        }
        elseif (!$code[0])
        {
            sb_show_message(PL_UPDATE_ERROR, true, 'warning');
            return;
        }
        else
        {
        	try
        	{
            	$xml = new SimpleXMLElement($code[0]);
        	}
        	catch (Exception $e)
        	{
				sb_show_message(PL_UPDATE_ERROR, true, 'warning');
				return;
        	}

			$values = array();
			$update_ver = '';

			$pagesCount = 25;	//	Кол-во сообщений на одной странице
		    $num = 0;

		   	if ($xml->update)
		   	{
				$num = count($xml->update); // Всего сообщений
		   	}

	    	// Всего страниц
	      	$totalPages = ceil($num / $pagesCount);

	       	// Номер текущей страницы
	    	if(isset($_GET['page_updates']))
	    	{
				$page = min(max(1, intval($_GET['page_updates'])), $totalPages);
				$_GET['page_updates'] = $page;
	    	}
			else
			{
				$page = 1;
	       	}

			require_once(SB_CMS_LIB_PATH.'/sbDBPager.inc.php');
			$pager = new sbDBPager('updates', 7, $pagesCount);

			$from = $pager->mPage;
			$pager->mNumberTemp = '&nbsp;<a href="javascript:sbGetTabContent(\'0\', \'{NUMBER}\');">{NUMBER}</a>&nbsp;';

			$pager->mBeginTemp = '<img id="begin_btn" src="'.SB_CMS_IMG_URL.'/begin.gif" width="14" height="15" alt="'.SB_ELEMS_BEGIN.'" onclick="sbGetTabContent(\'0\', \'1\');" style="cursor: hand;cursor:pointer;" align="absmiddle">&nbsp;';
			$pager->mBeginTempDisabled = '<img id="begin_btn" src="'.SB_CMS_IMG_URL.'/begin_gray.gif" width="14" height="15" alt="'.SB_ELEMS_BEGIN.'" align="absmiddle">&nbsp;';

			$pager->mPrevTemp = '<img src="'.SB_CMS_IMG_URL.'/previous.gif" width="14" height="15" alt="'.SB_ELEMS_PREV.'" onclick="sbGetTabContent(\'0\', \''.($from - 1).'\');" style="cursor: hand;cursor:pointer;" align="absmiddle">&nbsp;';
			$pager->mPrevTempDisabled = '<img src="'.SB_CMS_IMG_URL.'/previous_gray.gif" width="14" height="15" alt="'.SB_ELEMS_PREV.'" align="absmiddle">&nbsp;';

			$pager->mNextTemp = '<img src="'.SB_CMS_IMG_URL.'/next.gif" width="14" height="15" alt="'.SB_ELEMS_NEXT.'" onclick="sbGetTabContent(\'0\', \''.($from + 1).'\');" style="cursor: hand;cursor:pointer;" align="absmiddle">&nbsp;';
			$pager->mNextTempDisabled = '<img src="'.SB_CMS_IMG_URL.'/next_gray.gif" width="14" height="15" alt="'.SB_ELEMS_NEXT.'" align="absmiddle">&nbsp;';

			$pager->mEndTemp = '<img id="begin_btn" src="'.SB_CMS_IMG_URL.'/end.gif" width="14" height="15" alt="'.SB_ELEMS_END.'" onclick="sbGetTabContent(\'0\', \'{ALL_PAGES}\');" style="cursor: hand;cursor:pointer;" align="absmiddle">&nbsp;';
			$pager->mEndTempDisabled = '<img id="begin_btn" src="'.SB_CMS_IMG_URL.'/end_gray.gif" width="14" height="15" alt="'.SB_ELEMS_END.'" align="absmiddle">&nbsp;';

			$pager->mNumElemsAll = $num;
			$num_list = $pager->show();

			$from = ($page - 1) * $pagesCount; // номер точки восстановления с которой нужно начать выводить список
			$to = min($num, $from + $pagesCount);

			for($i = $from; $i < $to; $i++)
            {
				$update = $xml->update[$i];

				$u_update_id = (string) $update['id'];
				if ($update_ver == '')
					$update_ver = $u_update_id;

                $u_release_date = (string) $update['time'];
                $u_type = (string) $update['type'];
                $u_info = SB_CHARSET == 'UTF-8' ? $update : iconv('UTF-8', SB_CHARSET.'//IGNORE', $update);

                if ($u_info == '')
                    $u_info = PL_UPDATE_NO_DESC;

                $major_ver = trim(substr($u_update_id, 0, 2), '0');
                $minor_ver = substr($u_update_id, 2);

                if ($u_type == 'high')
                {
                    $img = '<img src="'.SB_CMS_IMG_URL.'/prevention_log.png" \>';
                }
                else
                {
                    $img = '';
                }

                $values[] = array($img, '<b>'.$major_ver.'.'.$minor_ver.'</b>', '<nobr>'.sb_date('d.m.Y', $u_release_date).'</nobr>', '<div class="hint_div">'.$u_info.'</div>');
            }

			if (count($values) == 0)
            {
				sb_show_message(PL_UPDATE_NO_UPDATE, true);
            }
            else
            {
				$disable_updates = false;
				$labels = array('', PL_UPDATE_INFO_VERSION, PL_UPDATE_INFO_DATE_RELEASE, PL_UPDATE_INFO_DESC);

				require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

				$layout = new sbLayout();
				$layout->mTableWidth = '100%';

				echo '<div style="margin-bottom:5px;">'.$num_list.'</div>';

				$fld = new sbLayoutTable($labels, $values);
				$fld->mHTML = '<tr><td colspan="4" style="text-align:center;padding:5px;">'.$num_list.'</td></tr>';

				$fld->mWidth = array('1', '50', '130', '');
				$fld->mAlign = array('center', 'center', 'center', '');

				$layout->addField('', $fld);
				$layout->show();

				echo '<input type="hidden" name="next_update_id" value="'.$update_ver.'" />';
            }
        }

        if (!$disable_updates)
        {
            echo '<script>
                sbGetE("setup_one").disabled = false;
                sbGetE("setup_all").disabled = false;
			</script>';
        }
    }

    // вывод закладок
    $tabs->show();
}

function fUpdate_Setup()
{
    $uid = preg_replace('/[^0-9]/', '', $_REQUEST['next_update_id']);

    if ($uid == '')
    {
        fUpdate_Init();
        return;
    }

    // передаем ключ на сервер и проверяем подписку
    $key = urlencode(base64_encode(file_get_contents(SB_CMS_KERNEL_PATH.'/key.php')));

    $zip = 0;
    if (extension_loaded('zip'))
    {
        $zip = 1;
    }
    $dopString = fUpdate_Version();
    // сервер возвращает код ошибки или XML запрошенного апдейта
    require_once (SB_CMS_LIB_PATH.'/sbDownload.inc.php');
    $download = new sbDownload('http://update.sbuilder.ru/billing/index.php?key='.$key.'&uid='.$uid.'&zip='.$zip.$dopString);
    $code = $download->download();

    if (substr_count($code, '|') > 0)
    {
        $code = explode('|', $code);
    }
    else
    {
        $code = array($code, '');
    }

    if (is_numeric($code[0]))
    {
        // произошла ошибка
        switch ($code[0])
        {
            case '001':
                fUpdate_Init();
                return;

            case '002':
                fUpdate_Init();
                return;

            case '005':
                sb_show_message(PL_UPDATE_H_ERROR_CODE_005, false, 'warning');
                fUpdate_Init();
                return;

            case '006':
                sb_show_message(PL_UPDATE_H_ERROR_CODE_006, false, 'warning');
                fUpdate_Init();
                return;

            case '007':
                sb_show_message(PL_UPDATE_H_ERROR_CODE_007, false, 'warning');
                fUpdate_Init();
                return;

            default:
                sb_show_message(PL_UPDATE_ERROR, false, 'warning');
                fUpdate_Init();
                return;
        }
    }

    if (isset($_REQUEST['setup_all']))
    {
        $_SESSION['sb_update_all'] = true;
    }
    elseif(isset($_SESSION['sb_update_all']))
    {
        unset($_SESSION['sb_update_all']);
    }

    // установка одного обновления
    if (!fUpdate_Setup_One($code[0]))
    {
        fUpdate_Init();
    }
}

function fUpdate_Setup_One($str)
{
    $xml = new SimpleXMLElement($str);

    $u_update_id = (string) $xml->update[0]['id'];
    $u_release_date = (string) $xml->update[0]['time'];
    $u_type = (string) $xml->update[0]['type'];
    $u_info = SB_CHARSET == 'UTF-8' ? $xml->update[0] : iconv('UTF-8', SB_CHARSET.'//IGNORE', $xml->update[0]);

    if ($u_info == '')
        $u_info = PL_UPDATE_NO_DESC;

    $GLOBALS['sbVfs']->mLocal = true;

    // проверяем права на папки и файлы
    if (!$GLOBALS['sbVfs']->exists(SB_CMS_TMP_PATH))
    {
        if (!$GLOBALS['sbVfs']->mkdir(SB_CMS_TMP_PATH))
        {
            sb_show_message(sprintf(PL_UPDATE_H_ERROR_MKDIR, substr(SB_CMS_TMP_PATH, strlen(SB_BASEDIR))), false, 'warning');
            $GLOBALS['sbVfs']->mLocal = false;
            return false;
        }
    }

    if (!$GLOBALS['sbVfs']->is_writable(SB_CMS_TMP_PATH))
    {
        sb_show_message(sprintf(PL_UPDATE_H_ERROR_DIR_RIGHTS, substr(SB_CMS_TMP_PATH, strlen(SB_BASEDIR))), false, 'warning');
        $GLOBALS['sbVfs']->mLocal = false;
        return false;
    }

    $GLOBALS['sbVfs']->mLocal = false;

    $major_ver = trim(substr($u_update_id, 0, 2), '0');
    $minor_ver = substr($u_update_id, 2);

    if (!isset($_SESSION['sb_update_xml']) || $_SESSION['sb_update_xml'] == '')
        $_SESSION['sb_update_xml'] = $str;

    echo '<script>
    function startUpdate()
    {
        sbShowDisDiv();
        sbShowMsgDiv(\''.sprintf(PL_UPDATE_UPDATING, $major_ver.'.'.$minor_ver, sb_date('d.m.Y', $u_release_date)).'\', "loading.gif", false);
        sbMsgDiv.onclick = null;
        sbLoadAsync("'.SB_CMS_EMPTY_FILE.'?event=pl_update_copy", afterStart);
    }
    function afterStart(res)
    {
        if (res == "FALSE" || res == "")
        {
            sbHideDisDiv();
            sbMsgDiv.style.zIndex = 0;
            sbShowMsgDiv(\''.PL_UPDATE_ERROR_UPDATING.'\', "warning.png", false);
        }
        else if (res == "TRUE")
        {
            sbShowMsgDiv(\''.sprintf(PL_UPDATE_UPDATING_END, $major_ver.'.'.$minor_ver, sb_date('d.m.Y', $u_release_date)).'\', "loading.gif", false);
            sbHideDisDiv();
            sbMsgDiv.style.zIndex = 0;
            window.location = "'.SB_CMS_CONTENT_FILE.'?event=pl_update_init&success=1";
        }

        res = res.split("|");

        if (res[0] == "dump")
        {
            sbShowMsgDiv(\''.sprintf(PL_UPDATE_UPDATING_DUMP, $major_ver.'.'.$minor_ver, sb_date('d.m.Y', $u_release_date)).'\', "loading.gif", false);
            sbLoadAsync("'.SB_CMS_EMPTY_FILE.'?event=pl_update_copy&action=dump&tmp_id="+res[1], afterStart);
        }
        else if (res[0] == "copy")
        {
            sbShowMsgDiv(\''.sprintf(PL_UPDATE_UPDATING_COPY, $major_ver.'.'.$minor_ver, sb_date('d.m.Y', $u_release_date)).'\', "loading.gif", false);
            sbLoadAsync("'.SB_CMS_EMPTY_FILE.'?event=pl_update_copy&action=copy&tmp_id="+res[1], afterStart);
        }
        else if (res[0] == "next")
        {
            sbShowMsgDiv(\''.sprintf(PL_UPDATE_UPDATING_END, $major_ver.'.'.$minor_ver, sb_date('d.m.Y', $u_release_date)).'\', "loading.gif", false);
            sbHideDisDiv();
            sbMsgDiv.style.zIndex = 0;
            window.location = "'.SB_CMS_CONTENT_FILE.'?event=pl_update_setup&next_update_id="+res[1]+"&setup_all=1";
        }
    }
    sbAddEvent(window, "load", startUpdate);
    </script>';

    return true;
}

function fUpdate_Copy()
{
    if (!isset($_SESSION['sb_update_xml']) || $_SESSION['sb_update_xml'] == '')
    {
        echo 'FALSE';
        sb_add_system_message(PL_UPDATE_ERROR_UPDATE_XML, SB_MSG_ERROR);
        return;
    }

    $GLOBALS['sbVfs']->mLocal = true;
    $xml = new SimpleXMLElement($_SESSION['sb_update_xml']);

    if (!isset($_GET['action']) || $_GET['action'] == '')
    {
        // копируем файлы в темповую директорию
        $zip = extension_loaded('zip');

        $tmp_id = uniqid();
        $tmp_dir = SB_CMS_TMP_PATH.'/'.$tmp_id;

        if (!$GLOBALS['sbVfs']->exists($tmp_dir))
        {
            if (!$GLOBALS['sbVfs']->mkdir($tmp_dir))
            {
                echo 'FALSE';
                unset($_SESSION['sb_update_xml']);
                sb_add_system_message(sprintf(PL_UPDATE_H_ERROR_MKDIR, substr($tmp_dir, strlen(SB_BASEDIR))), SB_MSG_ERROR);
                $GLOBALS['sbVfs']->mLocal = false;
                return;
            }
        }

        if (!$GLOBALS['sbVfs']->is_writable($tmp_dir))
        {
            echo 'FALSE';
            unset($_SESSION['sb_update_xml']);
            sb_add_system_message(sprintf(PL_UPDATE_H_ERROR_DIR_RIGHTS, substr($tmp_dir, strlen(SB_BASEDIR))), SB_MSG_ERROR);
            $GLOBALS['sbVfs']->mLocal = false;
            return;
        }

        require_once (SB_CMS_LIB_PATH.'/sbDownload.inc.php');

        if ($zip && isset($xml->update[0]->zip))
        {
            // скачиваем ZIP-архив
            $download = new sbDownload(trim((string) $xml->update[0]->zip[0]));
            $file = $download->download();

            if (!$file || sb_crc($file) != $xml->update[0]->zip[0]['checksum'])
            {
                echo 'FALSE';
                unset($_SESSION['sb_update_xml']);
                sb_add_system_message(sprintf(PL_UPDATE_H_ERROR_FILE_GET, '/update.zip'), SB_MSG_ERROR);

                $GLOBALS['sbVfs']->delete($tmp_dir);
                $GLOBALS['sbVfs']->mLocal = false;

                return;
            }

            if ($GLOBALS['sbVfs']->file_put_contents($tmp_dir.'/update.zip', $file) === false)
            {
                echo 'FALSE';
                unset($_SESSION['sb_update_xml']);
                sb_add_system_message(sprintf(PL_UPDATE_H_ERROR_FILE_PUT, substr($tmp_dir.'/update.zip', strlen(SB_BASEDIR))), SB_MSG_ERROR);

                $GLOBALS['sbVfs']->delete($tmp_dir);
                $GLOBALS['sbVfs']->mLocal = false;

                return;
            }

            $files = sb_unzip($tmp_dir.'/update.zip', $tmp_dir);

            if (!$files)
            {
                echo 'FALSE';
                unset($_SESSION['sb_update_xml']);
                sb_add_system_message(sprintf(PL_UPDATE_ERROR_UNZIP, substr($tmp_dir.'/update.zip', strlen(SB_BASEDIR))), SB_MSG_ERROR);

                $GLOBALS['sbVfs']->delete($tmp_dir);
                $GLOBALS['sbVfs']->mLocal = false;

                return;
            }

            $GLOBALS['sbVfs']->delete($tmp_dir.'/update.zip');
        }
        elseif(isset($xml->update[0]->dir))
        {
            // загружаем файлы по одному
            function sbReadDir($dir, $tmp_dir)
            {
                $download = new sbDownload('');

                foreach($dir as $dir_node)
                {
                    if (trim($dir_node['path']) != '')
                    {
                        $path = $tmp_dir.trim($dir_node['path']);

                        // создаем путь к директории
                        if (!$GLOBALS['sbVfs']->exists($path))
                        {
                            if (!$GLOBALS['sbVfs']->mkdir($path))
                            {
                                sb_add_system_message(sprintf(PL_UPDATE_H_ERROR_MKDIR, substr($path, strlen(SB_BASEDIR))), SB_MSG_ERROR);
                                return false;
                            }
                        }

                        if (!$GLOBALS['sbVfs']->is_writable($path))
                        {
                            sb_add_system_message(sprintf(PL_UPDATE_H_ERROR_DIR_RIGHTS, substr($path, strlen(SB_BASEDIR))), SB_MSG_ERROR);
                            return false;
                        }
                    }
                    else
                    {
                        $path = $tmp_dir;
                    }

                    foreach ($dir_node->file as $file_node)
                    {
                    	$file_path = $path.'/'.$file_node['name'];

                        // скачиваем файл
                        $download->setURL(trim((string) $file_node));
                        $file = $download->download();

                        if (!$file || sb_crc($file) != $file_node['checksum'])
                        {
                            sb_add_system_message(sprintf(PL_UPDATE_H_ERROR_FILE_GET, $dir_node['path'].'/'.$file_node['name']), SB_MSG_ERROR);
                            return false;
                        }

                        if ($GLOBALS['sbVfs']->file_put_contents($file_path, $file) === false)
                        {
                            sb_add_system_message(sprintf(PL_UPDATE_H_ERROR_FILE_PUT, substr($file_path, strlen(SB_BASEDIR))), SB_MSG_ERROR);
                            return false;
                        }
                    }

                    if (isset($dir_node->dir))
                    {
                        if (!sbReadDir($dir_node->dir, $tmp_dir))
                            return false;
                    }
                }

                return true;
            }

            if (!sbReadDir($xml->update[0]->dir, $tmp_dir))
            {
                echo 'FALSE';
                unset($_SESSION['sb_update_xml']);

                $GLOBALS['sbVfs']->delete($tmp_dir);
                $GLOBALS['sbVfs']->mLocal = false;

                return;
            }
        }
        else
        {
            echo 'FALSE';
            unset($_SESSION['sb_update_xml']);
            sb_add_system_message(PL_UPDATE_H_ERROR_CODE_005, SB_MSG_WARNING);

            $GLOBALS['sbVfs']->delete($tmp_dir);
            $GLOBALS['sbVfs']->mLocal = false;

            return;
        }

        echo 'dump|'.$tmp_id;
        $GLOBALS['sbVfs']->mLocal = false;
        return;
    }
    elseif($_GET['action'] == 'dump')
    {
        $sql = false;
        $tmp_id = preg_replace('/[^0-9a-zA-Z]+/', '', $_GET['tmp_id']);
        $tmp_dir = SB_CMS_TMP_PATH.'/'.$tmp_id;

        // разворачиваем дамп и проверяем права на файлы
        function sbCheckDir($dir, &$sql)
        {
            foreach($dir as $dir_node)
            {
                if (trim($dir_node['path']) != '')
                {
                    $path = SB_BASEDIR.trim($dir_node['path']);

                    // создаем путь к директории
                    if (!$GLOBALS['sbVfs']->exists($path))
                    {
                        if (!$GLOBALS['sbVfs']->mkdir($path))
                        {
                            sb_add_system_message(sprintf(PL_UPDATE_H_ERROR_MKDIR, substr($path, strlen(SB_BASEDIR))), SB_MSG_ERROR);
                            return false;
                        }
                    }

                    if (!$GLOBALS['sbVfs']->is_writable($path))
                    {
                        sb_add_system_message(sprintf(PL_UPDATE_ERROR_FILE_RIGHTS, substr($path, strlen(SB_BASEDIR))), SB_MSG_ERROR);
                        return false;
                    }
                }
                else
                {
                    $path = SB_BASEDIR;
                }

                foreach ($dir_node->file as $file_node)
                {
                    if ($file_node['name'] == 'dump.sql' && $dir_node['path'] == '')
                    {
                        $sql = true;
                        continue;
                    }

                    $file_path = $path.'/'.trim($file_node['name']);

                    // проверяем права файла
                    if ($GLOBALS['sbVfs']->exists($file_path) && !$GLOBALS['sbVfs']->is_writable($file_path))
                    {
                        sb_add_system_message(sprintf(PL_UPDATE_ERROR_FILE_RIGHTS, substr($file_path, strlen(SB_BASEDIR))), SB_MSG_ERROR);
                        return false;
                    }
                }

                if (isset($dir_node->dir))
                {
                    if (!sbCheckDir($dir_node->dir, $sql))
                        return false;
                }
            }

            return true;
        }

        if (!$GLOBALS['sbVfs']->is_writable(SB_BASEDIR))
        {
            echo 'FALSE';
            unset($_SESSION['sb_update_xml']);
            sb_add_system_message(sprintf(PL_UPDATE_H_ERROR_DIR_RIGHTS, '/'), SB_MSG_ERROR);

            $GLOBALS['sbVfs']->delete($tmp_dir);
            $GLOBALS['sbVfs']->mLocal = false;

            return;
        }

        if (!isset($xml->update[0]->dir) || !sbCheckDir($xml->update[0]->dir, $sql))
        {
            echo 'FALSE';
            unset($_SESSION['sb_update_xml']);

            $GLOBALS['sbVfs']->delete($tmp_dir);
            $GLOBALS['sbVfs']->mLocal = false;

            return;
        }

        // права прошли проверку, файлы скопировать мы сможем, теперь выполняем SQL-инструкции
        if ($sql)
        {
            if (!$GLOBALS['sbVfs']->exists($tmp_dir.'/dump.sql'))
            {
                echo 'FALSE';
                unset($_SESSION['sb_update_xml']);
                sb_add_system_message(sprintf(PL_UPDATE_H_ERROR_UPDATE_SQL_EXISTS, substr($tmp_dir.'/dump.sql', strlen(SB_BASEDIR))), SB_MSG_ERROR);

                $GLOBALS['sbVfs']->delete($tmp_dir);
                $GLOBALS['sbVfs']->mLocal = false;

                return;
            }

            $GLOBALS['sbVfs']->mLocal = false;
            require_once(SB_CMS_LIB_PATH.'/sbDumper.inc.php');
            $dumper = new sbDumper();

            if (!$dumper->loadDumpFile(substr($tmp_dir.'/dump.sql', strlen(SB_BASEDIR))))
            {
                echo 'FALSE';
                unset($_SESSION['sb_update_xml']);
                sb_add_system_message(sprintf(PL_UPDATE_H_ERROR_UPDATE_SQL, substr($tmp_dir.'/dump.sql', strlen(SB_BASEDIR))), SB_MSG_ERROR);
                return;
            }

            $GLOBALS['sbVfs']->mLocal = true;
        }

        echo 'copy|'.$tmp_id;
        $GLOBALS['sbVfs']->mLocal = false;
        return;
    }
    elseif($_GET['action'] == 'copy')
    {
        // копируем файлы
        $tmp_id = preg_replace('/[^0-9a-zA-Z]+/', '', $_GET['tmp_id']);
        $tmp_dir = SB_CMS_TMP_PATH.'/'.$tmp_id;

        $sql = false;
        $exec = false;

        function sbCopyDir($dir, $tmp_id, &$sql, &$exec)
        {
            foreach($dir as $dir_node)
            {
                if (trim($dir_node['path']) != '')
                {
                    $to_path = SB_BASEDIR.trim($dir_node['path']);
                    $from_path = SB_CMS_TMP_PATH.'/'.$tmp_id.trim($dir_node['path']);
                }
                else
                {
                    $to_path = SB_BASEDIR;
                    $from_path = SB_CMS_TMP_PATH.'/'.$tmp_id;
                }

                foreach ($dir_node->file as $file_node)
                {
                    if ($file_node['name'] == 'dump.sql' && $dir_node['path'] == '')
                    {
                        $sql = true;
                        continue;
                    }

                    if ($file_node['name'] == 'exec.php' && $dir_node['path'] == '')
                    {
                        $exec = true;
                        continue;
                    }

                    $from_file_path = $from_path.'/'.trim($file_node['name']);

                    if (trim((string) $file_node['name']) == 'htaccess')
                    {
                       	$to_file_path = $to_path.'/.htaccess';
                    }
                    else
                    {
                   		$to_file_path = $to_path.'/'.trim($file_node['name']);
                    }

                    // проверяем права файла
                    if (!$GLOBALS['sbVfs']->copy($from_file_path, $to_file_path, true))
                    {
                        sb_add_system_message(sprintf(PL_UPDATE_ERROR_FILE_COPY, substr($from_file_path, strlen(SB_BASEDIR)), substr($to_path, strlen(SB_BASEDIR))), SB_MSG_ERROR);
                        return false;
                    }
                }

                if (isset($dir_node->dir))
                {
                    if (!sbCopyDir($dir_node->dir, $tmp_id, $sql, $exec))
                        return false;
                }
            }

            return true;
        }

        if (!isset($xml->update[0]->dir) || !sbCopyDir($xml->update[0]->dir, $tmp_id, $sql, $exec))
        {
            echo 'FALSE';
            unset($_SESSION['sb_update_xml']);

            $GLOBALS['sbVfs']->delete($tmp_dir);
            $GLOBALS['sbVfs']->mLocal = false;

            return;
        }
    }

    unset($_SESSION['sb_update_xml']);

    if ($exec)
    {
        @include_once(SB_CMS_TMP_PATH.'/'.$tmp_id.'/exec.php');
    }

    // удаляем временную папку
    $GLOBALS['sbVfs']->delete($tmp_dir);
    $GLOBALS['sbVfs']->mLocal = false;

    // записываем результат в базу
    $row = array();
    $row['u_update_id'] = $xml->update[0]['id'];
    $row['u_release_date'] = $xml->update[0]['time'];
    $row['u_setup_date'] = time();
    $row['u_info'] = SB_CHARSET == 'UTF-8' ? (string) $xml->update[0] : iconv('UTF-8', SB_CHARSET.'//IGNORE', (string) $xml->update[0]);
    $row['u_sql'] = $sql ? '1' : '0';
    $row['u_type'] = $xml->update[0]['type'];

    $major_ver = trim(substr($xml->update[0]['id'], 0, 2), '0');
    $minor_ver = substr($xml->update[0]['id'], 2);

    sql_query('INSERT INTO sb_updates (?#) VALUES (?a)', array_keys($row), array_values($row), sprintf(PL_UPDATE_H_OK, $major_ver.'.'.$minor_ver, sb_date('d.m.Y', $xml->update[0]['time'])));

    // устанавливаем следующее обновление
    if (isset($xml->next) && (string) $xml->next[0] != '' && isset($_SESSION['sb_update_all']) && $_SESSION['sb_update_all'])
    {
        echo 'next|'.((string) $xml->next[0]);
    }
    elseif(isset($_SESSION['sb_update_all']))
    {
        unset($_SESSION['sb_update_all']);
    }

    echo 'TRUE';
}
?>