<?php
function fUser_Settings_Read()
{
    $tabId = (isset($_GET['tab_id']) ? intval($_GET['tab_id']) : -1);
    $tabStrs = array();
    $tabNum = 0;

    $settings = array();
    $all_settings_props = $_SESSION['sbPlugins']->getAllUserSettingsProps();
    $all_settings = sbPlugins::getAllUserSettings();

    foreach ($all_settings_props as $key => $value)
    {
        if (!isset($value['tab_name']) || $value['tab_name'] == '')
            continue;

        // раскладываем настройки по закладкам
        if (!isset($settings[$value['tab_name']]))
            $settings[$value['tab_name']] = array();

        if (isset($all_settings[$key]) && isset($all_settings[$key]['value']))
        	$value['value'] = $all_settings[$key]['value'];
        else
        	$value['value'] = null;

        $settings[$value['tab_name']][$key] = $value;
    }

    foreach ($settings as $key => $value)
    {
        // выводим закладки
        if ($tabNum != $tabId)
        {
            // если запрос на подгрузку закладки не пришел, выводим пустую строку
            $tabStrs[$key] = '';
        }
        else
        {
            // иначе выводим закладку
            $tabStrs[$key] = '<table width="100%" cellspacing="0" cellpadding="5" class="form">';
            foreach ($value as $subKey => $subValue)
            {
	            if ($subValue['type'] == '')
	            {
	            	if (trim($subValue['desc']) != '')
                	{
                		$tabStrs[$key] .= '<tr>
    			        	<td colspan="2"><div class="hint_div" style="text-align:center;">'.$subValue['desc'].'</div></td>
    		        	</tr>';
                	}

	                $tabStrs[$key] .= '<tr>
	                    <td colspan="2" style="padding: 0px; height: 1px; font-size: 1px; background: url('.SB_CMS_IMG_URL.'/hdelim.gif) repeat-x;"></td>
	                </tr>';
	                continue;
	            }

                $tabStrs[$key] .= '<tr>
        			 <th width="50%" style="vertical-align:top;">'.$subValue['desc'].':</th>
        			 <td>';

                switch ($subValue['type'])
                {
                    case 'string':
                        // строка
                        $tabStrs[$key] .= '<input type="text" size="40" value="'.sb_htmlspecialchars($subValue['value']).'" name="'.$subKey.'" />';
                        break;

                    case 'number':
                        // число
                        $tabStrs[$key] .= '<input type="text" value="'.sb_htmlspecialchars($subValue['value']).'" style="width:60px;" name="'.$subKey.'" id="spin_'.$subKey.'" />';
                        break;

                    case 'checkbox':
                        // чекбокс (булево)
                        // Так как непомеченные чекбоксы не передаются, то сохраняем значение в хиден-поле
                        $tabStrs[$key] .= '<input type="checkbox" value="1"'.($subValue['value'] == 1 ? ' checked' : '').' onclick="sbGetE(\''.$subKey.'\').value=(this.checked ? 1 : 0);" />
                                           <input type="hidden" id="'.$subKey.'" value="'.$subValue['value'].'" name="'.$subKey.'" />';
                        break;

                    case 'checkboxes':
                        // набор чекбоксов, считываем все значения и описания набора
                        if (count($subValue['type_values']) != 0)
                        {
                        	$i = 0;
                            foreach ($subValue['type_values'] as $ch_val => $ch_desc)
                            {
                                // так как непомеченные чекбоксы не передаются, то устанавливаем в хиден-поле флаг, что таковые имеются
                                $tabStrs[$key] .= '<input type="checkbox" value="'.$ch_val.'" id="'.$subKey.$i.'" name="'.$subKey.'[]"'.(in_array($ch_val, $subValue['value']) ? ' checked' : '').' /> - <label for="'.$subKey.$i.'">'.$ch_desc.'</label><br />
                                                   <input type="hidden" name="empty_'.$subKey.'" value="1" />';
                                $i++;
                            }
                        }
                        break;

                    case 'select':
                        // выпадающий список
                        if (count($subValue['type_values']) != 0)
                        {
                            $tabStrs[$key] .= '<select name="'.$subKey.'">';

                            foreach ($subValue['type_values'] as $opt_val => $opt_desc)
                            {
                                $tabStrs[$key] .= '<option value="'.$opt_val.'"'.($opt_val == $subValue['value'] ? ' selected' : '').'>'.$opt_desc.'</option>';
                            }
                            $tabStrs[$key] .= '</select>';
                        }
                        break;

                    case 'multiselect':
                        // список с множественным выбором
                        if (count($subValue['type_values']) != 0)
                        {
                            $tabStrs[$key] .= '<select name="'.$subKey.'[]" multiple="multiple">';

                            foreach ($subValue['type_values'] as $opt_val => $opt_desc)
                            {
                                $tabStrs[$key] .= '<option value="'.$opt_val.'"'.(in_array($opt_val, $subValue['value']) ? ' selected' : '').'>'.$opt_desc.'</option>';
                            }
                            $tabStrs[$key] .= '</select>';
                        }
                        break;

                    case 'radio':
                        // набор радио-кнопок
                        if (count($subValue['type_values']) != 0)
                        {
                        	$i = 0;
                            foreach ($subValue['type_values'] as $opt_val => $opt_desc)
                            {
                                $tabStrs[$key] .= '<input type="radio" id="'.$subKey.$i.'" name="'.$subKey.'" value="'.$opt_val.'"'.($opt_val == $subValue['value'] ? ' checked' : '').' /> - <label for="'.$subKey.$i.'">'.$opt_desc.'</label><br />';
                                $i++;
                            }
                        }
                        break;

                    case 'text_categs':
		                $res = false;
				        if ($subValue['value'] != '')
				        {
				            $res = sql_query('SELECT cat_title FROM sb_categs WHERE cat_id=?d', $subValue['value']);
				        }

				        if (!$res)
				        {
				            $num = 0;
				        }
				        else
				        {
				            $num = count($res);
				        }

                    	$tabStrs[$key] .= '<table><tr style="background-color: transparent;"><td>';
				        if (!$res)
				        {
				            $tabStrs[$key] .= '<span id="'.$subKey.'_text"><b style=\'font-size:11px;\'>'.SB_LAYOUT_NO_CATEG.'</b>';
				        }
				        else
				        {
				            $tabStrs[$key] .= '<span id="'.$subKey.'_text">'.$res[0][0];
				        }

        				$tabStrs[$key] .= '</span></td>
        					<td><nobr>&nbsp;<img class="button" src="'.SB_CMS_IMG_URL.'/categs.png" width="20" height="20" align="absmiddle" id="'.$subKey.'_button" onmouseup="sbPress(this, false);" onmousedown="sbPress(this, true);" onclick="sbGetCateg(\''.$subKey.'\')" />
		                    <img class="button" src="'.SB_CMS_IMG_URL.'/categs_drop.png" width="20" height="20" align="absmiddle" id="'.$subKey.'_drop_button" onmouseup="sbPress(this, false);" onmousedown="sbPress(this, true);" onclick="sbDropCateg(\''.$subKey.'\')" />
		                    <input type="hidden" name="'.$subKey.'" id="'.$subKey.'" value="'.$subValue['value'].'">
							</nobr></td></tr></table>';
						break;

                    case 'password':
                        //	пароль
						$tabStrs[$key] .= '<input type="password" size="40" value="'.sb_htmlspecialchars($subValue['value']).'" name="'.$subKey.'" />';
						break;
                }
                $tabStrs[$key] .= '</td></tr>';
            }

            $tabStrs[$key] .= '</table>';
        }

        $tabNum++;
    }

    if ($tabId == -1)
    {
        echo '<script src="'.SB_CMS_JSCRIPT_URL.'/sbSpinButton.js.php"></script>
        	<script>
        	var sbCategElId = null;
            function sbGetCateg(el_id)
            {
                var el = sbGetE(el_id);
                if (el.disabled)
                    return;

                if (el)
                {
                    sbCategElId = el_id;

                    var strPage = sb_cms_modal_dialog_file + "?event=pl_categs_get_categs&id="+el.value+"&ident=pl_texts";
                    var strAttr = "resizable=1,width=700,height=500";

                    sbShowModalDialog(strPage, strAttr, sbAfterGetCateg);
                }
            }
            function sbAfterGetCateg()
            {
                if (sbModalDialog.returnValue && sbCategElId)
                {
                    var el = sbGetE(sbCategElId);
                    var el_name = sbGetE(sbCategElId + "_text");

                    el.value = sbModalDialog.returnValue.id;
                    el_name.innerHTML = sbModalDialog.returnValue.text != "" ? sbModalDialog.returnValue.text : "<b>'.SB_LAYOUT_NO_CATEG.'</b>";
                }
            }
            function sbDropCateg(el_id)
            {
                var el = sbGetE(el_id);
                var el_name = sbGetE(el_id + "_text");

                el.value = "";
                el_name.innerHTML = "<b>'.SB_LAYOUT_NO_CATEG.'</b>";
            }
		</script>';
    }
    require_once(SB_CMS_LIB_PATH.'/sbTabs.inc.php');

    $tabs = new sbTabs(SB_CMS_CONTENT_FILE.'?event=pl_user_settings_submit', '', 'post', '');
    $tabs->setBottom('<input type="submit" value="'.KERNEL_SAVE.'">');
    $tabs->setAutoLoading(SB_CMS_EMPTY_FILE.'?event=pl_user_settings_read');
    $tabs->mTabsOnLoad = 'sbSetSpin';

    $i = 0;
    foreach ($tabStrs as $key => $value)
    {
        if ($i % 5 == 0 && $i != 0) $key = '$'.$key;
	    $tabs->addTab($key, $value);
	    $i++;
    }
    // вывод закладок
    $tabs->show();
}

function fUser_Settings_Submit()
{
    foreach ($_POST as $key => $value)
    {
        if ($key == 'tabidx')
            continue;

        if (substr($key, 0, 6) == 'empty_')
        {
            // проверяем, есть ли помеченные чекбоксы в наборе чекбоксов
            $key = substr($key, 6);
            if (isset($_POST[$key]))
            {
                // если есть, они будут добавлены
                continue;
            }
            else
            {
                // если нет, то значение набора - пустой массив
                $value = array();
            }
        }

        if (substr($key, 0, 5) == 'spin_')
        {
            // это число, получаем реальный идентификатор настройки
            $key = substr($key, 5);
        }

        // сохраняем настройку
        $_SESSION['sbPlugins']->setUserSetting($key, $value);
    }

    // записываем сообщение об изменении настроек в системный журнал
    sb_add_system_message(PL_USER_SETTINGS_LOG_MESSAGE);
    // выводим сообщение об успешном сохранении настроек
    sb_show_message(PL_USER_SETTINGS_SUCCESSFULLY_SAVED);

    echo '<script>
    window.parent.navmenu.sbShowToolbar();
    window.parent.navmenu.sbShowQuickToolbar();
    </script>';

    fUser_Settings_Read();
}
?>