<?php
require_once(SB_CMS_LANG_PATH.'/pl_users.h.lng.php');

if ($_SESSION['sbPlugins']->register('pl_users', PL_USERS_H_PLUGIN_NAME, 'http://www.sbuilder.ru/docs/helps40/cms_users.doc'))
{
	$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_ADMIN.'>'.PL_USERS_H_PLUGIN_NAME, 'init');
	$_SESSION['sbPlugins']->setMainEvent('init');

	$_SESSION['sbPlugins']->addUserEvent('init', 'fUsers_Init', 'read', PL_USERS_H_PLUGIN_NAME);
	$_SESSION['sbPlugins']->addUserEvent('edit', 'fUsers_Edit', 'read', PL_USERS_H_EDIT_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('edit_submit', 'fUsers_Edit_Submit', 'elems_edit', PL_USERS_H_EDIT_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('check_login', 'fUsers_Check_Login', 'elems_edit');
	$_SESSION['sbPlugins']->addUserEvent('delete', 'fUsers_Delete', 'elems_delete');
	$_SESSION['sbPlugins']->addUserEvent('paste', 'fUsers_Paste', 'elems_edit');
	$_SESSION['sbPlugins']->addUserEvent('before_paste', 'fUsers_Before_Paste', 'elems_edit');

	$_SESSION['sbPlugins']->addUserEvent('edit_cat', 'fUsers_Edit_Cat', 'read', PL_USERS_H_CAT_EDIT_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('edit_cat_submit', 'fUsers_Edit_Cat_Submit', 'categs_edit', PL_USERS_H_CAT_EDIT_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('delete_cat', 'fUsers_Delete_Cat', 'categs_delete');
	$_SESSION['sbPlugins']->addUserEvent('copy_cat', 'fUsers_Copy_Cat', 'categs_edit');
	
	$_SESSION['sbPlugins']->addUserEvent('generate_soap_token', 'fUsers_Generate_Soap_Token');

	$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_pass_date_limit_delim', PL_USERS_H_PLUGIN_NAME, '', '', '', 'all');
	$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_pass_date_limit', PL_USERS_H_PASS_LIMIT_DATE, 'number', '', '0', 'all');
	$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_pass_length_limit', PL_USERS_H_PASS_LIMIT_PASS, 'number', '', '6', 'all');
	$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_admin_first_change_pass', PL_USERS_H_PASS_FIRST_NEED_CHANGE, 'checkbox', '', '0', 'all');

	$fields = array();
	$fields['u_id'] = array('title' => PL_USERS_H_ID_LABEL, 'flags' => '8');
	$fields['u_auto_login'] = array('title' => PL_USERS_H_AUTO_LOGIN_LABEL, 'flags' => '4');
	$fields['u_block'] = array('title' => PL_USERS_H_BLOCK_LABEL, 'flags' => '10');
	$fields['u_notify'] = array('title' => PL_USERS_H_NOTIFY_LABEL, 'flags' => '10');
	$fields['u_login'] = array('title' => PL_USERS_H_LOGIN_LABEL, 'flags' => '4');
	$fields['u_pass'] = array('title' => PL_USERS_H_PASS_LABEL, 'flags' => '16');
	$fields['u_pass_date'] = array('title' => PL_USERS_H_PASS_DATE_LABEL, 'flags' => '9');
	$fields['u_name'] = array('title' => PL_USERS_H_NAME_LABEL, 'flags' => '4');
	$fields['u_admin'] = array('title' => PL_USERS_H_ADMIN_LABEL, 'flags' => '10');
	$fields['u_reg_date'] = array('title' => PL_USERS_H_REG_DATE_LABEL, 'flags' => '9');
	$fields['u_last_ip'] = array('title' => PL_USERS_H_LAST_IP_LABEL, 'flags' => '4');
	$fields['u_last_date'] = array('title' => PL_USERS_H_LAST_DATE_LABEL, 'flags' => '9');
	$fields['u_email'] = array('title' => PL_USERS_H_EMAIL_LABEL, 'flags' => '4');
	$fields['u_active_date'] = array('title' => PL_USERS_H_ACTIVE_DATE_LABEL, 'flags' => '9');
	$fields['u_domains'] = array('title' => PL_USERS_H_DOMAINS_LABEL, 'flags' => '4');
	$fields['u_uploading_exts'] = array('title' => PL_USERS_H_UPLOADING_EXTS_LABEL, 'flags' => '4');
	$fields['u_strip_php'] = array('title' => PL_USERS_H_STRIP_PHP_LABEL, 'flags' => '10');
	$fields['u_pers_birth'] = array('title' => PL_USERS_H_PERS_BIRTH_LABEL, 'flags' => '9');
	$fields['u_pers_prof'] = array('title' => PL_USERS_H_PERS_FROF_LABEL, 'flags' => '4');
	$fields['u_pers_otdel'] = array('title' => PL_USERS_H_PERS_OTDEL_LABEL, 'flags' => '4');
	$fields['u_pers_dolj'] = array('title' => PL_USERS_H_PERS_DOLJ_LABEL, 'flags' => '4');
	$fields['u_pers_messanger_type'] = array('title' => PL_USERS_H_PERS_MESS_TYPE_LABEL, 'flags' => '17');
	$fields['u_pers_messanger_id'] = array('title' => PL_USERS_H_PERS_MESS_ID_LABEL, 'flags' => '4');
	$fields['u_pers_phone'] = array('title' => PL_USERS_H_PERS_PHONE_LABEL, 'flags' => '4');
	$fields['u_pers_mob_phone'] = array('title' => PL_USERS_H_PERS_MOB_LABEL, 'flags' => '4');
	$fields['u_pers_address'] = array('title' => PL_USERS_H_PERS_ADDR_LABEL, 'flags' => '4');
	$fields['u_pers_dop'] = array('title' => PL_USERS_H_PERS_DOP_LABEL, 'flags' => '7');
	$fields['u_pers_foto'] = array('title' => PL_USERS_H_PERS_FOTO_LABEL, 'flags' => '4');
	$fields['u_work_title'] = array('title' => PL_USERS_H_WORK_TITLE_LABEL, 'flags' => '4');
	$fields['u_work_phone'] = array('title' => PL_USERS_H_WORK_PHONE_LABEL, 'flags' => '4');
	$fields['u_work_inner_phone'] = array('title' => PL_USERS_H_WORK_INNER_PHONE_LABEL, 'flags' => '4');
	$fields['u_work_fax'] = array('title' => PL_USERS_H_WORK_FAX_LABEL, 'flags' => '4');
	$fields['u_work_email'] = array('title' => PL_USERS_H_WORK_EMAIL_LABEL, 'flags' => '4');
	$fields['u_work_office'] = array('title' => PL_USERS_H_WORK_OFFICE_LABEL, 'flags' => '4');
	$fields['u_work_dop'] = array('title' => PL_USERS_H_WORK_DOP_LABEL, 'flags' => '7');
	$fields['u_ext_id'] = array('title' => PL_USERS_H_EXT_ID_LABEL, 'flags' => '8');
	$fields['u_wrong_pass_count'] = array('title' => PL_USERS_H_WRONG_PASS_COUN_LABEL, 'flags' => '8');

	$cat_fields = array();
	$cat_fields['ur_plugin_rights'] = array('title' => PL_USERS_H_CAT_USERS_RIGHT_LABEL, 'flags' => '18');
	$cat_fields['ur_workflow_rights'] = array('title' => PL_USERS_H_CAT_WORKFLOW_LABEL, 'flags' => '18');

	$_SESSION['sbPlugins']->addFieldsInfo('sb_users', 'u_id', 'u_login', $fields, $cat_fields);
	$_SESSION['sbPlugins']->addToConstructor('sb_users', false);
}

$_SESSION['sbPlugins']->addEventsRights('categs_edit', PL_USERS_H_CATEGS_EDIT_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('categs_delete', PL_USERS_H_CATEGS_DELETE_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('categs_rights', PL_USERS_H_CATEGS_RIGHTS_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('elems_edit', PL_USERS_H_ELEMS_EDIT_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('elems_delete', PL_USERS_H_ELEMS_DELETE_RIGHT);

$_SESSION['sbPlugins']->addSystemEvent('get_groups', 'fUsers_Get_Groups', PL_USERS_H_GET_GROUP_TITLE);
$_SESSION['sbPlugins']->addSystemEvent('set_groups', 'fUsers_Set_Groups', PL_USERS_H_GET_GROUP_TITLE);
$_SESSION['sbPlugins']->addSystemEvent('get_groups_print', 'fUsers_Get_Groups_Print', PL_USERS_H_GET_GROUP_TITLE);


?>