<?php
/**
 * Функция вывода формы голосования
 *
 * @param int $temp_id Идентификатор макета дизайна голосования.
 * @param string $pl_id Уникальный идентификатор модуля.
 * @param int $el_id Идентификатор элемента.
 *
 * @return string HTML-код формы голосования.
 */
function fVoting_Get_Form ($temp_id, $pl_id, $el_id)
{
	//$res = sql_query('SELECT vt_temp FROM sb_vote_temps WHERE vt_id=?d', $temp_id);
    $res = sbQueryCache::getTemplate('sb_vote_temps', $temp_id);
	if (!$res || trim($res[0][0]) == '')
		return '';

	$query_str = ($_SERVER['QUERY_STRING'] != '' ? '?'.$_SERVER['QUERY_STRING'] : '');
	foreach ($_GET as $key => $value)
	{
    	if (preg_match('/^[A-Z0-9_\-]+_cid$/i', $key))
    	{
    		if ($query_str != '')
    			$query_str .= '&'.$key.'='.intval($value);
    		else
    			$query_str .= '?'.$key.'='.intval($value);
    	}
    	elseif (preg_match('/^[A-Z0-9_\-]+_id$/i', $key))
    	{
    		if ($query_str != '')
    			$query_str .= '&'.$key.'='.intval($value);
    		else
    			$query_str .= '?'.$key.'='.intval($value);
    	}
		elseif (preg_match('/^page_+/i', $key))
    	{
    		if ($query_str != '')
    			$query_str .= '&'.$key.'='.intval($value);
    		else
    			$query_str .= '?'.$key.'='.intval($value);
    	}
    }

	$action = $GLOBALS['PHP_SELF'].$query_str;
	$hash = md5($el_id.'_'.$pl_id);

	return str_replace(array('{ACTION}', '{HASH}', '{ID}'), array($action, $hash, intval($el_id)), $res[0][0]);
}

/**
 * Функция осуществляющая процесс голосования
 *
 * @param int $temp_id Идентификатор макета дизайна голосования.
 * @param string $pl_id Идентификатор модуля.
 * @param int $el_id ID элемента.
 * @param int $el_sum Текущая сумма баллов элемента.
 * @param int $el_count Текущее кол-во проголосовавших за элемент.
 * @param int $el_rating Текущий рейтинг элемента.
 *
 * @return string Сообщение "Ваш голос принят" или "Вы уже голосовали", либо пустую строку в случае неудачи.
 */
function fVoting_Form_Submit ($temp_id, $pl_id, $el_id, &$el_sum, &$el_count, &$el_rating)
{
	$hash = md5($el_id.'_'.$pl_id);
	if(!isset($_REQUEST['v_hash']) || !isset($_REQUEST['v_sum']) || $hash != $_REQUEST['v_hash'] || isset($GLOBALS['sb_v_hash_'.$hash]))
	{
		$message = '';
		if (isset($GLOBALS['sb_v_hash_'.$hash]))
		{
			$res = sql_query('SELECT vt_not_vote, vt_vote_ok FROM sb_vote_temps WHERE vt_id=?d', $temp_id);
			if ($res)
			{
				list($error_msg, $ok_msg) = $res[0];
			}
			else
			{
				$error_msg = '';
				$ok_msg = '';
			}

			if ($GLOBALS['sb_v_hash_'.$hash] == 'ok')
				$message = $ok_msg;
			else
				$message = $error_msg;
		}

		return $message;
	}

	$v_sum = floatval($_REQUEST['v_sum']);

	$res = sql_query('SELECT vt_not_vote, vt_vote_ok FROM sb_vote_temps WHERE vt_id=?d', $temp_id);
	if ($res)
	{
		list($error_msg, $ok_msg) = $res[0];
	}
	else
	{
		$error_msg = '';
		$ok_msg = '';
	}

	$cookie_time = sbPlugins::getSetting('sb_voting_cookie_time');

	if(isset($_COOKIE['vote_'.$hash]) && $cookie_time != 0)
    {
    	$GLOBALS['sb_v_hash_'.$hash] = 'error';
    	return $error_msg;
    }

	$ip = sbAuth::getIP();
	$ip_count = sbPlugins::getSetting('sb_voting_ip_count');
	$res = sql_query('SELECT SUM(ips.vi_count), res.vr_id
	                            FROM sb_vote_ips ips, sb_vote_results res
	                            WHERE ips.vi_ip=?
	                            AND ips.vi_vr_id=res.vr_id
	                            AND res.vr_el_id=?d
	                            AND res.vr_plugin=?
	                            GROUP BY (ips.vi_vr_id)', $ip, $el_id, $pl_id);

	if ($res && $res[0][0] >= $ip_count && $ip_count > 0)
	{
		$GLOBALS['sb_v_hash_'.$hash] = 'error';
		return $error_msg;
	}

   	sb_setcookie('vote_'.$hash, 1, time() + $cookie_time * 24 * 60 * 60);

   	// сбрасываем кэш модуля
   	$GLOBALS['sbCache']->mCacheOff = true;

    if ($res)
    {
    	sql_query('UPDATE sb_vote_results SET vr_count=vr_count+(?f), vr_num=vr_num+1
                         WHERE vr_id=?d', $v_sum, $res[0][1]);

    	sql_query('UPDATE sb_vote_ips SET vi_count = vi_count + 1 WHERE vi_vr_id=?d AND vi_ip=?', $res[0][1], $ip);
    }
    else
    {
    	$vr_id = false;

    	$res = sql_query('SELECT vr_id FROM sb_vote_results WHERE vr_el_id=?d AND vr_plugin=?', $el_id, $pl_id);
    	if ($res)
    	{
    		list($vr_id) = $res[0];
    		sql_query('UPDATE sb_vote_results SET vr_count=vr_count+?f, vr_num=vr_num+1
                             WHERE vr_id=?d', $v_sum, $vr_id);
    	}
    	else
    	{
    		$res = sql_query('INSERT INTO sb_vote_results (vr_plugin, vr_el_id, vr_count, vr_num) VALUES (?, ?d, ?f, 1)', $pl_id, $el_id, $v_sum);
            if ($res)
            {
            	$vr_id = sql_insert_id();
            }
    	}

    	if (!$vr_id)
    	{
    		$GLOBALS['sb_v_hash_'.$hash] = 'error';
    		return $error_msg;
    	}

    	sql_query('INSERT INTO sb_vote_ips (vi_vr_id, vi_ip, vi_count) VALUES (?, ?, 1)', $vr_id, $ip);
    }

    $el_sum += floatval($_REQUEST['v_sum']);
    $el_count++;
    $el_rating = sprintf('%.2f', $el_sum / $el_count);

    unset($_REQUEST['v_hash']);
    unset($_REQUEST['v_sum']);

    $GLOBALS['sb_v_hash_'.$hash] = 'ok';
    return $ok_msg;
}
?>