<?php
require_once(SB_CMS_LANG_PATH.'/pl_workflow.h.lng.php');

if ($_SESSION['sbPlugins']->register('pl_workflow', PL_WORKFLOW_H_PLUGIN_NAME, ''))
{
	$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_ADMIN.'>'.PL_WORKFLOW_H_PLUGIN_NAME, 'init');
	$_SESSION['sbPlugins']->setMainEvent('init');

	$_SESSION['sbPlugins']->addUserEvent('init', 'fWorkflow_Init', 'read', PL_WORKFLOW_H_PLUGIN_NAME);
	$_SESSION['sbPlugins']->addUserEvent('edit', 'fWorkflow_Edit', 'elems_edit', PL_WORKFLOW_H_EDIT_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('edit_submit', 'fWorkflow_Edit_Submit', 'elems_edit', PL_WORKFLOW_H_EDIT_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('change_active', 'fWorkflow_Change_Active', 'elems_edit');
	$_SESSION['sbPlugins']->addUserEvent('change_demo', 'fWorkflow_Change_Demo', 'elems_edit');
	$_SESSION['sbPlugins']->addUserEvent('change_order', 'fWorkflow_Change_Order', 'elems_edit');
	$_SESSION['sbPlugins']->addUserEvent('delete', 'fWorkflow_Delete', 'elems_delete');

	// проверяем есть ли системные статусы (Опубликовано на сайте, Не опубликовано на сайте, Опубликовано на демо-сайте)
	$res = sql_query('SELECT w_code FROM sb_workflow');
	if(!$res)
	{
		// статусов нет
		for($i = 0; $i < 2; $i++)
		{
			$row = array();
			$row['w_title'] = constant('PL_WORKFLOW_H_INIT_CODE_TITLE'.$i);
			$row['w_order'] = $i+1;
			$row['w_code'] = $i;
			$row['w_on'] = 1;
			$row['w_accessible'] = '0|1|2';
			$row['w_show_demo'] = ($i == 0 ? 0 : 1);

			sql_query('INSERT INTO sb_workflow (?#) VALUES (?a)', array_keys($row), array_values($row));
		}
	}
	else
	{
		$not_found = array();
		$not_found[0] = true;
		$not_found[1] = true;

		foreach ($res as $value)
		{
			if (isset($not_found[$value[0]]))
				unset($not_found[$value[0]]);
		}

		if (count($not_found) > 0)
		{
			$res = sql_query('SELECT MAX(w_order) FROM sb_workflow');
			$w_order = $res[0][0];

			foreach ($not_found as $key => $value)
			{
				$row = array();
				$row['w_title'] = constant('PL_WORKFLOW_H_INIT_CODE_TITLE'.$key);
				$row['w_order'] = $w_order++;
				$row['w_code'] = $key;
				$row['w_on'] = 1;
				$row['w_accessible'] = '0|1|2';
				$row['w_show_demo'] = ($i == 0 ? 0 : 1);

				sql_query('INSERT INTO sb_workflow (?#) VALUES (?a)', array_keys($row), array_values($row));
			}
		}
	}

	$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_workflow_delim', PL_WORKFLOW_H_PLUGIN_NAME, '', '');
	$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_demo_ip', PL_WORKFLOW_H_SETTING_DEMO_IP, 'string', '127.0.0.*', '', SB_COOKIE_DOMAIN, true);
}

sb_add_rights();
?>